/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var x=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","electron","vs/base/common/errors","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/arrays","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/state/electron-main/state","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","crypto","net","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],ee=function(V){for(var e=[],y=0,t=V.length;y<t;y++)e[y]=x[V[y]];return e};define(x[108],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=y}),define(x[109],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function y(M){return M?M.replace(/\$\((.*?)\)/g,(E,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=y;class t{constructor(E,g,b){this.id=E,this.definition=g,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(M,E){const g=["codicon","codicon-"+M];return E&&g.push("codicon-modifier-"+E),g}e.getClassNamesArray=L;var D;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(P){if(P instanceof t)return["codicon","codicon-"+P.id];const I=E.exec(P.id);if(!I)return g(t.error);let[,v,d]=I;const h=["codicon","codicon-"+v];return d&&h.push("codicon-modifier-"+d.substr(1)),h}M.asClassNameArray=g;function b(P){return g(P).join(" ")}M.asClassName=b;function k(P){return"."+g(P).join(".")}M.asCSSSelector=k})(D=e.CSSIcon||(e.CSSIcon={}))}),define(x[110],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function y(E,g){const b=Math.pow(10,g);return Math.round(E*b)/b}class t{constructor(g,b,k,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,k))|0,this.a=y(Math.max(Math.min(1,P),0),3)}static equals(g,b){return g.r===b.r&&g.g===b.g&&g.b===b.b&&g.a===b.a}}e.RGBA=t;class L{constructor(g,b,k,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=y(Math.max(Math.min(1,b),0),3),this.l=y(Math.max(Math.min(1,k),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(g,b){return g.h===b.h&&g.s===b.s&&g.l===b.l&&g.a===b.a}static fromRGBA(g){const b=g.r/255,k=g.g/255,P=g.b/255,I=g.a,v=Math.max(b,k,P),d=Math.min(b,k,P);let h=0,p=0;const w=(d+v)/2,C=v-d;if(C>0){switch(p=Math.min(w<=.5?C/(2*w):C/(2-2*w),1),v){case b:h=(k-P)/C+(k<P?6:0);break;case k:h=(P-b)/C+2;break;case P:h=(b-k)/C+4;break}h*=60,h=Math.round(h)}return new L(h,p,w,I)}static _hue2rgb(g,b,k){return k<0&&(k+=1),k>1&&(k-=1),k<1/6?g+(b-g)*6*k:k<1/2?b:k<2/3?g+(b-g)*(2/3-k)*6:g}static toRGBA(g){const b=g.h/360,{s:k,l:P,a:I}=g;let v,d,h;if(k===0)v=d=h=P;else{const p=P<.5?P*(1+k):P+k-P*k,w=2*P-p;v=L._hue2rgb(w,p,b+1/3),d=L._hue2rgb(w,p,b),h=L._hue2rgb(w,p,b-1/3)}return new t(Math.round(v*255),Math.round(d*255),Math.round(h*255),I)}}e.HSLA=L;class D{constructor(g,b,k,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=y(Math.max(Math.min(1,b),0),3),this.v=y(Math.max(Math.min(1,k),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(g,b){return g.h===b.h&&g.s===b.s&&g.v===b.v&&g.a===b.a}static fromRGBA(g){const b=g.r/255,k=g.g/255,P=g.b/255,I=Math.max(b,k,P),v=Math.min(b,k,P),d=I-v,h=I===0?0:d/I;let p;return d===0?p=0:I===b?p=((k-P)/d%6+6)%6:I===k?p=(P-b)/d+2:p=(b-k)/d+4,new D(Math.round(p*60),h,I,g.a)}static toRGBA(g){const{h:b,s:k,v:P,a:I}=g,v=P*k,d=v*(1-Math.abs(b/60%2-1)),h=P-v;let[p,w,C]=[0,0,0];return b<60?(p=v,w=d):b<120?(p=d,w=v):b<180?(w=v,C=d):b<240?(w=d,C=v):b<300?(p=d,C=v):b<=360&&(p=v,C=d),p=Math.round((p+h)*255),w=Math.round((w+h)*255),C=Math.round((C+h)*255),new t(p,w,C,I)}}e.HSVA=D;class M{constructor(g){if(g)if(g instanceof t)this.rgba=g;else if(g instanceof L)this._hsla=g,this.rgba=L.toRGBA(g);else if(g instanceof D)this._hsva=g,this.rgba=D.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(g){return M.Format.CSS.parseHex(g)||M.red}get hsla(){return this._hsla?this._hsla:L.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:D.fromRGBA(this.rgba)}equals(g){return!!g&&t.equals(this.rgba,g.rgba)&&L.equals(this.hsla,g.hsla)&&D.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=M._relativeLuminanceForComponent(this.rgba.r),b=M._relativeLuminanceForComponent(this.rgba.g),k=M._relativeLuminanceForComponent(this.rgba.b),P=.2126*g+.7152*b+.0722*k;return y(P,4)}static _relativeLuminanceForComponent(g){const b=g/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(g){const b=this.getRelativeLuminance(),k=g.getRelativeLuminance();return b>k?(b+.05)/(k+.05):(k+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const b=this.getRelativeLuminance(),k=g.getRelativeLuminance();return b>k}isDarkerThan(g){const b=this.getRelativeLuminance(),k=g.getRelativeLuminance();return b<k}lighten(g){return new M(new L(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new M(new L(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:b,g:k,b:P,a:I}=this.rgba;return new M(new t(b,k,P,I*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const b=g.rgba,k=this.rgba.a,P=b.a,I=k+P*(1-k);if(I<1e-6)return M.transparent;const v=this.rgba.r*k/I+b.r*P*(1-k)/I,d=this.rgba.g*k/I+b.g*P*(1-k)/I,h=this.rgba.b*k/I+b.b*P*(1-k)/I;return new M(new t(v,d,h,I))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:b,g:k,b:P,a:I}=this.rgba;return new M(new t(g.rgba.r-I*(g.rgba.r-b),g.rgba.g-I*(g.rgba.g-k),g.rgba.b-I*(g.rgba.b-P),1))}flatten(...g){const b=g.reduceRight((k,P)=>M._flatten(P,k));return M._flatten(this,b)}static _flatten(g,b){const k=1-g.rgba.a;return new M(new t(k*b.rgba.r+g.rgba.a*g.rgba.r,k*b.rgba.g+g.rgba.a*g.rgba.g,k*b.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(g,b,k){if(g.isLighterThan(b))return g;k=k||.5;const P=g.getRelativeLuminance(),I=b.getRelativeLuminance();return k=k*(I-P)/I,g.lighten(k)}static getDarkerColor(g,b,k){if(g.isDarkerThan(b))return g;k=k||.5;const P=g.getRelativeLuminance(),I=b.getRelativeLuminance();return k=k*(P-I)/P,g.darken(k)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(E){let g;(function(b){let k;(function(P){function I(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:E.Format.CSS.formatRGBA(s)}P.formatRGB=I;function v(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}P.formatRGBA=v;function d(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(s)}P.formatHSL=d;function h(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}P.formatHSLA=h;function p(s){const l=s.toString(16);return l.length!==2?"0"+l:l}function w(s){return`#${p(s.rgba.r)}${p(s.rgba.g)}${p(s.rgba.b)}`}P.formatHex=w;function C(s,l=!1){return l&&s.rgba.a===1?E.Format.CSS.formatHex(s):`#${p(s.rgba.r)}${p(s.rgba.g)}${p(s.rgba.b)}${p(Math.round(s.rgba.a*255))}`}P.formatHexA=C;function m(s){return s.isOpaque()?E.Format.CSS.formatHex(s):E.Format.CSS.formatRGBA(s)}P.format=m;function u(s){const l=s.length;if(l===0||s.charCodeAt(0)!==35)return null;if(l===7){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6));return new E(new t(i,n,o,1))}if(l===9){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6)),r=16*c(s.charCodeAt(7))+c(s.charCodeAt(8));return new E(new t(i,n,o,r/255))}if(l===4){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3));return new E(new t(16*i+i,16*n+n,16*o+o))}if(l===5){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3)),r=c(s.charCodeAt(4));return new E(new t(16*i+i,16*n+n,16*o+o,(16*r+r)/255))}return null}P.parseHex=u;function c(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(k=b.CSS||(b.CSS={}))})(g=E.Format||(E.Format={}))}(M=e.Color||(e.Color={}))}),define(x[47],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(M){return(E,g,b)=>{let k=null,P=null;if(typeof b.value=="function"?(k="value",P=b.value):typeof b.get=="function"&&(k="get",P=b.get),!P)throw new Error("not supported");b[k]=M(P,g)}}e.createDecorator=y;function t(M,E,g){let b=null,k=null;if(typeof g.value=="function"?(b="value",k=g.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",k=g.get),!k)throw new Error("not supported");const P=`$memoize$${E}`;g[b]=function(...I){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,I)}),this[P]}}e.memoize=t;function L(M,E,g){return y((b,k)=>{const P=`$debounce$${k}`,I=`$debounce$result$${k}`;return function(...v){this[I]||(this[I]=g?g():void 0),clearTimeout(this[P]),E&&(this[I]=E(this[I],...v),v=[this[I]]),this[P]=setTimeout(()=>{b.apply(this,v),this[I]=g?g():void 0},M)}})}e.debounce=L;function D(M,E,g){return y((b,k)=>{const P=`$throttle$timer$${k}`,I=`$throttle$result$${k}`,v=`$throttle$lastRun$${k}`,d=`$throttle$pending$${k}`;return function(...h){if(this[I]||(this[I]=g?g():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),E&&(this[I]=E(this[I],...h)),this[d])return;const p=this[v]+M;p<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[I]]),this[I]=g?g():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[v]=Date.now(),b.apply(this,[this[I]]),this[I]=g?g():void 0},p-Date.now()))}})}e.throttle=D}),define(x[15],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(l=>{l(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=y,e.errorHandler=new y;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function L(c){g(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=L;function D(c){g(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=D;function M(c){if(c instanceof Error){let{name:s,message:l}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:s,message:l,stack:i}}return c}e.transformErrorForSerialization=M;const E="Canceled";function g(c){return c instanceof b?!0:c instanceof Error&&c.name===E&&c.message===E}e.isCancellationError=g;class b extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=b;function k(){const c=new Error(E);return c.name=c.message,c}e.canceled=k;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(c){const s=new Error(`${c} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class p extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=p;class w extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=w;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;class m extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(s){if(s&&s instanceof m)return s;if(s&&s instanceof Error){const l=new m;return l.name=s.name,l.message=s.message,l.stack=s.stack,l}return new m(s)}}e.ErrorNoTelemetry=m;class u extends Error{constructor(s){super(s);Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(x[26],ee([0,1,15]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(T,_=0){return T[T.length-(1+_)]}e.tail=t;function L(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=L;function D(T,_,q=(Z,oe)=>Z===oe){if(T===_)return!0;if(!T||!_||T.length!==_.length)return!1;for(let Z=0,oe=T.length;Z<oe;Z++)if(!q(T[Z],_[Z]))return!1;return!0}e.equals=D;function M(T,_,q){return E(T.length,Z=>q(T[Z],_))}e.binarySearch=M;function E(T,_){let q=0,Z=T-1;for(;q<=Z;){const oe=(q+Z)/2|0,ce=_(oe);if(ce<0)q=oe+1;else if(ce>0)Z=oe-1;else return oe}return-(q+1)}e.binarySearch2=E;function g(T,_){let q=0,Z=T.length;if(Z===0)return 0;for(;q<Z;){const oe=Math.floor((q+Z)/2);_(T[oe])?Z=oe:q=oe+1}return q}e.findFirstInSorted=g;function b(T,_,q){if(T=T|0,T>=_.length)throw new TypeError("invalid index");let Z=_[Math.floor(_.length*Math.random())],oe=[],ce=[],se=[];for(let he of _){const ue=q(he,Z);ue<0?oe.push(he):ue>0?ce.push(he):se.push(he)}return T<oe.length?b(T,oe,q):T<oe.length+se.length?se[0]:b(T-(oe.length+se.length),ce,q)}e.quickSelect=b;function k(T,_){const q=[];let Z;for(const oe of T.slice(0).sort(_))!Z||_(Z[0],oe)!==0?(Z=[oe],q.push(Z)):Z.push(oe);return q}e.groupBy=k;function P(T,_,q){const Z=[];function oe(he,ue,ge){if(ue===0&&ge.length===0)return;const Ee=Z[Z.length-1];Ee&&Ee.start+Ee.deleteCount===he?(Ee.deleteCount+=ue,Ee.toInsert.push(...ge)):Z.push({start:he,deleteCount:ue,toInsert:ge})}let ce=0,se=0;for(;;){if(ce===T.length){oe(ce,0,_.slice(se));break}if(se===_.length){oe(ce,T.length-ce,[]);break}const he=T[ce],ue=_[se],ge=q(he,ue);ge===0?(ce+=1,se+=1):ge<0?(oe(ce,1,[]),ce+=1):ge>0&&(oe(ce,0,[ue]),se+=1)}return Z}e.sortedDiff=P;function I(T,_,q){const Z=P(T,_,q),oe=[],ce=[];for(const se of Z)oe.push(...T.slice(se.start,se.start+se.deleteCount)),ce.push(...se.toInsert);return{removed:oe,added:ce}}e.delta=I;function v(T,_,q){if(q===0)return[];const Z=T.slice(0,q).sort(_);return h(T,_,Z,q,T.length),Z}e.top=v;function d(T,_,q,Z,oe){return q===0?Promise.resolve([]):new Promise((ce,se)=>{(async()=>{const he=T.length,ue=T.slice(0,q).sort(_);for(let ge=q,Ee=Math.min(q+Z,he);ge<he;ge=Ee,Ee=Math.min(Ee+Z,he)){if(ge>q&&await new Promise(Pe=>setTimeout(Pe)),oe&&oe.isCancellationRequested)throw new y.CancellationError;h(T,_,ue,ge,Ee)}return ue})().then(ce,se)})}e.topAsync=d;function h(T,_,q,Z,oe){for(const ce=q.length;Z<oe;Z++){const se=T[Z];if(_(se,q[ce-1])<0){q.pop();const he=g(q,ue=>_(se,ue)<0);q.splice(he,0,se)}}}function p(T){return T.filter(_=>!!_)}e.coalesce=p;function w(T){let _=0;for(let q=0;q<T.length;q++)T[q]&&(T[_]=T[q],_+=1);T.length=_}e.coalesceInPlace=w;function C(T,_,q){T.splice(q,0,T.splice(_,1)[0])}e.move=C;function m(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=m;function u(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=u;function c(T,_=q=>q){const q=new Set;return T.filter(Z=>{const oe=_(Z);return q.has(oe)?!1:(q.add(oe),!0)})}e.distinct=c;function s(T){const _=new Set;return q=>{const Z=T(q);return _.has(Z)?!1:(_.add(Z),!0)}}e.uniqueFilter=s;function l(T,_){const q=i(T,_);if(q!==-1)return T[q]}e.findLast=l;function i(T,_){for(let q=T.length-1;q>=0;q--){const Z=T[q];if(_(Z))return q}return-1}e.lastIndex=i;function n(T,_){return T.length>0?T[0]:_}e.firstOrDefault=n;function o(T,_){return T.length>0?T[T.length-1]:_}e.lastOrDefault=o;function r(T,_,q=(Z,oe)=>Z===oe){let Z=0;for(let oe=0,ce=Math.min(T.length,_.length);oe<ce&&q(T[oe],_[oe]);oe++)Z++;return Z}e.commonPrefixLength=r;function a(T){return[].concat(...T)}e.flatten=a;function f(T,_){let q=typeof _=="number"?T:0;typeof _=="number"?q=T:(q=0,_=T);const Z=[];if(q<=_)for(let oe=q;oe<_;oe++)Z.push(oe);else for(let oe=q;oe>_;oe--)Z.push(oe);return Z}e.range=f;function S(T,_,q){return T.reduce((Z,oe)=>(Z[_(oe)]=q?q(oe):oe,Z),Object.create(null))}e.index=S;function R(T,_){return T.push(_),()=>A(T,_)}e.insert=R;function A(T,_){const q=T.indexOf(_);if(q>-1)return T.splice(q,1),_}e.remove=A;function F(T,_,q){const Z=T.slice(0,_),oe=T.slice(_);return Z.concat(q,oe)}e.arrayInsert=F;function $(T,_){let q;if(typeof _=="number"){let Z=_;q=()=>{const oe=Math.sin(Z++)*179426549;return oe-Math.floor(oe)}}else q=Math.random;for(let Z=T.length-1;Z>0;Z-=1){const oe=Math.floor(q()*(Z+1)),ce=T[Z];T[Z]=T[oe],T[oe]=ce}}e.shuffle=$;function J(T,_){const q=T.indexOf(_);q>-1&&(T.splice(q,1),T.unshift(_))}e.pushToStart=J;function ne(T,_){const q=T.indexOf(_);q>-1&&(T.splice(q,1),T.push(_))}e.pushToEnd=ne;function Y(T,_){for(const q of _)T.push(q)}e.pushMany=Y;function re(T,_){return Array.isArray(T)?T.map(_):_(T)}e.mapArrayOrNot=re;function H(T){return Array.isArray(T)?T:[T]}e.asArray=H;function X(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=X;function j(T,_){for(const q of T){const Z=_(q);if(Z!==void 0)return Z}}e.mapFind=j;function B(T,_,q){const Z=K(T,_),oe=T.length,ce=q.length;T.length=oe+ce;for(let se=oe-1;se>=Z;se--)T[se+ce]=T[se];for(let se=0;se<ce;se++)T[se+Z]=q[se]}e.insertInto=B;function z(T,_,q,Z){const oe=K(T,_),ce=T.splice(oe,q);return B(T,oe,Z),ce}e.splice=z;function K(T,_){return _<0?Math.max(_+T.length,0):Math.min(_,T.length)}function te(T,_){return(q,Z)=>_(T(q),T(Z))}e.compareBy=te;const Q=(T,_)=>T-_;e.numberComparator=Q;function O(T,_){if(T.length===0)return;let q=T[0];for(let Z=1;Z<T.length;Z++){const oe=T[Z];_(oe,q)>0&&(q=oe)}return q}e.findMaxBy=O;function U(T,_){if(T.length===0)return;let q=T[0];for(let Z=1;Z<T.length;Z++){const oe=T[Z];_(oe,q)>=0&&(q=oe)}return q}e.findLastMaxBy=U;function W(T,_){return O(T,(q,Z)=>-_(q,Z))}e.findMinBy=W;class N{constructor(_){this.items=_,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_){let q=this.firstIdx;for(;q<this.items.length&&_(this.items[q]);)q++;const Z=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,Z}takeFromEndWhile(_){let q=this.lastIdx;for(;q>=0&&_(this.items[q]);)q--;const Z=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,Z}peek(){return this.items[this.firstIdx]}dequeue(){const _=this.items[this.firstIdx];return this.firstIdx++,_}takeCount(_){const q=this.items.slice(this.firstIdx,this.firstIdx+_);return this.firstIdx+=_,q}}e.ArrayQueue=N}),define(x[43],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(t){const L=this;let D=!1,M;return function(){return D||(D=!0,M=t.apply(L,arguments)),M}}e.once=y}),define(x[69],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(t){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=L;const D=Object.freeze([]);function M(){return D}t.empty=M;function*E(l){yield l}t.single=E;function g(l){return l||D}t.from=g;function b(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=b;function k(l){return l[Symbol.iterator]().next().value}t.first=k;function P(l,i){for(const n of l)if(i(n))return!0;return!1}t.some=P;function I(l,i){for(const n of l)if(i(n))return n}t.find=I;function*v(l,i){for(const n of l)i(n)&&(yield n)}t.filter=v;function*d(l,i){let n=0;for(const o of l)yield i(o,n++)}t.map=d;function*h(...l){for(const i of l)for(const n of i)yield n}t.concat=h;function*p(l){for(const i of l)for(const n of i)yield n}t.concatNested=p;function w(l,i,n){let o=n;for(const r of l)o=i(o,r);return o}t.reduce=w;function C(l,i){let n=0;for(const o of l)i(o,n++)}t.forEach=C;function*m(l,i,n=l.length){for(i<0&&(i+=l.length),n<0?n+=l.length:n>l.length&&(n=l.length);i<n;i++)yield l[i]}t.slice=m;function u(l,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,l];const o=l[Symbol.iterator]();for(let r=0;r<i;r++){const a=o.next();if(a.done)return[n,t.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=u;function c(l){return u(l)[0]}t.collect=c;function s(l,i,n=(o,r)=>o===r){const o=l[Symbol.iterator](),r=i[Symbol.iterator]();for(;;){const a=o.next(),f=r.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!n(a.value,f.value))return!1}}t.equals=s})(y=e.Iterable||(e.Iterable={}))}),define(x[44],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(s){s.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function M(s,l=!1){let i=0,n=s.length,o="",r=0,a=16,f=0;function S(Y){let re=0,H=0;for(;re<Y;){const X=s.charCodeAt(i);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;i++,re++}return re<Y&&(H=-1),H}function R(Y){i=Y,o="",r=0,a=16,f=0}function A(){const Y=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&b(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&b(s.charCodeAt(i)))for(i++;i<s.length&&b(s.charCodeAt(i));)i++;else return f=3,s.substring(Y,i);let re=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&b(s.charCodeAt(i))){for(i++;i<s.length&&b(s.charCodeAt(i));)i++;re=i}else f=3;return s.substring(Y,re)}function F(){let Y="",re=i;for(;;){if(i>=n){Y+=s.substring(re,i),f=2;break}const H=s.charCodeAt(i);if(H===34){Y+=s.substring(re,i),i++;break}if(H===92){if(Y+=s.substring(re,i),i++,i>=n){f=2;break}switch(s.charCodeAt(i++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const j=S(4);j>=0?Y+=String.fromCharCode(j):f=4;break}default:f=5}re=i;continue}if(H>=0&&H<=31)if(g(H)){Y+=s.substring(re,i),f=2;break}else f=6;i++}return Y}function $(){if(o="",f=0,r=i,i>=n)return r=n,a=17;let Y=s.charCodeAt(i);if(E(Y)){do i++,o+=String.fromCharCode(Y),Y=s.charCodeAt(i);while(E(Y));return a=15}if(g(Y))return i++,o+=String.fromCharCode(Y),Y===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(Y){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=F(),a=10;case 47:{const re=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(s.charCodeAt(i));)i++;return o=s.substring(re,i),a=12}if(s.charCodeAt(i+1)===42){i+=2;const H=n-1;let X=!1;for(;i<H;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,X=!0;break}i++}return X||(i++,f=1),o=s.substring(re,i),a=13}return o+=String.fromCharCode(Y),i++,a=16}case 45:if(o+=String.fromCharCode(Y),i++,i===n||!b(s.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=A(),a=11;default:for(;i<n&&J(Y);)i++,Y=s.charCodeAt(i);if(r!==i){switch(o=s.substring(r,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Y),i++,a=16}}function J(Y){if(E(Y)||g(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let Y;do Y=$();while(Y>=12&&Y<=15);return Y}return{setPosition:R,getPosition:()=>i,scan:l?ne:$,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>f}}e.createScanner=M;function E(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function g(s){return s===10||s===13||s===8232||s===8233}function b(s){return s>=48&&s<=57}var k;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(k||(k={}));function P(s,l){const i=[],n=new Object;let o;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(S,R,A,F){r.value=S,r.offset=R,r.length=A,r.type=F,r.colonOffset=void 0,o=r}try{m(s,{onObjectBegin:(S,R)=>{if(l<=S)throw n;o=void 0,a=l>S,i.push("")},onObjectProperty:(S,R,A)=>{if(l<R||(f(S,R,A,"property"),i[i.length-1]=S,l<=R+A))throw n},onObjectEnd:(S,R)=>{if(l<=S)throw n;o=void 0,i.pop()},onArrayBegin:(S,R)=>{if(l<=S)throw n;o=void 0,i.push(0)},onArrayEnd:(S,R)=>{if(l<=S)throw n;o=void 0,i.pop()},onLiteralValue:(S,R,A)=>{if(l<R||(f(S,R,A,c(S)),l<=R+A))throw n},onSeparator:(S,R,A)=>{if(l<=R)throw n;if(S===":"&&o&&o.type==="property")o.colonOffset=R,a=!1,o=void 0;else if(S===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:o,isAtPropertyKey:a,matches:S=>{let R=0;for(let A=0;R<S.length&&A<i.length;A++)if(S[R]===i[A]||S[R]==="*")R++;else if(S[R]!=="**")return!1;return R===S.length}}}e.getLocation=P;function I(s,l=[],i=D.DEFAULT){let n=null,o=[];const r=[];function a(S){Array.isArray(o)?o.push(S):n!==null&&(o[n]=S)}return m(s,{onObjectBegin:()=>{const S={};a(S),r.push(o),o=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{o=r.pop()},onArrayBegin:()=>{const S=[];a(S),r.push(o),o=S,n=null},onArrayEnd:()=>{o=r.pop()},onLiteralValue:a,onError:(S,R,A)=>{l.push({error:S,offset:R,length:A})}},i),o[0]}e.parse=I;function v(s,l=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function r(S){return n.children.push(S),S}m(s,{onObjectBegin:S=>{n=r({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,R,A)=>{n=r({type:"property",offset:R,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:R,length:A,parent:n})},onObjectEnd:(S,R)=>{n.length=S+R-n.offset,n=n.parent,o(S+R)},onArrayBegin:(S,R)=>{n=r({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,R)=>{n.length=S+R-n.offset,n=n.parent,o(S+R)},onLiteralValue:(S,R,A)=>{r({type:c(S),offset:R,length:A,parent:n,value:S}),o(R+A)},onSeparator:(S,R,A)=>{n.type==="property"&&(S===":"?n.colonOffset=R:S===","&&o(R))},onError:(S,R,A)=>{l.push({error:S,offset:R,length:A})}},i);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=v;function d(s,l){if(!s)return;let i=s;for(let n of l)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===n){i=r.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function h(s){if(!s.parent||!s.parent.children)return[];const l=h(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;l.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&l.push(i)}return l}e.getNodePath=h;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":{const l=Object.create(null);for(let i of s.children){const n=i.children[1];n&&(l[i.children[0].value]=p(n))}return l}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=p;function w(s,l,i=!1){return l>=s.offset&&l<s.offset+s.length||i&&l===s.offset+s.length}e.contains=w;function C(s,l,i=!1){if(w(s,l,i)){const n=s.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=l;o++){const r=C(n[o],l,i);if(r)return r}return s}}e.findNodeAtOffset=C;function m(s,l,i=D.DEFAULT){const n=M(s,!1);function o(O){return O?()=>O(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(O){return O?U=>O(U,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(l.onObjectBegin),f=r(l.onObjectProperty),S=o(l.onObjectEnd),R=o(l.onArrayBegin),A=o(l.onArrayEnd),F=r(l.onLiteralValue),$=r(l.onSeparator),J=o(l.onComment),ne=r(l.onError),Y=i&&i.disallowComments,re=i&&i.allowTrailingComma;function H(){for(;;){const O=n.scan();switch(n.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:Y||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(O){case 12:case 13:Y?X(10):J();break;case 16:X(1);break;case 15:case 14:break;default:return O}}}function X(O,U=[],W=[]){if(ne(O),U.length+W.length>0){let N=n.getToken();for(;N!==17;){if(U.indexOf(N)!==-1){H();break}else if(W.indexOf(N)!==-1)break;N=H()}}}function j(O){const U=n.getTokenValue();return O?F(U):f(U),H(),!0}function B(){switch(n.getToken()){case 11:{let O=0;try{O=JSON.parse(n.getTokenValue()),typeof O!="number"&&(X(2),O=0)}catch{X(2)}F(O);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return H(),!0}function z(){return n.getToken()!==10?(X(3,[],[2,5]),!1):(j(!1),n.getToken()===6?($(":"),H(),Q()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function K(){a(),H();let O=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(O||X(4,[],[]),$(","),H(),n.getToken()===2&&re)break}else O&&X(6,[],[]);z()||X(4,[],[2,5]),O=!0}return S(),n.getToken()!==2?X(7,[2],[]):H(),!0}function te(){R(),H();let O=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(O||X(4,[],[]),$(","),H(),n.getToken()===4&&re)break}else O&&X(6,[],[]);Q()||X(4,[],[4,5]),O=!0}return A(),n.getToken()!==4?X(8,[4],[]):H(),!0}function Q(){switch(n.getToken()){case 3:return te();case 1:return K();case 10:return j(!0);default:return B()}}return H(),n.getToken()===17?i.allowEmptyContent?!0:(X(4,[],[]),!1):Q()?(n.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=m;function u(s,l){let i=M(s),n=[],o,r=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:r!==a&&n.push(s.substring(r,a)),l!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,l)),r=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(x[111],ee([0,1,44]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(b,k,P){let I,v,d,h,p;if(k){for(h=k.offset,p=h+k.length,d=h;d>0&&!g(b,d-1);)d--;let a=p;for(;a<b.length&&!g(b,a);)a++;v=b.substring(d,a),I=M(v,P)}else v=b,I=0,d=0,h=0,p=b.length;const w=E(P,b);let C=!1,m=0,u;P.insertSpaces?u=D(" ",P.tabSize||4):u="	";const c=(0,y.createScanner)(v,!1);let s=!1;function l(){return w+D(u,I+m)}function i(){let a=c.scan();for(C=!1;a===15||a===14;)C=C||a===14,a=c.scan();return s=a===16||c.getTokenError()!==0,a}const n=[];function o(a,f,S){!s&&f<p&&S>h&&b.substring(f,S)!==a&&n.push({offset:f,length:S-f,content:a})}let r=i();if(r!==17){const a=c.getTokenOffset()+d,f=D(u,I);o(f,d,a)}for(;r!==17;){let a=c.getTokenOffset()+c.getTokenLength()+d,f=i(),S="";for(;!C&&(f===12||f===13);){const A=c.getTokenOffset()+d;o(" ",a,A),a=c.getTokenOffset()+c.getTokenLength()+d,S=f===12?l():"",f=i()}if(f===2)r!==1&&(m--,S=l());else if(f===4)r!==3&&(m--,S=l());else{switch(r){case 3:case 1:m++,S=l();break;case 5:case 12:S=l();break;case 13:C?S=l():S=" ";break;case 6:S=" ";break;case 10:if(f===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?S=" ":f!==5&&f!==17&&(s=!0);break;case 16:s=!0;break}C&&(f===12||f===13)&&(S=l())}const R=c.getTokenOffset()+d;o(S,a,R),r=f}return n}e.format=t;function L(b,k){const P=JSON.stringify(b,void 0,k.insertSpaces?k.tabSize||4:"	");return k.eol!==void 0?P.replace(/\r\n|\r|\n/g,k.eol):P}e.toFormattedString=L;function D(b,k){let P="";for(let I=0;I<k;I++)P+=b;return P}function M(b,k){let P=0,I=0;const v=k.tabSize||4;for(;P<b.length;){const d=b.charAt(P);if(d===" ")I++;else if(d==="	")I+=v;else break;P++}return Math.floor(I/v)}function E(b,k){for(let P=0;P<k.length;P++){const I=k.charAt(P);if(I==="\r")return P+1<k.length&&k.charAt(P+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=E;function g(b,k){return`\r
`.indexOf(b.charAt(k))!==-1}e.isEOL=g}),define(x[112],ee([0,1,44,111]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(b,k,P){return D(b,k,void 0,P)}e.removeProperty=L;function D(b,k,P,I,v){const d=k.slice(),h=[],p=(0,y.parseTree)(b,h);let w,C;for(;d.length>0&&(C=d.pop(),w=(0,y.findNodeAtLocation)(p,d),w===void 0&&P!==void 0);)typeof C=="string"?P={[C]:P}:P=[P];if(w)if(w.type==="object"&&typeof C=="string"&&Array.isArray(w.children)){const m=(0,y.findNodeAtLocation)(w,[C]);if(m!==void 0)if(P===void 0){if(!m.parent)throw new Error("Malformed AST");const u=w.children.indexOf(m.parent);let c,s=m.parent.offset+m.parent.length;if(u>0){const l=w.children[u-1];c=l.offset+l.length}else c=w.offset+1,w.children.length>1&&(s=w.children[1].offset);return M(b,{offset:c,length:s-c,content:""},I)}else return M(b,{offset:m.offset,length:m.length,content:JSON.stringify(P)},I);else{if(P===void 0)return[];const u=`${JSON.stringify(C)}: ${JSON.stringify(P)}`,c=v?v(w.children.map(l=>l.children[0].value)):w.children.length;let s;if(c>0){const l=w.children[c-1];s={offset:l.offset+l.length,length:0,content:","+u}}else w.children.length===0?s={offset:w.offset+1,length:0,content:u}:s={offset:w.offset+1,length:0,content:u+","};return M(b,s,I)}}else if(w.type==="array"&&typeof C=="number"&&Array.isArray(w.children))if(P!==void 0){const m=`${JSON.stringify(P)}`;let u;if(w.children.length===0||C===0)u={offset:w.offset+1,length:0,content:w.children.length===0?m:m+","};else{const c=C===-1||C>w.children.length?w.children.length:C,s=w.children[c-1];u={offset:s.offset+s.length,length:0,content:","+m}}return M(b,u,I)}else{const m=C,u=w.children[m];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===m){const s=w.children[m-1],l=s.offset+s.length,i=w.offset+w.length;c={offset:l,length:i-2-l,content:""}}else c={offset:u.offset,length:w.children[m+1].offset-u.offset,content:""};return M(b,c,I)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${w.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return M(b,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},I)}}e.setProperty=D;function M(b,k,P){let I=E(b,k),v=k.offset,d=k.offset+k.content.length;if(k.length===0||k.content.length===0){for(;v>0&&!(0,t.isEOL)(I,v-1);)v--;for(;d<I.length&&!(0,t.isEOL)(I,d);)d++}const h=(0,t.format)(I,{offset:v,length:d-v},P);for(let w=h.length-1;w>=0;w--){const C=h[w];I=E(I,C),v=Math.min(v,C.offset),d=Math.max(d,C.offset+C.length),d+=C.content.length-C.length}const p=b.length-(I.length-d)-v;return[{offset:v,length:p,content:I.substring(v,d)}]}e.withFormatting=M;function E(b,k){return b.substring(0,k.offset)+k.content+b.substring(k.offset+k.length)}e.applyEdit=E;function g(b,k){let P=k.slice(0).sort((v,d)=>{const h=v.offset-d.offset;return h===0?v.length-d.length:h}),I=b.length;for(let v=P.length-1;v>=0;v--){let d=P[v];if(d.offset+d.length<=I)b=E(b,d);else throw new Error("Overlapping edit");I=d.offset}return b}e.applyEdits=g}),define(x[113],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new y(()=>L(this.getValue()))}}e.Lazy=y}),define(x[2],ee([0,1,43,69]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let D=null;function M(o){D=o}if(e.setDisposableTracker=M,L){const o="__is_disposable_tracked__";M(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[o]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==C.None)try{r[o]=!0}catch{}}markAsDisposed(r){if(r&&r!==C.None)try{r[o]=!0}catch{}}markAsSingleton(r){}})}function E(o){return D?.trackDisposable(o),o}function g(o){D?.markAsDisposed(o)}function b(o,r){D?.setParent(o,r)}function k(o,r){if(!!D)for(const a of o)D.setParent(a,r)}function P(o){return D?.markAsSingleton(o),o}e.markAsSingleton=P;class I extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=I;function v(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=v;function d(o){if(t.Iterable.is(o)){let r=[];for(const a of o)if(a)try{a.dispose()}catch(f){r.push(f)}if(r.length===1)throw r[0];if(r.length>1)throw new I(r);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function h(...o){const r=p(()=>d(o));return k(o,r),r}e.combinedDisposable=h;function p(o){const r=E({dispose:(0,y.once)(()=>{g(r),o()})});return r}e.toDisposable=p;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return b(r,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new w,E(this),b(this._store,this)}dispose(){g(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&b(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&b(r,null),r}}e.MutableDisposable=m;class u{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(r){let a=r;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,g(this))},this}}e.SafeDisposable=c;class s{constructor(){this.references=new Map}acquire(r,...a){let f=this.references.get(r);f||(f={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,f));const{object:S}=f,R=(0,y.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(r,f.object),this.references.delete(r))});return f.counter++,{object:S,dispose:R}}}e.ReferenceCollection=s;class l{constructor(r){this.referenceCollection=r}async acquire(r,...a){const f=this.referenceCollection.acquire(r,...a);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(S){throw f.dispose(),S}}}e.AsyncReferenceCollection=l;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function n(o){const r=new w;try{o(r)}finally{r.dispose()}}e.disposeOnReturn=n}),define(x[114],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(D){this.element=D,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let D=this._first;for(;D!==y.Undefined;){const M=D.next;D.prev=y.Undefined,D.next=y.Undefined,D=M}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,M){const E=new y(D);if(this._first===y.Undefined)this._first=E,this._last=E;else if(M){const b=this._last;this._last=E,E.prev=b,b.next=E}else{const b=this._first;this._first=E,E.next=b,b.prev=E}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(E))}}shift(){if(this._first!==y.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==y.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==y.Undefined&&D.next!==y.Undefined){const M=D.prev;M.next=D.next,D.next.prev=M}else D.prev===y.Undefined&&D.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):D.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):D.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==y.Undefined;)yield D.element,D=D.next}}e.LinkedList=t}),function(){function V(L){const D=[];typeof L=="number"&&D.push("code/timeOrigin",L);function M(g){D.push(g,Date.now())}function E(){const g=[];for(let b=0;b<D.length;b+=2)g.push({name:D[b],startTime:D[b+1]});return g}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))D.push({name:M.name,startTime:Math.round(L+M.startTime)});return D}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function y(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=y(t))}(),define(x[3],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const y="en";let t=!1,L=!1,D=!1,M=!1,E=!1,g=!1,b=!1,k=!1,P=!1,I,v=y,d,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const w=typeof p?.versions?.electron=="string",C=w&&p?.type==="renderer";if(typeof navigator=="object"&&!C)h=navigator.userAgent,t=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,k=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=h.indexOf("Linux")>=0,g=!0,I=navigator.language,v=I;else if(typeof p=="object"){t=p.platform==="win32",L=p.platform==="darwin",D=p.platform==="linux",M=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,b=w,P=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=y,v=y;const r=p.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),f=a.availableLanguages["*"];I=a.locale,v=f||y,d=a._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var m;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function u(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let c=0;L?c=1:t?c=3:D&&(c=2),e.isWindows=t,e.isMacintosh=L,e.isLinux=D,e.isLinuxSnap=M,e.isNative=E,e.isElectron=b,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=P,e.platform=c,e.userAgent=h,e.language=v;var s;(function(r){function a(){return e.language}r.value=a;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function S(){return e.language==="en"}r.isDefault=S})(s=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let S=0,R=r.length;S<R;S++){const A=r[S];if(A.id===f.data.vscodeScheduleAsyncWork){r.splice(S,1),A.callback();return}}});let a=0;return f=>{const S=++a;r.push({id:S,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return r=>setTimeout(r)})();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||k?2:t?1:3;let i=!0,n=!1;function o(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,i=new Uint16Array(r.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(x[36],ee([0,1,3]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const L=y.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(x[8],ee([0,1,36]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,D=90,M=122,E=46,g=47,b=92,k=58,P=63;class I extends Error{constructor(u,c,s){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${l} of type ${c}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function v(m,u){if(typeof m!="string")throw new I(u,"string",m)}function d(m){return m===g||m===b}function h(m){return m===g}function p(m){return m>=t&&m<=D||m>=L&&m<=M}function w(m,u,c,s){let l="",i=0,n=-1,o=0,r=0;for(let a=0;a<=m.length;++a){if(a<m.length)r=m.charCodeAt(a);else{if(s(r))break;r=g}if(s(r)){if(!(n===a-1||o===1))if(o===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==E||l.charCodeAt(l.length-2)!==E){if(l.length>2){const f=l.lastIndexOf(c);f===-1?(l="",i=0):(l=l.slice(0,f),i=l.length-1-l.lastIndexOf(c)),n=a,o=0;continue}else if(l.length!==0){l="",i=0,n=a,o=0;continue}}u&&(l+=l.length>0?`${c}..`:"..",i=2)}else l.length>0?l+=`${c}${m.slice(n+1,a)}`:l=m.slice(n+1,a),i=a-n-1;n=a,o=0}else r===E&&o!==-1?++o:o=-1}return l}function C(m,u){if(u===null||typeof u!="object")throw new I("pathObject","Object",u);const c=u.dir||u.root,s=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${s}`:`${c}${m}${s}`:s}e.win32={resolve(...m){let u="",c="",s=!1;for(let l=m.length-1;l>=-1;l--){let i;if(l>=0){if(i=m[l],v(i,"path"),i.length===0)continue}else u.length===0?i=y.cwd():(i=y.env[`=${u}`]||y.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${u}\\`));const n=i.length;let o=0,r="",a=!1;const f=i.charCodeAt(0);if(n===1)d(f)&&(o=1,a=!0);else if(d(f))if(a=!0,d(i.charCodeAt(1))){let S=2,R=S;for(;S<n&&!d(i.charCodeAt(S));)S++;if(S<n&&S!==R){const A=i.slice(R,S);for(R=S;S<n&&d(i.charCodeAt(S));)S++;if(S<n&&S!==R){for(R=S;S<n&&!d(i.charCodeAt(S));)S++;(S===n||S!==R)&&(r=`\\\\${A}\\${i.slice(R,S)}`,o=S)}}}else o=1;else p(f)&&i.charCodeAt(1)===k&&(r=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(a=!0,o=3));if(r.length>0)if(u.length>0){if(r.toLowerCase()!==u.toLowerCase())continue}else u=r;if(s){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,s=a,a&&u.length>0)break}return c=w(c,!s,"\\",d),s?`${u}\\${c}`:`${u}${c}`||"."},normalize(m){v(m,"path");const u=m.length;if(u===0)return".";let c=0,s,l=!1;const i=m.charCodeAt(0);if(u===1)return h(i)?"\\":m;if(d(i))if(l=!0,d(m.charCodeAt(1))){let o=2,r=o;for(;o<u&&!d(m.charCodeAt(o));)o++;if(o<u&&o!==r){const a=m.slice(r,o);for(r=o;o<u&&d(m.charCodeAt(o));)o++;if(o<u&&o!==r){for(r=o;o<u&&!d(m.charCodeAt(o));)o++;if(o===u)return`\\\\${a}\\${m.slice(r)}\\`;o!==r&&(s=`\\\\${a}\\${m.slice(r,o)}`,c=o)}}}else c=1;else p(i)&&m.charCodeAt(1)===k&&(s=m.slice(0,2),c=2,u>2&&d(m.charCodeAt(2))&&(l=!0,c=3));let n=c<u?w(m.slice(c),!l,"\\",d):"";return n.length===0&&!l&&(n="."),n.length>0&&d(m.charCodeAt(u-1))&&(n+="\\"),s===void 0?l?`\\${n}`:n:l?`${s}\\${n}`:`${s}${n}`},isAbsolute(m){v(m,"path");const u=m.length;if(u===0)return!1;const c=m.charCodeAt(0);return d(c)||u>2&&p(c)&&m.charCodeAt(1)===k&&d(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let u,c;for(let i=0;i<m.length;++i){const n=m[i];v(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let s=!0,l=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++l;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++l,i>2&&(d(c.charCodeAt(2))?++l:s=!1))}if(s){for(;l<u.length&&d(u.charCodeAt(l));)l++;l>=2&&(u=`\\${u.slice(l)}`)}return e.win32.normalize(u)},relative(m,u){if(v(m,"from"),v(u,"to"),m===u)return"";const c=e.win32.resolve(m),s=e.win32.resolve(u);if(c===s||(m=c.toLowerCase(),u=s.toLowerCase(),m===u))return"";let l=0;for(;l<m.length&&m.charCodeAt(l)===b;)l++;let i=m.length;for(;i-1>l&&m.charCodeAt(i-1)===b;)i--;const n=i-l;let o=0;for(;o<u.length&&u.charCodeAt(o)===b;)o++;let r=u.length;for(;r-1>o&&u.charCodeAt(r-1)===b;)r--;const a=r-o,f=n<a?n:a;let S=-1,R=0;for(;R<f;R++){const F=m.charCodeAt(l+R);if(F!==u.charCodeAt(o+R))break;F===b&&(S=R)}if(R!==f){if(S===-1)return s}else{if(a>f){if(u.charCodeAt(o+R)===b)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}n>f&&(m.charCodeAt(l+R)===b?S=R:R===2&&(S=3)),S===-1&&(S=0)}let A="";for(R=l+S+1;R<=i;++R)(R===i||m.charCodeAt(R)===b)&&(A+=A.length===0?"..":"\\..");return o+=S,A.length>0?`${A}${s.slice(o,r)}`:(s.charCodeAt(o)===b&&++o,s.slice(o,r))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const u=e.win32.resolve(m);if(u.length<=2)return m;if(u.charCodeAt(0)===b){if(u.charCodeAt(1)===b){const c=u.charCodeAt(2);if(c!==P&&c!==E)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(p(u.charCodeAt(0))&&u.charCodeAt(1)===k&&u.charCodeAt(2)===b)return`\\\\?\\${u}`;return m},dirname(m){v(m,"path");const u=m.length;if(u===0)return".";let c=-1,s=0;const l=m.charCodeAt(0);if(u===1)return d(l)?m:".";if(d(l)){if(c=s=1,d(m.charCodeAt(1))){let o=2,r=o;for(;o<u&&!d(m.charCodeAt(o));)o++;if(o<u&&o!==r){for(r=o;o<u&&d(m.charCodeAt(o));)o++;if(o<u&&o!==r){for(r=o;o<u&&!d(m.charCodeAt(o));)o++;if(o===u)return m;o!==r&&(c=s=o+1)}}}}else p(l)&&m.charCodeAt(1)===k&&(c=u>2&&d(m.charCodeAt(2))?3:2,s=c);let i=-1,n=!0;for(let o=u-1;o>=s;--o)if(d(m.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return m.slice(0,i)},basename(m,u){u!==void 0&&v(u,"ext"),v(m,"path");let c=0,s=-1,l=!0,i;if(m.length>=2&&p(m.charCodeAt(0))&&m.charCodeAt(1)===k&&(c=2),u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let n=u.length-1,o=-1;for(i=m.length-1;i>=c;--i){const r=m.charCodeAt(i);if(d(r)){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),n>=0&&(r===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=m.length),m.slice(c,s)}for(i=m.length-1;i>=c;--i)if(d(m.charCodeAt(i))){if(!l){c=i+1;break}}else s===-1&&(l=!1,s=i+1);return s===-1?"":m.slice(c,s)},extname(m){v(m,"path");let u=0,c=-1,s=0,l=-1,i=!0,n=0;m.length>=2&&m.charCodeAt(1)===k&&p(m.charCodeAt(0))&&(u=s=2);for(let o=m.length-1;o>=u;--o){const r=m.charCodeAt(o);if(d(r)){if(!i){s=o+1;break}continue}l===-1&&(i=!1,l=o+1),r===E?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||l===-1||n===0||n===1&&c===l-1&&c===s+1?"":m.slice(c,l)},format:C.bind(null,"\\"),parse(m){v(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.length;let s=0,l=m.charCodeAt(0);if(c===1)return d(l)?(u.root=u.dir=m,u):(u.base=u.name=m,u);if(d(l)){if(s=1,d(m.charCodeAt(1))){let S=2,R=S;for(;S<c&&!d(m.charCodeAt(S));)S++;if(S<c&&S!==R){for(R=S;S<c&&d(m.charCodeAt(S));)S++;if(S<c&&S!==R){for(R=S;S<c&&!d(m.charCodeAt(S));)S++;S===c?s=S:S!==R&&(s=S+1)}}}}else if(p(l)&&m.charCodeAt(1)===k){if(c<=2)return u.root=u.dir=m,u;if(s=2,d(m.charCodeAt(2))){if(c===3)return u.root=u.dir=m,u;s=3}}s>0&&(u.root=m.slice(0,s));let i=-1,n=s,o=-1,r=!0,a=m.length-1,f=0;for(;a>=s;--a){if(l=m.charCodeAt(a),d(l)){if(!r){n=a+1;break}continue}o===-1&&(r=!1,o=a+1),l===E?i===-1?i=a:f!==1&&(f=1):i!==-1&&(f=-1)}return o!==-1&&(i===-1||f===0||f===1&&i===o-1&&i===n+1?u.base=u.name=m.slice(n,o):(u.name=m.slice(n,i),u.base=m.slice(n,o),u.ext=m.slice(i,o))),n>0&&n!==s?u.dir=m.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let u="",c=!1;for(let s=m.length-1;s>=-1&&!c;s--){const l=s>=0?m[s]:y.cwd();v(l,"path"),l.length!==0&&(u=`${l}/${u}`,c=l.charCodeAt(0)===g)}return u=w(u,!c,"/",h),c?`/${u}`:u.length>0?u:"."},normalize(m){if(v(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===g,c=m.charCodeAt(m.length-1)===g;return m=w(m,!u,"/",h),m.length===0?u?"/":c?"./":".":(c&&(m+="/"),u?`/${m}`:m)},isAbsolute(m){return v(m,"path"),m.length>0&&m.charCodeAt(0)===g},join(...m){if(m.length===0)return".";let u;for(let c=0;c<m.length;++c){const s=m[c];v(s,"path"),s.length>0&&(u===void 0?u=s:u+=`/${s}`)}return u===void 0?".":e.posix.normalize(u)},relative(m,u){if(v(m,"from"),v(u,"to"),m===u||(m=e.posix.resolve(m),u=e.posix.resolve(u),m===u))return"";const c=1,s=m.length,l=s-c,i=1,n=u.length-i,o=l<n?l:n;let r=-1,a=0;for(;a<o;a++){const S=m.charCodeAt(c+a);if(S!==u.charCodeAt(i+a))break;S===g&&(r=a)}if(a===o)if(n>o){if(u.charCodeAt(i+a)===g)return u.slice(i+a+1);if(a===0)return u.slice(i+a)}else l>o&&(m.charCodeAt(c+a)===g?r=a:a===0&&(r=0));let f="";for(a=c+r+1;a<=s;++a)(a===s||m.charCodeAt(a)===g)&&(f+=f.length===0?"..":"/..");return`${f}${u.slice(i+r)}`},toNamespacedPath(m){return m},dirname(m){if(v(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===g;let c=-1,s=!0;for(let l=m.length-1;l>=1;--l)if(m.charCodeAt(l)===g){if(!s){c=l;break}}else s=!1;return c===-1?u?"/":".":u&&c===1?"//":m.slice(0,c)},basename(m,u){u!==void 0&&v(u,"ext"),v(m,"path");let c=0,s=-1,l=!0,i;if(u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let n=u.length-1,o=-1;for(i=m.length-1;i>=0;--i){const r=m.charCodeAt(i);if(r===g){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1),n>=0&&(r===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=m.length),m.slice(c,s)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===g){if(!l){c=i+1;break}}else s===-1&&(l=!1,s=i+1);return s===-1?"":m.slice(c,s)},extname(m){v(m,"path");let u=-1,c=0,s=-1,l=!0,i=0;for(let n=m.length-1;n>=0;--n){const o=m.charCodeAt(n);if(o===g){if(!l){c=n+1;break}continue}s===-1&&(l=!1,s=n+1),o===E?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||s===-1||i===0||i===1&&u===s-1&&u===c+1?"":m.slice(u,s)},format:C.bind(null,"/"),parse(m){v(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const c=m.charCodeAt(0)===g;let s;c?(u.root="/",s=1):s=0;let l=-1,i=0,n=-1,o=!0,r=m.length-1,a=0;for(;r>=s;--r){const f=m.charCodeAt(r);if(f===g){if(!o){i=r+1;break}continue}n===-1&&(o=!1,n=r+1),f===E?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}if(n!==-1){const f=i===0&&c?1:i;l===-1||a===0||a===1&&l===n-1&&l===i+1?u.base=u.name=m.slice(f,n):(u.name=m.slice(f,l),u.base=m.slice(f,n),u.ext=m.slice(l,n))}return i>0?u.dir=m.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(x[70],ee([0,1,3]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var L;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(E,...g){const b=g.reduce((I,v)=>(I[v]=!0,I),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(I=>!b[I]).forEach(I=>{for(let v=0;v<k.length;v++)if(I.search(k[v])!==-1){delete E[I];break}})}e.sanitizeProcessEnvironment=D;function M(E){!E||(delete E.DEBUG,y.isMacintosh&&delete E.DYLD_LIBRARY_PATH,y.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(x[71],ee([0,1,3]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class L{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new L(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=L}),define(x[4],ee([0,1,15,43,2,114,71]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let E=!1,g=!1;var b;(function(r){r.None=()=>L.Disposable.None;function a(U){if(g){const{onListenerDidAdd:W}=U,N=d.create();let T=0;U.onListenerDidAdd=()=>{++T==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),W?.()}}}function f(U){return(W,N=null,T)=>{let _=!1,q;return q=U(Z=>{if(!_)return q?q.dispose():_=!0,W.call(N,Z)},null,T),_&&q.dispose(),q}}r.once=f;function S(U,W,N){return ne((T,_=null,q)=>U(Z=>T.call(_,W(Z)),null,q),N)}r.map=S;function R(U,W,N){return ne((T,_=null,q)=>U(Z=>{W(Z),T.call(_,Z)},null,q),N)}r.forEach=R;function A(U,W,N){return ne((T,_=null,q)=>U(Z=>W(Z)&&T.call(_,Z),null,q),N)}r.filter=A;function F(U){return U}r.signal=F;function $(...U){return(W,N=null,T)=>(0,L.combinedDisposable)(...U.map(_=>_(q=>W.call(N,q),null,T)))}r.any=$;function J(U,W,N,T){let _=N;return S(U,q=>(_=W(_,q),_),T)}r.reduce=J;function ne(U,W){let N;const T={onFirstListenerAdd(){N=U(_.fire,_)},onLastListenerRemove(){N.dispose()}};W||a(T);const _=new p(T);return W&&W.add(_),_.event}function Y(U,W,N=100,T=!1,_,q){let Z,oe,ce,se=0;const he={leakWarningThreshold:_,onFirstListenerAdd(){Z=U(ge=>{se++,oe=W(oe,ge),T&&!ce&&(ue.fire(oe),oe=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ee=oe;oe=void 0,ce=void 0,(!T||se>1)&&ue.fire(Ee),se=0},N)})},onLastListenerRemove(){Z.dispose()}};q||a(he);const ue=new p(he);return q&&q.add(ue),ue.event}r.debounce=Y;function re(U,W=(T,_)=>T===_,N){let T=!0,_;return A(U,q=>{const Z=T||!W(q,_);return T=!1,_=q,Z},N)}r.latch=re;function H(U,W,N){return[r.filter(U,W,N),r.filter(U,T=>!W(T),N)]}r.split=H;function X(U,W=!1,N=[]){let T=N.slice(),_=U(oe=>{T?T.push(oe):Z.fire(oe)});const q=()=>{T&&T.forEach(oe=>Z.fire(oe)),T=null},Z=new p({onFirstListenerAdd(){_||(_=U(oe=>Z.fire(oe)))},onFirstListenerDidAdd(){T&&(W?setTimeout(q):q())},onLastListenerRemove(){_&&_.dispose(),_=null}});return Z.event}r.buffer=X;class j{constructor(W){this.event=W}map(W){return new j(S(this.event,W))}forEach(W){return new j(R(this.event,W))}filter(W){return new j(A(this.event,W))}reduce(W,N){return new j(J(this.event,W,N))}latch(){return new j(re(this.event))}debounce(W,N=100,T=!1,_){return new j(Y(this.event,W,N,T,_))}on(W,N,T){return this.event(W,N,T)}once(W,N,T){return f(this.event)(W,N,T)}}function B(U){return new j(U)}r.chain=B;function z(U,W,N=T=>T){const T=(...oe)=>Z.fire(N(...oe)),_=()=>U.on(W,T),q=()=>U.removeListener(W,T),Z=new p({onFirstListenerAdd:_,onLastListenerRemove:q});return Z.event}r.fromNodeEventEmitter=z;function K(U,W,N=T=>T){const T=(...oe)=>Z.fire(N(...oe)),_=()=>U.addEventListener(W,T),q=()=>U.removeEventListener(W,T),Z=new p({onFirstListenerAdd:_,onLastListenerRemove:q});return Z.event}r.fromDOMEventEmitter=K;function te(U){return new Promise(W=>f(U)(W))}r.toPromise=te;function Q(U,W){return W(void 0),U(N=>W(N))}r.runAndSubscribe=Q;function O(U,W){let N=null;function T(q){N?.dispose(),N=new L.DisposableStore,W(q,N)}T(void 0);const _=U(q=>T(q));return(0,L.toDisposable)(()=>{_.dispose(),N?.dispose()})}r.runAndSubscribeWithStore=O})(b=e.Event||(e.Event={}));class k{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${k._idPool++}`}start(a){this._stopWatch=new M.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}k._idPool=0;let P=-1;function I(r){const a=P;return P=r,{dispose(){P=a}}}e.setGlobalLeakWarningThreshold=I;class v{constructor(a,f=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,f){let S=P;if(typeof this.customThreshold=="number"&&(S=this.customThreshold),S<=0||f<S)return;this._stacks||(this._stacks=new Map);const R=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,R+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let A,F=0;for(const[$,J]of this._stacks)(!A||F<J)&&(A=$,F=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${F}):`),console.warn(A)}return()=>{const A=this._stacks.get(a.value)||0;this._stacks.set(a.value,A-1)}}}class d{constructor(a){this.value=a}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(a,f,S){this.callback=a,this.callbackThis=f,this.stack=S,this.subscription=new L.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class p{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=P>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new k(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const f of a)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,f,S)=>{this._listeners||(this._listeners=new D.LinkedList);const R=this._listeners.isEmpty();R&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let A,F;this._leakageMon&&this._listeners.size>=30&&(F=d.create(),A=this._leakageMon.check(F,this._listeners.size+1)),E&&(F=F??d.create());const $=new h(a,f,F),J=this._listeners.push($);R&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,f);const ne=$.subscription.set(()=>{A&&A(),this._disposed||(J(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof L.DisposableStore?S.add(ne):Array.isArray(S)&&S.push(ne),ne}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C);for(let f of this._listeners)this._deliveryQueue.push(this,f,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class w{constructor(){this._queue=new D.LinkedList}get size(){return this._queue.size}push(a,f,S){this._queue.push(new m(a,f,S))}clear(a){const f=new D.LinkedList;for(const S of this._queue)S.emitter!==a&&f.push(S);this._queue=f}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(f){(0,y.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=w;class C extends w{clear(a){this._queue.clear()}}class m{constructor(a,f,S){this.emitter=a,this.listener=f,this.event=S}}class u extends p{async fireAsync(a,f,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const R of this._listeners)this._asyncDeliveryQueue.push([R,a]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[R,A]=this._asyncDeliveryQueue.shift(),F=[],$={...A,token:f,waitUntil:J=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");S&&(J=S(J,R.callback)),F.push(J)}};try{R.invoke($)}catch(J){(0,y.onUnexpectedError)(J);continue}Object.freeze(F),await Promise.allSettled(F).then(J=>{for(const ne of J)ne.status==="rejected"&&(0,y.onUnexpectedError)(ne.reason)})}}}}e.AsyncEmitter=u;class c extends p{constructor(a){super(a);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class s extends c{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=s;class l extends p{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const f={event:a,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const S=()=>{this.hasListeners&&this.unhook(f);const R=this.events.indexOf(f);this.events.splice(R,1)};return(0,L.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(f=>this.emitter.fire(f))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(a){return(f,S,R)=>a(A=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>f.call(S,A)):f.call(S,A)},void 0,R)}bufferEvents(a){const f=[];this.buffers.push(f);const S=a();return this.buffers.pop(),f.forEach(R=>R()),S}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=L.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(x[23],ee([0,1,4]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,g){const b=setTimeout(E.bind(g),0);return{dispose(){clearTimeout(b)}}});var L;(function(E){function g(b){return b===E.None||b===E.Cancelled||b instanceof D?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}E.isCancellationToken=g,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=L.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=M}),define(x[115],ee([0,1,23]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new y.CancellationTokenSource,g=this.task(E.token);return this.result={promise:g,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class L{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const g=JSON.stringify(E);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=L;class D{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const g=this.fn(E);return this._map.set(E,g),g}}e.CachedFunction=D}),define(x[85],ee([0,1,4,2]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const L=M=>({onDidChange:y.Event.None,value:M});e.staticObservableValue=L;class D extends t.Disposable{constructor(E){super();this._value=E,this.changeEmitter=this._register(new y.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=D}),define(x[49],ee([0,1,15,2]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=L;function D(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=D;function M(u){const c=u;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(u,c){return new g(u,c)}e.newWriteableStream=E;class g{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?(0,y.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let l;switch(c){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(s);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(u,c){const s=[];let l;for(;(l=u.read())!==null;)s.push(l);return c(s)}e.consumeReadable=b;function k(u,c,s){const l=[];let i;for(;(i=u.read())!==null&&l.length<s;)l.push(i);return i===null&&l.length>0?c(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=k;function P(u,c){return new Promise((s,l)=>{const i=[];I(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?l(n):s(void 0)},onEnd:()=>{s(c?c(i):void 0)}})})}e.consumeStream=P;function I(u,c){let s=!1;return u.on("error",l=>{s||c.onError(l)}),u.on("end",()=>{s||c.onEnd()}),u.on("data",l=>{s||c.onData(l)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=I;function v(u,c){return new Promise((s,l)=>{const i=new t.DisposableStore,n=[],o=f=>{if(n.push(f),n.length>c)return i.dispose(),u.pause(),s({stream:u,buffer:n,ended:!1})},r=f=>l(f),a=()=>s({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),i.add((0,t.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=v;function d(u,c){const s=E(c);return s.end(u),s}e.toStream=d;function h(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=h;function p(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=p;function w(u,c,s){const l=E(s);return I(u,{onData:i=>l.write(c.data(i)),onError:i=>l.error(c.error?c.error(i):i),onEnd:()=>l.end()}),l}e.transform=w;function C(u,c,s){let l=!1;return{read:()=>{const i=c.read();return l?i:(l=!0,i!==null?s([u,i]):u)}}}e.prefixedReadable=C;function m(u,c,s){let l=!1;const i=E(s);return I(c,{onData:n=>l?i.write(n):(l=!0,i.write(s([u,n]))),onError:n=>i.error(n),onEnd:()=>{l||(l=!0,i.write(u)),i.end()}}),i}e.prefixedStream=m}),define(x[18],ee([0,1,49]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,D;class M{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return t?new M(Buffer.allocUnsafe(f)):new M(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new M(f)}static fromString(f,S){return!(S?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(f)):(L||(L=new TextEncoder),new M(L.encode(f)))}static fromByteArray(f){const S=M.alloc(f.length);for(let R=0,A=f.length;R<A;R++)S.buffer[R]=f[R];return S}static concat(f,S){if(typeof S=="undefined"){S=0;for(let F=0,$=f.length;F<$;F++)S+=f[F].byteLength}const R=M.alloc(S);let A=0;for(let F=0,$=f.length;F<$;F++){const J=f[F];R.set(J,A),A+=J.byteLength}return R}clone(){const f=M.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(f,S){return new M(this.buffer.subarray(f,S))}set(f,S){if(f instanceof M)this.buffer.set(f.buffer,S);else if(f instanceof Uint8Array)this.buffer.set(f,S);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),S);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return b(this.buffer,f)}writeUInt32BE(f,S){k(this.buffer,f,S)}readUInt32LE(f){return P(this.buffer,f)}writeUInt32LE(f,S){I(this.buffer,f,S)}readUInt8(f){return v(this.buffer,f)}writeUInt8(f,S){d(this.buffer,f,S)}}e.VSBuffer=M;function E(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0}e.readUInt16LE=E;function g(a,f,S){a[S+0]=f&255,f=f>>>8,a[S+1]=f&255}e.writeUInt16LE=g;function b(a,f){return a[f]*2**24+a[f+1]*2**16+a[f+2]*2**8+a[f+3]}e.readUInt32BE=b;function k(a,f,S){a[S+3]=f,f=f>>>8,a[S+2]=f,f=f>>>8,a[S+1]=f,f=f>>>8,a[S]=f}e.writeUInt32BE=k;function P(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0|a[f+2]<<16>>>0|a[f+3]<<24>>>0}e.readUInt32LE=P;function I(a,f,S){a[S+0]=f&255,f=f>>>8,a[S+1]=f&255,f=f>>>8,a[S+2]=f&255,f=f>>>8,a[S+3]=f&255}e.writeUInt32LE=I;function v(a,f){return a[f]}e.readUInt8=v;function d(a,f,S){a[S]=f}e.writeUInt8=d;function h(a){return y.consumeReadable(a,f=>M.concat(f))}e.readableToBuffer=h;function p(a){return y.toReadable(a)}e.bufferToReadable=p;function w(a){return y.consumeStream(a,f=>M.concat(f))}e.streamToBuffer=w;async function C(a){return a.ended?M.concat(a.buffer):M.concat([...a.buffer,await w(a.stream)])}e.bufferedStreamToBuffer=C;function m(a){return y.toStream(a,f=>M.concat(f))}e.bufferToStream=m;function u(a){return y.transform(a,{data:f=>typeof f=="string"?M.fromString(f):M.wrap(f)},f=>M.concat(f))}e.streamToBufferReadableStream=u;function c(a){return y.newWriteableStream(f=>M.concat(f),a)}e.newWriteableBufferStream=c;function s(a,f){return y.prefixedReadable(a,f,S=>M.concat(S))}e.prefixedBufferReadable=s;function l(a,f){return y.prefixedStream(a,f,S=>M.concat(S))}e.prefixedBufferStream=l;function i(a){let f=0,S=0,R=0;const A=new Uint8Array(Math.floor(a.length/4*3)),F=J=>{switch(S){case 3:A[R++]=f|J,S=0;break;case 2:A[R++]=f|J>>>2,f=J<<6,S=3;break;case 1:A[R++]=f|J>>>4,f=J<<4,S=2;break;default:f=J<<2,S=1}};for(let J=0;J<a.length;J++){const ne=a.charCodeAt(J);if(ne>=65&&ne<=90)F(ne-65);else if(ne>=97&&ne<=122)F(ne-97+26);else if(ne>=48&&ne<=57)F(ne-48+52);else if(ne===43||ne===45)F(62);else if(ne===47||ne===95)F(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${a[J]}`)}}const $=R;for(;S>0;)F(0);return M.wrap(A).slice(0,$)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:a},f=!0,S=!1){const R=S?o:n;let A="";const F=a.byteLength%3;let $=0;for(;$<a.byteLength-F;$+=3){const J=a[$+0],ne=a[$+1],Y=a[$+2];A+=R[J>>>2],A+=R[(J<<4|ne>>>4)&63],A+=R[(ne<<2|Y>>>6)&63],A+=R[Y&63]}if(F===1){const J=a[$+0];A+=R[J>>>2],A+=R[J<<4&63],f&&(A+="==")}else if(F===2){const J=a[$+0],ne=a[$+1];A+=R[J>>>2],A+=R[(J<<4|ne>>>4)&63],A+=R[ne<<2&63],f&&(A+="=")}return A}e.encodeBase64=r}),define(x[28],ee([0,1,115,113]),function(V,e,y,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=D;const M=/{(\d+)}/g;function E(G,...ae){return ae.length===0?G:G.replace(M,function(le,me){const ve=parseInt(me,10);return isNaN(ve)||ve<0||ve>=ae.length?le:ae[ve]})}e.format=E;const g=/{([^}]+)}/g;function b(G,ae){return G.replace(g,(le,me)=>ae[me]??le)}e.format2=b;function k(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=k;function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function I(G,ae){let le=0;const me=ae.charCodeAt(0);for(let ve=G.length-1;ve>=0;ve--)G.charCodeAt(ve)===me&&le++;return le}e.count=I;function v(G,ae,le="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${le}`}e.truncate=v;function d(G,ae=" "){const le=h(G,ae);return p(le,ae)}e.trim=d;function h(G,ae){if(!G||!ae)return G;const le=ae.length;if(le===0||G.length===0)return G;let me=0;for(;G.indexOf(ae,me)===me;)me=me+le;return G.substring(me)}e.ltrim=h;function p(G,ae){if(!G||!ae)return G;const le=ae.length,me=G.length;if(le===0||me===0)return G;let ve=me,Me=-1;for(;Me=G.lastIndexOf(ae,ve-1),!(Me===-1||Me+le!==ve);){if(Me===0)return"";ve=Me}return G.substring(0,ve)}e.rtrim=p;function w(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function C(G){return G.replace(/\*/g,"")}e.stripWildcards=C;function m(G,ae,le={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=P(G)),le.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return le.global&&(me+="g"),le.matchCase||(me+="i"),le.multiline&&(me+="m"),le.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=m;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function s(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=s;function l(G){return G.split(/\r\n|\r|\n/)}e.splitLines=l;function i(G){for(let ae=0,le=G.length;ae<le;ae++){const me=G.charCodeAt(ae);if(me!==32&&me!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function n(G,ae=0,le=G.length){for(let me=ae;me<le;me++){const ve=G.charCodeAt(me);if(ve!==32&&ve!==9)return G.substring(ae,me)}return G.substring(ae,le)}e.getLeadingWhitespace=n;function o(G,ae=G.length-1){for(let le=ae;le>=0;le--){const me=G.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function r(G,ae,le){let me=[],ve=0;for(const Me of G.matchAll(ae)){if(me.push(G.slice(ve,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");ve=Me.index+Me[0].length,me.push(le(Me[0],...Me.slice(1),Me.index,G,Me.groups))}return me.push(G.slice(ve)),Promise.all(me).then(Me=>Me.join(""))}e.replaceAsync=r;function a(G,ae){return G<ae?-1:G>ae?1:0}e.compare=a;function f(G,ae,le=0,me=G.length,ve=0,Me=ae.length){for(;le<me&&ve<Me;le++,ve++){let Ke=G.charCodeAt(le),Oe=ae.charCodeAt(ve);if(Ke<Oe)return-1;if(Ke>Oe)return 1}const Ne=me-le,Qe=Me-ve;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstring=f;function S(G,ae){return R(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=S;function R(G,ae,le=0,me=G.length,ve=0,Me=ae.length){for(;le<me&&ve<Me;le++,ve++){let Ke=G.charCodeAt(le),Oe=ae.charCodeAt(ve);if(Ke===Oe)continue;if(Ke>=128||Oe>=128)return f(G.toLowerCase(),ae.toLowerCase(),le,me,ve,Me);A(Ke)&&(Ke-=32),A(Oe)&&(Oe-=32);const He=Ke-Oe;if(He!==0)return He}const Ne=me-le,Qe=Me-ve;return Ne<Qe?-1:Ne>Qe?1:0}e.compareSubstringIgnoreCase=R;function A(G){return G>=97&&G<=122}e.isLowerAsciiLetter=A;function F(G){return G>=65&&G<=90}e.isUpperAsciiLetter=F;function $(G,ae){return G.length===ae.length&&R(G,ae)===0}e.equalsIgnoreCase=$;function J(G,ae){const le=ae.length;return ae.length>G.length?!1:R(G,ae,0,le)===0}e.startsWithIgnoreCase=J;function ne(G,ae){let le,me=Math.min(G.length,ae.length);for(le=0;le<me;le++)if(G.charCodeAt(le)!==ae.charCodeAt(le))return le;return me}e.commonPrefixLength=ne;function Y(G,ae){let le,me=Math.min(G.length,ae.length);const ve=G.length-1,Me=ae.length-1;for(le=0;le<me;le++)if(G.charCodeAt(ve-le)!==ae.charCodeAt(Me-le))return le;return me}e.commonSuffixLength=Y;function re(G){return 55296<=G&&G<=56319}e.isHighSurrogate=re;function H(G){return 56320<=G&&G<=57343}e.isLowSurrogate=H;function X(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=X;function j(G,ae,le){const me=G.charCodeAt(le);if(re(me)&&le+1<ae){const ve=G.charCodeAt(le+1);if(H(ve))return X(me,ve)}return me}e.getNextCodePoint=j;function B(G,ae){const le=G.charCodeAt(ae-1);if(H(le)&&ae>1){const me=G.charCodeAt(ae-2);if(re(me))return X(me,le)}return le}class z{constructor(ae,le=0){this._str=ae,this._len=ae.length,this._offset=le}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=B(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=j(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=z;class K{constructor(ae,le=0){this._iterator=new z(ae,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=qe.getInstance(),le=this._iterator,me=le.offset;let ve=ae.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Me=le.offset,Ne=ae.getGraphemeBreakType(le.nextCodePoint());if(Je(ve,Ne)){le.setOffset(Me);break}ve=Ne}return le.offset-me}prevGraphemeLength(){const ae=qe.getInstance(),le=this._iterator,me=le.offset;let ve=ae.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Me=le.offset,Ne=ae.getGraphemeBreakType(le.prevCodePoint());if(Je(Ne,ve)){le.setOffset(Me);break}ve=Ne}return me-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function te(G,ae){return new K(G,ae).nextGraphemeLength()}e.nextCharLength=te;function Q(G,ae){return new K(G,ae).prevGraphemeLength()}e.prevCharLength=Q;function O(G,ae){ae>0&&H(G.charCodeAt(ae))&&ae--;const le=ae+te(G,ae);return[le-Q(G,le),le]}e.getCharContainingOffset=O;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(G){return U.test(G)}e.containsRTL=W;const N=/^[\t\n\r\x20-\x7E]*$/;function T(G){return N.test(G)}e.isBasicASCII=T,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=_;function q(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=q;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=Z;function oe(G,ae){if(G.length<ae)return G;const le=/\b/g;let me=0;for(;le.test(G)&&!(G.length-le.lastIndex<ae);)me=le.lastIndex,le.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=oe;const ce=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ue(G){return G&&(G=G.replace(ce,""),G=G.replace(se,""),G=G.replace(he,"")),G}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function Ee(G){return ge(G)?G.substr(1):G}e.stripUTF8BOM=Ee;function Pe(G,ae){if(!G||!ae||G.length<ae.length)return!1;const le=ae.length,me=G.toLowerCase();let ve=0,Me=-1;for(;ve<le;){const Ne=me.indexOf(ae[ve],Me+1);if(Ne<0)return!1;Me=Ne,ve++}return!0}e.fuzzyContains=Pe;function be(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=be;function Se(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Se;function Ie(G,ae=1){if(ae===0)return"";let le=-1;do le=G.indexOf(`
`,le+1),ae--;while(ae>0&&le>=0);return le===-1?G:(G[le-1]==="\r"&&le--,G.substr(0,le))}e.getNLines=Ie;function We(G){const ae=90-65+1;return G=G%(2*ae),G<ae?String.fromCharCode(97+G):String.fromCharCode(65+G-ae)}e.singleLetterHash=We;function _e(G){return qe.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=_e;function Je(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}var Ue;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class qe{constructor(){this._data=ot()}static getInstance(){return qe._INSTANCE||(qe._INSTANCE=new qe),qe._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const le=this._data,me=le.length/3;let ve=1;for(;ve<=me;)if(ae<le[3*ve])ve=2*ve;else if(ae>le[3*ve+1])ve=2*ve+1;else return le[3*ve+2];return 0}}qe._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(G,ae){if(G===0)return 0;const le=xe(G,ae);if(le!==void 0)return le;const me=new z(ae,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ze;function xe(G,ae){const le=new z(ae,G);let me=le.prevCodePoint();for(;vt(me)||me===65039||me===8419;){if(le.offset===0)return;me=le.prevCodePoint()}if(!Z(me))return;let ve=le.offset;return ve>0&&le.prevCodePoint()===8205&&(ve=le.offset),ve}function vt(G){return 127995<=G&&G<=127999}var at;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.noBreakWhitespace="\xA0";class je{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return je.cache.get(Array.from(ae))}static getLocales(){return je._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,L=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new y.LRUCachedFunction(G=>{function ae(Oe){const He=new Map;for(let Ve=0;Ve<Oe.length;Ve+=2)He.set(Oe[Ve],Oe[Ve+1]);return He}function le(Oe,He){const Ve=new Map(Oe);for(const[tt,ct]of He)Ve.set(tt,ct);return Ve}function me(Oe,He){if(!Oe)return He;const Ve=new Map;for(const[tt,ct]of Oe)He.has(tt)&&Ve.set(tt,ct);return Ve}const ve=L.ambiguousCharacterData.getValue();let Me=G.filter(Oe=>!Oe.startsWith("_")&&Oe in ve);Me.length===0&&(Me=["_default"]);let Ne;for(const Oe of Me){const He=ae(ve[Oe]);Ne=me(Ne,He)}const Qe=ae(ve._common),Ke=le(Qe,Ne);return new je(Ke)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(ae){return et.getData().has(ae)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et,et._data=void 0}),define(x[72],ee([0,1,28]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(w){return L(w,0)}e.hash=t;function L(w,C){switch(typeof w){case"object":return w===null?D(349,C):Array.isArray(w)?g(w,C):b(w,C);case"string":return E(w,C);case"boolean":return M(w,C);case"number":return D(w,C);case"undefined":return D(937,C);default:return D(617,C)}}e.doHash=L;function D(w,C){return(C<<5)-C+w|0}e.numberHash=D;function M(w,C){return D(w?433:863,C)}function E(w,C){C=D(149417,C);for(let m=0,u=w.length;m<u;m++)C=D(w.charCodeAt(m),C);return C}e.stringHash=E;function g(w,C){return C=D(104579,C),w.reduce((m,u)=>L(u,m),C)}function b(w,C){return C=D(181387,C),Object.keys(w).sort().reduce((m,u)=>(m=E(u,m),L(w[u],m)),C)}class k{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=L(C,this._value),this._value}}e.Hasher=k;var P;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function I(w,C,m=32){const u=m-C,c=~((1<<u)-1);return(w<<C|(c&w)>>>u)>>>0}function v(w,C=0,m=w.byteLength,u=0){for(let c=0;c<m;c++)w[C+c]=u}function d(w,C,m="0"){for(;w.length<C;)w=m+w;return w}function h(w,C=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(m=>m.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),C/4)}e.toHexString=h;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const m=C.length;if(m===0)return;const u=this._buff;let c=this._buffLen,s=this._leftoverHighSurrogate,l,i;for(s!==0?(l=s,i=-1,s=0):(l=C.charCodeAt(0),i=0);;){let n=l;if(y.isHighSurrogate(l))if(i+1<m){const o=C.charCodeAt(i+1);y.isLowSurrogate(o)?(i++,n=y.computeCodePoint(l,o)):n=65533}else{s=l;break}else y.isLowSurrogate(l)&&(n=65533);if(c=this._push(u,c,n),i++,i<m)l=C.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=s}_push(C,m,u){return u<128?C[m++]=u:u<2048?(C[m++]=192|(u&1984)>>>6,C[m++]=128|(u&63)>>>0):u<65536?(C[m++]=224|(u&61440)>>>12,C[m++]=128|(u&4032)>>>6,C[m++]=128|(u&63)>>>0):(C[m++]=240|(u&1835008)>>>18,C[m++]=128|(u&258048)>>>12,C[m++]=128|(u&4032)>>>6,C[m++]=128|(u&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=p._bigBlock32,m=this._buffDV;for(let a=0;a<64;a+=4)C.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)C.setUint32(a,I(C.getUint32(a-12,!1)^C.getUint32(a-32,!1)^C.getUint32(a-56,!1)^C.getUint32(a-64,!1),1),!1);let u=this._h0,c=this._h1,s=this._h2,l=this._h3,i=this._h4,n,o,r;for(let a=0;a<80;a++)a<20?(n=c&s|~c&l,o=1518500249):a<40?(n=c^s^l,o=1859775393):a<60?(n=c&s|c&l|s&l,o=2400959708):(n=c^s^l,o=3395469782),r=I(u,5)+n+i+o+C.getUint32(a*4,!1)&4294967295,i=l,l=s,s=I(c,30),c=u,u=r;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(V,e,y,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(V,y):L?L.value=y:e.set(V,y),y},Xe=this&&this.__classPrivateFieldGet||function(V,e,y,t){if(y==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!t:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?t:y==="a"?t.call(V):t?t.value:e.get(V)};define(x[35],ee([0,1,26,28]),function(V,e,y,t){"use strict";var L,D,M,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function g(o,r,a){let f=o.get(r);return f===void 0&&(f=a,o.set(r,f)),f}e.getOrSet=g;function b(o){const r=[];return o.forEach((a,f)=>{r.push(`${f} => ${a}`)}),`Map(${o.size}) {${r.join(", ")}}`}e.mapToString=b;function k(o){const r=[];return o.forEach(a=>{r.push(a)}),`Set(${o.size}) {${r.join(", ")}}`}e.setToString=k;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return a-f}value(){return this._value[this._pos]}}e.StringIterator=P;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class v{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let a=r.length-1;a>=0;a--,this._valueLen--){const f=this._value.charCodeAt(a);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var d;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(d||(d={}));class h{constructor(r,a){this._ignorePathCasing=r,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(w||(w={}));class C{constructor(r){this._iter=r}static forUris(r=()=>!1,a=()=>!1){return new C(new h(r,a))}static forPaths(r=!1){return new C(new v(void 0,!r))}static forStrings(){return new C(new P)}static forConfigKeys(){return new C(new I)}clear(){this._root=void 0}fill(r,a){if(a){const f=a.slice(0);(0,y.shuffle)(f);for(let S of f)this.set(S,r)}else{const f=r.slice(0);(0,y.shuffle)(f);for(let S of f)this.set(S[0],S[1])}}set(r,a){const f=this._iter.reset(r);let S;this._root||(this._root=new p,this._root.segment=f.value());const R=[];for(S=this._root;;){const F=f.cmp(S.segment);if(F>0)S.left||(S.left=new p,S.left.segment=f.value()),R.push([-1,S]),S=S.left;else if(F<0)S.right||(S.right=new p,S.right.segment=f.value()),R.push([1,S]),S=S.right;else if(f.hasNext())f.next(),S.mid||(S.mid=new p,S.mid.segment=f.value()),R.push([0,S]),S=S.mid;else break}const A=S.value;S.value=a,S.key=r;for(let F=R.length-1;F>=0;F--){const $=R[F][1];$.updateHeight();const J=$.balanceFactor();if(J<-1||J>1){const ne=R[F][0],Y=R[F+1][0];if(ne===1&&Y===1)R[F][1]=$.rotateLeft();else if(ne===-1&&Y===-1)R[F][1]=$.rotateRight();else if(ne===1&&Y===-1)$.right=R[F+1][1]=R[F+1][1].rotateRight(),R[F][1]=$.rotateLeft();else if(ne===-1&&Y===1)$.left=R[F+1][1]=R[F+1][1].rotateLeft(),R[F][1]=$.rotateRight();else throw new Error;if(F>0)switch(R[F-1][0]){case-1:R[F-1][1].left=R[F][1];break;case 1:R[F-1][1].right=R[F][1];break;case 0:R[F-1][1].mid=R[F][1];break}else this._root=R[0][1]}}return A}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const S=a.cmp(f.segment);if(S>0)f=f.left;else if(S<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else break}return f}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const f=this._iter.reset(r),S=[];let R=this._root;for(;R;){const A=f.cmp(R.segment);if(A>0)S.push([-1,R]),R=R.left;else if(A<0)S.push([1,R]),R=R.right;else if(f.hasNext())f.next(),S.push([0,R]),R=R.mid;else break}if(!!R){if(a?(R.left=void 0,R.mid=void 0,R.right=void 0,R.height=1):(R.key=void 0,R.value=void 0),!R.mid&&!R.value)if(R.left&&R.right){const A=this._min(R.right),{key:F,value:$,segment:J}=A;this._delete(A.key,!1),R.key=F,R.value=$,R.segment=J}else{const A=R.left??R.right;if(S.length>0){const[F,$]=S[S.length-1];switch(F){case-1:$.left=A;break;case 0:$.mid=A;break;case 1:$.right=A;break}}else this._root=A}for(let A=S.length-1;A>=0;A--){const F=S[A][1];F.updateHeight();const $=F.balanceFactor();if($>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),S[A][1]=F.rotateLeft()):$<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),S[A][1]=F.rotateRight()),A>0)switch(S[A-1][0]){case-1:S[A-1][1].left=S[A][1];break;case 1:S[A-1][1].right=S[A][1];break;case 0:S[A-1][1].mid=S[A][1];break}else this._root=S[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const a=this._iter.reset(r);let f=this._root,S;for(;f;){const R=a.cmp(f.segment);if(R>0)f=f.left;else if(R<0)f=f.right;else if(a.hasNext())a.next(),S=f.value||S,f=f.mid;else break}return f&&f.value||S}findSuperstr(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const S=a.cmp(f.segment);if(S>0)f=f.left;else if(S<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[a,f]of this)r(f,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=a=>{if(!a)return!0;const f=a.balanceFactor();return f<-1||f>1?!1:r(a.left)&&r(a.right)};return r(this._root)}}e.TernarySearchTree=C;class m{constructor(r,a){this.uri=r,this.value=a}}class u{constructor(r,a){this[L]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=a??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),new m(r,a)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[f,S]of this.map)r(S.value,S.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=u,u.defaultToKey=o=>o.toString();class c{constructor(r,a){this[D]="ResourceSet",!r||typeof r=="function"?this._map=new u(r):(this._map=new u(a),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,a){this._map.forEach((f,S)=>r.call(a,S,S,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var s;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class l{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const f=this._map.get(r);if(!!f)return a!==0&&this.touch(f,a),f.value}set(r,a,f=0){let S=this._map.get(r);if(S)S.value=a,f!==0&&this.touch(S,f);else{switch(S={key:r,value:a,next:void 0,previous:void 0},f){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(r,S),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const f=this._state;let S=this._head;for(;S;){if(a?r.bind(a)(S.value,S.key,this):r(S.value,S.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const r=this,a=this._state;let f=this._head;const S={[Symbol.iterator](){return S},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const R={value:f.key,done:!1};return f=f.next,R}else return{value:void 0,done:!0}}};return S}values(){const r=this,a=this._state;let f=this._head;const S={[Symbol.iterator](){return S},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const R={value:f.value,done:!1};return f=f.next,R}else return{value:void 0,done:!0}}};return S}entries(){const r=this,a=this._state;let f=this._head;const S={[Symbol.iterator](){return S},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const R={value:[f.key,f.value],done:!1};return f=f.next,R}else return{value:void 0,done:!0}}};return S}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,f=this.size;for(;a&&f>r;)this._map.delete(a.key),a=a.next,f--;this._head=a,this._size=f,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,f=r.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const f=r.next,S=r.previous;r===this._tail?(S.next=void 0,this._tail=S):(f.previous=S,S.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const f=r.next,S=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=S,S.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,f)=>{r.push([f,a])}),r}fromJSON(r){this.clear();for(const[a,f]of r)this.set(a,f)}}e.LinkedMap=l;class i extends l{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class n{constructor(r){E.set(this,void 0),Dt(this,E,r,"f")}get size(){return Xe(this,E,"f").size}forEach(r,a){Xe(this,E,"f").forEach(r,a)}get(r){return Xe(this,E,"f").get(r)}has(r){return Xe(this,E,"f").has(r)}entries(){return Xe(this,E,"f").entries()}keys(){return Xe(this,E,"f").keys()}values(){return Xe(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Xe(this,E,"f").entries()}}e.ReadonlyMapView=n}),define(x[73],ee([0,1,35]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new y.LRUCache(1e4);function L(b){return g(b,"NFC",t)}e.normalizeNFC=L;const D=new y.LRUCache(1e4);function M(b){return g(b,"NFD",D)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function g(b,k,P){if(!b)return b;const I=P.get(b);if(I)return I;let v;return E.test(b)?v=b.normalize(k):v=b,P.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(k){return M(k).replace(b,"")}}()}),define(x[12],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(a){return Array.isArray(a)}e.isArray=y;function t(a){return typeof a=="string"}e.isString=t;function L(a){return Array.isArray(a)&&a.every(f=>t(f))}e.isStringArray=L;function D(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=D;function M(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=M;function E(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=E;function g(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=g;function b(a){return a===!0||a===!1}e.isBoolean=b;function k(a){return typeof a=="undefined"}e.isUndefined=k;function P(a){return!I(a)}e.isDefined=P;function I(a){return k(a)||a===null}e.isUndefinedOrNull=I;function v(a,f){if(!a)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=v;function d(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=d;function h(...a){const f=[];for(let S=0;S<a.length;S++){const R=a[S];if(I(R))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);f.push(R)}return f}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function w(a){if(!D(a))return!1;for(let f in a)if(p.call(a,f))return!1;return!0}e.isEmptyObject=w;function C(a){return typeof a=="function"}e.isFunction=C;function m(...a){return a.length>0&&a.every(C)}e.areFunctions=m;function u(a,f){const S=Math.min(a.length,f.length);for(let R=0;R<S;R++)c(a[R],f[R])}e.validateConstraints=u;function c(a,f){if(t(f)){if(typeof a!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(C(f)){try{if(a instanceof f)return}catch{}if(!I(a)&&a.constructor===f||f.length===1&&f.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function s(a){let f=[],S=Object.getPrototypeOf(a);for(;Object.prototype!==S;)f=f.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return f}e.getAllPropertyNames=s;function l(a){const f=[];for(const S of s(a))typeof a[S]=="function"&&f.push(S);return f}e.getAllMethodNames=l;function i(a,f){const S=A=>function(){const F=Array.prototype.slice.call(arguments,0);return f(A,F)};let R={};for(const A of a)R[A]=S(A);return R}e.createProxyObject=i;function n(a){return a===null?void 0:a}e.withNullAsUndefined=n;function o(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=o;function r(a,f="Unreachable"){throw new Error(f)}e.assertNever=r}),define(x[29],ee([0,1,8,3,28,12]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function E(o){return o.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=E;function g(o){return o.indexOf("/")===-1&&(o=E(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=g;function b(o,r=y.posix.sep){if(!o)return"";const a=o.length,f=o.charCodeAt(0);if(M(f)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let R=3;const A=R;for(;R<a&&!M(o.charCodeAt(R));R++);if(A!==R&&!M(o.charCodeAt(R+1))){for(R+=1;R<a;R++)if(M(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,r)}}return r}else if(w(f)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+r:o.slice(0,2);let S=o.indexOf("://");if(S!==-1){for(S+=3;S<a;S++)if(M(o.charCodeAt(S)))return o.slice(0,S+1)}return""}e.getRoot=b;function k(o){if(!t.isWindows||!o||o.length<5)return!1;let r=o.charCodeAt(0);if(r!==92||(r=o.charCodeAt(1),r!==92))return!1;let a=2;const f=a;for(;a<o.length&&(r=o.charCodeAt(a),r!==92);a++);return!(f===a||(r=o.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=k;const P=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,r=t.isWindows){const a=r?P:I;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||r&&v.test(o)||o==="."||o===".."||r&&o[o.length-1]==="."||r&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function h(o,r,a){const f=o===r;return!a||f?f:!o||!r?!1:(0,L.equalsIgnoreCase)(o,r)}e.isEqual=h;function p(o,r,a,f=y.sep){if(o===r)return!0;if(!o||!r||r.length>o.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(o,r))return!1;if(r.length===o.length)return!0;let R=r.length;return r.charAt(r.length-1)===f&&R--,o.charAt(R)===f}return r.charAt(r.length-1)!==f&&(r+=f),o.indexOf(r)===0}e.isEqualOrParent=p;function w(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=w;function C(o,r){return t.isWindows&&o.endsWith(":")&&(o+=y.sep),(0,y.isAbsolute)(o)||(o=(0,y.join)(r,o)),o=(0,y.normalize)(o),t.isWindows?(o=(0,L.rtrim)(o,y.sep),o.endsWith(":")&&(o+=y.sep)):(o=(0,L.rtrim)(o,y.sep),o||(o=y.sep)),o}e.sanitizeFilePath=C;function m(o){const r=(0,y.normalize)(o);return t.isWindows?o.length>3?!1:u(r)&&(o.length===2||r.charCodeAt(2)===92):r===y.posix.sep}e.isRootOrDriveLetter=m;function u(o,r=t.isWindows){return r?w(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function s(o,r,a){return r.length>o.length?-1:o===r?0:(a&&(o=o.toLowerCase(),r=r.toLowerCase()),o.indexOf(r))}e.indexOfPath=s;function l(o){const r=o.split(":");let a,f,S;for(const R of r){const A=Number(R);(0,D.isNumber)(A)?f===void 0?f=A:S===void 0&&(S=A):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,r,a=8){let f="";for(let R=0;R<a;R++)f+=i.charAt(Math.floor(Math.random()*i.length));let S;return r?S=`${r}-${f}`:S=f,o?(0,y.join)(o,S):S}e.randomPath=n}),define(x[50],ee([0,1,12]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?p[w]=t(h[w]):p[w]=h[w]}),p}e.deepClone=t;function L(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const C in w)if(D.call(w,C)){const m=w[C];typeof m=="object"&&!Object.isFrozen(m)&&!(0,y.isTypedArray)(m)&&p.push(m)}}return h}e.deepFreeze=L;const D=Object.prototype.hasOwnProperty;function M(h,p){return E(h,p,new Set)}e.cloneAndChange=M;function E(h,p,w){if((0,y.isUndefinedOrNull)(h))return h;const C=p(h);if(typeof C!="undefined")return C;if((0,y.isArray)(h)){const m=[];for(const u of h)m.push(E(u,p,w));return m}if((0,y.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const m={};for(let u in h)D.call(h,u)&&(m[u]=E(h[u],p,w));return w.delete(h),m}return h}function g(h,p,w=!0){return(0,y.isObject)(h)?((0,y.isObject)(p)&&Object.keys(p).forEach(C=>{C in h?w&&((0,y.isObject)(h[C])&&(0,y.isObject)(p[C])?g(h[C],p[C],w):h[C]=p[C]):h[C]=p[C]}),h):p}e.mixin=g;function b(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let w,C;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(w=0;w<h.length;w++)if(!b(h[w],p[w]))return!1}else{const m=[];for(C in h)m.push(C);m.sort();const u=[];for(C in p)u.push(C);if(u.sort(),!b(m,u))return!1;for(w=0;w<m.length;w++)if(!b(h[m[w]],p[m[w]]))return!1}return!0}e.equals=b;function k(h){const p=new Set;return JSON.stringify(h,(w,C)=>{if((0,y.isObject)(C)||Array.isArray(C)){if(p.has(C))return"[Circular]";p.add(C)}return C})}e.safeStringify=k;function P(h,p,w){const C=p(h);return typeof C=="undefined"?w:C}e.getOrDefault=P;function I(h,p){const w=Object.create(null);return!h||!p||Object.keys(p).forEach(m=>{const u=h[m],c=p[m];b(u,c)||(w[m]=c)}),w}e.distinct=I;function v(h,p){const w=p.toLowerCase(),C=Object.keys(h).find(m=>m.toLowerCase()===w);return C?h[C]:h[p]}e.getCaseInsensitive=v;function d(h,p){const w=Object.create(null);for(const[C,m]of Object.entries(h))p(C,m)&&(w[C]=m);return w}e.filter=d}),define(x[7],ee([0,1,8,3]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,D=/^\//,M=/^\/\//;function E(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!D.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,n){return!i&&!n?"file":i}function b(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==P&&(n=P+n):n=P;break}return n}const k="",P="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(n,o,r,a,f,S=!1){typeof n=="object"?(this.scheme=n.scheme||k,this.authority=n.authority||k,this.path=n.path||k,this.query=n.query||k,this.fragment=n.fragment||k):(this.scheme=g(n,S),this.authority=o||k,this.path=b(this.scheme,r||k),this.query=a||k,this.fragment=f||k,E(this,S))}static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return m(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:r,path:a,query:f,fragment:S}=n;return o===void 0?o=this.scheme:o===null&&(o=k),r===void 0?r=this.authority:r===null&&(r=k),a===void 0?a=this.path:a===null&&(a=k),f===void 0?f=this.query:f===null&&(f=k),S===void 0?S=this.fragment:S===null&&(S=k),o===this.scheme&&r===this.authority&&a===this.path&&f===this.query&&S===this.fragment?this:new h(o,r,a,f,S)}static parse(n,o=!1){const r=I.exec(n);return r?new h(r[2]||k,l(r[4]||k),l(r[5]||k),l(r[7]||k),l(r[9]||k),o):new h(k,k,k,k,k)}static file(n){let o=k;if(t.isWindows&&(n=n.replace(/\\/g,P)),n[0]===P&&n[1]===P){const r=n.indexOf(P,2);r===-1?(o=n.substring(2),n=P):(o=n.substring(2,r),n=n.substring(r)||P)}return new h("file",o,n,k,k)}static from(n){const o=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return E(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let r;return t.isWindows&&n.scheme==="file"?r=v.file(y.win32.join(m(n,!0),...o)).path:r=y.posix.join(n.path,...o),n.with({path:r})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const o=new h(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=v;const d=t.isWindows?1:void 0;class h extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,n){let o,r=-1;for(let a=0;a<i.length;a++){const f=i.charCodeAt(a);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||n&&f===47)r!==-1&&(o+=encodeURIComponent(i.substring(r,a)),r=-1),o!==void 0&&(o+=i.charAt(a));else{o===void 0&&(o=i.substr(0,a));const S=p[f];S!==void 0?(r!==-1&&(o+=encodeURIComponent(i.substring(r,a)),r=-1),o+=S):r===-1&&(r=a)}}return r!==-1&&(o+=encodeURIComponent(i.substring(r))),o!==void 0?o:i}function C(i){let n;for(let o=0;o<i.length;o++){const r=i.charCodeAt(o);r===35||r===63?(n===void 0&&(n=i.substr(0,o)),n+=p[r]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function m(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=m;function u(i,n){const o=n?C:w;let r="",{scheme:a,authority:f,path:S,query:R,fragment:A}=i;if(a&&(r+=a,r+=":"),(f||a==="file")&&(r+=P,r+=P),f){let F=f.indexOf("@");if(F!==-1){const $=f.substr(0,F);f=f.substr(F+1),F=$.indexOf(":"),F===-1?r+=o($,!1):(r+=o($.substr(0,F),!1),r+=":",r+=o($.substr(F+1),!1)),r+="@"}f=f.toLowerCase(),F=f.indexOf(":"),F===-1?r+=o(f,!1):(r+=o(f.substr(0,F),!1),r+=f.substr(F))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const F=S.charCodeAt(1);F>=65&&F<=90&&(S=`/${String.fromCharCode(F+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const F=S.charCodeAt(0);F>=65&&F<=90&&(S=`${String.fromCharCode(F+32)}:${S.substr(2)}`)}r+=o(S,!0)}return R&&(r+="?",r+=o(R,!1)),A&&(r+="#",r+=n?A:w(A,!1)),r}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(s)?i.replace(s,n=>c(n)):i}}),define(x[116],ee([0,1,7]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const k=b;return k&&typeof k.type=="string"&&typeof k.severity=="string"}e.isRemoteConsoleLog=t;function L(b){const k=[];let P;try{const I=JSON.parse(b.arguments),v=I[I.length-1];v&&v.__$stack&&(I.pop(),P=v.__$stack),k.push(...I)}catch{k.push("Unable to log remote console arguments",b.arguments)}return{args:k,stack:P}}e.parse=L;function D(b){if(typeof b!="string")return D(L(b).stack);const k=b;if(k){const P=M(k),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(I&&I.length===4)return{uri:y.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=D;function M(b){if(!b)return b;const k=b.indexOf(`
`);return k===-1?b:b.substring(0,k)}function E(b,k){const{args:P,stack:I}=L(b),v=typeof P[0]=="string"&&P.length===1;let d=M(I);d&&(d=`(${d.trim()})`);let h=[];if(typeof P[0]=="string"?d&&v?h=[`%c[${k}] %c${P[0]} %c${d}`,g("blue"),g(""),g("grey")]:h=[`%c[${k}] %c${P[0]}`,g("blue"),g(""),...P.slice(1)]:h=[`%c[${k}]%`,g("blue"),...P],d&&!v&&h.push(d),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,h)}e.log=E;function g(b){return`color: ${b}`}}),define(x[117],ee([0,1,18,28,7]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(b){return JSON.stringify(b,E)}e.stringify=D;function M(b){let k=JSON.parse(b);return k=g(k),k}e.parse=M;function E(b,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,t.regExpFlags)(k)}:k}function g(b,k=0){if(!b||k>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return L.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof y.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let P=0;P<b.length;++P)b[P]=g(b[P],k+1);else for(const P in b)Object.hasOwnProperty.call(b,P)&&(b[P]=g(b[P],k+1))}return b}e.revive=g}),define(x[10],ee([0,1,3,7]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${L.vscodeRemoteResource}`}set(g,b,k){this._hosts[g]=b,this._ports[g]=k}setConnectionToken(g,b){this._connectionTokens[g]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const b=g.authority;let k=this._hosts[b];k&&k.indexOf(":")!==-1&&(k=`[${k}]`);const P=this._ports[b],I=this._connectionTokens[b];let v=`path=${encodeURIComponent(g.path)}`;return typeof I=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),t.URI.from({scheme:y.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${k}:${P}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new D;class M{asBrowserUri(g,b){const k=this.toUri(g,b);return k.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===L.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${L.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?k.with({scheme:L.vscodeFileResource,authority:k.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(g,b){const k=this.toUri(g,b);return k.scheme===L.vscodeFileResource?k.with({scheme:L.file,authority:k.authority!==M.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(g,b){return t.URI.isUri(g)?g:t.URI.parse(b.toUrl(g))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(x[16],ee([0,1,29,10,8,3,28,7]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(v){return(0,E.uriToFsPath)(v,!0)}e.originalFSPath=g;class b{constructor(d){this._ignorePathCasing=d}compare(d,h,p=!1){return d===h?0:(0,M.compare)(this.getComparisonKey(d,p),this.getComparisonKey(h,p))}isEqual(d,h,p=!1){return d===h?!0:!d||!h?!1:this.getComparisonKey(d,p)===this.getComparisonKey(h,p)}getComparisonKey(d,h=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,h,p=!1){if(d.scheme===h.scheme){if(d.scheme===t.Schemas.file)return y.isEqualOrParent(g(d),g(h),this._ignorePathCasing(d))&&d.query===h.query&&(p||d.fragment===h.fragment);if((0,e.isEqualAuthority)(d.authority,h.authority))return y.isEqualOrParent(d.path,h.path,this._ignorePathCasing(d),"/")&&d.query===h.query&&(p||d.fragment===h.fragment)}return!1}joinPath(d,...h){return E.URI.joinPath(d,...h)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let h;return d.scheme===t.Schemas.file?h=E.URI.file(L.dirname(g(d))).path:(h=L.posix.dirname(d.path),d.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),h="/")),d.with({path:h})}normalizePath(d){if(!d.path.length)return d;let h;return d.scheme===t.Schemas.file?h=E.URI.file(L.normalize(g(d))).path:h=L.posix.normalize(d.path),d.with({path:h})}relativePath(d,h){if(d.scheme!==h.scheme||!(0,e.isEqualAuthority)(d.authority,h.authority))return;if(d.scheme===t.Schemas.file){const C=L.relative(g(d),g(h));return D.isWindows?y.toSlashes(C):C}let p=d.path||"/",w=h.path||"/";if(this._ignorePathCasing(d)){let C=0;for(const m=Math.min(p.length,w.length);C<m&&!(p.charCodeAt(C)!==w.charCodeAt(C)&&p.charAt(C).toLowerCase()!==w.charAt(C).toLowerCase());C++);p=w.substr(0,C)+p.substr(C)}return L.posix.relative(p,w)}resolvePath(d,h){if(d.scheme===t.Schemas.file){const p=E.URI.file(L.resolve(g(d),h));return d.with({authority:p.authority,path:p.path})}return h=y.toPosixPath(h),d.with({path:L.posix.resolve(d.path,h)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,h){return d===h||d!==void 0&&h!==void 0&&(0,M.equalsIgnoreCase)(d,h)}hasTrailingPathSeparator(d,h=L.sep){if(d.scheme===t.Schemas.file){const p=g(d);return p.length>y.getRoot(p).length&&p[p.length-1]===h}else{const p=d.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,h=L.sep){return(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,h=L.sep){let p=!1;if(d.scheme===t.Schemas.file){const w=g(d);p=w!==void 0&&w.length===y.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=d.path;p=w.length===1&&w.charCodeAt(w.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path+"/"}):d}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===t.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function k(v,d){const h=[];for(let p=0;p<v.length;p++){const w=d(v[p]);v.some((C,m)=>m===p?!1:(0,e.isEqualOrParent)(w,d(C)))||h.push(v[p])}return h}e.distinctParents=k;var P;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(h){const p=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[u,c]=m.split(":");u&&c&&p.set(u,c)});const C=h.path.substring(0,h.path.indexOf(";"));return C&&p.set(v.META_DATA_MIME,C),p}v.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function I(v,d,h){if(d){let p=v.path;return p&&p[0]!==L.posix.sep&&(p=L.posix.sep+p),v.with({scheme:h,authority:d,path:p})}return v.with({scheme:h})}e.toLocalResource=I}),define(x[9],ee([0,1,23,15,4,2,16,3]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(U){return!!U&&typeof U.then=="function"}e.isThenable=g;function b(U){const W=new y.CancellationTokenSource,N=U(W.token),T=new Promise((_,q)=>{const Z=W.token.onCancellationRequested(()=>{Z.dispose(),W.dispose(),q(new t.CancellationError)});Promise.resolve(N).then(oe=>{Z.dispose(),W.dispose(),_(oe)},oe=>{Z.dispose(),W.dispose(),q(oe)})});return new class{cancel(){W.cancel()}then(_,q){return T.then(_,q)}catch(_){return this.then(void 0,_)}finally(_){return T.finally(_)}}}e.createCancelablePromise=b;function k(U,W,N){return new Promise((T,_)=>{const q=W.onCancellationRequested(()=>{q.dispose(),T(N)});U.then(T,_).finally(()=>q.dispose())})}e.raceCancellation=k;function P(U,W){return new Promise((N,T)=>{const _=W.onCancellationRequested(()=>{_.dispose(),T(new t.CancellationError)});U.then(N,T).finally(()=>_.dispose())})}e.raceCancellationError=P;async function I(U){let W=-1;const N=U.map((_,q)=>_.then(Z=>(W=q,Z))),T=await Promise.race(N);return U.forEach((_,q)=>{q!==W&&_.cancel()}),T}e.raceCancellablePromises=I;function v(U,W,N){let T;const _=setTimeout(()=>{T?.(void 0),N?.()},W);return Promise.race([U.finally(()=>clearTimeout(_)),new Promise(q=>T=q)])}e.raceTimeout=v;function d(U){return new Promise((W,N)=>{const T=U();g(T)?T.then(W,N):W(T)})}e.asPromise=d;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const T=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,T};this.queuedPromise=new Promise(T=>{this.activePromise.then(N,N).then(T)})}return new Promise((N,T)=>{this.queuedPromise.then(N,T)})}return this.activePromise=W(),new Promise((N,T)=>{this.activePromise.then(_=>{this.activePromise=null,N(_)},_=>{this.activePromise=null,T(_)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=p;class w{constructor(){this.promiseMap=new Map}queue(W,N){const _=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(W)===_&&this.promiseMap.delete(W)});return this.promiseMap.set(W,_),_}}e.SequencerByKey=w;const C=(U,W)=>{let N=!0;const T=setTimeout(()=>{N=!1,W()},U);return{isTriggered:()=>N,dispose:()=>{clearTimeout(T),N=!1}}},m=U=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,U())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,N=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,q)=>{this.doResolve=_,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}}));const T=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?m(T):C(N,T),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(W){this.delayer=new u(W),this.throttler=new h}trigger(W,N){return this.delayer.trigger(()=>this.throttler.queue(W),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class s{constructor(){this._isOpen=!1,this._promise=new Promise((W,N)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class l extends s{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(U,W){return W?new Promise((N,T)=>{const _=setTimeout(()=>{q.dispose(),N()},U),q=W.onCancellationRequested(()=>{clearTimeout(_),q.dispose(),T(new t.CancellationError)})}):b(N=>i(U,N))}e.timeout=i;function n(U,W=0){const N=setTimeout(U,W);return(0,D.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=n;function o(U){const W=[];let N=0;const T=U.length;function _(){return N<T?U[N++]():null}function q(Z){Z!=null&&W.push(Z);const oe=_();return oe?oe.then(q):Promise.resolve(W)}return Promise.resolve(null).then(q)}e.sequence=o;function r(U,W=T=>!!T,N=null){let T=0;const _=U.length,q=()=>{if(T>=_)return Promise.resolve(N);const Z=U[T++];return Promise.resolve(Z()).then(ce=>W(ce)?Promise.resolve(ce):q())};return q()}e.first=r;function a(U,W=T=>!!T,N=null){if(U.length===0)return Promise.resolve(N);let T=U.length;const _=()=>{T=-1;for(const q of U)q.cancel?.()};return new Promise((q,Z)=>{for(const oe of U)oe.then(ce=>{--T>=0&&W(ce)?(_(),q(ce)):T===0&&q(N)}).catch(ce=>{--T>=0&&(_(),Z(ce))})})}e.firstParallel=a;class f{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((N,T)=>{this.outstandingPromises.push({factory:W,c:N,e:T}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const N=W.factory();N.then(W.c,W.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class S extends f{constructor(){super(1)}}e.Queue=S;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const W=new B;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,N=M.extUri){const T=N.getComparisonKey(W);let _=this.queues.get(T);return _||(_=new S,L.Event.once(_.onDrained)(()=>{_?.dispose(),this.queues.delete(T),this.onDidQueueDrain()}),this.queues.set(T,_)),_}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class A{constructor(W,N){this._token=-1,typeof W=="function"&&typeof N=="number"&&this.setIfNotSet(W,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},N)}setIfNotSet(W,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},N))}}e.TimeoutTimer=A;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,N){this.cancel(),this._token=setInterval(()=>{W()},N)}}e.IntervalTimer=F;class ${constructor(W,N){this.timeoutToken=-1,this.runner=W,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=$;class J{constructor(W,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=J;class ne extends ${constructor(W,N){super(W,N);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ne;class Y extends D.Disposable{constructor(W,N){super();this.options=W,this.handler=N,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,E.setTimeout0)(()=>{if(W)return;const N=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(U,W)=>{const N=requestIdleCallback(U,typeof W=="number"?{timeout:W}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(N))}}}}();class re{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=re;async function H(U,W,N){let T;for(let _=0;_<N;_++)try{return await U()}catch(q){T=q,await i(W)}throw T}e.retry=H;class X{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,N,T){return this._pending={taskId:W,cancel:()=>T?.(),promise:N},N.then(()=>this.donePending(W),()=>this.donePending(W)),N}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let N,T;const _=new Promise((q,Z)=>{N=q,T=Z});this._next={run:W,promise:_,promiseResolve:N,promiseReject:T}}return this._next.promise}}e.TaskSequentializer=X;class j{constructor(W,N=()=>Date.now()){this.interval=W,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,N)=>{this.completeCallback=W,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(N=>{this.completeCallback(W),this.resolved=!0,N()})}error(W){return new Promise(N=>{this.errorCallback(W),this.rejected=!0,N()})}cancel(){new Promise(W=>{this.errorCallback(new t.CancellationError),this.rejected=!0,W()})}}e.DeferredPromise=B;var z;(function(U){async function W(T){let _;const q=await Promise.all(T.map(Z=>Z.then(oe=>oe,oe=>{_||(_=oe)})));if(typeof _!="undefined")throw _;return q}U.settled=W;function N(T){return new Promise(async(_,q)=>{try{await T(_,q)}catch(Z){q(Z)}})}U.withAsyncBody=N})(z=e.Promises||(e.Promises={}));var K;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(K||(K={}));class te{constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const N={emitOne:T=>this.emitOne(T),emitMany:T=>this.emitMany(T),reject:T=>this.reject(T)};try{await Promise.resolve(W(N)),this.resolve()}catch(T){this.reject(T)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(W){return new te(N=>{N.emitMany(W)})}static fromPromise(W){return new te(async N=>{N.emitMany(await W)})}static fromPromises(W){return new te(async N=>{await Promise.all(W.map(async T=>N.emitOne(await T)))})}static merge(W){return new te(async N=>{await Promise.all(W.map(async T=>{for await(const _ of T)N.emitOne(_)}))})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,N){return new te(async T=>{for await(const _ of W)T.emitOne(N(_))})}map(W){return te.map(this,W)}static filter(W,N){return new te(async T=>{for await(const _ of W)N(_)&&T.emitOne(_)})}filter(W){return te.filter(this,W)}static coalesce(W){return te.filter(W,N=>!!N)}coalesce(){return te.coalesce(this)}static async toPromise(W){const N=[];for await(const T of W)N.push(T);return N}toPromise(){return te.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class Q extends te{constructor(W,N){super(N);this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function O(U){const W=new y.CancellationTokenSource,N=U(W.token);return new Q(W,async T=>{const _=W.token.onCancellationRequested(()=>{_.dispose(),W.dispose(),T.reject(new t.CancellationError)});try{for await(const q of N){if(W.token.isCancellationRequested)return;T.emitOne(q)}_.dispose(),W.dispose()}catch(q){_.dispose(),W.dispose(),T.reject(q)}})}e.createCancelableAsyncIterable=O}),define(x[86],ee([0,1,26,9,29,35,8,3,28]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const k="[/\\\\]",P="[^/\\\\]",I=/\//g;function v(B,z){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${k}|${P}+${k}${z?`|${k}${P}+`:""})*?`}}function d(B,z){if(!B)return[];const K=[];let te=!1,Q=!1,O="";for(const U of B){switch(U){case z:if(!te&&!Q){K.push(O),O="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}O+=U}return O&&K.push(O),K}e.splitGlobAware=d;function h(B){if(!B)return"";let z="";const K=d(B,e.GLOB_SPLIT);if(K.every(te=>te===e.GLOBSTAR))z=".*";else{let te=!1;K.forEach((Q,O)=>{if(Q===e.GLOBSTAR){if(te)return;z+=v(2,O===K.length-1)}else{let U=!1,W="",N=!1,T="";for(const _ of Q){if(_!=="}"&&U){W+=_;continue}if(N&&(_!=="]"||!T)){let q;_==="-"?q=_:(_==="^"||_==="!")&&!T?q="^":_===e.GLOB_SPLIT?q="":q=(0,g.escapeRegExpCharacters)(_),T+=q;continue}switch(_){case"{":U=!0;continue;case"[":N=!0;continue;case"}":{z+=`(?:${d(W,",").map(oe=>h(oe)).join("|")})`,U=!1,W="";break}case"]":{z+="["+T+"]",N=!1,T="";break}case"?":z+=P;continue;case"*":z+=v(1);continue;default:z+=(0,g.escapeRegExpCharacters)(_)}}O<K.length-1&&(K[O+1]!==e.GLOBSTAR||O+2<K.length)&&(z+=k)}te=Q===e.GLOBSTAR})}return z}const p=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new D.LRUCache(1e4),l=function(){return!1},i=function(){return null};function n(B,z){if(!B)return i;let K;typeof B!="string"?K=B.pattern:K=B,K=K.trim();const te=`${K}_${!!z.trimForExclusions}`;let Q=s.get(te);if(Q)return o(Q,B);let O;return p.test(K)?Q=a(K.substr(4),K):(O=w.exec(r(K,z)))?Q=f(O[1],K):(z.trimForExclusions?m:C).test(K)?Q=S(K,z):(O=u.exec(r(K,z)))?Q=R(O[1].substr(1),K,!0):(O=c.exec(r(K,z)))?Q=R(O[1],K,!1):Q=A(K),s.set(te,Q),o(Q,B)}function o(B,z){if(typeof z=="string")return B;const K=function(te,Q){return(0,L.isEqualOrParent)(te,z.base,!E.isLinux)?B(te.substr(z.base.length+1),Q):null};return K.allBasenames=B.allBasenames,K.allPaths=B.allPaths,K.basenames=B.basenames,K.patterns=B.patterns,K}function r(B,z){return z.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function a(B,z){return function(K,te){return typeof K=="string"&&K.endsWith(B)?z:null}}function f(B,z){const K=`/${B}`,te=`\\${B}`,Q=function(U,W){return typeof U!="string"?null:W?W===B?z:null:U===B||U.endsWith(K)||U.endsWith(te)?z:null},O=[B];return Q.basenames=O,Q.patterns=[z],Q.allBasenames=O,Q}function S(B,z){const K=X(B.slice(1,-1).split(",").map(W=>n(W,z)).filter(W=>W!==i),B),te=K.length;if(!te)return i;if(te===1)return K[0];const Q=function(W,N){for(let T=0,_=K.length;T<_;T++)if(K[T](W,N))return B;return null},O=K.find(W=>!!W.allBasenames);O&&(Q.allBasenames=O.allBasenames);const U=K.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return U.length&&(Q.allPaths=U),Q}function R(B,z,K){const te=M.sep===M.posix.sep,Q=te?B:B.replace(I,M.sep),O=M.sep+Q,U=M.posix.sep+B;let W;return K?W=function(N,T){return typeof N=="string"&&(N===Q||N.endsWith(O)||!te&&(N===B||N.endsWith(U)))?z:null}:W=function(N,T){return typeof N=="string"&&(N===Q||!te&&N===B)?z:null},W.allPaths=[(K?"*/":"./")+B],W}function A(B){try{const z=new RegExp(`^${h(B)}$`);return function(K){return z.lastIndex=0,typeof K=="string"&&z.test(K)?B:null}}catch{return i}}function F(B,z,K){return!B||typeof z!="string"?!1:$(B)(z,void 0,K)}e.match=F;function $(B,z={}){if(!B)return l;if(typeof B=="string"||J(B)){const K=n(B,z);if(K===i)return l;const te=function(Q,O){return!!K(Q,O)};return K.allBasenames&&(te.allBasenames=K.allBasenames),K.allPaths&&(te.allPaths=K.allPaths),te}return re(B,z)}e.parse=$;function J(B){const z=B;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=J;function ne(B){return B.allBasenames||[]}e.getBasenameTerms=ne;function Y(B){return B.allPaths||[]}e.getPathTerms=Y;function re(B,z){const K=X(Object.getOwnPropertyNames(B).map(W=>H(W,B[W],z)).filter(W=>W!==i)),te=K.length;if(!te)return i;if(!K.some(W=>!!W.requiresSiblings)){if(te===1)return K[0];const W=function(_,q){let Z;for(let oe=0,ce=K.length;oe<ce;oe++){const se=K[oe](_,q);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const ce=await oe;if(typeof ce=="string")return ce}return null})():null},N=K.find(_=>!!_.allBasenames);N&&(W.allBasenames=N.allBasenames);const T=K.reduce((_,q)=>q.allPaths?_.concat(q.allPaths):_,[]);return T.length&&(W.allPaths=T),W}const Q=function(W,N,T){let _,q;for(let Z=0,oe=K.length;Z<oe;Z++){const ce=K[Z];ce.requiresSiblings&&T&&(N||(N=(0,M.basename)(W)),_||(_=N.substr(0,N.length-(0,M.extname)(W).length)));const se=ce(W,N,_,T);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(q||(q=[]),q.push(se))}return q?(async()=>{for(const Z of q){const oe=await Z;if(typeof oe=="string")return oe}return null})():null},O=K.find(W=>!!W.allBasenames);O&&(Q.allBasenames=O.allBasenames);const U=K.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return U.length&&(Q.allPaths=U),Q}function H(B,z,K){if(z===!1)return i;const te=n(B,K);if(te===i)return i;if(typeof z=="boolean")return te;if(z){const Q=z.when;if(typeof Q=="string"){const O=(U,W,N,T)=>{if(!T||!te(U,W))return null;const _=Q.replace("$(basename)",N),q=T(_);return(0,t.isThenable)(q)?q.then(Z=>Z?B:null):q?B:null};return O.requiresSiblings=!0,O}}return te}function X(B,z){const K=B.filter(W=>!!W.basenames);if(K.length<2)return B;const te=K.reduce((W,N)=>{const T=N.basenames;return T?W.concat(T):W},[]);let Q;if(z){Q=[];for(let W=0,N=te.length;W<N;W++)Q.push(z)}else Q=K.reduce((W,N)=>{const T=N.patterns;return T?W.concat(T):W},[]);const O=function(W,N){if(typeof W!="string")return null;if(!N){let _;for(_=W.length;_>0;_--){const q=W.charCodeAt(_-1);if(q===47||q===92)break}N=W.substr(_)}const T=te.indexOf(N);return T!==-1?Q[T]:null};O.basenames=te,O.patterns=Q,O.allBasenames=te;const U=B.filter(W=>!W.basenames);return U.push(O),U}function j(B,z){return(0,y.equals)(B,z,(K,te)=>typeof K=="string"&&typeof te=="string"?K===te:typeof K!="string"&&typeof te!="string"?K.base===te.base&&K.pattern===te.pattern:!1)}e.patternsEquals=j}),define(x[33],ee([0,1,26,29,10,8,3,16,28,7]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(r,a){const{os:f,tildify:S,relative:R}=a;if(R){const $=P(r,R,f);if(typeof $=="string")return $}let A=r.fsPath;if(f===1&&!M.isWindows?A=A.replace(/\//g,"\\"):f!==1&&M.isWindows&&(A=A.replace(/\\/g,"/")),f!==1&&S?.userHome){let $=S.userHome.fsPath,J;r.scheme!==S.userHome.scheme&&r.path.startsWith(D.posix.sep)?J=S.userHome.with({path:r.path}).fsPath:J=r.fsPath,A=h(J,$,f)}return(f===1?D.win32:D.posix).normalize(v(A,f===1))}e.getPathLabel=k;function P(r,a,f){const S=f===1?D.win32:D.posix,R=f===3?E.extUri:E.extUriIgnorePathCase,A=a.getWorkspace(),F=(0,y.firstOrDefault)(A.folders);if(!F)return;r.scheme!==F.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=F.uri.with({path:r.path}));const $=a.getWorkspaceFolder(r);if(!$)return;let J;if(R.isEqual($.uri,r)?J="":J=R.relativePath($.uri,r)??"",J&&(J=S.normalize(J)),A.folders.length>1&&!a.noPrefix){const ne=$.name?$.name:R.basenameOrAuthority($.uri);J=J?`${ne} \u2022 ${J}`:ne}return J}function I(r){if(!r)return;typeof r=="string"&&(r=b.URI.file(r));const a=(0,E.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,t.isRootOrDriveLetter)(a)?v(a):a}e.getBaseLabel=I;function v(r,a=M.isWindows){return(0,t.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=v;let d=Object.create(null);function h(r,a,f=M.OS){if(f===1||!r||!a)return r;let S=d.original===a?d.normalized:void 0;S||(S=a,M.isWindows&&(S=(0,t.toSlashes)(S)),S=`${(0,g.rtrim)(S,D.posix.sep)}${D.posix.sep}`,d={original:a,normalized:S});let R=r;return M.isWindows&&(R=(0,t.toSlashes)(R)),(f===3?R.startsWith(S):(0,g.startsWithIgnoreCase)(R,S))?`~/${R.substr(S.length)}`:r}e.tildify=h;function p(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=p;const w="\u2026",C="\\\\",m="~";function u(r,a=D.sep){const f=new Array(r.length);let S=!1;for(let R=0;R<r.length;R++){let A=r[R];if(A===""){f[R]=`.${a}`;continue}if(!A){f[R]=A;continue}S=!0;let F="",$=A;$.indexOf(C)===0?(F=$.substr(0,$.indexOf(C)+C.length),$=$.substr($.indexOf(C)+C.length)):$.indexOf(a)===0?(F=$.substr(0,$.indexOf(a)+a.length),$=$.substr($.indexOf(a)+a.length)):$.indexOf(m)===0&&(F=$.substr(0,$.indexOf(m)+m.length),$=$.substr($.indexOf(m)+m.length));const J=$.split(a);for(let ne=1;S&&ne<=J.length;ne++)for(let Y=J.length-ne;S&&Y>=0;Y--){S=!1;let re=J.slice(Y,Y+ne).join(a);for(let H=0;!S&&H<r.length;H++)if(H!==R&&r[H]&&r[H].indexOf(re)>-1){const X=Y+ne===J.length,j=Y>0&&r[H].indexOf(a)>-1?a+re:re,B=r[H].endsWith(j);S=!X||B}if(!S){let H="";(J[0].endsWith(":")||F!=="")&&(Y===1&&(Y=0,ne++,re=J[0]+a+re),Y>0&&(H=J[0]+a),H=F+H),Y>0&&(H=H+w+a),H=H+re,Y+ne<J.length&&(H=H+a+w),f[R]=H}}S&&(f[R]=A)}return f}e.shorten=u;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function s(r,a=Object.create(null)){const f=[];let S=!1,R="";for(const A of r)if(A==="$"||S&&A==="{")R&&f.push({value:R,type:c.TEXT}),R="",S=!0;else if(A==="}"&&S){const F=a[R];if(typeof F=="string")F.length&&f.push({value:F,type:c.VARIABLE});else if(F){const $=f[f.length-1];(!$||$.type!==c.SEPARATOR)&&f.push({value:F.label,type:c.SEPARATOR})}R="",S=!1}else R+=A;return R&&!S&&f.push({value:R,type:c.TEXT}),f.filter((A,F)=>{if(A.type===c.SEPARATOR){const $=f[F-1],J=f[F+1];return[$,J].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=s;function l(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function i(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(r){const a=r.indexOf("/")!==-1?D.posix:D.win32,f=a.basename(r),S=a.dirname(r);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}e.splitName=o}),define(x[118],ee([0,1,7]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(k){return k.toJSON()}class L{constructor(P){this._uriTransformer=P}transformIncoming(P){const I=this._uriTransformer.transformIncoming(P);return I===P?P:t(y.URI.from(I))}transformOutgoing(P){const I=this._uriTransformer.transformOutgoing(P);return I===P?P:t(y.URI.from(I))}transformOutgoingURI(P){const I=this._uriTransformer.transformOutgoing(P);return I===P?P:y.URI.from(I)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function D(k,P,I){if(!k||I>200)return null;if(typeof k=="object"){if(k instanceof y.URI)return P.transformOutgoing(k);for(let v in k)if(Object.hasOwnProperty.call(k,v)){const d=D(k[v],P,I+1);d!==null&&(k[v]=d)}}return null}function M(k,P){const I=D(k,P,0);return I===null?k:I}e.transformOutgoingURIs=M;function E(k,P,I,v){if(!k||v>200)return null;if(typeof k=="object"){if(k.$mid===1)return I?y.URI.revive(P.transformIncoming(k)):P.transformIncoming(k);for(let d in k)if(Object.hasOwnProperty.call(k,d)){const h=E(k[d],P,I,v+1);h!==null&&(k[d]=h)}}return null}function g(k,P){const I=E(k,P,!1,0);return I===null?k:I}e.transformIncomingURIs=g;function b(k,P){const I=E(k,P,!0,0);return I===null?k:I}e.transformAndReviveIncomingURIs=b}),define(x[31],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(L){return y.test(L)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(E){for(let g=0;g<E.length;g++)E[g]=Math.floor(Math.random()*256);return E};const D=new Uint8Array(16),M=[];for(let E=0;E<256;E++)M.push(E.toString(16).padStart(2,"0"));return function(){L(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let g=0,b="";return b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b+="-",b+=M[D[g++]],b+=M[D[g++]],b+="-",b+=M[D[g++]],b+=M[D[g++]],b+="-",b+=M[D[g++]],b+=M[D[g++]],b+="-",b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b+=M[D[g++]],b}}()}),define(x[119],ee([0,1,15,4,2,3,12,28]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const g="$initialize";let b=!1;function k(i){!D.isWeb||(b||(b=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(i.message))}e.logOnceWebWorkerWarning=k;var P;(function(i){i[i.Request=0]="Request",i[i.Reply=1]="Reply",i[i.SubscribeEvent=2]="SubscribeEvent",i[i.Event=3]="Event",i[i.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class I{constructor(n,o,r,a){this.vsWorker=n,this.req=o,this.method=r,this.args=a,this.type=0}}class v{constructor(n,o,r,a){this.vsWorker=n,this.seq=o,this.res=r,this.err=a,this.type=1}}class d{constructor(n,o,r,a){this.vsWorker=n,this.req=o,this.eventName=r,this.arg=a,this.type=2}}class h{constructor(n,o,r){this.vsWorker=n,this.req=o,this.event=r,this.type=3}}class p{constructor(n,o){this.vsWorker=n,this.req=o,this.type=4}}class w{constructor(n){this._workerId=-1,this._handler=n,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(n){this._workerId=n}sendMessage(n,o){const r=String(++this._lastSentReq);return new Promise((a,f)=>{this._pendingReplies[r]={resolve:a,reject:f},this._send(new I(this._workerId,r,n,o))})}listen(n,o){let r=null;const a=new t.Emitter({onFirstListenerAdd:()=>{r=String(++this._lastSentReq),this._pendingEmitters.set(r,a),this._send(new d(this._workerId,r,n,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(r),this._send(new p(this._workerId,r)),r=null}});return a.event}handleMessage(n){!n||!n.vsWorker||this._workerId!==-1&&n.vsWorker!==this._workerId||this._handleMessage(n)}_handleMessage(n){switch(n.type){case 1:return this._handleReplyMessage(n);case 0:return this._handleRequestMessage(n);case 2:return this._handleSubscribeEventMessage(n);case 3:return this._handleEventMessage(n);case 4:return this._handleUnsubscribeEventMessage(n)}}_handleReplyMessage(n){if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),o.reject(r);return}o.resolve(n.res)}_handleRequestMessage(n){let o=n.req;this._handler.handleMessage(n.method,n.args).then(a=>{this._send(new v(this._workerId,o,a,void 0))},a=>{a.detail instanceof Error&&(a.detail=(0,y.transformErrorForSerialization)(a.detail)),this._send(new v(this._workerId,o,void 0,(0,y.transformErrorForSerialization)(a)))})}_handleSubscribeEventMessage(n){const o=n.req,r=this._handler.handleEvent(n.eventName,n.arg)(a=>{this._send(new h(this._workerId,o,a))});this._pendingEvents.set(o,r)}_handleEventMessage(n){if(!this._pendingEmitters.has(n.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(n.req).fire(n.event)}_handleUnsubscribeEventMessage(n){if(!this._pendingEvents.has(n.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(n.req).dispose(),this._pendingEvents.delete(n.req)}_send(n){let o=[];if(n.type===0)for(let r=0;r<n.args.length;r++)n.args[r]instanceof ArrayBuffer&&o.push(n.args[r]);else n.type===1&&n.res instanceof ArrayBuffer&&o.push(n.res);this._handler.sendMessage(n,o)}}class C extends L.Disposable{constructor(n,o,r){super();let a=null;this._worker=this._register(n.create("vs/base/common/worker/simpleWorker",F=>{this._protocol.handleMessage(F)},F=>{a&&a(F)})),this._protocol=new w({sendMessage:(F,$)=>{this._worker.postMessage(F,$)},handleMessage:(F,$)=>{if(typeof r[F]!="function")return Promise.reject(new Error("Missing method "+F+" on main thread host."));try{return Promise.resolve(r[F].apply(r,$))}catch(J){return Promise.reject(J)}},handleEvent:(F,$)=>{if(u(F)){const J=r[F].call(r,$);if(typeof J!="function")throw new Error(`Missing dynamic event ${F} on main thread host.`);return J}if(m(F)){const J=r[F];if(typeof J!="function")throw new Error(`Missing event ${F} on main thread host.`);return J}throw new Error(`Malformed event name ${F}`)}}),this._protocol.setWorkerId(this._worker.getId());let f=null;typeof D.globals.require!="undefined"&&typeof D.globals.require.getConfig=="function"?f=D.globals.require.getConfig():typeof D.globals.requirejs!="undefined"&&(f=D.globals.requirejs.s.contexts._.config);const S=M.getAllMethodNames(r);this._onModuleLoaded=this._protocol.sendMessage(g,[this._worker.getId(),JSON.parse(JSON.stringify(f)),o,S]);const R=(F,$)=>this._request(F,$),A=(F,$)=>this._protocol.listen(F,$);this._lazyProxy=new Promise((F,$)=>{a=$,this._onModuleLoaded.then(J=>{F(c(J,R,A))},J=>{$(J),this._onError("Worker failed to load "+o,J)})})}getProxyObject(){return this._lazyProxy}_request(n,o){return new Promise((r,a)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(n,o).then(r,a)},a)})}_onError(n,o){console.error(n),console.info(o)}}e.SimpleWorkerClient=C;function m(i){return i[0]==="o"&&i[1]==="n"&&E.isUpperAsciiLetter(i.charCodeAt(2))}function u(i){return/^onDynamic/.test(i)&&E.isUpperAsciiLetter(i.charCodeAt(9))}function c(i,n,o){const r=S=>function(){const R=Array.prototype.slice.call(arguments,0);return n(S,R)},a=S=>function(R){return o(S,R)};let f={};for(const S of i){if(u(S)){f[S]=a(S);continue}if(m(S)){f[S]=o(S,void 0);continue}f[S]=r(S)}return f}class s{constructor(n,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new w({sendMessage:(r,a)=>{n(r,a)},handleMessage:(r,a)=>this._handleMessage(r,a),handleEvent:(r,a)=>this._handleEvent(r,a)})}onmessage(n){this._protocol.handleMessage(n)}_handleMessage(n,o){if(n===g)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._requestHandler[n].apply(this._requestHandler,o))}catch(r){return Promise.reject(r)}}_handleEvent(n,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(u(n)){const r=this._requestHandler[n].call(this._requestHandler,o);if(typeof r!="function")throw new Error(`Missing dynamic event ${n} on request handler.`);return r}if(m(n)){const r=this._requestHandler[n];if(typeof r!="function")throw new Error(`Missing event ${n} on request handler.`);return r}throw new Error(`Malformed event name ${n}`)}initialize(n,o,r,a){this._protocol.setWorkerId(n);const R=c(a,(A,F)=>this._protocol.sendMessage(A,F),(A,F)=>this._protocol.listen(A,F));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,D.globals.require.config(o)),new Promise((A,F)=>{(D.globals.require||V)([r],J=>{if(this._requestHandler=J.create(R),!this._requestHandler){F(new Error("No RequestHandler!"));return}A(M.getAllMethodNames(this._requestHandler))},F)}))}}e.SimpleWorkerServer=s;function l(i){return new s(i,null)}e.create=l}),define(x[120],ee([0,1,60,30,43]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(M,E){if(await new Promise((k,P)=>{const I=t.createReadStream(M),v=y.createHash("sha1");I.pipe(v);const d=(0,L.once)((h,p)=>{I.removeAllListeners(),v.removeAllListeners(),h?P(h):k(p)});I.once("error",d),I.once("end",d),v.once("error",d),v.once("data",h=>d(void 0,h.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=D}),define(x[121],ee([0,1,241]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(D="utf8"){this.stringDecoder=new y.StringDecoder(D),this.remaining=null}write(D){const M=[],E=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(E.length<1)return M;let g=0,b,k=g;for(;k<E.length;)if(b=E.charCodeAt(k),b===13||b===10){if(M.push(E.substring(g,k)),k++,k<E.length){const P=b;b=E.charCodeAt(k),(P===13&&b===10||P===10&&b===13)&&k++}g=k}else k++;return this.remaining=g<E.length?E.substr(g):null,M}end(){return this.remaining}}e.LineDecoder=t}),define(x[122],ee([0,1,27]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(M){const E=M.replace(/\-/g,":").toLowerCase();return!t.has(E)}function D(){const M=(0,y.networkInterfaces)();for(let E in M){const g=M[E];if(g){for(const{mac:b}of g)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(x[74],ee([0,1,27,15,35,31,122]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(k){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(k)}value(){if(this._value===void 0){let k=0,P=0;const I=(0,y.networkInterfaces)();for(let v in I){const d=I[v];if(d)for(const{mac:h,internal:p}of d)p||(P+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(k+=1))}this._value=P>0?k/P:0}return this._value}};let E;async function g(){return E||(E=(async()=>await b()||D.generateUuid())()),E}e.getMachineId=g;async function b(){try{const k=await new Promise((I,v)=>{V(["crypto"],I,v)}),P=(0,M.getMac)();return k.createHash("sha256").update(P,"utf8").digest("hex")}catch(k){t.onUnexpectedError(k);return}}}),define(x[20],ee([0,1,30,27,123,9,29,73,8,3,16,7]),function(V,e,y,t,L,D,M,E,g,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function v(Y,re=I.UNLINK){if((0,M.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");return re===I.UNLINK?h(Y):d(Y)}async function d(Y){try{const re=(0,M.randomPath)((0,t.tmpdir)());try{await y.promises.rename(Y,re)}catch{return h(Y)}h(re).catch(H=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function h(Y){return(0,L.promisify)(y.rm)(Y,{recursive:!0,force:!0,maxRetries:3})}function p(Y){if((0,M.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function w(Y,re){return u(await(re?C(Y):(0,L.promisify)(y.readdir)(Y)))}async function C(Y){try{return await(0,L.promisify)(y.readdir)(Y,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const re=[],H=await w(Y);for(const X of H){let j=!1,B=!1,z=!1;try{const K=await e.Promises.lstat((0,g.join)(Y,X));j=K.isFile(),B=K.isDirectory(),z=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}re.push({name:X,isFile:()=>j,isDirectory:()=>B,isSymbolicLink:()=>z})}return re}function m(Y){return u(y.readdirSync(Y))}e.readdirSync=m;function u(Y){return Y.map(re=>typeof re=="string"?b.isMacintosh?(0,E.normalizeNFC)(re):re:(re.name=b.isMacintosh?(0,E.normalizeNFC)(re.name):re.name,re))}async function c(Y){const re=await w(Y),H=[];for(const X of re)await l.existsDirectory((0,g.join)(Y,X))&&H.push(X);return H}function s(Y,re=1e3){return new Promise(H=>{let X=!1;const j=setInterval(()=>{X||(X=!0,y.access(Y,B=>{X=!1,B&&(clearInterval(j),H(void 0))}))},re)})}e.whenDeleted=s;var l;(function(Y){async function re(j){let B;try{if(B=await e.Promises.lstat(j),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(b.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw K}throw z}}Y.stat=re;async function H(j){try{const{stat:B,symbolicLink:z}=await Y.stat(j);return B.isFile()&&z?.dangling!==!0}catch{}return!1}Y.existsFile=H;async function X(j){try{const{stat:B,symbolicLink:z}=await Y.stat(j);return B.isDirectory()&&z?.dangling!==!0}catch{}return!1}Y.existsDirectory=X})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new D.ResourceQueue;function n(Y,re,H){return i.queueFor(P.URI.file(Y),k.extUriBiasedIgnorePathCase).queue(()=>{const X=f(H);return new Promise((j,B)=>r(Y,re,X,z=>z?B(z):j()))})}let o=!0;function r(Y,re,H,X){if(!o)return y.writeFile(Y,re,{mode:H.mode,flag:H.flag},X);y.open(Y,H.flag,H.mode,(j,B)=>{if(j)return X(j);y.writeFile(B,re,z=>{if(z)return y.close(B,()=>X(z));y.fdatasync(B,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),o=!1),y.close(B,te=>X(te))))})})}function a(Y,re,H){const X=f(H);if(!o)return y.writeFileSync(Y,re,{mode:X.mode,flag:X.flag});const j=y.openSync(Y,X.flag,X.mode);try{y.writeFileSync(j,re);try{y.fdatasyncSync(j)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o=!1}}finally{y.closeSync(j)}}e.writeFileSync=a;function f(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function S(Y,re){if(Y!==re)try{await e.Promises.rename(Y,re)}catch(H){if(Y.toLowerCase()!==re.toLowerCase()&&H.code==="EXDEV"||Y.endsWith("."))await R(Y,re,{preserveSymlinks:!1}),await v(Y,I.MOVE);else throw H}}async function R(Y,re,H){return F(Y,re,{root:{source:Y,target:re},options:H,handledSourcePaths:new Set})}const A=511;async function F(Y,re,H){if(H.handledSourcePaths.has(Y))return;H.handledSourcePaths.add(Y);const{stat:X,symbolicLink:j}=await l.stat(Y);if(j){if(H.options.preserveSymlinks)try{return await ne(Y,re,H)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(j.dangling)return}return X.isDirectory()?$(Y,re,X.mode&A,H):J(Y,re,X.mode&A)}async function $(Y,re,H,X){await e.Promises.mkdir(re,{recursive:!0,mode:H});const j=await w(Y);for(const B of j)await F((0,g.join)(Y,B),(0,g.join)(re,B),X)}async function J(Y,re,H){await e.Promises.copyFile(Y,re),await e.Promises.chmod(re,H)}async function ne(Y,re,H){let X=await e.Promises.readlink(Y);(0,M.isEqualOrParent)(X,H.root.source,!b.isLinux)&&(X=(0,g.join)(H.root.target,X.substr(H.root.source.length+1))),await e.Promises.symlink(X,re)}e.Promises=new class{get access(){return(0,L.promisify)(y.access)}get stat(){return(0,L.promisify)(y.stat)}get lstat(){return(0,L.promisify)(y.lstat)}get utimes(){return(0,L.promisify)(y.utimes)}get read(){return(Y,re,H,X,j)=>new Promise((B,z)=>{y.read(Y,re,H,X,j,(K,te,Q)=>K?z(K):B({bytesRead:te,buffer:Q}))})}get readFile(){return(0,L.promisify)(y.readFile)}get write(){return(Y,re,H,X,j)=>new Promise((B,z)=>{y.write(Y,re,H,X,j,(K,te,Q)=>K?z(K):B({bytesWritten:te,buffer:Q}))})}get appendFile(){return(0,L.promisify)(y.appendFile)}get fdatasync(){return(0,L.promisify)(y.fdatasync)}get truncate(){return(0,L.promisify)(y.truncate)}get rename(){return(0,L.promisify)(y.rename)}get copyFile(){return(0,L.promisify)(y.copyFile)}get open(){return(0,L.promisify)(y.open)}get close(){return(0,L.promisify)(y.close)}get symlink(){return(0,L.promisify)(y.symlink)}get readlink(){return(0,L.promisify)(y.readlink)}get chmod(){return(0,L.promisify)(y.chmod)}get mkdir(){return(0,L.promisify)(y.mkdir)}get unlink(){return(0,L.promisify)(y.unlink)}get rmdir(){return(0,L.promisify)(y.rmdir)}get realpath(){return(0,L.promisify)(y.realpath)}async exists(Y){try{return await e.Promises.access(Y),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return v}get move(){return S}get copy(){return R}}}),define(x[87],ee([0,1,30,8,3,28,20]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(I){if(L.isLinux)return I;const v=(0,t.dirname)(I);if(I===v)return I;const d=((0,t.basename)(I)||I).toLowerCase();try{const p=(0,M.readdirSync)(v).filter(w=>w.toLowerCase()===d);if(p.length===1){const w=E(v);if(w)return(0,t.join)(w,p[0])}else if(p.length>1){const w=p.indexOf(d);if(w>=0){const C=E(v);if(C)return(0,t.join)(C,p[w])}}}catch{}return null}e.realcaseSync=E;async function g(I){if(L.isLinux)return I;const v=(0,t.dirname)(I);if(I===v)return I;const d=((0,t.basename)(I)||I).toLowerCase();try{const p=(await M.Promises.readdir(v)).filter(w=>w.toLowerCase()===d);if(p.length===1){const w=await g(v);if(w)return(0,t.join)(w,p[0])}else if(p.length>1){const w=p.indexOf(d);if(w>=0){const C=await g(v);if(C)return(0,t.join)(C,p[w])}}}catch{}return null}e.realcase=g;async function b(I){try{return await M.Promises.realpath(I)}catch{const d=P(I);return await M.Promises.access(d,y.constants.R_OK),d}}e.realpath=b;function k(I){try{return y.realpathSync(I)}catch{const d=P(I);return y.accessSync(d,y.constants.R_OK),d}}e.realpathSync=k;function P(I){return(0,D.rtrim)((0,t.normalize)(I),t.sep)}}),define(x[88],ee([0,1,61]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,g,b,k=1){let P=!1;return new Promise(I=>{const v=setTimeout(()=>{if(!P)return P=!0,I(0)},b);L(E,g,k,d=>{if(!P)return P=!0,clearTimeout(v),I(d)})})}e.findFreePort=t;function L(E,g,b,k){if(g===0)return k(0);const P=new y.Socket;P.once("connect",()=>(M(P),L(E+b,g-1,b,k))),P.once("data",()=>{}),P.once("error",I=>(M(P),I.code!=="ECONNREFUSED"?L(E+b,g-1,b,k):k(E))),P.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(E,g,b){let k=!1,P,I=1;const v=y.createServer({pauseOnConnect:!0});function d(h,p){k||(k=!0,v.removeAllListeners(),v.close(),P&&clearTimeout(P),p(h))}return new Promise(h=>{P=setTimeout(()=>{d(0,h)},b),v.on("listening",()=>{d(E,h)}),v.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&I<g?(E++,I++,v.listen(E,"127.0.0.1")):d(0,h)}),v.on("close",()=>{d(0,h)}),v.listen(E,"127.0.0.1")})}e.findFreePortFaster=D;function M(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(g){console.error(g)}}}),define(x[124],ee([0,1,27,8,20]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var g;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(g||(g={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class P{constructor(c,s,l){this.exePath=c,this.displayName=s,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:u=!1}={}){return u?b===0?process.env["ProgramFiles(x86)"]||null:k===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:u=!1,findPreview:c=!1}={}){const s=I({useAlternateBitness:u});if(!s)return null;const l=t.join(s,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(l))return null;let i=-1,n=null;for(const a of await L.Promises.readdir(l)){let f=-1;if(c){const R=a.indexOf("-");if(R<0)continue;const A=a.substring(0,R);if(!D.test(A)||a.substring(R+1)!=="preview")continue;f=parseInt(A,10)}else{if(!D.test(a))continue;f=parseInt(a,10)}if(f<=i)continue;const S=t.join(l,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(S)||(n=S,i=f)}if(!n)return null;const o=s.includes("x86")?" (x86)":"",r=c?" Preview":"";return new P(n,`PowerShell${r}${o}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:s,pwshMsixName:l}=u?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(c))if(s.test(i)){const n=t.join(c,i,"pwsh.exe");return new P(n,l)}return null}function h(){const u=t.join(y.homedir(),".dotnet","tools","pwsh.exe");return new P(u,".NET Core PowerShell Global Tool")}function p(){const u=t.join(process.env.windir,b===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(u,"Windows PowerShell",!0)}async function*w(){let u=await v();u&&(yield u),u=await v({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=h(),u&&(yield u),u=await v({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await v({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=p(),u&&(yield u)}async function*C(){for await(const u of w())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=C;async function m(){for await(const u of C())return u;return null}e.getFirstAvailablePowerShellInstallation=m}),define(x[89],ee([0,1,45,10]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(M){return new Promise((E,g)=>{let b;const k=new Map;function P(v,d,h,p,w){const C=k.get(d);if(v===M||C){const m={name:I(h),cmd:h,pid:v,ppid:d,load:p,mem:w};k.set(v,m),v===M&&(b=m),C&&(C.children||(C.children=[]),C.children.push(m),C.children.length>1&&(C.children=C.children.sort((u,c)=>u.pid-c.pid)))}}function I(v){const d=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,C=/--crashes-directory/,m=/\\pipe\\winpty-control/,u=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(C.exec(v))return"electron-crash-reporter";if(m.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let s=c.exec(v);if(s&&s.length===2)return s[1]==="renderer"?d.exec(v)?"shared-process":h.exec(v)?"issue-reporter":p.exec(v)?"process-explorer":"window":s[1]==="utility"&&w.exec(v)?"utility-network-service":s[1];const l=/[a-zA-Z-]+\.js/g;let i="";do s=l.exec(v),s&&(i+=s+" ");while(s);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,h)=>{V(["windows-process-tree"],d,h)}).then(d=>{d.getProcessList(M,h=>{if(!h){g(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(h,p=>{const w=new Map;p.forEach(C=>{const m=v(C.commandLine||"");w.set(C.pid,{name:I(m),cmd:m,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),b=w.get(M),b?(w.forEach(C=>{const m=w.get(C.ppid);m&&(m.children||(m.children=[]),m.children.push(C))}),w.forEach(C=>{C.children&&(C.children=C.children.sort((m,u)=>m.pid-u.pid))}),E(b)):g(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let v=function(){let d=[b];const h=[];for(;d.length;){const w=d.shift();w&&(h.push(w.pid),w.children&&(d=d.concat(w.children)))}let p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);p+=" "+h.join(" "),(0,y.exec)(p,{},(w,C,m)=>{if(w||m)g(w||new Error(m.toString()));else{const u=C.toString().split(`
`);for(let c=0;c<h.length;c++){const s=k.get(h[c]);s.load=parseFloat(u[c])}if(!b){g(new Error(`Root process ${M} not found`));return}E(b)}})};(0,y.exec)("which ps",{},(d,h,p)=>{if(d||p)if(process.platform!=="linux")g(d||new Error(p.toString()));else{const w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,y.exec)(w,{},(C,m,u)=>{C||u?g(C||new Error(u.toString())):(D(m,P),v())})}else{const w=h.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${w} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,u,c)=>{m||c&&!c.includes("screen size is bogus")?g(m||new Error(c.toString())):(D(u,P),process.platform==="linux"?v():b?E(b):g(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=L;function D(M,E){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=M.toString().split(`
`);for(const k of b){const P=g.exec(k.trim());P&&P.length===6&&E(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(x[125],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"});var de=this&&this.__decorate||function(V,e,y,t){var L=arguments.length,D=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,y):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,y,t);else for(var E=V.length-1;E>=0;E--)(M=V[E])&&(D=(L<3?M(D):L>3?M(e,y,D):M(e,y))||D);return L>3&&D&&Object.defineProperty(e,y,D),D};define(x[38],ee([0,1,26,9,18,23,47,15,4,2,117,28,12]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function p(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(w||(w={}));class C{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class m{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var u;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(u||(u={}));function c(B){const z=L.VSBuffer.alloc(4);return z.writeUInt32BE(B,0),z}function s(B){return B.read(4).readUInt32BE(0)}function l(B){const z=L.VSBuffer.alloc(1);return z.writeUInt8(B,0),z}const i={Undefined:l(u.Undefined),String:l(u.String),Buffer:l(u.Buffer),VSBuffer:l(u.VSBuffer),Array:l(u.Array),Object:l(u.Object)},n=typeof Buffer!="undefined";function o(B,z){if(typeof z=="undefined")B.write(i.Undefined);else if(typeof z=="string"){const K=L.VSBuffer.fromString(z);B.write(i.String),B.write(c(K.byteLength)),B.write(K)}else if(n&&Buffer.isBuffer(z)){const K=L.VSBuffer.wrap(z);B.write(i.Buffer),B.write(c(K.byteLength)),B.write(K)}else if(z instanceof L.VSBuffer)B.write(i.VSBuffer),B.write(c(z.byteLength)),B.write(z);else if(Array.isArray(z)){B.write(i.Array),B.write(c(z.length));for(const K of z)o(B,K)}else{const K=L.VSBuffer.fromString(JSON.stringify(z));B.write(i.Object),B.write(c(K.byteLength)),B.write(K)}}function r(B){switch(B.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return B.read(s(B)).toString();case u.Buffer:return B.read(s(B)).buffer;case u.VSBuffer:return B.read(s(B));case u.Array:{const K=s(B),te=[];for(let Q=0;Q<K;Q++)te.push(r(B));return te}case u.Object:return JSON.parse(B.read(s(B)).toString())}}class a{constructor(z,K,te=null,Q=1e3){this.protocol=z,this.ctx=K,this.logger=te,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger?.logOutgoing(K,0,1,p(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(K,z.id,1,p(z.type),z.data);return}}}send(z,K=void 0){const te=new m;return o(te,z),o(te,K),this.sendBuffer(te.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const K=new C(z),te=r(K),Q=r(K),O=te[0];switch(O){case 100:return this.logger?.logIncoming(z.byteLength,te[1],1,`${d(O)}: ${te[2]}.${te[3]}`,Q),this.onPromise({type:O,id:te[1],channelName:te[2],name:te[3],arg:Q});case 102:return this.logger?.logIncoming(z.byteLength,te[1],1,`${d(O)}: ${te[2]}.${te[3]}`,Q),this.onEventListen({type:O,id:te[1],channelName:te[2],name:te[3],arg:Q});case 101:return this.logger?.logIncoming(z.byteLength,te[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:te[1]});case 103:return this.logger?.logIncoming(z.byteLength,te[1],1,`${d(O)}`),this.disposeActiveRequest({type:O,id:te[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const te=new D.CancellationTokenSource;let Q;try{Q=K.call(this.ctx,z.name,z.arg,te.token)}catch(W){Q=Promise.reject(W)}const O=z.id;Q.then(W=>{this.sendResponse({id:O,data:W,type:201}),this.activeRequests.delete(z.id)},W=>{W instanceof Error?this.sendResponse({id:O,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:O,data:W,type:203}),this.activeRequests.delete(z.id)});const U=(0,b.toDisposable)(()=>te.cancel());this.activeRequests.set(z.id,U)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const te=z.id,O=K.listen(this.ctx,z.name,z.arg)(U=>this.sendResponse({id:te,data:U,type:204}));this.activeRequests.set(z.id,O)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const te=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:te})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const te of K)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var f;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=K}getChannel(z){const K=this;return{call(te,Q,O){return K.isDisposed?Promise.reject(E.canceled()):K.requestPromise(z,te,Q,O)},listen(te,Q){return K.isDisposed?g.Event.None:K.requestEvent(z,te,Q)}}}requestPromise(z,K,te,Q=D.CancellationToken.None){const O=this.lastRequestId++,W={id:O,type:100,channelName:z,name:K,arg:te};if(Q.isCancellationRequested)return Promise.reject(E.canceled());let N;return new Promise((_,q)=>{if(Q.isCancellationRequested)return q(E.canceled());const Z=()=>{const he=ue=>{switch(ue.type){case 201:this.handlers.delete(O),_(ue.data);break;case 202:{this.handlers.delete(O);const ge=new Error(ue.data.message);ge.stack=ue.data.stack,ge.name=ue.data.name,q(ge);break}case 203:this.handlers.delete(O),q(ue.data);break}};this.handlers.set(O,he),this.sendRequest(W)};let oe=null;this.state===w.Idle?Z():(oe=(0,t.createCancelablePromise)(he=>this.whenInitialized()),oe.then(()=>{oe=null,Z()}));const ce=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:O,type:101}),q(E.canceled())},se=Q.onCancellationRequested(ce);N=(0,b.combinedDisposable)((0,b.toDisposable)(ce),se),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(z,K,te){const Q=this.lastRequestId++,U={id:Q,type:102,channelName:z,name:K,arg:te};let W=null;const N=new g.Emitter({onFirstListenerAdd:()=>{W=(0,t.createCancelablePromise)(_=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(N),this.sendRequest(U)})},onLastListenerRemove:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(N),this.sendRequest({id:Q,type:103}))}}),T=_=>N.fire(_.data);return this.handlers.set(Q,T),N.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${d(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,d(z.type));return}}}send(z,K=void 0){const te=new m;return o(te,z),o(te,K),this.sendBuffer(te.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const K=new C(z),te=r(K),Q=r(K),O=te[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,p(O)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,te[1],0,p(O),Q),this.onResponse({type:te[0],id:te[1],data:Q})}}onResponse(z){if(z.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([M.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class R{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:te})=>{g.Event.once(K.onMessage)(O=>{const U=new C(O),W=r(U),N=new a(K,W),T=new S(K);this.channels.forEach((q,Z)=>N.registerChannel(Z,q));const _={channelServer:N,channelClient:T,ctx:W};this._connections.add(_),this._onDidAddConnection.fire(_),te(()=>{N.dispose(),T.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const te=this;return{call(Q,O,U){let W;if((0,I.isFunction)(K)){let T=(0,y.getRandomElement)(te.connections.filter(K));W=T?Promise.resolve(T):g.Event.toPromise(g.Event.filter(te.onDidAddConnection,K))}else W=K.routeCall(te,Q,O);const N=W.then(T=>T.channelClient.getChannel(z));return F(N).call(Q,O,U)},listen(Q,O){if((0,I.isFunction)(K))return te.getMulticastEvent(z,K,Q,O);const U=K.routeEvent(te,Q,O).then(W=>W.channelClient.getChannel(z));return F(U).listen(Q,O)}}}getMulticastEvent(z,K,te,Q){const O=this;let U=new b.DisposableStore;const W=new g.Emitter({onFirstListenerAdd:()=>{U=new b.DisposableStore;const N=new g.EventMultiplexer,T=new Map,_=Z=>{const ce=Z.channelClient.getChannel(z).listen(te,Q),se=N.add(ce);T.set(Z,se)},q=Z=>{const oe=T.get(Z);!oe||(oe.dispose(),T.delete(Z))};O.connections.filter(K).forEach(_),g.Event.filter(O.onDidAddConnection,K)(_,void 0,U),O.onDidRemoveConnection(q,void 0,U),N.event(W.fire,W,U),U.add(N)},onLastListenerRemove:()=>{U.dispose()}});return W.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(te=>{te.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class A{constructor(z,K,te=null){const Q=new m;o(Q,K),z.send(Q.buffer),this.channelClient=new S(z,te),this.channelServer=new a(z,K,te)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(B){return{call(z,K,te){return B.then(Q=>Q.call(z,K,te))},listen(z,K){const te=new g.Relay;return B.then(Q=>te.input=Q.listen(z,K)),te.event}}}e.getDelayedChannel=F;function $(B){let z=!1;return{call(K,te,Q){return z?B.call(K,te,Q):(0,t.timeout)(0).then(()=>z=!0).then(()=>B.call(K,te,Q))},listen(K,te){if(z)return B.listen(K,te);const Q=new g.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>Q.input=B.listen(K,te)),Q.event}}}e.getNextTickChannel=$;class J{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await g.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=J;var ne;(function(B){function z(O,U){const W=O,N=U&&U.disableMarshalling,T=new Map;for(const _ in W)te(_)&&T.set(_,g.Event.buffer(W[_],!0));return new class{listen(_,q,Z){const oe=T.get(q);if(oe)return oe;if(Q(q)){const ce=W[q];if(typeof ce=="function")return ce.call(W,Z)}throw new Error(`Event not found: ${q}`)}call(_,q,Z){const oe=W[q];if(typeof oe=="function"){if(!N&&Array.isArray(Z))for(let ce=0;ce<Z.length;ce++)Z[ce]=(0,k.revive)(Z[ce]);return oe.apply(W,Z)}throw new Error(`Method not found: ${q}`)}}}B.fromService=z;function K(O,U){const W=U&&U.disableMarshalling;return new Proxy({},{get(N,T){if(typeof T=="string")return U?.properties?.has(T)?U.properties.get(T):Q(T)?function(_){return O.listen(T,_)}:te(T)?O.listen(T):async function(..._){let q;U&&!(0,I.isUndefinedOrNull)(U.context)?q=[U.context,..._]:q=_;const Z=await O.call(T,q);return W?Z:(0,k.revive)(Z)};throw new Error(`Property not found: ${String(T)}`)}})}B.toService=K;function te(O){return O[0]==="o"&&O[1]==="n"&&P.isUpperAsciiLetter(O.charCodeAt(2))}function Q(O){return/^onDynamic/.test(O)&&P.isUpperAsciiLetter(O.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let z=B.toString();if(z!=="[object Object]")return z}return B}function H(B){return Array.isArray(B)?B.map(re):re(B)}function X(B,z,K,te,Q,O,U){U=H(U);const W=Y[Q],N=W[te%W.length];let T=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(O)?(T=T.concat(U),T.push(")")):T.push(U),console.log.apply(console,T)}e.logWithColors=X;class j{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,te,Q,O){this._totalOutgoing+=z,X(this._outgoingPrefix,this._totalOutgoing,z,K,te,Q,O)}logIncoming(z,K,te,Q,O){this._totalIncoming+=z,X(this._incomingPrefix,this._totalIncoming,z,K,te,Q,O)}}e.IPCLogger=j}),define(x[126],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class y{constructor(L,D){this.sender=L,this.onMessage=D}send(L){try{this.sender.send("vscode:message",L.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=y}),define(x[127],ee([0,1,18,4,38]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(g){this.port=g,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",b=>y.VSBuffer.wrap(b.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class M extends L.IPCClient{constructor(g,b){const k=new D(g);super(k,b);this.protocol=k}dispose(){this.protocol.disconnect()}}e.Client=M}),define(x[90],ee([0,1,18,4,2,38]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let r=0;function a(S,R){if(!o.has(S)){const A=String(++r);o.set(S,A)}return o.get(S)}function f(S,R,A,F){if(!n.enableDiagnostics)return;const $=a(S,R);if(F instanceof y.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const J=y.VSBuffer.alloc(F.byteLength);J.set(F),n.records.push({timestamp:Date.now(),id:$,label:R,type:A,buff:J})}else n.records.push({timestamp:Date.now(),id:$,label:R,type:A,data:F})}n.traceSocketEvent=f})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function k(){return b||(b=y.VSBuffer.alloc(0)),b}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return k();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let a=y.VSBuffer.alloc(o),f=0,S=0;for(;o>0;){const R=this._chunks[S];if(R.byteLength>o){const A=R.slice(0,o);a.set(A,f),f+=o,r&&(this._chunks[S]=R.slice(o),this._totalLength-=o),o-=o}else a.set(R,f),f+=R.byteLength,r?(this._chunks.shift(),this._totalLength-=R.byteLength):S++,o-=R.byteLength}return a}}e.ChunkStream=P;var I;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(I||(I={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,r,a,f){this.type=o,this.id=r,this.ack=a,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends L.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,f=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new h(a,f,S,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=y.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(r,o.data)}_bufferAdd(o,r){const a=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,a}_bufferTake(){const o=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class C extends L.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=C;class m extends D.IPCClient{constructor(o,r,a=null){super(o,r,a);this.protocol=o}static fromSocket(o,r){return new m(new C(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=m;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,a=this._first;for(;a;)o[r++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new c(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<l._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=l._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),r=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let f=0;f<l._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=r&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(o,r=null,a=l.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),r&&this._socketReader.acceptChunk(r)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,k());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new h(7,0,0,k());this._socketWriter.write(o)}sendResume(){const o=new h(8,0,0,k());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,k());this._socketWriter.write(o);const r=this._outgoingUnackMsg.toArray();for(let a=0,f=r.length;a<f;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new h(6,0,0,k())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,f=r.length;a<f;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const r=new h(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const S=Math.max(2e4-r,2e4-a,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,k());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(x[37],ee([0,1,14,15]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class L{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,E){const g=(b,...k)=>{this.validateEvent(M,b)&&E(b,...k)};return this.mapListenerToWrapper.set(E,g),y.ipcMain.on(M,g),this}once(M,E){return y.ipcMain.once(M,(g,...b)=>{this.validateEvent(M,g)&&E(g,...b)}),this}handle(M,E){return y.ipcMain.handle(M,(g,...b)=>this.validateEvent(M,g)?E(g,...b):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return y.ipcMain.removeHandler(M),this}removeListener(M,E){const g=this.mapListenerToWrapper.get(E);return g&&(y.ipcMain.removeListener(M,g),this.mapListenerToWrapper.delete(E)),this}validateEvent(M,E){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const g=E.senderFrame,b=g.url;if(!b)return!0;let k="unknown";try{k=new URL(b).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${b}'.`),!1}return k!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${k}'.`),!1):g.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${k}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new L}),define(x[128],ee([0,1,14,37,12,125]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(D.CONTEXT_MENU_CHANNEL,(g,b,k,P,I)=>{const v=E(g,P,k);v.popup({window:(0,L.withNullAsUndefined)(y.BrowserWindow.fromWebContents(g.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{v&&g.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,b)}})})}e.registerContextMenuListener=M;function E(g,b,k){const P=new y.Menu;return k.forEach(I=>{let v;I.type==="separator"?v=new y.MenuItem({type:I.type}):Array.isArray(I.submenu)?v=new y.MenuItem({submenu:E(g,b,I.submenu),label:I.label}):v=new y.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(d,h,p)=>g.sender.send(b,I.id,p)}),P.append(v)}),P}}),define(x[129],ee([0,1,37,18,4,2,38,126]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(k,P){const I=L.Event.fromNodeEventEmitter(y.validatedIpcMain,P,(d,h)=>({event:d,message:h})),v=L.Event.filter(I,({event:d})=>d.sender.id===k);return L.Event.map(v,({message:d})=>d&&t.VSBuffer.wrap(d))}class b extends M.IPCServer{constructor(){super(b.getOnDidClientConnect())}static getOnDidClientConnect(){const P=L.Event.fromNodeEventEmitter(y.validatedIpcMain,"vscode:hello",({sender:I})=>I);return L.Event.map(P,I=>{const v=I.id,d=b.Clients.get(v);d&&d.dispose();const h=new L.Emitter;b.Clients.set(v,(0,D.toDisposable)(()=>h.fire()));const p=g(v,"vscode:message"),w=L.Event.any(L.Event.signal(g(v,"vscode:disconnect")),h.event);return{protocol:new E.Protocol(I,p),onDidClientDisconnect:w}})}}e.Server=b,b.Clients=new Map}),define(x[91],ee([0,1,37,4,31,127]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends D.Client{constructor(b,k){super({addEventListener:(P,I)=>b.addListener(P,I),removeEventListener:(P,I)=>b.removeListener(P,I),postMessage:P=>b.postMessage(P),start:()=>b.start(),close:()=>b.close()},k)}}e.Client=M;async function E(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const b=(0,L.generateUuid)();g.webContents.send("vscode:createMessageChannel",b);const k=t.Event.fromNodeEventEmitter(y.validatedIpcMain,"vscode:createMessageChannelResult",(I,v)=>({nonce:v,port:I.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(k,I=>I.nonce===b)));return P}e.connect=E}),define(x[92],ee([0,1,9,4,2,12]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function E(P){const I=P;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var g;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class b extends L.Disposable{constructor(I,v=Object.create(null)){super();this.database=I,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((v,d)=>this.accept(d,v)),I.deleted?.forEach(v=>this.accept(v,void 0))}accept(I,v){if(this.state===g.Closed)return;let d=!1;(0,D.isUndefinedOrNull)(v)?d=this.cache.delete(I):this.cache.get(I)!==v&&(this.cache.set(I,v),d=!0),d&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,v){const d=this.cache.get(I);return(0,D.isUndefinedOrNull)(d)?v:d}getBoolean(I,v){const d=this.get(I);return(0,D.isUndefinedOrNull)(d)?v:d==="true"}getNumber(I,v){const d=this.get(I);return(0,D.isUndefinedOrNull)(d)?v:parseInt(d,10)}async set(I,v){if(this.state===g.Closed)return;if((0,D.isUndefinedOrNull)(v))return this.delete(I);const d=String(v);if(this.cache.get(I)!==d)return this.cache.set(I,d),this.pendingInserts.set(I,d),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===g.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class k{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((v,d)=>this.items.set(d,v)),I.delete&&I.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=k}),define(x[130],ee([0,1,9,4,35,8,20]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(k,P=Object.create(null)){this.path=k,this.options=P,this.name=(0,D.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const k=await this.whenConnected,P=new Map;return(await this.all(k,"SELECT * FROM ItemTable")).forEach(v=>P.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(k){const P=await this.whenConnected;return this.doUpdateItems(P,k)}doUpdateItems(k,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,L.mapToString)(P.insert):"0"}), delete(${P.delete?(0,L.setToString)(P.delete):"0"})`),this.transaction(k,()=>{const I=P.insert,v=P.delete;if(I&&I.size>0){const d=[];d.push([]);let h=0;I.forEach((p,w)=>{let C=d[h];C.length>E.MAX_HOST_PARAMETERS&&(h++,C=[],d.push(C)),C.push(w,p)}),d.forEach(p=>{this.prepare(k,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,w=>w.run(p),()=>{const w=[];let C=0;return I.forEach((m,u)=>{w.push(u),C+=m.length}),`Keys: ${w.join(", ")} Length: ${C}`})})}if(v&&v.size){const d=[];d.push([]);let h=0;v.forEach(p=>{let w=d[h];w.length>E.MAX_HOST_PARAMETERS&&(h++,w=[],d.push(w)),w.push(p)}),d.forEach(p=>{this.prepare(k,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,w=>w.run(p),()=>{const w=[];return v.forEach(C=>{w.push(C)}),`Keys: ${w.join(", ")}`})})}})}async close(k){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,k)}doClose(k,P){return new Promise((I,v)=>{k.db.close(d=>(d&&this.handleSQLiteError(k,`[storage ${this.name}] close(): ${d}`),this.path===E.IN_MEMORY_PATH?I():!k.isErroneous&&!k.isInMemory?this.backup().then(I,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),I())):typeof P=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const p=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:P()}).then(()=>p(),w=>(p(),Promise.reject(w)))})).then(I,v):v(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const k=this.toBackupPath(this.path);return M.Promises.copy(this.path,k,{preserveSymlinks:!1})}toBackupPath(k){return`${k}.backup`}async checkIntegrity(k){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${k})`);const P=await this.whenConnected,I=await this.get(P,k?"PRAGMA integrity_check":"PRAGMA quick_check"),v=k?I.integrity_check:I.quick_check;return P.isErroneous?`${v} (last error: ${P.lastError})`:P.isInMemory?`${v} (in-memory!)`:v}async connect(k,P=!0){this.logger.trace(`[storage ${this.name}] open(${k}, retryOnBusy: ${P})`);try{return await this.doConnect(k)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&P)return await(0,y.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(k,!1);try{await M.Promises.unlink(k);try{await M.Promises.rename(this.toBackupPath(k),k)}catch{}return await this.doConnect(k)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(k,P){k.isErroneous=!0,k.lastError=P,this.logger.error(P)}doConnect(k){return new Promise((P,I)=>{new Promise((v,d)=>{V(["@vscode/sqlite3"],v,d)}).then(v=>{const d={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(k,h=>h?d.db?d.db.close(()=>I(h)):I(h):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),p=>d.db.close(()=>I(p)))),isInMemory:k===E.IN_MEMORY_PATH};d.db.on("error",h=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&d.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},I)})}exec(k,P){return new Promise((I,v)=>{k.db.exec(P,d=>d?(this.handleSQLiteError(k,`[storage ${this.name}] exec(): ${d}`),v(d)):I())})}get(k,P){return new Promise((I,v)=>{k.db.get(P,(d,h)=>d?(this.handleSQLiteError(k,`[storage ${this.name}] get(): ${d}`),v(d)):I(h))})}all(k,P){return new Promise((I,v)=>{k.db.all(P,(d,h)=>d?(this.handleSQLiteError(k,`[storage ${this.name}] all(): ${d}`),v(d)):I(h))})}transaction(k,P){return new Promise((I,v)=>{k.db.serialize(()=>{k.db.run("BEGIN TRANSACTION"),P(),k.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(k,`[storage ${this.name}] transaction(): ${d}`),v(d)):I())})})}prepare(k,P,I,v){const d=k.db.prepare(P),h=p=>{this.handleSQLiteError(k,`[storage ${this.name}] prepare(): ${p} (${P}). Details: ${v()}`)};d.on("error",h),I(d),d.finalize(p=>{p&&h(p),d.removeListener("error",h)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class g{constructor(k){k&&typeof k.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=k.logTrace),k&&typeof k.logError=="function"&&(this.logError=k.logError)}get isTracing(){return!!this.logTrace}trace(k){this.logTrace&&this.logTrace(k)}error(k){this.logError&&this.logError(k)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(x[131],ee([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(x[132],ee([0,1,131]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,D=L*24,M=D*7,E=D*30,g=D*365;function b(P,I,v){typeof P!="number"&&(P=P.getTime());const d=Math.round((new Date().getTime()-P)/1e3);if(d<-30)return(0,y.localize)(0,null,b(new Date().getTime()+d*1e3,!1));if(d<30)return(0,y.localize)(1,null);let h;return d<t?(h=d,I?h===1?v?(0,y.localize)(2,null,h):(0,y.localize)(3,null,h):v?(0,y.localize)(4,null,h):(0,y.localize)(5,null,h):h===1?v?(0,y.localize)(6,null,h):(0,y.localize)(7,null,h):v?(0,y.localize)(8,null,h):(0,y.localize)(9,null,h)):d<L?(h=Math.floor(d/t),I?h===1?v?(0,y.localize)(10,null,h):(0,y.localize)(11,null,h):v?(0,y.localize)(12,null,h):(0,y.localize)(13,null,h):h===1?v?(0,y.localize)(14,null,h):(0,y.localize)(15,null,h):v?(0,y.localize)(16,null,h):(0,y.localize)(17,null,h)):d<D?(h=Math.floor(d/L),I?h===1?v?(0,y.localize)(18,null,h):(0,y.localize)(19,null,h):v?(0,y.localize)(20,null,h):(0,y.localize)(21,null,h):h===1?v?(0,y.localize)(22,null,h):(0,y.localize)(23,null,h):v?(0,y.localize)(24,null,h):(0,y.localize)(25,null,h)):d<M?(h=Math.floor(d/D),I?h===1?(0,y.localize)(26,null,h):(0,y.localize)(27,null,h):h===1?(0,y.localize)(28,null,h):(0,y.localize)(29,null,h)):d<E?(h=Math.floor(d/M),I?h===1?v?(0,y.localize)(30,null,h):(0,y.localize)(31,null,h):v?(0,y.localize)(32,null,h):(0,y.localize)(33,null,h):h===1?v?(0,y.localize)(34,null,h):(0,y.localize)(35,null,h):v?(0,y.localize)(36,null,h):(0,y.localize)(37,null,h)):d<g?(h=Math.floor(d/E),I?h===1?v?(0,y.localize)(38,null,h):(0,y.localize)(39,null,h):v?(0,y.localize)(40,null,h):(0,y.localize)(41,null,h):h===1?v?(0,y.localize)(42,null,h):(0,y.localize)(43,null,h):v?(0,y.localize)(44,null,h):(0,y.localize)(45,null,h)):(h=Math.floor(d/g),I?h===1?v?(0,y.localize)(46,null,h):(0,y.localize)(47,null,h):v?(0,y.localize)(48,null,h):(0,y.localize)(49,null,h):h===1?v?(0,y.localize)(50,null,h):(0,y.localize)(51,null,h):v?(0,y.localize)(52,null,h):(0,y.localize)(53,null,h))}e.fromNow=b;function k(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=k}),define(x[133],ee([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(x[39],ee([0,1,26,12,133]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(P,I){return I&&(P.stack||P.stacktrace)?L.localize(0,null,E(P),M(P.stack)||M(P.stacktrace)):E(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function E(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?L.localize(1,null,P.message):P.message||L.localize(2,null)}function g(P=null,I=!1){if(!P)return L.localize(3,null);if(Array.isArray(P)){const v=y.coalesce(P),d=g(v[0],I);return v.length>1?L.localize(4,null,d,v.length):d}if(t.isString(P))return P;if(P.detail){const v=P.detail;if(v.error)return D(v.error,I);if(v.exception)return D(v.exception,I)}return P.stack?D(P,I):P.message?P.message:L.localize(5,null)}e.toErrorMessage=g;function b(P){const I=P;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=b;function k(P,I){let v;return typeof P=="string"?v=new Error(P):v=P,v.actions=I,v}e.createErrorWithActions=k}),define(x[134],ee([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(x[75],ee([0,1,45,29,10,50,8,3,36,70,12,121,20,134]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function d(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(c,s){if(E.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};s&&(l.cwd=s);const i=y.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],l);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,r)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(E.isLinux||E.isMacintosh)try{const l=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{y.execFile(l,[c.pid.toString()],{encoding:"utf8",shell:!0},(n,o,r)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function p(c=g.env){return c.comspec||"cmd.exe"}e.getWindowsShell=p;class w{constructor(s,l,i,n){if(l!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=l,this.shell=i,this.options=n;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(g.env).forEach(r=>{o[r]=g.env[r]}),Object.keys(this.options.env).forEach(r=>{o[r]=this.options.env[r]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const l=s.lastIndexOf(M.sep);return l!==-1&&(s=s.substring(l+1)),w.WellKnowCommands[s]?s:"other"}start(s){return E.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(g.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(l=>{let i,n;const o=new Promise((r,a)=>{i=r,n=a});if(l){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=y.exec(r,this.options,(a,f,S)=>{this.childProcess=null;const R=a;R&&R.killed?n({killed:this.terminateRequested,stdout:f.toString(),stderr:S.toString()}):this.handleExec(i,s,a,f,S)})}else{let r=null;const a=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,s,n);const S={terminated:this.terminateRequested};k.isNumber(f)&&(S.cmdCode=f),i(S)};if(this.shell&&E.isWindows){const f=D.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let S=!1,R=!1;const A=[];let F=this.ensureQuotes(this.cmd);A.push(F.value),S=F.quoted,this.args&&this.args.forEach(J=>{F=this.ensureQuotes(J),A.push(F.value),R=R&&F.quoted});const $=["/s","/c"];S?R?$.push('"'+A.join(" ")+'"'):A.length>1?$.push('"'+A[0]+'" '+A.slice(1).join(" ")):$.push('"'+A[0]+'"'):$.push(A.join(" ")),r=y.spawn(p(),$,f)}else this.cmd&&(r=y.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(k.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",f=>{this.childProcess=null,n({terminated:this.terminateRequested,error:f})}),r.pid&&(this.childProcess.on("close",a),this.handleSpawn(r,i,s,n,!0)))}return o})}handleClose(s,l,i,n){}ensureQuotes(s){return w.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,h(s,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!E.isWindows)return s(!1);const l=y.spawn(p(),["/s","/c"]);l.on("error",i=>s(!0)),l.on("exit",i=>s(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class C extends w{constructor(s,l,i,n){super(s,l,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,l,i,n,o){[n,o].forEach((r,a)=>{const f=new P.LineDecoder;f.write(r).forEach(A=>{l({line:A,source:a===0?0:1})});const R=f.end();R&&l({line:R,source:a===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,l,i,n,o){const r=new P.LineDecoder,a=new P.LineDecoder;s.stdout.on("data",f=>{r.write(f).forEach(R=>i({line:R,source:0}))}),s.stderr.on("data",f=>{a.write(f).forEach(R=>i({line:R,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=a}handleClose(s,l,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&i({line:r,source:1})}}e.LineProcess=C;function m(c){let s=[],l=!1;const i=function(n){if(l){s.push(n);return}(!c.send(n,r=>{if(r&&console.error(r),l=!1,s.length>0){const a=s.slice(0);s=[],a.forEach(f=>i(f))}})||E.isWindows)&&(l=!0)};return{send:i}}e.createQueuedSender=m;var u;(function(c){async function s(l,i,n){if(M.isAbsolute(l))return l;if(i===void 0&&(i=g.cwd()),M.dirname(l)!=="."||(n===void 0&&k.isString(g.env.PATH)&&(n=g.env.PATH.split(M.delimiter)),n===void 0||n.length===0))return M.join(i,l);async function r(a){if(await I.Promises.exists(a)){let f;try{f=await I.Promises.stat(a)}catch(S){S.message.startsWith("EACCES")&&(f=await I.Promises.lstat(a))}return f?!f.isDirectory():!1}return!1}for(let a of n){let f;if(M.isAbsolute(a)?f=M.join(a,l):f=M.join(i,a,l),await r(f))return f;let S=f+".com";if(await r(S)||(S=f+".exe",await r(S)))return S}return M.join(i,l)}c.findExecutable=s})(u=e.win32||(e.win32={}))}),define(x[135],ee([0,1,27,3,124,75]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(v,d){return v===1?t.isWindows?P():D.getWindowsShell(d):b(v,d)}e.getSystemShell=M;function E(v,d){return v===1?t.isWindows?I(d):D.getWindowsShell(d):b(v,d)}e.getSystemShellSync=E;let g=null;function b(v,d){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!g){let h;if(t.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,y.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}g=h}return g}let k=null;async function P(){return k||(k=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),k}function I(v){if(k)return k;const d=t.isWindows&&parseFloat((0,y.release)())>=10,h=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${v.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?p:D.getWindowsShell(v)}}),define(x[136],ee([0,1,45,9,18,23,116,15,4,2,50,75,70,38]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(w){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",C=>L.VSBuffer.wrap(Buffer.from(C,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=d;class h{constructor(w,C){this.modulePath=w,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(w){const C=this;return{call(m,u,c){return C.requestPromise(w,m,u,c)},listen(m,u){return C.requestEvent(w,m,u)}}}requestPromise(w,C,m,u=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(w),s=(0,t.createCancelablePromise)(n=>c.call(C,m,n)),l=u.onCancellationRequested(()=>s.cancel()),i=(0,b.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{l.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(w,C,m){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let u;const c=new g.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(w).listen(C,m)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,I.removeDangerousEnvVariables)(C.env),this.child=(0,y.fork)(this.modulePath,w,C);const m=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.options.serverName}`);return}m.fire(L.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),l=m.event,i={send:s,onMessage:l};this._client=new v.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,r)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,b.dispose)(a)),this.activeRequests.clear(),o!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:r})})}return this._client}getCachedChannel(w){let C=this.channels.get(w);return C||(C=this.client.getChannel(w),this.channels.set(w,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(x[137],ee([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(x[138],ee([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(x[139],ee([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(x[140],ee([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(x[141],ee([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(x[142],ee([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(x[143],ee([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(x[144],ee([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(x[145],ee([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(x[146],ee([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(x[147],ee([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(x[148],ee([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(x[149],ee([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(x[150],ee([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(x[151],ee([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(x[152],ee([13,11]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(x[153],ee([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(x[154],ee([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(x[155],ee([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(x[156],ee([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(x[157],ee([13,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(x[158],ee([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(x[159],ee([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(x[160],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function y(L){return L&&L.hasOwnProperty("folderUri")}e.isFolderBackupInfo=y;function t(L){return L&&L.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(x[161],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function y(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=y}),define(x[162],ee([0,1,4,2]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(E,g,b){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(E,g,b){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class D extends t.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,g,b){this.channel.call("attach",[E,g,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,g){this.channel.call("terminate",[E,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,g){return this.channel.call("openExtensionDevelopmentHostWindow",[E,g])}}e.ExtensionHostDebugChannelClient=D}),define(x[163],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class y{constructor(L){this.machineId=L}encryption(){return new Promise((L,D)=>V(["vscode-encrypt"],L,D))}async encrypt(L){try{return(await this.encryption()).encrypt(this.machineId,L)}catch{return L}}async decrypt(L){try{return(await this.encryption()).decrypt(this.machineId,L)}catch{return L}}}e.EncryptionMainService=y}),define(x[164],ee([0,1,132,47,10,8,36,16,7]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(h,p,w){this._args=h,this.paths=p,this.productService=w}get appRoot(){return(0,D.dirname)(L.FileAccess.asFileUri("",V).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(g.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?g.URI.file((0,D.join)(h,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(L.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const p=M.env.VSCODE_EXTENSIONS;if(p)return p;const w=M.env.VSCODE_PORTABLE;return w?(0,D.join)(w,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,D.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?g.URI.parse(h):g.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([t.memoize],b.prototype,"appRoot",null),de([t.memoize],b.prototype,"userHome",null),de([t.memoize],b.prototype,"userDataPath",null),de([t.memoize],b.prototype,"appSettingsHome",null),de([t.memoize],b.prototype,"tmpDir",null),de([t.memoize],b.prototype,"cacheHome",null),de([t.memoize],b.prototype,"userRoamingDataHome",null),de([t.memoize],b.prototype,"settingsResource",null),de([t.memoize],b.prototype,"userDataSyncHome",null),de([t.memoize],b.prototype,"userDataSyncLogResource",null),de([t.memoize],b.prototype,"sync",null),de([t.memoize],b.prototype,"machineSettingsResource",null),de([t.memoize],b.prototype,"globalStorageHome",null),de([t.memoize],b.prototype,"workspaceStorageHome",null),de([t.memoize],b.prototype,"localHistoryHome",null),de([t.memoize],b.prototype,"keybindingsResource",null),de([t.memoize],b.prototype,"keyboardLayoutResource",null),de([t.memoize],b.prototype,"argvResource",null),de([t.memoize],b.prototype,"snippetsHome",null),de([t.memoize],b.prototype,"isExtensionDevelopment",null),de([t.memoize],b.prototype,"untitledWorkspacesHome",null),de([t.memoize],b.prototype,"installSourcePath",null),de([t.memoize],b.prototype,"builtinExtensionsPath",null),de([t.memoize],b.prototype,"extensionsPath",null),de([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([t.memoize],b.prototype,"extensionDevelopmentKind",null),de([t.memoize],b.prototype,"extensionTestsLocationURI",null),de([t.memoize],b.prototype,"debugExtensionHost",null),de([t.memoize],b.prototype,"serviceMachineIdResource",null),de([t.memoize],b.prototype,"telemetryLogResource",null),de([t.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function k(d,h){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=k;function P(d,h){return v(d["inspect-search"],d["inspect-brk-search"],5876,h,d.extensionEnvironment)}e.parseSearchPort=P;function I(d,h){return v(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,h,d.extensionEnvironment)}e.parsePtyHostPort=I;function v(d,h,p,w,C,m){const c=Number(h||d)||(w?null:p),s=c?Boolean(!!h):!1;let l;if(m)try{l=JSON.parse(m)}catch{}return{port:c,break:s,debugId:C,env:l}}}),define(x[93],ee([0,1,242,3,140]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function E(d,h,p=M){const w={},C=["_"],m=[];for(let l in h){const i=h[l];i.alias&&(w[l]=i.alias),i.type==="string"||i.type==="string[]"?(C.push(l),i.deprecates&&C.push(...i.deprecates)):i.type==="boolean"&&(m.push(l),i.deprecates&&m.push(...i.deprecates))}const u=y(d,{string:C,boolean:m,alias:w}),c={},s=u;c._=u._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(let l in h){const i=h[l];i.alias&&delete s[i.alias];let n=s[l];if(i.deprecates)for(const o of i.deprecates)s.hasOwnProperty(o)&&(n||(n=s[o],n&&p.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null,l))),delete s[o]);typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),p.onMultipleValues(l,n)),c[l]=n,i.deprecationMessage&&p.onDeprecatedOption(l,i.deprecationMessage)),delete s[l]}for(let l in s)p.onUnknownOption(l);return c}e.parseArgs=E;function g(d,h){let p="";return h.args&&(Array.isArray(h.args)?p=` <${h.args.join("> <")}>`:p=` <${h.args}>`),h.alias?`-${h.alias} --${d}${p}`:`--${d}${p}`}function b(d,h){let p=0,w=[];for(const c in d){const s=d[c],l=g(c,s);p=Math.max(p,l.length),w.push([l,s.description])}let C=p+2+1;if(h-C<25)return w.reduce((c,s)=>c.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let m=h-C-1,u=[];for(const c of w){let s=c[0],l=P(c[1],m),i=k(C-s.length-2);u.push("  "+s+i+l[0]);for(let n=1;n<l.length;n++)u.push(k(C)+l[n])}return u}e.formatOptions=b;function k(d){return" ".repeat(d)}function P(d,h){let p=[];for(;d.length;){let w=d.length<h?d.length:d.lastIndexOf(" ",h),C=d.slice(0,w).trim();d=d.slice(w),p.push(C)}return p}function I(d,h,p,w,C){const m=process.stdout.isTTY&&process.stdout.columns||80,u=C?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",c=[`${d} ${p}`];c.push(""),c.push(`${(0,L.localize)(35,null)}: ${h} [${(0,L.localize)(36,null)}]${u}`),c.push(""),C?.noPipe!==!0&&(t.isWindows?c.push((0,L.localize)(37,null,h)):c.push((0,L.localize)(38,null,h)),c.push(""));const s={};for(const l in w){const i=w[l];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[l]=i}}for(let l in s){const i=l;let n=s[i];n&&(c.push(D[i]),c.push(...b(n,m)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function v(d,h){return`${d||(0,L.localize)(39,null)}
${h||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=v}),define(x[165],ee([0,1,61,162,93]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends t.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,g,b){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(b[0],b[1]):super.call(E,g,b)}async openExtensionDevelopmentHostWindow(E,g){const b=(0,L.parseArgs)(E,L.OPTIONS);b.debugRenderer=g;const k=b.extensionDevelopmentPath;if(!k)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(k,{context:5,cli:b});if(!g)return{success:!0};const I=P.win;if(!I)return{success:!0};const v=I.webContents.debugger;let d=v.isAttached()?1/0:0;const h=(0,y.createServer)(p=>{d++==0&&v.attach();let w=!1;const C=c=>{w||p.write(JSON.stringify(c)+"\0")},m=(c,s,l,i)=>C({method:s,params:l,sessionId:i});I.on("close",()=>{v.removeListener("message",m),p.end(),w=!0}),v.addListener("message",m);let u=Buffer.alloc(0);p.on("data",c=>{u=Buffer.concat([u,c]);for(let s=u.indexOf(0);s!==-1;s=u.indexOf(0)){let l;try{const i=u.slice(0,s).toString("utf8");u=u.slice(s+1),l=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}v.sendCommand(l.method,l.params,l.sessionId).then(i=>C({id:l.id,sessionId:l.sessionId,result:i})).catch(i=>C({id:l.id,sessionId:l.sessionId,error:{code:0,message:i.message}}))}}),p.on("error",c=>{console.error("error on cdp pipe:",c)}),p.on("close",()=>{w=!0,--d==0&&v.detach()})});return await new Promise(p=>h.listen(0,p)),I.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(x[51],ee([0,1,243,141,93]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function M(I,v){const d={onUnknownOption:p=>{console.warn((0,t.localize)(0,null,p))},onMultipleValues:(p,w)=>{console.warn((0,t.localize)(1,null,p,w))},onDeprecatedOption:(p,w)=>{console.warn((0,t.localize)(2,null,p,w))}},h=(0,L.parseArgs)(I,L.OPTIONS,v?d:void 0);return h.goto&&h._.forEach(p=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,t.localize)(3,null))),h["max-memory"]&&y(parseInt(h["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),h}function E(I){const v=I.findIndex(d=>!/^-/.test(d));if(v>-1)return[...I.slice(0,v),...I.slice(v+1)]}function g(I){let[,...v]=I;process.env.VSCODE_DEV&&(v=E(v)||[]);const d=!P(process.env);return M(v,d)}e.parseMainProcessArgv=g;function b(I){const[,,...v]=I;return M(v,!0)}e.parseCLIProcessArgv=b;function k(I,...v){const d=I.indexOf("--");return d===-1?I.push(...v):I.splice(d,0,...v),I}e.addArg=k;function P(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function V(e,y,t,L){function D(E){const g=M(E),b=[g];return e.isAbsolute(g)||b.unshift(L),e.resolve(...b)}function M(E){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,t);const k=E["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(P,"AppData","Roaming")}break;case"darwin":b=e.join(y.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,t)}return{getUserDataPath:D}}if(typeof define=="function")define(x[166],ee([0,244,27,10,16,36]),function(e,y,t,L,D,M){const E=D.dirname(L.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(D.joinPath(E,"package.json").fsPath);return V(y,t,g.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),t=require("os");module.exports=V(y,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(x[167],ee([0,1,27,164,166]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends t.AbstractNativeEnvironmentService{constructor(E,g){super(E,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,L.getUserDataPath)(E)},g)}}e.NativeEnvironmentService=D}),define(x[168],ee([0,1,30,27,29]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(M){const E=(0,L.randomPath)((0,t.tmpdir)());try{return(0,y.writeFileSync)(E,""),M&&console.log(`Marker file for --wait created: ${E}`),E}catch(g){M&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFile=D}),define(x[169],ee([0,1,18,31]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(D,M,E){let g=E&&E.get("storage.serviceMachineId",0)||null;if(g)return g;try{const k=(await M.readFile(D.serviceMachineIdResource)).value.toString();g=(0,t.isUUID)(k)?k:null}catch{g=null}if(!g){g=(0,t.generateUuid)();try{await M.writeFile(D.serviceMachineIdResource,y.VSBuffer.fromString(g))}catch{}}return E&&E.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=L}),define(x[76],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(L,D=[],M=!1){this.ctor=L,this.staticArguments=D,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=y}),define(x[170],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=y;class t{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let M of this._nodes.values())M.outgoing.size===0&&D.push(M);return D}insertEdge(D,M){const E=this.lookupOrInsertNode(D),g=this.lookupOrInsertNode(M);E.outgoing.set(this._hashFn(M),g),g.incoming.set(this._hashFn(D),E)}removeNode(D){const M=this._hashFn(D);this._nodes.delete(M);for(let E of this._nodes.values())E.outgoing.delete(M),E.incoming.delete(M)}lookupOrInsertNode(D){const M=this._hashFn(D);let E=this._nodes.get(M);return E||(E=new y(D),this._nodes.set(M,E)),E}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[M,E]of this._nodes)D.push(`${M}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,M]of this._nodes){const E=new Set([D]),g=this._findCycle(M,E);if(g)return g}}_findCycle(D,M){for(let[E,g]of D.outgoing){if(M.has(E))return[...M,E].join(" -> ");M.add(E);const b=this._findCycle(g,M);if(b)return b;M.delete(E)}}}e.Graph=t}),define(x[5],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(y=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(M,E,g){E[y.DI_TARGET]===E?E[y.DI_DEPENDENCIES].push({id:M,index:g}):(E[y.DI_DEPENDENCIES]=[{id:M,index:g}],E[y.DI_TARGET]=E)}function L(M){if(y.serviceIds.has(M))return y.serviceIds.get(M);const E=function(g,b,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,g,k)};return E.toString=()=>M,y.serviceIds.set(M,E),E}e.createDecorator=L;function D(M){return M}e.refineServiceDecorator=D}),define(x[52],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,y.createDecorator)("backupMainService")}),define(x[17],ee([0,1,12,7,5]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function D(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=D;function M(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||y.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var E;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=g;function b(w,C){const m=Object.create(null);for(let u in w)k(m,u,w[u],C);return m}e.toValuesTree=b;function k(w,C,m,u){const c=C.split("."),s=c.pop();let l=w;for(let i=0;i<c.length;i++){let n=c[i],o=l[n];switch(typeof o){case"undefined":o=l[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${C} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}l=o}if(typeof l=="object"&&l!==null)try{l[s]=m}catch{u(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(l)}`)}else u(`Ignoring ${C} as ${c.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=k;function P(w,C){const m=C.split(".");I(w,m)}e.removeFromValueTree=P;function I(w,C){const m=C.shift();if(C.length===0){delete w[m];return}if(Object.keys(w).indexOf(m)!==-1){const u=w[m];typeof u=="object"&&!Array.isArray(u)&&(I(u,C),Object.keys(u).length===0&&delete w[m])}}function v(w,C,m){function u(l,i){let n=l;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=C.split("."),s=u(w,c);return typeof s=="undefined"?m:s}e.getConfigurationValue=v;function d(w,C,m){Object.keys(C).forEach(u=>{u!=="__proto__"&&(u in w?y.isObject(w[u])&&y.isObject(C[u])?d(w[u],C[u],m):m&&(w[u]=C[u]):w[u]=C[u])})}e.merge=d;function h(w,C,m){const u=w.inspect(C),c=w.inspect(m);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=h;function p(w){return w.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(x[62],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(D,M){return this.secretVault[D]?.[M]??null}async setPassword(D,M,E){this.secretVault[D]=this.secretVault[D]??{},this.secretVault[D][M]=E}async deletePassword(D,M){return this.secretVault[D]?.[M]?(delete this.secretVault[D][M],Object.keys(this.secretVault[D]).length===0&&delete this.secretVault[D],!0):!1}async findPassword(D){return JSON.stringify(this.secretVault[D])??null}async findCredentials(D){const M=[];for(const E of Object.keys(this.secretVault[D]||{}))M.push({account:E,password:this.secretVault[D][E]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(x[77],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function t(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=t;class L{async getPerformanceInfo(M,E){return{}}async getSystemInfo(M,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,E){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=L}),define(x[94],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(x[53],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(x[171],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,y.createDecorator)("extensionUrlTrustService")}),define(x[172],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,y.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(x[95],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,y.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,y.createDecorator)("externalTerminal")}),define(x[173],ee([0,1,45,10,8,3,70,20,75,142,95]),function(V,e,y,t,L,D,M,E,g,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=b.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends I{openTerminal(u,c){return this.spawnTerminal(y,u,g.getWindowsShell(),c)}spawnTerminal(u,c,s,l){const i=c.windowsExec||v.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=L.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((r,a)=>{const f=p(process),S=u.spawn(s,o,{cwd:l,env:f});S.on("error",a),S.on("exit",()=>r())})}runInTerminal(u,c,s,l,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:v.getDefaultTerminalWindows();return new Promise((o,r)=>{const a=`"${c} - ${P}"`,f=`""${s.join('" "')}" & pause"`,S=["/c","start",a,"/wait",n,"/c",f],R=Object.assign({},p(process),l);Object.keys(R).filter($=>R[$]===null).forEach($=>delete R[$]);const A={cwd:c,env:R,windowsVerbatimArguments:!0};y.spawn(v.CMD,S,A).on("error",$=>{r(w($))}),o(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class d extends I{openTerminal(u,c){return this.spawnTerminal(y,u,c)}runInTerminal(u,c,s,l,i){const n=i.osxExec||k.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{if(n===k.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const a=n===k.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,V).fsPath,"-t",u||P,"-w",c];for(let F of s)S.push("-a"),S.push(F);if(l){const F=Object.assign({},p(process),l);for(let $ in F){const J=F[$];J===null?(S.push("-u"),S.push($)):(S.push("-e"),S.push(`${$}=${J}`))}}let R="";const A=y.spawn(d.OSASCRIPT,S);A.on("error",F=>{r(w(F))}),A.stderr.on("data",F=>{R+=F.toString()}),A.on("exit",F=>{if(F===0)o(void 0);else if(R){const $=R.split(`
`,1);r(new Error($[0]))}else r(new Error(b.localize(1,null,a,F)))})}else r(new Error(b.localize(2,null,n)))})}spawnTerminal(u,c,s){const l=c.osxExec||k.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",l];s&&o.push(s);const r=p(process),a=u.spawn("/usr/bin/open",o,{cwd:s,env:r});a.on("error",n),a.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class h extends I{openTerminal(u,c){return this.spawnTerminal(y,u,c)}runInTerminal(u,c,s,l,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{let a=[];n.then(f=>{f.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const S=`${C(s)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;a.push(`''${S}''`);const R=Object.assign({},p(process),l);Object.keys(R).filter(J=>R[J]===null).forEach(J=>delete R[J]);const A={cwd:c,env:R};let F="";const $=y.spawn(f,a,A);$.on("error",J=>{r(w(J))}),$.stderr.on("data",J=>{F+=J.toString()}),$.on("exit",J=>{if(J===0)o(void 0);else if(F){const ne=F.split(`
`,1);r(new Error(ne[0]))}else r(new Error(b.localize(4,null,f,J)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await E.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,s){const l=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{l.then(o=>{const r=p(process),a=u.spawn(o,[],{cwd:s,env:r});a.on("error",n),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=b.localize(3,null);function p(m){const u={...m.env};return(0,M.sanitizeProcessEnvironment)(u),u}function w(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(b.localize(5,null,m.path)):m}function C(m){let u="";for(let c of m)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(x[21],ee([0,1,15,35,8,28,12,7,144,5]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function k(j){return j.create===!0}e.isFileOpenForWriteOptions=k;var P;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var I;(function(j){j[j.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var v;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=d;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=p;function w(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function C(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=C;function m(j){return d(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(B,z){super(B);this.code=z}}e.FileSystemProviderError=c;function s(j,B){const z=new c(j.toString(),B);return i(z,B),z}e.createFileSystemProviderError=s;function l(j){return j||s((0,g.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=l;function i(j,B){return j.name=B?`${B} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=i;function n(j){if(!j)return u.Unknown;if(j instanceof c)return j.code;const B=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!B)return u.Unknown;switch(B[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function o(j){if(j instanceof A)return j.fileOperationResult;switch(n(j)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var r;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(B,z,K){this.resource=B,this.operation=z,this.target=K}isOperation(B){return this.operation===B}}e.FileOperationEvent=a;var f;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class S{constructor(B,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const K=new Map;for(const te of B){const Q=K.get(te.type);switch(Q?Q.push([te.resource,te]):K.set(te.type,[[te.resource,te]]),te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}}for(const[te,Q]of K)switch(te){case 1:this.added=t.TernarySearchTree.forUris(()=>z),this.added.fill(Q);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>z),this.updated.fill(Q);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>z),this.deleted.fill(Q);break}}contains(B,...z){return this.doContains(B,{includeChildren:!1},...z)}affects(B,...z){return this.doContains(B,{includeChildren:!0},...z)}doContains(B,z,...K){if(!B)return!1;const te=K.length>0;return!!((!te||K.includes(1))&&(this.added?.get(B)||z.includeChildren&&this.added?.findSuperstr(B))||(!te||K.includes(0))&&(this.updated?.get(B)||z.includeChildren&&this.updated?.findSuperstr(B))||(!te||K.includes(2))&&(this.deleted?.findSubstr(B)||z.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=S;function R(j,B,z){return!j||!B||j===B||B.length>j.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),z?(0,D.startsWithIgnoreCase)(j,B):j.indexOf(B)===0)}e.isParent=R;class A extends y.ErrorNoTelemetry{constructor(B,z,K){super(B);this.fileOperationResult=z,this.options=K}}e.FileOperationError=A;class F extends A{constructor(B,z,K){super(B,2,K);this.stat=z}}e.NotModifiedSinceFileOperationError=F;var $;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ne(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=ne;async function Y(j,B){if(!B.hasProvider(E.URI.from({scheme:j.scheme})))return new Promise(z=>{const K=B.onDidChangeFileSystemProviderRegistrations(te=>{te.scheme===j.scheme&&te.added&&(K.dispose(),z())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(B){return(0,M.isNumber)(B)||(B=0),B<re.KB?(0,g.localize)(1,null,B.toFixed(0)):B<re.MB?(0,g.localize)(2,null,(B/re.KB).toFixed(2)):B<re.GB?(0,g.localize)(3,null,(B/re.MB).toFixed(2)):B<re.TB?(0,g.localize)(4,null,(B/re.GB).toFixed(2)):(0,g.localize)(5,null,(B/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var H;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function X(j){return{maxFileSize:j===0?300*re.MB:16*re.GB,maxHeapSize:j===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=X}),define(x[174],ee([0,1,18,39,15,4,2,49,7,31,21]),function(V,e,y,t,L,D,M,E,g,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends M.Disposable{constructor(v,d){super();this.channel=v,this.extraCapabilities=d,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,d){const{buffer:h}=await this.channel.call("readFile",[v,d]);return h}readFileStream(v,d,h){const p=(0,E.newWriteableStream)(C=>y.VSBuffer.concat(C.map(m=>y.VSBuffer.wrap(m))).buffer),w=this.channel.listen("readFileStream",[v,d])(C=>{if(C instanceof y.VSBuffer)p.write(C.buffer);else{if(C==="end")p.end();else{let m=C;m instanceof Error||(m=(0,k.createFileSystemProviderError)((0,t.toErrorMessage)(m),k.FileSystemProviderErrorCode.Unknown)),p.error(m),p.end()}w.dispose()}});return h.onCancellationRequested(()=>{p.error((0,L.canceled)()),p.end(),w.dispose()}),p}writeFile(v,d,h){return this.channel.call("writeFile",[v,y.VSBuffer.wrap(d),h])}open(v,d){return this.channel.call("open",[v,d])}close(v){return this.channel.call("close",[v])}async read(v,d,h,p,w){const[C,m]=await this.channel.call("read",[v,d,w]);return h.set(C.buffer.slice(0,m),p),m}write(v,d,h,p,w){return this.channel.call("write",[v,d,y.VSBuffer.wrap(h),p,w])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,d){return this.channel.call("delete",[v,d])}rename(v,d,h){return this.channel.call("rename",[v,d,h])}copy(v,d,h){return this.channel.call("copy",[v,d,h])}cloneFile(v,d){return this.channel.call("cloneFile",[v,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const d=v;this._onDidChange.fire(d.map(h=>({resource:g.URI.revive(h.resource),type:h.type})))}else{const d=v;this._onDidWatchError.fire(d)}}))}watch(v,d){const h=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,h,v,d]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=P}),define(x[96],ee([0,1,18,15,145,21]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(k,P,I,v,d,h){let p;try{await E(k,P,I,v,d,h)}catch(w){p=w}finally{p&&d.errorTransformer&&(p=d.errorTransformer(p)),typeof p!="undefined"&&I.error(p),I.end()}}e.readFileIntoStream=M;async function E(k,P,I,v,d,h){g(h);const p=await k.open(P,{create:!1});try{g(h);let w=0,C=0,m=d&&typeof d.length=="number"?d.length:void 0,u=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,s=0;do C=await k.read(p,c,u.buffer,s,u.byteLength-s),c+=C,s+=C,w+=C,typeof m=="number"&&(m-=C),s===u.byteLength&&(await I.write(v(u)),u=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),s=0);while(C>0&&(typeof m!="number"||m>0)&&g(h)&&b(w,d));if(s>0){let l=s;typeof m=="number"&&(l=Math.min(s,m)),I.write(v(u.slice(0,l)))}}catch(w){throw(0,D.ensureFileSystemProviderError)(w)}finally{await k.close(p)}}function g(k){if(k.isCancellationRequested)throw(0,t.canceled)();return!0}function b(k,P){if(P?.limits){if(typeof P.limits.memory=="number"&&k>P.limits.memory)throw(0,D.createFileSystemProviderError)((0,L.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&k>P.limits.size)throw(0,D.createFileSystemProviderError)((0,L.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(x[63],ee([0,1,86,2,8,3,7,21]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(p){return p.recursive===!0}e.isRecursiveWatchRequest=g;class b extends t.Disposable{constructor(w,C,m,u){super();this.onFileChanges=w,this.onLogMessage=C,this.verboseLogging=m,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const w=new t.DisposableStore;this.watcherDisposables.value=w,this.watcher=this.createWatcher(w),this.watcher.setVerboseLogging(this.verboseLogging),w.add(this.watcher.onDidChangeFile(C=>this.onFileChanges(C))),w.add(this.watcher.onDidLogMessage(C=>this.onLogMessage(C))),w.add(this.watcher.onDidError(C=>this.onError(C)))}onError(w){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${w}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${w}`):this.error(w)}restart(w){this.restartCounter++,this.init(),this.watch(w)}async watch(w){this.requests=w,await this.watcher?.watch(w)}async setVerboseLogging(w){this.verboseLogging=w,await this.watcher?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${w}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class k extends b{constructor(w,C,m){super(w,C,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=k;class P extends b{constructor(w,C,m){super(w,C,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function I(p){return p.map(w=>({type:w.type,resource:M.URI.file(w.path)}))}e.toFileChanges=I;function v(p){const w=new h;for(const C of p)w.processEvent(C);return w.coalesce()}e.coalesceEvents=v;function d(p,w){const C=[];for(const m of w){let u=m;typeof u=="string"&&!u.startsWith(y.GLOBSTAR)&&!(0,L.isAbsolute)(u)&&(u={base:p,pattern:u}),C.push((0,y.parse)(u))}return C}e.parseWatcherPatterns=d;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(w){return D.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const C=this.mapPathToChange.get(this.toKey(w));let m=!1;if(C){const u=C.type,c=w.type;C.path!==w.path&&(w.type===2||w.type===1)?m=!0:u===1&&c===2?(this.mapPathToChange.delete(this.toKey(w)),this.coalesced.delete(C)):u===2&&c===1?C.type=0:u===1&&c===0||(C.type=c)}else m=!0;m&&(this.coalesced.add(w),this.mapPathToChange.set(this.toKey(w),w))}coalesce(){const w=[],C=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(w.push(m),!1):!0).sort((m,u)=>m.path.length-u.path.length).filter(m=>C.some(u=>(0,E.isParent)(m.path,u,!D.isLinux))?!1:(C.push(m.path),!0)).concat(w)}}}),define(x[175],ee([0,1,30,9,23,29,2,73,8,3,87,20,63]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends M.Disposable{constructor(p,w,C,m){super();this.request=p,this.onDidFilesChange=w,this.onLogMessage=C,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,I.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,I.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const p=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await P.Promises.stat(p);this._register(await this.doWatch(p,w.isDirectory()))}catch(p){p.code!=="ENOENT"?this.error(p):this.trace(p)}}async normalizePath(p){let w=p.path;try{w=await P.Promises.realpath(p.path),p.path===w&&(w=await(0,k.realcase)(p.path)??p.path),p.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${w})`)}catch{}return w}async doWatch(p,w){if(b.isMacintosh&&(0,D.isEqualOrParent)(p,"/Volumes/",!0))return this.error(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const C=new L.CancellationTokenSource(this.cts.token);let m=new M.DisposableStore;try{const u=(0,g.basename)(p),c=(0,y.watch)(p);m.add((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${p}'`);const s=new Set;if(w)try{for(const i of await P.Promises.readdir(p))s.add(i)}catch(i){this.error(i)}const l=new Map;m.add((0,M.toDisposable)(()=>{for(const[,i]of l)i.dispose();l.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${p} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(C.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),b.isMacintosh&&(o=(0,E.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(w)if(i==="rename"){l.get(o)?.dispose();const r=setTimeout(async()=>{if(l.delete(o),o===u&&!await P.Promises.exists(p)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,g.join)(p,o));if(C.token.isCancellationRequested)return;let f;a?s.has(o)?f=0:(f=1,s.add(o)):(s.delete(o),f=2),this.onFileChange({path:(0,g.join)(this.request.path,o),type:f})},v.FILE_DELETE_HANDLER_DELAY);l.set(o,(0,M.toDisposable)(()=>clearTimeout(r)))}else{let r;s.has(o)?r=0:(r=1,s.add(o)),this.onFileChange({path:(0,g.join)(this.request.path,o),type:r})}else if(i==="rename"||o!==u){const r=setTimeout(async()=>{const a=await P.Promises.exists(p);C.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(p,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,M.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await P.Promises.exists(p)&&!C.token.isCancellationRequested&&this.error(`Failed to watch ${p} for changes using fs.watch() (${u.toString()})`)}return(0,M.toDisposable)(()=>{C.dispose(!0),m.dispose()})}async onFileChange(p,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!w&&this.excludes.some(C=>C(p.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${p.path}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(C=>C(p.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${p.path}`):this.fileChangesBuffer.push(p);try{await this.fileChangesDelayer.trigger(async()=>{const C=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,I.coalesceEvents)(C);if(m.length>0){if(this.verboseLogging)for(const c of m)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(p){if(b.isLinux)return P.Promises.exists(p);try{const w=(0,g.basename)(p);return(await P.Promises.readdir((0,g.dirname)(p))).some(m=>m===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(p){this.verboseLogging=p}error(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}warn(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}trace(p){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function d(h,p,w,C,m=512){const u=await P.Promises.open(h,"r"),c=Buffer.allocUnsafe(m),s=new L.CancellationTokenSource(C);let l,i=!1;const n={path:h,excludes:[],recursive:!1},o=new v(n,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(i)return;i=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:f}=await P.Promises.read(u,c,0,m,null);if(!f||s.token.isCancellationRequested)break;p(c.slice(0,f))}}catch(f){l=new Error(f),s.dispose(!0)}finally{i=!1}}})()});return await o.ready,w(),new Promise((r,a)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await P.Promises.close(u)}catch(f){l=new Error(f)}l?a(l):r()})})}e.watchFileContents=d}),define(x[176],ee([0,1,4,86,2,3,175]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new y.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=y.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const k=this.normalizeRequests(b),P=k.filter(v=>{const d=this.watchers.get(v.path);return d?!(0,t.patternsEquals)(d.request.excludes,v.excludes)||!(0,t.patternsEquals)(d.request.includes,v.includes):!0}),I=Array.from(this.watchers.values()).filter(({request:v})=>!k.find(d=>d.path===v.path&&(0,t.patternsEquals)(d.excludes,v.excludes)&&(0,t.patternsEquals)(d.includes,v.includes))).map(({request:v})=>v.path);P.length&&this.trace(`Request to start watching: ${P.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?v.includes:"<all>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const v of I)this.stopWatching(v);for(const v of P)this.startWatching(v)}startWatching(b){const k=new M.NodeJSFileWatcherLibrary(b,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),P={request:b,instance:k};this.watchers.set(b.path,P)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const k=this.watchers.get(b);k&&(this.watchers.delete(b),k.instance.dispose())}normalizeRequests(b){const k=new Map;for(const P of b){const I=D.isLinux?P.path:P.path.toLowerCase();k.set(I,P)}return Array.from(k.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,k]of this.watchers)k.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,k){return k?`[File Watcher (node.js)] ${b} (path: ${k.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=E}),define(x[177],ee([0,1,63,176]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends y.AbstractNonRecursiveWatcherClient{constructor(M,E,g){super(M,E,g);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(x[178],ee([0,1,10,38,136,63]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends D.AbstractUniversalWatcherClient{constructor(g,b,k){super(g,b,k);this.init()}createWatcher(g){const b=g.add(new L.Client(y.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(b.onDidProcessExit(({code:k,signal:P})=>this.onError(`terminated by itself with code ${k}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(x[78],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...L){this._entries=new Map;for(let[D,M]of L)this.set(D,M)}set(L,D){const M=this._entries.get(L);return this._entries.set(L,D),M}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=y}),define(x[179],ee([0,1,9,15,76,170,5,78]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class b extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class k{constructor(d=new E.ServiceCollection,h=!1,p){this._activeInstantiations=new Set,this._services=d,this._strict=h,this._parent=p,this._services.set(M.IInstantiationService,this)}createChild(d){return new k(d,this._strict,this)}invokeFunction(d,...h){let p=I.traceInvocation(d),w=!1;try{return d({get:m=>{if(w)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(m,p);if(!u)throw new Error(`[invokeFunction] unknown service '${m}'`);return u}},...h)}finally{w=!0,p.stop()}}createInstance(d,...h){let p,w;return d instanceof L.SyncDescriptor?(p=I.traceCreation(d.ctor),w=this._createInstance(d.ctor,d.staticArguments.concat(h),p)):(p=I.traceCreation(d),w=this._createInstance(d,h,p)),p.stop(),w}_createInstance(d,h=[],p){let w=M._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),C=[];for(const u of w){let c=this._getOrCreateServiceInstance(u.id,p);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),C.push(c)}let m=w.length>0?w[0].index:h.length;if(h.length!==m){console.trace(`[createInstance] First service dependency of ${d.name} at position ${m+1} conflicts with ${h.length} static arguments`);let u=m-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,m)}return new d(...[...h,...C])}_setServiceInstance(d,h){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){let p=this._getServiceInstanceOrDescriptor(d);return p instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,p,h.branch(d,!0)):(h.branch(d,!1),p)}_safeCreateAndCacheServiceInstance(d,h,p){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,p)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,p){const w=new D.Graph(u=>u.id.toString());let C=0;const m=[{id:d,desc:h,_trace:p}];for(;m.length;){const u=m.pop();if(w.lookupOrInsertNode(u),C++>1e3)throw new b(w);for(let c of M._util.getServiceDependencies(u.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(c.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),s instanceof L.SyncDescriptor){const l={id:c.id,desc:s,_trace:u._trace.branch(c.id,!0)};w.insertEdge(u,l),m.push(l)}}}for(;;){const u=w.roots();if(u.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,p=[],w,C){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(h,p,w,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,p,w,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h=[],p,w){if(p){const C=new y.IdleValue(()=>this._createInstance(d,h,w));return new Proxy(Object.create(null),{get(m,u){if(u in m)return m[u];let c=C.value,s=c[u];return typeof s!="function"||(s=s.bind(c),m[u]=s),s},set(m,u,c){return C.value[u]=c,!0}})}else return this._createInstance(d,h,w)}_throwIfStrict(d,h){if(h&&console.warn(h),this._strict)throw new Error(d)}}e.InstantiationService=k;var P;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(P||(P={}));class I{constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return g?new I(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(d){return g?new I(0,d.name):I._None}branch(d,h){let p=new I(2,d.toString());return this._dep.push([d,h,p]),p}stop(){let d=Date.now()-this._start;I._totals+=d;let h=!1;function p(C,m){let u=[],c=new Array(C+1).join("	");for(const[s,l,i]of m._dep)if(l&&i){h=!0,u.push(`${c}CREATES -> ${s}`);let n=p(C+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${s}`);return u.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(d>2||h)&&console.log(w.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(x[6],ee([0,1,39,4,2,3,5]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function E(){return new Date().toISOString()}var g;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function b(l,i,n){switch(i){case g.Trace:l.trace(n);break;case g.Debug:l.debug(n);break;case g.Info:l.info(n);break;case g.Warning:l.warn(n);break;case g.Error:l.error(n);break;case g.Critical:l.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function k(l){let i="";for(let n=0;n<l.length;n++){let o=l[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=k;class P extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class I extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(g.Trace)&&this.log(g.Trace,k([i,...n]))}debug(i,...n){this.checkLogLevel(g.Debug)&&this.log(g.Debug,k([i,...n]))}info(i,...n){this.checkLogLevel(g.Info)&&this.log(g.Info,k([i,...n]))}warn(i,...n){this.checkLogLevel(g.Warning)&&this.log(g.Warning,k([i,...n]))}error(i,...n){if(this.checkLogLevel(g.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(g.Error,k(o))}else this.log(g.Error,k([i,...n]))}critical(i,...n){this.checkLogLevel(g.Critical)&&this.log(g.Critical,k([i,...n]))}flush(){}}e.AbstractMessageLogger=I;class v extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...n){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...n):console.log(`[main ${E()}]`,i,...n))}debug(i,...n){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...n):console.log(`[main ${E()}]`,i,...n))}info(i,...n){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...n):console.log(`[main ${E()}]`,i,...n))}warn(i,...n){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,i,...n):console.warn(`[main ${E()}]`,i,...n))}error(i,...n){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,i,...n):console.error(`[main ${E()}]`,i,...n))}critical(i,...n){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,i,...n):console.error(`[main ${E()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class d extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends P{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,y.toErrorMessage)(i,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class p extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=p;class w extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=w;class C extends L.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?g.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return g.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=m;function u(l){if(l.verbose)return g.Trace;if(typeof l.logLevel=="string"){const i=c(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(l){switch(l){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=c;function s(l){switch(l){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=s});var ie=this&&this.__param||function(V,e){return function(y,t){e(y,t,V)}};define(x[180],ee([0,1,62,4,2,6,3]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class wt extends L.Disposable{constructor(b){super();this.logService=b,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(b,k){let P;try{P=await this.withKeytar()}catch{return null}const I=await P.getPassword(b,k);if(I)try{let{content:v,hasNextChunk:d}=JSON.parse(I);if(!v||!d)return I;let h=1;for(;d;){const p=await P.getPassword(b,`${k}-${h}`),w=JSON.parse(p);v+=w.content,d=w.hasNextChunk,h++}return v}catch{return I}return I}async setPassword(b,k,P){let I;try{I=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const v=3,d=async(h,p,w)=>{let C=0,m;for(;C<v;)try{await I.setPassword(h,p,w);return}catch(u){m=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),C++,await new Promise(c=>setTimeout(c,200))}throw m};if(M.isWindows&&P.length>wt.MAX_PASSWORD_LENGTH){let h=0,p=0,w=!0;for(;w;){const C=P.substring(h,h+wt.PASSWORD_CHUNK_SIZE);h+=wt.PASSWORD_CHUNK_SIZE,w=P.length-h>0;const m={content:C,hasNextChunk:w};await d(b,p?`${k}-${p}`:k,JSON.stringify(m)),p++}}else await d(b,k,P);this._onDidChangePassword.fire({service:b,account:k})}async deletePassword(b,k){let P;try{P=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const I=await P.getPassword(b,k);if(!I)return!1;const v=await P.deletePassword(b,k);let{content:d,hasNextChunk:h}=JSON.parse(I);if(d&&h){let p=1;for(;h;){const w=`${k}-${p}`,C=await P.getPassword(b,w);await P.deletePassword(b,w),h=JSON.parse(C).hasNextChunk,p++}}return v&&this._onDidChangePassword.fire({service:b,account:k}),v}async findPassword(b){let k;try{k=await this.withKeytar()}catch{return null}return k.findPassword(b)}async findCredentials(b){let k;try{k=await this.withKeytar()}catch{return[]}return k.findCredentials(b)}clear(){return this._keytarCache instanceof y.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=de([ie(0,D.ILogService)],E),e.BaseCredentialsMainService=E}),define(x[181],ee([0,1,26,9,15,4,2,8,63,6]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class k extends M.Disposable{constructor(I,v){super();this.logService=I,this.options=v,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(I,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,v):this.watchNonRecursive(I,v)}watchUniversal(I,v){const d={path:this.toFilePath(I),excludes:v.excludes,includes:v.includes,recursive:v.recursive},h=(0,y.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,L.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,g.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const v of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const v of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(v)&&I.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,v){const d={path:this.toFilePath(I),excludes:v.excludes,includes:v.includes,recursive:!1},h=(0,y.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,L.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,g.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,E.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=k}),define(x[182],ee([0,1,26,9,18,23,4,72,69,2,35,10,64,16,49,143,21,96,6]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends b.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const l=new b.DisposableStore;return this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s}),l.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new p.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&l.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,b.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){s.push(l)}}),!this.provider.has(c)&&await t.Promises.settled(s)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,s){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&s)}listCapabilities(){return g.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,v.isAbsolutePath)(c))throw new p.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const l=new Error;throw l.name="ENOPRO",l.message=(0,h.localize)(1,null,c.toString()),l}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s)||(0,p.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(l){throw(0,p.toFileSystemProviderErrorCode)(l)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(l)}}async doResolveFile(c,s){const l=await this.withProvider(c),i=this.isPathCaseSensitive(l),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,r=s?.resolveMetadata,a=await l.stat(c);let f;return this.toFileStat(l,c,a,void 0,!!r,(S,R)=>(f||(f=k.TernarySearchTree.forUris(()=>!i),f.set(c,!0),n&&f.fill(!0,n)),f.get(S.resource)||f.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?R===1:!1))}async toFileStat(c,s,l,i,n,o){const{providerExtUri:r}=this.getExtUri(c),a={resource:s,name:r.basename(s),isFile:(l.type&p.FileType.File)!=0,isDirectory:(l.type&p.FileType.Directory)!=0,isSymbolicLink:(l.type&p.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const f=await c.readdir(s),S=await t.Promises.settled(f.map(async([R,A])=>{try{const F=r.joinPath(s,R),$=n?await c.stat(F):{type:A};return await this.toFileStat(c,F,$,f.length,n,o)}catch(F){return this.logService.trace(F),null}}));a.children=(0,y.coalesce)(S)}catch(f){this.logService.trace(f),a.children=[]}return a}return a}async resolveAll(c){return t.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(c){const s=await this.withProvider(c),l=await s.stat(c);return this.toFileStat(s,c,l,void 0,!0,()=>!1)}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch{return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(l){return l}return!0}async doValidateCreateFile(c,s){if(!s?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=L.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const i=await this.writeFile(c,s);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,i)),i}async writeFile(c,s,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,l)||await this.mkdirp(i,n.dirname(c));let r;if((0,p.hasReadWriteCapability)(i)&&!(s instanceof L.VSBuffer))if((0,d.isReadableStream)(s)){const a=await(0,d.peekStream)(s,3);a.ended?r=L.VSBuffer.concat(a.buffer):r=a}else r=(0,d.peekReadable)(s,a=>L.VSBuffer.concat(a),3);else r=s;!(0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)&&r instanceof L.VSBuffer?await this.doWriteUnbuffered(i,c,l,r):await this.doWriteBuffered(i,c,l,r instanceof L.VSBuffer?(0,L.bufferToReadable)(r):r),this._onDidRunOperation.fire(new p.FileOperationEvent(c,4))}catch(o){throw new p.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(o).toString()),(0,p.toFileOperationResult)(o),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(s)));let n;try{n=await c.stat(s)}catch{return}if((n.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,h.localize)(6,null,this.resourceForError(s)),0,l);if(this.throwIfFileIsReadonly(s,n),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==p.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&l.mtime<n.mtime&&l.etag!==(0,p.etag)({mtime:l.mtime,size:n.size}))throw new p.FileOperationError((0,h.localize)(7,null),3,l);return n}async readFile(c,s,l){const i=await this.withReadProvider(c);return s?.atomic?this.doReadFileAtomic(i,c,s,l):this.doReadFile(i,c,s,l)}async doReadFileAtomic(c,s,l,i){return new Promise((n,o)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,s,l,i);n(r)}catch(r){o(r)}})})}async doReadFile(c,s,l,i){const n=await this.doReadFileStream(c,s,{...l,preferUnbuffered:!0},i);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(c,s,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,s,l)}async doReadFileStream(c,s,l,i){const n=new D.CancellationTokenSource(i),o=this.validateReadFile(s,l).then(a=>a,a=>{throw n.cancel(),a});let r;try{return typeof l?.etag=="string"&&l.etag!==p.ETAG_DISABLED&&await o,l?.atomic&&(0,p.hasFileAtomicReadCapability)(c)||!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&l?.preferUnbuffered?r=this.readFileUnbuffered(c,s,l):(0,p.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,s,n.token,l):r=this.readFileBuffered(c,s,n.token,l),{...await o,value:r}}catch(a){r&&await(0,d.consumeStream)(r);const f=(0,h.localize)(8,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(a).toString());throw a instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(f,a.stat,l):new p.FileOperationError(f,(0,p.toFileOperationResult)(a),l)}}readFileStreamed(c,s,l,i=Object.create(null)){const n=c.readFileStream(s,i,l);return(0,d.transform)(n,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new p.FileOperationError((0,h.localize)(9,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(o).toString()),(0,p.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(c,s,l,i=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,w.readFileIntoStream)(c,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new p.FileOperationError((0,h.localize)(10,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(o).toString()),(0,p.toFileOperationResult)(o),i)},l),n}readFileUnbuffered(c,s,l){const i=(0,d.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;l?.atomic&&(0,p.hasFileAtomicReadCapability)(c)?n=await c.readFile(s,{atomic:!0}):n=await c.readFile(s),typeof l?.position=="number"&&(n=n.slice(l.position)),typeof l?.length=="number"&&(n=n.slice(0,l.length)),this.validateReadFileLimits(s,n.byteLength,l),i.end(L.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,s){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new p.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.ETAG_DISABLED&&s.etag===l.etag)throw new p.NotModifiedSinceFileOperationError((0,h.localize)(12,null),l,s);return this.validateReadFileLimits(c,l.size,s),l}validateReadFileLimits(c,s,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&s>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&s>l.limits.size&&(i=7),typeof i=="number")throw new p.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,s,l){return this.doCanMoveCopy(c,s,"move",l)}async canCopy(c,s,l){return this.doCanMoveCopy(c,s,"copy",l)}async doCanMoveCopy(c,s,l,i){if(c.toString()!==s.toString())try{const n=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,c,o,s,l,i)}catch(n){return n}return!0}async move(c,s,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"move",!!l),r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,o==="move"?2:3,r)),r}async copy(c,s,l){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"copy",!!l),r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,o==="copy"?3:2,r)),r}async doMoveCopy(c,s,l,i,n,o){if(s.toString()===i.toString())return n;const{exists:r,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,s,l,i,n,o);if(r&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),n==="copy"){if(c===l&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(s,i,{overwrite:o});else{const f=await this.resolve(s);f.isDirectory?await this.doCopyFolder(c,f,l,i):await this.doCopyFile(c,s,l,i)}return n}else return c===l?(await c.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(c,s,l,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,l,i){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,s,l,i);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,s,l,i);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,s,l,i);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,s,l,i)}async doCopyFolder(c,s,l,i){await l.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(l).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),l,o):this.doCopyFile(c,n.resource,l,o)}))}async doValidateMoveCopy(c,s,l,i,n,o){let r=!1;if(c===l){const{providerExtUri:f,isPathCaseSensitive:S}=this.getExtUri(c);if(S||(r=f.isEqual(s,i)),r&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!r&&f.isEqualOrParent(i,s))throw new Error((0,h.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!r){if(!o)throw new p.FileOperationError((0,h.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(c===l){const{providerExtUri:f}=this.getExtUri(c);if(f.isEqualOrParent(s,i))throw new Error((0,h.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:r}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,l)),l}async mkdirp(c,s){const l=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(s,i.dirname(s));)try{if(((await c.stat(s)).type&p.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileNotFound)throw n;l.push(i.basename(s)),s=i.dirname(s)}for(let n=l.length-1;n>=0;n--){s=i.joinPath(s,l[n]);try{await c.mkdir(s)}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(l){return l}return!0}async doValidateDelete(c,s){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!s?.useTrash&&!(l.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await l.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new p.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!s?.recursive){const r=await this.resolve(c);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return l}async del(c,s){const l=await this.doValidateDelete(c,s),i=!!s?.useTrash,n=!!s?.recursive;await l.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}async cloneFile(c,s){const l=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(l===i&&this.getExtUri(l).providerExtUri.isEqual(c,s))return;if(l===i&&(0,p.hasFileCloneCapability)(l))return l.cloneFile(c,s);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s));const n=this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri);return l===i&&(0,p.hasFileFolderCopyCapability)(l)?n.queue(()=>l.copy(c,s,{overwrite:!0})):n.queue(()=>this.doCopyFile(l,c,i,s))}watch(c,s={recursive:!1,excludes:[]}){const l=new b.DisposableStore;let i=!1,n=()=>{i=!0};return l.add((0,b.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,s);i?(0,b.dispose)(o):n=()=>(0,b.dispose)(o)}catch(o){this.logService.error(o)}})(),l}async doWatch(c,s){const l=await this.withProvider(c),i=(0,E.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:l.watch(c,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,b.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,s,l,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(s,{create:!0,unlock:l?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,s,l){let i=0,n;if((0,d.isReadableBufferedStream)(l)){if(l.buffer.length>0){const o=L.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,i,0),i+=o.byteLength}if(l.ended)return;n=l.stream}else n=l;return new Promise((o,r)=>{(0,d.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(c,s,a,a.byteLength,i,0)}catch(f){return r(f)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>r(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,l){let i=0,n;for(;(n=l.read())!==null;)await this.doWriteBuffer(c,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,s,l,i,n,o){let r=0;for(;r<i;)r+=await c.write(s,n+r,l.buffer,o+r,i-r)}async doWriteUnbuffered(c,s,l,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,l,i))}async doWriteUnbufferedQueued(c,s,l,i){let n;i instanceof L.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,L.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,L.bufferedStreamToBuffer)(i):n=(0,L.readableToBuffer)(i),await c.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,s,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,l,i))}async doPipeBufferedQueued(c,s,l,i){let n,o;try{n=await c.open(s,{create:!1}),o=await l.open(i,{create:!0,unlock:!1});const r=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,f=0,S=0;do S=await c.read(n,a,r.buffer,f,r.byteLength-f),await this.doWriteBuffer(l,o,r,S,a,f),a+=S,f+=S,f===r.byteLength&&(f=0);while(S>0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?l.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,l,i))}async doPipeUnbufferedQueued(c,s,l,i){return l.writeFile(i,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,l,i))}async doPipeUnbufferedToBufferedQueued(c,s,l,i){const n=await l.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(l,n,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,p.ensureFileSystemProviderError)(o)}finally{await l.close(n)}}async doPipeBufferedToUnbuffered(c,s,l,i){const n=await(0,L.streamToBuffer)(this.readFileBuffered(c,s,D.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,n)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new p.FileOperationError((0,h.localize)(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};m=de([ie(0,C.ILogService)],m),e.FileService=m}),define(x[79],ee([0,1,30,245,9,35,18,4,29,2,8,3,16,49,20,147,21,96,181,39,178,177]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(y)}catch(l){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(l)}`)}})();class s extends C.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new D.ResourceMap(o=>I.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(i,r.name))).type:a=this.toType(r),o.push([r.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=p.FileType.Unknown:i.isFile()?o=p.FileType.File:i.isDirectory()?o=p.FileType.Directory:o=p.FileType.Unknown,n&&(o|=p.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const r=new L.Barrier;return this.resourceLocks.set(i,r),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const r=this.toFilePath(i);return await d.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{o?.dispose()}}readFileStream(i,n,o){const r=(0,v.newWriteableStream)(a=>M.VSBuffer.concat(a.map(f=>M.VSBuffer.wrap(f))).buffer);return(0,w.readFileIntoStream)(this,i,r,a=>a.buffer,{...n,bufferSize:256*1024},o),r}async writeFile(i,n,o){let r;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,p.createFileSystemProviderError)((0,h.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,p.createFileSystemProviderError)((0,h.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof r=="number"&&await this.close(r)}}async open(i,n){const o=this.toFilePath(i);let r;(0,p.isFileOpenForWriteOptions)(n)&&(r=await this.createResourceLock(i));let a;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await d.SymlinkSupport.stat(o);S.mode&128||await d.Promises.chmod(o,S.mode|128)}catch(S){this.logService.trace(S)}let f;if((0,p.isFileOpenForWriteOptions)(n)){if(P.isWindows)try{await d.Promises.truncate(o,0),f="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}f||(f="w")}else f="r";a=await d.Promises.open(o,f)}catch(f){throw r?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(a,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),r){const f=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,r),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),f.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,r,a){const f=this.normalizePos(i,n);let S=null;try{S=(await d.Promises.read(i,o,r,a,f)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(i,f,S)}return S}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const r=this.mapHandleToPos.get(i);typeof r=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,r+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,r,a){return(0,L.retry)(()=>this.doWrite(i,n,o,r,a),100,3)}async doWrite(i,n,o,r,a){const f=this.normalizePos(i,n);let S=null;try{S=(await d.Promises.write(i,o,r,a,f)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),R)}finally{this.updatePos(i,f,S)}return S}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const r=this.toFilePath(i),a=this.toFilePath(n);if(r!==a)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(r,a)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,h.localize)(2,null,(0,k.basename)(r),(0,k.basename)((0,k.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,n,o){const r=this.toFilePath(i),a=this.toFilePath(n);if(r!==a)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(r,a,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,h.localize)(3,null,(0,k.basename)(r),(0,k.basename)((0,k.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,n,o,r){const a=this.toFilePath(i),f=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,g.isEqual)(a,f,!0)),S&&o==="copy")throw(0,p.createFileSystemProviderError)((0,h.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!S&&await d.Promises.exists(f)){if(!r)throw(0,p.createFileSystemProviderError)((0,h.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const r=this.toFilePath(i),a=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,g.isEqual)(r,a,!f))return;const S=new b.DisposableStore;try{const[R,A]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);S.add(R),S.add(A),o&&await d.Promises.mkdir((0,k.dirname)(a),{recursive:!0}),await d.Promises.copyFile(r,a)}catch(R){if(R.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(R)}finally{S.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(r=>i(r),r=>n(r),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(r=>i(r),r=>n(r),o)}toFileSystemProviderError(i){if(i instanceof p.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.toFilePath(i));r.mode&128||(o=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return o}}e.DiskFileSystemProvider=s}),define(x[183],ee([0,1,4,79,2,18,49,23]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends L.Disposable{constructor(P,I){super();this.provider=P,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(P,I,v){const d=this.getUriTransformer(P);switch(I){case"stat":return this.stat(d,v[0]);case"readdir":return this.readdir(d,v[0]);case"open":return this.open(d,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(d,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(d,v[0],v[1],v[2]);case"rename":return this.rename(d,v[0],v[1],v[2]);case"copy":return this.copy(d,v[0],v[1],v[2]);case"cloneFile":return this.cloneFile(d,v[0],v[1]);case"mkdir":return this.mkdir(d,v[0]);case"delete":return this.delete(d,v[0],v[1]);case"watch":return this.watch(d,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${I} not found`)}listen(P,I,v){const d=this.getUriTransformer(P);switch(I){case"fileChange":return this.onFileChange(d,v[0]);case"readFileStream":return this.onReadFileStream(d,v[0],v[1])}throw new Error(`Unknown event ${I}`)}stat(P,I){const v=this.transformIncoming(P,I,!0);return this.provider.stat(v)}readdir(P,I){const v=this.transformIncoming(P,I);return this.provider.readdir(v)}async readFile(P,I,v){const d=this.transformIncoming(P,I,!0),h=await this.provider.readFile(d,v);return D.VSBuffer.wrap(h)}onReadFileStream(P,I,v){const d=this.transformIncoming(P,I,!0),h=new E.CancellationTokenSource,p=new y.Emitter({onLastListenerRemove:()=>{h.cancel()}}),w=this.provider.readFileStream(d,v,h.token);return(0,M.listenStream)(w,{onData:C=>p.fire(D.VSBuffer.wrap(C)),onError:C=>p.fire(C),onEnd:()=>{p.fire("end"),p.dispose(),h.dispose()}}),p.event}writeFile(P,I,v,d){const h=this.transformIncoming(P,I);return this.provider.writeFile(h,v.buffer,d)}open(P,I,v){const d=this.transformIncoming(P,I,!0);return this.provider.open(d,v)}close(P){return this.provider.close(P)}async read(P,I,v){const d=D.VSBuffer.alloc(v),h=0,p=await this.provider.read(P,I,d.buffer,h,v);return[d,p]}write(P,I,v,d,h){return this.provider.write(P,I,v.buffer,d,h)}mkdir(P,I){const v=this.transformIncoming(P,I);return this.provider.mkdir(v)}delete(P,I,v){const d=this.transformIncoming(P,I);return this.provider.delete(d,v)}rename(P,I,v,d){const h=this.transformIncoming(P,I),p=this.transformIncoming(P,v);return this.provider.rename(h,p,d)}copy(P,I,v,d){const h=this.transformIncoming(P,I),p=this.transformIncoming(P,v);return this.provider.copy(h,p,d)}cloneFile(P,I,v){const d=this.transformIncoming(P,I),h=this.transformIncoming(P,v);return this.provider.cloneFile(d,h)}onFileChange(P,I){const v=new y.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(P,v))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return v.event}async watch(P,I,v,d,h){const p=this.sessionToWatcher.get(I);if(p){const w=this.transformIncoming(P,d),C=p.watch(v,w,h);this.watchRequests.set(I+v,C)}}async unwatch(P,I){const v=P+I,d=this.watchRequests.get(v);d&&((0,L.dispose)(d),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,P]of this.watchRequests)P.dispose();this.watchRequests.clear();for(const[,P]of this.sessionToWatcher)P.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class b extends L.Disposable{constructor(P,I,v,d){super();this.uriTransformer=P,this.logService=v,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(P){const I=this._register(new y.Emitter);this._register(I.event(v=>{P.fire(v.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(v=>I.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>P.fire(v)))}getRecursiveWatcherOptions(P){}getExtraExcludes(P){}watch(P,I,v){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(v.excludes=[...v.excludes,...d]),this.watcherRequests.set(P,this.fileWatcher.watch(I,v)),(0,L.toDisposable)(()=>{(0,L.dispose)(this.watcherRequests.get(P)),this.watcherRequests.delete(P)})}dispose(){super.dispose();for(const[,P]of this.watcherRequests)P.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(x[184],ee([0,1,14,146,3,7,21,8,183,118]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class k extends g.AbstractDiskFileSystemProviderChannel{constructor(v,d,h){super(v,d);this.environmentService=h}getUriTransformer(v){return b.DefaultURITransformer}transformIncoming(v,d){return D.URI.revive(d)}async delete(v,d,h){if(!h.useTrash)return super.delete(v,d,h);const p=this.transformIncoming(v,d),w=(0,E.normalize)(p.fsPath);try{await y.shell.trashItem(w)}catch{throw(0,M.createFileSystemProviderError)(L.isWindows?(0,t.localize)(0,null,(0,E.basename)(w)):(0,t.localize)(1,null,(0,E.basename)(w)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(v,d){return new P(v,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=k;class P extends g.AbstractSessionFileWatcher{watch(v,d,h){if(h.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(v,d,h)}}}),define(x[97],ee([0,1,6]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(D,M){switch(M){case y.LogLevel.Trace:return D.trace;case y.LogLevel.Debug:return D.debug;case y.LogLevel.Info:return D.info;case y.LogLevel.Warning:return D.warn;case y.LogLevel.Error:return D.error;case y.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class L extends y.AbstractLogger{constructor(M=y.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(M){this._logger=M;for(const{level:E,args:g}of this.buffer)t(M,E).apply(M,g);this.buffer=[]}_log(M,...E){this._logger?t(this._logger,M).apply(this._logger,E):this.getLevel()<=M&&this.buffer.push({level:M,args:E})}trace(M,...E){this._log(y.LogLevel.Trace,M,...E)}debug(M,...E){this._log(y.LogLevel.Debug,M,...E)}info(M,...E){this._log(y.LogLevel.Info,M,...E)}warn(M,...E){this._log(y.LogLevel.Warning,M,...E)}error(M,...E){this._log(y.LogLevel.Error,M,...E)}critical(M,...E){this._log(y.LogLevel.Critical,M,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L}),define(x[185],ee([0,1,9,18,16,21,5,97,6]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const b=5*D.ByteSize.MB;let k=class extends g.AbstractLogger{constructor(v,d,h,p,w){super();this.name=v,this.resource=d,this.donotUseFormatters=p,this.fileService=w,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new y.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,(0,g.format)(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,(0,g.format)(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,(0,g.format)(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,(0,g.format)(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(g.LogLevel.Error,(0,g.format)(d))}else this._log(g.LogLevel.Error,(0,g.format)(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,(0,g.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>b&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=d:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(h))})}getCurrentTimestamp(){const v=p=>p<10?`0${p}`:p,d=p=>p<10?`00${p}`:p<100?`0${p}`:p,h=new Date;return`${h.getFullYear()}-${v(h.getMonth()+1)}-${v(h.getDate())} ${v(h.getHours())}:${v(h.getMinutes())}:${v(h.getSeconds())}.${d(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,L.joinPath)((0,L.dirname)(this.resource),`${(0,L.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(v){switch(v){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}};k=de([ie(4,D.IFileService)],k),e.FileLogger=k;let P=class extends g.AbstractLoggerService{constructor(v,d,h){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=h}doCreateLogger(v,d,h){const p=new E.BufferLogService(d);return(0,D.whenProviderRegistered)(v,this.fileService).then(()=>p.logger=this.instantiationService.createInstance(k,h?.name||(0,L.basename)(v),v,p.getLevel(),!!h?.donotUseFormatters)),p}};P=de([ie(0,g.ILogService),ie(1,M.IInstantiationService),ie(2,D.IFileService)],P),e.FileLoggerService=P}),define(x[186],ee([0,1,4,7,6]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(I){this.service=I,this.onDidChangeLogLevel=y.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(I,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=D;class M{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){M.setLevel(this.channel,I)}static setLevel(I,v){return I.call("setLevel",v)}}e.LogLevelChannelClient=M;class E{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,v){throw new Error(`Event not found: ${v}`)}async call(I,v,d){switch(v){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(I,v){this.loggers.set(I.toString(),this.loggerService.createLogger(I,v))}consoleLog(I,v){let d=console.log;switch(I){case L.LogLevel.Error:d=console.error;break;case L.LogLevel.Warning:d=console.warn;break;case L.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(I,v){const d=this.loggers.get(I.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,p]of v)(0,L.log)(d,h,p)}}e.LoggerChannel=E;class g extends L.AbstractLoggerService{constructor(I,v,d){super(I,v);this.channel=d}createConsoleMainLogger(){return new L.AdapterLogger({log:(I,v)=>{this.channel.call("consoleLog",[I,v])}})}doCreateLogger(I,v,d){return new b(this.channel,I,v,d)}}e.LoggerChannelClient=g;class b extends L.AbstractMessageLogger{constructor(I,v,d,h){super(h?.always);this.channel=I,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,v){const d=[[I,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(I){this.channel.call("log",[this.file,I])}}class k extends L.LogService{constructor(I,v){super(v);this.parent=I,this._register(I.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=k}),define(x[98],ee([0,1,21,6]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function L(E,g,b,k,P){try{const I=await new Promise((d,h)=>{V(["spdlog"],d,h)});I.setFlushOn(t.LogLevel.Trace);const v=await I.createAsyncRotatingLogger(E,g,b,k);return P&&v.clearFormatters(),v}catch(I){console.error(I)}return null}function D(E,g,b){switch(g){case t.LogLevel.Trace:E.trace(b);break;case t.LogLevel.Debug:E.debug(b);break;case t.LogLevel.Info:E.info(b);break;case t.LogLevel.Warning:E.warn(b);break;case t.LogLevel.Error:E.error(b);break;case t.LogLevel.Critical:E.critical(b);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(g,b,k,P,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(g,b,k,P),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}async _createSpdLogLogger(g,b,k,P){const I=k?6:1,v=30/I*y.ByteSize.MB,d=await L(g,b,v,I,P);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:h,message:p}of this.buffer)D(this._logger,h,p);this.buffer=[]}}log(g,b){this._logger?D(this._logger,g,b):this.getLevel()<=g&&this.buffer.push({level:g,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(x[187],ee([0,1,10,16,31,21,185,6,98]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let b=class extends E.AbstractLoggerService{constructor(P,I){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=I}doCreateLogger(P,I,v){return P.scheme===y.Schemas.file?new g.SpdLogLogger(v?.name||(0,L.generateUuid)(),P.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,I):new M.FileLogger(v?.name??(0,t.basename)(P),P,I,!!v?.donotUseFormatters,this.fileService)}};b=de([ie(0,E.ILogService),ie(1,D.IFileService)],b),e.LoggerService=b}),define(x[188],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function y(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=y;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function L(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function D(M){return!y(M)&&!t(M)&&!L(M)}e.isMenubarMenuItemAction=D}),define(x[54],ee([0,1,10,3,36,16]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const E=t.globals.vscode.context.configuration();if(E)M=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const E=(0,D.dirname)(y.FileAccess.asFileUri("",V));M=V.__$__nodeRequire((0,D.joinPath)(E,"product.json").fsPath);const g=V.__$__nodeRequire((0,D.joinPath)(E,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:g.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(x[19],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(x[189],ee([0,1,60,6,19]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(E,g){this.productService=E,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const b=/^(.*)#([^#]+)$/.exec(g);if(!b)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,k,P]=b;let I=this.trustedExtensionUrlPublicKeys.get(E);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[E],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...I])}const v=Buffer.from(decodeURIComponent(P),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const d=v.slice(0,6),h=v.readUIntBE(0,6),p=Date.now()-h;if(p<0||p>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const w=v.slice(6),C=y.createVerify("SHA256");C.write(d),C.write(Buffer.from(k)),C.end();for(let m=0;m<I.length;m++){let u=I[m];if(u!==null){if(typeof u=="string")try{u=y.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),I[m]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${E}:`,c),I[m]=null;continue}if(C.verify(u,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};D=de([ie(0,L.IProductService),ie(1,t.ILogService)],D),e.ExtensionUrlTrustService=D}),define(x[55],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,y.createDecorator)("protocolMainService")}),define(x[190],ee([0,1,14,37,2,35,10,8,3,7,31,53,6]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let v=class extends L.Disposable{constructor(h,p){super();this.logService=p,this.validRoots=D.TernarySearchTree.forPaths(!g.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(h.appRoot),this.addValidFileRoot(h.extensionsPath),this.addValidFileRoot(h.globalStorageHome.fsPath),this.addValidFileRoot(h.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=y.session;h.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(p,w)=>this.handleResourceRequest(p,w)),h.protocol.interceptFileProtocol(M.Schemas.file,(p,w)=>this.handleFileRequest(p,w)),this._register((0,L.toDisposable)(()=>{h.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(h){const p=(0,E.normalize)(h);return this.validRoots.get(p)?L.Disposable.None:(this.validRoots.set(p,!0),(0,L.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(h,p){const w=b.URI.parse(h.url);return this.logService.error(`Refused to load resource ${w.fsPath} from ${M.Schemas.file}: protocol (original URL: ${h.url})`),p({error:-3})}handleResourceRequest(h,p){const w=this.requestToNormalizedFilePath(h);return this.validRoots.findSubstr(w)?p({path:w}):this.validExtensions.has((0,E.extname)(w))?p({path:w}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),p({error:-3}))}requestToNormalizedFilePath(h){const p=b.URI.parse(h.url),w=M.FileAccess.asFileUri(p);return(0,E.normalize)(w.fsPath)}createIPCObjectUrl(){let h;const p=b.URI.from({scheme:"vscode",path:(0,k.generateUuid)()}),w=p.toString(),C=async()=>h;return t.validatedIpcMain.handle(w,C),this.logService.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:p,update:m=>h=m,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${w}.`),t.validatedIpcMain.removeHandler(w)}}}};v=de([ie(0,P.INativeEnvironmentService),ie(1,I.ILogService)],v),e.ProtocolMainService=v}),define(x[40],ee([0,1,108,12]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(M,E){y.ok(t.isString(M)),y.ok(t.isObject(E)),y.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new L}),define(x[191],ee([0,1,4,40]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class D{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,b){this.schemasById[L(g)]=b,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new D;t.Registry.add(e.Extensions.JSONContribution,M)}),define(x[56],ee([0,1,26,4,12,138,17,191,40]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=g.Registry.as(E.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,l=!0){this.registerConfigurations([s],l)}registerConfigurations(s,l=!0){const i=this.doRegisterConfigurations(s,l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(s){const l=this.doDeregisterConfigurations(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:s,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,y.distinct)(i)})}registerDefaultConfigurations(s){const l=[],i=[];for(const{overrides:n,source:o}of s)for(const r in n)if(l.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),f=a?.valuesSources??new Map;if(o)for(const F of Object.keys(n[r]))f.set(F,o);const S={...a?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:o,value:S,valuesSources:f});const R=(0,M.getLanguageTagSettingPlainKey)(r),A={type:"object",default:S,description:D.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:L.isString(o)?void 0:o,defaultValueSource:o};i.push(...h(r)),this.configurationProperties[r]=A,this.defaultLanguageConfigurationOverridesNode.properties[r]=A}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:o});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const l=[];for(const{overrides:i,source:n}of s)for(const o in i){const r=this.configurationDefaultsOverrides.get(o),a=L.isString(n)?n:n?.id,f=L.isString(r?.source)?r?.source:r?.source?.id;if(a===f)if(l.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const S=this.configurationProperties[o];S&&(this.updatePropertyDefaultValue(o,S),this.updateSchema(o,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const l of s)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,l){const i=[];return s.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(s){const l=[],i=n=>{if(n.properties)for(const o in n.properties)l.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>i(o))};for(const n of s){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return l}validateAndRegisterProperties(s,l=!0,i,n,o=3){o=L.isUndefinedOrNull(s.scope)?o:s.scope;let r=[],a=s.properties;if(a)for(let S in a){if(l&&m(S)){delete a[S];continue}const R=a[S];if(R.source=i,R.defaultDefaultValue=a[S].default,this.updatePropertyDefaultValue(S,R),e.OVERRIDE_PROPERTY_REGEX.test(S)?R.scope=void 0:(R.scope=L.isUndefinedOrNull(R.scope)?o:R.scope,R.restricted=L.isUndefinedOrNull(R.restricted)?!!n?.includes(S):R.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.excludedConfigurationProperties[S]=a[S],delete a[S];continue}else this.configurationProperties[S]=a[S];!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),r.push(S)}let f=s.allOf;if(f)for(let S of f)r.push(...this.validateAndRegisterProperties(S,l,i,n,o));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const l=i=>{let n=i.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let o=i.allOf;o&&o.forEach(l)};l(s)}updateSchema(s,l){switch(e.allSettings.properties[s]=l,l.scope){case 1:e.applicationSettings.properties[s]=l;break;case 2:e.machineSettings.properties[s]=l;break;case 6:e.machineOverridableSettings.properties[s]=l;break;case 3:e.windowSettings.properties[s]=l;break;case 4:e.resourceSettings.properties[s]=l;break;case 5:e.resourceSettings.properties[s]=l,this.resourceLanguageSettingsSchema.properties[s]=l;break}}removeFromSchema(s,l){switch(delete e.allSettings.properties[s],l.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const l=`[${s}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,l){const i=this.configurationDefaultsOverrides.get(s);let n=i?.value,o=i?.source;L.isUndefined(n)&&(n=l.defaultDefaultValue,o=void 0),L.isUndefined(n)&&(n=w(l.type)),l.default=n,l.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",d=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let l=d.exec(c);for(;l?.length;){const i=l[1].trim();i&&s.push(i),l=d.exec(c)}}return(0,y.distinct)(s)}e.overrideIdentifiersFromKey=h;function p(c){return c.reduce((s,l)=>`${s}[${l}]`,"")}e.keyFromOverrideIdentifiers=p;function w(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const C=new I;g.Registry.add(e.Extensions.Configuration,C);function m(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?D.localize(7,null,c):C.getConfigurationProperties()[c]!==void 0?D.localize(8,null,c):null:D.localize(6,null)}e.validateProperty=m;function u(){const c=[],s=C.getConfigurationProperties();for(const l of Object.keys(s))c.push([l,s[l].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(x[192],ee([0,1,26,4,44,2,35,50,12,7,17,56,40]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},n=[],o=[]){this._contents=i,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,k.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const o=this.getContentsForOverrideIdentifer(n);return o?i?(0,k.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return y.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return y.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=E.deepClone(this.contents),o=E.deepClone(this.overrides),r=[...this.keys];for(const a of i){this.mergeContents(n,a.contents);for(const f of a.overrides){const[S]=o.filter(R=>y.equals(R.identifiers,f.identifiers));S?(this.mergeContents(S.contents,f.contents),S.keys.push(...f.keys),S.keys=y.distinct(S.keys)):o.push(E.deepClone(f))}for(const f of a.keys)r.indexOf(f)===-1&&r.push(f)}return new v(n,r,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const r of y.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r],f=n[r];f&&(typeof a=="object"&&typeof f=="object"?(a=E.deepClone(a),this.mergeContents(a,f)):a=f),o[r]=a}return new v(o,this.keys,this.overrides)}mergeContents(i,n){for(const o of Object.keys(n)){if(o in i&&g.isObject(i[o])&&g.isObject(n[o])){this.mergeContents(i[o],n[o]);continue}i[o]=E.deepClone(n[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?E.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,o=null;const r=a=>{a&&(o?this.mergeContents(o,a):o=E.deepClone(a))};for(const a of this.overrides)y.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&r(a.contents);return r(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,k.addToValueTree)(this.contents,i,n,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,k.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let o=0;o<n;o++)i.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(i={}){const n=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),r=Object.create(null),a=[];for(const f in n){const S=i[f],R=S!==void 0?S:n[f].default;(0,k.addToValueTree)(r,f,R,A=>console.error(`Conflict in default settings: ${A}`))}for(const f of Object.keys(r))P.OVERRIDE_PROPERTY_REGEX.test(f)&&a.push({identifiers:(0,P.overrideIdentifiersFromKey)(f),keys:Object.keys(r[f]),contents:(0,k.toValuesTree)(r[f],S=>console.error(`Conflict in default settings file: ${S}`))});super(r,o,a)}}e.DefaultConfigurationModel=d;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!g.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:o,keys:r,overrides:a,restricted:f}=this.doParseRaw(i,n);this._configurationModel=new v(o,r,a),this._restrictedConfigurations=f||[]}doParseContent(i){let n={},o=null,r=[],a=[],f=[];function S(A){Array.isArray(r)?r.push(A):o!==null&&(r[o]=A)}let R={onObjectBegin:()=>{let A={};S(A),a.push(r),r=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let A=[];S(A),a.push(r),r=A,o=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:S,onError:(A,F,$)=>{f.push({error:A,offset:F,length:$})}};if(i)try{L.visit(i,R),n=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(i,n){const o=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,o,!0,n);i=r.raw;const a=(0,k.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),f=Object.keys(i),S=this.toOverrides(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:a,keys:f,overrides:S,restricted:r.restricted}}filter(i,n,o,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const a={},f=[];for(let S in i)if(P.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const R=this.filter(i[S],n,!1,r);a[S]=R.raw,f.push(...R.restricted)}else{const R=n[S],A=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&f.push(S),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&R?.restricted||(a[S]=i[S]))}return{raw:a,restricted:f}}toOverrides(i,n){const o=[];for(const r of Object.keys(i))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const f in i[r])a[f]=i[r][f];o.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,k.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=h;class p extends D.Disposable{constructor(i,n,o,r){super();this.userSettingsResource=i,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class w{constructor(i,n,o=new v,r=new v,a=new M.ResourceMap,f=new v,S=new M.ResourceMap,R=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=S,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(i,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(i)}updateValue(i,n,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new v,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(i):r.setValue(i,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,o){const r=this.getConsolidateConfigurationModel(n,o),a=this.getFolderConfigurationModelForResource(n.resource,o),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),R=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),$=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,J=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,ne=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(i):f.getValue(i),Y=r.getValue(i),re=y.distinct(y.flatten(r.overrides.map(H=>H.identifiers))).filter(H=>r.getOverrideValue(i,H)!==void 0);return{defaultValue:S,userValue:R,userLocalValue:A,userRemoteValue:F,workspaceValue:$,workspaceFolderValue:J,memoryValue:ne,value:Y,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:J!==void 0?{value:a?.freeze().getValue(i),override:n.overrideIdentifier?a?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:f.getValue(i),override:n.overrideIdentifier?f.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:r,updated:a,removed:f}=c(this._defaultConfiguration,i);n=[...r,...a,...f]}for(const r of n)for(const a of(0,P.overrideIdentifiersFromKey)(r)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),S=i.getKeysForOverrideIdentifier(a),R=[...S.filter(A=>f.indexOf(A)===-1),...f.filter(A=>S.indexOf(A)===-1),...f.filter(A=>!E.equals(this._defaultConfiguration.override(a).getValue(A),i.override(a).getValue(A)))];o.push([a,R])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:r,overrides:a}=c(this.localUserConfiguration,i),f=[...n,...o,...r];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:r,overrides:a}=c(this.remoteUserConfiguration,i);let f=[...n,...o,...r];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:r,overrides:a}=c(this.workspaceConfiguration,i);let f=[...n,...o,...r];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:r,updated:a,removed:f,overrides:S}=c(o,n);let R=[...r,...a,...f];return(R.length||!o)&&this.updateFolderConfiguration(i,n),{keys:R,overrides:S}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:r,removed:a,overrides:f}=c(n,void 0);return{keys:[...o,...r,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const r=n.getFolder(i);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const a=this._memoryConfigurationByResource.get(i);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(n=o.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=o}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:o,overrides:r,keys:a}=this._folderConfigurations.get(n);return i.push([n,{contents:o,overrides:r,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((f,S)=>(f.set(b.URI.revive(S[0]),this.parseConfigurationModel(S[1])),f),new M.ResourceMap);return new w(n,o,new v,r,a,new v,new M.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=w;function C(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,n=new Map;for(const r of l)r.keys.forEach(a=>i.add(a)),r.overrides.forEach(([a,f])=>{const S=(0,M.getOrSet)(n,a,new Set);f.forEach(R=>S.add(R))});const o=[];return n.forEach((r,a)=>o.push([a,[...r.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=C;class m{constructor(i,n,o,r){this.change=i,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(S=>a.add(S)),i.overrides.forEach(([,S])=>S.forEach(R=>a.add(R))),this.affectedKeys=[...a.values()];const f=new v;this.affectedKeys.forEach(S=>f.setValue(S,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!E.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let o=(0,k.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(i=i[r],!i)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=m;class u extends m{constructor(i,n,o,r){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u;function c(l,i){const{added:n,removed:o,updated:r}=s(i,l),a=[],f=l?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const R=S.filter(A=>!f.includes(A));for(const A of R)a.push([A,i.getKeysForOverrideIdentifier(A)])}if(l){const R=f.filter(A=>!S.includes(A));for(const A of R)a.push([A,l.getKeysForOverrideIdentifier(A)])}if(i&&l){for(const R of f)if(S.includes(R)){const A=s({contents:l.getOverrideValue(void 0,R)||{},keys:l.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});a.push([R,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:o,updated:r,overrides:a}}function s(l,i){const n=l?i?l.keys.filter(a=>i.keys.indexOf(a)===-1):[...l.keys]:[],o=i?l?i.keys.filter(a=>l.keys.indexOf(a)===-1):[...i.keys]:[],r=[];if(l&&i){for(const a of i.keys)if(l.keys.indexOf(a)!==-1){const f=(0,k.getConfigurationValue)(i.contents,a),S=(0,k.getConfigurationValue)(l.contents,a);E.equals(f,S)||r.push(a)}}return{added:n,removed:o,updated:r}}}),define(x[193],ee([0,1,9,4,2,16,17,192,56,40]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class k extends L.Disposable{constructor(I,v){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,v)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,v){const d=typeof I=="string"?I:void 0,h=(0,M.isConfigurationOverrides)(I)?I:(0,M.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,h,void 0)}updateValue(I,v,d,h){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(d,v,1)}onDidDefaultConfigurationChange(I){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,I);this.trigger(d,v,6)}trigger(I,v,d){const h=new E.ConfigurationChangeEvent(I,{data:v},this.configuration);h.source=d,h.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=k}),define(x[194],ee([0,1,15,5]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends y.ErrorNoTelemetry{constructor(E,g=L.Unknown,b){super(E);this._message=E,this._code=g,this._detail=b,this.isHandled=g===L.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof D&&E.isHandled}}e.RemoteAuthorityResolverError=D}),define(x[65],ee([0,1,10]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(M){return M.scheme===y.Schemas.vscodeRemote?M.authority:void 0}e.getRemoteAuthority=t;function L(M){if(!M)return;const E=M.indexOf("+");return E<0?M:M.substr(0,E)}e.getRemoteName=L;function D(M){return`/${M.quality??"oss"}-${M.commit??"dev"}`}e.getRemoteServerRootPath=D}),define(x[195],ee([0,1,9,18,23,15,4,2,31,90,194,65]),function(V,e,y,t,L,D,M,E,g,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var v;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function d(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(Q){const O=new L.CancellationTokenSource;return setTimeout(()=>O.cancel(),Q),O.token}function p(Q,O){if(Q.isCancellationRequested||O.isCancellationRequested)return L.CancellationToken.Cancelled;const U=new L.CancellationTokenSource;return Q.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class w{constructor(O){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((U,W)=>{this._resolvePromise=U,this._rejectPromise=W}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function C(Q,O){const U=new w(O);return U.registerDisposable(Q.onControlMessage(W=>{const N=JSON.parse(W.toString()),T=j(N);T?U.reject(T):U.resolve(N)})),U.promise}function m(Q,O,U,W,N,T,_,q){const Z=new w(q);return O.connect(U,W,N,T,_,(oe,ce)=>{Z.didTimeout?(oe&&Q.error(oe),ce?.dispose()):oe||!ce?Z.reject(oe):Z.resolve(ce)}),Z.promise}function u(Q,O){const U=new w(O);return Q.then(W=>{U.didTimeout||U.resolve(W)},W=>{U.didTimeout||U.reject(W)}),U.promise}async function c(Q,O,U,W){const N=K(Q,O);Q.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let T;try{T=await m(Q.logService,Q.socketFactory,Q.host,Q.port,(0,P.getRemoteServerRootPath)(Q),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,`renderer-${d(O)}-${Q.reconnectionToken}`,W)}catch(ce){throw Q.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(ce),ce}Q.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let _,q;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(T,null),_=Q.reconnectionProtocol,q=!1):(_=new b.PersistentProtocol(T,null),q=!0),Q.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const Z=await u(Q.signService.createNewMessage((0,g.generateUuid)()),W),oe={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:Z.data};_.sendControl(t.VSBuffer.fromString(JSON.stringify(oe)));try{const ce=await C(_,p(W,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(Q.logService.trace(`${N} 4/6. received SignRequest control message.`),!await u(Q.signService.validate(Z,ce.signedData),W)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const he=await u(Q.signService.sign(ce.data),W),ue={type:"connectionType",commit:Q.commit,signedData:he,desiredConnectionType:O};return U&&(ue.args=U),Q.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(t.VSBuffer.fromString(JSON.stringify(ue))),{protocol:_,ownsProtocol:q}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(Q.logService.error(`${N} the handshake timed out. Error:`),Q.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${N} received error control message when negotiating connection. Error:`),Q.logService.error(ce)),q&&X(_),ce}}async function s(Q,O,U,W){const N=Date.now(),T=K(Q,O),{protocol:_,ownsProtocol:q}=await c(Q,O,U,W),Z=new w(W);return Z.registerDisposable(_.onControlMessage(oe=>{const ce=JSON.parse(oe.toString()),se=j(ce);se?(Q.logService.error(`${T} received error control message when negotiating connection. Error:`),Q.logService.error(se),q&&X(_),Z.reject(se)):(Q.reconnectionProtocol&&Q.reconnectionProtocol.endAcceptReconnection(),Q.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${te(N)}!`),Z.resolve({protocol:_,firstMessage:ce}))})),Z.promise}async function l(Q,O){const{protocol:U}=await s(Q,1,void 0,O);return{protocol:U}}async function i(Q,O,U){const{protocol:W,firstMessage:N}=await s(Q,2,O,U),T=N&&N.debugPort;return{protocol:W,debugPort:T}}async function n(Q,O,U){const W=Date.now(),N=K(Q,3),{protocol:T}=await c(Q,3,O,U);return Q.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${te(W)}!`),T}async function o(Q,O,U){const{host:W,port:N,connectionToken:T}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,host:W,port:N,connectionToken:T,reconnectionToken:O,reconnectionProtocol:U,socketFactory:Q.socketFactory,signService:Q.signService,logService:Q.logService}}async function r(Q,O,U){try{const W=(0,g.generateUuid)(),N=await o(Q,W,null),{protocol:T}=await l(N,L.CancellationToken.None);return new re(Q,O,U,W,T)}catch(W){throw Q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),Q.logService.error(W),Y.triggerPermanentFailure(0,0,k.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=r;async function a(Q,O){try{const U=(0,g.generateUuid)(),W=await o(Q,U,null),{protocol:N,debugPort:T}=await i(W,O,L.CancellationToken.None);return new H(Q,O,U,N,T)}catch(U){throw Q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),Q.logService.error(U),Y.triggerPermanentFailure(0,0,k.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=a;async function f(Q,O,U){const W=await o(Q,(0,g.generateUuid)(),null);return await n(W,{host:O,port:U},L.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function S(Q){return(0,y.createCancelablePromise)(O=>new Promise((U,W)=>{const N=setTimeout(U,Q*1e3);O.onCancellationRequested(()=>{clearTimeout(N),U()})}))}var R;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=A;class F{constructor(O,U,W,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=W,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class ${constructor(O,U,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=$;class J{constructor(O,U,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.type=4}}e.ConnectionGainEvent=J;class ne{constructor(O,U,W,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=W,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class Y extends E.Disposable{constructor(O,U,W,N,T){super();this._connectionType=O,this._options=U,this.reconnectionToken=W,this.protocol=N,this._reconnectionFailureIsFatal=T,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new J(this.reconnectionToken,0,0)),this._register(N.onSocketClose(_=>{const q=z(this._connectionType,this.reconnectionToken,!0);_?_.type===0?(this._options.logService.info(`${q} received socket close event (hadError: ${_.hadError}).`),_.error&&this._options.logService.error(_.error)):(this._options.logService.info(`${q} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this._options.logService.error(_.event)):this._options.logService.info(`${q} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const _=z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),this._register((0,E.toDisposable)(()=>{const _=Y._instances.indexOf(this);_>=0&&Y._instances.splice(_,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(O,U,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=U,this._permanentFailureHandled=W,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(O=>O._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(O=>O._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||Y._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const O=z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const N=W<U.length?U[W]:U[U.length-1];try{if(N>0){const _=S(N);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,_)),this._options.logService.info(`${O} waiting for ${N} seconds before reconnecting...`);try{await _}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${O} resolving connection...`);const T=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${T.host}:${T.port}...`),await this._reconnect(T,h(I)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(T){if(T.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(T),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(T),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(k.RemoteAuthorityResolverError.isTemporarilyNotAvailable(T)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(T);continue}if((T.code==="ETIMEDOUT"||T.code==="ENETUNREACH"||T.code==="ECONNREFUSED"||T.code==="ECONNRESET")&&T.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(T);continue}if((0,D.isCancellationError)(T)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(T);continue}if(T instanceof k.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(T),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,k.RemoteAuthorityResolverError.isHandled(T));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(T),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(O,U,W){this._reconnectionFailureIsFatal?Y.triggerPermanentFailure(O,U,W):this._gotoPermanentFailure(O,U,W)}_gotoPermanentFailure(O,U,W){this._onDidStateChange.fire(new ne(this.reconnectionToken,O,U,W)),X(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Y,Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class re extends Y{constructor(O,U,W,N,T){super(1,O,N,T,!0);this.client=this._register(new b.Client(T,{remoteAuthority:U,clientId:W},O.ipcLogger))}async _reconnect(O,U){await l(O,U)}}e.ManagementPersistentConnection=re;class H extends Y{constructor(O,U,W,N,T){super(2,O,W,N,!1);this._startArguments=U,this.debugPort=T}async _reconnect(O,U){await i(O,this._startArguments,U)}}e.ExtensionHostPersistentConnection=H;function X(Q){try{Q.acceptDisconnect();const O=Q.getSocket();Q.dispose(),O.dispose()}catch(O){(0,D.onUnexpectedError)(O)}}function j(Q){if(Q&&Q.type==="error"){const O=new Error(`Connection error: ${Q.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function B(Q,O){for(;Q.length<O;)Q+=" ";return Q}function z(Q,O,U){return`[remote-connection][${B(d(Q),13)}][${O.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function K(Q,O){return`${z(O,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.host}:${Q.port}]`}function te(Q){return`${Date.now()-Q} ms`}}),define(x[57],ee([0,1,18,151,56,5,40]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function E(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=E;function g(h){return h.res.statusCode===204}async function b(h){return g(h)?null:(await(0,y.streamToBuffer)(h.stream)).toString()}e.asText=b;async function k(h){if(!E(h))throw new Error("Server returned "+h.res.statusCode);return b(h)}e.asTextOrError=k;async function P(h){if(!E(h))throw new Error("Server returned "+h.res.statusCode);if(g(h))return null;const w=(await(0,y.streamToBuffer)(h.stream)).toString();try{return JSON.parse(w)}catch(C){throw C.message+=`:
`+w,C}}e.asJson=P;function I(h){d(h)}e.updateProxyConfigurationsScope=I;let v;function d(h){const p=M.Registry.as(L.Extensions.Configuration),w=v;v={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[v],remove:w?[w]:[]})}d(2)}),define(x[196],ee([0,1,197,12]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(M,E){return M.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:M.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function D(M,E,g={}){const b=(0,y.parse)(M),k=g.proxyUrl||L(b,E);if(!k)return null;const P=(0,y.parse)(k);if(!/^https?:$/.test(P.protocol||""))return null;const I={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(g.strictSSL)?g.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((v,d)=>{V(["http-proxy-agent"],v,d)}))(I):new(await new Promise((v,d)=>{V(["https-proxy-agent"],v,d)}))(I)}e.getProxyAgent=D}),define(x[99],ee([0,1,45,8,152,23,39,15,3,31,135,51,9]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let d;async function h(w,C,m){return C["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(m)&&!C["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(m)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=I.Promises.withAsyncBody(async(u,c)=>{const s=new D.CancellationTokenSource,l=setTimeout(()=>{s.dispose(!0),c(new Error((0,L.localize)(0,null)))},v);try{u(await p(w,s.token))}catch(i){!(0,E.isCancellationError)(i)&&!s.token.isCancellationRequested?c(new Error((0,L.localize)(1,null,(0,M.toErrorMessage)(i)))):u({})}finally{clearTimeout(l),s.dispose()}})),d)}e.getResolvedShellEnv=h;async function p(w,C){const m=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",m);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",u);const c=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",l);const i=await(0,k.getSystemShell)(g.OS,l);return w.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(C.isCancellationRequested)return o((0,E.canceled)());const r=(0,t.basename)(i);let a,f;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' ${S} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,f=["-Login","-Command"]):(a=`'${process.execPath}' ${S} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,r==="tcsh"?f=["-ic"]:f=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),a);const R=(0,y.spawn)(i,[...f,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});C.onCancellationRequested(()=>(R.kill(),o((0,E.canceled)()))),R.on("error",$=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),o($)});const A=[];R.stdout.on("data",$=>A.push($));const F=[];R.stderr.on("data",$=>F.push($)),R.on("close",($,J)=>{const ne=Buffer.concat(A).toString("utf8");w.trace("getUnixShellEnvironment#raw",ne);const Y=Buffer.concat(F).toString("utf8");if(Y.trim()&&w.trace("getUnixShellEnvironment#stderr",Y),$||J)return o(new Error((0,L.localize)(2,null,$,J)));const re=s.exec(ne),H=re?re[1]:"{}";try{const X=JSON.parse(H);m?X.ELECTRON_RUN_AS_NODE=m:delete X.ELECTRON_RUN_AS_NODE,u?X.ELECTRON_NO_ATTACH_CONSOLE=u:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",X),n(X)}catch(X){w.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(X)),o(X)}})})}}),define(x[80],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,y.createDecorator)(e.SIGN_SERVICE_ID)}),define(x[198],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class y{constructor(){this.validators=new Map}vsda(){return new Promise((L,D)=>V(["vsda"],L,D))}async createNewMessage(L){try{const D=await this.vsda(),M=new D.validator;if(M){const E=String(y._nextId++);return this.validators.set(E,M),{id:E,data:M.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,D){if(!L.id)return!0;const M=this.validators.get(L.id);if(!M)return!1;this.validators.delete(L.id);try{return M.validate(D)==="ok"}catch{return!1}}async sign(L){try{const D=await this.vsda(),M=new D.signer;if(M)return M.sign(L)}catch{}return L}}e.SignService=y,y._nextId=1}),define(x[46],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,y.createDecorator)("stateMainService")}),define(x[22],ee([0,1,14,37,9,4,2,3,36,12,5,6,46]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,k.createDecorator)("lifecycleMainService");var v;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(v=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class pt extends M.Disposable{constructor(w,C){super();this.logService=w,this.stateMainService=C,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(pt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(pt.QUIT_AND_RESTART_KEY)}registerListeners(){const w=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};y.app.addListener("before-quit",w);const C=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&y.app.quit()};y.app.addListener("window-all-closed",C),y.app.once("will-quit",m=>{this.logService.trace("Lifecycle#app.on(will-quit)"),m.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),y.app.removeListener("before-quit",w),y.app.removeListener("window-all-closed",C),y.app.quit()})})}fireOnWillShutdown(w){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const C=[];return this._onWillShutdown.fire({reason:w,join(m){C.push(m)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(C)}catch(m){this.logService.error(m)}try{await this.stateMainService.close()}catch(m){this.logService.error(m)}})(),this.pendingWillShutdownPromise}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===w)return;this.logService.trace(`lifecycle (main): phase changed (value: ${w})`),this._phase=w;const C=this.phaseWhen.get(this._phase);C&&(C.open(),this.phaseWhen.delete(this._phase))}async when(w){if(w<=this._phase)return;let C=this.phaseWhen.get(w);C||(C=new L.Barrier,this.phaseWhen.set(w,C)),await C.wait()}registerWindow(w){const C=new M.DisposableStore;this.windowCounter++,C.add(w.onWillLoad(u=>this._onWillLoadWindow.fire({window:w,workspace:u.workspace,reason:u.reason})));const m=(0,b.assertIsDefined)(w.win);m.on("close",u=>{const c=w.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${w.id}`),u.preventDefault(),this.unload(w,1).then(s=>{if(s){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(w),w.close()})}),m.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.windowCounter--,C.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(w,C){await this.unload(w,3)||w.reload(C)}unload(w,C){const m=this.mapWindowIdToPendingUnload.get(w.id);if(m)return m;const u=this.doUnload(w,C).finally(()=>{this.mapWindowIdToPendingUnload.delete(w.id)});return this.mapWindowIdToPendingUnload.set(w.id,u),u}async doUnload(w,C){if(!w.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${w.id}`);const m=this._quitRequested?2:C;let u=await this.onBeforeUnloadWindowInRenderer(w,m);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.handleWindowUnloadVeto(u)):(await this.onWillUnloadWindowInRenderer(w,m),!1)}handleWindowUnloadVeto(w){return w?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(w){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(w),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(w,C){return new Promise(m=>{const u=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${u}`,s=`vscode:cancel${u}`;t.validatedIpcMain.once(c,()=>{m(!1)}),t.validatedIpcMain.once(s,()=>{m(!0)}),w.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:C})})}onWillUnloadWindowInRenderer(w,C){return new Promise(m=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(c,()=>m()),w.send("vscode:onWillUnload",{replyChannel:c,reason:C})})}quit(w){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${w}`),w&&this.stateMainService.setItem(pt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(C=>{this.pendingQuitPromiseResolve=C,this.logService.trace("Lifecycle#quit() - calling app.quit()"),y.app.quit()}),this.pendingQuitPromise)}async relaunch(w){this.logService.trace("Lifecycle#relaunch()");const C=process.argv.slice(1);if(w?.addArgs&&C.push(...w.addArgs),w?.removeArgs)for(const c of w.removeArgs){const s=C.indexOf(c);s>=0&&C.splice(s,1)}const m=()=>{try{if(E.isWindows){const c=(0,g.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),y.app.relaunch({args:C})};y.app.once("quit",m),await this.quit(!0)&&y.app.removeListener("quit",m)}async kill(w){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const C of y.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let m;C.webContents&&!C.webContents.isDestroyed()?m=new Promise(u=>C.once("closed",u)):m=Promise.resolve(),C.destroy(),await m}})()]),y.app.exit(w)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=de([ie(0,P.ILogService),ie(1,I.IStateMainService)],h),e.LifecycleMainService=h}),define(x[199],ee([0,1,4,2,5,22]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let M=class extends t.Disposable{constructor(b){super();this._onDidChangeKeyboardLayout=this._register(new y.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,b.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const b=await new Promise((k,P)=>{V(["native-keymap"],k,P)});this._keyboardLayoutData=E(b),b.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(b),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=de([ie(0,D.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function E(g){const b=g.getKeyMap(),k=g.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:k}}}),define(x[100],ee([0,1,9,4,2,64,12,92,5]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var k;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var I;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class v extends L.Disposable{constructor(w={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,C){C===b?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:C,target:this.getKeyTargets(w)[C]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,C,m){return this.getStorage(C)?.get(w,m)}getBoolean(w,C,m){return this.getStorage(C)?.getBoolean(w,m)}getNumber(w,C,m){return this.getStorage(C)?.getNumber(w,m)}store(w,C,m,u){if((0,M.isUndefinedOrNull)(C)){this.remove(w,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,m,u),this.getStorage(m)?.set(w,C)})}remove(w,C){this.withPausedEmitters(()=>{this.updateKeyTarget(w,C,void 0),this.getStorage(C)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,C){const m=[],u=this.getKeyTargets(w);for(const c of Object.keys(u))u[c]===C&&m.push(c);return m}updateKeyTarget(w,C,m){const u=this.getKeyTargets(C);typeof m=="number"?u[w]!==m&&(u[w]=m,this.getStorage(C)?.set(b,JSON.stringify(u))):typeof u[w]=="number"&&(delete u[w],this.getStorage(C)?.set(b,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const C=this.get(b,w);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=k.NONE){this._onWillSaveState.fire({reason:w});const C=this.getStorage(0),m=this.getStorage(1);switch(w){case k.NONE:await y.Promises.settled([C?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await y.Promises.settled([C?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const w=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return h(w,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends v{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=d;async function h(p,w,C,m){const u=r=>{try{return JSON.parse(r)}catch{return r}},c=new Map,s=new Map;p.forEach((r,a)=>{c.set(a,r),s.set(a,u(r))});const l=new Map,i=new Map;w.forEach((r,a)=>{l.set(a,r),i.set(a,u(r))}),console.group(`Storage: Global (path: ${C})`);let n=[];c.forEach((r,a)=>{n.push({key:a,value:r})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${m})`);let o=[];l.forEach((r,a)=>{o.push({key:a,value:r})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=h}),define(x[200],ee([0,1,3,36,7,31]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(b){if(y.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function E(b,k,P,I,v,d,h,p,w,C){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,D.generateUuid)()+Date.now(),m.commitHash=v,m.version=d,m["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,y.PlatformToString)(y.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=I,m["common.product"]=C||"desktop";const u=g(p||[]);u&&(m["common.msftInternal"]=u);let c=0;const s=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.isLinuxSnap&&(m["common.snap"]="true");const l=M(P);l&&(m["common.platformDetail"]=l);try{const i=await b.readFile(L.URI.file(w));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=E;function g(b){const k=t.env.USERDNSDOMAIN;if(!k)return!1;const P=k.toLowerCase();return b.some(I=>P===I)}e.verifyMicrosoftInternalDomain=g}),define(x[32],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(x[201],ee([0,1,27,69,9,44,10,8,3,7,74,20,89,77,21,19,32]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function C(l,i){const n=`${l}::${i.join(":")}`,o=w.get(n);if(o)return o;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,f=new Map,S=2e4;function R(F,$,J,ne){const Y=$.substring(F.length+1);return L.Promises.withAsyncBody(async re=>{let H;try{H=await P.Promises.readdir($,{withFileTypes:!0})}catch{re();return}if(ne.count>=S){ne.count+=H.length,ne.maxReached=!0,re();return}let X=H.length;if(X===0){re();return}let j=H;ne.count+H.length>S&&(ne.maxReached=!0,X=S-ne.count,j=H.slice(0,X)),ne.count+=H.length;for(const B of j)if(B.isDirectory()){if(J.includes(B.name)||await R(F,(0,E.join)($,B.name),J,ne),--X==0){re();return}}else{const z=B.name.lastIndexOf(".");if(z>=0){const K=B.name.substring(z+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of r)K.relativePathPattern?.test(Y)!==!1&&K.filePattern.test(B.name)&&f.set(K.tag,(f.get(K.tag)??0)+1);if(--X==0){re();return}}})}const A=L.Promises.withAsyncBody(async F=>{const $={count:0,maxReached:!1};await R(l,l,i,$);const J=await c(l);F({configFiles:m(f),fileTypes:m(a),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:J})});return w.set(n,A),A}e.collectWorkspaceStats=C;function m(l){return[...t.Iterable.map(l.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const l={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=u;async function c(l){try{const i=new Map,n=(0,E.join)(l,".vscode","launch.json"),o=await P.Promises.readFile(n),r=[],a=(0,D.parse)(o.toString(),r);if(r.length)return console.log(`Unable to parse ${n}`),[];if((0,D.getNodeType)(a)==="object"&&a.configurations)for(const f of a.configurations){const S=f.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=c;let s=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const o=y.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(y.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||n.push(`Load (avg):       ${y.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,I.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[r,a]=o,f=this.formatProcessList(i,r);return n.forEach(S=>{if((0,v.isRemoteDiagnosticError)(S))f+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if(f+=`

Remote: ${S.hostName}`,S.processes&&(f+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const R of Object.keys(S.workspaceMetadata)){const A=S.workspaceMetadata[R];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),a+=`|    Folder (${R}): ${F}`,a+=this.formatWorkspaceStats(A)}}}),{processInfo:f,workspaceInfo:a}})}async getSystemInfo(i,n){const{memory:o,vmHint:r,os:a,cpus:f}=u(),S={os:a,memory:o,cpus:f,vmHint:r,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return g.isWindows||(S.load=`${y.loadavg().map(R=>Math.round(R)).join(", ")}`),g.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,n){const o=[];return(0,I.listProcesses)(i.mainPID).then(async r=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,r)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(a=>{if((0,v.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const f of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[f];let R=`${S.fileCount} files`;S.maxFilesReached&&(R=`more than ${R}`),o.push(`Folder (${f}): ${R}`),o.push(this.formatWorkspaceStats(S))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let r=0;const a=(A,F)=>{const $=` ${A}(${F})`;r+$.length>o?(n.push(f),f="|                 ",r=f.length):r+=$.length,f+=$};let f="|      File types:";const S=10;let R=i.fileTypes.length>S?S:i.fileTypes.length;for(let A=0;A<R;A++){const F=i.fileTypes[A];a(F.name,F.count)}if(n.push(f),i.configFiles.length>=0&&(f="|      Conf files:",r=0,i.configFiles.forEach(A=>{a(A.name,A.count)}),n.push(f)),i.launchConfigFiles.length>0){let A="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{A+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),n.push(A)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const f=b.URI.revive(a);if(f.scheme===M.Schemas.file){const S=f.fsPath;o.push(C(S,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),n.push(`|    Folder (${(0,E.basename)(S)}): ${A}`),n.push(this.formatWorkspaceStats(R))}).catch(R=>{n.push(`|      Error: Unable to collect workspace stats for folder ${S} (${R.toString()})`)}))}else n.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(a=>o.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,r,n,0),r.join(`
`)}formatProcessItem(i,n,o,r,a){const f=a===0;let S;f?S=r.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(S=`${S} (${n.get(r.pid)})`));const R=process.platform==="win32"?r.mem:y.totalmem()*(r.mem/100);o.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(r.children)&&r.children.forEach(A=>this.formatProcessItem(i,n,o,A,a+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const r=b.URI.revive(o);if(r.scheme!==M.Schemas.file)continue;const a=r.fsPath;try{(await C(a,["node_modules",".git"])).fileTypes.forEach(S=>n.add(S.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=b.URI.revive(n);if(o.scheme!==M.Schemas.file)continue;const r=o.fsPath;try{const a=await C(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),a.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),a.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};s=de([ie(0,p.ITelemetryService),ie(1,h.IProductService)],s),e.DiagnosticsService=s}),define(x[202],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(D){this.appenders=D}listen(D,M){throw new Error(`Event not found: ${M}`)}call(D,M,{eventName:E,data:g}){return this.appenders.forEach(b=>b.log(E,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class t{constructor(D){this.channel=D}log(D,M){return this.channel.call("log",{eventName:D,data:M}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(x[66],ee([0,1,50,85,12,17,32]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(u,c){return Promise.resolve(void 0)}publicLog2(u,c){return this.publicLog(u,c)}publicLogError(u,c){return Promise.resolve(void 0)}publicLogError2(u,c){return this.publicLogError(u,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class g{async publicLog(u,c,s){}async publicLogError(u,c,s){}}e.NullEndpointTelemetryService=g,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(m,u){return u.onDidChangeConfiguration(c=>{c.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(c.source),configurationKeys:p(c.sourceConfig)})})}e.configurationTelemetry=b;function k(m,u){return!(u.disableTelemetry||!m.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=k;function P(m){const u=m.getValue(M.TELEMETRY_SETTING_ID),c=m.getValue("telemetry.enableCrashReporter");if(m.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function I(m){const u=Object.create(null),c=Object.create(null),s=Object.create(null);h(m,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const i=s[l];typeof i=="number"?c[l]=i:typeof i=="boolean"?c[l]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${i.length}`),u[l]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(u[l]=i)}return{properties:u,measurements:c}}e.validateTelemetryData=I;const v=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(m){if(!m)return"none";for(const u of v)if(m.startsWith(`${u}+`))return u;return"other"}e.cleanRemoteAuthority=d;function h(m,u,c=0,s){if(!!m)for(let l of Object.getOwnPropertyNames(m)){const i=m[l],n=s?s+l:l;Array.isArray(i)?u[n]=(0,y.safeStringify)(i):i instanceof Date?u[n]=i.toISOString():(0,L.isObject)(i)?c<2?h(i,u,c+1,n+"."):u[n]=(0,y.safeStringify)(i):u[n]=i}}function p(m){if(!m)return[];const u=[];return w(u,"",m),u}function w(m,u,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(s=>w(m,u?`${u}.${s}`:s,c[s])):m.push(u)}function C(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=C}),define(x[203],ee([0,1,169,66]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(D,M,E,g,b,k){const P={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${M.nameShort})`},I=await(0,y.getServiceMachineId)(E,b,k);return(0,t.supportsTelemetry)(M,E)&&(0,t.getTelemetryLevel)(g)===3&&(P["X-Market-User-Id"]=I),P}e.resolveMarketplaceHeaders=L}),define(x[204],ee([0,1,2,50,85,3,28,153,17,56,54,19,40,32,66]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(C,m,u){this._configurationService=m,this._productService=u,this._experimentProperties={},this.telemetryLevel=new L.MutableObservableValue(3),this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appenders=C.appenders,this._commonProperties=C.commonProperties||Promise.resolve({}),this._piiPaths=C.piiPaths||[],this._sendErrorTelemetry=!!C.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(C,m){this._experimentProperties[C]=m}_updateTelemetryLevel(){let C=(0,d.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const u=m.usage?3:m.error?2:0;C=Math.min(C,u)}this.telemetryLevel.value=C}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const C=await this._commonProperties;let m=C.sessionID,u=C["common.machineId"],c=C["common.firstSessionDate"],s=C["common.msftInternal"];return{sessionId:m,machineId:u,firstSessionDate:c,msftInternal:s}}dispose(){this._disposables.dispose()}_log(C,m,u,c){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(s=>{u=(0,t.mixin)(u,s),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(C,u))},s=>{console.error(s)})}publicLog(C,m,u){return this._log(C,3,m,u)}publicLog2(C,m,u){return this.publicLog(C,m,u)}publicLogError(C,m){return this._sendErrorTelemetry?this._log(C,2,m,!0):Promise.resolve(void 0)}publicLogError2(C,m){return this.publicLogError(C,m)}_anonymizeFilePaths(C){let m=C;const u=[];for(let i of this._cleanupPatterns)for(;;){const n=i.exec(C);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const i=s.exec(C);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(m+=C.substring(l,i.index)+"<REDACTED: user-file-path>",l=s.lastIndex)}return l<C.length&&(m+=C.substr(l)),m}_removePropertiesWithPossibleUserInfo(C){if(!C)return C;const m=C.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(m))return`<REDACTED: ${c.label}`;return C}_cleanupInfo(C,m){let u=C;m&&(u=this._anonymizeFilePaths(u));for(let c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=de([ie(1,g.IConfigurationService),ie(2,P.IProductService)],h),e.TelemetryService=h;function p(){const w=(0,E.localize)(0,null,k.default.nameLong),C=k.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",k.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,E.localize)(3,null),u=(0,E.localize)(4,null),c=(0,E.localize)(5,null),s=(0,E.localize)(6,null),l=(0,E.localize)(7,null),i=`
|       | ${u} | ${c} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,E.localize)(8,null);return`
${w} ${C} ${m}

&nbsp;

${l}
${i}

&nbsp;

${n}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:k.default.privacyStatementUrl?(0,E.localize)(16,null,k.default.nameLong,k.default.privacyStatementUrl):(0,E.localize)(15,null,k.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(x[205],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var y;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST_DARK="hcDark",D.HIGH_CONTRAST_LIGHT="hcLight"})(y=e.ColorScheme||(e.ColorScheme={}));function t(D){return D===y.HIGH_CONTRAST_DARK||D===y.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function L(D){return D===y.DARK||D===y.HIGH_CONTRAST_DARK}e.isDark=L}),define(x[206],ee([0,1,109,4,2,5,40,205]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var g;(function(p){function w(C){return C&&typeof C=="object"&&typeof C.id=="string"}p.isThemeColor=w})(g=e.ThemeColor||(e.ThemeColor={}));function b(p){return{id:p}}e.themeColorFromId=b;var k;(function(p){function w(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||g.isThemeColor(n.color))}p.isThemeIcon=w;const C=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function m(n){const o=C.exec(n);if(!o)return;let[,r]=o;return{id:r}}p.fromString=m;function u(n){return{id:n}}p.fromId=u;function c(n,o){let r=n.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),o&&(r=`${r}~${o}`),{id:r}}p.modify=c;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}p.getModifier=s;function l(n,o){return n.id===o.id&&n.color?.id===o.color?.id}p.isEqual=l;function i(n,o){return{id:n.id,color:o?b(o):void 0}}p.asThemeIcon=i,p.asClassNameArray=y.CSSIcon.asClassNameArray,p.asClassName=y.CSSIcon.asClassName,p.asCSSSelector=y.CSSIcon.asCSSSelector})(k=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function P(p){switch(p){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,L.toDisposable)(()=>{const C=this.themingParticipants.indexOf(w);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new I;M.Registry.add(e.Extensions.ThemingContribution,v);function d(p){return v.onColorThemeChange(p)}e.registerThemingParticipant=d;class h extends L.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,C){let m=this.theme.getColor(w);return m&&C&&(m=C(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(x[58],ee([0,1,14,4,2,3,17,5,46]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const b="#FFFFFF",k="#1E1E1E",P="#000000",I="#FFFFFF",v="theme",d="themeBackground",h="windowSplash";e.IThemeMainService=(0,E.createDecorator)("themeMainService");let p=class extends L.Disposable{constructor(C,m){super();this.stateMainService=C,this.configurationService=m,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,y.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(D.isWindows){if(y.nativeTheme.shouldUseHighContrastColors)return{dark:y.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.isMacintosh){if(y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors)return{dark:y.nativeTheme.shouldUseDarkColors!==y.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.isLinux&&y.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:y.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const C=this.getColorScheme();if(C.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return C.dark?P:I;let m=this.stateMainService.getItem(d,null);if(!m)switch(this.stateMainService.getItem(v,"vs-dark").split(" ")[0]){case"vs":m=b;break;case"hc-black":m=P;break;case"hc-light":m=I;break;default:m=k}return D.isMacintosh&&m.toUpperCase()===k&&(m="#171717"),m}saveWindowSplash(C,m){this.stateMainService.setItems([{key:v,data:m.baseTheme},{key:d,data:m.colorInfo.background},{key:h,data:m}]),typeof C=="number"&&this.updateBackgroundColor(C,m)}updateBackgroundColor(C,m){for(const u of y.BrowserWindow.getAllWindows())if(u.id===C){u.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};p=de([ie(0,g.IStateMainService),ie(1,M.IConfigurationService)],p),e.ThemeMainService=p}),define(x[101],ee([0,1,4,3,5,6]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var M;(function(d){d.Http="http",d.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function I(d,h){return h?h!==1&&d<1024:!t.isWindows&&d<1024}e.isPortPrivileged=I;let v=class{constructor(h){this.logService=h,this._onTunnelOpened=new y.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new y.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new y.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],p=Array.from(this._tunnels.values());for(let w of p){const C=Array.from(w.values());for(let m of C){const u=await m.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:p}of h.values())await p.then(w=>w?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,p,w,C,m=!1,u,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${w} on local port ${C}.`),!h)return;p||(p="localhost");const s=this.retainOrCreateTunnel(h,p,w,C,m,u,c);return s?s.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(l);return(l.tunnelRemoteHost!==p||l.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const p=this._tunnels.get(h.tunnelRemoteHost);if(p){const w=p.get(h.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,w))}}}}async tryDisposeTunnel(h,p,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${p}.`);const C=w.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(p),C}}async closeTunnel(h,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${p} `);const w=this._tunnels.get(h);if(w&&w.has(p)){const C=w.get(p);C.refcount=0,await this.tryDisposeTunnel(h,p,C)}}addTunnelToMap(h,p,w){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(p,{refcount:1,value:w})}async removeEmptyTunnelFromMap(h,p){const w=this._tunnels.get(h);w&&(await w.get(p)||w.delete(p),w.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,p){let w=[h];k(h)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(h)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const C=w.map(m=>this._tunnels.get(m));for(const m of C){const u=m?.get(p);if(u)return u}}canTunnel(h){return!!b(h)}createWithProvider(h,p,w,C,m,u,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${w} on local port ${C}.`);const l={elevationRequired:m?I(C===void 0?w:C):!1},i={remoteAddress:{host:p,port:w},localAddressPort:C,privacy:u,public:u?u!==E.Private:void 0,protocol:c},n=h.forwardPort(i,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(p,w,n),n}};v=de([ie(0,D.ILogService)],v),e.AbstractTunnelService=v}),define(x[41],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(t=e.StateType||(e.StateType={}));var L;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,M)=>({type:"idle",updateType:D,error:M}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,y.createDecorator)("updateService")}),define(x[207],ee([0,1,3,154,56,40]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(x[208],ee([0,1,4,41]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(E){this.service=E}listen(E,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(E,g,b){switch(g){case"checkForUpdates":return this.service.checkForUpdates(b);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=L;class D{constructor(E){this.channel=E,this._onStateChange=new y.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(x[102],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,y.createDecorator)("urlService")}),define(x[209],ee([0,1,7]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(E){this.handler=E}listen(E,g){throw new Error(`Event not found: ${g}`)}call(E,g,b){switch(g){case"handleURL":return this.handler.handleURL(y.URI.revive(b[0]),b[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=t;class L{constructor(E){this.channel=E}handleURL(E,g){return this.channel.call("handleURL",[E.toJSON(),g])}}e.URLHandlerChannelClient=L;class D{constructor(E){this.next=E}async routeCall(E,g,b,k){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(b){const P=y.URI.revive(b);if(P&&P.query){const I=/\bwindowId=(\d+)/.exec(P.query);if(I){const v=I[1],d=new RegExp(`window:${v}`),h=E.connections.find(p=>d.test(p.ctx));if(h)return h}}}return this.next.routeCall(E,g,b,k)}routeEvent(E,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=D}),define(x[210],ee([0,1,9,2,7,19]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(b,k){const P=[...this.handlers.values()];return(0,y.first)(P.map(I=>()=>I.handleURL(b,k)),void 0,!1).then(I=>I||!1)}registerHandler(b){return this.handlers.add(b),(0,t.toDisposable)(()=>this.handlers.delete(b))}}e.AbstractURLService=M;let E=class extends M{constructor(b){super();this.productService=b}create(b){let{authority:k,path:P,query:I,fragment:v}=b||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return k&&P&&P.indexOf("/")!==0&&(P=`/${P}`),L.URI.from({scheme:this.productService.urlProtocol,authority:k,path:P,query:I,fragment:v})}};E=de([ie(0,D.IProductService)],E),e.NativeURLService=E}),define(x[211],ee([0,1,14,9,4,2,3,7]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(k){try{return E.URI.parse(k)}catch{return null}}class b{constructor(P,I,v,d,h){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=P,M.isWindows){const C=d.isBuilt?[]:[`"${d.appRoot}"`];C.push("--open-url","--"),y.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,C)}const p=L.Event.map(L.Event.fromNodeEventEmitter(y.app,"open-url",(C,m)=>({event:C,url:m})),({event:C,url:m})=>(C.preventDefault(),m));this.disposables.add(p(C=>{const m=g(C);!m||this.urlService.open(m,{originalUrl:C})})),v.getWindows().filter(C=>C.isReady).length>0?this.flush():L.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||P.push(I);P.length!==0&&(this.uris=P,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=b}),define(x[212],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,y.createDecorator)("webviewManagerService")}),define(x[213],ee([0,1,14,2,10,7]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);y.protocol.registerFileProtocol(L.Schemas.vscodeWebview,g)}handleWebviewRequest(g,b){try{const k=D.URI.parse(g.url),P=M.validWebviewFilePaths.get(k.path);if(typeof P=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${P}`,v=L.FileAccess.asFileUri(I,V);return b(decodeURIComponent(v.fsPath))}else return b({error:-10})}catch{}return b({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(x[67],ee([0,1,3]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function L(b){return!!b.folderUri}e.isFolderToOpen=L;function D(b){return!!b.fileUri}e.isFileToOpen=D;function M(b){const k=E(b),P=b.getValue("window.menuBarVisibility");return P==="default"||k==="native"&&P==="compact"||y.isMacintosh&&y.isNative?"classic":P}e.getMenuBarVisibility=M;function E(b){if(y.isWeb)return"custom";const k=b.getValue("window");if(k){if(y.isMacintosh&&k.nativeTabs===!0||y.isMacintosh&&k.nativeFullScreen===!1)return"native";const v=b.getValue("workbench.colorCustomizations");if(v?.["window.activeBorder"]||v?.["window.inactiveBorder"])return"custom";const d=k.titleBarStyle;if(d==="native"||d==="custom")return d}return y.isLinux?"native":"custom"}e.getTitleBarStyle=E;function g(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=g}),define(x[103],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var y;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(y=e.LoadReason||(e.LoadReason={}));var t;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const L=function(E=1){return{width:1024,height:768,mode:E}};e.defaultWindowState=L;var D;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var M;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.CRASHED=2]="CRASHED",E[E.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(x[34],ee([0,1,5]),function(V,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,y.createDecorator)("windowsMainService");var t;(function(L){L[L.CLI=0]="CLI",L[L.DOCK=1]="DOCK",L[L.MENU=2]="MENU",L[L.DIALOG=3]="DIALOG",L[L.DESKTOP=4]="DESKTOP",L[L.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(x[214],ee([0,1,14,23,4,72,2,31,62,94,6,19,34]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends M.Disposable{constructor(p,w,C,m,u){super();this.logService=p,this.windowsMainService=w,this.credentialsService=C,this.encryptionMainService=m,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=L.Event.fromNodeEventEmitter(y.app,"login",(w,C,m,u,c)=>({event:w,webContents:C,req:m,authInfo:u,callback:c}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:w,req:C,callback:m}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&C.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(u?.username,u?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(p);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const w=String((0,D.hash)({scheme:p.scheme,host:p.host,port:p.port}));let C,m;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(l){const i=JSON.parse(await this.encryptionMainService.decrypt(l));C=i.username,m=i.password}}catch(l){this.logService.error(l)}if(this.state!==v.StoredCredentialsUsed&&typeof C=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:C,password:m};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:p,username:this.sessionCredentials?.username??C,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=v.LoginDialogShown;const s=await new Promise(l=>{const i=async(n,o,r)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),r){const a={username:r.username,password:r.password};try{if(r.remember){const f=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w,f)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(f){this.logService.error(f)}l({username:a.username,password:a.password})}else l(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};d=de([ie(0,k.ILogService),ie(1,I.IWindowsMainService),ie(2,g.ICredentialsMainService),ie(3,b.IEncryptionMainService),ie(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(x[215],ee([0,1,62,6,53,19,34,180]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends E.BaseCredentialsMainService{constructor(k,P,I,v){super(k);this.environmentMainService=P,this.productService=I,this.windowsMainService=v,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new y.InMemoryCredentialsProvider,this._keytarCache;const k=await new Promise((P,I)=>{V(["keytar"],P,I)});return await k.findCredentials("test-keytar-loads"),this._keytarCache=k,this._keytarCache}};g=de([ie(0,t.ILogService),ie(1,L.INativeEnvironmentService),ie(2,D.IProductService),ie(3,M.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(x[216],ee([0,1,14,4,2,213,34]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends L.Disposable{constructor(b){super();this.windowsMainService=b,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(b,k){let P;if(typeof b.windowId=="number"){const{windowId:I}=b,v=this.windowsMainService.getWindowById(I);if(!v?.win)throw new Error(`Invalid windowId: ${I}`);P=v.win.webContents}else{const{webContentsId:I}=b;if(P=y.webContents.fromId(I),!P)throw new Error(`Invalid webContentsId: ${I}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(k)}async findInFrame(b,k,P,I){const d=this.getFrameByName(b,k);if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:I.findNext,forward:I.forward});const h=(p,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),d.removeListener("found-in-frame",h))};d.on("found-in-frame",h)}}async stopFindInFrame(b,k,P){const v=this.getFrameByName(b,k);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(b,k){const P=this.windowsMainService.getWindowById(b.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${b}`);const I=P.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===k);if(!I)throw new Error(`Unknown frame: ${k}`);return I}};E=de([ie(0,M.IWindowsMainService)],E),e.WebviewMainService=E}),define(x[217],ee([0,1,9,4,2]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends L.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:g,getActiveWindowId:b}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(E,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,y.createCancelablePromise)(()=>b()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(x[25],ee([0,1,157,8,35,16,7,5,10]),function(V,e,y,t,L,D,M,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function b(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b;function k(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=k;function P(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=P;function I(i){const n=i;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=I;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function h(i){const n=i;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class p{constructor(n,o,r,a,f){this._id=n,this._transient=r,this._configuration=a,this._ignorePathCasing=f,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class w{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function C(i){return new w({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return M.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=c;function s(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=s;function l(i){return(typeof i=="string"?(0,t.extname)(i):(0,D.extname)(i))===m}e.hasWorkspaceFileExtension=l}),define(x[48],ee([0,1,14,9,72,33,2,73,3,12,20,139,5,6,25]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,I.createDecorator)("dialogMainService");let h=class{constructor(w){this.logService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(w,C){return this.doPick({...w,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},C)}pickFolder(w,C){return this.doPick({...w,pickFolders:!0,title:(0,P.localize)(1,null)},C)}pickFile(w,C){return this.doPick({...w,pickFiles:!0,title:(0,P.localize)(2,null)},C)}pickWorkspace(w,C){const m=(0,P.localize)(3,null),u=(0,D.mnemonicButtonLabel)((0,P.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...w,pickFiles:!0,title:m,filters:c,buttonLabel:u},C)}async doPick(w,C){const m={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(m.properties=void 0,w.pickFiles&&w.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&m.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(m,(0,b.withNullAsUndefined)(C||y.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(w){if(w){let C=this.windowDialogQueues.get(w.id);return C||(C=new t.Queue,this.windowDialogQueues.set(w.id,C)),C}else return this.noWindowDialogueQueue}showMessageBox(w,C){return this.getWindowDialogQueue(C).queue(async()=>C?y.dialog.showMessageBox(C,w):y.dialog.showMessageBox(w))}async showSaveDialog(w,C){const m=this.acquireFileDialogLock(w,C);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(C).queue(async()=>{let u;return C?u=await y.dialog.showSaveDialog(C,w):u=await y.dialog.showSaveDialog(w),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,M.dispose)(m)}}normalizePath(w){return w&&g.isMacintosh&&(w=(0,E.normalizeNFC)(w)),w}normalizePaths(w){return w.map(C=>this.normalizePath(C))}async showOpenDialog(w,C){w.defaultPath&&(await k.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const m=this.acquireFileDialogLock(w,C);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(C).queue(async()=>{let u;return C?u=await y.dialog.showOpenDialog(C,w):u=await y.dialog.showOpenDialog(w),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,M.dispose)(m)}}acquireFileDialogLock(w,C){if(!C)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",w);let m=this.windowFileDialogLocks.get(C.id);m||(m=new Set,this.windowFileDialogLocks.set(C.id,m));const u=(0,L.hash)(w);if(!m.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",w),m.add(u),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",w),m?.delete(u),m?.size===0&&this.windowFileDialogLocks.delete(C.id)})}};h=de([ie(0,v.ILogService)],h),e.DialogMainService=h}),define(x[218],ee([0,1,4,2,25]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(E,g){super();this.logService=E,this.storageMainService=g,this._onDidChangeGlobalStorage=this._register(new y.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(y.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,g)=>(E?E.push(g):E=[g],E),D.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const g=new Map,b=new Set;return E.forEach(k=>{const P=this.storageMainService.globalStorage.get(k.key);typeof P=="string"?g.set(k.key,P):b.add(k.key)}),{changed:Array.from(g.entries()),deleted:Array.from(b.values())}}listen(E,g){switch(g){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${g}`)}async call(E,g,b){const k=(0,L.reviveIdentifier)(b.workspace),P=await this.withStorageInitialized(k);switch(g){case"getItems":return Array.from(P.items.entries());case"updateItems":{const I=b;if(I.insert)for(const[v,d]of I.insert)P.set(v,d);I.delete&&I.delete.forEach(v=>P.delete(v));break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(E){const g=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await g.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${b}`)}return g}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(x[219],ee([0,1,26,9,4,2,8,71,7,20,92,130,6,100,32,25]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends D.Disposable{constructor(c,s,l){super();this.logService=c,this.fileService=s,this.telemetryService=l,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new k.Storage(new k.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=k.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===k.StorageState.None)try{const c=await this.doCreate();this._storage.dispose(),this._storage=c,this._register(c.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(c);const s=c.getBoolean(v.IS_NEW_KEY);s===void 0?c.set(v.IS_NEW_KEY,!0):s&&c.set(v.IS_NEW_KEY,!1)}catch(c){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.state=k.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===I.LogLevel.Trace?c=>this.logService.trace(c):void 0,logError:c=>this.logService.error(c)}}doInit(c){return c.init()}get items(){return this._storage.items}get(c,s){return this._storage.get(c,s)}set(c,s){return this._storage.set(c,s)}delete(c){return this._storage.delete(c)}async close(){const c=new E.StopWatch(!1);await this.doClose(),c.stop(),c.elapsed()>p.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(c),this._onDidCloseStorage.fire()}async logSlowClose(c){if(!!this.path)try{const s=(0,y.top)(Array.from(this._storage.items.entries()).map(([i,n])=>({key:i,length:n.length})),(i,n)=>n.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),l=(await this.fileService.stat(g.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${l}b, Large Keys: ${s}`),this.telemetryService.publicLog2("storageSlowClose",{duration:c.elapsed(),size:l,largestEntries:s})}catch(s){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=k.StorageState.Closed,await this._storage.close()}}p.LOG_SLOW_CLOSE_THRESHOLD=300;class w extends p{constructor(c,s,l,i,n){super(s,i,n);this.options=c,this.environmentService=l}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME)}async doCreate(){return new k.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}async doInit(c){await super.doInit(c),this.updateTelemetryState(c)}updateTelemetryState(c){c.get(d.firstSessionDateStorageKey,void 0)===void 0&&c.set(d.firstSessionDateStorageKey,new Date().toUTCString());const l=c.get(d.currentSessionDateStorageKey,void 0),i=new Date().toUTCString();c.set(d.lastSessionDateStorageKey,typeof l=="undefined"?null:l),c.set(d.currentSessionDateStorageKey,i)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class C extends p{constructor(c,s,l,i,n,o){super(l,n,o);this.workspace=c,this.options=s,this.environmentService=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,C.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:c,wasCreated:s}=await this.prepareWorkspaceStorageFolder();return new k.Storage(new P.SQLiteStorageDatabase(c,{logging:this.createLoggingOptions()}),{hint:s?k.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),s=(0,M.join)(c,C.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(c)?{storageFilePath:s,wasCreated:!1}:(await b.Promises.mkdir(c,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(c),{storageFilePath:s,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(c){let s;if((0,h.isSingleFolderWorkspaceIdentifier)(this.workspace)?s={folder:this.workspace.uri.toString()}:(0,h.isWorkspaceIdentifier)(this.workspace)&&(s={workspace:this.workspace.configPath.toString()}),s)try{const l=(0,M.join)(c,C.WORKSPACE_META_NAME);await b.Promises.exists(l)||await b.Promises.writeFile(l,JSON.stringify(s,void 0,2))}catch(l){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=C,C.WORKSPACE_STORAGE_NAME="state.vscdb",C.WORKSPACE_META_NAME="workspace.json";class m extends p{get path(){}async doCreate(){return new k.Storage(new k.InMemoryStorageDatabase)}}e.InMemoryStorageMain=m}),define(x[104],ee([0,1,16,7,25]),function(V,e,y,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(g,b,k){for(const I of g){const v=I.openedWorkspace;if((0,L.isWorkspaceIdentifier)(v)){const d=k(v);if(d){if(d.folders.some(h=>y.extUriBiasedIgnorePathCase.isEqualOrParent(b,h.uri)))return I}else if(y.extUriBiasedIgnorePathCase.isEqualOrParent(b,v.configPath))return I}}const P=g.filter(I=>(0,L.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqualOrParent(b,I.openedWorkspace.uri));if(P.length)return P.sort((I,v)=>-(I.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function M(g,b){for(const k of g)if((0,L.isWorkspaceIdentifier)(k.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(k.openedWorkspace.configPath,b)||(0,L.isSingleFolderWorkspaceIdentifier)(k.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(k.openedWorkspace.uri,b))return k}e.findWindowOnWorkspaceOrFolder=M;function E(g,b){const k=P=>b.some(I=>y.extUriBiasedIgnorePathCase.isEqual(t.URI.file(I),t.URI.file(P)));for(const P of g)if(P.config?.extensionDevelopmentPath?.some(I=>k(I)))return P}e.findWindowOnExtensionDevelopmentPath=E}),define(x[220],ee([0,1,14,2,3,16,7,17,22,6,46,34,103,25]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class It extends t.Disposable{constructor(u,c,s,l,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=s,this.logService=l,this.configurationService=i,this._state=h(this.stateMainService.getItem(It.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){y.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let l=this.windowsMainService.getLastActiveWindow();(!l||l.isExtensionDevelopmentHost)&&(l=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),l&&(u.lastActiveWindow=this.toWindowState(l))}const c=this.windowsMainService.getWindows().find(l=>l.isExtensionDevelopmentHost&&!l.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(l=>!l.isExtensionDevelopmentHost).map(l=>this.toWindowState(l)));const s=w(u);this.stateMainService.setItem(It.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(s=>{const l=(0,v.isWorkspaceIdentifier)(u.openedWorkspace)&&s.workspace?.id===u.openedWorkspace.id,i=(0,v.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&s.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(s.folderUri,u.openedWorkspace.uri);(l||i)&&(s.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,v.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,v.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),s=this.configurationService.getValue("window");let l;return c.hasDefaultState?l=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(l=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),l&&L.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(l=!1)),c.mode===3&&!l&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=u.workspace;if((0,v.isWorkspaceIdentifier)(r)){const f=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===r.id).map(S=>S.uiState);if(f.length)return f[0]}if((0,v.isSingleFolderWorkspaceIdentifier)(r)){const f=this.state.openedWindows.filter(S=>S.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(S.folderUri,r.uri)).map(S=>S.uiState);if(f.length)return f[0]}else if(u.backupPath){const f=this.state.openedWindows.filter(S=>S.backupPath===u.backupPath).map(S=>S.uiState);if(f.length)return f[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!c&&a)return a.uiState}let s;const l=y.screen.getAllDisplays();if(l.length===1)s=l[0];else{if(L.isMacintosh){const r=y.screen.getCursorScreenPoint();s=y.screen.getDisplayNearestPoint(r)}!s&&c&&(s=y.screen.getDisplayMatching(c.getBounds())),s||(s=y.screen.getPrimaryDisplay()||l[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(s.bounds.x+s.bounds.width/2-i.width/2),i.y=Math.round(s.bounds.y+s.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const r=c.serializeWindowState();r.mode===3?i.mode=3:i=r,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;c.some(s=>s.x===u.x||s.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=de([ie(0,P.IWindowsMainService),ie(1,k.IStateMainService),ie(2,g.ILifecycleMainService),ie(3,b.ILogService),ie(4,E.IConfigurationService)],d),e.WindowsStateHandler=d;function h(m){const u={openedWindows:[]},c=m||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=p(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=p(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(s=>p(s))),u}e.restoreWindowsState=h;function p(m){const u={uiState:m.uiState};return m.backupPath&&(u.backupPath=m.backupPath),m.remoteAuthority&&(u.remoteAuthority=m.remoteAuthority),m.folder&&(u.folderUri=M.URI.parse(m.folder)),m.workspaceIdentifier&&(u.workspace={id:m.workspaceIdentifier.id,configPath:M.URI.parse(m.workspaceIdentifier.configURIPath)}),u}function w(m){return{lastActiveWindow:m.lastActiveWindow&&C(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&C(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(u=>C(u))}}e.getWindowsStateStoreData=w;function C(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(x[81],ee([0,1,29,44,112,33,10,8,3,16,7,5,65,25]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function d(S){return S.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function h(S){return S.hasOwnProperty("folderUri")}e.isRecentFolder=h;function p(S){return S.hasOwnProperty("fileUri")}e.isRecentFile=p;function w(S){return C(S)||m(S)}e.isStoredWorkspaceFolder=w;function C(S){const R=S;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function m(S){const R=S;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function u(S,R,A,F,$=!g.isWindows,J){if(S.scheme!==F.scheme)return{name:A,uri:S.toString(!0)};let ne=R?void 0:J.relativePath(F,S);if(ne!==void 0)ne.length===0?ne=".":g.isWindows&&S.scheme===M.Schemas.file&&!$&&(ne=ne.replace(/\//g,"\\"));else if(S.scheme===M.Schemas.file)ne=S.fsPath,g.isWindows&&(ne=(0,D.normalizeDriveLetter)(ne),$&&(ne=(0,y.toSlashes)(ne)));else{if(!J.isEqualAuthority(S.authority,F.authority))return{name:A,uri:S.toString(!0)};ne=S.path}return{name:A,path:ne}}e.getStoredWorkspaceFolder=u;function c(S,R,A){let F=[],$=new Set;const J=A.dirname(R);for(let ne of S){let Y;if(C(ne))ne.path&&(Y=A.resolvePath(J,ne.path));else if(m(ne))try{Y=k.URI.parse(ne.uri),Y.path[0]!=="/"&&(Y=Y.with({path:"/"+Y.path}))}catch(re){console.warn(re)}if(Y){let re=A.getComparisonKey(Y);if(!$.has(re)){$.add(re);const H=ne.name||A.basenameOrAuthority(Y);F.push(new v.WorkspaceFolder({uri:Y,name:H,index:F.length},ne))}}}return F}e.toWorkspaceFolders=c;function s(S,R,A,F,$){let J=l(R,S);const ne=$.dirname(R),Y=$.dirname(F),re=[],H=i(J.folders);for(const z of J.folders){const K=C(z)?$.resolvePath(ne,z.path):k.URI.parse(z.uri);let te;A?te=!1:te=!C(z)||(0,E.isAbsolute)(z.path),re.push(u(K,te,z.name,Y,H,$))}const X={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},j=L.setProperty(S,["folders"],re,X);let B=L.applyEdits(S,j);return(0,b.isEqualAuthority)(J.remoteAuthority,(0,I.getRemoteAuthority)(F))&&(B=L.applyEdits(B,L.removeProperty(B,["remoteAuthority"],X))),B}e.rewriteWorkspaceFileForNewLocation=s;function l(S,R){let A=t.parse(R);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(F=>w(F));else throw new Error(`${S} looks like an invalid workspace file.`);return A}function i(S){return g.isWindows?S.some(R=>C(R)&&R.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function n(S){return S.workspace&&typeof S.workspace=="object"&&typeof S.workspace.id=="string"&&typeof S.workspace.configPath=="string"}function o(S){return typeof S.folderUri=="string"}function r(S){return typeof S.fileUri=="string"}function a(S,R){const A={workspaces:[],files:[]};if(S){const F=function(J,ne){for(let Y=0;Y<J.length;Y++)try{ne(J[Y],Y)}catch(re){R.warn(`Error restoring recent entry ${JSON.stringify(J[Y])}: ${re.toString()}. Skip entry.`)}},$=S;Array.isArray($.entries)&&F($.entries,J=>{const ne=J.label,Y=J.remoteAuthority;n(J)?A.workspaces.push({label:ne,remoteAuthority:Y,workspace:{id:J.workspace.id,configPath:k.URI.parse(J.workspace.configPath)}}):o(J)?A.workspaces.push({label:ne,remoteAuthority:Y,folderUri:k.URI.parse(J.folderUri)}):r(J)&&A.files.push({label:ne,remoteAuthority:Y,fileUri:k.URI.parse(J.fileUri)})})}return A}e.restoreRecentlyOpened=a;function f(S){const R={entries:[]};for(const A of S.workspaces)h(A)?R.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):R.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of S.files)R.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return R}e.toStoreData=f}),define(x[105],ee([0,1,60,30,10,3,16]),function(V,e,y,t,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(b){function k(){let P=b.scheme===L.Schemas.file?(0,M.originalFSPath)(b):b.toString();return D.isLinux||(P=P.toLowerCase()),(0,y.createHash)("md5").update(P).digest("hex")}return{id:k(),configPath:b}}e.getWorkspaceIdentifier=E;function g(b,k){function P(){if(b.scheme!==L.Schemas.file)return(0,y.createHash)("md5").update(b.toString()).digest("hex");if(!k)try{k=(0,t.statSync)(b.fsPath)}catch{return}let v;return D.isLinux?v=k.ino:D.isMacintosh?v=k.birthtime.getTime():D.isWindows&&(typeof k.birthtimeMs=="number"?v=Math.floor(k.birthtimeMs):v=k.birthtime.getTime()),(0,y.createHash)("md5").update(b.fsPath).update(v?String(v):"").digest("hex")}const I=P();if(typeof I=="string")return{id:I,uri:b}}e.getSingleFolderWorkspaceIdentifier=g}),define(x[221],ee([0,1,15,4,10,6,246,119,22,71]),function(V,e,y,t,L,D,M,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class k{constructor(d,h){this._worker=new M.Worker(L.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",d),this._worker.on("error",h),this.onError=t.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=t.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=t.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(d,h){this._worker.postMessage(d,h)}dispose(){this._worker.terminate()}}let P=class{constructor(d){this._logService=d}async logInfo(d){this._logService.info(d)}};P=de([ie(0,D.ILogService)],P);let I=class{constructor(d,h){this._logService=d,this._shutdown=!1,this._proxy=null;const p={create:(w,C,m)=>{const u=new k(C,m);return u.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),u.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),u.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),u.postMessage(w,[]),u}};this._worker=new E.SimpleWorkerClient(p,"vs/platform/extensions/node/extensionHostStarterWorker",new P(this._logService)),this._initialize(),h.onWillShutdown(w=>{this._shutdown=!0,this._proxy&&w.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(d){return this._proxy.onDynamicStdout(d)}onDynamicStderr(d){return this._proxy.onDynamicStderr(d)}onDynamicMessage(d){return this._proxy.onDynamicMessage(d)}onDynamicError(d){return this._proxy.onDynamicError(d)}onDynamicExit(d){return this._proxy.onDynamicExit(d)}async createExtensionHost(){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,y.canceled)();return d.createExtensionHost()}async start(d,h){const p=b.StopWatch.create(!1),w=await this._worker.getProxyObject();if(this._shutdown)throw(0,y.canceled)();const C=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),m=await w.start(d,h),u=p.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${u} ms.`),clearTimeout(C),m}async enableInspectPort(d){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,y.canceled)();return h.enableInspectPort(d)}async kill(d){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,y.canceled)();return h.kill(d)}};I=de([ie(0,D.ILogService),ie(1,g.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(x[82],ee([0,1,60,61,27,18,15,4,2,8,3,31,38,90,222]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(R,A=""){this.debugLabel=A,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,M.onUnexpectedError)(F)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,A){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const A=F=>{this.traceSocketEvent("read",F),R(D.VSBuffer.wrap(F))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(R){const A=F=>{this.traceSocketEvent("close",{hadError:F}),R({type:0,hadError:F,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(R){const A=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,M.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,M.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=h;var p;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var w;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(w||(w={}));class C extends g.Disposable{constructor(R,A,F,$){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:F?.byteLength||0,recordInflateBytes:$}),this._flowManager=this._register(new m(this,A,F,$,this._onData,(J,ne)=>this._write(J,ne))),this._register(this._flowManager.onError(J=>{console.error(J),(0,M.onUnexpectedError)(J),this._onClose.fire({type:0,hadError:!0,error:J})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(J=>this._acceptChunk(J))),this._register(this.socket.onClose(J=>this._onClose.fire(J)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,A){this.socket.traceSocketEvent(R,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let F=2;R.byteLength<126?F+=0:R.byteLength<2**16?F+=2:F+=8;const $=D.VSBuffer.alloc(F);if(A?$.writeUInt8(194,0):$.writeUInt8(130,0),R.byteLength<126)$.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){$.writeUInt8(126,1);let J=1;$.writeUInt8(R.byteLength>>>8&255,++J),$.writeUInt8(R.byteLength>>>0&255,++J)}else{$.writeUInt8(127,1);let J=1;$.writeUInt8(0,++J),$.writeUInt8(0,++J),$.writeUInt8(0,++J),$.writeUInt8(0,++J),$.writeUInt8(R.byteLength>>>24&255,++J),$.writeUInt8(R.byteLength>>>16&255,++J),$.writeUInt8(R.byteLength>>>8&255,++J),$.writeUInt8(R.byteLength>>>0&255,++J)}this.socket.write(D.VSBuffer.concat([$,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),F=A.readUInt8(0),$=(F&128)>>>7,J=(F&64)>>>6,ne=A.readUInt8(1),Y=(ne&128)>>>7,re=ne&127;this._state.state=2,this._state.readLen=2+(Y?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=$,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(J)),this._state.firstFrameOfMessage=Boolean($),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),$=(F&128)>>>7;let J=F&127,ne=1;J===126?J=A.readUInt8(++ne)*2**8+A.readUInt8(++ne):J===127&&(J=A.readUInt8(++ne)*0+A.readUInt8(++ne)*0+A.readUInt8(++ne)*0+A.readUInt8(++ne)*0+A.readUInt8(++ne)*2**24+A.readUInt8(++ne)*2**16+A.readUInt8(++ne)*2**8+A.readUInt8(++ne));let Y=0;$&&(Y=A.readUInt8(++ne)*2**24+A.readUInt8(++ne)*2**16+A.readUInt8(++ne)*2**8+A.readUInt8(++ne)),this._state.state=3,this._state.readLen=J,this._state.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),s(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class m extends g.Disposable{constructor(R,A,F,$,J,ne){super();this._tracer=R,this._onData=J,this._writeFn=ne,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new u(this._tracer,$,F,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Y=>this._onError.fire(Y))),this._register(this._zlibDeflateStream.onError(Y=>this._onError.fire(Y)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(A,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,A){return new Promise((F,$)=>{R.write(A),R.flush(J=>F(J))})}acceptFrame(R,A,F){this._readQueue.push({data:R,isCompressed:A,isLastFrameOfMessage:F}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,A,F){return new Promise(($,J)=>{R.write(A),F&&R.write(D.VSBuffer.fromByteArray([0,0,255,255])),R.flush(ne=>$(ne))})}}class u extends g.Disposable{constructor(R,A,F,$){super();this._tracer=R,this._recordInflateBytes=A,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw($),this._zlibInflate.on("error",J=>{this._tracer.traceSocketEvent("zlibInflateError",{message:J?.message,code:J?.code}),this._onError.fire(J)}),this._zlibInflate.on("data",J=>{this._tracer.traceSocketEvent("zlibInflateData",J),this._pendingInflateData.push(D.VSBuffer.wrap(J))}),F&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(A)})}}class c extends g.Disposable{constructor(R,A){super();this._tracer=R,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibDeflate.on("data",F=>{this._tracer.traceSocketEvent("zlibDeflateData",F),this._pendingDeflateData.push(D.VSBuffer.wrap(F))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),R(A)})}}function s(S,R){if(R===0)return;let A=S.byteLength>>>2;for(let re=0;re<A;re++){const H=S.readUInt32BE(re*4);S.writeUInt32BE(H^R,re*4)}let F=A*4,$=S.byteLength-F;const J=R>>>24&255,ne=R>>>16&255,Y=R>>>8&255;$>=1&&S.writeUInt8(S.readUInt8(F)^J,F),$>=2&&S.writeUInt8(S.readUInt8(F+1)^ne,F+1),$>=3&&S.writeUInt8(S.readUInt8(F+2)^Y,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const S=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):R=(0,b.join)((0,L.tmpdir)(),`vscode-ipc-${S}.sock`),o(R),R}e.createRandomIPCHandle=i;function n(S,R,A){const F=(0,y.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${R}-sock`;let $;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?$=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${R}.sock`):$=(0,b.join)(S,`${A}-${R}.sock`),o($),$}e.createStaticIPCHandle=n;function o(S){const R=l[k.platform];typeof R=="number"&&S.length>=R&&console.warn(`WARNING: IPC handle "${S}" is longer than ${R} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{constructor(R){super(r.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const A=E.Event.fromNodeEventEmitter(R,"connection");return E.Event.map(A,F=>({protocol:new v.Protocol(new h(F,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(S){return new Promise((R,A)=>{const F=(0,t.createServer)();F.on("error",A),F.listen(S,()=>{F.removeListener("error",A),R(new r(F))})})}e.serve=a;function f(S,R){return new Promise((A,F)=>{const $=(0,t.createConnection)(S,()=>{$.removeListener("error",F),A(v.Client.fromSocket(new h($,`ipc-client${R}`),R))});$.once("error",F)})}e.connect=f}),define(x[24],ee([0,1,47,8,82,53,167,5]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(D.IEnvironmentService);class g extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,L.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([y.memoize],g.prototype,"cachedLanguagesPath",null),de([y.memoize],g.prototype,"backupHome",null),de([y.memoize],g.prototype,"backupWorkspacesPath",null),de([y.memoize],g.prototype,"mainIPCHandle",null),de([y.memoize],g.prototype,"mainLockfile",null),de([y.memoize],g.prototype,"sandbox",null),de([y.memoize],g.prototype,"disableUpdates",null),de([y.memoize],g.prototype,"disableKeytar",null),de([y.memoize],g.prototype,"codeCachePath",null),de([y.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(x[223],ee([0,1,60,30,29,10,8,3,16,7,20,161,17,24,21,6,160,25]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let C=class{constructor(u,c,s){this.configurationService=c,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(l,i)=>(0,L.isEqual)(l,i,!E.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await k.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(l=>({workspace:{id:l.id,configPath:b.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let s=[];try{Array.isArray(u.folderWorkspaceInfos)?s=u.folderWorkspaceInfos.map(l=>({folderUri:b.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(s=u.folderURIWorkspaces.map(l=>({folderUri:b.URI.parse(l),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(l=>u.workspace.id===l.workspace.id)||(this.workspaces.push(u),this.saveSync());const s=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(s,c),s}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,s=this.workspaces.findIndex(l=>l.workspace.id===c);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(s=>this.backupUriComparer.isEqual(u,s.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const s=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:c}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,M.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,s=[];for(let l of u){const i=l.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==D.Schemas.file||await k.Promises.exists(i.configPath.fsPath)?s.push(l):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return s}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(let l of u){const i=l.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!s.has(n)){s.add(n);const o=this.getBackupPath(this.getFolderHash(l));await this.doHasBackups(o)?i.scheme!==D.Schemas.file||await k.Promises.exists(i.fsPath)?c.push(l):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(let l of u){const i=l.backupFolder;if(typeof i!="string")return[];if(!s.has(i)){s.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(l):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await k.Promises.exists(u)&&await k.Promises.rm(u,k.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{await k.Promises.rename(u,s)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{t.renameSync(u,s)}catch(l){return this.logService.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,P.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,p.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await k.Promises.readdir(u);for(const s of c)try{if((await k.Promises.readdir((0,M.join)(u,s))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,k.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await k.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let s;return c.scheme===D.Schemas.file?s=E.isLinux?c.fsPath:c.fsPath.toLowerCase():s=c.toString().toLowerCase(),(0,y.createHash)("md5").update(s).digest("hex")}};C=de([ie(0,v.IEnvironmentMainService),ie(1,I.IConfigurationService),ie(2,h.ILogService)],C),e.BackupMainService=C}),define(x[224],ee([0,1,61,82]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,D,M,E,g,b){const k=I=>b(I,void 0),P=y.createConnection({host:L,port:D},()=>{P.removeListener("error",k);const I=Buffer.alloc(16);for(let p=0;p<16;p++)I[p]=Math.round(Math.random()*256);const v=I.toString("base64"),d=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${D}${M}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];P.write(d.join(`\r
`)+`\r
\r
`);const h=p=>{p.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),b(void 0,new t.NodeSocket(P,g)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",k)}}}),define(x[225],ee([0,1,197,9,18,15,2,12,17,53,99,6,196,222]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(p,w,C){super();this.environmentService=w,this.logService=C,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,w){this.logService.trace("RequestService#request (node) - begin",p.url);const{proxyUrl:C,strictSSL:m}=this;let u;try{u=await(0,k.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",l))}const c={...process.env,...u},s=p.agent?p.agent:await(0,I.getProxyAgent)(p.url||"",c,{proxyUrl:C,strictSSL:m});p.agent=s,p.strictSSL=m,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization});try{const l=await this._request(p,w);return this.logService.trace("RequestService#request (node) - success",p.url),l}catch(l){throw this.logService.trace("RequestService#request (node) - error",p.url,l),l}}async getNodeRequest(p){return((0,y.parse)(p.url).protocol==="https:"?await new Promise((m,u)=>{V(["https"],m,u)}):await new Promise((m,u)=>{V(["http"],m,u)})).request}_request(p,w){return t.Promises.withAsyncBody(async(C,m)=>{let u;const c=(0,y.parse)(p.url),s=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,E.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(l.auth=p.user+":"+p.password),u=s(l,i=>{const n=(0,E.isNumber)(p.followRedirects)?p.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...p,url:i.headers.location,followRedirects:n-1},w).then(C,m);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,v.createGunzip)())),C({res:i,stream:(0,L.streamToBufferReadableStream)(o)})}}),u.on("error",m),p.timeout&&u.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&u.write(p.data),u.end(),w.onCancellationRequested(()=>{u.abort(),m((0,D.canceled)())})})}async resolveProxy(p){}};d=de([ie(0,g.IConfigurationService),ie(1,b.INativeEnvironmentService),ie(2,P.ILogService)],d),e.RequestService=d}),define(x[226],ee([0,1,14,225]),function(V,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(M){return y.net.request}class D extends t.RequestService{request(E,g){return super.request({...E||{},getRawRequest:L},g)}}e.RequestMainService=D}),define(x[227],ee([0,1,14,37,9,4,2,10,12,91,24,22,6,54,55,58,39]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends M.Disposable{constructor(m,u,c,s,l,i,n){super();this.machineId=m,this.userEnv=u,this.environmentMainService=c,this.lifecycleMainService=s,this.logService=l,this.themeMainService=i,this.protocolMainService=n,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(m,u)=>this.onWindowConnection(m,u)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(m,u)=>this.onWorkerConnection(m,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(m,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(m.sender.isDestroyed())return c.close();m.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[c])}onWorkerConnection(m,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const c=new M.DisposableStore,s=i=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${i}')`,u),c.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},l=y.BrowserWindow.fromId(u.reply.windowId);if(!l||l.isDestroyed()||l.webContents.isDestroyed()||!u.reply.channel){s("unavailable");return}c.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,i=>i.window.win===l)(()=>s("load"))),c.add(D.Event.fromNodeEventEmitter(l,"closed")(()=>s("closed"))),l.webContents.postMessage(u.reply.channel,u.reply.nonce,m.ports)}onWillShutdown(){const m=this.window;!m||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(m.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{m.close()}catch{}this.window=void 0},0))}send(m,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${m}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(m,...u)}catch(c){this.logService.warn(`Error sending IPC message to channel '${m}' of shared process: ${(0,p.toErrorMessage)(c)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),m()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),m()}))})()),this._whenIpcReady}createWindow(){const m=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new y.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${m.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),m.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=m=>{this.logService.trace("SharedProcess#close prevented"),m.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(m,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(m,u,c)=>this._onDidError.fire({type:3,details:{reason:c,exitCode:u}})))}async connect(){await this.whenIpcReady;const m=(0,g.assertIsDefined)(this.window);return(0,b.connect)(m)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const m=this.window;return m?!m.isDestroyed()&&!m.webContents.isDestroyed():!1}};w=de([ie(2,k.IEnvironmentMainService),ie(3,P.ILifecycleMainService),ie(4,I.ILogService),ie(5,h.IThemeMainService),ie(6,d.IProtocolMainService)],w),e.SharedProcess=w}),define(x[228],ee([0,1,9,18,8,16,12,7,20,24,21,6]),function(V,e,y,t,L,D,M,E,g,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class I{constructor(h,p,w){this.storagePath=h,this.logService=p,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new y.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==1&&this.logService.error(h)}}getItem(h,p){const w=this.storage[h];return(0,M.isUndefinedOrNull)(w)?p:w}setItem(h,p){this.setItems([{key:h,data:p}])}setItems(h){let p=!1;for(const{key:w,data:C}of h)this.storage[w]!==C&&((0,M.isUndefinedOrNull)(C)?(0,M.isUndefined)(this.storage[w])||(this.storage[w]=void 0,p=!0):(this.storage[w]=C,p=!0));p&&this.save()}removeItem(h){(0,M.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(h){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),h)}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(h)),this.lastSavedStorageContents=h}catch(p){this.logService.error(p)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=I;let v=class kt{constructor(h,p,w){this.environmentMainService=h,this.logService=p,this.legacyStateFilePath=E.URI.file((0,L.join)(this.environmentMainService.userDataPath,kt.STATE_FILE)),this.stateFilePath=(0,D.joinPath)(this.environmentMainService.globalStorageHome,kt.STATE_FILE),this.fileStorage=new I(this.stateFilePath,p,w)}async init(){try{await g.Promises.move(this.legacyStateFilePath.fsPath,this.stateFilePath.fsPath)}catch(h){h.code!=="ENOENT"&&this.logService.error(h)}return this.fileStorage.init()}getItem(h,p){return this.fileStorage.getItem(h,p)}setItem(h,p){this.fileStorage.setItem(h,p)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}};v.STATE_FILE="storage.json",v=de([ie(0,b.IEnvironmentMainService),ie(1,P.ILogService),ie(2,k.IFileService)],v),e.StateMainService=v}),define(x[83],ee([0,1,43,2,53,24,21,5,22,6,100,219,32]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,E.createDecorator)("storageMainService");let v=class extends t.Disposable{constructor(p,w,C,m,u){super();this.logService=p,this.environmentService=w,this.lifecycleMainService=C,this.fileService=m,this.telemetryService=u,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(p=>{p.workspace&&this.workspaceStorage(p.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(p=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=p.reason,p.join(this.globalStorage.close());for(const[,w]of this.mapWorkspaceToStorage)p.join(w.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const p=new P.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService,this.fileService,this.telemetryService);return(0,y.once)(p.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),p}workspaceStorage(p){let w=this.mapWorkspaceToStorage.get(p.id);return w||(this.logService.trace(`StorageMainService: creating workspace storage (${p.id})`),w=this.createWorkspaceStorage(p),this.mapWorkspaceToStorage.set(p.id,w),(0,y.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${p.id})`),this.mapWorkspaceToStorage.delete(p.id)})),w}createWorkspaceStorage(p){return this.shutdownReason===2?new P.InMemoryStorageMain(this.logService,this.fileService,this.telemetryService):new P.WorkspaceStorageMain(p,this.getStorageOptions(),this.logService,this.environmentService,this.fileService,this.telemetryService)}};v=de([ie(0,b.ILogService),ie(1,L.IEnvironmentService),ie(2,g.ILifecycleMainService),ie(3,M.IFileService),ie(4,I.ITelemetryService)],v),e.StorageMainService=v,e.IGlobalStorageMainService=(0,E.createDecorator)("globalStorageMainService");let d=class extends k.AbstractStorageService{constructor(p,w){super();this.environmentMainService=p,this.storageMainService=w,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(p){switch(p){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(p){return p===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};d=de([ie(0,D.IEnvironmentMainService),ie(1,e.IStorageMainService)],d),e.GlobalStorageMainService=d}),define(x[229],ee([0,1,61,88,224,9,2,17,6,19,195,101,80]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(C,m,u,c,s){let l;for(let i=3;i&&(l&&l.dispose(),l=await new d(C,m,u,c,s).waitForReady(),!(s&&t.BROWSER_RESTRICTED_PORTS[s]||!t.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));i--);return l}class d extends M.Disposable{constructor(m,u,c,s,l){super();this.defaultTunnelHost=u,this.suggestedLocalPort=l,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=y.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let m=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(m){m.pause();const u=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,k.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),s=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&m.write(l.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),s.end()}),m.on("close",()=>s.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),s.destroy()}),s.on("end",()=>m.end()),s.on("close",()=>m.end()),s.on("error",()=>{m.destroy()}),m.pipe(s),s.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),s.end()})}}let h=class extends P.AbstractTunnelService{constructor(m,u,c,s,l){super(u);this.socketFactory=m,this.signService=c,this.productService=s,this.configurationService=l}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,u,c,s,l,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,s,l,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${s}.`);const r={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},a=v(r,this.defaultTunnelHost,u,c,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,a),a}}};h=de([ie(1,g.ILogService),ie(2,I.ISignService),ie(3,b.IProductService),ie(4,E.IConfigurationService)],h),e.BaseTunnelService=h;let p=class extends h{constructor(m,u,c,s){super(L.nodeSocketFactory,m,u,c,s)}};p=de([ie(0,g.ILogService),ie(1,I.ISignService),ie(2,b.IProductService),ie(3,E.IConfigurationService)],p),e.TunnelService=p;let w=class extends M.Disposable{constructor(m,u,c,s){super();this.logService=m,this.productService=u,this.signService=c,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(m,u,c,s,l,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${l}.`),!this._tunnelServices.has(m)){const r=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(r),this._tunnelServices.set(m,r),r.onTunnelClosed(async()=>{(await r.tunnels).length===0&&(r.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(u,c,s,l,i,n,o)}};w=de([ie(0,g.ILogService),ie(1,b.IProductService),ie(2,I.ISignService),ie(3,E.IConfigurationService)],w),e.SharedTunnelsService=w}),define(x[84],ee([0,1,9,23,4,17,24,22,6,19,57,41]),function(V,e,y,t,L,D,M,E,g,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(d,h,p){return`${p.updateUrl}/api/update/${d}/${h}/${p.commit}`}e.createUpdateURL=I;let v=class{constructor(h,p,w,C,m,u){this.lifecycleMainService=h,this.configurationService=p,this.environmentMainService=w,this.requestService=C,this.logService=m,this.productService=u,this._state=P.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=await this.getUpdateMode(),p=this.getProductQuality(h);if(!p){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}async getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,y.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}getUpdateType(){return 1}doQuitAndInstall(){}};v=de([ie(0,E.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,M.IEnvironmentMainService),ie(3,k.IRequestService),ie(4,g.ILogService),ie(5,b.IProductService)],v),e.AbstractUpdateService=v}),define(x[230],ee([0,1,14,47,4,2,17,24,22,6,19,57,32,41,84]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends d.AbstractUpdateService{constructor(w,C,m,u,c,s,l){super(w,C,u,c,s,l);this.telemetryService=m,this.disposables=new D.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(y.autoUpdater,"error",(w,C)=>C)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(y.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(y.autoUpdater,"update-available",(w,C,m)=>({url:C,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(y.autoUpdater,"update-downloaded",(w,C,m,u)=>({releaseNotes:C,version:m,productVersion:m,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(v.State.Idle(1,m))}buildUpdateFeedUrl(w){let C;this.productService.darwinUniversalAssetId?C=this.productService.darwinUniversalAssetId:C=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,d.createUpdateURL)(C,w,this.productService);try{y.autoUpdater.setFeedURL({url:m})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return m}doCheckForUpdates(w){this.setState(v.State.CheckingForUpdates(w)),y.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(v.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),y.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([t.memoize],h.prototype,"onRawError",null),de([t.memoize],h.prototype,"onRawUpdateNotAvailable",null),de([t.memoize],h.prototype,"onRawUpdateAvailable",null),de([t.memoize],h.prototype,"onRawUpdateDownloaded",null),h=de([ie(0,g.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,I.ITelemetryService),ie(3,E.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,b.ILogService),ie(6,k.IProductService)],h),e.DarwinUpdateService=h}),define(x[231],ee([0,1,45,30,9,4,8,24,22,6,32,41]),function(V,e,y,t,L,D,M,E,g,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(h,p,w){if(this.lifecycleMainService=h,this.logService=w,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,C=>this.logService.error(C))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,L.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=de([ie(0,g.ILifecycleMainService),ie(1,E.IEnvironmentMainService),ie(2,b.ILogService)],I);let v=class extends I{constructor(h,p,w,C,m,u){super(w,C,m);this.snap=h,this.snapRevision=p,this.telemetryService=u;const c=(0,t.watch)(M.dirname(this.snap)),s=D.Event.fromNodeEventEmitter(c,"change",(o,r)=>r),l=D.Event.filter(s,o=>o==="current"),n=D.Event.debounce(l,(o,r)=>r,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,y.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((w,C)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(m,u)=>m?C(m):w(u))),p=M.basename(h);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=de([ie(2,g.ILifecycleMainService),ie(3,E.IEnvironmentMainService),ie(4,b.ILogService),ie(5,k.ITelemetryService)],v),e.SnapUpdateService=v}),define(x[42],ee([0,1,14,30,4,44,33,2,10,8,3,16,12,20,159,52,48,24,5,6,19,104,25,81,105]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let n=class extends E.Disposable{constructor(r,a,f,S,R){super();this.environmentMainService=r,this.logService=a,this.backupMainService=f,this.dialogMainService=S,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,a=>(0,t.readFileSync)(a,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>v.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(!!this.isWorkspacePath(r)&&r.scheme===g.Schemas.file)try{const f=a(r.fsPath);return f instanceof Promise?f.then(S=>this.doResolveWorkspace(r,S),S=>{}):this.doResolveWorkspace(r,f)}catch{return}}isWorkspacePath(r){return(0,s.isUntitledWorkspace)(r,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const f=this.doParseStoredWorkspace(r,a),S=(0,i.getWorkspaceIdentifier)(r);return{id:S.id,configPath:S.configPath,folders:(0,l.toWorkspaceFolders)(f.folders,S.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:f.remoteAuthority,transient:f.transient}}catch(f){this.logService.warn(f.toString())}}doParseStoredWorkspace(r,a){const f=(0,D.parse)(a);if(f&&Array.isArray(f.folders))f.folders=f.folders.filter(S=>(0,l.isStoredWorkspaceFolder)(S));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return f}async createUntitledWorkspace(r,a){const{workspace:f,storedWorkspace:S}=this.newUntitledWorkspace(r,a),R=f.configPath.fsPath;return await v.Promises.mkdir((0,b.dirname)(R),{recursive:!0}),await v.Promises.writeFile(R,JSON.stringify(S,null,"	")),f}createUntitledWorkspaceSync(r,a){const{workspace:f,storedWorkspace:S}=this.newUntitledWorkspace(r,a),R=f.configPath.fsPath;return(0,t.mkdirSync)((0,b.dirname)(R),{recursive:!0}),(0,v.writeFileSync)(R,JSON.stringify(S,null,"	")),f}newUntitledWorkspace(r=[],a){const f=(Date.now()+Math.round(Math.random()*1e3)).toString(),S=(0,P.joinPath)(this.untitledWorkspacesHome,f),R=(0,P.joinPath)(S,s.UNTITLED_WORKSPACE_NAME),A=[];for(const F of r)A.push((0,l.getStoredWorkspaceFolder)(F.uri,!0,F.name,S,!k.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,i.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,s.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const a=(0,P.originalFSPath)(r.configPath);try{(0,v.rimrafSync)((0,b.dirname)(a));const f=(0,b.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,t.existsSync)(f)&&(0,v.writeFileSync)((0,b.join)(f,"obsolete"),"")}catch(f){this.logService.warn(`Unable to delete untitled workspace ${a} (${f}).`)}}getUntitledWorkspacesSync(){const r=[];try{const a=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(f=>(0,P.joinPath)(this.untitledWorkspacesHome,f,s.UNTITLED_WORKSPACE_NAME));for(const f of a){const S=(0,i.getWorkspaceIdentifier)(f),R=this.resolveLocalWorkspaceSync(f);R?r.push({workspace:S,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(S)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return r}async enterWorkspace(r,a,f){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,f))return;const R=this.doEnterWorkspace(r,(0,i.getWorkspaceIdentifier)(f));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,a,f){if(!f)return!0;if((0,s.isWorkspaceIdentifier)(r.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,f))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,f)){const S={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(f)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(S,(0,I.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,a){if(!r.config)return;r.focus();let f;return r.config.extensionDevelopmentPath||(f=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,s.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=f,{workspace:a,backupPath:f}}};n=de([ie(0,w.IEnvironmentMainService),ie(1,m.ILogService),ie(2,h.IBackupMainService),ie(3,p.IDialogMainService),ie(4,u.IProductService)],n),e.WorkspacesManagementMainService=n}),define(x[106],ee([0,1,37,23,5,34,25,42]),function(V,e,y,t,L,D,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let g=class{constructor(k,P){this.windowsMainService=k,this.workspacesManagementMainService=P}async getRemoteDiagnostics(k){const P=this.windowsMainService.getWindows();return(await Promise.all(P.map(v=>new Promise(d=>{const h=v.remoteAuthority;if(h){const p=`vscode:getDiagnosticInfoResponse${v.id}`,w={includeProcesses:k.includeProcesses,folders:k.includeWorkspaceMetadata?this.getFolderURIs(v):void 0};v.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:p,args:w}),y.validatedIpcMain.once(p,(C,m)=>{m||d({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),d(m)}),setTimeout(()=>{d({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else d(void 0)})))).filter(v=>!!v)}getFolderURIs(k){const P=[],I=k.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(I))P.push(I.uri);else if((0,M.isWorkspaceIdentifier)(I)){const v=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);v&&v.folders.forEach(h=>{P.push(h.uri)})}return P}};g=de([ie(0,D.IWindowsMainService),ie(1,E.IWorkspacesManagementMainService)],g),e.DiagnosticsMainService=g}),define(x[107],ee([0,1,14,26,3,12,7,20,17,51,5,6,102,34,25,42]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,k.createDecorator)(e.ID);let p=class{constructor(C,m,u,c,s){this.logService=C,this.windowsMainService=m,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=s}async start(C,m){this.logService.trace("Received data from other instance: ",C,m),L.isMacintosh&&y.app.focus({steal:!0});const u=this.parseOpenUrl(C);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:s,url:l}of u)this.urlService.open(s,{originalUrl:l})})}else return this.startOpenWindow(C,m)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,t.coalesce)(C._urls.map(m=>{try{return{uri:M.URI.parse(m),url:m}}catch{return null}})):[]}async startOpenWindow(C,m){const u=(0,b.isLaunchedFromCli)(m)?0:4;let c=[];const s=C.wait&&C.waitMarkerFilePath?M.URI.file(C.waitMarkerFilePath):void 0,l=C.remote||void 0,i={context:u,cli:C,userEnv:m,waitMarkerFileURI:s,remoteAuthority:l};if(C.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,i);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let n=!1;if(C["new-window"]||C["unity-launch"])n=!0;else if(C["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!L.isMacintosh}if(n)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),c=[o]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(s&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,E.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const C=[];return y.BrowserWindow.getAllWindows().forEach(m=>{const u=this.windowsMainService.getWindowById(m.id);u?C.push(this.codeWindowToInfo(u)):C.push(this.browserWindowToInfo(m))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:C,screenReader:!!y.app.accessibilitySupportEnabled,gpuFeatureStatus:y.app.getGPUFeatureStatus()}}getFolderURIs(C){const m=[],u=C.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(u))m.push(u.uri);else if((0,d.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(l=>{m.push(l.uri)})}return m}codeWindowToInfo(C){const m=this.getFolderURIs(C),u=(0,D.assertIsDefined)(C.win);return this.browserWindowToInfo(u,m,C.remoteAuthority)}browserWindowToInfo(C,m=[],u){return{pid:C.webContents.getOSProcessId(),title:C.getTitle(),folderURIs:m,remoteAuthority:u}}};p=de([ie(0,P.ILogService),ie(1,v.IWindowsMainService),ie(2,I.IURLService),ie(3,h.IWorkspacesManagementMainService),ie(4,g.IConfigurationService)],p),e.LaunchMainService=p}),define(x[59],ee([0,1,45,14,27,123,47,4,33,2,10,8,3,7,87,74,20,88,150,48,24,5,22,6,19,58,34,25,42]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i,n,o,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let f=class extends b.Disposable{constructor(R,A,F,$,J,ne,Y,re,H){super();this.sharedProcess=R,this.windowsMainService=A,this.dialogMainService=F,this.lifecycleMainService=$,this.environmentMainService=J,this.logService=ne,this.productService=Y,this.themeMainService=re,this.workspacesManagementMainService=H,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,X=>X.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(X,j)=>j.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(X,j)=>j.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(X,j)=>j.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),X=>!!X),X=>X.id),E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(X,j)=>j.id),X=>!!this.windowsMainService.getWindowById(X))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(X,j,B)=>B),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),E.Event.fromNodeEventEmitter(t.screen,"display-added"),E.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(A=>({id:A.id,workspace:A.openedWorkspace,title:A.win?.getTitle()??"",filename:A.getRepresentedFilename(),dirty:A.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const A=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(A)return A.id}openWindow(R,A,F){return Array.isArray(A)?this.doOpenWindow(R,A,F):this.doOpenEmptyWindow(R,A)}async doOpenWindow(R,A,F=Object.create(null)){A.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:A,cli:this.environmentMainService.args,forceNewWindow:F.forceNewWindow,forceReuseWindow:F.forceReuseWindow,preferNewWindow:F.preferNewWindow,diffMode:F.diffMode,addMode:F.addMode,gotoLineMode:F.gotoLineMode,noRecentEntry:F.noRecentEntry,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:F.remoteAuthority||void 0})}async doOpenEmptyWindow(R,A){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},A)}async toggleFullScreen(R){const A=this.windowById(R);A&&A.toggleFullScreen()}async handleTitleDoubleClick(R){const A=this.windowById(R);A&&A.handleTitleDoubleClick()}async isMaximized(R){const A=this.windowById(R);return A?.win?A.win.isMaximized():!1}async maximizeWindow(R){const A=this.windowById(R);A?.win&&A.win.maximize()}async unmaximizeWindow(R){const A=this.windowById(R);A?.win&&A.win.unmaximize()}async minimizeWindow(R){const A=this.windowById(R);A?.win&&A.win.minimize()}async updateTitleBarOverlay(R,A,F){if(!I.isWindows||!this.environmentMainService.isBuilt)return;const $=this.windowById(R);$?.win&&$.win.setTitleBarOverlay({color:A,symbolColor:F})}async focusWindow(R,A){A&&typeof A.windowId=="number"&&(R=A.windowId);const F=this.windowById(R);F&&F.focus({force:A?.force??!1})}async setMinimumSize(R,A,F){const $=this.windowById(R);if($?.win){const[J,ne]=$.win.getSize(),[Y,re]=$.win.getMinimumSize(),[H,X]=[A??Y,F??re],[j,B]=[Math.max(J,H),Math.max(ne,X)];(Y!==H||re!==X)&&$.win.setMinimumSize(H,X),(J!==j||ne!==B)&&$.win.setSize(j,B)}}async saveWindowSplash(R,A){this.themeMainService.saveWindowSplash(R,A)}async installShellCommand(R){const{source:A,target:F}=await this.getShellCommandLink();try{const{symbolicLink:$}=await p.SymlinkSupport.stat(A);if($&&!$.dangling){const J=await(0,d.realpath)(A);if(F===J)return}await p.Promises.unlink(A)}catch($){if($.code!=="ENOENT")throw $}try{await p.Promises.symlink(F,A)}catch($){if($.code!=="EACCES"&&$.code!=="ENOENT")throw $;const{response:J}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,C.localize)(0,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,C.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,C.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(J===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${F}' '${A}'\\" with administrator privileges"`;await(0,D.promisify)(y.exec)(ne)}catch{throw new Error((0,C.localize)(3,null,A))}}}async uninstallShellCommand(R){const{source:A}=await this.getShellCommandLink();try{await p.Promises.unlink(A)}catch(F){switch(F.code){case"EACCES":{const{response:$}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,C.localize)(4,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,C.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if($===0)try{const J=`osascript -e "do shell script \\"rm '${A}'\\" with administrator privileges"`;await(0,D.promisify)(y.exec)(J)}catch{throw new Error((0,C.localize)(7,null,A))}break}case"ENOENT":break;default:throw F}}}async getShellCommandLink(){const R=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),A=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(R))throw new Error((0,C.localize)(8,null,R));return{source:A,target:R}}async showMessageBox(R,A){return this.dialogMainService.showMessageBox(A,this.toBrowserWindow(R))}async showSaveDialog(R,A){return this.dialogMainService.showSaveDialog(A,this.toBrowserWindow(R))}async showOpenDialog(R,A){return this.dialogMainService.showOpenDialog(A,this.toBrowserWindow(R))}toBrowserWindow(R){const A=this.windowById(R);if(A?.win)return A.win}async pickFileFolderAndOpen(R,A){const F=await this.dialogMainService.pickFileFolder(A);F&&this.doOpenPicked(await Promise.all(F.map(async $=>await p.SymlinkSupport.existsDirectory($)?{folderUri:v.URI.file($)}:{fileUri:v.URI.file($)})),A,R)}async pickFolderAndOpen(R,A){const F=await this.dialogMainService.pickFolder(A);F&&this.doOpenPicked(F.map($=>({folderUri:v.URI.file($)})),A,R)}async pickFileAndOpen(R,A){const F=await this.dialogMainService.pickFile(A);F&&this.doOpenPicked(F.map($=>({fileUri:v.URI.file($)})),A,R)}async pickWorkspaceAndOpen(R,A){const F=await this.dialogMainService.pickWorkspace(A);F&&this.doOpenPicked(F.map($=>({workspaceUri:v.URI.file($)})),A,R)}doOpenPicked(R,A,F){this.windowsMainService.open({context:3,contextWindowId:F,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:A.forceNewWindow})}async showItemInFolder(R,A){t.shell.showItemInFolder(A)}async setRepresentedFilename(R,A){const F=this.windowById(R);F&&F.setRepresentedFilename(A)}async setDocumentEdited(R,A){const F=this.windowById(R);F&&F.setDocumentEdited(A)}async openExternal(R,A){return I.isLinuxSnap?this.safeSnapOpenExternal(A):t.shell.openExternal(A),!0}safeSnapOpenExternal(R){const A=process.env.GDK_PIXBUF_MODULE_FILE,F=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=A,process.env.GDK_PIXBUF_MODULEDIR=F}moveItemToTrash(R,A){return t.shell.trashItem(A)}async isAdmin(){let R;return I.isWindows?R=(await new Promise((A,F)=>{V(["native-is-elevated"],A,F)}))():R=process.getuid()===0,R}async writeElevated(R,A,F,$){const J=await new Promise((ne,Y)=>{V(["@vscode/sudo-prompt"],ne,Y)});return new Promise((ne,Y)=>{const re=[`"${this.cliPath}"`];$?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${A.fsPath}"`,`"${F.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};J.exec(re.join(" "),H,(X,j,B)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),X?Y(X):ne(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,L.totalmem)(),freemem:(0,L.freemem)(),loadavg:(0,L.loadavg)()}}async getOSProperties(){return{arch:(0,L.arch)(),platform:(0,L.platform)(),release:(0,L.release)(),type:(0,L.type)(),cpus:(0,L.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(R,A,F){process.kill(A,F)}async readClipboardText(R,A){return t.clipboard.readText(A)}async writeClipboardText(R,A,F){return t.clipboard.writeText(A,F)}async readClipboardFindText(R){return t.clipboard.readFindText()}async writeClipboardFindText(R,A){return t.clipboard.writeFindText(A)}async writeClipboardBuffer(R,A,F,$){return t.clipboard.writeBuffer(A,Buffer.from(F),$)}async readClipboardBuffer(R,A){return t.clipboard.readBuffer(A)}async hasClipboard(R,A,F){return t.clipboard.has(A,F)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,A){const F=this.windowById(R);F&&F.updateTouchBar(A)}async notifyReady(R){const A=this.windowById(R);A&&A.setReady()}async relaunch(R,A){return this.lifecycleMainService.relaunch(A)}async reload(R,A){const F=this.windowById(R);if(F){if((0,r.isWorkspaceIdentifier)(F.openedWorkspace)){const $=F.openedWorkspace.configPath;if($.scheme===k.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace($))?.transient)return this.openWindow(F.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(F,A?.disableExtensions!==void 0?{_:[],"disable-extensions":A.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,A){const F=this.windowById(A);if(F?.win)return F.win.close()}async quit(R){const A=this.windowsMainService.getLastActiveWindow();A?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&A.win?A.win.close():this.lifecycleMainService.quit()}async exit(R,A){await this.lifecycleMainService.kill(A)}async resolveProxy(R,A){const $=this.windowById(R)?.win?.webContents?.session;if($)return $.resolveProxy(A)}findFreePort(R,A,F,$,J=1){return(0,w.findFreePort)(A,F,$,J)}async openDevTools(R,A){const F=this.windowById(R);F?.win&&F.win.webContents.openDevTools(A)}async toggleDevTools(R){const A=this.windowById(R);A?.win&&A.win.webContents.toggleDevTools()}async sendInputEvent(R,A){const F=this.windowById(R);F?.win&&(A.type==="mouseDown"||A.type==="mouseUp")&&F.win.webContents.sendInputEvent(A)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,A,F,$){if(!I.isWindows)return;const J=await new Promise((ne,Y)=>{V(["@vscode/windows-registry"],ne,Y)});try{return J.GetStringRegKey(A,F,$)}catch{return}}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};de([M.memoize],f.prototype,"cliPath",null),f=de([ie(1,o.IWindowsMainService),ie(2,m.IDialogMainService),ie(3,s.ILifecycleMainService),ie(4,u.IEnvironmentMainService),ie(5,l.ILogService),ie(6,i.IProductService),ie(7,n.IThemeMainService),ie(8,a.IWorkspacesManagementMainService)],f),e.NativeHostMainService=f}),define(x[232],ee([0,1,14,37,27,33,2,10,3,89,148,77,106,48,24,5,107,6,59,54,19,55,67]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,h.createDecorator)("issueMainService");let l=class Rt{constructor(n,o,r,a,f,S,R,A,F,$){this.userEnv=n,this.environmentMainService=o,this.launchMainService=r,this.logService=a,this.diagnosticsService=f,this.diagnosticsMainService=S,this.dialogMainService=R,this.nativeHostMainService=A,this.protocolMainService=F,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(o,r);this.safeSend(n,"vscode:issueSystemInfoResponse",a)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const r=await this.launchMainService.getMainProcessId();o.push({name:(0,k.localize)(0,null),rootProcess:await(0,b.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,P.isRemoteDiagnosticError)(f)?o.push({name:f.hostName,rootProcess:f}):f.processes&&o.push({name:f.hostName,rootProcess:f.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,k.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,k.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,k.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",r.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,k.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,k.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,k.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:r,from:a,args:f}=o;let S;switch(a){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}S&&S.webContents.send("vscode:runAction",{id:r,from:a,args:f})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...r){n.sender.isDestroyed()||n.sender.send(o,...r)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new M.DisposableStore,r=o.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:n.styles.backgroundColor,title:(0,k.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:m.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new M.DisposableStore,r=o.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:n.styles.backgroundColor,title:(0,k.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:m.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,r,a){const f=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:r.title,backgroundColor:r.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,s.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return f.setMenuBarVisibility(!1),f}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,r){let a;const f=y.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(g.isMacintosh){const A=y.screen.getCursorScreenPoint();a=y.screen.getDisplayNearestPoint(A)}!a&&n&&(a=y.screen.getDisplayMatching(n.getBounds())),a||(a=y.screen.getPrimaryDisplay()||f[0])}const S={width:o,height:r},R=a.bounds;return S.x=R.x+R.width/2-S.width/2,S.y=R.y+R.height/2-S.height/2,R.width>0&&R.height>0&&(S.x<R.x&&(S.x=R.x),S.y<R.y&&(S.y=R.y),S.x>R.x+R.width&&(S.x=R.x),S.y>R.y+R.height&&(S.y=R.y),S.width>R.width&&(S.width=R.width),S.height>R.height&&(S.height=R.height)),S}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=de([ie(1,d.IEnvironmentMainService),ie(2,p.ILaunchMainService),ie(3,w.ILogService),ie(4,P.IDiagnosticsService),ie(5,I.IDiagnosticsMainService),ie(6,v.IDialogMainService),ie(7,C.INativeHostMainService),ie(8,c.IProtocolMainService),ie(9,u.IProductService)],l),e.IssueMainService=l}),define(x[233],ee([0,1,23,17,24,22,6,59,19,57,32,41,84]),function(V,e,y,t,L,D,M,E,g,b,k,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends I.AbstractUpdateService{constructor(h,p,w,C,m,u,c,s){super(h,p,C,m,u,s);this.telemetryService=w,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,I.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(P.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},y.CancellationToken.None).then(b.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const w=h?p.message||p:void 0;this.setState(P.State.Idle(1,w))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(P.State.Idle(1))}};v=de([ie(0,D.ILifecycleMainService),ie(1,t.IConfigurationService),ie(2,k.ITelemetryService),ie(3,L.IEnvironmentMainService),ie(4,b.IRequestService),ie(5,M.ILogService),ie(6,E.INativeHostMainService),ie(7,g.IProductService)],v),e.LinuxUpdateService=v}),define(x[234],ee([0,1,45,30,27,9,23,47,8,7,120,20,17,24,21,22,6,59,19,57,32,41,84]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,f=1e3){for(;!a();)await(0,D.timeout)(f)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),i}function o(a){if(a==="none"||a==="manual"||a==="start"||a==="default")return a}let r=class extends s.AbstractUpdateService{constructor(f,S,R,A,F,$,J,ne,Y){super(f,S,A,F,$,Y);this.telemetryService=R,this.fileService=J,this.nativeHostMainService=ne}get cachePath(){const f=g.join((0,L.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(f,{recursive:!0}).then(()=>f)}async getUpdateMode(){if(this.productService.win32RegValueName){const f=`Software\\Policies\\Microsoft\\${this.productService.win32RegValueName}`,[S,R]=await Promise.all([this.nativeHostMainService.windowsGetStringRegKey(void 0,"HKEY_LOCAL_MACHINE",f,"UpdateMode").then(o),this.nativeHostMainService.windowsGetStringRegKey(void 0,"HKEY_CURRENT_USER",f,"UpdateMode").then(o)]);if(S)return this.logService.info(`update#getUpdateMode: 'UpdateMode' policy defined in 'HKLM\\${f}':`,S),S;if(R)return this.logService.info(`update#getUpdateMode: 'UpdateMode' policy defined in 'HKCU\\${f}':`,R),R}return await super.getUpdateMode()}buildUpdateFeedUrl(f){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),n()===1?S+="-archive":this.productService.target==="user"&&(S+="-user"),(0,s.createUpdateURL)(S,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(c.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},M.CancellationToken.None).then(m.asJson).then(S=>{const R=n();return!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(S)),Promise.resolve(null)):(this.setState(c.State.Downloading(S)),this.cleanup(S.version).then(()=>this.getUpdatePackagePath(S.version).then(A=>P.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const $=S.url,J=S.hash,ne=`${A}.tmp`;return this.requestService.request({url:$},M.CancellationToken.None).then(Y=>this.fileService.writeFile(b.URI.file(ne),Y.stream)).then(J?()=>(0,k.checksum)(ne,S.hash):()=>{}).then(()=>P.Promises.rename(ne,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&S.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(S)):this.setState(c.State.Ready(S))})))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const R=f?S.message||S:void 0;this.setState(c.State.Idle(n(),R))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(f){const S=await this.cachePath;return g.join(S,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const S=f?$=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test($):()=>!0,R=await this.cachePath,F=(await P.Promises.readdir(R)).filter(S).map(async $=>{try{await P.Promises.unlink(g.join(R,$))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(c.State.Updating(f));const S=await this.cachePath;this.availableUpdate.updateFilePath=g.join(S,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,y.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise(($,J)=>{V(["windows-mutex"],$,J)});l(()=>F.isActive(A)).then(()=>this.setState(c.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,y.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}};de([E.memoize],r.prototype,"cachePath",null),r=de([ie(0,h.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,u.ITelemetryService),ie(3,v.IEnvironmentMainService),ie(4,m.IRequestService),ie(5,p.ILogService),ie(6,d.IFileService),ie(7,w.INativeHostMainService),ie(8,C.IProductService)],r),e.Win32UpdateService=r}),define(x[235],ee([0,1,14,9,23,39,4,33,2,10,8,64,3,7,155,52,17,48,24,51,21,22,6,19,55,203,83,32,206,58,67,34,25,42,103,110]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i,n,o,r,a,f,S,R,A,F,$,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(re){re[re.NONE=0]="NONE",re[re.NAVIGATING=1]="NAVIGATING",re[re.READY=2]="READY"})(ne||(ne={}));let Y=class extends g.Disposable{constructor(H,X,j,B,z,K,te,Q,O,U,W,N,T,_,q,Z){super();this.logService=X,this.environmentMainService=j,this.fileService=B,this.globalStorageMainService=z,this.storageMainService=K,this.configurationService=te,this.themeMainService=Q,this.workspacesManagementMainService=O,this.backupMainService=U,this.telemetryService=W,this.dialogMainService=N,this.lifecycleMainService=T,this.productService=_,this.protocolMainService=q,this.windowsMainService=Z,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[oe,ce]=this.restoreWindowState(H.state);this.windowState=oe,this.logService.trace("window#ctor: using window state",oe);const se=this.windowState.mode===0||this.windowState.mode===3,he=this.configurationService.getValue("window"),ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:S.WindowMinimumSize.WIDTH,minHeight:S.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,S.zoomLevelToZoomFactor)(he?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?ue.icon=(0,k.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ue.icon=(0,k.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ue.fullscreenable=!1),I.isMacintosh&&(ue.acceptFirstMouse=!0,he?.clickThroughInactive===!1&&(ue.acceptFirstMouse=!1));const ge=I.isMacintosh&&he?.nativeTabs===!0;ge&&(ue.tabbingIdentifier=this.productService.nameShort);const Ee=(0,S.getTitleBarStyle)(this.configurationService)==="custom";if(Ee&&(ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(ue.frame=!1),I.isWindows&&this.environmentMainService.isBuilt)){const Pe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),be=J.Color.fromHex(Pe).isDarker()?"#FFFFFF":"#000000";ue.titleBarOverlay={height:29,color:Pe,symbolColor:be}}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new y.BrowserWindow(ue),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&Ee&&this._win.setSheetOffset(22),I.isMacintosh&&ce&&(!ge||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Pe=>typeof Pe=="number")){const Pe=this.windowState;this._win.setBounds({width:Pe.width,height:Pe.height,x:Pe.x,y:Pe.y})}se&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(H){I.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){I.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){I.isMacintosh&&H?.force&&y.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(H=>{function X(){j.dispose(),B.dispose(),H()}const j=this.onDidClose(()=>X()),B=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(X,j)=>this.onWindowError(2,j)),this._win.webContents.on("did-fail-load",(X,j,B)=>this.onWindowError(3,{reason:B,exitCode:j})),this._win.webContents.on("will-prevent-unload",X=>{X.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",X=>{this._config&&(this._config.maximized=!0),y.app.emit("browser-window-maximize",X,this._win)}),this._win.on("unmaximize",X=>{this._config&&(this._config.maximized=!1),y.app.emit("browser-window-unmaximize",X,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(X=>this.onDidDeleteUntitledWorkspace(X)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(X,j)=>{const B=await this.getMarketplaceHeaders();j({cancel:!1,requestHeaders:Object.assign(X.requestHeaders,B)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(H,X){switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:H,reason:X?.reason,code:X?.exitCode}),H){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(j.response!==1){const B=j.response===0;this.destroyWindow(B,j.checkboxChecked)}}else if(H===2){let j;X?j=(0,d.localize)(7,null,X.reason,X.exitCode??"<unknown>"):j=(0,d.localize)(6,null);const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(9,null))],message:j,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),z=B.response===0;this.destroyWindow(z,B.checkboxChecked)}break}}async destroyWindow(H,X){const j=this._config?.workspace;if(X&&j)try{const B=this.storageMainService.workspaceStorage(j);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.logService.error(B)}if(this._onDidDestroy.fire(),this._win?.destroy(),H&&this._config){let B,z;(0,A.isSingleFolderWorkspaceIdentifier)(j)?B={folderUri:j.uri}:(0,A.isWorkspaceIdentifier)(j)?B={workspaceUri:j.configPath}:z=!0;const[K]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});K.focus()}}onDidDeleteUntitledWorkspace(H){this._config?.workspace?.id===H.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;X?.endsWith("/")&&(X=X.substr(0,X.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||j!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=j;const B=X||"",z=j?`${j},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(H){I.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,X=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,X),this.readyState===0?this._config=H:this.pendingLoadConfig=H,this.readyState=1,this._win.loadURL(b.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const j=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:H.workspace,reason:X.isReload?3:j?2:1})}updateConfiguration(H,X){const j=(this._config??this.pendingLoadConfig)?.userEnv;if(j){const B=(0,m.isLaunchedFromCli)(j)&&!(0,m.isLaunchedFromCli)(H.userEnv),z=this.isExtensionDevelopmentHost;(B||z)&&(H.userEnv={...j,...H.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(H["disable-extensions"]=X.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),H.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const X=Object.assign({},this._config);X.workspace=await this.validateWorkspaceBeforeReload(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&H&&(X.verbose=H.verbose,X.debugId=H.debugId,X.extensionEnvironment=H.extensionEnvironment,X["inspect-extensions"]=H["inspect-extensions"],X["inspect-brk-extensions"]=H["inspect-brk-extensions"],X["extensions-dir"]=H["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:H?.["disable-extensions"]})}async validateWorkspaceBeforeReload(H){if((0,A.isWorkspaceIdentifier)(H.workspace)){const X=H.workspace.configPath;if(X.scheme===b.Schemas.file&&!await this.fileService.exists(X))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(H.workspace)){const X=H.workspace.uri;if(X.scheme===b.Schemas.file&&!await this.fileService.exists(X))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,$.defaultWindowState)();if(this.isFullScreen){let j;try{j=y.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,$.defaultWindowState)();return{mode:3,display:j?j.id:void 0,width:this.windowState.width||B.width,height:this.windowState.height||B.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let X;if(!I.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?H.mode=0:H.mode=1,X===1||X===0){let j;X===1?j=this.getBounds():j=this._win.getNormalBounds(),H.x=j.x,H.y=j.y,H.width=j.width,H.height=j.height}return H}restoreWindowState(H){(0,P.mark)("code/willRestoreCodeWindowState");let X=!1;if(H)try{const j=y.screen.getAllDisplays();X=j.length>1,H=this.validateWindowState(H,j)}catch(j){this.logService.warn(`Unexpected error validating window state: ${j}
${j.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[H||(0,$.defaultWindowState)(),X]}validateWindowState(H,X){if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const z=this.getWorkingArea(X[0]);if(z){let K=function(){!H||typeof H.x!="number"||typeof H.y!="number"||!z||(H.x<z.x&&(H.x=z.x),H.y<z.y&&(H.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),K(),H.width>z.width&&(H.width=z.width),H.height>z.height&&(H.height=z.height),H.x>z.x+z.width-128&&(H.x=z.x+z.width-H.width),H.y>z.y+z.height-128&&(H.y=z.y+z.height-H.height),K()}return H}if(H.display&&H.mode===3){const z=X.find(K=>K.id===H.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const K=(0,$.defaultWindowState)(3);return K.x=z.bounds.x,K.y=z.bounds.y,K}}let j,B;try{j=y.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),B=this.getWorkingArea(j)}catch{}if(j&&B&&H.x+H.width>B.x&&H.y+H.height>B.y&&H.x<B.x+B.width&&H.y<B.y+B.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",B),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,X]=this._win.getPosition(),[j,B]=this._win.getSize();return{x:H,y:X,width:j,height:B}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,S.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,X=!0){I.isMacintosh||(H==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const X=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,X,...j){this.isReady?this.send(H,...j):this.ready().then(()=>{X.isCancellationRequested||this.send(H,...j)})}send(H,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${H}' for window that is destroyed`);return}try{this._win.webContents.send(H,...X)}catch(j){this.logService.warn(`Error sending IPC message to channel '${H}' of window ${this._id}: ${(0,D.toErrorMessage)(j)}`)}}}updateTouchBar(H){!I.isMacintosh||this.touchBarGroups.forEach((X,j)=>{const B=H[j];X.segments=this.createTouchBarGroupSegments(B)})}createTouchBar(){if(!!I.isMacintosh){for(let H=0;H<10;H++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const X=this.createTouchBarGroupSegments(H),j=new y.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:j.segments[B].id,from:"touchbar"})}});return j}createTouchBarGroupSegments(H=[]){return H.map(j=>{let B;j.icon&&!a.ThemeIcon.isThemeIcon(j.icon)&&j.icon?.dark?.scheme===b.Schemas.file&&(B=y.nativeImage.createFromPath(v.URI.revive(j.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let z;return typeof j.title=="string"?z=j.title:z=j.title.value,{id:j.id,label:B?void 0:z,icon:B}})}dispose(){super.dispose(),this._win=null}};Y=de([ie(1,s.ILogService),ie(2,C.IEnvironmentMainService),ie(3,u.IFileService),ie(4,o.IGlobalStorageMainService),ie(5,o.IStorageMainService),ie(6,p.IConfigurationService),ie(7,f.IThemeMainService),ie(8,F.IWorkspacesManagementMainService),ie(9,h.IBackupMainService),ie(10,r.ITelemetryService),ie(11,w.IDialogMainService),ie(12,c.ILifecycleMainService),ie(13,l.IProductService),ie(14,i.IProtocolMainService),ie(15,R.IWindowsMainService)],Y),e.CodeWindow=Y}),define(x[68],ee([0,1,14,26,9,4,33,2,10,3,16,7,20,158,5,22,6,83,81,25,42]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class Ge extends E.Disposable{constructor(l,i,n,o){super();this.logService=l,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.globalStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new L.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){const i=[],n=[];for(let o of l)if((0,C.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,C.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const r=this.indexOfFile(n,o.fileUri)>=0,a=o.fileUri.scheme===g.Schemas.file&&Ge.COMMON_FILES_FILTER.indexOf((0,k.basename)(o.fileUri))>=0;!r&&!a&&(n.push(o),b.isWindows&&o.fileUri.scheme===g.Schemas.file&&y.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>Ge.MAX_TOTAL_RECENT_ENTRIES&&(i.length=Ge.MAX_TOTAL_RECENT_ENTRIES),n.length>Ge.MAX_TOTAL_RECENT_ENTRIES&&(n.length=Ge.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const i=a=>{const f=this.location(a);for(const S of l)if(k.extUriBiasedIgnorePathCase.isEqual(S,f))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),r=n.files.filter(i);(o.length!==n.workspaces.length||r.length!==n.files.length)&&(await this.saveRecentlyOpened({files:r,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),b.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(l){const i=[],n=[];if(l){const r=l.config?.workspace;(0,m.isWorkspaceIdentifier)(r)&&!this.workspacesManagementMainService.isUntitledWorkspace(r)?i.push({workspace:r,remoteAuthority:l.remoteAuthority}):(0,m.isSingleFolderWorkspaceIdentifier)(r)&&i.push({folderUri:r.uri,remoteAuthority:l.remoteAuthority})}const o=l?.config?.filesToOpenOrCreate;if(o)for(let r of o){const a=r.fileUri;a&&this.indexOfFile(n,a)===-1&&n.push({fileUri:a})}return await this.addEntriesFromStorage(i,n),{workspaces:i,files:n}}async addEntriesFromStorage(l,i){let n=await this.getRecentlyOpenedFromStorage();for(let o of n.workspaces){let r=(0,C.isRecentFolder)(o)?this.indexOfFolder(l,o.folderUri):this.indexOfWorkspace(l,o.workspace);r>=0?l[r].label=l[r].label||o.label:l.push(o)}for(let o of n.files){let r=this.indexOfFile(i,o.fileUri);r>=0?i[r].label=i[r].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let l;const i=this.globalStorageMainService.get(Ge.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{l=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,C.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(Ge.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,C.toStoreData)(l)),0,1)}location(l){return(0,C.isRecentFolder)(l)?l.folderUri:(0,C.isRecentFile)(l)?l.fileUri:l.workspace.configPath}indexOfWorkspace(l,i){return l.findIndex(n=>(0,C.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(l,i){return l.findIndex(n=>(0,C.isRecentFolder)(n)&&k.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(l,i){return l.findIndex(n=>k.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!b.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!b.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let r of y.app.getJumpListSettings().removedItems){const a=r.args;if(a){const f=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(a);f&&i.push(P.URI.parse(f[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,Ge.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(r=>{const a=(0,C.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:f,description:S}=this.getWindowsJumpListLabel(a,r.label);let R;return P.URI.isUri(a)?R=`--folder-uri "${a.toString()}"`:(n=!0,R=`--file-uri "${a.configPath.toString()}"`),{type:"task",title:f.substr(0,255),description:S.substr(0,255),program:process.execPath,args:R,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&l.push({type:"custom",name:n?(0,v.localize)(2,null):(0,v.localize)(3,null),items:o})}l.push({type:"recent"});try{y.app.setJumpList(l)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(l,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(P.URI.isUri(l))return{title:(0,k.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,v.localize)(4,null),description:""};let n=(0,k.basename)(l.configPath);return n.endsWith(m.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-m.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,n),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,M.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!b.isMacintosh)return;y.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),i=[];let n=0;for(let r=0;r<l.workspaces.length&&n<Ge.MAX_MACOS_DOCK_RECENT_WORKSPACES;r++){const a=this.location(l.workspaces[r]);if(a.scheme===g.Schemas.file){const f=(0,k.originalFSPath)(a);await I.Promises.exists(f)&&(i.push(f),n++)}}const o=[];for(let r=0;r<l.files.length&&n<Ge.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;r++){const a=this.location(l.files[r]);if(a.scheme===g.Schemas.file){const f=(0,k.originalFSPath)(a);if(Ge.COMMON_FILES_FILTER.includes((0,k.basename)(a))||i.includes(f))continue;await I.Promises.exists(f)&&(o.push(f),n++)}}o.reverse().forEach(r=>y.app.addRecentDocument(r)),i.reverse().forEach(r=>y.app.addRecentDocument(r))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=de([ie(0,p.ILogService),ie(1,u.IWorkspacesManagementMainService),ie(2,h.ILifecycleMainService),ie(3,w.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(x[236],ee([0,1,14,9,23,33,3,7,149,17,24,22,6,188,59,19,46,32,41,67,34,68]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let l=class Pt{constructor(o,r,a,f,S,R,A,F,$,J,ne){this.updateService=o,this.configurationService=r,this.windowsMainService=a,this.environmentMainService=f,this.telemetryService=S,this.workspacesHistoryMainService=R,this.stateMainService=A,this.lifecycleMainService=F,this.logService=$,this.nativeHostMainService=J,this.productService=ne,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Pt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,A,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,A,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:A?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,A,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(R,A,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,A,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const r=this.productService.requestFeatureUrl;r&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(r,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const f=this.productService.licenseUrl;f&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const R=f.indexOf("?")>0?"&":"?";this.openUrl(`${f}${R}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(f,"openLicenseUrl")});const S=this.productService.privacyStatementUrl;S&&f&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(S,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,r){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Pt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!M.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=y.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(M.isMacintosh?new y.Menu:null);return}const r=new y.Menu;let a;if(M.isMacintosh){const S=new y.Menu;a=new y.MenuItem({label:this.productService.nameShort,submenu:S}),this.setMacApplicationMenu(S),r.append(a)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const S=new y.Menu;S.append(new y.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(S)}if(this.shouldDrawMenu("File")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:S});this.setMenuById(S,"File"),r.append(R)}if(this.shouldDrawMenu("Edit")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:S});this.setMenuById(S,"Edit"),r.append(R)}if(this.shouldDrawMenu("Selection")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:S});this.setMenuById(S,"Selection"),r.append(R)}if(this.shouldDrawMenu("View")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:S});this.setMenuById(S,"View"),r.append(R)}if(this.shouldDrawMenu("Go")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:S});this.setMenuById(S,"Go"),r.append(R)}if(this.shouldDrawMenu("Run")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:S});this.setMenuById(S,"Run"),r.append(R)}if(this.shouldDrawMenu("Terminal")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:S});this.setMenuById(S,"Terminal"),r.append(R)}let f;if(this.shouldDrawMenu("Window")){const S=new y.Menu;f=new y.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:S,role:"window"}),this.setMacWindowMenu(S)}if(f&&r.append(f),this.shouldDrawMenu("Help")){const S=new y.Menu,R=new y.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:S,role:"help"});this.setMenuById(S,"Help"),r.append(R)}r.items&&r.items.length>0?y.Menu.setApplicationMenu(r):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const r=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let f;if(this.shouldDrawMenu("Preferences")){const Y=new y.Menu;this.setMenuById(Y,"Preferences"),f=new y.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:Y})}const S=new y.Menu,R=new y.MenuItem({label:g.localize(12,null),role:"services",submenu:S}),A=new y.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new y.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new y.MenuItem({label:g.localize(15,null),role:"unhide"}),J=new y.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:async(Y,re,H)=>{const X=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.confirmBeforeQuit(H)&&this.nativeHostMainService.quit(void 0)}})),ne=[r];ne.push(...a),f&&ne.push(i(),f),ne.push(i(),R,i(),A,F,$,i(),J),ne.forEach(Y=>o.append(Y))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const r=this.configurationService.getValue("window.confirmBeforeClose");if(r==="always"||r==="keyboardOnly"&&this.isKeyboardEvent(o)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,D.mnemonicButtonLabel)(g.localize(17,null)),(0,D.mnemonicButtonLabel)(g.localize(18,null))],message:g.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return f===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,r){r.forEach(a=>{if((0,v.isMenubarMenuItemSeparator)(a))o.append(i());else if((0,v.isMenubarMenuItemSubmenu)(a)){const f=new y.Menu,S=new y.MenuItem({label:this.mnemonicLabel(a.label),submenu:f});this.setMenu(f,a.submenu.items),o.append(S)}else(0,v.isMenubarMenuItemRecentAction)(a)?o.append(this.createOpenRecentMenuItem(a)):(0,v.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?o.append(new y.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):o.append(this.createMenuItem(a.label,a.id,!1,a.checked)):o.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):o.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(o,r){this.menubarMenus&&this.menubarMenus[r]&&this.setMenu(o,this.menubarMenus[r].items)}insertCheckForUpdatesItems(o){const r=this.getUpdateMenuItems();r.length&&(r.forEach(a=>o.append(a)),o.append(i()))}createOpenRecentMenuItem(o){const r=E.URI.revive(o.uri),a=o.id,f=a==="openRecentFile"?{fileUri:r}:a==="openRecentWorkspace"?{workspaceUri:r}:{folderUri:r};return new y.MenuItem(this.likeAction(a,{label:o.label,click:(S,R,A)=>{const F=this.isOptionClick(A);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[f],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([r])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,r,a){const f={label:this.mnemonicLabel(o),role:a,enabled:!0};return new y.MenuItem(this.withKeybinding(r,f))}setMacWindowMenu(o){const r=new y.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new y.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),f=new y.MenuItem({label:g.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),S=this.createMenuItem(g.localize(23,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(i()),R.push(this.createMenuItem(g.localize(24,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[r,a,i(),S,...R,i(),f].forEach(A=>o.append(A))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(g.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new y.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(g.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(g.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(g.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,r,a,f){const S=this.mnemonicLabel(o),R=typeof r=="function"?r:(ne,Y,re)=>{const H=ne?ne.userSettingsLabel:null;let X=r;Array.isArray(r)&&(X=this.isOptionClick(re)?r[1]:r[0]),H&&re.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:X})},A=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,F=typeof f=="boolean"?f:!1,$={label:S,click:R,enabled:A};F&&($.type="checkbox",$.checked=F);let J;return typeof r=="string"?J=r:Array.isArray(r)&&(J=r[0]),M.isMacintosh&&(J==="editor.action.clipboardCutAction"?$.role="cut":J==="editor.action.clipboardCopyAction"?$.role="copy":J==="editor.action.clipboardPasteAction"&&($.role="paste"),J==="undo"?$.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?$.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(J,$))}makeContextAwareClickHandler(o,r){return(a,f,S)=>{const R=y.BrowserWindow.getFocusedWindow();if(!R)return r.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return r.inDevTools(R.webContents.devToolsWebContents);o(a,f||R,S)}}runActionInRenderer(o){let r=y.BrowserWindow.getFocusedWindow();if(!r){const f=this.windowsMainService.getLastActiveWindow();f?.isMinimized()&&(r=f.win)}const a=r?this.windowsMainService.getWindowById(r.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const f={id:o.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",L.CancellationToken.None,f)}else{const f={userSettingsLabel:o.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",L.CancellationToken.None,f)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,r){const a=typeof o=="string"?this.keybindings[o]:void 0;if(a?.label){if(a.isNative!==!1)r.accelerator=a.label,r.userSettingsLabel=a.userSettingsLabel;else if(typeof r.label=="string"){const f=r.label.indexOf("[");f>=0?r.label=`${r.label.substr(0,f)} [${a.label}]`:r.label=`${r.label} [${a.label}]`}}else r.accelerator=void 0;return r}likeAction(o,r,a=!r.accelerator){a&&(r=this.withKeybinding(o,r));const f=r.click;return r.click=(S,R,A)=>{this.reportMenuActionTelemetry(o),f&&f(S,R,A)},r}openUrl(o,r){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(r)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,D.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=de([ie(0,C.IUpdateService),ie(1,b.IConfigurationService),ie(2,u.IWindowsMainService),ie(3,k.IEnvironmentMainService),ie(4,w.ITelemetryService),ie(5,c.IWorkspacesHistoryMainService),ie(6,p.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,I.ILogService),ie(9,d.INativeHostMainService),ie(10,h.IProductService)],l),e.Menubar=l;function i(){return new y.MenuItem({type:"separator"})}}),define(x[237],ee([0,1,5,22,6,236]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,y.createDecorator)("menubarMainService");let M=class{constructor(g,b,k){this.instantiationService=g,this.lifecycleMainService=b,this.logService=k,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(g,b){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(b,g)}};M=de([ie(0,y.IInstantiationService),ie(1,t.ILifecycleMainService),ie(2,L.ILogService)],M),e.MenubarMainService=M}),define(x[238],ee([0,1,14,30,27,26,23,4,29,43,33,2,10,8,64,3,36,16,12,7,156,52,17,48,24,21,5,22,6,54,19,55,65,46,67,235,104,220,25,105,68,42,58]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i,n,o,r,a,f,S,R,A,F,$,J,ne,Y,re,H,X,j,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(Q){return(0,re.isWorkspaceIdentifier)(Q?.workspace)}function K(Q){return(0,re.isSingleFolderWorkspaceIdentifier)(Q?.workspace)}let te=class st extends P.Disposable{constructor(O,U,W,N,T,_,q,Z,oe,ce,se,he,ue,ge,Ee,Pe){super();this.machineId=O,this.initialUserEnv=U,this.logService=W,this.stateMainService=N,this.environmentMainService=T,this.lifecycleMainService=_,this.backupMainService=q,this.configurationService=Z,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=ce,this.instantiationService=se,this.dialogMainService=he,this.fileService=ue,this.productService=ge,this.protocolMainService=Ee,this.themeMainService=Pe,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Y.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(O=>this._onDidSignalReadyWindow.fire(O.window))),this._register(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const U=new P.DisposableStore;if(U.add(E.Event.any(O.onDidClose,O.onDidDestroy)(()=>U.dispose())),O.config.extensionDevelopmentPath)for(const W of O.config.extensionDevelopmentPath)U.add(this.protocolMainService.addValidFileRoot(W));O.config.extensionTestsPath&&U.add(this.protocolMainService.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,U){let W=this.environmentMainService.args;const N=U?.remoteAuthority||void 0,T=!0,_=U?.forceReuseWindow,q=!_;return this.open({...O,cli:W,forceEmpty:T,forceNewWindow:q,forceReuseWindow:_,remoteAuthority:N})}openExistingWindow(O,U){O.focus(),this.handleWaitMarkerFile(U,[O])}open(O){this.logService.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const U=[],W=[],N=[],T=[],_=[];let q,Z=0;const oe=this.getPathsToOpen(O);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)K(ue)?O.addMode?U.push(ue):W.push(ue):z(ue)?N.push(ue):ue.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),q.filesToOpenOrCreate.push(ue)):ue.backupPath?_.push({backupFolder:(0,v.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):Z++;O.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),q&&O.waitMarkerFileURI&&(q.filesToWait={paths:[...q.filesToDiff,...q.filesToOpenOrCreate],waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(T.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...T),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:ce,filesOpenedInWindow:se}=this.doOpen(O,N,W,_,Z,q,U);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${W.length}, emptyToRestore: ${_.length}, emptyToOpen: ${Z})`),ce.length>1)if(se)se.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let ge=!0,Ee=!0;if(ue){const Pe=ce.filter(be=>this.windowsStateHandler.state.lastActiveWindow&&be.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Pe.length&&(Pe[0].focus(),ge=!1,Ee=!1)}if(ge)for(let Pe=ce.length-1;Pe>=0;Pe--){const be=ce[Pe];if(!(be.openedWorkspace&&T.some(Se=>be.openedWorkspace&&Se.workspace.id===be.openedWorkspace.id)||be.backupPath&&_.some(Se=>be.backupPath&&Se.backupFolder===(0,v.basename)(be.backupPath)))){be.focus(),Ee=!1;break}}Ee&&ce[ce.length-1].focus()}const he=q&&q.filesToDiff.length>0;if(!ce.some(ue=>ue.isExtensionDevelopmentHost)&&!he&&!O.noRecentEntry){const ue=[];for(const ge of oe)z(ge)&&!ge.transient?ue.push({label:ge.label,workspace:ge.workspace,remoteAuthority:ge.remoteAuthority}):K(ge)?ue.push({label:ge.label,folderUri:ge.workspace.uri,remoteAuthority:ge.remoteAuthority}):ge.fileUri&&ue.push({label:ge.label,fileUri:ge.fileUri,remoteAuthority:ge.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(O,ce),ce}handleWaitMarkerFile(O,U){const W=O.waitMarkerFileURI;O.context===0&&W&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}doOpen(O,U,W,N,T,_,q){const Z=[];let oe;function ce(be,Se){Z.push(be),Se&&(oe=be,_=void 0)}let{openFolderInNewWindow:se,openFilesInNewWindow:he}=this.shouldOpenNewWindow(O);if(!O.initialStartup&&q.length>0){const be=q[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(be);Se&&ce(this.doAddFoldersToExistingWindow(Se,q.map(Ie=>Ie.workspace.uri)))}const ue=W.length+U.length+N.length;if(_&&ue===0){const be=_.filesToOpenOrCreate[0]||_.filesToDiff[0],Se=this.getWindows().filter(We=>_&&(0,w.isEqualAuthority)(We.remoteAuthority,_.remoteAuthority));let Ie;be?.fileUri&&!he&&((O.context===4||O.context===0||O.context===1)&&(Ie=(0,ne.findWindowOnFile)(Se,be.fileUri,We=>We.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(We.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(Se))),Ie?(0,re.isWorkspaceIdentifier)(Ie.openedWorkspace)?U.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?W.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(O,Ie,_),!0):ce(this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow}),!0)}const ge=(0,D.distinct)(U,be=>be.workspace.id);if(ge.length>0){const be=(0,D.coalesce)(ge.map(Se=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(be.length>0){const Se=be[0],Ie=(0,w.isEqualAuthority)(_?.remoteAuthority,Se.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(O,Se,Ie),!!Ie),se=!0}ge.forEach(Se=>{if(be.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===Se.workspace.id))return;const Ie=Se.remoteAuthority,We=(0,w.isEqualAuthority)(_?.remoteAuthority,Ie)?_:void 0;ce(this.doOpenFolderOrWorkspace(O,Se,se,We),!!We),se=!0})}const Ee=(0,D.distinct)(W,be=>w.extUriBiasedIgnorePathCase.getComparisonKey(be.workspace.uri));if(Ee.length>0){const be=(0,D.coalesce)(Ee.map(Se=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(be.length>0){const Se=be[0],Ie=(0,w.isEqualAuthority)(_?.remoteAuthority,Se.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(O,Se,Ie),!!Ie),se=!0}Ee.forEach(Se=>{if(be.some(_e=>(0,re.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,Se.workspace.uri)))return;const Ie=Se.remoteAuthority,We=(0,w.isEqualAuthority)(_?.remoteAuthority,Ie)?_:void 0;ce(this.doOpenFolderOrWorkspace(O,Se,se,We),!!We),se=!0})}const Pe=(0,D.distinct)(N,be=>be.backupFolder);if(Pe.length>0&&Pe.forEach(be=>{const Se=be.remoteAuthority,Ie=(0,w.isEqualAuthority)(_?.remoteAuthority,Se)?_:void 0;ce(this.doOpenEmpty(O,!0,Se,Ie,be),!!Ie),se=!0}),Z.length===0||_){_&&!T&&T++;const be=_?_.remoteAuthority:O.remoteAuthority;for(let Se=0;Se<T;Se++)ce(this.doOpenEmpty(O,se,be,_),!!_),se=!0}return{windows:(0,D.distinct)(Z),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(O,U,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),U.focus();const N={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToWait:W?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",M.CancellationToken.None,N),U}doAddFoldersToExistingWindow(O,U){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),O.focus();const W={foldersToAdd:U};return O.sendWhenReady("vscode:addFolders",M.CancellationToken.None,W),O}doOpenEmpty(O,U,W,N,T){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!T,remoteAuthority:W,filesToOpen:N,forceNewWindow:U});let _;return!U&&typeof O.contextWindowId=="number"&&(_=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:W,forceNewWindow:U,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:_,emptyWindowBackupInfo:T})}doOpenFolderOrWorkspace(O,U,W,N,T){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:N}),!W&&!T&&typeof O.contextWindowId=="number"&&(T=this.getWindowById(O.contextWindowId)),this.openInBrowserWindow({workspace:U.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:T})}getPathsToOpen(O){let U,W=!1,N=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(O),W=!0):O.forceEmpty?U=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(U=this.doExtractPathsFromCLI(O.cli),U.length===0&&U.push(Object.create(null)),W=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),N=!0),!O.addMode&&W){const T=U.filter(_=>K(_));if(T.length>1){const _=T[0].remoteAuthority;if(T.every(q=>(0,w.isEqualAuthority)(q.remoteAuthority,_))){const q=this.workspacesManagementMainService.createUntitledWorkspaceSync(T.map(Z=>({uri:Z.workspace.uri})));U.push({workspace:q,remoteAuthority:_}),U=U.filter(Z=>!K(Z))}}}return O.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(T=>z(T)||K(T)||T.backupPath)),U}doExtractPathsFromAPI(O){const U=[],W={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority};for(const N of(0,D.coalesce)(O.urisToOpen||[])){const T=this.resolveOpenable(N,W);if(T)T.label=N.label,U.push(T);else{const _=this.resourceFromOpenable(N),q={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:_.scheme===I.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:_.scheme===I.Schemas.file?(0,u.localize)(3,null,(0,k.getPathLabel)(_,{os:h.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,_.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(q,(0,C.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return U}doExtractPathsFromCLI(O){const U=[],W={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:!1},N=O["folder-uri"];if(N)for(const q of N){const Z=this.cliArgToUri(q);if(Z){const oe=this.resolveOpenable({folderUri:Z},W);oe&&U.push(oe)}}const T=O["file-uri"];if(T)for(const q of T){const Z=this.cliArgToUri(q);if(Z){const oe=this.resolveOpenable((0,re.hasWorkspaceFileExtension)(q)?{workspaceUri:Z}:{fileUri:Z},W);oe&&U.push(oe)}}const _=O._;for(const q of _){const Z=W.remoteAuthority?this.doResolvePathRemote(q,W):this.doResolveFilePath(q,W);Z&&U.push(Z)}return U}cliArgToUri(O){try{const U=m.URI.parse(O);if(!U.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${O}`);return}return U}catch(U){this.logService.error(`Invalid URI input string: ${O}, ${U.message}`)}}doGetPathsFromLastSession(){const O=this.getRestoreWindowsSetting();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];O!=="one"&&U.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&U.push(this.windowsStateHandler.state.lastActiveWindow);const W=[];for(const N of U)if(N.workspace){const T=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});z(T)&&W.push(T)}else if(N.folderUri){const T=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});K(T)&&W.push(T)}else O!=="folders"&&N.backupPath&&W.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return W}}}getRestoreWindowsSetting(){let O;return this.lifecycleMainService.wasRestarted?O="all":(O=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}resolveOpenable(O,U=Object.create(null)){let W=this.resourceFromOpenable(O);return W.scheme===I.Schemas.file?((0,$.isFileToOpen)(O)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,U)):this.doResolveRemoteOpenable(O,U)}doResolveRemoteOpenable(O,U){let W=this.resourceFromOpenable(O);const N=(0,A.getRemoteAuthority)(W)||U.remoteAuthority;if(W=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(W)),(0,$.isFileToOpen)(O)){if(U.gotoLineMode){const{path:T,line:_,column:q}=(0,g.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:T}),options:{selection:_?{startLineNumber:_,startColumn:q||1}:void 0},remoteAuthority:N}}return{fileUri:W,remoteAuthority:N}}else if((0,$.isWorkspaceToOpen)(O))return{workspace:(0,H.getWorkspaceIdentifier)(W),remoteAuthority:N};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:N}}resourceFromOpenable(O){return(0,$.isWorkspaceToOpen)(O)?O.workspaceUri:(0,$.isFolderToOpen)(O)?O.folderUri:O.fileUri}doResolveFilePath(O,U){let W,N;U.gotoLineMode&&({path:O,line:W,column:N}=(0,g.parseLineAndColumnAware)(O)),O=(0,g.sanitizeFilePath)((0,v.normalize)(O),(0,p.cwd)());try{const T=(0,t.statSync)(O);if(T.isFile()){if(!U.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(m.URI.file(O));if(_)return _.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:n.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:m.URI.file(O),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:N||1}:void 0}}}else{if(T.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(m.URI.file(O),T),type:n.FileType.Directory,exists:!0};if(!h.isWindows&&O==="/dev/null")return{fileUri:m.URI.file(O),type:n.FileType.File,exists:!0}}}catch{const _=m.URI.file(O);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),U.ignoreFileNotFound)return{fileUri:_,type:n.FileType.File,exists:!1}}}doResolvePathRemote(O,U){const W=O.charCodeAt(0),N=U.remoteAuthority;let T,_;U.gotoLineMode&&({path:O,line:T,column:_}=(0,g.parseLineAndColumnAware)(O)),W!==47&&((0,g.isWindowsDriveLetter)(W)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,g.toSlashes)(O)),O=`/${O}`);const q=m.URI.from({scheme:I.Schemas.vscodeRemote,authority:N,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(O))return U.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:T?{startLineNumber:T,startColumn:_||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(q),remoteAuthority:N};if(U.gotoLineMode||v.posix.basename(O).indexOf(".")!==-1)return{fileUri:q,options:{selection:T?{startLineNumber:T,startColumn:_||1}:void 0},remoteAuthority:N}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:N}}shouldOpenNewWindow(O){const U=this.configurationService.getValue("window"),W=U?.openFoldersInNewWindow||"default",N=U?.openFilesInNewWindow||"off";let T=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(W==="on"||W==="off")&&(T=W==="on");let _=!1;return O.forceNewWindow||O.forceReuseWindow?_=!!O.forceNewWindow&&!O.forceReuseWindow:(h.isMacintosh?O.context===1&&(_=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!O.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(_=N==="on")),{openFolderInNewWindow:!!T,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(O,U){const W=(0,ne.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(W)return this.lifecycleMainService.reload(W,U.cli),W.focus(),[W];let N=U.cli["folder-uri"]||[],T=U.cli["file-uri"]||[],_=U.cli._;if(!_.length&&!N.length&&!T.length&&!U.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,se=ce&&(ce.workspace||ce.folderUri);se&&(m.URI.isUri(se)?se.scheme===I.Schemas.file?_=[se.fsPath]:N=[se.toString()]:se.configPath.scheme===I.Schemas.file?_=[(0,w.originalFSPath)(se.configPath)]:T=[se.configPath.toString()])}let q=U.remoteAuthority;for(const ce of O)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=m.URI.parse(ce),he=(0,A.getRemoteAuthority)(se);he&&(q?(0,w.isEqualAuthority)(he,q)||this.logService.error("more than one extension development path authority"):q=he)}_=_.filter(ce=>{const se=m.URI.file(ce);return(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:(0,w.isEqualAuthority)((0,A.getRemoteAuthority)(se),q)}),N=N.filter(ce=>{const se=this.cliArgToUri(ce);return se&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,w.isEqualAuthority)((0,A.getRemoteAuthority)(se),q):!1}),T=T.filter(ce=>{const se=this.cliArgToUri(ce);return se&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,w.isEqualAuthority)((0,A.getRemoteAuthority)(se),q):!1}),U.cli._=_,U.cli["folder-uri"]=N,U.cli["file-uri"]=T;const Z=!_.length&&!N.length&&!T.length,oe={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:Z,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:q};return this.open(oe)}openInBrowserWindow(O){const U=this.configurationService.getValue("window"),W={...this.environmentMainService.args,...O.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.initialUserEnv,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:f.default,isInitialStartup:O.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof U?.zoomLevel=="number"?U.zoomLevel:void 0,autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme()};let N;if(!O.forceNewWindow&&!O.forceNewTabbedWindow&&(N=O.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const T=N.config;!W.extensionDevelopmentPath&&T&&!!T.extensionDevelopmentPath&&(W.extensionDevelopmentPath=T.extensionDevelopmentPath,W.verbose=T.verbose,W["inspect-brk-extensions"]=T["inspect-brk-extensions"],W.debugId=T.debugId,W.extensionEnvironment=T.extensionEnvironment,W["inspect-extensions"]=T["inspect-extensions"],W["extensions-dir"]=T["extensions-dir"])}else{const T=this.windowsStateHandler.getNewWindowState(W);(0,d.mark)("code/willCreateCodeWindow");const _=N=this.instantiationService.createInstance(J.CodeWindow,{state:T,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow){const Z=this.getLastActiveWindow();Z&&Z.addTabbedWindow(_)}st.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,b.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,b.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,b.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_));const q=(0,C.assertIsDefined)(_.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return W.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(T=>{T||this.doOpenInBrowserWindow(N,W,O)}):this.doOpenInBrowserWindow(N,W,O),N}doOpenInBrowserWindow(O,U,W){if(!U.extensionDevelopmentPath)if((0,re.isWorkspaceIdentifier)(U.workspace))U.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:U.workspace,remoteAuthority:U.remoteAuthority});else if((0,re.isSingleFolderWorkspaceIdentifier)(U.workspace))U.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority});else{const N=W.emptyWindowBackupInfo&&W.emptyWindowBackupInfo.backupFolder;U.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,U.remoteAuthority)}O.load(U)}onWindowClosed(O){const U=st.WINDOWS.indexOf(O);st.WINDOWS.splice(U,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=y.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(O){return this.doGetLastActiveWindow(this.getWindows().filter(U=>(0,w.isEqualAuthority)(U.remoteAuthority,O)))}doGetLastActiveWindow(O){const U=Math.max.apply(Math,O.map(W=>W.lastFocusTime));return O.find(W=>W.lastFocusTime===U)}sendToFocused(O,...U){const W=this.getFocusedWindow()||this.getLastActiveWindow();W&&W.sendWhenReady(O,M.CancellationToken.None,...U)}sendToAll(O,U,W){for(const N of this.getWindows())W&&W.indexOf(N.id)>=0||N.sendWhenReady(O,M.CancellationToken.None,U)}getWindows(){return st.WINDOWS}getWindowCount(){return st.WINDOWS.length}getWindowById(O){const U=this.getWindows().filter(W=>W.id===O);return(0,D.firstOrDefault)(U)}getWindowByWebContents(O){const U=y.BrowserWindow.fromWebContents(O);if(!!U)return this.getWindowById(U.id)}};te.WINDOWS=[],te=de([ie(2,a.ILogService),ie(3,F.IStateMainService),ie(4,i.IEnvironmentMainService),ie(5,r.ILifecycleMainService),ie(6,c.IBackupMainService),ie(7,s.IConfigurationService),ie(8,X.IWorkspacesHistoryMainService),ie(9,j.IWorkspacesManagementMainService),ie(10,o.IInstantiationService),ie(11,l.IDialogMainService),ie(12,n.IFileService),ie(13,S.IProductService),ie(14,R.IProtocolMainService),ie(15,B.IThemeMainService)],te),e.WindowsMainService=te}),define(x[239],ee([0,1,52,34,68,42]),function(V,e,y,t,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(g,b,k,P){this.workspacesManagementMainService=g,this.windowsMainService=b,this.workspacesHistoryMainService=k,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,b){const k=this.windowsMainService.getWindowById(g);if(k)return this.workspacesManagementMainService.enterWorkspace(k,this.windowsMainService.getWindows(),b)}createUntitledWorkspace(g,b,k){return this.workspacesManagementMainService.createUntitledWorkspace(b,k)}deleteUntitledWorkspace(g,b){return this.workspacesManagementMainService.deleteUntitledWorkspace(b)}getWorkspaceIdentifier(g,b){return this.workspacesManagementMainService.getWorkspaceIdentifier(b)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(g))}addRecentlyOpened(g,b){return this.workspacesHistoryMainService.addRecentlyOpened(b)}removeRecentlyOpened(g,b){return this.workspacesHistoryMainService.removeRecentlyOpened(b)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=de([ie(0,D.IWorkspacesManagementMainService),ie(1,t.IWindowsMainService),ie(2,L.IWorkspacesHistoryMainService),ie(3,y.IBackupMainService)],M),e.WorkspacesMainService=M}),define(x[240],ee([0,1,14,37,30,27,18,39,15,29,43,44,33,2,10,8,3,12,7,31,74,128,38,129,91,214,137,52,223,17,62,165,77,106,48,94,163,24,51,99,171,189,172,221,95,173,174,21,184,79,76,5,78,232,199,107,22,6,186,237,59,19,65,227,80,46,218,83,200,32,202,204,66,41,208,230,233,231,234,102,209,210,211,212,216,34,238,217,25,81,68,239,42,215]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i,n,o,r,a,f,S,R,A,F,$,J,ne,Y,re,H,X,j,B,z,K,te,Q,O,U,W,N,T,_,q,Z,oe,ce,se,he,ue,ge,Ee,Pe,be,Se,Ie,We,_e,Je,Ue,qe,ot,Ze,xe,vt,at,je,et,G,ae,le,me,ve,Me,Ne,Qe,Ke,Oe,He,Ve,tt,ct,Mt,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let St=class extends v.Disposable{constructor(fe,pe,ye,we,ke,Ae,Re,De,Ce,Le){super();this.mainProcessNodeIpcServer=fe,this.userEnv=pe,this.mainInstantiationService=ye,this.logService=we,this.environmentMainService=ke,this.lifecycleMainService=Ae,this.configurationService=Re,this.stateMainService=De,this.fileService=Ce,this.productService=Le,this.configureSession(),this.registerListeners()}configureSession(){const fe=Ce=>Ce?.startsWith(`${d.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);y.session.defaultSession.setPermissionRequestHandler((Ce,Le,Te,Be)=>fe(Be.requestingUrl)?Te(pe.has(Le)):Te(!1)),y.session.defaultSession.setPermissionCheckHandler((Ce,Le,Te,Be)=>fe(Be.requestingUrl)?pe.has(Le):!1);const ye=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),we=Ce=>{for(let Le=Ce;Le;Le=Le.parent)if(Le.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},ke=Ce=>Ce.resourceType==="xhr"||we(Ce.frame),Ae=Ce=>{const Le=Ce.frame;if(!Le||!this.windowsMainService)return!1;const Te=y.BrowserWindow.getAllWindows();for(const Be of Te)if(Le.processId===Be.webContents.mainFrame.processId)return!0;return!1},Re=(Ce,Le)=>{if(Ce.path!=="/index.html")return!0;const Te=Le.frame;if(!Te||!this.windowsMainService)return!1;for(const Be of this.windowsMainService.getWindows())if(Be.win&&Te.processId===Be.win.webContents.mainFrame.processId)return!0;return!1};y.session.defaultSession.webRequest.onBeforeRequest((Ce,Le)=>{const Te=C.URI.parse(Ce.url);return Te.scheme===d.Schemas.vscodeWebview&&!Re(Te,Ce)?(this.logService.error("Blocked vscode-webview request",Ce.url),Le({cancel:!0})):Te.scheme===d.Schemas.vscodeFileResource&&!Ae(Ce)?(this.logService.error("Blocked vscode-file request",Ce.url),Le({cancel:!0})):Te.path.endsWith(".svg")&&!ye.has(Te.scheme)?Le({cancel:!ke(Ce)}):Le({cancel:!1})}),y.session.defaultSession.webRequest.onHeadersReceived((Ce,Le)=>{const Te=Ce.responseHeaders,Be=Te["content-type"]||Te["Content-Type"];if(Be&&Array.isArray(Be)){const Ye=C.URI.parse(Ce.url);if(Ye.path.endsWith(".svg")&&ye.has(Ye.scheme))return Te["Content-Type"]=["image/svg+xml"],Le({cancel:!1,responseHeaders:Te});if(!Ye.path.endsWith(d.Schemas.vscodeRemoteResource)&&Be.some(it=>it.toLowerCase().includes("image/svg")))return Le({cancel:!ke(Ce)})}return Le({cancel:!1})});const De=y.session.defaultSession;typeof De.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&De.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,g.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,g.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,g.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),y.app.on("accessibility-support-changed",(ye,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),y.app.on("activate",(ye,we)=>{this.logService.trace("app#activate"),we||this.windowsMainService?.openEmptyWindow({context:1})}),y.app.on("web-contents-created",(ye,we)=>{we.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),we.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let fe=[],pe;y.app.on("open-file",(ye,we)=>{this.logService.trace("app#open-file: ",we),ye.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(we)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],pe=void 0},100)}),y.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const we=this.windowsMainService?.getWindowByWebContents(ye.sender);let ke,Ae;return we?.config?(ke=we.config,Ae={...process.env,...we.config.userEnv}):(ke=this.environmentMainService.args,Ae=process.env),this.resolveShellEnvironment(ke,Ae,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,we,ke)=>{const Ae=this.validateNlsPath([we]);if(!Ae||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ae,M.VSBuffer.fromString(ke))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...we)=>{const ke=this.validateNlsPath(we);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(fe){let pe;for(const ye of fe)typeof ye=="string"&&(typeof pe!="string"?pe=ye:pe=(0,h.join)(pe,ye));if(!(typeof pe!="string"||!(0,h.isAbsolute)(pe)||!(0,b.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!p.isLinux)))return C.URI.file(pe)}onUnexpectedError(fe){if(fe){const pe={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;p.isWindows&&fe&&y.app.setAppUserModelId(fe);try{p.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!y.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&y.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ce){this.logService.error(Ce)}const pe=new l.Server;this.lifecycleMainService.onWillShutdown(Ce=>{Ce.reason===2&&pe.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:we,sharedProcessReady:ke,sharedProcessClient:Ae}=this.setupSharedProcess(ye),Re=await this.initServices(ye,we,ke);this._register(Re.createInstance(n.ProxyAuthHandler)),Re.invokeFunction(Ce=>this.initChannels(Ce,pe,Ae));const De=Re.invokeFunction(Ce=>this.openFirstWindow(Ce,pe));Re.invokeFunction(Ce=>this.afterWindowOpen(Ce,we)),this.environmentMainService.args.trace&&Re.invokeFunction(Ce=>this.stopTracingEventually(Ce,De))}async resolveMachineId(){let fe=this.stateMainService.getItem(Ue.machineIdKey);return(!fe||p.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,u.getMachineId)(),this.stateMainService.setItem(Ue.machineIdKey,fe)),fe}setupSharedProcess(fe){const pe=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,fe,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(ke,"main")})(),we=(async()=>(await pe.whenReady(),ye))();return{sharedProcess:pe,sharedProcessReady:we,sharedProcessClient:ye}}async initServices(fe,pe,ye){const we=new _.ServiceCollection;switch(process.platform){case"win32":we.set(xe.IUpdateService,new N.SyncDescriptor(G.Win32UpdateService));break;case"linux":p.isLinuxSnap?we.set(xe.IUpdateService,new N.SyncDescriptor(et.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(xe.IUpdateService,new N.SyncDescriptor(je.LinuxUpdateService));break;case"darwin":we.set(xe.IUpdateService,new N.SyncDescriptor(at.DarwinUpdateService));break}we.set(Qe.IWindowsMainService,new N.SyncDescriptor(Ke.WindowsMainService,[fe,this.userEnv])),we.set($.IDialogMainService,new N.SyncDescriptor($.DialogMainService)),we.set(oe.ILaunchMainService,new N.SyncDescriptor(oe.LaunchMainService)),we.set(F.IDiagnosticsMainService,new N.SyncDescriptor(F.DiagnosticsMainService)),we.set(A.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(ye.then(Ae=>Ae.getChannel("diagnostics"))))),we.set(q.IIssueMainService,new N.SyncDescriptor(q.IssueMainService,[this.userEnv])),we.set(J.IEncryptionMainService,new N.SyncDescriptor(ne.EncryptionMainService,[fe])),we.set(Z.IKeyboardLayoutMainService,new N.SyncDescriptor(Z.KeyboardLayoutMainService)),we.set(ge.INativeHostMainService,new N.SyncDescriptor(ge.NativeHostMainService,[pe])),we.set(S.ICredentialsMainService,new N.SyncDescriptor(Lt.CredentialsNativeMainService)),we.set(Me.IWebviewManagerService,new N.SyncDescriptor(Ne.WebviewMainService)),we.set(Ve.IWorkspacesService,new N.SyncDescriptor(ct.WorkspacesMainService)),we.set(Mt.IWorkspacesManagementMainService,new N.SyncDescriptor(Mt.WorkspacesManagementMainService)),we.set(tt.IWorkspacesHistoryMainService,new N.SyncDescriptor(tt.WorkspacesHistoryMainService)),we.set(ue.IMenubarMainService,new N.SyncDescriptor(ue.MenubarMainService)),we.set(X.IExtensionUrlTrustService,new N.SyncDescriptor(j.ExtensionUrlTrustService)),we.set(B.IExtensionHostStarter,new N.SyncDescriptor(z.WorkerMainProcessExtensionHostStarter)),we.set(_e.IStorageMainService,new N.SyncDescriptor(_e.StorageMainService)),we.set(_e.IGlobalStorageMainService,new N.SyncDescriptor(_e.GlobalStorageMainService)),p.isWindows?we.set(K.IExternalTerminalMainService,new N.SyncDescriptor(te.WindowsExternalTerminalService)):p.isMacintosh?we.set(K.IExternalTerminalMainService,new N.SyncDescriptor(te.MacExternalTerminalService)):p.isLinux&&we.set(K.IExternalTerminalMainService,new N.SyncDescriptor(te.LinuxExternalTerminalService));const ke=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(we.set(r.IBackupMainService,ke),we.set(ae.IURLService,new N.SyncDescriptor(me.NativeURLService)),(0,Ze.supportsTelemetry)(this.productService,this.environmentMainService)){const Ae=(0,s.getDelayedChannel)(ye.then(Te=>Te.getChannel("telemetryAppender"))),Re=new qe.TelemetryAppenderClient(Ae),De=(0,Je.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ce=(0,Ze.getPiiPathsFromEnvironment)(this.environmentMainService),Le={appenders:[Re],commonProperties:De,piiPaths:Ce,sendErrorTelemetry:!0};we.set(Ue.ITelemetryService,new N.SyncDescriptor(ot.TelemetryService,[Le]))}else we.set(Ue.ITelemetryService,Ze.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(we)}initChannels(fe,pe,ye){const we=s.ProxyChannel.fromService(fe.get(oe.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",we);const ke=s.ProxyChannel.fromService(fe.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const Ae=this.fileService.getProvider(d.Schemas.file);(0,w.assertType)(Ae instanceof W.DiskFileSystemProvider);const Re=new U.DiskFileSystemProviderChannel(Ae,this.logService,this.environmentMainService);pe.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Re),ye.then($e=>$e.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Re));const De=new vt.UpdateChannel(fe.get(xe.IUpdateService));pe.registerChannel("update",De);const Ce=s.ProxyChannel.fromService(fe.get(q.IIssueMainService));pe.registerChannel("issue",Ce);const Le=s.ProxyChannel.fromService(fe.get(J.IEncryptionMainService));pe.registerChannel("encryption",Le);const Te=s.ProxyChannel.fromService(fe.get(S.ICredentialsMainService));pe.registerChannel("credentials",Te);const Be=s.ProxyChannel.fromService(fe.get(Se.ISignService));pe.registerChannel("sign",Be);const Ye=s.ProxyChannel.fromService(fe.get(Z.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Ye),this.nativeHostMainService=fe.get(ge.INativeHostMainService);const it=s.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",it),ye.then($e=>$e.registerChannel("nativeHost",it));const yt=s.ProxyChannel.fromService(fe.get(Ve.IWorkspacesService));pe.registerChannel("workspaces",yt);const ze=s.ProxyChannel.fromService(fe.get(ue.IMenubarMainService));pe.registerChannel("menubar",ze);const ft=s.ProxyChannel.fromService(fe.get(ae.IURLService));pe.registerChannel("url",ft);const lt=s.ProxyChannel.fromService(fe.get(X.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",lt);const ut=s.ProxyChannel.fromService(fe.get(Me.IWebviewManagerService));pe.registerChannel("webview",ut);const ht=this._register(new We.StorageDatabaseChannel(this.logService,fe.get(_e.IStorageMainService)));pe.registerChannel("storage",ht),ye.then($e=>$e.registerChannel("storage",ht));const gt=s.ProxyChannel.fromService(fe.get(K.IExternalTerminalMainService));pe.registerChannel("externalTerminal",gt);const nt=new he.LogLevelChannel(fe.get(se.ILogService));pe.registerChannel("logLevel",nt),ye.then($e=>$e.registerChannel("logLevel",nt));const rt=new he.LoggerChannel(fe.get(se.ILoggerService));pe.registerChannel("logger",rt),ye.then($e=>$e.registerChannel("logger",rt));const mt=new R.ElectronExtensionHostDebugBroadcastChannel(fe.get(Qe.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",mt);const Fe=s.ProxyChannel.fromService(fe.get(B.IExtensionHostStarter));pe.registerChannel(B.ipcExtensionHostStarterChannelName,Fe)}openFirstWindow(fe,pe){const ye=this.windowsMainService=fe.get(Qe.IWindowsMainService),we=fe.get(ae.IURLService),ke=fe.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const Ae=[],Re=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Fe=>{try{return{uri:C.URI.parse(Fe),url:Fe}}catch{return}}).filter(Fe=>{if(!Fe||this.shouldBlockURI(Fe.uri))return!1;const $e=this.getWindowOpenableFromProtocolLink(Fe.uri);return $e?(Ae.push($e),!1):!0}),De=this,Ce=this.environmentMainService,Le=this.productService,Te=this.logService;we.registerHandler({async handleURL(Fe,$e){if(Te.trace("app#handleURL: ",Fe.toString(!0),$e),Fe.scheme===Le.urlProtocol&&Fe.path==="workspace"&&(Fe=Fe.with({authority:"file",path:C.URI.parse(Fe.query).path,query:""})),De.shouldBlockURI(Fe))return!0;let dt=!1;const bt=new URLSearchParams(Fe.query);bt.get("windowId")==="_blank"&&(bt.delete("windowId"),Fe=Fe.with({query:bt.toString()}),dt=!0),dt||(dt=p.isMacintosh&&ye.getWindowCount()===0);const Et=De.getWindowOpenableFromProtocolLink(Fe);if(Te.trace("app#handleURL: windowOpenableFromProtocolLink = ",Et),Et){const[Ct]=ye.open({context:5,cli:{...Ce.args},urisToOpen:[Et],forceNewWindow:dt,gotoLineMode:!0});return Ct.focus(),!0}if(dt){const[Ct]=ye.open({context:5,cli:{...Ce.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Pe.getRemoteAuthority)(Fe)});return await Ct.ready(),we.open(Fe,$e)}return!1}});const Be=this._register(new Oe.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ye=new s.StaticRouter(Fe=>Be.getActiveClientId().then($e=>Fe===$e)),it=new le.URLHandlerRouter(Ye),yt=pe.getChannel("urlHandler",it);we.registerHandler(new le.URLHandlerChannelClient(yt)),this._register(new ve.ElectronURLListener(Re,we,ye,this.environmentMainService,this.productService));const ze=this.environmentMainService.args,ft=global.macOpenFiles,lt=(0,re.isLaunchedFromCli)(process.env)?0:4,ut=ze._.length,ht=!!ze["folder-uri"],gt=!!ze["file-uri"],nt=ze["skip-add-to-recently-opened"]===!0,rt=ze.wait&&ze.waitMarkerFilePath?C.URI.file(ze.waitMarkerFilePath):void 0,mt=ze.remote||void 0;return Ae.length>0?ye.open({context:lt,cli:ze,urisToOpen:Ae,gotoLineMode:!0,initialStartup:!0}):ze["new-window"]&&!ut&&!ht&&!gt?ye.open({context:lt,cli:ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0,remoteAuthority:mt}):ft.length&&!ut&&!ht&&!gt?ye.open({context:1,cli:ze,urisToOpen:ft.map(Fe=>this.getWindowOpenableFromPathSync(Fe)),noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0}):ye.open({context:lt,cli:ze,forceNewWindow:ze["new-window"]||!ut&&ze["unity-launch"],diffMode:ze.diff,noRecentEntry:nt,waitMarkerFileURI:rt,gotoLineMode:ze.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(fe){return!!(fe.authority===d.Schemas.file&&p.isWindows&&y.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,I.getPathLabel)(fe,{os:p.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===d.Schemas.file){const pe=C.URI.file(fe.fsPath);return(0,He.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(fe.authority===d.Schemas.vscodeRemote){const pe=fe.path.indexOf(h.posix.sep,1);if(pe!==-1){const ye=fe.path.substring(1,pe),we=fe.path.substring(pe),ke=C.URI.from({scheme:d.Schemas.vscodeRemote,authority:ye,path:we,query:fe.query,fragment:fe.fragment});return(0,He.hasWorkspaceFileExtension)(we)?{workspaceUri:ke}:/:[\d]+$/.test(we)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:C.URI.file(fe)};if((0,He.hasWorkspaceFileExtension)(fe))return{workspaceUri:C.URI.file(fe)}}catch{}return{fileUri:C.URI.file(fe)}}async afterWindowOpen(fe,pe){this.lifecycleMainService.phase=3;let ye=!1;(0,k.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const we=fe.get(Ue.ITelemetryService);this._register(pe.onDidError(({type:Re,details:De})=>{let Ce;switch(Re){case 1:Ce="SharedProcess: detected unresponsive window";break;case 2:Ce=`SharedProcess: crashed (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break;case 3:Ce=`SharedProcess: failed to load (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break}(0,g.onUnexpectedError)(new Error(Ce)),we.publicLog2("sharedprocesserror",{type:Re,reason:De?.reason,code:De?.exitCode,visible:pe.isVisible(),shuttingdown:ye})}));const ke=this.productService.win32MutexName;if(p.isWindows&&ke)try{const Re=V.__$__nodeRequire("windows-mutex").Mutex,De=new Re(ke);(0,k.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Re){this.logService.error(Re)}y.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Re,De)=>{De({url:Re.url.replace(/^vscode-remote-resource:/,"http:"),method:Re.method})});const Ae=fe.get(xe.IUpdateService);(Ae instanceof G.Win32UpdateService||Ae instanceof je.LinuxUpdateService||Ae instanceof at.DarwinUpdateService)&&await Ae.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,P.stripComments)(De))["enable-crash-reporter"]===void 0){const Te=(0,Ze.getTelemetryLevel)(this.configurationService)>=1,Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Te},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],Ye=De.substring(0,De.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Ye))}}catch(Re){this.logService.error(Re)}}async resolveShellEnvironment(fe,pe,ye){try{return await(0,H.getResolvedShellEnv)(this.logService,fe,pe)}catch(we){const ke=(0,E.toErrorMessage)(we);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(fe,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ye=fe.get($.IDialogMainService);let we=!1;const ke=async Re=>{if(we)return;we=!0;const De=await y.contentTracing.stopRecording(`${(0,b.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Re?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,De),buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,w.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))},Ae=setTimeout(()=>ke(!0),3e4);Promise.all(pe.map(Re=>Re.ready())).then(()=>{clearTimeout(Ae),ke(!1)})}};St=de([ie(2,T.IInstantiationService),ie(3,se.ILogService),ie(4,Y.IEnvironmentMainService),ie(5,ce.ILifecycleMainService),ie(6,f.IConfigurationService),ie(7,Ie.IStateMainService),ie(8,O.IFileService),ie(9,Ee.IProductService)],St),e.CodeApplication=St}),define(x[247],ee([0,1,14,30,7,26,9,39,15,29,43,33,10,8,64,3,36,28,20,38,82,240,11,17,193,201,24,51,168,21,182,79,76,179,78,22,97,6,187,98,54,19,55,190,101,229,57,226,80,198,46,228,66,58,207]),function(V,e,y,t,L,D,M,E,g,b,k,P,I,v,d,h,p,w,C,m,u,c,s,l,i,n,o,r,a,f,S,R,A,F,$,J,ne,Y,re,H,X,j,B,z,K,te,Q,O,U,W,N,T,_,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(se){console.error(se.message),y.app.exit(1)}}async startup(){(0,g.setUnexpectedErrorHandler)(Se=>console.error(Se));const[se,he,ue,ge,Ee,Pe,be]=this.createServices();try{try{await this.initServices(ue,ge,Ee)}catch(Se){throw this.handleStartupDataDirError(ue,be.nameLong,Se),Se}await se.invokeFunction(async Se=>{const Ie=Se.get(Y.ILogService),We=Se.get(J.ILifecycleMainService),_e=Se.get(f.IFileService),Je=await this.claimInstance(Ie,ue,We,se,be,!0);return C.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Ue=>{Ie.warn(`Error writing main lockfile: ${Ue.stack}`)}),Pe.logger=new H.SpdLogLogger("main",(0,v.join)(ue.logsPath,"main.log"),!0,!1,Pe.getLevel()),(0,k.once)(We.onWillShutdown)(Ue=>{_e.dispose(),ge.dispose(),Ue.join(C.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),se.createInstance(c.CodeApplication,Je,he).startup()})}catch(Se){se.invokeFunction(this.quit,Se)}}createServices(){const se=new $.ServiceCollection,he={_serviceBrand:void 0,...X.default};se.set(j.IProductService,he);const ue=new o.EnvironmentMainService(this.resolveArgs(),he),ge=this.patchEnvironment(ue);se.set(o.IEnvironmentMainService,ue);const Ee=new ne.BufferLogService,Pe=new Y.MultiplexLogService([new Y.ConsoleMainLogger((0,Y.getLogLevel)(ue)),Ee]);process.once("exit",()=>Pe.dispose()),se.set(Y.ILogService,Pe);const be=new S.FileService(Pe);se.set(f.IFileService,be);const Se=new R.DiskFileSystemProvider(Pe);be.registerProvider(I.Schemas.file,Se),se.set(Y.ILoggerService,new re.LoggerService(Pe,be));const Ie=new i.ConfigurationService(ue.settingsResource,be);se.set(l.IConfigurationService,Ie),se.set(J.ILifecycleMainService,new A.SyncDescriptor(J.LifecycleMainService));const We=new T.StateMainService(ue,Pe,be);return se.set(N.IStateMainService,We),se.set(Q.IRequestService,new A.SyncDescriptor(O.RequestMainService)),se.set(q.IThemeMainService,new A.SyncDescriptor(q.ThemeMainService)),se.set(U.ISignService,new A.SyncDescriptor(W.SignService)),se.set(K.ITunnelService,new A.SyncDescriptor(te.TunnelService)),se.set(B.IProtocolMainService,new A.SyncDescriptor(z.ProtocolMainService)),[new F.InstantiationService(se,!0),ge,ue,Ie,We,Ee,he]}patchEnvironment(se){const he={VSCODE_IPC_HOOK:se.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const ge=process.env[ue];typeof ge=="string"&&(he[ue]=ge)}),Object.assign(process.env,he),he}initServices(se,he,ue){return M.Promises.settled([Promise.all([se.extensionsPath,se.codeCachePath,se.logsPath,se.globalStorageHome.fsPath,se.workspaceStorageHome.fsPath,se.localHistoryHome.fsPath,se.backupHome].map(ge=>ge?C.Promises.mkdir(ge,{recursive:!0}):void 0)),he.initialize(),ue.init()])}async claimInstance(se,he,ue,ge,Ee,Pe){let be;try{(0,d.mark)("code/willStartMainServer"),be=await(0,u.serve)(he.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,k.once)(ue.onWillShutdown)(()=>be.dispose())}catch(Se){if(Se.code!=="EADDRINUSE")throw this.handleStartupDataDirError(he,Ee.nameLong,Se),Se;let Ie;try{Ie=await(0,u.connect)(he.mainIPCHandle,"main")}catch(Ue){if(!Pe||h.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,Ee.nameShort),(0,s.localize)(1,null),Ee.nameLong),Ue;try{(0,t.unlinkSync)(he.mainIPCHandle)}catch(qe){throw se.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(se,he,ue,ge,Ee,!1)}if(he.extensionTestsLocationURI&&!he.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw se.error(Ue),Ie.dispose(),new Error(Ue)}let We;!he.args.wait&&!he.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,Ee.nameShort),(0,s.localize)(3,null),Ee.nameLong)},1e4));const _e=m.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),Je=m.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(he.args.status)return ge.invokeFunction(async()=>{const Ue=new n.DiagnosticsService(_.NullTelemetryService,Ee),qe=await _e.getMainProcessInfo(),ot=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ze=await Ue.getDiagnostics(qe,ot);throw console.log(Ze),new g.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(_e,se),se.trace("Sending env to running instance..."),await _e.start(he.args,process.env),Ie.dispose(),We&&clearTimeout(We),new g.ExpectedError("Sent env to running instance. Terminating...")}if(he.args.status)throw se.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),be}handleStartupDataDirError(se,he,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const ge=(0,D.coalesce)([se.userDataPath,se.extensionsPath,u.XDG_RUNTIME_DIR]).map(Ee=>(0,P.getPathLabel)(L.URI.file(Ee),{os:h.OS,tildify:se}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,E.toErrorMessage)(ue),ge.join(`
`)),he)}}showStartupWarningDialog(se,he,ue){y.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,s.localize)(6,null))],message:se,detail:he,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(se,he){if(h.isWindows){const ue=await se.getMainProcessId();he.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((ge,Ee)=>{V(["windows-foreground-love"],ge,Ee)})).allowSetForegroundWindow(ue)}catch(ge){he.error(ge)}}}quit(se,he){const ue=se.get(Y.ILogService),ge=se.get(J.ILifecycleMainService);let Ee=0;he&&(he.isExpected?he.message&&ue.trace(he.message):(Ee=1,he.stack?ue.error(he.stack):ue.error(`Startup error: ${he.toString()}`))),ge.kill(Ee)}resolveArgs(){const se=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(se.wait&&!se.waitMarkerFilePath){const he=(0,a.createWaitMarkerFile)(se.verbose);he&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",he),se.waitMarkerFilePath=he)}return se}validatePaths(se){if(se["open-url"]&&(se._urls=se._,se._=[]),!se.remote){const he=this.doValidatePaths(se._,se.goto);se._=he}return se}doValidatePaths(se,he){const ue=(0,p.cwd)(),ge=se.map(be=>{let Se=String(be),Ie;he&&(Ie=(0,b.parseLineAndColumnAware)(Se),Se=Ie.path),Se&&(Se=this.preparePath(ue,Se));const We=(0,b.sanitizeFilePath)(Se,ue),_e=(0,v.basename)(We);return _e&&!(0,b.isValidBasename)(_e)?null:he&&Ie?(Ie.path=We,this.toPath(Ie)):We}),Ee=h.isWindows||h.isMacintosh,Pe=(0,D.distinct)(ge,be=>be&&Ee?be.toLowerCase():be||"");return(0,D.coalesce)(Pe)}preparePath(se,he){return h.isWindows&&(he=(0,w.rtrim)(he,'"')),he=(0,w.trim)((0,w.trim)(he," "),"	"),h.isWindows&&(he=(0,v.resolve)(se,he),he=(0,w.rtrim)(he,".")),he}toPath(se){const he=[se.path];return typeof se.line=="number"&&he.push(String(se.line)),typeof se.column=="number"&&he.push(String(se.column)),he.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c29becfad5f68270b9b23efeafb147722c5feba/core/vs/code/electron-main/main.js.map
