/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],te=function(_){for(var i=[],D=0,I=_.length;D<I;D++)i[D]=ee[_[D]];return i};define(ee[61],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function D(I,P){if(!I)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=D}),define(ee[45],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(T){return(v,l,m)=>{let L=null,O=null;if(typeof m.value=="function"?(L="value",O=m.value):typeof m.get=="function"&&(L="get",O=m.get),!O)throw new Error("not supported");m[L]=T(O,l)}}i.createDecorator=D;function I(T,v,l){let m=null,L=null;if(typeof l.value=="function"?(m="value",L=l.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",L=l.get),!L)throw new Error("not supported");const O=`$memoize$${v}`;l[m]=function(...p){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,p)}),this[O]}}i.memoize=I;function P(T,v,l){return D((m,L)=>{const O=`$debounce$${L}`,p=`$debounce$result$${L}`;return function(...w){this[p]||(this[p]=l?l():void 0),clearTimeout(this[O]),v&&(this[p]=v(this[p],...w),w=[this[p]]),this[O]=setTimeout(()=>{m.apply(this,w),this[p]=l?l():void 0},T)}})}i.debounce=P;function R(T,v,l){return D((m,L)=>{const O=`$throttle$timer$${L}`,p=`$throttle$result$${L}`,w=`$throttle$lastRun$${L}`,b=`$throttle$pending$${L}`;return function(...g){if(this[p]||(this[p]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),v&&(this[p]=v(this[p],...g)),this[b])return;const y=this[w]+T;y<=Date.now()?(this[w]=Date.now(),m.apply(this,[this[p]]),this[p]=l?l():void 0):(this[b]=!0,this[O]=setTimeout(()=>{this[b]=!1,this[w]=Date.now(),m.apply(this,[this[p]]),this[p]=l?l():void 0},y-Date.now()))}})}i.throttle=R}),define(ee[46],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function T(t,r=!1){let e=0,n=t.length,o="",c=0,f=16,d=0;function E(N){let W=0,G=0;for(;W<N;){const H=t.charCodeAt(e);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;e++,W++}return W<N&&(G=-1),G}function A(N){e=N,o="",c=0,f=16,d=0}function V(){const N=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&m(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&m(t.charCodeAt(e)))for(e++;e<t.length&&m(t.charCodeAt(e));)e++;else return d=3,t.substring(N,e);let W=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&m(t.charCodeAt(e))){for(e++;e<t.length&&m(t.charCodeAt(e));)e++;W=e}else d=3;return t.substring(N,W)}function Z(){let N="",W=e;for(;;){if(e>=n){N+=t.substring(W,e),d=2;break}const G=t.charCodeAt(e);if(G===34){N+=t.substring(W,e),e++;break}if(G===92){if(N+=t.substring(W,e),e++,e>=n){d=2;break}switch(t.charCodeAt(e++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const ie=E(4);ie>=0?N+=String.fromCharCode(ie):d=4;break}default:d=5}W=e;continue}if(G>=0&&G<=31)if(l(G)){N+=t.substring(W,e),d=2;break}else d=6;e++}return N}function Y(){if(o="",d=0,c=e,e>=n)return c=n,f=17;let N=t.charCodeAt(e);if(v(N)){do e++,o+=String.fromCharCode(N),N=t.charCodeAt(e);while(v(N));return f=15}if(l(N))return e++,o+=String.fromCharCode(N),N===13&&t.charCodeAt(e)===10&&(e++,o+=`
`),f=14;switch(N){case 123:return e++,f=1;case 125:return e++,f=2;case 91:return e++,f=3;case 93:return e++,f=4;case 58:return e++,f=6;case 44:return e++,f=5;case 34:return e++,o=Z(),f=10;case 47:{const W=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!l(t.charCodeAt(e));)e++;return o=t.substring(W,e),f=12}if(t.charCodeAt(e+1)===42){e+=2;const G=n-1;let H=!1;for(;e<G;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,H=!0;break}e++}return H||(e++,d=1),o=t.substring(W,e),f=13}return o+=String.fromCharCode(N),e++,f=16}case 45:if(o+=String.fromCharCode(N),e++,e===n||!m(t.charCodeAt(e)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=V(),f=11;default:for(;e<n&&ne(N);)e++,N=t.charCodeAt(e);if(c!==e){switch(o=t.substring(c,e),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(N),e++,f=16}}function ne(N){if(v(N)||l(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let N;do N=Y();while(N>=12&&N<=15);return N}return{setPosition:A,getPosition:()=>e,scan:r?re:Y,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>e-c,getTokenError:()=>d}}i.createScanner=T;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function l(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function O(t,r){const e=[],n=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function d(E,A,V,Z){c.value=E,c.offset=A,c.length=V,c.type=Z,c.colonOffset=void 0,o=c}try{S(t,{onObjectBegin:(E,A)=>{if(r<=E)throw n;o=void 0,f=r>E,e.push("")},onObjectProperty:(E,A,V)=>{if(r<A||(d(E,A,V,"property"),e[e.length-1]=E,r<=A+V))throw n},onObjectEnd:(E,A)=>{if(r<=E)throw n;o=void 0,e.pop()},onArrayBegin:(E,A)=>{if(r<=E)throw n;o=void 0,e.push(0)},onArrayEnd:(E,A)=>{if(r<=E)throw n;o=void 0,e.pop()},onLiteralValue:(E,A,V)=>{if(r<A||(d(E,A,V,s(E)),r<=A+V))throw n},onSeparator:(E,A,V)=>{if(r<=A)throw n;if(E===":"&&o&&o.type==="property")o.colonOffset=A,f=!1,o=void 0;else if(E===","){const Z=e[e.length-1];typeof Z=="number"?e[e.length-1]=Z+1:(f=!0,e[e.length-1]=""),o=void 0}}})}catch(E){if(E!==n)throw E}return{path:e,previousNode:o,isAtPropertyKey:f,matches:E=>{let A=0;for(let V=0;A<E.length&&V<e.length;V++)if(E[A]===e[V]||E[A]==="*")A++;else if(E[A]!=="**")return!1;return A===E.length}}}i.getLocation=O;function p(t,r=[],e=R.DEFAULT){let n=null,o=[];const c=[];function f(E){Array.isArray(o)?o.push(E):n!==null&&(o[n]=E)}return S(t,{onObjectBegin:()=>{const E={};f(E),c.push(o),o=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const E=[];f(E),c.push(o),o=E,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(E,A,V)=>{r.push({error:E,offset:A,length:V})}},e),o[0]}i.parse=p;function w(t,r=[],e=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function c(E){return n.children.push(E),E}S(t,{onObjectBegin:E=>{n=c({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,A,V)=>{n=c({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:A,length:V,parent:n})},onObjectEnd:(E,A)=>{n.length=E+A-n.offset,n=n.parent,o(E+A)},onArrayBegin:(E,A)=>{n=c({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,A)=>{n.length=E+A-n.offset,n=n.parent,o(E+A)},onLiteralValue:(E,A,V)=>{c({type:s(E),offset:A,length:V,parent:n,value:E}),o(A+V)},onSeparator:(E,A,V)=>{n.type==="property"&&(E===":"?n.colonOffset=A:E===","&&o(A))},onError:(E,A,V)=>{r.push({error:E,offset:A,length:V})}},e);const d=n.children[0];return d&&delete d.parent,d}i.parseTree=w;function b(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const c of e.children)if(Array.isArray(c.children)&&c.children[0].value===n){e=c.children[1],o=!0;break}if(!o)return}else{const o=n;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}i.findNodeAtLocation=b;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=g;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":{const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=y(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=y;function a(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=a;function u(t,r,e=!1){if(a(t,r,e)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const c=u(n[o],r,e);if(c)return c}return t}}i.findNodeAtOffset=u;function S(t,r,e=R.DEFAULT){const n=T(t,!1);function o($){return $?()=>$(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c($){return $?se=>$(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const f=o(r.onObjectBegin),d=c(r.onObjectProperty),E=o(r.onObjectEnd),A=o(r.onArrayBegin),V=o(r.onArrayEnd),Z=c(r.onLiteralValue),Y=c(r.onSeparator),ne=o(r.onComment),re=c(r.onError),N=e&&e.disallowComments,W=e&&e.allowTrailingComma;function G(){for(;;){const $=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:N||H(11);break;case 2:H(12);break;case 6:H(16);break}switch($){case 12:case 13:N?H(10):ne();break;case 16:H(1);break;case 15:case 14:break;default:return $}}}function H($,se=[],M=[]){if(re($),se.length+M.length>0){let U=n.getToken();for(;U!==17;){if(se.indexOf(U)!==-1){G();break}else if(M.indexOf(U)!==-1)break;U=G()}}}function ie($){const se=n.getTokenValue();return $?Z(se):d(se),G(),!0}function k(){switch(n.getToken()){case 11:{let $=0;try{$=JSON.parse(n.getTokenValue()),typeof $!="number"&&(H(2),$=0)}catch{H(2)}Z($);break}case 7:Z(null);break;case 8:Z(!0);break;case 9:Z(!1);break;default:return!1}return G(),!0}function C(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(Y(":"),G(),q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){f(),G();let $=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if($||H(4,[],[]),Y(","),G(),n.getToken()===2&&W)break}else $&&H(6,[],[]);C()||H(4,[],[2,5]),$=!0}return E(),n.getToken()!==2?H(7,[2],[]):G(),!0}function z(){A(),G();let $=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if($||H(4,[],[]),Y(","),G(),n.getToken()===4&&W)break}else $&&H(6,[],[]);q()||H(4,[],[4,5]),$=!0}return V(),n.getToken()!==4?H(8,[4],[]):G(),!0}function q(){switch(n.getToken()){case 3:return z();case 1:return F();case 10:return ie(!0);default:return k()}}return G(),n.getToken()===17?e.allowEmptyContent?!0:(H(4,[],[]),!1):q()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}i.visit=S;function h(t,r){let e=T(t),n=[],o,c=0,f;do switch(f=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:c!==f&&n.push(t.substring(c,f)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),c=e.getPosition();break}while(o!==17);return n.join("")}i.stripComments=h;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function _(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function T(l){R.push(l,Date.now())}function v(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:T,getMarks:v}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(P+T.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=D(I))}(),define(ee[47],te([0,1,10]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(I=i.Source||(i.Source={}));var P;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function R(v,...l){const m=l.reduce((p,w)=>(p[w]=!0,p),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(p=>!m[p]).forEach(p=>{for(let w=0;w<L.length;w++)if(p.search(L[w])!==-1){delete v[p];break}})}i.sanitizeProcessEnvironment=R;function T(v){!v||(delete v.DEBUG,D.isMacintosh&&delete v.DYLD_LIBRARY_PATH,D.isLinux&&delete v.LD_PRELOAD)}i.removeDangerousEnvVariables=T}),function(_,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var I in D)(typeof exports=="object"?exports:_)[I]=D[I]}}(typeof self!="undefined"?self:this,function(){return function(_){var i={};function D(I){if(i[I])return i[I].exports;var P=i[I]={i:I,l:!1,exports:{}};return _[I].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=_,D.c=i,D.d=function(I,P,R){D.o(I,P)||Object.defineProperty(I,P,{enumerable:!0,get:R})},D.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},D.t=function(I,P){if(1&P&&(I=D(I)),8&P||4&P&&typeof I=="object"&&I&&I.__esModule)return I;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:I}),2&P&&typeof I!="string")for(var T in I)D.d(R,T,function(v){return I[v]}.bind(null,T));return R},D.n=function(I){var P=I&&I.__esModule?function(){return I.default}:function(){return I};return D.d(P,"a",P),P},D.o=function(I,P){return Object.prototype.hasOwnProperty.call(I,P)},D.p="",D(D.s=0)}([function(_,i,D){(function(I){var P;i=_.exports=M,P=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,v=i.re=[],l=i.src=[],m=0,L=m++;l[L]="0|[1-9]\\d*";var O=m++;l[O]="[0-9]+";var p=m++;l[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=m++;l[w]="("+l[L]+")\\.("+l[L]+")\\.("+l[L]+")";var b=m++;l[b]="("+l[O]+")\\.("+l[O]+")\\.("+l[O]+")";var g=m++;l[g]="(?:"+l[L]+"|"+l[p]+")";var y=m++;l[y]="(?:"+l[O]+"|"+l[p]+")";var a=m++;l[a]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var u=m++;l[u]="(?:-?("+l[y]+"(?:\\."+l[y]+")*))";var S=m++;l[S]="[0-9A-Za-z-]+";var h=m++;l[h]="(?:\\+("+l[S]+"(?:\\."+l[S]+")*))";var s=m++,t="v?"+l[w]+l[a]+"?"+l[h]+"?";l[s]="^"+t+"$";var r="[v=\\s]*"+l[b]+l[u]+"?"+l[h]+"?",e=m++;l[e]="^"+r+"$";var n=m++;l[n]="((?:<|>)?=?)";var o=m++;l[o]=l[O]+"|x|X|\\*";var c=m++;l[c]=l[L]+"|x|X|\\*";var f=m++;l[f]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[a]+")?"+l[h]+"?)?)?";var d=m++;l[d]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[u]+")?"+l[h]+"?)?)?";var E=m++;l[E]="^"+l[n]+"\\s*"+l[f]+"$";var A=m++;l[A]="^"+l[n]+"\\s*"+l[d]+"$";var V=m++;l[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Z=m++;l[Z]="(?:~>?)";var Y=m++;l[Y]="(\\s*)"+l[Z]+"\\s+",v[Y]=new RegExp(l[Y],"g");var ne=m++;l[ne]="^"+l[Z]+l[f]+"$";var re=m++;l[re]="^"+l[Z]+l[d]+"$";var N=m++;l[N]="(?:\\^)";var W=m++;l[W]="(\\s*)"+l[N]+"\\s+",v[W]=new RegExp(l[W],"g");var G=m++;l[G]="^"+l[N]+l[f]+"$";var H=m++;l[H]="^"+l[N]+l[d]+"$";var ie=m++;l[ie]="^"+l[n]+"\\s*("+r+")$|^$";var k=m++;l[k]="^"+l[n]+"\\s*("+t+")$|^$";var C=m++;l[C]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[f]+")",v[C]=new RegExp(l[C],"g");var F=m++;l[F]="^\\s*("+l[f]+")\\s+-\\s+("+l[f]+")\\s*$";var z=m++;l[z]="^\\s*("+l[d]+")\\s+-\\s+("+l[d]+")\\s*$";var q=m++;l[q]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)P($,l[$]),v[$]||(v[$]=new RegExp(l[$]));function se(x,K){if(x instanceof M)return x;if(typeof x!="string"||x.length>R||!(K?v[e]:v[s]).test(x))return null;try{return new M(x,K)}catch{return null}}function M(x,K){if(x instanceof M){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof M))return new M(x,K);P("SemVer",x,K),this.loose=K;var J=x.trim().match(K?v[e]:v[s]);if(!J)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<T)return me}return fe}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}i.parse=se,i.valid=function(x,K){var J=se(x,K);return J?J.version:null},i.clean=function(x,K){var J=se(x.trim().replace(/^[=v]+/,""),K);return J?J.version:null},i.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof M||(x=new M(x,this.loose)),this.compareMain(x)||this.comparePre(x)},M.prototype.compareMain=function(x){return x instanceof M||(x=new M(x,this.loose)),j(this.major,x.major)||j(this.minor,x.minor)||j(this.patch,x.patch)},M.prototype.comparePre=function(x){if(x instanceof M||(x=new M(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],fe=x.prerelease[K];if(P("prerelease compare",K,J,fe),J===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(J===void 0)return-1;if(J!==fe)return j(J,fe)}while(++K)},M.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,K,J,fe){typeof J=="string"&&(fe=J,J=void 0);try{return new M(x,J).inc(K,fe).version}catch{return null}},i.diff=function(x,K){if(oe(x,K))return null;var J=se(x),fe=se(K);if(J.prerelease.length||fe.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==fe[me])return me},i.compareIdentifiers=j;var U=/^[0-9]+$/;function j(x,K){var J=U.test(x),fe=U.test(K);return J&&fe&&(x=+x,K=+K),J&&!fe?-1:fe&&!J?1:x<K?-1:x>K?1:0}function B(x,K,J){return new M(x,J).compare(new M(K,J))}function X(x,K,J){return B(x,K,J)>0}function Q(x,K,J){return B(x,K,J)<0}function oe(x,K,J){return B(x,K,J)===0}function ce(x,K,J){return B(x,K,J)!==0}function de(x,K,J){return B(x,K,J)>=0}function ve(x,K,J){return B(x,K,J)<=0}function le(x,K,J,fe){var me;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof J=="object"&&(J=J.version),me=x===J;break;case"!==":typeof x=="object"&&(x=x.version),typeof J=="object"&&(J=J.version),me=x!==J;break;case"":case"=":case"==":me=oe(x,J,fe);break;case"!=":me=ce(x,J,fe);break;case">":me=X(x,J,fe);break;case">=":me=de(x,J,fe);break;case"<":me=Q(x,J,fe);break;case"<=":me=ve(x,J,fe);break;default:throw new TypeError("Invalid operator: "+K)}return me}function ue(x,K){if(x instanceof ue){if(x.loose===K)return x;x=x.value}if(!(this instanceof ue))return new ue(x,K);P("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(x,K){return j(K,x)},i.major=function(x,K){return new M(x,K).major},i.minor=function(x,K){return new M(x,K).minor},i.patch=function(x,K){return new M(x,K).patch},i.compare=B,i.compareLoose=function(x,K){return B(x,K,!0)},i.rcompare=function(x,K,J){return B(K,x,J)},i.sort=function(x,K){return x.sort(function(J,fe){return i.compare(J,fe,K)})},i.rsort=function(x,K){return x.sort(function(J,fe){return i.rcompare(J,fe,K)})},i.gt=X,i.lt=Q,i.eq=oe,i.neq=ce,i.gte=de,i.lte=ve,i.cmp=le,i.Comparator=ue;var ye={};function ge(x,K){if(x instanceof ge)return x.loose===K?x:new ge(x.raw,K);if(x instanceof ue)return new ge(x.value,K);if(!(this instanceof ge))return new ge(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ee(x){return!x||x.toLowerCase()==="x"||x==="*"}function Fe(x,K,J,fe,me,Re,we,Oe,Ie,Te,Ne,De,Ce){return((K=Ee(J)?"":Ee(fe)?">="+J+".0.0":Ee(me)?">="+J+"."+fe+".0":">="+K)+" "+(Oe=Ee(Ie)?"":Ee(Te)?"<"+(+Ie+1)+".0.0":Ee(Ne)?"<"+Ie+"."+(+Te+1)+".0":De?"<="+Ie+"."+Te+"."+Ne+"-"+De:"<="+Oe)).trim()}function je(x,K){for(var J=0;J<x.length;J++)if(!x[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<x.length;J++)if(P(x[J].semver),x[J].semver!==ye&&x[J].semver.prerelease.length>0){var fe=x[J].semver;if(fe.major===K.major&&fe.minor===K.minor&&fe.patch===K.patch)return!0}return!1}return!0}function ze(x,K,J){try{K=new ge(K,J)}catch{return!1}return K.test(x)}function xe(x,K,J,fe){var me,Re,we,Oe,Ie;switch(x=new M(x,fe),K=new ge(K,fe),J){case">":me=X,Re=ve,we=Q,Oe=">",Ie=">=";break;case"<":me=Q,Re=de,we=X,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(x,K,fe))return!1;for(var Te=0;Te<K.set.length;++Te){var Ne=K.set[Te],De=null,Ce=null;if(Ne.forEach(function(ke){ke.semver===ye&&(ke=new ue(">=0.0.0")),De=De||ke,Ce=Ce||ke,me(ke.semver,De.semver,fe)?De=ke:we(ke.semver,Ce.semver,fe)&&(Ce=ke)}),De.operator===Oe||De.operator===Ie||(!Ce.operator||Ce.operator===Oe)&&Re(x,Ce.semver)||Ce.operator===Ie&&we(x,Ce.semver))return!1}return!0}ue.prototype.parse=function(x){var K=this.loose?v[ie]:v[k],J=x.match(K);if(!J)throw new TypeError("Invalid comparator: "+x);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new M(J[2],this.loose):this.semver=ye},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new M(x,this.loose)),le(x,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(x,K){if(!(x instanceof ue))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new ge(x.value,K),ze(this.value,J,K);if(x.operator==="")return J=new ge(this.value,K),ze(x.semver,J,K);var fe=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Re=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=le(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=le(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return fe||me||Re&&we||Oe||Ie},i.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),P("range",x,K);var J=K?v[z]:v[F];x=x.replace(J,Fe),P("hyphen replace",x),x=x.replace(v[C],"$1$2$3"),P("comparator trim",x,v[C]),x=(x=(x=x.replace(v[Y],"$1~")).replace(v[W],"$1^")).split(/\s+/).join(" ");var fe=K?v[ie]:v[k],me=x.split(" ").map(function(Re){return function(we,Oe){return P("comp",we),we=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Ne){return function(De,Ce){P("caret",De,Ce);var ke=Ce?v[H]:v[G];return De.replace(ke,function(Ae,pe,Se,be,Pe){var Le;return P("caret",De,Ae,pe,Se,be,Pe),Ee(pe)?Le="":Ee(Se)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(be)?Le=pe==="0"?">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+".0 <"+(+pe+1)+".0.0":Pe?(P("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=pe==="0"?Se==="0"?">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+Se+"."+(+be+1):">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+"."+be+Pe+" <"+(+pe+1)+".0.0"):(P("no pr"),Le=pe==="0"?Se==="0"?">="+pe+"."+Se+"."+be+" <"+pe+"."+Se+"."+(+be+1):">="+pe+"."+Se+"."+be+" <"+pe+"."+(+Se+1)+".0":">="+pe+"."+Se+"."+be+" <"+(+pe+1)+".0.0"),P("caret return",Le),Le})}(Ne,Te)}).join(" ")}(we,Oe),P("caret",we),we=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Ne){return function(De,Ce){var ke=Ce?v[re]:v[ne];return De.replace(ke,function(Ae,pe,Se,be,Pe){var Le;return P("tilde",De,Ae,pe,Se,be,Pe),Ee(pe)?Le="":Ee(Se)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(be)?Le=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0":Pe?(P("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+pe+"."+Se+"."+be+Pe+" <"+pe+"."+(+Se+1)+".0"):Le=">="+pe+"."+Se+"."+be+" <"+pe+"."+(+Se+1)+".0",P("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(we,Oe),P("tildes",we),we=function(Ie,Te){return P("replaceXRanges",Ie,Te),Ie.split(/\s+/).map(function(Ne){return function(De,Ce){De=De.trim();var ke=Ce?v[A]:v[E];return De.replace(ke,function(Ae,pe,Se,be,Pe,Le){P("xRange",De,Ae,pe,Se,be,Pe,Le);var Ve=Ee(Se),Me=Ve||Ee(be),Ue=Me||Ee(Pe);return pe==="="&&Ue&&(pe=""),Ve?Ae=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ue?(Me&&(be=0),Ue&&(Pe=0),pe===">"?(pe=">=",Me?(Se=+Se+1,be=0,Pe=0):Ue&&(be=+be+1,Pe=0)):pe==="<="&&(pe="<",Me?Se=+Se+1:be=+be+1),Ae=pe+Se+"."+be+"."+Pe):Me?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ue&&(Ae=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),P("xRange return",Ae),Ae})}(Ne,Te)}).join(" ")}(we,Oe),P("xrange",we),we=function(Ie,Te){return P("replaceStars",Ie,Te),Ie.trim().replace(v[q],"")}(we,Oe),P("stars",we),we}(Re,K)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Re){return!!Re.match(fe)})),me=me.map(function(Re){return new ue(Re,K)})},ge.prototype.intersects=function(x,K){if(!(x instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(fe){return x.set.some(function(me){return me.every(function(Re){return fe.intersects(Re,K)})})})})},i.toComparators=function(x,K){return new ge(x,K).set.map(function(J){return J.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new M(x,this.loose));for(var K=0;K<this.set.length;K++)if(je(this.set[K],x))return!0;return!1},i.satisfies=ze,i.maxSatisfying=function(x,K,J){var fe=null,me=null;try{var Re=new ge(K,J)}catch{return null}return x.forEach(function(we){Re.test(we)&&(fe&&me.compare(we)!==-1||(me=new M(fe=we,J)))}),fe},i.minSatisfying=function(x,K,J){var fe=null,me=null;try{var Re=new ge(K,J)}catch{return null}return x.forEach(function(we){Re.test(we)&&(fe&&me.compare(we)!==1||(me=new M(fe=we,J)))}),fe},i.validRange=function(x,K){try{return new ge(x,K).range||"*"}catch{return null}},i.ltr=function(x,K,J){return xe(x,K,"<",J)},i.gtr=function(x,K,J){return xe(x,K,">",J)},i.outside=xe,i.prerelease=function(x,K){var J=se(x,K);return J&&J.prerelease.length?J.prerelease:null},i.intersects=function(x,K,J){return x=new ge(x,J),K=new ge(K,J),x.intersects(K)},i.coerce=function(x){if(x instanceof M)return x;if(typeof x!="string")return null;var K=x.match(v[V]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(_,i){var D,I,P=_.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function v(y){if(D===setTimeout)return setTimeout(y,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch{I=T}})();var l,m=[],L=!1,O=-1;function p(){L&&l&&(L=!1,l.length?m=l.concat(m):O=-1,m.length&&w())}function w(){if(!L){var y=v(p);L=!0;for(var a=m.length;a;){for(l=m,m=[];++O<a;)l&&l[O].run();O=-1,a=m.length}l=null,L=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(y)}}function b(y,a){this.fun=y,this.array=a}function g(){}P.nextTick=function(y){var a=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)a[u-1]=arguments[u];m.push(new b(y,a)),m.length!==1||L||v(w)},b.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(y){return[]},P.binding=function(y){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(y){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ee[62],te([0,1]),function(_,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(v,l,m){this.level=v,this.key=l,this.value=m,this.forward=[]}}const P=void 0;class R{constructor(v,l=2**16){this.comparator=v,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,P,P)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,l){return R._insert(this,v,l,this.comparator)&&(this._size+=1),this}delete(v){const l=R._delete(this,v,this.comparator);return l&&(this._size-=1),l}forEach(v,l){let m=this._header.forward[0];for(;m;)v.call(l,m.value,m.key,this),m=m.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",l=this._header.forward[0];for(;l;)v+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return v}static _search(v,l,m){let L=v._header;for(let O=v._level-1;O>=0;O--)for(;L.forward[O]&&m(L.forward[O].key,l)<0;)L=L.forward[O];if(L=L.forward[0],L&&m(L.key,l)===0)return L}static _insert(v,l,m,L){let O=[],p=v._header;for(let w=v._level-1;w>=0;w--){for(;p.forward[w]&&L(p.forward[w].key,l)<0;)p=p.forward[w];O[w]=p}if(p=p.forward[0],p&&L(p.key,l)===0)return p.value=m,!1;{let w=R._randomLevel(v);if(w>v._level){for(let b=v._level;b<w;b++)O[b]=v._header;v._level=w}p=new I(w,l,m);for(let b=0;b<w;b++)p.forward[b]=O[b].forward[b],O[b].forward[b]=p;return!0}}static _randomLevel(v,l=.5){let m=1;for(;Math.random()<l&&m<v._maxLevel;)m+=1;return m}static _delete(v,l,m){let L=[],O=v._header;for(let p=v._level-1;p>=0;p--){for(;O.forward[p]&&m(O.forward[p].key,l)<0;)O=O.forward[p];L[p]=O}if(O=O.forward[0],!O||m(O.key,l)!==0)return!1;for(let p=0;p<v._level&&L[p].forward[p]===O;p++)L[p].forward[p]=O.forward[p];for(;v._level>0&&v._header.forward[v._level-1]===P;)v._level-=1;return!0}}i.SkipList=R}),define(ee[48],te([0,1,3,2]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const P=T=>({onDidChange:D.Event.None,value:T});i.staticObservableValue=P;class R extends I.Disposable{constructor(v){super();this._value=v,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}}i.MutableObservableValue=R}),define(ee[39],te([0,1,7,2]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(h){const s=h;return s?typeof s.read=="function":!1}i.isReadable=P;function R(h){const s=h;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}i.isReadableStream=R;function T(h){const s=h;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=T;function v(h,s){return new l(h,s)}i.newWriteableStream=v;class l{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const e=r.indexOf(t);e>=0&&r.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(h,s){const t=[];let r;for(;(r=h.read())!==null;)t.push(r);return s(t)}i.consumeReadable=m;function L(h,s,t){const r=[];let e;for(;(e=h.read())!==null&&r.length<t;)r.push(e);return e===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof e!="undefined"){const n=e;return e=void 0,n}return h.read()}}}i.peekReadable=L;function O(h,s){return new Promise((t,r)=>{const e=[];p(h,{onData:n=>{s&&e.push(n)},onError:n=>{s?r(n):t(void 0)},onEnd:()=>{t(s?s(e):void 0)}})})}i.consumeStream=O;function p(h,s){let t=!1;return h.on("error",r=>{t||s.onError(r)}),h.on("end",()=>{t||s.onEnd()}),h.on("data",r=>{t||s.onData(r)}),(0,I.toDisposable)(()=>t=!0)}i.listenStream=p;function w(h,s){return new Promise((t,r)=>{const e=new I.DisposableStore,n=[],o=d=>{if(n.push(d),n.length>s)return e.dispose(),h.pause(),t({stream:h,buffer:n,ended:!1})},c=d=>r(d),f=()=>t({stream:h,buffer:n,ended:!0});e.add((0,I.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),e.add((0,I.toDisposable)(()=>h.removeListener("end",f))),h.on("end",f),e.add((0,I.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}i.peekStream=w;function b(h,s){const t=v(s);return t.end(h),t}i.toStream=b;function g(){const h=v(()=>{throw new Error("not supported")});return h.end(),h}i.emptyStream=g;function y(h){let s=!1;return{read:()=>s?null:(s=!0,h)}}i.toReadable=y;function a(h,s,t){const r=v(t);return p(h,{onData:e=>r.write(s.data(e)),onError:e=>r.error(s.error?s.error(e):e),onEnd:()=>r.end()}),r}i.transform=a;function u(h,s,t){let r=!1;return{read:()=>{const e=s.read();return r?e:(r=!0,e!==null?t([h,e]):h)}}}i.prefixedReadable=u;function S(h,s,t){let r=!1;const e=v(t);return p(s,{onData:n=>r?e.write(n):(r=!0,e.write(t([h,n]))),onError:n=>e.error(n),onEnd:()=>{r||(r=!0,e.write(h)),e.end()}}),e}i.prefixedStream=S}),define(ee[16],te([0,1,39]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let P,R;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return I?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return I&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,E){return!(E?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(d)):(P||(P=new TextEncoder),new T(P.encode(d)))}static fromByteArray(d){const E=T.alloc(d.length);for(let A=0,V=d.length;A<V;A++)E.buffer[A]=d[A];return E}static concat(d,E){if(typeof E=="undefined"){E=0;for(let Z=0,Y=d.length;Z<Y;Z++)E+=d[Z].byteLength}const A=T.alloc(E);let V=0;for(let Z=0,Y=d.length;Z<Y;Z++){const ne=d[Z];A.set(ne,V),V+=ne.byteLength}return A}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,E){return new T(this.buffer.subarray(d,E))}set(d,E){if(d instanceof T)this.buffer.set(d.buffer,E);else if(d instanceof Uint8Array)this.buffer.set(d,E);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),E);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return m(this.buffer,d)}writeUInt32BE(d,E){L(this.buffer,d,E)}readUInt32LE(d){return O(this.buffer,d)}writeUInt32LE(d,E){p(this.buffer,d,E)}readUInt8(d){return w(this.buffer,d)}writeUInt8(d,E){b(this.buffer,d,E)}}i.VSBuffer=T;function v(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}i.readUInt16LE=v;function l(f,d,E){f[E+0]=d&255,d=d>>>8,f[E+1]=d&255}i.writeUInt16LE=l;function m(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}i.readUInt32BE=m;function L(f,d,E){f[E+3]=d,d=d>>>8,f[E+2]=d,d=d>>>8,f[E+1]=d,d=d>>>8,f[E]=d}i.writeUInt32BE=L;function O(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}i.readUInt32LE=O;function p(f,d,E){f[E+0]=d&255,d=d>>>8,f[E+1]=d&255,d=d>>>8,f[E+2]=d&255,d=d>>>8,f[E+3]=d&255}i.writeUInt32LE=p;function w(f,d){return f[d]}i.readUInt8=w;function b(f,d,E){f[E]=d}i.writeUInt8=b;function g(f){return D.consumeReadable(f,d=>T.concat(d))}i.readableToBuffer=g;function y(f){return D.toReadable(f)}i.bufferToReadable=y;function a(f){return D.consumeStream(f,d=>T.concat(d))}i.streamToBuffer=a;async function u(f){return f.ended?T.concat(f.buffer):T.concat([...f.buffer,await a(f.stream)])}i.bufferedStreamToBuffer=u;function S(f){return D.toStream(f,d=>T.concat(d))}i.bufferToStream=S;function h(f){return D.transform(f,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}i.streamToBufferReadableStream=h;function s(f){return D.newWriteableStream(d=>T.concat(d),f)}i.newWriteableBufferStream=s;function t(f,d){return D.prefixedReadable(f,d,E=>T.concat(E))}i.prefixedBufferReadable=t;function r(f,d){return D.prefixedStream(f,d,E=>T.concat(E))}i.prefixedBufferStream=r;function e(f){let d=0,E=0,A=0;const V=new Uint8Array(Math.floor(f.length/4*3)),Z=ne=>{switch(E){case 3:V[A++]=d|ne,E=0;break;case 2:V[A++]=d|ne>>>2,d=ne<<6,E=3;break;case 1:V[A++]=d|ne>>>4,d=ne<<4,E=2;break;default:d=ne<<2,E=1}};for(let ne=0;ne<f.length;ne++){const re=f.charCodeAt(ne);if(re>=65&&re<=90)Z(re-65);else if(re>=97&&re<=122)Z(re-97+26);else if(re>=48&&re<=57)Z(re-48+52);else if(re===43||re===45)Z(62);else if(re===47||re===95)Z(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${f[ne]}`)}}const Y=A;for(;E>0;)Z(0);return T.wrap(V).slice(0,Y)}i.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:f},d=!0,E=!1){const A=E?o:n;let V="";const Z=f.byteLength%3;let Y=0;for(;Y<f.byteLength-Z;Y+=3){const ne=f[Y+0],re=f[Y+1],N=f[Y+2];V+=A[ne>>>2],V+=A[(ne<<4|re>>>4)&63],V+=A[(re<<2|N>>>6)&63],V+=A[N&63]}if(Z===1){const ne=f[Y+0];V+=A[ne>>>2],V+=A[ne<<4&63],d&&(V+="==")}else if(Z===2){const ne=f[Y+0],re=f[Y+1];V+=A[ne>>>2],V+=A[(ne<<4|re>>>4)&63],V+=A[re<<2&63],d&&(V+="=")}return V}i.encodeBase64=c}),define(ee[63],te([0,1,25]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(a){return P(a,0)}i.hash=I;function P(a,u){switch(typeof a){case"object":return a===null?R(349,u):Array.isArray(a)?l(a,u):m(a,u);case"string":return v(a,u);case"boolean":return T(a,u);case"number":return R(a,u);case"undefined":return R(937,u);default:return R(617,u)}}i.doHash=P;function R(a,u){return(u<<5)-u+a|0}i.numberHash=R;function T(a,u){return R(a?433:863,u)}function v(a,u){u=R(149417,u);for(let S=0,h=a.length;S<h;S++)u=R(a.charCodeAt(S),u);return u}i.stringHash=v;function l(a,u){return u=R(104579,u),a.reduce((S,h)=>P(h,S),u)}function m(a,u){return u=R(181387,u),Object.keys(a).sort().reduce((S,h)=>(S=v(h,S),P(a[h],S)),u)}class L{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=P(u,this._value),this._value}}i.Hasher=L;var O;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function p(a,u,S=32){const h=S-u,s=~((1<<h)-1);return(a<<u|(s&a)>>>h)>>>0}function w(a,u=0,S=a.byteLength,h=0){for(let s=0;s<S;s++)a[u+s]=h}function b(a,u,S="0"){for(;a.length<u;)a=S+a;return a}function g(a,u=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(S=>S.toString(16).padStart(2,"0")).join(""):b((a>>>0).toString(16),u/4)}i.toHexString=g;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const S=u.length;if(S===0)return;const h=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,r,e;for(t!==0?(r=t,e=-1,t=0):(r=u.charCodeAt(0),e=0);;){let n=r;if(D.isHighSurrogate(r))if(e+1<S){const o=u.charCodeAt(e+1);D.isLowSurrogate(o)?(e++,n=D.computeCodePoint(r,o)):n=65533}else{t=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(h,s,n),e++,e<S)r=u.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(u,S,h){return h<128?u[S++]=h:h<2048?(u[S++]=192|(h&1984)>>>6,u[S++]=128|(h&63)>>>0):h<65536?(u[S++]=224|(h&61440)>>>12,u[S++]=128|(h&4032)>>>6,u[S++]=128|(h&63)>>>0):(u[S++]=240|(h&1835008)>>>18,u[S++]=128|(h&258048)>>>12,u[S++]=128|(h&4032)>>>6,u[S++]=128|(h&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=y._bigBlock32,S=this._buffDV;for(let f=0;f<64;f+=4)u.setUint32(f,S.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)u.setUint32(f,p(u.getUint32(f-12,!1)^u.getUint32(f-32,!1)^u.getUint32(f-56,!1)^u.getUint32(f-64,!1),1),!1);let h=this._h0,s=this._h1,t=this._h2,r=this._h3,e=this._h4,n,o,c;for(let f=0;f<80;f++)f<20?(n=s&t|~s&r,o=1518500249):f<40?(n=s^t^r,o=1859775393):f<60?(n=s&t|s&r|t&r,o=2400959708):(n=s^t^r,o=3395469782),c=p(h,5)+n+e+o+u.getUint32(f*4,!1)&4294967295,e=r,r=t,t=p(s,30),s=h,h=c;this._h0=this._h0+h&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[49],te([0,1,25]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const R="error",T="warning",v="warn",l="info",m="ignore";function L(p){return p?D.equalsIgnoreCase(R,p)?P.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(v,p)?P.Warning:D.equalsIgnoreCase(l,p)?P.Info:P.Ignore:P.Ignore}P.fromValue=L;function O(p){switch(p){case P.Error:return R;case P.Warning:return T;case P.Info:return l;default:return m}}P.toString=O}(I||(I={})),i.default=I}),define(ee[21],te([0,1,8]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const y=Array.isArray(g)?[]:{};return Object.keys(g).forEach(a=>{g[a]&&typeof g[a]=="object"?y[a]=I(g[a]):y[a]=g[a]}),y}i.deepClone=I;function P(g){if(!g||typeof g!="object")return g;const y=[g];for(;y.length>0;){const a=y.shift();Object.freeze(a);for(const u in a)if(R.call(a,u)){const S=a[u];typeof S=="object"&&!Object.isFrozen(S)&&!(0,D.isTypedArray)(S)&&y.push(S)}}return g}i.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function T(g,y){return v(g,y,new Set)}i.cloneAndChange=T;function v(g,y,a){if((0,D.isUndefinedOrNull)(g))return g;const u=y(g);if(typeof u!="undefined")return u;if((0,D.isArray)(g)){const S=[];for(const h of g)S.push(v(h,y,a));return S}if((0,D.isObject)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const S={};for(let h in g)R.call(g,h)&&(S[h]=v(g[h],y,a));return a.delete(g),S}return g}function l(g,y,a=!0){return(0,D.isObject)(g)?((0,D.isObject)(y)&&Object.keys(y).forEach(u=>{u in g?a&&((0,D.isObject)(g[u])&&(0,D.isObject)(y[u])?l(g[u],y[u],a):g[u]=y[u]):g[u]=y[u]}),g):y}i.mixin=l;function m(g,y){if(g===y)return!0;if(g==null||y===null||y===void 0||typeof g!=typeof y||typeof g!="object"||Array.isArray(g)!==Array.isArray(y))return!1;let a,u;if(Array.isArray(g)){if(g.length!==y.length)return!1;for(a=0;a<g.length;a++)if(!m(g[a],y[a]))return!1}else{const S=[];for(u in g)S.push(u);S.sort();const h=[];for(u in y)h.push(u);if(h.sort(),!m(S,h))return!1;for(a=0;a<S.length;a++)if(!m(g[S[a]],y[S[a]]))return!1}return!0}i.equals=m;function L(g){const y=new Set;return JSON.stringify(g,(a,u)=>{if((0,D.isObject)(u)||Array.isArray(u)){if(y.has(u))return"[Circular]";y.add(u)}return u})}i.safeStringify=L;function O(g,y,a){const u=y(g);return typeof u=="undefined"?a:u}i.getOrDefault=O;function p(g,y){const a=Object.create(null);return!g||!y||Object.keys(y).forEach(S=>{const h=g[S],s=y[S];m(h,s)||(a[S]=s)}),a}i.distinct=p;function w(g,y){const a=y.toLowerCase(),u=Object.keys(g).find(S=>S.toLowerCase()===a);return u?g[u]:g[y]}i.getCaseInsensitive=w;function b(g,y){const a=Object.create(null);for(const[u,S]of Object.entries(g))y(u,S)&&(a[u]=S);return a}i.filter=b}),define(ee[64],te([0,1,9]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(m){const L=m;return L&&typeof L.type=="string"&&typeof L.severity=="string"}i.isRemoteConsoleLog=I;function P(m){const L=[];let O;try{const p=JSON.parse(m.arguments),w=p[p.length-1];w&&w.__$stack&&(p.pop(),O=w.__$stack),L.push(...p)}catch{L.push("Unable to log remote console arguments",m.arguments)}return{args:L,stack:O}}i.parse=P;function R(m){if(typeof m!="string")return R(P(m).stack);const L=m;if(L){const O=T(L),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}i.getFirstFrame=R;function T(m){if(!m)return m;const L=m.indexOf(`
`);return L===-1?m:m.substring(0,L)}function v(m,L){const{args:O,stack:p}=P(m),w=typeof O[0]=="string"&&O.length===1;let b=T(p);b&&(b=`(${b.trim()})`);let g=[];if(typeof O[0]=="string"?b&&w?g=[`%c[${L}] %c${O[0]} %c${b}`,l("blue"),l(""),l("grey")]:g=[`%c[${L}] %c${O[0]}`,l("blue"),l(""),...O.slice(1)]:g=[`%c[${L}]%`,l("blue"),...O],b&&!w&&g.push(b),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}i.log=v;function l(m){return`color: ${m}`}}),define(ee[50],te([0,1,16,25,9]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function R(m){return JSON.stringify(m,v)}i.stringify=R;function T(m){let L=JSON.parse(m);return L=l(L),L}i.parse=T;function v(m,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,I.regExpFlags)(L)}:L}function l(m,L=0){if(!m||L>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return P.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof D.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let O=0;O<m.length;++O)m[O]=l(m[O],L+1);else for(const O in m)Object.hasOwnProperty.call(m,O)&&(m[O]=l(m[O],L+1))}return m}i.revive=l}),define(ee[65],te([0,1,18,51,14,11,10,17,25,9]),function(_,i,D,I,P,R,T,v,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function L(c,f){const{os:d,tildify:E,relative:A}=f;if(A){const Y=O(c,A,d);if(typeof Y=="string")return Y}let V=c.fsPath;if(d===1&&!T.isWindows?V=V.replace(/\//g,"\\"):d!==1&&T.isWindows&&(V=V.replace(/\\/g,"/")),d!==1&&E?.userHome){let Y=E.userHome.fsPath,ne;c.scheme!==E.userHome.scheme&&c.path.startsWith(R.posix.sep)?ne=E.userHome.with({path:c.path}).fsPath:ne=c.fsPath,V=g(ne,Y,d)}return(d===1?R.win32:R.posix).normalize(w(V,d===1))}i.getPathLabel=L;function O(c,f,d){const E=d===1?R.win32:R.posix,A=d===3?v.extUri:v.extUriIgnorePathCase,V=f.getWorkspace(),Z=(0,D.firstOrDefault)(V.folders);if(!Z)return;c.scheme!==Z.uri.scheme&&c.path.startsWith(R.posix.sep)&&(c=Z.uri.with({path:c.path}));const Y=f.getWorkspaceFolder(c);if(!Y)return;let ne;if(A.isEqual(Y.uri,c)?ne="":ne=A.relativePath(Y.uri,c)??"",ne&&(ne=E.normalize(ne)),V.folders.length>1&&!f.noPrefix){const re=Y.name?Y.name:A.basenameOrAuthority(Y.uri);ne=ne?`${re} \u2022 ${ne}`:re}return ne}function p(c){if(!c)return;typeof c=="string"&&(c=m.URI.file(c));const f=(0,v.basename)(c)||(c.scheme===P.Schemas.file?c.fsPath:c.path);return T.isWindows&&(0,I.isRootOrDriveLetter)(f)?w(f):f}i.getBaseLabel=p;function w(c,f=T.isWindows){return(0,I.hasDriveLetter)(c,f)?c.charAt(0).toUpperCase()+c.slice(1):c}i.normalizeDriveLetter=w;let b=Object.create(null);function g(c,f,d=T.OS){if(d===1||!c||!f)return c;let E=b.original===f?b.normalized:void 0;E||(E=f,T.isWindows&&(E=(0,I.toSlashes)(E)),E=`${(0,l.rtrim)(E,R.posix.sep)}${R.posix.sep}`,b={original:f,normalized:E});let A=c;return T.isWindows&&(A=(0,I.toSlashes)(A)),(d===3?A.startsWith(E):(0,l.startsWithIgnoreCase)(A,E))?`~/${A.substr(E.length)}`:c}i.tildify=g;function y(c,f){return c.replace(/^~($|\/|\\)/,`${f}$1`)}i.untildify=y;const a="\u2026",u="\\\\",S="~";function h(c,f=R.sep){const d=new Array(c.length);let E=!1;for(let A=0;A<c.length;A++){let V=c[A];if(V===""){d[A]=`.${f}`;continue}if(!V){d[A]=V;continue}E=!0;let Z="",Y=V;Y.indexOf(u)===0?(Z=Y.substr(0,Y.indexOf(u)+u.length),Y=Y.substr(Y.indexOf(u)+u.length)):Y.indexOf(f)===0?(Z=Y.substr(0,Y.indexOf(f)+f.length),Y=Y.substr(Y.indexOf(f)+f.length)):Y.indexOf(S)===0&&(Z=Y.substr(0,Y.indexOf(S)+S.length),Y=Y.substr(Y.indexOf(S)+S.length));const ne=Y.split(f);for(let re=1;E&&re<=ne.length;re++)for(let N=ne.length-re;E&&N>=0;N--){E=!1;let W=ne.slice(N,N+re).join(f);for(let G=0;!E&&G<c.length;G++)if(G!==A&&c[G]&&c[G].indexOf(W)>-1){const H=N+re===ne.length,ie=N>0&&c[G].indexOf(f)>-1?f+W:W,k=c[G].endsWith(ie);E=!H||k}if(!E){let G="";(ne[0].endsWith(":")||Z!=="")&&(N===1&&(N=0,re++,W=ne[0]+f+W),N>0&&(G=ne[0]+f),G=Z+G),N>0&&(G=G+a+f),G=G+W,N+re<ne.length&&(G=G+f+a),d[A]=G}}E&&(d[A]=V)}return d}i.shorten=h;var s;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function t(c,f=Object.create(null)){const d=[];let E=!1,A="";for(const V of c)if(V==="$"||E&&V==="{")A&&d.push({value:A,type:s.TEXT}),A="",E=!0;else if(V==="}"&&E){const Z=f[A];if(typeof Z=="string")Z.length&&d.push({value:Z,type:s.VARIABLE});else if(Z){const Y=d[d.length-1];(!Y||Y.type!==s.SEPARATOR)&&d.push({value:Z.label,type:s.SEPARATOR})}A="",E=!1}else A+=V;return A&&!E&&d.push({value:A,type:s.TEXT}),d.filter((V,Z)=>{if(V.type===s.SEPARATOR){const Y=d[Z-1],ne=d[Z+1];return[Y,ne].every(re=>re&&(re.type===s.VARIABLE||re.type===s.TEXT)&&re.value.length>0)}return!0}).map(V=>V.value).join("")}i.template=t;function r(c,f){return T.isMacintosh||f?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):c.replace(/&&|&/g,d=>d==="&"?"&&":"&")}i.mnemonicMenuLabel=r;function e(c,f){return T.isMacintosh||f?c.replace(/\(&&\w\)|&&/g,""):T.isWindows?c.replace(/&&|&/g,d=>d==="&"?"&&":"&"):c.replace(/&&/g,"_")}i.mnemonicButtonLabel=e;function n(c){return c.replace(/&/g,"&&")}i.unmnemonicLabel=n;function o(c){const f=c.indexOf("/")!==-1?R.posix:R.win32,d=f.basename(c),E=f.dirname(c);return d.length?{name:d,parentPath:E}:{name:E,parentPath:""}}i.splitName=o}),define(ee[32],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(P){return D.test(P)}i.isUUID=I,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(v){for(let l=0;l<v.length;l++)v[l]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),T=[];for(let v=0;v<256;v++)T.push(v.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,m="";return m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m+="-",m+=T[R[l++]],m+=T[R[l++]],m+="-",m+=T[R[l++]],m+=T[R[l++]],m+="-",m+=T[R[l++]],m+=T[R[l++]],m+="-",m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m+=T[R[l++]],m}}()}),define(ee[66],te([0,1,136]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(R="utf8"){this.stringDecoder=new D.StringDecoder(R),this.remaining=null}write(R){const T=[],v=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(v.length<1)return T;let l=0,m,L=l;for(;L<v.length;)if(m=v.charCodeAt(L),m===13||m===10){if(T.push(v.substring(l,L)),L++,L<v.length){const O=m;m=v.charCodeAt(L),(O===13&&m===10||O===10&&m===13)&&L++}l=L}else L++;return this.remaining=l<v.length?v.substr(l):null,T}end(){return this.remaining}}i.LineDecoder=I}),define(ee[67],te([0,1,33,11,19]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var l;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class O{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:h=!1}={}){return h?m===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:h=!1,findPreview:s=!1}={}){const t=p({useAlternateBitness:h});if(!t)return null;const r=I.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const f of await P.Promises.readdir(r)){let d=-1;if(s){const A=f.indexOf("-");if(A<0)continue;const V=f.substring(0,A);if(!R.test(V)||f.substring(A+1)!=="preview")continue;d=parseInt(V,10)}else{if(!R.test(f))continue;d=parseInt(f,10)}if(d<=e)continue;const E=I.join(r,f,"pwsh.exe");!await P.SymlinkSupport.existsFile(E)||(n=E,e=d)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new O(n,`PowerShell${c}${o}`,!0)}async function b({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=h?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(s))if(t.test(e)){const n=I.join(s,e,"pwsh.exe");return new O(n,r)}return null}function g(){const h=I.join(D.homedir(),".dotnet","tools","pwsh.exe");return new O(h,".NET Core PowerShell Global Tool")}function y(){const h=I.join(process.env.windir,m===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(h,"Windows PowerShell",!0)}async function*a(){let h=await w();h&&(yield h),h=await w({useAlternateBitness:!0}),h&&(yield h),h=await b(),h&&(yield h),h=g(),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await b({findPreview:!0}),h&&(yield h),h=await w({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=y(),h&&(yield h)}async function*u(){for await(const h of a())await h.exists()&&(yield h)}i.enumeratePowerShellInstallations=u;async function S(){for await(const h of u())return h;return null}i.getFirstAvailablePowerShellInstallation=S});var he=this&&this.__decorate||function(_,i,D,I){var P=arguments.length,R=P<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,D):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(_,i,D,I);else for(var v=_.length-1;v>=0;v--)(T=_[v])&&(R=(P<3?T(R):P>3?T(i,D,R):T(i,D))||R);return P>3&&R&&Object.defineProperty(i,D,R),R};define(ee[52],te([0,1,18,4,16,26,45,7,3,2,50,25,8]),function(_,i,D,I,P,R,T,v,l,m,L,O,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var w;(function(k){k[k.Promise=100]="Promise",k[k.PromiseCancel=101]="PromiseCancel",k[k.EventListen=102]="EventListen",k[k.EventDispose=103]="EventDispose"})(w=i.RequestType||(i.RequestType={}));function b(k){switch(k){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(k){k[k.Initialize=200]="Initialize",k[k.PromiseSuccess=201]="PromiseSuccess",k[k.PromiseError=202]="PromiseError",k[k.PromiseErrorObj=203]="PromiseErrorObj",k[k.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function y(k){switch(k){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(k){k[k.Uninitialized=0]="Uninitialized",k[k.Idle=1]="Idle"})(a||(a={}));class u{constructor(C){this.buffer=C,this.pos=0}read(C){const F=this.buffer.slice(this.pos,this.pos+C);return this.pos+=F.byteLength,F}}class S{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(C){this.buffers.push(C)}}var h;(function(k){k[k.Undefined=0]="Undefined",k[k.String=1]="String",k[k.Buffer=2]="Buffer",k[k.VSBuffer=3]="VSBuffer",k[k.Array=4]="Array",k[k.Object=5]="Object"})(h||(h={}));function s(k){const C=P.VSBuffer.alloc(4);return C.writeUInt32BE(k,0),C}function t(k){return k.read(4).readUInt32BE(0)}function r(k){const C=P.VSBuffer.alloc(1);return C.writeUInt8(k,0),C}const e={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},n=typeof Buffer!="undefined";function o(k,C){if(typeof C=="undefined")k.write(e.Undefined);else if(typeof C=="string"){const F=P.VSBuffer.fromString(C);k.write(e.String),k.write(s(F.byteLength)),k.write(F)}else if(n&&Buffer.isBuffer(C)){const F=P.VSBuffer.wrap(C);k.write(e.Buffer),k.write(s(F.byteLength)),k.write(F)}else if(C instanceof P.VSBuffer)k.write(e.VSBuffer),k.write(s(C.byteLength)),k.write(C);else if(Array.isArray(C)){k.write(e.Array),k.write(s(C.length));for(const F of C)o(k,F)}else{const F=P.VSBuffer.fromString(JSON.stringify(C));k.write(e.Object),k.write(s(F.byteLength)),k.write(F)}}function c(k){switch(k.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return k.read(t(k)).toString();case h.Buffer:return k.read(t(k)).buffer;case h.VSBuffer:return k.read(t(k));case h.Array:{const F=t(k),z=[];for(let q=0;q<F;q++)z.push(c(k));return z}case h.Object:return JSON.parse(k.read(t(k)).toString())}}class f{constructor(C,F,z=null,q=1e3){this.protocol=C,this.ctx=F,this.logger=z,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(C,F){this.channels.set(C,F),setTimeout(()=>this.flushPendingRequests(C),0)}sendResponse(C){switch(C.type){case 200:{const F=this.send([C.type]);this.logger?.logOutgoing(F,0,1,y(C.type));return}case 201:case 202:case 204:case 203:{const F=this.send([C.type,C.id],C.data);this.logger?.logOutgoing(F,C.id,1,y(C.type),C.data);return}}}send(C,F=void 0){const z=new S;return o(z,C),o(z,F),this.sendBuffer(z.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch{return 0}}onRawMessage(C){const F=new u(C),z=c(F),q=c(F),$=z[0];switch($){case 100:return this.logger?.logIncoming(C.byteLength,z[1],1,`${b($)}: ${z[2]}.${z[3]}`,q),this.onPromise({type:$,id:z[1],channelName:z[2],name:z[3],arg:q});case 102:return this.logger?.logIncoming(C.byteLength,z[1],1,`${b($)}: ${z[2]}.${z[3]}`,q),this.onEventListen({type:$,id:z[1],channelName:z[2],name:z[3],arg:q});case 101:return this.logger?.logIncoming(C.byteLength,z[1],1,`${b($)}`),this.disposeActiveRequest({type:$,id:z[1]});case 103:return this.logger?.logIncoming(C.byteLength,z[1],1,`${b($)}`),this.disposeActiveRequest({type:$,id:z[1]})}}onPromise(C){const F=this.channels.get(C.channelName);if(!F){this.collectPendingRequest(C);return}const z=new R.CancellationTokenSource;let q;try{q=F.call(this.ctx,C.name,C.arg,z.token)}catch(M){q=Promise.reject(M)}const $=C.id;q.then(M=>{this.sendResponse({id:$,data:M,type:201}),this.activeRequests.delete(C.id)},M=>{M instanceof Error?this.sendResponse({id:$,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.sendResponse({id:$,data:M,type:203}),this.activeRequests.delete(C.id)});const se=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(C.id,se)}onEventListen(C){const F=this.channels.get(C.channelName);if(!F){this.collectPendingRequest(C);return}const z=C.id,$=F.listen(this.ctx,C.name,C.arg)(se=>this.sendResponse({id:z,data:se,type:204}));this.activeRequests.set(C.id,$)}disposeActiveRequest(C){const F=this.activeRequests.get(C.id);F&&(F.dispose(),this.activeRequests.delete(C.id))}collectPendingRequest(C){let F=this.pendingRequests.get(C.channelName);F||(F=[],this.pendingRequests.set(C.channelName,F));const z=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.sendResponse({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:C,timeoutTimer:z})}flushPendingRequests(C){const F=this.pendingRequests.get(C);if(F){for(const z of F)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(C)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=f;var d;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(d=i.RequestInitiator||(i.RequestInitiator={}));class E{constructor(C,F=null){this.protocol=C,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=F}getChannel(C){const F=this;return{call(z,q,$){return F.isDisposed?Promise.reject(v.canceled()):F.requestPromise(C,z,q,$)},listen(z,q){return F.isDisposed?l.Event.None:F.requestEvent(C,z,q)}}}requestPromise(C,F,z,q=R.CancellationToken.None){const $=this.lastRequestId++,M={id:$,type:100,channelName:C,name:F,arg:z};if(q.isCancellationRequested)return Promise.reject(v.canceled());let U;return new Promise((B,X)=>{if(q.isCancellationRequested)return X(v.canceled());const Q=()=>{const ve=le=>{switch(le.type){case 201:this.handlers.delete($),B(le.data);break;case 202:{this.handlers.delete($);const ue=new Error(le.data.message);ue.stack=le.data.stack,ue.name=le.data.name,X(ue);break}case 203:this.handlers.delete($),X(le.data);break}};this.handlers.set($,ve),this.sendRequest(M)};let oe=null;this.state===a.Idle?Q():(oe=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,Q()}));const ce=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:$,type:101}),X(v.canceled())},de=q.onCancellationRequested(ce);U=(0,m.combinedDisposable)((0,m.toDisposable)(ce),de),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(C,F,z){const q=this.lastRequestId++,se={id:q,type:102,channelName:C,name:F,arg:z};let M=null;const U=new l.Emitter({onFirstListenerAdd:()=>{M=(0,I.createCancelablePromise)(B=>this.whenInitialized()),M.then(()=>{M=null,this.activeRequests.add(U),this.sendRequest(se)})},onLastListenerRemove:()=>{M?(M.cancel(),M=null):(this.activeRequests.delete(U),this.sendRequest({id:q,type:103}))}}),j=B=>U.fire(B.data);return this.handlers.set(q,j),U.event}sendRequest(C){switch(C.type){case 100:case 102:{const F=this.send([C.type,C.id,C.channelName,C.name],C.arg);this.logger&&this.logger.logOutgoing(F,C.id,0,`${b(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const F=this.send([C.type,C.id]);this.logger&&this.logger.logOutgoing(F,C.id,0,b(C.type));return}}}send(C,F=void 0){const z=new S;return o(z,C),o(z,F),this.sendBuffer(z.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch{return 0}}onBuffer(C){const F=new u(C),z=c(F),q=c(F),$=z[0];switch($){case 200:return this.logger&&this.logger.logIncoming(C.byteLength,0,0,y($)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(C.byteLength,z[1],0,y($),q),this.onResponse({type:z[0],id:z[1],data:q})}}onResponse(C){if(C.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(C.id);F&&F(C)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([T.memoize],E.prototype,"onDidInitializePromise",null),i.ChannelClient=E;class A{constructor(C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,C(({protocol:F,onDidClientDisconnect:z})=>{l.Event.once(F.onMessage)($=>{const se=new u($),M=c(se),U=new f(F,M),j=new E(F);this.channels.forEach((X,Q)=>U.registerChannel(Q,X));const B={channelServer:U,channelClient:j,ctx:M};this._connections.add(B),this._onDidAddConnection.fire(B),z(()=>{U.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const C=[];return this._connections.forEach(F=>C.push(F)),C}getChannel(C,F){const z=this;return{call(q,$,se){let M;if((0,p.isFunction)(F)){let j=(0,D.getRandomElement)(z.connections.filter(F));M=j?Promise.resolve(j):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,F))}else M=F.routeCall(z,q,$);const U=M.then(j=>j.channelClient.getChannel(C));return Z(U).call(q,$,se)},listen(q,$){if((0,p.isFunction)(F))return z.getMulticastEvent(C,F,q,$);const se=F.routeEvent(z,q,$).then(M=>M.channelClient.getChannel(C));return Z(se).listen(q,$)}}}getMulticastEvent(C,F,z,q){const $=this;let se=new m.DisposableStore;const M=new l.Emitter({onFirstListenerAdd:()=>{se=new m.DisposableStore;const U=new l.EventMultiplexer,j=new Map,B=Q=>{const ce=Q.channelClient.getChannel(C).listen(z,q),de=U.add(ce);j.set(Q,de)},X=Q=>{const oe=j.get(Q);!oe||(oe.dispose(),j.delete(Q))};$.connections.filter(F).forEach(B),l.Event.filter($.onDidAddConnection,F)(B,void 0,se),$.onDidRemoveConnection(X,void 0,se),U.event(M.fire,M,se),se.add(U)},onLastListenerRemove:()=>{se.dispose()}});return M.event}registerChannel(C,F){this.channels.set(C,F),this._connections.forEach(z=>{z.channelServer.registerChannel(C,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=A;class V{constructor(C,F,z=null){const q=new S;o(q,F),C.send(q.buffer),this.channelClient=new E(C,z),this.channelServer=new f(C,F,z)}getChannel(C){return this.channelClient.getChannel(C)}registerChannel(C,F){this.channelServer.registerChannel(C,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=V;function Z(k){return{call(C,F,z){return k.then(q=>q.call(C,F,z))},listen(C,F){const z=new l.Relay;return k.then(q=>z.input=q.listen(C,F)),z.event}}}i.getDelayedChannel=Z;function Y(k){let C=!1;return{call(F,z,q){return C?k.call(F,z,q):(0,I.timeout)(0).then(()=>C=!0).then(()=>k.call(F,z,q))},listen(F,z){if(C)return k.listen(F,z);const q=new l.Relay;return(0,I.timeout)(0).then(()=>C=!0).then(()=>q.input=k.listen(F,z)),q.event}}}i.getNextTickChannel=Y;class ne{constructor(C){this.fn=C}routeCall(C){return this.route(C)}routeEvent(C){return this.route(C)}async route(C){for(const F of C.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await l.Event.toPromise(C.onDidAddConnection),await this.route(C)}}i.StaticRouter=ne;var re;(function(k){function C($,se){const M=$,U=se&&se.disableMarshalling,j=new Map;for(const B in M)z(B)&&j.set(B,l.Event.buffer(M[B],!0));return new class{listen(B,X,Q){const oe=j.get(X);if(oe)return oe;if(q(X)){const ce=M[X];if(typeof ce=="function")return ce.call(M,Q)}throw new Error(`Event not found: ${X}`)}call(B,X,Q){const oe=M[X];if(typeof oe=="function"){if(!U&&Array.isArray(Q))for(let ce=0;ce<Q.length;ce++)Q[ce]=(0,L.revive)(Q[ce]);return oe.apply(M,Q)}throw new Error(`Method not found: ${X}`)}}}k.fromService=C;function F($,se){const M=se&&se.disableMarshalling;return new Proxy({},{get(U,j){if(typeof j=="string")return se?.properties?.has(j)?se.properties.get(j):q(j)?function(B){return $.listen(j,B)}:z(j)?$.listen(j):async function(...B){let X;se&&!(0,p.isUndefinedOrNull)(se.context)?X=[se.context,...B]:X=B;const Q=await $.call(j,X);return M?Q:(0,L.revive)(Q)};throw new Error(`Property not found: ${String(j)}`)}})}k.toService=F;function z($){return $[0]==="o"&&$[1]==="n"&&O.isUpperAsciiLetter($.charCodeAt(2))}function q($){return/^onDynamic/.test($)&&O.isUpperAsciiLetter($.charCodeAt(9))}})(re=i.ProxyChannel||(i.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(k){if(Array.isArray(k))return k;if(k&&typeof k=="object"&&typeof k.toString=="function"){let C=k.toString();if(C!=="[object Object]")return C}return k}function G(k){return Array.isArray(k)?k.map(W):W(k)}function H(k,C,F,z,q,$,se){se=G(se);const M=N[q],U=M[z%M.length];let j=[`%c[${k}]%c[${String(C).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test($)?(j=j.concat(se),j.push(")")):j.push(se),console.log.apply(console,j)}i.logWithColors=H;class ie{constructor(C,F){this._outgoingPrefix=C,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(C,F,z,q,$){this._totalOutgoing+=C,H(this._outgoingPrefix,this._totalOutgoing,C,F,z,q,$)}logIncoming(C,F,z,q,$){this._totalIncoming+=C,H(this._incomingPrefix,this._totalIncoming,C,F,z,q,$)}}i.IPCLogger=ie}),define(ee[68],te([0,1,4,3,2,8]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var T;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=i.StorageHint||(i.StorageHint={}));function v(O){const p=O;return p?.changed instanceof Map||p?.deleted instanceof Set}i.isStorageItemsChangeEvent=v;var l;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(l=i.StorageState||(i.StorageState={}));class m extends P.Disposable{constructor(p,w=Object.create(null)){super();this.database=p,this.options=w,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((w,b)=>this.accept(b,w)),p.deleted?.forEach(w=>this.accept(w,void 0))}accept(p,w){if(this.state===l.Closed)return;let b=!1;(0,R.isUndefinedOrNull)(w)?b=this.cache.delete(p):this.cache.get(p)!==w&&(this.cache.set(p,w),b=!0),b&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,w){const b=this.cache.get(p);return(0,R.isUndefinedOrNull)(b)?w:b}getBoolean(p,w){const b=this.get(p);return(0,R.isUndefinedOrNull)(b)?w:b==="true"}getNumber(p,w){const b=this.get(p);return(0,R.isUndefinedOrNull)(b)?w:parseInt(b,10)}async set(p,w){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(w))return this.delete(p);const b=String(w);if(this.cache.get(p)!==b)return this.cache.set(p,b),this.pendingInserts.set(p,b),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===l.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class L{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((w,b)=>this.items.set(b,w)),p.delete&&p.delete.forEach(w=>this.items.delete(w))}async close(){}}i.InMemoryStorageDatabase=L}),define(ee[69],te([5,6]),function(_,i){return _.create("vs/base/common/date",i)}),define(ee[70],te([0,1,69]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,P=I*60,R=P*24,T=R*7,v=R*30,l=R*365;function m(O,p,w){typeof O!="number"&&(O=O.getTime());const b=Math.round((new Date().getTime()-O)/1e3);if(b<-30)return(0,D.localize)(0,null,m(new Date().getTime()+b*1e3,!1));if(b<30)return(0,D.localize)(1,null);let g;return b<I?(g=b,p?g===1?w?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):w?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?w?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):w?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):b<P?(g=Math.floor(b/I),p?g===1?w?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):w?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?w?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):w?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):b<R?(g=Math.floor(b/P),p?g===1?w?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):w?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?w?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):w?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):b<T?(g=Math.floor(b/R),p?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):b<v?(g=Math.floor(b/T),p?g===1?w?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):w?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?w?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):w?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):b<l?(g=Math.floor(b/v),p?g===1?w?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):w?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?w?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):w?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(b/l),p?g===1?w?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):w?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?w?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):w?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}i.fromNow=m;function L(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=L}),define(ee[71],te([5,6]),function(_,i){return _.create("vs/base/common/errorMessage",i)}),define(ee[28],te([0,1,18,8,71]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function R(O,p){return p&&(O.stack||O.stacktrace)?P.localize(0,null,v(O),T(O.stack)||T(O.stacktrace)):v(O)}function T(O){return Array.isArray(O)?O.join(`
`):O}function v(O){return typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?P.localize(1,null,O.message):O.message||P.localize(2,null)}function l(O=null,p=!1){if(!O)return P.localize(3,null);if(Array.isArray(O)){const w=D.coalesce(O),b=l(w[0],p);return w.length>1?P.localize(4,null,b,w.length):b}if(I.isString(O))return O;if(O.detail){const w=O.detail;if(w.error)return R(w.error,p);if(w.exception)return R(w.exception,p)}return O.stack?R(O,p):O.message?O.message:P.localize(5,null)}i.toErrorMessage=l;function m(O){const p=O;return p instanceof Error&&Array.isArray(p.actions)}i.isErrorWithActions=m;function L(O,p){let w;return typeof O=="string"?w=new Error(O):w=O,w.actions=p,w}i.createErrorWithActions=L}),define(ee[72],te([5,6]),function(_,i){return _.create("vs/base/common/jsonErrorMessages",i)}),define(ee[73],te([0,1,72]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(P){switch(P){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(ee[74],te([5,6]),function(_,i){return _.create("vs/base/node/processes",i)}),define(ee[53],te([0,1,40,51,14,21,11,10,29,47,8,66,19,74]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function b(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(s,t){if(v.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const e=D.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(n=>{e.once("error",o=>{n({success:!1,error:o})}),e.once("exit",(o,c)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?b(r.status):1})}else if(v.isLinux||v.isMacintosh)try{const r=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(e=>{D.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(n,o,c)=>{e(n?{success:!1,error:n}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function y(s=l.env){return s.comspec||"cmd.exe"}i.getWindowsShell=y;class a{constructor(t,r,e,n){if(r!==void 0&&e!==void 0&&n!==void 0)this.cmd=t,this.args=r,this.shell=e,this.options=n;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(l.env).forEach(c=>{o[c]=l.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(T.sep);return r!==-1&&(t=t.substring(r+1)),a.WellKnowCommands[t]?t:"other"}start(t){return v.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(r=>{let e,n;const o=new Promise((c,f)=>{e=c,n=f});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(f,d,E)=>{this.childProcess=null;const A=f;A&&A.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:E.toString()}):this.handleExec(e,t,f,d,E)})}else{let c=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,e,t,n);const E={terminated:this.terminateRequested};L.isNumber(d)&&(E.cmdCode=d),e(E)};if(this.shell&&v.isWindows){const d=R.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let E=!1,A=!1;const V=[];let Z=this.ensureQuotes(this.cmd);V.push(Z.value),E=Z.quoted,this.args&&this.args.forEach(ne=>{Z=this.ensureQuotes(ne),V.push(Z.value),A=A&&Z.quoted});const Y=["/s","/c"];E?A?Y.push('"'+V.join(" ")+'"'):V.length>1?Y.push('"'+V[0]+'" '+V.slice(1).join(" ")):Y.push('"'+V[0]+'"'):Y.push(V.join(" ")),c=D.spawn(y(),Y,d)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(L.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),c.pid&&(this.childProcess.on("close",f),this.handleSpawn(c,e,t,n,!0)))}return o})}handleClose(t,r,e,n){}ensureQuotes(t){return a.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,g(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!v.isWindows)return t(!1);const r=D.spawn(y(),["/s","/c"]);r.on("error",e=>t(!0)),r.on("exit",e=>t(!1))})}}i.AbstractProcess=a,a.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},a.regexp=/^[^"].* .*[^"]/;class u extends a{constructor(t,r,e,n){super(t,r,e,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,e,n,o){[n,o].forEach((c,f)=>{const d=new O.LineDecoder;d.write(c).forEach(V=>{r({line:V,source:f===0?0:1})});const A=d.end();A&&r({line:A,source:f===0?0:1})}),t({terminated:this.terminateRequested,error:e})}handleSpawn(t,r,e,n,o){const c=new O.LineDecoder,f=new O.LineDecoder;t.stdout.on("data",d=>{c.write(d).forEach(A=>e({line:A,source:0}))}),t.stderr.on("data",d=>{f.write(d).forEach(A=>e({line:A,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=f}handleClose(t,r,e,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&e({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&e({line:c,source:1})}}i.LineProcess=u;function S(s){let t=[],r=!1;const e=function(n){if(r){t.push(n);return}(!s.send(n,c=>{if(c&&console.error(c),r=!1,t.length>0){const f=t.slice(0);t=[],f.forEach(d=>e(d))}})||v.isWindows)&&(r=!0)};return{send:e}}i.createQueuedSender=S;var h;(function(s){async function t(r,e,n){if(T.isAbsolute(r))return r;if(e===void 0&&(e=l.cwd()),T.dirname(r)!=="."||(n===void 0&&L.isString(l.env.PATH)&&(n=l.env.PATH.split(T.delimiter)),n===void 0||n.length===0))return T.join(e,r);async function c(f){if(await p.Promises.exists(f)){let d;try{d=await p.Promises.stat(f)}catch(E){E.message.startsWith("EACCES")&&(d=await p.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(let f of n){let d;if(T.isAbsolute(f)?d=T.join(f,r):d=T.join(e,f,r),await c(d))return d;let E=d+".com";if(await c(E)||(E=d+".exe",await c(E)))return E}return T.join(e,r)}s.findExecutable=t})(h=i.win32||(i.win32={}))}),define(ee[75],te([0,1,33,10,67,53]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function T(w,b){return w===1?I.isWindows?O():R.getWindowsShell(b):m(w,b)}i.getSystemShell=T;function v(w,b){return w===1?I.isWindows?p(b):R.getWindowsShell(b):m(w,b)}i.getSystemShellSync=v;let l=null;function m(w,b){if(I.isLinux&&w===2||I.isMacintosh&&w===3)return"/bin/bash";if(!l){let g;if(I.isWindows)g="/bin/bash";else{if(g=b.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let L=null;async function O(){return L||(L=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),L}function p(w){if(L)return L;const b=I.isWindows&&parseFloat((0,D.release)())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return b?y:R.getWindowsShell(w)}}),define(ee[76],te([0,1,40,4,16,26,64,7,3,2,21,53,47,52]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class b extends w.ChannelServer{constructor(a){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",u=>P.VSBuffer.wrap(Buffer.from(u,"base64")))},a);process.once("disconnect",()=>this.dispose())}}i.Server=b;class g{constructor(a,u){this.modulePath=a,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new I.Delayer(S),this.child=null,this._client=null}getChannel(a){const u=this;return{call(S,h,s){return u.requestPromise(a,S,h,s)},listen(S,h){return u.requestEvent(a,S,h)}}}requestPromise(a,u,S,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(a),t=(0,I.createCancelablePromise)(n=>s.call(u,S,n)),r=h.onCancellationRequested(()=>t.cancel()),e=(0,m.toDisposable)(()=>t.cancel());return this.activeRequests.add(e),t.finally(()=>{r.dispose(),this.activeRequests.delete(e),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(a,u,S){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let h;const s=new l.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(a).listen(u,S)(s.fire,s),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,L.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,a,u);const S=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}S.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=S.event,e={send:t,onMessage:r};this._client=new w.ChannelClient(e);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(f=>(0,m.dispose)(f)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(a){let u=this.channels.get(a);return u||(u=this.client.getChannel(a),this.channels.set(a,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=g}),define(ee[77],te([5,6]),function(_,i){return _.create("vs/base/node/zip",i)}),define(ee[78],te([5,6]),function(_,i){return _.create("vs/platform/configuration/common/configurationRegistry",i)}),define(ee[79],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(ee[80],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(ee[81],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(ee[82],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(ee[83],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(ee[84],te([5,6]),function(_,i){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(ee[85],te([5,6]),function(_,i){return _.create("vs/platform/extensions/common/extensionValidator",i)}),define(ee[86],te([5,6]),function(_,i){return _.create("vs/platform/files/common/fileService",i)}),define(ee[87],te([5,6]),function(_,i){return _.create("vs/platform/files/common/io",i)}),define(ee[88],te([5,6]),function(_,i){return _.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(ee[89],te([5,6]),function(_,i){return _.create("vs/platform/request/common/request",i)}),define(ee[90],te([5,6]),function(_,i){return _.create("vs/platform/shell/node/shellEnv",i)}),define(ee[91],te([5,6]),function(_,i){return _.create("vs/platform/telemetry/common/telemetryService",i)}),define(ee[92],te([0,1,70,45,14,11,29,17,9]),function(_,i,D,I,P,R,T,v,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class m{constructor(g,y,a){this._args=g,this.paths=y,this.productService=a}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",_).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?l.URI.file((0,R.join)(g,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,v.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,R.resolve)(g):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,R.resolve)(g):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,R.resolve)(g);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const a=T.env.VSCODE_PORTABLE;return a?(0,R.join)(a,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(y=>/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,R.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([I.memoize],m.prototype,"appRoot",null),he([I.memoize],m.prototype,"userHome",null),he([I.memoize],m.prototype,"userDataPath",null),he([I.memoize],m.prototype,"appSettingsHome",null),he([I.memoize],m.prototype,"tmpDir",null),he([I.memoize],m.prototype,"cacheHome",null),he([I.memoize],m.prototype,"userRoamingDataHome",null),he([I.memoize],m.prototype,"settingsResource",null),he([I.memoize],m.prototype,"userDataSyncHome",null),he([I.memoize],m.prototype,"userDataSyncLogResource",null),he([I.memoize],m.prototype,"sync",null),he([I.memoize],m.prototype,"machineSettingsResource",null),he([I.memoize],m.prototype,"globalStorageHome",null),he([I.memoize],m.prototype,"workspaceStorageHome",null),he([I.memoize],m.prototype,"localHistoryHome",null),he([I.memoize],m.prototype,"keybindingsResource",null),he([I.memoize],m.prototype,"keyboardLayoutResource",null),he([I.memoize],m.prototype,"argvResource",null),he([I.memoize],m.prototype,"snippetsHome",null),he([I.memoize],m.prototype,"isExtensionDevelopment",null),he([I.memoize],m.prototype,"untitledWorkspacesHome",null),he([I.memoize],m.prototype,"installSourcePath",null),he([I.memoize],m.prototype,"builtinExtensionsPath",null),he([I.memoize],m.prototype,"extensionsPath",null),he([I.memoize],m.prototype,"extensionDevelopmentLocationURI",null),he([I.memoize],m.prototype,"extensionDevelopmentKind",null),he([I.memoize],m.prototype,"extensionTestsLocationURI",null),he([I.memoize],m.prototype,"debugExtensionHost",null),he([I.memoize],m.prototype,"serviceMachineIdResource",null),he([I.memoize],m.prototype,"telemetryLogResource",null),he([I.memoize],m.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=m;function L(b,g){return w(b["inspect-extensions"],b["inspect-brk-extensions"],5870,g,b.debugId,b.extensionEnvironment)}i.parseExtensionHostPort=L;function O(b,g){return w(b["inspect-search"],b["inspect-brk-search"],5876,g,b.extensionEnvironment)}i.parseSearchPort=O;function p(b,g){return w(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,g,b.extensionEnvironment)}i.parsePtyHostPort=p;function w(b,g,y,a,u,S){const s=Number(g||b)||(a?null:y),t=s?Boolean(!!g):!1;let r;if(S)try{r=JSON.parse(S)}catch{}return{port:s,break:t,debugId:u,env:r}}}),function(){"use strict";function _(i,D,I,P){function R(v){const l=T(v),m=[l];return i.isAbsolute(l)||m.unshift(P),i.resolve(...m)}function T(v){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return i.join(m,I);const L=v["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=i.join(O,"AppData","Roaming")}break;case"darwin":m=i.join(D.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(m,I)}return{getUserDataPath:R}}if(typeof define=="function")define(ee[93],te([0,137,33,14,17,29]),function(i,D,I,P,R,T){const v=R.dirname(P.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return _(D,I,l.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),I=require("os");module.exports=_(D,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[94],te([0,1,33,92,93]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(v,l){super(v,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(v)},l)}}i.NativeEnvironmentService=R}),define(ee[41],te([0,1,17,49,85,34]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function l(a){return a=a.trim(),a==="*"||T.test(a)}i.isValidVersionStr=l;function m(a){if(!l(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=a.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=m;function L(a){if(!a)return null;let u=a.majorBase,S=a.majorMustEqual,h=a.minorBase,s=a.minorMustEqual,t=a.patchBase,r=a.patchMustEqual;a.hasCaret&&(u===0||(s=!1),r=!1);let e=0;if(a.preRelease){const n=v.exec(a.preRelease);if(n){const[,o,c,f]=n;e=Date.UTC(Number(o),Number(c)-1,Number(f))}}return{majorBase:u,majorMustEqual:S,minorBase:h,minorMustEqual:s,patchBase:t,patchMustEqual:r,isMinimum:a.hasGreaterEquals,notBefore:e}}i.normalizeVersion=L;function O(a,u,S){let h;typeof a=="string"?h=L(m(a)):h=a;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let t;if(typeof S=="string"?t=L(m(S)):t=S,!h||!t)return!1;let r=h.majorBase,e=h.minorBase,n=h.patchBase,o=t.majorBase,c=t.minorBase,f=t.patchBase,d=t.notBefore,E=t.majorMustEqual,A=t.minorMustEqual,V=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:e>c?!0:e<c||s&&s<d?!1:n>=f:(r===1&&o===0&&(!E||!A||!V)&&(o=1,c=0,f=0,E=!0,A=!1,V=!1),r<o?!1:r>o?!E:e<c?!1:e>c?!A:n<f?!1:n>f?!V:!(s&&s<d))}i.isValidVersion=O;function p(a,u,S,h,s){const t=[];if(typeof h.publisher!="undefined"&&typeof h.publisher!="string")return t.push([I.default.Error,P.localize(0,null)]),t;if(typeof h.name!="string")return t.push([I.default.Error,P.localize(1,null,"name")]),t;if(typeof h.version!="string")return t.push([I.default.Error,P.localize(2,null,"version")]),t;if(!h.engines)return t.push([I.default.Error,P.localize(3,null,"engines")]),t;if(typeof h.engines.vscode!="string")return t.push([I.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof h.extensionDependencies!="undefined"&&!y(h.extensionDependencies))return t.push([I.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof h.activationEvents!="undefined"){if(!y(h.activationEvents))return t.push([I.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof h.main=="undefined"&&typeof h.browser=="undefined")return t.push([I.default.Error,P.localize(7,null,"activationEvents","main")]),t}if(typeof h.extensionKind!="undefined"&&typeof h.main=="undefined"&&t.push([I.default.Warning,P.localize(8,null,"extensionKind")]),typeof h.main!="undefined"){if(typeof h.main!="string")return t.push([I.default.Error,P.localize(9,null,"main")]),t;{const n=(0,D.joinPath)(S,h.main);(0,D.isEqualOrParent)(n,S)||t.push([I.default.Warning,P.localize(10,null,n.path,S.path)])}if(typeof h.activationEvents=="undefined")return t.push([I.default.Error,P.localize(11,null,"activationEvents","main")]),t}if(typeof h.browser!="undefined"){if(typeof h.browser!="string")return t.push([I.default.Error,P.localize(12,null,"browser")]),t;{const n=(0,D.joinPath)(S,h.browser);(0,D.isEqualOrParent)(n,S)||t.push([I.default.Warning,P.localize(13,null,n.path,S.path)])}if(typeof h.activationEvents=="undefined")return t.push([I.default.Error,P.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(h.version))return t.push([I.default.Error,P.localize(15,null)]),t;const r=[];if(!w(a,u,h,s,r))for(const n of r)t.push([I.default.Error,n]);return t}i.validateExtensionManifest=p;function w(a,u,S,h,s){return h||typeof S.main=="undefined"&&typeof S.browser=="undefined"?!0:g(a,u,S.engines.vscode,s)}i.isValidExtensionVersion=w;function b(a,u,S){return a==="*"||g(u,S,a)}i.isEngineValid=b;function g(a,u,S,h=[]){let s=L(m(S));if(!s)return h.push(P.localize(16,null,S)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return h.push(P.localize(17,null,S)),!1}else if(!s.majorMustEqual)return h.push(P.localize(18,null,S)),!1;return O(a,u,s)?!0:(h.push(P.localize(19,null,a,S)),!1)}function y(a){if(!Array.isArray(a))return!1;for(let u=0,S=a.length;u<S;u++)if(typeof a[u]!="string")return!1;return!0}}),define(ee[95],te([0,1,16,32]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(R,T,v){let l=v&&v.get("storage.serviceMachineId",0)||null;if(l)return l;try{const L=(await T.readFile(R.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(L)?L:null}catch{l=null}if(!l){l=(0,I.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,D.VSBuffer.fromString(l))}catch{}}return v&&v.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=P}),define(ee[42],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(P,R=[],T=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=T}}i.SyncDescriptor=D}),define(ee[96],te([0,1,42]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function P(T,v,l){v instanceof D.SyncDescriptor||(v=new D.SyncDescriptor(v,[],l)),I.push([T,v])}i.registerSingleton=P;function R(){return I}i.getSingletonServiceDescriptors=R}),define(ee[97],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=D;class I{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const v=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(T);v.outgoing.set(this._hashFn(T),l),l.incoming.set(this._hashFn(R),v)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let v of this._nodes.values())v.outgoing.delete(T),v.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let v=this._nodes.get(T);return v||(v=new D(R),this._nodes.set(T,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,v]of this._nodes)R.push(`${T}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,T]of this._nodes){const v=new Set([R]),l=this._findCycle(T,v);if(l)return l}}_findCycle(R,T){for(let[v,l]of R.outgoing){if(T.has(v))return[...T,v].join(" -> ");T.add(v);const m=this._findCycle(l,T);if(m)return m;T.delete(v)}}}i.Graph=I}),define(ee[22],te([0,1,8,9,12]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof I.URI)}i.isConfigurationOverrides=R;function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||D.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=T;var v;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(v=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function m(a,u){const S=Object.create(null);for(let h in a)L(S,h,a[h],u);return S}i.toValuesTree=m;function L(a,u,S,h){const s=u.split("."),t=s.pop();let r=a;for(let e=0;e<s.length;e++){let n=s[e],o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${u} as ${s.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=S}catch{h(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=L;function O(a,u){const S=u.split(".");p(a,S)}i.removeFromValueTree=O;function p(a,u){const S=u.shift();if(u.length===0){delete a[S];return}if(Object.keys(a).indexOf(S)!==-1){const h=a[S];typeof h=="object"&&!Array.isArray(h)&&(p(h,u),Object.keys(h).length===0&&delete a[S])}}function w(a,u,S){function h(r,e){let n=r;for(const o of e){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=u.split("."),t=h(a,s);return typeof t=="undefined"?S:t}i.getConfigurationValue=w;function b(a,u,S){Object.keys(u).forEach(h=>{h!=="__proto__"&&(h in a?D.isObject(a[h])&&D.isObject(u[h])?b(a[h],u[h],S):S&&(a[h]=u[h]):a[h]=u[h])})}i.merge=b;function g(a,u,S){const h=a.inspect(u),s=a.inspect(S);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:h.defaultValue}i.getMigratedSettingValue=g;function y(a){return a.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=y}),define(ee[54],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ee[20],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(ee[23],te([0,1,80,12]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function R(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=R;function T(a,u){switch(a){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function v(a,u){return u==="web"&&!a.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function l(a,u,S){return v(u,S)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===S?!0:m(S).includes(a)}i.isTargetPlatformCompatible=l;function m(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=m;function L(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}i.isIExtensionIdentifier=L;var O;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(O=i.SortBy||(i.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=i.SortOrder||(i.SortOrder={}));var w;(function(a){a.Install="install",a.Uninstall="uninstall"})(w=i.StatisticType||(i.StatisticType={}));var b;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(b=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var g;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(g=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class y extends Error{constructor(u,S){super(u);this.code=S,this.name=S}}i.ExtensionManagementError=y,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ee[55],te([0,1,16,7,87,15]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function T(L,O,p,w,b,g){let y;try{await v(L,O,p,w,b,g)}catch(a){y=a}finally{y&&b.errorTransformer&&(y=b.errorTransformer(y)),typeof y!="undefined"&&p.error(y),p.end()}}i.readFileIntoStream=T;async function v(L,O,p,w,b,g){l(g);const y=await L.open(O,{create:!1});try{l(g);let a=0,u=0,S=b&&typeof b.length=="number"?b.length:void 0,h=D.VSBuffer.alloc(Math.min(b.bufferSize,typeof S=="number"?S:b.bufferSize)),s=b&&typeof b.position=="number"?b.position:0,t=0;do u=await L.read(y,s,h.buffer,t,h.byteLength-t),s+=u,t+=u,a+=u,typeof S=="number"&&(S-=u),t===h.byteLength&&(await p.write(w(h)),h=D.VSBuffer.alloc(Math.min(b.bufferSize,typeof S=="number"?S:b.bufferSize)),t=0);while(u>0&&(typeof S!="number"||S>0)&&l(g)&&m(a,b));if(t>0){let r=t;typeof S=="number"&&(r=Math.min(t,S)),p.write(w(h.slice(0,r)))}}catch(a){throw(0,R.ensureFileSystemProviderError)(a)}finally{await L.close(y)}}function l(L){if(L.isCancellationRequested)throw(0,I.canceled)();return!0}function m(L,O){if(O?.limits){if(typeof O.limits.memory=="number"&&L>O.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&L>O.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[98],te([0,1,3,138,2,10,139]),function(_,i,D,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class v extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const L=this.normalizeRequests(m),O=L.filter(w=>{const b=this.watchers.get(w.path);return b?!(0,I.patternsEquals)(b.request.excludes,w.excludes)||!(0,I.patternsEquals)(b.request.includes,w.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:w})=>!L.find(b=>b.path===w.path&&(0,I.patternsEquals)(b.excludes,w.excludes)&&(0,I.patternsEquals)(b.includes,w.includes))).map(({request:w})=>w.path);O.length&&this.trace(`Request to start watching: ${O.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?w.includes:"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const w of p)this.stopWatching(w);for(const w of O)this.startWatching(w)}startWatching(m){const L=new T.NodeJSFileWatcherLibrary(m,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),O={request:m,instance:L};this.watchers.set(m.path,O)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const L=this.watchers.get(m);L&&(this.watchers.delete(m),L.instance.dispose())}normalizeRequests(m){const L=new Map;for(const O of m){const p=R.isLinux?O.path:O.path.toLowerCase();L.set(p,O)}return Array.from(L.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,L]of this.watchers)L.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,L){return L?`[File Watcher (node.js)] ${m} (path: ${L.request.path})`:`[File Watcher (node.js)] ${m}`}}i.NodeJSWatcher=v}),define(ee[99],te([0,1,56,98]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends D.AbstractNonRecursiveWatcherClient{constructor(T,v,l){super(T,v,l);this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(ee[100],te([0,1,14,52,76,56]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class T extends R.AbstractUniversalWatcherClient{constructor(l,m,L){super(l,m,L);this.init()}createWatcher(l){const m=l.add(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:L,signal:O})=>this.onError(`terminated by itself with code ${L}, signal: ${O}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(m.getChannel("watcher")))}}i.UniversalWatcherClient=T}),define(ee[57],te([0,1]),function(_,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(let[R,T]of P)this.set(R,T)}set(P,R){const T=this._entries.get(P);return this._entries.set(P,R),T}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=D}),define(ee[101],te([0,1,4,7,42,97,12,57]),function(_,i,D,I,P,R,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const l=!1;class m extends Error{constructor(b){super("cyclic dependency between services");this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class L{constructor(b=new v.ServiceCollection,g=!1,y){this._activeInstantiations=new Set,this._services=b,this._strict=g,this._parent=y,this._services.set(T.IInstantiationService,this)}createChild(b){return new L(b,this._strict,this)}invokeFunction(b,...g){let y=p.traceInvocation(b),a=!1;try{return b({get:S=>{if(a)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(S,y);if(!h)throw new Error(`[invokeFunction] unknown service '${S}'`);return h}},...g)}finally{a=!0,y.stop()}}createInstance(b,...g){let y,a;return b instanceof P.SyncDescriptor?(y=p.traceCreation(b.ctor),a=this._createInstance(b.ctor,b.staticArguments.concat(g),y)):(y=p.traceCreation(b),a=this._createInstance(b,g,y)),y.stop(),a}_createInstance(b,g=[],y){let a=T._util.getServiceDependencies(b).sort((h,s)=>h.index-s.index),u=[];for(const h of a){let s=this._getOrCreateServiceInstance(h.id,y);s||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${h.id}.`,!1),u.push(s)}let S=a.length>0?a[0].index:g.length;if(g.length!==S){console.trace(`[createInstance] First service dependency of ${b.name} at position ${S+1} conflicts with ${g.length} static arguments`);let h=S-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,S)}return new b(...[...g,...u])}_setServiceInstance(b,g){if(this._services.get(b)instanceof P.SyncDescriptor)this._services.set(b,g);else if(this._parent)this._parent._setServiceInstance(b,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){let g=this._services.get(b);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):g}_getOrCreateServiceInstance(b,g){let y=this._getServiceInstanceOrDescriptor(b);return y instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,y,g.branch(b,!0)):(g.branch(b,!1),y)}_safeCreateAndCacheServiceInstance(b,g,y){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,g,y)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,g,y){const a=new R.Graph(h=>h.id.toString());let u=0;const S=[{id:b,desc:g,_trace:y}];for(;S.length;){const h=S.pop();if(a.lookupOrInsertNode(h),u++>1e3)throw new m(a);for(let s of T._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),t instanceof P.SyncDescriptor){const r={id:s.id,desc:t,_trace:h._trace.branch(s.id,!0)};a.insertEdge(h,r),S.push(r)}}}for(;;){const h=a.roots();if(h.length===0){if(!a.isEmpty())throw new m(a);break}for(const{data:s}of h){if(this._getServiceInstanceOrDescriptor(s.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}a.removeNode(s)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,g,y=[],a,u){if(this._services.get(b)instanceof P.SyncDescriptor)return this._createServiceInstance(g,y,a,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,g,y,a,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(b,g=[],y,a){if(y){const u=new D.IdleValue(()=>this._createInstance(b,g,a));return new Proxy(Object.create(null),{get(S,h){if(h in S)return S[h];let s=u.value,t=s[h];return typeof t!="function"||(t=t.bind(s),S[h]=t),t},set(S,h,s){return u.value[h]=s,!0}})}else return this._createInstance(b,g,a)}_throwIfStrict(b,g){if(g&&console.warn(g),this._strict)throw new Error(b)}}i.InstantiationService=L;var O;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(O||(O={}));class p{constructor(b,g){this.type=b,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(b){return l?new p(1,b.name||b.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(b){return l?new p(0,b.name):p._None}branch(b,g){let y=new p(2,b.toString());return this._dep.push([b,g,y]),y}stop(){let b=Date.now()-this._start;p._totals+=b;let g=!1;function y(u,S){let h=[],s=new Array(u+1).join("	");for(const[t,r,e]of S._dep)if(r&&e){g=!0,h.push(`${s}CREATES -> ${t}`);let n=y(u+1,e);n&&h.push(n)}else h.push(`${s}uses -> ${t}`);return h.join(`
`)}let a=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(b>2||g)&&console.log(a.join(`
`))}}i.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ee[58],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,D.createDecorator)("localizationsService");function I(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}i.isValidLocalization=I}),define(ee[13],te([0,1,28,3,2,10,12]),function(_,i,D,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,T.createDecorator)("logService"),i.ILoggerService=(0,T.createDecorator)("loggerService");function v(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function m(r,e,n){switch(e){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=m;function L(r){let e="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(n>0?" ":"")+o}return e}i.format=L;class O extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=O;class p extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,L([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,L([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,L([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,L([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(l.Error,L(o))}else this.log(l.Error,L([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,L([e,...n]))}flush(){}}i.AbstractMessageLogger=p;class w extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...n):console.log(`[main ${v()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...n):console.log(`[main ${v()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...n):console.log(`[main ${v()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,e,...n):console.warn(`[main ${v()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,e,...n):console.error(`[main ${v()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,e,...n):console.error(`[main ${v()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=w;class b extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=b;class g extends O{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,D.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class y extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const o of this.logServices)o.trace(e,...n)}debug(e,...n){for(const o of this.logServices)o.debug(e,...n)}info(e,...n){for(const o of this.logServices)o.info(e,...n)}warn(e,...n){for(const o of this.logServices)o.warn(e,...n)}error(e,...n){for(const o of this.logServices)o.error(e,...n)}critical(e,...n){for(const o of this.logServices)o.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=y;class a extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=a;class u extends P.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class S{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=S;function h(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=s(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=h;function s(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=s;function t(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=t});var ae=this&&this.__param||function(_,i){return function(D,I){i(D,I,_)}};define(ee[102],te([0,1,40,4,28,3,2,14,11,19,20,13]),function(_,i,D,I,P,R,T,v,l,m,L,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(b,g){super();this.environmentService=b,this.logService=g,this.processesLimiter=new I.Limiter(5)}async postUninstall(b){const g=this.parseScript(b,"uninstall");return g&&(this.logService.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,b).then(()=>this.logService.info(b.identifier.id,b.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(b.identifier.id,b.manifest.version,`Failed to run post uninstall script: ${y}`)))),m.Promises.rm(this.getExtensionStoragePath(b)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(b,g){const y=`vscode:${g}`;if(b.location.scheme===v.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[y]=="string"){const a=b.manifest.scripts[y].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.logService.warn(b.identifier.id,b.manifest.version,`${y} should be a node script`),null):{script:(0,l.join)(b.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}runLifecycleHook(b,g,y,a,u){return new Promise((S,h)=>{const s=this.start(b,g,y,u);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?h(e):S(void 0)};s.on("error",e=>{r((0,P.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,n)=>{r(e?`post-${g} process exited with code ${e}`:void 0)}),a&&(t=setTimeout(()=>{t=null,s.kill(),h("timed out")},5e3))})}start(b,g,y,a){const u={silent:!0,execArgv:void 0},S=(0,D.fork)(b,[`--type=extension-post-${g}`,...y],u);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const h=R.Event.fromNodeEventEmitter(S.stdout,"data"),s=R.Event.fromNodeEventEmitter(S.stderr,"data");h(e=>this.logService.info(a.identifier.id,a.manifest.version,`post-${g}`,e)),s(e=>this.logService.error(a.identifier.id,a.manifest.version,`post-${g}`,e));const t=R.Event.any(R.Event.map(h,e=>({data:`%c${e}`,format:[""]})),R.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(a.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),S}getExtensionStoragePath(b){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};p=he([ae(0,L.IEnvironmentService),ae(1,O.ILogService)],p),i.ExtensionsLifecycle=p}),define(ee[103],te([0,1,18,4,7,3,2,11,56,13]),function(_,i,D,I,P,R,T,v,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class L extends T.Disposable{constructor(p,w){super();this.logService=p,this.options=w,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(p,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,w):this.watchNonRecursive(p,w)}watchUniversal(p,w){const b={path:this.toFilePath(p),excludes:w.excludes,includes:w.includes,recursive:w.recursive},g=(0,D.insert)(this.universalPathsToWatch,b);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,P.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,l.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const w of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const w of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(w)&&p.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,w){const b={path:this.toFilePath(p),excludes:w.excludes,includes:w.includes,recursive:!1},g=(0,D.insert)(this.nonRecursivePathsToWatch,b);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,P.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,l.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,v.normalize)(p.fsPath)}}i.AbstractDiskFileSystemProvider=L}),define(ee[104],te([0,1,18,4,16,26,3,63,140,2,59,14,105,17,39,86,15,55,13]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class extends m.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const r=new m.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new y.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,m.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){t.push(r)}}),!this.provider.has(s)&&await I.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return l.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,w.isAbsolutePath)(s))throw new y.FileOperationError((0,g.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,s.toString()),r}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)||(0,y.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,g.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(s,t){const r=await this.withProvider(s),e=this.isPathCaseSensitive(r),n=t?.resolveTo,o=t?.resolveSingleChildDescendants,c=t?.resolveMetadata,f=await r.stat(s);let d;return this.toFileStat(r,s,f,void 0,!!c,(E,A)=>(d||(d=L.TernarySearchTree.forUris(()=>!e),d.set(s,!0),n&&d.fill(!0,n)),d.get(E.resource)||d.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?A===1:!1))}async toFileStat(s,t,r,e,n,o){const{providerExtUri:c}=this.getExtUri(s),f={resource:t,name:c.basename(t),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(f.isDirectory&&o(f,e)){try{const d=await s.readdir(t),E=await I.Promises.settled(d.map(async([A,V])=>{try{const Z=c.joinPath(t,A),Y=n?await s.stat(Z):{type:V};return await this.toFileStat(s,Z,Y,d.length,n,o)}catch(Z){return this.logService.trace(Z),null}}));f.children=(0,D.coalesce)(E)}catch(d){this.logService.trace(d),f.children=[]}return f}return f}async resolveAll(s){return I.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),r=await t.stat(s);return this.toFileStat(t,s,r,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(r){return r}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,g.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const e=await this.writeFile(s,t);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,e)),e}async writeFile(s,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,s,r)||await this.mkdirp(e,n.dirname(s));let c;if((0,y.hasReadWriteCapability)(e)&&!(t instanceof P.VSBuffer))if((0,b.isReadableStream)(t)){const f=await(0,b.peekStream)(t,3);f.ended?c=P.VSBuffer.concat(f.buffer):c=f}else c=(0,b.peekReadable)(t,f=>P.VSBuffer.concat(f),3);else c=t;!(0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e)&&c instanceof P.VSBuffer?await this.doWriteUnbuffered(e,s,r,c):await this.doWriteBuffered(e,s,r,c instanceof P.VSBuffer?(0,P.bufferToReadable)(c):c),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,g.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(t)));let n;try{n=await s.stat(t)}catch{return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,g.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(s,t,r){const e=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(e,s,t,r):this.doReadFile(e,s,t,r)}async doReadFileAtomic(s,t,r,e){return new Promise((n,o)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(s,t,r,e);n(c)}catch(c){o(c)}})})}async doReadFile(s,t,r,e){const n=await this.doReadFileStream(s,t,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(s,t,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,t,r)}async doReadFileStream(s,t,r,e){const n=new R.CancellationTokenSource(e),o=this.validateReadFile(t,r).then(f=>f,f=>{throw n.cancel(),f});let c;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await o,r?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&r?.preferUnbuffered?c=this.readFileUnbuffered(s,t,r):(0,y.hasFileReadStreamCapability)(s)?c=this.readFileStreamed(s,t,n.token,r):c=this.readFileBuffered(s,t,n.token,r),{...await o,value:c}}catch(f){c&&await(0,b.consumeStream)(c);const d=(0,g.localize)(8,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(f).toString());throw f instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(d,f.stat,r):new y.FileOperationError(d,(0,y.toFileOperationResult)(f),r)}}readFileStreamed(s,t,r,e=Object.create(null)){const n=s.readFileStream(t,e,r);return(0,b.transform)(n,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,g.localize)(9,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),e)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,t,r,e=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,a.readFileIntoStream)(s,t,n,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,g.localize)(10,null,this.resourceForError(t),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),e)},r),n}readFileUnbuffered(s,t,r){const e=(0,b.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?n=await s.readFile(t,{atomic:!0}):n=await s.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(t,n.byteLength,r),e.end(P.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(s,t){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,g.localize)(11,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==y.ETAG_DISABLED&&t.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,t);return this.validateReadFileLimits(s,r.size,t),r}validateReadFileLimits(s,t,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&t>r.limits.size&&(e=7),typeof e=="number")throw new y.FileOperationError((0,g.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,t,r){return this.doCanMoveCopy(s,t,"move",r)}async canCopy(s,t,r){return this.doCanMoveCopy(s,t,"copy",r)}async doCanMoveCopy(s,t,r,e){if(s.toString()!==t.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,s,o,t,r,e)}catch(n){return n}return!0}async move(s,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(e,s,n,t,"move",!!r),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,t,r){const e=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(e,s,n,t,"copy",!!r),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,t,r,e,n,o){if(t.toString()===e.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(s,t,r,e,n,o);if(c&&!f&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(s===r&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(t,e,{overwrite:o});else{const d=await this.resolve(t);d.isDirectory?await this.doCopyFolder(s,d,r,e):await this.doCopyFile(s,t,r,e)}return n}else return s===r?(await s.rename(t,e,{overwrite:o}),n):(await this.doMoveCopy(s,t,r,e,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,r,e){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,t,r,e);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,t,r,e);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,t,r,e);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,t,r,e)}async doCopyFolder(s,t,r,e){await r.mkdir(e),Array.isArray(t.children)&&await I.Promises.settled(t.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,t,r,e,n,o){let c=!1;if(s===r){const{providerExtUri:d,isPathCaseSensitive:E}=this.getExtUri(s);if(E||(c=d.isEqual(t,e)),c&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!c&&d.isEqualOrParent(e,t))throw new Error((0,g.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const f=await this.exists(e);if(f&&!c){if(!o)throw new y.FileOperationError((0,g.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(s===r){const{providerExtUri:d}=this.getExtUri(s);if(d.isEqualOrParent(t,e))throw new Error((0,g.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:f,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,r)),r}async mkdirp(s,t){const r=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(t,e.dirname(t));)try{if(((await s.stat(t)).type&y.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(t)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(t)),t=e.dirname(t)}for(let n=r.length-1;n>=0;n--){t=e.joinPath(t,r[n]);try{await s.mkdir(t)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(r){return r}return!0}async doValidateDelete(s,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new y.FileOperationError((0,g.localize)(20,null,this.resourceForError(s)),1);if(!!!t?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(s)))}return r}async del(s,t){const r=await this.doValidateDelete(s,t),e=!!t?.useTrash,n=!!t?.recursive;await r.delete(s,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,t){const r=await this.withProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(r===e&&this.getExtUri(r).providerExtUri.isEqual(s,t))return;if(r===e&&(0,y.hasFileCloneCapability)(r))return r.cloneFile(s,t);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(t));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===e&&(0,y.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,t,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,e,t))}watch(s,t={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,m.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,t);e?(0,m.dispose)(o):n=()=>(0,m.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,t){const r=await this.withProvider(s),e=(0,v.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),t]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(s,t)},this.activeWatchers.set(e,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,m.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,b.isReadableStream)(e)||(0,b.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,n,e):await this.doWriteReadableBufferedQueued(s,n,e)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,t,r){let e=0,n;if((0,b.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,t,o,o.byteLength,e,0),e+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,c)=>{(0,b.listenStream)(n,{onData:async f=>{n.pause();try{await this.doWriteBuffer(s,t,f,f.byteLength,e,0)}catch(d){return c(d)}e+=f.byteLength,setTimeout(()=>n.resume())},onError:f=>c(f),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,t,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,t,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(s,t,r,e,n,o){let c=0;for(;c<e;)c+=await s.write(t,n+c,r.buffer,o+c,e-c)}async doWriteUnbuffered(s,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,r,e))}async doWriteUnbufferedQueued(s,t,r,e){let n;e instanceof P.VSBuffer?n=e:(0,b.isReadableStream)(e)?n=await(0,P.streamToBuffer)(e):(0,b.isReadableBufferedStream)(e)?n=await(0,P.bufferedStreamToBuffer)(e):n=(0,P.readableToBuffer)(e),await s.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,r,e))}async doPipeBufferedQueued(s,t,r,e){let n,o;try{n=await s.open(t,{create:!1}),o=await r.open(e,{create:!0,unlock:!1});const c=P.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,d=0,E=0;do E=await s.read(n,f,c.buffer,d,c.byteLength-d),await this.doWriteBuffer(r,o,c,E,f,d),f+=E,d+=E,d===c.byteLength&&(d=0);while(E>0)}catch(c){throw(0,y.ensureFileSystemProviderError)(c)}finally{await I.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,r,e))}async doPipeUnbufferedQueued(s,t,r,e){return r.writeFile(e,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,r,e))}async doPipeUnbufferedToBufferedQueued(s,t,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,t,r,e){const n=await(0,P.streamToBuffer)(this.readFileBuffered(s,t,R.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new y.FileOperationError((0,g.localize)(22,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,g.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===O.Schemas.file?s.fsPath:s.toString(!0)}};S=he([ae(0,u.ILogService)],S),i.FileService=S}),define(ee[106],te([0,1,107,141,4,59,16,3,51,2,11,10,17,39,19,88,15,55,103,28,100,99]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u,S,h,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(r)}`)}})();class t extends u.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:o}=await b.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await b.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async c=>{try{let f;c.isSymbolicLink()?f=(await this.stat((0,p.joinPath)(e,c.name))).type:f=this.toType(c),o.push([c.name,f])}catch(f){this.logService.trace(f)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let o;return n?.dangling?o=y.FileType.Unknown:e.isFile()?o=y.FileType.File:e.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,n&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(e){const n=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const c=new P.Barrier;return this.resourceLocks.set(e,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(e)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(e,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const c=this.toFilePath(e);return await b.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}readFileStream(e,n,o){const c=(0,w.newWriteableStream)(f=>T.VSBuffer.concat(f.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,a.readFileIntoStream)(this,e,c,f=>f.buffer,{...n,bufferSize:256*1024},o),c}async writeFile(e,n,o){let c;try{const f=this.toFilePath(e);if(!o.create||!o.overwrite){if(await b.Promises.exists(f)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,g.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,g.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(e,f)}finally{typeof c=="number"&&await this.close(c)}}async open(e,n){const o=this.toFilePath(e);let c;(0,y.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(e));let f;try{if((0,y.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:E}=await b.SymlinkSupport.stat(o);E.mode&128||await b.Promises.chmod(o,E.mode|128)}catch(E){this.logService.trace(E)}let d;if((0,y.isFileOpenForWriteOptions)(n)){if(O.isWindows)try{await b.Promises.truncate(o,0),d="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}d||(d="w")}else d="r";f=await b.Promises.open(o,d)}catch(d){throw c?.dispose(),(0,y.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(f,0),(0,y.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(f,e),c){const d=this.mapHandleToLock.get(f);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${f} (${o})`),this.mapHandleToLock.set(f,c),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${f} (${o})`),d.dispose())}return f}async close(e){const n=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await b.Promises.fdatasync(e)}catch(o){this.canFlush=!1,this.logService.error(o)}return await b.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(e)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),n.dispose())}}async read(e,n,o,c,f){const d=this.normalizePos(e,n);let E=null;try{E=(await b.Promises.read(e,o,c,f,d)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(e,d,E)}return E}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,o){const c=this.mapHandleToPos.get(e);typeof c=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,c+o):this.mapHandleToPos.delete(e)))}async write(e,n,o,c,f){return(0,P.retry)(()=>this.doWrite(e,n,o,c,f),100,3)}async doWrite(e,n,o,c,f){const d=this.normalizePos(e,n);let E=null;try{E=(await b.Promises.write(e,o,c,f,d)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),A)}finally{this.updatePos(e,d,E)}return E}async mkdir(e){try{await b.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const o=this.toFilePath(e);n.recursive?await b.Promises.rm(o,b.RimRafMode.MOVE):await b.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,n,o){const c=this.toFilePath(e),f=this.toFilePath(n);if(c!==f)try{await this.validateTargetDeleted(e,n,"move",o.overwrite),await b.Promises.move(c,f)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(2,null,(0,L.basename)(c),(0,L.basename)((0,L.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(e,n,o){const c=this.toFilePath(e),f=this.toFilePath(n);if(c!==f)try{await this.validateTargetDeleted(e,n,"copy",o.overwrite),await b.Promises.copy(c,f,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(3,null,(0,L.basename)(c),(0,L.basename)((0,L.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(e,n,o,c){const f=this.toFilePath(e),d=this.toFilePath(n);let E=!1;if(!!(this.capabilities&1024)||(E=(0,l.isEqual)(f,d,!0)),E&&o==="copy")throw(0,y.createFileSystemProviderError)((0,g.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!E&&await b.Promises.exists(d)){if(!c)throw(0,y.createFileSystemProviderError)((0,g.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(e,n){return this.doCloneFile(e,n,!1)}async doCloneFile(e,n,o){const c=this.toFilePath(e),f=this.toFilePath(n),d=!!(this.capabilities&1024);if((0,l.isEqual)(c,f,!d))return;const E=new m.DisposableStore;try{const[A,V]=await Promise.all([this.createResourceLock(e),this.createResourceLock(n)]);E.add(A),E.add(V),o&&await b.Promises.mkdir((0,L.dirname)(f),{recursive:!0}),await b.Promises.copyFile(c,f)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(e,n,!0);throw this.toFileSystemProviderError(A)}finally{E.dispose()}}createUniversalWatcher(e,n,o){return new h.UniversalWatcherClient(c=>e(c),c=>n(c),o)}createNonRecursiveWatcher(e,n,o){return new s.NodeJSWatcherClient(c=>e(c),c=>n(c),o)}toFileSystemProviderError(e){if(e instanceof y.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=y.FileSystemProviderErrorCode.NoPermissions;break;default:n=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let o=this.toFileSystemProviderError(n);if(e&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await b.SymlinkSupport.stat(this.toFilePath(e));c.mode&128||(o=(0,y.createFileSystemProviderError)(n,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}i.DiskFileSystemProvider=t}),define(ee[108],te([0,1,15,13]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(v,l,m,L,O){try{const p=await new Promise((b,g)=>{_(["spdlog"],b,g)});p.setFlushOn(I.LogLevel.Trace);const w=await p.createAsyncRotatingLogger(v,l,m,L);return O&&w.clearFormatters(),w}catch(p){console.error(p)}return null}function R(v,l,m){switch(l){case I.LogLevel.Trace:v.trace(m);break;case I.LogLevel.Debug:v.debug(m);break;case I.LogLevel.Info:v.info(m);break;case I.LogLevel.Warning:v.warn(m);break;case I.LogLevel.Error:v.error(m);break;case I.LogLevel.Critical:v.critical(m);break;default:throw new Error("Invalid log level")}}class T extends I.AbstractMessageLogger{constructor(l,m,L,O,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(l,m,L,O),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(l,m,L,O){const p=L?6:1,w=30/p*D.ByteSize.MB,b=await P(l,m,w,p,O);if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:g,message:y}of this.buffer)R(this._logger,g,y);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=T}),define(ee[27],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(ee[30],te([0,1,61,8]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(T,v){D.ok(I.isString(T)),D.ok(I.isObject(v)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,v)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}i.Registry=new P}),define(ee[109],te([0,1,3,30]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[P(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;I.Registry.add(i.Extensions.JSONContribution,T)}),define(ee[35],te([0,1,18,3,8,78,22,109,30]),function(_,i,D,I,P,R,T,v,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var m;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(m=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var L;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const O=l.Registry.as(v.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},O.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const e=this.doRegisterConfigurations(t,r);O.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(t){const r=this.doDeregisterConfigurations(t);O.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const e=[];e.push(...this.doDeregisterConfigurations(r)),e.push(...this.doRegisterConfigurations(t,!1)),O.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(e)})}registerDefaultConfigurations(t){const r=[],e=[];for(const{overrides:n,source:o}of t)for(const c in n)if(r.push(c),i.OVERRIDE_PROPERTY_REGEX.test(c)){const f=this.configurationDefaultsOverrides.get(c),d=f?.valuesSources??new Map;if(o)for(const Z of Object.keys(n[c]))d.set(Z,o);const E={...f?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:E,valuesSources:d});const A=(0,T.getLanguageTagSettingPlainKey)(c),V={type:"object",default:E,description:R.localize(1,null,A),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:P.isString(o)?void 0:o,defaultValueSource:o};e.push(...g(c)),this.configurationProperties[c]=V,this.defaultLanguageConfigurationOverridesNode.properties[c]=V}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:o});const f=this.configurationProperties[c];f&&(this.updatePropertyDefaultValue(c,f),this.updateSchema(c,f))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const r=[];for(const{overrides:e,source:n}of t)for(const o in e){const c=this.configurationDefaultsOverrides.get(o),f=P.isString(n)?n:n?.id,d=P.isString(c?.source)?c?.source:c?.source?.id;if(f===d)if(r.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const E=this.configurationProperties[o];E&&(this.updatePropertyDefaultValue(o,E),this.updateSchema(o,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r){const e=[];return t.forEach(n=>{e.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),e}doDeregisterConfigurations(t){const r=[],e=n=>{if(n.properties)for(const o in n.properties)r.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>e(o))};for(const n of t){e(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(t,r=!0,e,n,o=3){o=P.isUndefinedOrNull(t.scope)?o:t.scope;let c=[],f=t.properties;if(f)for(let E in f){if(r&&S(E)){delete f[E];continue}const A=f[E];if(A.source=e,A.defaultDefaultValue=f[E].default,this.updatePropertyDefaultValue(E,A),i.OVERRIDE_PROPERTY_REGEX.test(E)?A.scope=void 0:(A.scope=P.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=P.isUndefinedOrNull(A.restricted)?!!n?.includes(E):A.restricted),f[E].hasOwnProperty("included")&&!f[E].included){this.excludedConfigurationProperties[E]=f[E],delete f[E];continue}else this.configurationProperties[E]=f[E];!f[E].deprecationMessage&&f[E].markdownDeprecationMessage&&(f[E].deprecationMessage=f[E].markdownDeprecationMessage),c.push(E)}let d=t.allOf;if(d)for(let E of d)c.push(...this.validateAndRegisterProperties(E,r,e,n,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=e=>{let n=e.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);let o=e.allOf;o&&o.forEach(r)};r(t)}updateSchema(t,r){switch(i.allSettings.properties[t]=r,r.scope){case 1:i.applicationSettings.properties[t]=r;break;case 2:i.machineSettings.properties[t]=r;break;case 6:i.machineOverridableSettings.properties[t]=r;break;case 3:i.windowSettings.properties[t]=r;break;case 4:i.resourceSettings.properties[t]=r;break;case 5:i.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete i.allSettings.properties[t],r.scope){case 1:delete i.applicationSettings.properties[t];break;case 2:delete i.machineSettings.properties[t];break;case 6:delete i.machineOverridableSettings.properties[t];break;case 3:delete i.windowSettings.properties[t];break;case 4:case 5:delete i.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,e={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,e),i.allSettings.properties[r]=e,i.applicationSettings.properties[r]=e,i.machineSettings.properties[r]=e,i.machineOverridableSettings.properties[r]=e,i.windowSettings.properties[r]=e,i.resourceSettings.properties[r]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const e=this.configurationDefaultsOverrides.get(t);let n=e?.value,o=e?.source;P.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),P.isUndefined(n)&&(n=a(r.type)),r.default=n,r.defaultValueSource=o}}const w="\\[([^\\]]+)\\]",b=new RegExp(w,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function g(s){const t=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let r=b.exec(s);for(;r?.length;){const e=r[1].trim();e&&t.push(e),r=b.exec(s)}}return(0,D.distinct)(t)}i.overrideIdentifiersFromKey=g;function y(s){return s.reduce((t,r)=>`${t}[${r}]`,"")}i.keyFromOverrideIdentifiers=y;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const u=new p;l.Registry.add(i.Extensions.Configuration,u);function S(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?R.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):null:R.localize(6,null)}i.validateProperty=S;function h(){const s=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))s.push([r,t[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=h}),define(ee[110],te([0,1,18,3,46,2,59,21,8,9,22,35,30]),function(_,i,D,I,P,R,T,v,l,m,L,O,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class w{constructor(e={},n=[],o=[]){this._contents=e,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,L.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const o=this.getContentsForOverrideIdentifer(n);return o?e?(0,L.getConfigurationValue)(o,e):o:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const o of this.overrides)o.identifiers.includes(e)&&n.push(...o.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return D.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=v.deepClone(this.contents),o=v.deepClone(this.overrides),c=[...this.keys];for(const f of e){this.mergeContents(n,f.contents);for(const d of f.overrides){const[E]=o.filter(A=>D.equals(A.identifiers,d.identifiers));E?(this.mergeContents(E.contents,d.contents),E.keys.push(...d.keys),E.keys=D.distinct(E.keys)):o.push(v.deepClone(d))}for(const d of f.keys)c.indexOf(d)===-1&&c.push(d)}return new w(n,c,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const c of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[c],d=n[c];d&&(typeof f=="object"&&typeof d=="object"?(f=v.deepClone(f),this.mergeContents(f,d)):f=d),o[c]=f}return new w(o,this.keys,this.overrides)}mergeContents(e,n){for(const o of Object.keys(n)){if(o in e&&l.isObject(e[o])&&l.isObject(n[o])){this.mergeContents(e[o],n[o]);continue}e[o]=v.deepClone(n[o])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?v.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,o=null;const c=f=>{f&&(o?this.mergeContents(o,f):o=v.deepClone(f))};for(const f of this.overrides)D.equals(f.identifiers,[e])?n=f.contents:f.identifiers.includes(e)&&c(f.contents);return c(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,L.addToValueTree)(this.contents,e,n,o=>{throw new Error(o)})}removeValue(e){this.removeKey(e)&&(0,L.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let o=0;o<n;o++)e.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=w;class b extends w{constructor(e={}){const n=p.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(n),c=Object.create(null),f=[];for(const d in n){const E=e[d],A=E!==void 0?E:n[d].default;(0,L.addToValueTree)(c,d,A,V=>console.error(`Conflict in default settings: ${V}`))}for(const d of Object.keys(c))O.OVERRIDE_PROPERTY_REGEX.test(d)&&f.push({identifiers:(0,O.overrideIdentifiersFromKey)(d),keys:Object.keys(c[d]),contents:(0,L.toValuesTree)(c[d],E=>console.error(`Conflict in default settings file: ${E}`))});super(c,o,f)}}i.DefaultConfigurationModel=b;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const o=this.doParseContent(e);this.parseRaw(o,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:o,keys:c,overrides:f,restricted:d}=this.doParseRaw(e,n);this._configurationModel=new w(o,c,f),this._restrictedConfigurations=d||[]}doParseContent(e){let n={},o=null,c=[],f=[],d=[];function E(V){Array.isArray(c)?c.push(V):o!==null&&(c[o]=V)}let A={onObjectBegin:()=>{let V={};E(V),f.push(c),c=V,o=null},onObjectProperty:V=>{o=V},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{let V=[];E(V),f.push(c),c=V,o=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:E,onError:(V,Z,Y)=>{d.push({error:V,offset:Z,length:Y})}};if(e)try{P.visit(e,A),n=c[0]||{}}catch(V){console.error(`Error while parsing settings file ${this._name}: ${V}`),this._parseErrors=[V]}return n}doParseRaw(e,n){const o=p.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),c=this.filter(e,o,!0,n);e=c.raw;const f=(0,L.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),d=Object.keys(e),E=this.toOverrides(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:f,keys:d,overrides:E,restricted:c.restricted}}filter(e,n,o,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:e,restricted:[]};const f={},d=[];for(let E in e)if(O.OVERRIDE_PROPERTY_REGEX.test(E)&&o){const A=this.filter(e[E],n,!1,c);f[E]=A.raw,d.push(...A.restricted)}else{const A=n[E],V=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&d.push(E),(V===void 0||c.scopes===void 0||c.scopes.includes(V))&&(c.skipRestricted&&A?.restricted||(f[E]=e[E]))}return{raw:f,restricted:d}}toOverrides(e,n){const o=[];for(const c of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(c)){const f={};for(const d in e[c])f[d]=e[c][d];o.push({identifiers:(0,O.overrideIdentifiersFromKey)(c),keys:Object.keys(f),contents:(0,L.toValuesTree)(f,n)})}return o}}i.ConfigurationModelParser=g;class y extends R.Disposable{constructor(e,n,o,c){super();this.userSettingsResource=e,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&o.isEqual(f.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=y;class a{constructor(e,n,o=new w,c=new w,f=new T.ResourceMap,d=new w,E=new T.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=c,this._folderConfigurations=f,this._memoryConfiguration=d,this._memoryConfigurationByResource=E,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(e)}updateValue(e,n,o={}){let c;o.resource?(c=this._memoryConfigurationByResource.get(o.resource),c||(c=new w,this._memoryConfigurationByResource.set(o.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(e):c.setValue(e,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,o){const c=this.getConsolidateConfigurationModel(n,o),f=this.getFolderConfigurationModelForResource(n.resource,o),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,E=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),V=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),Z=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),Y=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ne=f?n.overrideIdentifier?f.freeze().override(n.overrideIdentifier).getValue(e):f.freeze().getValue(e):void 0,re=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(e):d.getValue(e),N=c.getValue(e),W=D.distinct(D.flatten(c.overrides.map(G=>G.identifiers))).filter(G=>c.getOverrideValue(e,G)!==void 0);return{defaultValue:E,userValue:A,userLocalValue:V,userRemoteValue:Z,workspaceValue:Y,workspaceFolderValue:ne,memoryValue:re,value:N,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:V!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:Z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:f?.freeze().getValue(e),override:n.overrideIdentifier?f?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:d.getValue(e),override:n.overrideIdentifier?d.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const o=[];if(!n){const{added:c,updated:f,removed:d}=s(this._defaultConfiguration,e);n=[...c,...f,...d]}for(const c of n)for(const f of(0,O.overrideIdentifiersFromKey)(c)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(f),E=e.getKeysForOverrideIdentifier(f),A=[...E.filter(V=>d.indexOf(V)===-1),...d.filter(V=>E.indexOf(V)===-1),...d.filter(V=>!v.equals(this._defaultConfiguration.override(f).getValue(V),e.override(f).getValue(V)))];o.push([f,A])}return this.updateDefaultConfiguration(e),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:o,removed:c,overrides:f}=s(this.localUserConfiguration,e),d=[...n,...o,...c];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:f}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:o,removed:c,overrides:f}=s(this.remoteUserConfiguration,e);let d=[...n,...o,...c];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:f}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:o,removed:c,overrides:f}=s(this.workspaceConfiguration,e);let d=[...n,...o,...c];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:f}}compareAndUpdateFolderConfiguration(e,n){const o=this.folderConfigurations.get(e),{added:c,updated:f,removed:d,overrides:E}=s(o,n);let A=[...c,...f,...d];return(A.length||!o)&&this.updateFolderConfiguration(e,n),{keys:A,overrides:E}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:o,updated:c,removed:f,overrides:d}=s(n,void 0);return{keys:[...o,...c,...f],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let o=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?o.override(e.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:e},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const c=n.getFolder(e);c&&(o=this.getFolderConsolidatedConfiguration(c.uri)||o);const f=this._memoryConfigurationByResource.get(e);f&&(o=o.merge(f))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(e);c?(n=o.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=o}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const o=n.getFolder(e);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:o,overrides:c,keys:f}=this._folderConfigurations.get(n);return e.push([n,{contents:o,overrides:c,keys:f}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>e.add(o))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>e.add(o))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(e).forEach(c=>n.add(c))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),o=this.parseConfigurationModel(e.user),c=this.parseConfigurationModel(e.workspace),f=e.folders.reduce((d,E)=>(d.set(m.URI.revive(E[0]),this.parseConfigurationModel(E[1])),d),new T.ResourceMap);return new a(n,o,new w,c,f,new w,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=a;function u(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const c of r)c.keys.forEach(f=>e.add(f)),c.overrides.forEach(([f,d])=>{const E=(0,T.getOrSet)(n,f,new Set);d.forEach(A=>E.add(A))});const o=[];return n.forEach((c,f)=>o.push([f,[...c.values()]])),{keys:[...e.values()],overrides:o}}i.mergeChanges=u;class S{constructor(e,n,o,c){this.change=e,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=c,this._previousConfiguration=void 0;const f=new Set;e.keys.forEach(E=>f.add(E)),e.overrides.forEach(([,E])=>E.forEach(A=>f.add(A))),this.affectedKeys=[...f.values()];const d=new w;this.affectedKeys.forEach(E=>d.setValue(E,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!v.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let o=(0,L.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof o=="object"&&(c=Object.keys(o)[0]);){if(e=e[c],!e)return!1;o=o[c]}return!0}}i.ConfigurationChangeEvent=S;class h extends S{constructor(e,n,o,c){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=o,this.sourceConfig=c}}i.AllKeysConfigurationChangeEvent=h;function s(r,e){const{added:n,removed:o,updated:c}=t(e,r),f=[],d=r?.getAllOverrideIdentifiers()||[],E=e?.getAllOverrideIdentifiers()||[];if(e){const A=E.filter(V=>!d.includes(V));for(const V of A)f.push([V,e.getKeysForOverrideIdentifier(V)])}if(r){const A=d.filter(V=>!E.includes(V));for(const V of A)f.push([V,r.getKeysForOverrideIdentifier(V)])}if(e&&r){for(const A of d)if(E.includes(A)){const V=t({contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)},{contents:e.getOverrideValue(void 0,A)||{},keys:e.getKeysForOverrideIdentifier(A)});f.push([A,[...V.added,...V.removed,...V.updated]])}}return{added:n,removed:o,updated:c,overrides:f}}function t(r,e){const n=r?e?r.keys.filter(f=>e.keys.indexOf(f)===-1):[...r.keys]:[],o=e?r?e.keys.filter(f=>r.keys.indexOf(f)===-1):[...e.keys]:[],c=[];if(r&&e){for(const f of e.keys)if(r.keys.indexOf(f)!==-1){const d=(0,L.getConfigurationValue)(e.contents,f),E=(0,L.getConfigurationValue)(r.contents,f);v.equals(d,E)||c.push(f)}}return{added:n,removed:o,updated:c}}}),define(ee[111],te([0,1,4,3,2,17,22,110,35,30]),function(_,i,D,I,P,R,T,v,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class L extends P.Disposable{constructor(p,w){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,w)),this.configuration=new v.Configuration(new v.DefaultConfigurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:b})=>this.onDidDefaultConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new v.Configuration(new v.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,w){const b=typeof p=="string"?p:void 0,g=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(b,g,void 0)}updateValue(p,w,b,g){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const w=this.configuration.toData(),b=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(b,w,1)}onDidDefaultConfigurationChange(p){const w=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(new v.DefaultConfigurationModel,p);this.trigger(b,w,6)}trigger(p,w,b){const g=new v.ConfigurationChangeEvent(p,{data:w},this.configuration);g.source=b,g.sourceConfig=this.getTargetConfiguration(b),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=L}),define(ee[112],te([0,1,14]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function I(T){return T.scheme===D.Schemas.vscodeRemote?T.authority:void 0}i.getRemoteAuthority=I;function P(T){if(!T)return;const v=T.indexOf("+");return v<0?T:T.substr(0,v)}i.getRemoteName=P;function R(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}i.getRemoteServerRootPath=R}),define(ee[36],te([0,1,25,12,112]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}i.getWorkspaceSupportTypeMessage=R;function T(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}i.isIExtensionIdentifier=T,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var v;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(v=i.ExtensionType||(i.ExtensionType={}));var l;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(l=i.TargetPlatform||(i.TargetPlatform={}));class m{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){let y=typeof b=="string"?b:b.value,a=typeof g=="string"?g:g.value;return D.equalsIgnoreCase(y,a)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}i.ExtensionIdentifier=m;function L(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}i.isLanguagePackExtension=L;function O(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=O;function p(w,b){if(b){const g=`onResolveRemoteAuthority:${(0,P.getRemoteName)(b)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}i.isResolverExtension=p,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,25,23,36,10,9,7,29]),function(_,i,D,I,P,R,T,v,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function m(e,n){return e.uuid&&n.uuid?e.uuid===n.uuid:e.id===n.id?!0:(0,D.compareIgnoreCase)(e.id,n.id)===0}i.areSameExtensions=m;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class O{constructor(n,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=n.id}static create(n){const o=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new O(n.identifier,o,c)}static parse(n){const o=L.exec(n);return o&&o[1]&&o[2]?new O({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof O?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}i.ExtensionKey=O;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(e){const n=p.exec(e);return n&&n[1]?[g(n[1]),n[2]]:[g(e),void 0]}i.getIdAndVersion=w;function b(e,n){return`${e}.${n}`}i.getExtensionId=b;function g(e){return e.toLocaleLowerCase()}i.adoptToGalleryExtensionId=g;function y(e,n){return g(b(e,n))}i.getGalleryExtensionId=y;function a(e,n){const o=[],c=f=>{for(const d of o)if(d.some(E=>m(n(E),n(f))))return d;return null};for(const f of e){const d=c(f);d?d.push(f):o.push([f])}return o}i.groupByExtension=a;function u(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function S(e){return{id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,isPreReleaseVersion:e.properties.isPreReleaseVersion,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0),...e.telemetryData}}i.getGalleryExtensionTelemetryData=S,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function h(e){const n=new Set;if(e.malicious)for(const o of e.malicious)n.add(o.id);return n}i.getMaliciousExtensionsSet=h;function s(e,n){const o=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const f=c.shift();if(f&&o.every(d=>!m(d.identifier,{id:f}))){const d=e.filter(E=>m(E.identifier,{id:f}));d.length===1&&(o.push(d[0]),c.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}i.getExtensionDependencies=s;async function t(e,n){if(!R.isLinux)return!1;let o;try{o=(await e.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await e.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(f))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=t;async function r(e,n){const o=await t(e,n),c=(0,I.getTargetPlatform)(o?"alpine":R.platform,l.arch);return n.debug("ComputeTargetPlatform:",c),c}i.computeTargetPlatform=r}),define(ee[113],te([0,1,26,7,65,14,34,9,81,23,24,36]),function(_,i,D,I,P,R,T,v,l,m,L,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const p=y=>(0,l.localize)(0,null,y),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");function b(y,a){return a?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let g=class{constructor(a,u){this.extensionManagementService=a,this.extensionGalleryService=u}get location(){}async listExtensions(a,u,S=console){let h=await this.extensionManagementService.getInstalled(1);const s=O.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){S.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){S.log("Possible Categories: "),s.forEach(r=>{S.log(r)});return}this.location&&S.log((0,l.localize)(2,null,this.location)),h=h.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let t;for(let r of h)t!==r.identifier.id&&(t=r.identifier.id,S.log(b(r.manifest,a)))}async installExtensions(a,u,S,h,s=console){const t=[],r=[];a.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(d,E)=>{const A=e.find(V=>(0,L.areSameExtensions)(V.identifier,{id:d}));if(A){if(!h&&(!E||E==="prerelease"&&A.preRelease))return s.log((0,l.localize)(5,null,d,A.manifest.version,d)),!1;if(E&&A.manifest.version===E)return s.log((0,l.localize)(6,null,`${d}@${E}`)),!1}return!0},o=(d,E,A)=>{f.push({id:d,version:E!=="prerelease"?E:void 0,installOptions:{...S,isBuiltin:A,installPreReleaseVersion:E==="prerelease"||S.installPreReleaseVersion}})},c=[],f=[];for(const d of a)if(d instanceof v.URI)c.push(d);else{const[E,A]=(0,L.getIdAndVersion)(d);n(E,A)&&o(E,A,!1)}for(const d of u){const[E,A]=(0,L.getIdAndVersion)(d);n(E,A)&&o(E,A,!0)}if(c.length&&await Promise.all(c.map(async d=>{try{const E=await this.installVSIX(d,{...S,isBuiltin:!1},h,s);E&&r.push(E)}catch(E){s.error(E.message||E.stack||E),t.push(d.toString())}})),f.length){const d=await this.getGalleryExtensions(f);await Promise.all(f.map(async E=>{const A=d.get(E.id.toLowerCase());if(A)try{const V=await this.installFromGallery(E,A,e,h,s);V&&r.push(V)}catch(V){s.error(V.message||V.stack||V),t.push(E.id)}else s.error(`${p(E.version?`${E.id}@${E.version}`:E.id)}
${w}`),t.push(E.id)}))}if(t.length)throw new Error((0,l.localize)(7,null,t.join(", ")))}async installVSIX(a,u,S,h){const s=await this.extensionManagementService.getManifest(a);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,S,h))try{return await this.extensionManagementService.install(a,u),h.log((0,l.localize)(8,null,(0,P.getBaseLabel)(a))),s}catch(r){if((0,I.isCancellationError)(r))return h.log((0,l.localize)(9,null,(0,P.getBaseLabel)(a))),null;throw r}return null}async getGalleryExtensions(a){const u=new Map,S=a.some(s=>s.installOptions.installPreReleaseVersion),h=await this.extensionGalleryService.getExtensions(a.map(s=>({...s,preRelease:S})),D.CancellationToken.None);for(const s of h)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:a,version:u,installOptions:S},h,s,t,r){const e=await this.extensionGalleryService.getManifest(h,D.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=s.find(o=>(0,L.areSameExtensions)(o.identifier,h.identifier));if(n){if(h.version===n.manifest.version)return r.log((0,l.localize)(10,null,u?`${a}@${u}`:a)),null;r.log((0,l.localize)(11,null,a,h.version))}try{return S.isBuiltin?r.log(u?(0,l.localize)(12,null,a,u):(0,l.localize)(13,null,a)):r.log(u?(0,l.localize)(14,null,a,u):(0,l.localize)(15,null,a)),await this.extensionManagementService.installFromGallery(h,{...S,installGivenVersion:!!u}),r.log((0,l.localize)(16,null,a,h.version)),e}catch(o){if((0,I.isCancellationError)(o))return r.log((0,l.localize)(17,null,a)),null;throw o}}validateExtensionKind(a,u){return!0}async validateVSIX(a,u,S){const h={id:(0,L.getGalleryExtensionId)(a.publisher,a.name)},t=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,L.areSameExtensions)(h,r.identifier)&&(0,T.gt)(r.manifest.version,a.version));return t&&!u?(S.log((0,l.localize)(18,null,t.identifier.id,t.manifest.version,a.version)),!1):this.validateExtensionKind(a,S)}async uninstallExtensions(a,u,S=console){const h=async t=>{if(t instanceof v.URI){const r=await this.extensionManagementService.getManifest(t);return b(r)}return t},s=[];for(const t of a){const r=await h(t),n=(await this.extensionManagementService.getInstalled()).filter(o=>(0,L.areSameExtensions)(o.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${w}`);if(n.some(o=>o.type===0)){S.log((0,l.localize)(19,null,r));return}if(!u&&n.some(o=>o.isBuiltin)){S.log((0,l.localize)(20,null,r));return}S.log((0,l.localize)(21,null,r));for(const o of n)await this.extensionManagementService.uninstall(o),s.push(o);this.location?S.log((0,l.localize)(22,null,r,this.location)):S.log((0,l.localize)(23,null,r))}}async locateExtension(a,u=console){const S=await this.extensionManagementService.getInstalled();a.forEach(h=>{S.forEach(s=>{if(s.identifier.id===h&&s.location.scheme===R.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(a){return this.location?(0,l.localize)(24,null,a,this.location):(0,l.localize)(25,null,a)}};g=he([ae(0,m.IExtensionManagementService),ae(1,m.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(ee[43],te([0,1,18,4,21,16,7,46,73,2,14,11,10,17,34,49,8,9,82,20,24,36,41,15,12,13,27,3,50]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u,S,h,s,t,r,e,n,o,c,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var d;(function(re){function N(W,G){if(W===G)return!0;let H=Object.keys(W),ie=new Set;for(let k of Object.keys(G))ie.add(k);if(H.length!==ie.size)return!1;for(let k of H){if(W[k]!==G[k])return!1;ie.delete(k)}return ie.size===0}re.equals=N})(d=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,e.createDecorator)("IExtensionsScannerService");let E=class extends m.Disposable{constructor(N,W,G,H,ie,k,C,F){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=W,this.extensionsControlLocation=G,this.cacheLocation=H,this.fileService=ie,this.logService=k,this.environmentService=C,this.productService=F,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new Z((0,w.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new Z((0,w.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new V(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N){const[W,G]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(N)]),H=await this.scanExtensionsUnderDevelopment(N,[...W,...G]);return this.dedupExtensions([...W,...G,...H],await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const W=[];W.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),W.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[G,H]=await Promise.all(W);return this.applyScanOptions([...G,...H],N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!N.includeUninstalled,N.language);let H=await(N.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return H=await this.applyScanOptions(H,N,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(N,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const G=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(H=>H.scheme===L.Schemas.file).map(async H=>{const ie=await this.createExtensionScannerInput(H,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ie)).map(C=>(C.type=W.find(F=>(0,h.areSameExtensions)(F.identifier,C.identifier))?.type??C.type,this.extensionsScanner.validate(C,ie)))}))).flat();return this.applyScanOptions(G,N,!0)}return[]}async scanExistingExtension(N,W,G){const H=await this.createExtensionScannerInput(N,W,!0,G.language),ie=await this.extensionsScanner.scanExtension(H);return!ie||!G.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(N,W,G){const H=await this.createExtensionScannerInput(N,W,!0,G.language),ie=await this.extensionsScanner.scanOneOrMultipleExtensions(H);return this.applyScanOptions(ie,G,!0)}async updateMetadata(N,W){const G=(0,w.joinPath)(N,"package.json"),H=(await this.fileService.readFile(G)).value.toString(),ie=JSON.parse(H);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ie.__metadata={...ie.__metadata,...W},await this.fileService.writeFile((0,w.joinPath)(N,"package.json"),R.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async applyScanOptions(N,W,G){return W.includeAllVersions||(N=this.dedupExtensions(N,await this.getTargetPlatform(),G)),W.includeInvalid||(N=N.filter(H=>H.isValid)),N.sort((H,ie)=>{const k=O.basename(H.location.fsPath),C=O.basename(ie.location.fsPath);return k<C?-1:k>C?1:0})}dedupExtensions(N,W,G){const H=new Map;for(const ie of N){const k=s.ExtensionIdentifier.toKey(ie.identifier.id),C=H.get(k);if(C){if(C.isValid&&!ie.isValid)continue;if(C.isValid===ie.isValid){if(G&&b.gt(C.manifest.version,ie.manifest.version)){this.logService.debug(`Skipping extension ${ie.location.path} with lower version ${ie.manifest.version}.`);continue}if(b.eq(C.manifest.version,ie.manifest.version)&&C.targetPlatform===W){this.logService.debug(`Skipping extension ${ie.location.path} from different target platform ${ie.targetPlatform}`);continue}}C.type===0?this.logService.debug(`Overwriting system extension ${C.location.path} with ${ie.location.path}.`):this.logService.warn(`Overwriting user extension ${C.location.path} with ${ie.location.path}.`)}H.set(k,ie)}return[...H.values()]}async scanDefaultSystemExtensions(N,W){this.logService.trace("Started scanning system extensions");const G=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,W),ie=await(N&&!G.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(G);return this.logService.trace("Scanned system extensions:",ie.length),ie}async scanDevSystemExtensions(N,W){const G=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!G?.length)return[];this.logService.trace("Started scanning dev system extensions");const H=W?await this.getBuiltInExtensionControl():{},ie=[],k=a.URI.file(O.normalize(O.join(L.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions")));for(const F of G){const z=H[F.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":ie.push((0,w.joinPath)(k,F.name));break;default:ie.push(a.URI.file(z));break}}const C=await Promise.all(ie.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",C.length),(0,D.coalesce)(C)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,W,G,H,ie=!0){const k=await this.getTranslations(H??p.language);let C;try{const F=await this.fileService.stat(N);typeof F.mtime=="number"&&(C=F.mtime)}catch{}return new A(N,C,W,G,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,H,k)}};E=he([ae(4,r.IFileService),ae(5,n.ILogService),ae(6,S.IEnvironmentService),ae(7,o.IProductService)],E),i.AbstractExtensionsScannerService=E;class A{constructor(N,W,G,H,ie,k,C,F,z,q,$){this.location=N,this.mtime=W,this.type=G,this.excludeObsolete=H,this.validate=ie,this.productVersion=k,this.productDate=C,this.productCommit=F,this.devMode=z,this.language=q,this.translations=$}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,W){return(0,w.isEqual)(N.location,W.location)&&N.mtime===W.mtime&&N.type===W.type&&N.excludeObsolete===W.excludeObsolete&&N.validate===W.validate&&N.productVersion===W.productVersion&&N.productDate===W.productDate&&N.productCommit===W.productCommit&&N.devMode===W.devMode&&N.language===W.language&&d.equals(N.translations,W.translations)}}class V extends m.Disposable{constructor(N,W){super();this.fileService=N,this.logService=W}async scanExtensions(N){const W=await this.fileService.resolve(N.location);if(W.children){let G={};if(N.excludeObsolete&&N.type===1)try{const ie=(await this.fileService.readFile((0,w.joinPath)(N.location,".obsolete"))).value.toString();G=JSON.parse(ie)}catch{}const H=await Promise.all(W.children.map(async ie=>{if(!ie.isDirectory||N.type===1&&(0,w.basename)(ie.resource).indexOf(".")===0)return null;const k=new A(ie.resource,N.mtime,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations),C=await this.scanExtension(k);return C&&!G[h.ExtensionKey.create(C).toString()]?C:null}));return(0,D.coalesce)(H)}return[]}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,w.joinPath)(N.location,"package.json"))){const W=await this.scanExtension(N);return W?[W]:[]}else return await this.scanExtensions(N)}catch(W){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(N){try{let W=await this.scanExtensionManifest(N.location);if(W){W.publisher||(W.publisher=s.UNDEFINED_PUBLISHER);const G=W.__metadata;delete W.__metadata;const H=(0,h.getGalleryExtensionId)(W.publisher,W.name),ie=G?.id?{id:H,uuid:G.id}:{id:H},k=G?.isSystem?0:N.type,C=k===0||!!G?.isBuiltin;W=await this.translateManifest(N.location,W,A.createNlsConfiguration(N));const F={type:k,identifier:ie,manifest:W,location:N.location,isBuiltin:C,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return N.validate?this.validate(F,N):F}}catch(W){N.type!==0&&this.logService.error(W)}return null}validate(N,W){let G=!0;const H=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,N.manifest,N.isBuiltin);for(const[ie,k]of H)ie===g.default.Error&&(G=!1,this.logService.error(this.formatMessage(W.location,k)));return N.isValid=G,N.validations=H,N}async scanExtensionManifest(N){const W=(0,w.joinPath)(N,"package.json");let G;try{G=(await this.fileService.readFile(W)).value.toString()}catch(ie){return(0,r.toFileOperationResult)(ie)!==1&&this.logService.error(this.formatMessage(N,(0,u.localize)(0,null,W.path,ie.message))),null}let H;try{H=JSON.parse(G)}catch{const k=[];(0,v.parse)(G,k);for(const C of k)this.logService.error(this.formatMessage(N,(0,u.localize)(1,null,W.path,C.offset,C.length,(0,l.getParseErrorMessage)(C.error))));return null}return(0,v.getNodeType)(H)!=="object"?(this.logService.error(this.formatMessage(N,(0,u.localize)(2,null,W.path))),null):H}async translateManifest(N,W,G){const H=await this.getLocalizedMessages(N,W,G);if(H)try{const ie=[],k=await this.resolveOriginalMessageBundle(H.default,ie);if(ie.length>0)return ie.forEach(F=>{this.logService.error(this.formatMessage(N,(0,u.localize)(3,null,H.default?.path,(0,l.getParseErrorMessage)(F.error))))}),W;if((0,v.getNodeType)(H)!=="object")return this.logService.error(this.formatMessage(N,(0,u.localize)(4,null,H.default?.path))),W;const C=H.values||Object.create(null);this.replaceNLStrings(G.pseudo,W,C,k,N)}catch{}return W}async getLocalizedMessages(N,W,G){const H=(0,w.joinPath)(N,"package.nls.json"),ie=(z,q)=>{q.forEach($=>{this.logService.error(this.formatMessage(N,(0,u.localize)(5,null,z?.path,(0,l.getParseErrorMessage)($.error))))})},k=z=>{this.logService.error(this.formatMessage(N,(0,u.localize)(6,null,z?.path)))},C=`${W.publisher}.${W.name}`,F=G.translations[C];if(F)try{const z=a.URI.file(F),q=(await this.fileService.readFile(z)).value.toString();let $=[],se=(0,v.parse)(q,$);return $.length>0?(ie(z,$),{values:void 0,default:H}):(0,v.getNodeType)(se)!=="object"?(k(z),{values:void 0,default:H}):{values:se.contents?se.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.fileService.exists(H))return;let q;try{q=await this.findMessageBundles(N,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const $=(await this.fileService.readFile(q.localized)).value.toString();let se=[],M=(0,v.parse)($,se);return se.length>0?(ie(q.localized,se),{values:void 0,default:q.original}):(0,v.getNodeType)(M)!=="object"?(k(q.localized),{values:void 0,default:q.original}):{values:M,default:q.original}}catch{return{values:void 0,default:q.original}}}}async resolveOriginalMessageBundle(N,W){if(N)try{const G=(await this.fileService.readFile(N)).value.toString();return(0,v.parse)(G,W)}catch{return null}else return null}findMessageBundles(N,W){return new Promise((G,H)=>{const ie=k=>{let C=(0,w.joinPath)(N,`package.nls.${k}.json`);this.fileService.exists(C).then(F=>{F&&G({localized:C,original:(0,w.joinPath)(N,"package.nls.json")});let z=k.lastIndexOf("-");z===-1?G({localized:(0,w.joinPath)(N,"package.nls.json"),original:null}):(k=k.substring(0,z),ie(k))})};if(W.devMode||W.pseudo||!W.language)return G({localized:(0,w.joinPath)(N,"package.nls.json"),original:null});ie(W.language)})}replaceNLStrings(N,W,G,H,ie){const k=(C,F,z)=>{const q=C[F];if((0,y.isString)(q)){const $=q,se=$.length;if(se>1&&$[0]==="%"&&$[se-1]==="%"){const M=$.substr(1,se-2);let U=G[M];U===void 0&&H&&(U=H[M]);let j=typeof U=="string"?U:typeof U?.message=="string"?U.message:void 0;j!==void 0?(N&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C[F]=z&&(F==="title"||F==="category")&&H?{value:j,original:H[M]}:j):this.logService.warn(this.formatMessage(ie,(0,u.localize)(7,null,M)))}}else if((0,y.isObject)(q))for(let $ in q)q.hasOwnProperty($)&&($==="commands"?k(q,$,!0):k(q,$,z));else if((0,y.isArray)(q))for(let $=0;$<q.length;$++)k(q,$,z)};for(let C in W)W.hasOwnProperty(C)&&k(W,C)}formatMessage(N,W){return`[${N.path}]: ${W}`}}class Z extends V{constructor(N,W,G){super(W,G);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const W=await this.readExtensionCache();if(this.input=N,W&&W.input&&A.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(H=>(H.location=a.URI.revive(H.location),H));const G=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:G}),G}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),W=JSON.parse(N.value.toString());return{result:W.result,input:(0,f.revive)(W.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(N)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const W=N.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(G,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(H){this.logService.error(H)}}}function Y(re,N){const W=(0,h.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:W,identifier:new s.ExtensionIdentifier(W),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:N,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}i.toExtensionDescription=Y;class ne extends E{constructor(N,W,G,H,ie,k,C,F){super(N,W,(0,w.joinPath)(G,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(H,s.MANIFEST_CACHE_FOLDER),ie,k,C,F);this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const z=await this.fileService.readFile(a.URI.file(p.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}i.NativeExtensionsScannerService=ne}),define(ee[114],te([0,1,4,7,2,10,17,34,9,32,19,20,23,24,15,13]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let y=class extends P.Disposable{constructor(u,S,h,s){super();this.fileService=S,this.extensionGalleryService=h,this.logService=s,this.extensionsDownloadDir=l.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,S){await this.cleanUpPromise;const h=this.getName(u),s=(0,T.joinPath)(this.extensionsDownloadDir,h);if(!await this.fileService.exists(s)){const t=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(u,t,S);try{await this.rename(t,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(t)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,t.path),r}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,S,h){try{await L.Promises.rename(u.fsPath,S.fsPath)}catch(s){if(R.isWindows&&s&&s.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${u} to ${S} with 'EPERM' error. Trying again...`),this.rename(u,S,h);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const S=[],h=[];for(const r of u.children){const e=w.ExtensionKey.parse(r.name);e&&h.push([e,r])}const s=(0,w.groupByExtension)(h,([r])=>r),t=[];for(const r of s)r.sort((e,n)=>v.rcompare(e[0].version,n[0].version)),S.push(...r.slice(1).map(e=>e[1].resource)),t.push(r[0][1]);t.sort((r,e)=>r.mtime-e.mtime),S.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(S.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?w.ExtensionKey.create(u).toString().toLowerCase():(0,m.generateUuid)()}};y=he([ae(0,O.INativeEnvironmentService),ae(1,b.IFileService),ae(2,p.IExtensionGalleryService),ae(3,g.ILogService)],y),i.ExtensionsDownloader=y}),define(ee[115],te([0,1,2,11,19,36]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(l,m){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtensions(L=>this.onDidInstallExtensions(L))),this._register(m.onDidUninstallExtension(L=>this.onDidUnInstallExtension(L)))}onDidInstallExtensions(l){l.some(m=>!!m.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=T}),define(ee[116],te([0,1,9,20,43,15,13,27]),function(_,i,D,I,P,R,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let l=class extends P.NativeExtensionsScannerService{constructor(L,O,p,w){super(D.URI.file(p.builtinExtensionsPath),D.URI.file(p.extensionsPath),p.userHome,D.URI.file(p.userDataPath),L,O,p,w)}};l=he([ae(0,R.IFileService),ae(1,T.ILogService),ae(2,I.INativeEnvironmentService),ae(3,v.IProductService)],l),i.ExtensionsScannerService=l}),define(ee[117],te([0,1,142,18,4,2,14,11,19,20,23,24,58,13]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let b=class extends R.Disposable{constructor(a,u,S){super();this.extensionManagementService=a,this.logService=S,this.cache=this._register(new g(u,S)),this.extensionManagementService.registerParticipant({postInstall:async h=>this.postInstallExtension(h),postUninstall:async h=>this.postUninstallExtension(h)})}async getLanguageIds(){const a=await this.cache.getLanguagePacks(),u=["en",...Object.keys(a)];return(0,I.distinct)(u)}async postInstallExtension(a){a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",a.identifier.id),await this.update())}async postUninstallExtension(a){const u=await this.cache.getLanguagePacks();Object.keys(u).some(S=>u[S]&&u[S].extensions.some(h=>(0,O.areSameExtensions)(h.extensionIdentifier,a.identifier)))&&(this.logService.info("Removing language packs from the extension",a.identifier.id),await this.update())}async update(){const[a,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(u);return!(0,I.equals)(Object.keys(a),Object.keys(S))}};b=he([ae(0,L.IExtensionManagementService),ae(1,m.INativeEnvironmentService),ae(2,w.ILogService)],b),i.LocalizationsService=b;let g=class extends R.Disposable{constructor(a,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(a.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(a){return this.withLanguagePacks(u=>{Object.keys(u).forEach(S=>delete u[S]),this.createLanguagePacksFromExtensions(u,...a)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(a,...u){for(const S of u)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(a,S);Object.keys(a).forEach(S=>this.updateHash(a[S]))}createLanguagePacksFromExtension(a,u){const S=u.identifier,h=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of h)if(u.location.scheme===T.Schemas.file&&(0,p.isValidLocalization)(s)){let t=a[s.languageId];t||(t={hash:"",extensions:[],translations:{}},a[s.languageId]=t);let r=t.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,S))[0];r?r.version=u.manifest.version:t.extensions.push({extensionIdentifier:S,version:u.manifest.version});for(const e of s.translations)t.translations[e.id]=(0,v.join)(u.location.fsPath,e.path)}}updateHash(a){if(a){const u=(0,D.createHash)("md5");for(const S of a.extensions)u.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);a.hash=u.digest("hex")}}withLanguagePacks(a=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(u=a(S),S)).then(S=>{for(const s of Object.keys(S))S[s]||delete S[s];this.languagePacks=S,this.initializedCache=!0;const h=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",h),l.Promises.writeFile(this.languagePacksFilePath,h)}).then(()=>u,S=>this.logService.error(S))})}};g=he([ae(0,m.INativeEnvironmentService),ae(1,w.ILogService)],g)}),define(ee[44],te([0,1,16,89,35,12,30]),function(_,i,D,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function v(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}i.isSuccess=v;function l(g){return g.res.statusCode===204}async function m(g){return l(g)?null:(await(0,D.streamToBuffer)(g.stream)).toString()}i.asText=m;async function L(g){if(!v(g))throw new Error("Server returned "+g.res.statusCode);return m(g)}i.asTextOrError=L;async function O(g){if(!v(g))throw new Error("Server returned "+g.res.statusCode);if(l(g))return null;const a=(await(0,D.streamToBuffer)(g.stream)).toString();try{return JSON.parse(a)}catch(u){throw u.message+=`:
`+a,u}}i.asJson=O;function p(g){b(g)}i.updateProxyConfigurationsScope=p;let w;function b(g){const y=T.Registry.as(P.Extensions.Configuration),a=w;w={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[w],remove:a?[a]:[]})}b(2)}),define(ee[118],te([0,1,26,14,15,44]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let T=class{constructor(l,m){this.requestService=l,this.fileService=m}async download(l,m,L=D.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,m);return}const O={type:"GET",url:l.toString()},p=await this.requestService.request(O,L);if(p.res.statusCode===200)await this.fileService.writeFile(m,p.stream);else{const w=await(0,R.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${w}`)}}};T=he([ae(0,R.IRequestService),ae(1,P.IFileService)],T),i.DownloadService=T}),define(ee[119],te([0,1,120,8]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(T,v){return T.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:T.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(T,v,l={}){const m=(0,D.parse)(T),L=l.proxyUrl||P(m,v);if(!L)return null;const O=(0,D.parse)(L);if(!/^https?:$/.test(O.protocol||""))return null;const p={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((w,b)=>{_(["http-proxy-agent"],w,b)}))(p):new(await new Promise((w,b)=>{_(["https-proxy-agent"],w,b)}))(p)}i.getProxyAgent=R}),define(ee[121],te([0,1,40,11,90,26,28,7,10,32,75,143,4]),function(_,i,D,I,P,R,T,v,l,m,L,O,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const w=1e4;let b;async function g(a,u,S){return u["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(S)&&!u["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(S)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=p.Promises.withAsyncBody(async(h,s)=>{const t=new R.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),s(new Error((0,P.localize)(0,null)))},w);try{h(await y(a,t.token))}catch(e){!(0,v.isCancellationError)(e)&&!t.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,T.toErrorMessage)(e)))):h({})}finally{clearTimeout(r),t.dispose()}})),b)}i.getResolvedShellEnv=g;async function y(a,u){const S=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",S);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",h);const s=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",r);const e=await(0,L.getSystemShell)(l.OS,r);return a.trace("getUnixShellEnvironment#shell",e),new Promise((n,o)=>{if(u.isCancellationRequested)return o((0,v.canceled)());const c=(0,I.basename)(e);let f,d;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(f=`& '${process.execPath}' ${E} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,d=["-Login","-Command"]):(f=`'${process.execPath}' ${E} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),f);const A=(0,D.spawn)(e,[...d,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(A.kill(),o((0,v.canceled)()))),A.on("error",Y=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Y)),o(Y)});const V=[];A.stdout.on("data",Y=>V.push(Y));const Z=[];A.stderr.on("data",Y=>Z.push(Y)),A.on("close",(Y,ne)=>{const re=Buffer.concat(V).toString("utf8");a.trace("getUnixShellEnvironment#raw",re);const N=Buffer.concat(Z).toString("utf8");if(N.trim()&&a.trace("getUnixShellEnvironment#stderr",N),Y||ne)return o(new Error((0,P.localize)(2,null,Y,ne)));const W=t.exec(re),G=W?W[1]:"{}";try{const H=JSON.parse(G);S?H.ELECTRON_RUN_AS_NODE=S:delete H.ELECTRON_RUN_AS_NODE,h?H.ELECTRON_NO_ATTACH_CONSOLE=h:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",H),n(H)}catch(H){a.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),o(H)}})})}}),define(ee[122],te([0,1,4,3,2,105,8,68,12]),function(_,i,D,I,P,R,T,v,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var L;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(L=i.WillSaveStateReason||(i.WillSaveStateReason={}));var O;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(O=i.StorageScope||(i.StorageScope={}));var p;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(p=i.StorageTarget||(i.StorageTarget={}));class w extends P.Disposable{constructor(a={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=a,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,u){u===m?(a===0?this._globalKeyTargets=void 0:a===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:a})):this._onDidChangeValue.fire({scope:a,key:u,target:this.getKeyTargets(a)[u]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,u,S){return this.getStorage(u)?.get(a,S)}getBoolean(a,u,S){return this.getStorage(u)?.getBoolean(a,S)}getNumber(a,u,S){return this.getStorage(u)?.getNumber(a,S)}store(a,u,S,h){if((0,T.isUndefinedOrNull)(u)){this.remove(a,S);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,S,h),this.getStorage(S)?.set(a,u)})}remove(a,u){this.withPausedEmitters(()=>{this.updateKeyTarget(a,u,void 0),this.getStorage(u)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,u){const S=[],h=this.getKeyTargets(a);for(const s of Object.keys(h))h[s]===u&&S.push(s);return S}updateKeyTarget(a,u,S){const h=this.getKeyTargets(u);typeof S=="number"?h[a]!==S&&(h[a]=S,this.getStorage(u)?.set(m,JSON.stringify(h))):typeof h[a]=="number"&&(delete h[a],this.getStorage(u)?.set(m,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(a){return a===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(a){const u=this.get(m,a);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(a){return this.getBoolean(i.IS_NEW_KEY,a)===!0}async flush(a=L.NONE){this._onWillSaveState.fire({reason:a});const u=this.getStorage(0),S=this.getStorage(1);switch(a){case L.NONE:await D.Promises.settled([u?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([u?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve()]);break}}async logStorage(){const a=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return g(a,u,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends w{constructor(){super();this.globalStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.globalStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a)))}getStorage(a){return a===0?this.globalStorage:this.workspaceStorage}getLogDetails(a){return a===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(a){}}i.InMemoryStorageService=b;async function g(y,a,u,S){const h=c=>{try{return JSON.parse(c)}catch{return c}},s=new Map,t=new Map;y.forEach((c,f)=>{s.set(f,c),t.set(f,h(c))});const r=new Map,e=new Map;a.forEach((c,f)=>{r.set(f,c),e.set(f,h(c))}),console.group(`Storage: Global (path: ${u})`);let n=[];s.forEach((c,f)=>{n.push({key:f,value:c})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${S})`);let o=[];r.forEach((c,f)=>{o.push({key:f,value:c})}),console.table(o),console.groupEnd(),console.log(e)}i.logStorage=g}),define(ee[123],te([0,1,10,29,9,32]),function(_,i,D,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function T(m){if(D.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function v(m,L,O,p,w,b,g,y,a,u){const S=Object.create(null);S["common.machineId"]=g,S.sessionID=(0,R.generateUuid)()+Date.now(),S.commitHash=w,S.version=b,S["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,D.PlatformToString)(D.platform),S["common.nodePlatform"]=I.platform,S["common.nodeArch"]=p,S["common.product"]=u||"desktop";const h=l(y||[]);h&&(S["common.msftInternal"]=h);let s=0;const t=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),D.isLinuxSnap&&(S["common.snap"]="true");const r=T(O);r&&(S["common.platformDetail"]=r);try{const e=await m.readFile(P.URI.file(a));S["common.source"]=e.value.toString().slice(0,30)}catch{}return S}i.resolveCommonProperties=v;function l(m){const L=I.env.USERDNSDOMAIN;if(!L)return!1;const O=L.toLowerCase();return m.some(p=>O===p)}i.verifyMicrosoftInternalDomain=l}),define(ee[31],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(ee[124],te([0,1,18,4,26,7,3,2,10,9,79,23,24,13,27,31]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let y=class extends v.Disposable{constructor(t,r,e,n){super();this.galleryService=t,this.telemetryService=r,this.logService=e,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,v.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(e=>(0,O.isTargetPlatformCompatible)(e,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new O.ExtensionManagementError(L.localize(0,null),O.ExtensionManagementErrorCode.Internal);const e=await this.checkAndGetCompatibleVersion(t,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(e.manifest,e.extension,r)}catch(e){throw S(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:e}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(e),u(e)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(1,null));const r=await this.getTargetPlatform(),[e]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},P.CancellationToken.None);if(!e)throw new Error(L.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,e){if(!m.URI.isUri(r)){let d=this.installingExtensions.get(p.ExtensionKey.create(r).toString());if(d)return this.logService.info("Extensions is already requested to install",r.identifier.id),d.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],o=[],c=this.createInstallExtensionTask(t,r,e);m.URI.isUri(r)||this.installingExtensions.set(p.ExtensionKey.create(r).toString(),c),this._onInstallExtension.fire({identifier:c.identifier,source:r}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:t});let f=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const E=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,t,!!e.installOnlyNewlyAddedFromExtensionPack,!!e.installPreReleaseVersion);for(const{gallery:A,manifest:V}of E){f=f||!!V.extensionDependencies?.some(Y=>(0,p.areSameExtensions)({id:Y},c.identifier));const Z=p.ExtensionKey.create(A).toString();if(this.installingExtensions.has(Z))this.logService.info("Extension is already requested to install",A.identifier.id);else{const Y=this.createInstallExtensionTask(V,A,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(Z,Y),this._onInstallExtension.fire({identifier:Y.identifier,source:A}),this.logService.info("Installing extension:",Y.identifier.id),n.push({task:Y,manifest:V})}}}catch(E){if(m.URI.isUri(c.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,E.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,E.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),E}const d=n.reduce((E,{task:A,manifest:V})=>(E.set(A.identifier.id.toLowerCase(),{task:A,manifest:V}),E),new Map);for(;d.size;){let E;const A=[...d.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(Z=>d.has(Z.toLowerCase())));A.length?E=d.size===1?A:A.filter(({task:V})=>!(V===c&&!f)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:V})=>V.identifier.id)),E=[...d.values()]),await this.joinAllSettled(E.map(async({task:V})=>{const Z=new Date().getTime();try{const Y=await V.run();if(await this.joinAllSettled(this.participants.map(ne=>ne.postInstall(Y,V.source,e,P.CancellationToken.None))),!m.URI.isUri(V.source)){const ne=V.operation===3;if(S(this.telemetryService,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(V.source),duration:new Date().getTime()-Z,durationSinceUpdate:ne?void 0:new Date().getTime()-V.source.lastUpdated}),l.isWeb&&V.operation!==3)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}o.push({local:Y,identifier:V.identifier,operation:V.operation,source:V.source})}catch(Y){throw m.URI.isUri(V.source)||S(this.telemetryService,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(V.source),duration:new Date().getTime()-Z,error:Y}),this.logService.error("Error while installing the extension:",V.identifier.id),Y}finally{d.delete(V.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:E})=>this.logService.info("Extension installed successfully:",E.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:E})=>(0,p.areSameExtensions)(E,c.identifier))[0].local}catch(d){if(n.forEach(({task:E})=>E.cancel()),o.length)try{const E=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<E.length;A++){const V=E[A],{identifier:Z}=o[A];V.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Z.id):this.logService.warn("Rollback: Error while uninstalling extension",Z.id,(0,R.getErrorMessage)(V.reason))}}catch(E){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(E),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(n.map(({task:E})=>({identifier:E.identifier,operation:2,source:E.source}))),d}finally{for(const{task:d}of n)if(!m.URI.isUri(d.source)){const E=p.ExtensionKey.create(d.source).toString();this.installingExtensions.delete(E)||this.logService.warn("Installation task is not found in the cache",E)}}}async joinAllSettled(t){const r=[],e=[],n=await Promise.allSettled(t);for(const o of n)o.status==="fulfilled"?r.push(o.value):e.push(o.reason);if(e.length)throw a(e);return r}async getAllDepsAndPackExtensionsToInstall(t,r,e,n){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[t,...o.map(E=>E.identifier)],f=[],d=async(E,A)=>{const V=A.extensionDependencies||[],Z=[...V];if(A.extensionPack){const Y=e?o.find(ne=>(0,p.areSameExtensions)(ne.identifier,E)):void 0;for(const ne of A.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(re=>(0,p.areSameExtensions)({id:re},{id:ne}))||Z.every(re=>!(0,p.areSameExtensions)({id:re},{id:ne}))&&Z.push(ne)}if(Z.length){const Y=[...c,...f.map(re=>re.gallery.identifier)],ne=Z.filter(re=>Y.every(N=>!(0,p.areSameExtensions)(N,{id:re})));if(ne.length){const re=await this.galleryService.getExtensions(ne.map(N=>({id:N,preRelease:n})),P.CancellationToken.None);for(const N of re){if(Y.find(H=>(0,p.areSameExtensions)(H,N.identifier)))continue;const W=V.some(H=>(0,p.areSameExtensions)({id:H},N.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(N,!0,n)}catch(H){if(H instanceof O.ExtensionManagementError&&H.code===O.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw H}f.push({gallery:G.extension,manifest:G.manifest}),await d(G.extension.identifier,G.manifest)}}}};return await d(t,r),o=await this.getInstalled(),f.filter(E=>!o.some(A=>(0,p.areSameExtensions)(A.identifier,E.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r,e){const n=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(n).has(t.identifier.id))throw new O.ExtensionManagementError(L.localize(3,null,t.identifier.id),O.ExtensionManagementErrorCode.Malicious);if(!!n.unsupportedPreReleaseExtensions&&!!n.unsupportedPreReleaseExtensions[t.identifier.id])throw new O.ExtensionManagementError(L.localize(4,null,t.identifier.id,n.unsupportedPreReleaseExtensions[t.identifier.id].displayName),O.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(t)){const f=await this.getTargetPlatform();throw new O.ExtensionManagementError(L.localize(5,null,t.identifier.id,this.productService.nameLong,(0,O.TargetPlatformToString)(f)),O.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(t,r,e);if(o){if(e&&r&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new O.ExtensionManagementError(L.localize(6,null,t.identifier.id,this.productService.nameLong,this.productService.version),O.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!e&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],P.CancellationToken.None))[0]?new O.ExtensionManagementError(L.localize(7,null,t.identifier.id),O.ExtensionManagementErrorCode.ReleaseVersionNotFound):new O.ExtensionManagementError(L.localize(8,null,t.identifier.id,this.productService.nameLong,this.productService.version),O.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,P.CancellationToken.None);if(c===null)throw new O.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,O.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new O.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,O.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(t,r,e){const n=await this.getTargetPlatform();let o=null;return r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==e&&(o=(await this.galleryService.getExtensions([{...t.identifier,preRelease:e}],{targetPlatform:n,compatible:!0},P.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(t,e,n)&&(o=t),!o&&r&&(o=await this.galleryService.getCompatibleExtension(t,e,n)),o}async unininstallExtension(t,r){const e=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),e.waitUntilTaskIsFinished();const n=(d,E)=>{const A=this.createUninstallExtensionTask(d,E);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),A},o=(d,E)=>{E?this.logService.error("Failed to uninstall extension:",d.identifier.id,E.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(d),error:E}),this._onDidUninstallExtension.fire({identifier:d.identifier,error:E?.code})},c=[],f=[];try{c.push(n(t,{}));const d=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const E=this.getAllPackExtensionsToUninstall(t,d);for(const A of E)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):c.push(n(A,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(c.map(E=>E.extension),d,t),await this.joinAllSettled(c.map(async E=>{try{if(await E.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(E.extension,r,P.CancellationToken.None))),E.extension.identifier.uuid)try{await this.galleryService.reportStatistic(E.extension.manifest.publisher,E.extension.manifest.name,E.extension.manifest.version,"uninstall")}catch{}o(E.extension)}catch(A){const V=A instanceof O.ExtensionManagementError?A:new O.ExtensionManagementError((0,R.getErrorMessage)(A),O.ExtensionManagementErrorCode.Internal);throw o(E.extension,V),V}finally{f.push(E)}}))}catch(d){const E=d instanceof O.ExtensionManagementError?d:new O.ExtensionManagementError((0,R.getErrorMessage)(d),O.ExtensionManagementErrorCode.Internal);for(const A of c){try{A.cancel()}catch{}f.includes(A)||o(A.extension,E)}throw E}finally{for(const d of c)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(t,r,e){for(const n of t){const o=this.getDependents(n,r);if(o.length){const c=o.filter(f=>!t.some(d=>(0,p.areSameExtensions)(d.identifier,f.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,e))}}}getDependentsErrorMessage(t,r,e){return e===t?r.length===1?L.localize(9,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?L.localize(10,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):L.localize(11,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?L.localize(12,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?L.localize(13,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):L.localize(14,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,e=[]){if(e.indexOf(t)!==-1)return[];e.push(t);const n=t.manifest.extensionPack?t.manifest.extensionPack:[];if(n.length){const o=r.filter(f=>!f.isBuiltin&&n.some(d=>(0,p.areSameExtensions)({id:d},f.identifier))),c=[];for(const f of o)c.push(...this.getAllPackExtensionsToUninstall(f,r,e));return[...o,...c]}return[]}getDependents(t,r){return r.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(n=>(0,p.areSameExtensions)({id:n},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};y=he([ae(0,O.IExtensionGalleryService),ae(1,g.ITelemetryService),ae(2,w.ILogService),ae(3,b.IProductService)],y),i.AbstractExtensionManagementService=y;function a(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,e)=>new Error(`${r.message}${r.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}i.joinErrors=a;function u(s){if(s instanceof O.ExtensionManagementError)return s;const t=new O.ExtensionManagementError(s.message,O.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function S(s,t,{extensionData:r,duration:e,error:n,durationSinceUpdate:o}){const c=n?n instanceof O.ExtensionManagementError?n.code:O.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...r,success:!n,duration:e,errorcode:c,durationSinceUpdate:o})}i.reportTelemetry=S;class h{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>new Promise((r,e)=>{const n=t.onCancellationRequested(()=>{n.dispose(),e(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=h}),define(ee[37],te([0,1,21,48,8,22,31]),function(_,i,D,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class v{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(h,s){return Promise.resolve(void 0)}publicLog2(h,s){return this.publicLog(h,s)}publicLogError(h,s){return Promise.resolve(void 0)}publicLogError2(h,s){return this.publicLogError(h,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=v,i.NullTelemetryService=new v;class l{async publicLog(h,s,t){}async publicLogError(h,s,t){}}i.NullEndpointTelemetryService=l,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(S,h){return h.onDidChangeConfiguration(s=>{s.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:y(s.sourceConfig)})})}i.configurationTelemetry=m;function L(S,h){return!(h.disableTelemetry||!S.enableTelemetry||h.extensionTestsLocationURI)}i.supportsTelemetry=L;function O(S){const h=S.getValue(T.TELEMETRY_SETTING_ID),s=S.getValue("telemetry.enableCrashReporter");if(S.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=O;function p(S){const h=Object.create(null),s=Object.create(null),t=Object.create(null);g(S,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const e=t[r];typeof e=="number"?s[r]=e:typeof e=="boolean"?s[r]=e?1:0:typeof e=="string"?(e.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${e.length}`),h[r]=e.substring(0,8191)):typeof e!="undefined"&&e!==null&&(h[r]=e)}return{properties:h,measurements:s}}i.validateTelemetryData=p;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function b(S){if(!S)return"none";for(const h of w)if(S.startsWith(`${h}+`))return h;return"other"}i.cleanRemoteAuthority=b;function g(S,h,s=0,t){if(!!S)for(let r of Object.getOwnPropertyNames(S)){const e=S[r],n=t?t+r:r;Array.isArray(e)?h[n]=(0,D.safeStringify)(e):e instanceof Date?h[n]=e.toISOString():(0,P.isObject)(e)?s<2?g(e,h,s+1,n+"."):h[n]=(0,D.safeStringify)(e):h[n]=e}}function y(S){if(!S)return[];const h=[];return a(h,"",S),h}function a(S,h,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>a(S,h?`${h}.${t}`:t,s[t])):S.push(h)}function u(S){return[S.appRoot,S.extensionsPath,S.userHome.fsPath,S.tmpDir.fsPath,S.userDataPath]}i.getPiiPathsFromEnvironment=u}),define(ee[125],te([0,1,95,37]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(R,T,v,l,m,L){const O={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${T.nameShort})`},p=await(0,D.getServiceMachineId)(v,m,L);return(0,I.supportsTelemetry)(T,v)&&(0,I.getTelemetryLevel)(l)===3&&(O["X-Market-User-Id"]=p),O}i.resolveMarketplaceHeaders=P}),define(ee[126],te([0,1,18,26,7,21,10,29,8,9,22,20,23,24,41,15,13,27,44,125,122,31]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u,S,h,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const t=T.isWeb?"web":(0,p.getTargetPlatform)(T.platform,v.arch);var r;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function e(...M){return String(M.reduce((U,j)=>U|j,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class E{constructor(U=d){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,j=this.state.pageSize){return new E({...this.state,pageNumber:U,pageSize:j})}withFilter(U,...j){const B=[...this.state.criteria,...j.length?j.map(X=>({filterType:U,value:X})):[{filterType:U}]];return new E({...this.state,criteria:B})}withSortBy(U){return new E({...this.state,sortBy:U})}withSortOrder(U){return new E({...this.state,sortOrder:U})}withFlags(...U){return new E({...this.state,flags:U.reduce((j,B)=>j|B,0)})}withAssetTypes(...U){return new E({...this.state,assetTypes:U})}withSource(U){return new E({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:j,pageSize:B,sortBy:X,sortOrder:Q,flags:oe,assetTypes:ce}=this.state;return{filters:[{criteria:U,pageNumber:j,pageSize:B,sortBy:X,sortOrder:Q}],assetTypes:ce,flags:oe}}get searchText(){const U=this.state.criteria.filter(j=>j.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(M,U){const j=(M||[]).filter(B=>B.statisticName===U)[0];return j?j.value:0}function V(M){const U="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(B=>B.assetType.indexOf(U)===0).reduce((B,X)=>{const Q=ne(M,X.assetType);return Q&&B.push([X.assetType.substring(U.length),Q]),B},[])}function Z(M){if(M.properties){const U=M.properties.filter(X=>X.key===o.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=U.filter(X=>j.test(X.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ne(M,o.Repository)}function Y(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function ne(M,U){return M.files.filter(B=>B.assetType===U)[0]?{uri:`${M.assetUri}/${U}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${U}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function re(M,U){const j=M.properties?M.properties.filter(X=>X.key===U):[],B=j.length>0&&j[0].value;return B?B.split(",").map(X=>(0,w.adoptToGalleryExtensionId)(X)):[]}function N(M){const U=M.properties?M.properties.filter(j=>j.key===c.Engine):[];return U.length>0&&U[0].value||""}function W(M){const U=M.properties?M.properties.filter(j=>j.key===c.PreRelease):[];return U.length>0&&U[0].value==="true"}function G(M){const U=M.properties?M.properties.filter(B=>B.key===c.LocalizedLanguages):[],j=U.length>0&&U[0].value||"";return j?j.split(","):[]}function H(M){return M.indexOf("preview")!==-1}function ie(M){return M.targetPlatform?(0,p.toTargetPlatform)(M.targetPlatform):"undefined"}function k(M){const U=(0,D.distinct)(M.versions.map(ie)),j=!!M.tags?.includes(p.WEB_EXTENSION_TAG),B=U.indexOf("web");return j?B===-1&&U.push("web"):B!==-1&&U.splice(B,1),U}function C(M,U){const j=(0,p.getFallbackTargetPlarforms)(U);for(let B=0;B<M.length;B++){const X=M[B];if(X.version===M[B-1]?.version){let Q=B;const oe=ie(X);if(oe===U)for(;Q>0&&M[Q-1].version===X.version;)Q--;else if(j.includes(oe))for(;Q>0&&M[Q-1].version===X.version&&ie(M[Q-1])!==U;)Q--;Q!==B&&(M.splice(B,1),M.splice(Q,0,X))}}return M}i.sortExtensionVersions=C;function F(M,U,j){M.telemetryData={index:U,querySource:j}}function z(M,U,j){const B=M.versions[0],X={manifest:ne(U,o.Manifest),readme:ne(U,o.Details),changelog:ne(U,o.Changelog),license:ne(U,o.License),repository:Z(U),download:Y(U),icon:ne(U,o.Icon),coreTranslations:V(U)};return{identifier:{id:(0,w.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:U.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:A(M.statistics,"install"),rating:A(M.statistics,"averagerating"),ratingCount:A(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:j,assets:X,properties:{dependencies:re(U,c.Dependency),extensionPack:re(U,c.ExtensionPack),engine:N(U),localizedLanguages:G(U),targetPlatform:ie(U),isPreReleaseVersion:W(U)},hasPreReleaseVersion:W(B),hasReleaseVersion:!0,preview:H(M.flags)}}let q=class{constructor(U,j,B,X,Q,oe,ce,de){this.requestService=j,this.logService=B,this.environmentService=X,this.telemetryService=Q,this.fileService=oe,this.productService=ce,this.configurationService=de;const ve=ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,S.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,U)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,j,B){const X=I.CancellationToken.isCancellationToken(j)?{}:j,Q=I.CancellationToken.isCancellationToken(j)?j:B,oe=[],ce=[],de=[],ve=[];let le=!0;for(const ge of U){ge.uuid?ce.push(ge.uuid):oe.push(ge.id);const Ee=!!(ge.version||ge.preRelease);de.push({id:ge.id,uuid:ge.uuid,includePreRelease:Ee}),ge.version&&ve.push({id:ge.id,uuid:ge.uuid,version:ge.version}),le=le&&!!ge.hasPreRelease&&!Ee}if(!ce.length&&!oe.length)return[];let ue=new E().withPage(1,U.length);ce.length&&(ue=ue.withFilter(n.ExtensionId,...ce)),oe.length&&(ue=ue.withFilter(n.ExtensionName,...oe)),(X.queryAllVersions||le)&&(ue=ue.withFlags(ue.flags,r.IncludeVersions)),X.source&&(ue=ue.withSource(X.source));const{extensions:ye}=await this.queryGalleryExtensions(ue,{targetPlatform:X.targetPlatform??t,includePreRelease:de,versions:ve,compatible:!!X.compatible},Q);return X.source&&ye.forEach((ge,Ee)=>F(ge,Ee,X.source)),ye}async getCompatibleExtension(U,j,B){if((0,p.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(U,j,B))return U;const X=new E().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:Q}=await this.queryGalleryExtensions(X,{targetPlatform:B,compatible:!0,includePreRelease:j},I.CancellationToken.None);return Q[0]||null}async isExtensionCompatible(U,j,B){if(!(0,p.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,B)||!j&&U.properties.isPreReleaseVersion)return!1;let X=U.properties.engine;if(!X){const Q=await this.getManifest(U,I.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");X=Q.engines.vscode}return(0,b.isEngineValid)(X,this.productService.version,this.productService.date)}async isValidVersion(U,j,B,X,Q){if(!(0,p.isTargetPlatformCompatible)(ie(U),X,Q)||j!=="any"&&W(U)!==(j==="prerelease"))return!1;if(B){const oe=await this.getEngine(U);if(!(0,b.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}return!0}async query(U,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=U.text||"";const X=(0,R.getOrDefault)(U,le=>le.pageSize,50);let Q=new E().withPage(1,X);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ue,ye)=>(Q=Q.withFilter(n.Category,ye||ue),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ue,ye)=>(Q=Q.withFilter(n.Tag,ye||ue),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),Q=Q.withFilter(n.SearchText,B)),Q=Q.withSortBy(0)):U.ids?Q=Q.withFilter(n.ExtensionId,...U.ids):U.names?Q=Q.withFilter(n.ExtensionName,...U.names):Q=Q.withSortBy(4),typeof U.sortBy=="number"&&(Q=Q.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(Q=Q.withSortOrder(U.sortOrder)),U.source&&(Q=Q.withSource(U.source));const oe=async(le,ue)=>{const{extensions:ye,total:ge}=await this.queryGalleryExtensions(le,{targetPlatform:t,compatible:!1,includePreRelease:!!U.includePreRelease},ue);return ye.forEach((Ee,Fe)=>F(Ee,(le.pageNumber-1)*le.pageSize+Fe,U.source)),{extensions:ye,total:ge}},{extensions:ce,total:de}=await oe(Q,j),ve=async(le,ue)=>{if(ue.isCancellationRequested)throw new P.CancellationError;const{extensions:ye}=await oe(Q.withPage(le+1),ue);return ye};return{firstPage:ce,total:de,pageSize:Q.pageSize,getPage:ve}}async queryGalleryExtensions(U,j,B){const X=U.flags;!!(U.flags&r.IncludeLatestVersionOnly)&&!!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(U.flags&r.IncludeLatestVersionOnly)&&!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags,r.IncludeLatestVersionOnly)),j.versions?.length&&(U=U.withFlags(U.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),U=U.withFlags(U.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:Q,total:oe}=await this.queryRawGalleryExtensions(U,B);if(!(U.flags&r.IncludeLatestVersionOnly)){const le=[];for(const ue of Q){const ye=await this.toGalleryExtensionWithCriteria(ue,j);ye&&le.push(ye)}return{extensions:le,total:oe}}const de=[],ve=new Map;for(let le=0;le<Q.length;le++){const ue=Q[le],ye={id:(0,w.getGalleryExtensionId)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},ge=(0,l.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Fe=>(0,w.areSameExtensions)(Fe,ye))?.includePreRelease;if(j.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(k(ue),j.targetPlatform))continue;const Ee=await this.toGalleryExtensionWithCriteria(ue,j);!Ee||Ee.properties.isPreReleaseVersion&&(!ge||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==j.targetPlatform&&Ee.hasPreReleaseVersion?ve.set(ue.extensionId,le):de.push([le,Ee])}if(ve.size){const le=new Date().getTime(),ue=new E().withFlags(X&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,ve.size).withFilter(n.ExtensionId,...ve.keys()),{extensions:ye}=await this.queryGalleryExtensions(ue,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const ge of ye){const Ee=ve.get(ge.identifier.uuid);de.push([Ee,ge])}}return{extensions:de.sort((le,ue)=>le[0]-ue[0]).map(([,le])=>le),total:oe}}async toGalleryExtensionWithCriteria(U,j){const B={id:(0,w.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},X=j.versions?.find(de=>(0,w.areSameExtensions)(de,B))?.version,Q=(0,l.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(de=>(0,w.areSameExtensions)(de,B))?.includePreRelease,oe=k(U),ce=C(U.versions,j.targetPlatform);if(j.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(oe,j.targetPlatform))return null;for(let de=0;de<ce.length;de++){const ve=ce[de];if(!(X&&ve.version!==X)){if(await this.isValidVersion(ve,Q?"any":"release",j.compatible,oe,j.targetPlatform))return z(U,ve,oe);if(X&&ve.version===X)return null}}return X||j.compatible?null:z(U,U.versions[0],oe)}async queryRawGalleryExtensions(U,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,e(r.Unpublished));const B=await this.commonHeadersPromise,X=JSON.stringify(U.raw),Q={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},oe=new Date().getTime();let ce,de,ve=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:X,headers:Q},j),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,u.asJson)(ce);if(le){const ue=le.results[0],ye=ue.extensions,ge=ue.resultMetadata&&ue.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ve=ge&&ge.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw de=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-oe,success:!!ce&&(0,u.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:de?(0,P.isCancellationError)(de)?"canceled":(0,P.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(U,j,B,X){if(!this.isEnabled())return;const Q=T.isWeb?this.api(`/itemName/${U}.${j}/version/${B}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${j}/${B}/stats?statType=${X}`),oe=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:Q,headers:de},I.CancellationToken.None)}catch{}}async download(U,j,B){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const X=(0,w.getGalleryExtensionTelemetryData)(U),Q=new Date().getTime(),oe=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:le}),ce=B===2?"install":B===3?"update":"",de=ce?{uri:`${U.assets.download.uri}${m.URI.parse(U.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${U.assets.download.fallbackUri}${m.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:U.assets.download,ve=await this.getAsset(de);await this.fileService.writeFile(j,ve.stream),oe(new Date().getTime()-Q)}async getReadme(U,j){if(U.assets.readme){const B=await this.getAsset(U.assets.readme,{},j);return await(0,u.asTextOrError)(B)||""}return""}async getManifest(U,j){if(U.assets.manifest){const B=await this.getAsset(U.assets.manifest,{},j),X=await(0,u.asTextOrError)(B);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(U,j){const B=ne(U,o.Manifest);if(!B)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(B,{headers:X});return await(0,u.asJson)(Q)}async getCoreTranslation(U,j){const B=U.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(B){const X=await this.getAsset(B[1]),Q=await(0,u.asTextOrError)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(U,j){if(U.assets.changelog){const B=await this.getAsset(U.assets.changelog,{},j);return await(0,u.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(U,j,B){let X=new E().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?X=X.withFilter(n.ExtensionId,U.identifier.uuid):X=X.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:Q}=await this.queryRawGalleryExtensions(X,I.CancellationToken.None);if(!Q.length)return[];const oe=k(Q[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(oe,B))return[];const ce=[];await Promise.all(Q[0].versions.map(async le=>{try{await this.isValidVersion(le,j?"any":"release",!0,oe,B)&&ce.push(le)}catch{}}));const de=[],ve=new Set;for(const le of C(ce,B))ve.has(le.version)||(ve.add(le.version),de.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:W(le)}));return de}async getAsset(U,j={},B=I.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},oe={...X,...j.headers||{}};j={...j,...Q,headers:oe};const ce=U.uri,de=U.fallbackUri,ve={...j,url:ce};try{const le=await this.requestService.request(ve,B);if(le.res.statusCode===200)return le;const ue=await(0,u.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ue}`)}catch(le){if((0,P.isCancellationError)(le))throw le;const ue=(0,P.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:ue});const ye={...j,url:de};return this.requestService.request(ye,B)}}async getEngine(U){let j=N(U);if(!j){const B=await this.getManifestFromRawExtensionVersion(U,I.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,u.asJson)(U),B=[],X={};if(j){for(const Q of j.malicious)B.push({id:Q});if(j.unsupported)for(const Q of Object.keys(j.unsupported)){const oe=j.unsupported[Q];(0,l.isBoolean)(oe)||(X[Q.toLowerCase()]=oe.preReleaseExtension)}if(j.migrateToPreRelease)for(const[Q,oe]of Object.entries(j.migrateToPreRelease))(!oe.engine||(0,b.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(X[Q.toLowerCase()]=oe)}return{malicious:B,unsupportedPreReleaseExtensions:X}}};q=he([ae(1,u.IRequestService),ae(2,y.ILogService),ae(3,O.IEnvironmentService),ae(4,s.ITelemetryService),ae(5,g.IFileService),ae(6,a.IProductService),ae(7,L.IConfigurationService)],q);let $=class extends q{constructor(U,j,B,X,Q,oe,ce,de){super(U,j,B,X,Q,oe,ce,de)}};$=he([ae(0,h.IStorageService),ae(1,u.IRequestService),ae(2,y.ILogService),ae(3,O.IEnvironmentService),ae(4,s.ITelemetryService),ae(5,g.IFileService),ae(6,a.IProductService),ae(7,L.IConfigurationService)],$),i.ExtensionGalleryService=$;let se=class extends q{constructor(U,j,B,X,Q,oe,ce){super(void 0,U,j,B,X,Q,oe,ce)}};se=he([ae(0,u.IRequestService),ae(1,y.ILogService),ae(2,O.IEnvironmentService),ae(3,s.ITelemetryService),ae(4,g.IFileService),ae(5,a.IProductService),ae(6,L.IConfigurationService)],se),i.ExtensionGalleryServiceWithNoStorageService=se}),define(ee[127],te([0,1,2,21,48,10,25,91,22,35,128,27,30,31,37]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let g=class{constructor(u,S,h){this._configurationService=S,this._productService=h,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,S){this._experimentProperties[u]=S}_updateTelemetryLevel(){let u=(0,b.getTelemetryLevel)(this._configurationService);const S=this._productService.enabledTelemetryLevels;if(S){this._sendErrorTelemetry=this.sendErrorTelemetry?S.error:!1;const h=S.usage?3:S.error?2:0;u=Math.min(u,h)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties;let S=u.sessionID,h=u["common.machineId"],s=u["common.firstSessionDate"],t=u["common.msftInternal"];return{sessionId:S,machineId:h,firstSessionDate:s,msftInternal:t}}dispose(){this._disposables.dispose()}_log(u,S,h,s){return this.telemetryLevel.value<S?Promise.resolve(void 0):this._commonProperties.then(t=>{h=(0,I.mixin)(h,t),h=(0,I.mixin)(h,this._experimentProperties),h=(0,I.cloneAndChange)(h,r=>{if(typeof r=="string")return this._cleanupInfo(r,s)}),this._appenders.forEach(r=>r.log(u,h))},t=>{console.error(t)})}publicLog(u,S,h){return this._log(u,3,S,h)}publicLog2(u,S,h){return this.publicLog(u,S,h)}publicLogError(u,S){return this._sendErrorTelemetry?this._log(u,2,S,!0):Promise.resolve(void 0)}publicLogError2(u,S){return this.publicLogError(u,S)}_anonymizeFilePaths(u){let S=u;const h=[];for(let e of this._cleanupPatterns)for(;;){const n=e.exec(u);if(!n)break;h.push([n.index,e.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(S="";;){const e=t.exec(u);if(!e)break;!s.test(e[0])&&h.every(([n,o])=>e.index<n||e.index>=o)&&(S+=u.substring(r,e.index)+"<REDACTED: user-file-path>",r=t.lastIndex)}return r<u.length&&(S+=u.substr(r)),S}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const S=u.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of h)if(s.regex.test(S))return`<REDACTED: ${s.label}`;return u}_cleanupInfo(u,S){let h=u;S&&(h=this._anonymizeFilePaths(h));for(let s of this._cleanupPatterns)h=h.replace(s,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=he([ae(1,l.IConfigurationService),ae(2,O.IProductService)],g),i.TelemetryService=g;function y(){const a=(0,v.localize)(0,null,L.default.nameLong),u=L.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",L.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=R.isWeb?"":(0,v.localize)(3,null),h=(0,v.localize)(4,null),s=(0,v.localize)(5,null),t=(0,v.localize)(6,null),r=(0,v.localize)(7,null),e=`
|       | ${h} | ${s} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,v.localize)(8,null);return`
${a} ${u} ${S}

&nbsp;

${r}
${e}

&nbsp;

${n}
`}p.Registry.as(m.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(m.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:L.default.privacyStatementUrl?(0,v.localize)(16,null,L.default.nameLong,L.default.privacyStatementUrl):(0,v.localize)(15,null,L.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[129],te([0,1,7,21,37]),function(_,i,D,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(v){const l=await new Promise((L,O)=>{_(["applicationinsights"],L,O)});let m;return l.defaultClient?(m=new l.TelemetryClient(v),m.channel.setUseDiskRetryCaching(!0)):(l.setup(v).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),m=l.defaultClient),v.indexOf("AIF-")===0&&(m.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),m}class T{constructor(l,m,L){this._eventPrefix=l,this._defaultData=m,this._defaultData||(this._defaultData=Object.create(null)),typeof L=="function"?this._aiClient=L():this._aiClient=L,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(m=>{l(m)},m=>{(0,D.onUnexpectedError)(m),console.error(m)})}}log(l,m){if(!!this._aiClient){m=(0,I.mixin)(m,this._defaultData),m=(0,P.validateTelemetryData)(m);try{this._withAIClient(L=>L.trackEvent({name:this._eventPrefix+"/"+l,properties:m.properties,measurements:m.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(m=>{try{m.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=T}),define(ee[130],te([0,1,11,19]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(R,T){const v=Object.create(null),l=(L,O)=>{const p=JSON.parse(L);v[O]=p};if(T){const L=[],O=await I.Promises.readdir(T);for(const w of O)try{(await I.Promises.stat((0,D.join)(T,w))).isDirectory()&&L.push(w)}catch{}const p=[];for(const w of L)(await I.Promises.readdir((0,D.join)(T,w))).filter(g=>g==="telemetry.json").length===1&&p.push(w);for(const w of p){const b=(await I.Promises.readFile((0,D.join)(T,w,"telemetry.json"))).toString();l(b,w)}}let m=(await I.Promises.readFile((0,D.join)(R,"telemetry-core.json"))).toString();return l(m,"vscode-core"),m=(await I.Promises.readFile((0,D.join)(R,"telemetry-extensions.json"))).toString(),l(m,"vscode-extensions"),JSON.stringify(v,null,4)}i.buildTelemetryMessage=P}),define(ee[38],te([0,1,12]),function(_,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ee[131],te([0,1,3,2,9,20,24,15,13,38]),function(_,i,D,I,P,R,T,v,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let L=class extends I.Disposable{constructor(p,w,b,g,y){super();this.extensionsManagementService=p,this.logService=g,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(u=>this.onInstallExtension(u))),this._register(p.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(p.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const a=P.URI.file(b.extensionsPath);this._register(w.watch(a)),this._register(D.Event.filter(w.onDidFilesChange,u=>u.rawChanges.some(S=>this.doesChangeAffects(S,a)))(()=>this.onDidChange()))}doesChangeAffects(p,w){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),w)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const w of p)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(w=>!(0,T.areSameExtensions)(w,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,T.areSameExtensions)(w,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),w=p.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,T.areSameExtensions)(y,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),b=this.installedExtensions.filter(g=>this.installingExtensions.some(y=>(0,T.areSameExtensions)(y,g))?!1:p.every(y=>!(0,T.areSameExtensions)(y.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=p.map(g=>g.identifier),(w.length||b.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:b})}}};L=he([ae(1,v.IFileService),ae(2,R.INativeEnvironmentService),ae(3,l.ILogService),ae(4,m.IUriIdentityService)],L),i.ExtensionsWatcher=L}),define(ee[132],te([0,1,38,96,15,17,62,3,2]),function(_,i,D,I,P,R,T,v,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class m{constructor(p){this.uri=p,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let L=class{constructor(p){this._fileService=p,this._dispooables=new l.DisposableStore,this._limit=2**16;const w=new Map,b=g=>{let y=w.get(g.scheme);return y===void 0&&(y=p.hasProvider(g)&&!this._fileService.hasCapability(g,1024),w.set(g.scheme,y)),y};this._dispooables.add(v.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new R.ExtUri(b),this._canonicalUris=new T.SkipList((g,y)=>this.extUri.compare(g,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,R.normalizePath)(p));let w=this._canonicalUris.get(p);return w?w.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new m(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((b,g)=>b[1].touch<g[1].touch?1:b[1].touch>g[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let b=0;b<w;b++)this._canonicalUris.set(p[b][0],p[b][1].touch())}};L=he([ae(0,P.IFileService)],L),i.UriIdentityService=L,(0,I.registerSingleton)(D.IUriIdentityService,L,!0)}),define(ee[60],te([0,1,107,4,11,8,19,77,144,145]),function(_,i,D,I,P,R,T,v,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class L extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=L;function O(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function p(s){if(s instanceof L)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new L(t,s)}function w(s,t,r,e,n,o){const c=P.dirname(t),f=P.join(e,c);if(!f.startsWith(e))return Promise.reject(new Error(v.localize(0,null,t)));const d=P.join(e,t);let E;return o.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(T.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((A,V)=>{if(!o.isCancellationRequested)try{E=(0,D.createWriteStream)(d,{mode:r}),E.once("close",()=>A()),E.once("error",V),s.once("error",V),s.pipe(E)}catch(Z){V(Z)}}))}function b(s,t,r,e){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((c,f)=>{const d=new I.Sequencer,E=A=>{A.isCancellationRequested||(o++,s.readEntry())};s.once("error",f),s.once("close",()=>n.then(()=>{e.isCancellationRequested||s.entryCount===o?c():f(new L("Incomplete",new Error(v.localize(1,null,o,s.entryCount))))},f)),s.readEntry(),s.on("entry",A=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){E(e);return}const V=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(V)){const ne=P.join(t,V);n=(0,I.createCancelablePromise)(re=>T.Promises.mkdir(ne,{recursive:!0}).then(()=>E(re)).then(void 0,f));return}const Z=y(s,A),Y=O(A);n=(0,I.createCancelablePromise)(ne=>d.queue(()=>Z.then(re=>w(re,V,Y,t,r,ne).then(()=>E(ne)))).then(null,f))})})}function g(s,t=!1){return new Promise((r,e)=>{(0,l.open)(s,t?{lazyEntries:!0}:void 0,(n,o)=>{n?e(p(n)):r((0,R.assertIsDefined)(o))})})}function y(s,t){return new Promise((r,e)=>{s.openReadStream(t,(n,o)=>{n?e(p(n)):r((0,R.assertIsDefined)(o))})})}function a(s,t){return new Promise((r,e)=>{const n=new m.ZipFile;t.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>r(s))})}i.zip=a;function u(s,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=g(s,!0);return r.overwrite&&(o=o.then(c=>T.Promises.rm(t).then(()=>c))),o.then(c=>b(c,t,{sourcePathRegex:n},e))}i.extract=u;function S(s,t){return g(s).then(r=>new Promise((e,n)=>{r.on("entry",o=>{o.fileName===t&&y(r,o).then(c=>e(c),c=>n(c))}),r.once("close",()=>n(new Error(v.localize(2,null,t))))}))}function h(s,t){return S(s,t).then(r=>new Promise((e,n)=>{const o=[];r.once("error",n),r.on("data",c=>o.push(c)),r.on("end",()=>e(Buffer.concat(o)))}))}i.buffer=h}),define(ee[133],te([0,1,60,84]),function(_,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(R){return(0,D.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=P}),define(ee[134],te([0,1,4,28,7,2,14,11,10,17,34,8,9,32,19,60,83,54,20,124,23,24,43,114,102,133,115,131,41,15,12,13,27,31,38]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u,S,h,s,t,r,e,n,o,c,f,d,E,A,V,Z,Y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let ne=class extends S.AbstractExtensionManagementService{constructor(k,C,F,z,q,$,se,M,U){super(k,C,F,M);this.environmentService=z,this.downloadService=q,this.fileService=se;const j=this._register($.createInstance(e.ExtensionsLifecycle));this.extensionsScanner=this._register($.createInstance(re,X=>j.postUninstall(X))),this.manifestCache=this._register(new o.ExtensionsManifestCache(z,this)),this.extensionsDownloader=this._register($.createInstance(r.ExtensionsDownloader));const B=this._register(new c.ExtensionsWatcher(this,se,z,F,U));this._register(B.onDidChangeExtensionsByAnotherSource(({added:X,removed:Q})=>{X.length&&this._onDidInstallExtensions.fire(X.map(oe=>({identifier:oe.identifier,operation:1,local:oe}))),Q.forEach(oe=>this._onDidUninstallExtension.fire({identifier:oe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(k){this.logService.trace("ExtensionManagementService#zip",k.identifier.id);const C=await this.collectFiles(k),F=await(0,g.zip)((0,m.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)()).fsPath,C);return p.URI.file(F)}async unzip(k){return this.logService.trace("ExtensionManagementService#unzip",k.toString()),(await this.install(k)).identifier}async getManifest(k){const C=await this.downloadVsix(k),F=v.resolve(C.fsPath);return(0,n.getManifest)(F)}getInstalled(k=null){return this.extensionsScanner.scanExtensions(k)}async install(k,C={}){this.logService.trace("ExtensionManagementService#install",k.toString());const F=await this.downloadVsix(k),z=await(0,n.getManifest)(v.resolve(F.fsPath));if(z.engines&&z.engines.vscode&&!(0,f.isEngineValid)(z.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(z.publisher,z.name),this.productService.version));return this.installExtension(z,F,C)}async updateMetadata(k,C){this.logService.trace("ExtensionManagementService#updateMetadata",k.identifier.id);const F={...C};return C.isPreReleaseVersion&&(F.preRelease=!0),k=await this.extensionsScanner.updateMetadata(k,F),this.manifestCache.invalidate(),k}async updateExtensionScope(k,C){return this.logService.trace("ExtensionManagementService#updateExtensionScope",k.identifier.id),k=await this.extensionsScanner.updateMetadata(k,{isMachineScoped:C}),this.manifestCache.invalidate(),k}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(k){if(k.scheme===T.Schemas.file)return k;const C=(0,m.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)());return await this.downloadService.download(k,C),C}createInstallExtensionTask(k,C,F){return p.URI.isUri(C)?new G(k,C,F,this.galleryService,this.extensionsScanner,this.logService):new W(C,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(k,C){return new H(k,C,this.extensionsScanner)}async collectFiles(k){const C=async z=>{let q=await b.Promises.readdir(z);q=q.map(M=>v.join(z,M));const $=await Promise.all(q.map(M=>b.Promises.stat(M)));let se=Promise.resolve([]);return $.forEach((M,U)=>{const j=q[U];M.isFile()&&(se=se.then(B=>[...B,j])),M.isDirectory()&&(se=se.then(B=>C(j).then(X=>[...B,...X])))}),se};return(await C(k.location.fsPath)).map(z=>({path:`extension/${v.relative(k.location.fsPath,z)}`,localPath:z}))}};ne=he([ae(0,h.IExtensionGalleryService),ae(1,Z.ITelemetryService),ae(2,A.ILogService),ae(3,u.INativeEnvironmentService),ae(4,a.IDownloadService),ae(5,E.IInstantiationService),ae(6,d.IFileService),ae(7,V.IProductService),ae(8,Y.IUriIdentityService)],ne),i.ExtensionManagementService=ne;let re=class extends R.Disposable{constructor(k,C,F,z){super();this.beforeRemovingExtension=k,this.fileService=C,this.extensionsScannerService=F,this.logService=z,this.uninstalledPath=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const C={includeInvalid:!0};let F=[];return k===null||k===0?F.push(...await this.extensionsScannerService.scanAllExtensions(C)):k===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(C)),F=k!==null?F.filter(z=>z.type===k):F,Promise.all(F.map(z=>this.toLocalExtension(z)))}async scanUserExtensions(k){const C=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!k,includeInvalid:!0});return Promise.all(C.map(F=>this.toLocalExtension(F)))}async extractUserExtension(k,C,F,z){const q=k.toString(),$=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),se=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await b.Promises.rm(se)}catch{throw new h.ExtensionManagementError(y.localize(1,null,se,k.id),h.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(k,C,$,z),await this.extensionsScannerService.updateMetadata(p.URI.file($),{...F,installedTimestamp:Date.now()});try{await this.rename(k,$,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(M){try{await b.Promises.rm($)}catch{}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(M)}. Deleted from extracted location`,$),M}return this.scanLocalExtension(p.URI.file(se),1)}async updateMetadata(k,C){return await this.extensionsScannerService.updateMetadata(k.location,C),this.scanLocalExtension(k.location,k.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const C=k.map(F=>s.ExtensionKey.create(F));await this.withUninstalledExtensions(F=>{C.forEach(z=>F[z.toString()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(z=>delete z[k.toString()]);const F=(await this.scanUserExtensions(!0)).find(z=>s.ExtensionKey.create(z).equals(k))||null;return F?this.updateMetadata(F,{installedTimestamp:Date.now()}):null}async removeExtension(k,C){this.logService.trace(`Deleting ${C} extension from disk`,k.identifier.id,k.location.fsPath),await b.Promises.rm(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[s.ExtensionKey.create(k).toString()])}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(z){if(z.code!=="ENOENT")throw z}let F={};if(C)try{F=JSON.parse(C)}catch{}return k&&(k(F),Object.keys(F).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await b.Promises.rm(this.uninstalledPath)),F})}async extractAtLocation(k,C,F,z){this.logService.trace(`Started extracting the extension from ${C} to ${F}`);try{await b.Promises.rm(F)}catch(q){throw new h.ExtensionManagementError(this.joinErrors(q).message,h.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(C,F,{sourcePath:"extension",overwrite:!0},z),this.logService.info(`Extracted extension to ${F}:`,k.id)}catch(q){try{await b.Promises.rm(F)}catch{}let $=h.ExtensionManagementErrorCode.Extract;throw q instanceof g.ExtractError&&(q.type==="CorruptZip"?$=h.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&($=h.ExtensionManagementErrorCode.IncompleteZip)),new h.ExtensionManagementError(q.message,$)}}async rename(k,C,F,z){try{await b.Promises.rename(C,F)}catch(q){if(l.isWindows&&q&&q.code==="EPERM"&&Date.now()<z)return this.logService.info(`Failed renaming ${C} to ${F} with 'EPERM' error. Trying again...`,k.id),this.rename(k,C,F,z);throw new h.ExtensionManagementError(q.message||y.localize(2,null,C,F),q.code||h.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(k,C){const F=await this.extensionsScannerService.scanExistingExtension(k,C,{includeInvalid:!0});if(F)return this.toLocalExtension(F);throw new Error(y.localize(3,null,k.path))}async toLocalExtension(k){const C=await this.fileService.resolve(k.location);let F,z;return C.children&&(F=C.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,z=C.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:k.identifier,type:k.type,isBuiltin:k.isBuiltin||!!k.metadata?.isBuiltin,location:k.location,manifest:k.manifest,targetPlatform:k.targetPlatform,validations:k.validations,isValid:k.isValid,readmeUrl:F,changelogUrl:z,publisherDisplayName:k.metadata?.publisherDisplayName||null,publisherId:k.metadata?.publisherId||null,isMachineScoped:!!k.metadata?.isMachineScoped,isPreReleaseVersion:!!k.metadata?.isPreReleaseVersion,preRelease:!!k.metadata?.preRelease,installedTimestamp:k.metadata?.installedTimestamp,updated:!!k.metadata?.updated}}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),C=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const $ of C)k[s.ExtensionKey.create($).toString()]||F.add($.identifier.id.toLowerCase());const z=(0,s.groupByExtension)(C,$=>$.identifier);await D.Promises.settled(z.map(async $=>{const se=$.sort((M,U)=>L.rcompare(M.manifest.version,U.manifest.version))[0];F.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(se))}));const q=C.filter($=>k[s.ExtensionKey.create($).toString()]);await D.Promises.settled(q.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=[],F=await this.extensionsScannerService.getTargetPlatform(),z=(0,s.groupByExtension)(k,q=>q.identifier);C.push(...z.map(q=>q.sort(($,se)=>{const M=L.rcompare($.manifest.version,se.manifest.version);return M!==0?M:$.targetPlatform===F?-1:1}).slice(1)).flat()),await D.Promises.settled(C.map(q=>this.removeExtension(q,"outdated")))}joinErrors(k){const C=Array.isArray(k)?k:[k];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((F,z)=>new Error(`${F.message}${F.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}};re=he([ae(1,d.IFileService),ae(2,t.IExtensionsScannerService),ae(3,A.ILogService)],re);class N extends S.AbstractExtensionTask{constructor(k,C,F,z,q){super();this.identifier=k,this.source=C,this.options=F,this.extensionsScanner=z,this.logService=q,this._operation=2}get operation(){return(0,O.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(k,C){try{const F=await this.unsetUninstalledAndGetLocal(k.key);if(F)return k.metadata?this.extensionsScanner.updateMetadata(F,k.metadata):F}catch{throw l.isMacintosh?new h.ExtensionManagementError(y.localize(4,null),h.ExtensionManagementErrorCode.Internal):new h.ExtensionManagementError(y.localize(5,null),h.ExtensionManagementErrorCode.Internal)}return this.extract(k,C)}async unsetUninstalledAndGetLocal(k){if(!await this.isUninstalled(k))return null;this.logService.trace("Removing the extension from uninstalled list:",k.id);const F=await this.extensionsScanner.setInstalled(k);return this.logService.info("Removed the extension from uninstalled list:",k.id),F}async isUninstalled(k){return!!(await this.extensionsScanner.getUninstalledExtensions())[k.toString()]}async extract({zipPath:k,key:C,metadata:F},z){let q=await this.extensionsScanner.extractUserExtension(C,k,F,z);return this.logService.info("Extracting completed.",C.id),q}}class W extends N{constructor(k,C,F,z,q){super(k.identifier,k,C,z,q);this.gallery=k,this.extensionsDownloader=F}async doRun(k){const F=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,s.areSameExtensions)(q.identifier,this.gallery.identifier));F&&(this._operation=3);const z=await this.downloadInstallableExtension(this.gallery,this._operation);z.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,z.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin,z.metadata.isSystem=F?.type===0?!0:void 0,z.metadata.updated=!!F,z.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,z.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,O.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:F?.preRelease);try{const q=await this.installExtension(z,k);return F&&(F.targetPlatform!==q.targetPlatform||L.neq(F.manifest.version,q.manifest.version))&&await this.extensionsScanner.setUninstalled(F),q}catch(q){throw await this.deleteDownloadedVSIX(z.zipPath),q}}async deleteDownloadedVSIX(k){try{await this.extensionsDownloader.delete(p.URI.file(k))}catch(C){this.logService.warn("Error while deleting the downloaded vsix",k.toString(),(0,P.getErrorMessage)(C))}}async downloadInstallableExtension(k,C){const F={id:k.identifier.uuid,publisherId:k.publisherId,publisherDisplayName:k.publisherDisplayName,targetPlatform:k.properties.targetPlatform};let z;try{this.logService.trace("Started downloading extension:",k.identifier.id),z=(await this.extensionsDownloader.downloadExtension(k,C)).fsPath,this.logService.info("Downloaded extension:",k.identifier.id,z)}catch(q){throw new h.ExtensionManagementError((0,S.joinErrors)(q).message,h.ExtensionManagementErrorCode.Download)}try{return await(0,n.getManifest)(z),{zipPath:z,key:s.ExtensionKey.create(k),metadata:F}}catch(q){throw await this.deleteDownloadedVSIX(z),new h.ExtensionManagementError((0,S.joinErrors)(q).message,h.ExtensionManagementErrorCode.Invalid)}}}class G extends N{constructor(k,C,F,z,q,$){super({id:(0,s.getGalleryExtensionId)(k.publisher,k.name)},C,F,q,$);this.manifest=k,this.location=C,this.galleryService=z}async doRun(k){const C=new s.ExtensionKey(this.identifier,this.manifest.version),z=(await this.extensionsScanner.scanExtensions(1)).find($=>(0,s.areSameExtensions)(this.identifier,$.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,k);if(q.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||z?.isBuiltin,z)if(this._operation=3,C.equals(new s.ExtensionKey(z.identifier,z.manifest.version)))try{await this.extensionsScanner.removeExtension(z,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else L.gt(z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(z);else{const $=await this.unsetUninstalledAndGetLocal(C);if($)try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:v.resolve(this.location.fsPath),key:C,metadata:q},k)}async getMetadata(k,C,F){try{let[z]=await this.galleryService.getExtensions([{id:k,version:C}],F);if(z||([z]=await this.galleryService.getExtensions([{id:k}],F)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class H extends S.AbstractExtensionTask{constructor(k,C,F){super();this.extension=k,this.options=C,this.extensionsScanner=F}async doRun(k){const C=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const z=s.ExtensionKey.create(this.extension);C.push(...F.filter(q=>z.equals(s.ExtensionKey.create(q))))}else C.push(...F.filter(z=>(0,s.areSameExtensions)(z.identifier,this.extension.identifier)));if(!C.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...C),this.options.remove)for(const z of C)try{k.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(z)}catch(q){throw new Error(y.localize(9,null,(0,I.toErrorMessage)(q)))}}}}),define(ee[135],te([0,1,120,4,16,7,2,8,22,20,121,13,119,146]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let b=class extends T.Disposable{constructor(y,a,u){super();this.environmentService=a,this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,a){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:u,strictSSL:S}=this;let h;try{h=await(0,L.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...h},t=y.agent?y.agent:await(0,p.getProxyAgent)(y.url||"",s,{proxyUrl:u,strictSSL:S});y.agent=t,y.strictSSL=S,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(y,a);return this.logService.trace("RequestService#request (node) - success",y.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",y.url,r),r}}async getNodeRequest(y){return((0,D.parse)(y.url).protocol==="https:"?await new Promise((S,h)=>{_(["https"],S,h)}):await new Promise((S,h)=>{_(["http"],S,h)})).request}_request(y,a){return I.Promises.withAsyncBody(async(u,S)=>{let h;const s=(0,D.parse)(y.url),t=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),r={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,v.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(r.auth=y.user+":"+y.password),h=t(r,e=>{const n=(0,v.isNumber)(y.followRedirects)?y.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...y,url:e.headers.location,followRedirects:n-1},a).then(u,S);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,w.createGunzip)())),u({res:e,stream:(0,P.streamToBufferReadableStream)(o)})}}),h.on("error",S),y.timeout&&h.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&h.write(y.data),h.end(),a.onCancellationRequested(()=>{h.abort(),S((0,R.canceled)())})})}async resolveProxy(y){}};b=he([ae(0,l.IConfigurationService),ae(1,m.INativeEnvironmentService),ae(2,O.ILogService)],b),i.RequestService=b}),define(ee[147],te([0,1,33,4,16,28,7,2,14,11,29,17,9,19,22,111,54,118,20,94,126,23,113,43,134,116,15,104,106,42,101,57,58,117,13,108,128,27,44,135,123,31,127,37,129,130,38,132]),function(_,i,D,I,P,R,T,v,l,m,L,O,p,w,b,g,y,a,u,S,h,s,t,r,e,n,o,c,f,d,E,A,V,Z,Y,ne,re,N,W,G,H,ie,k,C,F,z,q,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class se extends v.Disposable{constructor(j){super();this.argv=j,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[j,B]=await this.initServices();return j.invokeFunction(async X=>{const Q=X.get(Y.ILogService),oe=X.get(o.IFileService),ce=X.get(u.INativeEnvironmentService),de=X.get(s.IExtensionManagementCLIService);Q.info("CLI main",this.argv),this.registerErrorHandler(Q),await this.doRun(ce,de,oe),await Promise.all(B.map(ve=>{(0,I.raceTimeout)(ve.flush(),1e3)}))})}async initServices(){const j=new A.ServiceCollection,B={_serviceBrand:void 0,...re.default};j.set(N.IProductService,B);const X=new S.NativeEnvironmentService(this.argv,B);j.set(u.INativeEnvironmentService,X),await Promise.all([X.appSettingsHome.fsPath,X.extensionsPath].map(ye=>ye?w.Promises.mkdir(ye,{recursive:!0}):void 0));const Q=(0,Y.getLogLevel)(X),oe=[];oe.push(new ne.SpdLogLogger("cli",(0,m.join)(X.logsPath,"cli.log"),!0,!1,Q)),Q===Y.LogLevel.Trace&&oe.push(new Y.ConsoleLogger(Q));const ce=this._register(new Y.MultiplexLogService(oe));j.set(Y.ILogService,ce);const de=this._register(new c.FileService(ce));j.set(o.IFileService,de);const ve=this._register(new f.DiskFileSystemProvider(ce));de.registerProvider(l.Schemas.file,ve);const le=this._register(new g.ConfigurationService(X.settingsResource,de));j.set(b.IConfigurationService,le),await le.initialize(),j.set(q.IUriIdentityService,new $.UriIdentityService(de)),j.set(W.IRequestService,new d.SyncDescriptor(G.RequestService)),j.set(y.IDownloadService,new d.SyncDescriptor(a.DownloadService)),j.set(r.IExtensionsScannerService,new d.SyncDescriptor(n.ExtensionsScannerService)),j.set(s.IExtensionManagementService,new d.SyncDescriptor(e.ExtensionManagementService)),j.set(s.IExtensionGalleryService,new d.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService)),j.set(s.IExtensionManagementCLIService,new d.SyncDescriptor(t.ExtensionManagementCLIService)),j.set(V.ILocalizationsService,new d.SyncDescriptor(Z.LocalizationsService));const ue=[];if((0,C.supportsTelemetry)(B,X)){B.aiConfig&&B.aiConfig.asimovKey&&ue.push(new F.AppInsightsAppender("monacoworkbench",null,B.aiConfig.asimovKey));const{installSourcePath:ye}=X,ge={appenders:ue,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ee;try{const Fe=await w.Promises.readFile((0,O.joinPath)(X.globalStorageHome,"storage.json").fsPath);Ee=JSON.parse(Fe.toString())[ie.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&ce.error(Fe)}return(0,H.resolveCommonProperties)(de,(0,D.release)(),(0,D.hostname)(),process.arch,B.commit,B.version,Ee,B.msftInternalDomains,ye)})(),piiPaths:(0,C.getPiiPathsFromEnvironment)(X)};j.set(ie.ITelemetryService,new d.SyncDescriptor(k.TelemetryService,[ge]))}else j.set(ie.ITelemetryService,C.NullTelemetryService);return[new E.InstantiationService(j),ue]}registerErrorHandler(j){(0,T.setUnexpectedErrorHandler)(B=>{const X=(0,R.toErrorMessage)(B,!0);!X||j.error(`[uncaught exception in CLI]: ${X}`)}),process.on("uncaughtException",B=>(0,T.onUnexpectedError)(B)),process.on("unhandledRejection",B=>(0,T.onUnexpectedError)(B))}async doRun(j,B,X){if(this.argv["install-source"])return this.setInstallSource(j,X,this.argv["install-source"]);if(this.argv["list-extensions"])return B.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Q={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return B.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Q,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return B.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return B.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,z.buildTelemetryMessage)(j.appRoot,j.extensionsPath))}}asExtensionIdOrVSIX(j){return j.map(B=>/\.vsix$/i.test(B)?p.URI.file((0,m.isAbsolute)(B)?B:(0,m.join)((0,L.cwd)(),B)):B)}async setInstallSource(j,B,X){await B.writeFile(p.URI.file(j.installSourcePath),P.VSBuffer.fromString(X.slice(0,30)))}}async function M(U){const j=new se(U);try{await j.run()}finally{j.dispose()}}i.main=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c29becfad5f68270b9b23efeafb147722c5feba/core/vs/code/node/cliProcessMain.js.map
