/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/glob","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/platform/files/common/files","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/stopwatch","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookProxyKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(Y){for(var e=[],d=0,i=Y.length;d<i;d++)e[d]=Ie[Y[d]];return e};define(Ie[55],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(i,C){if(!i)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=d}),define(Ie[77],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function d(I){return I?I.replace(/\$\((.*?)\)/g,(D,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=d;class i{constructor(D,b,A){this.id=D,this.definition=b,this.description=A,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function C(I,D){const b=["codicon","codicon-"+I];return D&&b.push("codicon-modifier-"+D),b}e.getClassNamesArray=C;var P;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function b(k){if(k instanceof i)return["codicon","codicon-"+k.id];const y=D.exec(k.id);if(!y)return b(i.error);let[,T,_]=y;const m=["codicon","codicon-"+T];return _&&m.push("codicon-modifier-"+_.substr(1)),m}I.asClassNameArray=b;function A(k){return b(k).join(" ")}I.asClassName=A;function L(k){return"."+b(k).join(".")}I.asCSSSelector=L})(P=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[56],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function i(L){const k=[];for(let y in L)d.call(L,y)&&k.push(L[y]);return k}e.values=i;function C(L,k){for(let y in L)if(d.call(L,y)&&k({key:y,value:L[y]},function(){delete L[y]})===!1)return}e.forEach=C;function P(L,k){const y=Object.create(null);for(const T of L){const _=k(T);let m=y[_];m||(m=y[_]=[]),m.push(T)}return y}e.groupBy=P;function I(L){const k=Object.create(null);return L&&L.forEach((y,T)=>{k[T]=y}),k}e.fromMap=I;function D(L,k){const y=[],T=[];for(let _ of L)k.has(_)||y.push(_);for(let _ of k)L.has(_)||T.push(_);return{removed:y,added:T}}e.diffSets=D;function b(L,k){const y=[],T=[];for(let[_,m]of L)k.has(_)||y.push(m);for(let[_,m]of k)L.has(_)||T.push(m);return{removed:y,added:T}}e.diffMaps=b;class A{constructor(){this.map=new Map}add(k,y){let T=this.map.get(k);T||(T=new Set,this.map.set(k,T)),T.add(y)}delete(k,y){const T=this.map.get(k);!T||(T.delete(y),T.size===0&&this.map.delete(k))}forEach(k,y){const T=this.map.get(k);!T||T.forEach(y)}}e.SetMap=A}),define(Ie[57],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(I){return(D,b,A)=>{let L=null,k=null;if(typeof A.value=="function"?(L="value",k=A.value):typeof A.get=="function"&&(L="get",k=A.get),!k)throw new Error("not supported");A[L]=I(k,b)}}e.createDecorator=d;function i(I,D,b){let A=null,L=null;if(typeof b.value=="function"?(A="value",L=b.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(A="get",L=b.get),!L)throw new Error("not supported");const k=`$memoize$${D}`;b[A]=function(...y){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,y)}),this[k]}}e.memoize=i;function C(I,D,b){return d((A,L)=>{const k=`$debounce$${L}`,y=`$debounce$result$${L}`;return function(...T){this[y]||(this[y]=b?b():void 0),clearTimeout(this[k]),D&&(this[y]=D(this[y],...T),T=[this[y]]),this[k]=setTimeout(()=>{A.apply(this,T),this[y]=b?b():void 0},I)}})}e.debounce=C;function P(I,D,b){return d((A,L)=>{const k=`$throttle$timer$${L}`,y=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,_=`$throttle$pending$${L}`;return function(...m){if(this[y]||(this[y]=b?b():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),D&&(this[y]=D(this[y],...m)),this[_])return;const v=this[T]+I;v<=Date.now()?(this[T]=Date.now(),A.apply(this,[this[y]]),this[y]=b?b():void 0):(this[_]=!0,this[k]=setTimeout(()=>{this[_]=!1,this[T]=Date.now(),A.apply(this,[this[y]]),this[y]=b?b():void 0},v-Date.now()))}})}e.throttle=P}),define(Ie[11],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(w=>{w(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=d,e.errorHandler=new d;function i(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=i;function C(f){b(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=C;function P(f){b(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=P;function I(f){if(f instanceof Error){let{name:o,message:w}=f;const r=f.stacktrace||f.stack;return{$isError:!0,name:o,message:w,stack:r}}return f}e.transformErrorForSerialization=I;const D="Canceled";function b(f){return f instanceof A?!0:f instanceof Error&&f.name===D&&f.message===D}e.isCancellationError=b;class A extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=A;function L(){const f=new Error(D);return f.name=f.message,f}e.canceled=L;function k(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=k;function y(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=y;function T(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function _(f){const o=new Error(`${f} has been disposed`);return o.name="DISPOSED",o}e.disposed=_;function m(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=m;class v extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=v;class g extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=g;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;class h extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(o){if(o&&o instanceof h)return o;if(o&&o instanceof Error){const w=new h;return w.name=o.name,w.message=o.message,w.stack=o.stack,w}return new h(o)}}e.ErrorNoTelemetry=h;class l extends Error{constructor(o){super(o);Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(Ie[16],ke([1,0,11]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(ne,he=0){return ne[ne.length-(1+he)]}e.tail=i;function C(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.tail2=C;function P(ne,he,Se=(Re,ve)=>Re===ve){if(ne===he)return!0;if(!ne||!he||ne.length!==he.length)return!1;for(let Re=0,ve=ne.length;Re<ve;Re++)if(!Se(ne[Re],he[Re]))return!1;return!0}e.equals=P;function I(ne,he,Se){return D(ne.length,Re=>Se(ne[Re],he))}e.binarySearch=I;function D(ne,he){let Se=0,Re=ne-1;for(;Se<=Re;){const ve=(Se+Re)/2|0,Te=he(ve);if(Te<0)Se=ve+1;else if(Te>0)Re=ve-1;else return ve}return-(Se+1)}e.binarySearch2=D;function b(ne,he){let Se=0,Re=ne.length;if(Re===0)return 0;for(;Se<Re;){const ve=Math.floor((Se+Re)/2);he(ne[ve])?Re=ve:Se=ve+1}return Se}e.findFirstInSorted=b;function A(ne,he,Se){if(ne=ne|0,ne>=he.length)throw new TypeError("invalid index");let Re=he[Math.floor(he.length*Math.random())],ve=[],Te=[],Ae=[];for(let le of he){const pe=Se(le,Re);pe<0?ve.push(le):pe>0?Te.push(le):Ae.push(le)}return ne<ve.length?A(ne,ve,Se):ne<ve.length+Ae.length?Ae[0]:A(ne-(ve.length+Ae.length),Te,Se)}e.quickSelect=A;function L(ne,he){const Se=[];let Re;for(const ve of ne.slice(0).sort(he))!Re||he(Re[0],ve)!==0?(Re=[ve],Se.push(Re)):Re.push(ve);return Se}e.groupBy=L;function k(ne,he,Se){const Re=[];function ve(le,pe,ee){if(pe===0&&ee.length===0)return;const te=Re[Re.length-1];te&&te.start+te.deleteCount===le?(te.deleteCount+=pe,te.toInsert.push(...ee)):Re.push({start:le,deleteCount:pe,toInsert:ee})}let Te=0,Ae=0;for(;;){if(Te===ne.length){ve(Te,0,he.slice(Ae));break}if(Ae===he.length){ve(Te,ne.length-Te,[]);break}const le=ne[Te],pe=he[Ae],ee=Se(le,pe);ee===0?(Te+=1,Ae+=1):ee<0?(ve(Te,1,[]),Te+=1):ee>0&&(ve(Te,0,[pe]),Ae+=1)}return Re}e.sortedDiff=k;function y(ne,he,Se){const Re=k(ne,he,Se),ve=[],Te=[];for(const Ae of Re)ve.push(...ne.slice(Ae.start,Ae.start+Ae.deleteCount)),Te.push(...Ae.toInsert);return{removed:ve,added:Te}}e.delta=y;function T(ne,he,Se){if(Se===0)return[];const Re=ne.slice(0,Se).sort(he);return m(ne,he,Re,Se,ne.length),Re}e.top=T;function _(ne,he,Se,Re,ve){return Se===0?Promise.resolve([]):new Promise((Te,Ae)=>{(async()=>{const le=ne.length,pe=ne.slice(0,Se).sort(he);for(let ee=Se,te=Math.min(Se+Re,le);ee<le;ee=te,te=Math.min(te+Re,le)){if(ee>Se&&await new Promise(F=>setTimeout(F)),ve&&ve.isCancellationRequested)throw new d.CancellationError;m(ne,he,pe,ee,te)}return pe})().then(Te,Ae)})}e.topAsync=_;function m(ne,he,Se,Re,ve){for(const Te=Se.length;Re<ve;Re++){const Ae=ne[Re];if(he(Ae,Se[Te-1])<0){Se.pop();const le=b(Se,pe=>he(Ae,pe)<0);Se.splice(le,0,Ae)}}}function v(ne){return ne.filter(he=>!!he)}e.coalesce=v;function g(ne){let he=0;for(let Se=0;Se<ne.length;Se++)ne[Se]&&(ne[he]=ne[Se],he+=1);ne.length=he}e.coalesceInPlace=g;function E(ne,he,Se){ne.splice(Se,0,ne.splice(he,1)[0])}e.move=E;function h(ne){return!Array.isArray(ne)||ne.length===0}e.isFalsyOrEmpty=h;function l(ne){return Array.isArray(ne)&&ne.length>0}e.isNonEmptyArray=l;function f(ne,he=Se=>Se){const Se=new Set;return ne.filter(Re=>{const ve=he(Re);return Se.has(ve)?!1:(Se.add(ve),!0)})}e.distinct=f;function o(ne){const he=new Set;return Se=>{const Re=ne(Se);return he.has(Re)?!1:(he.add(Re),!0)}}e.uniqueFilter=o;function w(ne,he){const Se=r(ne,he);if(Se!==-1)return ne[Se]}e.findLast=w;function r(ne,he){for(let Se=ne.length-1;Se>=0;Se--){const Re=ne[Se];if(he(Re))return Se}return-1}e.lastIndex=r;function s(ne,he){return ne.length>0?ne[0]:he}e.firstOrDefault=s;function n(ne,he){return ne.length>0?ne[ne.length-1]:he}e.lastOrDefault=n;function t(ne,he,Se=(Re,ve)=>Re===ve){let Re=0;for(let ve=0,Te=Math.min(ne.length,he.length);ve<Te&&Se(ne[ve],he[ve]);ve++)Re++;return Re}e.commonPrefixLength=t;function a(ne){return[].concat(...ne)}e.flatten=a;function u(ne,he){let Se=typeof he=="number"?ne:0;typeof he=="number"?Se=ne:(Se=0,he=ne);const Re=[];if(Se<=he)for(let ve=Se;ve<he;ve++)Re.push(ve);else for(let ve=Se;ve>he;ve--)Re.push(ve);return Re}e.range=u;function c(ne,he,Se){return ne.reduce((Re,ve)=>(Re[he(ve)]=Se?Se(ve):ve,Re),Object.create(null))}e.index=c;function S(ne,he){return ne.push(he),()=>R(ne,he)}e.insert=S;function R(ne,he){const Se=ne.indexOf(he);if(Se>-1)return ne.splice(Se,1),he}e.remove=R;function O(ne,he,Se){const Re=ne.slice(0,he),ve=ne.slice(he);return Re.concat(Se,ve)}e.arrayInsert=O;function N(ne,he){let Se;if(typeof he=="number"){let Re=he;Se=()=>{const ve=Math.sin(Re++)*179426549;return ve-Math.floor(ve)}}else Se=Math.random;for(let Re=ne.length-1;Re>0;Re-=1){const ve=Math.floor(Se()*(Re+1)),Te=ne[Re];ne[Re]=ne[ve],ne[ve]=Te}}e.shuffle=N;function p(ne,he){const Se=ne.indexOf(he);Se>-1&&(ne.splice(Se,1),ne.unshift(he))}e.pushToStart=p;function U(ne,he){const Se=ne.indexOf(he);Se>-1&&(ne.splice(Se,1),ne.push(he))}e.pushToEnd=U;function B(ne,he){for(const Se of he)ne.push(Se)}e.pushMany=B;function z(ne,he){return Array.isArray(ne)?ne.map(he):he(ne)}e.mapArrayOrNot=z;function re(ne){return Array.isArray(ne)?ne:[ne]}e.asArray=re;function H(ne){return ne[Math.floor(Math.random()*ne.length)]}e.getRandomElement=H;function M(ne,he){for(const Se of ne){const Re=he(Se);if(Re!==void 0)return Re}}e.mapFind=M;function j(ne,he,Se){const Re=q(ne,he),ve=ne.length,Te=Se.length;ne.length=ve+Te;for(let Ae=ve-1;Ae>=Re;Ae--)ne[Ae+Te]=ne[Ae];for(let Ae=0;Ae<Te;Ae++)ne[Ae+Re]=Se[Ae]}e.insertInto=j;function V(ne,he,Se,Re){const ve=q(ne,he),Te=ne.splice(ve,Se);return j(ne,ve,Re),Te}e.splice=V;function q(ne,he){return he<0?Math.max(he+ne.length,0):Math.min(he,ne.length)}function ie(ne,he){return(Se,Re)=>he(ne(Se),ne(Re))}e.compareBy=ie;const Q=(ne,he)=>ne-he;e.numberComparator=Q;function ue(ne,he){if(ne.length===0)return;let Se=ne[0];for(let Re=1;Re<ne.length;Re++){const ve=ne[Re];he(ve,Se)>0&&(Se=ve)}return Se}e.findMaxBy=ue;function ce(ne,he){if(ne.length===0)return;let Se=ne[0];for(let Re=1;Re<ne.length;Re++){const ve=ne[Re];he(ve,Se)>=0&&(Se=ve)}return Se}e.findLastMaxBy=ce;function G(ne,he){return ue(ne,(Se,Re)=>-he(Se,Re))}e.findMinBy=G;class ge{constructor(he){this.items=he,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(he){let Se=this.firstIdx;for(;Se<this.items.length&&he(this.items[Se]);)Se++;const Re=Se===this.firstIdx?null:this.items.slice(this.firstIdx,Se);return this.firstIdx=Se,Re}takeFromEndWhile(he){let Se=this.lastIdx;for(;Se>=0&&he(this.items[Se]);)Se--;const Re=Se===this.lastIdx?null:this.items.slice(Se+1,this.lastIdx+1);return this.lastIdx=Se,Re}peek(){return this.items[this.firstIdx]}dequeue(){const he=this.items[this.firstIdx];return this.firstIdx++,he}takeCount(he){const Se=this.items.slice(this.firstIdx,this.firstIdx+he);return this.firstIdx+=he,Se}}e.ArrayQueue=ge}),define(Ie[58],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(i){const C=this;let P=!1,I;return function(){return P||(P=!0,I=i.apply(C,arguments)),I}}e.once=d}),define(Ie[78],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(Ie[79],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(i){function C(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}i.is=C;const P=Object.freeze([]);function I(){return P}i.empty=I;function*D(w){yield w}i.single=D;function b(w){return w||P}i.from=b;function A(w){return!w||w[Symbol.iterator]().next().done===!0}i.isEmpty=A;function L(w){return w[Symbol.iterator]().next().value}i.first=L;function k(w,r){for(const s of w)if(r(s))return!0;return!1}i.some=k;function y(w,r){for(const s of w)if(r(s))return s}i.find=y;function*T(w,r){for(const s of w)r(s)&&(yield s)}i.filter=T;function*_(w,r){let s=0;for(const n of w)yield r(n,s++)}i.map=_;function*m(...w){for(const r of w)for(const s of r)yield s}i.concat=m;function*v(w){for(const r of w)for(const s of r)yield s}i.concatNested=v;function g(w,r,s){let n=s;for(const t of w)n=r(n,t);return n}i.reduce=g;function E(w,r){let s=0;for(const n of w)r(n,s++)}i.forEach=E;function*h(w,r,s=w.length){for(r<0&&(r+=w.length),s<0?s+=w.length:s>w.length&&(s=w.length);r<s;r++)yield w[r]}i.slice=h;function l(w,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,w];const n=w[Symbol.iterator]();for(let t=0;t<r;t++){const a=n.next();if(a.done)return[s,i.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return n}}]}i.consume=l;function f(w){return l(w)[0]}i.collect=f;function o(w,r,s=(n,t)=>n===t){const n=w[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const a=n.next(),u=t.next();if(a.done!==u.done)return!1;if(a.done)return!0;if(!s(a.value,u.value))return!1}}i.equals=o})(d=e.Iterable||(e.Iterable={}))}),define(Ie[144],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var i;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(o){o.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function I(o,w=!1){let r=0,s=o.length,n="",t=0,a=16,u=0;function c(B){let z=0,re=0;for(;z<B;){const H=o.charCodeAt(r);if(H>=48&&H<=57)re=re*16+H-48;else if(H>=65&&H<=70)re=re*16+H-65+10;else if(H>=97&&H<=102)re=re*16+H-97+10;else break;r++,z++}return z<B&&(re=-1),re}function S(B){r=B,n="",t=0,a=16,u=0}function R(){const B=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&A(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&A(o.charCodeAt(r)))for(r++;r<o.length&&A(o.charCodeAt(r));)r++;else return u=3,o.substring(B,r);let z=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&A(o.charCodeAt(r))){for(r++;r<o.length&&A(o.charCodeAt(r));)r++;z=r}else u=3;return o.substring(B,z)}function O(){let B="",z=r;for(;;){if(r>=s){B+=o.substring(z,r),u=2;break}const re=o.charCodeAt(r);if(re===34){B+=o.substring(z,r),r++;break}if(re===92){if(B+=o.substring(z,r),r++,r>=s){u=2;break}switch(o.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const M=c(4);M>=0?B+=String.fromCharCode(M):u=4;break}default:u=5}z=r;continue}if(re>=0&&re<=31)if(b(re)){B+=o.substring(z,r),u=2;break}else u=6;r++}return B}function N(){if(n="",u=0,t=r,r>=s)return t=s,a=17;let B=o.charCodeAt(r);if(D(B)){do r++,n+=String.fromCharCode(B),B=o.charCodeAt(r);while(D(B));return a=15}if(b(B))return r++,n+=String.fromCharCode(B),B===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),a=14;switch(B){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,n=O(),a=10;case 47:{const z=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<s&&!b(o.charCodeAt(r));)r++;return n=o.substring(z,r),a=12}if(o.charCodeAt(r+1)===42){r+=2;const re=s-1;let H=!1;for(;r<re;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,u=1),n=o.substring(z,r),a=13}return n+=String.fromCharCode(B),r++,a=16}case 45:if(n+=String.fromCharCode(B),r++,r===s||!A(o.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),a=11;default:for(;r<s&&p(B);)r++,B=o.charCodeAt(r);if(t!==r){switch(n=o.substring(t,r),n){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return n+=String.fromCharCode(B),r++,a=16}}function p(B){if(D(B)||b(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=N();while(B>=12&&B<=15);return B}return{setPosition:S,getPosition:()=>r,scan:w?U:N,getToken:()=>a,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>u}}e.createScanner=I;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function b(o){return o===10||o===13||o===8232||o===8233}function A(o){return o>=48&&o<=57}var L;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(L||(L={}));function k(o,w){const r=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(c,S,R,O){t.value=c,t.offset=S,t.length=R,t.type=O,t.colonOffset=void 0,n=t}try{h(o,{onObjectBegin:(c,S)=>{if(w<=c)throw s;n=void 0,a=w>c,r.push("")},onObjectProperty:(c,S,R)=>{if(w<S||(u(c,S,R,"property"),r[r.length-1]=c,w<=S+R))throw s},onObjectEnd:(c,S)=>{if(w<=c)throw s;n=void 0,r.pop()},onArrayBegin:(c,S)=>{if(w<=c)throw s;n=void 0,r.push(0)},onArrayEnd:(c,S)=>{if(w<=c)throw s;n=void 0,r.pop()},onLiteralValue:(c,S,R)=>{if(w<S||(u(c,S,R,f(c)),w<=S+R))throw s},onSeparator:(c,S,R)=>{if(w<=S)throw s;if(c===":"&&n&&n.type==="property")n.colonOffset=S,a=!1,n=void 0;else if(c===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(a=!0,r[r.length-1]=""),n=void 0}}})}catch(c){if(c!==s)throw c}return{path:r,previousNode:n,isAtPropertyKey:a,matches:c=>{let S=0;for(let R=0;S<c.length&&R<r.length;R++)if(c[S]===r[R]||c[S]==="*")S++;else if(c[S]!=="**")return!1;return S===c.length}}}e.getLocation=k;function y(o,w=[],r=P.DEFAULT){let s=null,n=[];const t=[];function a(c){Array.isArray(n)?n.push(c):s!==null&&(n[s]=c)}return h(o,{onObjectBegin:()=>{const c={};a(c),t.push(n),n=c,s=null},onObjectProperty:c=>{s=c},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const c=[];a(c),t.push(n),n=c,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:a,onError:(c,S,R)=>{w.push({error:c,offset:S,length:R})}},r),n[0]}e.parse=y;function T(o,w=[],r=P.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(c){s.type==="property"&&(s.length=c-s.offset,s=s.parent)}function t(c){return s.children.push(c),c}h(o,{onObjectBegin:c=>{s=t({type:"object",offset:c,length:-1,parent:s,children:[]})},onObjectProperty:(c,S,R)=>{s=t({type:"property",offset:S,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:c,offset:S,length:R,parent:s})},onObjectEnd:(c,S)=>{s.length=c+S-s.offset,s=s.parent,n(c+S)},onArrayBegin:(c,S)=>{s=t({type:"array",offset:c,length:-1,parent:s,children:[]})},onArrayEnd:(c,S)=>{s.length=c+S-s.offset,s=s.parent,n(c+S)},onLiteralValue:(c,S,R)=>{t({type:f(c),offset:S,length:R,parent:s,value:c}),n(S+R)},onSeparator:(c,S,R)=>{s.type==="property"&&(c===":"?s.colonOffset=S:c===","&&n(S))},onError:(c,S,R)=>{w.push({error:c,offset:S,length:R})}},r);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=T;function _(o,w){if(!o)return;let r=o;for(let s of w)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=_;function m(o){if(!o.parent||!o.parent.children)return[];const w=m(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;w.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&w.push(r)}return w}e.getNodePath=m;function v(o){switch(o.type){case"array":return o.children.map(v);case"object":{const w=Object.create(null);for(let r of o.children){const s=r.children[1];s&&(w[r.children[0].value]=v(s))}return w}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=v;function g(o,w,r=!1){return w>=o.offset&&w<o.offset+o.length||r&&w===o.offset+o.length}e.contains=g;function E(o,w,r=!1){if(g(o,w,r)){const s=o.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=w;n++){const t=E(s[n],w,r);if(t)return t}return o}}e.findNodeAtOffset=E;function h(o,w,r=P.DEFAULT){const s=I(o,!1);function n(ue){return ue?()=>ue(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(ue){return ue?ce=>ue(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=n(w.onObjectBegin),u=t(w.onObjectProperty),c=n(w.onObjectEnd),S=n(w.onArrayBegin),R=n(w.onArrayEnd),O=t(w.onLiteralValue),N=t(w.onSeparator),p=n(w.onComment),U=t(w.onError),B=r&&r.disallowComments,z=r&&r.allowTrailingComma;function re(){for(;;){const ue=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ue){case 12:case 13:B?H(10):p();break;case 16:H(1);break;case 15:case 14:break;default:return ue}}}function H(ue,ce=[],G=[]){if(U(ue),ce.length+G.length>0){let ge=s.getToken();for(;ge!==17;){if(ce.indexOf(ge)!==-1){re();break}else if(G.indexOf(ge)!==-1)break;ge=re()}}}function M(ue){const ce=s.getTokenValue();return ue?O(ce):u(ce),re(),!0}function j(){switch(s.getToken()){case 11:{let ue=0;try{ue=JSON.parse(s.getTokenValue()),typeof ue!="number"&&(H(2),ue=0)}catch{H(2)}O(ue);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return re(),!0}function V(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(M(!1),s.getToken()===6?(N(":"),re(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function q(){a(),re();let ue=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ue||H(4,[],[]),N(","),re(),s.getToken()===2&&z)break}else ue&&H(6,[],[]);V()||H(4,[],[2,5]),ue=!0}return c(),s.getToken()!==2?H(7,[2],[]):re(),!0}function ie(){S(),re();let ue=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ue||H(4,[],[]),N(","),re(),s.getToken()===4&&z)break}else ue&&H(6,[],[]);Q()||H(4,[],[4,5]),ue=!0}return R(),s.getToken()!==4?H(8,[4],[]):re(),!0}function Q(){switch(s.getToken()){case 3:return ie();case 1:return q();case 10:return M(!0);default:return j()}}return re(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function l(o,w){let r=I(o),s=[],n,t=0,a;do switch(a=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:t!==a&&s.push(o.substring(t,a)),w!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,w)),t=r.getPosition();break}while(n!==17);return s.join("")}e.stripComments=l;function f(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(Ie[80],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new d(()=>C(this.getValue()))}}e.Lazy=d}),define(Ie[6],ke([1,0,58,79]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let P=null;function I(n){P=n}if(e.setDisposableTracker=I,C){const n="__is_disposable_tracked__";I(new class{trackDisposable(t){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[n]||console.log(a)},3e3)}setParent(t,a){if(t&&t!==E.None)try{t[n]=!0}catch{}}markAsDisposed(t){if(t&&t!==E.None)try{t[n]=!0}catch{}}markAsSingleton(t){}})}function D(n){return P?.trackDisposable(n),n}function b(n){P?.markAsDisposed(n)}function A(n,t){P?.setParent(n,t)}function L(n,t){if(!!P)for(const a of n)P.setParent(a,t)}function k(n){return P?.markAsSingleton(n),n}e.markAsSingleton=k;class y extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=y;function T(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=T;function _(n){if(i.Iterable.is(n)){let t=[];for(const a of n)if(a)try{a.dispose()}catch(u){t.push(u)}if(t.length===1)throw t[0];if(t.length>1)throw new y(t);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=_;function m(...n){const t=v(()=>_(n));return L(n,t),t}e.combinedDisposable=m;function v(n){const t=D({dispose:(0,d.once)(()=>{b(t),n()})});return t}e.toDisposable=v;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{_(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return A(t,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new g,D(this),A(this._store,this)}dispose(){b(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&A(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&A(t,null),t}}e.MutableDisposable=h;class l{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(t){let a=t;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,b(this))},this}}e.SafeDisposable=f;class o{constructor(){this.references=new Map}acquire(t,...a){let u=this.references.get(t);u||(u={counter:0,object:this.createReferencedObject(t,...a)},this.references.set(t,u));const{object:c}=u,S=(0,d.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(t,u.object),this.references.delete(t))});return u.counter++,{object:c,dispose:S}}}e.ReferenceCollection=o;class w{constructor(t){this.referenceCollection=t}async acquire(t,...a){const u=this.referenceCollection.acquire(t,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(c){throw u.dispose(),c}}}e.AsyncReferenceCollection=w;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(n){const t=new g;try{n(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(Ie[92],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(P){this.element=P,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class i{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let P=this._first;for(;P!==d.Undefined;){const I=P.next;P.prev=d.Undefined,P.next=d.Undefined,P=I}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,I){const D=new d(P);if(this._first===d.Undefined)this._first=D,this._last=D;else if(I){const A=this._last;this._last=D,D.prev=A,A.next=D}else{const A=this._first;this._first=D,D.next=A,A.prev=D}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(D))}}shift(){if(this._first!==d.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==d.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==d.Undefined&&P.next!==d.Undefined){const I=P.prev;I.next=P.next,P.next.prev=I}else P.prev===d.Undefined&&P.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):P.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):P.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==d.Undefined;)yield P.element,P=P.next}}e.LinkedList=i}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[145],ke([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(ve,Te){for(var Ae=0;Ae<Te.length;Ae++){var le=Te[Ae];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(ve,le.key,le)}}function d(ve,Te,Ae){return Te&&e(ve.prototype,Te),Ae&&e(ve,Ae),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function i(ve,Te){if(!!ve){if(typeof ve=="string")return C(ve,Te);var Ae=Object.prototype.toString.call(ve).slice(8,-1);if(Ae==="Object"&&ve.constructor&&(Ae=ve.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(ve);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return C(ve,Te)}}function C(ve,Te){(Te==null||Te>ve.length)&&(Te=ve.length);for(var Ae=0,le=new Array(Te);Ae<Te;Ae++)le[Ae]=ve[Ae];return le}function P(ve,Te){var Ae=typeof Symbol!="undefined"&&ve[Symbol.iterator]||ve["@@iterator"];if(Ae)return(Ae=Ae.call(ve)).next.bind(Ae);if(Array.isArray(ve)||(Ae=i(ve))||Te&&ve&&typeof ve.length=="number"){Ae&&(ve=Ae);var le=0;return function(){return le>=ve.length?{done:!0}:{done:!1,value:ve[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=I();function D(ve){Y.defaults=ve}var b=/[&<>"']/,A=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(Te){return y[Te]};function _(ve,Te){if(Te){if(b.test(ve))return ve.replace(A,T)}else if(L.test(ve))return ve.replace(k,T);return ve}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(ve){return ve.replace(m,function(Te,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var g=/(^|[^\[])\^/g;function E(ve,Te){ve=ve.source||ve,Te=Te||"";var Ae={replace:function(pe,ee){return ee=ee.source||ee,ee=ee.replace(g,"$1"),ve=ve.replace(pe,ee),Ae},getRegex:function(){return new RegExp(ve,Te)}};return Ae}var h=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(ve,Te,Ae){if(ve){var le;try{le=decodeURIComponent(v(Ae)).replace(h,"").toLowerCase()}catch{return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}Te&&!l.test(Ae)&&(Ae=n(Te,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch{return null}return Ae}var o={},w=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(ve,Te){o[" "+ve]||(w.test(ve)?o[" "+ve]=ve+"/":o[" "+ve]=c(ve,"/",!0)),ve=o[" "+ve];var Ae=ve.indexOf(":")===-1;return Te.substring(0,2)==="//"?Ae?Te:ve.replace(r,"$1")+Te:Te.charAt(0)==="/"?Ae?Te:ve.replace(s,"$1")+Te:ve+Te}var t={exec:function(){}};function a(ve){for(var Te=1,Ae,le;Te<arguments.length;Te++){Ae=arguments[Te];for(le in Ae)Object.prototype.hasOwnProperty.call(Ae,le)&&(ve[le]=Ae[le])}return ve}function u(ve,Te){var Ae=ve.replace(/\|/g,function(ee,te,F){for(var $=!1,K=te;--K>=0&&F[K]==="\\";)$=!$;return $?"|":" |"}),le=Ae.split(/ \|/),pe=0;if(le[0].trim()||le.shift(),le[le.length-1].trim()||le.pop(),le.length>Te)le.splice(Te);else for(;le.length<Te;)le.push("");for(;pe<le.length;pe++)le[pe]=le[pe].trim().replace(/\\\|/g,"|");return le}function c(ve,Te,Ae){var le=ve.length;if(le===0)return"";for(var pe=0;pe<le;){var ee=ve.charAt(le-pe-1);if(ee===Te&&!Ae)pe++;else if(ee!==Te&&Ae)pe++;else break}return ve.substr(0,le-pe)}function S(ve,Te){if(ve.indexOf(Te[1])===-1)return-1;for(var Ae=ve.length,le=0,pe=0;pe<Ae;pe++)if(ve[pe]==="\\")pe++;else if(ve[pe]===Te[0])le++;else if(ve[pe]===Te[1]&&(le--,le<0))return pe;return-1}function R(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(ve,Te){if(Te<1)return"";for(var Ae="";Te>1;)Te&1&&(Ae+=ve),Te>>=1,ve+=ve;return Ae+ve}function N(ve,Te,Ae,le){var pe=Te.href,ee=Te.title?_(Te.title):null,te=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){le.state.inLink=!0;var F={type:"link",raw:Ae,href:pe,title:ee,text:te,tokens:le.inlineTokens(te,[])};return le.state.inLink=!1,F}else return{type:"image",raw:Ae,href:pe,title:ee,text:_(te)}}function p(ve,Te){var Ae=ve.match(/^(\s+)(?:```)/);if(Ae===null)return Te;var le=Ae[1];return Te.split(`
`).map(function(pe){var ee=pe.match(/^\s+/);if(ee===null)return pe;var te=ee[0];return te.length>=le.length?pe.slice(le.length):pe}).join(`
`)}var U=function(){function ve(Ae){this.options=Ae||Y.defaults}var Te=ve.prototype;return Te.space=function(le){var pe=this.rules.block.newline.exec(le);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}},Te.code=function(le){var pe=this.rules.block.code.exec(le);if(pe){var ee=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:c(ee,`
`)}}},Te.fences=function(le){var pe=this.rules.block.fences.exec(le);if(pe){var ee=pe[0],te=p(ee,pe[3]||"");return{type:"code",raw:ee,lang:pe[2]?pe[2].trim():pe[2],text:te}}},Te.heading=function(le){var pe=this.rules.block.heading.exec(le);if(pe){var ee=pe[2].trim();if(/#$/.test(ee)){var te=c(ee,"#");(this.options.pedantic||!te||/ $/.test(te))&&(ee=te.trim())}var F={type:"heading",raw:pe[0],depth:pe[1].length,text:ee,tokens:[]};return this.lexer.inline(F.text,F.tokens),F}},Te.hr=function(le){var pe=this.rules.block.hr.exec(le);if(pe)return{type:"hr",raw:pe[0]}},Te.blockquote=function(le){var pe=this.rules.block.blockquote.exec(le);if(pe){var ee=pe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:pe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},Te.list=function(le){var pe=this.rules.block.list.exec(le);if(pe){var ee,te,F,$,K,X,me,Ee,oe,De,Ce,We,je=pe[1].trim(),Fe=je.length>1,Ye={type:"list",raw:"",ordered:Fe,start:Fe?+je.slice(0,-1):"",loose:!1,items:[]};je=Fe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Fe?je:"[*+-]");for(var J=new RegExp("^( {0,3}"+je+")((?: [^\\n]*)?(?:\\n|$))");le&&(We=!1,!(!(pe=J.exec(le))||this.rules.block.hr.test(le)));){if(ee=pe[0],le=le.substring(ee.length),Ee=pe[2].split(`
`,1)[0],oe=le.split(`
`,1)[0],this.options.pedantic?($=2,Ce=Ee.trimLeft()):($=pe[2].search(/[^ ]/),$=$>4?1:$,Ce=Ee.slice($),$+=pe[1].length),X=!1,!Ee&&/^ *$/.test(oe)&&(ee+=oe+`
`,le=le.substring(oe.length+1),We=!0),!We)for(var se=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])");le&&(De=le.split(`
`,1)[0],Ee=De,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!se.test(Ee));){if(Ee.search(/[^ ]/)>=$||!Ee.trim())Ce+=`
`+Ee.slice($);else if(!X)Ce+=`
`+Ee;else break;!X&&!Ee.trim()&&(X=!0),ee+=De+`
`,le=le.substring(De.length+1)}Ye.loose||(me?Ye.loose=!0:/\n *\n *$/.test(ee)&&(me=!0)),this.options.gfm&&(te=/^\[[ xX]\] /.exec(Ce),te&&(F=te[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!te,checked:F,loose:!1,text:Ce}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=Ce.trimRight(),Ye.raw=Ye.raw.trimRight();var _e=Ye.items.length;for(K=0;K<_e;K++){this.lexer.state.top=!1,Ye.items[K].tokens=this.lexer.blockTokens(Ye.items[K].text,[]);var ae=Ye.items[K].tokens.filter(function(Ne){return Ne.type==="space"}),ye=ae.every(function(Ne){for(var He=Ne.raw.split(""),qe=0,Ge=P(He),Ze;!(Ze=Ge()).done;){var Xe=Ze.value;if(Xe===`
`&&(qe+=1),qe>1)return!0}return!1});!Ye.loose&&ae.length&&ye&&(Ye.loose=!0,Ye.items[K].loose=!0)}return Ye}},Te.html=function(le){var pe=this.rules.block.html.exec(le);if(pe){var ee={type:"html",raw:pe[0],pre:!this.options.sanitizer&&(pe[1]==="pre"||pe[1]==="script"||pe[1]==="style"),text:pe[0]};return this.options.sanitize&&(ee.type="paragraph",ee.text=this.options.sanitizer?this.options.sanitizer(pe[0]):_(pe[0]),ee.tokens=[],this.lexer.inline(ee.text,ee.tokens)),ee}},Te.def=function(le){var pe=this.rules.block.def.exec(le);if(pe){pe[3]&&(pe[3]=pe[3].substring(1,pe[3].length-1));var ee=pe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:pe[0],href:pe[2],title:pe[3]}}},Te.table=function(le){var pe=this.rules.block.table.exec(le);if(pe){var ee={type:"table",header:u(pe[1]).map(function(me){return{text:me}}),align:pe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:pe[3]?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=pe[0];var te=ee.align.length,F,$,K,X;for(F=0;F<te;F++)/^ *-+: *$/.test(ee.align[F])?ee.align[F]="right":/^ *:-+: *$/.test(ee.align[F])?ee.align[F]="center":/^ *:-+ *$/.test(ee.align[F])?ee.align[F]="left":ee.align[F]=null;for(te=ee.rows.length,F=0;F<te;F++)ee.rows[F]=u(ee.rows[F],ee.header.length).map(function(me){return{text:me}});for(te=ee.header.length,$=0;$<te;$++)ee.header[$].tokens=[],this.lexer.inlineTokens(ee.header[$].text,ee.header[$].tokens);for(te=ee.rows.length,$=0;$<te;$++)for(X=ee.rows[$],K=0;K<X.length;K++)X[K].tokens=[],this.lexer.inlineTokens(X[K].text,X[K].tokens);return ee}}},Te.lheading=function(le){var pe=this.rules.block.lheading.exec(le);if(pe){var ee={type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},Te.paragraph=function(le){var pe=this.rules.block.paragraph.exec(le);if(pe){var ee={type:"paragraph",raw:pe[0],text:pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},Te.text=function(le){var pe=this.rules.block.text.exec(le);if(pe){var ee={type:"text",raw:pe[0],text:pe[0],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},Te.escape=function(le){var pe=this.rules.inline.escape.exec(le);if(pe)return{type:"escape",raw:pe[0],text:_(pe[1])}},Te.tag=function(le){var pe=this.rules.inline.tag.exec(le);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):_(pe[0]):pe[0]}},Te.link=function(le){var pe=this.rules.inline.link.exec(le);if(pe){var ee=pe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var te=c(ee.slice(0,-1),"\\");if((ee.length-te.length)%2==0)return}else{var F=S(pe[2],"()");if(F>-1){var $=pe[0].indexOf("!")===0?5:4,K=$+pe[1].length+F;pe[2]=pe[2].substring(0,F),pe[0]=pe[0].substring(0,K).trim(),pe[3]=""}}var X=pe[2],me="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);Ee&&(X=Ee[1],me=Ee[3])}else me=pe[3]?pe[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ee)?X=X.slice(1):X=X.slice(1,-1)),N(pe,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},pe[0],this.lexer)}},Te.reflink=function(le,pe){var ee;if((ee=this.rules.inline.reflink.exec(le))||(ee=this.rules.inline.nolink.exec(le))){var te=(ee[2]||ee[1]).replace(/\s+/g," ");if(te=pe[te.toLowerCase()],!te||!te.href){var F=ee[0].charAt(0);return{type:"text",raw:F,text:F}}return N(ee,te,ee[0],this.lexer)}},Te.emStrong=function(le,pe,ee){ee===void 0&&(ee="");var te=this.rules.inline.emStrong.lDelim.exec(le);if(!!te&&!(te[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=te[1]||te[2]||"";if(!F||F&&(ee===""||this.rules.inline.punctuation.exec(ee))){var $=te[0].length-1,K,X,me=$,Ee=0,oe=te[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,pe=pe.slice(-1*le.length+$);(te=oe.exec(pe))!=null;)if(K=te[1]||te[2]||te[3]||te[4]||te[5]||te[6],!!K){if(X=K.length,te[3]||te[4]){me+=X;continue}else if((te[5]||te[6])&&$%3&&!(($+X)%3)){Ee+=X;continue}if(me-=X,!(me>0)){if(X=Math.min(X,X+me+Ee),Math.min($,X)%2){var De=le.slice(1,$+te.index+X);return{type:"em",raw:le.slice(0,$+te.index+X+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var Ce=le.slice(2,$+te.index+X-1);return{type:"strong",raw:le.slice(0,$+te.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}}}}},Te.codespan=function(le){var pe=this.rules.inline.code.exec(le);if(pe){var ee=pe[2].replace(/\n/g," "),te=/[^ ]/.test(ee),F=/^ /.test(ee)&&/ $/.test(ee);return te&&F&&(ee=ee.substring(1,ee.length-1)),ee=_(ee,!0),{type:"codespan",raw:pe[0],text:ee}}},Te.br=function(le){var pe=this.rules.inline.br.exec(le);if(pe)return{type:"br",raw:pe[0]}},Te.del=function(le){var pe=this.rules.inline.del.exec(le);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2],[])}},Te.autolink=function(le,pe){var ee=this.rules.inline.autolink.exec(le);if(ee){var te,F;return ee[2]==="@"?(te=_(this.options.mangle?pe(ee[1]):ee[1]),F="mailto:"+te):(te=_(ee[1]),F=te),{type:"link",raw:ee[0],text:te,href:F,tokens:[{type:"text",raw:te,text:te}]}}},Te.url=function(le,pe){var ee;if(ee=this.rules.inline.url.exec(le)){var te,F;if(ee[2]==="@")te=_(this.options.mangle?pe(ee[0]):ee[0]),F="mailto:"+te;else{var $;do $=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while($!==ee[0]);te=_(ee[0]),ee[1]==="www."?F="http://"+te:F=te}return{type:"link",raw:ee[0],text:te,href:F,tokens:[{type:"text",raw:te,text:te}]}}},Te.inlineText=function(le,pe){var ee=this.rules.inline.text.exec(le);if(ee){var te;return this.lexer.state.inRawBlock?te=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):_(ee[0]):ee[0]:te=_(this.options.smartypants?pe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:te}}},ve}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=E(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=E(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=E(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=E(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=E(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=E(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=a({},B),B.gfm=a({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=E(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=E(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=a({},B.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:E(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=E(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=E(B._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=E(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=E(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=E(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=E(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=E(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=E(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=E(z.reflink).replace("label",z._label).replace("ref",B._label).getRegex(),z.nolink=E(z.nolink).replace("ref",B._label).getRegex(),z.reflinkSearch=E(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=a({},z),z.pedantic=a({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=a({},z.normal,{escape:E(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=E(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=a({},z.gfm,{br:E(z.br).replace("{2,}","*").getRegex(),text:E(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function re(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(ve){var Te="",Ae,le,pe=ve.length;for(Ae=0;Ae<pe;Ae++)le=ve.charCodeAt(Ae),Math.random()>.5&&(le="x"+le.toString(16)),Te+="&#"+le+";";return Te}var M=function(){function ve(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Y.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var le={block:B.normal,inline:z.normal};this.options.pedantic?(le.block=B.pedantic,le.inline=z.pedantic):this.options.gfm&&(le.block=B.gfm,this.options.breaks?le.inline=z.breaks:le.inline=z.gfm),this.tokenizer.rules=le}ve.lex=function(le,pe){var ee=new ve(pe);return ee.lex(le)},ve.lexInline=function(le,pe){var ee=new ve(pe);return ee.inlineTokens(le)};var Te=ve.prototype;return Te.lex=function(le){le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens);for(var pe;pe=this.inlineQueue.shift();)this.inlineTokens(pe.src,pe.tokens);return this.tokens},Te.blockTokens=function(le,pe){var ee=this;pe===void 0&&(pe=[]),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var te,F,$,K;le;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(te=me.call({lexer:ee},le,pe))?(le=le.substring(te.raw.length),pe.push(te),!0):!1}))){if(te=this.tokenizer.space(le)){le=le.substring(te.raw.length),te.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(te);continue}if(te=this.tokenizer.code(le)){le=le.substring(te.raw.length),F=pe[pe.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+te.raw,F.text+=`
`+te.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):pe.push(te);continue}if(te=this.tokenizer.fences(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.heading(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.hr(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.blockquote(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.list(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.html(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.def(le)){le=le.substring(te.raw.length),F=pe[pe.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+te.raw,F.text+=`
`+te.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[te.tag]||(this.tokens.links[te.tag]={href:te.href,title:te.title});continue}if(te=this.tokenizer.table(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.lheading(le)){le=le.substring(te.raw.length),pe.push(te);continue}if($=le,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,Ee=le.slice(1),oe=void 0;ee.options.extensions.startBlock.forEach(function(De){oe=De.call({lexer:this},Ee),typeof oe=="number"&&oe>=0&&(me=Math.min(me,oe))}),me<1/0&&me>=0&&($=le.substring(0,me+1))}(),this.state.top&&(te=this.tokenizer.paragraph($))){F=pe[pe.length-1],K&&F.type==="paragraph"?(F.raw+=`
`+te.raw,F.text+=`
`+te.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):pe.push(te),K=$.length!==le.length,le=le.substring(te.raw.length);continue}if(te=this.tokenizer.text(le)){le=le.substring(te.raw.length),F=pe[pe.length-1],F&&F.type==="text"?(F.raw+=`
`+te.raw,F.text+=`
`+te.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):pe.push(te);continue}if(le){var X="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,pe},Te.inline=function(le,pe){this.inlineQueue.push({src:le,tokens:pe})},Te.inlineTokens=function(le,pe){var ee=this;pe===void 0&&(pe=[]);var te,F,$,K=le,X,me,Ee;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)oe.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,X.index)+"["+O("a",X[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,X.index)+"["+O("a",X[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,X.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;)if(me||(Ee=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(te=Ce.call({lexer:ee},le,pe))?(le=le.substring(te.raw.length),pe.push(te),!0):!1}))){if(te=this.tokenizer.escape(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.tag(le)){le=le.substring(te.raw.length),F=pe[pe.length-1],F&&te.type==="text"&&F.type==="text"?(F.raw+=te.raw,F.text+=te.text):pe.push(te);continue}if(te=this.tokenizer.link(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(te.raw.length),F=pe[pe.length-1],F&&te.type==="text"&&F.type==="text"?(F.raw+=te.raw,F.text+=te.text):pe.push(te);continue}if(te=this.tokenizer.emStrong(le,K,Ee)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.codespan(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.br(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.del(le)){le=le.substring(te.raw.length),pe.push(te);continue}if(te=this.tokenizer.autolink(le,H)){le=le.substring(te.raw.length),pe.push(te);continue}if(!this.state.inLink&&(te=this.tokenizer.url(le,H))){le=le.substring(te.raw.length),pe.push(te);continue}if($=le,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,We=le.slice(1),je=void 0;ee.options.extensions.startInline.forEach(function(Fe){je=Fe.call({lexer:this},We),typeof je=="number"&&je>=0&&(Ce=Math.min(Ce,je))}),Ce<1/0&&Ce>=0&&($=le.substring(0,Ce+1))}(),te=this.tokenizer.inlineText($,re)){le=le.substring(te.raw.length),te.raw.slice(-1)!=="_"&&(Ee=te.raw.slice(-1)),me=!0,F=pe[pe.length-1],F&&F.type==="text"?(F.raw+=te.raw,F.text+=te.text):pe.push(te);continue}if(le){var De="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return pe},d(ve,null,[{key:"rules",get:function(){return{block:B,inline:z}}}]),ve}(),j=function(){function ve(Ae){this.options=Ae||Y.defaults}var Te=ve.prototype;return Te.code=function(le,pe,ee){var te=(pe||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(le,te);F!=null&&F!==le&&(ee=!0,le=F)}return le=le.replace(/\n$/,"")+`
`,te?'<pre><code class="'+this.options.langPrefix+_(te,!0)+'">'+(ee?le:_(le,!0))+`</code></pre>
`:"<pre><code>"+(ee?le:_(le,!0))+`</code></pre>
`},Te.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},Te.html=function(le){return le},Te.heading=function(le,pe,ee,te){return this.options.headerIds?"<h"+pe+' id="'+this.options.headerPrefix+te.slug(ee)+'">'+le+"</h"+pe+`>
`:"<h"+pe+">"+le+"</h"+pe+`>
`},Te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Te.list=function(le,pe,ee){var te=pe?"ol":"ul",F=pe&&ee!==1?' start="'+ee+'"':"";return"<"+te+F+`>
`+le+"</"+te+`>
`},Te.listitem=function(le){return"<li>"+le+`</li>
`},Te.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Te.paragraph=function(le){return"<p>"+le+`</p>
`},Te.table=function(le,pe){return pe&&(pe="<tbody>"+pe+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+pe+`</table>
`},Te.tablerow=function(le){return`<tr>
`+le+`</tr>
`},Te.tablecell=function(le,pe){var ee=pe.header?"th":"td",te=pe.align?"<"+ee+' align="'+pe.align+'">':"<"+ee+">";return te+le+"</"+ee+`>
`},Te.strong=function(le){return"<strong>"+le+"</strong>"},Te.em=function(le){return"<em>"+le+"</em>"},Te.codespan=function(le){return"<code>"+le+"</code>"},Te.br=function(){return this.options.xhtml?"<br/>":"<br>"},Te.del=function(le){return"<del>"+le+"</del>"},Te.link=function(le,pe,ee){if(le=f(this.options.sanitize,this.options.baseUrl,le),le===null)return ee;var te='<a href="'+_(le)+'"';return pe&&(te+=' title="'+pe+'"'),te+=">"+ee+"</a>",te},Te.image=function(le,pe,ee){if(le=f(this.options.sanitize,this.options.baseUrl,le),le===null)return ee;var te='<img src="'+le+'" alt="'+ee+'"';return pe&&(te+=' title="'+pe+'"'),te+=this.options.xhtml?"/>":">",te},Te.text=function(le){return le},ve}(),V=function(){function ve(){}var Te=ve.prototype;return Te.strong=function(le){return le},Te.em=function(le){return le},Te.codespan=function(le){return le},Te.del=function(le){return le},Te.html=function(le){return le},Te.text=function(le){return le},Te.link=function(le,pe,ee){return""+ee},Te.image=function(le,pe,ee){return""+ee},Te.br=function(){return""},ve}(),q=function(){function ve(){this.seen={}}var Te=ve.prototype;return Te.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Te.getNextSafeSlug=function(le,pe){var ee=le,te=0;if(this.seen.hasOwnProperty(ee)){te=this.seen[le];do te++,ee=le+"-"+te;while(this.seen.hasOwnProperty(ee))}return pe||(this.seen[le]=te,this.seen[ee]=0),ee},Te.slug=function(le,pe){pe===void 0&&(pe={});var ee=this.serialize(le);return this.getNextSafeSlug(ee,pe.dryrun)},ve}(),ie=function(){function ve(Ae){this.options=Ae||Y.defaults,this.options.renderer=this.options.renderer||new j,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new q}ve.parse=function(le,pe){var ee=new ve(pe);return ee.parse(le)},ve.parseInline=function(le,pe){var ee=new ve(pe);return ee.parseInline(le)};var Te=ve.prototype;return Te.parse=function(le,pe){pe===void 0&&(pe=!0);var ee="",te,F,$,K,X,me,Ee,oe,De,Ce,We,je,Fe,Ye,J,se,_e,ae,ye,Ne=le.length;for(te=0;te<Ne;te++){if(Ce=le[te],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(ye=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),ye!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){ee+=ye||"";continue}switch(Ce.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,v(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(oe="",Ee="",K=Ce.header.length,F=0;F<K;F++)Ee+=this.renderer.tablecell(this.parseInline(Ce.header[F].tokens),{header:!0,align:Ce.align[F]});for(oe+=this.renderer.tablerow(Ee),De="",K=Ce.rows.length,F=0;F<K;F++){for(me=Ce.rows[F],Ee="",X=me.length,$=0;$<X;$++)Ee+=this.renderer.tablecell(this.parseInline(me[$].tokens),{header:!1,align:Ce.align[$]});De+=this.renderer.tablerow(Ee)}ee+=this.renderer.table(oe,De);continue}case"blockquote":{De=this.parse(Ce.tokens),ee+=this.renderer.blockquote(De);continue}case"list":{for(We=Ce.ordered,je=Ce.start,Fe=Ce.loose,K=Ce.items.length,De="",F=0;F<K;F++)J=Ce.items[F],se=J.checked,_e=J.task,Ye="",J.task&&(ae=this.renderer.checkbox(se),Fe?J.tokens.length>0&&J.tokens[0].type==="paragraph"?(J.tokens[0].text=ae+" "+J.tokens[0].text,J.tokens[0].tokens&&J.tokens[0].tokens.length>0&&J.tokens[0].tokens[0].type==="text"&&(J.tokens[0].tokens[0].text=ae+" "+J.tokens[0].tokens[0].text)):J.tokens.unshift({type:"text",text:ae}):Ye+=ae),Ye+=this.parse(J.tokens,Fe),De+=this.renderer.listitem(Ye,_e,se);ee+=this.renderer.list(De,We,je);continue}case"html":{ee+=this.renderer.html(Ce.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(De=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;te+1<Ne&&le[te+1].type==="text";)Ce=le[++te],De+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);ee+=pe?this.renderer.paragraph(De):De;continue}default:{var He='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return ee},Te.parseInline=function(le,pe){pe=pe||this.renderer;var ee="",te,F,$,K=le.length;for(te=0;te<K;te++){if(F=le[te],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&($=this.options.extensions.renderers[F.type].call({parser:this},F),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){ee+=$||"";continue}switch(F.type){case"escape":{ee+=pe.text(F.text);break}case"html":{ee+=pe.html(F.text);break}case"link":{ee+=pe.link(F.href,F.title,this.parseInline(F.tokens,pe));break}case"image":{ee+=pe.image(F.href,F.title,F.text);break}case"strong":{ee+=pe.strong(this.parseInline(F.tokens,pe));break}case"em":{ee+=pe.em(this.parseInline(F.tokens,pe));break}case"codespan":{ee+=pe.codespan(F.text);break}case"br":{ee+=pe.br();break}case"del":{ee+=pe.del(this.parseInline(F.tokens,pe));break}case"text":{ee+=pe.text(F.text);break}default:{var X='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ee},ve}();function Q(ve,Te,Ae){if(typeof ve=="undefined"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof Te=="function"&&(Ae=Te,Te=null),Te=a({},Q.defaults,Te||{}),R(Te),Ae){var le=Te.highlight,pe;try{pe=M.lex(ve,Te)}catch($){return Ae($)}var ee=function(K){var X;if(!K)try{Te.walkTokens&&Q.walkTokens(pe,Te.walkTokens),X=ie.parse(pe,Te)}catch(me){K=me}return Te.highlight=le,K?Ae(K):Ae(null,X)};if(!le||le.length<3||(delete Te.highlight,!pe.length))return ee();var te=0;Q.walkTokens(pe,function($){$.type==="code"&&(te++,setTimeout(function(){le($.text,$.lang,function(K,X){if(K)return ee(K);X!=null&&X!==$.text&&($.text=X,$.escaped=!0),te--,te===0&&ee()})},0))}),te===0&&ee();return}try{var F=M.lex(ve,Te);return Te.walkTokens&&Q.walkTokens(F,Te.walkTokens),ie.parse(F,Te)}catch($){if($.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+_($.message+"",!0)+"</pre>";throw $}}Q.options=Q.setOptions=function(ve){return a(Q.defaults,ve),D(Q.defaults),Q},Q.getDefaults=I,Q.defaults=Y.defaults,Q.use=function(){for(var ve=arguments.length,Te=new Array(ve),Ae=0;Ae<ve;Ae++)Te[Ae]=arguments[Ae];var le=a.apply(void 0,[{}].concat(Te)),pe=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;Te.forEach(function(te){if(te.extensions&&(ee=!0,te.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var K=pe.renderers?pe.renderers[$.name]:null;K?pe.renderers[$.name]=function(){for(var X=arguments.length,me=new Array(X),Ee=0;Ee<X;Ee++)me[Ee]=arguments[Ee];var oe=$.renderer.apply(this,me);return oe===!1&&(oe=K.apply(this,me)),oe}:pe.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");pe[$.level]?pe[$.level].unshift($.tokenizer):pe[$.level]=[$.tokenizer],$.start&&($.level==="block"?pe.startBlock?pe.startBlock.push($.start):pe.startBlock=[$.start]:$.level==="inline"&&(pe.startInline?pe.startInline.push($.start):pe.startInline=[$.start]))}$.childTokens&&(pe.childTokens[$.name]=$.childTokens)})),te.renderer&&function(){var $=Q.defaults.renderer||new j,K=function(Ee){var oe=$[Ee];$[Ee]=function(){for(var De=arguments.length,Ce=new Array(De),We=0;We<De;We++)Ce[We]=arguments[We];var je=te.renderer[Ee].apply($,Ce);return je===!1&&(je=oe.apply($,Ce)),je}};for(var X in te.renderer)K(X);le.renderer=$}(),te.tokenizer&&function(){var $=Q.defaults.tokenizer||new U,K=function(Ee){var oe=$[Ee];$[Ee]=function(){for(var De=arguments.length,Ce=new Array(De),We=0;We<De;We++)Ce[We]=arguments[We];var je=te.tokenizer[Ee].apply($,Ce);return je===!1&&(je=oe.apply($,Ce)),je}};for(var X in te.tokenizer)K(X);le.tokenizer=$}(),te.walkTokens){var F=Q.defaults.walkTokens;le.walkTokens=function($){te.walkTokens.call(this,$),F&&F.call(this,$)}}ee&&(le.extensions=pe),Q.setOptions(le)})},Q.walkTokens=function(ve,Te){for(var Ae=function(){var te=pe.value;switch(Te.call(Q,te),te.type){case"table":{for(var F=P(te.header),$;!($=F()).done;){var K=$.value;Q.walkTokens(K.tokens,Te)}for(var X=P(te.rows),me;!(me=X()).done;)for(var Ee=me.value,oe=P(Ee),De;!(De=oe()).done;){var Ce=De.value;Q.walkTokens(Ce.tokens,Te)}break}case"list":{Q.walkTokens(te.items,Te);break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[te.type]?Q.defaults.extensions.childTokens[te.type].forEach(function(We){Q.walkTokens(te[We],Te)}):te.tokens&&Q.walkTokens(te.tokens,Te)}},le=P(ve),pe;!(pe=le()).done;)Ae()},Q.parseInline=function(ve,Te){if(typeof ve=="undefined"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");Te=a({},Q.defaults,Te||{}),R(Te);try{var Ae=M.lexInline(ve,Te);return Te.walkTokens&&Q.walkTokens(Ae,Te.walkTokens),ie.parseInline(Ae,Te)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+_(le.message+"",!0)+"</pre>";throw le}},Q.Parser=ie,Q.parser=ie.parse,Q.Renderer=j,Q.TextRenderer=V,Q.Lexer=M,Q.lexer=M.lex,Q.Tokenizer=U,Q.Slugger=q,Q.parse=Q;var ue=Q.options,ce=Q.setOptions,G=Q.use,ge=Q.walkTokens,ne=Q.parseInline,he=Q,Se=ie.parse,Re=M.lex;Y.Lexer=M,Y.Parser=ie,Y.Renderer=j,Y.Slugger=q,Y.TextRenderer=V,Y.Tokenizer=U,Y.getDefaults=I,Y.lexer=Re,Y.marked=Q,Y.options=ue,Y.parse=he,Y.parseInline=ne,Y.parser=Se,Y.setOptions=ce,Y.use=G,Y.walkTokens=ge,Object.defineProperty(Y,"__esModule",{value:!0})}),define(Ie[93],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(D,b,A){return Math.min(Math.max(D,b),A)}e.clamp=d;function i(D,b){return(b+D%b)%b}e.rot=i;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class P{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class I{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const A=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function Y(C){const P=[];typeof C=="number"&&P.push("code/timeOrigin",C);function I(b){P.push(b,Date.now())}function D(){const b=[];for(let A=0;A<P.length;A+=2)b.push({name:P[A],startTime:P[A+1]});return b}return{mark:I,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const I of performance.getEntriesByType("mark"))P.push({name:I.name,startTime:Math.round(C+I.startTime)});return P}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function d(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=d(i))}(),define(Ie[12],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const d="en";let i=!1,C=!1,P=!1,I=!1,D=!1,b=!1,A=!1,L=!1,k=!1,y,T=d,_,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const g=typeof v?.versions?.electron=="string",E=g&&v?.type==="renderer";if(typeof navigator=="object"&&!E)m=navigator.userAgent,i=m.indexOf("Windows")>=0,C=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=m.indexOf("Linux")>=0,b=!0,y=navigator.language,T=y;else if(typeof v=="object"){i=v.platform==="win32",C=v.platform==="darwin",P=v.platform==="linux",I=P&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,A=g,k=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=d,T=d;const t=v.env.VSCODE_NLS_CONFIG;if(t)try{const a=JSON.parse(t),u=a.availableLanguages["*"];y=a.locale,T=u||d,_=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var h;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let f=0;C?f=1:i?f=3:P&&(f=2),e.isWindows=i,e.isMacintosh=C,e.isLinux=P,e.isLinuxSnap=I,e.isNative=D,e.isElectron=A,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isCI=k,e.platform=f,e.userAgent=m,e.language=T;var o;(function(t){function a(){return e.language}t.value=a;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=u;function c(){return e.language==="en"}t.isDefault=c})(o=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=_,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let t=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let c=0,S=t.length;c<S;c++){const R=t[c];if(R.id===u.data.vscodeScheduleAsyncWork){t.splice(c,1),R.callback();return}}});let a=0;return u=>{const c=++a;t.push({id:c,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:c},"*")}}return t=>setTimeout(t)})();var w;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(w=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||L?2:i?1:3;let r=!0,s=!1;function n(){if(!s){s=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,r=new Uint16Array(t.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[40],ke([1,0,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const C=d.globals.vscode.process;i={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(Ie[9],ke([1,0,40]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,C=97,P=90,I=122,D=46,b=47,A=92,L=58,k=63;class y extends Error{constructor(l,f,o){let w;typeof f=="string"&&f.indexOf("not ")===0?(w="must not be",f=f.replace(/^not /,"")):w="must be";const r=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${r} ${w} of type ${f}`;s+=`. Received type ${typeof o}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function T(h,l){if(typeof h!="string")throw new y(l,"string",h)}function _(h){return h===b||h===A}function m(h){return h===b}function v(h){return h>=i&&h<=P||h>=C&&h<=I}function g(h,l,f,o){let w="",r=0,s=-1,n=0,t=0;for(let a=0;a<=h.length;++a){if(a<h.length)t=h.charCodeAt(a);else{if(o(t))break;t=b}if(o(t)){if(!(s===a-1||n===1))if(n===2){if(w.length<2||r!==2||w.charCodeAt(w.length-1)!==D||w.charCodeAt(w.length-2)!==D){if(w.length>2){const u=w.lastIndexOf(f);u===-1?(w="",r=0):(w=w.slice(0,u),r=w.length-1-w.lastIndexOf(f)),s=a,n=0;continue}else if(w.length!==0){w="",r=0,s=a,n=0;continue}}l&&(w+=w.length>0?`${f}..`:"..",r=2)}else w.length>0?w+=`${f}${h.slice(s+1,a)}`:w=h.slice(s+1,a),r=a-s-1;s=a,n=0}else t===D&&n!==-1?++n:n=-1}return w}function E(h,l){if(l===null||typeof l!="object")throw new y("pathObject","Object",l);const f=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${o}`:`${f}${h}${o}`:o}e.win32={resolve(...h){let l="",f="",o=!1;for(let w=h.length-1;w>=-1;w--){let r;if(w>=0){if(r=h[w],T(r,"path"),r.length===0)continue}else l.length===0?r=d.cwd():(r=d.env[`=${l}`]||d.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===A)&&(r=`${l}\\`));const s=r.length;let n=0,t="",a=!1;const u=r.charCodeAt(0);if(s===1)_(u)&&(n=1,a=!0);else if(_(u))if(a=!0,_(r.charCodeAt(1))){let c=2,S=c;for(;c<s&&!_(r.charCodeAt(c));)c++;if(c<s&&c!==S){const R=r.slice(S,c);for(S=c;c<s&&_(r.charCodeAt(c));)c++;if(c<s&&c!==S){for(S=c;c<s&&!_(r.charCodeAt(c));)c++;(c===s||c!==S)&&(t=`\\\\${R}\\${r.slice(S,c)}`,n=c)}}}else n=1;else v(u)&&r.charCodeAt(1)===L&&(t=r.slice(0,2),n=2,s>2&&_(r.charCodeAt(2))&&(a=!0,n=3));if(t.length>0)if(l.length>0){if(t.toLowerCase()!==l.toLowerCase())continue}else l=t;if(o){if(l.length>0)break}else if(f=`${r.slice(n)}\\${f}`,o=a,a&&l.length>0)break}return f=g(f,!o,"\\",_),o?`${l}\\${f}`:`${l}${f}`||"."},normalize(h){T(h,"path");const l=h.length;if(l===0)return".";let f=0,o,w=!1;const r=h.charCodeAt(0);if(l===1)return m(r)?"\\":h;if(_(r))if(w=!0,_(h.charCodeAt(1))){let n=2,t=n;for(;n<l&&!_(h.charCodeAt(n));)n++;if(n<l&&n!==t){const a=h.slice(t,n);for(t=n;n<l&&_(h.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&!_(h.charCodeAt(n));)n++;if(n===l)return`\\\\${a}\\${h.slice(t)}\\`;n!==t&&(o=`\\\\${a}\\${h.slice(t,n)}`,f=n)}}}else f=1;else v(r)&&h.charCodeAt(1)===L&&(o=h.slice(0,2),f=2,l>2&&_(h.charCodeAt(2))&&(w=!0,f=3));let s=f<l?g(h.slice(f),!w,"\\",_):"";return s.length===0&&!w&&(s="."),s.length>0&&_(h.charCodeAt(l-1))&&(s+="\\"),o===void 0?w?`\\${s}`:s:w?`${o}\\${s}`:`${o}${s}`},isAbsolute(h){T(h,"path");const l=h.length;if(l===0)return!1;const f=h.charCodeAt(0);return _(f)||l>2&&v(f)&&h.charCodeAt(1)===L&&_(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let l,f;for(let r=0;r<h.length;++r){const s=h[r];T(s,"path"),s.length>0&&(l===void 0?l=f=s:l+=`\\${s}`)}if(l===void 0)return".";let o=!0,w=0;if(typeof f=="string"&&_(f.charCodeAt(0))){++w;const r=f.length;r>1&&_(f.charCodeAt(1))&&(++w,r>2&&(_(f.charCodeAt(2))?++w:o=!1))}if(o){for(;w<l.length&&_(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return e.win32.normalize(l)},relative(h,l){if(T(h,"from"),T(l,"to"),h===l)return"";const f=e.win32.resolve(h),o=e.win32.resolve(l);if(f===o||(h=f.toLowerCase(),l=o.toLowerCase(),h===l))return"";let w=0;for(;w<h.length&&h.charCodeAt(w)===A;)w++;let r=h.length;for(;r-1>w&&h.charCodeAt(r-1)===A;)r--;const s=r-w;let n=0;for(;n<l.length&&l.charCodeAt(n)===A;)n++;let t=l.length;for(;t-1>n&&l.charCodeAt(t-1)===A;)t--;const a=t-n,u=s<a?s:a;let c=-1,S=0;for(;S<u;S++){const O=h.charCodeAt(w+S);if(O!==l.charCodeAt(n+S))break;O===A&&(c=S)}if(S!==u){if(c===-1)return o}else{if(a>u){if(l.charCodeAt(n+S)===A)return o.slice(n+S+1);if(S===2)return o.slice(n+S)}s>u&&(h.charCodeAt(w+S)===A?c=S:S===2&&(c=3)),c===-1&&(c=0)}let R="";for(S=w+c+1;S<=r;++S)(S===r||h.charCodeAt(S)===A)&&(R+=R.length===0?"..":"\\..");return n+=c,R.length>0?`${R}${o.slice(n,t)}`:(o.charCodeAt(n)===A&&++n,o.slice(n,t))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const l=e.win32.resolve(h);if(l.length<=2)return h;if(l.charCodeAt(0)===A){if(l.charCodeAt(1)===A){const f=l.charCodeAt(2);if(f!==k&&f!==D)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===A)return`\\\\?\\${l}`;return h},dirname(h){T(h,"path");const l=h.length;if(l===0)return".";let f=-1,o=0;const w=h.charCodeAt(0);if(l===1)return _(w)?h:".";if(_(w)){if(f=o=1,_(h.charCodeAt(1))){let n=2,t=n;for(;n<l&&!_(h.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&_(h.charCodeAt(n));)n++;if(n<l&&n!==t){for(t=n;n<l&&!_(h.charCodeAt(n));)n++;if(n===l)return h;n!==t&&(f=o=n+1)}}}}else v(w)&&h.charCodeAt(1)===L&&(f=l>2&&_(h.charCodeAt(2))?3:2,o=f);let r=-1,s=!0;for(let n=l-1;n>=o;--n)if(_(h.charCodeAt(n))){if(!s){r=n;break}}else s=!1;if(r===-1){if(f===-1)return".";r=f}return h.slice(0,r)},basename(h,l){l!==void 0&&T(l,"ext"),T(h,"path");let f=0,o=-1,w=!0,r;if(h.length>=2&&v(h.charCodeAt(0))&&h.charCodeAt(1)===L&&(f=2),l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let s=l.length-1,n=-1;for(r=h.length-1;r>=f;--r){const t=h.charCodeAt(r);if(_(t)){if(!w){f=r+1;break}}else n===-1&&(w=!1,n=r+1),s>=0&&(t===l.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return f===o?o=n:o===-1&&(o=h.length),h.slice(f,o)}for(r=h.length-1;r>=f;--r)if(_(h.charCodeAt(r))){if(!w){f=r+1;break}}else o===-1&&(w=!1,o=r+1);return o===-1?"":h.slice(f,o)},extname(h){T(h,"path");let l=0,f=-1,o=0,w=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===L&&v(h.charCodeAt(0))&&(l=o=2);for(let n=h.length-1;n>=l;--n){const t=h.charCodeAt(n);if(_(t)){if(!r){o=n+1;break}continue}w===-1&&(r=!1,w=n+1),t===D?f===-1?f=n:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||w===-1||s===0||s===1&&f===w-1&&f===o+1?"":h.slice(f,w)},format:E.bind(null,"\\"),parse(h){T(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const f=h.length;let o=0,w=h.charCodeAt(0);if(f===1)return _(w)?(l.root=l.dir=h,l):(l.base=l.name=h,l);if(_(w)){if(o=1,_(h.charCodeAt(1))){let c=2,S=c;for(;c<f&&!_(h.charCodeAt(c));)c++;if(c<f&&c!==S){for(S=c;c<f&&_(h.charCodeAt(c));)c++;if(c<f&&c!==S){for(S=c;c<f&&!_(h.charCodeAt(c));)c++;c===f?o=c:c!==S&&(o=c+1)}}}}else if(v(w)&&h.charCodeAt(1)===L){if(f<=2)return l.root=l.dir=h,l;if(o=2,_(h.charCodeAt(2))){if(f===3)return l.root=l.dir=h,l;o=3}}o>0&&(l.root=h.slice(0,o));let r=-1,s=o,n=-1,t=!0,a=h.length-1,u=0;for(;a>=o;--a){if(w=h.charCodeAt(a),_(w)){if(!t){s=a+1;break}continue}n===-1&&(t=!1,n=a+1),w===D?r===-1?r=a:u!==1&&(u=1):r!==-1&&(u=-1)}return n!==-1&&(r===-1||u===0||u===1&&r===n-1&&r===s+1?l.base=l.name=h.slice(s,n):(l.name=h.slice(s,r),l.base=h.slice(s,n),l.ext=h.slice(r,n))),s>0&&s!==o?l.dir=h.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let l="",f=!1;for(let o=h.length-1;o>=-1&&!f;o--){const w=o>=0?h[o]:d.cwd();T(w,"path"),w.length!==0&&(l=`${w}/${l}`,f=w.charCodeAt(0)===b)}return l=g(l,!f,"/",m),f?`/${l}`:l.length>0?l:"."},normalize(h){if(T(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===b,f=h.charCodeAt(h.length-1)===b;return h=g(h,!l,"/",m),h.length===0?l?"/":f?"./":".":(f&&(h+="/"),l?`/${h}`:h)},isAbsolute(h){return T(h,"path"),h.length>0&&h.charCodeAt(0)===b},join(...h){if(h.length===0)return".";let l;for(let f=0;f<h.length;++f){const o=h[f];T(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":e.posix.normalize(l)},relative(h,l){if(T(h,"from"),T(l,"to"),h===l||(h=e.posix.resolve(h),l=e.posix.resolve(l),h===l))return"";const f=1,o=h.length,w=o-f,r=1,s=l.length-r,n=w<s?w:s;let t=-1,a=0;for(;a<n;a++){const c=h.charCodeAt(f+a);if(c!==l.charCodeAt(r+a))break;c===b&&(t=a)}if(a===n)if(s>n){if(l.charCodeAt(r+a)===b)return l.slice(r+a+1);if(a===0)return l.slice(r+a)}else w>n&&(h.charCodeAt(f+a)===b?t=a:a===0&&(t=0));let u="";for(a=f+t+1;a<=o;++a)(a===o||h.charCodeAt(a)===b)&&(u+=u.length===0?"..":"/..");return`${u}${l.slice(r+t)}`},toNamespacedPath(h){return h},dirname(h){if(T(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===b;let f=-1,o=!0;for(let w=h.length-1;w>=1;--w)if(h.charCodeAt(w)===b){if(!o){f=w;break}}else o=!1;return f===-1?l?"/":".":l&&f===1?"//":h.slice(0,f)},basename(h,l){l!==void 0&&T(l,"ext"),T(h,"path");let f=0,o=-1,w=!0,r;if(l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let s=l.length-1,n=-1;for(r=h.length-1;r>=0;--r){const t=h.charCodeAt(r);if(t===b){if(!w){f=r+1;break}}else n===-1&&(w=!1,n=r+1),s>=0&&(t===l.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=n))}return f===o?o=n:o===-1&&(o=h.length),h.slice(f,o)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===b){if(!w){f=r+1;break}}else o===-1&&(w=!1,o=r+1);return o===-1?"":h.slice(f,o)},extname(h){T(h,"path");let l=-1,f=0,o=-1,w=!0,r=0;for(let s=h.length-1;s>=0;--s){const n=h.charCodeAt(s);if(n===b){if(!w){f=s+1;break}continue}o===-1&&(w=!1,o=s+1),n===D?l===-1?l=s:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||o===-1||r===0||r===1&&l===o-1&&l===f+1?"":h.slice(l,o)},format:E.bind(null,"/"),parse(h){T(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const f=h.charCodeAt(0)===b;let o;f?(l.root="/",o=1):o=0;let w=-1,r=0,s=-1,n=!0,t=h.length-1,a=0;for(;t>=o;--t){const u=h.charCodeAt(t);if(u===b){if(!n){r=t+1;break}continue}s===-1&&(n=!1,s=t+1),u===D?w===-1?w=t:a!==1&&(a=1):w!==-1&&(a=-1)}if(s!==-1){const u=r===0&&f?1:r;w===-1||a===0||a===1&&w===s-1&&w===r+1?l.base=l.name=h.slice(u,s):(l.name=h.slice(u,w),l.base=h.slice(u,s),l.ext=h.slice(w,s))}return r>0?l.dir=h.slice(0,r-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[94],ke([1,0,9]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(k){k.text="text/plain",k.binary="application/octet-stream",k.unknown="application/unknown",k.markdown="text/markdown",k.latex="text/latex",k.uriList="text/uri-list"})(i=e.Mimes||(e.Mimes={}));const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(k){const y=(0,d.extname)(k),T=C[y.toLowerCase()];return T!==void 0?T:D(k)}e.getMediaOrTextMime=I;function D(k){const y=(0,d.extname)(k);return P[y.toLowerCase()]}e.getMediaMime=D;function b(k){for(const y in P)if(P[y]===k)return y}e.getExtensionForMimeType=b;const A=/^(.+)\/(.+?)(;.+)?$/;function L(k,y){const T=A.exec(k);return T?`${T[1].toLowerCase()}/${T[2].toLowerCase()}${T[3]??""}`:y?void 0:k}e.normalizeMimeType=L}),define(Ie[95],ke([1,0,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var C;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(D,...b){const A=b.reduce((y,T)=>(y[T]=!0,y),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(y=>!A[y]).forEach(y=>{for(let T=0;T<L.length;T++)if(y.search(L[T])!==-1){delete D[y];break}})}e.sanitizeProcessEnvironment=P;function I(D){!D||(delete D.DEBUG,d.isMacintosh&&delete D.DYLD_LIBRARY_PATH,d.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var i in d)(typeof exports=="object"?exports:Y)[i]=d[i]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function d(i){if(e[i])return e[i].exports;var C=e[i]={i,l:!1,exports:{}};return Y[i].call(C.exports,C,C.exports,d),C.l=!0,C.exports}return d.m=Y,d.c=e,d.d=function(i,C,P){d.o(i,C)||Object.defineProperty(i,C,{enumerable:!0,get:P})},d.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},d.t=function(i,C){if(1&C&&(i=d(i)),8&C||4&C&&typeof i=="object"&&i&&i.__esModule)return i;var P=Object.create(null);if(d.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:i}),2&C&&typeof i!="string")for(var I in i)d.d(P,I,function(D){return i[D]}.bind(null,I));return P},d.n=function(i){var C=i&&i.__esModule?function(){return i.default}:function(){return i};return d.d(C,"a",C),C},d.o=function(i,C){return Object.prototype.hasOwnProperty.call(i,C)},d.p="",d(d.s=0)}([function(Y,e,d){(function(i){var C;e=Y.exports=G,C=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],b=e.src=[],A=0,L=A++;b[L]="0|[1-9]\\d*";var k=A++;b[k]="[0-9]+";var y=A++;b[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=A++;b[T]="("+b[L]+")\\.("+b[L]+")\\.("+b[L]+")";var _=A++;b[_]="("+b[k]+")\\.("+b[k]+")\\.("+b[k]+")";var m=A++;b[m]="(?:"+b[L]+"|"+b[y]+")";var v=A++;b[v]="(?:"+b[k]+"|"+b[y]+")";var g=A++;b[g]="(?:-("+b[m]+"(?:\\."+b[m]+")*))";var E=A++;b[E]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var h=A++;b[h]="[0-9A-Za-z-]+";var l=A++;b[l]="(?:\\+("+b[h]+"(?:\\."+b[h]+")*))";var f=A++,o="v?"+b[T]+b[g]+"?"+b[l]+"?";b[f]="^"+o+"$";var w="[v=\\s]*"+b[_]+b[E]+"?"+b[l]+"?",r=A++;b[r]="^"+w+"$";var s=A++;b[s]="((?:<|>)?=?)";var n=A++;b[n]=b[k]+"|x|X|\\*";var t=A++;b[t]=b[L]+"|x|X|\\*";var a=A++;b[a]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[g]+")?"+b[l]+"?)?)?";var u=A++;b[u]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[E]+")?"+b[l]+"?)?)?";var c=A++;b[c]="^"+b[s]+"\\s*"+b[a]+"$";var S=A++;b[S]="^"+b[s]+"\\s*"+b[u]+"$";var R=A++;b[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=A++;b[O]="(?:~>?)";var N=A++;b[N]="(\\s*)"+b[O]+"\\s+",D[N]=new RegExp(b[N],"g");var p=A++;b[p]="^"+b[O]+b[a]+"$";var U=A++;b[U]="^"+b[O]+b[u]+"$";var B=A++;b[B]="(?:\\^)";var z=A++;b[z]="(\\s*)"+b[B]+"\\s+",D[z]=new RegExp(b[z],"g");var re=A++;b[re]="^"+b[B]+b[a]+"$";var H=A++;b[H]="^"+b[B]+b[u]+"$";var M=A++;b[M]="^"+b[s]+"\\s*("+w+")$|^$";var j=A++;b[j]="^"+b[s]+"\\s*("+o+")$|^$";var V=A++;b[V]="(\\s*)"+b[s]+"\\s*("+w+"|"+b[a]+")",D[V]=new RegExp(b[V],"g");var q=A++;b[q]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var ie=A++;b[ie]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var Q=A++;b[Q]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,b[ue]),D[ue]||(D[ue]=new RegExp(b[ue]));function ce(oe,De){if(oe instanceof G)return oe;if(typeof oe!="string"||oe.length>P||!(De?D[r]:D[f]).test(oe))return null;try{return new G(oe,De)}catch{return null}}function G(oe,De){if(oe instanceof G){if(oe.loose===De)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof G))return new G(oe,De);C("SemVer",oe,De),this.loose=De;var Ce=oe.trim().match(De?D[r]:D[f]);if(!Ce)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var je=+We;if(je>=0&&je<I)return je}return We}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=ce,e.valid=function(oe,De){var Ce=ce(oe,De);return Ce?Ce.version:null},e.clean=function(oe,De){var Ce=ce(oe.trim().replace(/^[=v]+/,""),De);return Ce?Ce.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(oe){return C("SemVer.compare",this.version,this.loose,oe),oe instanceof G||(oe=new G(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},G.prototype.compareMain=function(oe){return oe instanceof G||(oe=new G(oe,this.loose)),ne(this.major,oe.major)||ne(this.minor,oe.minor)||ne(this.patch,oe.patch)},G.prototype.comparePre=function(oe){if(oe instanceof G||(oe=new G(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var De=0;do{var Ce=this.prerelease[De],We=oe.prerelease[De];if(C("prerelease compare",De,Ce,We),Ce===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==We)return ne(Ce,We)}while(++De)},G.prototype.inc=function(oe,De){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,De,Ce,We){typeof Ce=="string"&&(We=Ce,Ce=void 0);try{return new G(oe,Ce).inc(De,We).version}catch{return null}},e.diff=function(oe,De){if(ve(oe,De))return null;var Ce=ce(oe),We=ce(De);if(Ce.prerelease.length||We.prerelease.length){for(var je in Ce)if((je==="major"||je==="minor"||je==="patch")&&Ce[je]!==We[je])return"pre"+je;return"prerelease"}for(var je in Ce)if((je==="major"||je==="minor"||je==="patch")&&Ce[je]!==We[je])return je},e.compareIdentifiers=ne;var ge=/^[0-9]+$/;function ne(oe,De){var Ce=ge.test(oe),We=ge.test(De);return Ce&&We&&(oe=+oe,De=+De),Ce&&!We?-1:We&&!Ce?1:oe<De?-1:oe>De?1:0}function he(oe,De,Ce){return new G(oe,Ce).compare(new G(De,Ce))}function Se(oe,De,Ce){return he(oe,De,Ce)>0}function Re(oe,De,Ce){return he(oe,De,Ce)<0}function ve(oe,De,Ce){return he(oe,De,Ce)===0}function Te(oe,De,Ce){return he(oe,De,Ce)!==0}function Ae(oe,De,Ce){return he(oe,De,Ce)>=0}function le(oe,De,Ce){return he(oe,De,Ce)<=0}function pe(oe,De,Ce,We){var je;switch(De){case"===":typeof oe=="object"&&(oe=oe.version),typeof Ce=="object"&&(Ce=Ce.version),je=oe===Ce;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof Ce=="object"&&(Ce=Ce.version),je=oe!==Ce;break;case"":case"=":case"==":je=ve(oe,Ce,We);break;case"!=":je=Te(oe,Ce,We);break;case">":je=Se(oe,Ce,We);break;case">=":je=Ae(oe,Ce,We);break;case"<":je=Re(oe,Ce,We);break;case"<=":je=le(oe,Ce,We);break;default:throw new TypeError("Invalid operator: "+De)}return je}function ee(oe,De){if(oe instanceof ee){if(oe.loose===De)return oe;oe=oe.value}if(!(this instanceof ee))return new ee(oe,De);C("comparator",oe,De),this.loose=De,this.parse(oe),this.semver===te?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(oe,De){return ne(De,oe)},e.major=function(oe,De){return new G(oe,De).major},e.minor=function(oe,De){return new G(oe,De).minor},e.patch=function(oe,De){return new G(oe,De).patch},e.compare=he,e.compareLoose=function(oe,De){return he(oe,De,!0)},e.rcompare=function(oe,De,Ce){return he(De,oe,Ce)},e.sort=function(oe,De){return oe.sort(function(Ce,We){return e.compare(Ce,We,De)})},e.rsort=function(oe,De){return oe.sort(function(Ce,We){return e.rcompare(Ce,We,De)})},e.gt=Se,e.lt=Re,e.eq=ve,e.neq=Te,e.gte=Ae,e.lte=le,e.cmp=pe,e.Comparator=ee;var te={};function F(oe,De){if(oe instanceof F)return oe.loose===De?oe:new F(oe.raw,De);if(oe instanceof ee)return new F(oe.value,De);if(!(this instanceof F))return new F(oe,De);if(this.loose=De,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function $(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function K(oe,De,Ce,We,je,Fe,Ye,J,se,_e,ae,ye,Ne){return((De=$(Ce)?"":$(We)?">="+Ce+".0.0":$(je)?">="+Ce+"."+We+".0":">="+De)+" "+(J=$(se)?"":$(_e)?"<"+(+se+1)+".0.0":$(ae)?"<"+se+"."+(+_e+1)+".0":ye?"<="+se+"."+_e+"."+ae+"-"+ye:"<="+J)).trim()}function X(oe,De){for(var Ce=0;Ce<oe.length;Ce++)if(!oe[Ce].test(De))return!1;if(De.prerelease.length){for(Ce=0;Ce<oe.length;Ce++)if(C(oe[Ce].semver),oe[Ce].semver!==te&&oe[Ce].semver.prerelease.length>0){var We=oe[Ce].semver;if(We.major===De.major&&We.minor===De.minor&&We.patch===De.patch)return!0}return!1}return!0}function me(oe,De,Ce){try{De=new F(De,Ce)}catch{return!1}return De.test(oe)}function Ee(oe,De,Ce,We){var je,Fe,Ye,J,se;switch(oe=new G(oe,We),De=new F(De,We),Ce){case">":je=Se,Fe=le,Ye=Re,J=">",se=">=";break;case"<":je=Re,Fe=Ae,Ye=Se,J="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(oe,De,We))return!1;for(var _e=0;_e<De.set.length;++_e){var ae=De.set[_e],ye=null,Ne=null;if(ae.forEach(function(He){He.semver===te&&(He=new ee(">=0.0.0")),ye=ye||He,Ne=Ne||He,je(He.semver,ye.semver,We)?ye=He:Ye(He.semver,Ne.semver,We)&&(Ne=He)}),ye.operator===J||ye.operator===se||(!Ne.operator||Ne.operator===J)&&Fe(oe,Ne.semver)||Ne.operator===se&&Ye(oe,Ne.semver))return!1}return!0}ee.prototype.parse=function(oe){var De=this.loose?D[M]:D[j],Ce=oe.match(De);if(!Ce)throw new TypeError("Invalid comparator: "+oe);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new G(Ce[2],this.loose):this.semver=te},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(oe){return C("Comparator.test",oe,this.loose),this.semver===te||(typeof oe=="string"&&(oe=new G(oe,this.loose)),pe(oe,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(oe,De){if(!(oe instanceof ee))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new F(oe.value,De),me(this.value,Ce,De);if(oe.operator==="")return Ce=new F(this.value,De),me(oe.semver,Ce,De);var We=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Fe=this.semver.version===oe.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),J=pe(this.semver,"<",oe.semver,De)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),se=pe(this.semver,">",oe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return We||je||Fe&&Ye||J||se},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(oe){var De=this.loose;oe=oe.trim(),C("range",oe,De);var Ce=De?D[ie]:D[q];oe=oe.replace(Ce,K),C("hyphen replace",oe),oe=oe.replace(D[V],"$1$2$3"),C("comparator trim",oe,D[V]),oe=(oe=(oe=oe.replace(D[N],"$1~")).replace(D[z],"$1^")).split(/\s+/).join(" ");var We=De?D[M]:D[j],je=oe.split(" ").map(function(Fe){return function(Ye,J){return C("comp",Ye),Ye=function(se,_e){return se.trim().split(/\s+/).map(function(ae){return function(ye,Ne){C("caret",ye,Ne);var He=Ne?D[H]:D[re];return ye.replace(He,function(qe,Ge,Ze,Xe,rt){var tt;return C("caret",ye,qe,Ge,Ze,Xe,rt),$(Ge)?tt="":$(Ze)?tt=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":$(Xe)?tt=Ge==="0"?">="+Ge+"."+Ze+".0 <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+".0 <"+(+Ge+1)+".0.0":rt?(C("replaceCaret pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=Ge==="0"?Ze==="0"?">="+Ge+"."+Ze+"."+Xe+rt+" <"+Ge+"."+Ze+"."+(+Xe+1):">="+Ge+"."+Ze+"."+Xe+rt+" <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+"."+Xe+rt+" <"+(+Ge+1)+".0.0"):(C("no pr"),tt=Ge==="0"?Ze==="0"?">="+Ge+"."+Ze+"."+Xe+" <"+Ge+"."+Ze+"."+(+Xe+1):">="+Ge+"."+Ze+"."+Xe+" <"+Ge+"."+(+Ze+1)+".0":">="+Ge+"."+Ze+"."+Xe+" <"+(+Ge+1)+".0.0"),C("caret return",tt),tt})}(ae,_e)}).join(" ")}(Ye,J),C("caret",Ye),Ye=function(se,_e){return se.trim().split(/\s+/).map(function(ae){return function(ye,Ne){var He=Ne?D[U]:D[p];return ye.replace(He,function(qe,Ge,Ze,Xe,rt){var tt;return C("tilde",ye,qe,Ge,Ze,Xe,rt),$(Ge)?tt="":$(Ze)?tt=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":$(Xe)?tt=">="+Ge+"."+Ze+".0 <"+Ge+"."+(+Ze+1)+".0":rt?(C("replaceTilde pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),tt=">="+Ge+"."+Ze+"."+Xe+rt+" <"+Ge+"."+(+Ze+1)+".0"):tt=">="+Ge+"."+Ze+"."+Xe+" <"+Ge+"."+(+Ze+1)+".0",C("tilde return",tt),tt})}(ae,_e)}).join(" ")}(Ye,J),C("tildes",Ye),Ye=function(se,_e){return C("replaceXRanges",se,_e),se.split(/\s+/).map(function(ae){return function(ye,Ne){ye=ye.trim();var He=Ne?D[S]:D[c];return ye.replace(He,function(qe,Ge,Ze,Xe,rt,tt){C("xRange",ye,qe,Ge,Ze,Xe,rt,tt);var pt=$(Ze),nt=pt||$(Xe),ut=nt||$(rt);return Ge==="="&&ut&&(Ge=""),pt?qe=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&ut?(nt&&(Xe=0),ut&&(rt=0),Ge===">"?(Ge=">=",nt?(Ze=+Ze+1,Xe=0,rt=0):ut&&(Xe=+Xe+1,rt=0)):Ge==="<="&&(Ge="<",nt?Ze=+Ze+1:Xe=+Xe+1),qe=Ge+Ze+"."+Xe+"."+rt):nt?qe=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":ut&&(qe=">="+Ze+"."+Xe+".0 <"+Ze+"."+(+Xe+1)+".0"),C("xRange return",qe),qe})}(ae,_e)}).join(" ")}(Ye,J),C("xrange",Ye),Ye=function(se,_e){return C("replaceStars",se,_e),se.trim().replace(D[Q],"")}(Ye,J),C("stars",Ye),Ye}(Fe,De)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Fe){return!!Fe.match(We)})),je=je.map(function(Fe){return new ee(Fe,De)})},F.prototype.intersects=function(oe,De){if(!(oe instanceof F))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(We){return oe.set.some(function(je){return je.every(function(Fe){return We.intersects(Fe,De)})})})})},e.toComparators=function(oe,De){return new F(oe,De).set.map(function(Ce){return Ce.map(function(We){return We.value}).join(" ").trim().split(" ")})},F.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new G(oe,this.loose));for(var De=0;De<this.set.length;De++)if(X(this.set[De],oe))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(oe,De,Ce){var We=null,je=null;try{var Fe=new F(De,Ce)}catch{return null}return oe.forEach(function(Ye){Fe.test(Ye)&&(We&&je.compare(Ye)!==-1||(je=new G(We=Ye,Ce)))}),We},e.minSatisfying=function(oe,De,Ce){var We=null,je=null;try{var Fe=new F(De,Ce)}catch{return null}return oe.forEach(function(Ye){Fe.test(Ye)&&(We&&je.compare(Ye)!==1||(je=new G(We=Ye,Ce)))}),We},e.validRange=function(oe,De){try{return new F(oe,De).range||"*"}catch{return null}},e.ltr=function(oe,De,Ce){return Ee(oe,De,"<",Ce)},e.gtr=function(oe,De,Ce){return Ee(oe,De,">",Ce)},e.outside=Ee,e.prerelease=function(oe,De){var Ce=ce(oe,De);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(oe,De,Ce){return oe=new F(oe,Ce),De=new F(De,Ce),oe.intersects(De)},e.coerce=function(oe){if(oe instanceof G)return oe;if(typeof oe!="string")return null;var De=oe.match(D[R]);return De==null?null:ce((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,d(1))},function(Y,e){var d,i,C=Y.exports={};function P(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function D(v){if(d===setTimeout)return setTimeout(v,0);if((d===P||!d)&&setTimeout)return d=setTimeout,setTimeout(v,0);try{return d(v,0)}catch{try{return d.call(null,v,0)}catch{return d.call(this,v,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:P}catch{d=P}try{i=typeof clearTimeout=="function"?clearTimeout:I}catch{i=I}})();var b,A=[],L=!1,k=-1;function y(){L&&b&&(L=!1,b.length?A=b.concat(A):k=-1,A.length&&T())}function T(){if(!L){var v=D(y);L=!0;for(var g=A.length;g;){for(b=A,A=[];++k<g;)b&&b[k].run();k=-1,g=A.length}b=null,L=!1,function(E){if(i===clearTimeout)return clearTimeout(E);if((i===I||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(E);try{i(E)}catch{try{return i.call(null,E)}catch{return i.call(this,E)}}}(v)}}function _(v,g){this.fun=v,this.array=g}function m(){}C.nextTick=function(v){var g=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)g[E-1]=arguments[E];A.push(new _(v,g)),A.length!==1||L||D(T)},_.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=m,C.addListener=m,C.once=m,C.off=m,C.removeListener=m,C.removeAllListeners=m,C.emit=m,C.prependListener=m,C.prependOnceListener=m,C.listeners=function(v){return[]},C.binding=function(v){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(v){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ie[48],ke([1,0,12]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=d.globals.performance&&typeof d.globals.performance.now=="function";class C{constructor(I){this._highResolution=i&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new C(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=C}),define(Ie[3],ke([1,0,11,58,6,92,48]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,b=!1;var A;(function(t){t.None=()=>C.Disposable.None;function a(ce){if(b){const{onListenerDidAdd:G}=ce,ge=_.create();let ne=0;ce.onListenerDidAdd=()=>{++ne==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),G?.()}}}function u(ce){return(G,ge=null,ne)=>{let he=!1,Se;return Se=ce(Re=>{if(!he)return Se?Se.dispose():he=!0,G.call(ge,Re)},null,ne),he&&Se.dispose(),Se}}t.once=u;function c(ce,G,ge){return U((ne,he=null,Se)=>ce(Re=>ne.call(he,G(Re)),null,Se),ge)}t.map=c;function S(ce,G,ge){return U((ne,he=null,Se)=>ce(Re=>{G(Re),ne.call(he,Re)},null,Se),ge)}t.forEach=S;function R(ce,G,ge){return U((ne,he=null,Se)=>ce(Re=>G(Re)&&ne.call(he,Re),null,Se),ge)}t.filter=R;function O(ce){return ce}t.signal=O;function N(...ce){return(G,ge=null,ne)=>(0,C.combinedDisposable)(...ce.map(he=>he(Se=>G.call(ge,Se),null,ne)))}t.any=N;function p(ce,G,ge,ne){let he=ge;return c(ce,Se=>(he=G(he,Se),he),ne)}t.reduce=p;function U(ce,G){let ge;const ne={onFirstListenerAdd(){ge=ce(he.fire,he)},onLastListenerRemove(){ge.dispose()}};G||a(ne);const he=new v(ne);return G&&G.add(he),he.event}function B(ce,G,ge=100,ne=!1,he,Se){let Re,ve,Te,Ae=0;const le={leakWarningThreshold:he,onFirstListenerAdd(){Re=ce(ee=>{Ae++,ve=G(ve,ee),ne&&!Te&&(pe.fire(ve),ve=void 0),clearTimeout(Te),Te=setTimeout(()=>{const te=ve;ve=void 0,Te=void 0,(!ne||Ae>1)&&pe.fire(te),Ae=0},ge)})},onLastListenerRemove(){Re.dispose()}};Se||a(le);const pe=new v(le);return Se&&Se.add(pe),pe.event}t.debounce=B;function z(ce,G=(ne,he)=>ne===he,ge){let ne=!0,he;return R(ce,Se=>{const Re=ne||!G(Se,he);return ne=!1,he=Se,Re},ge)}t.latch=z;function re(ce,G,ge){return[t.filter(ce,G,ge),t.filter(ce,ne=>!G(ne),ge)]}t.split=re;function H(ce,G=!1,ge=[]){let ne=ge.slice(),he=ce(ve=>{ne?ne.push(ve):Re.fire(ve)});const Se=()=>{ne&&ne.forEach(ve=>Re.fire(ve)),ne=null},Re=new v({onFirstListenerAdd(){he||(he=ce(ve=>Re.fire(ve)))},onFirstListenerDidAdd(){ne&&(G?setTimeout(Se):Se())},onLastListenerRemove(){he&&he.dispose(),he=null}});return Re.event}t.buffer=H;class M{constructor(G){this.event=G}map(G){return new M(c(this.event,G))}forEach(G){return new M(S(this.event,G))}filter(G){return new M(R(this.event,G))}reduce(G,ge){return new M(p(this.event,G,ge))}latch(){return new M(z(this.event))}debounce(G,ge=100,ne=!1,he){return new M(B(this.event,G,ge,ne,he))}on(G,ge,ne){return this.event(G,ge,ne)}once(G,ge,ne){return u(this.event)(G,ge,ne)}}function j(ce){return new M(ce)}t.chain=j;function V(ce,G,ge=ne=>ne){const ne=(...ve)=>Re.fire(ge(...ve)),he=()=>ce.on(G,ne),Se=()=>ce.removeListener(G,ne),Re=new v({onFirstListenerAdd:he,onLastListenerRemove:Se});return Re.event}t.fromNodeEventEmitter=V;function q(ce,G,ge=ne=>ne){const ne=(...ve)=>Re.fire(ge(...ve)),he=()=>ce.addEventListener(G,ne),Se=()=>ce.removeEventListener(G,ne),Re=new v({onFirstListenerAdd:he,onLastListenerRemove:Se});return Re.event}t.fromDOMEventEmitter=q;function ie(ce){return new Promise(G=>u(ce)(G))}t.toPromise=ie;function Q(ce,G){return G(void 0),ce(ge=>G(ge))}t.runAndSubscribe=Q;function ue(ce,G){let ge=null;function ne(Se){ge?.dispose(),ge=new C.DisposableStore,G(Se,ge)}ne(void 0);const he=ce(Se=>ne(Se));return(0,C.toDisposable)(()=>{he.dispose(),ge?.dispose()})}t.runAndSubscribeWithStore=ue})(A=e.Event||(e.Event={}));class L{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${L._idPool++}`}start(a){this._stopWatch=new I.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let k=-1;function y(t){const a=k;return k=t,{dispose(){k=a}}}e.setGlobalLeakWarningThreshold=y;class T{constructor(a,u=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,u){let c=k;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||u<c)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let R,O=0;for(const[N,p]of this._stacks)(!R||O<p)&&(R=N,O=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${O}):`),console.warn(R)}return()=>{const R=this._stacks.get(a.value)||0;this._stacks.set(a.value,R-1)}}}class _{constructor(a){this.value=a}static create(){return new _(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(a,u,c){this.callback=a,this.callbackThis=u,this.stack=c,this.subscription=new C.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class v{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const u of a)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,u,c)=>{this._listeners||(this._listeners=new P.LinkedList);const S=this._listeners.isEmpty();S&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,O;this._leakageMon&&this._listeners.size>=30&&(O=_.create(),R=this._leakageMon.check(O,this._listeners.size+1)),D&&(O=O??_.create());const N=new m(a,u,O),p=this._listeners.push(N);S&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,u);const U=N.subscription.set(()=>{R&&R(),this._disposed||(p(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof C.DisposableStore?c.add(U):Array.isArray(c)&&c.push(U),U}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(let u of this._listeners)this._deliveryQueue.push(this,u,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class g{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(a,u,c){this._queue.push(new h(a,u,c))}clear(a){const u=new P.LinkedList;for(const c of this._queue)c.emitter!==a&&u.push(c);this._queue=u}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(u){(0,d.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=g;class E extends g{clear(a){this._queue.clear()}}class h{constructor(a,u,c){this.emitter=a,this.listener=u,this.event=c}}class l extends v{async fireAsync(a,u,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,a]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[S,R]=this._asyncDeliveryQueue.shift(),O=[],N={...R,token:u,waitUntil:p=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");c&&(p=c(p,S.callback)),O.push(p)}};try{S.invoke(N)}catch(p){(0,d.onUnexpectedError)(p);continue}Object.freeze(O),await Promise.allSettled(O).then(p=>{for(const U of p)U.status==="rejected"&&(0,d.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=l;class f extends v{constructor(a){super(a);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=f;class o extends f{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=o;class w extends v{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]})}}e.MicrotaskEmitter=w;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const u={event:a,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const S=this.events.indexOf(u);this.events.splice(S,1)};return(0,C.toDisposable)((0,i.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(u=>this.emitter.fire(u))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(a){return(u,c,S)=>a(R=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>u.call(c,R)):u.call(c,R)},void 0,S)}bufferEvents(a){const u=[];this.buffers.push(u);const c=a();return this.buffers.pop(),u.forEach(S=>S()),c}}e.EventBufferer=s;class n{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=C.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=n}),define(Ie[21],ke([1,0,3]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,b){const A=setTimeout(D.bind(b),0);return{dispose(){clearTimeout(A)}}});var C;(function(D){function b(A){return A===D.None||A===D.Cancelled||A instanceof P?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}D.isCancellationToken=b,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(C=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=C.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=I}),define(Ie[146],ke([1,0,21]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new d.CancellationTokenSource,b=this.task(D.token);return this.result={promise:b,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=i;class C{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const b=JSON.stringify(D);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=C;class P{constructor(D){this.fn=D,this._map=new Map}get cachedValues(){return this._map}get(D){if(this._map.has(D))return this._map.get(D);const b=this.fn(D);return this._map.set(D,b),b}}e.CachedFunction=P}),define(Ie[96],ke([1,0,11,6]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(l){const f=l;return f?typeof f.read=="function":!1}e.isReadable=C;function P(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=P;function I(l){const f=l;return f?P(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=I;function D(l,f){return new b(l,f)}e.newWriteableStream=D;class b{constructor(f,o){this.reducer=f,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(o=>o(f))}emitError(f){this.listeners.error.length===0?(0,d.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(o=>o(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,o){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(f,o){if(this.state.destroyed)return;let w;switch(f){case"data":w=this.listeners.data;break;case"end":w=this.listeners.end;break;case"error":w=this.listeners.error;break}if(w){const r=w.indexOf(o);r>=0&&w.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(w=>w())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(l,f){const o=[];let w;for(;(w=l.read())!==null;)o.push(w);return f(o)}e.consumeReadable=A;function L(l,f,o){const w=[];let r;for(;(r=l.read())!==null&&w.length<o;)w.push(r);return r===null&&w.length>0?f(w):{read:()=>{if(w.length>0)return w.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=L;function k(l,f){return new Promise((o,w)=>{const r=[];y(l,{onData:s=>{f&&r.push(s)},onError:s=>{f?w(s):o(void 0)},onEnd:()=>{o(f?f(r):void 0)}})})}e.consumeStream=k;function y(l,f){let o=!1;return l.on("error",w=>{o||f.onError(w)}),l.on("end",()=>{o||f.onEnd()}),l.on("data",w=>{o||f.onData(w)}),(0,i.toDisposable)(()=>o=!0)}e.listenStream=y;function T(l,f){return new Promise((o,w)=>{const r=new i.DisposableStore,s=[],n=u=>{if(s.push(u),s.length>f)return r.dispose(),l.pause(),o({stream:l,buffer:s,ended:!1})},t=u=>w(u),a=()=>o({stream:l,buffer:s,ended:!0});r.add((0,i.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),r.add((0,i.toDisposable)(()=>l.removeListener("end",a))),l.on("end",a),r.add((0,i.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=T;function _(l,f){const o=D(f);return o.end(l),o}e.toStream=_;function m(){const l=D(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=m;function v(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=v;function g(l,f,o){const w=D(o);return y(l,{onData:r=>w.write(f.data(r)),onError:r=>w.error(f.error?f.error(r):r),onEnd:()=>w.end()}),w}e.transform=g;function E(l,f,o){let w=!1;return{read:()=>{const r=f.read();return w?r:(w=!0,r!==null?o([l,r]):l)}}}e.prefixedReadable=E;function h(l,f,o){let w=!1;const r=D(o);return y(f,{onData:s=>w?r.write(s):(w=!0,r.write(o([l,s]))),onError:s=>r.error(s),onEnd:()=>{w||(w=!0,r.write(l)),r.end()}}),r}e.prefixedStream=h}),define(Ie[23],ke([1,0,96]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let C,P;class I{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return i?new I(Buffer.allocUnsafe(u)):new I(new Uint8Array(u))}static wrap(u){return i&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new I(u)}static fromString(u,c){return!(c?.dontUseNodeBuffer||!1)&&i?new I(Buffer.from(u)):(C||(C=new TextEncoder),new I(C.encode(u)))}static fromByteArray(u){const c=I.alloc(u.length);for(let S=0,R=u.length;S<R;S++)c.buffer[S]=u[S];return c}static concat(u,c){if(typeof c=="undefined"){c=0;for(let O=0,N=u.length;O<N;O++)c+=u[O].byteLength}const S=I.alloc(c);let R=0;for(let O=0,N=u.length;O<N;O++){const p=u[O];S.set(p,R),R+=p.byteLength}return S}clone(){const u=I.alloc(this.byteLength);return u.set(this),u}toString(){return i?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(u,c){return new I(this.buffer.subarray(u,c))}set(u,c){if(u instanceof I)this.buffer.set(u.buffer,c);else if(u instanceof Uint8Array)this.buffer.set(u,c);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),c);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),c);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return A(this.buffer,u)}writeUInt32BE(u,c){L(this.buffer,u,c)}readUInt32LE(u){return k(this.buffer,u)}writeUInt32LE(u,c){y(this.buffer,u,c)}readUInt8(u){return T(this.buffer,u)}writeUInt8(u,c){_(this.buffer,u,c)}}e.VSBuffer=I;function D(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=D;function b(a,u,c){a[c+0]=u&255,u=u>>>8,a[c+1]=u&255}e.writeUInt16LE=b;function A(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=A;function L(a,u,c){a[c+3]=u,u=u>>>8,a[c+2]=u,u=u>>>8,a[c+1]=u,u=u>>>8,a[c]=u}e.writeUInt32BE=L;function k(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=k;function y(a,u,c){a[c+0]=u&255,u=u>>>8,a[c+1]=u&255,u=u>>>8,a[c+2]=u&255,u=u>>>8,a[c+3]=u&255}e.writeUInt32LE=y;function T(a,u){return a[u]}e.readUInt8=T;function _(a,u,c){a[c]=u}e.writeUInt8=_;function m(a){return d.consumeReadable(a,u=>I.concat(u))}e.readableToBuffer=m;function v(a){return d.toReadable(a)}e.bufferToReadable=v;function g(a){return d.consumeStream(a,u=>I.concat(u))}e.streamToBuffer=g;async function E(a){return a.ended?I.concat(a.buffer):I.concat([...a.buffer,await g(a.stream)])}e.bufferedStreamToBuffer=E;function h(a){return d.toStream(a,u=>I.concat(u))}e.bufferToStream=h;function l(a){return d.transform(a,{data:u=>typeof u=="string"?I.fromString(u):I.wrap(u)},u=>I.concat(u))}e.streamToBufferReadableStream=l;function f(a){return d.newWriteableStream(u=>I.concat(u),a)}e.newWriteableBufferStream=f;function o(a,u){return d.prefixedReadable(a,u,c=>I.concat(c))}e.prefixedBufferReadable=o;function w(a,u){return d.prefixedStream(a,u,c=>I.concat(c))}e.prefixedBufferStream=w;function r(a){let u=0,c=0,S=0;const R=new Uint8Array(Math.floor(a.length/4*3)),O=p=>{switch(c){case 3:R[S++]=u|p,c=0;break;case 2:R[S++]=u|p>>>2,u=p<<6,c=3;break;case 1:R[S++]=u|p>>>4,u=p<<4,c=2;break;default:u=p<<2,c=1}};for(let p=0;p<a.length;p++){const U=a.charCodeAt(p);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${a[p]}`)}}const N=S;for(;c>0;)O(0);return I.wrap(R).slice(0,N)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:a},u=!0,c=!1){const S=c?n:s;let R="";const O=a.byteLength%3;let N=0;for(;N<a.byteLength-O;N+=3){const p=a[N+0],U=a[N+1],B=a[N+2];R+=S[p>>>2],R+=S[(p<<4|U>>>4)&63],R+=S[(U<<2|B>>>6)&63],R+=S[B&63]}if(O===1){const p=a[N+0];R+=S[p>>>2],R+=S[p<<4&63],u&&(R+="==")}else if(O===2){const p=a[N+0],U=a[N+1];R+=S[p>>>2],R+=S[(p<<4|U>>>4)&63],R+=S[U<<2&63],u&&(R+="=")}return R}e.encodeBase64=t}),define(Ie[8],ke([1,0,146,80]),function(Y,e,d,i){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=P;const I=/{(\d+)}/g;function D(ae,...ye){return ye.length===0?ae:ae.replace(I,function(Ne,He){const qe=parseInt(He,10);return isNaN(qe)||qe<0||qe>=ye.length?Ne:ye[qe]})}e.format=D;const b=/{([^}]+)}/g;function A(ae,ye){return ae.replace(b,(Ne,He)=>ye[He]??Ne)}e.format2=A;function L(ae){return ae.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=L;function k(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function y(ae,ye){let Ne=0;const He=ye.charCodeAt(0);for(let qe=ae.length-1;qe>=0;qe--)ae.charCodeAt(qe)===He&&Ne++;return Ne}e.count=y;function T(ae,ye,Ne="\u2026"){return ae.length<=ye?ae:`${ae.substr(0,ye)}${Ne}`}e.truncate=T;function _(ae,ye=" "){const Ne=m(ae,ye);return v(Ne,ye)}e.trim=_;function m(ae,ye){if(!ae||!ye)return ae;const Ne=ye.length;if(Ne===0||ae.length===0)return ae;let He=0;for(;ae.indexOf(ye,He)===He;)He=He+Ne;return ae.substring(He)}e.ltrim=m;function v(ae,ye){if(!ae||!ye)return ae;const Ne=ye.length,He=ae.length;if(Ne===0||He===0)return ae;let qe=He,Ge=-1;for(;Ge=ae.lastIndexOf(ye,qe-1),!(Ge===-1||Ge+Ne!==qe);){if(Ge===0)return"";qe=Ge}return ae.substring(0,qe)}e.rtrim=v;function g(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function E(ae){return ae.replace(/\*/g,"")}e.stripWildcards=E;function h(ae,ye,Ne={}){if(!ae)throw new Error("Cannot create regex from empty string");ye||(ae=k(ae)),Ne.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let He="";return Ne.global&&(He+="g"),Ne.matchCase||(He+="i"),Ne.multiline&&(He+="m"),Ne.unicode&&(He+="u"),new RegExp(ae,He)}e.createRegExp=h;function l(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function f(ae){return!!ae.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function o(ae){return(ae.global?"g":"")+(ae.ignoreCase?"i":"")+(ae.multiline?"m":"")+(ae.unicode?"u":"")}e.regExpFlags=o;function w(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=w;function r(ae){for(let ye=0,Ne=ae.length;ye<Ne;ye++){const He=ae.charCodeAt(ye);if(He!==32&&He!==9)return ye}return-1}e.firstNonWhitespaceIndex=r;function s(ae,ye=0,Ne=ae.length){for(let He=ye;He<Ne;He++){const qe=ae.charCodeAt(He);if(qe!==32&&qe!==9)return ae.substring(ye,He)}return ae.substring(ye,Ne)}e.getLeadingWhitespace=s;function n(ae,ye=ae.length-1){for(let Ne=ye;Ne>=0;Ne--){const He=ae.charCodeAt(Ne);if(He!==32&&He!==9)return Ne}return-1}e.lastNonWhitespaceIndex=n;function t(ae,ye,Ne){let He=[],qe=0;for(const Ge of ae.matchAll(ye)){if(He.push(ae.slice(qe,Ge.index)),Ge.index===void 0)throw new Error("match.index should be defined");qe=Ge.index+Ge[0].length,He.push(Ne(Ge[0],...Ge.slice(1),Ge.index,ae,Ge.groups))}return He.push(ae.slice(qe)),Promise.all(He).then(Ge=>Ge.join(""))}e.replaceAsync=t;function a(ae,ye){return ae<ye?-1:ae>ye?1:0}e.compare=a;function u(ae,ye,Ne=0,He=ae.length,qe=0,Ge=ye.length){for(;Ne<He&&qe<Ge;Ne++,qe++){let rt=ae.charCodeAt(Ne),tt=ye.charCodeAt(qe);if(rt<tt)return-1;if(rt>tt)return 1}const Ze=He-Ne,Xe=Ge-qe;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstring=u;function c(ae,ye){return S(ae,ye,0,ae.length,0,ye.length)}e.compareIgnoreCase=c;function S(ae,ye,Ne=0,He=ae.length,qe=0,Ge=ye.length){for(;Ne<He&&qe<Ge;Ne++,qe++){let rt=ae.charCodeAt(Ne),tt=ye.charCodeAt(qe);if(rt===tt)continue;if(rt>=128||tt>=128)return u(ae.toLowerCase(),ye.toLowerCase(),Ne,He,qe,Ge);R(rt)&&(rt-=32),R(tt)&&(tt-=32);const pt=rt-tt;if(pt!==0)return pt}const Ze=He-Ne,Xe=Ge-qe;return Ze<Xe?-1:Ze>Xe?1:0}e.compareSubstringIgnoreCase=S;function R(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=R;function O(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=O;function N(ae,ye){return ae.length===ye.length&&S(ae,ye)===0}e.equalsIgnoreCase=N;function p(ae,ye){const Ne=ye.length;return ye.length>ae.length?!1:S(ae,ye,0,Ne)===0}e.startsWithIgnoreCase=p;function U(ae,ye){let Ne,He=Math.min(ae.length,ye.length);for(Ne=0;Ne<He;Ne++)if(ae.charCodeAt(Ne)!==ye.charCodeAt(Ne))return Ne;return He}e.commonPrefixLength=U;function B(ae,ye){let Ne,He=Math.min(ae.length,ye.length);const qe=ae.length-1,Ge=ye.length-1;for(Ne=0;Ne<He;Ne++)if(ae.charCodeAt(qe-Ne)!==ye.charCodeAt(Ge-Ne))return Ne;return He}e.commonSuffixLength=B;function z(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=z;function re(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=re;function H(ae,ye){return(ae-55296<<10)+(ye-56320)+65536}e.computeCodePoint=H;function M(ae,ye,Ne){const He=ae.charCodeAt(Ne);if(z(He)&&Ne+1<ye){const qe=ae.charCodeAt(Ne+1);if(re(qe))return H(He,qe)}return He}e.getNextCodePoint=M;function j(ae,ye){const Ne=ae.charCodeAt(ye-1);if(re(Ne)&&ye>1){const He=ae.charCodeAt(ye-2);if(z(He))return H(He,Ne)}return Ne}class V{constructor(ye,Ne=0){this._str=ye,this._len=ye.length,this._offset=Ne}get offset(){return this._offset}setOffset(ye){this._offset=ye}prevCodePoint(){const ye=j(this._str,this._offset);return this._offset-=ye>=65536?2:1,ye}nextCodePoint(){const ye=M(this._str,this._len,this._offset);return this._offset+=ye>=65536?2:1,ye}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class q{constructor(ye,Ne=0){this._iterator=new V(ye,Ne)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ye=Ce.getInstance(),Ne=this._iterator,He=Ne.offset;let qe=ye.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const Ge=Ne.offset,Ze=ye.getGraphemeBreakType(Ne.nextCodePoint());if(oe(qe,Ze)){Ne.setOffset(Ge);break}qe=Ze}return Ne.offset-He}prevGraphemeLength(){const ye=Ce.getInstance(),Ne=this._iterator,He=Ne.offset;let qe=ye.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const Ge=Ne.offset,Ze=ye.getGraphemeBreakType(Ne.prevCodePoint());if(oe(Ze,qe)){Ne.setOffset(Ge);break}qe=Ze}return He-Ne.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function ie(ae,ye){return new q(ae,ye).nextGraphemeLength()}e.nextCharLength=ie;function Q(ae,ye){return new q(ae,ye).prevGraphemeLength()}e.prevCharLength=Q;function ue(ae,ye){ye>0&&re(ae.charCodeAt(ye))&&ye--;const Ne=ye+ie(ae,ye);return[Ne-Q(ae,Ne),Ne]}e.getCharContainingOffset=ue;const ce=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(ae){return ce.test(ae)}e.containsRTL=G;const ge=/^[\t\n\r\x20-\x7E]*$/;function ne(ae){return ge.test(ae)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function he(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=he;function Se(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=Se;function Re(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=Re;function ve(ae,ye){if(ae.length<ye)return ae;const Ne=/\b/g;let He=0;for(;Ne.test(ae)&&!(ae.length-Ne.lastIndex<ye);)He=Ne.lastIndex,Ne.lastIndex+=1;return ae.substring(He).replace(/^\s/,"")}e.lcut=ve;const Te=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function pe(ae){return ae&&(ae=ae.replace(Te,""),ae=ae.replace(Ae,""),ae=ae.replace(le,"")),ae}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ee;function te(ae){return ee(ae)?ae.substr(1):ae}e.stripUTF8BOM=te;function F(ae,ye){if(!ae||!ye||ae.length<ye.length)return!1;const Ne=ye.length,He=ae.toLowerCase();let qe=0,Ge=-1;for(;qe<Ne;){const Ze=He.indexOf(ye[qe],Ge+1);if(Ze<0)return!1;Ge=Ze,qe++}return!0}e.fuzzyContains=F;function $(ae,ye=!1){return ae?(ye&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=$;function K(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=K;function X(ae,ye=1){if(ye===0)return"";let Ne=-1;do Ne=ae.indexOf(`
`,Ne+1),ye--;while(ye>0&&Ne>=0);return Ne===-1?ae:(ae[Ne-1]==="\r"&&Ne--,ae.substr(0,Ne))}e.getNLines=X;function me(ae){const ye=90-65+1;return ae=ae%(2*ye),ae<ye?String.fromCharCode(97+ae):String.fromCharCode(65+ae-ye)}e.singleLetterHash=me;function Ee(ae){return Ce.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=Ee;function oe(ae,ye){return ae===0?ye!==5&&ye!==7:ae===2&&ye===3?!1:ae===4||ae===2||ae===3||ye===4||ye===2||ye===3?!0:!(ae===8&&(ye===8||ye===9||ye===11||ye===12)||(ae===11||ae===9)&&(ye===9||ye===10)||(ae===12||ae===10)&&ye===10||ye===5||ye===13||ye===7||ae===1||ae===13&&ye===14||ae===6&&ye===6)}var De;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(De=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=We()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Ne=this._data,He=Ne.length/3;let qe=1;for(;qe<=He;)if(ye<Ne[3*qe])qe=2*qe;else if(ye>Ne[3*qe+1])qe=2*qe+1;else return Ne[3*qe+2];return 0}}Ce._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ae,ye){if(ae===0)return 0;const Ne=Fe(ae,ye);if(Ne!==void 0)return Ne;const He=new V(ye,ae);return He.prevCodePoint(),He.offset}e.getLeftDeleteOffset=je;function Fe(ae,ye){const Ne=new V(ye,ae);let He=Ne.prevCodePoint();for(;Ye(He)||He===65039||He===8419;){if(Ne.offset===0)return;He=Ne.prevCodePoint()}if(!Re(He))return;let qe=Ne.offset;return qe>0&&Ne.prevCodePoint()===8205&&(qe=Ne.offset),qe}function Ye(ae){return 127995<=ae&&ae<=127999}var J;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(J||(J={})),e.noBreakWhitespace="\xA0";class se{constructor(ye){this.confusableDictionary=ye}static getInstance(ye){return se.cache.get(Array.from(ye))}static getLocales(){return se._locales.getValue()}isAmbiguous(ye){return this.confusableDictionary.has(ye)}getPrimaryConfusable(ye){return this.confusableDictionary.get(ye)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,C=se,se.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new d.LRUCachedFunction(ae=>{function ye(tt){const pt=new Map;for(let nt=0;nt<tt.length;nt+=2)pt.set(tt[nt],tt[nt+1]);return pt}function Ne(tt,pt){const nt=new Map(tt);for(const[ut,Pt]of pt)nt.set(ut,Pt);return nt}function He(tt,pt){if(!tt)return pt;const nt=new Map;for(const[ut,Pt]of tt)pt.has(ut)&&nt.set(ut,Pt);return nt}const qe=C.ambiguousCharacterData.getValue();let Ge=ae.filter(tt=>!tt.startsWith("_")&&tt in qe);Ge.length===0&&(Ge=["_default"]);let Ze;for(const tt of Ge){const pt=ye(qe[tt]);Ze=He(Ze,pt)}const Xe=ye(qe._common),rt=Ne(Xe,Ze);return new se(rt)}),se._locales=new i.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(ae=>!ae.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(ye){return _e.getData().has(ye)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(Ie[59],ke([1,0,8]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(g){return C(g,0)}e.hash=i;function C(g,E){switch(typeof g){case"object":return g===null?P(349,E):Array.isArray(g)?b(g,E):A(g,E);case"string":return D(g,E);case"boolean":return I(g,E);case"number":return P(g,E);case"undefined":return P(937,E);default:return P(617,E)}}e.doHash=C;function P(g,E){return(E<<5)-E+g|0}e.numberHash=P;function I(g,E){return P(g?433:863,E)}function D(g,E){E=P(149417,E);for(let h=0,l=g.length;h<l;h++)E=P(g.charCodeAt(h),E);return E}e.stringHash=D;function b(g,E){return E=P(104579,E),g.reduce((h,l)=>C(l,h),E)}function A(g,E){return E=P(181387,E),Object.keys(g).sort().reduce((h,l)=>(h=D(l,h),C(g[l],h)),E)}class L{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=C(E,this._value),this._value}}e.Hasher=L;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function y(g,E,h=32){const l=h-E,f=~((1<<l)-1);return(g<<E|(f&g)>>>l)>>>0}function T(g,E=0,h=g.byteLength,l=0){for(let f=0;f<h;f++)g[E+f]=l}function _(g,E,h="0"){for(;g.length<E;)g=h+g;return g}function m(g,E=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(h=>h.toString(16).padStart(2,"0")).join(""):_((g>>>0).toString(16),E/4)}e.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const h=E.length;if(h===0)return;const l=this._buff;let f=this._buffLen,o=this._leftoverHighSurrogate,w,r;for(o!==0?(w=o,r=-1,o=0):(w=E.charCodeAt(0),r=0);;){let s=w;if(d.isHighSurrogate(w))if(r+1<h){const n=E.charCodeAt(r+1);d.isLowSurrogate(n)?(r++,s=d.computeCodePoint(w,n)):s=65533}else{o=w;break}else d.isLowSurrogate(w)&&(s=65533);if(f=this._push(l,f,s),r++,r<h)w=E.charCodeAt(r);else break}this._buffLen=f,this._leftoverHighSurrogate=o}_push(E,h,l){return l<128?E[h++]=l:l<2048?(E[h++]=192|(l&1984)>>>6,E[h++]=128|(l&63)>>>0):l<65536?(E[h++]=224|(l&61440)>>>12,E[h++]=128|(l&4032)>>>6,E[h++]=128|(l&63)>>>0):(E[h++]=240|(l&1835008)>>>18,E[h++]=128|(l&258048)>>>12,E[h++]=128|(l&4032)>>>6,E[h++]=128|(l&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=v._bigBlock32,h=this._buffDV;for(let a=0;a<64;a+=4)E.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)E.setUint32(a,y(E.getUint32(a-12,!1)^E.getUint32(a-32,!1)^E.getUint32(a-56,!1)^E.getUint32(a-64,!1),1),!1);let l=this._h0,f=this._h1,o=this._h2,w=this._h3,r=this._h4,s,n,t;for(let a=0;a<80;a++)a<20?(s=f&o|~f&w,n=1518500249):a<40?(s=f^o^w,n=1859775393):a<60?(s=f&o|f&w|o&w,n=2400959708):(s=f^o^w,n=3395469782),t=y(l,5)+s+r+n+E.getUint32(a*4,!1)&4294967295,r=w,w=o,o=y(f,30),f=l,l=t;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+w&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[24],ke([1,0,16,8]),function(Y,e,d,i){"use strict";var C,P,I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,t,a){let u=n.get(t);return u===void 0&&(u=a,n.set(t,u)),u}e.getOrSet=b;function A(n){const t=[];return n.forEach((a,u)=>{t.push(`${u} => ${a}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=A;function L(n){const t=[];return n.forEach(a=>{t.push(a)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=L;class k{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const a=t.charCodeAt(0),u=this._value.charCodeAt(this._pos);return a-u}value(){return this._value[this._pos]}}e.StringIterator=k;class y{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class T{constructor(t=!0,a=!0){this._splitOnBackslash=t,this._caseSensitive=a}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let a=t.length-1;a>=0;a--,this._valueLen--){const u=this._value.charCodeAt(a);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var _;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(_||(_={}));class m{constructor(t,a){this._ignorePathCasing=t,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(g||(g={}));class E{constructor(t){this._iter=t}static forUris(t=()=>!1,a=()=>!1){return new E(new m(t,a))}static forPaths(t=!1){return new E(new T(void 0,!t))}static forStrings(){return new E(new k)}static forConfigKeys(){return new E(new y)}clear(){this._root=void 0}fill(t,a){if(a){const u=a.slice(0);(0,d.shuffle)(u);for(let c of u)this.set(c,t)}else{const u=t.slice(0);(0,d.shuffle)(u);for(let c of u)this.set(c[0],c[1])}}set(t,a){const u=this._iter.reset(t);let c;this._root||(this._root=new v,this._root.segment=u.value());const S=[];for(c=this._root;;){const O=u.cmp(c.segment);if(O>0)c.left||(c.left=new v,c.left.segment=u.value()),S.push([-1,c]),c=c.left;else if(O<0)c.right||(c.right=new v,c.right.segment=u.value()),S.push([1,c]),c=c.right;else if(u.hasNext())u.next(),c.mid||(c.mid=new v,c.mid.segment=u.value()),S.push([0,c]),c=c.mid;else break}const R=c.value;c.value=a,c.key=t;for(let O=S.length-1;O>=0;O--){const N=S[O][1];N.updateHeight();const p=N.balanceFactor();if(p<-1||p>1){const U=S[O][0],B=S[O+1][0];if(U===1&&B===1)S[O][1]=N.rotateLeft();else if(U===-1&&B===-1)S[O][1]=N.rotateRight();else if(U===1&&B===-1)N.right=S[O+1][1]=S[O+1][1].rotateRight(),S[O][1]=N.rotateLeft();else if(U===-1&&B===1)N.left=S[O+1][1]=S[O+1][1].rotateLeft(),S[O][1]=N.rotateRight();else throw new Error;if(O>0)switch(S[O-1][0]){case-1:S[O-1][1].left=S[O][1];break;case 1:S[O-1][1].right=S[O][1];break;case 0:S[O-1][1].mid=S[O][1];break}else this._root=S[0][1]}}return R}get(t){return this._getNode(t)?.value}_getNode(t){const a=this._iter.reset(t);let u=this._root;for(;u;){const c=a.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(a.hasNext())a.next(),u=u.mid;else break}return u}has(t){const a=this._getNode(t);return!(a?.value===void 0&&a?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,a){const u=this._iter.reset(t),c=[];let S=this._root;for(;S;){const R=u.cmp(S.segment);if(R>0)c.push([-1,S]),S=S.left;else if(R<0)c.push([1,S]),S=S.right;else if(u.hasNext())u.next(),c.push([0,S]),S=S.mid;else break}if(!!S){if(a?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const R=this._min(S.right),{key:O,value:N,segment:p}=R;this._delete(R.key,!1),S.key=O,S.value=N,S.segment=p}else{const R=S.left??S.right;if(c.length>0){const[O,N]=c[c.length-1];switch(O){case-1:N.left=R;break;case 0:N.mid=R;break;case 1:N.right=R;break}}else this._root=R}for(let R=c.length-1;R>=0;R--){const O=c[R][1];O.updateHeight();const N=O.balanceFactor();if(N>1?(O.right.balanceFactor()>=0||(O.right=O.right.rotateRight()),c[R][1]=O.rotateLeft()):N<-1&&(O.left.balanceFactor()<=0||(O.left=O.left.rotateLeft()),c[R][1]=O.rotateRight()),R>0)switch(c[R-1][0]){case-1:c[R-1][1].left=c[R][1];break;case 1:c[R-1][1].right=c[R][1];break;case 0:c[R-1][1].mid=c[R][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const a=this._iter.reset(t);let u=this._root,c;for(;u;){const S=a.cmp(u.segment);if(S>0)u=u.left;else if(S<0)u=u.right;else if(a.hasNext())a.next(),c=u.value||c,u=u.mid;else break}return u&&u.value||c}findSuperstr(t){const a=this._iter.reset(t);let u=this._root;for(;u;){const c=a.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(a.hasNext())a.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(t){for(const[a,u]of this)t(u,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=a=>{if(!a)return!0;const u=a.balanceFactor();return u<-1||u>1?!1:t(a.left)&&t(a.right)};return t(this._root)}}e.TernarySearchTree=E;class h{constructor(t,a){this.uri=t,this.value=a}}class l{constructor(t,a){this[C]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=a??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new h(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a!="undefined"&&(t=t.bind(a));for(let[u,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=n=>n.toString();class f{constructor(t,a){this[P]="ResourceSet",!t||typeof t=="function"?this._map=new l(t):(this._map=new l(a),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,a){this._map.forEach((u,c)=>t.call(a,c,c,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class w{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const u=this._map.get(t);if(!!u)return a!==0&&this.touch(u,a),u.value}set(t,a,u=0){let c=this._map.get(t);if(c)c.value=a,u!==0&&this.touch(c,u);else{switch(c={key:t,value:a,next:void 0,previous:void 0},u){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const u=this._state;let c=this._head;for(;c;){if(a?t.bind(a)(c.value,c.key,this):t(c.value,c.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,a=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.key,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return c}values(){const t=this,a=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.value,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return c}entries(){const t=this,a=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:[u.key,u.value],done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return c}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,u=this.size;for(;a&&u>t;)this._map.delete(a.key),a=a.next,u--;this._head=a,this._size=u,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,u=t.previous;if(!a||!u)throw new Error("Invalid list");a.previous=u,u.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const u=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(u.previous=c,c.next=u),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const u=t.next,c=t.previous;t===this._head?(u.previous=void 0,this._head=u):(u.previous=c,c.next=u),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,u)=>{t.push([u,a])}),t}fromJSON(t){this.clear();for(const[a,u]of t)this.set(a,u)}}e.LinkedMap=w;class r extends w{constructor(t,a=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){D.set(this,void 0),et(this,D,t,"f")}get size(){return Ue(this,D,"f").size}forEach(t,a){Ue(this,D,"f").forEach(t,a)}get(t){return Ue(this,D,"f").get(t)}has(t){return Ue(this,D,"f").has(t)}entries(){return Ue(this,D,"f").entries()}keys(){return Ue(this,D,"f").keys()}values(){return Ue(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ue(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(Ie[97],ke([1,0,24,8]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ee){return function(te,F){for(let $=0,K=ee.length;$<K;$++){const X=ee[$](te,F);if(X)return X}return null}}e.or=C,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,te,F){if(!F||F.length<te.length)return null;let $;return ee?$=i.startsWithIgnoreCase(F,te):$=F.indexOf(te)===0,$?te.length>0?[{start:0,end:te.length}]:[]:null}function I(ee,te){const F=te.toLowerCase().indexOf(ee.toLowerCase());return F===-1?null:[{start:F,end:F+ee.length}]}e.matchesContiguousSubString=I;function D(ee,te){return b(ee.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=D;function b(ee,te,F,$){if(F===ee.length)return[];if($===te.length)return null;if(ee[F]===te[$]){let K=null;return(K=b(ee,te,F+1,$+1))?g({start:$,end:$+1},K):null}return b(ee,te,F,$+1)}function A(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.isUpper=L;function k(ee){return 48<=ee&&ee<=57}function y(ee){return ee===32||ee===9||ee===10||ee===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>T.add(ee.charCodeAt(0)));function _(ee){return y(ee)||T.has(ee)}function m(ee,te){return ee===te||_(ee)&&_(te)}function v(ee){return A(ee)||L(ee)||k(ee)}function g(ee,te){return te.length===0?te=[ee]:ee.end===te[0].start?te[0].start=ee.start:te.unshift(ee),te}function E(ee,te){for(let F=te;F<ee.length;F++){const $=ee.charCodeAt(F);if(L($)||k($)||F>0&&!v(ee.charCodeAt(F-1)))return F}return ee.length}function h(ee,te,F,$){if(F===ee.length)return[];if($===te.length)return null;if(ee[F]!==te[$].toLowerCase())return null;{let K=null,X=$+1;for(K=h(ee,te,F+1,$+1);!K&&(X=E(te,X))<te.length;)K=h(ee,te,F+1,X),X++;return K===null?null:g({start:$,end:$+1},K)}}function l(ee){let te=0,F=0,$=0,K=0,X=0;for(let Ce=0;Ce<ee.length;Ce++)X=ee.charCodeAt(Ce),L(X)&&te++,A(X)&&F++,v(X)&&$++,k(X)&&K++;const me=te/ee.length,Ee=F/ee.length,oe=$/ee.length,De=K/ee.length;return{upperPercent:me,lowerPercent:Ee,alphaPercent:oe,numericPercent:De}}function f(ee){const{upperPercent:te,lowerPercent:F}=ee;return F===0&&te>.6}function o(ee){const{upperPercent:te,lowerPercent:F,alphaPercent:$,numericPercent:K}=ee;return F>.2&&te<.8&&$>.6&&K<.2}function w(ee){let te=0,F=0,$=0,K=0;for(let X=0;X<ee.length;X++)$=ee.charCodeAt(X),L($)&&te++,A($)&&F++,y($)&&K++;return(te===0||F===0)&&K===0?ee.length<=30:te<=5}function r(ee,te){if(!te||(te=te.trim(),te.length===0)||!w(ee)||te.length>60)return null;const F=l(te);if(!o(F)){if(!f(F))return null;te=te.toLowerCase()}let $=null,K=0;for(ee=ee.toLowerCase();K<te.length&&($=h(ee,te,0,K))===null;)K=E(te,K+1);return $}e.matchesCamelCase=r;function s(ee,te,F=!1){if(!te||te.length===0)return null;let $=null,K=0;for(ee=ee.toLowerCase(),te=te.toLowerCase();K<te.length&&($=n(ee,te,0,K,F))===null;)K=t(te,K+1);return $}e.matchesWords=s;function n(ee,te,F,$,K){if(F===ee.length)return[];if($===te.length)return null;if(m(ee.charCodeAt(F),te.charCodeAt($))){let X=null,me=$+1;if(X=n(ee,te,F+1,$+1,K),!K)for(;!X&&(me=t(te,me))<te.length;)X=n(ee,te,F+1,me,K),me++;return X===null?null:g({start:$,end:$+1},X)}else return null}function t(ee,te){for(let F=te;F<ee.length;F++)if(_(ee.charCodeAt(F))||F>0&&_(ee.charCodeAt(F-1)))return F;return ee.length}const a=C(e.matchesPrefix,r,I),u=C(e.matchesPrefix,r,D),c=new d.LRUCache(1e4);function S(ee,te,F=!1){if(typeof ee!="string"||typeof te!="string")return null;let $=c.get(ee);$||($=new RegExp(i.convertSimple2RegExpPattern(ee),"i"),c.set(ee,$));const K=$.exec(te);return K?[{start:K.index,end:K.index+K[0].length}]:F?u(ee,te):a(ee,te)}e.matchesFuzzy=S;function R(ee,te){const F=Se(ee,ee.toLowerCase(),0,te,te.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?N(F):null}e.matchesFuzzy2=R;function O(ee,te,F,$,K,X){const me=Math.min(13,ee.length);for(;F<me;F++){const Ee=Se(ee,te,F,$,K,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,X]}e.anyScore=O;function N(ee){if(typeof ee=="undefined")return[];const te=[],F=ee[1];for(let $=ee.length-1;$>1;$--){const K=ee[$]+F,X=te[te.length-1];X&&X.end===K?X.end=K+1:te.push({start:K,end:K+1})}return te}e.createMatches=N;const p=128;function U(){const ee=[],te=[];for(let F=0;F<=p;F++)te[F]=0;for(let F=0;F<=p;F++)ee.push(te.slice(0));return ee}function B(ee){const te=[];for(let F=0;F<=ee;F++)te[F]=0;return te}const z=B(2*p),re=B(2*p),H=U(),M=U(),j=U(),V=!1;function q(ee,te,F,$,K){function X(Ee,oe,De=" "){for(;Ee.length<oe;)Ee=De+Ee;return Ee}let me=` |   |${$.split("").map(Ee=>X(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=F;Ee++)Ee===0?me+=" |":me+=`${te[Ee-1]}|`,me+=ee[Ee].slice(0,K+1).map(oe=>X(oe.toString(),3)).join("|")+`
`;return me}function ie(ee,te,F,$){ee=ee.substr(te),F=F.substr($),console.log(q(M,ee,ee.length,F,F.length)),console.log(q(j,ee,ee.length,F,F.length)),console.log(q(H,ee,ee.length,F,F.length))}function Q(ee,te){if(te<0||te>=ee.length)return!1;const F=ee.codePointAt(te);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(F)}}function ue(ee,te){if(te<0||te>=ee.length)return!1;switch(ee.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function ce(ee,te,F){return te[ee]!==F[ee]}function G(ee,te,F,$,K,X,me=!1){for(;te<F&&K<X;)ee[te]===$[K]&&(me&&(z[te]=K),te+=1),K+=1;return te===F}e.isPatternInWord=G;var ge;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ne;(function(ee){ee.Default=[-100,0];function te(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}ee.isDefault=te})(ne=e.FuzzyScore||(e.FuzzyScore={}));class he{constructor(te,F){this.firstMatchCanBeWeak=te,this.boostFullMatch=F}}e.FuzzyScoreOptions=he,he.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Se(ee,te,F,$,K,X,me=he.default){const Ee=ee.length>p?p:ee.length,oe=$.length>p?p:$.length;if(F>=Ee||X>=oe||Ee-F>oe-X||!G(te,F,Ee,K,X,oe,!0))return;Re(Ee,oe,F,X,te,K);let De=1,Ce=1,We=F,je=X;const Fe=[!1];for(De=1,We=F;We<Ee;De++,We++){const ae=z[We],ye=re[We],Ne=We+1<Ee?re[We+1]:oe;for(Ce=ae-X+1,je=ae;je<Ne;Ce++,je++){let He=Number.MIN_SAFE_INTEGER,qe=!1;je<=ye&&(He=ve(ee,te,We,F,$,K,je,oe,X,H[De-1][Ce-1]===0,Fe));let Ge=0;He!==Number.MAX_SAFE_INTEGER&&(qe=!0,Ge=He+M[De-1][Ce-1]);const Ze=je>ae,Xe=Ze?M[De][Ce-1]+(H[De][Ce-1]>0?-5:0):0,rt=je>ae+1&&H[De][Ce-1]>0,tt=rt?M[De][Ce-2]+(H[De][Ce-2]>0?-5:0):0;if(rt&&(!Ze||tt>=Xe)&&(!qe||tt>=Ge))M[De][Ce]=tt,j[De][Ce]=3,H[De][Ce]=0;else if(Ze&&(!qe||Xe>=Ge))M[De][Ce]=Xe,j[De][Ce]=2,H[De][Ce]=0;else if(qe)M[De][Ce]=Ge,j[De][Ce]=1,H[De][Ce]=H[De-1][Ce-1]+1;else throw new Error("not possible")}}if(V&&ie(ee,F,$,X),!Fe[0]&&!me.firstMatchCanBeWeak)return;De--,Ce--;const Ye=[M[De][Ce],X];let J=0,se=0;for(;De>=1;){let ae=Ce;do{const ye=j[De][ae];if(ye===3)ae=ae-2;else if(ye===2)ae=ae-1;else break}while(ae>=1);J>1&&te[F+De-1]===K[X+Ce-1]&&!ce(ae+X-1,$,K)&&J+1>H[De][ae]&&(ae=Ce),ae===Ce?J++:J=1,se||(se=ae),De--,Ce=ae-1,Ye.push(Ce)}oe===Ee&&me.boostFullMatch&&(Ye[0]+=2);const _e=se-Ee;return Ye[0]-=_e,Ye}e.fuzzyScore=Se;function Re(ee,te,F,$,K,X){let me=ee-1,Ee=te-1;for(;me>=F&&Ee>=$;)K[me]===X[Ee]&&(re[me]=Ee,me--),Ee--}function ve(ee,te,F,$,K,X,me,Ee,oe,De,Ce){if(te[F]!==X[me])return Number.MIN_SAFE_INTEGER;let We=1,je=!1;return me===F-$?We=ee[F]===K[me]?7:5:ce(me,K,X)&&(me===0||!ce(me-1,K,X))?(We=ee[F]===K[me]?7:5,je=!0):Q(X,me)&&(me===0||!Q(X,me-1))?We=5:(Q(X,me-1)||ue(X,me-1))&&(We=5,je=!0),We>1&&F===$&&(Ce[0]=!0),je||(je=ce(me,K,X)||Q(X,me-1)||ue(X,me-1)),F===$?me>oe&&(We-=je?3:5):De?We+=je?2:0:We+=je?0:1,me+1===Ee&&(We-=je?3:5),We}function Te(ee,te,F,$,K,X,me){return le(ee,te,F,$,K,X,!0,me)}e.fuzzyScoreGracefulAggressive=Te;function Ae(ee,te,F,$,K,X,me){return le(ee,te,F,$,K,X,!1,me)}e.fuzzyScoreGraceful=Ae;function le(ee,te,F,$,K,X,me,Ee){let oe=Se(ee,te,F,$,K,X,Ee);if(oe&&!me)return oe;if(ee.length>=3){const De=Math.min(7,ee.length-1);for(let Ce=F+1;Ce<De;Ce++){const We=pe(ee,Ce);if(We){const je=Se(We,We.toLowerCase(),F,$,K,X,Ee);je&&(je[0]-=3,(!oe||je[0]>oe[0])&&(oe=je))}}}return oe}function pe(ee,te){if(te+1>=ee.length)return;const F=ee[te],$=ee[te+1];if(F!==$)return ee.slice(0,te)+$+F+ee.slice(te+2)}}),define(Ie[147],ke([1,0,77,97,8]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(d.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${P.source}`,"g");function b(v){return v.replace(D,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=b;const A=new RegExp(`\\\\${P.source}`,"g");function L(v){return v.replace(A,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function y(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(k,(g,E,h,l)=>h?g:E||l||"")}e.stripIcons=y;function T(v){const g=v.indexOf(e.iconStartMarker);return g===-1?{text:v}:_(v,g)}e.parseLabelWithIcons=T;function _(v,g){const E=[];let h="";function l(a){if(a){h+=a;for(const u of a)E.push(w)}}let f=-1,o="",w=0,r,s,n=g;const t=v.length;for(l(v.substr(0,g));n<t;)r=v[n],s=v[n+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=n,l(o),o=e.iconStartMarker,n++):r===")"&&f!==-1?(w+=n-f+1,f=-1,o=""):f!==-1?I.test(r)?o+=r:(l(o),f=-1,o=""):l(r),n++;return l(o),{text:h,iconOffsets:E}}function m(v,g,E=!1){const{text:h,iconOffsets:l}=g;if(!l||l.length===0)return(0,i.matchesFuzzy)(v,h,E);const f=(0,C.ltrim)(h," "),o=h.length-f.length,w=(0,i.matchesFuzzy)(v,f,E);if(w)for(const r of w){const s=l[r.start+o]+o;r.start+=s,r.end+=s}return w}e.matchesFuzzyIconAware=m}),define(Ie[81],ke([1,0,24]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new d.LRUCache(1e4);function C(A){return b(A,"NFC",i)}e.normalizeNFC=C;const P=new d.LRUCache(1e4);function I(A){return b(A,"NFD",P)}e.normalizeNFD=I;const D=/[^\u0000-\u0080]/;function b(A,L,k){if(!A)return A;const y=k.get(A);if(y)return y;let T;return D.test(A)?T=A.normalize(L):T=A,k.set(A,T),T}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(L){return I(L).replace(A,"")}}()}),define(Ie[43],ke([1,0,8]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(i||(i={})),function(C){const P="error",I="warning",D="warn",b="info",A="ignore";function L(y){return y?d.equalsIgnoreCase(P,y)?C.Error:d.equalsIgnoreCase(I,y)||d.equalsIgnoreCase(D,y)?C.Warning:d.equalsIgnoreCase(b,y)?C.Info:C.Ignore:C.Ignore}C.fromValue=L;function k(y){switch(y){case C.Error:return P;case C.Warning:return I;case C.Info:return b;default:return A}}C.toString=k}(i||(i={})),e.default=i}),define(Ie[14],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(a){return Array.isArray(a)}e.isArray=d;function i(a){return typeof a=="string"}e.isString=i;function C(a){return Array.isArray(a)&&a.every(u=>i(u))}e.isStringArray=C;function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=P;function I(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=I;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=b;function A(a){return a===!0||a===!1}e.isBoolean=A;function L(a){return typeof a=="undefined"}e.isUndefined=L;function k(a){return!y(a)}e.isDefined=k;function y(a){return L(a)||a===null}e.isUndefinedOrNull=y;function T(a,u){if(!a)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=T;function _(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=_;function m(...a){const u=[];for(let c=0;c<a.length;c++){const S=a[c];if(y(S))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);u.push(S)}return u}e.assertAllDefined=m;const v=Object.prototype.hasOwnProperty;function g(a){if(!P(a))return!1;for(let u in a)if(v.call(a,u))return!1;return!0}e.isEmptyObject=g;function E(a){return typeof a=="function"}e.isFunction=E;function h(...a){return a.length>0&&a.every(E)}e.areFunctions=h;function l(a,u){const c=Math.min(a.length,u.length);for(let S=0;S<c;S++)f(a[S],u[S])}e.validateConstraints=l;function f(a,u){if(i(u)){if(typeof a!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(E(u)){try{if(a instanceof u)return}catch{}if(!y(a)&&a.constructor===u||u.length===1&&u.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function o(a){let u=[],c=Object.getPrototypeOf(a);for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}e.getAllPropertyNames=o;function w(a){const u=[];for(const c of o(a))typeof a[c]=="function"&&u.push(c);return u}e.getAllMethodNames=w;function r(a,u){const c=R=>function(){const O=Array.prototype.slice.call(arguments,0);return u(R,O)};let S={};for(const R of a)S[R]=c(R);return S}e.createProxyObject=r;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function n(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=n;function t(a,u="Unreachable"){throw new Error(u)}e.assertNever=t}),define(Ie[30],ke([1,0,9,12,8,14]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(n){return n===47||n===92}e.isPathSeparator=I;function D(n){return n.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=D;function b(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=b;function A(n,t=d.posix.sep){if(!n)return"";const a=n.length,u=n.charCodeAt(0);if(I(u)){if(I(n.charCodeAt(1))&&!I(n.charCodeAt(2))){let S=3;const R=S;for(;S<a&&!I(n.charCodeAt(S));S++);if(R!==S&&!I(n.charCodeAt(S+1))){for(S+=1;S<a;S++)if(I(n.charCodeAt(S)))return n.slice(0,S+1).replace(/[\\/]/g,t)}}return t}else if(g(u)&&n.charCodeAt(1)===58)return I(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<a;c++)if(I(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=A;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let a=2;const u=a;for(;a<n.length&&(t=n.charCodeAt(a),t!==92);a++);return!(u===a||(t=n.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(n,t=i.isWindows){const a=t?k:y;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||t&&T.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=_;function m(n,t,a){const u=n===t;return!a||u?u:!n||!t?!1:(0,C.equalsIgnoreCase)(n,t)}e.isEqual=m;function v(n,t,a,u=d.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(a){if(!(0,C.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let S=t.length;return t.charAt(t.length-1)===u&&S--,n.charAt(S)===u}return t.charAt(t.length-1)!==u&&(t+=u),n.indexOf(t)===0}e.isEqualOrParent=v;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function E(n,t){return i.isWindows&&n.endsWith(":")&&(n+=d.sep),(0,d.isAbsolute)(n)||(n=(0,d.join)(t,n)),n=(0,d.normalize)(n),i.isWindows?(n=(0,C.rtrim)(n,d.sep),n.endsWith(":")&&(n+=d.sep)):(n=(0,C.rtrim)(n,d.sep),n||(n=d.sep)),n}e.sanitizeFilePath=E;function h(n){const t=(0,d.normalize)(n);return i.isWindows?n.length>3?!1:l(t)&&(n.length===2||t.charCodeAt(2)===92):t===d.posix.sep}e.isRootOrDriveLetter=h;function l(n,t=i.isWindows){return t?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function f(n){return l(n)?n[0]:void 0}e.getDriveLetter=f;function o(n,t,a){return t.length>n.length?-1:n===t?0:(a&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=o;function w(n){const t=n.split(":");let a,u,c;for(const S of t){const R=Number(S);(0,P.isNumber)(R)?u===void 0?u=R:c===void 0&&(c=R):a=a?[a,S].join(":"):S}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:c!==void 0?c:u!==void 0?1:void 0}}e.parseLineAndColumnAware=w;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,a=8){let u="";for(let S=0;S<a;S++)u+=r.charAt(Math.floor(Math.random()*r.length));let c;return t?c=`${t}-${u}`:c=u,n?(0,d.join)(n,c):c}e.randomPath=s}),define(Ie[26],ke([1,0,14]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(g=>{m[g]&&typeof m[g]=="object"?v[g]=i(m[g]):v[g]=m[g]}),v}e.deepClone=i;function C(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const E in g)if(P.call(g,E)){const h=g[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,d.isTypedArray)(h)&&v.push(h)}}return m}e.deepFreeze=C;const P=Object.prototype.hasOwnProperty;function I(m,v){return D(m,v,new Set)}e.cloneAndChange=I;function D(m,v,g){if((0,d.isUndefinedOrNull)(m))return m;const E=v(m);if(typeof E!="undefined")return E;if((0,d.isArray)(m)){const h=[];for(const l of m)h.push(D(l,v,g));return h}if((0,d.isObject)(m)){if(g.has(m))throw new Error("Cannot clone recursive data-structure");g.add(m);const h={};for(let l in m)P.call(m,l)&&(h[l]=D(m[l],v,g));return g.delete(m),h}return m}function b(m,v,g=!0){return(0,d.isObject)(m)?((0,d.isObject)(v)&&Object.keys(v).forEach(E=>{E in m?g&&((0,d.isObject)(m[E])&&(0,d.isObject)(v[E])?b(m[E],v[E],g):m[E]=v[E]):m[E]=v[E]}),m):v}e.mixin=b;function A(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let g,E;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(g=0;g<m.length;g++)if(!A(m[g],v[g]))return!1}else{const h=[];for(E in m)h.push(E);h.sort();const l=[];for(E in v)l.push(E);if(l.sort(),!A(h,l))return!1;for(g=0;g<h.length;g++)if(!A(m[h[g]],v[h[g]]))return!1}return!0}e.equals=A;function L(m){const v=new Set;return JSON.stringify(m,(g,E)=>{if((0,d.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}e.safeStringify=L;function k(m,v,g){const E=v(m);return typeof E=="undefined"?g:E}e.getOrDefault=k;function y(m,v){const g=Object.create(null);return!m||!v||Object.keys(v).forEach(h=>{const l=m[h],f=v[h];A(l,f)||(g[h]=f)}),g}e.distinct=y;function T(m,v){const g=v.toLowerCase(),E=Object.keys(m).find(h=>h.toLowerCase()===g);return E?m[E]:m[v]}e.getCaseInsensitive=T;function _(m,v){const g=Object.create(null);for(const[E,h]of Object.entries(m))v(E,h)&&(g[E]=h);return g}e.filter=_}),define(Ie[98],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function i(P){return P<0?0:P>255?255:P|0}e.toUint8=i;function C(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=C}),define(Ie[2],ke([1,0,9,12]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,P=/^\//,I=/^\/\//;function D(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(r,s){return!r&&!s?"file":r}function A(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const L="",k="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(s,n,t,a,u,c=!1){typeof s=="object"?(this.scheme=s.scheme||L,this.authority=s.authority||L,this.path=s.path||L,this.query=s.query||L,this.fragment=s.fragment||L):(this.scheme=b(s,c),this.authority=n||L,this.path=A(this.scheme,t||L),this.query=a||L,this.fragment=u||L,D(this,c))}static isUri(s){return s instanceof T?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:t,path:a,query:u,fragment:c}=s;return n===void 0?n=this.scheme:n===null&&(n=L),t===void 0?t=this.authority:t===null&&(t=L),a===void 0?a=this.path:a===null&&(a=L),u===void 0?u=this.query:u===null&&(u=L),c===void 0?c=this.fragment:c===null&&(c=L),n===this.scheme&&t===this.authority&&a===this.path&&u===this.query&&c===this.fragment?this:new m(n,t,a,u,c)}static parse(s,n=!1){const t=y.exec(s);return t?new m(t[2]||L,w(t[4]||L),w(t[5]||L),w(t[7]||L),w(t[9]||L),n):new m(L,L,L,L,L)}static file(s){let n=L;if(i.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const t=s.indexOf(k,2);t===-1?(n=s.substring(2),s=k):(n=s.substring(2,t),s=s.substring(t)||k)}return new m("file",n,s,L,L)}static from(s){const n=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return D(n,!0),n}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return i.isWindows&&s.scheme==="file"?t=T.file(d.win32.join(h(s,!0),...n)).path:t=d.posix.join(s.path,...n),s.with({path:t})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof T)return s;{const n=new m(s);return n._formatted=s.external,n._fsPath=s._sep===_?s.fsPath:null,n}}else return s}}e.URI=T;const _=i.isWindows?1:void 0;class m extends T{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=_),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,s){let n,t=-1;for(let a=0;a<r.length;a++){const u=r.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||s&&u===47)t!==-1&&(n+=encodeURIComponent(r.substring(t,a)),t=-1),n!==void 0&&(n+=r.charAt(a));else{n===void 0&&(n=r.substr(0,a));const c=v[u];c!==void 0?(t!==-1&&(n+=encodeURIComponent(r.substring(t,a)),t=-1),n+=c):t===-1&&(t=a)}}return t!==-1&&(n+=encodeURIComponent(r.substring(t))),n!==void 0?n:r}function E(r){let s;for(let n=0;n<r.length;n++){const t=r.charCodeAt(n);t===35||t===63?(s===void 0&&(s=r.substr(0,n)),s+=v[t]):s!==void 0&&(s+=r[n])}return s!==void 0?s:r}function h(r,s){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=h;function l(r,s){const n=s?E:g;let t="",{scheme:a,authority:u,path:c,query:S,fragment:R}=r;if(a&&(t+=a,t+=":"),(u||a==="file")&&(t+=k,t+=k),u){let O=u.indexOf("@");if(O!==-1){const N=u.substr(0,O);u=u.substr(O+1),O=N.indexOf(":"),O===-1?t+=n(N,!1):(t+=n(N.substr(0,O),!1),t+=":",t+=n(N.substr(O+1),!1)),t+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?t+=n(u,!1):(t+=n(u.substr(0,O),!1),t+=u.substr(O))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const O=c.charCodeAt(1);O>=65&&O<=90&&(c=`/${String.fromCharCode(O+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const O=c.charCodeAt(0);O>=65&&O<=90&&(c=`${String.fromCharCode(O+32)}:${c.substr(2)}`)}t+=n(c,!0)}return S&&(t+="?",t+=n(S,!1)),R&&(t+="#",t+=s?R:g(R,!1)),t}function f(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+f(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(r){return r.match(o)?r.replace(o,s=>f(s)):r}}),define(Ie[60],ke([1,0,23,8,2]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(A){return JSON.stringify(A,D)}e.stringify=P;function I(A){let L=JSON.parse(A);return L=b(L),L}e.parse=I;function D(A,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,i.regExpFlags)(L)}:L}function b(A,L=0){if(!A||L>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return C.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof d.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let k=0;k<A.length;++k)A[k]=b(A[k],L+1);else for(const k in A)Object.hasOwnProperty.call(A,k)&&(A[k]=b(A[k],L+1))}return A}e.revive=b}),define(Ie[10],ke([1,0,12,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${C.vscodeRemoteResource}`}set(b,A,L){this._hosts[b]=A,this._ports[b]=L}setConnectionToken(b,A){this._connectionTokens[b]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const A=b.authority;let L=this._hosts[A];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const k=this._ports[A],y=this._connectionTokens[A];let T=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),i.URI.from({scheme:d.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${L}:${k}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new P;class I{asBrowserUri(b,A){const L=this.toUri(b,A);return L.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===C.file&&(d.isNative||d.isWebWorker&&d.globals.origin===`${C.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?L.with({scheme:C.vscodeFileResource,authority:L.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(b,A){const L=this.toUri(b,A);return L.scheme===C.vscodeFileResource?L.with({scheme:C.file,authority:L.authority!==I.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(b,A){return i.URI.isUri(b)?b:i.URI.parse(A.toUrl(b))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Ie[22],ke([1,0,30,10,9,12,8,2]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(T){return(0,D.uriToFsPath)(T,!0)}e.originalFSPath=b;class A{constructor(_){this._ignorePathCasing=_}compare(_,m,v=!1){return _===m?0:(0,I.compare)(this.getComparisonKey(_,v),this.getComparisonKey(m,v))}isEqual(_,m,v=!1){return _===m?!0:!_||!m?!1:this.getComparisonKey(_,v)===this.getComparisonKey(m,v)}getComparisonKey(_,m=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,m,v=!1){if(_.scheme===m.scheme){if(_.scheme===i.Schemas.file)return d.isEqualOrParent(b(_),b(m),this._ignorePathCasing(_))&&_.query===m.query&&(v||_.fragment===m.fragment);if((0,e.isEqualAuthority)(_.authority,m.authority))return d.isEqualOrParent(_.path,m.path,this._ignorePathCasing(_),"/")&&_.query===m.query&&(v||_.fragment===m.fragment)}return!1}joinPath(_,...m){return D.URI.joinPath(_,...m)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return C.posix.basename(_.path)}extname(_){return C.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let m;return _.scheme===i.Schemas.file?m=D.URI.file(C.dirname(b(_))).path:(m=C.posix.dirname(_.path),_.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),m="/")),_.with({path:m})}normalizePath(_){if(!_.path.length)return _;let m;return _.scheme===i.Schemas.file?m=D.URI.file(C.normalize(b(_))).path:m=C.posix.normalize(_.path),_.with({path:m})}relativePath(_,m){if(_.scheme!==m.scheme||!(0,e.isEqualAuthority)(_.authority,m.authority))return;if(_.scheme===i.Schemas.file){const E=C.relative(b(_),b(m));return P.isWindows?d.toSlashes(E):E}let v=_.path||"/",g=m.path||"/";if(this._ignorePathCasing(_)){let E=0;for(const h=Math.min(v.length,g.length);E<h&&!(v.charCodeAt(E)!==g.charCodeAt(E)&&v.charAt(E).toLowerCase()!==g.charAt(E).toLowerCase());E++);v=g.substr(0,E)+v.substr(E)}return C.posix.relative(v,g)}resolvePath(_,m){if(_.scheme===i.Schemas.file){const v=D.URI.file(C.resolve(b(_),m));return _.with({authority:v.authority,path:v.path})}return m=d.toPosixPath(m),_.with({path:C.posix.resolve(_.path,m)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,m){return _===m||_!==void 0&&m!==void 0&&(0,I.equalsIgnoreCase)(_,m)}hasTrailingPathSeparator(_,m=C.sep){if(_.scheme===i.Schemas.file){const v=b(_);return v.length>d.getRoot(v).length&&v[v.length-1]===m}else{const v=_.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,m=C.sep){return(0,e.hasTrailingPathSeparator)(_,m)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,m=C.sep){let v=!1;if(_.scheme===i.Schemas.file){const g=b(_);v=g!==void 0&&g.length===d.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=_.path;v=g.length===1&&g.charCodeAt(g.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(_,m)?_.with({path:_.path+"/"}):_}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(T=>T.scheme===i.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new A(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,_){const m=[];for(let v=0;v<T.length;v++){const g=_(T[v]);T.some((E,h)=>h===v?!1:(0,e.isEqualOrParent)(g,_(E)))||m.push(T[v])}return m}e.distinctParents=L;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function _(m){const v=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[l,f]=h.split(":");l&&f&&v.set(l,f)});const E=m.path.substring(0,m.path.indexOf(";"));return E&&v.set(T.META_DATA_MIME,E),v}T.parseMetaData=_})(k=e.DataUri||(e.DataUri={}));function y(T,_,m){if(_){let v=T.path;return v&&v[0]!==C.posix.sep&&(v=C.posix.sep+v),T.with({scheme:m,authority:_,path:v})}return T.with({scheme:m})}e.toLocalResource=y}),define(Ie[17],ke([1,0,21,11,3,6,22,12]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(ce){return!!ce&&typeof ce.then=="function"}e.isThenable=b;function A(ce){const G=new d.CancellationTokenSource,ge=ce(G.token),ne=new Promise((he,Se)=>{const Re=G.token.onCancellationRequested(()=>{Re.dispose(),G.dispose(),Se(new i.CancellationError)});Promise.resolve(ge).then(ve=>{Re.dispose(),G.dispose(),he(ve)},ve=>{Re.dispose(),G.dispose(),Se(ve)})});return new class{cancel(){G.cancel()}then(he,Se){return ne.then(he,Se)}catch(he){return this.then(void 0,he)}finally(he){return ne.finally(he)}}}e.createCancelablePromise=A;function L(ce,G,ge){return new Promise((ne,he)=>{const Se=G.onCancellationRequested(()=>{Se.dispose(),ne(ge)});ce.then(ne,he).finally(()=>Se.dispose())})}e.raceCancellation=L;function k(ce,G){return new Promise((ge,ne)=>{const he=G.onCancellationRequested(()=>{he.dispose(),ne(new i.CancellationError)});ce.then(ge,ne).finally(()=>he.dispose())})}e.raceCancellationError=k;async function y(ce){let G=-1;const ge=ce.map((he,Se)=>he.then(Re=>(G=Se,Re))),ne=await Promise.race(ge);return ce.forEach((he,Se)=>{Se!==G&&he.cancel()}),ne}e.raceCancellablePromises=y;function T(ce,G,ge){let ne;const he=setTimeout(()=>{ne?.(void 0),ge?.()},G);return Promise.race([ce.finally(()=>clearTimeout(he)),new Promise(Se=>ne=Se)])}e.raceTimeout=T;function _(ce){return new Promise((G,ge)=>{const ne=ce();b(ne)?ne.then(G,ge):G(ne)})}e.asPromise=_;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const ne=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ne};this.queuedPromise=new Promise(ne=>{this.activePromise.then(ge,ge).then(ne)})}return new Promise((ge,ne)=>{this.queuedPromise.then(ge,ne)})}return this.activePromise=G(),new Promise((ge,ne)=>{this.activePromise.then(he=>{this.activePromise=null,ge(he)},he=>{this.activePromise=null,ne(he)})})}}e.Throttler=m;class v{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=v;class g{constructor(){this.promiseMap=new Map}queue(G,ge){const he=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(G)===he&&this.promiseMap.delete(G)});return this.promiseMap.set(G,he),he}}e.SequencerByKey=g;const E=(ce,G)=>{let ge=!0;const ne=setTimeout(()=>{ge=!1,G()},ce);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ne),ge=!1}}},h=ce=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ce())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,ge=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((he,Se)=>{this.doResolve=he,this.doReject=Se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const he=this.task;return this.task=null,he()}}));const ne=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?h(ne):E(ge,ne),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class f{constructor(G){this.delayer=new l(G),this.throttler=new m}trigger(G,ge){return this.delayer.trigger(()=>this.throttler.queue(G),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class o{constructor(){this._isOpen=!1,this._promise=new Promise((G,ge)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class w extends o{constructor(G){super();this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=w;function r(ce,G){return G?new Promise((ge,ne)=>{const he=setTimeout(()=>{Se.dispose(),ge()},ce),Se=G.onCancellationRequested(()=>{clearTimeout(he),Se.dispose(),ne(new i.CancellationError)})}):A(ge=>r(ce,ge))}e.timeout=r;function s(ce,G=0){const ge=setTimeout(ce,G);return(0,P.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=s;function n(ce){const G=[];let ge=0;const ne=ce.length;function he(){return ge<ne?ce[ge++]():null}function Se(Re){Re!=null&&G.push(Re);const ve=he();return ve?ve.then(Se):Promise.resolve(G)}return Promise.resolve(null).then(Se)}e.sequence=n;function t(ce,G=ne=>!!ne,ge=null){let ne=0;const he=ce.length,Se=()=>{if(ne>=he)return Promise.resolve(ge);const Re=ce[ne++];return Promise.resolve(Re()).then(Te=>G(Te)?Promise.resolve(Te):Se())};return Se()}e.first=t;function a(ce,G=ne=>!!ne,ge=null){if(ce.length===0)return Promise.resolve(ge);let ne=ce.length;const he=()=>{ne=-1;for(const Se of ce)Se.cancel?.()};return new Promise((Se,Re)=>{for(const ve of ce)ve.then(Te=>{--ne>=0&&G(Te)?(he(),Se(Te)):ne===0&&Se(ge)}).catch(Te=>{--ne>=0&&(he(),Re(Te))})})}e.firstParallel=a;class u{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){return this._size++,new Promise((ge,ne)=>{this.outstandingPromises.push({factory:G,c:ge,e:ne}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const ge=G.factory();ge.then(G.c,G.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class c extends u{constructor(){super(1)}}e.Queue=c;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const G=new j;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueFor(G,ge=I.extUri){const ne=ge.getComparisonKey(G);let he=this.queues.get(ne);return he||(he=new c,C.Event.once(he.onDrained)(()=>{he?.dispose(),this.queues.delete(ne),this.onDidQueueDrain()}),this.queues.set(ne,he)),he}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class R{constructor(G,ge){this._token=-1,typeof G=="function"&&typeof ge=="number"&&this.setIfNotSet(G,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},ge)}setIfNotSet(G,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},ge))}}e.TimeoutTimer=R;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,ge){this.cancel(),this._token=setInterval(()=>{G()},ge)}}e.IntervalTimer=O;class N{constructor(G,ge){this.timeoutToken=-1,this.runner=G,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class p{constructor(G,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class U extends N{constructor(G,ge){super(G,ge);this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner&&this.runner(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class B extends P.Disposable{constructor(G,ge){super();this.options=G,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...G),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ce=>{(0,D.setTimeout0)(()=>{if(G)return;const ge=Date.now()+15;ce(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(ce,G)=>{const ge=requestIdleCallback(ce,typeof G=="number"?{timeout:G}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,cancelIdleCallback(ge))}}}}();class z{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function re(ce,G,ge){let ne;for(let he=0;he<ge;he++)try{return await ce()}catch(Se){ne=Se,await r(G)}throw ne}e.retry=re;class H{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(G,ge,ne){return this._pending={taskId:G,cancel:()=>ne?.(),promise:ge},ge.then(()=>this.donePending(G),()=>this.donePending(G)),ge}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let ge,ne;const he=new Promise((Se,Re)=>{ge=Se,ne=Re});this._next={run:G,promise:he,promiseResolve:ge,promiseReject:ne}}return this._next.promise}}e.TaskSequentializer=H;class M{constructor(G,ge=()=>Date.now()){this.interval=G,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,ge)=>{this.completeCallback=G,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(G){return new Promise(ge=>{this.completeCallback(G),this.resolved=!0,ge()})}error(G){return new Promise(ge=>{this.errorCallback(G),this.rejected=!0,ge()})}cancel(){new Promise(G=>{this.errorCallback(new i.CancellationError),this.rejected=!0,G()})}}e.DeferredPromise=j;var V;(function(ce){async function G(ne){let he;const Se=await Promise.all(ne.map(Re=>Re.then(ve=>ve,ve=>{he||(he=ve)})));if(typeof he!="undefined")throw he;return Se}ce.settled=G;function ge(ne){return new Promise(async(he,Se)=>{try{await ne(he,Se)}catch(Re){Se(Re)}})}ce.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var q;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(q||(q={}));class ie{constructor(G){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const ge={emitOne:ne=>this.emitOne(ne),emitMany:ne=>this.emitMany(ne),reject:ne=>this.reject(ne)};try{await Promise.resolve(G(ge)),this.resolve()}catch(ne){this.reject(ne)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(G){return new ie(ge=>{ge.emitMany(G)})}static fromPromise(G){return new ie(async ge=>{ge.emitMany(await G)})}static fromPromises(G){return new ie(async ge=>{await Promise.all(G.map(async ne=>ge.emitOne(await ne)))})}static merge(G){return new ie(async ge=>{await Promise.all(G.map(async ne=>{for await(const he of ne)ge.emitOne(he)}))})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(G,ge){return new ie(async ne=>{for await(const he of G)ne.emitOne(ge(he))})}map(G){return ie.map(this,G)}static filter(G,ge){return new ie(async ne=>{for await(const he of G)ge(he)&&ne.emitOne(he)})}filter(G){return ie.filter(this,G)}static coalesce(G){return ie.filter(G,ge=>!!ge)}coalesce(){return ie.coalesce(this)}static async toPromise(G){const ge=[];for await(const ne of G)ge.push(ne);return ge}toPromise(){return ie.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class Q extends ie{constructor(G,ge){super(ge);this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function ue(ce){const G=new d.CancellationTokenSource,ge=ce(G.token);return new Q(G,async ne=>{const he=G.token.onCancellationRequested(()=>{he.dispose(),G.dispose(),ne.reject(new i.CancellationError)});try{for await(const Se of ge){if(G.token.isCancellationRequested)return;ne.emitOne(Se)}he.dispose(),G.dispose()}catch(Se){he.dispose(),G.dispose(),ne.reject(Se)}})}e.createCancelableAsyncIterable=ue}),define(Ie[99],ke([1,0,17,9]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new d.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),P=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(c,S,R=!1){const O=c||"",N=S||"",p=C.value.collator.compare(O,N);return C.value.collatorIsNumeric&&p===0&&O!==N?O<N?-1:1:p}e.compareFileNames=D;function b(c,S){const R=P.value.collator;return c=c||"",S=S||"",f(R,c,S)}e.compareFileNamesDefault=b;function A(c,S){const R=P.value.collator;return c=c||"",S=S||"",s(c,S)||f(R,c,S)}e.compareFileNamesUpper=A;function L(c,S){const R=P.value.collator;return c=c||"",S=S||"",r(c,S)||f(R,c,S)}e.compareFileNamesLower=L;function k(c,S){return c=c||"",S=S||"",c===S?0:c<S?-1:1}e.compareFileNamesUnicode=k;function y(c,S,R=!1){R||(c=c&&c.toLowerCase(),S=S&&S.toLowerCase());const[O,N]=h(c),[p,U]=h(S);return O!==p?O<p?-1:1:N===U?0:N<U?-1:1}e.noIntlCompareFileNames=y;function T(c,S){const[R,O]=h(c),[N,p]=h(S);let U=C.value.collator.compare(O,p);if(U===0){if(C.value.collatorIsNumeric&&O!==p)return O<p?-1:1;if(U=C.value.collator.compare(R,N),C.value.collatorIsNumeric&&U===0&&R!==N)return R<N?-1:1}return U}e.compareFileExtensions=T;function _(c,S){c=c||"",S=S||"";const R=l(c),O=l(S),N=P.value.collator,p=I.value.collator;return f(p,R,O)||f(N,c,S)}e.compareFileExtensionsDefault=_;function m(c,S){c=c||"",S=S||"";const R=l(c),O=l(S),N=P.value.collator,p=I.value.collator;return f(p,R,O)||s(c,S)||f(N,c,S)}e.compareFileExtensionsUpper=m;function v(c,S){c=c||"",S=S||"";const R=l(c),O=l(S),N=P.value.collator,p=I.value.collator;return f(p,R,O)||r(c,S)||f(N,c,S)}e.compareFileExtensionsLower=v;function g(c,S){c=c||"",S=S||"";const R=l(c).toLowerCase(),O=l(S).toLowerCase();return R!==O?R<O?-1:1:c!==S?c<S?-1:1:0}e.compareFileExtensionsUnicode=g;const E=/^(.*?)(\.([^.]*))?$/;function h(c,S=!1){const R=c?E.exec(c):[];let O=[R&&R[1]||"",R&&R[3]||""];return S&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function l(c){const S=c?E.exec(c):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function f(c,S,R){let O=c.compare(S,R);return O!==0?O:S.length!==R.length?S.length<R.length?-1:1:0}function o(c){const S=c.charAt(0);return S.toLocaleUpperCase()!==S}function w(c){const S=c.charAt(0);return S.toLocaleLowerCase()!==S}function r(c,S){return o(c)&&w(S)?-1:w(c)&&o(S)?1:0}function s(c,S){return w(c)&&o(S)?-1:o(c)&&w(S)?1:0}function n(c,S,R=!1){return R||(c=c&&c.toLowerCase(),S=S&&S.toLowerCase()),c===S?0:c<S?-1:1}function t(c,S,R=!1){const O=c.split(i.sep),N=S.split(i.sep),p=O.length-1,U=N.length-1;let B,z;for(let re=0;;re++){if(B=p===re,z=U===re,B&&z)return D(O[re],N[re],R);if(B)return-1;if(z)return 1;const H=n(O[re],N[re],R);if(H!==0)return H}}e.comparePaths=t;function a(c,S,R){const O=c.toLowerCase(),N=S.toLowerCase(),p=u(c,S,R);if(p)return p;const U=O.endsWith(R),B=N.endsWith(R);if(U!==B)return U?-1:1;const z=D(O,N);return z!==0?z:O.localeCompare(N)}e.compareAnything=a;function u(c,S,R){const O=c.toLowerCase(),N=S.toLowerCase(),p=O.startsWith(R),U=N.startsWith(R);if(p!==U)return p?-1:1;if(p&&U){if(O.length<N.length)return-1;if(O.length>N.length)return 1}return 0}e.compareByPrefix=u}),define(Ie[100],ke([1,0,99,97,59,9,12,8]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const b=0,A=[b,[]];function L(H,M,j,V){if(!H||!M)return A;const q=H.length,ie=M.length;if(q<ie)return A;const Q=H.toLowerCase();return k(M,j,ie,H,Q,q,V)}e.scoreFuzzy=L;function k(H,M,j,V,q,ie,Q){const ue=[],ce=[];for(let he=0;he<j;he++){const Se=he*ie,Re=Se-ie,ve=he>0,Te=H[he],Ae=M[he];for(let le=0;le<ie;le++){const pe=le>0,ee=Se+le,te=ee-1,F=Re+le-1,$=pe?ue[te]:0,K=ve&&pe?ue[F]:0,X=ve&&pe?ce[F]:0;let me;!K&&ve?me=0:me=y(Te,Ae,V,q,le,X),me&&K+me>=$&&(Q||ve||q.startsWith(M,le))?(ce[ee]=X+1,ue[ee]=K+me):(ce[ee]=b,ue[ee]=$)}}const G=[];let ge=j-1,ne=ie-1;for(;ge>=0&&ne>=0;){const he=ge*ie+ne;ce[he]===b||(G.push(ne),ge--),ne--}return[ue[j*ie-1],G.reverse()]}function y(H,M,j,V,q,ie){let Q=0;if(!T(M,V[q]))return Q;if(Q+=1,ie>0&&(Q+=ie*5),H===j[q]&&(Q+=1),q===0)Q+=8;else{const ue=_(j.charCodeAt(q-1));ue?Q+=ue:(0,i.isUpper)(j.charCodeAt(q))&&ie===0&&(Q+=2)}return Q}function T(H,M){return H===M?!0:H==="/"||H==="\\"?M==="/"||M==="\\":!1}function _(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function v(H,M,j=0,V=0){const q=M;return q.values&&q.values.length>1?g(H,q.values,j,V):E(H,M,j,V)}e.scoreFuzzy2=v;function g(H,M,j,V){let q=0;const ie=[];for(const Q of M){const[ue,ce]=E(H,Q,j,V);if(typeof ue!="number")return m;q+=ue,ie.push(...ce)}return[q,u(ie)]}function E(H,M,j,V){const q=(0,i.fuzzyScore)(M.original,M.originalLowercase,j,H,H.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,i.createMatches)(q)]:m}const h=Object.freeze({score:0}),l=1<<18,f=1<<17,o=1<<16;function w(H,M,j,V){const q=V.values?V.values:[V];return(0,C.hash)({[V.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:H,description:M,allowNonContiguousMatches:j}})}function r(H,M,j,V,q){if(!H||!M.normalized)return h;const ie=V.getItemLabel(H);if(!ie)return h;const Q=V.getItemDescription(H),ue=w(ie,Q,j,M),ce=q[ue];if(ce)return ce;const G=s(ie,Q,V.getItemPath(H),M,j);return q[ue]=G,G}e.scoreItemFuzzy=r;function s(H,M,j,V,q){const ie=!j||!V.containsPathSeparator;return j&&(I.isLinux?V.pathNormalized===j:(0,D.equalsIgnoreCase)(V.pathNormalized,j))?{score:l,labelMatch:[{start:0,end:H.length}],descriptionMatch:M?[{start:0,end:M.length}]:void 0}:V.values&&V.values.length>1?n(H,M,j,V.values,ie,q):t(H,M,j,V,ie,q)}function n(H,M,j,V,q,ie){let Q=0;const ue=[],ce=[];for(const G of V){const{score:ge,labelMatch:ne,descriptionMatch:he}=t(H,M,j,G,q,ie);if(ge===b)return h;Q+=ge,ne&&ue.push(...ne),he&&ce.push(...he)}return{score:Q,labelMatch:u(ue),descriptionMatch:u(ce)}}function t(H,M,j,V,q,ie){if(q||!M){const[Q,ue]=L(H,V.normalized,V.normalizedLowercase,ie&&!V.expectContiguousMatch);if(Q){const ce=(0,i.matchesPrefix)(V.normalized,H);let G;return ce?(G=f,G+=Math.round(V.normalized.length/H.length*100)):G=o,{score:G+Q,labelMatch:ce||a(ue)}}}if(M){let Q=M;j&&(Q=`${M}${P.sep}`);const ue=Q.length,ce=`${Q}${H}`,[G,ge]=L(ce,V.normalized,V.normalizedLowercase,ie&&!V.expectContiguousMatch);if(G){const ne=a(ge),he=[],Se=[];return ne.forEach(Re=>{Re.start<ue&&Re.end>ue?(he.push({start:0,end:Re.end-ue}),Se.push({start:Re.start,end:ue})):Re.start>=ue?he.push({start:Re.start-ue,end:Re.end-ue}):Se.push(Re)}),{score:G,labelMatch:he,descriptionMatch:Se}}}return h}function a(H){const M=[];if(!H)return M;let j;for(const V of H)j&&j.end===V?j.end+=1:(j={start:V,end:V+1},M.push(j));return M}function u(H){const M=H.sort((q,ie)=>q.start-ie.start),j=[];let V;for(const q of M)!V||!c(V,q)?(V=q,j.push(q)):(V.start=Math.min(V.start,q.start),V.end=Math.max(V.end,q.end));return j}function c(H,M){return!(H.end<M.start||M.end<H.start)}function S(H,M,j,V,q,ie){const Q=r(H,j,V,q,ie),ue=r(M,j,V,q,ie),ce=Q.score,G=ue.score;if((ce===l||G===l)&&ce!==G)return ce===l?-1:1;if(ce>o||G>o){if(ce!==G)return ce>G?-1:1;if(ce<f&&G<f){const Te=O(Q.labelMatch,ue.labelMatch);if(Te!==0)return Te}const Re=q.getItemLabel(H)||"",ve=q.getItemLabel(M)||"";if(Re.length!==ve.length)return Re.length-ve.length}if(ce!==G)return ce>G?-1:1;const ge=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,ne=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(ge&&!ne)return-1;if(ne&&!ge)return 1;const he=R(H,Q,q),Se=R(M,ue,q);return he&&Se&&he!==Se?Se>he?-1:1:N(H,M,j,q)}e.compareItemsByFuzzyScore=S;function R(H,M,j){let V=-1,q=-1;if(M.descriptionMatch&&M.descriptionMatch.length?V=M.descriptionMatch[0].start:M.labelMatch&&M.labelMatch.length&&(V=M.labelMatch[0].start),M.labelMatch&&M.labelMatch.length){if(q=M.labelMatch[M.labelMatch.length-1].end,M.descriptionMatch&&M.descriptionMatch.length){const ie=j.getItemDescription(H);ie&&(q+=ie.length)}}else M.descriptionMatch&&M.descriptionMatch.length&&(q=M.descriptionMatch[M.descriptionMatch.length-1].end);return q-V}function O(H,M){if(!H&&!M||(!H||!H.length)&&(!M||!M.length))return 0;if(!M||!M.length)return-1;if(!H||!H.length)return 1;const j=H[0].start,q=H[H.length-1].end-j,ie=M[0].start,ue=M[M.length-1].end-ie;return q===ue?0:ue<q?1:-1}function N(H,M,j,V){const q=V.getItemLabel(H)||"",ie=V.getItemLabel(M)||"",Q=V.getItemDescription(H),ue=V.getItemDescription(M),ce=q.length+(Q?Q.length:0),G=ie.length+(ue?ue.length:0);if(ce!==G)return ce-G;const ge=V.getItemPath(H),ne=V.getItemPath(M);return ge&&ne&&ge.length!==ne.length?ge.length-ne.length:q!==ie?(0,d.compareAnything)(q,ie,j.normalized):Q&&ue&&Q!==ue?(0,d.compareAnything)(Q,ue,j.normalized):ge&&ne&&ge!==ne?(0,d.compareAnything)(ge,ne,j.normalized):0}function p(H){return H.startsWith('"')&&H.endsWith('"')}const U=" ";function B(H){typeof H!="string"&&(H="");const M=H.toLowerCase(),{pathNormalized:j,normalized:V,normalizedLowercase:q}=z(H),ie=j.indexOf(P.sep)>=0,Q=p(H);let ue;const ce=H.split(U);if(ce.length>1)for(const G of ce){const ge=p(G),{pathNormalized:ne,normalized:he,normalizedLowercase:Se}=z(G);he&&(ue||(ue=[]),ue.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:ne,normalized:he,normalizedLowercase:Se,expectContiguousMatch:ge}))}return{original:H,originalLowercase:M,pathNormalized:j,normalized:V,normalizedLowercase:q,values:ue,containsPathSeparator:ie,expectContiguousMatch:Q}}e.prepareQuery=B;function z(H){let M;I.isWindows?M=H.replace(/\//g,P.sep):M=H.replace(/\\/g,P.sep);const j=(0,D.stripWildcards)(M).replace(/\s|"/g,"");return{pathNormalized:M,normalized:j,normalizedLowercase:j.toLowerCase()}}function re(H){return Array.isArray(H)?B(H.map(M=>M.original).join(U)):B(H.original)}e.pieceToQuery=re}),define(Ie[34],ke([1,0,16,17,30,24,9,12,8]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",y=/\//g;function T(j,V){switch(j){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${V?`|${L}${k}+`:""})*?`}}function _(j,V){if(!j)return[];const q=[];let ie=!1,Q=!1,ue="";for(const ce of j){switch(ce){case V:if(!ie&&!Q){q.push(ue),ue="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ue+=ce}return ue&&q.push(ue),q}e.splitGlobAware=_;function m(j){if(!j)return"";let V="";const q=_(j,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))V=".*";else{let ie=!1;q.forEach((Q,ue)=>{if(Q===e.GLOBSTAR){if(ie)return;V+=T(2,ue===q.length-1)}else{let ce=!1,G="",ge=!1,ne="";for(const he of Q){if(he!=="}"&&ce){G+=he;continue}if(ge&&(he!=="]"||!ne)){let Se;he==="-"?Se=he:(he==="^"||he==="!")&&!ne?Se="^":he===e.GLOB_SPLIT?Se="":Se=(0,b.escapeRegExpCharacters)(he),ne+=Se;continue}switch(he){case"{":ce=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${_(G,",").map(ve=>m(ve)).join("|")})`,ce=!1,G="";break}case"]":{V+="["+ne+"]",ge=!1,ne="";break}case"?":V+=k;continue;case"*":V+=T(1);continue;default:V+=(0,b.escapeRegExpCharacters)(he)}}ue<q.length-1&&(q[ue+1]!==e.GLOBSTAR||ue+2<q.length)&&(V+=L)}ie=Q===e.GLOBSTAR})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new P.LRUCache(1e4),w=function(){return!1},r=function(){return null};function s(j,V){if(!j)return r;let q;typeof j!="string"?q=j.pattern:q=j,q=q.trim();const ie=`${q}_${!!V.trimForExclusions}`;let Q=o.get(ie);if(Q)return n(Q,j);let ue;return v.test(q)?Q=a(q.substr(4),q):(ue=g.exec(t(q,V)))?Q=u(ue[1],q):(V.trimForExclusions?h:E).test(q)?Q=c(q,V):(ue=l.exec(t(q,V)))?Q=S(ue[1].substr(1),q,!0):(ue=f.exec(t(q,V)))?Q=S(ue[1],q,!1):Q=R(q),o.set(ie,Q),n(Q,j)}function n(j,V){if(typeof V=="string")return j;const q=function(ie,Q){return(0,C.isEqualOrParent)(ie,V.base,!D.isLinux)?j(ie.substr(V.base.length+1),Q):null};return q.allBasenames=j.allBasenames,q.allPaths=j.allPaths,q.basenames=j.basenames,q.patterns=j.patterns,q}function t(j,V){return V.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function a(j,V){return function(q,ie){return typeof q=="string"&&q.endsWith(j)?V:null}}function u(j,V){const q=`/${j}`,ie=`\\${j}`,Q=function(ce,G){return typeof ce!="string"?null:G?G===j?V:null:ce===j||ce.endsWith(q)||ce.endsWith(ie)?V:null},ue=[j];return Q.basenames=ue,Q.patterns=[V],Q.allBasenames=ue,Q}function c(j,V){const q=H(j.slice(1,-1).split(",").map(G=>s(G,V)).filter(G=>G!==r),j),ie=q.length;if(!ie)return r;if(ie===1)return q[0];const Q=function(G,ge){for(let ne=0,he=q.length;ne<he;ne++)if(q[ne](G,ge))return j;return null},ue=q.find(G=>!!G.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ce=q.reduce((G,ge)=>ge.allPaths?G.concat(ge.allPaths):G,[]);return ce.length&&(Q.allPaths=ce),Q}function S(j,V,q){const ie=I.sep===I.posix.sep,Q=ie?j:j.replace(y,I.sep),ue=I.sep+Q,ce=I.posix.sep+j;let G;return q?G=function(ge,ne){return typeof ge=="string"&&(ge===Q||ge.endsWith(ue)||!ie&&(ge===j||ge.endsWith(ce)))?V:null}:G=function(ge,ne){return typeof ge=="string"&&(ge===Q||!ie&&ge===j)?V:null},G.allPaths=[(q?"*/":"./")+j],G}function R(j){try{const V=new RegExp(`^${m(j)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?j:null}}catch{return r}}function O(j,V,q){return!j||typeof V!="string"?!1:N(j)(V,void 0,q)}e.match=O;function N(j,V={}){if(!j)return w;if(typeof j=="string"||p(j)){const q=s(j,V);if(q===r)return w;const ie=function(Q,ue){return!!q(Q,ue)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return z(j,V)}e.parse=N;function p(j){const V=j;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=p;function U(j){return j.allBasenames||[]}e.getBasenameTerms=U;function B(j){return j.allPaths||[]}e.getPathTerms=B;function z(j,V){const q=H(Object.getOwnPropertyNames(j).map(G=>re(G,j[G],V)).filter(G=>G!==r)),ie=q.length;if(!ie)return r;if(!q.some(G=>!!G.requiresSiblings)){if(ie===1)return q[0];const G=function(he,Se){let Re;for(let ve=0,Te=q.length;ve<Te;ve++){const Ae=q[ve](he,Se);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Re||(Re=[]),Re.push(Ae))}return Re?(async()=>{for(const ve of Re){const Te=await ve;if(typeof Te=="string")return Te}return null})():null},ge=q.find(he=>!!he.allBasenames);ge&&(G.allBasenames=ge.allBasenames);const ne=q.reduce((he,Se)=>Se.allPaths?he.concat(Se.allPaths):he,[]);return ne.length&&(G.allPaths=ne),G}const Q=function(G,ge,ne){let he,Se;for(let Re=0,ve=q.length;Re<ve;Re++){const Te=q[Re];Te.requiresSiblings&&ne&&(ge||(ge=(0,I.basename)(G)),he||(he=ge.substr(0,ge.length-(0,I.extname)(G).length)));const Ae=Te(G,ge,he,ne);if(typeof Ae=="string")return Ae;(0,i.isThenable)(Ae)&&(Se||(Se=[]),Se.push(Ae))}return Se?(async()=>{for(const Re of Se){const ve=await Re;if(typeof ve=="string")return ve}return null})():null},ue=q.find(G=>!!G.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ce=q.reduce((G,ge)=>ge.allPaths?G.concat(ge.allPaths):G,[]);return ce.length&&(Q.allPaths=ce),Q}function re(j,V,q){if(V===!1)return r;const ie=s(j,q);if(ie===r)return r;if(typeof V=="boolean")return ie;if(V){const Q=V.when;if(typeof Q=="string"){const ue=(ce,G,ge,ne)=>{if(!ne||!ie(ce,G))return null;const he=Q.replace("$(basename)",ge),Se=ne(he);return(0,i.isThenable)(Se)?Se.then(Re=>Re?j:null):Se?j:null};return ue.requiresSiblings=!0,ue}}return ie}function H(j,V){const q=j.filter(G=>!!G.basenames);if(q.length<2)return j;const ie=q.reduce((G,ge)=>{const ne=ge.basenames;return ne?G.concat(ne):G},[]);let Q;if(V){Q=[];for(let G=0,ge=ie.length;G<ge;G++)Q.push(V)}else Q=q.reduce((G,ge)=>{const ne=ge.patterns;return ne?G.concat(ne):G},[]);const ue=function(G,ge){if(typeof G!="string")return null;if(!ge){let he;for(he=G.length;he>0;he--){const Se=G.charCodeAt(he-1);if(Se===47||Se===92)break}ge=G.substr(he)}const ne=ie.indexOf(ge);return ne!==-1?Q[ne]:null};ue.basenames=ie,ue.patterns=Q,ue.allBasenames=ie;const ce=j.filter(G=>!G.basenames);return ce.push(ue),ce}function M(j,V){return(0,d.equals)(j,V,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}e.patternsEquals=M}),define(Ie[101],ke([1,0,11,147,22,8,2]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(v="",g=!1){if(this.value=v,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(v,g=0){return this.value+=y(this.supportThemeIcons?(0,i.escapeIcons)(v):v).replace(/([ \t]+)/g,(E,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,g){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(v,g,E){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(v),")"),E&&(this.value+=` "${this._escape(this._escape(E,'"'),")")}"`),this.value+=")",this}_escape(v,g){const E=new RegExp((0,P.escapeRegExpCharacters)(g),"g");return v.replace(E,(h,l)=>v.charAt(l-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=b;function A(m){return L(m)?!m.value:Array.isArray(m)?m.every(A):!0}e.isEmptyMarkdownString=A;function L(m){return m instanceof b?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(m,v){return m===v?!0:!m||!v?!1:m.value===v.value&&m.isTrusted===v.isTrusted&&m.supportThemeIcons===v.supportThemeIcons&&m.supportHtml===v.supportHtml&&(m.baseUri===v.baseUri||!!m.baseUri&&!!v.baseUri&&(0,C.isEqual)(I.URI.from(m.baseUri),I.URI.from(v.baseUri)))}e.markdownStringEqual=k;function y(m){return m.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function T(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function _(m){const v=[],g=m.split("|").map(h=>h.trim());m=g[0];const E=g[1];if(E){const h=/height=(\d+)/.exec(E),l=/width=(\d+)/.exec(E),f=h?h[1]:"",o=l?l[1]:"",w=isFinite(parseInt(o)),r=isFinite(parseInt(f));w&&v.push(`width="${o}"`),r&&v.push(`height="${f}"`)}return{href:m,dimensions:v}}e.parseHrefAndDimensions=_}),define(Ie[102],ke([1,0,16,30,10,9,12,22,8,2]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(t,a){const{os:u,tildify:c,relative:S}=a;if(S){const N=k(t,S,u);if(typeof N=="string")return N}let R=t.fsPath;if(u===1&&!I.isWindows?R=R.replace(/\//g,"\\"):u!==1&&I.isWindows&&(R=R.replace(/\\/g,"/")),u!==1&&c?.userHome){let N=c.userHome.fsPath,p;t.scheme!==c.userHome.scheme&&t.path.startsWith(P.posix.sep)?p=c.userHome.with({path:t.path}).fsPath:p=t.fsPath,R=m(p,N,u)}return(u===1?P.win32:P.posix).normalize(T(R,u===1))}e.getPathLabel=L;function k(t,a,u){const c=u===1?P.win32:P.posix,S=u===3?D.extUri:D.extUriIgnorePathCase,R=a.getWorkspace(),O=(0,d.firstOrDefault)(R.folders);if(!O)return;t.scheme!==O.uri.scheme&&t.path.startsWith(P.posix.sep)&&(t=O.uri.with({path:t.path}));const N=a.getWorkspaceFolder(t);if(!N)return;let p;if(S.isEqual(N.uri,t)?p="":p=S.relativePath(N.uri,t)??"",p&&(p=c.normalize(p)),R.folders.length>1&&!a.noPrefix){const U=N.name?N.name:S.basenameOrAuthority(N.uri);p=p?`${U} \u2022 ${p}`:U}return p}function y(t){if(!t)return;typeof t=="string"&&(t=A.URI.file(t));const a=(0,D.basename)(t)||(t.scheme===C.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,i.isRootOrDriveLetter)(a)?T(a):a}e.getBaseLabel=y;function T(t,a=I.isWindows){return(0,i.hasDriveLetter)(t,a)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let _=Object.create(null);function m(t,a,u=I.OS){if(u===1||!t||!a)return t;let c=_.original===a?_.normalized:void 0;c||(c=a,I.isWindows&&(c=(0,i.toSlashes)(c)),c=`${(0,b.rtrim)(c,P.posix.sep)}${P.posix.sep}`,_={original:a,normalized:c});let S=t;return I.isWindows&&(S=(0,i.toSlashes)(S)),(u===3?S.startsWith(c):(0,b.startsWithIgnoreCase)(S,c))?`~/${S.substr(c.length)}`:t}e.tildify=m;function v(t,a){return t.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=v;const g="\u2026",E="\\\\",h="~";function l(t,a=P.sep){const u=new Array(t.length);let c=!1;for(let S=0;S<t.length;S++){let R=t[S];if(R===""){u[S]=`.${a}`;continue}if(!R){u[S]=R;continue}c=!0;let O="",N=R;N.indexOf(E)===0?(O=N.substr(0,N.indexOf(E)+E.length),N=N.substr(N.indexOf(E)+E.length)):N.indexOf(a)===0?(O=N.substr(0,N.indexOf(a)+a.length),N=N.substr(N.indexOf(a)+a.length)):N.indexOf(h)===0&&(O=N.substr(0,N.indexOf(h)+h.length),N=N.substr(N.indexOf(h)+h.length));const p=N.split(a);for(let U=1;c&&U<=p.length;U++)for(let B=p.length-U;c&&B>=0;B--){c=!1;let z=p.slice(B,B+U).join(a);for(let re=0;!c&&re<t.length;re++)if(re!==S&&t[re]&&t[re].indexOf(z)>-1){const H=B+U===p.length,M=B>0&&t[re].indexOf(a)>-1?a+z:z,j=t[re].endsWith(M);c=!H||j}if(!c){let re="";(p[0].endsWith(":")||O!=="")&&(B===1&&(B=0,U++,z=p[0]+a+z),B>0&&(re=p[0]+a),re=O+re),B>0&&(re=re+g+a),re=re+z,B+U<p.length&&(re=re+a+g),u[S]=re}}c&&(u[S]=R)}return u}e.shorten=l;var f;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(t,a=Object.create(null)){const u=[];let c=!1,S="";for(const R of t)if(R==="$"||c&&R==="{")S&&u.push({value:S,type:f.TEXT}),S="",c=!0;else if(R==="}"&&c){const O=a[S];if(typeof O=="string")O.length&&u.push({value:O,type:f.VARIABLE});else if(O){const N=u[u.length-1];(!N||N.type!==f.SEPARATOR)&&u.push({value:O.label,type:f.SEPARATOR})}S="",c=!1}else S+=R;return S&&!c&&u.push({value:S,type:f.TEXT}),u.filter((R,O)=>{if(R.type===f.SEPARATOR){const N=u[O-1],p=u[O+1];return[N,p].every(U=>U&&(U.type===f.VARIABLE||U.type===f.TEXT)&&U.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function w(t,a){return I.isMacintosh||a?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function r(t,a){return I.isMacintosh||a?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function s(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(t){const a=t.indexOf("/")!==-1?P.posix:P.win32,u=a.basename(t),c=a.dirname(t);return u.length?{name:u,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(Ie[103],ke([1,0,2]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const y=this._uriTransformer.transformIncoming(k);return y===k?k:i(d.URI.from(y))}transformOutgoing(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:i(d.URI.from(y))}transformOutgoingURI(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:d.URI.from(y)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function P(L,k,y){if(!L||y>200)return null;if(typeof L=="object"){if(L instanceof d.URI)return k.transformOutgoing(L);for(let T in L)if(Object.hasOwnProperty.call(L,T)){const _=P(L[T],k,y+1);_!==null&&(L[T]=_)}}return null}function I(L,k){const y=P(L,k,0);return y===null?L:y}e.transformOutgoingURIs=I;function D(L,k,y,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return y?d.URI.revive(k.transformIncoming(L)):k.transformIncoming(L);for(let _ in L)if(Object.hasOwnProperty.call(L,_)){const m=D(L[_],k,y,T+1);m!==null&&(L[_]=m)}}return null}function b(L,k){const y=D(L,k,!1,0);return y===null?L:y}e.transformIncomingURIs=b;function A(L,k){const y=D(L,k,!0,0);return y===null?L:y}e.transformAndReviveIncomingURIs=A}),define(Ie[35],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(C){return d.test(C)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(D){for(let b=0;b<D.length;b++)D[b]=Math.floor(Math.random()*256);return D};const P=new Uint8Array(16),I=[];for(let D=0;D<256;D++)I.push(D.toString(16).padStart(2,"0"));return function(){C(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let b=0,A="";return A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A+="-",A+=I[P[b++]],A+=I[P[b++]],A+="-",A+=I[P[b++]],A+=I[P[b++]],A+="-",A+=I[P[b++]],A+=I[P[b++]],A+="-",A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A+=I[P[b++]],A}}()}),define(Ie[148],ke([1,0,104]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(P="utf8"){this.stringDecoder=new d.StringDecoder(P),this.remaining=null}write(P){const I=[],D=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(D.length<1)return I;let b=0,A,L=b;for(;L<D.length;)if(A=D.charCodeAt(L),A===13||A===10){if(I.push(D.substring(b,L)),L++,L<D.length){const k=A;A=D.charCodeAt(L),(k===13&&A===10||k===10&&A===13)&&L++}b=L}else L++;return this.remaining=b<D.length?D.substr(b):null,I}end(){return this.remaining}}e.LineDecoder=i}),define(Ie[29],ke([1,0,61,62,294,17,30,81,9,12,22,2]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function T(B,z=y.UNLINK){if((0,I.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return z===y.UNLINK?m(B):_(B)}async function _(B){try{const z=(0,I.randomPath)((0,i.tmpdir)());try{await d.promises.rename(B,z)}catch{return m(B)}m(z).catch(re=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function m(B){return(0,C.promisify)(d.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function v(B){if((0,I.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function g(B,z){return l(await(z?E(B):(0,C.promisify)(d.readdir)(B)))}async function E(B){try{return await(0,C.promisify)(d.readdir)(B,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const z=[],re=await g(B);for(const H of re){let M=!1,j=!1,V=!1;try{const q=await e.Promises.lstat((0,b.join)(B,H));M=q.isFile(),j=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}z.push({name:H,isFile:()=>M,isDirectory:()=>j,isSymbolicLink:()=>V})}return z}function h(B){return l(d.readdirSync(B))}e.readdirSync=h;function l(B){return B.map(z=>typeof z=="string"?A.isMacintosh?(0,D.normalizeNFC)(z):z:(z.name=A.isMacintosh?(0,D.normalizeNFC)(z.name):z.name,z))}async function f(B){const z=await g(B),re=[];for(const H of z)await w.existsDirectory((0,b.join)(B,H))&&re.push(H);return re}function o(B,z=1e3){return new Promise(re=>{let H=!1;const M=setInterval(()=>{H||(H=!0,d.access(B,j=>{H=!1,j&&(clearInterval(M),re(void 0))}))},z)})}e.whenDeleted=o;var w;(function(B){async function z(M){let j;try{if(j=await e.Promises.lstat(M),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(A.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw q}throw V}}B.stat=z;async function re(M){try{const{stat:j,symbolicLink:V}=await B.stat(M);return j.isFile()&&V?.dangling!==!0}catch{}return!1}B.existsFile=re;async function H(M){try{const{stat:j,symbolicLink:V}=await B.stat(M);return j.isDirectory()&&V?.dangling!==!0}catch{}return!1}B.existsDirectory=H})(w=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new P.ResourceQueue;function s(B,z,re){return r.queueFor(k.URI.file(B),L.extUriBiasedIgnorePathCase).queue(()=>{const H=u(re);return new Promise((M,j)=>t(B,z,H,V=>V?j(V):M()))})}let n=!0;function t(B,z,re,H){if(!n)return d.writeFile(B,z,{mode:re.mode,flag:re.flag},H);d.open(B,re.flag,re.mode,(M,j)=>{if(M)return H(M);d.writeFile(j,z,V=>{if(V)return d.close(j,()=>H(V));d.fdatasync(j,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),n=!1),d.close(j,ie=>H(ie))))})})}function a(B,z,re){const H=u(re);if(!n)return d.writeFileSync(B,z,{mode:H.mode,flag:H.flag});const M=d.openSync(B,H.flag,H.mode);try{d.writeFileSync(M,z);try{d.fdatasyncSync(M)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),n=!1}}finally{d.closeSync(M)}}e.writeFileSync=a;function u(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function c(B,z){if(B!==z)try{await e.Promises.rename(B,z)}catch(re){if(B.toLowerCase()!==z.toLowerCase()&&re.code==="EXDEV"||B.endsWith("."))await S(B,z,{preserveSymlinks:!1}),await T(B,y.MOVE);else throw re}}async function S(B,z,re){return O(B,z,{root:{source:B,target:z},options:re,handledSourcePaths:new Set})}const R=511;async function O(B,z,re){if(re.handledSourcePaths.has(B))return;re.handledSourcePaths.add(B);const{stat:H,symbolicLink:M}=await w.stat(B);if(M){if(re.options.preserveSymlinks)try{return await U(B,z,re)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(M.dangling)return}return H.isDirectory()?N(B,z,H.mode&R,re):p(B,z,H.mode&R)}async function N(B,z,re,H){await e.Promises.mkdir(z,{recursive:!0,mode:re});const M=await g(B);for(const j of M)await O((0,b.join)(B,j),(0,b.join)(z,j),H)}async function p(B,z,re){await e.Promises.copyFile(B,z),await e.Promises.chmod(z,re)}async function U(B,z,re){let H=await e.Promises.readlink(B);(0,I.isEqualOrParent)(H,re.root.source,!A.isLinux)&&(H=(0,b.join)(re.root.target,H.substr(re.root.source.length+1))),await e.Promises.symlink(H,z)}e.Promises=new class{get access(){return(0,C.promisify)(d.access)}get stat(){return(0,C.promisify)(d.stat)}get lstat(){return(0,C.promisify)(d.lstat)}get utimes(){return(0,C.promisify)(d.utimes)}get read(){return(B,z,re,H,M)=>new Promise((j,V)=>{d.read(B,z,re,H,M,(q,ie,Q)=>q?V(q):j({bytesRead:ie,buffer:Q}))})}get readFile(){return(0,C.promisify)(d.readFile)}get write(){return(B,z,re,H,M)=>new Promise((j,V)=>{d.write(B,z,re,H,M,(q,ie,Q)=>q?V(q):j({bytesWritten:ie,buffer:Q}))})}get appendFile(){return(0,C.promisify)(d.appendFile)}get fdatasync(){return(0,C.promisify)(d.fdatasync)}get truncate(){return(0,C.promisify)(d.truncate)}get rename(){return(0,C.promisify)(d.rename)}get copyFile(){return(0,C.promisify)(d.copyFile)}get open(){return(0,C.promisify)(d.open)}get close(){return(0,C.promisify)(d.close)}get symlink(){return(0,C.promisify)(d.symlink)}get readlink(){return(0,C.promisify)(d.readlink)}get chmod(){return(0,C.promisify)(d.chmod)}get mkdir(){return(0,C.promisify)(d.mkdir)}get unlink(){return(0,C.promisify)(d.unlink)}get rmdir(){return(0,C.promisify)(d.rmdir)}get realpath(){return(0,C.promisify)(d.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return f}get writeFile(){return s}get rm(){return T}get move(){return c}get copy(){return S}}}),define(Ie[105],ke([1,0,61,9,12,8,29]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(y){if(C.isLinux)return y;const T=(0,i.dirname)(y);if(y===T)return y;const _=((0,i.basename)(y)||y).toLowerCase();try{const v=(0,I.readdirSync)(T).filter(g=>g.toLowerCase()===_);if(v.length===1){const g=D(T);if(g)return(0,i.join)(g,v[0])}else if(v.length>1){const g=v.indexOf(_);if(g>=0){const E=D(T);if(E)return(0,i.join)(E,v[g])}}}catch{}return null}e.realcaseSync=D;async function b(y){if(C.isLinux)return y;const T=(0,i.dirname)(y);if(y===T)return y;const _=((0,i.basename)(y)||y).toLowerCase();try{const v=(await I.Promises.readdir(T)).filter(g=>g.toLowerCase()===_);if(v.length===1){const g=await b(T);if(g)return(0,i.join)(g,v[0])}else if(v.length>1){const g=v.indexOf(_);if(g>=0){const E=await b(T);if(E)return(0,i.join)(E,v[g])}}}catch{}return null}e.realcase=b;async function A(y){try{return await I.Promises.realpath(y)}catch{const _=k(y);return await I.Promises.access(_,d.constants.R_OK),_}}e.realpath=A;function L(y){try{return d.realpathSync(y)}catch{const _=k(y);return d.accessSync(_,d.constants.R_OK),_}}e.realpathSync=L;function k(y){return(0,P.rtrim)((0,i.normalize)(y),i.sep)}});var Ve=this&&this.__decorate||function(Y,e,d,i){var C=arguments.length,P=C<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,d):i,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Y,e,d,i);else for(var D=Y.length-1;D>=0;D--)(I=Y[D])&&(P=(C<3?I(P):C>3?I(e,d,P):I(e,d))||P);return C>3&&P&&Object.defineProperty(e,d,P),P};define(Ie[106],ke([1,0,16,17,23,21,57,11,3,6,60,8,14]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function _(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function v(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));class E{constructor(V){this.buffer=V,this.pos=0}read(V){const q=this.buffer.slice(this.pos,this.pos+V);return this.pos+=q.byteLength,q}}class h{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var l;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(l||(l={}));function f(j){const V=C.VSBuffer.alloc(4);return V.writeUInt32BE(j,0),V}function o(j){return j.read(4).readUInt32BE(0)}function w(j){const V=C.VSBuffer.alloc(1);return V.writeUInt8(j,0),V}const r={Undefined:w(l.Undefined),String:w(l.String),Buffer:w(l.Buffer),VSBuffer:w(l.VSBuffer),Array:w(l.Array),Object:w(l.Object)},s=typeof Buffer!="undefined";function n(j,V){if(typeof V=="undefined")j.write(r.Undefined);else if(typeof V=="string"){const q=C.VSBuffer.fromString(V);j.write(r.String),j.write(f(q.byteLength)),j.write(q)}else if(s&&Buffer.isBuffer(V)){const q=C.VSBuffer.wrap(V);j.write(r.Buffer),j.write(f(q.byteLength)),j.write(q)}else if(V instanceof C.VSBuffer)j.write(r.VSBuffer),j.write(f(V.byteLength)),j.write(V);else if(Array.isArray(V)){j.write(r.Array),j.write(f(V.length));for(const q of V)n(j,q)}else{const q=C.VSBuffer.fromString(JSON.stringify(V));j.write(r.Object),j.write(f(q.byteLength)),j.write(q)}}function t(j){switch(j.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return j.read(o(j)).toString();case l.Buffer:return j.read(o(j)).buffer;case l.VSBuffer:return j.read(o(j));case l.Array:{const q=o(j),ie=[];for(let Q=0;Q<q;Q++)ie.push(t(j));return ie}case l.Object:return JSON.parse(j.read(o(j)).toString())}}class a{constructor(V,q,ie=null,Q=1e3){this.protocol=V,this.ctx=q,this.logger=ie,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(V,q){this.channels.set(V,q),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const q=this.send([V.type]);this.logger?.logOutgoing(q,0,1,v(V.type));return}case 201:case 202:case 204:case 203:{const q=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(q,V.id,1,v(V.type),V.data);return}}}send(V,q=void 0){const ie=new h;return n(ie,V),n(ie,q),this.sendBuffer(ie.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const q=new E(V),ie=t(q),Q=t(q),ue=ie[0];switch(ue){case 100:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${_(ue)}: ${ie[2]}.${ie[3]}`,Q),this.onPromise({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 102:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${_(ue)}: ${ie[2]}.${ie[3]}`,Q),this.onEventListen({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 101:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${_(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]});case 103:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${_(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]})}}onPromise(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const ie=new P.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,V.name,V.arg,ie.token)}catch(G){Q=Promise.reject(G)}const ue=V.id;Q.then(G=>{this.sendResponse({id:ue,data:G,type:201}),this.activeRequests.delete(V.id)},G=>{G instanceof Error?this.sendResponse({id:ue,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:ue,data:G,type:203}),this.activeRequests.delete(V.id)});const ce=(0,A.toDisposable)(()=>ie.cancel());this.activeRequests.set(V.id,ce)}onEventListen(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const ie=V.id,ue=q.listen(this.ctx,V.name,V.arg)(ce=>this.sendResponse({id:ie,data:ce,type:204}));this.activeRequests.set(V.id,ue)}disposeActiveRequest(V){const q=this.activeRequests.get(V.id);q&&(q.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let q=this.pendingRequests.get(V.channelName);q||(q=[],this.pendingRequests.set(V.channelName,q));const ie=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:V,timeoutTimer:ie})}flushPendingRequests(V){const q=this.pendingRequests.get(V);if(q){for(const ie of q)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,A.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class c{constructor(V,q=null){this.protocol=V,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=q}getChannel(V){const q=this;return{call(ie,Q,ue){return q.isDisposed?Promise.reject(D.canceled()):q.requestPromise(V,ie,Q,ue)},listen(ie,Q){return q.isDisposed?b.Event.None:q.requestEvent(V,ie,Q)}}}requestPromise(V,q,ie,Q=P.CancellationToken.None){const ue=this.lastRequestId++,G={id:ue,type:100,channelName:V,name:q,arg:ie};if(Q.isCancellationRequested)return Promise.reject(D.canceled());let ge;return new Promise((he,Se)=>{if(Q.isCancellationRequested)return Se(D.canceled());const Re=()=>{const le=pe=>{switch(pe.type){case 201:this.handlers.delete(ue),he(pe.data);break;case 202:{this.handlers.delete(ue);const ee=new Error(pe.data.message);ee.stack=pe.data.stack,ee.name=pe.data.name,Se(ee);break}case 203:this.handlers.delete(ue),Se(pe.data);break}};this.handlers.set(ue,le),this.sendRequest(G)};let ve=null;this.state===g.Idle?Re():(ve=(0,i.createCancelablePromise)(le=>this.whenInitialized()),ve.then(()=>{ve=null,Re()}));const Te=()=>{ve?(ve.cancel(),ve=null):this.sendRequest({id:ue,type:101}),Se(D.canceled())},Ae=Q.onCancellationRequested(Te);ge=(0,A.combinedDisposable)((0,A.toDisposable)(Te),Ae),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(V,q,ie){const Q=this.lastRequestId++,ce={id:Q,type:102,channelName:V,name:q,arg:ie};let G=null;const ge=new b.Emitter({onFirstListenerAdd:()=>{G=(0,i.createCancelablePromise)(he=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(ge),this.sendRequest(ce)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(ge),this.sendRequest({id:Q,type:103}))}}),ne=he=>ge.fire(he.data);return this.handlers.set(Q,ne),ge.event}sendRequest(V){switch(V.type){case 100:case 102:{const q=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger&&this.logger.logOutgoing(q,V.id,0,`${_(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const q=this.send([V.type,V.id]);this.logger&&this.logger.logOutgoing(q,V.id,0,_(V.type));return}}}send(V,q=void 0){const ie=new h;return n(ie,V),n(ie,q),this.sendBuffer(ie.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const q=new E(V),ie=t(q),Q=t(q),ue=ie[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(V.byteLength,0,0,v(ue)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(V.byteLength,ie[1],0,v(ue),Q),this.onResponse({type:ie[0],id:ie[1],data:Q})}}onResponse(V){if(V.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(V.id);q&&q(V)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,A.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ve([I.memoize],c.prototype,"onDidInitializePromise",null),e.ChannelClient=c;class S{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:q,onDidClientDisconnect:ie})=>{b.Event.once(q.onMessage)(ue=>{const ce=new E(ue),G=t(ce),ge=new a(q,G),ne=new c(q);this.channels.forEach((Se,Re)=>ge.registerChannel(Re,Se));const he={channelServer:ge,channelClient:ne,ctx:G};this._connections.add(he),this._onDidAddConnection.fire(he),ie(()=>{ge.dispose(),ne.dispose(),this._connections.delete(he),this._onDidRemoveConnection.fire(he)})})})}get connections(){const V=[];return this._connections.forEach(q=>V.push(q)),V}getChannel(V,q){const ie=this;return{call(Q,ue,ce){let G;if((0,y.isFunction)(q)){let ne=(0,d.getRandomElement)(ie.connections.filter(q));G=ne?Promise.resolve(ne):b.Event.toPromise(b.Event.filter(ie.onDidAddConnection,q))}else G=q.routeCall(ie,Q,ue);const ge=G.then(ne=>ne.channelClient.getChannel(V));return O(ge).call(Q,ue,ce)},listen(Q,ue){if((0,y.isFunction)(q))return ie.getMulticastEvent(V,q,Q,ue);const ce=q.routeEvent(ie,Q,ue).then(G=>G.channelClient.getChannel(V));return O(ce).listen(Q,ue)}}}getMulticastEvent(V,q,ie,Q){const ue=this;let ce=new A.DisposableStore;const G=new b.Emitter({onFirstListenerAdd:()=>{ce=new A.DisposableStore;const ge=new b.EventMultiplexer,ne=new Map,he=Re=>{const Te=Re.channelClient.getChannel(V).listen(ie,Q),Ae=ge.add(Te);ne.set(Re,Ae)},Se=Re=>{const ve=ne.get(Re);!ve||(ve.dispose(),ne.delete(Re))};ue.connections.filter(q).forEach(he),b.Event.filter(ue.onDidAddConnection,q)(he,void 0,ce),ue.onDidRemoveConnection(Se,void 0,ce),ge.event(G.fire,G,ce),ce.add(ge)},onLastListenerRemove:()=>{ce.dispose()}});return G.event}registerChannel(V,q){this.channels.set(V,q),this._connections.forEach(ie=>{ie.channelServer.registerChannel(V,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class R{constructor(V,q,ie=null){const Q=new h;n(Q,q),V.send(Q.buffer),this.channelClient=new c(V,ie),this.channelServer=new a(V,q,ie)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,q){this.channelServer.registerChannel(V,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(j){return{call(V,q,ie){return j.then(Q=>Q.call(V,q,ie))},listen(V,q){const ie=new b.Relay;return j.then(Q=>ie.input=Q.listen(V,q)),ie.event}}}e.getDelayedChannel=O;function N(j){let V=!1;return{call(q,ie,Q){return V?j.call(q,ie,Q):(0,i.timeout)(0).then(()=>V=!0).then(()=>j.call(q,ie,Q))},listen(q,ie){if(V)return j.listen(q,ie);const Q=new b.Relay;return(0,i.timeout)(0).then(()=>V=!0).then(()=>Q.input=j.listen(q,ie)),Q.event}}}e.getNextTickChannel=N;class p{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const q of V.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await b.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=p;var U;(function(j){function V(ue,ce){const G=ue,ge=ce&&ce.disableMarshalling,ne=new Map;for(const he in G)ie(he)&&ne.set(he,b.Event.buffer(G[he],!0));return new class{listen(he,Se,Re){const ve=ne.get(Se);if(ve)return ve;if(Q(Se)){const Te=G[Se];if(typeof Te=="function")return Te.call(G,Re)}throw new Error(`Event not found: ${Se}`)}call(he,Se,Re){const ve=G[Se];if(typeof ve=="function"){if(!ge&&Array.isArray(Re))for(let Te=0;Te<Re.length;Te++)Re[Te]=(0,L.revive)(Re[Te]);return ve.apply(G,Re)}throw new Error(`Method not found: ${Se}`)}}}j.fromService=V;function q(ue,ce){const G=ce&&ce.disableMarshalling;return new Proxy({},{get(ge,ne){if(typeof ne=="string")return ce?.properties?.has(ne)?ce.properties.get(ne):Q(ne)?function(he){return ue.listen(ne,he)}:ie(ne)?ue.listen(ne):async function(...he){let Se;ce&&!(0,y.isUndefinedOrNull)(ce.context)?Se=[ce.context,...he]:Se=he;const Re=await ue.call(ne,Se);return G?Re:(0,L.revive)(Re)};throw new Error(`Property not found: ${String(ne)}`)}})}j.toService=q;function ie(ue){return ue[0]==="o"&&ue[1]==="n"&&k.isUpperAsciiLetter(ue.charCodeAt(2))}function Q(ue){return/^onDynamic/.test(ue)&&k.isUpperAsciiLetter(ue.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let V=j.toString();if(V!=="[object Object]")return V}return j}function re(j){return Array.isArray(j)?j.map(z):z(j)}function H(j,V,q,ie,Q,ue,ce){ce=re(ce);const G=B[Q],ge=G[ie%G.length];let ne=[`%c[${j}]%c[${String(V).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(ue)?(ne=ne.concat(ce),ne.push(")")):ne.push(ce),console.log.apply(console,ne)}e.logWithColors=H;class M{constructor(V,q){this._outgoingPrefix=V,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,q,ie,Q,ue){this._totalOutgoing+=V,H(this._outgoingPrefix,this._totalOutgoing,V,q,ie,Q,ue)}logIncoming(V,q,ie,Q,ue){this._totalIncoming+=V,H(this._incomingPrefix,this._totalIncoming,V,q,ie,Q,ue)}}e.IPCLogger=M}),define(Ie[107],ke([1,0,23,3,6,106]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const n=new WeakMap;let t=0;function a(c,S){if(!n.has(c)){const R=String(++t);n.set(c,R)}return n.get(c)}function u(c,S,R,O){if(!s.enableDiagnostics)return;const N=a(c,S);if(O instanceof d.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const p=d.VSBuffer.alloc(O.byteLength);p.set(O),s.records.push({timestamp:Date.now(),id:N,label:S,type:R,buff:p})}else s.records.push({timestamp:Date.now(),id:N,label:S,type:R,data:O})}s.traceSocketEvent=u})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function L(){return A||(A=d.VSBuffer.alloc(0)),A}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,t){if(n===0)return L();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const S=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=n),S}if(this._chunks[0].byteLength>n){const S=this._chunks[0].slice(0,n);return t&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),S}let a=d.VSBuffer.alloc(n),u=0,c=0;for(;n>0;){const S=this._chunks[c];if(S.byteLength>n){const R=S.slice(0,n);a.set(R,u),u+=n,t&&(this._chunks[c]=S.slice(n),this._totalLength-=n),n-=n}else a.set(S,u),u+=S.byteLength,t?(this._chunks.shift(),this._totalLength-=S.byteLength):c++,n-=S.byteLength}return a}}e.ChunkStream=k;var y;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(y||(y={}));function T(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var _;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(_=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(n,t,a,u){this.type=n,this.id=t,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.Disposable{constructor(n){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,c=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new m(a,u,c,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=d.VSBuffer.alloc(13);t.writeUInt8(n.type,0),t.writeUInt32BE(n.id,1),t.writeUInt32BE(n.ack,5),t.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(t,n.data)}_bufferAdd(n,t){const a=this._totalLength===0;return this._data.push(n,t),this._totalLength+=n.byteLength+t.byteLength,a}_bufferTake(){const n=d.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,t){this._bufferAdd(n,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class E extends C.Disposable{constructor(n){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new m(1,0,0,n))}}e.Protocol=E;class h extends P.IPCClient{constructor(n,t,a=null){super(n,t,a);this.protocol=n}static fromSocket(n,t){return new h(new E(n),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=h;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],t=0,a=this._first;for(;a;)n[t++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const t=new f(n);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class w{constructor(){this.lastRuns=[];const n=Date.now();for(let t=0;t<w._HISTORY_LENGTH;t++)this.lastRuns[t]=n-1e3*t;setInterval(()=>{for(let t=w._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return w._INSTANCE||(w._INSTANCE=new w),w._INSTANCE}load(){const n=Date.now(),t=(1+w._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<w._HISTORY_LENGTH;u++)n-this.lastRuns[u]<=t&&a++;return 1-a/w._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}w._HISTORY_LENGTH=10,w._INSTANCE=null;class r{constructor(n,t=null,a=w.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new m(5,0,0,L());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new m(7,0,0,L());this._socketWriter.write(n)}sendResume(){const n=new m(8,0,0,L());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,t){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new m(3,0,this._incomingAckId,L());this._socketWriter.write(n);const t=this._outgoingUnackMsg.toArray();for(let a=0,u=t.length;a<u;a++)this._socketWriter.write(t[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new m(6,0,0,L())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let a=0,u=t.length;a<u;a++)this._socketWriter.write(t[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,t,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const t=new m(2,0,0,n);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),t=Date.now()-n.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const c=Math.max(2e4-t,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},c)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new m(3,0,this._incomingAckId,L());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(Ie[108],ke([1,0,98]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(D){const b=(0,d.toUint8)(D);this._defaultValue=b,this._asciiMap=i._createAsciiMap(b),this._map=new Map}static _createAsciiMap(D){const b=new Uint8Array(256);for(let A=0;A<256;A++)b[A]=D;return b}set(D,b){const A=(0,d.toUint8)(b);D>=0&&D<256?this._asciiMap[D]=A:this._map.set(D,A)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=i;var C;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(C||(C={}));class P{constructor(){this._actual=new i(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=P}),define(Ie[49],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(C,P){this.lineNumber=C,this.column=P}with(C=this.lineNumber,P=this.column){return C===this.lineNumber&&P===this.column?this:new d(C,P)}delta(C=0,P=0){return this.with(this.lineNumber+C,this.column+P)}equals(C){return d.equals(this,C)}static equals(C,P){return!C&&!P?!0:!!C&&!!P&&C.lineNumber===P.lineNumber&&C.column===P.column}isBefore(C){return d.isBefore(this,C)}static isBefore(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<P.column}isBeforeOrEqual(C){return d.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<=P.column}static compare(C,P){const I=C.lineNumber|0,D=P.lineNumber|0;if(I===D){const b=C.column|0,A=P.column|0;return b-A}return I-D}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new d(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=d}),define(Ie[36],ke([1,0,49]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(P,I,D,b){P>D||P===D&&I>b?(this.startLineNumber=D,this.startColumn=b,this.endLineNumber=P,this.endColumn=I):(this.startLineNumber=P,this.startColumn=I,this.endLineNumber=D,this.endColumn=b)}isEmpty(){return i.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return i.containsPosition(this,P)}static containsPosition(P,I){return!(I.lineNumber<P.startLineNumber||I.lineNumber>P.endLineNumber||I.lineNumber===P.startLineNumber&&I.column<P.startColumn||I.lineNumber===P.endLineNumber&&I.column>P.endColumn)}static strictContainsPosition(P,I){return!(I.lineNumber<P.startLineNumber||I.lineNumber>P.endLineNumber||I.lineNumber===P.startLineNumber&&I.column<=P.startColumn||I.lineNumber===P.endLineNumber&&I.column>=P.endColumn)}containsRange(P){return i.containsRange(this,P)}static containsRange(P,I){return!(I.startLineNumber<P.startLineNumber||I.endLineNumber<P.startLineNumber||I.startLineNumber>P.endLineNumber||I.endLineNumber>P.endLineNumber||I.startLineNumber===P.startLineNumber&&I.startColumn<P.startColumn||I.endLineNumber===P.endLineNumber&&I.endColumn>P.endColumn)}strictContainsRange(P){return i.strictContainsRange(this,P)}static strictContainsRange(P,I){return!(I.startLineNumber<P.startLineNumber||I.endLineNumber<P.startLineNumber||I.startLineNumber>P.endLineNumber||I.endLineNumber>P.endLineNumber||I.startLineNumber===P.startLineNumber&&I.startColumn<=P.startColumn||I.endLineNumber===P.endLineNumber&&I.endColumn>=P.endColumn)}plusRange(P){return i.plusRange(this,P)}static plusRange(P,I){let D,b,A,L;return I.startLineNumber<P.startLineNumber?(D=I.startLineNumber,b=I.startColumn):I.startLineNumber===P.startLineNumber?(D=I.startLineNumber,b=Math.min(I.startColumn,P.startColumn)):(D=P.startLineNumber,b=P.startColumn),I.endLineNumber>P.endLineNumber?(A=I.endLineNumber,L=I.endColumn):I.endLineNumber===P.endLineNumber?(A=I.endLineNumber,L=Math.max(I.endColumn,P.endColumn)):(A=P.endLineNumber,L=P.endColumn),new i(D,b,A,L)}intersectRanges(P){return i.intersectRanges(this,P)}static intersectRanges(P,I){let D=P.startLineNumber,b=P.startColumn,A=P.endLineNumber,L=P.endColumn,k=I.startLineNumber,y=I.startColumn,T=I.endLineNumber,_=I.endColumn;return D<k?(D=k,b=y):D===k&&(b=Math.max(b,y)),A>T?(A=T,L=_):A===T&&(L=Math.min(L,_)),D>A||D===A&&b>L?null:new i(D,b,A,L)}equalsRange(P){return i.equalsRange(this,P)}static equalsRange(P,I){return!!P&&!!I&&P.startLineNumber===I.startLineNumber&&P.startColumn===I.startColumn&&P.endLineNumber===I.endLineNumber&&P.endColumn===I.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(P){return new d.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(P){return new d.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,I){return new i(this.startLineNumber,this.startColumn,P,I)}setStartPosition(P,I){return new i(P,I,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(P){return new i(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,I=P){return new i(P.lineNumber,P.column,I.lineNumber,I.column)}static lift(P){return P?new i(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,I){return!(P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<I.startColumn||I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<P.startColumn)}static areIntersecting(P,I){return!(P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<=I.startColumn||I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,I){if(P&&I){const A=P.startLineNumber|0,L=I.startLineNumber|0;if(A===L){const k=P.startColumn|0,y=I.startColumn|0;if(k===y){const T=P.endLineNumber|0,_=I.endLineNumber|0;if(T===_){const m=P.endColumn|0,v=I.endColumn|0;return m-v}return T-_}return k-y}return A-L}return(P?1:0)-(I?1:0)}static compareRangesUsingEnds(P,I){return P.endLineNumber===I.endLineNumber?P.endColumn===I.endColumn?P.startLineNumber===I.startLineNumber?P.startColumn-I.startColumn:P.startLineNumber-I.startLineNumber:P.endColumn-I.endColumn:P.endLineNumber-I.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=i}),define(Ie[149],ke([1,0,49,36]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class P extends i.Range{constructor(D,b,A,L){super(D,b,A,L);this.selectionStartLineNumber=D,this.selectionStartColumn=b,this.positionLineNumber=A,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return P.selectionsEqual(this,D)}static selectionsEqual(D,b){return D.selectionStartLineNumber===b.selectionStartLineNumber&&D.selectionStartColumn===b.selectionStartColumn&&D.positionLineNumber===b.positionLineNumber&&D.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,b){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,D,b):new P(D,b,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,b){return this.getDirection()===0?new P(D,b,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,D,b)}static fromPositions(D,b=D){return new P(D.lineNumber,D.column,b.lineNumber,b.column)}static fromRange(D,b){return b===0?new P(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new P(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new P(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,b){if(D&&!b||!D&&b)return!1;if(!D&&!b)return!0;if(D.length!==b.length)return!1;for(let A=0,L=D.length;A<L;A++)if(!this.selectionsEqual(D[A],b[A]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,b,A,L,k){return k===0?new P(D,b,A,L):new P(A,L,D,b)}}e.Selection=P}),define(Ie[150],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[151],ke([1,0,108]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends d.CharacterClassifier{constructor(D){super(0);for(let b=0,A=D.length;b<A;b++)this.set(D.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function P(I){const D={};return b=>(D.hasOwnProperty(b)||(D[b]=I(b)),D[b])}e.getMapForWordSeparators=P(I=>new C(I))}),define(Ie[109],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(D=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)D.indexOf(A)>=0||(b+="\\"+A);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=d();function i(D){let b=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)b=D;else{let A="g";D.ignoreCase&&(A+="i"),D.multiline&&(A+="m"),D.unicode&&(A+="u"),b=new RegExp(D.source,A)}return b.lastIndex=0,b}e.ensureValidWordDefinition=i;const C={maxLen:1e3,windowSize:15,timeBudget:150};function P(D,b,A,L,k=C){if(A.length>k.maxLen){let v=D-k.maxLen/2;return v<0?v=0:L+=v,A=A.substring(v,D+k.maxLen/2),P(D,b,A,L,k)}const y=Date.now(),T=D-1-L;let _=-1,m=null;for(let v=1;!(Date.now()-y>=k.timeBudget);v++){const g=T-k.windowSize*v;b.lastIndex=Math.max(0,g);const E=I(b,A,T,_);if(!E&&m||(m=E,g<=0))break;_=g}if(m){const v={word:m[0],startColumn:L+1+m.index,endColumn:L+1+m.index+m[0].length};return b.lastIndex=0,v}return null}e.getWordAtText=P;function I(D,b,A,L){let k;for(;k=D.exec(b);){const y=k.index||0;if(y<=A&&D.lastIndex>=A)return k;if(L>0&&y>L)return null}return null}}),define(Ie[152],ke([1,0,34,9]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(P,I,D,b,A,L){if(Array.isArray(P)){let k=0;for(const y of P){const T=C(y,I,D,b,A,L);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return b?P==="*"?5:P===D?10:0:0;if(P){const{language:k,pattern:y,scheme:T,hasAccessToAllModels:_,notebookType:m}=P;if(!b&&!_)return 0;m&&A&&(I=A);let v=0;if(T)if(T===I.scheme)v=10;else if(T==="*")v=5;else return 0;if(k)if(k===D)v=10;else if(k==="*")v=Math.max(v,5);else return 0;if(m)if(m===L)v=10;else if(m==="*"&&L!==void 0)v=Math.max(v,5);else return 0;if(y){let g;if(typeof y=="string"?g=y:g={...y,base:(0,i.normalize)(y.base)},g===I.fsPath||(0,d.match)(g,I.fsPath))v=10;else return 0}return v}else return 0}}e.score=C}),define(Ie[153],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class i{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let b=0,A=D.notIn.length;b<A;b++)switch(D.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,b){if(D.getTokenCount()===0)return!0;const A=D.findTokenIndexAtOffset(b-2),L=D.getStandardTokenType(A);return this.isOK(L)}_findNeutralCharacterInRange(D,b){for(let A=D;A<=b;A++){const L=String.fromCharCode(A);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class C{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of D)P(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),P(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),P(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),P(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&P(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=C;function P(I,D,b){I.has(D)?I.get(D).push(b):I.set(D,[b])}}),define(Ie[154],ke([1,0,108]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class C{constructor(_,m,v){const g=new Uint8Array(_*m);for(let E=0,h=_*m;E<h;E++)g[E]=v;this._data=g,this.rows=_,this.cols=m}get(_,m){return this._data[_*this.cols+m]}set(_,m,v){this._data[_*this.cols+m]=v}}e.Uint8Matrix=C;class P{constructor(_){let m=0,v=0;for(let E=0,h=_.length;E<h;E++){const[l,f,o]=_[E];f>m&&(m=f),l>v&&(v=l),o>v&&(v=o)}m++,v++;const g=new C(v,m,0);for(let E=0,h=_.length;E<h;E++){const[l,f,o]=_[E];g.set(l,f,o)}this._states=g,this._maxCharCode=m}nextState(_,m){return m<0||m>=this._maxCharCode?0:this._states.get(_,m)}}e.StateMachine=P;let I=null;function D(){return I===null&&(I=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var b;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let A=null;function L(){if(A===null){A=new d.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<T.length;m++)A.set(T.charCodeAt(m),1);const _=".,;";for(let m=0;m<_.length;m++)A.set(_.charCodeAt(m),2)}return A}class k{static _createLink(_,m,v,g,E){let h=E-1;do{const l=m.charCodeAt(h);if(_.get(l)!==2)break;h--}while(h>g);if(g>0){const l=m.charCodeAt(g-1),f=m.charCodeAt(h);(l===40&&f===41||l===91&&f===93||l===123&&f===125)&&h--}return{range:{startLineNumber:v,startColumn:g+1,endLineNumber:v,endColumn:h+2},url:m.substring(g,h+1)}}static computeLinks(_,m=D()){const v=L(),g=[];for(let E=1,h=_.getLineCount();E<=h;E++){const l=_.getLineContent(E),f=l.length;let o=0,w=0,r=0,s=1,n=!1,t=!1,a=!1,u=!1;for(;o<f;){let c=!1;const S=l.charCodeAt(o);if(s===13){let R;switch(S){case 40:n=!0,R=0;break;case 41:R=n?0:1;break;case 91:a=!0,t=!0,R=0;break;case 93:a=!1,R=t?0:1;break;case 123:u=!0,R=0;break;case 125:R=u?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=a?0:1;break;default:R=v.get(S)}R===1&&(g.push(k._createLink(v,l,E,w,o)),c=!0)}else if(s===12){let R;S===91?(t=!0,R=0):R=v.get(S),R===1?c=!0:s=13}else s=m.nextState(s,S),s===0&&(c=!0);c&&(s=1,n=!1,t=!1,u=!1,w=o+1,r=S),o++}s===13&&g.push(k._createLink(v,l,E,w,f))}return g}}e.LinkComputer=k;function y(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=y}),define(Ie[110],ke([1,0,26]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var b;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(b=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class L{constructor(h,l){this._findMatchBrand=void 0,this.range=h,this.matches=l}}e.FindMatch=L;var k;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None",E[E.LeftOfInjectedText=3]="LeftOfInjectedText",E[E.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class _{constructor(h,l,f,o,w,r){this.identifier=h,this.range=l,this.text=f,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=w,this._isTracked=r}}e.ValidAnnotatedEditOperation=_;class m{constructor(h,l,f){this.regex=h,this.wordSeparators=l,this.simpleSearch=f}}e.SearchData=m;class v{constructor(h,l,f){this.reverseEdits=h,this.changes=l,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=v;function g(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(Ie[155],ke([1,0,16,98]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class C{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,A){b=(0,i.toUint32)(b);const L=this.values,k=this.prefixSum,y=A.length;return y===0?!1:(this.values=new Uint32Array(L.length+y),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b),b+y),this.values.set(A,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(b,A){return b=(0,i.toUint32)(b),A=(0,i.toUint32)(A),this.values[b]===A?!1:(this.values[b]=A,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,A){b=(0,i.toUint32)(b),A=(0,i.toUint32)(A);const L=this.values,k=this.prefixSum;if(b>=L.length)return!1;const y=L.length-b;return A>=y&&(A=y),A===0?!1:(this.values=new Uint32Array(L.length-A),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b+A),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,i.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),b>=this.values.length&&(b=this.values.length-1);for(let L=A;L<=b;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let A=0,L=this.values.length-1,k=0,y=0,T=0;for(;A<=L;)if(k=A+(L-A)/2|0,y=this.prefixSum[k],T=y-this.values[k],b<T)L=k-1;else if(b>=y)A=k+1;else break;return new I(k,b-T)}}e.PrefixSumComputer=C;class P{constructor(b){this._values=b,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(b){return this._ensureValid(),b===0?0:this._prefixSum[b-1]}getIndexOf(b){this._ensureValid();const A=this._indexBySum[b],L=A>0?this._prefixSum[A-1]:0;return new I(A,b-L)}removeValues(b,A){this._values.splice(b,A),this._invalidate(b)}insertValues(b,A){this._values=(0,d.arrayInsert)(this._values,b,A),this._invalidate(b)}_invalidate(b){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,b-1)}_ensureValid(){if(!this._isValid){for(let b=this._validEndIndex+1,A=this._values.length;b<A;b++){const L=this._values[b],k=b>0?this._prefixSum[b-1]:0;this._prefixSum[b]=k+L;for(let y=0;y<L;y++)this._indexBySum[k+y]=b}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(b,A){this._values[b]!==A&&(this._values[b]=A,this._invalidate(b))}}e.ConstantTimePrefixSumComputer=P;class I{constructor(b,A){this.index=b,this.remainder=A,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=A}}e.PrefixSumIndexOfResult=I}),define(Ie[156],ke([1,0,8,49,155]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(D,b,A,L){this._uri=D,this._lines=b,this._eol=A,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const b=D.changes;for(const A of b)this._acceptDeleteRange(A.range),this._acceptInsertText(new i.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,b=this._lines.length,A=new Uint32Array(b);for(let L=0;L<b;L++)A[L]=this._lines[L].length+D;this._lineStarts=new C.PrefixSumComputer(A)}}_setLineText(D,b){this._lines[D]=b,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,b){if(b.length===0)return;const A=(0,d.splitLines)(b);if(A.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+A[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}A[A.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+A[0]);const L=new Uint32Array(A.length-1);for(let k=1;k<A.length;k++)this._lines.splice(D.lineNumber+k-1,0,A[k]),L[k-1]=A[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=P}),define(Ie[157],ke([1,0,8,151,49,36,110]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class b{constructor(E,h,l,f){this.searchString=E,this.isRegex=h,this.matchCase=l,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=A(this.searchString):E=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!h)return null;let l=!this.isRegex&&!E;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new I.SearchData(h,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=b;function A(g){if(!g||g.length===0)return!1;for(let E=0,h=g.length;E<h;E++)if(g.charCodeAt(E)===92){if(E++,E>=h)break;const f=g.charCodeAt(E);if(f===110||f===114||f===87)return!0}return!1}e.isMultilineRegexSource=A;function L(g,E,h){if(!h)return new I.FindMatch(g,null);const l=[];for(let f=0,o=E.length;f<o;f++)l[f]=E[f];return new I.FindMatch(g,l)}e.createFindMatch=L;class k{constructor(E){const h=[];let l=0;for(let f=0,o=E.length;f<o;f++)E.charCodeAt(f)===10&&(h[l++]=f);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(E){const h=this._lineFeedsOffsets;let l=0,f=h.length-1;if(f===-1||E<=h[0])return 0;for(;l<f;){const o=l+((f-l)/2>>0);h[o]>=E?f=o-1:h[o+1]>=E?(l=o,f=o):l=o+1}return l+1}}class y{static findMatches(E,h,l,f,o){const w=h.parseSearchRequest();return w?w.regex.multiline?this._doFindMatchesMultiline(E,l,new v(w.wordSeparators,w.regex),f,o):this._doFindMatchesLineByLine(E,l,w,f,o):[]}static _getMultilineMatchRange(E,h,l,f,o,w){let r,s=0;f?(s=f.findLineFeedCountBeforeOffset(o),r=h+o+s):r=h+o;let n;if(f){const c=f.findLineFeedCountBeforeOffset(o+w.length)-s;n=r+w.length+c}else n=r+w.length;const t=E.getPositionAt(r),a=E.getPositionAt(n);return new P.Range(t.lineNumber,t.column,a.lineNumber,a.column)}static _doFindMatchesMultiline(E,h,l,f,o){const w=E.getOffsetAt(h.getStartPosition()),r=E.getValueInRange(h,1),s=E.getEOL()===`\r
`?new k(r):null,n=[];let t=0,a;for(l.reset(0);a=l.next(r);)if(n[t++]=L(this._getMultilineMatchRange(E,w,r,s,a.index,a[0]),a,f),t>=o)return n;return n}static _doFindMatchesLineByLine(E,h,l,f,o){const w=[];let r=0;if(h.startLineNumber===h.endLineNumber){const n=E.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(l,n,h.startLineNumber,h.startColumn-1,r,w,f,o),w}const s=E.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(l,s,h.startLineNumber,h.startColumn-1,r,w,f,o);for(let n=h.startLineNumber+1;n<h.endLineNumber&&r<o;n++)r=this._findMatchesInLine(l,E.getLineContent(n),n,0,r,w,f,o);if(r<o){const n=E.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(l,n,h.endLineNumber,0,r,w,f,o)}return w}static _findMatchesInLine(E,h,l,f,o,w,r,s){const n=E.wordSeparators;if(!r&&E.simpleSearch){const u=E.simpleSearch,c=u.length,S=h.length;let R=-c;for(;(R=h.indexOf(u,R+c))!==-1;)if((!n||m(n,h,S,R,c))&&(w[o++]=new I.FindMatch(new P.Range(l,R+1+f,l,R+1+c+f),null),o>=s))return o;return o}const t=new v(E.wordSeparators,E.regex);let a;t.reset(0);do if(a=t.next(h),a&&(w[o++]=L(new P.Range(l,a.index+1+f,l,a.index+1+a[0].length+f),a,r),o>=s))return o;while(a);return o}static findNextMatch(E,h,l,f){const o=h.parseSearchRequest();if(!o)return null;const w=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(E,l,w,f):this._doFindNextMatchLineByLine(E,l,w,f)}static _doFindNextMatchMultiline(E,h,l,f){const o=new C.Position(h.lineNumber,1),w=E.getOffsetAt(o),r=E.getLineCount(),s=E.getValueInRange(new P.Range(o.lineNumber,o.column,r,E.getLineMaxColumn(r)),1),n=E.getEOL()===`\r
`?new k(s):null;l.reset(h.column-1);let t=l.next(s);return t?L(this._getMultilineMatchRange(E,w,s,n,t.index,t[0]),t,f):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(E,new C.Position(1,1),l,f):null}static _doFindNextMatchLineByLine(E,h,l,f){const o=E.getLineCount(),w=h.lineNumber,r=E.getLineContent(w),s=this._findFirstMatchInLine(l,r,w,h.column,f);if(s)return s;for(let n=1;n<=o;n++){const t=(w+n-1)%o,a=E.getLineContent(t+1),u=this._findFirstMatchInLine(l,a,t+1,1,f);if(u)return u}return null}static _findFirstMatchInLine(E,h,l,f,o){E.reset(f-1);const w=E.next(h);return w?L(new P.Range(l,w.index+1,l,w.index+1+w[0].length),w,o):null}static findPreviousMatch(E,h,l,f){const o=h.parseSearchRequest();if(!o)return null;const w=new v(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(E,l,w,f):this._doFindPreviousMatchLineByLine(E,l,w,f)}static _doFindPreviousMatchMultiline(E,h,l,f){const o=this._doFindMatchesMultiline(E,new P.Range(1,1,h.lineNumber,h.column),l,f,10*D);if(o.length>0)return o[o.length-1];const w=E.getLineCount();return h.lineNumber!==w||h.column!==E.getLineMaxColumn(w)?this._doFindPreviousMatchMultiline(E,new C.Position(w,E.getLineMaxColumn(w)),l,f):null}static _doFindPreviousMatchLineByLine(E,h,l,f){const o=E.getLineCount(),w=h.lineNumber,r=E.getLineContent(w).substring(0,h.column-1),s=this._findLastMatchInLine(l,r,w,f);if(s)return s;for(let n=1;n<=o;n++){const t=(o+w-n-1)%o,a=E.getLineContent(t+1),u=this._findLastMatchInLine(l,a,t+1,f);if(u)return u}return null}static _findLastMatchInLine(E,h,l,f){let o=null,w;for(E.reset(0);w=E.next(h);)o=L(new P.Range(l,w.index+1,l,w.index+1+w[0].length),w,f);return o}}e.TextModelSearch=y;function T(g,E,h,l,f){if(l===0)return!0;const o=E.charCodeAt(l-1);if(g.get(o)!==0||o===13||o===10)return!0;if(f>0){const w=E.charCodeAt(l);if(g.get(w)!==0)return!0}return!1}function _(g,E,h,l,f){if(l+f===h)return!0;const o=E.charCodeAt(l+f);if(g.get(o)!==0||o===13||o===10)return!0;if(f>0){const w=E.charCodeAt(l+f-1);if(g.get(w)!==0)return!0}return!1}function m(g,E,h,l,f){return T(g,E,h,l,f)&&_(g,E,h,l,f)}e.isValidMatch=m;class v{constructor(E,h){this._wordSeparators=E,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(E){this._searchRegex.lastIndex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(E){const h=E.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(l=this._searchRegex.exec(E),!l))return null;const f=l.index,o=l[0].length;if(f===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){d.getNextCodePoint(E,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=f,this._prevMatchLength=o,!this._wordSeparators||m(this._wordSeparators,E,h,f,o))return l}while(l);return null}}e.Searcher=v}),define(Ie[111],ke([1,0,23,12]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function P(k){for(let y=0,T=k.length;y<T;y+=4){const _=k[y+0],m=k[y+1],v=k[y+2],g=k[y+3];k[y+0]=g,k[y+1]=v,k[y+2]=m,k[y+3]=_}}function I(k){const y=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return i.isLittleEndian()||P(y),d.VSBuffer.wrap(y)}function D(k){const y=k.buffer;if(i.isLittleEndian()||P(y),y.byteOffset%4==0)return new Uint32Array(y.buffer,y.byteOffset,y.length/4);{const T=new Uint8Array(y.byteLength);return T.set(y),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function b(k){const y=new Uint32Array(A(k));let T=0;if(y[T++]=k.id,k.type==="full")y[T++]=1,y[T++]=k.data.length,y.set(k.data,T),T+=k.data.length;else{y[T++]=2,y[T++]=k.deltas.length;for(const _ of k.deltas)y[T++]=_.start,y[T++]=_.deleteCount,_.data?(y[T++]=_.data.length,y.set(_.data,T),T+=_.data.length):y[T++]=0}return I(y)}e.encodeSemanticTokensDto=b;function A(k){let y=0;if(y+=1+1,k.type==="full")y+=1+k.data.length;else{y+=1,y+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(y+=T.data.length)}return y}function L(k){const y=D(k);let T=0;const _=y[T++];if(y[T++]===1){const E=y[T++],h=y.subarray(T,T+E);return T+=E,{id:_,type:"full",data:h}}const v=y[T++],g=[];for(let E=0;E<v;E++){const h=y[T++],l=y[T++],f=y[T++];let o;f>0&&(o=y.subarray(T,T+f),T+=f),g[E]={start:h,deleteCount:l,data:o}}return{id:_,type:"delta",deltas:g}}e.decodeSemanticTokensDto=L}),define(Ie[158],ke([1,0,3,6]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,b){return this._map.set(D,b),this.fire([D]),(0,i.toDisposable)(()=>{this._map.get(D)===b&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,b){this._factories.get(D)?.dispose();const A=new P(this,D,b);return this._factories.set(D,A),(0,i.toDisposable)(()=>{const L=this._factories.get(D);!L||L!==A||(this._factories.delete(D),L.dispose())})}async getOrCreate(D){const b=this.get(D);if(b)return b;const A=this._factories.get(D);return!A||A.isResolved?null:(await A.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const A=this._factories.get(D);return!!(!A||A.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=C;class P extends i.Disposable{constructor(D,b,A){super();this._registry=D,this._languageId=b,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(Ie[63],ke([1,0,2,36,158,77]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var D;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var b;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(b=e.ColorId||(e.ColorId={}));var A;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var L;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L=e.MetadataConsts||(e.MetadataConsts={}));class k{static getLanguageId(U){return(U&255)>>>0}static getTokenType(U){return(U&768)>>>8}static containsBalancedBrackets(U){return(U&1024)!=0}static getFontStyle(U){return(U&30720)>>>11}static getForeground(U){return(U&16744448)>>>15}static getBackground(U){return(U&4278190080)>>>24}static getClassNameFromMetadata(U){const B=this.getForeground(U);let z="mtk"+B;const re=this.getFontStyle(U);return re&1&&(z+=" mtki"),re&2&&(z+=" mtkb"),re&4&&(z+=" mtku"),re&8&&(z+=" mtks"),z}static getInlineStyleFromMetadata(U,B){const z=this.getForeground(U),re=this.getFontStyle(U);let H=`color: ${B[z]};`;re&1&&(H+="font-style: italic;"),re&2&&(H+="font-weight: bold;");let M="";return re&4&&(M+=" underline"),re&8&&(M+=" line-through"),M&&(H+=`text-decoration:${M};`),H}static getPresentationFromMetadata(U){const B=this.getForeground(U),z=this.getFontStyle(U);return{foreground:B,italic:Boolean(z&1),bold:Boolean(z&2),underline:Boolean(z&4),strikethrough:Boolean(z&8)}}}e.TokenMetadata=k;class y{constructor(U,B,z){this._tokenBrand=void 0,this.offset=U,this.type=B,this.language=z}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class T{constructor(U,B){this._tokenizationResultBrand=void 0,this.tokens=U,this.endState=B}}e.TokenizationResult=T;class _{constructor(U,B){this._encodedTokenizationResultBrand=void 0,this.tokens=U,this.endState=B}}e.EncodedTokenizationResult=_;var m;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(p){const U=new Map;U.set(0,P.Codicon.symbolMethod),U.set(1,P.Codicon.symbolFunction),U.set(2,P.Codicon.symbolConstructor),U.set(3,P.Codicon.symbolField),U.set(4,P.Codicon.symbolVariable),U.set(5,P.Codicon.symbolClass),U.set(6,P.Codicon.symbolStruct),U.set(7,P.Codicon.symbolInterface),U.set(8,P.Codicon.symbolModule),U.set(9,P.Codicon.symbolProperty),U.set(10,P.Codicon.symbolEvent),U.set(11,P.Codicon.symbolOperator),U.set(12,P.Codicon.symbolUnit),U.set(13,P.Codicon.symbolValue),U.set(15,P.Codicon.symbolEnum),U.set(14,P.Codicon.symbolConstant),U.set(15,P.Codicon.symbolEnum),U.set(16,P.Codicon.symbolEnumMember),U.set(17,P.Codicon.symbolKeyword),U.set(27,P.Codicon.symbolSnippet),U.set(18,P.Codicon.symbolText),U.set(19,P.Codicon.symbolColor),U.set(20,P.Codicon.symbolFile),U.set(21,P.Codicon.symbolReference),U.set(22,P.Codicon.symbolCustomColor),U.set(23,P.Codicon.symbolFolder),U.set(24,P.Codicon.symbolTypeParameter),U.set(25,P.Codicon.account),U.set(26,P.Codicon.issues);function B(H){let M=U.get(H);return M||(console.info("No codicon found for CompletionItemKind "+H),M=P.Codicon.symbolProperty),M}p.toIcon=B;const z=new Map;z.set("method",0),z.set("function",1),z.set("constructor",2),z.set("field",3),z.set("variable",4),z.set("class",5),z.set("struct",6),z.set("interface",7),z.set("module",8),z.set("property",9),z.set("event",10),z.set("operator",11),z.set("unit",12),z.set("value",13),z.set("constant",14),z.set("enum",15),z.set("enum-member",16),z.set("enumMember",16),z.set("keyword",17),z.set("snippet",27),z.set("text",18),z.set("color",19),z.set("file",20),z.set("reference",21),z.set("customcolor",22),z.set("folder",23),z.set("type-parameter",24),z.set("typeParameter",24),z.set("account",25),z.set("issue",26);function re(H,M){let j=z.get(H);return typeof j=="undefined"&&!M&&(j=9),j}p.fromString=re})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(p){p[p.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var l;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(l=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var w;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(w=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function r(p){return p&&d.URI.isUri(p.uri)&&i.Range.isIRange(p.range)&&(i.Range.isIRange(p.originSelectionRange)||i.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=r;var s;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var n;(function(p){p[p.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(p){const U=new Map;U.set(0,P.Codicon.symbolFile),U.set(1,P.Codicon.symbolModule),U.set(2,P.Codicon.symbolNamespace),U.set(3,P.Codicon.symbolPackage),U.set(4,P.Codicon.symbolClass),U.set(5,P.Codicon.symbolMethod),U.set(6,P.Codicon.symbolProperty),U.set(7,P.Codicon.symbolField),U.set(8,P.Codicon.symbolConstructor),U.set(9,P.Codicon.symbolEnum),U.set(10,P.Codicon.symbolInterface),U.set(11,P.Codicon.symbolFunction),U.set(12,P.Codicon.symbolVariable),U.set(13,P.Codicon.symbolConstant),U.set(14,P.Codicon.symbolString),U.set(15,P.Codicon.symbolNumber),U.set(16,P.Codicon.symbolBoolean),U.set(17,P.Codicon.symbolArray),U.set(18,P.Codicon.symbolObject),U.set(19,P.Codicon.symbolKey),U.set(20,P.Codicon.symbolNull),U.set(21,P.Codicon.symbolEnumMember),U.set(22,P.Codicon.symbolStruct),U.set(23,P.Codicon.symbolEvent),U.set(24,P.Codicon.symbolOperator),U.set(25,P.Codicon.symbolTypeParameter);function B(z){let re=U.get(z);return re||(console.info("No codicon found for SymbolKind "+z),re=P.Codicon.symbolProperty),re}p.toIcon=B})(t=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(U){this.value=U}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var u;(function(p){function U(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}p.is=U})(u=e.Command||(e.Command={}));var c;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var S;(function(p){p[p.Unresolved=0]="Unresolved",p[p.Resolved=1]="Resolved"})(S=e.CommentThreadState||(e.CommentThreadState={}));var R;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(R=e.CommentMode||(e.CommentMode={}));var O;(function(p){p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(O=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new C.TokenizationRegistry;var N;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(N=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[159],ke([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(Ie[160],ke([1,0,159]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,C=i*60,P=C*24,I=P*7,D=P*30,b=P*365;function A(k,y,T){typeof k!="number"&&(k=k.getTime());const _=Math.round((new Date().getTime()-k)/1e3);if(_<-30)return(0,d.localize)(0,null,A(new Date().getTime()+_*1e3,!1));if(_<30)return(0,d.localize)(1,null);let m;return _<i?(m=_,y?m===1?T?(0,d.localize)(2,null,m):(0,d.localize)(3,null,m):T?(0,d.localize)(4,null,m):(0,d.localize)(5,null,m):m===1?T?(0,d.localize)(6,null,m):(0,d.localize)(7,null,m):T?(0,d.localize)(8,null,m):(0,d.localize)(9,null,m)):_<C?(m=Math.floor(_/i),y?m===1?T?(0,d.localize)(10,null,m):(0,d.localize)(11,null,m):T?(0,d.localize)(12,null,m):(0,d.localize)(13,null,m):m===1?T?(0,d.localize)(14,null,m):(0,d.localize)(15,null,m):T?(0,d.localize)(16,null,m):(0,d.localize)(17,null,m)):_<P?(m=Math.floor(_/C),y?m===1?T?(0,d.localize)(18,null,m):(0,d.localize)(19,null,m):T?(0,d.localize)(20,null,m):(0,d.localize)(21,null,m):m===1?T?(0,d.localize)(22,null,m):(0,d.localize)(23,null,m):T?(0,d.localize)(24,null,m):(0,d.localize)(25,null,m)):_<I?(m=Math.floor(_/P),y?m===1?(0,d.localize)(26,null,m):(0,d.localize)(27,null,m):m===1?(0,d.localize)(28,null,m):(0,d.localize)(29,null,m)):_<D?(m=Math.floor(_/I),y?m===1?T?(0,d.localize)(30,null,m):(0,d.localize)(31,null,m):T?(0,d.localize)(32,null,m):(0,d.localize)(33,null,m):m===1?T?(0,d.localize)(34,null,m):(0,d.localize)(35,null,m):T?(0,d.localize)(36,null,m):(0,d.localize)(37,null,m)):_<b?(m=Math.floor(_/D),y?m===1?T?(0,d.localize)(38,null,m):(0,d.localize)(39,null,m):T?(0,d.localize)(40,null,m):(0,d.localize)(41,null,m):m===1?T?(0,d.localize)(42,null,m):(0,d.localize)(43,null,m):T?(0,d.localize)(44,null,m):(0,d.localize)(45,null,m)):(m=Math.floor(_/b),y?m===1?T?(0,d.localize)(46,null,m):(0,d.localize)(47,null,m):T?(0,d.localize)(48,null,m):(0,d.localize)(49,null,m):m===1?T?(0,d.localize)(50,null,m):(0,d.localize)(51,null,m):T?(0,d.localize)(52,null,m):(0,d.localize)(53,null,m))}e.fromNow=A;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ie[161],ke([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(Ie[50],ke([1,0,16,14,161]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,y){return y&&(k.stack||k.stacktrace)?C.localize(0,null,D(k),I(k.stack)||I(k.stacktrace)):D(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function D(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function b(k=null,y=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const T=d.coalesce(k),_=b(T[0],y);return T.length>1?C.localize(4,null,_,T.length):_}if(i.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,y);if(T.exception)return P(T.exception,y)}return k.stack?P(k,y):k.message?k.message:C.localize(5,null)}e.toErrorMessage=b;function A(k){const y=k;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=A;function L(k,y){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=y,T}e.createErrorWithActions=L}),define(Ie[162],ke([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(Ie[112],ke([1,0,41,30,10,26,9,12,40,95,14,148,29,162]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function _(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(f,o){if(D.isWindows)try{const w={stdio:["pipe","pipe","ignore"]};o&&(w.cwd=o);const r=d.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],w);return new Promise(s=>{r.once("error",n=>{s({success:!1,error:n})}),r.once("exit",(n,t)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(w){return Promise.resolve({success:!1,error:w,code:w.status?_(w.status):1})}else if(D.isLinux||D.isMacintosh)try{const w=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{d.execFile(w,[f.pid.toString()],{encoding:"utf8",shell:!0},(s,n,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(w){return Promise.resolve({success:!1,error:w})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function v(f=b.env){return f.comspec||"cmd.exe"}e.getWindowsShell=v;class g{constructor(o,w,r,s){if(w!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=w,this.shell=r,this.options=s;else{const n=o;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(b.env).forEach(t=>{n[t]=b.env[t]}),Object.keys(this.options.env).forEach(t=>{n[t]=this.options.env[t]}),this.options.env=n}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const w=o.lastIndexOf(I.sep);return w!==-1&&(o=o.substring(w+1)),g.WellKnowCommands[o]?o:"other"}start(o){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(b.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(w=>{let r,s;const n=new Promise((t,a)=>{r=t,s=a});if(w){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=d.exec(t,this.options,(a,u,c)=>{this.childProcess=null;const S=a;S&&S.killed?s({killed:this.terminateRequested,stdout:u.toString(),stderr:c.toString()}):this.handleExec(r,o,a,u,c)})}else{let t=null;const a=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,o,s);const c={terminated:this.terminateRequested};L.isNumber(u)&&(c.cmdCode=u),r(c)};if(this.shell&&D.isWindows){const u=P.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let c=!1,S=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),c=O.quoted,this.args&&this.args.forEach(p=>{O=this.ensureQuotes(p),R.push(O.value),S=S&&O.quoted});const N=["/s","/c"];c?S?N.push('"'+R.join(" ")+'"'):R.length>1?N.push('"'+R[0]+'" '+R.slice(1).join(" ")):N.push('"'+R[0]+'"'):N.push(R.join(" ")),t=d.spawn(v(),N,u)}else this.cmd&&(t=d.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(L.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",u=>{this.childProcess=null,s({terminated:this.terminateRequested,error:u})}),t.pid&&(this.childProcess.on("close",a),this.handleSpawn(t,r,o,s,!0)))}return n})}handleClose(o,w,r,s){}ensureQuotes(o){return g.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,m(o,this.options.cwd).then(w=>(w.success&&(this.childProcess=null),w))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!D.isWindows)return o(!1);const w=d.spawn(v(),["/s","/c"]);w.on("error",r=>o(!0)),w.on("exit",r=>o(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class E extends g{constructor(o,w,r,s){super(o,w,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,w,r,s,n){[s,n].forEach((t,a)=>{const u=new k.LineDecoder;u.write(t).forEach(R=>{w({line:R,source:a===0?0:1})});const S=u.end();S&&w({line:S,source:a===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,w,r,s,n){const t=new k.LineDecoder,a=new k.LineDecoder;o.stdout.on("data",u=>{t.write(u).forEach(S=>r({line:S,source:0}))}),o.stderr.on("data",u=>{a.write(u).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=a}handleClose(o,w,r,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=E;function h(f){let o=[],w=!1;const r=function(s){if(w){o.push(s);return}(!f.send(s,t=>{if(t&&console.error(t),w=!1,o.length>0){const a=o.slice(0);o=[],a.forEach(u=>r(u))}})||D.isWindows)&&(w=!0)};return{send:r}}e.createQueuedSender=h;var l;(function(f){async function o(w,r,s){if(I.isAbsolute(w))return w;if(r===void 0&&(r=b.cwd()),I.dirname(w)!=="."||(s===void 0&&L.isString(b.env.PATH)&&(s=b.env.PATH.split(I.delimiter)),s===void 0||s.length===0))return I.join(r,w);async function t(a){if(await y.Promises.exists(a)){let u;try{u=await y.Promises.stat(a)}catch(c){c.message.startsWith("EACCES")&&(u=await y.Promises.lstat(a))}return u?!u.isDirectory():!1}return!1}for(let a of s){let u;if(I.isAbsolute(a)?u=I.join(a,w):u=I.join(r,a,w),await t(u))return u;let c=u+".com";if(await t(c)||(c=u+".exe",await t(c)))return c}return I.join(r,w)}f.findExecutable=o})(l=e.win32||(e.win32={}))}),define(Ie[163],ke([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(Ie[113],ke([1,0,163,12,109,16,26,150]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=A;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(se,_e,ae,ye){this.id=se,this.name=_e,this.defaultValue=ae,this.schema=ye}applyUpdate(se,_e){return T(se,_e)}compute(se,_e,ae){return ae}}class y{constructor(se,_e){this.newValue=se,this.didChange=_e}}e.ApplyUpdateResult=y;function T(J,se){if(typeof J!="object"||typeof se!="object"||!J||!se)return new y(se,J!==se);if(Array.isArray(J)||Array.isArray(se)){const ae=Array.isArray(J)&&Array.isArray(se)&&P.equals(J,se);return new y(se,ae)}let _e=!1;for(const ae in se)if(se.hasOwnProperty(ae)){const ye=T(J[ae],se[ae]);ye.didChange&&(J[ae]=ye.newValue,_e=!0)}return new y(J,_e)}class _{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,_e){return T(se,_e)}validate(se){return this.defaultValue}}class m{constructor(se,_e,ae,ye){this.id=se,this.name=_e,this.defaultValue=ae,this.schema=ye}applyUpdate(se,_e){return T(se,_e)}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,_e,ae){return ae}}function v(J,se){return typeof J=="undefined"?se:J==="false"?!1:Boolean(J)}e.boolean=v;class g extends m{constructor(se,_e,ae,ye=void 0){typeof ye!="undefined"&&(ye.type="boolean",ye.default=ae);super(se,_e,ae,ye)}validate(se){return v(se,this.defaultValue)}}function E(J,se,_e,ae){if(typeof J=="undefined")return se;let ye=parseInt(J,10);return isNaN(ye)?se:(ye=Math.max(_e,ye),ye=Math.min(ae,ye),ye|0)}e.clampedInt=E;class h extends m{constructor(se,_e,ae,ye,Ne,He=void 0){typeof He!="undefined"&&(He.type="integer",He.default=ae,He.minimum=ye,He.maximum=Ne);super(se,_e,ae,He);this.minimum=ye,this.maximum=Ne}static clampedInt(se,_e,ae,ye){return E(se,_e,ae,ye)}validate(se){return h.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class l extends m{constructor(se,_e,ae,ye,Ne){typeof Ne!="undefined"&&(Ne.type="number",Ne.default=ae);super(se,_e,ae,Ne);this.validationFn=ye}static clamp(se,_e,ae){return se<_e?_e:se>ae?ae:se}static float(se,_e){if(typeof se=="number")return se;if(typeof se=="undefined")return _e;const ae=parseFloat(se);return isNaN(ae)?_e:ae}validate(se){return this.validationFn(l.float(se,this.defaultValue))}}class f extends m{static string(se,_e){return typeof se!="string"?_e:se}constructor(se,_e,ae,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.default=ae);super(se,_e,ae,ye)}validate(se){return f.string(se,this.defaultValue)}}function o(J,se,_e){return typeof J!="string"||_e.indexOf(J)===-1?se:J}e.stringSet=o;class w extends m{constructor(se,_e,ae,ye,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=ye,Ne.default=ae);super(se,_e,ae,Ne);this._allowedValues=ye}validate(se){return o(se,this.defaultValue,this._allowedValues)}}class r extends k{constructor(se,_e,ae,ye,Ne,He,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Ne,qe.default=ye);super(se,_e,ae,qe);this._allowedValues=Ne,this._convert=He}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function s(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,_e,ae){return ae===0?se.accessibilitySupport:ae}}class t extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:d.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertSpace:v(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(J){switch(J){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function R(J){switch(J){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class O extends _{constructor(){super(128)}compute(se,_e,ae){const ye=["monaco-editor"];return _e.get(33)&&ye.push(_e.get(33)),se.extraEditorClassName&&ye.push(se.extraEditorClassName),_e.get(66)==="default"?ye.push("mouse-default"):_e.get(66)==="copy"&&ye.push("mouse-copy"),_e.get(100)&&ye.push("showUnused"),_e.get(126)&&ye.push("showDeprecated"),ye.join(" ")}}class N extends g{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(se,_e,ae){return ae&&se.emptySelectionClipboard}}class p extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:d.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:d.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{cursorMoveOnType:v(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":o(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":o(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(_e.loop,this.defaultValue.loop)}}}class U extends k{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?U.OFF:se==="true"?U.ON:se:Boolean(se)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class B extends _{constructor(){super(44)}compute(se,_e,ae){return se.fontInfo}}class z extends m{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(se){const _e=l.float(se,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(_e,6,100)}compute(se,_e,ae){return se.fontInfo.fontSize}}class re extends k{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.MINIMUM_VALUE,maximum:re.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(h.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,re.MINIMUM_VALUE,re.MAXIMUM_VALUE))}}re.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],re.MINIMUM_VALUE=1,re.MAXIMUM_VALUE=1e3;class H extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},ae=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),..._e},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),..._e},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:ae,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:ae,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:ae,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:ae,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:ae,description:d.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{multiple:o(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??o(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??o(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??o(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??o(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??o(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class M extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:d.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),delay:h.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:v(_e.sticky,this.defaultValue.sticky),above:v(_e.above,this.defaultValue.above)}}}var j;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class V extends _{constructor(){super(131)}compute(se,_e,ae){return V.computeLayout(_e,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const _e=se.height/se.lineHeight,ae=se.scrollBeyondLastLine?_e-1:0,ye=(se.viewLineCount+ae)/(se.pixelRatio*se.height),Ne=Math.floor(se.viewLineCount/ye);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:ae,desiredRatio:ye,minimapLineCount:Ne}}static _computeMinimapLayout(se,_e){const ae=se.outerWidth,ye=se.outerHeight,Ne=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const He=_e.stableMinimapLayoutInput,qe=He&&se.outerHeight===He.outerHeight&&se.lineHeight===He.lineHeight&&se.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&se.pixelRatio===He.pixelRatio&&se.scrollBeyondLastLine===He.scrollBeyondLastLine&&se.minimap.enabled===He.minimap.enabled&&se.minimap.side===He.minimap.side&&se.minimap.size===He.minimap.size&&se.minimap.showSlider===He.minimap.showSlider&&se.minimap.renderCharacters===He.minimap.renderCharacters&&se.minimap.maxColumn===He.minimap.maxColumn&&se.minimap.scale===He.minimap.scale&&se.verticalScrollbarWidth===He.verticalScrollbarWidth&&se.isViewportWrapping===He.isViewportWrapping,Ge=se.lineHeight,Ze=se.typicalHalfwidthCharacterWidth,Xe=se.scrollBeyondLastLine,rt=se.minimap.renderCharacters;let tt=Ne>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const pt=se.minimap.maxColumn,nt=se.minimap.size,ut=se.minimap.side,Pt=se.verticalScrollbarWidth,Nt=se.viewLineCount,yt=se.remainingWidth,ft=se.isViewportWrapping,Dt=rt?2:3;let At=Math.floor(Ne*ye);const Ft=At/Ne;let Ke=!1,zt=!1,Rt=Dt*tt,Mt=tt/Ne,Pe=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeyondLastLine:lt,desiredRatio:dt,minimapLineCount:vt}=V.computeContainedMinimapLineCount({viewLineCount:Nt,scrollBeyondLastLine:Xe,height:ye,lineHeight:Ge,pixelRatio:Ne});if(Nt/vt>1)Ke=!0,zt=!0,tt=1,Rt=1,Mt=tt/Ne;else{let mt=!1,wt=tt+1;if(nt==="fit"){const Lt=Math.ceil((Nt+lt)*Rt);ft&&qe&&yt<=_e.stableFitRemainingWidth?(mt=!0,wt=_e.stableFitMaxMinimapScale):mt=Lt>At}if(nt==="fill"||mt){Ke=!0;const Lt=tt;Rt=Math.min(Ge*Ne,Math.max(1,Math.floor(1/dt))),ft&&qe&&yt<=_e.stableFitRemainingWidth&&(wt=_e.stableFitMaxMinimapScale),tt=Math.min(wt,Math.max(1,Math.floor(Rt/Dt))),tt>Lt&&(Pe=Math.min(2,tt/Lt)),Mt=tt/Ne/Pe,At=Math.ceil(Math.max(Qe,Nt+lt)*Rt),ft?(_e.stableMinimapLayoutInput=se,_e.stableFitRemainingWidth=yt,_e.stableFitMaxMinimapScale=tt):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const Le=Math.floor(pt*Mt),we=Math.min(Le,Math.max(0,Math.floor((yt-Pt-2)*Mt/(Ze+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Z=Math.floor(Ne*we);const Me=Z/Ne;Z=Math.floor(Z*Pe);const xe=rt?1:2,st=ut==="left"?0:ae-we-Pt;return{renderMinimap:xe,minimapLeft:st,minimapWidth:we,minimapHeightIsEditorHeight:Ke,minimapIsSampling:zt,minimapScale:tt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Z,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ft}}static computeLayout(se,_e){const ae=_e.outerWidth|0,ye=_e.outerHeight|0,Ne=_e.lineHeight|0,He=_e.lineNumbersDigitCount|0,qe=_e.typicalHalfwidthCharacterWidth,Ge=_e.maxDigitWidth,Ze=_e.pixelRatio,Xe=_e.viewLineCount,rt=se.get(123),tt=rt==="inherit"?se.get(122):rt,pt=tt==="inherit"?se.get(118):tt,nt=se.get(121),ut=se.get(2),Pt=_e.isDominatedByLongLines,Nt=se.get(50),yt=se.get(60).renderType!==0,ft=se.get(61),Dt=se.get(94),At=se.get(65),Ft=se.get(92),Ke=Ft.verticalScrollbarSize,zt=Ft.verticalHasArrows,Rt=Ft.arrowSize,Mt=Ft.horizontalScrollbarSize,Pe=se.get(58),Le=se.get(37);let we;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const Qt=parseFloat(Pe.substr(0,Pe.length-2));we=h.clampedInt(Qt*qe,0,0,1e3)}else we=h.clampedInt(Pe,0,0,1e3);Le&&(we+=16);let Z=0;if(yt){const Qt=Math.max(He,ft);Z=Math.round(Qt*Ge)}let Me=0;Nt&&(Me=Ne);let xe=0,st=xe+Me,Qe=st+Z,lt=Qe+we;const dt=ae-Me-Z-we;let vt=!1,_t=!1,mt=-1;ut!==2&&(tt==="inherit"&&Pt?(vt=!0,_t=!0):pt==="on"||pt==="bounded"?_t=!0:pt==="wordWrapColumn"&&(mt=nt));const wt=V._computeMinimapLayout({outerWidth:ae,outerHeight:ye,lineHeight:Ne,typicalHalfwidthCharacterWidth:qe,pixelRatio:Ze,scrollBeyondLastLine:Dt,minimap:At,verticalScrollbarWidth:Ke,viewLineCount:Xe,remainingWidth:dt,isViewportWrapping:_t},_e.memory||new L);wt.renderMinimap!==0&&wt.minimapLeft===0&&(xe+=wt.minimapWidth,st+=wt.minimapWidth,Qe+=wt.minimapWidth,lt+=wt.minimapWidth);const Lt=dt-wt.minimapWidth,bt=Math.max(1,Math.floor((Lt-Ke-2)/qe)),Kt=zt?Rt:0;return _t&&(mt=Math.max(1,bt),pt==="bounded"&&(mt=Math.min(mt,nt))),{width:ae,height:ye,glyphMarginLeft:xe,glyphMarginWidth:Me,lineNumbersLeft:st,lineNumbersWidth:Z,decorationsLeft:Qe,decorationsWidth:we,contentLeft:lt,contentWidth:Lt,minimap:wt,viewportColumn:bt,isWordWrapMinified:vt,isViewportWrapping:_t,wrappingColumn:mt,verticalScrollbarWidth:Ke,horizontalScrollbarHeight:Mt,overviewRuler:{top:Kt,width:Ke,height:ye-2*Kt,right:0}}}}e.EditorLayoutInfoComputer=V;class q extends k{constructor(){const se={enabled:!0};super(57,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:d.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}class ie extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",displayStyle:"compact"};super(127,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:d.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(45,null),d.localize(46,null),d.localize(47,null),d.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:d.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:d.localize(50,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return typeof _e.enabled=="boolean"&&(_e.enabled=_e.enabled?"on":"off"),{enabled:o(_e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(_e.fontFamily,this.defaultValue.fontFamily),displayStyle:o(_e.displayStyle,this.defaultValue.displayStyle,["standard","compact"])}}}class Q extends l{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>l.clamp(se,0,150),{markdownDescription:d.localize(51,null)})}compute(se,_e,ae){return se.fontInfo.lineHeight}}class ue extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:d.localize(52,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(53,null),d.localize(54,null),d.localize(55,null)],default:se.size,description:d.localize(56,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:d.localize(57,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:d.localize(58,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(59,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:d.localize(60,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:d.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),size:o(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(_e.side,this.defaultValue.side,["right","left"]),showSlider:o(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(_e.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(_e.scale,1,1,3),maxColumn:h.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(J){return J==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(62,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(63,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{top:h.clampedInt(_e.top,0,0,1e3),bottom:h.clampedInt(_e.bottom,0,0,1e3)}}}class ge extends k{constructor(){const se={enabled:!0,cycle:!1};super(76,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:d.localize(64,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:d.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),cycle:v(_e.cycle,this.defaultValue.cycle)}}}class ne extends _{constructor(){super(129)}compute(se,_e,ae){return se.pixelRatio}}class he extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},_e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null)]}];super(79,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:_e,default:se.strings,description:d.localize(69,null)},comments:{anyOf:_e,default:se.comments,description:d.localize(70,null)},other:{anyOf:_e,default:se.other,description:d.localize(71,null)}},default:se,markdownDescription:d.localize(72,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Ze=se?"on":"off";return{comments:Ze,strings:Ze,other:Ze}}if(!se||typeof se!="object")return this.defaultValue;const{other:_e,comments:ae,strings:ye}=se,Ne=["on","inline","off"];let He,qe,Ge;return typeof _e=="boolean"?He=_e?"on":"off":He=o(_e,this.defaultValue.other,Ne),typeof ae=="boolean"?qe=ae?"on":"off":qe=o(ae,this.defaultValue.comments,Ne),typeof ye=="boolean"?Ge=ye?"on":"off":Ge=o(ye,this.defaultValue.strings,Ne),{other:He,comments:qe,strings:Ge}}}var Se;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"on",description:d.localize(77,null)})}validate(se){let _e=this.defaultValue.renderType,ae=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(_e=4,ae=se):se==="interval"?_e=3:se==="relative"?_e=2:se==="on"?_e=1:_e=0),{renderType:_e,renderFn:ae}}}function ve(J){const se=J.get(87);return se==="editable"?J.get(81):se!=="on"}e.filterValidationDecorations=ve;class Te extends k{constructor(){const se=[],_e={type:"number",description:d.localize(78,null)};super(91,"rulers",se,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:d.localize(79,null),format:"color-hex"}}}]},default:se,description:d.localize(80,null)})}validate(se){if(Array.isArray(se)){const _e=[];for(let ae of se)if(typeof ae=="number")_e.push({column:h.clampedInt(ae,0,0,1e4),color:null});else if(ae&&typeof ae=="object"){const ye=ae;_e.push({column:h.clampedInt(ye.column,0,0,1e4),color:ye.color})}return _e.sort((ae,ye)=>ae.column-ye.column),_e}return this.defaultValue}}function Ae(J,se){if(typeof J!="string")return se;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class le extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(81,null),d.localize(82,null),d.localize(83,null)],default:"auto",description:d.localize(84,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:"auto",description:d.localize(88,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:d.localize(89,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:d.localize(90,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:d.localize(91,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se,ae=h.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=h.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(_e.vertical,this.defaultValue.vertical),horizontal:Ae(_e.horizontal,this.defaultValue.horizontal),useShadows:v(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ae,horizontalSliderSize:h.clampedInt(_e.horizontalSliderSize,ae,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:h.clampedInt(_e.verticalSliderSize,ye,0,1e3),scrollByPage:v(_e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class pe extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:d.localize(92,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:d.localize(93,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:d.localize(94,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:d.localize(95,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:d.localize(96,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:d.localize(97,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:d.localize(98,null)}})}applyUpdate(se,_e){let ae=!1;_e.allowedCharacters&&(I.equals(se.allowedCharacters,_e.allowedCharacters)||(se={...se,allowedCharacters:_e.allowedCharacters},ae=!0)),_e.allowedLocales&&(I.equals(se.allowedLocales,_e.allowedLocales)||(se={...se,allowedLocales:_e.allowedLocales},ae=!0));const ye=super.applyUpdate(se,_e);return ae?new y(ye.newValue,!0):ye}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{nonBasicASCII:$(_e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(_e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(_e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$(_e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$(_e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,_e){if(typeof se!="object"||!se)return _e;const ae={};for(const[ye,Ne]of Object.entries(se))Ne===!0&&(ae[ye]=!0);return ae}}class ee extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:d.localize(99,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),mode:o(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class te extends k{constructor(){const se={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:d.localize(100,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:d.localize(101,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(_e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class F extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(102,null),d.localize(103,null),d.localize(104,null)],default:se.bracketPairs,description:d.localize(105,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(106,null),d.localize(107,null),d.localize(108,null)],default:se.bracketPairsHorizontal,description:d.localize(109,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:d.localize(110,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:d.localize(111,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(112,null),d.localize(113,null),d.localize(114,null)],default:se.highlightActiveIndentation,description:d.localize(115,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{bracketPairs:$(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:$(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $(J,se,_e){const ae=_e.indexOf(J);return ae===-1?se:_e[ae]}class K extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(116,null),d.localize(117,null)],default:se.insertMode,description:d.localize(118,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:d.localize(119,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:d.localize(120,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:d.localize(121,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:d.localize(122,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:d.localize(123,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:d.localize(124,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:d.localize(125,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:d.localize(126,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(127,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(128,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(140,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(141,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(142,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(143,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(144,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(145,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(146,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(147,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(148,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(149,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(150,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertMode:o(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(_e.showIcons,this.defaultValue.showIcons),showStatusBar:v(_e.showStatusBar,this.defaultValue.showStatusBar),preview:v(_e.preview,this.defaultValue.preview),previewMode:o(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(_e.showMethods,this.defaultValue.showMethods),showFunctions:v(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:v(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(_e.showDeprecated,this.defaultValue.showDeprecated),showFields:v(_e.showFields,this.defaultValue.showFields),showVariables:v(_e.showVariables,this.defaultValue.showVariables),showClasses:v(_e.showClasses,this.defaultValue.showClasses),showStructs:v(_e.showStructs,this.defaultValue.showStructs),showInterfaces:v(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:v(_e.showModules,this.defaultValue.showModules),showProperties:v(_e.showProperties,this.defaultValue.showProperties),showEvents:v(_e.showEvents,this.defaultValue.showEvents),showOperators:v(_e.showOperators,this.defaultValue.showOperators),showUnits:v(_e.showUnits,this.defaultValue.showUnits),showValues:v(_e.showValues,this.defaultValue.showValues),showConstants:v(_e.showConstants,this.defaultValue.showConstants),showEnums:v(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:v(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(_e.showKeywords,this.defaultValue.showKeywords),showWords:v(_e.showWords,this.defaultValue.showWords),showColors:v(_e.showColors,this.defaultValue.showColors),showFiles:v(_e.showFiles,this.defaultValue.showFiles),showReferences:v(_e.showReferences,this.defaultValue.showReferences),showFolders:v(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:v(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(_e.showSnippets,this.defaultValue.showSnippets),showUsers:v(_e.showUsers,this.defaultValue.showUsers),showIssues:v(_e.showIssues,this.defaultValue.showIssues)}}}class X extends k{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(158,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends _{constructor(){super(130)}compute(se,_e,ae){return _e.get(81)?!0:se.tabFocusMode}}var Ee;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function oe(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends _{constructor(){super(132)}compute(se,_e,ae){const ye=_e.get(131);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",We="Menlo, Monaco, 'Courier New', monospace",je="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?We:i.isLinux?je:Ce,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(J){return e.editorOptionsRegistry[J.id]=J,J}var Ye;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.foldingMaximumRegions=41]="foldingMaximumRegions",J[J.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=43]="fontFamily",J[J.fontInfo=44]="fontInfo",J[J.fontLigatures=45]="fontLigatures",J[J.fontSize=46]="fontSize",J[J.fontWeight=47]="fontWeight",J[J.formatOnPaste=48]="formatOnPaste",J[J.formatOnType=49]="formatOnType",J[J.glyphMargin=50]="glyphMargin",J[J.gotoLocation=51]="gotoLocation",J[J.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",J[J.hover=53]="hover",J[J.inDiffEditor=54]="inDiffEditor",J[J.inlineSuggest=55]="inlineSuggest",J[J.letterSpacing=56]="letterSpacing",J[J.lightbulb=57]="lightbulb",J[J.lineDecorationsWidth=58]="lineDecorationsWidth",J[J.lineHeight=59]="lineHeight",J[J.lineNumbers=60]="lineNumbers",J[J.lineNumbersMinChars=61]="lineNumbersMinChars",J[J.linkedEditing=62]="linkedEditing",J[J.links=63]="links",J[J.matchBrackets=64]="matchBrackets",J[J.minimap=65]="minimap",J[J.mouseStyle=66]="mouseStyle",J[J.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=68]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",J[J.multiCursorModifier=70]="multiCursorModifier",J[J.multiCursorPaste=71]="multiCursorPaste",J[J.occurrencesHighlight=72]="occurrencesHighlight",J[J.overviewRulerBorder=73]="overviewRulerBorder",J[J.overviewRulerLanes=74]="overviewRulerLanes",J[J.padding=75]="padding",J[J.parameterHints=76]="parameterHints",J[J.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",J[J.quickSuggestions=79]="quickSuggestions",J[J.quickSuggestionsDelay=80]="quickSuggestionsDelay",J[J.readOnly=81]="readOnly",J[J.renameOnType=82]="renameOnType",J[J.renderControlCharacters=83]="renderControlCharacters",J[J.renderFinalNewline=84]="renderFinalNewline",J[J.renderLineHighlight=85]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=87]="renderValidationDecorations",J[J.renderWhitespace=88]="renderWhitespace",J[J.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",J[J.roundedSelection=90]="roundedSelection",J[J.rulers=91]="rulers",J[J.scrollbar=92]="scrollbar",J[J.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=94]="scrollBeyondLastLine",J[J.scrollPredominantAxis=95]="scrollPredominantAxis",J[J.selectionClipboard=96]="selectionClipboard",J[J.selectionHighlight=97]="selectionHighlight",J[J.selectOnLineNumbers=98]="selectOnLineNumbers",J[J.showFoldingControls=99]="showFoldingControls",J[J.showUnused=100]="showUnused",J[J.snippetSuggestions=101]="snippetSuggestions",J[J.smartSelect=102]="smartSelect",J[J.smoothScrolling=103]="smoothScrolling",J[J.stickyTabStops=104]="stickyTabStops",J[J.stopRenderingLineAfter=105]="stopRenderingLineAfter",J[J.suggest=106]="suggest",J[J.suggestFontSize=107]="suggestFontSize",J[J.suggestLineHeight=108]="suggestLineHeight",J[J.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",J[J.suggestSelection=110]="suggestSelection",J[J.tabCompletion=111]="tabCompletion",J[J.tabIndex=112]="tabIndex",J[J.unicodeHighlighting=113]="unicodeHighlighting",J[J.unusualLineTerminators=114]="unusualLineTerminators",J[J.useShadowDOM=115]="useShadowDOM",J[J.useTabStops=116]="useTabStops",J[J.wordSeparators=117]="wordSeparators",J[J.wordWrap=118]="wordWrap",J[J.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=121]="wordWrapColumn",J[J.wordWrapOverride1=122]="wordWrapOverride1",J[J.wordWrapOverride2=123]="wordWrapOverride2",J[J.wrappingIndent=124]="wrappingIndent",J[J.wrappingStrategy=125]="wrappingStrategy",J[J.showDeprecated=126]="showDeprecated",J[J.inlayHints=127]="inlayHints",J[J.editorClassName=128]="editorClassName",J[J.pixelRatio=129]="pixelRatio",J[J.tabFocusMode=130]="tabFocusMode",J[J.layoutInfo=131]="layoutInfo",J[J.wrappingInfo=132]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(159,null)})),acceptSuggestionOnEnter:Fe(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(160,null),""],markdownDescription:d.localize(161,null)})),accessibilitySupport:Fe(new n),accessibilityPageSize:Fe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(162,null)})),ariaLabel:Fe(new f(4,"ariaLabel",d.localize(163,null))),autoClosingBrackets:Fe(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(164,null),d.localize(165,null),""],description:d.localize(166,null)})),autoClosingDelete:Fe(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(167,null),""],description:d.localize(168,null)})),autoClosingOvertype:Fe(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(169,null),""],description:d.localize(170,null)})),autoClosingQuotes:Fe(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(171,null),d.localize(172,null),""],description:d.localize(173,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[d.localize(174,null),d.localize(175,null),d.localize(176,null),d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),automaticLayout:Fe(new g(10,"automaticLayout",!1)),autoSurround:Fe(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(180,null),d.localize(181,null),d.localize(182,null),""],description:d.localize(183,null)})),bracketPairColorization:Fe(new te),bracketPairGuides:Fe(new F),stickyTabStops:Fe(new g(104,"stickyTabStops",!1,{description:d.localize(184,null)})),codeLens:Fe(new g(14,"codeLens",!0,{description:d.localize(185,null)})),codeLensFontFamily:Fe(new f(15,"codeLensFontFamily","",{description:d.localize(186,null)})),codeLensFontSize:Fe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(187,null)})),colorDecorators:Fe(new g(17,"colorDecorators",!0,{description:d.localize(188,null)})),columnSelection:Fe(new g(18,"columnSelection",!1,{description:d.localize(189,null)})),comments:Fe(new t),contextmenu:Fe(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new g(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(190,null)})),cursorBlinking:Fe(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:d.localize(191,null)})),cursorSmoothCaretAnimation:Fe(new g(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(192,null)})),cursorStyle:Fe(new r(24,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:d.localize(193,null)})),cursorSurroundingLines:Fe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(194,null)})),cursorSurroundingLinesStyle:Fe(new w(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(195,null),d.localize(196,null)],description:d.localize(197,null)})),cursorWidth:Fe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(198,null)})),disableLayerHinting:Fe(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new g(30,"domReadOnly",!1)),dragAndDrop:Fe(new g(31,"dragAndDrop",!0,{description:d.localize(199,null)})),emptySelectionClipboard:Fe(new N),extraEditorClassName:Fe(new f(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new l(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:d.localize(200,null)})),find:Fe(new p),fixedOverflowWidgets:Fe(new g(36,"fixedOverflowWidgets",!1)),folding:Fe(new g(37,"folding",!0,{description:d.localize(201,null)})),foldingStrategy:Fe(new w(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(202,null),d.localize(203,null)],description:d.localize(204,null)})),foldingHighlight:Fe(new g(39,"foldingHighlight",!0,{description:d.localize(205,null)})),foldingImportsByDefault:Fe(new g(40,"foldingImportsByDefault",!1,{description:d.localize(206,null)})),foldingMaximumRegions:Fe(new h(41,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(207,null)})),unfoldOnClickAfterEndOfLine:Fe(new g(42,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(208,null)})),fontFamily:Fe(new f(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(209,null)})),fontInfo:Fe(new B),fontLigatures2:Fe(new U),fontSize:Fe(new z),fontWeight:Fe(new re),formatOnPaste:Fe(new g(48,"formatOnPaste",!1,{description:d.localize(210,null)})),formatOnType:Fe(new g(49,"formatOnType",!1,{description:d.localize(211,null)})),glyphMargin:Fe(new g(50,"glyphMargin",!0,{description:d.localize(212,null)})),gotoLocation:Fe(new H),hideCursorInOverviewRuler:Fe(new g(52,"hideCursorInOverviewRuler",!1,{description:d.localize(213,null)})),hover:Fe(new M),inDiffEditor:Fe(new g(54,"inDiffEditor",!1)),letterSpacing:Fe(new l(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>l.clamp(J,-5,20),{description:d.localize(214,null)})),lightbulb:Fe(new q),lineDecorationsWidth:Fe(new m(58,"lineDecorationsWidth",10)),lineHeight:Fe(new Q),lineNumbers:Fe(new Re),lineNumbersMinChars:Fe(new h(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new g(62,"linkedEditing",!1,{description:d.localize(215,null)})),links:Fe(new g(63,"links",!0,{description:d.localize(216,null)})),matchBrackets:Fe(new w(64,"matchBrackets","always",["always","near","never"],{description:d.localize(217,null)})),minimap:Fe(new ue),mouseStyle:Fe(new w(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new l(67,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:d.localize(218,null)})),mouseWheelZoom:Fe(new g(68,"mouseWheelZoom",!1,{markdownDescription:d.localize(219,null)})),multiCursorMergeOverlapping:Fe(new g(69,"multiCursorMergeOverlapping",!0,{description:d.localize(220,null)})),multiCursorModifier:Fe(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[d.localize(221,null),d.localize(222,null)],markdownDescription:d.localize(223,null)})),multiCursorPaste:Fe(new w(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(224,null),d.localize(225,null)],markdownDescription:d.localize(226,null)})),occurrencesHighlight:Fe(new g(72,"occurrencesHighlight",!0,{description:d.localize(227,null)})),overviewRulerBorder:Fe(new g(73,"overviewRulerBorder",!0,{description:d.localize(228,null)})),overviewRulerLanes:Fe(new h(74,"overviewRulerLanes",3,0,3)),padding:Fe(new G),parameterHints:Fe(new ge),peekWidgetDefaultFocus:Fe(new w(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(229,null),d.localize(230,null)],description:d.localize(231,null)})),definitionLinkOpensInPeek:Fe(new g(78,"definitionLinkOpensInPeek",!1,{description:d.localize(232,null)})),quickSuggestions:Fe(new he),quickSuggestionsDelay:Fe(new h(80,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(233,null)})),readOnly:Fe(new g(81,"readOnly",!1)),renameOnType:Fe(new g(82,"renameOnType",!1,{description:d.localize(234,null),markdownDeprecationMessage:d.localize(235,null)})),renderControlCharacters:Fe(new g(83,"renderControlCharacters",!0,{description:d.localize(236,null),restricted:!0})),renderFinalNewline:Fe(new g(84,"renderFinalNewline",!0,{description:d.localize(237,null)})),renderLineHighlight:Fe(new w(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(238,null)],description:d.localize(239,null)})),renderLineHighlightOnlyWhenFocus:Fe(new g(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(240,null)})),renderValidationDecorations:Fe(new w(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new w(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(241,null),d.localize(242,null),d.localize(243,null),""],description:d.localize(244,null)})),revealHorizontalRightPadding:Fe(new h(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new g(90,"roundedSelection",!0,{description:d.localize(245,null)})),rulers:Fe(new Te),scrollbar:Fe(new le),scrollBeyondLastColumn:Fe(new h(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(246,null)})),scrollBeyondLastLine:Fe(new g(94,"scrollBeyondLastLine",!0,{description:d.localize(247,null)})),scrollPredominantAxis:Fe(new g(95,"scrollPredominantAxis",!0,{description:d.localize(248,null)})),selectionClipboard:Fe(new g(96,"selectionClipboard",!0,{description:d.localize(249,null),included:i.isLinux})),selectionHighlight:Fe(new g(97,"selectionHighlight",!0,{description:d.localize(250,null)})),selectOnLineNumbers:Fe(new g(98,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new w(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),showUnused:Fe(new g(100,"showUnused",!0,{description:d.localize(254,null)})),showDeprecated:Fe(new g(126,"showDeprecated",!0,{description:d.localize(255,null)})),inlayHints:Fe(new ie),snippetSuggestions:Fe(new w(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(256,null),d.localize(257,null),d.localize(258,null),d.localize(259,null)],description:d.localize(260,null)})),smartSelect:Fe(new X),smoothScrolling:Fe(new g(103,"smoothScrolling",!1,{description:d.localize(261,null)})),stopRenderingLineAfter:Fe(new h(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new K),inlineSuggest:Fe(new ee),suggestFontSize:Fe(new h(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(262,null)})),suggestLineHeight:Fe(new h(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(263,null)})),suggestOnTriggerCharacters:Fe(new g(109,"suggestOnTriggerCharacters",!0,{description:d.localize(264,null)})),suggestSelection:Fe(new w(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(265,null),d.localize(266,null),d.localize(267,null)],description:d.localize(268,null)})),tabCompletion:Fe(new w(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(269,null),d.localize(270,null),d.localize(271,null)],description:d.localize(272,null)})),tabIndex:Fe(new h(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new pe),unusualLineTerminators:Fe(new w(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(273,null),d.localize(274,null),d.localize(275,null)],description:d.localize(276,null)})),useShadowDOM:Fe(new g(115,"useShadowDOM",!0)),useTabStops:Fe(new g(116,"useTabStops",!0,{description:d.localize(277,null)})),wordSeparators:Fe(new f(117,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:d.localize(278,null)})),wordWrap:Fe(new w(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(279,null),d.localize(280,null),d.localize(281,null),d.localize(282,null)],description:d.localize(283,null)})),wordWrapBreakAfterCharacters:Fe(new f(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new f(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new h(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(284,null)})),wordWrapOverride1:Fe(new w(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new w(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[d.localize(285,null),d.localize(286,null),d.localize(287,null),d.localize(288,null)],description:d.localize(289,null)})),wrappingStrategy:Fe(new w(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(290,null),d.localize(291,null)],description:d.localize(292,null)})),editorClassName:Fe(new O),pixelRatio:Fe(new ne),tabFocusMode:Fe(new me),layoutInfo:Fe(new V),wrappingInfo:Fe(new De)}}),define(Ie[164],ke([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[165],ke([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[166],ke([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[167],ke([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[168],ke([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(Ie[169],ke([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(Ie[170],ke([19,20]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(Ie[171],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[172],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[173],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[174],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[175],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[176],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[177],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[178],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[179],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[180],ke([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(Ie[181],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[182],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[183],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[184],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ie[185],ke([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[186],ke([19,20]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[187],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var d;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var i;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var C;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(C=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var I;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(I=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ie[188],ke([1,0,22,43,166,295]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function b(g){return g=g.trim(),g==="*"||I.test(g)}e.isValidVersionStr=b;function A(g){if(!b(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(I);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=A;function L(g){if(!g)return null;let E=g.majorBase,h=g.majorMustEqual,l=g.minorBase,f=g.minorMustEqual,o=g.patchBase,w=g.patchMustEqual;g.hasCaret&&(E===0||(f=!1),w=!1);let r=0;if(g.preRelease){const s=D.exec(g.preRelease);if(s){const[,n,t,a]=s;r=Date.UTC(Number(n),Number(t)-1,Number(a))}}return{majorBase:E,majorMustEqual:h,minorBase:l,minorMustEqual:f,patchBase:o,patchMustEqual:w,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function k(g,E,h){let l;typeof g=="string"?l=L(A(g)):l=g;let f;E instanceof Date?f=E.getTime():typeof E=="string"&&(f=new Date(E).getTime());let o;if(typeof h=="string"?o=L(A(h)):o=h,!l||!o)return!1;let w=l.majorBase,r=l.minorBase,s=l.patchBase,n=o.majorBase,t=o.minorBase,a=o.patchBase,u=o.notBefore,c=o.majorMustEqual,S=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?w>n?!0:w<n?!1:r>t?!0:r<t||f&&f<u?!1:s>=a:(w===1&&n===0&&(!c||!S||!R)&&(n=1,t=0,a=0,c=!0,S=!1,R=!1),w<n?!1:w>n?!c:r<t?!1:r>t?!S:s<a?!1:s>a?!R:!(f&&f<u))}e.isValidVersion=k;function y(g,E,h,l,f){const o=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return o.push([i.default.Error,C.localize(0,null)]),o;if(typeof l.name!="string")return o.push([i.default.Error,C.localize(1,null,"name")]),o;if(typeof l.version!="string")return o.push([i.default.Error,C.localize(2,null,"version")]),o;if(!l.engines)return o.push([i.default.Error,C.localize(3,null,"engines")]),o;if(typeof l.engines.vscode!="string")return o.push([i.default.Error,C.localize(4,null,"engines.vscode")]),o;if(typeof l.extensionDependencies!="undefined"&&!v(l.extensionDependencies))return o.push([i.default.Error,C.localize(5,null,"extensionDependencies")]),o;if(typeof l.activationEvents!="undefined"){if(!v(l.activationEvents))return o.push([i.default.Error,C.localize(6,null,"activationEvents")]),o;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return o.push([i.default.Error,C.localize(7,null,"activationEvents","main")]),o}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&o.push([i.default.Warning,C.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return o.push([i.default.Error,C.localize(9,null,"main")]),o;{const s=(0,d.joinPath)(h,l.main);(0,d.isEqualOrParent)(s,h)||o.push([i.default.Warning,C.localize(10,null,s.path,h.path)])}if(typeof l.activationEvents=="undefined")return o.push([i.default.Error,C.localize(11,null,"activationEvents","main")]),o}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return o.push([i.default.Error,C.localize(12,null,"browser")]),o;{const s=(0,d.joinPath)(h,l.browser);(0,d.isEqualOrParent)(s,h)||o.push([i.default.Warning,C.localize(13,null,s.path,h.path)])}if(typeof l.activationEvents=="undefined")return o.push([i.default.Error,C.localize(14,null,"activationEvents","browser")]),o}if(!P.valid(l.version))return o.push([i.default.Error,C.localize(15,null)]),o;const w=[];if(!T(g,E,l,f,w))for(const s of w)o.push([i.default.Error,s]);return o}e.validateExtensionManifest=y;function T(g,E,h,l,f){return l||typeof h.main=="undefined"&&typeof h.browser=="undefined"?!0:m(g,E,h.engines.vscode,f)}e.isValidExtensionVersion=T;function _(g,E,h){return g==="*"||m(E,h,g)}e.isEngineValid=_;function m(g,E,h,l=[]){let f=L(A(h));if(!f)return l.push(C.localize(16,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return l.push(C.localize(17,null,h)),!1}else if(!f.majorMustEqual)return l.push(C.localize(18,null,h)),!1;return k(g,E,f)?!0:(l.push(C.localize(19,null,g,h)),!1)}function v(g){if(!Array.isArray(g))return!1;for(let E=0,h=g.length;E<h;E++)if(typeof g[E]!="string")return!1;return!0}}),define(Ie[114],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(C,P=[],I=!1){this.ctor=C,this.staticArguments=P,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=d}),define(Ie[82],ke([1,0,114]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function C(I,D,b){D instanceof d.SyncDescriptor||(D=new d.SyncDescriptor(D,[],b)),i.push([I,D])}e.registerSingleton=C;function P(){return i}e.getSingletonServiceDescriptors=P}),define(Ie[189],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=d;class i{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let I of this._nodes.values())I.outgoing.size===0&&P.push(I);return P}insertEdge(P,I){const D=this.lookupOrInsertNode(P),b=this.lookupOrInsertNode(I);D.outgoing.set(this._hashFn(I),b),b.incoming.set(this._hashFn(P),D)}removeNode(P){const I=this._hashFn(P);this._nodes.delete(I);for(let D of this._nodes.values())D.outgoing.delete(I),D.incoming.delete(I)}lookupOrInsertNode(P){const I=this._hashFn(P);let D=this._nodes.get(I);return D||(D=new d(P),this._nodes.set(I,D)),D}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[I,D]of this._nodes)P.push(`${I}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,I]of this._nodes){const D=new Set([P]),b=this._findCycle(I,D);if(b)return b}}_findCycle(P,I){for(let[D,b]of P.outgoing){if(I.has(D))return[...I,D].join(" -> ");I.add(D);const A=this._findCycle(b,I);if(A)return A;I.delete(D)}}}e.Graph=i}),define(Ie[4],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(b){return b[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(d=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function i(I,D,b){D[d.DI_TARGET]===D?D[d.DI_DEPENDENCIES].push({id:I,index:b}):(D[d.DI_DEPENDENCIES]=[{id:I,index:b}],D[d.DI_TARGET]=D)}function C(I){if(d.serviceIds.has(I))return d.serviceIds.get(I);const D=function(b,A,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,b,L)};return D.toString=()=>I,d.serviceIds.set(I,D),D}e.createDecorator=C;function P(I){return I}e.refineServiceDecorator=P}),define(Ie[83],ke([1,0,14,2,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationOverrides=P;function I(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||d.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=I;var D;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function A(g,E){const h=Object.create(null);for(let l in g)L(h,l,g[l],E);return h}e.toValuesTree=A;function L(g,E,h,l){const f=E.split("."),o=f.pop();let w=g;for(let r=0;r<f.length;r++){let s=f[r],n=w[s];switch(typeof n){case"undefined":n=w[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${E} as ${f.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}w=n}if(typeof w=="object"&&w!==null)try{w[o]=h}catch{l(`Ignoring ${E} as ${f.join(".")} is ${JSON.stringify(w)}`)}else l(`Ignoring ${E} as ${f.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=L;function k(g,E){const h=E.split(".");y(g,h)}e.removeFromValueTree=k;function y(g,E){const h=E.shift();if(E.length===0){delete g[h];return}if(Object.keys(g).indexOf(h)!==-1){const l=g[h];typeof l=="object"&&!Array.isArray(l)&&(y(l,E),Object.keys(l).length===0&&delete g[h])}}function T(g,E,h){function l(w,r){let s=w;for(const n of r){if(typeof s!="object"||s===null)return;s=s[n]}return s}const f=E.split("."),o=l(g,f);return typeof o=="undefined"?h:o}e.getConfigurationValue=T;function _(g,E,h){Object.keys(E).forEach(l=>{l!=="__proto__"&&(l in g?d.isObject(g[l])&&d.isObject(E[l])?_(g[l],E[l],h):h&&(g[l]=E[l]):g[l]=E[l])})}e.merge=_;function m(g,E,h){const l=g.inspect(E),f=g.inspect(h);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=m;function v(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(Ie[64],ke([1,0,12,8,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",d.isMacintosh),P.set("isLinux",d.isLinux),P.set("isWindows",d.isWindows),P.set("isWeb",d.isWeb),P.set("isMacNative",d.isMacintosh&&!d.isWeb),P.set("isEdge",d.isEdge),P.set("isFirefox",d.isFirefox),P.set("isChrome",d.isChrome),P.set("isSafari",d.isSafari);const I=Object.prototype.hasOwnProperty;var D;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return k.INSTANCE}static true(){return y.INSTANCE}static has(p){return T.create(p)}static equals(p,U){return _.create(p,U)}static notEquals(p,U){return g.create(p,U)}static regex(p,U){return r.create(p,U)}static in(p,U){return m.create(p,U)}static not(p){return E.create(p)}static and(...p){return t.create(p,null)}static or(...p){return a.create(p,null,!0)}static greater(p,U){return l.create(p,U)}static greaterEquals(p,U){return f.create(p,U)}static smaller(p,U){return o.create(p,U)}static smallerEquals(p,U){return w.create(p,U)}static deserialize(p,U=!1){if(!!p)return this._deserializeOrExpression(p,U)}static _deserializeOrExpression(p,U){let B=p.split("||");return a.create(B.map(z=>this._deserializeAndExpression(z,U)),null,!0)}static _deserializeAndExpression(p,U){let B=p.split("&&");return t.create(B.map(z=>this._deserializeOne(z,U)),null)}static _deserializeOne(p,U){if(p=p.trim(),p.indexOf("!=")>=0){let B=p.split("!=");return g.create(B[0].trim(),this._deserializeValue(B[1],U))}if(p.indexOf("==")>=0){let B=p.split("==");return _.create(B[0].trim(),this._deserializeValue(B[1],U))}if(p.indexOf("=~")>=0){let B=p.split("=~");return r.create(B[0].trim(),this._deserializeRegexValue(B[1],U))}if(p.indexOf(" in ")>=0){let B=p.split(" in ");return m.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const B=p.split(">=");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const B=p.split(">");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const B=p.split("<=");return w.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const B=p.split("<");return o.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(p)?E.create(p.substr(1).trim()):T.create(p)}static _deserializeValue(p,U){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let B=/^'([^']*)'$/.exec(p);return B?B[1].trim():p}static _deserializeRegexValue(p,U){if((0,i.isFalsyOrWhitespace)(p)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=p.indexOf("/"),z=p.lastIndexOf("/");if(B===z||B<0){if(U)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let re=p.slice(B+1,z),H=p[z+1]==="i"?"i":"";try{return new RegExp(re,H)}catch(M){if(U)throw new Error(`bad regexp-value '${p}', parse error: ${M}`);return console.warn(`bad regexp-value '${p}', parse error: ${M}`),null}}}e.ContextKeyExpr=b;function A(N,p){const U=N?N.substituteConstants():void 0,B=p?p.substituteConstants():void 0;return!U&&!B?!0:!U||!B?!1:U.equals(B)}e.expressionsAreEqualWithConstantSubstitution=A;function L(N,p){return N.cmp(p)}class k{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class y{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class T{constructor(p,U){this.key=p,this.negated=U,this.type=2}static create(p,U=null){const B=P.get(p);return typeof B=="boolean"?B?y.INSTANCE:k.INSTANCE:new T(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:c(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=P.get(this.key);return typeof p=="boolean"?p?y.INSTANCE:k.INSTANCE:this}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class _{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=4}static create(p,U,B=null){if(typeof U=="boolean")return U?T.create(p,B):E.create(p,B);const z=P.get(p);return typeof z=="boolean"?U===(z?"true":"false")?y.INSTANCE:k.INSTANCE:new _(p,U,B)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=P.get(this.key);if(typeof p=="boolean"){const U=p?"true":"false";return this.value===U?y.INSTANCE:k.INSTANCE}return this}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=_;class m{constructor(p,U){this.key=p,this.valueKey=U,this.type=10,this.negated=null}static create(p,U){return new m(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}substituteConstants(){return this}evaluate(p){const U=p.getValue(this.valueKey),B=p.getValue(this.key);return Array.isArray(U)?U.includes(B):typeof B=="string"&&typeof U=="object"&&U!==null?I.call(U,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=m;class v{constructor(p){this._actual=p,this.type=11}static create(p){return new v(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new v(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class g{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=5}static create(p,U,B=null){if(typeof U=="boolean")return U?E.create(p,B):T.create(p,B);const z=P.get(p);return typeof z=="boolean"?U===(z?"true":"false")?k.INSTANCE:y.INSTANCE:new g(p,U,B)}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=P.get(this.key);if(typeof p=="boolean"){const U=p?"true":"false";return this.value===U?k.INSTANCE:y.INSTANCE}return this}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class E{constructor(p,U){this.key=p,this.negated=U,this.type=3}static create(p,U=null){const B=P.get(p);return typeof B=="boolean"?B?k.INSTANCE:y.INSTANCE:new E(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:c(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=P.get(this.key);return typeof p=="boolean"?p?k.INSTANCE:y.INSTANCE:this}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;function h(N,p){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?p(N):k.INSTANCE}class l{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=12}static create(p,U,B=null){return h(U,z=>new l(p,z,B))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class f{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=13}static create(p,U,B=null){return h(U,z=>new f(p,z,B))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class o{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=14}static create(p,U,B=null){return h(U,z=>new o(p,z,B))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class w{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=15}static create(p,U,B=null){return h(U,z=>new w(p,z,B))}cmp(p){return p.type!==this.type?this.type-p.type:S(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=w;class r{constructor(p,U){this.key=p,this.regexp=U,this.type=7,this.negated=null}static create(p,U){return new r(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const U=this.regexp?this.regexp.source:"",B=p.regexp?p.regexp.source:"";return U<B?-1:U>B?1:0}equals(p){if(p.type===this.type){const U=this.regexp?this.regexp.source:"",B=p.regexp?p.regexp.source:"";return this.key===p.key&&U===B}return!1}substituteConstants(){return this}evaluate(p){let U=p.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(p){this._actual=p,this.type=8}static create(p){return new s(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new s(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(N){let p=null;for(let U=0,B=N.length;U<B;U++){const z=N[U].substituteConstants();if(N[U]!==z&&p===null){p=[];for(let re=0;re<U;re++)p[re]=N[re]}p!==null&&(p[U]=z)}return p===null?N:p}class t{constructor(p,U){this.expr=p,this.negated=U,this.type=6}static create(p,U){return t._normalizeArr(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const z=L(this.expr[U],p.expr[U]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:t.create(p,this.negated)}evaluate(p){for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].evaluate(p))return!1;return!0}static _normalizeArr(p,U){const B=[];let z=!1;for(const re of p)if(!!re){if(re.type===1){z=!0;continue}if(re.type===0)return k.INSTANCE;if(re.type===6){B.push(...re.expr);continue}B.push(re)}if(B.length===0&&z)return y.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(L);for(let re=1;re<B.length;re++)B[re-1].equals(B[re])&&(B.splice(re,1),re--);if(B.length===1)return B[0];for(;B.length>1;){const re=B[B.length-1];if(re.type!==9)break;B.pop();const H=B.pop(),M=B.length===0,j=a.create(re.expr.map(V=>t.create([V,H],null)),null,M);j&&(B.push(j),B.sort(L))}return B.length===1?B[0]:new t(B,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new t(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){const p=[];for(let U of this.expr)p.push(U.negate());this.negated=a.create(p,this,!0)}return this.negated}}class a{constructor(p,U){this.expr=p,this.negated=U,this.type=9}static create(p,U,B){return a._normalizeArr(p,U,B)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const z=L(this.expr[U],p.expr[U]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}substituteConstants(){const p=n(this.expr);return p===this.expr?this:a.create(p,this.negated,!1)}evaluate(p){for(let U=0,B=this.expr.length;U<B;U++)if(this.expr[U].evaluate(p))return!0;return!1}static _normalizeArr(p,U,B){let z=[],re=!1;if(p){for(let H=0,M=p.length;H<M;H++){const j=p[H];if(!!j){if(j.type===0){re=!0;continue}if(j.type===1)return y.INSTANCE;if(j.type===9){z=z.concat(j.expr);continue}z.push(j)}}if(z.length===0&&re)return k.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];if(B){for(let H=0;H<z.length;H++)for(let M=H+1;M<z.length;M++)R(z[H],z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0]}return new a(z,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new a(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){let p=[];for(let U of this.expr)p.push(U.negate());for(;p.length>1;){const U=p.shift(),B=p.shift(),z=[];for(const H of O(U))for(const M of O(B))z.push(t.create([H,M],null));const re=p.length===0;p.unshift(a.create(z,null,re))}this.negated=p[0]}return this.negated}}class u extends T{constructor(p,U,B){super(p,null);this._defaultValue=U,typeof B=="object"?u._info.push({...B,key:p}):B!==!0&&u._info.push({key:p,description:B,type:U!=null?typeof U:void 0})}static all(){return u._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return _.create(this.key,p)}notEqualsTo(p){return g.create(this.key,p)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function c(N,p){return N<p?-1:N>p?1:0}function S(N,p,U,B){return N<U?-1:N>U?1:p<B?-1:p>B?1:0}function R(N,p){if(p.type===6&&N.type!==9&&N.type!==6){for(const z of p.expr)if(N.equals(z))return!0}const U=N.negate(),B=O(U).concat(O(p));B.sort(L);for(let z=0;z<B.length;z++){const H=B[z].negate();for(let M=z+1;M<B.length;M++){const j=B[M];if(H.equals(j))return!0}}return!1}e.implies=R;function O(N){return N.type===9?N.expr:[N]}}),define(Ie[190],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[115],ke([1,0,165,4]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function I(g,E){switch(g){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function D(g,E){return E==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function b(g,E,h){return D(E,h)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===h?!0:A(h).includes(g)}e.isTargetPlatformCompatible=b;function A(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var y;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var T;(function(g){g.Install="install",g.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var _;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(E,h){super(E);this.code=h,this.name=h}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,d.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,d.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService")}),define(Ie[191],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,d.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,d.createDecorator)("externalTerminal")}),define(Ie[192],ke([1,0,41,10,9,12,95,29,112,167,191]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends y{openTerminal(l,f){return this.spawnTerminal(d,l,b.getWindowsShell(),f)}spawnTerminal(l,f,o,w){const r=f.windowsExec||T.getDefaultTerminalWindows();w&&w[1]===":"&&(w=w[0].toUpperCase()+w.substr(1));const s=C.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return l.spawn(r,w?[w]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(s==="wt"||s==="wt.exe")&&n.push("-d ."),new Promise((t,a)=>{const u=v(process),c=l.spawn(o,n,{cwd:w,env:u});c.on("error",a),c.on("exit",()=>t())})}runInTerminal(l,f,o,w,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((n,t)=>{const a=`"${f} - ${k}"`,u=`""${o.join('" "')}" & pause"`,c=["/c","start",a,"/wait",s,"/c",u],S=Object.assign({},v(process),w);Object.keys(S).filter(N=>S[N]===null).forEach(N=>delete S[N]);const R={cwd:f,env:S,windowsVerbatimArguments:!0};d.spawn(T.CMD,c,R).on("error",N=>{t(g(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class _ extends y{openTerminal(l,f){return this.spawnTerminal(d,l,f)}runInTerminal(l,f,o,w,r){const s=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{if(s===L.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const a=s===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",c=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Y).fsPath,"-t",l||k,"-w",f];for(let O of o)c.push("-a"),c.push(O);if(w){const O=Object.assign({},v(process),w);for(let N in O){const p=O[N];p===null?(c.push("-u"),c.push(N)):(c.push("-e"),c.push(`${N}=${p}`))}}let S="";const R=d.spawn(_.OSASCRIPT,c);R.on("error",O=>{t(g(O))}),R.stderr.on("data",O=>{S+=O.toString()}),R.on("exit",O=>{if(O===0)n(void 0);else if(S){const N=S.split(`
`,1);t(new Error(N[0]))}else t(new Error(A.localize(1,null,a,O)))})}else t(new Error(A.localize(2,null,s)))})}spawnTerminal(l,f,o){const w=f.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const n=["-a",w];o&&n.push(o);const t=v(process),a=l.spawn("/usr/bin/open",n,{cwd:o,env:t});a.on("error",s),a.on("exit",()=>r())})}}e.MacExternalTerminalService=_,_.OSASCRIPT="/usr/bin/osascript";class m extends y{openTerminal(l,f){return this.spawnTerminal(d,l,f)}runInTerminal(l,f,o,w,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{let a=[];s.then(u=>{u.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const c=`${E(o)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;a.push(`''${c}''`);const S=Object.assign({},v(process),w);Object.keys(S).filter(p=>S[p]===null).forEach(p=>delete S[p]);const R={cwd:f,env:S};let O="";const N=d.spawn(u,a,R);N.on("error",p=>{t(g(p))}),N.stderr.on("data",p=>{O+=p.toString()}),N.on("exit",p=>{if(p===0)n(void 0);else if(O){const U=O.split(`
`,1);t(new Error(U[0]))}else t(new Error(A.localize(4,null,u,p)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await D.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(f=>{l?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,f,o){const w=f.linuxExec?Promise.resolve(f.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{w.then(n=>{const t=v(process),a=l.spawn(n,[],{cwd:o,env:t});a.on("error",s),a.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=A.localize(3,null);function v(h){const l={...h.env};return(0,I.sanitizeProcessEnvironment)(l),l}function g(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(A.localize(5,null,h.path)):h}function E(h){let l="";for(let f of h)f.indexOf(" ")>=0?l+='"'+f+'"':l+=f,l+=" ";return l}}),define(Ie[42],ke([1,0,11,24,9,8,14,2,168,4]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function L(M){return M.create===!0}e.isFileOpenForWriteOptions=L;var k;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var y;(function(M){M[M.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var T;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(T=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=_;function m(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=m;function v(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=v;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=E;function h(M){return _(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=h;var l;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(j,V){super(j);this.code=V}}e.FileSystemProviderError=f;function o(M,j){const V=new f(M.toString(),j);return r(V,j),V}e.createFileSystemProviderError=o;function w(M){return M||o((0,b.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=w;function r(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function s(M){if(!M)return l.Unknown;if(M instanceof f)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return l.Unknown;switch(j[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=s;function n(M){if(M instanceof R)return M.fileOperationResult;switch(s(M)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class a{constructor(j,V,q){this.resource=j,this.operation=V,this.target=q}isOperation(j){return this.operation===j}}e.FileOperationEvent=a;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(j,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const q=new Map;for(const ie of j){const Q=q.get(ie.type);switch(Q?Q.push([ie.resource,ie]):q.set(ie.type,[[ie.resource,ie]]),ie.type){case 1:this.rawAdded.push(ie.resource);break;case 0:this.rawUpdated.push(ie.resource);break;case 2:this.rawDeleted.push(ie.resource);break}}for(const[ie,Q]of q)switch(ie){case 1:this.added=i.TernarySearchTree.forUris(()=>V),this.added.fill(Q);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>V),this.updated.fill(Q);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>V),this.deleted.fill(Q);break}}contains(j,...V){return this.doContains(j,{includeChildren:!1},...V)}affects(j,...V){return this.doContains(j,{includeChildren:!0},...V)}doContains(j,V,...q){if(!j)return!1;const ie=q.length>0;return!!((!ie||q.includes(1))&&(this.added?.get(j)||V.includeChildren&&this.added?.findSuperstr(j))||(!ie||q.includes(0))&&(this.updated?.get(j)||V.includeChildren&&this.updated?.findSuperstr(j))||(!ie||q.includes(2))&&(this.deleted?.findSubstr(j)||V.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function S(M,j,V){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==C.sep&&(j+=C.sep),V?(0,P.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=S;class R extends d.ErrorNoTelemetry{constructor(j,V,q){super(j);this.fileOperationResult=V,this.options=q}}e.FileOperationError=R;class O extends R{constructor(j,V,q){super(j,2,q);this.stat=V}}e.NotModifiedSinceFileOperationError=O;var N;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=U;async function B(M,j){if(!j.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(V=>{const q=j.onDidChangeFileSystemProviderRegistrations(ie=>{ie.scheme===M.scheme&&ie.added&&(q.dispose(),V())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,I.isNumber)(j)||(j=0),j<z.KB?(0,b.localize)(1,null,j.toFixed(0)):j<z.MB?(0,b.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,b.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,b.localize)(4,null,(j/z.GB).toFixed(2)):(0,b.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var re;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function H(M){return{maxFileSize:M===0?300*z.MB:16*z.GB,maxHeapSize:M===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=H}),define(Ie[84],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...C){this._entries=new Map;for(let[P,I]of C)this.set(P,I)}set(C,P){const I=this._entries.get(C);return this._entries.set(C,P),I}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=d}),define(Ie[193],ke([1,0,17,11,114,189,4,84]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class A extends Error{constructor(_){super("cyclic dependency between services");this.message=_.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${_.toString()}`}}class L{constructor(_=new D.ServiceCollection,m=!1,v){this._activeInstantiations=new Set,this._services=_,this._strict=m,this._parent=v,this._services.set(I.IInstantiationService,this)}createChild(_){return new L(_,this._strict,this)}invokeFunction(_,...m){let v=y.traceInvocation(_),g=!1;try{return _({get:h=>{if(g)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,v);if(!l)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...m)}finally{g=!0,v.stop()}}createInstance(_,...m){let v,g;return _ instanceof C.SyncDescriptor?(v=y.traceCreation(_.ctor),g=this._createInstance(_.ctor,_.staticArguments.concat(m),v)):(v=y.traceCreation(_),g=this._createInstance(_,m,v)),v.stop(),g}_createInstance(_,m=[],v){let g=I._util.getServiceDependencies(_).sort((l,f)=>l.index-f.index),E=[];for(const l of g){let f=this._getOrCreateServiceInstance(l.id,v);f||this._throwIfStrict(`[createInstance] ${_.name} depends on UNKNOWN service ${l.id}.`,!1),E.push(f)}let h=g.length>0?g[0].index:m.length;if(m.length!==h){console.trace(`[createInstance] First service dependency of ${_.name} at position ${h+1} conflicts with ${m.length} static arguments`);let l=h-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,h)}return new _(...[...m,...E])}_setServiceInstance(_,m){if(this._services.get(_)instanceof C.SyncDescriptor)this._services.set(_,m);else if(this._parent)this._parent._setServiceInstance(_,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(_){let m=this._services.get(_);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(_):m}_getOrCreateServiceInstance(_,m){let v=this._getServiceInstanceOrDescriptor(_);return v instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(_,v,m.branch(_,!0)):(m.branch(_,!1),v)}_safeCreateAndCacheServiceInstance(_,m,v){if(this._activeInstantiations.has(_))throw new Error(`illegal state - RECURSIVELY instantiating service '${_}'`);this._activeInstantiations.add(_);try{return this._createAndCacheServiceInstance(_,m,v)}finally{this._activeInstantiations.delete(_)}}_createAndCacheServiceInstance(_,m,v){const g=new P.Graph(l=>l.id.toString());let E=0;const h=[{id:_,desc:m,_trace:v}];for(;h.length;){const l=h.pop();if(g.lookupOrInsertNode(l),E++>1e3)throw new A(g);for(let f of I._util.getServiceDependencies(l.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(f.id);if(o||this._throwIfStrict(`[createInstance] ${_} depends on ${f.id} which is NOT registered.`,!0),o instanceof C.SyncDescriptor){const w={id:f.id,desc:o,_trace:l._trace.branch(f.id,!0)};g.insertEdge(l,w),h.push(w)}}}for(;;){const l=g.roots();if(l.length===0){if(!g.isEmpty())throw new A(g);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof C.SyncDescriptor){const w=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,w)}g.removeNode(f)}}return this._getServiceInstanceOrDescriptor(_)}_createServiceInstanceWithOwner(_,m,v=[],g,E){if(this._services.get(_)instanceof C.SyncDescriptor)return this._createServiceInstance(m,v,g,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(_,m,v,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(_,m=[],v,g){if(v){const E=new d.IdleValue(()=>this._createInstance(_,m,g));return new Proxy(Object.create(null),{get(h,l){if(l in h)return h[l];let f=E.value,o=f[l];return typeof o!="function"||(o=o.bind(f),h[l]=o),o},set(h,l,f){return E.value[l]=f,!0}})}else return this._createInstance(_,m,g)}_throwIfStrict(_,m){if(m&&console.warn(m),this._strict)throw new Error(_)}}e.InstantiationService=L;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class y{constructor(_,m){this.type=_,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(_){return b?new y(1,_.name||_.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(_){return b?new y(0,_.name):y._None}branch(_,m){let v=new y(2,_.toString());return this._dep.push([_,m,v]),v}stop(){let _=Date.now()-this._start;y._totals+=_;let m=!1;function v(E,h){let l=[],f=new Array(E+1).join("	");for(const[o,w,r]of h._dep)if(w&&r){m=!0,l.push(`${f}CREATES -> ${o}`);let s=v(E+1,r);s&&l.push(s)}else l.push(`${f}uses -> ${o}`);return l.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${_.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(_>2||m)&&console.log(g.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Ie[13],ke([1,0,50,3,6,12,4]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function D(){return new Date().toISOString()}var b;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function A(w,r,s){switch(r){case b.Trace:w.trace(s);break;case b.Debug:w.debug(s);break;case b.Info:w.info(s);break;case b.Warning:w.warn(s);break;case b.Error:w.error(s);break;case b.Critical:w.critical(s);break;default:throw new Error("Invalid log level")}}e.log=A;function L(w){let r="";for(let s=0;s<w.length;s++){let n=w[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(s>0?" ":"")+n}return r}e.format=L;class k extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class y extends k{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(b.Trace)&&this.log(b.Trace,L([r,...s]))}debug(r,...s){this.checkLogLevel(b.Debug)&&this.log(b.Debug,L([r,...s]))}info(r,...s){this.checkLogLevel(b.Info)&&this.log(b.Info,L([r,...s]))}warn(r,...s){this.checkLogLevel(b.Warning)&&this.log(b.Warning,L([r,...s]))}error(r,...s){if(this.checkLogLevel(b.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(b.Error,L(n))}else this.log(b.Error,L([r,...s]))}critical(r,...s){this.checkLogLevel(b.Critical)&&this.log(b.Critical,L([r,...s]))}flush(){}}e.AbstractMessageLogger=y;class T extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!P.isWindows}trace(r,...s){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}debug(r,...s){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}info(r,...s){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}warn(r,...s){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,r,...s):console.warn(`[main ${D()}]`,r,...s))}error(r,...s){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}critical(r,...s){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class _ extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=_;class m extends k{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,d.toErrorMessage)(r,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class v extends k{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const n of this.logServices)n.trace(r,...s)}debug(r,...s){for(const n of this.logServices)n.debug(r,...s)}info(r,...s){for(const n of this.logServices)n.info(r,...s)}warn(r,...s){for(const n of this.logServices)n.warn(r,...s)}error(r,...s){for(const n of this.logServices)n.error(r,...s)}critical(r,...s){for(const n of this.logServices)n.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class g extends C.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=g;class E extends C.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,s?.always?b.Trace:this.logLevel,s),this.loggers.set(r.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class h{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return b.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=h;function l(w){if(w.verbose)return b.Trace;if(typeof w.logLevel=="string"){const r=f(w.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function f(w){switch(w){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=f;function o(w){switch(w){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=o}),define(Ie[194],ke([1,0,42,13]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(D,b,A,L,k){try{const y=await new Promise((_,m)=>{Y(["spdlog"],_,m)});y.setFlushOn(i.LogLevel.Trace);const T=await y.createAsyncRotatingLogger(D,b,A,L);return k&&T.clearFormatters(),T}catch(y){console.error(y)}return null}function P(D,b,A){switch(b){case i.LogLevel.Trace:D.trace(A);break;case i.LogLevel.Debug:D.debug(A);break;case i.LogLevel.Info:D.info(A);break;case i.LogLevel.Warning:D.warn(A);break;case i.LogLevel.Error:D.error(A);break;case i.LogLevel.Critical:D.critical(A);break;default:throw new Error("Invalid log level")}}class I extends i.AbstractMessageLogger{constructor(b,A,L,k,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(b,A,L,k),this._register(this.onDidChangeLogLevel(T=>{this._logger&&this._logger.setLevel(T)}))}async _createSpdLogLogger(b,A,L,k){const y=L?6:1,T=30/y*d.ByteSize.MB,_=await C(b,A,T,y,k);if(_){this._logger=_,this._logger.setLevel(this.getLevel());for(const{level:m,message:v}of this.buffer)P(this._logger,m,v);this.buffer=[]}}log(b,A){this._logger?P(this._logger,b,A):this.getLevel()<=b&&this.buffer.push({level:b,message:A})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(Ie[116],ke([1,0,43,169,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var I;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function A(_,m){return m-_}b.compare=A;const L=Object.create(null);L[b.Error]=(0,i.localize)(0,null),L[b.Warning]=(0,i.localize)(1,null),L[b.Info]=(0,i.localize)(2,null);function k(_){return L[_]||""}b.toString=k;function y(_){switch(_){case d.default.Error:return b.Error;case d.default.Warning:return b.Warning;case d.default.Info:return b.Info;case d.default.Ignore:return b.Hint}}b.fromSeverity=y;function T(_){switch(_){case b.Error:return d.default.Error;case b.Warning:return d.default.Warning;case b.Info:return d.default.Info;case b.Hint:return d.default.Ignore}}b.toSeverity=T}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(b){const A="";function L(y){return k(y,!0)}b.makeKey=L;function k(y,T){let _=[A];return y.source?_.push(y.source.replace("\xA6","\\\xA6")):_.push(A),y.code?typeof y.code=="string"?_.push(y.code.replace("\xA6","\\\xA6")):_.push(y.code.value.replace("\xA6","\\\xA6")):_.push(A),y.severity!==void 0&&y.severity!==null?_.push(I.toString(y.severity)):_.push(A),y.message&&T?_.push(y.message.replace("\xA6","\\\xA6")):_.push(A),y.startLineNumber!==void 0&&y.startLineNumber!==null?_.push(y.startLineNumber.toString()):_.push(A),y.startColumn!==void 0&&y.startColumn!==null?_.push(y.startColumn.toString()):_.push(A),y.endLineNumber!==void 0&&y.endLineNumber!==null?_.push(y.endLineNumber.toString()):_.push(A),y.endColumn!==void 0&&y.endColumn!==null?_.push(y.endColumn.toString()):_.push(A),_.push(A),_.join("\xA6")}b.makeKeyOptionalMessage=k})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Ie[195],ke([1,0,3,43,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new b,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class b{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=b}),define(Ie[117],ke([1,0,6,8,2,4]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function I(L,k){return C.URI.isUri(L)?(0,i.equalsIgnoreCase)(L.scheme,k):(0,i.startsWithIgnoreCase)(L,k+":")}e.matchesScheme=I;function D(L,...k){return k.some(y=>I(L,y))}e.matchesSomeScheme=D;function b(L,k){return L.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=b;function A(L){let k;const y=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return y&&(k={startLineNumber:parseInt(y[1]),startColumn:y[2]?parseInt(y[2]):1,endLineNumber:y[4]?parseInt(y[4]):void 0,endColumn:y[4]?y[5]?parseInt(y[5]):1:void 0},L=L.with({fragment:""})),{selection:k,uri:L}}e.extractSelection=A}),define(Ie[196],ke([1,0,10,12,40,22]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)I=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const D=(0,P.dirname)(d.FileAccess.asFileUri("",Y));I=Y.__$__nodeRequire((0,P.joinPath)(D,"product.json").fsPath);const b=Y.__$__nodeRequire((0,P.joinPath)(D,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0}),Object.assign(I,{version:b.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I});var $e=this&&this.__param||function(Y,e){return function(d,i){e(d,i,Y)}};define(Ie[118],ke([1,0,17,21,6,4]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let b=class extends C.Disposable{constructor(k,y){super();this.deferred=new d.DeferredPromise,y.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};b=Ve([$e(1,e.IProgressService)],b),e.UnmanagedProgress=b;class A extends C.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const y=++this.currentOperationId,T=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{y===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:y,token:T.token,stop:()=>this.doStop(y),isCurrent:()=>this.currentOperationId===y}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ie[44],ke([1,0,55,14]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(I,D){d.ok(i.isString(I)),d.ok(i.isObject(D)),d.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,D)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new C}),define(Ie[197],ke([1,0,3,44]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class P{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,A){this.schemasById[C(b)]=A,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new P;i.Registry.add(e.Extensions.JSONContribution,I)}),define(Ie[119],ke([1,0,16,3,14,164,83,197,44]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(A=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=b.Registry.as(D.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,w=!0){this.registerConfigurations([o],w)}registerConfigurations(o,w=!0){const r=this.doRegisterConfigurations(o,w);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const w=this.doDeregisterConfigurations(o);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:w})}updateConfigurations({add:o,remove:w}){const r=[];r.push(...this.doDeregisterConfigurations(w)),r.push(...this.doRegisterConfigurations(o,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,d.distinct)(r)})}registerDefaultConfigurations(o){const w=[],r=[];for(const{overrides:s,source:n}of o)for(const t in s)if(w.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const a=this.configurationDefaultsOverrides.get(t),u=a?.valuesSources??new Map;if(n)for(const O of Object.keys(s[t]))u.set(O,n);const c={...a?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:c,valuesSources:u});const S=(0,I.getLanguageTagSettingPlainKey)(t),R={type:"object",default:c,description:P.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:C.isString(n)?void 0:n,defaultValueSource:n};r.push(...m(t)),this.configurationProperties[t]=R,this.defaultLanguageConfigurationOverridesNode.properties[t]=R}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:w,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const w=[];for(const{overrides:r,source:s}of o)for(const n in r){const t=this.configurationDefaultsOverrides.get(n),a=C.isString(s)?s:s?.id,u=C.isString(t?.source)?t?.source:t?.source?.id;if(a===u)if(w.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const c=this.configurationProperties[n];c&&(this.updatePropertyDefaultValue(n,c),this.updateSchema(n,c))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:w,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const w of o)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,w){const r=[];return o.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,w,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(o){const w=[],r=s=>{if(s.properties)for(const n in s.properties)w.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n]);s.allOf&&s.allOf.forEach(n=>r(n))};for(const s of o){r(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return w}validateAndRegisterProperties(o,w=!0,r,s,n=3){n=C.isUndefinedOrNull(o.scope)?n:o.scope;let t=[],a=o.properties;if(a)for(let c in a){if(w&&h(c)){delete a[c];continue}const S=a[c];if(S.source=r,S.defaultDefaultValue=a[c].default,this.updatePropertyDefaultValue(c,S),e.OVERRIDE_PROPERTY_REGEX.test(c)?S.scope=void 0:(S.scope=C.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=C.isUndefinedOrNull(S.restricted)?!!s?.includes(c):S.restricted),a[c].hasOwnProperty("included")&&!a[c].included){this.excludedConfigurationProperties[c]=a[c],delete a[c];continue}else this.configurationProperties[c]=a[c];!a[c].deprecationMessage&&a[c].markdownDeprecationMessage&&(a[c].deprecationMessage=a[c].markdownDeprecationMessage),t.push(c)}let u=o.allOf;if(u)for(let c of u)t.push(...this.validateAndRegisterProperties(c,w,r,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const w=r=>{let s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let n=r.allOf;n&&n.forEach(w)};w(o)}updateSchema(o,w){switch(e.allSettings.properties[o]=w,w.scope){case 1:e.applicationSettings.properties[o]=w;break;case 2:e.machineSettings.properties[o]=w;break;case 6:e.machineOverridableSettings.properties[o]=w;break;case 3:e.windowSettings.properties[o]=w;break;case 4:e.resourceSettings.properties[o]=w;break;case 5:e.resourceSettings.properties[o]=w,this.resourceLanguageSettingsSchema.properties[o]=w;break}}removeFromSchema(o,w){switch(delete e.allSettings.properties[o],w.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const w=`[${o}]`,r={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,r),e.allSettings.properties[w]=r,e.applicationSettings.properties[w]=r,e.machineSettings.properties[w]=r,e.machineOverridableSettings.properties[w]=r,e.windowSettings.properties[w]=r,e.resourceSettings.properties[w]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,w){const r=this.configurationDefaultsOverrides.get(o);let s=r?.value,n=r?.source;C.isUndefined(s)&&(s=w.defaultDefaultValue,n=void 0),C.isUndefined(s)&&(s=g(w.type)),w.default=s,w.defaultValueSource=n}}const T="\\[([^\\]]+)\\]",_=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(f){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let w=_.exec(f);for(;w?.length;){const r=w[1].trim();r&&o.push(r),w=_.exec(f)}}return(0,d.distinct)(o)}e.overrideIdentifiersFromKey=m;function v(f){return f.reduce((o,w)=>`${o}[${w}]`,"")}e.keyFromOverrideIdentifiers=v;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const E=new y;b.Registry.add(e.Extensions.Configuration,E);function h(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?P.localize(7,null,f):E.getConfigurationProperties()[f]!==void 0?P.localize(8,null,f):null:P.localize(6,null)}e.validateProperty=h;function l(){const f=[],o=E.getConfigurationProperties();for(const w of Object.keys(o))f.push([w,o[w].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(Ie[198],ke([1,0,16,3,144,6,24,26,14,2,83,119,44]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class T{constructor(r={},s=[],n=[]){this._contents=r,this._keys=s,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,s){const n=this.getContentsForOverrideIdentifer(s);return n?r?(0,L.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const n of this.overrides)n.identifiers.includes(r)&&s.push(...n.keys);return d.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return d.distinct(r)}override(r){let s=this.overrideConfigurations.get(r);return s||(s=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,s)),s}merge(...r){const s=D.deepClone(this.contents),n=D.deepClone(this.overrides),t=[...this.keys];for(const a of r){this.mergeContents(s,a.contents);for(const u of a.overrides){const[c]=n.filter(S=>d.equals(S.identifiers,u.identifiers));c?(this.mergeContents(c.contents,u.contents),c.keys.push(...u.keys),c.keys=d.distinct(c.keys)):n.push(D.deepClone(u))}for(const u of a.keys)t.indexOf(u)===-1&&t.push(u)}return new T(s,t,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const s=this.getContentsForOverrideIdentifer(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const t of d.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[t],u=s[t];u&&(typeof a=="object"&&typeof u=="object"?(a=D.deepClone(a),this.mergeContents(a,u)):a=u),n[t]=a}return new T(n,this.keys,this.overrides)}mergeContents(r,s){for(const n of Object.keys(s)){if(n in r&&b.isObject(r[n])&&b.isObject(s[n])){this.mergeContents(r[n],s[n]);continue}r[n]=D.deepClone(s[n])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?D.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let s=null,n=null;const t=a=>{a&&(n?this.mergeContents(n,a):n=D.deepClone(a))};for(const a of this.overrides)d.equals(a.identifiers,[r])?s=a.contents:a.identifiers.includes(r)&&t(a.contents);return t(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,s){this.addKey(r),(0,L.addToValueTree)(this.contents,r,s,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,L.removeFromValueTree)(this.contents,r)}addKey(r){let s=this.keys.length;for(let n=0;n<s;n++)r.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,r)}removeKey(r){let s=this.keys.indexOf(r);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=T;class _ extends T{constructor(r={}){const s=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(s),t=Object.create(null),a=[];for(const u in s){const c=r[u],S=c!==void 0?c:s[u].default;(0,L.addToValueTree)(t,u,S,R=>console.error(`Conflict in default settings: ${R}`))}for(const u of Object.keys(t))k.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,k.overrideIdentifiersFromKey)(u),keys:Object.keys(t[u]),contents:(0,L.toValuesTree)(t[u],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,n,a)}}e.DefaultConfigurationModel=_;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,s){if(!b.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,s)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,s){this._raw=r;const{contents:n,keys:t,overrides:a,restricted:u}=this.doParseRaw(r,s);this._configurationModel=new T(n,t,a),this._restrictedConfigurations=u||[]}doParseContent(r){let s={},n=null,t=[],a=[],u=[];function c(R){Array.isArray(t)?t.push(R):n!==null&&(t[n]=R)}let S={onObjectBegin:()=>{let R={};c(R),a.push(t),t=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let R=[];c(R),a.push(t),t=R,n=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:c,onError:(R,O,N)=>{u.push({error:R,offset:O,length:N})}};if(r)try{C.visit(r,S),s=t[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(r,s){const n=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,n,!0,s);r=t.raw;const a=(0,L.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),u=Object.keys(r),c=this.toOverrides(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:a,keys:u,overrides:c,restricted:t.restricted}}filter(r,s,n,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const a={},u=[];for(let c in r)if(k.OVERRIDE_PROPERTY_REGEX.test(c)&&n){const S=this.filter(r[c],s,!1,t);a[c]=S.raw,u.push(...S.restricted)}else{const S=s[c],R=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&u.push(c),(R===void 0||t.scopes===void 0||t.scopes.includes(R))&&(t.skipRestricted&&S?.restricted||(a[c]=r[c]))}return{raw:a,restricted:u}}toOverrides(r,s){const n=[];for(const t of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(t)){const a={};for(const u in r[t])a[u]=r[t][u];n.push({identifiers:(0,k.overrideIdentifiersFromKey)(t),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,s)})}return n}}e.ConfigurationModelParser=m;class v extends P.Disposable{constructor(r,s,n,t){super();this.userSettingsResource=r,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class g{constructor(r,s,n=new T,t=new T,a=new I.ResourceMap,u=new T,c=new I.ResourceMap,S=!0){this._defaultConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=c,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(r,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(r)}updateValue(r,s,n={}){let t;n.resource?(t=this._memoryConfigurationByResource.get(n.resource),t||(t=new T,this._memoryConfigurationByResource.set(n.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(r):t.setValue(r,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,s,n){const t=this.getConsolidateConfigurationModel(s,n),a=this.getFolderConfigurationModelForResource(s.resource,n),u=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,c=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),S=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,p=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,U=s.overrideIdentifier?u.override(s.overrideIdentifier).getValue(r):u.getValue(r),B=t.getValue(r),z=d.distinct(d.flatten(t.overrides.map(re=>re.identifiers))).filter(re=>t.getOverrideValue(r,re)!==void 0);return{defaultValue:c,userValue:S,userLocalValue:R,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:p,memoryValue:U,value:B,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:a?.freeze().getValue(r),override:s.overrideIdentifier?a?.freeze().getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:u.getValue(r),override:s.overrideIdentifier?u.getOverrideValue(r,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const s=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,s){this._folderConfigurations.set(r,s),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const n=[];if(!s){const{added:t,updated:a,removed:u}=f(this._defaultConfiguration,r);s=[...t,...a,...u]}for(const t of s)for(const a of(0,k.overrideIdentifiersFromKey)(t)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),c=r.getKeysForOverrideIdentifier(a),S=[...c.filter(R=>u.indexOf(R)===-1),...u.filter(R=>c.indexOf(R)===-1),...u.filter(R=>!D.equals(this._defaultConfiguration.override(a).getValue(R),r.override(a).getValue(R)))];n.push([a,S])}return this.updateDefaultConfiguration(r),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=f(this.localUserConfiguration,r),u=[...s,...n,...t];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=f(this.remoteUserConfiguration,r);let u=[...s,...n,...t];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:n,removed:t,overrides:a}=f(this.workspaceConfiguration,r);let u=[...s,...n,...t];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(r,s){const n=this.folderConfigurations.get(r),{added:t,updated:a,removed:u,overrides:c}=f(n,s);let S=[...t,...a,...u];return(S.length||!n)&&this.updateFolderConfiguration(r,s),{keys:S,overrides:c}}compareAndDeleteFolderConfiguration(r){const s=this.folderConfigurations.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:t,removed:a,overrides:u}=f(s,void 0);return{keys:[...n,...t,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,s){let n=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier?n.override(r.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:r},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&r){const t=s.getFolder(r);t&&(n=this.getFolderConsolidatedConfiguration(t.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let s=this._foldersConsolidatedConfigurations.get(r);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(s=n.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(r,s)):s=n}return s}getFolderConfigurationModelForResource(r,s){if(s&&r){const n=s.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,s)=>{const{contents:n,overrides:t,keys:a}=this._folderConfigurations.get(s);return r.push([s,{contents:n,overrides:t,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>r.add(s)),this.userConfiguration.freeze().keys.forEach(s=>r.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(t=>s.add(t))),[...s.values()]}static parse(r){const s=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((u,c)=>(u.set(A.URI.revive(c[0]),this.parseConfigurationModel(c[1])),u),new I.ResourceMap);return new g(s,n,new T,t,a,new T,new I.ResourceMap,!1)}static parseConfigurationModel(r){return new T(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=g;function E(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const r=new Set,s=new Map;for(const t of w)t.keys.forEach(a=>r.add(a)),t.overrides.forEach(([a,u])=>{const c=(0,I.getOrSet)(s,a,new Set);u.forEach(S=>c.add(S))});const n=[];return s.forEach((t,a)=>n.push([a,[...t.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=E;class h{constructor(r,s,n,t){this.change=r,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(c=>a.add(c)),r.overrides.forEach(([,c])=>c.forEach(S=>a.add(S))),this.affectedKeys=[...a.values()];const u=new T;this.affectedKeys.forEach(c=>u.setValue(c,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,s,this.currentWorkspace);return!D.equals(n,t)}return!0}return!1}doesAffectedKeysTreeContains(r,s){let n=(0,L.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof n=="object"&&(t=Object.keys(n)[0]);){if(r=r[t],!r)return!1;n=n[t]}return!0}}e.ConfigurationChangeEvent=h;class l extends h{constructor(r,s,n,t){super({keys:r.allKeys(),overrides:[]},void 0,r,s);this.source=n,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=l;function f(w,r){const{added:s,removed:n,updated:t}=o(r,w),a=[],u=w?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const S=c.filter(R=>!u.includes(R));for(const R of S)a.push([R,r.getKeysForOverrideIdentifier(R)])}if(w){const S=u.filter(R=>!c.includes(R));for(const R of S)a.push([R,w.getKeysForOverrideIdentifier(R)])}if(r&&w){for(const S of u)if(c.includes(S)){const R=o({contents:w.getOverrideValue(void 0,S)||{},keys:w.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});a.push([S,[...R.added,...R.removed,...R.updated]])}}return{added:s,removed:n,updated:t,overrides:a}}function o(w,r){const s=w?r?w.keys.filter(a=>r.keys.indexOf(a)===-1):[...w.keys]:[],n=r?w?r.keys.filter(a=>w.keys.indexOf(a)===-1):[...r.keys]:[],t=[];if(w&&r){for(const a of r.keys)if(w.keys.indexOf(a)!==-1){const u=(0,L.getConfigurationValue)(r.contents,a),c=(0,L.getConfigurationValue)(w.contents,a);D.equals(u,c)||t.push(a)}}return{added:s,removed:n,updated:t}}}),define(Ie[120],ke([1,0,11,4]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var C;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends d.ErrorNoTelemetry{constructor(D,b=C.Unknown,A){super(D);this._message=D,this._code=b,this._detail=A,this.isHandled=b===C.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===C.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===C.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}}e.RemoteAuthorityResolverError=P}),define(Ie[121],ke([1,0,10]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(I){return I.scheme===d.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=i;function C(I){if(!I)return;const D=I.indexOf("+");return D<0?I:I.substr(0,D)}e.getRemoteName=C;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P}),define(Ie[28],ke([1,0,8,4,121]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(T){if(typeof T=="object"&&T!==null&&T.supported!==!0)return T.description}e.getWorkspaceSupportTypeMessage=P;function I(T){return T&&typeof T=="object"&&typeof T.id=="string"&&(!T.uuid||typeof T.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(T){T[T.System=0]="System",T[T.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var b;(function(T){T.WIN32_X64="win32-x64",T.WIN32_IA32="win32-ia32",T.WIN32_ARM64="win32-arm64",T.LINUX_X64="linux-x64",T.LINUX_ARM64="linux-arm64",T.LINUX_ARMHF="linux-armhf",T.ALPINE_X64="alpine-x64",T.ALPINE_ARM64="alpine-arm64",T.DARWIN_X64="darwin-x64",T.DARWIN_ARM64="darwin-arm64",T.WEB="web",T.UNIVERSAL="universal",T.UNKNOWN="unknown",T.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class A{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,m){if(typeof _=="undefined"||_===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof _=="string"||typeof m=="string"){let v=typeof _=="string"?_:_.value,g=typeof m=="string"?m:m.value;return d.equalsIgnoreCase(v,g)}return _._lower===m._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=A;function L(T){return T.contributes&&T.contributes.localizations?T.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function k(T){return T.contributes&&T.contributes.authentication?T.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=k;function y(T,_){if(_){const m=`onResolveRemoteAuthority:${(0,C.getRemoteName)(_)}`;return T.activationEvents?.indexOf(m)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[199],ke([1,0,8,115,28,12,2,11,40]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,d.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=A;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new k(s.identifier,n,t)}static parse(s){const n=L.exec(s);return n&&n[1]&&n[2]?new k({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof k?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=k;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(r){const s=y.exec(r);return s&&s[1]?[m(s[1]),s[2]]:[m(r),void 0]}e.getIdAndVersion=T;function _(r,s){return`${r}.${s}`}e.getExtensionId=_;function m(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=m;function v(r,s){return m(_(r,s))}e.getGalleryExtensionId=v;function g(r,s){const n=[],t=a=>{for(const u of n)if(u.some(c=>A(s(c),s(a))))return u;return null};for(const a of r){const u=t(a);u?u.push(a):n.push([a])}return n}e.groupByExtension=g;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function h(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function l(r){const s=new Set;if(r.malicious)for(const n of r.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=l;function f(r,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const a=t.shift();if(a&&n.every(u=>!A(u.identifier,{id:a}))){const u=r.filter(c=>A(c.identifier,{id:a}));u.length===1&&(n.push(u[0]),t.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=f;async function o(r,s){if(!P.isLinux)return!1;let n;try{n=(await r.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function w(r,s){const n=await o(r,s),t=(0,i.getTargetPlatform)(n?"alpine":P.platform,b.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=w}),define(Ie[200],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d{constructor(){this.validators=new Map}vsda(){return new Promise((C,P)=>Y(["vsda"],C,P))}async createNewMessage(C){try{const P=await this.vsda(),I=new P.validator;if(I){const D=String(d._nextId++);return this.validators.set(D,I),{id:D,data:I.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,P){if(!C.id)return!0;const I=this.validators.get(C.id);if(!I)return!1;this.validators.delete(C.id);try{return I.validate(P)==="ok"}catch{return!1}}async sign(C){try{const P=await this.vsda(),I=new P.signer;if(I)return I.sign(C)}catch{}return C}}e.SignService=d,d._nextId=1}),define(Ie[201],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,P,I=5){let D;return D=P(b=>{const A=typeof b=="string"?b:b.data;let L=this._terminalBufferMap.get(C);if(L){L.data.push(A);return}const k=setTimeout(()=>this.flushBuffer(C),I);L={data:[A],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),D.dispose()}},this._terminalBufferMap.set(C,L)}),D}stopBuffering(C){const P=this._terminalBufferMap.get(C);P&&P.dispose()}flushBuffer(C){const P=this._terminalBufferMap.get(C);P&&(this._terminalBufferMap.delete(C),this._callback(C,P.data.join("")))}}e.TerminalDataBufferer=d}),define(Ie[202],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var d;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(d=e.ColorScheme||(e.ColorScheme={}));function i(P){return P===d.HIGH_CONTRAST_DARK||P===d.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function C(P){return P===d.DARK||P===d.HIGH_CONTRAST_DARK}e.isDark=C}),define(Ie[85],ke([1,0,77,3,6,4,44,202]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var b;(function(v){function g(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=g})(b=e.ThemeColor||(e.ThemeColor={}));function A(v){return{id:v}}e.themeColorFromId=A;var L;(function(v){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||b.isThemeColor(s.color))}v.isThemeIcon=g;const E=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function h(s){const n=E.exec(s);if(!n)return;let[,t]=n;return{id:t}}v.fromString=h;function l(s){return{id:s}}v.fromId=l;function f(s,n){let t=s.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),n&&(t=`${t}~${n}`),{id:t}}v.modify=f;function o(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}v.getModifier=o;function w(s,n){return s.id===n.id&&s.color?.id===n.color?.id}v.isEqual=w;function r(s,n){return{id:s.id,color:n?A(n):void 0}}v.asThemeIcon=r,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function k(v){switch(v){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,C.toDisposable)(()=>{const E=this.themingParticipants.indexOf(g);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let T=new y;I.Registry.add(e.Extensions.ThemingContribution,T);function _(v){return T.onColorThemeChange(v)}e.registerThemingParticipant=_;class m extends C.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,E){let h=this.theme.getColor(g);return h&&E&&(h=E(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(Ie[122],ke([1,0,3,12,4,13]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var I;(function(_){_.Http="http",_.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(_){_.ConstantPrivate="constantPrivate",_.Private="private",_.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(_){_[_.Notify=1]="Notify",_[_.OpenBrowser=2]="OpenBrowser",_[_.OpenPreview=3]="OpenPreview",_[_.Silent=4]="Silent",_[_.Ignore=5]="Ignore",_[_.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(_){if(_.scheme!=="http"&&_.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(_.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(_){return e.LOCALHOST_ADDRESSES.indexOf(_)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(_){return e.ALL_INTERFACES_ADDRESSES.indexOf(_)>=0}e.isAllInterfaces=k;function y(_,m){return m?m!==1&&_<1024:!i.isWindows&&_<1024}e.isPortPrivileged=y;let T=class{constructor(m){this.logService=m,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],v=Array.from(this._tunnels.values());for(let g of v){const E=Array.from(g.values());for(let h of E){const l=await h.value;l&&m.push(l)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:v}of m.values())await v.then(g=>g?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,v,g,E,h=!1,l,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${g} on local port ${E}.`),!m)return;v||(v="localhost");const o=this.retainOrCreateTunnel(m,v,g,E,h,l,f);return o?o.then(w=>{if(!w){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(w);return(w.tunnelRemoteHost!==v||w.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const v=this._tunnels.get(m.tunnelRemoteHost);if(v){const g=v.get(m.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,g))}}}}async tryDisposeTunnel(m,v,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${v}.`);const E=g.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(v),E}}async closeTunnel(m,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${v} `);const g=this._tunnels.get(m);if(g&&g.has(v)){const E=g.get(v);E.refcount=0,await this.tryDisposeTunnel(m,v,E)}}addTunnelToMap(m,v,g){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(v,{refcount:1,value:g})}async removeEmptyTunnelFromMap(m,v){const g=this._tunnels.get(m);g&&(await g.get(v)||g.delete(v),g.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,v){let g=[m];L(m)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):k(m)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(h=>this._tunnels.get(h));for(const h of E){const l=h?.get(v);if(l)return l}}canTunnel(m){return!!A(m)}createWithProvider(m,v,g,E,h,l,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${g} on local port ${E}.`);const w={elevationRequired:h?y(E===void 0?g:E):!1},r={remoteAddress:{host:v,port:g},localAddressPort:E,privacy:l,public:l?l!==D.Private:void 0,protocol:f},s=m.forwardPort(r,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,g,s),s}};T=Ve([$e(0,P.ILogService)],T),e.AbstractTunnelService=T}),define(Ie[203],ke([1,0,10]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function i(b){return b.scheme!==d.Schemas.file&&b.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=i;function C(b){if(b.folders.length)return b.folders.every(A=>i(A.uri))?b.folders[0].uri:void 0;if(b.configuration&&i(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=C;function P(b){return C(b)?.scheme}e.getVirtualWorkspaceScheme=P;function I(b){return C(b)?.authority}e.getVirtualWorkspaceAuthority=I;function D(b){return C(b)!==void 0}e.isVirtualWorkspace=D}),define(Ie[45],ke([1,0,170,9,24,22,2,4,10]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function A(r){const s=r;return typeof s?.id=="string"&&I.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=A;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function k(r){const s=r;return typeof s?.id=="string"&&I.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=k;function y(r){const s=r;if(s?.uri)return{id:s.id,uri:I.URI.revive(s.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:I.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=y;var T;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function _(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=_;function m(r){const s=r;return!!(s&&typeof s=="object"&&I.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=m;class v{constructor(s,n,t,a,u){this._id=s,this._transient=t,this._configuration=a,this._ignorePathCasing=u,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class g{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,P.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(r){return new g({uri:r,index:0,name:(0,P.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,d.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(r,s){return P.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function f(r){let s;return I.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=f;function o(r,s){return!l(r,s)&&!f(r)}e.isSavedWorkspace=o;function w(r){return(typeof r=="string"?(0,i.extname)(r):(0,P.extname)(r))===h}e.hasWorkspaceFileExtension=w}),define(Ie[86],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const P=this._idPool++;return this._data.set(P,C),this.logDebugInfo(),P}get(C,P){return this._data.has(C)?this._data.get(C)[P]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(Ie[46],ke([1,0,10,22,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(D=>{const b=this._providerInfo.get(D.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(D,b){b===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,b)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(Ie[204],ke([1,0,17]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(I,D,b){this._deferredPromises=new Map,this._id=I,this._shared=D,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of A.values())L.complete()}catch(L){for(const k of A.values())k.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,D){let b=this._value[I];return typeof b=="undefined"&&(b=D),b}update(I,D){this._value[I]=D;let b=this._deferredPromises.get(I);if(b!==void 0)return b.p;const A=new d.DeferredPromise;return this._deferredPromises.set(I,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class C extends i{constructor(I,D){super(I.identifier.value,!0,D);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=C}),define(Ie[205],ke([1,0,3,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new d.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,D,b,A){const k=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptModelChanged(D.value,b,A);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Ie[18],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class i{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[206],ke([1,0,28,3]),function(Y,e,d,i){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(D,b){C.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(D.identifier),et(this,C,b,"f"),Ue(this,C,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(D){return Ue(this,C,"f").get(this._id,D)}store(D,b){return Ue(this,C,"f").store(this._id,D,b)}delete(D){return Ue(this,C,"f").delete(this._id,D)}}e.ExtensionSecrets=P,C=new WeakMap}),define(Ie[123],ke([1,0,4,3]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new i.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,D){this._level=I,this._productConfig=D||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(Ie[51],ke([1,0,4,122,3,18]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(b){function A(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:k.protocol}}b.fromApiTunnel=A;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==i.TunnelPrivacyId.ConstantPrivate&&k.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}b.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let D=class{constructor(A){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,L){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,L){return{dispose:()=>{}}}async $providePortAttributes(A,L,k,y,T){return[]}async $forwardPort(A,L){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=Ve([$e(0,P.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[7],ke([1,0,16,11,101,24,94,8,14,2,35,42,120]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";var T,_,m,v,g,E,h,l,f,o,w,r,s,n,t,a,u,c,S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(x){function W(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(W,x),Object.setPrototypeOf(W.prototype,x.prototype),W}let N=g=class{constructor(W){T.set(this,void 0),et(this,T,W,"f")}static from(...W){let de=W;return new g(function(){if(de){for(const Oe of de)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();de=void 0}})}dispose(){typeof Ue(this,T,"f")=="function"&&(Ue(this,T,"f").call(this),et(this,T,void 0,"f"))}};T=new WeakMap,N=g=Ve([O],N),e.Disposable=N;let p=E=class{constructor(W,de){if(W<0)throw(0,i.illegalArgument)("line must be non-negative");if(de<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=W,this._character=de}static Min(...W){if(W.length===0)throw new TypeError;let de=W[0];for(let Oe=1;Oe<W.length;Oe++){const Je=W[Oe];Je.isBefore(de)&&(de=Je)}return de}static Max(...W){if(W.length===0)throw new TypeError;let de=W[0];for(let Oe=1;Oe<W.length;Oe++){const Je=W[Oe];Je.isAfter(de)&&(de=Je)}return de}static isPosition(W){if(!W)return!1;if(W instanceof E)return!0;let{line:de,character:Oe}=W;return typeof de=="number"&&typeof Oe=="number"}static of(W){if(W instanceof E)return W;if(this.isPosition(W))return new E(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,de=0){if(W===null||de===null)throw(0,i.illegalArgument)();let Oe;return typeof W=="undefined"?Oe=0:typeof W=="number"?Oe=W:(Oe=typeof W.lineDelta=="number"?W.lineDelta:0,de=typeof W.characterDelta=="number"?W.characterDelta:0),Oe===0&&de===0?this:new E(this.line+Oe,this.character+de)}with(W,de=this.character){if(W===null||de===null)throw(0,i.illegalArgument)();let Oe;return typeof W=="undefined"?Oe=this.line:typeof W=="number"?Oe=W:(Oe=typeof W.line=="number"?W.line:this.line,de=typeof W.character=="number"?W.character:this.character),Oe===this.line&&de===this.character?this:new E(Oe,de)}toJSON(){return{line:this.line,character:this.character}}};p=E=Ve([O],p),e.Position=p;let U=h=class{constructor(W,de,Oe,Je){let it,at;if(typeof W=="number"&&typeof de=="number"&&typeof Oe=="number"&&typeof Je=="number"?(it=new p(W,de),at=new p(Oe,Je)):p.isPosition(W)&&p.isPosition(de)&&(it=p.of(W),at=p.of(de)),!it||!at)throw new Error("Invalid arguments");it.isBefore(at)?(this._start=it,this._end=at):(this._start=at,this._end=it)}static isRange(W){return W instanceof h?!0:W?p.isPosition(W.start)&&p.isPosition(W.end):!1}static of(W){if(W instanceof h)return W;if(this.isRange(W))return new h(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return h.isRange(W)?this.contains(W.start)&&this.contains(W.end):p.isPosition(W)?!(p.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const de=p.Max(W.start,this._start),Oe=p.Min(W.end,this._end);if(!de.isAfter(Oe))return new h(de,Oe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const de=p.Min(W.start,this._start),Oe=p.Max(W.end,this.end);return new h(de,Oe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,de=this.end){if(W===null||de===null)throw(0,i.illegalArgument)();let Oe;return W?p.isPosition(W)?Oe=W:(Oe=W.start||this.start,de=W.end||this.end):Oe=this.start,Oe.isEqual(this._start)&&de.isEqual(this.end)?this:new h(Oe,de)}toJSON(){return[this.start,this.end]}};U=h=Ve([O],U),e.Range=U;let B=l=class extends U{constructor(W,de,Oe,Je){let it,at;if(typeof W=="number"&&typeof de=="number"&&typeof Oe=="number"&&typeof Je=="number"?(it=new p(W,de),at=new p(Oe,Je)):p.isPosition(W)&&p.isPosition(de)&&(it=p.of(W),at=p.of(de)),!it||!at)throw new Error("Invalid arguments");super(it,at);this._anchor=it,this._active=at}static isSelection(W){return W instanceof l?!0:W?U.isRange(W)&&p.isPosition(W.anchor)&&p.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=l=Ve([O],B),e.Selection=B;class z{constructor(W,de,Oe){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("host");if(typeof de!="number"||de===0||Math.round(de)!==de)throw(0,i.illegalArgument)("port");if(typeof Oe!="undefined"&&(typeof Oe!="string"||Oe.length===0||!/^[0-9A-Za-z\-]+$/.test(Oe)))throw(0,i.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(de),this.connectionToken=Oe}}e.ResolvedAuthority=z;class re extends Error{constructor(W,de=y.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(W);this._message=W,this._code=de,this._detail=Oe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(W,de){return new re(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,de)}static TemporarilyNotAvailable(W){return new re(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var H;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var M;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=f=class{constructor(W,de){this._range=W,this._newText=de}static isTextEdit(W){return W instanceof f?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,de){return new f(W,de)}static insert(W,de){return f.replace(new U(W,W),de)}static delete(W){return f.replace(W,"")}static setEndOfLine(W){const de=new f(new U(new p(0,0),new p(0,0)),"");return de.newEol=W,de}get range(){return this._range}set range(W){if(W&&!U.isRange(W))throw(0,i.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,i.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,i.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=f=Ve([O],j),e.TextEdit=j;class V{constructor(W,de){this.range=W,this.snippet=de}}e.SnippetTextEdit=V;var q;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,de,Oe,Je){this._edits.push({_type:1,from:W,to:de,options:Oe,metadata:Je})}createFile(W,de,Oe){this._edits.push({_type:1,from:void 0,to:W,options:de,metadata:Oe})}deleteFile(W,de,Oe){this._edits.push({_type:1,from:W,to:void 0,options:de,metadata:Oe})}replaceNotebookMetadata(W,de,Oe){this._edits.push({_type:3,metadata:Oe,uri:W,edit:{editType:5,metadata:de},notebookMetadata:de})}replaceNotebookCells(W,de,Oe,Je,it){let at,ct,Ct=[],Tt;if(gt.isNotebookRange(de)&&jt.isNotebookCellDataArray(Oe)&&!jt.isNotebookCellDataArray(Je)?(at=de.start,ct=de.end,Ct=Oe,Tt=Je):typeof de=="number"&&typeof Oe=="number"&&jt.isNotebookCellDataArray(Je)&&(at=de,ct=Oe,Ct=Je,Tt=it),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:W,index:at,count:ct-at,cells:Ct,metadata:Tt})}replaceNotebookCellMetadata(W,de,Oe,Je){this._edits.push({_type:3,metadata:Je,uri:W,edit:{editType:8,index:de,metadata:Oe}})}replace(W,de,Oe,Je){this._edits.push({_type:2,uri:W,edit:new j(de,Oe),metadata:Je})}insert(W,de,Oe,Je){this.replace(W,new U(de,de),Oe,Je)}delete(W,de,Oe){this.replace(W,de,"",Oe)}has(W){return this._edits.some(de=>de._type===2&&de.uri.toString()===W.toString())}set(W,de){if(de)for(const Oe of de)Oe&&this._edits.push({_type:2,uri:W,edit:Oe});else{for(let Oe=0;Oe<this._edits.length;Oe++){const Je=this._edits[Oe];Je._type===2&&Je.uri.toString()===W.toString()&&(this._edits[Oe]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(W){const de=[];for(let Oe of this._edits)Oe._type===2&&Oe.uri.toString()===W.toString()&&de.push(Oe.edit);return de}entries(){const W=new P.ResourceMap;for(let de of this._edits)if(de._type===2){let Oe=W.get(de.uri);Oe||(Oe=[de.uri,[]],W.set(de.uri,Oe)),Oe[1].push(de.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Ve([O],ie),e.WorkspaceEdit=ie;let Q=o=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,de=this._tabstop++){if(typeof W=="function"){const Oe=new o;Oe._tabstop=this._tabstop,W(Oe),this._tabstop=Oe._tabstop,W=Oe.value}else W=o._escape(W);return this.value+="${",this.value+=de,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,de=this._tabstop++){const Oe=W.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=de,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(W,de){if(typeof de=="function"){const Oe=new o;Oe._tabstop=this._tabstop,de(Oe),this._tabstop=Oe._tabstop,de=Oe.value}else typeof de=="string"&&(de=de.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,de&&(this.value+=":",this.value+=de),this.value+="}",this}};Q=o=Ve([O],Q),e.SnippetString=Q;var ue;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ue=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=w=class{constructor(W,de){if(this.uri=W,de)if(U.isRange(de))this.range=U.of(de);else if(p.isPosition(de))this.range=new U(de,de);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof w?!0:W?U.isRange(W.range)&&A.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=w=Ve([O],G),e.Location=G;let ge=class{constructor(W,de){this.location=W,this.message=de}static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&A.URI.isUri(W.location.uri):!1}static isEqual(W,de){return W===de?!0:!W||!de?!1:W.message===de.message&&W.location.range.isEqual(de.location.range)&&W.location.uri.toString()===de.location.uri.toString()}};ge=Ve([O],ge),e.DiagnosticRelatedInformation=ge;let ne=class{constructor(W,de,Oe=ce.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!de)throw new TypeError("message must be set");this.range=W,this.message=de,this.severity=Oe}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,de){return W===de?!0:!W||!de?!1:W.message===de.message&&W.severity===de.severity&&W.code===de.code&&W.severity===de.severity&&W.source===de.source&&W.range.isEqual(de.range)&&(0,d.equals)(W.tags,de.tags)&&(0,d.equals)(W.relatedInformation,de.relatedInformation,ge.isEqual)}};ne=Ve([O],ne),e.Diagnostic=ne;let he=class{constructor(W,de){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=de}};he=Ve([O],he),e.Hover=he;var Se;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(W,de=Se.Text){this.range=W,this.kind=de}toJSON(){return{range:this.range,kind:Se[this.kind]}}};Re=Ve([O],Re),e.DocumentHighlight=Re;var ve;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ve=e.SymbolKind||(e.SymbolKind={}));var Te;(function(x){x[x.Deprecated=1]="Deprecated"})(Te=e.SymbolTag||(e.SymbolTag={}));let Ae=r=class{constructor(W,de,Oe,Je,it){this.name=W,this.kind=de,this.containerName=it,typeof Oe=="string"&&(this.containerName=Oe),Je instanceof G?this.location=Je:Oe instanceof U&&(this.location=new G(Je,Oe)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ve[this.kind],location:this.location,containerName:this.containerName}}};Ae=r=Ve([O],Ae),e.SymbolInformation=Ae;let le=s=class{constructor(W,de,Oe,Je,it){this.name=W,this.detail=de,this.kind=Oe,this.range=Je,this.selectionRange=it,this.children=[],s.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(s.validate)}};le=s=Ve([O],le),e.DocumentSymbol=le;var pe;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor(W,de){this.title=W,this.kind=de}};ee=Ve([O],ee),e.CodeAction=ee;let te=n=class{constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.sep)}};te.sep=".",te=n=Ve([O],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let F=class{constructor(W,de){if(this.range=W,this.parent=de,de&&!de.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};F=Ve([O],F),e.SelectionRange=F;class ${constructor(W,de,Oe,Je,it,at){this.kind=W,this.name=de,this.detail=Oe,this.uri=Je,this.range=it,this.selectionRange=at}}e.CallHierarchyItem=$;class K{constructor(W,de){this.fromRanges=de,this.from=W}}e.CallHierarchyIncomingCall=K;class X{constructor(W,de){this.fromRanges=de,this.to=W}}e.CallHierarchyOutgoingCall=X;var me;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(me=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ee=class{constructor(W,de){this.range=W,this.command=de}get isResolved(){return!!this.command}};Ee=Ve([O],Ee),e.CodeLens=Ee;let oe=t=class{constructor(W,de=!1){_.set(this,void 0),et(this,_,new C.MarkdownString(W,{supportThemeIcons:de}),"f")}static isMarkdownString(W){return W instanceof t?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ue(this,_,"f").value}set value(W){Ue(this,_,"f").value=W}get isTrusted(){return Ue(this,_,"f").isTrusted}set isTrusted(W){Ue(this,_,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,_,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,_,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,_,"f").supportHtml}set supportHtml(W){Ue(this,_,"f").supportHtml=W}get baseUri(){return Ue(this,_,"f").baseUri}set baseUri(W){Ue(this,_,"f").baseUri=W}appendText(W){return Ue(this,_,"f").appendText(W),this}appendMarkdown(W){return Ue(this,_,"f").appendMarkdown(W),this}appendCodeblock(W,de){return Ue(this,_,"f").appendCodeblock(de??"",W),this}};_=new WeakMap,oe=t=Ve([O],oe),e.MarkdownString=oe;let De=class{constructor(W,de){this.label=W,this.documentation=de}};De=Ve([O],De),e.ParameterInformation=De;let Ce=class{constructor(W,de){this.label=W,this.documentation=de,this.parameters=[]}};Ce=Ve([O],Ce),e.SignatureInformation=Ce;let We=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};We=Ve([O],We),e.SignatureHelp=We;var je;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(W){this.value=W}};Ye=Ve([O],Ye),e.InlayHintLabelPart=Ye;let J=class{constructor(W,de,Oe){this.position=W,this.label=de,this.kind=Oe}};J=Ve([O],J),e.InlayHint=J;var se;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _e;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(_e=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(x){x[x.Deprecated=1]="Deprecated"})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(W,de){this.label=W,this.kind=de}toJSON(){return{label:this.label,kind:this.kind&&_e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=Ve([O],ye),e.CompletionItem=ye;let Ne=class{constructor(W=[],de=!1){this.items=W,this.isIncomplete=de}};Ne=Ve([O],Ne),e.CompletionList=Ne;let He=class{constructor(W,de,Oe){this.insertText=W,this.range=de,this.command=Oe}};He=Ve([O],He),e.InlineSuggestion=He;let qe=class{constructor(W){this.commands=void 0,this.items=W}};qe=Ve([O],qe),e.InlineSuggestionList=qe;let Ge=class{constructor(W,de,Oe){this.insertText=W,this.range=de,this.command=Oe}};Ge=Ve([O],Ge),e.InlineSuggestionNew=Ge;let Ze=class{constructor(W,de){this.items=W,this.commands=de}};Ze=Ve([O],Ze),e.InlineSuggestionsNew=Ze;var Xe;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var rt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var tt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ut;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Pt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Pt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Nt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(de){switch(de){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let yt=class{constructor(W,de){if(de&&!A.URI.isUri(de))throw(0,i.illegalArgument)("target");if(!U.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.target=de}};yt=Ve([O],yt),e.DocumentLink=yt;let ft=class{constructor(W,de,Oe,Je){this.red=W,this.green=de,this.blue=Oe,this.alpha=Je}};ft=Ve([O],ft),e.Color=ft;let Dt=class{constructor(W,de){if(de&&!(de instanceof ft))throw(0,i.illegalArgument)("color");if(!U.isRange(W)||W.isEmpty)throw(0,i.illegalArgument)("range");this.range=W,this.color=de}};Dt=Ve([O],Dt),e.ColorInformation=Dt;let At=class{constructor(W){if(!W||typeof W!="string")throw(0,i.illegalArgument)("label");this.label=W}};At=Ve([O],At),e.ColorPresentation=At;var Ft;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var Ke;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class zt{constructor(W,de,Oe){if(this.startIndex=W,this.length=de,this.tooltip=Oe,typeof W!="number"||W<0)throw(0,i.illegalArgument)("startIndex");if(typeof de!="number"||de<1)throw(0,i.illegalArgument)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=zt;var Rt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Rt=e.TerminalLocation||(e.TerminalLocation={}));class Mt{constructor(W){if(this.options=W,typeof W!="object")throw(0,i.illegalArgument)("options")}}e.TerminalProfile=Mt;var Pe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Le;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Le=e.TaskPanelKind||(e.TaskPanelKind={}));let we=a=class{constructor(W,de){if(this.label=de,typeof W!="string"||typeof de!="string")throw(0,i.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};we.Clean=new a("clean","Clean"),we.Build=new a("build","Build"),we.Rebuild=new a("rebuild","Rebuild"),we.Test=new a("test","Test"),we=a=Ve([O],we),e.TaskGroup=we;function Z(x){let W="";for(let de=0;de<x.length;de++)W+=x[de].replace(/,/g,",,")+",";return W}let Me=class{constructor(W,de,Oe){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=W,de!==void 0&&(Array.isArray(de)?(this._args=de,this._options=Oe):this._options=de)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,i.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let de of this._args)W.push(de);return Z(W)}};Me=Ve([O],Me),e.ProcessExecution=Me;let xe=class{constructor(W,de,Oe){if(this._args=[],Array.isArray(de)){if(!W)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W,this._args=de,this._options=Oe}else{if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W,this._options=de}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,i.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let de of this._args)W.push(typeof de=="string"?de:de.value);return Z(W)}};xe=Ve([O],xe),e.ShellExecution=xe;var st;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(st=e.ShellQuoting||(e.ShellQuoting={}));var Qe;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Qe=e.TaskScope||(e.TaskScope={}));class lt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=lt;let dt=u=class{constructor(W,de,Oe,Je,it,at){this.__deprecated=!1,this._definition=this.definition=W;let ct;typeof de=="string"?(this._name=this.name=de,this._source=this.source=Oe,this.execution=Je,ct=it,this.__deprecated=!0):de===Qe.Global||de===Qe.Workspace?(this.target=de,this._name=this.name=Oe,this._source=this.source=Je,this.execution=it,ct=at):(this.target=de,this._name=this.name=Oe,this._source=this.source=Je,this.execution=it,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Me?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const de=this._definition.type;(u.EmptyType===de||u.ProcessType===de||u.ShellType===de||u.ExtensionCallbackType===de)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=u=Ve([O],dt),e.Task=dt;var vt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(W,de=mt.None){this.collapsibleState=de,A.URI.isUri(W)?this.resourceUri=W:this.label=W}};_t=Ve([O],_t),e.TreeItem=_t;var mt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};wt=Ve([O],wt),e.DataTransferItem=wt;let Lt=class{constructor(){this._items=new Map}get(W){return this._items.get(W)}set(W,de){this._items.set(W,de)}forEach(W){this._items.forEach(W)}};Lt=Ve([O],Lt),e.DataTransfer=Lt;let bt=class{constructor(W,de){this.id=W,this.color=de}};bt=Ve([O],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Kt=class{constructor(W){this.id=W}};Kt=Ve([O],Kt),e.ThemeColor=Kt;var Qt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Et=class{constructor(W,de){if(typeof W!="string"&&(!W||!A.URI.isUri(W)&&!A.URI.isUri(W.uri)))throw(0,i.illegalArgument)("base");if(typeof de!="string")throw(0,i.illegalArgument)("pattern");typeof W=="string"?this.baseUri=A.URI.file(W):A.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=de}get base(){return this._base}set base(W){this._base=W,this._baseUri=A.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Et=Ve([O],Et),e.RelativePattern=Et;let $t=class{constructor(W,de,Oe,Je){this.enabled=typeof W=="boolean"?W:!0,typeof de=="string"&&(this.condition=de),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};$t=Ve([O],$t),e.Breakpoint=$t;let Yt=class extends $t{constructor(W,de,Oe,Je,it){super(de,Oe,Je,it);if(W===null)throw(0,i.illegalArgument)("location");this.location=W}};Yt=Ve([O],Yt),e.SourceBreakpoint=Yt;let Jt=class extends $t{constructor(W,de,Oe,Je,it){super(de,Oe,Je,it);this.functionName=W}};Jt=Ve([O],Jt),e.FunctionBreakpoint=Jt;let ci=class extends $t{constructor(W,de,Oe,Je,it,at,ct){super(Je,it,at,ct);if(!de)throw(0,i.illegalArgument)("dataId");this.label=W,this.dataId=de,this.canPersist=Oe}};ci=Ve([O],ci),e.DataBreakpoint=ci;let ui=class{constructor(W,de,Oe){this.command=W,this.args=de||[],this.options=Oe}};ui=Ve([O],ui),e.DebugAdapterExecutable=ui;let kt=class{constructor(W,de){this.port=W,this.host=de}};kt=Ve([O],kt),e.DebugAdapterServer=kt;let Zt=class{constructor(W){this.path=W}};Zt=Ve([O],Zt),e.DebugAdapterNamedPipeServer=Zt;let di=class{constructor(W){this.implementation=W}};di=Ve([O],di),e.DebugAdapterInlineImplementation=di;let Xt=class{constructor(W,de){this.range=W,this.expression=de}};Xt=Ve([O],Xt),e.EvaluatableExpression=Xt;var ei;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(ei=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var ht;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(ht=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let hi=class{constructor(W,de){this.range=W,this.text=de}};hi=Ve([O],hi),e.InlineValueText=hi;let Bt=class{constructor(W,de,Oe=!0){this.range=W,this.variableName=de,this.caseSensitiveLookup=Oe}};Bt=Ve([O],Bt),e.InlineValueVariableLookup=Bt;let xt=class{constructor(W,de){this.range=W,this.expression=de}};xt=Ve([O],xt),e.InlineValueEvaluatableExpression=xt;let ti=class{constructor(W,de){this.frameId=W,this.stoppedLocation=de}};ti=Ve([O],ti),e.InlineValueContext=ti;var Ti;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ti=e.FileChangeType||(e.FileChangeType={}));let ii=c=class extends Error{constructor(W,de=k.FileSystemProviderErrorCode.Unknown,Oe){super(A.URI.isUri(W)?W.toString(!0):W);this.code=Oe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,de),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}static FileExists(W){return new c(W,k.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(W){return new c(W,k.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(W){return new c(W,k.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(W){return new c(W,k.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(W){return new c(W,k.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(W){return new c(W,k.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};ii=c=Ve([O],ii),e.FileSystemError=ii;let fi=class{constructor(W,de,Oe){this.start=W,this.end=de,this.kind=Oe}};fi=Ve([O],fi),e.FoldingRange=fi;var Si;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Pi=e.CommentMode||(e.CommentMode={}));var mi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class gi{constructor(W,de=[]){this.tokenTypes=W,this.tokenModifiers=de}}e.SemanticTokensLegend=gi;function Ai(x){return typeof x=="undefined"||(0,b.isStringArray)(x)}class pi{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let de=0,Oe=W.tokenTypes.length;de<Oe;de++)this._tokenTypeStrToInt.set(W.tokenTypes[de],de);for(let de=0,Oe=W.tokenModifiers.length;de<Oe;de++)this._tokenModifierStrToInt.set(W.tokenModifiers[de],de)}}push(W,de,Oe,Je,it){if(typeof W=="number"&&typeof de=="number"&&typeof Oe=="number"&&typeof Je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(W,de,Oe,Je,it);if(U.isRange(W)&&typeof de=="string"&&Ai(Oe))return this._push(W,de,Oe);throw(0,i.illegalArgument)()}_push(W,de,Oe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(de))throw new Error("`tokenType` is not in the provided legend");const Je=W.start.line,it=W.start.character,at=W.end.character-W.start.character,ct=this._tokenTypeStrToInt.get(de);let Ct=0;if(Oe)for(const Tt of Oe){if(!this._tokenModifierStrToInt.has(Tt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Tt);Ct|=1<<Wt>>>0}this._pushEncoded(Je,it,at,ct,Ct)}_pushEncoded(W,de,Oe,Je,it){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&de<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Tt=0,Wt=0;for(let Ht=0;Ht<Ct;Ht++){let qt=this._data[5*Ht],bi=this._data[5*Ht+1];qt===0?(qt=Tt,bi+=Wt):qt+=Tt,this._data[5*Ht]=qt,this._data[5*Ht+1]=bi,Tt=qt,Wt=bi}}let at=W,ct=de;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Oe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=it,this._prevLine=W,this._prevChar=de}static _sortAndDeltaEncode(W){let de=[];const Oe=W.length/5|0;for(let ct=0;ct<Oe;ct++)de[ct]=ct;de.sort((ct,Ct)=>{const Tt=W[5*ct],Wt=W[5*Ct];if(Tt===Wt){const Ht=W[5*ct+1],qt=W[5*Ct+1];return Ht-qt}return Tt-Wt});const Je=new Uint32Array(W.length);let it=0,at=0;for(let ct=0;ct<Oe;ct++){const Ct=5*de[ct],Tt=W[Ct+0],Wt=W[Ct+1],Ht=W[Ct+2],qt=W[Ct+3],bi=W[Ct+4],Xi=Tt-it,dn=Xi===0?Wt-at:Wt,Ei=5*ct;Je[Ei+0]=Xi,Je[Ei+1]=dn,Je[Ei+2]=Ht,Je[Ei+3]=qt,Je[Ei+4]=bi,it=Tt,at=Wt}return Je}build(W){return this._dataIsSortedAndDeltaEncoded?new Vt(new Uint32Array(this._data),W):new Vt(pi._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=pi;class Vt{constructor(W,de){this.resultId=de,this.data=W}}e.SemanticTokens=Vt;class Ri{constructor(W,de,Oe){this.start=W,this.deleteCount=de,this.data=Oe}}e.SemanticTokensEdit=Ri;class Li{constructor(W,de){this.resultId=de,this.edits=W}}e.SemanticTokensEdits=Li;var Oi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Oi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ri=class{constructor(){}};ri.Back={iconPath:new bt("arrow-left")},ri=Ve([O],ri),e.QuickInputButtons=ri;var vi;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(vi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var _i;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(_i=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ci;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class ze{constructor(W,de,Oe){this.badge=W,this.tooltip=de,this.color=Oe}static validate(W){if(W.badge){let de=(0,D.nextCharLength)(W.badge,0);if(de<W.badge.length&&(de+=(0,D.nextCharLength)(W.badge,de)),W.badge.length>de)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ze;let Ut=class{constructor(W){this.kind=W}};Ut=Ve([O],Ut),e.ColorTheme=Ut;var yi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(yi=e.ColorThemeKind||(e.ColorThemeKind={}));class gt{constructor(W,de){if(W<0)throw(0,i.illegalArgument)("start must be positive");if(de<0)throw(0,i.illegalArgument)("end must be positive");W<=de?(this._start=W,this._end=de):(this._start=de,this._end=W)}static isNotebookRange(W){return W instanceof gt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let de=this._start,Oe=this._end;return W.start!==void 0&&(de=W.start),W.end!==void 0&&(Oe=W.end),de===this._start&&Oe===this._end?this:new gt(de,Oe)}}e.NotebookRange=gt;class jt{constructor(W,de,Oe,Je,it,at,ct){this.kind=W,this.value=de,this.languageId=Oe,this.mime=Je,this.outputs=it??[],this.metadata=at,this.executionSummary=ct,jt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(de=>jt.isNotebookCellData(de))}static isNotebookCellData(W){return!0}}e.NotebookCellData=jt;class Ni{constructor(W){this.cells=W}}e.NotebookData=Ni;class Ot{constructor(W,de){this.data=W,this.mime=de;const Oe=(0,I.normalizeMimeType)(de,!0);if(!Oe)throw new Error(`INVALID mime type: ${de}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}static isNotebookCellOutputItem(W){return W instanceof Ot?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const de={name:W.name,message:W.message,stack:W.stack};return Ot.json(de,"application/vnd.code.notebook.error")}static stdout(W){return Ot.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Ot.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,de="application/octet-stream"){return new Ot(W,de)}static text(W,de=I.Mimes.text){const Oe=Ue(Ot,m,"f",v).encode(String(W));return new Ot(Oe,de)}static json(W,de="text/x-json"){const Oe=JSON.stringify(W,void 0,"	");return Ot.text(Oe,de)}}e.NotebookCellOutputItem=Ot,m=Ot,v={value:new TextEncoder};class si{constructor(W,de,Oe){this.items=si.ensureUniqueMimeTypes(W,!0),typeof de=="string"?(this.id=de,this.metadata=Oe):(this.id=(0,L.generateUuid)(),this.metadata=de??Oe)}static isNotebookCellOutput(W){return W instanceof si?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,b.isArray)(W.items)}static ensureUniqueMimeTypes(W,de=!1){const Oe=new Set,Je=new Set;for(let it=0;it<W.length;it++){const at=W[it],ct=(0,I.normalizeMimeType)(at.mime);if(!Oe.has(ct)){Oe.add(ct);continue}Je.add(it),de&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Je.size===0?W:W.filter((it,at)=>!Je.has(at))}}e.NotebookCellOutput=si;var oi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(oi=e.NotebookCellKind||(e.NotebookCellKind={}));var Fi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Fi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Mi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ui;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ui=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Di{constructor(W,de){this.text=W,this.alignment=de}}e.NotebookCellStatusBarItem=Di;var Bi;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Bi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Wi{constructor(W,de=[]){this.uri=W,this.provides=(0,d.asArray)(de)}}e.NotebookRendererScript=Wi;let wi=class{constructor(W,de){this.label=W,this.timestamp=de}};wi=Ve([O],wi),e.TimelineItem=wi;var zi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(zi=e.ExtensionMode||(e.ExtensionMode={}));var Hi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Hi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var fe;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(fe=e.StandardTokenType||(e.StandardTokenType={}));class be{constructor(W,de){this.ranges=W,this.wordPattern=de}}e.LinkedEditingRanges=be;class Be{constructor(W,de){this._port=W,this._autoForwardAction=de}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Be;var ot;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ot=e.TestResultState||(e.TestResultState={}));var St;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(St=e.TestRunProfileKind||(e.TestRunProfileKind={}));let It=class{constructor(W=void 0,de=void 0,Oe=void 0){this.include=W,this.exclude=de,this.profile=Oe}};It=Ve([O],It),e.TestRunRequest=It;let $i=S=class{constructor(W){this.message=W}static diff(W,de,Oe){const Je=new S(W);return Je.expectedOutput=de,Je.actualOutput=Oe,Je}};$i=S=Ve([O],$i),e.TestMessage=$i;let xi=class{constructor(W){this.id=W}};xi=Ve([O],xi),e.TestTag=xi;let ai=class{constructor(W,de){this.covered=W,this.total=de}};ai=Ve([O],ai),e.CoveredCount=ai;let Vi=R=class{constructor(W,de,Oe,Je){this.uri=W,this.statementCoverage=de,this.branchCoverage=Oe,this.functionCoverage=Je}static fromDetails(W,de){const Oe=new ai(0,0),Je=new ai(0,0),it=new ai(0,0);for(const ct of de)if("branches"in ct){Oe.total+=1,Oe.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)Je.total+=1,Je.covered+=Ct.executionCount>0?1:0}else it.total+=1,it.covered+=ct.executionCount>0?1:0;const at=new R(W,Oe,Je.total>0?Je:void 0,it.total>0?it:void 0);return at.detailedCoverage=de,at}};Vi=R=Ve([O],Vi),e.FileCoverage=Vi;let ji=class{constructor(W,de,Oe=[]){this.executionCount=W,this.location=de,this.branches=Oe}};ji=Ve([O],ji),e.StatementCoverage=ji;let qi=class{constructor(W,de){this.executionCount=W,this.location=de}};qi=Ve([O],qi),e.BranchCoverage=qi;let Gi=class{constructor(W,de){this.executionCount=W,this.location=de}};Gi=Ve([O],Gi),e.FunctionCoverage=Gi;var Zi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var en;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(en=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var tn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(tn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class nn{constructor(W,de,Oe,Je,it,at){this.kind=W,this.name=de,this.detail=Oe,this.uri=Je,this.range=it,this.selectionRange=at}}e.TypeHierarchyItem=nn;class rn{constructor(W){this.uri=W}}e.TextTabInput=rn;class sn{constructor(W,de){this.original=W,this.modified=de}}e.TextDiffTabInput=sn;class on{constructor(W,de){this.uri=W,this.viewType=de}}e.CustomEditorTabInput=on;class an{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=an;class ln{constructor(W,de){this.uri=W,this.notebookType=de}}e.NotebookEditorTabInput=ln;class cn{constructor(W,de,Oe){this.original=W,this.modified=de,this.notebookType=Oe}}e.NotebookDiffEditorTabInput=cn;class un{constructor(){}}e.TerminalEditorTabInput=un}),define(Ie[124],ke([1,0,55,10,8,156,109,7,16]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function L(_,m){m?A.set(_,m):A.delete(_)}e.setWordDefinitionFor=L;function k(_){return A.get(_)}e.getWordDefinitionFor=k;class y extends P.MirrorTextModel{constructor(m,v,g,E,h,l,f,o){super(v,g,E,h);this._proxy=m,this._languageId=l,this._isDirty=f,this.notebook=o,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,b.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===i.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},save(){return m._save()},getText(v){return v?m._getTextInRange(v):m.getText()},get eol(){return m._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(v){return m._lineAt(v)},offsetAt(v){return m._offsetAt(v)},positionAt(v){return m._positionAt(v)},validateRange(v){return m._validateRange(v)},validatePosition(v){return m._validatePosition(v)},getWordRangeAtPosition(v,g){return m._getWordRangeAtPosition(v,g)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,d.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,d.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const v=this._validateRange(m);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const g=this._eol,E=v.start.line,h=v.end.line,l=[];l.push(this._lines[E].substring(v.start.character));for(let f=E+1;f<h;f++)l.push(this._lines[f]);return l.push(this._lines[h].substring(0,v.end.character)),l.join(g)}_lineAt(m){let v;if(m instanceof D.Position?v=m.line:typeof m=="number"&&(v=m),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new T(v,this._lines[v],v===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(m),g=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,g))}_validateRange(m){if(!(m instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(m.start),g=this._validatePosition(m.end);return v===m.start&&g===m.end?m:new D.Range(v.line,v.character,g.line,g.character)}_validatePosition(m){if(!(m instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:v,character:g}=m,E=!1;if(v<0)v=0,g=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,g=this._lines[v].length,E=!0;else{const h=this._lines[v].length;g<0?(g=0,E=!0):g>h&&(g=h,E=!0)}return E?new D.Position(v,g):m}_getWordRangeAtPosition(m,v){const g=this._validatePosition(m);if(!v)v=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,I.getWordAtText)(g.character+1,(0,I.ensureValidWordDefinition)(v),this._lines[g.line],0);if(E)return new D.Range(g.line,E.startColumn-1,g.line,E.endColumn-1)}}e.ExtHostDocumentData=y;class T{constructor(m,v,g){this._line=m,this._text=v,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ie[207],ke([1,0,7,18,3]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(D){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let b;switch(D){case"light":b=d.ColorThemeKind.Light;break;case"hcDark":b=d.ColorThemeKind.HighContrast;break;case"hcLight":b=d.ColorThemeKind.HighContrastLight;break;default:b=d.ColorThemeKind.Dark}this._actual=new d.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ve([$e(0,i.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ie[65],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class i{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=i}),define(Ie[208],ke([1,0,23]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(b){let A=this.buffers.indexOf(b);return A<0&&(A=this.buffers.length,this.buffers.push(b)),A}}function C(D,b){if(b.serializeBuffersForPostMessage){const A=new i,L=(T,_)=>{if(_ instanceof ArrayBuffer){const m=A.add(_);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(_)){const m=P(_);if(m){const v=A.add(_.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:m,byteLength:_.byteLength,byteOffset:_.byteOffset}}}}return _},k=JSON.stringify(D,L),y=A.buffers.map(T=>{const _=new Uint8Array(T);return d.VSBuffer.wrap(_)});return{message:k,buffers:y}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=C;function P(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(D,b){const A=b.map(y=>{const T=new ArrayBuffer(y.byteLength);return new Uint8Array(T).set(y.buffer),T}),L=b.length?(y,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const _=T,{index:m}=_,v=A[m];if(_.view)switch(_.view.type){case 1:return new Int8Array(v,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return T}:void 0;return{message:JSON.parse(D,L),arrayBuffers:A}}e.deserializeWebviewMessage=I}),define(Ie[125],ke([1,0,58,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var C;(function(P){function I(b,A){const L=new Map;return b.types.forEach((k,y)=>{L.set(k,{asString:async()=>b.items[y].asString,asFile:()=>{const T=b.items[y].fileData;if(!!T)return{name:T.name,uri:i.URI.revive(T.uri),data:(0,d.once)(()=>A(y))}},value:void 0})}),L}P.toDataTransfer=I;async function D(b){const A={types:[],items:[]},L=Array.from(b.entries());for(const k of L){A.types.push(k[0]);const y=await k[1].asString(),T=k[1].asFile();A.items.push({asString:y,fileData:T?{name:T.name,uri:T.uri}:void 0})}return A}P.toDataTransferDTO=D})(C=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(Ie[209],ke([1,0,103]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function i(P){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:P,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function C(P){return new d.URITransformer(i(P))}e.createURITransformer=C}),define(Ie[210],ke([1,0,180,14,2,6,4,44,42,16,10]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var y;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(y=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(H){const M=H;return!!M&&typeof M.getSelection=="function"&&!!M.onDidChangeSelection}e.isEditorPaneWithSelection=T;function _(H,M,j){for(const V of j.visibleEditorPanes)if(V.group.id===M&&H.matches(V.input))return V.getViewState()}e.findViewStateForEditor=_;function m(H){if(r(H))return!1;const M=H;return C.URI.isUri(M?.resource)}e.isResourceEditorInput=m;function v(H){if(r(H))return!1;const M=H;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=v;function g(H){if(r(H)||v(H))return!1;const M=H;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function E(H){if(r(H))return!1;const M=H;return M?M.resource===void 0||M.resource.scheme===L.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var h;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var l;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class f{constructor(){this.mapIdToSaveSource=new Map}registerSource(M,j){let V=this.mapIdToSaveSource.get(M);return V||(V={source:M,label:j},this.mapIdToSaveSource.set(M,V)),V.source}getSourceLabel(M){return this.mapIdToSaveSource.get(M)?.label??M}}e.SaveSourceRegistry=new f;var o;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends P.Disposable{}e.AbstractEditorInput=w;function r(H){return H instanceof w}e.isEditorInput=r;function s(H){const M=H;return C.URI.isUri(M?.preferredResource)}function n(H){const M=H;return r(M?.primary)&&r(M?.secondary)}e.isSideBySideEditorInput=n;function t(H){const M=H;return r(M?.modified)&&r(M?.original)}e.isDiffEditorInput=t;function a(H){return r(H?.editor)}e.isEditorInputWithOptions=a;function u(H){const M=H;return a(H)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function c(H){const M=H;return typeof M?.groupId=="number"&&r(M.editor)}e.isEditorIdentifier=c;var S;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(S=e.EditorCloseContext||(e.EditorCloseContext={}));var R;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var O;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(O=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(M,j){if(!M)return;if(j?.supportSideBySide){const{primary:q,secondary:ie}=this.getSideEditors(M);if(q&&ie){if(j?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getOriginalUri(q,{filterByScheme:j.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:j.filterByScheme});M=j.supportSideBySide===O.PRIMARY?q:ie}}if(v(M)||g(M))return;const V=s(M)?M.preferredResource:M.resource;return!V||!j||!j.filterByScheme?V:this.filterUri(V,j.filterByScheme)}getSideEditors(M){return n(M)||g(M)?{primary:M.primary,secondary:M.secondary}:t(M)||v(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,j){if(!M)return;if(j?.supportSideBySide){const{primary:q,secondary:ie}=this.getSideEditors(M);if(q&&ie){if(j?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getCanonicalUri(q,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:j.filterByScheme});M=j.supportSideBySide===O.PRIMARY?q:ie}}if(v(M)||g(M))return;const V=M.resource;return!V||!j||!j.filterByScheme?V:this.filterUri(V,j.filterByScheme)}filterUri(M,j){if(Array.isArray(j)){if(j.some(V=>M.scheme===V))return M}else if(j===M.scheme)return M}}e.EditorResourceAccessor=new N;var p;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const j=this.instantiationService=M.get(I.IInstantiationService);for(const[V,q]of this.editorSerializerConstructors)this.createEditorSerializer(V,q,j);this.editorSerializerConstructors.clear()}createEditorSerializer(M,j,V){const q=V.createInstance(j);this.editorSerializerInstances.set(M,q)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,j){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,j,this.instantiationService):this.editorSerializerConstructors.set(M,j),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new U);async function B(H,M){if(!H||!H.length)return[];const j=await Promise.all(H.map(async V=>{const q=C.URI.revive(V.fileUri);if(!q||!await M.canHandleResource(q))return;let Q=V.exists,ue=V.type;if(typeof Q!="boolean"||typeof ue!="number")try{ue=(await M.stat(q)).isDirectory?b.FileType.Directory:b.FileType.Unknown,Q=!0}catch{Q=!1}if(!Q&&V.openOnlyIfExists||ue===b.FileType.Directory)return;const ce={...V.options,pinned:!0};let G;return Q?G={resource:q,options:ce}:G={resource:q,options:ce,forceUntitled:!0},G}));return(0,A.coalesce)(j)}e.pathsToEditors=B;var z;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function re(H){const M=H;if(!M)return!1;const j=M;if(j.modified)return re(j.modified);const V=M;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.isTextEditorViewState=re}),define(Ie[87],ke([1,0,10,2]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(D,b){return D.scheme===d.Schemas.http||D.scheme===d.Schemas.https?D:(b&&b.authority&&b.isRemote&&D.scheme===d.Schemas.file&&(D=i.URI.from({scheme:d.Schemas.vscodeRemote,authority:b.authority,path:D.path})),i.URI.from({scheme:d.Schemas.https,authority:`${D.scheme}+${P(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=C;function P(D){return D.replace(/./g,b=>{const A=b.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?b:"-"+A.toString(16).padStart(4,"0")})}function I(D){return D.replace(/-([0-9a-f]{4})/g,(b,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=I}),define(Ie[211],ke([1,0,3,6,87]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(D,b,A){this._proxy=D,this._editors=b,this._remoteInfo=A,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const L=b.getVisibleTextEditors();for(const k of this._insets.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,b,A,L,k){let y;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===D){y=h;break}if(!y)throw new Error("not a visible editor");const T=this,_=this._handlePool++,m=new d.Emitter,v=new d.Emitter,g=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,C.asWebviewUri)(h,T._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(h){this._options=h,T._proxy.$setOptions(_,h)}get options(){return this._options}set html(h){this._html=h,T._proxy.$setHtml(_,h)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(h){return T._proxy.$postMessage(_,h)}},E=new class{constructor(){this.editor=D,this.line=b,this.height=A,this.webview=g,this.onDidDispose=v.event}dispose(){T._insets.has(_)&&(T._insets.delete(_),T._proxy.$disposeEditorInset(_),v.fire(),v.dispose(),m.dispose())}};return this._proxy.$createEditorInset(_,y.id,y.value.document.uri,b+1,A,L||{},k.identifier,k.extensionLocation),this._insets.set(_,{editor:D,inset:E,onDidReceiveMessage:m}),E}$onDidDispose(D){const b=this._insets.get(D);b&&b.inset.dispose()}$onDidReceiveMessage(D,b){const A=this._insets.get(D);A&&A.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=P}),define(Ie[126],ke([1,0,3,17,181]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,b,A,L){const k={command:D};if(b&&Object.keys(b).length>0&&(k.arguments=b),this.internalSend("request",k),typeof L=="number"){const y=setTimeout(()=>{clearTimeout(y);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const _={type:"response",seq:0,request_seq:k.seq,success:!1,command:D,message:(0,C.localize)(0,null,L,D)};T(_)}},L)}return A&&this.pendingRequests.set(k.seq,A),k.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,b){return D.type!=="event"||b.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,i.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":{const b=D,A=this.pendingRequests.get(b.request_seq);A&&(this.pendingRequests.delete(b.request_seq),A(b));break}}}}internalSend(D,b){b.type=D,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((b,A)=>D.set(A,b)),await(0,i.timeout)(500),D.forEach((b,A)=>{b({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ie[212],ke([1,0,182,64,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new i.RawContextKey("debugType",void 0,{type:"string",description:d.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new i.RawContextKey("debugConfigurationType",void 0,{type:"string",description:d.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new i.RawContextKey("debugState","inactive",{type:"string",description:d.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new i.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:d.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new i.RawContextKey("inDebugMode",!1,{type:"boolean",description:d.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new i.RawContextKey("inDebugRepl",!1,{type:"boolean",description:d.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new i.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:d.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new i.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:d.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new i.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:d.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new i.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:d.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new i.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:d.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new i.RawContextKey("variablesFocused",!0,{type:"boolean",description:d.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new i.RawContextKey("expressionSelected",!1,{type:"boolean",description:d.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new i.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:d.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new i.RawContextKey("callStackItemType",void 0,{type:"string",description:d.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new i.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:d.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new i.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:d.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new i.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:d.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new i.RawContextKey("watchItemType",void 0,{type:"string",description:d.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new i.RawContextKey("canViewMemory",void 0,{type:"boolean",description:d.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new i.RawContextKey("breakpointItemType",void 0,{type:"string",description:d.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new i.RawContextKey("breakpointAccessType",void 0,{type:"string",description:d.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new i.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:d.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new i.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:d.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new i.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:d.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new i.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:d.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new i.RawContextKey("stepBackSupported",!1,{type:"boolean",description:d.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new i.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:d.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new i.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:d.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new i.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:d.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new i.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:d.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new i.RawContextKey("breakpointsExist",!1,{type:"boolean",description:d.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new i.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:d.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new i.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:d.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new i.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:d.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new i.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:d.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new i.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:d.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new i.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:d.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new i.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:d.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new i.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:d.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new i.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:d.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new i.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:d.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new i.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:d.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new i.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:d.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new i.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:d.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new i.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:d.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new i.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:d.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new i.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:d.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new i.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:d.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new i.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:d.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new i.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:d.localize(50,null)});const P=k=>d.localize(51,null,k);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:d.localize(52,null)};var I;(function(k){k[k.Inactive=0]="Inactive",k[k.Initializing=1]="Initializing",k[k.Stopped=2]="Stopped",k[k.Running=3]="Running"})(I=e.State||(e.State={}));function D(k){switch(k){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var b;(function(k){k[k.Valid=0]="Valid",k[k.Unreadable=1]="Unreadable",k[k.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(k){k[k.Initial=1]="Initial",k[k.Dynamic=2]="Dynamic"})(A=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,C.createDecorator)(e.DEBUG_SERVICE_ID);var L;(function(k){k[k.CONDITION=0]="CONDITION",k[k.HIT_COUNT=1]="HIT_COUNT",k[k.LOG_MESSAGE=2]="LOG_MESSAGE"})(L=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[213],ke([1,0,8,2,9,26,10]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function b(r,s,n){return r.replace(D,function(t,a){return s&&a.length>0&&a[0]!=="_"?t:n&&n.hasOwnProperty(a)?n[a]:t})}e.formatPII=b;function A(r){const s={};for(const n of Object.keys(r))n.startsWith("!")||(s[n]=r[n]);return s}e.filterExceptionsFromTelemetry=A;function L(r){return r.configuration.request==="attach"&&!k(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function k(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(s,"extensionhost")||(0,d.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function y(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=y;function T(r,s,n){let t,a=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let c=null;for(;c=u.exec(r);){const S=c.index+1,R=S+c[0].length;if(S<=s&&R>=n){t=c[0],a=S;break}}if(t){const S=/\w+/g;let R=null;for(;(R=S.exec(t))&&!(R.index+1+a+R[0].length>=n););R&&(t=t.substring(0,S.lastIndex))}return t?{start:a,end:a+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const _=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(_))}e.isUri=m;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return i.URI.parse(r.path);if((0,C.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=i.URI.revive(r.path);if(s)return s.scheme===I.Schemas.file?s.fsPath:s.toString()}return r.path}function E(r,s){const n=s?v:g,t=(0,P.deepClone)(r);return l(t,(a,u)=>{a&&u&&(u.path=n(u))}),t}e.convertToDAPaths=E;function h(r,s){const n=s?v:g,t=(0,P.deepClone)(r);return l(t,(a,u)=>{!a&&u&&(u.path=n(u))}),t}e.convertToVSCPaths=h;function l(r,s){switch(r.type){case"event":{const n=r;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(a=>s(!1,a.location))}break;default:break}break}}}function f(r){return r.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):o(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=f;function o(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function w(r,s){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=w}),define(Ie[214],ke([1,0,29,41,183,127,9,8,26,12,115,126]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class y extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const h=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${y.TWO_CRLF}${h}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+h))}continue}}else{const h=this.rawData.indexOf(y.TWO_CRLF);if(h!==-1){const f=this.rawData.toString("utf8",0,h).split(y.HEADER_LINESEPARATOR);for(const o of f){const w=o.split(y.HEADER_FIELDSEPARATOR);w[0]==="Content-Length"&&(this.contentLength=Number(w[1]))}this.rawData=this.rawData.slice(h+y.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=y,y.TWO_CRLF=`\r
\r
`,y.HEADER_LINESEPARATOR=/\r?\n/,y.HEADER_FIELDSEPARATOR=/: */;class T extends y{startSession(){return new Promise((E,h)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",f=>{l?this._onError.fire(f):h(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class _ extends T{constructor(E){super();this.adapterServer=E}createConnection(E){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=_;class m extends T{constructor(E){super();this.adapterServer=E}createConnection(E){return P.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=m;class v extends y{constructor(E,h,l){super();this.adapterExecutable=E,this.debugType=h,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,h=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(I.isAbsolute(E)){if(!await d.Promises.exists(E))throw new Error(C.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let f=process.env;if(l.env&&Object.keys(l.env).length>0&&(f=b.mixin(b.deepClone(process.env),l.env)),E==="node")if(Array.isArray(h)&&h.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:f,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(r.cwd=l.cwd);const s=i.fork(h[0],h.slice(1),r);if(!s.pid)throw new Error(C.localize(2,null,h[0]));this.serverProcess=s}else throw new Error(C.localize(3,null));else{const w={env:f};l.cwd&&(w.cwd=l.cwd),this.serverProcess=i.spawn(E,h,w)}this.serverProcess.on("error",w=>{this._onError.fire(w)}),this.serverProcess.on("exit",(w,r)=>{this._onExit.fire(w)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",w=>{this._onError.fire(w)}),this.serverProcess.stdin.on("error",w=>{this._onError.fire(w)});const o=this.outputService;if(o){const w=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const s=o.getChannel(L.ExtensionsChannelId);s&&s.append(w(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((E,h)=>{const l=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,o,w){if(f)return h(f)});l.on("exit",E),l.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,h){if(!E)return;const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=I.join(h,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(I.isAbsolute(E.program)?l.program=E.program:l.program=I.join(h,E.program)),E.args&&(l.args=E.args);const f=E;return f.win&&(l.win=v.extract(f.win,h)),f.winx86&&(l.winx86=v.extract(f.winx86,h)),f.windows&&(l.windows=v.extract(f.windows,h)),f.osx&&(l.osx=v.extract(f.osx,h)),f.linux&&(l.linux=v.extract(f.linux,h)),l}static platformAdapterExecutable(E,h){let l=Object.create(null);h=h.toLowerCase();for(const n of E)if(n.contributes){const t=n.contributes.debuggers;t&&t.length>0&&t.filter(a=>typeof a.type=="string"&&D.equalsIgnoreCase(a.type,h)).forEach(a=>{const u=v.extract(a,n.extensionLocation.fsPath);l=b.mixin(l,u,n.isBuiltin)})}let f;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=l.winx86||l.win||l.windows:A.isWindows?f=l.win||l.windows:A.isMacintosh?f=l.osx:A.isLinux&&(f=l.linux),f=f||l;const o=f.program||l.program,w=f.args||l.args,r=f.runtime||l.runtime,s=f.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(w||[])};if(o)return{type:"executable",command:o,args:w||[]}}}e.ExecutableDebugAdapter=v}),define(Ie[215],ke([1,0,41,30,12]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(A,L){return new Promise((k,y)=>{let T="";const _=d.spawn(A,L);_.pid&&_.stdout.on("data",m=>{T+=m.toString()}),_.on("error",m=>{y(m)}),_.on("close",m=>{k(T)})})}async function I(A){if(A)if(C.isWindows){const L=await new Promise((k,y)=>{Y(["windows-process-tree"],k,y)});return new Promise(k=>{L.getProcessTree(A,y=>{k(!!y&&y.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(A)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var D;(function(A){A[A.cmd=0]="cmd",A[A.powershell=1]="powershell",A[A.bash=2]="bash"})(D||(D={}));function b(A,L,k,y){A=A.trim().toLowerCase();let T;A.indexOf("powershell")>=0||A.indexOf("pwsh")>=0?T=1:A.indexOf("cmd.exe")>=0?T=0:A.indexOf("bash")>=0?T=2:C.isWindows?T=0:T=2;let _,m=" ";switch(T){case 1:if(_=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),k){const v=(0,i.getDriveLetter)(k);v&&(m+=`${v}:; `),m+=`cd ${_(k)}; `}if(y)for(const v in y){const g=y[v];g===null?m+=`Remove-Item env:${v}; `:m+=`\${env:${v}}='${g}'; `}if(L.length>0){const v=_(L.shift());m+=v[0]==="'"?`& ${v} `:`${v} `;for(const g of L)m+=g==="<"||g===">"?g:_(g),m+=" "}break;case 0:if(_=v=>(v=v.replace(/\"/g,'""'),v=v.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>v.includes(g))||v.length===0?`"${v}"`:v),k){const v=(0,i.getDriveLetter)(k);v&&(m+=`${v}: && `),m+=`cd ${_(k)} && `}if(y){m+='cmd /C "';for(const v in y){let g=y[v];g===null?m+=`set "${v}=" && `:(g=g.replace(/[&^|<>]/g,E=>`^${E}`),m+=`set "${v}=${g}" && `)}}for(const v of L)m+=v==="<"||v===">"?v:_(v),m+=" ";y&&(m+='"');break;case 2:{_=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;])/g,"\\$1"),g.length===0?'""':g);const v=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(k&&(m+=`cd ${_(k)} ; `),y){m+="/usr/bin/env";for(const g in y){const E=y[g];E===null?m+=` -u ${v(g)}`:m+=` ${v(`${g}=${E}`)}`}m+=" "}for(const g of L)m+=g==="<"||g===">"?g:_(g),m+=" ";break}}return m}e.prepareCommand=b}),define(Ie[128],ke([1,0,34,79,94,10,9,12,64]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json",C.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var k;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var T;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(T=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var _;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(_=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var g;(function(n){n.scheme=P.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function a(N,p){return N.with({scheme:n.scheme,fragment:`ch${p.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}n.generate=a;function u(N){if(N.scheme!==n.scheme)return;const p=t.exec(N.fragment);return p?{handle:Number(p[1]),notebook:N.with({scheme:N.fragment.substring(p[0].length)||P.Schemas.file,fragment:null})}:void 0}n.parse=u;function c(N,p){return N.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${p??""},${N.scheme!==P.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=c;function S(N){if(N.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const p=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!p)return;const U=p[1]&&p[1]!==""?p[1]:void 0,B=p[2];return{outputId:U,notebook:N.with({scheme:B||P.Schemas.file,fragment:null})}}n.parseCellOutputUri=S;function R(N,p,U){return N.with({scheme:U,fragment:`ch${p.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}n.generateCellUri=R;function O(N,p){if(N.scheme!==p)return;const U=t.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substring(U[0].length)||P.Schemas.file,fragment:null})}:void 0}n.parseCellUri=O})(g=e.CellUri||(e.CellUri={}));const E=n=>D.isWindows?n.replace(/\//g,"\\"):n;class h{constructor(t=[],a=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=a,this.order=[...new Set(t)].map(u=>({pattern:u,matches:d.parse(E(u))}))}sort(t){const a=new Map(i.Iterable.map(t,c=>[c,E(c)]));let u=[];for(const{matches:c}of this.order)for(const[S,R]of a)if(c(R)){u.push(S),a.delete(S);break}return a.size&&(u=u.concat([...a.keys()].sort((c,S)=>this.defaultOrder.indexOf(c)-this.defaultOrder.indexOf(S)))),u}prioritize(t,a){const u=this.findIndex(t);if(u===-1){this.order.unshift({pattern:t,matches:d.parse(E(t))});return}const c=new Set(a.map(R=>this.findIndex(R,u)));c.delete(-1);const S=Array.from(c).sort();this.order.splice(u+1,0,...S.map(R=>this.order[R]));for(let R=S.length-1;R>=0;R--)this.order.splice(S[R],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,a=this.order.length){const u=E(t);for(let c=0;c<a;c++)if(this.order[c].matches(u))return c;return-1}}e.MimeTypeDisplayOrder=h;function l(n,t,a,u=(c,S)=>c===S){const c=[];function S(N,p,U){if(p===0&&U.length===0)return;const B=c[c.length-1];B&&B.start+B.deleteCount===N?(B.deleteCount+=p,B.toInsert.push(...U)):c.push({start:N,deleteCount:p,toInsert:U})}let R=0,O=0;for(;;){if(R===n.length){S(R,0,t.slice(O));break}if(O===t.length){S(R,n.length-R,[]);break}const N=n[R],p=t[O];if(u(N,p)){R+=1,O+=1;continue}a(p)?(S(R,1,[]),R+=1):(S(R,0,[p]),O+=1)}return c}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var f;(function(n){n.default="default",n.option="option"})(f=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(n){const t=n;return!!((typeof t.include=="string"||d.isRelativePattern(t.include))&&(typeof t.exclude=="string"||d.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=o;function w(n,t,a){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const u=o(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,c=o(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(d.match(u,(0,I.basename)(a.fsPath).toLowerCase()))return!(c&&d.match(c,(0,I.basename)(a.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=w,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ie[216],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(Ie[217],ke([1,0,184,4,64]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ie[218],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=d;function i(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=i}),define(Ie[66],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(P){P.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class C{constructor(I,D=I.length){if(this.path=I,this.viewEnd=D,I.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,D,b=I.parent){if(I.id===D)return new C([D]);let A=[I.id];for(let L=b;L&&L.id!==D;L=L.parent)A.push(L.id);return A.push(D),new C(A.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const D=I.indexOf("\0");return D===-1?I:I.slice(0,D)}static fromString(I){return new C(I.split("\0"))}static join(I,D){return new C([...I.path,D])}static joinToString(I,D){return I.toString()+"\0"+D}static compare(I,D){return I===D?0:D.startsWith(I+"\0")?2:I.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new C(this.path,I)}compare(I){if(typeof I=="string")return C.compare(this.toString(),I);for(let D=0;D<I.viewEnd&&D<this.viewEnd;D++)if(I.path[D]!==this.path[D])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=C}),define(Ie[67],ke([1,0,2,36]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var C;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(C=e.TestResultState||(e.TestResultState={}));var P;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:i.Range.lift(t.range),uri:d.URI.revive(t.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var D;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var b;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var A;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(A=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(n){n.serialize=t=>t.type===0?b.serialize(t):A.serialize(t),n.deserialize=t=>t.type===0?b.deserialize(t):A.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var k;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const y="\0",T=(n,t)=>n+y+t;e.namespaceTestTag=T;const _=n=>{const t=n.indexOf(y);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=_;var m;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?d.URI.revive(t.uri):void 0,range:t.range?i.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(m=e.ITestItem||(e.ITestItem={}));var v;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:m.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:m.deserialize(t.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(n){n.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},n.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?i.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=h;var l;(function(n){n.serialize=(t,a)=>({...g.serialize(t),children:a,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(k.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var f;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var w;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:g.deserialize(t.item)}:t.op===1?{op:t.op,item:E.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:g.serialize(t.item)}:t.op===1?{op:t.op,item:E.serialize(t.item)}:t})(w=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,a){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const a=this.createChangeCollector();for(const u of t)switch(u.op){case 0:{const c=g.deserialize(u.item);if(c.parent){if(this.items.has(c.parent)){const S=this.items.get(c.parent);S.children.add(c.item.extId);const R=this.createItem(c,S);this.items.set(c.item.extId,R),a.add(R)}}else{const S=this.createItem(c);this.roots.add(S),this.items.set(c.item.extId,S),a.add(S)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=E.deserialize(u.item),S=this.items.get(c.extId);if(!S)break;c.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,c),a.update(S);break}case 2:{const c=this.items.get(u.itemId);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const S=[[u.itemId]];for(;S.length;)for(const R of S.pop()){const O=this.items.get(R);O&&(S.push(O.children),this.items.delete(R),a.remove(O,O!==c),O.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u.itemId);break;case 3:this.updatePendingRoots(u.amount);break;case 5:this._tags.set(u.tag.id,u.tag);break;case 6:this._tags.delete(u.id);break}a.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(Ie[88],ke([1,0,17,3,6,14,67,66]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const A=(g,E)=>g===E,L={range:(g,E)=>g===E?!0:!g||!E?!1:g.equalsRange(E),busy:A,label:A,description:A,error:A,tags:(g,E)=>!(g.length!==E.length||g.some(h=>!E.includes(h)))},k=(g,E)=>{let h;for(const[l,f]of Object.entries(L))f(g[l],E[l])||(h?h[l]=E[l]:h={[l]:E[l]});return h};class y extends C.Disposable{constructor(E){super();this.options=E,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(E){this._resolveHandler=E;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const h=this.diff[this.diff.length-1];if(h&&E.op===1){if(h.op===1&&h.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(h.item,E.item);return}if(h.op===0&&h.item.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(h.item,E.item);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,h){const l=this.tree.get(E);if(!!l){if((l.expandLevels===void 0||h>l.expandLevels)&&(l.expandLevels=h),l.expand===1){const f=this.resolveChildren(l);return f.isOpen()?this.expandChildren(l,h-1):f.wait().then(()=>this.expandChildren(l,h-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,h-1)):this.expandChildren(l,h-1)}}dispose(){for(const E of this.tree.values())this.options.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(E,h){switch(h.op){case 3:this.removeItem(D.TestId.joinToString(E.fullId,h.id));break;case 0:this.upsertItem(h.item,E);break;case 5:for(const l of h.ops)this.onTestItemEvent(E,l);break;case 1:this.diffTagRefs(h.new,h.old,E.fullId.toString());break;case 2:this.updateExpandability(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:h.update}});break;default:(0,P.assertNever)(h)}}upsertItem(E,h){const l=D.TestId.fromExtHostTestItem(E,this.root.id,h?.actual),f=this.options.getApiFor(E);f.parent&&f.parent!==h?.actual&&this.options.getChildren(f.parent).delete(E.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:E,parent:h?l.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},E.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(E,h),this.pushDiff({op:0,item:{parent:o.parent&&o.parent.toString(),controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(E)}}),this.connectItemAndChildren(E,o,h);return}if(o.actual===E){this.connectItem(E,o,h);return}const w=this.options.getChildren(o.actual),r=o.actual,s=k(this.options.toITestItem(r),this.options.toITestItem(E));this.options.getApiFor(r).listener=void 0,o.actual=E,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(E.tags,r.tags,l.toString()),delete s.tags),this.onTestItemEvent(o,{op:4,update:s})),this.connectItemAndChildren(E,o,h);for(const n of w)this.options.getChildren(E).get(n.id)||this.removeItem(D.TestId.joinToString(l,n.id))}diffTagRefs(E,h,l){const f=new Set(h.map(o=>o.id));for(const o of E)f.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:l,item:{tags:E.map(o=>(0,I.namespaceTestTag)(this.options.controllerId,o.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(E){const h=this.tags.get(E.id);h?h.refCount++:(this.tags.set(E.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,E.id)}}))}decrementTagRefs(E){const h=this.tags.get(E);h&&!--h.refCount&&(this.tags.delete(E),this.pushDiff({op:6,id:(0,I.namespaceTestTag)(this.options.controllerId,E)}))}setItemParent(E,h){this.options.getApiFor(E).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(E,h,l){this.setItemParent(E,l);const f=this.options.getApiFor(E);f.parent=l?.actual,f.listener=o=>this.onTestItemEvent(h,o),this.updateExpandability(h)}connectItemAndChildren(E,h,l){this.connectItem(E,h,l);for(const f of this.options.getChildren(E))this.upsertItem(f,h)}updateExpandability(E){let h;this._resolveHandler?E.resolveBarrier?h=E.resolveBarrier.isOpen()?3:2:h=E.actual.canResolveChildren?1:0:h=0,h!==E.expand&&(E.expand=h,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:h}}),h===1&&E.expandLevels!==void 0&&this.resolveChildren(E))}expandChildren(E,h){if(h<0)return;const l=[];for(const f of this.options.getChildren(E.actual)){const o=this.expand(D.TestId.joinToString(E.fullId,f.id),h);(0,d.isThenable)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this._resolveHandler){const o=new d.Barrier;return o.open(),o}E.expand=2,this.pushExpandStateUpdate(E);const h=E.resolveBarrier=new d.Barrier,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let f;try{f=this._resolveHandler(E.actual===this.root?void 0:E.actual)}catch(o){l(o)}return(0,d.isThenable)(f)?f.catch(l).then(()=>{h.open(),this.updateExpandability(E)}):(h.open(),this.updateExpandability(E)),E.resolveBarrier}pushExpandStateUpdate(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}removeItem(E){const h=this.tree.get(E);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:E});const l=[h];for(;l.length;){const f=l.pop();if(!!f){this.options.getApiFor(f.actual).listener=void 0;for(const o of f.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(f.fullId.toString());for(const o of this.options.getChildren(f.actual))l.push(this.tree.get(D.TestId.joinToString(f.fullId,o.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.diffOpEmitter.fire(E)}}e.TestItemCollection=y;class T extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=T;class _ extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=_;class m extends Error{constructor(E,h,l){super(`TestItem with ID "${E}" is from controller "${h}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=m;const v=(g,E,h)=>{let l=new Map;return{get size(){return l.size},forEach(f,o){for(const w of l.values())f.call(o,w,this)},replace(f){const o=new Map,w=new Set(l.keys()),r={op:5,ops:[]};for(const s of f){if(!(s instanceof h))throw new _(s.id);const n=E(s).controllerId;if(n!==g.controllerId)throw new m(s.id,n,g.controllerId);if(o.has(s.id))throw new T(s.id);o.set(s.id,s),w.delete(s.id),r.ops.push({op:0,item:s})}for(const s of w.keys())r.ops.push({op:3,id:s});g.listener?.(r),l=o},add(f){if(!(f instanceof h))throw new _(f.id);l.set(f.id,f),g.listener?.({op:0,item:f})},delete(f){l.delete(f)&&g.listener?.({op:3,id:f})},get(f){return l.get(f)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=v}),define(Ie[129],ke([1,0,88]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const i=new WeakMap,C=(I,D)=>{const b={controllerId:D};return i.set(I,b),b};e.createPrivateApiFor=C;const P=I=>{const D=i.get(I);if(!D)throw new d.InvalidTestItemError(I?.id||"<unknown>");return D};e.getPrivateApiFor=P}),define(Ie[219],ke([1,0,9,40,14,26,12,102,185,8]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(y,T,_,m){this._contributedVariables=new Map,this._context=y,this._labelService=T,this._userHomePromise=_,m&&(this._envVariablesPromise=m.then(v=>this.prepareEnv(v)))}prepareEnv(y){if(I.isWindows){const T=Object.create(null);return Object.keys(y).forEach(_=>{T[_.toLowerCase()]=y[_]}),T}return y}resolveWithEnvironment(y,T,_){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},T?T.uri:void 0,_)}async resolveAsync(y,T){const _={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(_,y?y.uri:void 0,T)}async resolveAnyBase(y,T,_,m){const v=P.deepClone(T);I.isWindows&&v.windows?Object.keys(v.windows).forEach(E=>v[E]=v.windows[E]):I.isMacintosh&&v.osx?Object.keys(v.osx).forEach(E=>v[E]=v.osx[E]):I.isLinux&&v.linux&&Object.keys(v.linux).forEach(E=>v[E]=v.linux[E]),delete v.windows,delete v.osx,delete v.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,y?y.uri:void 0,v,_,m)}async resolveAnyAsync(y,T,_){return this.resolveAnyBase(y,T,_)}async resolveAnyMap(y,T,_){const m=new Map;return{newConfig:await this.resolveAnyBase(y,T,_,m),resolvedVariables:m}}resolveWithInteractionReplace(y,T,_,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,T,_,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,T){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,T)}async recursiveResolve(y,T,_,m,v){if(C.isString(_))return this.resolveString(y,T,_,m,v);if(C.isArray(_))return Promise.all(_.map(g=>this.recursiveResolve(y,T,g,m,v)));if(C.isObject(_)){let g=Object.create(null);const E=await Promise.all(Object.keys(_).map(async h=>[await this.resolveString(y,T,h,m,v),await this.recursiveResolve(y,T,_[h],m,v)]));for(const[h,l]of E)g[h]=l;return g}return _}resolveString(y,T,_,m,v){return(0,A.replaceAsync)(_,L.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(L.VARIABLE_LHS))return g;let h=await this.evaluateSingleVariable(y,g,E,T,m);return v&&v.set(E,h),h!==g&&C.isString(h)&&h.match(L.VARIABLE_REGEXP)&&(h=await this.resolveString(y,T,h,m,v)),h})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,T,_,m,v){let g;const E=_.split(":");E.length>1&&(_=E[0],g=E[1]);const h=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error((0,b.localize)(0,null,T))},l=()=>{const o=h();if(this._context.getWorkspaceFolderPathForFile){const w=this._context.getWorkspaceFolderPathForFile();if(w)return w}throw new Error((0,b.localize)(1,null,T,d.basename(o)))},f=()=>{if(g){const o=this._context.getFolderUri(g);if(o)return o;throw new Error((0,b.localize)(2,null,T,g))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,T)):new Error((0,b.localize)(4,null,T))};switch(_){case"env":if(g){if(y.env){const o=y.env[I.isWindows?g.toLowerCase():g];if(C.isString(o))return o}return""}throw new Error((0,b.localize)(5,null,T));case"config":if(g){const o=this._context.getConfigurationValue(m,g);if(C.isUndefinedOrNull(o))throw new Error((0,b.localize)(6,null,T,g));if(C.isObject(o))throw new Error((0,b.localize)(7,null,T,g));return o}throw new Error((0,b.localize)(8,null,T));case"command":return this.resolveFromMap(T,g,v,"command");case"input":return this.resolveFromMap(T,g,v,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new Error((0,b.localize)(9,null,T,g));return this.fsPath(o.extensionLocation)}throw new Error((0,b.localize)(10,null,T));default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return m||g?(0,D.normalizeDriveLetter)(this.fsPath(f())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(f()));case"userHome":{if(y.userHome)return y.userHome;throw new Error((0,b.localize)(11,null,T))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new Error((0,b.localize)(12,null,T))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new Error((0,b.localize)(13,null,T))}case"file":return h();case"fileWorkspaceFolder":return l();case"relativeFile":return m||g?d.relative(this.fsPath(f()),h()):h();case"relativeFileDirname":{const o=d.dirname(h());if(m||g){const w=d.relative(this.fsPath(f()),o);return w.length===0?".":w}return o}case"fileDirname":return d.dirname(h());case"fileExtname":return d.extname(h());case"fileBasename":return d.basename(h());case"fileBasenameNoExtension":{const o=d.basename(h());return o.slice(0,o.length-d.extname(o).length)}case"fileDirnameBasename":return d.basename(d.dirname(h()));case"execPath":{const o=this._context.getExecPath();return o||T}case"execInstallFolder":{const o=this._context.getAppRoot();return o||T}case"pathSeparator":return d.sep;default:try{const o=g?`${_}:${g}`:_;return this.resolveFromMap(T,o,v,void 0)}catch{return T}}}}resolveFromMap(y,T,_,m){if(T&&_){const v=m===void 0?_[T]:_[m+":"+T];if(typeof v=="string")return v;throw new Error((0,b.localize)(14,null,y))}return y}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],ke([1,0,4,210]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var C;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var D;(function(_){_[_.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function A(_){const m=_;return(0,i.isEditorInput)(m?.editor)&&(0,i.isEditorInput)(m?.replacement)}e.isEditorReplacement=A;var L;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function y(_){const m=_;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=y;function T(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ie[220],ke([1,0,4,130]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(P){const I=P;return typeof P=="number"||(0,i.isEditorGroup)(I)}e.isPreferredGroup=C}),define(Ie[15],ke([1,0,16,23,101,24,145,60,26,14,2,36,63,187,116,129,128,66,67,220,7]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(Pe){function Le(Z){const{selectionStartLineNumber:Me,selectionStartColumn:xe,positionLineNumber:st,positionColumn:Qe}=Z,lt=new l.Position(Me-1,xe-1),dt=new l.Position(st-1,Qe-1);return new l.Selection(lt,dt)}Pe.to=Le;function we(Z){const{anchor:Me,active:xe}=Z;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Pe.from=we})(f=e.Selection||(e.Selection={}));var o;(function(Pe){function Le(Z){if(!Z)return;const{start:Me,end:xe}=Z;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Pe.from=Le;function we(Z){if(!Z)return;const{startLineNumber:Me,startColumn:xe,endLineNumber:st,endColumn:Qe}=Z;return new l.Range(Me-1,xe-1,st-1,Qe-1)}Pe.to=we})(o=e.Range||(e.Range={}));var w;(function(Pe){function Le(we){switch(we){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Pe.to=Le})(w=e.TokenType||(e.TokenType={}));var r;(function(Pe){function Le(Z){return new l.Position(Z.lineNumber-1,Z.column-1)}Pe.to=Le;function we(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Pe.from=we})(r=e.Position||(e.Position={}));var s;(function(Pe){function Le(Me,xe){return(0,d.coalesce)((0,d.asArray)(Me).map(st=>we(st,xe)))}Pe.from=Le;function we(Me,xe){if(typeof Me=="string")return{$serialized:!0,language:Me};if(Me)return{$serialized:!0,language:Me.language,scheme:Z(Me.scheme,xe),pattern:ye.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType}}function Z(Me,xe){return xe&&typeof Me=="string"?xe.transformOutgoingScheme(Me):Me}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Pe){function Le(Z){switch(Z){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function we(Z){switch(Z){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Pe.to=we})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(Pe){function Le(Z){let Me;return Z.code&&((0,A.isString)(Z.code)||(0,A.isNumber)(Z.code)?Me=String(Z.code):Me={value:String(Z.code.value),target:Z.code.target}),{...o.from(Z.range),message:Z.message,source:Z.source,code:Me,severity:u.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(a.from),tags:Array.isArray(Z.tags)?(0,d.coalesce)(Z.tags.map(n.from)):void 0}}Pe.from=Le;function we(Z){const Me=new l.Diagnostic(o.to(Z),Z.message,u.to(Z.severity));return Me.source=Z.source,Me.code=(0,A.isString)(Z.code)?Z.code:Z.code?.value,Me.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(a.to),Me.tags=Z.tags&&(0,d.coalesce)(Z.tags.map(n.to)),Me}Pe.to=we})(t=e.Diagnostic||(e.Diagnostic={}));var a;(function(Pe){function Le(Z){return{...o.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Pe.from=Le;function we(Z){return new l.DiagnosticRelatedInformation(new l.Location(Z.resource,o.to(Z)),Z.message)}Pe.to=we})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(Pe){function Le(Z){switch(Z){case l.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Pe.from=Le;function we(Z){switch(Z){case _.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Pe.to=we})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(Pe){function Le(Z){return typeof Z=="number"&&Z>=l.ViewColumn.One?Z-1:Z===l.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Pe.from=Le;function we(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=we})(c=e.ViewColumn||(e.ViewColumn={}));function S(Pe){return typeof Pe.range!="undefined"}function R(Pe){return Pe.length===0?!0:!!S(Pe[0])}e.isDecorationOptionsArr=R;var O;(function(Pe){function Le(Qe){return Qe.map(Pe.from)}Pe.fromMany=Le;function we(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Z(Qe){let lt;if(we(Qe)){const{language:mt,value:wt}=Qe;lt={value:"```"+mt+`
`+wt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Qe)?lt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?lt={value:Qe}:lt={value:""};const dt=Object.create(null);lt.uris=dt;const vt=mt=>{try{let wt=L.URI.parse(mt,!0);wt=wt.with({query:Me(wt.query,dt)}),dt[mt]=wt}catch{}return""},_t=new I.marked.Renderer;return _t.link=vt,_t.image=mt=>typeof mt=="string"?vt(C.parseHrefAndDimensions(mt).href):"",(0,I.marked)(lt.value,{renderer:_t}),lt}Pe.from=Z;function Me(Qe,lt){if(!Qe)return Qe;let dt;try{dt=(0,D.parse)(Qe)}catch{}if(!dt)return Qe;let vt=!1;return dt=(0,b.cloneAndChange)(dt,_t=>{if(L.URI.isUri(_t)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[mt]=_t,vt=!0,mt}else return}),vt?JSON.stringify(dt):Qe}function xe(Qe){const lt=new l.MarkdownString(Qe.value,Qe.supportThemeIcons);return lt.isTrusted=Qe.isTrusted,lt.supportHtml=Qe.supportHtml,lt.baseUri=Qe.baseUri?L.URI.from(Qe.baseUri):void 0,lt}Pe.to=xe;function st(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Pe.from(Qe)}Pe.fromStrict=st})(O=e.MarkdownString||(e.MarkdownString={}));function N(Pe){return R(Pe)?Pe.map(Le=>({range:o.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?O.fromMany(Le.hoverMessage):Le.hoverMessage?O.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:o.from(Le)}))}e.fromRangeOrRangeWithMessage=N;function p(Pe){return typeof Pe=="undefined"?Pe:typeof Pe=="string"?L.URI.file(Pe):Pe}e.pathOrURIToURI=p;var U;(function(Pe){function Le(we){return typeof we=="undefined"?we:{contentText:we.contentText,contentIconPath:we.contentIconPath?p(we.contentIconPath):void 0,border:we.border,borderColor:we.borderColor,fontStyle:we.fontStyle,fontWeight:we.fontWeight,textDecoration:we.textDecoration,color:we.color,backgroundColor:we.backgroundColor,margin:we.margin,width:we.width,height:we.height}}Pe.from=Le})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Pe){function Le(we){return typeof we=="undefined"?we:{backgroundColor:we.backgroundColor,outline:we.outline,outlineColor:we.outlineColor,outlineStyle:we.outlineStyle,outlineWidth:we.outlineWidth,border:we.border,borderColor:we.borderColor,borderRadius:we.borderRadius,borderSpacing:we.borderSpacing,borderStyle:we.borderStyle,borderWidth:we.borderWidth,fontStyle:we.fontStyle,fontWeight:we.fontWeight,textDecoration:we.textDecoration,cursor:we.cursor,color:we.color,opacity:we.opacity,letterSpacing:we.letterSpacing,gutterIconPath:we.gutterIconPath?p(we.gutterIconPath):void 0,gutterIconSize:we.gutterIconSize,overviewRulerColor:we.overviewRulerColor,before:we.before?U.from(we.before):void 0,after:we.after?U.from(we.after):void 0}}Pe.from=Le})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Pe){function Le(we){if(typeof we=="undefined")return we;switch(we){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var re;(function(Pe){function Le(we){return{isWholeLine:we.isWholeLine,rangeBehavior:we.rangeBehavior?z.from(we.rangeBehavior):void 0,overviewRulerLane:we.overviewRulerLane,light:we.light?B.from(we.light):void 0,dark:we.dark?B.from(we.dark):void 0,backgroundColor:we.backgroundColor,outline:we.outline,outlineColor:we.outlineColor,outlineStyle:we.outlineStyle,outlineWidth:we.outlineWidth,border:we.border,borderColor:we.borderColor,borderRadius:we.borderRadius,borderSpacing:we.borderSpacing,borderStyle:we.borderStyle,borderWidth:we.borderWidth,fontStyle:we.fontStyle,fontWeight:we.fontWeight,textDecoration:we.textDecoration,cursor:we.cursor,color:we.color,opacity:we.opacity,letterSpacing:we.letterSpacing,gutterIconPath:we.gutterIconPath?p(we.gutterIconPath):void 0,gutterIconSize:we.gutterIconSize,overviewRulerColor:we.overviewRulerColor,before:we.before?U.from(we.before):void 0,after:we.after?U.from(we.after):void 0}}Pe.from=Le})(re=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Pe){function Le(Z){return{text:Z.newText,eol:Z.newEol&&Ye.from(Z.newEol),range:o.from(Z.range)}}Pe.from=Le;function we(Z){const Me=new l.TextEdit(o.to(Z.range),Z.text);return Me.newEol=typeof Z.eol=="undefined"?void 0:Ye.to(Z.eol),Me}Pe.to=we})(H=e.TextEdit||(e.TextEdit={}));var M;(function(Pe){function Le(we){return{range:o.from(we.range),snippet:we.snippet.value}}Pe.from=Le})(M=e.SnippetTextEdit||(e.SnippetTextEdit={}));var j;(function(Pe){function Le(Z,Me){const xe={edits:[]};if(Z instanceof l.WorkspaceEdit){const st=new P.ResourceSet;for(const Qe of Z._allEntries())Qe._type===1&&L.URI.isUri(Qe.to)&&Qe.from===void 0&&st.add(Qe.to);for(const Qe of Z._allEntries())Qe._type===1?xe.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata}):Qe._type===2?xe.edits.push({_type:2,resource:Qe.uri,edit:H.from(Qe.edit),modelVersionId:st.has(Qe.uri)?void 0:Me?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Qe.uri),edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(rt.from)}})}return xe}Pe.from=Le;function we(Z){const Me=new l.WorkspaceEdit;for(const xe of Z.edits)xe.edit?Me.replace(L.URI.revive(xe.resource),o.to(xe.edit.range),xe.edit.text):Me.renameFile(L.URI.revive(xe.oldUri),L.URI.revive(xe.newUri),xe.options);return Me}Pe.to=we})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Pe){const Le=Object.create(null);Le[l.SymbolKind.File]=0,Le[l.SymbolKind.Module]=1,Le[l.SymbolKind.Namespace]=2,Le[l.SymbolKind.Package]=3,Le[l.SymbolKind.Class]=4,Le[l.SymbolKind.Method]=5,Le[l.SymbolKind.Property]=6,Le[l.SymbolKind.Field]=7,Le[l.SymbolKind.Constructor]=8,Le[l.SymbolKind.Enum]=9,Le[l.SymbolKind.Interface]=10,Le[l.SymbolKind.Function]=11,Le[l.SymbolKind.Variable]=12,Le[l.SymbolKind.Constant]=13,Le[l.SymbolKind.String]=14,Le[l.SymbolKind.Number]=15,Le[l.SymbolKind.Boolean]=16,Le[l.SymbolKind.Array]=17,Le[l.SymbolKind.Object]=18,Le[l.SymbolKind.Key]=19,Le[l.SymbolKind.Null]=20,Le[l.SymbolKind.EnumMember]=21,Le[l.SymbolKind.Struct]=22,Le[l.SymbolKind.Event]=23,Le[l.SymbolKind.Operator]=24,Le[l.SymbolKind.TypeParameter]=25;function we(Me){return typeof Le[Me]=="number"?Le[Me]:6}Pe.from=we;function Z(Me){for(const xe in Le)if(Le[xe]===Me)return Number(xe);return l.SymbolKind.Property}Pe.to=Z})(V=e.SymbolKind||(e.SymbolKind={}));var q;(function(Pe){function Le(Z){switch(Z){case l.SymbolTag.Deprecated:return 1}}Pe.from=Le;function we(Z){switch(Z){case 1:return l.SymbolTag.Deprecated}}Pe.to=we})(q=e.SymbolTag||(e.SymbolTag={}));var ie;(function(Pe){function Le(Z){return{name:Z.name,kind:V.from(Z.kind),tags:Z.tags&&Z.tags.map(q.from),containerName:Z.containerName,location:ge.from(Z.location)}}Pe.from=Le;function we(Z){const Me=new l.SymbolInformation(Z.name,V.to(Z.kind),Z.containerName,ge.to(Z.location));return Me.tags=Z.tags&&Z.tags.map(q.to),Me}Pe.to=we})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Pe){function Le(Z){const Me={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),kind:V.from(Z.kind),tags:Z.tags?.map(q.from)??[]};return Z.children&&(Me.children=Z.children.map(Le)),Me}Pe.from=Le;function we(Z){const Me=new l.DocumentSymbol(Z.name,Z.detail,V.to(Z.kind),o.to(Z.range),o.to(Z.selectionRange));return(0,d.isNonEmptyArray)(Z.tags)&&(Me.tags=Z.tags.map(q.to)),Z.children&&(Me.children=Z.children.map(we)),Me}Pe.to=we})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(Pe){function Le(Z){const Me=new l.CallHierarchyItem(V.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),o.to(Z.range),o.to(Z.selectionRange));return Me._sessionId=Z._sessionId,Me._itemId=Z._itemId,Me}Pe.to=Le;function we(Z,Me,xe){if(Me=Me??Z._sessionId,xe=xe??Z._itemId,Me===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:xe,name:Z.name,detail:Z.detail,kind:V.from(Z.kind),uri:Z.uri,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),tags:Z.tags?.map(q.from)}}Pe.from=we})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(Pe){function Le(we){return new l.CallHierarchyIncomingCall(ue.to(we.from),we.fromRanges.map(Z=>o.to(Z)))}Pe.to=Le})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(Pe){function Le(we){return new l.CallHierarchyOutgoingCall(ue.to(we.to),we.fromRanges.map(Z=>o.to(Z)))}Pe.to=Le})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(Pe){function Le(Z){return{range:Z.range&&o.from(Z.range),uri:Z.uri}}Pe.from=Le;function we(Z){return new l.Location(L.URI.revive(Z.uri),o.to(Z.range))}Pe.to=we})(ge=e.location||(e.location={}));var ne;(function(Pe){function Le(Z){const Me=Z,xe=Z;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:xe.uri,range:o.from(Me.targetRange?Me.targetRange:xe.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Pe.from=Le;function we(Z){return{targetUri:L.URI.revive(Z.uri),targetRange:o.to(Z.range),targetSelectionRange:Z.targetSelectionRange?o.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?o.to(Z.originSelectionRange):void 0}}Pe.to=we})(ne=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(Pe){function Le(Z){return{range:o.from(Z.range),contents:O.fromMany(Z.contents)}}Pe.from=Le;function we(Z){return new l.Hover(Z.contents.map(O.to),o.to(Z.range))}Pe.to=we})(he=e.Hover||(e.Hover={}));var Se;(function(Pe){function Le(Z){return{range:o.from(Z.range),expression:Z.expression}}Pe.from=Le;function we(Z){return new l.EvaluatableExpression(o.to(Z.range),Z.expression)}Pe.to=we})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(Pe){function Le(Z){if(Z instanceof l.InlineValueText)return{type:"text",range:o.from(Z.range),text:Z.text};if(Z instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function we(Z){switch(Z.type){case"text":return{range:o.to(Z.range),text:Z.text};case"variable":return{range:o.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:o.to(Z.range),expression:Z.expression}}}Pe.to=we})(Re=e.InlineValue||(e.InlineValue={}));var ve;(function(Pe){function Le(Z){return{frameId:Z.frameId,stoppedLocation:o.from(Z.stoppedLocation)}}Pe.from=Le;function we(Z){return new l.InlineValueContext(Z.frameId,o.to(Z.stoppedLocation))}Pe.to=we})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Pe){function Le(Z){return{range:o.from(Z.range),kind:Z.kind}}Pe.from=Le;function we(Z){return new l.DocumentHighlight(o.to(Z.range),Z.kind)}Pe.to=we})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(Pe){function Le(we){switch(we){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Pe.to=Le})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(Pe){function Le(we){return{triggerKind:Ae.to(we.triggerKind),triggerCharacter:we.triggerCharacter}}Pe.to=Le})(le=e.CompletionContext||(e.CompletionContext={}));var pe;(function(Pe){function Le(Z){switch(Z){case l.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function we(Z){switch(Z){case 1:return l.CompletionItemTag.Deprecated}}Pe.to=we})(pe=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Pe){const Le=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function we(xe){return Le.get(xe)??9}Pe.from=we;const Z=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Me(xe){return Z.get(xe)??l.CompletionItemKind.Property}Pe.to=Me})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Pe){function Le(we,Z){const Me=new l.CompletionItem(we.label);return Me.insertText=we.insertText,Me.kind=ee.to(we.kind),Me.tags=we.tags?.map(pe.to),Me.detail=we.detail,Me.documentation=C.isMarkdownString(we.documentation)?O.to(we.documentation):we.documentation,Me.sortText=we.sortText,Me.filterText=we.filterText,Me.preselect=we.preselect,Me.commitCharacters=we.commitCharacters,k.Range.isIRange(we.range)?Me.range=o.to(we.range):typeof we.range=="object"&&(Me.range={inserting:o.to(we.range.insert),replacing:o.to(we.range.replace)}),Me.keepWhitespace=typeof we.insertTextRules=="undefined"?!1:Boolean(we.insertTextRules&1),typeof we.insertTextRules!="undefined"&&we.insertTextRules&4?Me.insertText=new l.SnippetString(we.insertText):(Me.insertText=we.insertText,Me.textEdit=Me.range instanceof l.Range?new l.TextEdit(Me.range,Me.insertText):void 0),we.additionalTextEdits&&we.additionalTextEdits.length>0&&(Me.additionalTextEdits=we.additionalTextEdits.map(xe=>H.to(xe))),Me.command=Z&&we.command?Z.fromInternal(we.command):void 0,Me}Pe.to=Le})(te=e.CompletionItem||(e.CompletionItem={}));var F;(function(Pe){function Le(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation)}}Pe.from=Le;function we(Z){return{label:Z.label,documentation:C.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation}}Pe.to=we})(F=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(Pe){function Le(Z){return{label:Z.label,documentation:O.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(F.from):[],activeParameter:Z.activeParameter}}Pe.from=Le;function we(Z){return{label:Z.label,documentation:C.isMarkdownString(Z.documentation)?O.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(F.to):[],activeParameter:Z.activeParameter}}Pe.to=we})($=e.SignatureInformation||(e.SignatureInformation={}));var K;(function(Pe){function Le(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map($.from):[]}}Pe.from=Le;function we(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map($.to):[]}}Pe.to=we})(K=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Le(we,Z){const Me=new l.InlayHint(r.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(me.to.bind(void 0,we)),Z.kind&&Ee.to(Z.kind));return Me.textEdits=Z.textEdits&&Z.textEdits.map(H.to),Me.tooltip=C.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,Me.paddingLeft=Z.paddingLeft,Me.paddingRight=Z.paddingRight,Me}Pe.to=Le})(X=e.InlayHint||(e.InlayHint={}));var me;(function(Pe){function Le(we,Z){const Me=new l.InlayHintLabelPart(Z.label);return Me.tooltip=C.isMarkdownString(Z.tooltip)?O.to(Z.tooltip):Z.tooltip,y.Command.is(Z.command)&&(Me.command=we.fromInternal(Z.command)),Z.location&&(Me.location=ge.to(Z.location)),Me}Pe.to=Le})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ee;(function(Pe){function Le(Z){return Z}Pe.from=Le;function we(Z){return Z}Pe.to=we})(Ee=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(Pe){function Le(Z){return{range:o.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Pe.from=Le;function we(Z){let Me;if(Z.url)try{Me=typeof Z.url=="string"?L.URI.parse(Z.url,!0):L.URI.revive(Z.url)}catch{}return new l.DocumentLink(o.to(Z.range),Me)}Pe.to=we})(oe=e.DocumentLink||(e.DocumentLink={}));var De;(function(Pe){function Le(Z){const Me=new l.ColorPresentation(Z.label);return Z.textEdit&&(Me.textEdit=H.to(Z.textEdit)),Z.additionalTextEdits&&(Me.additionalTextEdits=Z.additionalTextEdits.map(xe=>H.to(xe))),Me}Pe.to=Le;function we(Z){return{label:Z.label,textEdit:Z.textEdit?H.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Me=>H.from(Me)):void 0}}Pe.from=we})(De=e.ColorPresentation||(e.ColorPresentation={}));var Ce;(function(Pe){function Le(Z){return new l.Color(Z[0],Z[1],Z[2],Z[3])}Pe.to=Le;function we(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Pe.from=we})(Ce=e.Color||(e.Color={}));var We;(function(Pe){function Le(Z){return{range:o.from(Z.range)}}Pe.from=Le;function we(Z){return new l.SelectionRange(o.to(Z.range))}Pe.to=we})(We=e.SelectionRange||(e.SelectionRange={}));var je;(function(Pe){function Le(we){switch(we){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Fe;(function(Pe){function Le(Z){switch(Z){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function we(Z){switch(Z){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Pe.to=we})(Fe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Le(Z){if(Z===l.EndOfLine.CRLF)return 1;if(Z===l.EndOfLine.LF)return 0}Pe.from=Le;function we(Z){if(Z===1)return l.EndOfLine.CRLF;if(Z===0)return l.EndOfLine.LF}Pe.to=we})(Ye=e.EndOfLine||(e.EndOfLine={}));var J;(function(Pe){function Le(we){if(typeof we=="object")return we.viewId;switch(we){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(J=e.ProgressLocation||(e.ProgressLocation={}));var se;(function(Pe){function Le(we){const Z={start:we.start+1,end:we.end+1};return we.kind&&(Z.kind=_e.from(we.kind)),Z}Pe.from=Le})(se=e.FoldingRange||(e.FoldingRange={}));var _e;(function(Pe){function Le(we){if(we)switch(we){case l.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}Pe.from=Le})(_e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Pe){function Le(we){if(we)return{pinned:typeof we.preview=="boolean"?!we.preview:void 0,inactive:we.background,preserveFocus:we.preserveFocus,selection:typeof we.selection=="object"?o.from(we.selection):void 0,override:typeof we.override=="boolean"?T.EditorResolution.DISABLED:void 0}}Pe.from=Le})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(Pe){function Le(xe){return xe instanceof l.RelativePattern?xe.toJSON():typeof xe=="string"?xe:we(xe)||Z(xe)?new l.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Pe.from=Le;function we(xe){const st=xe;return st?L.URI.isUri(st.baseUri)&&typeof st.pattern=="string":!1}function Z(xe){const st=xe;return st?typeof st.base=="string"&&typeof st.pattern=="string":!1}function Me(xe){return typeof xe=="string"?xe:new l.RelativePattern(L.URI.revive(xe.baseUri),xe.pattern)}Pe.to=Me})(ye=e.GlobPattern||(e.GlobPattern={}));var Ne;(function(Pe){function Le(we){if(we){if(Array.isArray(we))return we.map(Le);if(typeof we=="string")return we;{const Z=we;return{language:Z.language,scheme:Z.scheme,pattern:ye.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}Pe.from=Le})(Ne=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(Pe){function Le(Z){return{start:Z.start,end:Z.end}}Pe.from=Le;function we(Z){return new l.NotebookRange(Z.start,Z.end)}Pe.to=we})(He=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Pe){function Le(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Pe.to=Le;function we(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Pe.from=we})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ge;(function(Pe){function Le(we){if(we===v.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(we===v.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(we===v.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${we}`)}Pe.to=Le})(Ge=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Pe){function Le(Z){switch(Z){case l.NotebookCellKind.Markup:return v.CellKind.Markup;case l.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Le;function we(Z){switch(Z){case v.CellKind.Markup:return l.NotebookCellKind.Markup;case v.CellKind.Code:default:return l.NotebookCellKind.Code}}Pe.to=we})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Xe;(function(Pe){function Le(Z){const Me={metadata:Z.metadata??Object.create(null),cells:[]};for(let xe of Z.cells)l.NotebookCellData.validate(xe),Me.cells.push(rt.from(xe));return Me}Pe.from=Le;function we(Z){const Me=new l.NotebookData(Z.cells.map(rt.to));return(0,A.isEmptyObject)(Z.metadata)||(Me.metadata=Z.metadata),Me}Pe.to=we})(Xe=e.NotebookData||(e.NotebookData={}));var rt;(function(Pe){function Le(Z){return{cellKind:Ze.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:qe.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(pt.from):[]}}Pe.from=Le;function we(Z){return new l.NotebookCellData(Ze.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(pt.to):void 0,Z.metadata,Z.internalMetadata?qe.to(Z.internalMetadata):void 0)}Pe.to=we})(rt=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(Pe){function Le(Z){return{mime:Z.mime,valueBytes:i.VSBuffer.wrap(Z.data)}}Pe.from=Le;function we(Z){return new l.NotebookCellOutputItem(Z.valueBytes.buffer,Z.mime)}Pe.to=we})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var pt;(function(Pe){function Le(Z){return{outputId:Z.id,items:Z.items.map(tt.from),metadata:Z.metadata}}Pe.from=Le;function we(Z){const Me=Z.items.map(tt.to);return new l.NotebookCellOutput(Me,Z.outputId,Z.metadata)}Pe.to=we})(pt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var nt;(function(Pe){function Le(Me){return Z(Me)?{include:(0,A.withNullAsUndefined)(ye.from(Me.include)),exclude:(0,A.withNullAsUndefined)(ye.from(Me.exclude))}:(0,A.withNullAsUndefined)(ye.from(Me))}Pe.from=Le;function we(Me){return Z(Me)?{include:ye.to(Me.include),exclude:ye.to(Me.exclude)}:ye.to(Me)}Pe.to=we;function Z(Me){const xe=Me;return xe?!(0,A.isUndefinedOrNull)(xe.include)&&!(0,A.isUndefinedOrNull)(xe.exclude):!1}})(nt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Pe){function Le(we){return{backgroundColor:we.backgroundColor,borderColor:we.borderColor,top:we.top?U.from(we.top):void 0}}Pe.from=Le})(ut=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Pt;(function(Pe){function Le(we,Z,Me){const xe=typeof we.command=="string"?{title:"",command:we.command}:we.command;return{alignment:we.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(xe,Me),text:we.text,tooltip:we.tooltip,accessibilityInformation:we.accessibilityInformation,priority:we.priority}}Pe.from=Le})(Pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Nt;(function(Pe){function Le(we){return{transientOutputs:we?.transientOutputs??!1,transientCellMetadata:we?.transientCellMetadata??{},transientDocumentMetadata:we?.transientDocumentMetadata??{}}}Pe.from=Le})(Nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(Pe){function Le(Z){return{uri:Z.uri,provides:Z.provides}}Pe.from=Le;function we(Z){return new l.NotebookRendererScript(L.URI.revive(Z.uri),Z.provides)}Pe.to=we})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Le(Z){return{message:O.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:o.from(Z.location.range),uri:Z.location.uri}}}Pe.from=Le;function we(Z){const Me=new l.TestMessage(typeof Z.message=="string"?Z.message:O.to(Z.message));return Me.actualOutput=Z.actual,Me.expectedOutput=Z.expected,Me.location=Z.location?ge.to(Z.location):void 0,Me}Pe.to=we})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(Pe){Pe.namespace=E.namespaceTestTag,Pe.denamespace=E.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var At;(function(Pe){function Le(Z){const Me=(0,m.getPrivateApiFor)(Z).controllerId;return{extId:g.TestId.fromExtHostTestItem(Z,Me).toString(),label:Z.label,uri:L.URI.revive(Z.uri),busy:!1,tags:Z.tags.map(xe=>Dt.namespace(Me,xe.id)),range:k.Range.lift(o.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&O.fromStrict(Z.error)||null}}Pe.from=Le;function we(Z){return{parent:void 0,error:void 0,id:g.TestId.fromString(Z.extId).localId,label:Z.label,uri:L.URI.revive(Z.uri),tags:(Z.tags||[]).map(Me=>{const{tagId:xe}=Dt.denamespace(Me);return new l.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:o.to(Z.range||void 0),canResolveChildren:!1,busy:!1,description:Z.description||void 0,sortText:Z.sortText||void 0}}Pe.toPlain=we})(At=e.TestItem||(e.TestItem={})),function(Pe){function Le(Z){return{id:Z.id}}Pe.from=Le;function we(Z){return new l.TestTag(Z.id)}Pe.to=we}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){const Le=(Z,Me)=>{const xe={...At.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(st=>({state:st.state,duration:st.duration,messages:st.messages.filter(Qe=>Qe.type===0).map(ft.to)})),children:Z.children.map(st=>Me.get(st)).filter(A.isDefined).map(st=>Le(st,Me))};for(const st of xe.children)st.parent=xe;return xe};function we(Z){const Me=[],xe=new Map;for(const st of Z.items)xe.set(st.item.extId,st),Z.request.targets.some(Qe=>Qe.controllerId===st.controllerId&&Qe.testIds.includes(st.item.extId))&&Me.push(st);return{completedAt:Z.completedAt,results:Me.map(st=>Le(st,xe))}}Pe.to=we})(Ft=e.TestResults||(e.TestResults={}));var Ke;(function(Pe){function Le(xe){return{covered:xe.covered,total:xe.covered}}function we(xe){return"line"in xe?r.from(xe):o.from(xe)}function Z(xe){return"branches"in xe?{count:xe.executionCount,location:we(xe.location),type:1,branches:xe.branches.length?xe.branches.map(st=>({count:st.executionCount,location:st.location&&we(st.location)})):void 0}:{type:0,count:xe.executionCount,location:we(xe.location)}}Pe.fromDetailed=Z;function Me(xe){return{uri:xe.uri,statement:Le(xe.statementCoverage),branch:xe.branchCoverage&&Le(xe.branchCoverage),function:xe.functionCoverage&&Le(xe.functionCoverage),details:xe.detailedCoverage?.map(Z)}}Pe.fromFile=Me})(Ke=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Pe){function Le(we){switch(we){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Pe.to=Le})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Rt;(function(Pe){function Le(Z){const Me=new l.TypeHierarchyItem(V.to(Z.kind),Z.name,Z.detail||"",L.URI.revive(Z.uri),o.to(Z.range),o.to(Z.selectionRange));return Me._sessionId=Z._sessionId,Me._itemId=Z._itemId,Me}Pe.to=Le;function we(Z,Me,xe){if(Me=Me??Z._sessionId,xe=xe??Z._itemId,Me===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:xe,kind:V.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:o.from(Z.range),selectionRange:o.from(Z.selectionRange),tags:Z.tags?.map(q.from)}}Pe.from=we})(Rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(Pe){function Le(we){if(!!we)return{value:we.value,tooltip:we.tooltip}}Pe.from=Le})(Mt=e.ViewBadge||(e.ViewBadge={}))}),define(Ie[221],ke([1,0,2,11,7,15,92]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(A,L,k,y={timeout:1500,errors:3}){this._logService=A,this._documents=L,this._mainThreadBulkEdits=k,this._thresholds=y,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(L,k,y)=>{const _={dispose:this._callbacks.push([L,k,A])};return Array.isArray(y)&&y.push(_),_}}async $participateInSave(A,L){const k=d.URI.revive(A);let y=!1;const T=setTimeout(()=>y=!0,this._thresholds.timeout),_=[];try{for(let m of[...this._callbacks]){if(y)break;const v=this._documents.getDocument(k),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:v,reason:P.TextDocumentSaveReason.to(L)});_.push(g)}}finally{clearTimeout(T)}return _}_deliverEventAsyncAndBlameBadListeners([A,L,k],y){const T=this._badListeners.get(A);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,A,L,y).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const m=this._badListeners.get(A);this._badListeners.set(A,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,L,k,y){const T=[],_=Date.now(),{document:m,reason:v}=y,{version:g}=m,E=Object.freeze({document:m,reason:v,waitUntil(h){if(Object.isFrozen(T))throw(0,i.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(h))}});try{L.apply(k,[E])}catch(h){return Promise.reject(h)}return Object.freeze(T),new Promise((h,l)=>{const f=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(f),h(o)}).catch(o=>{clearTimeout(f),l(o)})}).then(h=>{const l={edits:[]};for(const f of h)if(Array.isArray(f)&&f.every(o=>o instanceof C.TextEdit))for(const{newText:o,newEol:w,range:r}of f)l.edits.push({_type:2,resource:m.uri,edit:{range:r&&P.Range.from(r),text:o,eol:w&&P.EndOfLine.from(w)}});if(l.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(Ie[222],ke([1,0,10,2,15,7,128]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(k,y,T,_){this.start=k,this.deletedCount=y,this.deletedItems=T,this.items=_}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class b{constructor(k,y,T){this.notebook=k,this._extHostDocument=y,this._cellData=T,this.handle=T.handle,this.uri=i.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,y=this._extHostDocument.getDocument(this.uri);if(!y)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:y.document,get mime(){return k._mime},set mime(_){k._mime=_},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(C.NotebookCellOutput.to)}setOutputItems(k,y,T){const _=T.map(C.NotebookCellOutputItem.to),m=this._outputs.find(v=>v.id===k);m&&(y||(m.items.length=0),m.items.push(..._))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=b;class A{constructor(k,y,T,_,m){this._proxy=k,this._textDocumentsAndEditors=y,this._textDocuments=T,this.uri=_,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0,void 0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,y={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===d.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(m=>m.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(y)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,y,T){this._versionId=k.versionId,this._isDirty=y,this.acceptDocumentPropertiesChanged({metadata:T});const _={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},m=[];for(const g of k.rawEvents)g.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1,_.contentChanges):g.kind===I.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx,_.contentChanges):g.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(g.index,g.outputs),m.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems),m.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(g.index,g.language),m.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document})):g.kind===I.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document}):g.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(g.index,g.metadata),m.push({cell:this._cells[g.index].apiCell,metadata:this._cells[g.index].apiCell.metadata})):g.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(g.index,g.internalMetadata),m.push({cell:this._cells[g.index].apiCell,executionSummary:this._cells[g.index].apiCell.executionSummary}));const v=new Map;for(let g=0;g<m.length;g++){const E=m[g],h=v.get(E.cell);if(h===void 0){const l=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...E});v.set(E.cell,l-1)}else _.cellChanges[h]={..._.cellChanges[h],...E}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let y=k.start|0,T=k.end|0;return y<0&&(y=0),T>this._cells.length&&(T=this._cells.length),k.with({start:y,end:T})}_getCells(k){k=this._validateRange(k);const y=[];for(let T=k.start;T<k.end;T++)y.push(this._cells[T]);return y}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,y,T){if(this._disposed)return;const _=[],m=[],v=[];if(k.reverse().forEach(g=>{const h=g[2].map(o=>{const w=new b(this,this._textDocumentsAndEditors,o);return y||m.push(b.asModelAddData(this.apiNotebook,o)),w}),l=new D(g[0],g[1],[],h),f=this._cells.splice(g[0],g[1],...h);for(const o of f)v.push(o.uri),l.deletedItems.push(o.apiCell);_.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:v}),T)for(let g of _)T.push(g.asApiEvent())}_moveCell(k,y,T){const _=this._cells.splice(k,1);this._cells.splice(y,0,..._);const m=[new D(k,1,_.map(v=>v.apiCell),[]),new D(y,0,[],_)];for(const v of m)T.push(v.asApiEvent())}_setCellOutputs(k,y){this._cells[k].setOutputs(y)}_setCellOutputItems(k,y,T,_){this._cells[k].setOutputItems(y,T,_)}_changeCellLanguage(k,y){const T=this._cells[k];T.apiCell.document.languageId!==y&&this._textDocuments.$acceptModelLanguageChanged(T.uri,y)}_changeCellMime(k,y){const T=this._cells[k];T.apiCell.mime=y}_changeCellMetadata(k,y){this._cells[k].setMetadata(y)}_changeCellInternalMetadata(k,y){this._cells[k].setInternalMetadata(y)}getCellFromApiCell(k){return this._cells.find(y=>y.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(y=>y.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Ie[131],ke([1,0,7,15,11]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:A})}replaceCells(b,A,L){this._throwIfFinalized(),!(b===A&&L.length===0)&&this._collectedEdits.push({editType:1,index:b,count:A-b,cells:L.map(i.NotebookCellData.from)})}}class I{constructor(b,A,L,k,y,T){this.id=b,this._proxy=A,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._visibleRanges=k,this._viewColumn=T}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get selections(){return b._selections},set selections(A){if(!Array.isArray(A)||!A.every(d.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");b._selections=A,b._trySetSelections(A)},get visibleRanges(){return b._visibleRanges},revealRange(A,L){b._proxy.$tryRevealRange(b.id,i.NotebookRange.from(A),L??d.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(A){const L=new P(this.document.version);return A(L),b._applyEdit(L.finalize())},setDecorations(A,L){return b.setDecorations(A,L)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(i.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const A=[];let L=-1;for(let k=0;k<b.cellEdits.length;k++){if(L<0){A.push(b.cellEdits[k]),L++;continue}const T=A[L],_=b.cellEdits[k];if(T.editType===1&&_.editType===1&&T.index===_.index){T.cells.push(...b.cellEdits[k].cells),T.count+=b.cellEdits[k].count;continue}A.push(b.cellEdits[k]),L++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,A)}setDecorations(b,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return A.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(A),b.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(Ie[223],ke([1,0,15,118,173,21,57,11]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}async withProgress(y,T,_){const m=this._handles++,{title:v,location:g,cancellable:E}=T,h={label:(0,C.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this._proxy.$startProgress(m,{location:d.ProgressLocation.from(g),title:v,source:h,cancellable:E},y.isUnderDevelopment?void 0:y.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(m,_,!!E)}_withProgress(y,T,_){let m;_&&(m=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,m));const v=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),m&&m.dispose()};let g;try{g=T(new L(this._proxy,y),_&&m?m.token:P.CancellationToken.None)}catch(E){throw v(y),E}return g.then(E=>v(y),E=>v(y)),g}$acceptProgressCanceled(y){const T=this._mapHandleToCancellationSource.get(y);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=b;function A(k,y){return k.message=y.message,typeof y.increment=="number"&&(typeof k.increment=="number"?k.increment+=y.increment:k.increment=y.increment),k}class L extends i.Progress{constructor(y,T){super(_=>this.throttledReport(_));this._proxy=y,this._handle=T}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ve([(0,I.throttle)(100,(k,y)=>A(k,y),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ie[132],ke([1,0,36,129,66,88,67,15,2]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const A=(h,l,f,o)=>{let w=l;return{enumerable:!0,configurable:!1,get(){return w},set(r){if(!f(w,r)){const s=w;w=r,h.listener?.(o(r,s))}}}},L=(h,l)=>h===l,k={range:(h,l)=>h===l?!0:!h||!l?!1:h.isEqual(l),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(h,l)=>!(h.length!==l.length||h.some(f=>!l.find(o=>f.id===o.id)))},y=h=>l=>({op:4,update:h(l)}),T=(h,l)=>({range:A(h,void 0,k.range,y(f=>({range:d.Range.lift(D.Range.from(f))}))),label:A(h,l,k.label,y(f=>({label:f}))),description:A(h,void 0,k.description,y(f=>({description:f}))),sortText:A(h,void 0,k.sortText,y(f=>({sortText:f}))),canResolveChildren:A(h,!1,k.canResolveChildren,f=>({op:2,state:f})),busy:A(h,!1,k.busy,y(f=>({busy:f}))),error:A(h,void 0,k.error,y(f=>({error:D.MarkdownString.fromStrict(f)||null}))),tags:A(h,[],k.tags,(f,o)=>({op:1,new:f.map(D.TestTag.from),old:o.map(D.TestTag.from)}))}),_=h=>{const l=C.TestId.fromString(h.extId),f=new v(l.controllerId,l.localId,h.label,b.URI.revive(h.uri)||void 0);return f.range=D.Range.to(h.range||void 0),f.description=h.description||void 0,f.sortText=h.sortText||void 0,f.tags=h.tags.map(o=>D.TestTag.to({id:(0,I.denamespaceTestTag)(o).tagId})),f},m=h=>{let l;for(const f of h.tests){const o=_(f.item);(0,i.getPrivateApiFor)(o).parent=l,l=o}return l};e.toItemFromContext=m;class v{constructor(l,f,o,w){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const r=(0,i.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:w,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof g?void 0:r.parent}},children:{value:(0,P.createTestItemChildren)(r,i.getPrivateApiFor,v),enumerable:!0,writable:!1},...T(r,o)})}}e.TestItemImpl=v;class g extends v{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=g;class E extends P.TestItemCollection{constructor(l,f){super({controllerId:l,getApiFor:i.getPrivateApiFor,getChildren:o=>o.children,root:new g(l,f),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=E}),define(Ie[133],ke([1,0,55,11,78,15,7]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(y,T,_){const m=D._Keys.nextId();y.$registerTextEditorDecorationType(T.identifier,m,P.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:m,dispose(){y.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=D,D._Keys=new C.IdGenerator("TextEditorDecorationType");class b{constructor(y,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=y,this._documentVersionId=y.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(y,T){this._throwIfFinalized();let _=null;if(y instanceof I.Position)_=new I.Range(y,y);else if(y instanceof I.Range)_=y;else throw new Error("Unrecognized location");this._pushEdit(_,T,!1)}insert(y,T){this._throwIfFinalized(),this._pushEdit(new I.Range(y,y),T,!0)}delete(y){this._throwIfFinalized();let T=null;if(y instanceof I.Range)T=y;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(y,T,_){const m=this._document.validateRange(y);this._collectedEdits.push({range:m,text:T,forceMoveMarkers:_})}setEndOfLine(y){if(this._throwIfFinalized(),y!==I.EndOfLine.LF&&y!==I.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=y}}e.TextEditorEdit=b;class A{constructor(y,T,_,m){this._proxy=y,this._id=T,this._accept(_),this._logService=m;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(g){v._setTabSize(g)},get insertSpaces(){return v._insertSpaces},set insertSpaces(g){v._setInsertSpaces(g)},get cursorStyle(){return v._cursorStyle},set cursorStyle(g){v._setCursorStyle(g)},get lineNumbers(){return v._lineNumbers},set lineNumbers(g){v._setLineNumbers(g)}}}_accept(y){this._tabSize=y.tabSize,this._insertSpaces=y.insertSpaces,this._cursorStyle=y.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(y.lineNumbers)}_validateTabSize(y){if(y==="auto")return"auto";if(typeof y=="number"){const T=Math.floor(y);return T>0?T:null}if(typeof y=="string"){const T=parseInt(y,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(y){const T=this._validateTabSize(y);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(y){return y==="auto"?"auto":y==="false"?!1:Boolean(y)}_setInsertSpaces(y){const T=this._validateInsertSpaces(y);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(y){this._cursorStyle!==y&&(this._cursorStyle=y,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:y})))}_setLineNumbers(y){this._lineNumbers!==y&&(this._lineNumbers=y,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(y)})))}assign(y){const T={};let _=!1;if(typeof y.tabSize!="undefined"){const m=this._validateTabSize(y.tabSize);m==="auto"?(_=!0,T.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,_=!0,T.tabSize=m)}if(typeof y.insertSpaces!="undefined"){const m=this._validateInsertSpaces(y.insertSpaces);m==="auto"?(_=!0,T.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,_=!0,T.insertSpaces=m)}typeof y.cursorStyle!="undefined"&&this._cursorStyle!==y.cursorStyle&&(this._cursorStyle=y.cursorStyle,_=!0,T.cursorStyle=y.cursorStyle),typeof y.lineNumbers!="undefined"&&this._lineNumbers!==y.lineNumbers&&(this._lineNumbers=y.lineNumbers,_=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(y.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(y,T){T.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${y}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=A;class L{constructor(y,T,_,m,v,g,E,h){this.id=y,this._proxy=T,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new A(this._proxy,this.id,g,_),this._visibleRanges=E,this._viewColumn=h;const l=this;this.value=Object.freeze({get document(){return m.getValue()},set document(f){throw(0,i.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(f){if(!(f instanceof I.Selection))throw(0,i.illegalArgument)("selection");l._selections=[f],l._trySetSelection()},get selections(){return l._selections},set selections(f){if(!Array.isArray(f)||f.some(o=>!(o instanceof I.Selection)))throw(0,i.illegalArgument)("selections");l._selections=f,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(f){throw(0,i.readonly)("visibleRanges")},get options(){return l._options.value},set options(f){l._disposed||l._options.assign(f)},get viewColumn(){return l._viewColumn},set viewColumn(f){throw(0,i.readonly)("viewColumn")},edit(f,o={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const w=new b(m.getValue(),o);return f(w),l._applyEdit(w)},insertSnippet(f,o,w={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=l._selections.map(s=>P.Range.from(s));else if(o instanceof I.Position){const{lineNumber:s,column:n}=P.Position.from(o);r=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(o instanceof I.Range)r=[P.Range.from(o)];else{r=[];for(const s of o)if(s instanceof I.Range)r.push(P.Range.from(s));else{const{lineNumber:n,column:t}=P.Position.from(s);r.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return T.$tryInsertSnippet(y,m.getValue().version,f.value,r,w)},setDecorations(f,o){const w=o.length===0;w&&!l._hasDecorationsForKey.has(f.key)||(w?l._hasDecorationsForKey.delete(f.key):l._hasDecorationsForKey.add(f.key),l._runOnProxy(()=>{if(P.isDecorationOptionsArr(o))return T.$trySetDecorations(y,f.key,P.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let s=0,n=o.length;s<n;s++){const t=o[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return T.$trySetDecorationsFast(y,f.key,r)}}))},revealRange(f,o){l._runOnProxy(()=>T.$tryRevealRange(y,P.Range.from(f),o||I.TextEditorRevealType.Default))},show(f){T.$tryShowEditor(y,P.ViewColumn.from(f))},hide(){T.$tryHideEditor(y)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(y){(0,d.ok)(!this._disposed),this._options._accept(y)}_acceptVisibleRanges(y){(0,d.ok)(!this._disposed),this._visibleRanges=y}_acceptViewColumn(y){(0,d.ok)(!this._disposed),this._viewColumn=y}_acceptSelections(y){(0,d.ok)(!this._disposed),this._selections=y}async _trySetSelection(){const y=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,y)),this.value}_applyEdit(y){const T=y.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const _=T.edits.map(v=>v.range);_.sort((v,g)=>v.end.line===g.end.line?v.end.character===g.end.character?v.start.line===g.start.line?v.start.character-g.start.character:v.start.line-g.start.line:v.end.character-g.end.character:v.end.line-g.end.line);for(let v=0,g=_.length-1;v<g;v++){const E=_[v].end;if(_[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=T.edits.map(v=>({range:P.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,m,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(y){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):y().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(Ie[224],ke([1,0,4,190]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(i.IEnvironmentService)}),define(Ie[225],ke([1,0,28,3,9]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=P;class I{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let k of L.activationEvents)k==="onUri"&&(k=`onUri:${d.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(L)}}set(L){this._extensionDescriptions=L,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,k){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const y=I._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(y.map(T=>T.identifier)),k.length>0){const T=new Set;k.forEach(_=>T.add(d.ExtensionIdentifier.toKey(_))),this._extensionDescriptions=this._extensionDescriptions.filter(_=>!T.has(d.ExtensionIdentifier.toKey(_.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(y)}static _findLoopingExtensions(L){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,g){this.addNode(v),this.addNode(g),this._arcs.has(v)?this._arcs.get(v).push(g):this._arcs.set(v,[g])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,g){const E=k.getArcs(v);for(let h=0;h<E.length;h++)if(!g.has(E[h]))return!1;return!0}getNodes(){return this._nodesArr}};let y=new Map;for(let v of L){const g=d.ExtensionIdentifier.toKey(v.identifier);if(y.set(g,v),v.extensionDependencies)for(let E of v.extensionDependencies){const h=d.ExtensionIdentifier.toKey(E);k.addArc(g,h)}}let T=new Set;k.getNodes().filter(v=>k.getArcs(v).length===0).forEach(v=>T.add(v));let _=k.getNodes().filter(v=>!T.has(v)),m;do{m=!1;for(let v=0;v<_.length;v++){const g=_[v];k.hasOnlyGoodArcs(g,T)&&(_.splice(v,1),v--,T.add(g),m=!0)}}while(m);return _.map(v=>y.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const k=this._activationMap.get(L);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const k=this._extensionsMap.get(d.ExtensionIdentifier.toKey(L));return k||void 0}}e.ExtensionDescriptionRegistry=I;var D;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(D||(D={}));function b(A,L){const k=A.isBuiltin?0:A.isUnderDevelopment?2:1,y=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(k!==y)return k-y;const T=C.posix.basename(A.extensionLocation.path),_=C.posix.basename(L.extensionLocation.path);return T<_?-1:T>_?1:0}}),define(Ie[134],ke([1,0,23]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var i;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(i=e.UIKind||(e.UIKind={}));var C;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function I(b){const A=d.VSBuffer.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=I;function D(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=D}),define(Ie[25],ke([1,0,3,2,4,28,199]),function(Y,e,d,i,C,P,I){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class A{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=A;class L{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(t){this.dependency=t}}e.MissingExtensionDependency=k;var y;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class _{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,a){const u=[],c=[],S=[],R=[],O=g(this._allExtensions),N=g(t),p=(re,H)=>re.extensionLocation.toString()===H.extensionLocation.toString()||re.isBuiltin===H.isBuiltin||re.isUserBuiltin===H.isUserBuiltin||re.isUnderDevelopment===H.isUnderDevelopment;for(const re of this._allExtensions){const H=N.get(P.ExtensionIdentifier.toKey(re.identifier));if(!H){u.push(re.identifier),O.delete(P.ExtensionIdentifier.toKey(re.identifier));continue}if(!p(re,H)){u.push(re.identifier),O.delete(P.ExtensionIdentifier.toKey(re.identifier));continue}}for(const re of t){const H=O.get(P.ExtensionIdentifier.toKey(re.identifier));if(!H){c.push(re);continue}if(!p(H,re)){u.push(H.identifier),O.delete(P.ExtensionIdentifier.toKey(H.identifier));continue}}const U=v(this._myExtensions),B=v(a);for(const re of this._myExtensions)B.has(P.ExtensionIdentifier.toKey(re))||S.push(re);for(const re of a)U.has(P.ExtensionIdentifier.toKey(re))||R.push(re);const z={toRemove:u,toAdd:c,myToRemove:S,myToAdd:R};return this.delta(z),z}delta(t){const{toRemove:a,toAdd:u,myToRemove:c,myToAdd:S}=t,R=v(a),O=v(c);for(let N=0;N<this._allExtensions.length;N++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[N].identifier))&&(this._allExtensions.splice(N,1),N--);for(let N=0;N<this._myExtensions.length;N++)O.has(P.ExtensionIdentifier.toKey(this._myExtensions[N]))&&(this._myExtensions.splice(N,1),N--);for(const N of u)this._allExtensions.push(N);for(const N of S)this._myExtensions.push(N)}containsExtension(t){for(const a of this._myExtensions)if(P.ExtensionIdentifier.equals(a,t))return!0;return!1}}e.ExtensionHostExtensions=_;class m{constructor(t){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,t)for(const a of t)this.add(a)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,a){this._map.forEach(u=>t.call(a,u,u,this))}*entries(){for(let[t,a]of this._map)yield[a,a]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=m;function v(n){const t=new Set;for(const a of n)t.add(P.ExtensionIdentifier.toKey(a));return t}e.extensionIdentifiersArrayToSet=v;function g(n){const t=new Map;for(const a of n)t.set(P.ExtensionIdentifier.toKey(a.identifier),a);return t}function E(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=E;function h(n,t){if(!E(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=h;class l{constructor(t,a,u,c){this.codeLoadingTime=t,this.activateCallTime=a,this.activateResolvedTime=u,this.activationReason=c}}e.ActivationTimes=l;class f{constructor(t,a){this.description=t,this.value=a}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var o;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function w(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=w;function r(n,t){return{identifier:new P.ExtensionIdentifier((0,I.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,a){return Promise.resolve(0)}getInspectPorts(t,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,a){return Promise.resolve()}}e.NullExtensionService=s}),define(Ie[226],ke([1,0,11,28,25,13,17]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(v,g,E,h){this.startup=v,this.codeLoadingTime=g,this.activateCallTime=E,this.activateResolvedTime=h}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class b{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,g){return v===-1||g===-1?-1:g-v}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class A{constructor(v,g,E,h,l,f){this.activationFailed=v,this.activationFailedError=g,this.activationTimes=E,this.module=h,this.exports=l,this.subscriptions=f}}e.ActivatedExtension=A;class L extends A{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class k extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class y extends A{constructor(v){super(!0,v,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let T=class{constructor(v,g,E,h,l){this._logService=l,this._registry=v,this._resolvedExtensionsSet=new Set,g.forEach(f=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(f))),this._externalExtensionsMap=new Map,E.forEach(f=>this._externalExtensionsMap.set(i.ExtensionIdentifier.toKey(f),f)),this._host=h,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,g]of this._operations)g.dispose()}isActivated(v){const g=this._operations.get(i.ExtensionIdentifier.toKey(v));return Boolean(g&&g.value)}getActivatedExtension(v){const g=this._operations.get(i.ExtensionIdentifier.toKey(v));if(!g||!g.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return g.value}async activateByEvent(v,g){if(this._alreadyActivatedEvents[v])return;const E=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(E.map(h=>({id:h.identifier,reason:{startup:g,extensionId:h.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,g){const E=this._registry.getExtensionDescription(v);if(!E)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:E.identifier,reason:g}])}async _activateExtensions(v){const g=v.filter(E=>!this.isActivated(E.id)).map(E=>this._handleActivationRequest(E));await Promise.all(g.map(E=>E.wait()))}_handleActivationRequest(v){if(this._operations.has(i.ExtensionIdentifier.toKey(v.id)))return this._operations.get(i.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const g=this._registry.getExtensionDescription(v.id);if(!g){const l=new Error(`Cannot activate unknown extension '${v.id.value}'`),f=this._createAndSaveOperation(v,null,[],new y(l));return this._host.onExtensionActivationError(v.id,l,new C.MissingExtensionDependency(v.id.value)),f}const E=[],h=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;for(const l of h){if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(l)))continue;const f=this._operations.get(i.ExtensionIdentifier.toKey(l));if(f){E.push(f);continue}if(this._externalExtensionsMap.has(i.ExtensionIdentifier.toKey(l))){E.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(i.ExtensionIdentifier.toKey(l)),reason:v.reason}));continue}const o=this._registry.getExtensionDescription(l);if(o){if(!o.main&&!o.browser)continue;E.push(this._handleActivationRequest({id:o.identifier,reason:v.reason}));continue}const w=g.displayName||g.identifier.value,r=new Error(`Cannot activate the '${w}' extension because it depends on unknown extension '${l}'`),s=this._createAndSaveOperation(v,g.displayName,[],new y(r));return this._host.onExtensionActivationError(g.identifier,r,new C.MissingExtensionDependency(l)),s}return this._createAndSaveOperation(v,g.displayName,E,null)}_createAndSaveOperation(v,g,E,h){const l=new _(v.id,g,v.reason,E,h,this._host,this._logService);return this._operations.set(i.ExtensionIdentifier.toKey(v.id),l),l}};T=Ve([$e(4,P.ILogService)],T),e.ExtensionsActivator=T;let _=class{constructor(v,g,E,h,l,f,o){this._id=v,this._displayName=g,this._reason=E,this._deps=h,this._value=l,this._host=f,this._logService=o,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const g=this._deps[v];if(g.value&&!g.value.activationFailed){this._deps.splice(v,1),v--;continue}if(g.value&&g.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);E.detail=g.value.activationFailedError,this._value=new y(E),this._host.onExtensionActivationError(this._id,E,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const g=new Error;if(v&&v.name&&(g.name=v.name),v&&v.message?g.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(g.stack=v.stack),this._value=new y(g),this._isDisposed&&d.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};_=Ve([$e(6,P.ILogService)],_)}),define(Ie[227],ke([1,0,13,27,25]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends d.LogService{constructor(D,b){super(D.createLogger(b.logFile,{name:C.ExtensionHostLogFileName}))}};P=Ve([$e(0,d.ILoggerService),$e(1,i.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ie[228],ke([1,0,11]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,I)=>{this._actualOk=P,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,d.onUnexpectedError)(P))}then(P,I){return this._ensureActual().then(P,I)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=i}),define(Ie[52],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const i=[];function C(D){const b=new d(D);return i[b.nid]=b,b}e.createProxyIdentifier=C;function P(D){return i[D].sid}e.getStringIdentifierForProxy=P;class I{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=I}),define(Ie[5],ke([1,0,60,2,52]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.NotebookInput=3]="NotebookInput",h[h.NotebookDiffInput=4]="NotebookDiffInput",h[h.CustomEditorInput=5]="CustomEditorInput",h[h.WebviewEditorInput=6]="WebviewEditorInput",h[h.TerminalEditorInput=7]="TerminalEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var D;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var b;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(b=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(l){return l._id=T._n++,l}}e.IdObject=T,T._n=0;var _;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(_=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(h){if(h&&h.edits)for(const l of h.edits)typeof l.resource=="object"?l.resource=i.URI.revive(l.resource):(l.newUri=i.URI.revive(l.newUri),l.oldUri=i.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,d.revive)(l.metadata));return h}e.reviveWorkspaceEditDto=g;var E;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,C.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,C.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookProxyKernels:(0,C.createProxyIdentifier)("MainThreadNotebookProxyKernels"),MainThreadNotebookRenderers:(0,C.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookProxyKernels:(0,C.createProxyIdentifier)("ExtHostNotebookProxyKernels"),ExtHostNotebookRenderers:(0,C.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[89],ke([1,0,5,3,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(D){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,b){return this._proxy.$getPassword(D,b)}store(D,b,A){return this._proxy.$setPassword(D,b,A)}delete(D,b){return this._proxy.$deletePassword(D,b)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(Ie[68],ke([1,0,4,13,5,18]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(b,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(C.MainContext.MainThreadTelemetry)}report(b,A,L){const k=this.getUsageKey(b,A);this._reportedUsages.has(k)||(this._reportedUsages.add(k),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:b}))}getUsageKey(b,A){return`${b}-${A.identifier.value}`}};I=Ve([$e(0,P.IExtHostRpcService),$e(1,i.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(D,b,A){}})}),define(Ie[229],ke([1,0,3,5,7,28]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,A,L,k={}){const y=P.ExtensionIdentifier.toKey(b.identifier),T=this._inFlightRequests.get(y)||[],_=[...L].sort().join(" ");let m=T.find(v=>v.scopes===_);if(m)return m.result;{const v=this._getSession(b,y,A,L,k);m={scopes:_,result:v},T.push(m),this._inFlightRequests.set(y,T);try{await v}finally{const g=T.findIndex(E=>E.scopes===_);g>-1&&(T.splice(g),this._inFlightRequests.set(y,T))}return v}}async _getSession(b,A,L,k,y={}){await this._proxy.$ensureProvider(L);const T=b.displayName||b.name;return this._proxy.$getSession(L,k,A,T,y)}async removeSession(b,A){const L=this._authenticationProviders.get(b);return L?L.provider.removeSession(A):this._proxy.$removeSession(b,A)}registerAuthenticationProvider(b,A,L,k){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:A,provider:L,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===b)||this._providers.push({id:b,label:A});const y=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(b,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,A,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{y.dispose(),this._authenticationProviders.delete(b);const T=this._providers.findIndex(_=>_.id===b);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,A){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this._onDidChangeSessions.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ie[230],ke([1,0,5,18,15]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(D,b){this._proxy=D.getProxy(d.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:A=>b.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(D){const b=C.WorkspaceEdit.from(D,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(b)}};P=Ve([$e(0,i.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Ie[231],ke([1,0,5]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(P){const I=P.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(D){return I.$writeText(D)}})}}e.ExtHostClipboard=i});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[37],ke([1,0,14,7,15,26,5,16,13,60,36,49,2,6,4,18,132,23,52,50]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(a,u){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,f.set(this,void 0),et(this,l,a.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=u,et(this,f,a.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new w(this,c=>{const S=this._apiCommands.get(c);return S?.result===s.Void?S:void 0},u),this._argumentProcessors=[{processArgument(c){return(0,A.revive)(c)}},{processArgument(c){return(0,P.cloneAndChange)(c,function(S){if(L.Range.isIRange(S))return C.Range.to(S);if(k.Position.isIPosition(S))return C.Position.to(S);if(L.Range.isIRange(S.range)&&y.URI.isUri(S.uri))return C.location.to(S);if(S instanceof g.VSBuffer)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(a){this._argumentProcessors.push(a)}registerApiCommand(a){const u=this.registerCommand(!1,a.id,async(...c)=>{const S=a.args.map((O,N)=>{if(!O.validate(c[N]))throw new Error(`Invalid argument '${O.name}' when running '${a.id}', received: ${c[N]}`);return O.convert(c[N])}),R=await this.executeCommand(a.internalId,...S);return a.result.convert(R,c,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this._apiCommands.set(a.id,a),new i.Disposable(()=>{u.dispose(),this._apiCommands.delete(a.id)})}registerCommand(a,u,c,S,R,O){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:c,thisArg:S,description:R,extension:O}),a&&Ue(this,l,"f").$registerCommand(u),new i.Disposable(()=>{this._commands.delete(u)&&a&&Ue(this,l,"f").$unregisterCommand(u)})}executeCommand(a,...u){return this._logService.trace("ExtHostCommands#executeCommand",a),this._doExecuteCommand(a,u,!0)}async _doExecuteCommand(a,u,c){if(this._commands.has(a))return this._executeContributedCommand(a,u,!1);{let S=!1;const R=(0,P.cloneAndChange)(u,function(O){if(O instanceof i.Position)return C.Position.from(O);if(O instanceof i.Range)return C.Range.from(O);if(O instanceof i.Location)return C.location.from(O);if(i.NotebookRange.isNotebookRange(O))return C.NotebookRange.from(O);if(O instanceof ArrayBuffer)return S=!0,g.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return S=!0,g.VSBuffer.wrap(O);if(O instanceof g.VSBuffer)return S=!0,O;if(!Array.isArray(O))return O});try{const O=await Ue(this,l,"f").$executeCommand(a,S?new E.SerializableObjectWithBuffers(R):R,c);return(0,A.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(a,u,!1);throw O}}}async _executeContributedCommand(a,u,c){const S=this._commands.get(a);if(!S)throw new Error("Unknown command");this._reportTelemetry(S,a);let{callback:R,thisArg:O,description:N}=S;if(N)for(let p=0;p<N.args.length;p++)try{(0,d.validateConstraint)(u[p],N.args[p].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${N.args[p].name}' - ${N.args[p].description}`)}try{return await R.apply(O,u)}catch(p){if(a===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...u);U&&(a=U.command)}throw this._logService.error(p,a,S.extension?.identifier),c?new class extends Error{constructor(){super((0,h.toErrorMessage)(p));this.id=a,this.source=S.extension?.displayName??S.extension?.name}}:p}}_reportTelemetry(a,u){!a.extension||a.extension.isBuiltin||Ue(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:u})}$executeContributedCommand(a,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",a),this._commands.has(a)?(u=u.map(c=>this._argumentProcessors.reduce((S,R)=>R.processArgument(S),c)),this._executeContributedCommand(a,u,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this._logService.trace("ExtHostCommands#getCommands",a),Ue(this,l,"f").$getCommands().then(u=>(a&&(u=u.filter(c=>c[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(let[u,c]of this._commands){let{description:S}=c;S&&(a[u]=S)}return Promise.resolve(a)}};l=new WeakMap,f=new WeakMap,o=Ve([$e(0,m.IExtHostRpcService),$e(1,b.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class w{constructor(a,u,c){this._commands=a,this._lookupApiCommand=u,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(a,u){if(!a)return;const c={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return c;const S=this._lookupApiCommand(a.command);if(S)c.id=S.internalId,c.arguments=S.args.map((R,O)=>R.convert(a.arguments&&a.arguments[O]));else if((0,D.isNonEmptyArray)(a.arguments)){const R=++this._cachIdPool;this._cache.set(R,a),u.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),c.$ident=R,c.id=this.delegatingCommandId,c.arguments=[R],this._logService.trace("CommandsConverter#CREATE",a.command,R)}return c}fromInternal(a){return typeof a.$ident=="number"?this._cache.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this._cache.get(a[0])}_executeConvertedCommand(...a){const u=this.getActualCommand(...a);return this._logService.trace("CommandsConverter#EXECUTE",a[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class r{constructor(a,u,c,S){this.name=a,this.description=u,this.validate=c,this.convert=S}optional(){return new r(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,u){return new r(a??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>y.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>i.Position.isPosition(t),C.Position.from),r.Range=new r("range","A range in a text document",t=>i.Range.isRange(t),C.Range.from),r.Selection=new r("selection","A selection in a text document",t=>i.Selection.isSelection(t),C.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,C.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,C.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,C.TestItem.from);class s{constructor(a,u){this.description=a,this.convert=u}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(a,u,c,S,R){this.id=a,this.internalId=u,this.description=c,this.args=S,this.result=R}}e.ApiCommand=n}),define(Ie[232],ke([1,0,2,15,7,63,37,16,111,117,10]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(i.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,v)=>{if((0,D.isFalsyOrEmpty)(m))return;class g extends C.SymbolInformation{static to(h){const l=new g(h.name,i.SymbolKind.to(h.kind),h.containerName||"",new C.Location(v[0],i.Range.to(h.range)));return l.detail=h.detail,l.range=l.location.range,l.selectionRange=i.Range.to(h.selectionRange),l.children=h.children?h.children.map(g.to):[],l}}return m.map(g.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(i.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(i.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(i.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(v=>C.Position.isPosition(v)),m=>m.map(i.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(v=>{let g;for(const E of v.reverse())g=new C.SelectionRange(i.Range.to(E),g);return g}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(i.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",m=>m.map(i.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:i.Range.to(m.range),placeholder:m.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return i.WorkspaceEdit.to(m)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(i.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new C.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const v=(0,b.decodeSemanticTokensDto)(m);if(v.type==="full")return new C.SemanticTokens(v.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new C.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const v=(0,b.decodeSemanticTokensDto)(m);if(v.type==="full")return new C.SemanticTokens(v.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,v,g)=>{if(!m)return new C.CompletionList([]);const E=m.suggestions.map(h=>i.CompletionItem.to(h,g));return new C.CompletionList(E,m.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return i.SignatureHelp.to(m)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,v,g)=>T(E=>new C.CodeLens(i.Range.to(E.range),E.command&&g.fromInternal(E.command)))(m))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>C.Range.isRange(m),m=>C.Selection.isSelection(m)?i.Selection.from(m):i.Range.from(m)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,v,g)=>T(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(E.command)}else{const h=new C.CodeAction(E.title,E.kind?new C.CodeActionKind(E.kind):void 0);return E.edit&&(h.edit=i.WorkspaceEdit.to(E.edit)),E.command&&(h.command=g.fromInternal(E.command)),h.isPreferred=E.isPreferred,h}})(m))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(v=>new C.ColorInformation(i.Range.to(v.range),i.Color.to(v.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",m=>m instanceof C.Color,i.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:i.Range.from(m.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(i.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,v,g)=>m.map(i.InlayHint.to.bind(void 0,g)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(v=>i.NotebookExclusiveDocumentPattern.to(v))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(i.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>d.URI.isUri(m)||typeof m=="string"&&(0,A.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[i.ViewColumn.from(m),void 0]:[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[i.ViewColumn.from(m),void 0]:[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[i.ViewColumn.from(m.viewColumn),i.TextEditorOpenOptions.from(m)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",m=>m.map(i.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class y{static register(v){k.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=y;function T(m){return v=>{if(Array.isArray(v))return v.map(m)}}function _(m){if(!Array.isArray(m))return;const v=[];for(const g of m)P.isLocationLink(g)?v.push(i.DefinitionLink.to(g)):v.push(i.location.to(g));return v}}),define(Ie[233],ke([1,0,17,57,3,6,2,63,28,15,7,25,5]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(_,m,v){const g=_.getProxy(y.MainContext.MainThreadComments);class E{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,m.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const a=this._commentControllers.get(t.handle);return a?a.value:t}else if(t&&t.$mid===7){const a=this._commentControllers.get(t.commentControlHandle);if(!a)return t;const u=a.getCommentThread(t.commentThreadHandle);return u?u.value:t}else if(t&&t.$mid===8){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const u=a.getCommentThread(t.thread.commentThreadHandle);return u?{thread:u.value,text:t.text}:t}else if(t&&t.$mid===9){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const u=a.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let c=t.commentUniqueId,S=u.getCommentByUniqueId(c);return S||t}else if(t&&t.$mid===10){const a=this._commentControllers.get(t.thread.commentControlHandle);if(!a)return t;const u=a.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let c=t.text,S=t.commentUniqueId,R=u.getCommentByUniqueId(S);return R?(R.body=c,R):t}return t}})}createCommentController(t,a,u){const c=E.handlePool++,S=new l(t,c,a,u);this._commentControllers.set(S.handle,S);const R=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(S),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),R),S.value}$createCommentThreadTemplate(t,a,u){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(a,u)}async $updateCommentThreadTemplate(t,a,u){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(a,u)}$deleteCommentThread(t,a){const u=this._commentControllers.get(t);u&&u.$deleteCommentThread(a)}$provideCommentingRanges(t,a,u){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const S=v.getDocument(I.URI.revive(a));return(0,d.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(S,u)).then(R=>R?R.map(O=>A.Range.from(O)):void 0)}$toggleReaction(t,a,u,c,S){const R=this._commentControllers.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const O=R.getCommentThread(a);if(O){const N=O.getCommentByUniqueId(c.uniqueIdInThread);if(R!==void 0&&N&&R.reactionHandler)return R.reactionHandler(N,w(S))}return Promise.resolve(void 0)})}dispose(){}}E.handlePool=0;class h{constructor(t,a,u,c,S,R,O,N){this._commentControllerHandle=a,this._id=u,this._uri=c,this._range=S,this._comments=R,this.extensionDescription=O,this._isTemplate=N,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),g.$createCommentThread(a,this.handle,this._id,this._uri,A.Range.from(this._range),O.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(a,this.handle)}});const p=this;this.value={get uri(){return p.uri},get range(){return p.range},set range(U){p.range=U},get comments(){return p.comments},set comments(U){p.comments=U},get collapsibleState(){return p.collapsibleState},set collapsibleState(U){p.collapsibleState=U},get canReply(){return p.canReply},set canReply(U){p.canReply=U},get contextValue(){return p.contextValue},set contextValue(U){p.contextValue=U},get label(){return p.label},set label(U){p.label=U},get state(){return p.state},set state(U){p.state=U},dispose:()=>{p.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const t=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),a={};t("range")&&(a.range=A.Range.from(this._range)),t("label")&&(a.label=this.label),t("contextValue")&&(a.contextValue=this.contextValue??null),t("comments")&&(a.comments=this._comments.map(u=>f(this,u,this._commentsMap))),t("collapsibleState")&&(a.collapseState=r(this._collapseState)),t("canReply")&&(a.canReply=this.canReply),t("state")&&(a.state=s(this._state)),t("isTemplate")&&(a.isTemplate=this._isTemplate),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(t){for(let a of this._commentsMap){let u=a[0],c=a[1];if(t===c)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}h._handlePool=0,Ve([(0,i.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,a,u,c){this._extension=t,this._handle=a,this._id=u,this._label=c,this._threads=new Map,g.$registerCommentController(this.handle,u,c);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(R){S.options=R},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(R){S.commentingRangeProvider=R},get reactionHandler(){return S.reactionHandler},set reactionHandler(R){S.reactionHandler=R},createCommentThread(R,O,N){return S.createCommentThread(R,O,N).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,a,u,c){if(typeof t=="string"){const S=new h(this.id,this.handle,t,a,u,c,this._extension,!1);return this._threads.set(S.handle,S),S}else{const S=new h(this.id,this.handle,void 0,t,a,u,this._extension,!1);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(t,a){const u=new h(this.id,this.handle,void 0,I.URI.revive(t),A.Range.to(a),[],this._extension,!0);return u.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(t,a){let u=this._threads.get(t);u&&(u.range=A.Range.to(a))}$deleteCommentThread(t){let a=this._threads.get(t);a&&a.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function f(n,t,a){let u=a.get(t);u||(u=++n.commentHandle,a.set(t,u));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:u,body:typeof t.body=="string"?t.body:A.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(S=>o(S)):void 0,timestamp:t.timestamp?.toJSON()}}function o(n){return{label:n.label,iconPath:n.iconPath?A.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function w(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?I.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function r(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case L.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new E}e.createExtHostComments=T}),define(Ie[135],ke([1,0,2,5,7,4,18,13,16,8,9]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class Ii{constructor(T,_){this._logService=_,this._provider=new Map,this._proxy=T.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,_){const m=Ii._handlePool++;this._provider.set(m,{provider:T,extensionId:_}),this._proxy.$registerDecorationProvider(m,_.value);const v=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(m,null);return}let E=(0,b.asArray)(g);if(E.length<=Ii._maxEventSize){this._proxy.$onDidChange(m,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",_.value,E.length);const h=E.map(o=>({uri:o,rank:(0,A.count)(o.path,"/")})),l=(0,b.groupBy)(h,(o,w)=>o.rank-w.rank||(0,A.compare)(o.uri.path,w.uri.path));let f=[];e:for(let o of l){let w;for(let r of o){let s=(0,L.dirname)(r.uri.path);if(w!==s&&(w=s,f.push(r.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(m,f)});return new C.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(T,_,m){if(!this._provider.has(T))return Object.create(null);const v=Object.create(null),{provider:g,extensionId:E}=this._provider.get(T);return await Promise.all(_.map(async h=>{try{const{uri:l,id:f}=h,o=await Promise.resolve(g.provideFileDecoration(d.URI.revive(l),m));if(!o)return;try{C.FileDecoration.validate(o),v[f]=[o.propagate,o.tooltip,o.badge,o.color]}catch(w){this._logService.warn(`INVALID decoration from extension '${E.value}': ${w}`)}}catch(l){this._logService.error(l)}})),v}};k._handlePool=0,k._maxEventSize=250,k=Ve([$e(0,I.IExtHostRpcService),$e(1,D.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[234],ke([1,0,171,116,2,5,7,15,3,13,24,46]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";var y,T,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(E,h,l,f,o,w){this._name=E,this._owner=h,this._maxDiagnosticsPerFile=l,y.set(this,void 0),T.set(this,void 0),_.set(this,void 0),this._isDisposed=!1,et(this,_,new L.ResourceMap(r=>f.getComparisonKey(r)),"f"),et(this,y,o,"f"),et(this,T,w,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,_,"f").keys()]),Ue(this,y,"f")&&Ue(this,y,"f").$clear(this._owner),Ue(this,_,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,h){if(!E){this.clear();return}this._checkDisposed();let l=[];if(C.URI.isUri(E)){if(!h){this.delete(E);return}Ue(this,_,"f").set(E,h.slice()),l=[E]}else if(Array.isArray(E)){l=[];let o;E=[...E].sort(m._compareIndexedTuplesByUri);for(const w of E){const[r,s]=w;if((!o||r.toString()!==o.toString())&&(o&&Ue(this,_,"f").get(o).length===0&&Ue(this,_,"f").delete(o),o=r,l.push(r),Ue(this,_,"f").set(r,[])),s){const n=Ue(this,_,"f").get(r);n&&n.push(...s)}else{const n=Ue(this,_,"f").get(r);n&&(n.length=0)}}}if(Ue(this,T,"f").fire(l),!Ue(this,y,"f"))return;const f=[];for(let o of l){let w=[];const r=Ue(this,_,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){w=[];const s=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of r)if(t.severity===s[n]&&w.push(D.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;w.push({severity:i.MarkerSeverity.Info,message:(0,d.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:w[w.length-1].startLineNumber,startColumn:w[w.length-1].startColumn,endLineNumber:w[w.length-1].endLineNumber,endColumn:w[w.length-1].endColumn})}else w=r.map(s=>D.Diagnostic.from(s));f.push([o,w])}Ue(this,y,"f").$changeMany(this._owner,f)}delete(E){this._checkDisposed(),Ue(this,T,"f").fire([E]),Ue(this,_,"f").delete(E),Ue(this,y,"f")&&Ue(this,y,"f").$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,_,"f").keys()]),Ue(this,_,"f").clear(),Ue(this,y,"f")&&Ue(this,y,"f").$clear(this._owner)}forEach(E,h){this._checkDisposed();for(let l of Ue(this,_,"f").keys())E.apply(h,[l,this.get(l),this])}get(E){this._checkDisposed();const h=Ue(this,_,"f").get(E);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Ue(this,_,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,h){return E[0].toString()<h[0].toString()?-1:E[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=m,y=new WeakMap,T=new WeakMap,_=new WeakMap;let v=class li{constructor(E,h,l){this._logService=h,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=E.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(E){const h=new L.ResourceMap;for(const l of E)h.set(l,l);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(E,h){const{_collections:l,_proxy:f,_onDidChangeDiagnostics:o,_logService:w,_fileSystemInfoService:r}=this,s=new class{$changeMany(a,u){f.$changeMany(a,u),w.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,a,u.length===0?"CLEARING":u)}$clear(a){f.$clear(a),w.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,a)}dispose(){f.dispose()}};let n;if(!h)h="_generated_diagnostic_collection_name_#"+li._idPool++,n=h;else if(!l.has(h))n=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do n=h+li._idPool++;while(l.has(n))}return new class extends m{constructor(){super(h,n,li._maxDiagnosticsPerFile,r.extUri,s,o);l.set(n,this)}dispose(){super.dispose(),l.delete(n)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const h=new Map,l=[];for(const f of this._collections.values())f.forEach((o,w)=>{let r=h.get(o.toString());typeof r=="undefined"&&(r=l.length,h.set(o.toString(),r),l.push([o,[]])),l[r][1]=l[r][1].concat(...w)});return l}}_getDiagnostics(E){let h=[];for(let l of this._collections.values())l.has(E)&&(h=h.concat(l.get(E)));return h}$acceptMarkersChange(E){if(!this._mirrorCollection){const h="_generated_mirror",l=new m(h,h,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,l),this._mirrorCollection=l}for(const[h,l]of E)this._mirrorCollection.set(C.URI.revive(h),l.map(D.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Ve([$e(1,A.ILogService),$e(2,k.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(Ie[235],ke([1,0,2,5]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(I){this._proxy=I.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(D=>D?D.map(b=>d.URI.revive(b)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(D=>D?d.URI.revive(D):void 0)}}e.ExtHostDialogs=C}),define(Ie[236],ke([1,0,11,2,7,5,10,21,8]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(k,y,T){this._documentsAndEditors=y,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,y){if(Object.keys(I.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=A._handlePool++;this._documentContentProviders.set(T,y),this._proxy.$registerTextContentProvider(T,k);let _;return typeof y.onDidChange=="function"&&(_=y.onDidChange(m=>{if(m.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(T,m).then(v=>{if(!v&&typeof v!="string")return;const g=this._documentsAndEditors.getDocument(m);if(!g)return;const E=(0,b.splitLines)(v);if(!g.equalLines(E))return this._proxy.$onVirtualDocumentChange(m,v)},d.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(k,y){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(i.URI.revive(y),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${y.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(Ie[237],ke([1,0,3,6,2,5,124,15,14,26,7]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,_){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=_,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const v of m)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const v of m)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const _=this._documentsAndEditors.getDocument(T);if(_)return _}getDocument(T){const _=this.getDocumentData(T);if(!_?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return _.document}ensureDocumentData(T){const _=this._documentsAndEditors.getDocument(T);if(_)return Promise.resolve(_);let m=this._documentLoader.get(T.toString());return m||(m=this._proxy.$tryOpenDocument(T).then(v=>{this._documentLoader.delete(T.toString());const g=C.URI.revive(v);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(g))},v=>(this._documentLoader.delete(T.toString()),Promise.reject(v))),this._documentLoader.set(T.toString(),m)),m}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(_=>C.URI.revive(_))}$acceptModelLanguageChanged(T,_){const m=C.URI.revive(T),v=this._documentsAndEditors.getDocument(m);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(_),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(T){const _=C.URI.revive(T),m=this._documentsAndEditors.getDocument(_);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(T,_){const m=C.URI.revive(T),v=this._documentsAndEditors.getDocument(m);if(!v)throw new Error("unknown document");v._acceptIsDirty(_),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,_,m){const v=C.URI.revive(T),g=this._documentsAndEditors.getDocument(v);if(!g)throw new Error("unknown document");g._acceptIsDirty(m),g.onEvents(_);let E;_.isUndoing?E=L.TextDocumentChangeReason.Undo:_.isRedoing&&(E=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:g.document,contentChanges:_.changes.map(h=>({range:D.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:E}))}setWordDefinitionFor(T,_){(0,I.setWordDefinitionFor)(T,_)}}e.ExtHostDocuments=k}),define(Ie[53],ke([1,0,55,3,6,2,4,5,124,18,133,15,13,24,10,79,80]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,f){this._extHostRpc=l,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const f=[],o=[],w=[];if(l.removedDocuments)for(const r of l.removedDocuments){const s=P.URI.revive(r),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),f.push(n.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const s=P.URI.revive(r.uri);let n=this._documents.get(s);if(n&&s.scheme!==_.Schemas.vscodeNotebookCell&&s.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new g(new b.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,n),o.push(n.value)),n.ref()}if(l.removedEditors)for(const r of l.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&w.push(s)}if(l.addedEditors)for(const r of l.addedEditors){const s=P.URI.revive(r.documentUri);d.ok(this._documents.has(s),`document '${s}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(s).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>n.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(a=>k.Range.to(a)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}l.newActiveEditor!==void 0&&(d.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,C.dispose)(f),(0,C.dispose)(w),l.removedDocuments&&this._onDidRemoveDocuments.fire(f),l.addedDocuments&&this._onDidAddDocuments.fire(o),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return l?f:f?.value}allEditors(){return[...this._editors.values()]}};E=Ve([$e(0,A.IExtHostRpcService),$e(1,y.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[54],ke([1,0,15,5,2,3,4,7,18,14,56]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class k{constructor(v,g,E){this._activeTabIdGetter=E,this._parentGroup=g,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,g={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(g)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 5:return new D.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new D.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new D.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new D.TerminalEditorTabInput;default:return}}}class y{constructor(v,g,E){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=E;for(const h of v.tabs)h.isActive&&(this._activeTabId=h.id),this._tabs.push(new k(h,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,g={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return d.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(E=>E.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(E=>E.apiObject))}};this._apiObject=Object.freeze(g)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const E=new k(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,E),v.tabDto.isActive&&(this._activeTabId=E.tabId),E}else if(v.kind===1){const E=this._tabs.splice(v.index,1)[0];if(!E)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return E.tabId===this._activeTabId&&(this._activeTabId=""),E}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const E=this._tabs.splice(v.oldIndex,1)[0];if(!E)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,E),E}const g=this._tabs.find(E=>E.tabId===v.tabDto.id);if(!g)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),g.acceptDtoUpdate(v.tabDto),g}activeTabId(){return this._activeTabId}}let T=class{constructor(v){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(i.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,g={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(E=>E.apiObject))},get activeTabGroup(){const E=v._activeGroupId;return(0,A.assertIsDefined)(v._extHostTabGroups.find(l=>l.groupId===E)?.apiObject)},close:async(E,h)=>{const l=Array.isArray(E)?E:[E];return l.length?_(l[0])?this._closeGroups(l,h):this._closeTabs(l,h):!0}};this._apiObject=Object.freeze(g)}return this._apiObject}$acceptEditorTabModel(v){const g=new Set(this._extHostTabGroups.map(r=>r.groupId)),E=new Set(v.map(r=>r.groupId)),h=(0,L.diffSets)(g,E),l=this._extHostTabGroups.filter(r=>h.removed.includes(r.groupId)).map(r=>r.apiObject),f=[],o=[];this._extHostTabGroups=v.map(r=>{const s=new y(r,this._proxy,()=>this._activeGroupId);return h.added.includes(s.groupId)?f.push(s.apiObject):o.push(s.apiObject),s});const w=(0,A.assertIsDefined)(v.find(r=>r.isActive===!0)?.groupId);w!==void 0&&this._activeGroupId!==w&&(this._activeGroupId=w),this._onDidChangeTabGroups.fire(Object.freeze({opened:f,closed:l,changed:o}))}$acceptTabGroupUpdate(v){const g=this._extHostTabGroups.find(E=>E.groupId===v.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const g=this._extHostTabGroups.find(h=>h.groupId===v.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const E=g.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[E.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[E.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[E.apiObject]}));return}}_findExtHostTabFromApi(v){for(const g of this._extHostTabGroups)for(const E of g.tabs)if(E.apiObject===v)return E}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(g=>g.apiObject===v)}async _closeTabs(v,g){const E=[];for(const h of v){const l=this._findExtHostTabFromApi(h);if(!l)throw new Error("Tab close: Invalid tab not found!");E.push(l.tabId)}return this._proxy.$closeTab(E,g)}async _closeGroups(v,g){const E=[];for(const h of v){const l=this._findExtHostTabGroupFromApi(h);if(!l)throw new Error("Group close: Invalid group not found!");E.push(l.groupId)}return this._proxy.$closeGroup(E,g)}};T=Ve([$e(0,b.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function _(m){return m.tabs!==void 0}}),define(Ie[238],ke([1,0,2,5,6,7,15,154,8,23,25]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(_){this._stateMachine=void 0,this._schemes.push(_)}delete(_){const m=this._schemes.indexOf(_);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const _=this._schemes.sort(),m=[];let v,g,E=14,h=14;for(const l of _){let f=v?(0,b.commonPrefixLength)(v,l):0;for(f===0?g=1:g=h;f<l.length;f++)f+1===l.length?(E=h,h=9):h+=1,m.push([g,l.toUpperCase().charCodeAt(f),h]),m.push([g,l.toLowerCase().charCodeAt(f),h]),g=h;v=l,h=E}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new D.StateMachine(m)}}provideDocumentLinks(_){this._initStateMachine();const m=[],v=D.LinkComputer.computeLinks({getLineContent(g){return _.lineAt(g-1).text},getLineCount(){return _.lineCount}},this._stateMachine);for(const g of v){const E=I.DocumentLink.to(g);E.target&&m.push(E)}return m}}class y{constructor(_,m){this._extHostLanguageFeatures=m,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=_.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(_,m,v,g={}){if(this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(_,"*",this._linkProvider));const E=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(E,v);let h=2;g.isCaseSensitive&&(h+=1024),g.isReadonly&&(h+=2048),typeof v.copy=="function"&&(h+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(_,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(E,m,h).catch(f=>{console.error(`FAILED to register filesystem provider of ${_.identifier.value}-extension for the scheme ${m}`),console.error(f)});const l=v.onDidChangeFile(f=>{const o=[];for(const w of f){let{uri:r,type:s}=w;if(r.scheme!==m)continue;let n;switch(s){case P.FileChangeType.Changed:n=0;break;case P.FileChangeType.Created:n=1;break;case P.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(E,o)});return(0,C.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(_){const{type:m,ctime:v,mtime:g,size:E,permissions:h}=_;return{type:m,ctime:v,mtime:g,size:E,permissions:h}}$stat(_,m){return Promise.resolve(this._getFsProvider(_).stat(d.URI.revive(m))).then(v=>y._asIStat(v))}$readdir(_,m){return Promise.resolve(this._getFsProvider(_).readDirectory(d.URI.revive(m)))}$readFile(_,m){return Promise.resolve(this._getFsProvider(_).readFile(d.URI.revive(m))).then(v=>A.VSBuffer.wrap(v))}$writeFile(_,m,v,g){return Promise.resolve(this._getFsProvider(_).writeFile(d.URI.revive(m),v.buffer,g))}$delete(_,m,v){return Promise.resolve(this._getFsProvider(_).delete(d.URI.revive(m),v))}$rename(_,m,v,g){return Promise.resolve(this._getFsProvider(_).rename(d.URI.revive(m),d.URI.revive(v),g))}$copy(_,m,v,g){const E=this._getFsProvider(_);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(d.URI.revive(m),d.URI.revive(v),g))}$mkdir(_,m){return Promise.resolve(this._getFsProvider(_).createDirectory(d.URI.revive(m)))}$watch(_,m,v,g){const E=this._getFsProvider(_).watch(d.URI.revive(v),g);this._watches.set(m,E)}$unwatch(_,m){const v=this._watches.get(m);v&&(v.dispose(),this._watches.delete(m))}$open(_,m,v){const g=this._getFsProvider(_);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(d.URI.revive(m),v))}$close(_,m){const v=this._getFsProvider(_);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(m))}$read(_,m,v,g){const E=this._getFsProvider(_);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const h=A.VSBuffer.alloc(g);return Promise.resolve(E.read(m,v,h.buffer,0,g)).then(l=>h.slice(0,l))}$write(_,m,v,g){const E=this._getFsProvider(_);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(m,v,g.buffer,0,g.byteLength))}_getFsProvider(_){const m=this._fsProvider.get(_);if(!m){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return m}}e.ExtHostFileSystem=y}),define(Ie[69],ke([1,0,5,42,7,23,4,18,46,6]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Gt{constructor(y,T){this._fileSystemProvider=new Map,this._proxy=y.getProxy(d.MainContext.MainThreadFileSystem);const _=this;this.value=Object.freeze({async stat(m){try{const v=_._fileSystemProvider.get(m.scheme);if(!v)return await _._proxy.$stat(m);await _._proxy.$ensureActivation(m.scheme);const g=await v.stat(m);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions}}catch(v){Gt._handleError(v)}},async readDirectory(m){try{const v=_._fileSystemProvider.get(m.scheme);return v?(await _._proxy.$ensureActivation(m.scheme),(await v.readDirectory(m)).slice()):await _._proxy.$readdir(m)}catch(v){return Gt._handleError(v)}},async createDirectory(m){try{return await _._proxy.$mkdir(m)}catch(v){return Gt._handleError(v)}},async readFile(m){try{const v=_._fileSystemProvider.get(m.scheme);return v?(await _._proxy.$ensureActivation(m.scheme),(await v.readFile(m)).slice()):(await _._proxy.$readFile(m)).buffer}catch(v){return Gt._handleError(v)}},async writeFile(m,v){try{return await _._proxy.$writeFile(m,P.VSBuffer.wrap(v))}catch(g){return Gt._handleError(g)}},async delete(m,v){try{const g=_._fileSystemProvider.get(m.scheme);return g?(await _._proxy.$ensureActivation(m.scheme),await g.delete(m,{recursive:!1,...v})):await _._proxy.$delete(m,{recursive:!1,useTrash:!1,...v})}catch(g){return Gt._handleError(g)}},async rename(m,v,g){try{return await _._proxy.$rename(m,v,{overwrite:!1,...g})}catch(E){return Gt._handleError(E)}},async copy(m,v,g){try{return await _._proxy.$copy(m,v,{overwrite:!1,...g})}catch(E){return Gt._handleError(E)}},isWritableFileSystem(m){const v=T.getCapabilities(m);if(typeof v=="number")return!(v&2048)}})}static _handleError(y){if(y instanceof C.FileSystemError)throw y;if(!(y instanceof Error))throw new C.FileSystemError(String(y));if(y.name==="ENOPRO")throw C.FileSystemError.Unavailable(y.message);switch(y.name){case i.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(y.message);case i.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(y.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(y.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(y.message);case i.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(y.message);case i.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(y.message);default:throw new C.FileSystemError(y.message,y.name)}}addFileSystemProvider(y,T){return this._fileSystemProvider.set(y,T),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(y))}};L=Ve([$e(0,D.IExtHostRpcService),$e(1,b.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[239],ke([1,0,3,34,2,5,15,7]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{constructor(k,y,T,_,m,v,g,E){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter;const h=this.ensureWatching(k,T,m);this._config=0,v&&(this._config+=1),g&&(this._config+=2),E&&(this._config+=4);const l=(0,i.parse)(m),f=typeof m=="string",o=_(w=>{if(!v)for(let r of w.created){const s=C.URI.revive(r);l(s.fsPath)&&(!f||y.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(let r of w.changed){const s=C.URI.revive(r);l(s.fsPath)&&(!f||y.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!E)for(let r of w.deleted){const s=C.URI.revive(r);l(s.fsPath)&&(!f||y.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=D.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(k,y,T){let _=D.Disposable.from();if(typeof T=="string")return _;const m=k.getProxy(P.MainContext.MainThreadFileSystem);let v=!1;(T.pattern.includes(i.GLOBSTAR)||T.pattern.includes(i.GLOB_SPLIT))&&(v=!0);const g=Math.random();return m.$watch(y.identifier.value,g,T.baseUri,{recursive:v,excludes:[]}),D.Disposable.from({dispose:()=>m.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(k,y,T){this._mainContext=k,this._logService=y,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,y,T,_,m,v){return new b(this._mainContext,k,y,this._onFileSystemEvent.event,I.GlobPattern.from(T),_,m,v)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,y){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(T=>({oldUri:C.URI.revive(T.source),newUri:C.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(T=>C.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:y.map(T=>C.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,y){return(T,_,m)=>{const v=function(E){T.call(_,E)};return v.extension=k,y.event(v,void 0,m)}}async $onWillRunFileOperation(k,y,T,_){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))},T,_);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(m=>C.URI.revive(m.target))},T,_);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(m=>C.URI.revive(m.target))},T,_)}}async _fireWillEvent(k,y,T,_){const m=new Set,v=[];if(await k.fireAsync(y,_,async(E,h)=>{const l=Date.now(),f=await Promise.resolve(E);f instanceof D.WorkspaceEdit&&(v.push(f),m.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-l>T&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),_.isCancellationRequested||v.length===0)return;const g={edits:[]};for(let E of v){let{edits:h}=I.WorkspaceEdit.from(E,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});g.edits=g.edits.concat(h)}return{edit:g,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=A}),define(Ie[240],ke([1,0,2,37]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(I,D,b,A){this._extHostNotebooks=D,this._textDocumentsAndEditors=b,this._commands=A;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",k=>!0,k=>k),new i.ApiCommandArgument("resource","Interactive resource Uri",k=>!0,k=>k),new i.ApiCommandArgument("controllerId","Notebook controller Id",k=>!0,k=>k),new i.ApiCommandArgument("title","Interactive editor title",k=>!0,k=>k)],new i.ApiCommandResult("Notebook and input URI",k=>{if(k.notebookEditorId!==void 0){const y=this._extHostNotebooks.getEditorById(k.notebookEditorId);return{notebookUri:d.URI.revive(k.notebookUri),inputUri:d.URI.revive(k.inputUri),notebookEditor:y.apiEditor}}return{notebookUri:d.URI.revive(k.notebookUri),inputUri:d.URI.revive(k.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(I,D,b,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:b,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=C}),define(Ie[241],ke([1,0,6,5]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(I){this._handlePool=0,this._proxy=I.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,I),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=C}),define(Ie[242],ke([1,0,2,26,15,7,63,5,8,36,16,14,149,21,6,111,78,86,48,11,17,25,125]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class w{constructor(F,$){this._documents=F,this._provider=$}async provideDocumentSymbols(F,$){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentSymbols(K,$);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(C.DocumentSymbol.from):w._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((X,me)=>{let Ee=X.location.range.start.compareTo(me.location.range.start);return Ee===0&&(Ee=me.location.range.end.compareTo(X.location.range.end)),Ee});const $=[],K=[];for(const X of F){const me={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(K.length===0){K.push(me),$.push(me);break}const Ee=K[K.length-1];if(A.Range.containsRange(Ee.range,me.range)&&!A.Range.equalsRange(Ee.range,me.range)){Ee.children&&Ee.children.push(me),K.push(me);break}K.pop()}}return $}}class r{constructor(F,$,K){this._documents=F,this._commands=$,this._provider=K,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,$){const K=this._documents.getDocument(F),X=await this._provider.provideCodeLenses(K,$);if(!X||$.isCancellationRequested)return;const me=this._cache.add(X),Ee=new _.DisposableStore;this._disposables.set(me,Ee);const oe={cacheId:me,lenses:[]};for(let De=0;De<X.length;De++)oe.lenses.push({cacheId:[me,De],range:C.Range.from(X[De].range),command:this._commands.toInternal(X[De].command,Ee)});return oe}async resolveCodeLens(F,$){const K=F.cacheId&&this._cache.get(...F.cacheId);if(!K)return;let X;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?X=K:X=await this._provider.resolveCodeLens(K,$),X||(X=K),$.isCancellationRequested)return;const me=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!me)return F.command=this._commands.toInternal(X.command??r._badCmd,me),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(te){return Array.isArray(te)?te.map(C.DefinitionLink.from):te?[C.DefinitionLink.from(te)]:[]}class n{constructor(F,$){this._documents=F,this._provider=$}async provideDefinition(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideDefinition(X,me,K);return s(Ee)}}class t{constructor(F,$){this._documents=F,this._provider=$}async provideDeclaration(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideDeclaration(X,me,K);return s(Ee)}}class a{constructor(F,$){this._documents=F,this._provider=$}async provideImplementation(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideImplementation(X,me,K);return s(Ee)}}class u{constructor(F,$){this._documents=F,this._provider=$}async provideTypeDefinition(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideTypeDefinition(X,me,K);return s(Ee)}}class c{constructor(F,$){this._documents=F,this._provider=$}async provideHover(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideHover(X,me,K);if(!(!Ee||(0,L.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=X.getWordRangeAtPosition(me)),Ee.range||(Ee.range=new P.Range(me,me)),C.Hover.from(Ee)}}class S{constructor(F,$){this._documents=F,this._provider=$}async provideEvaluatableExpression(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideEvaluatableExpression(X,me,K);if(Ee)return C.EvaluatableExpression.from(Ee)}}class R{constructor(F,$){this._documents=F,this._provider=$}async provideInlineValues(F,$,K,X){const me=this._documents.getDocument(F),Ee=await this._provider.provideInlineValues(me,C.Range.to($),C.InlineValueContext.to(K),X);if(Array.isArray(Ee))return Ee.map(oe=>C.InlineValue.from(oe))}}class O{constructor(F,$){this._documents=F,this._provider=$}async provideDocumentHighlights(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideDocumentHighlights(X,me,K);if(Array.isArray(Ee))return Ee.map(C.DocumentHighlight.from)}}class N{constructor(F,$){this._documents=F,this._provider=$}async provideLinkedEditingRanges(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.provideLinkedEditingRanges(X,me,K);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.coalesce)(Ee.ranges.map(C.Range.from)),wordPattern:Ee.wordPattern}}}class p{constructor(F,$){this._documents=F,this._provider=$}async provideReferences(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($),oe=await this._provider.provideReferences(me,Ee,K,X);if(Array.isArray(oe))return oe.map(C.location.from)}}class U{constructor(F,$,K,X,me,Ee,oe){this._documents=F,this._commands=$,this._diagnostics=K,this._provider=X,this._logService=me,this._extension=Ee,this._apiDeprecation=oe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,$,K,X){const me=this._documents.getDocument(F),Ee=y.Selection.isISelection($)?C.Selection.to($):C.Range.to($),oe=[];for(const Ye of this._diagnostics.getDiagnostics(F))if(Ee.intersection(Ye.range)&&oe.push(Ye)>U._maxCodeActionsPerFile)break;const De={diagnostics:oe,only:K.only?new P.CodeActionKind(K.only):void 0,triggerKind:C.CodeActionTriggerKind.to(K.trigger)},Ce=await this._provider.provideCodeActions(me,Ee,De,X);if(!(0,L.isNonEmptyArray)(Ce)||X.isCancellationRequested)return;const We=this._cache.add(Ce),je=new _.DisposableStore;this._disposables.set(We,je);const Fe=[];for(let Ye=0;Ye<Ce.length;Ye++){const J=Ce[Ye];!J||(U._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Fe.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,je)})):(De.only&&(J.kind?De.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Fe.push({cacheId:[We,Ye],title:J.title,command:J.command&&this._commands.toInternal(J.command,je),diagnostics:J.diagnostics&&J.diagnostics.map(C.Diagnostic.from),edit:J.edit&&C.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:We,actions:Fe}}async resolveCodeAction(F,$){const[K,X]=F,me=this._cache.get(K,X);if(!me||U._isCommand(me)||!this._provider.resolveCodeAction)return;const Ee=await this._provider.resolveCodeAction(me,$)??me;return Ee?.edit?C.WorkspaceEdit.from(Ee.edit):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}U._maxCodeActionsPerFile=1e3;class B{constructor(F,$){this._documents=F,this._provider=$}async provideDocumentFormattingEdits(F,$,K){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentFormattingEdits(X,$,K);if(Array.isArray(me))return me.map(C.TextEdit.from)}}class z{constructor(F,$){this._documents=F,this._provider=$}async provideDocumentRangeFormattingEdits(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Range.to($),oe=await this._provider.provideDocumentRangeFormattingEdits(me,Ee,K,X);if(Array.isArray(oe))return oe.map(C.TextEdit.from)}}class re{constructor(F,$){this._documents=F,this._provider=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,$,K,X,me){const Ee=this._documents.getDocument(F),oe=C.Position.to($),De=await this._provider.provideOnTypeFormattingEdits(Ee,oe,K,X,me);if(Array.isArray(De))return De.map(C.TextEdit.from)}}class H{constructor(F,$){this._provider=F,this._logService=$,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,$){const K=await this._provider.provideWorkspaceSymbols(F,$);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const X=this._cache.add(K),me={cacheId:X,symbols:[]};for(let Ee=0;Ee<K.length;Ee++){const oe=K[Ee];if(!oe||!oe.name){this._logService.warn("INVALID SymbolInformation",oe);continue}me.symbols.push({...C.WorkspaceSymbol.from(oe),cacheId:[X,Ee]})}return me}async resolveWorkspaceSymbol(F,$){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this._cache.get(...F.cacheId);if(K){const X=await this._provider.resolveWorkspaceSymbol(K,$);return X&&(0,i.mixin)(F,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class M{constructor(F,$,K){this._documents=F,this._provider=$,this._logService=K}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($);try{const oe=await this._provider.provideRenameEdits(me,Ee,K,X);return oe?C.WorkspaceEdit.from(oe):void 0}catch(oe){const De=M._asMessage(oe);return De?{rejectReason:De,edits:void 0}:Promise.reject(oe)}}async resolveRenameLocation(F,$,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(F),me=C.Position.to($);try{const Ee=await this._provider.prepareRename(X,me,K);let oe,De;if(P.Range.isRange(Ee)?(oe=Ee,De=X.getText(Ee)):(0,k.isObject)(Ee)&&(oe=Ee.range,De=Ee.placeholder),!oe||!De)return;if(oe.start.line>me.line||oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(oe),text:De}}catch(Ee){const oe=M._asMessage(Ee);return oe?{rejectReason:oe,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class j{constructor(F,$){this.resultId=F,this.tokens=$}}class V{constructor(F,$){this._documents=F,this._provider=$,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,$,K){const X=this._documents.getDocument(F),me=$!==0?this._previousResults.get($):null;let Ee=typeof me?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,me.resultId,K):await this._provider.provideDocumentSemanticTokens(X,K);return me&&this._previousResults.delete($),Ee?(Ee=V._fixProvidedSemanticTokens(Ee),this._send(V._convertToEdits(me,Ee),Ee)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return V._isSemanticTokens(F)?V._isCorrectSemanticTokens(F)?F:new P.SemanticTokens(new Uint32Array(F.data),F.resultId):V._isSemanticTokensEdits(F)?V._isCorrectSemanticTokensEdits(F)?F:new P.SemanticTokensEdits(F.edits.map($=>new P.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const $ of F.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,$){if(!V._isSemanticTokens($)||!F||!F.tokens)return $;const K=F.tokens,X=K.length,me=$.data,Ee=me.length;let oe=0;const De=Math.min(X,Ee);for(;oe<De&&K[oe]===me[oe];)oe++;if(oe===X&&oe===Ee)return new P.SemanticTokensEdits([],$.resultId);let Ce=0;const We=De-oe;for(;Ce<We&&K[X-Ce-1]===me[Ee-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:oe,deleteCount:X-oe-Ce,data:me.subarray(oe,Ee-Ce)}],$.resultId)}_send(F,$){if(V._isSemanticTokens(F)){const K=this._nextResultId++;return this._previousResults.set(K,new j(F.resultId,F.data)),(0,m.encodeSemanticTokensDto)({id:K,type:"full",data:F.data})}if(V._isSemanticTokensEdits(F)){const K=this._nextResultId++;return V._isSemanticTokens($)?this._previousResults.set(K,new j($.resultId,$.data)):this._previousResults.set(K,new j(F.resultId)),(0,m.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(F.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class q{constructor(F,$){this._documents=F,this._provider=$}async provideDocumentRangeSemanticTokens(F,$,K){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentRangeSemanticTokens(X,C.Range.to($),K);return me?this._send(me):null}_send(F){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=q;class ie{constructor(F,$,K,X,me){this._documents=F,this._commands=$,this._provider=K,this._apiDeprecation=X,this._extension=me,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($),oe=me.getWordRangeAtPosition(Ee)||new P.Range(Ee,Ee),De=oe.with({end:Ee}),Ce=new E.StopWatch(!0),We=await this._provider.provideCompletionItems(me,Ee,X,C.CompletionContext.to(K));if(!We||X.isCancellationRequested)return;const je=Array.isArray(We)?new P.CompletionList(We):We,Fe=ie.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Ye=new _.DisposableStore;this._disposables.set(Fe,Ye);const J=[],se={x:Fe,b:J,a:{replace:C.Range.from(oe),insert:C.Range.from(De)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let _e=0;_e<je.items.length;_e++){const ae=je.items[_e],ye=this._convertCompletionItem(ae,[Fe,_e],De,oe);J.push(ye)}return se}async resolveCompletionItem(F,$){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveCompletionItem(K,$);if(!!X)return this._convertCompletionItem(X,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,$,K,X){const me=this._disposables.get($[0]);if(!me)throw Error("DisposableStore is missing...");const Ee={x:$,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(F.command,me)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof P.SnippetString&&(Ee.h=F.insertText.value,Ee.i|=4);let oe;return F.textEdit?oe=F.textEdit.range:F.range&&(oe=F.range),P.Range.isRange(oe)?Ee.j=C.Range.from(oe):oe&&(!K?.isEqual(oe.inserting)||!X?.isEqual(oe.replacing))&&(Ee.j={insert:C.Range.from(oe.inserting),replace:C.Range.from(oe.replacing)}),Ee}}class Q{async provideInlineCompletions(F,$,K,X){}disposeCompletions(F){}handleDidShowCompletionItem(F,$){}}class ue extends Q{constructor(F,$,K,X){super();this._extension=F,this._documents=$,this._provider=K,this._commands=X,this._references=new G,this._isAdditionsProposedApiEnabled=(0,f.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,f.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($),oe=await this._provider.provideInlineCompletionItems(me,Ee,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:C.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},X);if(!oe||X.isCancellationRequested)return;const De=(0,k.isArray)(oe)?oe:oe.items,Ce=this._isAdditionsProposedApiEnabled?(0,k.isArray)(oe)?[]:oe.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We&&We.dispose()},items:De}),items:De.map((Fe,Ye)=>{let J;Fe.command&&(We||(We=new _.DisposableStore),J=this._commands.toInternal(Fe.command,We));const se=Fe.insertText;return{insertText:typeof se=="string"?se:{snippet:se.value},filterText:Fe.filterText,range:Fe.range?C.Range.from(Fe.range):void 0,command:J,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Fe.completeBracketPairs:!1}}),commands:Ce.map(Fe=>(We||(We=new _.DisposableStore),this._commands.toInternal(Fe,We)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,$){const K=this._references.get(F)?.items[$];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class ce extends Q{constructor(F,$,K,X){super();this.extension=F,this._documents=$,this._provider=K,this._commands=X,this._references=new G,this.isAdditionProposedApiEnabled=(0,f.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($),oe=await this._provider.provideInlineCompletionItems(me,Ee,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:C.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},X);if(!oe||X.isCancellationRequested)return;const De=(0,k.isArray)(oe)?oe:oe.items,Ce=(0,k.isArray)(oe)?[]:oe.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We&&We.dispose()},items:De}),items:De.map((Fe,Ye)=>{let J;Fe.command&&(We||(We=new _.DisposableStore),J=this._commands.toInternal(Fe.command,We));const se=Fe.insertText;return{insertText:typeof se=="string"?se:{snippet:se.value},filterText:Fe.filterText,range:Fe.range?C.Range.from(Fe.range):void 0,command:J,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Fe.completeBracketPairs:!1}}),commands:Ce.map(Fe=>(We||(We=new _.DisposableStore),this._commands.toInternal(Fe,We)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,$){const K=this._references.get(F)?.items[$];K&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class G{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const $=this._idPool++;return this._references.set($,F),$}disposeReferenceId(F){const $=this._references.get(F);return this._references.delete(F),$}get(F){return this._references.get(F)}}class ge{constructor(F,$){this._documents=F,this._provider=$,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(F,$,K,X){const me=this._documents.getDocument(F),Ee=C.Position.to($),oe=this.reviveContext(K),De=await this._provider.provideSignatureHelp(me,Ee,X,oe);if(De){const Ce=this._cache.add([De]);return{...C.SignatureHelp.from(De),id:Ce}}}reviveContext(F){let $;if(F.activeSignatureHelp){const K=C.SignatureHelp.to(F.activeSignatureHelp),X=this._cache.get(F.activeSignatureHelp.id,0);X?($=X,$.activeSignature=K.activeSignature,$.activeParameter=K.activeParameter):$=K}return{...F,activeSignatureHelp:$}}releaseSignatureHelp(F){this._cache.delete(F)}}class ne{constructor(F,$,K,X,me){this._documents=F,this._commands=$,this._provider=K,this._logService=X,this._extension=me,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,$,K){const X=this._documents.getDocument(F),me=C.Range.to($),Ee=await this._provider.provideInlayHints(X,me,K);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${$}`);return}if(K.isCancellationRequested)return;const oe=this._cache.add(Ee);this._disposables.set(oe,new _.DisposableStore);const De={hints:[],cacheId:oe};for(let Ce=0;Ce<Ee.length;Ce++)this._isValidInlayHint(Ee[Ce],me)&&De.hints.push(this._convertInlayHint(Ee[Ce],[oe,Ce]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${$}`),De}async resolveInlayHint(F,$){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveInlayHint(K,$);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,$){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!($&&!$.contains(F.position))}_convertInlayHint(F,$){const K=this._disposables.get($[0]);if(!K)throw Error("DisposableStore is missing...");const X={label:"",cacheId:$,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?X.label=F.label:X.label=F.label.map(me=>{let Ee={label:me.value};return Ee.tooltip=C.MarkdownString.fromStrict(me.tooltip),P.Location.isLocation(me.location)&&(Ee.location=C.location.from(me.location)),me.command&&(Ee.command=this._commands.toInternal(me.command,K)),Ee}),X}}class he{constructor(F,$){this._documents=F,this._provider=$,this._cache=new g.Cache("DocumentLink")}async provideLinks(F,$){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentLinks(K,$);if(!(!Array.isArray(X)||X.length===0)&&!$.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(he._validateLink).map(C.DocumentLink.from)};{const me=this._cache.add(X),Ee={links:[],cacheId:me};for(let oe=0;oe<X.length;oe++){if(!he._validateLink(X[oe]))continue;const De=C.DocumentLink.from(X[oe]);De.cacheId=[me,oe],Ee.links.push(De)}return Ee}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,$){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveDocumentLink(K,$);if(!(!X||!he._validateLink(X)))return C.DocumentLink.from(X)}releaseLinks(F){this._cache.delete(F)}}class Se{constructor(F,$){this._documents=F,this._provider=$}async provideColors(F,$){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentColors(K,$);return Array.isArray(X)?X.map(Ee=>({color:C.Color.from(Ee.color),range:C.Range.from(Ee.range)})):[]}async provideColorPresentations(F,$,K){const X=this._documents.getDocument(F),me=C.Range.to($.range),Ee=C.Color.to($.color),oe=await this._provider.provideColorPresentations(Ee,{document:X,range:me},K);if(!!Array.isArray(oe))return oe.map(C.ColorPresentation.from)}}class Re{constructor(F,$){this._documents=F,this._provider=$}async provideFoldingRanges(F,$,K){const X=this._documents.getDocument(F),me=await this._provider.provideFoldingRanges(X,$,K);if(!!Array.isArray(me))return me.map(C.FoldingRange.from)}}class ve{constructor(F,$,K){this._documents=F,this._provider=$,this._logService=K}async provideSelectionRanges(F,$,K){const X=this._documents.getDocument(F),me=$.map(C.Position.to),Ee=await this._provider.provideSelectionRanges(X,me,K);if(!(0,L.isNonEmptyArray)(Ee))return[];if(Ee.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const oe=[];for(let De=0;De<me.length;De++){const Ce=[];oe.push(Ce);let We=me[De],je=Ee[De];for(;;){if(!je.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(C.SelectionRange.from(je)),!je.parent)break;We=je.range,je=je.parent}}return oe}}class Te{constructor(F,$){this._documents=F,this._provider=$,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.prepareCallHierarchy(X,me,K);if(!Ee)return;const oe=this._idPool.nextId();return this._cache.set(oe,new Map),Array.isArray(Ee)?Ee.map(De=>this._cacheAndConvertItem(oe,De)):[this._cacheAndConvertItem(oe,Ee)]}async provideCallsTo(F,$,K){const X=this._itemFromCache(F,$);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(X,K);if(!!me)return me.map(Ee=>({from:this._cacheAndConvertItem(F,Ee.from),fromRanges:Ee.fromRanges.map(oe=>C.Range.from(oe))}))}async provideCallsFrom(F,$,K){const X=this._itemFromCache(F,$);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(X,K);if(!!me)return me.map(Ee=>({to:this._cacheAndConvertItem(F,Ee.to),fromRanges:Ee.fromRanges.map(oe=>C.Range.from(oe))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,$){const K=this._cache.get(F),X=C.CallHierarchyItem.from($,F,K.size.toString(36));return K.set(X._itemId,$),X}_itemFromCache(F,$){return this._cache.get(F)?.get($)}}class Ae{constructor(F,$){this._documents=F,this._provider=$,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(F,$,K){const X=this._documents.getDocument(F),me=C.Position.to($),Ee=await this._provider.prepareTypeHierarchy(X,me,K);if(!Ee)return;const oe=this._idPool.nextId();return this._cache.set(oe,new Map),Array.isArray(Ee)?Ee.map(De=>this._cacheAndConvertItem(oe,De)):[this._cacheAndConvertItem(oe,Ee)]}async provideSupertypes(F,$,K){const X=this._itemFromCache(F,$);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySupertypes(X,K);if(!!me)return me.map(Ee=>this._cacheAndConvertItem(F,Ee))}async provideSubtypes(F,$,K){const X=this._itemFromCache(F,$);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySubtypes(X,K);if(!!me)return me.map(Ee=>this._cacheAndConvertItem(F,Ee))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,$){const K=this._cache.get(F),X=C.TypeHierarchyItem.from($,F,K.size.toString(36));return K.set(X._itemId,$),X}_itemFromCache(F,$){return this._cache.get(F)?.get($)}}class le{constructor(F,$,K,X){this._proxy=F,this._documents=$,this._provider=K,this._handle=X}async provideDocumentOnDropEdits(F,$,K,X,me){const Ee=this._documents.getDocument($),oe=C.Position.to(K),De=o.DataTransferConverter.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,We)).buffer),Ce=await this._provider.provideDocumentOnDropEdits(Ee,oe,De,me);if(!!Ce)return C.SnippetTextEdit.from(Ce)}}class pe{constructor(F,$){this.adapter=F,this.extension=$}}class ee{constructor(F,$,K,X,me,Ee,oe){this._adapter=new Map,this._uriTransformer=$,this._proxy=F.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=K,this._commands=X,this._diagnostics=me,this._logService=Ee,this._apiDeprecation=oe}_transformDocumentSelector(F){return C.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new P.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ee._handlePool++}async _withAdapter(F,$,K,X,me,Ee=!1){const oe=this._adapter.get(F);if(!oe||!(oe.adapter instanceof $))return X;const De=Date.now();Ee||this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(oe.adapter,oe.extension);return Promise.resolve(Ce).catch(We=>{(0,h.isCancellationError)(We)||(this._logService.error(`[${oe.extension.identifier.value}] provider FAILED`),this._logService.error(We))}).finally(()=>{Ee||this._logService.trace(`[${oe.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),T.CancellationToken.isCancellationToken(me)?(0,l.raceCancellationError)(Ce,me):Ce}_addNewAdapter(F,$){const K=this._nextHandle();return this._adapter.set(K,new pe(F,$)),K}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,$,K,X){const me=this._addNewAdapter(new w(this._documents,K),F),Ee=X&&X.label||ee._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector($),Ee),this._createDisposable(me)}$provideDocumentSymbols(F,$,K){return this._withAdapter(F,w,X=>X.provideDocumentSymbols(d.URI.revive($),K),void 0,K)}registerCodeLensProvider(F,$,K){const X=this._nextHandle(),me=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new pe(new r(this._documents,this._commands.converter,K),F)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector($),me);let Ee=this._createDisposable(X);if(me!==void 0){const oe=K.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(me));Ee=P.Disposable.from(Ee,oe)}return Ee}$provideCodeLenses(F,$,K){return this._withAdapter(F,r,X=>X.provideCodeLenses(d.URI.revive($),K),void 0,K)}$resolveCodeLens(F,$,K){return this._withAdapter(F,r,X=>X.resolveCodeLens($,K),void 0,void 0)}$releaseCodeLenses(F,$){this._withAdapter(F,r,K=>Promise.resolve(K.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(F,$,K){const X=this._addNewAdapter(new n(this._documents,K),F);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideDefinition(F,$,K,X){return this._withAdapter(F,n,me=>me.provideDefinition(d.URI.revive($),K,X),[],X)}registerDeclarationProvider(F,$,K){const X=this._addNewAdapter(new t(this._documents,K),F);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideDeclaration(F,$,K,X){return this._withAdapter(F,t,me=>me.provideDeclaration(d.URI.revive($),K,X),[],X)}registerImplementationProvider(F,$,K){const X=this._addNewAdapter(new a(this._documents,K),F);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideImplementation(F,$,K,X){return this._withAdapter(F,a,me=>me.provideImplementation(d.URI.revive($),K,X),[],X)}registerTypeDefinitionProvider(F,$,K){const X=this._addNewAdapter(new u(this._documents,K),F);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideTypeDefinition(F,$,K,X){return this._withAdapter(F,u,me=>me.provideTypeDefinition(d.URI.revive($),K,X),[],X)}registerHoverProvider(F,$,K,X){const me=this._addNewAdapter(new c(this._documents,K),F);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector($)),this._createDisposable(me)}$provideHover(F,$,K,X){return this._withAdapter(F,c,me=>me.provideHover(d.URI.revive($),K,X),void 0,X)}registerEvaluatableExpressionProvider(F,$,K,X){const me=this._addNewAdapter(new S(this._documents,K),F);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector($)),this._createDisposable(me)}$provideEvaluatableExpression(F,$,K,X){return this._withAdapter(F,S,me=>me.provideEvaluatableExpression(d.URI.revive($),K,X),void 0,X)}registerInlineValuesProvider(F,$,K,X){const me=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new R(this._documents,K),F);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector($),me);let oe=this._createDisposable(Ee);if(me!==void 0){const De=K.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));oe=P.Disposable.from(oe,De)}return oe}$provideInlineValues(F,$,K,X,me){return this._withAdapter(F,R,Ee=>Ee.provideInlineValues(d.URI.revive($),K,X,me),void 0,me)}registerDocumentHighlightProvider(F,$,K){const X=this._addNewAdapter(new O(this._documents,K),F);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideDocumentHighlights(F,$,K,X){return this._withAdapter(F,O,me=>me.provideDocumentHighlights(d.URI.revive($),K,X),void 0,X)}registerLinkedEditingRangeProvider(F,$,K){const X=this._addNewAdapter(new N(this._documents,K),F);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideLinkedEditingRanges(F,$,K,X){return this._withAdapter(F,N,async me=>{const Ee=await me.provideLinkedEditingRanges(d.URI.revive($),K,X);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ee._serializeRegExp(Ee.wordPattern):void 0}},void 0,X)}registerReferenceProvider(F,$,K){const X=this._addNewAdapter(new p(this._documents,K),F);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideReferences(F,$,K,X,me){return this._withAdapter(F,p,Ee=>Ee.provideReferences(d.URI.revive($),K,X,me),void 0,me)}registerCodeActionProvider(F,$,K,X){const me=new _.DisposableStore,Ee=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,K,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector($),{providedKinds:X?.providedCodeActionKinds?.map(oe=>oe.value),documentation:X?.documentation?.map(oe=>({kind:oe.kind.value,command:this._commands.converter.toInternal(oe.command,me)}))},ee._extLabel(F),Boolean(K.resolveCodeAction)),me.add(this._createDisposable(Ee)),me}$provideCodeActions(F,$,K,X,me){return this._withAdapter(F,U,Ee=>Ee.provideCodeActions(d.URI.revive($),K,X,me),void 0,me)}$resolveCodeAction(F,$,K){return this._withAdapter(F,U,X=>X.resolveCodeAction($,K),void 0,void 0)}$releaseCodeActions(F,$){this._withAdapter(F,U,K=>Promise.resolve(K.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(F,$,K){const X=this._addNewAdapter(new B(this._documents,K),F);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector($),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentFormattingEdits(F,$,K,X){return this._withAdapter(F,B,me=>me.provideDocumentFormattingEdits(d.URI.revive($),K,X),void 0,X)}registerDocumentRangeFormattingEditProvider(F,$,K){const X=this._addNewAdapter(new z(this._documents,K),F);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector($),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(F,$,K,X,me){return this._withAdapter(F,z,Ee=>Ee.provideDocumentRangeFormattingEdits(d.URI.revive($),K,X,me),void 0,me)}registerOnTypeFormattingEditProvider(F,$,K,X){const me=this._addNewAdapter(new re(this._documents,K),F);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector($),X,F.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(F,$,K,X,me,Ee){return this._withAdapter(F,re,oe=>oe.provideOnTypeFormattingEdits(d.URI.revive($),K,X,me,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(F,$){const K=this._addNewAdapter(new H($,this._logService),F);return this._proxy.$registerNavigateTypeSupport(K,typeof $.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(F,$,K){return this._withAdapter(F,H,X=>X.provideWorkspaceSymbols($,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,$,K){return this._withAdapter(F,H,X=>X.resolveWorkspaceSymbol($,K),void 0,void 0)}$releaseWorkspaceSymbols(F,$){this._withAdapter(F,H,K=>K.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(F,$,K){const X=this._addNewAdapter(new M(this._documents,K,this._logService),F);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector($),M.supportsResolving(K)),this._createDisposable(X)}$provideRenameEdits(F,$,K,X,me){return this._withAdapter(F,M,Ee=>Ee.provideRenameEdits(d.URI.revive($),K,X,me),void 0,me)}$resolveRenameLocation(F,$,K,X){return this._withAdapter(F,M,me=>me.resolveRenameLocation(d.URI.revive($),K,X),void 0,X)}registerDocumentSemanticTokensProvider(F,$,K,X){const me=this._addNewAdapter(new V(this._documents,K),F),Ee=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector($),X,Ee);let oe=this._createDisposable(me);if(Ee){const De=K.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));oe=P.Disposable.from(oe,De)}return oe}$provideDocumentSemanticTokens(F,$,K,X){return this._withAdapter(F,V,me=>me.provideDocumentSemanticTokens(d.URI.revive($),K,X),null,X)}$releaseDocumentSemanticTokens(F,$){this._withAdapter(F,V,K=>K.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,$,K,X){const me=this._addNewAdapter(new q(this._documents,K),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector($),X),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(F,$,K,X){return this._withAdapter(F,q,me=>me.provideDocumentRangeSemanticTokens(d.URI.revive($),K,X),null,X)}registerCompletionItemProvider(F,$,K,X){const me=this._addNewAdapter(new ie(this._documents,this._commands.converter,K,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(me,this._transformDocumentSelector($),X,ie.supportsResolving(K),`${F.identifier.value}(${X.join("")})`),this._createDisposable(me)}$provideCompletionItems(F,$,K,X,me){return this._withAdapter(F,ie,Ee=>Ee.provideCompletionItems(d.URI.revive($),K,X,me),void 0,me)}$resolveCompletionItem(F,$,K){return this._withAdapter(F,ie,X=>X.resolveCompletionItem($,K),void 0,K)}$releaseCompletionItems(F,$){this._withAdapter(F,ie,K=>K.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(F,$,K){const X=new ue(F,this._documents,K,this._commands.converter),me=this._addNewAdapter(X,F);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector($),X.supportsHandleDidShowCompletionItem),this._createDisposable(me)}registerInlineCompletionsProviderNew(F,$,K){const X=this._addNewAdapter(new ce(F,this._documents,K,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector($),!0),this._createDisposable(X)}$provideInlineCompletions(F,$,K,X,me){return this._withAdapter(F,Q,Ee=>Ee.provideInlineCompletions(d.URI.revive($),K,X,me),void 0,me)}$handleInlineCompletionDidShow(F,$,K){this._withAdapter(F,Q,async X=>{X.handleDidShowCompletionItem($,K)},void 0,void 0)}$freeInlineCompletionsList(F,$){this._withAdapter(F,Q,async K=>{K.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(F,$,K,X){const me=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,Ee=this._addNewAdapter(new ge(this._documents,K),F);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector($),me),this._createDisposable(Ee)}$provideSignatureHelp(F,$,K,X,me){return this._withAdapter(F,ge,Ee=>Ee.provideSignatureHelp(d.URI.revive($),K,X,me),void 0,me)}$releaseSignatureHelp(F,$){this._withAdapter(F,ge,K=>K.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(F,$,K){const X=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new ne(this._documents,this._commands.converter,K,this._logService,F),F);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector($),typeof K.resolveInlayHint=="function",X,ee._extLabel(F));let Ee=this._createDisposable(me);if(X!==void 0){const oe=K.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(X));Ee=P.Disposable.from(Ee,oe)}return Ee}$provideInlayHints(F,$,K,X){return this._withAdapter(F,ne,me=>me.provideInlayHints(d.URI.revive($),K,X),void 0,X)}$resolveInlayHint(F,$,K){return this._withAdapter(F,ne,X=>X.resolveInlayHint($,K),void 0,K)}$releaseInlayHints(F,$){this._withAdapter(F,ne,K=>K.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(F,$,K){const X=this._addNewAdapter(new he(this._documents,K),F);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector($),typeof K.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(F,$,K){return this._withAdapter(F,he,X=>X.provideLinks(d.URI.revive($),K),void 0,K,$.scheme==="output")}$resolveDocumentLink(F,$,K){return this._withAdapter(F,he,X=>X.resolveLink($,K),void 0,void 0,!0)}$releaseDocumentLinks(F,$){this._withAdapter(F,he,K=>K.releaseLinks($),void 0,void 0,!0)}registerColorProvider(F,$,K){const X=this._addNewAdapter(new Se(this._documents,K),F);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideDocumentColors(F,$,K){return this._withAdapter(F,Se,X=>X.provideColors(d.URI.revive($),K),[],K)}$provideColorPresentations(F,$,K,X){return this._withAdapter(F,Se,me=>me.provideColorPresentations(d.URI.revive($),K,X),void 0,X)}registerFoldingRangeProvider(F,$,K){const X=this._nextHandle(),me=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new pe(new Re(this._documents,K),F)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector($),me);let Ee=this._createDisposable(X);if(me!==void 0){const oe=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Ee=P.Disposable.from(Ee,oe)}return Ee}$provideFoldingRanges(F,$,K,X){return this._withAdapter(F,Re,me=>me.provideFoldingRanges(d.URI.revive($),K,X),void 0,X)}registerSelectionRangeProvider(F,$,K){const X=this._addNewAdapter(new ve(this._documents,K,this._logService),F);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideSelectionRanges(F,$,K,X){return this._withAdapter(F,ve,me=>me.provideSelectionRanges(d.URI.revive($),K,X),[],X)}registerCallHierarchyProvider(F,$,K){const X=this._addNewAdapter(new Te(this._documents,K),F);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$prepareCallHierarchy(F,$,K,X){return this._withAdapter(F,Te,me=>Promise.resolve(me.prepareSession(d.URI.revive($),K,X)),void 0,X)}$provideCallHierarchyIncomingCalls(F,$,K,X){return this._withAdapter(F,Te,me=>me.provideCallsTo($,K,X),void 0,X)}$provideCallHierarchyOutgoingCalls(F,$,K,X){return this._withAdapter(F,Te,me=>me.provideCallsFrom($,K,X),void 0,X)}$releaseCallHierarchy(F,$){this._withAdapter(F,Te,K=>Promise.resolve(K.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(F,$,K){const X=this._addNewAdapter(new Ae(this._documents,K),F);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$prepareTypeHierarchy(F,$,K,X){return this._withAdapter(F,Ae,me=>Promise.resolve(me.prepareSession(d.URI.revive($),K,X)),void 0,X)}$provideTypeHierarchySupertypes(F,$,K,X){return this._withAdapter(F,Ae,me=>me.provideSupertypes($,K,X),void 0,X)}$provideTypeHierarchySubtypes(F,$,K,X){return this._withAdapter(F,Ae,me=>me.provideSubtypes($,K,X),void 0,X)}$releaseTypeHierarchy(F,$){this._withAdapter(F,Ae,K=>Promise.resolve(K.releaseSession($)),void 0,void 0)}registerDocumentOnDropProvider(F,$,K){const X=this._nextHandle();return this._adapter.set(X,new pe(new le(this._proxy,this._documents,K,X),F)),this._proxy.$registerDocumentOnDropProvider(X,this._transformDocumentSelector($)),this._createDisposable(X)}$provideDocumentOnDropEdits(F,$,K,X,me,Ee){return this._withAdapter(F,le,oe=>Promise.resolve(oe.provideDocumentOnDropEdits($,d.URI.revive(K),X,me,Ee)),void 0,void 0)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,b.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ee._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ee._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ee._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ee._serializeRegExp(F.beforeText),afterText:F.afterText?ee._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ee._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ee._serializeOnEnterRule)}setLanguageConfiguration(F,$,K){let{wordPattern:X}=K;if(X&&(0,b.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor($,X):this._documents.setWordDefinitionFor($,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const me=this._nextHandle(),Ee={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ee._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?ee._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ee._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,$,Ee),this._createDisposable(me)}$setWordDefinitions(F){for(const $ of F)this._documents.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(Ie[243],ke([1,0,5,15,7,43,17,6]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(L,k,y,T){this._documents=k,this._commands=y,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,k){await this._proxy.$changeLanguage(L,k);const y=this._documents.getDocumentData(L);if(!y)throw new Error(`document '${L.toString()}' NOT found`);return y.document}async tokenAtPosition(L,k){const y=L.version,T=i.Position.from(k),_=await this._proxy.$tokensAtPosition(L.uri,T),m={type:C.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!_)return m;const v={range:i.Range.to(_.range),type:i.TokenType.to(_.type)};return!v.range.contains(k)||y!==L.version?m:v}createLanguageStatusItem(L,k,y){const T=this._handlePool++,_=this._proxy,m=this._ids,v=`${L.identifier.value}/${k}`;if(m.has(v))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);m.add(v);const g={selector:y,id:k,name:L.displayName??L.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let E,h=new D.DisposableStore;const l=()=>{E?.dispose(),E=(0,I.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(T,{id:v,name:g.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===C.LanguageStatusSeverity.Error?P.default.Error:g.severity===C.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:g.command&&this._commands.toInternal(g.command,h),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},f={dispose(){h.dispose(),E?.dispose(),_.$removeLanguageStatus(T),m.delete(v)},get id(){return g.id},get name(){return g.name},set name(o){g.name=o,l()},get selector(){return g.selector},set selector(o){g.selector=o,l()},get text(){return g.text},set text(o){g.text=o,l()},get detail(){return g.detail},set detail(o){g.detail=o,l()},get severity(){return g.severity},set severity(o){g.severity=o,l()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(o){g.accessibilityInformation=o,l()},get command(){return g.command},set command(o){g.command=o,l()},get busy(){return g.busy},set busy(o){g.busy=o,l()}};return l(),f}}e.ExtHostLanguages=b}),define(Ie[136],ke([1,0,13,5,27,18,3]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends d.AbstractLoggerService{constructor(L,k){const y=new I.Emitter;super(k.logLevel,y.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(y)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,k,y){return new b(this._proxy,L,k,y)}};D=Ve([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class b extends d.AbstractMessageLogger{constructor(L,k,y,T){super(T?.always);this.proxy=L,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(y),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,k){const y=[[L,k]];this.isLoggerCreated?this.doLog(y):this.buffer.push(...y)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ie[244],ke([1,0,5,13,25]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(D){return D&&D.title}let I=class{constructor(b,A){this._logService=A,this._proxy=b.getProxy(d.MainContext.MainThreadMessageService)}showMessage(b,A,L,k,y){const T={source:{identifier:b.identifier,label:b.displayName||b.name}};let _;typeof k=="string"||P(k)?_=[k,...y]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,_=y),T.useCustom&&(0,C.checkProposedApiEnabled)(b,"resolvers");const m=[];for(let v=0;v<_.length;v++){const g=_[v];if(typeof g=="string")m.push({title:g,handle:v,isCloseAffordance:!1});else if(typeof g=="object"){let{title:E,isCloseAffordance:h}=g;m.push({title:E,isCloseAffordance:!!h,handle:v})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(A,L,T,m).then(v=>{if(typeof v=="number")return _[v]})}};I=Ve([$e(1,i.ILogService)],I),e.ExtHostMessageService=I}),define(Ie[245],ke([1,0,23,3,59,6,24,8,14,2,86,5,37,15,7,52,222,131]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class E{constructor(l,f,o,w,r){this._textDocumentsAndEditors=o,this._textDocuments=w,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,u=this._documents.get(n)?.getCell(t);if(u)return u.apiCell}return s}}),E._registerApiCommands(f)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const f=this._editors.get(l);if(!f)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(l){for(const[f,o]of this._editors)if(o.apiEditor===l)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,f){const o=this._documents.get(l);if(!o&&!f)throw new Error(`NO notebook document for '${l}'`);return o}_getProviderData(l){const f=this._notebookContentProviders.get(l);if(!f)throw new Error(`NO provider for '${l}'`);return f}registerNotebookContentProvider(l,f,o,w,r){if((0,D.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:l,provider:o});let s;return o.onDidChangeNotebookContentOptions&&(s=o.onDidChangeNotebookContentOptions(()=>{const n=T.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(f,n)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},f,T.NotebookDocumentContentOptions.from(w),E._convertNotebookRegistrationData(l,r)),new _.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(l,f){if(!f)return;const o=f.filenamePattern.map(w=>T.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(f.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:f.displayName,filenamePattern:o,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,f,o){const w=E._notebookStatusBarItemProviderHandlePool++,r=typeof o.onDidChangeCellStatusBarItems=="function"?E._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(w,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(w,r,f);let s;return r!==void 0&&(s=o.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(r))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(w),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(w,r),s&&s.dispose()})}async createNotebookDocument(l){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&T.NotebookData.from(l.content)});return A.URI.revive(f)}async openNotebookDocument(l){const f=this._documents.get(l);if(f)return f.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(l),w=this._documents.get(A.URI.revive(o));return(0,b.assertIsDefined)(w?.apiNotebook)}async showNotebookDocument(l,f){A.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let o;typeof f=="object"?o={position:T.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(T.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:o={preserveFocus:!1};const w=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,o),r=w&&this._editors.get(w)?.apiEditor;if(r)return r;throw w?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,f,o,w){const r=this._notebookStatusBarItemProviders.get(l),s=A.URI.revive(f),n=this._documents.get(s);if(!n||!r)return;const t=n.getCellFromIndex(o);if(!t)return;const a=await r.provideCellStatusBarItems(t.apiCell,w);if(!a)return;const u=new P.DisposableStore,c=this._statusBarCache.add([u]),R=(Array.isArray(a)?a:[a]).map(O=>T.NotebookStatusBarItem.from(O,this._commandsConverter,u));return{cacheId:c,items:R}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,f,o,w,r){if((0,D.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,o),this._notebookProxy.$registerNotebookSerializer(s,{id:l.identifier,location:l.extensionLocation},f,T.NotebookDocumentContentOptions.from(w),E._convertNotebookRegistrationData(l,r)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(l,f,o){const w=this._notebookSerializer.get(l);if(!w)throw new Error("NO serializer found");const r=await w.deserializeNotebook(f.buffer,o);return new m.SerializableObjectWithBuffers(T.NotebookData.from(r))}async $notebookToData(l,f,o){const w=this._notebookSerializer.get(l);if(!w)throw new Error("NO serializer found");const r=await w.serializeNotebook(T.NotebookData.to(f.value),o);return d.VSBuffer.wrap(r)}async $openNotebook(l,f,o,w,r){const{provider:s}=this._getProviderData(l),n=await s.openNotebook(A.URI.revive(f),{backupId:o,untitledDocumentData:w?.buffer},r);return new m.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(T.NotebookCellData.from)})}async $saveNotebook(l,f,o){const w=this.getNotebookDocument(A.URI.revive(f)),{provider:r}=this._getProviderData(l);return await r.saveNotebook(w.apiNotebook,o),!0}async $saveNotebookAs(l,f,o,w){const r=this.getNotebookDocument(A.URI.revive(f)),{provider:s}=this._getProviderData(l);return await s.saveNotebookAs(A.URI.revive(o),r.apiNotebook,w),!0}async $backupNotebook(l,f,o){const w=this.getNotebookDocument(A.URI.revive(f)),r=this._getProviderData(l),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),n=String((0,C.hash)([w.uri.toString(),this._backupIdPool++])),t=A.URI.joinPath(s,n),a=await r.provider.backupNotebook(w.apiNotebook,{destination:t},o);return w.updateBackup(a),a.id}_createExtHostEditor(l,f,o){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const w=new g.ExtHostNotebookEditor(f,this._notebookEditorsProxy,l,o.visibleRanges.map(T.NotebookRange.to),o.selections.map(T.NotebookRange.to),typeof o.viewColumn=="number"?T.ViewColumn.to(o.viewColumn):void 0);this._editors.set(f,w)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const o of l.value.removedDocuments){const w=A.URI.revive(o),r=this._documents.get(w);r&&(r.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===w.toString()&&this._editors.delete(s.id)}if(l.value.addedDocuments){const o=[];for(const w of l.value.addedDocuments){const r=A.URI.revive(w.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,w);o.push(...w.cells.map(n=>v.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(l.value.addedEditors)for(const o of l.value.addedEditors){if(this._editors.has(o.id))return;const w=A.URI.revive(o.documentUri),r=this._documents.get(w);r&&this._createExtHostEditor(r,o.id,o)}const f=[];if(l.value.removedEditors)for(const o of l.value.removedEditors){const w=this._editors.get(o);w&&(this._editors.delete(o),this._activeNotebookEditor?.id===w.id&&(this._activeNotebookEditor=void 0),f.push(w))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const o=new Set;this._visibleNotebookEditors.forEach(w=>o.add(w.id));for(const w of this._editors.values()){const r=o.has(w.id);w._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const f=y.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new y.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>d.VSBuffer.wrap(r))],new y.ApiCommandResult("Notebook Data",r=>T.NotebookData.to(r.value))),w=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new m.SerializableObjectWithBuffers(T.NotebookData.from(r)))],new y.ApiCommandResult("Bytes",r=>r.buffer));l.registerApiCommand(o),l.registerApiCommand(w)}}e.ExtHostNotebookController=E,E._notebookStatusBarItemProviderHandlePool=0}),define(Ie[246],ke([1,0,3,78,13,5,18,15]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(k,y){const T=b._Keys.nextId();k.$registerNotebookEditorDecorationType(T,D.NotebookDecorationRenderOptions.from(y)),this.value={key:T,dispose(){k.$removeNotebookEditorDecorationType(T)}}}}b._Keys=new i.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(k,y,T){this._logService=k,this._extHostRpc=y,this._notebooksAndEditors=T,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new b(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,y);const T=this._notebooksAndEditors.getEditorById(k);y.visibleRanges&&T._acceptVisibleRanges(y.visibleRanges.ranges.map(D.NotebookRange.to)),y.selections&&T._acceptSelections(y.selections.selections.map(D.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const y in k)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(D.ViewColumn.to(k[y]))}};A=Ve([$e(0,C.ILogService),$e(1,I.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(Ie[137],ke([1,0,16,17,21,3,6,24,2,28,13,5,37,15,7,87,216,25,52]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(s,n,t,a,u){this._initData=n,this._extHostNotebook=t,this._commands=a,this._logService=u,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(k.MainContext.MainThreadNotebookKernels);const c=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const R=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:R}}else if(S&&"notebookEditor"in S){const R=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return S})],y.ApiCommandResult.Void);this._commands.registerApiCommand(c)}createNotebookController(s,n,t,a,u,c){for(const ie of this._kernelData.values())if(ie.controller.id===n&&A.ExtensionIdentifier.equals(s.identifier,ie.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const S=this._handlePool++,R=this;this._logService.trace(`NotebookController[${S}], CREATED by ${s.identifier.value}, ${n}`);const O=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${s.identifier}'`);let N=!1;const p=new I.DisposableStore,U=new P.Emitter,B=new P.Emitter,z={id:w(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:a||s.identifier.value,preloads:c?c.map(T.NotebookRendererScript.from):[]};let re=u??O,H;this._proxy.$addKernel(S,z).catch(ie=>{console.log(ie),N=!0});let M=0;const j=()=>{if(N)return;const ie=++M;Promise.resolve().then(()=>{ie===M&&this._proxy.$updateKernel(S,z)})},V=new D.ResourceMap,q={get id(){return n},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return z.label},set label(ie){z.label=ie??s.displayName??s.name,j()},get detail(){return z.detail??""},set detail(ie){z.detail=ie,j()},get description(){return z.description??""},set description(ie){z.description=ie,j()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind??""},set kind(ie){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),z.kind=ie,j()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ie){z.supportedLanguages=ie,j()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){z.supportsExecutionOrder=ie,j()},get rendererScripts(){return z.preloads?z.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ie){re=ie??O},get interruptHandler(){return H},set interruptHandler(ie){H=ie,z.supportsInterrupt=Boolean(ie),j()},createNotebookCellExecution(ie){if(N)throw new Error("notebook controller is DISPOSED");if(!V.has(ie.notebook.uri))throw R._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return R._createNotebookCellExecution(ie,w(s.identifier,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${S}], DISPOSED`),N=!0,this._kernelData.delete(S),p.dispose(),U.dispose(),B.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(ie,Q){R._proxy.$updateNotebookPriority(S,ie.uri,Q)},onDidReceiveMessage:B.event,postMessage(ie,Q){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(S,Q&&R._extHostNotebook.getIdByEditor(Q),ie)},asWebviewUri(ie){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,m.asWebviewUri)(ie,R._initData.remote)}};return this._kernelData.set(S,{extensionId:s.identifier,controller:q,onDidReceiveMessage:B,onDidChangeSelection:U,associatedNotebooks:V}),q}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return w(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const a=this._kernelData.get(s);if(a){const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));t?a.associatedNotebooks.set(u.uri,!0):a.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,u.uri.toString(),t),a.onDidChangeSelection.fire({selected:t,notebook:u.apiNotebook})}}async $executeCells(s,n,t){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(n)),c=[];for(const S of t){const R=u.getCell(S);R&&c.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,u.uri.toString(),c.length),await a.controller.executeHandler.call(a.controller,c,u.apiNotebook,a.controller)}catch(S){this._logService.error(`NotebookController[${s}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(s,n,t){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,u.apiNotebook);else for(const c of t){const S=u.getCell(c);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const a=this._kernelData.get(s);if(!a)return;const u=this._extHostNotebook.getEditorById(n);a.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(s)).getCell(n);u&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:t?T.NotebookCellExecutionState.to(t):_.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const u=new f(n,a,this._proxy);this._activeExecutions.set(a.uri,u);const c=u.onDidChangeState(()=>{u.state===l.Resolved&&(u.dispose(),c.dispose(),this._activeExecutions.delete(a.uri))});return u.asApiObject()}};h=Ve([$e(4,L.ILogService)],h),e.ExtHostNotebookKernels=h;var l;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(l||(l={}));class f extends I.Disposable{constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=f.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new o(10,a=>this.update(a)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new E.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(s){return s.map(n=>{const t=_.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?T.NotebookCellOutput.from(n):T.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const a=this.validateAndConvertOutputs((0,d.asArray)(s));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:t,outputs:a})}async updateOutputItems(s,n,t){return s=_.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(s),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:s.map(T.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===l.Resolved||s._state===l.Started)throw new Error("Cannot call start again");s._state=l.Started,s._onDidChangeState.fire(),s.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,a){if(s._state===l.Resolved)throw new Error("Cannot call resolve twice");s._state=l.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new E.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,a){return s.verifyStateForOutput(),s.updateOutputs(t,a,!0)},replaceOutput(t,a){return s.verifyStateForOutput(),s.updateOutputs(t,a,!1)},appendOutputItems(t,a){return s.verifyStateForOutput(),s.updateOutputItems(t,a,!0)},replaceOutputItems(t,a){return s.verifyStateForOutput(),s.updateOutputItems(t,a,!1)}})}}f.HANDLE=0;class o{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function w(r,s){return`${r.value}/${s}`}e.createKernelId=w}),define(Ie[247],ke([1,0,3,6,24,13,5,137,25]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookProxyKernels=void 0;let A=class{constructor(k,y,T){this.extHostNotebook=y,this._logService=T,this._proxyKernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new d.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=k.getProxy(I.MainContext.MainThreadNotebookProxyKernels)}createNotebookProxyController(k,y,T,_,m){const v=this._handlePool++;let g=!1;const E=new i.DisposableStore,h=new d.Emitter,l={id:(0,D.createKernelId)(k.identifier,y),notebookType:T,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:_||k.identifier.value};let f=m;this._proxy.$addProxyKernel(v,l).catch(n=>{console.log(n),g=!0});let o=0;const w=()=>{if(g)return;const n=++o;Promise.resolve().then(()=>{n===o&&this._proxy.$updateProxyKernel(v,l)})},r=new C.ResourceMap,s={get id(){return y},get notebookType(){return l.notebookType},onDidChangeSelectedNotebooks:h.event,get label(){return l.label},set label(n){l.label=n??k.displayName??k.name,w()},get detail(){return l.detail??""},set detail(n){l.detail=n,w()},get description(){return l.description??""},set description(n){l.description=n,w()},get kind(){return(0,b.checkProposedApiEnabled)(k,"notebookControllerKind"),l.kind??""},set kind(n){(0,b.checkProposedApiEnabled)(k,"notebookControllerKind"),l.kind=n,w()},get resolveHandler(){return f},dispose:()=>{g||(this._logService.trace(`NotebookProxyController[${v}], DISPOSED`),g=!0,this._proxyKernelData.delete(v),E.dispose(),h.dispose(),this._proxy.$removeProxyKernel(v))}};return this._proxyKernelData.set(v,{extensionId:k.identifier,controller:s,onDidChangeSelection:h,associatedNotebooks:r}),s}async $resolveKernel(k){const y=this._proxyKernelData.get(k);if(!y)return null;const T=await y.controller.resolveHandler();return typeof T=="string"?T:this.extHostNotebook.getIdByController(T)}};A=Ve([$e(2,P.ILogService)],A),e.ExtHostNotebookProxyKernels=A}),define(Ie[248],ke([1,0,3,5,131,25]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class I{constructor(b,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=b.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(b,A,L){const k=this._extHostNotebook.getEditorById(b);this._rendererMessageEmitters.get(A)?.fire({editor:k.apiEditor,message:L})}createRendererMessaging(b,A){if(!b.contributes?.notebookRenderer?.some(T=>T.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const L=(0,P.isProposedApiEnabled)(b,"notebookEditor"),k=new WeakMap;return{onDidReceiveMessage:(T,_,m)=>{const v=L?T:g=>{const E={};k.set(E,g.editor),T({editor:E,message:g.message})};return this.getOrCreateEmitterFor(A).event(v,_,m)},postMessage:(T,_)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,_]=[_,T]);const m=L?_:k.get(_),v=m&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(m);return this.proxy.$postMessage(v?.id,A,T)}}}getOrCreateEmitterFor(b){let A=this._rendererMessageEmitters.get(b);return A||(A=new d.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(b)}}),this._rendererMessageEmitters.set(b,A),A)}}e.ExtHostNotebookRenderers=I}),define(Ie[249],ke([1,0,21,3,6,5,2,7,11,16,43,85]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function y(T,_,m){const v=T.getProxy(P.MainContext.MainThreadQuickOpen);class g{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,a=d.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(n),c=++this._instances,S=v.$show(c,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},a),R={},O=S.then(()=>R);return Promise.race([O,u]).then(N=>{if(N!==R)return u.then(p=>{const U=[];for(let B=0;B<p.length;B++){const z=p[B];typeof z=="string"?U.push({label:z,handle:B}):z.kind===D.QuickPickItemKind.Separator?U.push({type:"separator",label:z.label}):U.push({label:z.label,description:z.description,detail:z.detail,picked:z.picked,alwaysShow:z.alwaysShow,handle:B})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{t.onDidSelectItem(p[B])}),v.$setItems(c,U),S.then(B=>{if(typeof B=="number")return p[B];if(Array.isArray(B))return B.map(z=>p[z])})})}).then(void 0,N=>{if(!(0,b.isCancellationError)(N))return v.$setError(c,N),Promise.reject(N)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=d.CancellationToken.None){return this._validateInput=n?.validateInput,v.$input(n,typeof this._validateInput=="function",t).then(void 0,a=>{if(!(0,b.isCancellationError)(a))return Promise.reject(a)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let a;switch(t.severity){case D.InputBoxValidationSeverity.Info:a=L.default.Info;break;case D.InputBoxValidationSeverity.Warning:a=L.default.Warning;break;case D.InputBoxValidationSeverity.Error:a=L.default.Error;break;default:a=t.message?L.default.Error:L.default.Ignore;break}return{content:t.message,severity:a}}async showWorkspaceFolderPick(n,t=d.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!a)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(c=>c.uri.toString()===a.uri.toString())}createQuickPick(n){const t=new w(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new r(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const a=this._sessions.get(n);a&&a._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const a=this._sessions.get(n);a instanceof w&&a._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const a=this._sessions.get(n);a instanceof w&&a._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const a=this._sessions.get(n);a&&a._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,a){const u=this._sessions.get(n);u instanceof w&&u._fireDidTriggerItemButton(t,a)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class E{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=w._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new i.Emitter,this._onDidChangeValueEmitter=new i.Emitter,this._onDidTriggerButtonEmitter=new i.Emitter,this._onDidHideEmitter=new i.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,a)=>{const u=t===D.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(u,t)}),this.update({buttons:n.map((t,a)=>({...o(t),tooltip:t.tooltip,handle:t===D.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const a=n[t];this._pendingUpdate[t]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function h(s){if(s instanceof D.ThemeIcon)return{id:s.id};const n=f(s),t=l(s);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof t=="string"?I.URI.file(t):t}}function l(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}function o(s){const n=h(s.iconPath);let t,a;return"id"in n?a=k.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:a}}class w extends E{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new i.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new i.Emitter,this._onDidTriggerItemButtonEmitter=new i.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,u)=>{this._handlesToItems.set(u,a),this._itemsToHandles.set(a,u)});const t=[];for(let a=0;a<n.length;a++){const u=n[a];u.kind===D.QuickPickItemKind.Separator?t.push({type:"separator",label:u.label}):t.push({handle:a,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((c,S)=>({...o(c),tooltip:c.tooltip,handle:S}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,A.coalesce)(n.map(a=>this._handlesToItems.get(a)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,A.coalesce)(n.map(a=>this._handlesToItems.get(a)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const a=this._handlesToItems.get(n);if(!a||!a.buttons||!a.buttons.length)return;const u=a.buttons[t];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:a})}}class r extends E{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:L.default.Error}):this.update({validationMessage:n.message,severity:n.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new g(_,m)}e.createExtHostQuickOpen=y});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[250],ke([1,0,2,3,57,6,17,5,16,99,13,28,85,15,25]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_){"use strict";var m,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(u){if(u)return typeof u.iconPath=="string"?d.URI.file(u.iconPath):d.URI.isUri(u.iconPath)||y.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function E(u,c){if(!u.iconPath&&!c.iconPath)return 0;if(u.iconPath){if(!c.iconPath)return 1}else return-1;const S=typeof u.iconPath=="string"?u.iconPath:d.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,R=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,A.comparePaths)(S,R)}function h(u,c){let S=0;if(u.strikeThrough!==c.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==c.faded)return u.faded?1:-1;if(u.tooltip!==c.tooltip)return(u.tooltip||"").localeCompare(c.tooltip||"");if(S=E(u,c),S!==0)return S;if(u.light&&c.light)S=E(u.light,c.light);else{if(u.light)return 1;if(c.light)return-1}if(S!==0)return S;if(u.dark&&c.dark)S=E(u.dark,c.dark);else{if(u.dark)return 1;if(c.dark)return-1}return S}function l(u,c){if(u.command!==c.command)return u.command<c.command?-1:1;if(u.title!==c.title)return u.title<c.title?-1:1;if(u.tooltip!==c.tooltip){if(u.tooltip!==void 0&&c.tooltip!==void 0)return u.tooltip<c.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(u.arguments===c.arguments)return 0;if(u.arguments)if(c.arguments){if(u.arguments.length!==c.arguments.length)return u.arguments.length-c.arguments.length}else return 1;else return-1;for(let S=0;S<u.arguments.length;S++){const R=u.arguments[S],O=c.arguments[S];if(R!==O)return R<O?-1:1}return 0}function f(u,c){let S=(0,A.comparePaths)(u.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(S!==0)return S;if(u.command&&c.command)S=l(u.command,c.command);else{if(u.command)return 1;if(c.command)return-1}if(S!==0)return S;if(u.decorations&&c.decorations)S=h(u.decorations,c.decorations);else{if(u.decorations)return 1;if(c.decorations)return-1}return S}function o(u,c){for(let S=0;S<u.length;S++)if(u[S]!==c[S])return!1;return!0}function w(u,c){return u.command===c.command&&u.title===c.title&&u.tooltip===c.tooltip&&(u.arguments&&c.arguments?o(u.arguments,c.arguments):u.arguments===c.arguments)}function r(u,c){return(0,b.equals)(u,c,w)}class s{constructor(c,S,R){this._extension=c,this._sourceControlHandle=R,m.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,et(this,m,S,"f")}get value(){return this._value}set value(c){c=c??"",Ue(this,m,"f").$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){Ue(this,m,"f").$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,Ue(this,m,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,Ue(this,m,"f").$setInputBoxVisibility(this._sourceControlHandle,c))}showValidationMessage(c,S){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this._sourceControlHandle,c,S)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=s,m=new WeakMap;class n{constructor(c,S,R,O,N){this._proxy=c,this._commands=S,this._sourceControlHandle=R,this._id=O,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,S){const R=this._resourceStatesCommandsMap.get(c);return R?(0,I.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(f),R=(0,b.sortedDiff)(this._resourceSnapshot,c,f).map(p=>{const U=p.toInsert.map(B=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,B);const re=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ge=new P.DisposableStore;H=this._commands.converter.toInternal(B.command,ge),this._resourceStatesDisposablesMap.set(z,ge)}else this._resourceStatesCommandsMap.set(z,B.command);const M=g(B.decorations),j=B.decorations&&g(B.decorations.light)||M,V=B.decorations&&g(B.decorations.dark)||M,q=[j,V],ie=B.decorations&&B.decorations.tooltip||"",Q=B.decorations&&!!B.decorations.strikeThrough,ue=B.decorations&&!!B.decorations.faded,ce=B.contextValue||"";return{rawResource:[z,re,q,ie,Q,ue,ce,H],handle:z}});return{start:p.start,deleteCount:p.deleteCount,toInsert:U}}),O=R.map(({start:p,deleteCount:U,toInsert:B})=>[p,U,B.map(z=>z.rawResource)]),N=R.reverse();for(const{start:p,deleteCount:U,toInsert:B}of N){const z=B.map(H=>H.handle),re=this._handlesSnapshot.splice(p,U,...z);for(const H of re)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=c,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(c,S,R,O,N,p){this._extension=c,this._commands=R,this._id=O,this._label=N,this._rootUri=p,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,et(this,v,S,"f"),this._inputBox=new s(c,Ue(this,v,"f"),this.handle),Ue(this,v,"f").$registerSourceControl(this.handle,O,N,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,Ue(this,v,"f").$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,Ue(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,Ue(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=c;const S=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);Ue(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=c;const S=c!==void 0?{command:this._commands.converter.toInternal(c.command,this._actionButtonDisposables.value),description:c.description}:void 0;Ue(this,v,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&r(this._statusBarCommands,c))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=c;const S=(c||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(c,S){const R=new n(Ue(this,v,"f"),this._commands,this.handle,c,S),O=i.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,O),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const c=[],S=[];for(const[R,O]of this.createdResourceGroups){O.dispose();const N=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});i.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),N.dispose(),this._groups.delete(R.handle),Ue(this,v,"f").$unregisterGroup(this.handle,R.handle)}),c.push([R.handle,R.id,R.label,R.features]);const p=R._takeResourceStateSnapshot();p.length>0&&S.push([R.handle,p]),this._groups.set(R.handle,R)}Ue(this,v,"f").$registerGroups(this.handle,c,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(S=>{const R=S._takeResourceStateSnapshot();R.length!==0&&c.push([S.handle,R])}),c.length>0&&Ue(this,v,"f").$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),Ue(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,t._handlePool=0,Ve([(0,C.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let a=class Qi{constructor(c,S,R){this._commands=S,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=c.getProxy(D.MainContext.MainThreadSCM),this._telemetry=c.getProxy(D.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const N=this._sourceControls.get(O.sourceControlHandle);if(!N)return O;const p=N.getResourceGroup(O.groupHandle);return p?p.getResourceState(O.handle):O}else if(O&&O.$mid===4){const N=this._sourceControls.get(O.sourceControlHandle);return N?N.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const N=this._sourceControls.get(O.handle);return N||O}return O}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,S,R,O){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,S,R,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const N=Qi._handlePool++,p=new t(c,this._proxy,this._commands,S,R,O);this._sourceControls.set(N,p);const U=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(c.identifier))||[];return U.push(p),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(c.identifier),U),p}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const S=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(c.identifier)),R=S&&S[S.length-1];return R&&R.inputBox}$provideOriginalResource(c,S,R){const O=d.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,O.toString());const N=this._sourceControls.get(c);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(O,R)).then(p=>p||null)}$onInputBoxValueChange(c,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const R=this._sourceControls.get(c);return R&&R.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(c,S,R,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,S,R);const N=this._sourceControls.get(c);if(!N)return Promise.resolve(void 0);const p=N.getResourceGroup(S);return p?p.$executeResourceCommand(R,O):Promise.resolve(void 0)}$validateInput(c,S,R){this.logService.trace("ExtHostSCM#$validateInput",c);const O=this._sourceControls.get(c);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>O.inputBox.validateInput(S,R)).then(N=>{if(!N)return Promise.resolve(void 0);const p=T.MarkdownString.fromStrict(N.message);return p?Promise.resolve([p,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};a._handlePool=0,a=Ve([$e(2,L.ILogService)],a),e.ExtHostSCM=a});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[251],ke([1,0,7,5,174,6,15,14]),function(Y,e,d,i,C,P,I,D){"use strict";var b,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(_,m,v,g,E=d.StatusBarAlignment.Left,h){b.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,et(this,b,_,"f"),et(this,A,m,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=g,this._alignment=E,this._priority=this.validatePriority(h)}validatePriority(_){if(!!(0,D.isNumber)(_))return _===Number.POSITIVE_INFINITY?Number.MAX_VALUE:_===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:_}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set name(_){this._name=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!L.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){this._command?.fromApi!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:Ue(this,A,"f").toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:Ue(this,A,"f").toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let _;this._extension?this._id?_=`${this._extension.identifier.value}.${this._id}`:_=this._extension.identifier.value:_=this._id;let m;this._name?m=this._name:m=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=I.MarkdownString.fromStrict(this._tooltip);Ue(this,b,"f").$setEntry(this._entryId,_,m,this._text,g,this._command?.internal,v,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,b=new WeakMap,A=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(_){this._messages=[],this._item=_.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const m={message:_};return this._messages.unshift(m),this._update(),new d.Disposable(()=>{const v=this._messages.indexOf(m);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class y{constructor(_,m){this._proxy=_.getProxy(i.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new k(this)}createStatusBarEntry(_,m,v,g){return new L(this._proxy,this._commands,_,m,v,g)}setStatusBarMessage(_,m){const v=this._statusMessage.setMessage(_);let g;return typeof m=="number"?g=setTimeout(()=>v.dispose(),m):typeof m!="undefined"&&m.then(()=>v.dispose(),()=>v.dispose()),new d.Disposable(()=>{v.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=y}),define(Ie[90],ke([1,0,5,3,4]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(D){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,b){this._proxy.$registerExtensionStorageKeysToSync(D,b)}initializeExtensionStorage(D,b,A){return this._proxy.$initializeExtensionStorage(D,b).then(L=>L||A)}setValue(D,b,A){return this._proxy.$setValue(D,b,A)}$acceptValue(D,b,A){this._onDidChangeStorage.fire({shared:D,key:b,value:A})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Ie[70],ke([1,0,4,27,13,69,2]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let D=class{constructor(A,L,k){this._logService=L,this._extHostFileSystem=k,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(y=>this._value=y)}async _getWorkspaceStorageURI(A){return I.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,L=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(A){if(this._value)return I.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return I.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Ve([$e(0,i.IExtHostInitDataService),$e(1,C.ILogService),$e(2,P.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(Ie[38],ke([1,0,3,5,4,2,18,6,7,175,11,218,21,35,201,85,14,17]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class E{constructor(t,a,u,c){this._proxy=t,this._id=a,this._creationOptions=u,this._name=c,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(R,O=!0){S._checkDisposed(),S._proxy.$sendText(S._id,R,O)},show(R){S._checkDisposed(),S._proxy.$show(S._id,R)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(t,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,v.withNullAsUndefined)(t.shellPath),shellArgs:(0,v.withNullAsUndefined)(t.shellArgs),cwd:(0,v.withNullAsUndefined)(t.cwd),env:(0,v.withNullAsUndefined)(t.env),icon:(0,v.withNullAsUndefined)(r(t.iconPath)),color:m.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,v.withNullAsUndefined)(t.message),strictEnv:(0,v.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(t.location,a?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,a,u,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:m.ThemeColor.isThemeColor(c)?c.id:void 0,location:this._serializeParentTerminal(t,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,a){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,a){return t===this._cols&&a===this._rows||t===0||a===0?!1:(this._cols=t,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=E;class h{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,a){this._pty.setDimensions?.({columns:t,rows:a})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let l=1,f=class extends D.Disposable{constructor(t,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,c]of this._terminalProcesses)c.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,a){const u=new E(this._proxy,(0,T.generateUuid)(),t,t.name),c=new h(t.pty);return u.createExtensionTerminal(t.location,this._serializeParentTerminal(t,a).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(S=>{const R=this._setupExtHostProcessListeners(S,c);this._terminalProcessDisposables[S]=R}),this._terminals.push(u),u.value}_serializeParentTerminal(t,a){if(a=a||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const u=t.location.parentTerminal;if(u){const c=this._terminals.find(S=>S.value===u);c&&(a.resolvedExtHostIdentifier=c._id)}}else t.location&&typeof t.location!="object"?a.location=t.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(t,a){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const c=new h(a),S=this._setupExtHostProcessListeners(t,c);this._terminalProcessDisposables[t]=S}async $acceptActiveTerminalChanged(t){const a=this._activeTerminal;if(t===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,a){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:a})}async $acceptTerminalDimensions(t,a,u){const c=this._getTerminalById(t);c&&c.setDimensions(a,u)&&this._onDidChangeTerminalDimensions.fire({terminal:c.value,dimensions:c.value.dimensions})}async $acceptTerminalMaximumDimensions(t,a,u){this._terminalProcesses.get(t)?.resize(a,u)}async $acceptTerminalTitleChange(t,a){const u=this._getTerminalById(t);u&&(u.name=a)}async $acceptTerminalClosed(t,a){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const c=this._terminals.splice(u,1)[0];c.setExitCode(a),this._onDidCloseTerminal.fire(c.value)}}$acceptTerminalOpened(t,a,u,c){if(a){const O=this._getTerminalObjectIndexById(this._terminals,a);if(O!==null){this._terminals[O]._id=t,this._onDidOpenTerminal.fire(this.terminals[O]),this._terminals[O].isOpen=!0;return}}const S={name:c.name,shellPath:c.executable,shellArgs:c.args,cwd:typeof c.cwd=="string"?c.cwd:P.URI.revive(c.cwd),env:c.env,hideFromUser:c.hideFromUser},R=new E(this._proxy,t,S,u);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(t,a){const u=this._getTerminalById(t);u&&u._setProcessId(a)}async $startExtensionTerminal(t,a){const u=this._getTerminalById(t);if(!u)return{message:(0,A.localize)(0,null,t)};u.isOpen||await new Promise(S=>{const R=this.onDidOpenTerminal(async O=>{O===u.value&&(R.dispose(),S())})});const c=this._terminalProcesses.get(t);c?c.startSendingEvents(a):this._extensionTerminalAwaitingStart[t]={initialDimensions:a}}_setupExtHostProcessListeners(t,a){const u=new D.DisposableStore;u.add(a.onProcessReady(S=>this._proxy.$sendProcessReady(t,S.pid,S.cwd))),u.add(a.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(t,S))),this._bufferer.startBuffering(t,a.onProcessData),u.add(a.onProcessExit(S=>this._onProcessExit(t,S))),this._terminalProcesses.set(t,a);const c=this._extensionTerminalAwaitingStart[t];return c&&a instanceof h&&(a.startSendingEvents(c.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,a){this._terminalProcesses.get(t)?.acknowledgeDataEvent(a)}$acceptProcessInput(t,a){this._terminalProcesses.get(t)?.input(a)}$acceptTerminalInteraction(t){const a=this._getTerminalById(t);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(t,a,u){try{this._terminalProcesses.get(t)?.resize(a,u)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(t,a){this._terminalProcesses.get(t)?.shutdown(a)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:a}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,a,u){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,u),this._proxy.$registerProfileProvider(a,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(t,a){const u=new y.CancellationTokenSource().token;let c=await this._profileProviders.get(t)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(c&&!("options"in c)&&(c={options:c}),!c||!("options"in c))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in c.options){this.createExtensionTerminal(c.options,a);return}this.createTerminalFromOptions(c.options,a)}}async $provideLinks(t,a){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const c=this._terminalLinkCancellationSource.get(t);c&&c.dispose(!0);const S=new y.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,S);const R=[],O={terminal:u.value,line:a},N=[];for(const B of this._linkProviders)N.push(g.Promises.withAsyncBody(async z=>{S.token.onCancellationRequested(()=>z({provider:B,links:[]}));const re=await B.provideTerminalLinks(O,S.token)||[];S.token.isCancellationRequested||z({provider:B,links:re})}));const p=await Promise.all(N);if(S.token.isCancellationRequested)return[];const U=new Map;for(const B of p)B&&B.links.length>0&&R.push(...B.links.map(z=>{const re={id:l++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return U.set(re.id,{provider:B.provider,link:z}),re}));return this._terminalLinkCache.set(t,U),R}$activateLink(t,a){const u=this._terminalLinkCache.get(t)?.get(a);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(t,a){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,a)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,a){const u=this._getTerminalObjectIndexById(t,a);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,a){let u=null;return t.some((c,S)=>c._id===a?(u=S,!0):!1),u}getEnvironmentVariableCollection(t){let a=this._environmentVariableCollections.get(t.identifier.value);return a||(a=new o,this._setEnvironmentVariableCollection(t.identifier.value,a)),a}_syncEnvironmentVariableCollection(t,a){const u=(0,k.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(t,a.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(a=>{const u=a[0],c=new o(a[1]);this._setEnvironmentVariableCollection(u,c)})}$acceptDefaultProfile(t,a){this._defaultProfile=t,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(t,a){this._environmentVariableCollections.set(t,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,a)})}};f=Ve([$e(1,I.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,a){this._setIfDiffers(t,{value:a,type:b.EnvironmentVariableMutatorType.Replace})}append(t,a){this._setIfDiffers(t,{value:a,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,a){this._setIfDiffers(t,{value:a,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,a){const u=this.map.get(t);(!u||u.value!==a.value||u.type!==a.type)&&(this.map.set(t,a),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,a){this.map.forEach((u,c)=>t.call(a,c,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let w=class extends f{constructor(t){super(!1,t)}createTerminal(t,a,u){throw new L.NotSupportedError}createTerminalFromOptions(t,a){throw new L.NotSupportedError}};w=Ve([$e(0,I.IExtHostRpcService)],w),e.WorkerExtHostTerminalService=w;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return m.ThemeColor.isThemeColor(n)?n:void 0}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[252],ke([1,0,16,23,21,3,58,59,6,26,14,35,5,18,132,15,7,66,88,67]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(N,p){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=N.getProxy(y.MainContext.MainThreadTesting),this.observer=new c(this.proxy),this.runTracker=new r(this.proxy),p.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,_.toItemFromContext)(U):U})}createTestController(N,p,U){if(this.controllers.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const B=new b.DisposableStore,z=B.add(new _.ExtHostTestItemCollection(N,p));z.root.label=p;const re=new Map,H=this.proxy,M={items:z.root.children,get label(){return p},set label(V){p=V,z.root.label=V,H.$updateController(N,{label:p})},get refreshHandler(){return U},set refreshHandler(V){U=V,H.$updateController(N,{canRefresh:!!V})},get id(){return N},createRunProfile:(V,q,ie,Q,ue)=>{let ce=(0,D.hash)(V);for(;re.has(ce);)ce++;return new S(this.proxy,re,N,ce,V,q,ie,Q,ue)},createTestItem(V,q,ie){return new _.TestItemImpl(N,V,q,ie)},createTestRun:(V,q,ie=!0)=>this.runTracker.createTestRun(N,z,V,q,ie),set resolveHandler(V){z.resolveHandler=V},get resolveHandler(){return z.resolveHandler},dispose:()=>{B.dispose()}};H.$registerTestController(N,p,!!U),B.add((0,b.toDisposable)(()=>H.$unregisterTestController(N)));const j={controller:M,collection:z,profiles:re};return this.controllers.set(N,j),B.add((0,b.toDisposable)(()=>this.controllers.delete(N))),B.add(z.onDidGenerateDiff(V=>H.$publishDiff(N,V.map(h.TestsDiffOp.serialize)))),M}createTestObserver(){return this.observer.checkout()}async runTests(N,p=C.CancellationToken.None){const U=s(N);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(U.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(z=>g.TestId.fromExtHostTestItem(z,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:R[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:N.exclude?.map(z=>z.id)},p)}$provideFileCoverage(N,p,U){return(0,d.mapFind)(this.runTracker.trackers,z=>z.id===N?z.getCoverage(p):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(N,p,U,B){return(0,d.mapFind)(this.runTracker.trackers,re=>re.id===N?re.getCoverage(p):void 0)?.resolveFileCoverage(U,B)??Promise.resolve([])}$configureRunProfile(N,p){this.controllers.get(N)?.profiles.get(p)?.configureHandler?.()}async $refreshTests(N,p){await this.controllers.get(N)?.controller.refreshHandler?.(p)}$publishTestResults(N){this.results=Object.freeze(N.map(p=>(0,A.deepFreeze)(m.TestResults.to(p))).concat(this.results).sort((p,U)=>U.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(N,p){const U=this.controllers.get(g.TestId.fromString(N).controllerId)?.collection;U&&(await U.expand(N,p<0?1/0:p),U.flushDiff())}$acceptDiff(N){this.observer.applyDiff(N.map(h.TestsDiffOp.deserialize))}async $runControllerTests(N,p){const U=this.controllers.get(N.controllerId);if(!U)return;const{collection:B,profiles:z}=U,re=z.get(N.profileId);if(!re)return;const H=N.testIds.map(q=>B.tree.get(q)).filter(L.isDefined),M=N.excludeExtIds.map(q=>U.collection.tree.get(q)).filter(L.isDefined).filter(q=>H.some(ie=>ie.fullId.compare(q.fullId)===2));if(!H.length)return;const j=new v.TestRunRequest(H.some(q=>q.actual instanceof _.TestItemRootImpl)?void 0:H.map(q=>q.actual),M.map(q=>q.actual),re),V=this.runTracker.prepareForMainThreadTestRun(j,n.fromInternal(N,U.collection),p);try{await re.runHandler(j,p)}finally{V.isRunning&&!p.isCancellationRequested&&await P.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(N){N===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(N)}};o=Ve([$e(0,T.IExtHostRpcService)],o),e.ExtHostTesting=o;class w extends b.Disposable{constructor(N,p,U){super();this.dto=N,this.proxy=p,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(N){return this.tasks.get(N)?.coverage}createRun(N){const p=this.dto.id,U=this.dto.controllerId,B=(0,k.generateUuid)(),z=new t(this.proxy,p,B),re=V=>(q,...ie)=>{if(M){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),V(q,...ie))},H=(V,q)=>{const ie=q instanceof Array?q.map(m.TestMessage.from):[m.TestMessage.from(q)];if(V.uri&&V.range){const Q={range:m.Range.from(V.range),uri:V.uri};for(const ue of ie)ue.location=ue.location||Q}this.proxy.$appendTestMessagesInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),ie)};let M=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:N,get coverageProvider(){return z.coverageProvider},set coverageProvider(V){z.coverageProvider=V},enqueued:re(V=>{this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),1)}),skipped:re(V=>{this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),5)}),started:re(V=>{this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),2)}),errored:re((V,q,ie)=>{H(V,q),this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),6,ie)}),failed:re((V,q,ie)=>{H(V,q),this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,U).toString(),4,ie)}),passed:re((V,q)=>{this.proxy.$updateTestStateInRun(p,B,g.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,q)}),appendOutput:(V,q,ie)=>{M||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(p,B,i.VSBuffer.fromString(V),q&&m.location.from(q),ie&&g.TestId.fromExtHostTestItem(ie,U).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(p,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:j,coverage:z}),this.proxy.$startedTestRunTask(p,{id:B,name:N,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(N){if(!(N instanceof _.TestItemImpl))throw new E.InvalidTestItemError(N.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(N,this.dto.controllerId).toString()))return;const p=[],U=this.dto.colllection.root;for(;;){const B=m.TestItem.from(N);if(p.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),N===U))break;N=N.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,p)}}class r{constructor(N){this.proxy=N,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(N,p,U){return this.getTracker(N,p,U)}cancelRunById(N){for(const p of this.tracked.values())if(p.id===N){p.dispose();return}}cancelAllRuns(){for(const N of this.tracked.values())N.dispose()}createTestRun(N,p,U,B,z){const re=this.tracked.get(U);if(re)return re.createRun(B);const H=n.fromPublic(N,p,U,z),M=s(U);this.proxy.$startedExtensionTestRun({controllerId:N,profile:M&&{group:R[M.kind],id:M.profileId},exclude:U.exclude?.map(V=>g.TestId.fromExtHostTestItem(V,p.root.id).toString())??[],id:H.id,include:U.include?.map(V=>g.TestId.fromExtHostTestItem(V,p.root.id).toString())??[p.root.id],persist:z});const j=this.getTracker(U,H);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),j.createRun(B)}getTracker(N,p,U){const B=new w(p,this.proxy,U);return this.tracked.set(N,B),B.onEnd(()=>this.tracked.delete(N)),B}}e.TestRunCoordinator=r;const s=O=>{if(!!O.profile){if(!(O.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class n{constructor(N,p,U,B,z,re){this.controllerId=N,this.id=p,this.isPersisted=z,this.colllection=re,this.includePrefix=U.map(H=>H+"\0"),this.excludePrefix=B.map(H=>H+"\0")}static fromPublic(N,p,U,B){return new n(N,(0,k.generateUuid)(),U.include?.map(z=>g.TestId.fromExtHostTestItem(z,N).toString())??[N],U.exclude?.map(z=>g.TestId.fromExtHostTestItem(z,N).toString())??[],B,p)}static fromInternal(N,p){return new n(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,p)}isIncluded(N){const p=g.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(p===U||p.startsWith(U))return!1;for(const U of this.includePrefix)if(p===U||p.startsWith(U))return!0;return!1}}e.TestRunDto=n;class t{constructor(N,p,U){this.proxy=N,this.runId=p,this.taskId=U}set coverageProvider(N){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this._coverageProvider=N,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(N){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(N))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(p){throw this.fileCoverage=void 0,p}}async resolveFileCoverage(N,p){const U=await this.fileCoverage;let B=U?.[N];return!this._coverageProvider||!U||!B?[]:(B.detailedCoverage||(B=U[N]=await this._coverageProvider.resolveFileCoverage?.(B,p)??B),B.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class a extends h.IncrementalChangeCollector{constructor(N){super();this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(N){this.added.add(N)}update(N){Object.assign(N.revived,m.TestItem.toPlain(N.item)),this.added.has(N)||this.updated.add(N)}remove(N){if(this.added.has(N)){this.added.delete(N);return}if(this.updated.delete(N),N.parent&&this.alreadyRemoved.has(N.parent)){this.alreadyRemoved.add(N.item.extId);return}this.removed.add(N)}getChangeEvent(){const{added:N,updated:p,removed:U}=this;return{get added(){return[...N].map(B=>B.revived)},get updated(){return[...p].map(B=>B.revived)},get removed(){return[...U].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends h.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(N){return this.items.get(N)}getMirroredTestDataByReference(N){return this.items.get(N.id)}createItem(N,p){return{...N,revived:m.TestItem.toPlain(N.item),depth:p?p.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=u;class c{constructor(N){this.proxy=N}checkout(){this.current||(this.current=this.createObserverData());const N=this.current;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(p=>p.revived)},dispose:(0,I.once)(()=>{--N.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(N){return this.current?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.current?.tests.apply(N)}createObserverData(){const N=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:N}}}class S{constructor(N,p,U,B,z,re,H,M=!1,j=void 0){this.controllerId=U,this.profileId=B,this._label=z,this.kind=re,this.runHandler=H,this._isDefault=M,this._tag=j,l.set(this,void 0),f.set(this,void 0),et(this,l,N,"f"),et(this,f,p,"f"),p.set(B,this);const V=R[re];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);Ue(this,l,"f").$publishTestRunProfile({profileId:B,controllerId:U,tag:j?m.TestTag.namespace(this.controllerId,j.id):null,label:z,group:V,isDefault:M,hasConfigurationHandler:!1})}get label(){return this._label}set label(N){N!==this._label&&(this._label=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get isDefault(){return this._isDefault}set isDefault(N){N!==this._isDefault&&(this._isDefault=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?m.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(N){N!==this._configureHandler&&(this._configureHandler=N,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}dispose(){Ue(this,f,"f")?.delete(this.profileId)&&(et(this,f,void 0,"f"),Ue(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,l=new WeakMap,f=new WeakMap;const R={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(Ie[253],ke([1,0,16,3,5,133,15,7]),function(Y,e,d,i,C,P,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(L,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(y=>this._onDidChangeVisibleTextEditors.fire(y)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(y=>this._onDidChangeActiveTextEditor.fire(y))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const k=this._extHostDocumentsAndEditors.allEditors();return L?k:k.map(y=>y.value)}async showTextDocument(L,k,y){let T;typeof k=="number"?T={position:I.ViewColumn.from(k),preserveFocus:y}:typeof k=="object"?T={position:I.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?I.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const _=await this._proxy.$tryShowTextDocument(L.uri,T),m=_&&this._extHostDocumentsAndEditors.getEditor(_);if(m)return m.value;throw _?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new P.TextEditorDecorationType(this._proxy,L,k).value}$acceptEditorPropertiesChanged(L,k){const y=this._extHostDocumentsAndEditors.getEditor(L);if(!y)throw new Error("unknown text editor");if(k.options&&y._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(I.Selection.to);y._acceptSelections(T)}if(k.visibleRanges){const T=d.coalesce(k.visibleRanges.map(I.Range.to));y._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:y.value,options:{...k.options,lineNumbers:I.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=D.TextEditorSelectionChangeKind.fromValue(k.selections.source),_=k.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:y.value,selections:_,kind:T})}if(k.visibleRanges){const T=d.coalesce(k.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:y.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const k in L){const y=this._extHostDocumentsAndEditors.getEditor(k);if(!y)throw new Error("Unknown text editor");const T=I.ViewColumn.to(L[k]);y.value.viewColumn!==T&&(y._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:y.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=b}),define(Ie[254],ke([1,0,2,4,5,6,7,15,14]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class A{constructor(y,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===11){const m=_.uri===void 0?void 0:d.URI.revive(_.uri);return this._itemsBySourceAndUriMap.get(_.source)?.get(L(m))?.get(_.handle)}return _}})}async $getTimeline(y,T,_,m){return this._providers.get(y)?.provideTimeline(d.URI.revive(T),_,m)}registerTimelineProvider(y,T,_,m){const v=new P.DisposableStore,g=this.convertTimelineItem(T.id,m,v).bind(this);let E;T.onDidChange&&(E=T.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:T.id}),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:y,onDidChange:void 0,async provideTimeline(l,f,o){f?.resetCache&&(v.clear(),h.get(T.id)?.clear());const w=await T.provideTimeline(l,f,o);if(w==null)return;const r=g(l,f);return{...w,source:T.id,items:w.items.map(r)}},dispose(){for(const l of h.values())l.get(T.id)?.clear();E?.dispose(),v.dispose()}})}convertTimelineItem(y,T,_){return(m,v)=>{let g;if(v?.cacheResults){let E=this._itemsBySourceAndUriMap.get(y);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(y,E));const h=L(m);g=E.get(h),g===void 0&&(g=new Map,E.set(h,g))}return E=>{const{iconPath:h,...l}=E,f=`${y}|${E.id??E.timestamp}`;g?.set(f,E);let o,w,r;E.iconPath&&(h instanceof I.ThemeIcon?r={id:h.id,color:h.color}:d.URI.isUri(h)?(o=h,w=h):{light:o,dark:w}=h);let s;return I.MarkdownString.isMarkdownString(l.tooltip)?s=D.MarkdownString.from(l.tooltip):(0,b.isString)(l.tooltip)?s=l.tooltip:I.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=D.MarkdownString.from(l.detail)):(0,b.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=l.detail),{...l,id:l.id??void 0,handle:f,source:y,command:E.command?T.toInternal(E.command,_):void 0,icon:o,iconDark:w,themeIcon:r,tooltip:s,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(y){if(this._providers.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this._proxy.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this._providers.set(y.id,y),(0,P.toDisposable)(()=>{for(const _ of this._itemsBySourceAndUriMap.values())_.get(y.id)?.clear();this._providers.delete(y.id),this._proxy.$unregisterTimelineProvider(y.id),y.dispose()})}}e.ExtHostTimeline=A;function L(k){return k?.toString()}}),define(Ie[255],ke([1,0,6,10,2,5]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(b){this._openers=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,A,L,k){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const y=k.schemes.find(T=>!I.supportedSchemes.has(T));if(y)throw new Error(`Scheme '${y}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,L),this._proxy.$registerUriOpener(A,k.schemes,b,k.label),(0,d.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(b,A,L){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener with id: ${b}`);const y=C.URI.revive(A);return k.canOpenExternalUri(y,L)}async $openUri(b,A,L){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener id: '${b}'`);return k.openExternalUri(C.URI.revive(A.resolvedUri),{sourceUri:C.URI.revive(A.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(Ie[256],ke([1,0,5,2,6,11,28]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(A,L){if(this.handles.has(I.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const k=D.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(A)),this.handlers.set(k,L),this._proxy.$registerUriHandler(k,A),(0,C.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(A)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(A,L){const k=this.handlers.get(A);if(!k)return Promise.resolve(void 0);try{k.handleUri(i.URI.revive(L))}catch(y){(0,P.onUnexpectedError)(y)}return Promise.resolve(void 0)}async createAppUri(A){return i.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=D,D.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[71],ke([1,0,3,10,2,188,208,87,5]),function(Y,e,d,i,C,P,I,D,b){"use strict";var A,L,k,y,T,_,m,v,g,E,h,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(u,c,S,R,O,N,p){A.set(this,void 0),L.set(this,void 0),k.set(this,void 0),y.set(this,void 0),T.set(this,void 0),_.set(this,void 0),m.set(this,""),v.set(this,void 0),g.set(this,!1),E.set(this,!1),h.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new d.Emitter),this._onDidDispose=Ue(this,l,"f").event,et(this,A,u,"f"),et(this,L,c,"f"),et(this,v,S,"f"),et(this,y,R,"f"),et(this,T,O,"f"),et(this,_,N,"f"),et(this,h,o(N),"f"),et(this,k,p,"f")}dispose(){et(this,g,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return et(this,E,!0,"f"),(0,D.asWebviewUri)(u,Ue(this,y,"f"))}get cspSource(){const u=Ue(this,_,"f").extensionLocation;if(u.scheme===i.Schemas.https||u.scheme===i.Schemas.http){let c=u.toString();return c.endsWith("/")||(c+="/"),c+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,m,"f")}set html(u){this.assertNotDisposed(),Ue(this,m,"f")!==u&&(et(this,m,u,"f"),!Ue(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(et(this,E,!0,"f"),Ue(this,k,"f").report("Webview vscode-resource: uris",Ue(this,_,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,A,"f"),u))}get options(){return this.assertNotDisposed(),Ue(this,v,"f")}set options(u){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,A,"f"),s(Ue(this,_,"f"),Ue(this,T,"f"),u)),et(this,v,u,"f")}async postMessage(u){if(Ue(this,g,"f"))return!1;const c=(0,I.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:Ue(this,h,"f")});return Ue(this,L,"f").$postMessage(Ue(this,A,"f"),c.message,...c.buffers)}assertNotDisposed(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,A=new WeakMap,L=new WeakMap,k=new WeakMap,y=new WeakMap,T=new WeakMap,_=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,E=new WeakMap,h=new WeakMap,l=new WeakMap;function o(a){try{const u=(0,P.normalizeVersion)((0,P.parseVersion)(a.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class w{constructor(u,c,S,R,O){this.remoteInfo=c,this.workspace=S,this._logService=R,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=u.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(u,c,S){const R=this.getWebview(u);if(R){const{message:O}=(0,I.deserializeWebviewMessage)(c,S.value);R._onMessageEmitter.fire(O)}}$onMissingCsp(u,c){this._logService.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,c,S){const R=new f(u,this._webviewProxy,n(c),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(u,R),R._onDidDispose(()=>{this._webviews.delete(u)}),R}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=w;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=r;function s(a,u,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||t(a,u)}}e.serializeWebviewOptions=s;function n(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(u=>C.URI.from(u))}}e.reviveOptions=n;function t(a,u){return[...(u?.getWorkspaceFolders()||[]).map(c=>c.uri),a.extensionLocation]}}),define(Ie[257],ke([1,0,21,59,6,10,22,2,15,71,86,5,7]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(o,w){this.document=o,this._storagePath=w,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,w){await this.getEdit(o).undo(),w||this.disposeBackup()}async redo(o,w){await this.getEdit(o).redo(),w||this.disposeBackup()}disposeEdits(o){for(const w of o)this._edits.delete(w)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=l(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const w=this._edits.get(o,0);if(!w)throw new Error("No edit found");return w}}class _{constructor(){this._documents=new Map}get(o,w){return this._documents.get(this.key(o,w))}add(o,w,r){const s=this.key(o,w.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${o} resource:${w.uri}`);const n=new T(w,r);return this._documents.set(s,n),n}delete(o,w){const r=this.key(o,w.uri);this._documents.delete(r)}key(o,w){return`${o}@@@${w}`}}var m;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(m||(m={}));class v{constructor(){this._providers=new Map}addTextProvider(o,w,r){return this.add(0,o,w,r)}addCustomProvider(o,w,r){return this.add(1,o,w,r)}get(o){return this._providers.get(o)}add(o,w,r,s){if(this._providers.has(w))throw new Error(`Provider for viewType:${w} already registered`);return this._providers.set(w,{type:o,extension:r,provider:s}),new y.Disposable(()=>this._providers.delete(w))}}class g{constructor(o,w,r,s,n){this._extHostDocuments=w,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new v,this._documents=new _,this._proxy=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,w,r,s){const n=new C.DisposableStore;return E(r)?(n.add(this._editorProviders.addTextProvider(w,o,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(o),w,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(w,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(t=>{const a=this.getCustomDocumentEntry(w,t.document.uri);if(h(t)){const u=a.addEdit(t);this._proxy.$onDidEdit(t.document.uri,w,u,t.label)}else this._proxy.$onContentChange(t.document.uri,w)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(o),w,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(o))),y.Disposable.from(n,new y.Disposable(()=>{this._proxy.$unregisterEditorProvider(w)}))}async $createCustomDocument(o,w,r,s,n){const t=this._editorProviders.get(w);if(!t)throw new Error(`No provider found for '${w}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${w}'`);const a=D.URI.revive(o),u=await t.provider.openCustomDocument(a,{backupId:r,untitledDocumentData:s?.buffer},n);let c;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(c=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(w,u,c),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,w){const r=this._editorProviders.get(w);if(!r)throw new Error(`No provider found for '${w}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${w}'`);const s=D.URI.revive(o),{document:n}=this.getCustomDocumentEntry(w,s);this._documents.delete(w,n),n.dispose()}async $resolveWebviewEditor(o,w,r,s,n,t){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);const u=b.ViewColumn.to(n),c=this._extHostWebview.createNewWebview(w,s.webviewOptions,a.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(w,r,s.title,u,s.panelOptions,c,!0),R=D.URI.revive(o);switch(a.type){case 1:{const{document:O}=this.getCustomDocumentEntry(r,R);return a.provider.resolveCustomEditor(O,S,t)}case 0:{const O=this._extHostDocuments.getDocument(R);return a.provider.resolveCustomTextEditor(O,S,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,w,r){this.getCustomDocumentEntry(w,o).disposeEdits(r)}async $onMoveCustomEditor(o,w,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const t=D.URI.revive(w),a=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(a,n,d.CancellationToken.None)}async $undo(o,w,r,s){return this.getCustomDocumentEntry(w,o).undo(r,s)}async $redo(o,w,r,s){return this.getCustomDocumentEntry(w,o).redo(r,s)}async $revert(o,w,r){const s=this.getCustomDocumentEntry(w,o);await this.getCustomEditorProvider(w).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(o,w,r){const s=this.getCustomDocumentEntry(w,o);await this.getCustomEditorProvider(w).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(o,w,r,s){const n=this.getCustomDocumentEntry(w,o);return this.getCustomEditorProvider(w).saveCustomDocumentAs(n.document,D.URI.revive(r),s)}async $backup(o,w,r){const s=this.getCustomDocumentEntry(w,o),t=await this.getCustomEditorProvider(w).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(o,w){const r=this._documents.get(o,D.URI.revive(w));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function E(f){return typeof f.resolveCustomTextEditor=="function"}function h(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function l(f){const o=f.scheme===P.Schemas.file||f.scheme===P.Schemas.untitled?f.fsPath:f.toString();return(0,i.hash)(o)+""}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[258],ke([1,0,3,6,2,35,15,71,5,7]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";var L,k,y,T,_,m,v,g,E,h,l,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class w extends i.Disposable{constructor(t,a,u,c){super();L.set(this,void 0),k.set(this,void 0),y.set(this,void 0),T.set(this,void 0),_.set(this,void 0),m.set(this,void 0),v.set(this,void 0),g.set(this,void 0),E.set(this,!0),h.set(this,void 0),l.set(this,!1),f.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,f,"f").event,o.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ue(this,o,"f").event,et(this,L,t,"f"),et(this,k,a,"f"),et(this,T,u,"f"),et(this,y,c.viewType,"f"),et(this,_,c.panelOptions,"f"),et(this,g,c.viewColumn,"f"),et(this,m,c.title,"f"),et(this,h,c.active,"f")}dispose(){Ue(this,l,"f")||(et(this,l,!0,"f"),Ue(this,f,"f").fire(),Ue(this,k,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,y,"f")}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(t){this.assertNotDisposed(),Ue(this,m,"f")!==t&&(et(this,m,t,"f"),Ue(this,k,"f").$setTitle(Ue(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(t){this.assertNotDisposed(),Ue(this,v,"f")!==t&&(et(this,v,t,"f"),Ue(this,k,"f").$setIconPath(Ue(this,L,"f"),C.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ue(this,_,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,g,"f")=="number"&&Ue(this,g,"f")<0))return Ue(this,g,"f")}get active(){return this.assertNotDisposed(),Ue(this,h,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(t){Ue(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(et(this,h,t.active,"f"),et(this,E,t.visible,"f"),et(this,g,t.viewColumn,"f"),Ue(this,o,"f").fire({webviewPanel:this}))}reveal(t,a){this.assertNotDisposed(),Ue(this,k,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!a})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,y=new WeakMap,T=new WeakMap,_=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,E=new WeakMap,h=new WeakMap,l=new WeakMap,f=new WeakMap,o=new WeakMap;class r{constructor(t,a,u){this.webviews=a,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(t,a,u,c,S={}){const R=typeof c=="object"?c.viewColumn:c,O={viewColumn:I.ViewColumn.from(R),preserveFocus:typeof c=="object"&&!!c.preserveFocus},N=(0,D.shouldSerializeBuffersForPostMessage)(t),p=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(t),p,a,{title:u,panelOptions:s(S),webviewOptions:(0,D.serializeWebviewOptions)(t,this.workspace,S),serializeBuffersForPostMessage:N},O);const U=this.webviews.createNewWebview(p,S,t);return this.createNewWebviewPanel(p,a,u,R,S,U,!0)}$onDidChangeWebviewPanelViewStates(t){const a=Object.keys(t);a.sort((u,c)=>{const S=t[u],R=t[c];return S.active?1:R.active?-1:+S.visible-+R.visible});for(const u of a){const c=this.getWebviewPanel(u);if(!c)continue;const S=t[u];c._updateViewState({active:S.active,visible:S.visible,viewColumn:I.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,a,u){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:u,extension:t}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(t,a,u,c){const S=this._serializers.get(a);if(!S)throw new Error(`No serializer found for '${a}'`);const{serializer:R,extension:O}=S,N=this.webviews.createNewWebview(t,u.webviewOptions,O),p=this.createNewWebviewPanel(t,a,u.title,c,u.panelOptions,N,u.active);await R.deserializeWebviewPanel(p,u.state)}createNewWebviewPanel(t,a,u,c,S,R,O){const N=new w(t,this._proxy,R,{viewType:a,title:u,viewColumn:c,panelOptions:S,active:O});return this._webviewPanels.set(t,N),N}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[259],ke([1,0,3,6,71,25,15,5,7]),function(Y,e,d,i,C,P,I,D,b){"use strict";var A,L,k,y,T,_,m,v,g,E,h,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends i.Disposable{constructor(r,s,n,t,a,u,c){super();A.set(this,void 0),L.set(this,void 0),k.set(this,void 0),y.set(this,void 0),T.set(this,void 0),_.set(this,!1),m.set(this,void 0),v.set(this,void 0),g.set(this,void 0),E.set(this,void 0),h.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,l.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,l,"f").event,et(this,k,n,"f"),et(this,v,t,"f"),et(this,A,r,"f"),et(this,L,s,"f"),et(this,y,a,"f"),et(this,T,u,"f"),et(this,m,c,"f")}dispose(){Ue(this,_,"f")||(et(this,_,!0,"f"),Ue(this,l,"f").fire(),Ue(this,y,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,v,"f")}set title(r){this.assertNotDisposed(),Ue(this,v,"f")!==r&&(et(this,v,r,"f"),Ue(this,L,"f").$setWebviewViewTitle(Ue(this,A,"f"),r))}get description(){return this.assertNotDisposed(),Ue(this,g,"f")}set description(r){this.assertNotDisposed(),Ue(this,g,"f")!==r&&(et(this,g,r,"f"),Ue(this,L,"f").$setWebviewViewDescription(Ue(this,A,"f"),r))}get visible(){return Ue(this,m,"f")}get webview(){return Ue(this,y,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(r){r===Ue(this,m,"f")||Ue(this,_,"f")||(et(this,m,r,"f"),Ue(this,h,"f").fire())}get badge(){return this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Ue(this,T,"f"),"badges"),Ue(this,E,"f")}set badge(r){this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Ue(this,T,"f"),"badges"),!(r?.value===Ue(this,E,"f")?.value&&r?.tooltip===Ue(this,E,"f")?.tooltip)&&(et(this,E,I.ViewBadge.from(r),"f"),Ue(this,L,"f").$setWebviewViewBadge(Ue(this,A,"f"),r))}show(r){this.assertNotDisposed(),Ue(this,L,"f").$show(Ue(this,A,"f"),!!r)}assertNotDisposed(){if(Ue(this,_,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,L=new WeakMap,k=new WeakMap,y=new WeakMap,T=new WeakMap,_=new WeakMap,m=new WeakMap,v=new WeakMap,g=new WeakMap,E=new WeakMap,h=new WeakMap,l=new WeakMap;class o{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(r)}),new b.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,n,t,a){const u=this._viewProviders.get(s);if(!u)throw new Error(`No view provider found for '${s}'`);const{provider:c,extension:S}=u,R=this._extHostWebview.createNewWebview(r,{},S),O=new f(r,this._proxy,s,n,R,S,!0);this._webviewViews.set(r,O),await c.resolveWebviewView(O,{state:t},a)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=o}),define(Ie[138],ke([1,0,3,5,2,10,8,4,18]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Yi{constructor(k){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yi.InitialState,this._proxy=k.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(y=>this.$onDidChangeWindowFocus(y))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,y){let T;if(typeof k=="string"){T=k;try{k=C.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,I.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,y)}async asExternalUri(k,y){if((0,I.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,y);return C.URI.from(T)}};A.InitialState={focused:!0},A=Ve([$e(0,b.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(Ie[260],ke([1,0,9,62,35,37,6,5,2,18]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends I.Disposable{constructor(y,T){super();const _=y.getProxy(D.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async m=>{const v=b.URI.file((0,d.join)((0,i.tmpdir)(),(0,C.generateUuid)()));return await _.$download(m,v),v})}};L=Ve([$e(0,A.IExtHostRpcService),$e(1,P.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ie[261],ke([1,0,136,10,194,35]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends d.ExtHostLoggerService{doCreateLogger(b,A,L){return b.scheme===i.Schemas.file?new C.SpdLogLogger(L?.name||(0,P.generateUuid)(),b.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,A):super.doCreateLogger(b,A,L)}}e.ExtHostLoggerService=I}),define(Ie[262],ke([1,0,61,9,2,70,6,10,17,29]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends P.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const w=await super._getWorkspaceStorageURI(o);if(w.scheme!==D.Schemas.file)return w;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${w.fsPath}.`),w;const r=w.fsPath;let s=0;do{let n;s===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await k(n);const t=i.join(n,"vscode.lock"),a=await m(this._logService,t,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),C.URI.file(n);s++}while(s<10);return w}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(f){try{await A.Promises.stat(f);return}catch{}try{await A.Promises.mkdir(f,{recursive:!0})}catch{}}const y=1e3,T=10*60*1e3;class _ extends I.Disposable{constructor(o,w){super();this.logService=o,this.filename=w,this._timer=this._register(new b.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(o,w);(!r||r.pid!==process.pid)&&(o.info(`Lock '${w}': The lock was lost unexpectedly.`),this._timer.cancel());try{await A.Promises.utimes(w,new Date,new Date)}catch(s){o.error(s),o.info(`Lock '${w}': Could not update mtime.`)}},y)}dispose(){super.dispose();try{d.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const w={pid:process.pid,willReleaseAt:Date.now()+o};await A.Promises.writeFile(this.filename,JSON.stringify(w),{flag:"w"})}catch(w){this.logService.error(w)}}}async function m(f,o,w){try{const s={pid:process.pid,willReleaseAt:0};await A.Promises.writeFile(o,JSON.stringify(s),{flag:"wx"})}catch(s){f.error(s)}const r=await v(f,o);return!r||r.pid!==process.pid?w?(f.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),h(f,o)):(f.info(`Lock '${o}': Lock acquired.`),new _(f,o))}async function v(f,o){let w;try{w=await A.Promises.readFile(o)}catch(r){return f.error(r),null}try{return JSON.parse(String(w))}catch(r){return f.error(r),null}}async function g(f,o){let w;try{w=await A.Promises.stat(o)}catch(r){return f.error(r),0}return w.mtime.getTime()}function E(f){try{return process.kill(f,0),!0}catch{return!1}}async function h(f,o){const w=await v(f,o);if(!w)return f.info(`Lock '${o}': Could not read pid of lock holder.`),l(f,o);if(w.willReleaseAt){let a=w.willReleaseAt-Date.now();if(a<5e3){for(a>0?f.info(`Lock '${o}': The lockfile is scheduled to be released in ${a} ms.`):f.info(`Lock '${o}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,b.timeout)(Math.min(100,a)),await g(f,o)===0)return l(f,o);a=w.willReleaseAt-Date.now()}return l(f,o)}}if(!E(w.pid))return f.info(`Lock '${o}': The pid ${w.pid} appears to be gone.`),l(f,o);const r=await g(f,o),s=Date.now()-r;if(s<=T)return f.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;f.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.timeout)(2e3);const n=await g(f,o),t=Date.now()-n;return t<=T?(f.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(f.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),l(f,o))}async function l(f,o){f.info(`Lock '${o}': Deleting a stale lock.`);try{await A.Promises.unlink(o)}catch{}return m(f,o,!0)}}),define(Ie[263],ke([1,0,35,18,38]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends C.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,b,A){return this.createTerminalFromOptions({name:D,shellPath:b,shellArgs:A})}createTerminalFromOptions(D,b){const A=new C.ExtHostTerminal(this._proxy,(0,d.generateUuid)(),D,D.name);return this._terminals.push(A),A.create(D,this._serializeParentTerminal(D,b)),A.value}};P=Ve([$e(0,i.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(Ie[264],ke([1,0,5,18,179,6,27,2,41,22,29,7,12,51,3,122,93,13]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(u,c,S){this.remoteAddress=u,this.localAddress=c,this._dispose=S,this._onDispose=new _.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function h(a){const u=a.trim().split(`
`),c=[];return u.forEach(R=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);O&&O.length>=3&&c.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),c.reduce((R,O)=>(R[O.socket]=O,R),{})}e.getSockets=h;function l(...a){const u=[].concat(...a.map(o));return[...new Map(u.filter(c=>c.st==="0A").map(c=>{const S=c.local_address.split(":");return{socket:parseInt(c.inode,10),ip:f(S[0]),port:parseInt(S[1],16)}}).map(c=>[c.ip+":"+c.port,c])).values()]}e.loadListeningPorts=l;function f(a){let u="";if(a.length===8)for(let c=a.length-2;c>=0;c-=2)u+=parseInt(a.substr(c,2),16),c!==0&&(u+=".");else for(let c=a.length-4;c>=0;c-=4)u+=parseInt(a.substr(c,4),16).toString(16),c!==0&&(u+=":");return u}e.parseIpAddress=f;function o(a){const u=a.trim().split(`
`),c=u.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return u.map(R=>R.trim().split(/\s+/).reduce((O,N,p)=>(O[c[p]||p]=N,O),{}))}e.loadConnectionTable=o;function w(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/server-main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function r(a){const u=a.trim().split(`
`),c=[];return u.forEach(S=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);R&&R.length>=4&&c.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),c}e.getRootProcesses=r;async function s(a,u,c){const S=c.reduce((O,N)=>(O[N.pid]=N,O),{}),R=[];return a.forEach(({socket:O,ip:N,port:p})=>{const U=u[O]?u[O].pid:void 0,B=U?S[U]?.cmd:void 0;U&&B&&!w(B)&&R.push({host:N,port:p,detail:B,pid:U})}),R}e.findPorts=s;function n(a,u,c){const S=new Map,R=r(u);for(const O of a){const N=c.get(O.port);if(N){S.set(O.port,N);continue}const p=R.find(U=>U.cmd.includes(`${O.port}`));if(p){let U=p,B;do B=R.find(z=>z.ppid===U.pid),B&&(U=B);while(B);S.set(O.port,{host:O.ip,port:O.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else S.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=n;let t=class extends P.Disposable{constructor(u,c,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new _.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(d.MainContext.MainThreadTunnelService),y.isLinux&&c.remote.isRemote&&c.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(c,u.displayName);if(S){const R=new E(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,c){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:u,provider:c}),this._proxy.$registerPortsAttributesProvider(u,S),new k.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(u,c,S,R,O){const N=[];for(const U of u){const B=this._portAttributesProviders.get(U);if(!B)return[];N.push(...await Promise.all(c.map(async z=>B.provider.providePortAttributes(z,S,R,O))))}const p=N.filter(U=>!!U);return p.length>0?p.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;let c=new v.MovingAverage,S;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),O=(await this.findCandidatePorts()).filter(p=>(0,m.isLocalhost)(p.host)||(0,m.isAllInterfaces)(p.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(p=>p.port).join(", ")}`);const N=new Date().getTime()-R;c.update(N),(!S||JSON.stringify(S)!==JSON.stringify(O))&&(S=O,await this._proxy.$onFoundNewCandidates(S)),await new Promise(p=>setTimeout(()=>p(),this.calculateDelay(c.value)))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory){this._forwardPortProvider=u.tunnelFactory;let c=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]);const S=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:c}:void 0;this._proxy.$setTunnelProvider(S)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,c){if(this._extensionTunnels.has(u.host)){const S=this._extensionTunnels.get(u.host);S.has(u.port)&&(c&&S.get(u.port).disposeListener.dispose(),await S.get(u.port).tunnel.dispose(),S.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(u,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const R=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const O=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:R,disposeListener:O}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const c=await Promise.all(u.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),S=u.filter((R,O)=>c[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(R=>R.port).join(", ")} to ${S.map(R=>R.port).join(", ")}`),S}async findCandidatePorts(){let u="",c="";try{u=await L.Promises.readFile("/proc/net/tcp","utf8"),c=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=l(u,c),R=await new Promise(H=>{(0,b.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,j,V)=>{H(j)})}),O=h(R),N=await L.Promises.readdir("/proc"),p=[];for(let H of N)try{const M=Number(H),j=A.joinPath(D.URI.file("/proc"),H);if((await L.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(M)){const q=await L.Promises.readlink(A.joinPath(j,"cwd").fsPath),ie=await L.Promises.readFile(A.joinPath(j,"cmdline").fsPath,"utf8");p.push({pid:M,cwd:q,cmd:ie})}}catch{}const U=[],B=S.filter(H=>{const M=O[H.socket];return M||U.push(H),M}),z=s(B,O,p);let re;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const H=await new Promise(M=>{(0,b.exec)("ps -F -A -l | grep root",(j,V,q)=>{M(V)})});this._foundRootPorts=n(U,H,this._foundRootPorts),re=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${re.join(", ")}`)}return z.then(H=>re?H.concat(re):H)}};t=Ve([$e(0,i.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,g.ILogService)],t),e.ExtHostTunnelService=t}),define(Ie[265],ke([1,0,17,23,21,11,3,6,103,228,52]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function y(S,R){try{return JSON.stringify(S,R)}catch{return"null"}}const T="$$ref$$",_={[T]:-1};class m{constructor(R,O){this.jsonString=R,this.referencedBuffers=O}}function v(S,R=null,O=!1){const N=[];return{jsonString:(O?y:JSON.stringify)(S,(U,B)=>{if(typeof B=="undefined")return _;if(typeof B=="object"){if(B instanceof i.VSBuffer){const z=N.push(B)-1;return{[T]:z}}if(R)return R(U,B)}return B}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function g(S,R,O){return JSON.parse(S,(N,p)=>{if(p){const U=p[T];if(typeof U=="number")return R[U];if(O&&p.$mid===1)return O.transformIncoming(p)}return p})}e.parseJsonAndRestoreBufferRefs=g;function E(S,R){return JSON.stringify(S,R)}function h(S){return S?(R,O)=>O&&O.$mid===1?S.transformOutgoing(O):O:null}var l;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var f;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(f=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},w=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends D.Disposable{constructor(R,O=null,N=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=O,this._uriTransformer=N,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,U=L.ProxyIdentifier.count;p<U;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,b.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:O,sid:N}=R;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,N)),this._proxies[O]}_createProxy(R,O){let N={get:(p,U)=>(typeof U=="string"&&!p[U]&&U.charCodeAt(0)===36&&(p[U]=(...B)=>this._remoteCall(R,U,B)),U===r?O:p[U])};return new Proxy(Object.create(null),N)}set(R,O){return this._locals[R.nid]=O,O}assertRegistered(R){for(let O=0,N=R.length;O<N;O++){const p=R[O];if(!this._locals[p.nid])throw new Error(`Missing proxy instance ${p.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const O=R.byteLength,N=n.read(R,0),p=N.readUInt8(),U=N.readUInt32();switch(p){case 1:case 2:{let{rpcId:B,method:z,args:re}=a.deserializeRequestJSONArgs(N);this._uriTransformer&&(re=(0,b.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,U,B,z,re,p===2);break}case 3:case 4:{let{rpcId:B,method:z,args:re}=a.deserializeRequestMixedArgs(N);this._uriTransformer&&(re=(0,b.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(O,U,B,z,re,p===4);break}case 5:{this._logger&&this._logger.logIncoming(O,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(O,U);break}case 7:{this._receiveReply(O,U,void 0);break}case 9:{let B=a.deserializeReplyOKJSON(N);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(O,U,B);break}case 10:{const B=a.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(O,U,B);break}case 8:{let B=a.deserializeReplyOKVSBuffer(N);this._receiveReply(O,U,B);break}case 11:{let B=a.deserializeReplyErrError(N);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(O,U,B);break}case 12:{this._receiveReplyErr(O,U,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,O,N,p,U,B){this._logger&&this._logger.logIncoming(R,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${p}(`,U);const z=String(O);let re,H;if(B){const j=new C.CancellationTokenSource;U.push(j.token),re=this._invokeHandler(N,p,U),H=()=>j.cancel()}else re=this._invokeHandler(N,p,U),H=o;this._cancelInvokedHandlers[z]=H;const M=a.serializeAcknowledged(O);this._logger&&this._logger.logOutgoing(M.byteLength,O,1,"ack"),this._protocol.send(M),re.then(j=>{delete this._cancelInvokedHandlers[z];const V=a.serializeReplyOK(O,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,O,1,"reply:",j),this._protocol.send(V)},j=>{delete this._cancelInvokedHandlers[z];const V=a.serializeReplyErr(O,j);this._logger&&this._logger.logOutgoing(V.byteLength,O,1,"replyErr:",j),this._protocol.send(V)})}_receiveCancel(R,O){this._logger&&this._logger.logIncoming(R,O,1,"receiveCancel");const N=String(O);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(R,O,N){this._logger&&this._logger.logIncoming(R,O,0,"receiveReply:",N);const p=String(O);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const U=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],U.resolveOk(N)}_receiveReplyErr(R,O,N){this._logger&&this._logger.logIncoming(R,O,0,"receiveReplyErr:",N);const p=String(O);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const U=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let B;N&&(N.$isError?(B=new Error,B.name=N.name,B.message=N.message,B.stack=N.stack):B=N),U.resolveErr(B)}_invokeHandler(R,O,N){try{return Promise.resolve(this._doInvokeHandler(R,O,N))}catch(p){return Promise.reject(p)}}_doInvokeHandler(R,O,N){const p=this._locals[R];if(!p)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));let U=p[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(R));return U.apply(p,N)}_remoteCall(R,O,N){if(this._isDisposed)return Promise.reject(P.canceled());let p=null;if(N.length>0&&C.CancellationToken.isCancellationToken(N[N.length-1])&&(p=N.pop()),p&&p.isCancellationRequested)return Promise.reject(P.canceled());const U=a.serializeRequestArguments(N,this._uriReplacer),B=++this._lastMessageId,z=String(B),re=new A.LazyPromise;p&&p.onCancellationRequested(()=>{const M=a.serializeCancel(B);this._logger&&this._logger.logOutgoing(M.byteLength,B,0,"cancel"),this._protocol.send(a.serializeCancel(B))}),this._pendingRPCReplies[z]=re,this._onWillSendRequest(B);const H=a.serializeRequest(B,R,O,U,!!p);return this._logger&&this._logger.logOutgoing(H.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${O}(`,N),this._protocol.send(H),re}}e.RPCProtocol=s,k=w,s.UNRESPONSIVE_TIME=3*1e3;class n{constructor(R,O){this._buff=R,this._offset=O}static alloc(R,O,N){let p=new n(i.VSBuffer.alloc(N+1+4),0);return p.writeUInt8(R),p.writeUInt32(O),p}static read(R,O){return new n(R,O)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,N}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,N}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,O}static sizeMixedArray(R){let O=0;O+=1;for(let N=0,p=R.length;N<p;N++){const U=R[N];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let B=0;B<U.buffers.length;++B)O+=this.sizeVSBuffer(U.buffers[B]);break;case 4:break}}return O}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let O=0,N=R.length;O<N;O++){const p=R[O];switch(p.type){case 1:this.writeUInt8(1),this.writeLongString(p.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p.value);break;case 3:this.writeUInt8(3),this.writeUInt32(p.buffers.length),this.writeLongString(p.value);for(let U=0;U<p.buffers.length;++U)this.writeBuffer(p.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let O=new Array(R);for(let N=0;N<R;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),B=this.readLongString(),z=[];for(let re=0;re<U;++re)z.push(this.readVSBuffer());O[N]=new L.SerializableObjectWithBuffers(g(B,z,null));break}case 4:O[N]=void 0;break}return O}}n.sizeUInt32=4;var t;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(t||(t={}));class a{static _useMixedArgSerialization(R){for(let O=0,N=R.length;O<N;O++)if(R[O]instanceof i.VSBuffer||R[O]instanceof L.SerializableObjectWithBuffers||typeof R[O]=="undefined")return!0;return!1}static serializeRequestArguments(R,O){if(this._useMixedArgSerialization(R)){const N=[];for(let p=0,U=R.length;p<U;p++){const B=R[p];if(B instanceof i.VSBuffer)N[p]={type:2,value:B};else if(typeof B=="undefined")N[p]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:re}=v(B.value,O);N[p]={type:3,value:i.VSBuffer.fromString(z),buffers:re}}else N[p]={type:1,value:i.VSBuffer.fromString(E(B,O))}}return{type:1,args:N}}return{type:0,args:E(R,O)}}static serializeRequest(R,O,N,p,U){switch(p.type){case 0:return this._requestJSONArgs(R,O,N,p.args,U);case 1:return this._requestMixedArgs(R,O,N,p.args,U)}}static _requestJSONArgs(R,O,N,p,U){const B=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(p);let re=0;re+=n.sizeUInt8(),re+=n.sizeShortString(B),re+=n.sizeLongString(z);let H=n.alloc(U?2:1,R,re);return H.writeUInt8(O),H.writeShortString(B),H.writeLongString(z),H.buffer}static deserializeRequestJSONArgs(R){const O=R.readUInt8(),N=R.readShortString(),p=R.readLongString();return{rpcId:O,method:N,args:JSON.parse(p)}}static _requestMixedArgs(R,O,N,p,U){const B=i.VSBuffer.fromString(N);let z=0;z+=n.sizeUInt8(),z+=n.sizeShortString(B),z+=n.sizeMixedArray(p);let re=n.alloc(U?4:3,R,z);return re.writeUInt8(O),re.writeShortString(B),re.writeMixedArray(p),re.buffer}static deserializeRequestMixedArgs(R){const O=R.readUInt8(),N=R.readShortString(),p=R.readMixedArray(),U=new Array(p.length);for(let B=0,z=p.length;B<z;B++){const re=p[B];typeof re=="string"?U[B]=JSON.parse(re):U[B]=re}return{rpcId:O,method:N,args:U}}static serializeAcknowledged(R){return n.alloc(5,R,0).buffer}static serializeCancel(R){return n.alloc(6,R,0).buffer}static serializeReplyOK(R,O,N){if(typeof O=="undefined")return this._serializeReplyOKEmpty(R);if(O instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(R,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:p,referencedBuffers:U}=v(O.value,N,!0);return this._serializeReplyOKJSONWithBuffers(R,p,U)}else return this._serializeReplyOKJSON(R,y(O,N))}static _serializeReplyOKEmpty(R){return n.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,O){let N=0;N+=n.sizeVSBuffer(O);let p=n.alloc(8,R,N);return p.writeVSBuffer(O),p.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,O){const N=i.VSBuffer.fromString(O);let p=0;p+=n.sizeLongString(N);let U=n.alloc(9,R,p);return U.writeLongString(N),U.buffer}static _serializeReplyOKJSONWithBuffers(R,O,N){const p=i.VSBuffer.fromString(O);let U=0;U+=n.sizeUInt32,U+=n.sizeLongString(p);for(const z of N)U+=n.sizeVSBuffer(z);let B=n.alloc(10,R,U);B.writeUInt32(N.length),B.writeLongString(p);for(const z of N)B.writeBuffer(z);return B.buffer}static deserializeReplyOKJSON(R){const O=R.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(R,O){const N=R.readUInt32(),p=R.readLongString(),U=[];for(let B=0;B<N;++B)U.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(g(p,U,O))}static serializeReplyErr(R,O){const N=O?y(P.transformErrorForSerialization(O),null):void 0;if(typeof N!="string")return this._serializeReplyErrEmpty(R);const p=i.VSBuffer.fromString(N);let U=0;U+=n.sizeLongString(p);let B=n.alloc(11,R,U);return B.writeLongString(p),B.buffer}static deserializeReplyErrError(R){const O=R.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(R){return n.alloc(12,R,0).buffer}}var u;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var c;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(c||(c={}))}),define(Ie[266],ke([1,0,3,44,64,4,42,11,17]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var A;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(A=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new d.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new d.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(_){this.channels.has(_.id)||(this.channels.set(_.id,_),this._onDidRegisterChannel.fire(_.id))}getChannels(){const _=[];return this.channels.forEach(m=>_.push(m)),_}getChannel(_){return this.channels.get(_)}removeChannel(_){this.channels.delete(_),this._onDidRemoveChannel.fire(_)}}i.Registry.add(e.Extensions.OutputChannels,new L);function k(T,_,m,v,g){return(0,b.createCancelablePromise)(async E=>{await(0,I.whenProviderRegistered)(m,v);const h=i.Registry.as(e.Extensions.OutputChannels);try{await y(m,1,v,g,E),h.registerChannel({id:T,label:_,file:m,log:!0})}catch(l){(0,D.isCancellationError)(l)||g.error("Error while registering log channel",m.toString(),(0,D.getErrorMessage)(l))}})}e.registerLogChannel=k;async function y(T,_,m,v,g){if(!await m.exists(T)){if(g.isCancellationRequested)throw new D.CancellationError;if(_>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,b.timeout)(1e3,g),await y(T,_+1,m,v,g)}}}),define(Ie[139],ke([1,0,5,6,4,18,13,266,69,27,46,160,23,14]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class _ extends i.Disposable{constructor(g,E,h,l){super();this.id=g,this.name=E,this.logger=h,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,g)}replace(g){const E=this.offset;this.write(g),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,E),this.visible&&this.logger.flush()}show(g,E){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:E))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=y.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=_;let m=class{constructor(g,E,h,l,f){this.extHostFileSystem=h,this.extHostFileSystemInfo=l,this.loggerService=f,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(d.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(E.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[E,h]of this.channels)h.visible=E===this.visibleChannelId}createOutputChannel(g,E,h){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(E)&&!E.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(g,E,h);return l.then(f=>{this.channels.set(f.id,f),f.visible=f.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,l)}async doCreateOutputChannel(g,E,h){const l=await this.createOutputDirectory(),f=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(f,{always:!0,donotRotate:!0,donotUseFormatters:!0}),w=await this.proxy.$register(g,!1,f,E,h.identifier.value);return new _(w,g,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,E){let h=!1;const l=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return g},append(f){l(),E.then(o=>o.append(f))},appendLine(f){l(),E.then(o=>o.appendLine(f))},clear(){l(),E.then(f=>f.clear())},replace(f){l(),E.then(o=>o.replace(f))},show(f,o){l(),E.then(w=>w.show(f,o))},hide(){l(),E.then(f=>f.hide())},dispose(){h=!0,E.then(f=>f.dispose())}}}};m=Ve([$e(0,P.IExtHostRpcService),$e(1,A.IExtHostInitDataService),$e(2,b.IExtHostConsumerFileSystem),$e(3,L.IExtHostFileSystemInfo),$e(4,I.ILoggerService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ie[267],ke([1,0,4]),function(Y,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(Ie[268],ke([1,0,30,10,9,12,22,2,4,203,45,224,267]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let T=class Ji{constructor(m,v,g,E){this.localUserHome=m,this.remoteAgentService=v,this.environmentService=g,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome??m})()}hasValidBasename(m,v,g){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(E=>this.doHasValidBasename(m,E,v)):this.doHasValidBasename(m,v,g)}doHasValidBasename(m,v,g){return m.scheme===i.Schemas.file||m.scheme===i.Schemas.vscodeRemote?(0,d.isValidBasename)(g??(0,I.basename)(m),v===1):!0}get defaultUriScheme(){return Ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,v){if(m.remoteAuthority)return i.Schemas.vscodeRemote;const g=(0,A.getVirtualWorkspaceScheme)(v.getWorkspace());if(g)return g;const E=v.getWorkspace().folders[0];if(E)return E.uri.scheme;const h=v.getWorkspace().configuration;return h?h.scheme:i.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?C.win32:C.posix)}async fileURI(m){let v="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const E=m.indexOf("/",2);E===-1?(v=m.substring(2),m="/"):(v=m.substring(2,E),m=m.substring(E)||"/")}return D.URI.from({scheme:i.Schemas.file,authority:v,path:m,query:"",fragment:""})}};T=Ve([$e(1,y.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ie[72],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(I,D){this.line=I,this.character=D}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,D){return new d(0,0)}with(I){return new d(0,0)}}e.Position=d;class i{constructor(I,D,b,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(I,D),this.end=new d(b,A)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new i(0,0,0,0)}with(I){return new i(0,0,0,0)}}e.Range=i;var C;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],ke([1,0,16,34,26,30,8,4,9,11,72,17]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const y="\u27EA ",T=" characters skipped \u27EB",_=(y.length+T.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var m;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function g(q){return!!q.preview}e.resultIsMatch=g;function E(q){return!!q.resource}e.isFileMatch=E;function h(q){return!!q.message}e.isProgressMessage=h;var l;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=f;class o{constructor(ie,Q,ue){this.ranges=Q;const ce=Array.isArray(Q)?Q:[Q];if(ue&&ue.matchLines===1&&w(ce)){ie=(0,I.getNLines)(ie,ue.matchLines);let G="",ge=0,ne=0;const he=Math.floor(ue.charsPerLine/5),Se=[];for(const Re of ce){const ve=Math.max(Re.startColumn-he,0),Te=Re.startColumn+ue.charsPerLine;if(ve>ne+he+_){const Ae=y+(ve-ne)+T;G+=Ae+ie.slice(ve,Te),ge+=ve-(ne+Ae.length)}else G+=ie.slice(ne,Te);Se.push(new s(0,Re.startColumn-ge,Re.endColumn-ge)),ne=Te}this.preview={text:G,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const G=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:ie,matches:(0,d.mapArrayOrNot)(Q,ge=>new r(ge.startLineNumber-G,ge.startColumn,ge.endLineNumber-G,ge.endColumn))}}}}e.TextSearchMatch=o;function w(q){const ie=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==ie||Q.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,Q,ue,ce){this.startLineNumber=ie,this.startColumn=Q,this.endLineNumber=ue,this.endColumn=ce}}e.SearchRange=r;class s extends r{constructor(ie,Q,ue){super(ie,Q,ie,ue)}}e.OneLineRange=s;var n;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(q,ie=!0){const Q=q&&q.files&&q.files.exclude,ue=ie&&q&&q.search&&q.search.exclude;if(!Q&&!ue)return;if(!Q||!ue)return Q||ue;let ce=Object.create(null);return ce=C.mixin(ce,C.deepClone(Q)),ce=C.mixin(ce,C.deepClone(ue),!0),ce}e.getExcludes=t;function a(q,ie){return q.excludePattern&&i.match(q.excludePattern,ie)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&i.match(q.includePattern,ie)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const ue=Q.folder.fsPath;if(P.isEqualOrParent(ie,ue)){const ce=b.relative(ue,ie);return!Q.includePattern||!!i.match(Q.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var u;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class c extends Error{constructor(ie,Q){super(ie);this.code=Q}}e.SearchError=c;function S(q){const ie=q.message;if((0,A.isCancellationError)(q))return new c(ie,u.canceled);try{const Q=JSON.parse(ie);return new c(Q.message,Q.code)}catch{return new c(ie,u.other)}}e.deserializeSearchError=S;function R(q){const ie={message:q.message,code:q.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=R;function O(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=O;function N(q){return q.type==="success"}e.isSerializedSearchSuccess=N;function p(q){return!!q.path}e.isSerializedFileMatch=p;function U(q,ie){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,I.fuzzyContains)(Q,ie)}e.isFilePatternMatch=U;class B{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function z(q,ie){const Q={...q||{},...ie||{}};return Object.keys(Q).filter(ue=>{const ce=Q[ue];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=z;class re{constructor(ie,Q){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let ue=ie.includePattern;Q.includePattern&&(ue?ue={...ue,...Q.includePattern}:ue=Q.includePattern),ue&&(this._parsedIncludeExpression=i.parse(ue))}matchesExcludesSync(ie,Q,ue){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,ue))}includedInQuerySync(ie,Q,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,Q,ue))}includedInQuery(ie,Q,ue){const ce=this._parsedExcludeExpression(ie,Q,ue),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,Q,ue):!0;return(0,k.isThenable)(ce)?ce.then(ge=>ge?!1:G()):G()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=re;function H(q){for(const ie in q)if(typeof q[ie]!="boolean")return!0;return!1}function M(q){if(!q)return;let ie;return Q=>(ie||(ie=(q()||Promise.resolve([])).then(ue=>ue?V(ue):{})),ie.then(ue=>!!ue[Q]))}e.hasSiblingPromiseFn=M;function j(q){if(!q)return;let ie;return Q=>{if(!ie){const ue=q();ie=ue?V(ue):{}}return!!ie[Q]}}e.hasSiblingFn=j;function V(q){const ie={};for(const Q of q)ie[Q]=!0;return ie}}),define(Ie[32],ke([1,0,16,17,21,3,24,10,93,22,8,14,2,177,4,13,195,45,46,27,18,15,7,31,5]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l,f,o,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(O,N,p){return new A.ExtUri(U=>u(U,p)).isEqual(O,N)}function n(O,N,p){return s(O.uri,N.uri,p)?0:(0,L.compare)(O.uri.toString(),N.uri.toString())}function t(O,N,p){return O.index!==N.index?O.index<N.index?-1:1:s(O.uri,N.uri,p)?(0,L.compare)(O.name,N.name):(0,L.compare)(O.uri.toString(),N.uri.toString())}function a(O,N,p,U){const B=O.slice(0).sort((re,H)=>p(re,H,U)),z=N.slice(0).sort((re,H)=>p(re,H,U));return(0,d.delta)(B,z,(re,H)=>p(re,H,U))}function u(O,N){const p=N.getCapabilities(O.scheme);return!(p&&p&1024)}class c extends g.Workspace{constructor(N,p,U,B,z,re,H){super(N,U.map(M=>new g.WorkspaceFolder(M)),B,z,H);this._name=p,this._isUntitled=re,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(H),U.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(N,p,U,B){if(!N)return{workspace:null,added:[],removed:[]};const{id:z,name:re,folders:H,configuration:M,transient:j,isUntitled:V}=N,q=[],ie=p;p?H.forEach((G,ge)=>{const ne=y.URI.revive(G.uri),he=c._findFolder(U||p,ne,B);he?(he.name=G.name,he.index=G.index,q.push(he)):q.push({uri:ne,name:G.name,index:ge})}):q.push(...H.map(({uri:G,name:ge,index:ne})=>({uri:y.URI.revive(G),name:ge,index:ne}))),q.sort((G,ge)=>G.index<ge.index?-1:1);const Q=new c(z,re,q,!!j,M?y.URI.revive(M):null,!!V,G=>u(G,B)),{added:ue,removed:ce}=a(ie?ie.workspaceFolders:[],Q.workspaceFolders,n,B);return{workspace:Q,added:ue,removed:ce}}static _findFolder(N,p,U){for(let B=0;B<N.folders.length;B++){const z=N.workspaceFolders[B];if(s(z.uri,p,U))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,p){return p&&this._structure.get(N)&&(N=(0,A.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let S=class{constructor(N,p,U,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=B,this._extHostFileSystemInfo=U,this._requestIdProvider=new b.Counter,this._barrier=new i.Barrier,this._proxy=N.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(r.MainContext.MainThreadMessageService);const z=p.workspace;this._confirmedWorkspace=z?new c(z.id,z.name,[],!!z.transient,z.configuration?y.URI.revive(z.configuration):null,!!z.isUntitled,re=>u(re,U)):void 0}$initializeWorkspace(N,p){this._trusted=p,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?y.URI.from({scheme:D.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,p,U,...B){const z=[];if(Array.isArray(B)&&B.forEach(V=>{y.URI.isUri(V.uri)&&!z.some(q=>s(q.uri,V.uri,this._extHostFileSystemInfo))&&z.push({uri:V.uri,name:V.name||(0,A.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[p,U].some(V=>typeof V!="number"||V<0)||U===0&&z.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(p+U>re.length)return!1;const H=re.slice(0);H.splice(p,U,...z.map(V=>({uri:V.uri,name:V.name||(0,A.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<H.length;V++){const q=H[V];if(H.some((ie,Q)=>Q!==V&&s(q.uri,ie.uri,this._extHostFileSystemInfo)))return!1}H.forEach((V,q)=>V.index=q);const{added:M,removed:j}=a(re,H,t,this._extHostFileSystemInfo);if(M.length===0&&j.length===0)return!1;if(this._proxy){const V=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(V,p,U,z).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(v.Severity.Error,(0,T.localize)(0,null,V,q.toString()),ie,[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(N,p){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async getWorkspaceFolder2(N,p){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,p)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,p){let U,B="";if(typeof N=="string"?(U=y.URI.file(N),B=N):typeof N!="undefined"&&(U=N,B=N.fsPath),!U)return B;const z=this.getWorkspaceFolder(U,!0);if(!z)return B;typeof p=="undefined"&&this._actualWorkspace&&(p=this._actualWorkspace.folders.length>1);let re=(0,A.relativePath)(z.uri,U);return p&&z.name&&(re=`${z.name}/${re}`),re}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=c.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:p,added:U,removed:B}=c.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=p||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:B}))}findFiles(N,p,U,B,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let re;if(p===null?re=!1:p&&(typeof p=="string"?re=p:re=p.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:M}=R(f.GlobPattern.from(N));return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(H),(0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(re),(0,k.withUndefinedAsNull)(U),z).then(j=>Array.isArray(j)?j.map(V=>y.URI.revive(V)):[])}async findTextInFiles(N,p,U,B,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),H=typeof p.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:p.previewOptions,{includePattern:M,folder:j}=R(f.GlobPattern.from(p.include)),V=typeof p.exclude=="string"?p.exclude:p.exclude?p.exclude.pattern:void 0,q={ignoreSymlinks:typeof p.followSymlinks=="boolean"?!p.followSymlinks:void 0,disregardIgnoreFiles:typeof p.useIgnoreFiles=="boolean"?!p.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof p.useGlobalIgnoreFiles=="boolean"?!p.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof p.useParentIgnoreFiles=="boolean"?!p.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof p.useDefaultExcludes=="boolean"?!p.useDefaultExcludes:!0,fileEncoding:p.encoding,maxResults:p.maxResults,previewOptions:H,afterContext:p.afterContext,beforeContext:p.beforeContext,includePattern:M,excludePattern:V},ie=!1;if(this._activeSearchCallbacks[re]=Q=>{if(ie)return;const ue=y.URI.revive(Q.resource);Q.results.forEach(ce=>{(0,w.resultIsMatch)(ce)?U({uri:ue,preview:{text:ce.preview.text,matches:(0,d.mapArrayOrNot)(ce.preview.matches,G=>new o.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,d.mapArrayOrNot)(ce.ranges,G=>new o.Range(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):U({uri:ue,text:ce.text,lineNumber:ce.lineNumber})})},z.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(N,(0,k.withUndefinedAsNull)(j),q,re,z);return delete this._activeSearchCallbacks[re],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[re],Q}}$handleTextSearchResult(N,p){this._activeSearchCallbacks[p]&&this._activeSearchCallbacks[p](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=Ve([$e(0,l.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,E.IExtHostFileSystemInfo),$e(3,m.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,_.createDecorator)("IExtHostWorkspace");function R(O){let N,p;return O&&(typeof O=="string"?N=O:(N=O.pattern,p=y.URI.revive(O.baseUri))),{includePattern:N,folder:p}}}),define(Ie[33],ke([1,0,26,3,32,5,7,198,119,14,17,4,18,13,2]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(w,r){if(r){const s=r.split(".");let n=w;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function v(w){return w instanceof _.URI}function g(w){return w&&w.uri instanceof _.URI&&w.languageId&&typeof w.languageId=="string"}function E(w){return w&&!w.uri&&w.languageId&&typeof w.languageId=="string"}function h(w){return w&&w.uri instanceof _.URI&&(!w.name||typeof w.name=="string")&&(!w.index||typeof w.index=="number")}function l(w){if(v(w))return{resource:w};if(g(w))return{resource:w.uri,overrideIdentifier:w.languageId};if(E(w))return{overrideIdentifier:w.languageId};if(h(w))return{resource:w.uri};if(w===null)return{resource:null}}let f=class{constructor(r,s,n){this._proxy=r.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,s))}};f=Ve([$e(0,y.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,T.ILogService)],f),e.ExtHostConfiguration=f;class o{constructor(r,s,n,t){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(r,s,n){const t=l(s)||{},a=this._toReadonlyValue(r?m(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,n?.identifier);function u(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(S){return typeof m(a,S)!="undefined"},get:(S,R)=>{this._validateConfigurationAccess(r?`${r}.${S}`:S,t,n?.identifier);let O=m(a,S);if(typeof O=="undefined")O=R;else{let N;const p=(U,B)=>{let z;const re=()=>{N=N||(0,d.deepClone)(a),z=z||m(N,B)};return(0,A.isObject)(U)?new Proxy(U,{get:(H,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return re(),()=>z;if(N)return z=z||m(N,B),z[M];const j=H[M];return typeof M=="string"?p(j,`${B}.${M}`):j},set:(H,M,j)=>(re(),z&&(z[M]=j),!0),deleteProperty:(H,M)=>(re(),z&&delete z[M],!0),defineProperty:(H,M,j)=>(re(),z&&Object.defineProperty(z,M,j),!0)}):U};O=p(O,S)}return O},update:(S,R,O,N)=>{S=r?`${r}.${S}`:S;const p=u(O);return R!==void 0?this._proxy.$updateConfigurationOption(p,S,R,t,N):this._proxy.$removeConfigurationOption(p,S,t,N)},inspect:S=>{S=r?`${r}.${S}`:S;const R=(0,d.deepClone)(this._configuration.inspect(S,t,this._extHostWorkspace.workspace));if(R)return{key:S,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof a=="object"&&(0,d.mixin)(c,a,!1),Object.freeze(c)}_toReadonlyValue(r){const s=n=>(0,A.isObject)(n)?new Proxy(n,{get:(t,a)=>s(t[a]),set:(t,a,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(t,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(t,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(r)}_validateConfigurationAccess(r,s,n){const t=b.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),a=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const n=new D.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,a)=>n.affectsConfiguration(t,l(a))})}_toMap(r){return r.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[73],ke([1,0,2,17,3,5,7,32,53,33,21,38,18,27,4,10,12,13,68,217,11]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(B){function z(H){if(H!=null)return H}B.from=z;function re(H){if(H!=null)return H}B.to=re})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var w;(function(B){function z(H){if(H!=null)return H}B.from=z;function re(H){if(H!=null)return H}B.to=re})(w=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(B){function z(H){if(H!=null)return H}B.from=z;function re(H){if(H!=null)return H}B.to=re})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(B){function z(M){if(M){const j=M;return j&&!!j.process}else return!1}B.is=z;function re(M){if(M==null)return;const j={process:M.process,args:M.args};return M.options&&(j.options=r.from(M.options)),j}B.from=re;function H(M){if(M!=null)return new I.ProcessExecution(M.process,M.args,M.options)}B.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(B){function z(H){if(H!=null)return H}B.from=z;function re(H){if(H!=null)return H}B.to=re})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(B){function z(M){if(M){const j=M;return j&&(!!j.commandLine||!!j.command)}else return!1}B.is=z;function re(M){if(M==null)return;const j={};return M.commandLine!==void 0?j.commandLine=M.commandLine:(j.command=M.command,j.args=M.args),M.options&&(j.options=n.from(M.options)),j}B.from=re;function H(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new I.ShellExecution(M.commandLine,M.options):new I.ShellExecution(M.command,M.args?M.args:[],M.options)}B.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(B){function z(M){if(M){let j=M;return j&&j.customExecution==="customExecution"}else return!1}B.is=z;function re(M){return{customExecution:"customExecution"}}B.from=re;function H(M,j){return j.get(M)}B.to=H})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(B){function z(re,H){let M;return re.scope!==void 0&&typeof re.scope!="number"?M=re.scope.uri:re.scope!==void 0&&typeof re.scope=="number"&&(re.scope===I.TaskScope.Workspace&&H&&H.workspaceFile?M=H.workspaceFile:M=h.USER_TASKS_GROUP_KEY),{id:re._id,workspaceFolder:M}}B.from=z})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(B){function z(re){if(re!=null)return{_id:re.id,isDefault:re.isDefault}}B.from=z})(c=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function(B){function z(M,j){if(M==null)return[];const V=[];for(let q of M){const ie=re(q,j);ie&&V.push(ie)}return V}B.fromMany=z;function re(M,j){if(M==null)return;let V;M.execution instanceof I.ProcessExecution?V=s.from(M.execution):M.execution instanceof I.ShellExecution?V=t.from(M.execution):M.execution&&M.execution instanceof I.CustomExecution&&(V=a.from(M.execution));const q=o.from(M.definition);let ie;return M.scope?typeof M.scope=="number"?ie=M.scope:ie=M.scope.uri:ie=I.TaskScope.Workspace,!q||!ie?void 0:{_id:M._id,definition:q,name:M.name,source:{extensionId:j.identifier.value,label:M.source,scope:ie},execution:V,isBackground:M.isBackground,group:c.from(M.group),presentationOptions:w.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}B.from=re;async function H(M,j,V){if(M==null)return;let q;s.is(M.execution)?q=s.to(M.execution):t.is(M.execution)?q=t.to(M.execution):a.is(M.execution)&&(q=a.to(M._id,V));const ie=o.to(M.definition);let Q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Q=M.source.scope:Q=await j.resolveWorkspaceFolder(d.URI.revive(M.source.scope)):Q=I.TaskScope.Workspace),!ie||!Q)return;const ue=new I.Task(ie,Q,M.name,M.source.label,q,M.problemMatchers);return M.isBackground!==void 0&&(ue.isBackground=M.isBackground),M.group!==void 0&&(ue.group=I.TaskGroup.from(M.group._id),ue.group&&M.group.isDefault&&(ue.group=new I.TaskGroup(ue.group.id,ue.group.label),M.group.isDefault===!0&&(ue.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ue.presentationOptions=w.to(M.presentationOptions)),M._id&&(ue._id=M._id),M.detail&&(ue.detail=M.detail),ue}B.to=H})(S=e.TaskDTO||(e.TaskDTO={}));var R;(function(B){function z(H){return H}B.from=z;function re(H){if(!!H)return Object.assign(Object.create(null),H)}B.to=re})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(z,re,H){this._id=re,this._task=H,f.set(this,void 0),et(this,f,z,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}f=new WeakMap;var N;(function(B){function z(re){return{id:re._id,task:void 0}}B.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let p=class{constructor(z,re,H,M,j,V,q,ie){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=z.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=M,this._configurationService=j,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,re,H){if(!H)return new I.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:re,provider:H,extension:z}),this._proxy.$registerTaskProvider(M,re),new I.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(z,re){this._proxy.$registerTaskSystem(z,re)}fetchTasks(z){return this._proxy.$fetchTasks(R.from(z)).then(async re=>{const H=[];for(let M of re){const j=await S.to(M,this._workspaceProvider,this._providedCustomExecutions2);j&&H.push(j)}return H})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(re=>z.push(re)),z}terminateTask(z){if(!(z instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,re,H){const M=this._providedCustomExecutions2.get(z.id);M&&(this._activeCustomExecutions2.set(z.id,M),this._terminalService.attachPtyToTerminal(re,await M.callback(H))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const re=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:re})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const re=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:re,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const re=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:re,exitCode:z.exitCode})}$provideTasks(z,re){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));const M=[],j=(0,i.asPromise)(()=>H.provider.provideTasks(L.CancellationToken.None)).then(V=>this.provideTasksInternal(re,M,H,V));return new Promise(V=>{j.then(q=>{Promise.all(M).then(()=>{V(q)})})})}async $resolveTask(z,re){const H=this._handlers.get(z);if(!H)return Promise.reject(new Error("no handler found"));if(re.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${re.definition.type}] cannot be resolved by provider of type [${H.type}].`);const M=await S.to(re,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const j=await H.provider.resolveTask(M,L.CancellationToken.None);if(!j)return;this.checkDeprecation(j,H);const V=S.from(j,H.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(V.execution)&&await this.addCustomExecution(V,j,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,re,H){const M=await this._proxy.$createTaskId(z);!H&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,re.execution)),this._providedCustomExecutions2.set(M,re.execution)}async getTaskExecution(z,re){if(typeof z=="string"){const j=this._taskExecutionPromises.get(z);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let H=this._taskExecutionPromises.get(z.id);if(H)return H;const M=new Promise((j,V)=>{function q(ie,Q,ue){ue?j(new O(ie,Q.id,ue)):V("Unexpected: Task does not exist.")}re?q(this,z,re):S.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>q(this,z,ie))});return this._taskExecutionPromises.set(z.id,M),M.then(j=>(this._taskExecutions.set(z.id,j),j),j=>Promise.reject(j))}checkDeprecation(z,re){z._deprecated&&this._deprecationService.report("Task.constructor",re.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let H=this._notProvidedCustomExecutions.values(),M=H.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=H.next()}};p=Ve([$e(0,y.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,g.ILogService),$e(7,E.IExtHostApiDeprecationService)],p),e.ExtHostTaskBase=p;let U=class extends p{constructor(z,re,H,M,j,V,q,ie){super(z,re,H,M,j,V,q,ie);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(z,re){if(!re.execution)throw new Error("Tasks to execute must include an execution");const H=S.from(re,z);if(H===void 0)throw new Error("Task is not valid");if(a.is(H.execution))await this.addCustomExecution(H,re,!1);else throw new l.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),re);return this._proxy.$executeTask(H).catch(j=>{throw new Error(j)}),M}provideTasksInternal(z,re,H,M){const j=[];if(M)for(let V of M){this.checkDeprecation(V,H),(!V.definition||!z[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const q=S.from(V,H.extension);q&&a.is(q.execution)?(j.push(q),re.push(this.addCustomExecution(q,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:H.extension}}async resolveTaskInternal(z){if(a.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,re){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,re,H){}};U=Ve([$e(0,y.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,g.ILogService),$e(7,E.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(Ie[269],ke([1,0,9,21,50,34,22,48,31]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(y,T,_){this.config=y,this.provider=T,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=y.filePattern,this.includePattern=y.includePattern&&P.parse(y.includePattern),this.maxResults=y.maxResults||void 0,this.exists=y.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=y.excludePattern&&P.parse(y.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(y=>y.cancel()),this.activeCancellationTokens=new Set}search(y){const T=this.config.folderQueries||[];return new Promise((_,m)=>{const v=g=>{this.resultCount++,y(g)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const E=g.toString(),h=d.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,h)||this.matchFile(v,{base:g,basename:h})}),Promise.all(T.map(g=>this.searchInFolder(g,v))).then(g=>{_({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{m(new Error((0,C.toErrorMessage)(g)))})})}async searchInFolder(y,T){const _=new i.CancellationTokenSource,m=this.getSearchOptionsForFolder(y),v=this.initDirectoryTree(),g=new b.QueryGlobTester(this.config,y),E=!g.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(_),h=D.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,_.token),f=h.elapsed(),o=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(w=>{const r=d.posix.relative(y.folder.path,w.path);if(E){const s=d.basename(w.path);this.matchFile(T,{base:y.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(v,y.folder,r,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,g,T),{providerTime:f,postProcessTime:o.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(y){const T=(0,b.resolvePatternsForProvider)(this.config.includePattern,y.includePattern),_=(0,b.resolvePatternsForProvider)(this.config.excludePattern,y.excludePattern);return{folder:y.folder,excludes:_,includes:T,useIgnoreFiles:!y.disregardIgnoreFiles,useGlobalIgnoreFiles:!y.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!y.disregardParentIgnoreFiles,followSymlinks:!y.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const y={rootEntries:[],pathToEntries:Object.create(null)};return y.pathToEntries["."]=y.rootEntries,y}addDirectoryEntries({pathToEntries:y},T,_,m){if(_===this.filePattern){const g=d.basename(this.filePattern);this.matchFile(m,{base:T,relativePath:this.filePattern,basename:g})}function v(g){const E=d.basename(g),h=d.dirname(g);let l=y[h];l||(l=y[h]=[],v(h)),l.push({base:T,relativePath:g,basename:E})}v(_)}matchDirectoryTree({rootEntries:y,pathToEntries:T},_,m){const v=this,g=this.filePattern;function E(h){const l=(0,b.hasSiblingFn)(()=>h.map(f=>f.basename));for(let f=0,o=h.length;f<o;f++){const w=h[f],{relativePath:r,basename:s}=w;if(_.matchesExcludesSync(r,s,g!==s?l:void 0))continue;const n=T[r];if(n)E(n);else{if(r===g)continue;v.matchFile(m,w)}if(v.isLimitHit)break}}E(y)}matchFile(y,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||y(T))}}class L{constructor(){this.sessions=new Map}fileSearch(y,T,_,m){const v=this.getSessionTokenSource(y.cacheKey),g=new A(y,T,v&&v.token);let E=0;const h=l=>{E+=l.length,_(l.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(g,L.BATCH_SIZE,h,m).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(y){const T=this.getSessionTokenSource(y);T&&T.cancel()}getSessionTokenSource(y){if(!!y)return this.sessions.has(y)||this.sessions.set(y,new i.CancellationTokenSource),this.sessions.get(y)}rawMatchToSearchItem(y){return y.relativePath?{resource:I.joinPath(y.base,y.relativePath)}:{resource:y.base}}doSearch(y,T,_,m){m.onCancellationRequested(()=>{y.cancel()});const v=E=>{E&&(g.push(E),T>0&&g.length>=T&&(_(g),g=[]))};let g=[];return y.search(v).then(E=>(g.length&&_(g),E),E=>(g.length&&_(g),Promise.reject(E)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ie[270],ke([1,0,16,56,34,102,24,10,9,22,8,14,2,157,186,83,13,45,130,268,31]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(c,S,R,O,N){this.configurationService=c,this.workspaceContextService=S,this.editorGroupsService=R,this.logService=O,this.pathService=N}text(c,S,R={}){c=this.getContentPattern(c,R);const O=this.configurationService.getValue(),N=S&&S.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(S?.map(g.toWorkspaceFolder),R),type:2,contentPattern:c,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(c,S){const R=this.configurationService.getValue();c.isRegExp&&(c.pattern=c.pattern.replace(/\r?\n/g,"\\n"));const O={...c,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(c,S)&&(O.isCaseSensitive=!0),this.isMultiline(c)&&(O.isMultiline=!0),O}file(c,S={}){return{...this.commonQuery(c,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(c,S){return c?(c=Array.isArray(c)?c.map(n):n(c),S?this.parseSearchPaths(c):{pattern:w(...Array.isArray(c)?c:[c])}):{}}commonQuery(c=[],S={}){const R=this.handleIncludeExclude(S.includePattern,S.expandPatterns),O=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),N=c.length>1,p=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,S,O)):c.map(z=>this.getFolderQueryForRoot(z,S,O,N))).filter(z=>!!z),U={_reason:S._reason,folderQueries:p,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:O.pattern,includePattern:R.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const z=d.coalesce(d.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(j=>j.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const re=z.filter(M=>(0,l.pathIncludedInQuery)(U,M.fsPath)),H=this.commonQueryFromFileList(re);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...U,...H}}const B=S.extraFileResources&&S.extraFileResources.filter(z=>(0,l.pathIncludedInQuery)(U,z.fsPath));return U.extraFileResources=B&&B.length?B:void 0,U}commonQueryFromFileList(c){const S=[],R=new I.ResourceMap,O={};let N=!1;return c.forEach(p=>{if(p.scheme===D.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(p)){const B=this.workspaceContextService.getWorkspaceFolder(p)?.uri??p.with({path:b.dirname(p.fsPath)});let z=R.get(B);z||(N=!0,z={folder:B,includePattern:{}},S.push(z),R.set(B,z));const re=b.relative(B.fsPath,p.fsPath);(0,k.assertIsDefined)(z.includePattern)[re.replace(/\\/g,"/")]=!0}else p.fsPath&&(N=!0,O[p.fsPath]=!0)}),{folderQueries:S,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(c,S){if(S.isSmartCase){if(c.isRegExp){if(L.containsUppercaseCharacter(c.pattern,!0))return!0}else if(L.containsUppercaseCharacter(c.pattern))return!0}return!!c.isCaseSensitive}isMultiline(c){return c.isMultiline||c.isRegExp&&(0,T.isMultilineRegexSource)(c.pattern)||c.pattern.indexOf(`
`)>=0?!0:!!c.isMultiline}parseSearchPaths(c){const S=H=>b.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),O=(Array.isArray(c)?c:r(c)).map(H=>{const M=this.pathService.resolvedUserHome;return M?(0,P.untildify)(H,M.scheme===D.Schemas.file?M.fsPath:M.path):H}),N=i.groupBy(O,H=>S(H)?"searchPaths":"exprSegments"),p=(N.exprSegments||[]).map(H=>L.rtrim(H,"/")).map(H=>L.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),U={},B=this.expandSearchPathPatterns(N.searchPaths||[]);B&&B.length&&(U.searchPaths=B);const z=d.flatten(p),re=w(...z);return re&&(U.pattern=re),U}getExcludesForFolder(c,S){return S.disregardExcludeSettings?void 0:(0,l.getExcludes)(c,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(c){if(!c||!c.length)return[];const S=d.flatten(c.map(O=>{let{pathPortion:N,globPortion:p}=o(O);p&&(p=t(p));const U=this.expandOneSearchPath(N);return d.flatten(U.map(B=>this.resolveOneSearchPathPattern(B,p)))})),R=new Map;return S.forEach(O=>{const N=O.searchPath.toString(),p=R.get(N);p?O.pattern&&(p.pattern=p.pattern||{},p.pattern[O.pattern]=!0):R.set(N,{searchPath:O.searchPath,pattern:O.pattern?w(O.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(c){if(b.isAbsolute(c)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==D.Schemas.file?[{searchPath:S[0].uri.with({path:c})}]:[{searchPath:y.URI.file(b.normalize(c))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(c=n(c),c.startsWith("../")||c===".."){const O=b.posix.resolve(S.path,c);return[{searchPath:S.with({path:O})}]}const R=t(c);return[{searchPath:S,pattern:R}]}else{if(c==="./"||c===".\\")return[];{const S=c.replace(/^\.[\/\\]/,""),O=this.workspaceContextService.getWorkspace().folders.map(N=>{const p=S.match(new RegExp(`^${L.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return p?{match:p,folder:N}:null}).filter(k.isDefined);if(O.length)return O.map(N=>{const p=N.match[1];return{searchPath:N.folder.uri,pattern:p&&t(p)}});{const N=c.match(/\.[\/\\](.+)[\/\\]?/),p=N?N[1]:c,U=_.localize(0,null,p);throw new Error(U)}}}}resolveOneSearchPathPattern(c,S){const R=c.pattern&&S?`${c.pattern}/${S}`:c.pattern||S,O=[{searchPath:c.searchPath,pattern:R}];return R&&!R.endsWith("**")&&O.push({searchPath:c.searchPath,pattern:R+"/**"}),O}getFolderQueryForSearchPath(c,S,R){const O=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(c.searchPath),S,R,!1);return O?{...O,includePattern:c.pattern}:null}getFolderQueryForRoot(c,S,R,O){let N;const p=y.URI.isUri(c)?c:c.uri;if(R.searchPaths){const H=R.searchPaths.filter(M=>(0,A.isEqual)(M.searchPath,p))[0];if(H&&!H.pattern)return null;H&&(N=H.pattern)}const U=this.configurationService.getValue({resource:p}),z={...this.getExcludesForFolder(U,S)||{},...N||{}},re=y.URI.isUri(c)?(0,A.basename)(c):c.name;return{folder:p,folderName:O?re:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!U.search.followSymlinks}}};f=Ve([$e(0,m.IConfigurationService),$e(1,g.IWorkspaceContextService),$e(2,E.IEditorGroupsService),$e(3,v.ILogService),$e(4,h.IPathService)],f),e.QueryBuilder=f;function o(u){const c=u.match(/[\*\{\}\(\)\[\]\?]/);if(c){const S=c.index,R=u.substr(0,S).match(/[/|\\][^/\\]*$/);if(R){let O=u.substr(0,R.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function w(...u){return u.length?u.reduce((c,S)=>(c[S]=!0,c),Object.create(null)):void 0}function r(u){return C.splitGlobAware(u,",").map(c=>c.trim()).filter(c=>!!c.length)}function s(u){return[`**/${u}/**`,`**/${u}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function n(u){return u.replace(/\\/g,"/")}function t(u){return n(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(u,c){u=d.distinct(u,O=>O.toString());const S=[],R=c.getWorkspace();return u&&u.forEach(O=>{let N;if(c.getWorkbenchState()===2)N=(0,A.relativePath)(R.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const p=c.getWorkspaceFolder(O);if(p){const U=p.name;if(R.folders.filter(z=>z.name===U).length===1){const z=(0,A.relativePath)(p.uri,O);z===""?N=`./${p.name}`:N=`./${p.name}/${z}`}else N=O.fsPath}}N&&S.push(N)}),S}e.resolveResourcesForSearchIncludes=a}),define(Ie[271],ke([1,0,22,2,21,11,4,270,31,45]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(m,v){const g=v.activationEvents;if(!g)return Promise.resolve(void 0);const E=[],h=[];for(const s of g)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||m.forceUsingSearch?h.push(n):E.push(n)}if(E.length===0&&h.length===0)return Promise.resolve(void 0);let l;const f=new Promise((s,n)=>{l=s}),o=s=>l({activationEvent:s}),w=Promise.all(E.map(s=>y(m,s,o))).then(()=>{}),r=T(m,v.identifier,h,o);return Promise.all([w,r]).then(()=>{l(void 0)}),f}e.checkActivateWorkspaceContainsExtension=k;async function y(m,v,g){for(const E of m.folders)if(await m.exists(d.joinPath(i.URI.revive(E),v))){g(`workspaceContains:${v}`);return}}async function T(m,v,g,E){if(g.length===0)return Promise.resolve(void 0);const h=new C.CancellationTokenSource,l=m.checkExists(m.folders,g,h.token),f=setTimeout(async()=>{h.cancel(),m.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},L);let o=!1;try{o=await l}catch(w){P.isCancellationError(w)||P.onUnexpectedError(w)}h.dispose(),clearTimeout(f),o&&E(`workspaceContains:${g.join(",")}`)}function _(m,v,g,E){const h=m.get(I.IInstantiationService),l=m.get(b.ISearchService),o=h.createInstance(D.QueryBuilder).file(v.map(w=>(0,A.toWorkspaceFolder)(i.URI.revive(w))),{_reason:"checkExists",includePattern:g,exists:!0});return l.fileSearch(o,E).then(w=>!!w.limitHit,w=>P.isCancellationError(w)?!1:Promise.reject(w))}e.checkGlobFileExists=_});var et=this&&this.__classPrivateFieldSet||function(Y,e,d,i,C){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?C.call(Y,d):C?C.value=d:e.set(Y,d),d},Ue=this&&this.__classPrivateFieldGet||function(Y,e,d,i){if(d==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!i:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?i:d==="a"?i.call(Y):i?i.value:e.get(Y)};define(Ie[39],ke([1,0,172,9,74,22,17,6,24,2,13,5,33,226,90,32,25,225,11,28,23,204,7,120,4,27,70,18,84,51,38,3,271,89,206,10]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l,f,o,w,r,s,n,t,a,u,c,S,R,O,N,p){"use strict";var U,B,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let re=class ki extends D.Disposable{constructor(Q,ue,ce,G,ge,ne,he,Se,Re,ve){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ue,this._extHostContext=ce,this._initData=he,this._extHostWorkspace=G,this._extHostConfiguration=ge,this._logService=ne,this._extHostTunnelService=Re,this._extHostTerminalService=ve,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new g.ExtensionDescriptionRegistry(this._initData.allExtensions);const Te=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new g.ExtensionDescriptionRegistry(j(this._globalRegistry,Te)),this._storage=new _.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Se,this._instaService=Q.createChild(new a.ServiceCollection([_.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));let Ae=[],le=[];this._initData.remote.isRemote&&(Ae=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),le=this._initData.allExtensions.filter(ee=>!Te.has(h.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const pe=(0,v.extensionIdentifiersArrayToSet)(le);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,Ae,le,{onExtensionActivationError:(ee,te,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,E.transformErrorForSerialization(te),F)},actualActivateExtension:async(ee,te)=>{if(pe.has(h.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,te),new T.HostExtension;const F=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(F,te)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){E.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Q)}terminate(Q,ue=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),E.setUnexpectedErrorHandler(G=>{this._logService.error(G)}),this._extHostContext.dispose();const ce=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),ce]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ue}`):this._logService.info(`Extension host exiting with code ${ue}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ue)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const ue=await this._mainThreadExtensionsProxy.$getExtension(Q);return ue&&{...ue,identifier:new h.ExtensionIdentifier(ue.identifier.value),extensionLocation:A.URI.revive(ue.extensionLocation)}}_activateByEvent(Q,ue){return this._activator.activateByEvent(Q,ue)}_activateById(Q,ue){return this._activator.activateById(Q,ue)}activateByIdWithErrors(Q,ue){return this._activateById(Q,ue).then(()=>{const ce=this._activator.getActivatedExtension(Q);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==p.Schemas.file)return Q;const ue=await this._hostUtils.realpath(Q.fsPath);return A.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const ue=b.TernarySearchTree.forUris(ce=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ce));return await Promise.all(Q.map(async ce=>{if(this._getEntryPoint(ce)){const G=await this._realPathExtensionUri(ce.extensionLocation);ue.set(G,ce)}})),ue}_deactivate(Q){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return ue;const ce=this._activator.getActivatedExtension(Q);if(!ce)return ue;try{typeof ce.module.deactivate=="function"&&(ue=Promise.resolve(ce.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(G)}try{(0,D.dispose)(ce.subscriptions)}catch(G){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(G)}return ue}async _activateExtension(Q,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,ue).then(ce=>{const G=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,ue),this._logExtensionActivationTimes(Q,ue,"success",G),ce},ce=>{throw this._logExtensionActivationTimes(Q,ue,"failure"),ce})}_logExtensionActivationTimes(Q,ue,ce,G){const ge=H(Q,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...G||{},outcome:ce})}_doActivateExtension(Q,ue){const ce=H(Q,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const G=this._getEntryPoint(Q);if(!G)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${Q.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const ge=new T.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(Q.identifier,(0,P.joinPath)(Q.extensionLocation,G),ge),this._loadExtensionContext(Q)]).then(ne=>(C.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),ki._callActivate(this._logService,Q.identifier,ne[0],ne[1],ge))).then(ne=>(C.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),ne))}_loadExtensionContext(Q){const ue=new f.ExtensionGlobalMemento(Q,this._storage),ce=new f.ExtensionMemento(Q.identifier.value,!1,this._storage),G=new N.ExtensionSecrets(Q,this._secretState),ge=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,ne=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([ue.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let Se,Re;const ve=(0,v.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:ce,secrets:G,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Te){return i.join(Q.extensionLocation.fsPath,Te)},get storagePath(){return he._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(Q).fsPath},get logPath(){return i.join(he._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return A.URI.joinPath(he._initData.logsLocation,Q.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(Q)},get globalStorageUri(){return he._storagePath.globalValue(Q)},get extensionMode(){return ge},get extension(){return Se===void 0&&(Se=new M(he,Q.identifier,Q,ne,!1)),Se},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(Q,"extensionRuntime"),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!Re){if(!ve)return;const Te=S.Event.buffer(S.Event.fromDOMEventEmitter(ve,"message",Ae=>Ae.data));ve.start(),Re={onDidReceiveMessage:Te,postMessage:ve.postMessage.bind(ve)}}return Re}})})}static _callActivate(Q,ue,ce,G,ge){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,ue,ce,G,ge).then(ne=>new T.ActivatedExtension(!1,null,ge.build(),ce,ne,G.subscriptions))}static _callActivateOptional(Q,ue,ce,G,ge){if(typeof ce.activate=="function")try{ge.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const ne=typeof global=="object"?global:self,he=ce.activate.apply(ne,[G]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(he).then(Se=>(ge.activateResolveStop(),Se))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(ce)}_activateOneStartupFinished(Q,ue){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:ue}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const ue of Q.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(Q,ue)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(ue),G=Promise.all([Q,ce]).then(()=>{});return Promise.race([G,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(Q,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,ue){if(this.isActivated(ue.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={logService:this._logService,folders:Q.map(ne=>ne.uri),forceUsingSearch:ce,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,he,Se)=>this._mainThreadWorkspaceProxy.$checkExists(ne,he,Se)},ge=await(0,R.checkActivateWorkspaceContainsExtension)(G,ue);if(!!ge)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:ge.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:ue}=this._initData.environment;if(!Q||!ue)throw new Error(d.localize(0,null));const ce=await this._loadCommonJSModule(null,ue,new T.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(d.localize(1,null,ue.toString()));return new Promise((G,ge)=>{const ne=(Re,ve)=>{Re?ge(Re):G(typeof ve=="number"&&ve>0?1:0)},he=(0,P.originalFSPath)(ue),Se=ce.run(he,ne);Se&&Se.then&&Se.then(()=>{G(0)}).catch(Re=>{ge(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}async $extensionTestsExit(Q){this.terminate(`test runner requested exit with code ${Q}`,Q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,ue){return this._resolvers[Q]=ue,(0,D.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const ue=Q.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const ce=Q.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(Q,ue){this._logService.info(`$resolveAuthority invoked for authority (${V(Q)})`);const{authorityPrefix:ce,resolver:G}=await this._activateAndGetResolver(Q);if(!G)return{type:"error",error:{code:w.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(G)),C.mark(`code/extHost/willResolveAuthority/${ce}`);const ge=await G.resolve(Q,{resolveAttempt:ue});C.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const ne={authority:Q,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},he={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:he,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(C.mark(`code/extHost/didResolveAuthorityError/${ce}`),ge instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Q,ue){this._logService.info(`$getCanonicalURI invoked for authority (${V(Q)})`);const{resolver:ce}=await this._activateAndGetResolver(Q);if(!ce)return null;const G=A.URI.revive(ue);if(typeof ce.getCanonicalURI=="undefined")return G;const ge=await(0,I.asPromise)(()=>ce.getCanonicalURI(G));return ge||G}static _applyExtensionsDelta(Q,ue,ce){const G=new g.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());G.deltaExtensions(ce.toAdd,ce.toRemove);const ge=(0,v.extensionIdentifiersArrayToSet)(ue.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of ce.myToRemove)ge.delete(h.ExtensionIdentifier.toKey(he));for(const he of ce.myToAdd)ge.add(h.ExtensionIdentifier.toKey(he));const ne=j(G,ge);return{globalRegistry:G,myExtensions:ne}}$startExtensionHost(Q){Q.toAdd.forEach(G=>G.extensionLocation=A.URI.revive(G.extensionLocation));const{globalRegistry:ue,myExtensions:ce}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(ce),this._startExtensionHost()}$activateByEvent(Q,ue){return ue===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(Q,!1))}async $activate(Q,ue){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,ue),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(ne=>ne.extensionLocation=A.URI.revive(ne.extensionLocation));const{globalRegistry:ue,myExtensions:ce}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),G=await this._createExtensionPathIndex(ce);return(await this.getExtensionPathIndex()).setSearchTree(G),this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(ce),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){let ue=l.VSBuffer.alloc(Q),ce=Math.random()%256;for(let G=0;G<Q;G++)ue.writeUInt8(ce,G);return ue}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};re=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,t.IExtHostRpcService),$e(3,m.IExtHostWorkspace),$e(4,y.IExtHostConfiguration),$e(5,L.ILogService),$e(6,s.IExtHostInitDataService),$e(7,n.IExtensionStoragePaths),$e(8,u.IExtHostTunnelService),$e(9,c.IExtHostTerminalService)],re),e.AbstractExtHostExtensionService=re;function H(ie,Q){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(Q,ue,ce,G,ge){U.set(this,void 0),B.set(this,void 0),z.set(this,void 0),et(this,U,Q,"f"),et(this,B,ue,"f"),et(this,z,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=i.normalize((0,P.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=G,this.isFromDifferentExtensionHost=ge}get isActive(){return Ue(this,U,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,U,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,U,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=M,U=new WeakMap,B=new WeakMap,z=new WeakMap;function j(ie,Q){return ie.getAllExtensionDescriptions().filter(ue=>Q.has(h.ExtensionIdentifier.toKey(ue.identifier)))}function V(ie){const Q=ie.indexOf("+");return Q===-1?ie:ie.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(Ie[272],ke([1,0,74,2,5,33,25,28,18,27,4,39,40,13,8]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(f,o,w,r,s,n,t){this._apiFactory=f,this._extensionRegistry=o,this._instaService=w,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,o,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(E,o)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,o,this._initData.environment.appUriScheme))}register(f){if("nodeModuleName"in f)if(Array.isArray(f.nodeModuleName))for(let o of f.nodeModuleName)this._factories.set(o,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(o=>f.alternativeModuleName(o))}};m=Ve([$e(2,L.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,A.IExtHostInitDataService),$e(6,T.ILogService)],m),e.RequireInterceptor=m;let v=class Ki{constructor(f){if(f.environment.appRoot&&Ki.aliased.size){const o=(0,_.escapeRegExpCharacters)(this.forceForwardSlashes(f.environment.appRoot.fsPath)),w="[a-z0-9_.-]",r=`@${w}+\\/${w}+|${w}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(f){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(f));if(!o)return;const[,w,r,s]=o,n=Ki.aliased.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),w+n+s}forceForwardSlashes(f){return f.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=Ve([$e(0,A.IExtHostInitDataService)],v);class g{constructor(f,o,w,r,s){this._apiFactory=f,this._extensionPaths=o,this._extensionRegistry=w,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,o){const w=this._extensionPaths.findSubstr(o);if(w){let r=this._extApiImpl.get(D.ExtensionIdentifier.toKey(w.identifier));return r||(r=this._apiFactory(w,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(w.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,n)=>r+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(f,o,w){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(C.MainContext.MainThreadTelemetry);const{environment:r}=w,s=o.getProxy(C.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;y.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>s.$getPassword(n,t),setPassword:(n,t,a)=>s.$setPassword(n,t,a),deletePassword:(n,t)=>s.$deletePassword(n,t),findPassword:n=>s.$findPassword(n),findCredentials(n){return s.$findCredentials(n)}}}load(f,o){const w=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:w?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const o=f.length;if(o<=7||!this.alternativeNames)return;const w=o-7;if((f.charAt(w)==="/"||f.charAt(w)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};E=Ve([$e(1,b.IExtHostRpcService),$e(2,A.IExtHostInitDataService)],E);let h=class{constructor(f,o,w){this._extensionPaths=f,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=w.getProxy(C.MainContext.MainThreadTelemetry);const r=w.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,n)=>{const t=i.URI.parse(s);return n?this.callOriginal(s,n):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,s,{}):this.callOriginal(s,n)}}load(f,o,w){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=w(f),this._impl}callOriginal(f,o){return this.sendNoForwardTelemetry(),this._original(f,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=Ve([$e(2,b.IExtHostRpcService)],h)}),define(Ie[47],ke([1,0,80,6,9,40,4,53,54,39,7,32,219,33]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class _ extends y.AbstractVariableResolverService{constructor(g,E,h,l,f,o,w){function r(){if(h){const s=h.activeEditor();if(s)return s.document.uri;const n=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof L.TextDiffTabInput||n.input instanceof L.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof L.TextTabInput||n.input instanceof L.NotebookEditorTabInput||n.input instanceof L.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=o.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(s,n)=>f.getConfiguration(void 0,s).get(n),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return C.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const s=r();if(s){const n=E.getWorkspaceFolder(s);if(n)return C.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(h){const s=h.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(h){const s=h.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,w?Promise.resolve(w):void 0,Promise.resolve(P.env))}}let m=class extends i.Disposable{constructor(g,E,h,l,f){super();this.extensionService=g,this.workspaceService=E,this.editorService=h,this.configurationService=l,this.editorTabs=f,this._resolver=new d.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};m=Ve([$e(0,A.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,D.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(Ie[75],ke([1,0,17,3,14,2,4,5,54,39,18,7,32,126,213,33,47]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let g=class{constructor(r,s,n,t,a,u){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=a,this._variableResolver=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new i.Emitter,this._onDidTerminateDebugSession=new i.Emitter,this._onDidChangeActiveDebugSession=new i.Emitter,this._onDidReceiveDebugSessionCustomEvent=new i.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new i.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new h(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(c=>{c.onDidChange(S=>{this.registerAllDebugTypes(c)}),this.registerAllDebugTypes(c)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,s){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,a="?";return s&&(t+=`${a}session=${encodeURIComponent(s.id)}`,a="&"),t+=`${a}ref=${n.sourceReference}`,P.URI.parse(t)}else{if(n.path)return P.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const a of t)(0,_.isDebuggerMainContribution)(a)&&s.push(a.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(a=>{const u=a.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,a),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const a of s)if(a instanceof k.SourceBreakpoint){let u=t.get(a.location.uri.toString());u||(u={type:"sourceMulti",uri:a.location.uri,lines:[]},t.set(a.location.uri.toString(),u),n.push(u)),u.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof k.FunctionBreakpoint&&n.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(u=>u instanceof k.SourceBreakpoint).map(u=>u.id),t=s.filter(u=>u instanceof k.FunctionBreakpoint).map(u=>u.id),a=s.filter(u=>u instanceof k.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,a)}startDebugging(r,s,n){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,n){if(!s)return new k.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(a=>a.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,n){if(!n)return new k.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(a=>a.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new k.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:n,factory:s}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let n;const t=await this.getFolder(r);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new f(r.implementation)}createSignService(){}async $startDASession(r,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const u=this.convertToDto(a),c=this.createDebugAdapter(u,t);if(!c)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const S=c;return this._debugAdapters.set(r,S),this.getDebugAdapterTrackers(t).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),S.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const N=O,p={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(N.arguments.value);p.body={signature:U},S.sendResponse(p)}else throw new Error("no signer")}catch(U){p.success=!1,p.message=U.message,S.sendResponse(p)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(O),O=(0,_.convertToVSCPaths)(O,!0),n._debugServiceProxy.$acceptDAMessage(r,O)}),S.onError(O=>{R&&R.onError&&R.onError(O),this._debugServiceProxy.$acceptDAError(r,O.name,O.message,O.stack)}),S.onExit(O=>{R&&R.onExit&&R.onExit((0,C.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,C.withNullAsUndefined)(O),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,s){s=(0,_.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s);const t=this._debugAdapters.get(r);t&&t.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(r);return this._debugAdapters.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],n=[],t=[];if(r.added)for(const a of r.added){const u=a.id;if(u&&!this._breakpoints.has(u)){let c;if(a.type==="function")c=new k.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")c=new k.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const S=P.URI.revive(a.uri);c=new k.SourceBreakpoint(new k.Location(S,new k.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}c._id=u,this._breakpoints.set(u,c),s.push(c)}}if(r.removed)for(const a of r.removed){const u=this._breakpoints.get(a);u&&(this._breakpoints.delete(a),n.push(u))}if(r.changed){for(const a of r.changed)if(a.id){const u=this._breakpoints.get(a.id);if(u){if(u instanceof k.FunctionBreakpoint&&a.type==="function"){const c=u;c.enabled=a.enabled,c.condition=a.condition,c.hitCondition=a.hitCondition,c.logMessage=a.logMessage,c.functionName=a.functionName}else if(u instanceof k.SourceBreakpoint&&a.type==="source"){const c=u;c.enabled=a.enabled,c.condition=a.condition,c.hitCondition=a.hitCondition,c.logMessage=a.logMessage,c.location=new k.Location(P.URI.revive(a.uri),new k.Position(a.line,a.character))}t.push(u)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(r,s,n){return(0,d.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.getFolder(s);return t.provideDebugConfigurations(a,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,n,t){return(0,d.asPromise)(async()=>{const a=this.getConfigProviderByHandle(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(s);return a.resolveDebugConfiguration(u,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,n,t){return(0,d.asPromise)(async()=>{const a=this.getConfigProviderByHandle(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(s);return a.resolveDebugConfigurationWithSubstitutedVariables(u,n,t)})}async $provideDebugAdapter(r,s){const n=this.getAdapterDescriptorFactoryByHandle(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(a)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){const n=await this.getSession(r);n&&n._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(n=>n.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(n=>n.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(n=>n.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const n=r.configuration.type,t=this._trackerFactories.filter(a=>a.type===n||a.type==="*").map(a=>(0,d.asPromise)(()=>a.factory.createDebugAdapterTracker(r)).then(u=>u,u=>null));return Promise.race([Promise.all(t).then(a=>{const u=a.filter(c=>!!c);if(u.length>0)return new l(u)}),new Promise((a,u)=>{const c=setTimeout(()=>{clearTimeout(c),u(new Error("timeout"))},1e3)})]).catch(a=>{})}async getAdapterDescriptor(r,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new k.DebugAdapterServer(n));if(r){const a=await this._extensionService.getExtensionRegistry();return(0,d.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,a))).then(u=>{if(u)return u})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,n){(r.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:n}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const n=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new E(this._debugServiceProxy,r.id,r.type,r.name,n,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=P.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};g=Ve([$e(0,L.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,m.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,v.IExtHostVariableResolverProvider)],g),e.ExtHostDebugServiceBase=g;class E{constructor(r,s,n,t,a,u,c){this._debugServiceProxy=r,this._id=s,this._type=n,this._name=t,this._workspaceFolder=a,this._configuration=u,this._parentSession=c}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=E;class h{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=h;class l{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(n=>n.onExit?n.onExit(r,s):void 0)}}class f extends T.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends g{constructor(r,s,n,t,a,u){super(r,s,n,t,a,u)}};o=Ve([$e(0,L.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,m.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,v.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Ie[273],ke([1,0,11,74,2,5,265,13,82,84,27,193,18,65,39]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class m{constructor(g,E,h,l,f){this._hostUtils=h,this._rpcProtocol=new I.RPCProtocol(g,null,l),E=m._transform(E,this._rpcProtocol);const o=new A.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:f}),o.set(y.IExtHostRpcService,new y.ExtHostRpcService(this._rpcProtocol)),o.set(T.IURITransformerService,new T.URITransformerService(l)),o.set(_.IHostUtils,h);const w=new k.InstantiationService(o,!0);this._logService=w.invokeFunction(t=>t.get(D.ILogService)),i.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=w.invokeFunction(t=>t.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(a,u)=>{let c="",S,R;for(const O of u)c+=`
	at ${O.toString()}`,R=O.getFileName(),!S&&R&&(S=t.findSubstr(C.URI.file(R)));return r.set(a,S),`${a.name||"Error"}: ${a.message||""}${c}`}});const s=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);d.setUnexpectedErrorHandler(t=>{const a=d.transformErrorForSerialization(t),u=r.get(t);u?s.$onExtensionRuntimeError(u.identifier,a):n.$onUnexpectedError(a)})}async asBrowserUri(g){const E=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,E){g.allExtensions.forEach(l=>l.extensionLocation=C.URI.revive(E.transformIncomingURIs(l.extensionLocation))),g.environment.appRoot=C.URI.revive(E.transformIncomingURIs(g.environment.appRoot));const h=g.environment.extensionDevelopmentLocationURI;return h&&(g.environment.extensionDevelopmentLocationURI=h.map(l=>C.URI.revive(E.transformIncomingURIs(l)))),g.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=C.URI.revive(E.transformIncomingURIs(g.logsLocation)),g.logFile=C.URI.revive(E.transformIncomingURIs(g.logFile)),g.workspace=E.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=m}),define(Ie[274],ke([1,0,17,12,178,192,200,75,54,39,18,38,7,47,32,214,215,33]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let E=class extends D.ExtHostDebugServiceBase{constructor(w,r,s,n,t,a,u){super(w,r,s,n,a,u);this._terminalService=t,this._integratedTerminalInstances=new f}createDebugAdapter(w,r){switch(w.type){case"server":return new m.SocketDebugAdapter(w);case"pipeServer":return new m.NamedPipeDebugAdapter(w);case"executable":return new m.ExecutableDebugAdapter(w,r.type)}return super.createDebugAdapter(w,r)}daExecutableFromPackage(w,r){const s=m.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),w.type);if(s)return new y.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new I.SignService}async $runInTerminal(w,r){if(w.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const s=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),a=w.title||C.localize(0,null),u=JSON.stringify({shell:n,shellArgs:t});let c=await this._integratedTerminalInstances.checkout(u,a),S,R=!1;if(c)S=w.cwd;else{const U={shellPath:n,shellArgs:t,cwd:w.cwd,name:a,iconPath:new y.ThemeIcon("debug")};R=!0,c=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,u)}c.show(!0);const O=await c.processId;R?await new Promise(U=>setTimeout(U,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?c.sendText("cls"):n.indexOf("bash")>=0?c.sendText("clear"):i.isWindows?c.sendText("cls"):c.sendText("clear"));const N=(0,v.prepareCommand)(n,w.args,S,w.env);c.sendText(N);const p=this.onDidTerminateDebugSession(U=>{U.id===r&&(this._integratedTerminalInstances.free(c),p.dispose())});return O}else if(w.kind==="external")return l(w,await this._configurationService.getConfigProvider());return super.$runInTerminal(w,r)}};E=Ve([$e(0,L.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,b.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider)],E),e.ExtHostDebugService=E;let h;function l(o,w){if(!h)if(i.isWindows)h=new P.WindowsExternalTerminalService;else if(i.isMacintosh)h=new P.MacExternalTerminalService;else if(i.isLinux)h=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=w.getConfiguration("terminal");return h.runInTerminal(o.title,o.cwd,o.args,o.env||{},r.external||{})}e.runInExternalTerminal=l;class f{constructor(){this._terminalInstances=new Map}async checkout(w,r){const n=[...this._terminalInstances.entries()].map(([t,a])=>(0,d.createCancelablePromise)(async u=>{if(t.name!==r||a.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await t.processId))return null;const c=Date.now();return a.lastUsedAt+f.minUseDelay>c||u.isCancellationRequested||a.config!==w?null:(a.lastUsedAt=c,t)}));return await(0,d.firstParallel)(n,t=>!!t)}insert(w,r){this._terminalInstances.set(w,{lastUsedAt:Date.now(),config:r})}free(w){const r=this._terminalInstances.get(w);r&&(r.lastUsedAt=-1)}onTerminalClosed(w){this._terminalInstances.delete(w)}}f.minUseDelay=1e3}),define(Ie[275],ke([1,0,9,2,112,32,53,33,45,38,18,27,73,10,13,68,22,62,47]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends y.ExtHostTaskBase{constructor(f,o,w,r,s,n,t,a,u){super(f,o,w,r,s,n,t,a);this.workspaceService=w,this.variableResolver=u,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(f,o){const w=o;if(!o.execution&&w._id===void 0)throw new Error("Tasks to execute must include an execution");if(w._id!==void 0){const r=y.TaskHandleDTO.from(w,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(s,o);return this._proxy.$executeTask(r).catch(()=>{}),n}else{const r=y.TaskDTO.from(o,f);if(r===void 0)return Promise.reject(new Error("Task is not valid"));y.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,o,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),o);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(f,o,w,r){const s=[];if(r)for(let n of r){this.checkDeprecation(n,w),(!n.definition||!f[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const t=y.TaskDTO.from(n,w.extension);t&&(s.push(t),y.CustomExecutionDTO.is(t.execution)&&o.push(this.addCustomExecution(t,n,!0)))}return{tasks:s,extension:w.extension}}async resolveTaskInternal(f){return f}async getAFolder(f){let o=f&&f.length>0?f[0]:void 0;if(!o){const w=i.URI.file((0,g.homedir)());o=new b.WorkspaceFolder({uri:w,name:v.basename(w),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(f,o){const w=i.URI.revive(f),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(w),n=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),a=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let u of o.variables)r.variables[u]=await t.resolveAsync(a,u);if(o.process!==void 0){let u;if(o.process.path!==void 0){u=o.process.path.split(d.delimiter);for(let c=0;c<u.length;c++)u[c]=await t.resolveAsync(a,u[c])}r.process=await C.win32.findExecutable(await t.resolveAsync(a,o.process.name),o.process.cwd!==void 0?await t.resolveAsync(a,o.process.cwd):void 0,u)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(f,o,w){return C.win32.findExecutable(f,o,w)}};h=Ve([$e(0,L.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,I.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,A.IExtHostTerminalService),$e(6,_.ILogService),$e(7,m.IExtHostApiDeprecationService),$e(8,E.IExtHostVariableResolverProvider)],h),e.ExtHostTask=h}),define(Ie[276],ke([1,0,62,47]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class C extends i.ExtHostVariableResolverProviderService{homeDir(){return(0,d.homedir)()}}e.NodeExtHostVariableResolverProviderService=C}),define(Ie[140],ke([1,0,16,17,21,50,10,9,22,14,2,31]),function(Y,e,d,i,C,P,I,D,b,A,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(h,l,f,o){this.query=h,this.provider=l,this.fileUtils=f,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,l){const f=this.query.folderQueries||[],o=new C.CancellationTokenSource;return l.onCancellationRequested(()=>o.cancel()),new Promise((w,r)=>{this.collector=new _(h);let s=!1;const n=(t,a)=>{if(!s&&!this.isLimitHit){const u=this.resultSize(t);v(t)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,s=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const c=this.resultSize(t);this.resultCount+=c,(c>0||!v(t))&&this.collector.add(t,a)}};Promise.all(f.map((t,a)=>this.searchInFolder(t,u=>n(u,a),o.token))).then(t=>{o.dispose(),this.collector.flush();const a=t.some(u=>!!u&&!!u.limitHit);w({limitHit:this.isLimitHit||a,messages:(0,d.flatten)(t.map(u=>u?.message?(0,A.isArray)(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const a=(0,P.toErrorMessage)(t);r(new Error(a))})})}resultSize(h){return v(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,l){const f=Array.isArray(h.ranges)?h.ranges:[h.ranges],o=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:f.slice(0,l),preview:{matches:o.slice(0,l),text:h.preview.text},uri:h.uri}}async searchInFolder(h,l,f){const o=new k.QueryGlobTester(this.query,h),w=[],r={report:t=>{if(!this.validateProviderResult(t))return;const a=h.folder.scheme===I.Schemas.file?(0,k.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,u=b.relativePath(h.folder,t.uri);if(u){const c=o.includedInQuery(u,D.basename(u),a);(0,i.isThenable)(c)?w.push(c.then(S=>{S&&l(t)})):c&&l(t)}}},s=this.getSearchOptionsForFolder(h),n=await this.provider.provideTextSearchResults(T(this.query.contentPattern),s,r,f);return w.length&&await Promise.all(w),n}validateProviderResult(h){if(v(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const l=(0,k.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),f=(0,k.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),o={folder:L.URI.from(h.folder),excludes:f,includes:l,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=y;function T(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class _{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,l=>this.sendItems(l))}add(h,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!b.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(m(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=_;function m(E){return v(E)?{preview:{matches:(0,d.mapArrayOrNot)(E.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:E.preview.text},ranges:(0,d.mapArrayOrNot)(E.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function v(E){return!!E.preview}e.extensionResultIsMatch=v;class g{constructor(h,l){this.maxBatchSize=h,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,l){!h||this.addItemToBatch(h,l)}addItems(h,l){!h||this.addItemsToBatch(h,l)}addItemToBatch(h,l){this.batch.push(h),this.batchSize+=l,this.onUpdate()}addItemsToBatch(h,l){this.batch=this.batch.concat(h),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(Ie[76],ke([1,0,6,5,4,269,18,65,13,2,140]),function(Y,e,d,i,C,P,I,D,b,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(m,v,g){this.extHostRpc=m,this._uriTransformer=v,this._logService=g,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,v){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const g=this._handlePool++;return this._textSearchProvider.set(g,v),this._proxy.$registerTextSearchProvider(g,this._transformScheme(m)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(m,v){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const g=this._handlePool++;return this._fileSearchProvider.set(g,v),this._proxy.$registerFileSearchProvider(g,this._transformScheme(m)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(m,v,g,E){const h=y(g),l=this._fileSearchProvider.get(m);if(l)return this._fileSearchManager.fileSearch(h,l,f=>{this._proxy.$handleFileMatch(m,v,f.map(o=>o.resource))},E);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,v,g,E){const h=this._textSearchProvider.get(m);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const l=y(g);return this.createTextSearchManager(l,h).search(o=>this._proxy.$handleTextMatch(m,v,o),E)}$enableExtensionHostSearch(){}createTextSearchManager(m,v){return new L.TextSearchManager(m,v,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}};k=Ve([$e(0,I.IExtHostRpcService),$e(1,D.IURITransformerService),$e(2,b.ILogService)],k),e.ExtHostSearch=k;function y(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(T),extraFileResources:_.extraFileResources&&_.extraFileResources.map(m=>A.URI.revive(m))}}e.reviveQuery=y;function T(_){return{..._,folder:A.URI.revive(_.folder)}}}),define(Ie[277],ke([1,0,82,139,32,135,33,37,53,38,73,75,76,90,51,68,138,69,46,89,123,54,136,13,227,47]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l,f,o,w,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(w.ILoggerService,o.ExtHostLoggerService),(0,d.registerSingleton)(w.ILogService,r.ExtHostLogService),(0,d.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,d.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,d.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,d.registerSingleton)(g.IExtHostConsumerFileSystem,g.ExtHostConsumerFileSystem),(0,d.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,d.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,d.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,d.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,d.registerSingleton)(y.IExtHostSearch,y.ExtHostSearch),(0,d.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,d.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,d.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,d.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,d.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,d.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,d.registerSingleton)(f.IExtHostEditorTabs,f.ExtHostEditorTabs),(0,d.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(Ie[91],ke([1,0,16,13,31,72]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=I;function D(k,y,T,_){const m=(0,d.mapArrayOrNot)(T,b),v=new C.TextSearchMatch(y,m,_),g=v.preview.matches;return{ranges:(0,d.mapArrayOrNot)(m,A),uri:k,preview:{text:v.preview.text,matches:(0,d.mapArrayOrNot)(g,A)}}}e.createTextSearchResult=D;function b(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function A(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(y,T){this.prefix=y,this.logService=T}appendLine(y){this.logService.debug(`${this.prefix}#search`,y)}};L=Ve([$e(1,i.ILogService)],L),e.OutputChannel=L}),define(Ie[278],ke([1,0,41,9,81,30,12,8,91,279]),function(Y,e,d,i,C,P,I,D,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(h,l,f,o){const w=y(h,l,f,o),r=l.folder.fsPath;return{cmd:d.spawn(L,w.args,{cwd:r}),rgDiskPath:L,siblingClauses:w.siblingClauses,rgArgs:w,cwd:r}}e.spawnRipgrepCmd=k;function y(h,l,f,o){const w=["--files","--hidden","--case-sensitive"];_([l],f,!1).forEach(s=>{const n=(0,b.anchorGlob)(s);if(w.push("-g",n),I.isMacintosh){const t=(0,C.normalizeNFD)(n);t!==n&&w.push("-g",t)}});const r=T([l],o,void 0,!1);return r.globArgs.forEach(s=>{const n=`!${(0,b.anchorGlob)(s)}`;if(w.push("-g",n),I.isMacintosh){const t=(0,C.normalizeNFD)(n);t!==n&&w.push("-g",t)}}),l.disregardIgnoreFiles!==!1?w.push("--no-ignore"):l.disregardParentIgnoreFiles!==!1&&w.push("--no-ignore-parent"),l.ignoreSymlinks||w.push("--follow"),h.exists&&w.push("--quiet"),w.push("--no-config"),l.disregardGlobalIgnoreFiles&&w.push("--no-ignore-global"),{args:w,siblingClauses:r.siblingClauses}}function T(h,l,f,o=!0){const w=[];let r={};return h.forEach(s=>{const n=Object.assign({},s.excludePattern||{},l||{}),t=m(n,o?s.folder.fsPath:void 0,f);w.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:w,siblingClauses:r}}e.foldersToRgExcludeGlobs=T;function _(h,l,f=!0){const o=[];return h.forEach(w=>{const r=Object.assign({},l||{},w.includePattern||{}),s=m(r,f?w.folder.fsPath:void 0);o.push(...s.globArgs)}),o}e.foldersToIncludeGlobs=_;function m(h,l,f){const o=[],w={};return Object.keys(h).forEach(r=>{if(f&&f.has(r)||!r)return;const s=h[r];r=g(l?v(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),o.push(E(r))):s&&s.when&&(w[r]=s)}),{globArgs:o,siblingClauses:w}}function v(h,l){return i.isAbsolute(l)?l:i.join(h,l)}e.getAbsoluteGlob=v;function g(h){return h=D.rtrim(h,"\\"),D.rtrim(h,"/")}function E(h){return P.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=E}),define(Ie[280],ke([1,0,41,61,9,104,16,50,34,81,30,12,48,8,14,29,31,278,100]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(r=>r())});class l{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&b.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&b.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(n=>{const t=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),a=n.folder.fsPath;s.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==a).forEach(u=>{(0,L.isEqualOrParent)(u,a)&&(t[C.relative(a,u)]=!0)}),this.folderExcludePatterns.set(a,new o(t,a))})}cancel(){this.isCanceled=!0,h.forEach(s=>s())}walk(s,n,t,a,u){if(this.fileWalkSW=y.StopWatch.create(!1),this.isCanceled)return u(null,this.isLimitHit);n.forEach(c=>{const S=C.basename(c.fsPath);this.globalExcludePattern&&this.globalExcludePattern(c.fsPath,S)||this.matchFile(t,{relativePath:c.fsPath,searchPath:void 0})}),this.cmdSW=y.StopWatch.create(!1),this.parallel(s,(c,S)=>{this.call(this.cmdTraversal,this,c,t,a,R=>{if(R){const O=(0,D.toErrorMessage)(R);console.error(O),this.errors.push(O),S(R,void 0)}else S(null,void 0)})},(c,S)=>{this.fileWalkSW.stop();const R=c?I.coalesce(c)[0]:null;u(R,this.isLimitHit)})}parallel(s,n,t){const a=new Array(s.length),u=new Array(s.length);let c=!1,S=0;if(s.length===0)return t(null,[]);s.forEach((R,O)=>{n(R,(N,p)=>{if(N?(c=!0,a[O]=null,u[O]=N):(a[O]=p,u[O]=null),++S===s.length)return t(c?u:null,a)})})}call(s,n,...t){try{s.apply(n,t)}catch(a){t[t.length-1](a)}}cmdTraversal(s,n,t,a){const u=s.folder.fsPath,c=k.isMacintosh;let S;const R=()=>S&&S.kill();h.add(R);let O=H=>{h.delete(R),O=()=>{},a(H)},N="";const p=this.initDirectoryTree();let U;const B=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression);S=B.cmd,U=!Object.keys(B.siblingClauses).length;const z=B.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let re=`${B.rgDiskPath} ${z}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(re+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),t({message:re}),this.cmdResultCount=0,this.collectStdout(S,"utf8",t,(H,M,j)=>{if(H){O(H);return}if(this.isLimitHit){O();return}const q=(N+(c?A.normalizeNFC(M||""):M)).split(`
`);if(j){const ie=q.length;q[ie-1]=q[ie-1].trim(),q[ie-1]||q.pop()}else N=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,U){for(const ie of q)if(this.matchFile(n,{base:u,relativePath:ie,searchPath:this.getSearchPath(s,ie)}),this.isLimitHit){R();break}(j||this.isLimitHit)&&O();return}this.addDirectoryEntries(s,p,u,q,n),j&&(this.matchDirectoryTree(p,u,n),O())})}spawnFindCmd(s){const n=this.folderExcludePatterns.get(s.folder.fsPath),t=n.getBasenameTerms(),a=n.getPathTerms(),u=["-L","."];if(t.length||a.length){u.push("-not","(","(");for(const c of t)u.push("-name",c),u.push("-o");for(const c of a)u.push("-path",c),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),d.spawn("find",u,{cwd:s.folder.fsPath})}readStdout(s,n,t){let a="";this.collectStdout(s,n,()=>{},(u,c,S)=>{if(u){t(u);return}a+=c,S&&t(null,a)})}collectStdout(s,n,t,a){let u=(R,O,N)=>{(R||N)&&(u=()=>{},this.cmdSW&&this.cmdSW.stop()),a(R,O,N)},c=!1;s.stdout?(this.forwardData(s.stdout,n,u),s.stdout.once("data",()=>c=!0)):t({message:"stdout is null"});let S;s.stderr?S=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",R=>{u(R)}),s.on("close",R=>{let O;!c&&(O=this.decodeData(S,n))&&w(O)?u(new Error(`command failed with error code ${R}: ${this.decodeData(S,n)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),u(null,"",!0))})}forwardData(s,n,t){const a=new P.StringDecoder(n);return s.on("data",u=>{t(null,a.write(u))}),a}collectData(s){const n=[];return s.on("data",t=>{n.push(t)}),n}decodeData(s,n){const t=new P.StringDecoder(n);return s.map(a=>t.write(a)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:n},t,a,u){a.indexOf(this.filePattern)!==-1&&this.matchFile(u,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const c=S=>{const R=C.basename(S),O=C.dirname(S);let N=n[O];N||(N=n[O]=[],c(O)),N.push({base:t,relativePath:S,basename:R,searchPath:this.getSearchPath(s,S)})};a.forEach(c)}matchDirectoryTree({rootEntries:s,pathToEntries:n},t,a){const u=this,c=this.folderExcludePatterns.get(t),S=this.filePattern;function R(O){u.directoriesWalked++;const N=(0,v.hasSiblingFn)(()=>O.map(p=>p.basename));for(let p=0,U=O.length;p<U;p++){const B=O[p],{relativePath:z,basename:re}=B;if(c.test(z,re,S!==re?N:void 0))continue;const H=n[z];if(H)R(H);else{if(u.filesWalked++,z===S)continue;u.matchFile(a,B)}if(u.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,n,t,a,u){const c=s.folder,S=(0,v.hasSiblingFn)(()=>t);this.parallel(t,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const N=n?[n,R].join(C.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(N,R,this.config.filePattern!==R?S:void 0))return O(null);const p=[c.fsPath,N].join(C.sep);i.lstat(p,(U,B)=>{if(U||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(p,B,(z,re)=>z||this.isCanceled||this.isLimitHit?O(null):re.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(p,B,(H,M)=>H||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?O(null):(this.walkedPaths[M]=!0,m.Promises.readdir(p).then(j=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(s,N,j,a,V=>O(V||null))},j=>{O(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&_.isNumber(re.size)&&re.size>this.maxFilesize||this.matchFile(a,{base:c.fsPath,relativePath:N,searchPath:this.getSearchPath(s,N)}),O(null,void 0)))})},R=>{const O=R&&I.coalesce(R);return u(O&&O.length>0?O[0]:void 0)})}matchFile(s,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,C.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(n))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,n,t){return n.isSymbolicLink()?i.stat(s,t):t(null,n)}realPathIfNeeded(s,n,t){return n.isSymbolicLink()?i.realpath(s,(a,u)=>a?t(a):t(null,u)):t(null,s)}getSearchPath(s,n){return s.folderName?C.join(s.folderName,n):n}}e.FileWalker=l;class f{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new l(s)}search(s,n,t){this.walker.walk(this.folderQueries,this.extraFiles,s,n,(a,u)=>{t(a,{limitHit:u,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class o{constructor(s,n){this.expression=s,this.root=n,this.init(s)}init(s){let n,t;Object.keys(s).filter(a=>s[a]).forEach(a=>{C.isAbsolute(a)?(n=n||b.getEmptyExpression(),n[a]=s[a]):(t=t||b.getEmptyExpression(),t[a]=s[a])}),this.absoluteParsedExpr=n&&b.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=t&&b.parse(t,{trimForExclusions:!0})}test(s,n,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,n,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,s),n,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...b.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...b.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...b.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...b.getPathTerms(this.relativeParsedExpr)),s}}function w(r){const s=r.trim().split(`
`),n=s[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return T.uppercaseFirstLetter(s[s.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=w}),define(Ie[281],ke([1,0,96,23]),function(Y,e,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,I=512,D=512*8,b=512*128;var A;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(A=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(s,n){super(s);this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class k{constructor(s){this.iconvLiteDecoder=s}static async create(s){let n;if(s!==e.UTF8)n=(await new Promise((a,u)=>{Y(["@vscode/iconv-lite-umd"],a,u)})).getDecoder(m(s));else{const t=new TextDecoder;n={write(a){return t.decode(a,{stream:!0})},end(){return t.decode()}}}return new k(n)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function y(r,s){const n=s.minBytesRequiredForDetection??s.guessEncoding?D:I;return new Promise((t,a)=>{const u=(0,d.newWriteableStream)(p=>p.join("")),c=[];let S=0,R,O;const N=async()=>{try{const p=await w({buffer:i.VSBuffer.concat(c),bytesRead:S},s.guessEncoding);if(p.seemsBinary&&s.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);p.encoding=await s.overwriteEncoding(p.encoding),R=await k.create(p.encoding);const U=R.write(i.VSBuffer.concat(c).buffer);u.write(U),c.length=0,S=0,t({stream:u,detected:p})}catch(p){O?.dispose(),u.destroy(),a(p)}};O=(0,d.listenStream)(r,{onData:async p=>{R?u.write(R.write(p.buffer)):(c.push(p),S+=p.byteLength,S>=n&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:p=>u.error(p),onEnd:async()=>{R||await N(),u.end(R?.end())}})})}e.toDecodeStream=y;async function T(r,s,n){const a=(await new Promise((S,R)=>{Y(["@vscode/iconv-lite-umd"],S,R)})).getEncoder(m(s),n);let u=!1,c=!1;return{read(){if(c)return null;const S=r.read();if(typeof S!="string"){if(c=!0,!u&&n?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=a.end();return R&&R.length>0?(u=!0,i.VSBuffer.wrap(R)):null}return u=!0,i.VSBuffer.wrap(a.write(S))}}}e.toEncodeReadable=T;async function _(r){return(await new Promise((n,t)=>{Y(["@vscode/iconv-lite-umd"],n,t)})).encodingExists(m(r))}e.encodingExists=_;function m(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=m;function v(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),t=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=r.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const g=["ascii","utf-16","utf-32"];async function E(r){const s=await new Promise((c,S)=>{Y(["jschardet"],c,S)}),n=r.slice(0,b),t=f(n.buffer),a=s.detect(t);if(!a||!a.encoding)return null;const u=a.encoding.toLowerCase();return 0<=g.indexOf(u)?null:l(a.encoding)}const h={ibm866:"cp866",big5:"cp950"};function l(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[s]||s}function f(r){let s="";for(let n=0;n<r.length;n++)s+=String.fromCharCode(r[n]);return s}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=o;function w({buffer:r,bytesRead:s},n){let t=v(r,s),a=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let u=!0,c=!0,S=!1;for(let R=0;R<s&&R<P;R++){const O=R%2==1,N=r.readUInt8(R)===0;if(N&&(S=!0),u&&(O&&!N||!O&&N)&&(u=!1),c&&(O&&N||!O&&!N)&&(c=!1),N&&!u&&!c)break}S&&(u?t=e.UTF16le:c?t=e.UTF16be:a=!0)}return n&&!a&&!t&&r?E(r.slice(0,s)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:a,encoding:t}}e.detectEncodingFromBuffer=w,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[141],ke([1,0,281,29,140]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends C.TextSearchManager{constructor(D,b,A=i,L="searchProcess"){super(D,b,{readdir:k=>A.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,d.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=P}),define(Ie[282],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class d{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const P=this._dragOperations.get(C);return this._dragOperations.delete(C),P}}addDragOperationTransfer(C,P){this._dragOperations.set(C,P)}getRenderedTreeElement(C){if(this._renderedElements.has(C))return this._renderedElements.get(C)}addRenderedTreeItemElement(C,P){this._renderedElements.set(C,P)}removeRenderedTreeItemElement(C){this._renderedElements.has(C)&&this._renderedElements.delete(C)}}e.TreeviewsService=d}),define(Ie[283],ke([1,0,176,22,2,3,6,17,7,14,16,15,21,125,282,25]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(h,l){if((0,A.isString)(h))return{label:h};if(h&&typeof h=="object"&&typeof h.label=="string"){let f;return Array.isArray(h.highlights)&&(f=h.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),f=f.length?f:void 0),{label:h.label,highlights:f}}}class g{constructor(l,f,o){this._proxy=l,this.commands=f,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new _.TreeviewsService;function w(r){return r&&r.$treeViewId&&r.$treeItemHandle}f.registerArgumentProcessor({processArgument:r=>w(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>w(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(l,f,o){const w=this.createTreeView(l,{treeDataProvider:f},o);return{dispose:()=>w.dispose()}}createTreeView(l,f,o){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const w=f.dragAndDropController?.dropMimeTypes??[],r=f.dragAndDropController?.dragMimeTypes??[],s=!!f.dragAndDropController?.handleDrag,n=!!f.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dropMimeTypes:w,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:n}),a=this.createExtHostTreeView(l,f,o);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(u){a.message=u},get title(){return a.title},set title(u){a.title=u},get description(){return a.description},set description(u){a.description=u},get badge(){return(0,m.checkProposedApiEnabled)(o,"badges"),a.badge},set badge(u){(0,m.checkProposedApiEnabled)(o,"badges"),a.badge=u},reveal:(u,c)=>a.reveal(u,c),dispose:async()=>{await t,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,f){const o=this.treeViews.get(l);return o?o.getChildren(f):Promise.reject(new Error((0,d.localize)(0,null,l)))}async $handleDrop(l,f,o,w,r,s,n,t){const a=this.treeViews.get(l);if(!a)return Promise.reject(new Error((0,d.localize)(1,null,l)));const u=T.DataTransferConverter.toDataTransfer(o,async c=>(await this._proxy.$resolveDropFileData(l,f,c)).buffer);return n===l&&t&&await this.addAdditionalTransferItems(u,a,t,r,s),a.onDrop(u,w,r)}async addAdditionalTransferItems(l,f,o,w,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((n,t)=>{if(n){const a=n.asFile();l.set(t,{value:n.value,asString:n.asString,asFile(){if(!!a)return{name:a.name,uri:a.uri,data:async()=>await a.data()}}})}});else if(r&&f.handleDrag){const n=f.handleDrag(o,l,w);this.treeDragAndDropService.addDragOperationTransfer(r,n),await n}return l}async $handleDrag(l,f,o,w){const r=this.treeViews.get(l);if(!r)return Promise.reject(new Error((0,d.localize)(2,null,l)));const s=await this.addAdditionalTransferItems(new Map,r,f,w,o);if(!!s)return T.DataTransferConverter.toDataTransferDTO(s)}async $hasResolve(l){const f=this.treeViews.get(l);if(!f)throw new Error((0,d.localize)(3,null,l));return f.hasResolve}$resolve(l,f,o){const w=this.treeViews.get(l);if(!w)throw new Error((0,d.localize)(4,null,l));return w.resolveTreeItem(f,o)}$setExpanded(l,f,o){const w=this.treeViews.get(l);if(!w)throw new Error((0,d.localize)(5,null,l));w.setExpanded(f,o)}$setSelection(l,f){const o=this.treeViews.get(l);if(!o)throw new Error((0,d.localize)(6,null,l));o.setSelection(f)}$setVisible(l,f){const o=this.treeViews.get(l);if(!o)throw new Error((0,d.localize)(7,null,l));o.setVisible(f)}createExtHostTreeView(l,f,o){const w=new E(l,f,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(l,w),w}convertArgument(l){const f=this.treeViews.get(l.$treeViewId);return f?f.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=g;class E extends I.Disposable{constructor(l,f,o,w,r,s){super();if(this.viewId=l,this.proxy=o,this.commands=w,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new y.CancellationTokenSource,s.contributes&&s.contributes.views)for(const a in s.contributes.views)for(const u of s.contributes.views[a])u.id===l&&(this._title=u.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,t;this._register(P.Event.debounce(this._onDidChangeData.event,(a,u)=>(a||(a={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(c=>t=c),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?a.elements.push(...u.element):a.elements.push(u.element)),u.message&&(a.message=!0),a),200,!0)(({message:a,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=t;return n=null,this.refresh(u).then(()=>c())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.isUndefinedOrNull)(l))}async getChildren(l){const f=l?this.getExtensionElement(l):void 0;if(l&&!f)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(l);return o||(o=await this.fetchChildrenNodes(f)),o?o.map(w=>w.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,f){f=f||{select:!0,focus:!1};const o=(0,A.isUndefinedOrNull)(f.select)?!0:f.select,w=(0,A.isUndefinedOrNull)(f.focus)?!1:f.focus,r=(0,A.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:o,focus:w,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:w,expand:r})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=k.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,f){const o=this.getExtensionElement(l);o&&(f?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(l){(0,L.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,f,o){const w=[];for(const r of l){const s=this.getExtensionElement(r);s&&w.push(s)}if(!(!this.dndController?.handleDrag||w.length===0))return await this.dndController.handleDrag(w,f,o),f}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,f,o){const w=f?this.getExtensionElement(f):void 0;if(!(!w&&f||!this.dndController?.handleDrop))return(0,D.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(w,l,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,f){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(l);if(o){const w=this.nodes.get(o);if(w){const r=await this.dataProvider.resolveTreeItem(w.extensionItem,o,f)??w.extensionItem;return w.item.tooltip=this.getTooltip(r.tooltip),w.item.command=this.getCommand(w.disposableStore,r.command),w.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(f=>f?this.resolveUnknownParentChain(f).then(o=>this.resolveTreeNode(f,o[o.length-1]).then(w=>(o.push(w),o))):Promise.resolve([]))}resolveParent(l){const f=this.nodes.get(l);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,f){const o=this.nodes.get(l);return o?Promise.resolve(o):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(w=>this.createHandle(l,w,f,!0)).then(w=>this.getChildren(f?f.item.handle:void 0).then(()=>{const r=this.getExtensionElement(w);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${w}`)}))}getChildrenNodes(l){if(l){let f;if(typeof l=="string"){const o=this.getExtensionElement(l);f=o?this.nodes.get(o):void 0}else f=l;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const f=new y.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=l?this.nodes.get(l):void 0,w=await this.dataProvider.getChildren(l);if(f.token.isCancellationRequested)return;const r=await Promise.all((0,L.coalesce)(w||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,o):null}));return f.token.isCancellationRequested?void 0:(0,L.coalesce)(r)}finally{f.dispose()}}refresh(l){if(l.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new y.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(l);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const f=new Set,o=l.map(r=>this.nodes.get(r));for(const r of o)if(r&&!f.has(r.item.handle)){let s=r;for(;s&&s.parent&&o.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&f.add(r.item.handle)}const w=[];return f.forEach(r=>{const s=this.elements.get(r);if(s){const n=this.nodes.get(s);n&&(!n.parent||!f.has(n.parent.item.handle))&&w.push(r)}}),w}refreshHandles(l){const f={};return Promise.all(l.map(o=>this.refreshNode(o).then(w=>{w&&(f[o]=w.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(l){const f=this.getExtensionElement(l);if(f){const o=this.nodes.get(f);if(o)return this.clearChildren(f),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(w=>{if(w){const r=this.createTreeNode(f,w,o.parent);return this.updateNodeCache(f,r,o,o.parent),o.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,f,o){const w=this.createTreeNode(l,f,o);if(f.id&&this.elements.has(w.item.handle))throw new Error((0,d.localize)(8,null,f.id));return this.addNodeToCache(l,w),this.addNodeToParentCache(w,o),w}getTooltip(l){return b.MarkdownString.isMarkdownString(l)?k.MarkdownString.from(l):l}getCommand(l,f){return f?this.commands.toInternal(f,l):void 0}createTreeNode(l,f,o){const w=new I.DisposableStore,r=this.createHandle(l,f,o),s=this.getLightIconPath(f);return{item:{handle:r,parentHandle:o?o.item.handle:void 0,label:v(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(w,f.command),contextValue:f.contextValue,icon:s,iconDark:this.getDarkIconPath(f)||s,themeIcon:this.getThemeIcon(f),collapsibleState:(0,A.isUndefinedOrNull)(f.collapsibleState)?b.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:o,children:void 0,disposableStore:w,dispose(){w.dispose()}}}getThemeIcon(l){return l.iconPath instanceof b.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:f,label:o,resourceUri:w},r,s){if(f)return`${E.ID_HANDLE_PREFIX}/${f}`;const n=v(o,this.extension),t=r?r.item.handle:E.LABEL_HANDLE_PREFIX;let a=n?n.label:w?(0,i.basename)(w):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const u=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,c=this.getChildrenNodes(r)||[];let S,R=0;do{if(S=`${t}/${R}:${a}`,s||!this.elements.has(S)||u===S)break;R++}while(R<=c.length);return S}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof b.ThemeIcon))return typeof l.iconPath=="string"||C.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof b.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return C.URI.isUri(l)?l:C.URI.file(l)}addNodeToCache(l,f){this.elements.set(f.item.handle,l),this.nodes.set(l,f)}updateNodeCache(l,f,o,w){this.elements.delete(f.item.handle),this.nodes.delete(l),f.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(l,f);const r=this.getChildrenNodes(w)||[],s=r.filter(n=>n.item.handle===o.item.handle)[0];s&&r.splice(r.indexOf(s),1,f)}addNodeToParentCache(l,f){f?(f.children||(f.children=[]),f.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const f=this.nodes.get(l);if(f){if(f.children)for(const o of f.children){const w=this.elements.get(o.item.handle);w&&this.clear(w)}f.children=void 0}}else this.clearAll()}clear(l){const f=this.nodes.get(l);if(f){if(f.children)for(const o of f.children){const w=this.elements.get(o.item.handle);w&&this.clear(w)}this.nodes.delete(l),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}E.LABEL_HANDLE_PREFIX="0",E.ID_HANDLE_PREFIX="1"}),define(Ie[284],ke([1,0,21,11,3,43,2,113,110,153,152,42,5,134,232,231,37,233,33,234,235,236,221,237,53,39,238,239,242,243,244,139,223,249,250,251,90,38,253,283,15,7,256,71,138,32,56,211,241,121,135,73,75,76,13,65,18,27,245,207,51,68,229,254,70,69,259,257,258,230,46,252,255,89,54,123,137,72,248,10,117,246,205,240,6,25,212,247]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l,f,o,w,r,s,n,t,a,u,c,S,R,O,N,p,U,B,z,re,H,M,j,V,q,ie,Q,ue,ce,G,ge,ne,he,Se,Re,ve,Te,Ae,le,pe,ee,te,F,$,K,X,me,Ee,oe,De,Ce,We,je,Fe,Ye,J,se,_e,ae,ye,Ne,He,qe,Ge,Ze,Xe,rt,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function pt(nt){const ut=nt.get(Ae.IExtHostInitDataService),Pt=nt.get(Ce.IExtHostFileSystemInfo),Nt=nt.get(X.IExtHostConsumerFileSystem),yt=nt.get(s.IExtHostExtensionService),ft=nt.get(ie.IExtHostWorkspace),Dt=nt.get(J.IExtHostTelemetry),At=nt.get(E.IExtHostConfiguration),Ft=nt.get(ve.IURITransformerService),Ke=nt.get(Te.IExtHostRpcService),zt=nt.get(U.IExtHostStorage),Rt=nt.get(K.IExtensionStoragePaths),Mt=nt.get(Re.ILoggerService),Pe=nt.get(Re.ILogService),Le=nt.get(ee.IExtHostTunnelService),we=nt.get(te.IExtHostApiDeprecationService),Z=nt.get(q.IExtHostWindow),Me=nt.get(Fe.IExtHostSecretState),xe=nt.get(Ye.IExtHostEditorTabs);Ke.set(y.ExtHostContext.ExtHostFileSystemInfo,Pt),Ke.set(y.ExtHostContext.ExtHostLogLevelServiceShape,Mt),Ke.set(y.ExtHostContext.ExtHostWorkspace,ft),Ke.set(y.ExtHostContext.ExtHostConfiguration,At),Ke.set(y.ExtHostContext.ExtHostExtensionService,yt),Ke.set(y.ExtHostContext.ExtHostStorage,zt),Ke.set(y.ExtHostContext.ExtHostTunnelService,Le),Ke.set(y.ExtHostContext.ExtHostWindow,Z),Ke.set(y.ExtHostContext.ExtHostSecretState,Me),Ke.set(y.ExtHostContext.ExtHostTelemetry,Dt),Ke.set(y.ExtHostContext.ExtHostEditorTabs,xe);const st=Ke.set(y.ExtHostContext.ExtHostDecorations,nt.get(ge.IExtHostDecorations)),Qe=Ke.set(y.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(r.IExtHostDocumentsAndEditors)),lt=Ke.set(y.ExtHostContext.ExtHostCommands,nt.get(v.IExtHostCommands)),dt=Ke.set(y.ExtHostContext.ExtHostTerminalService,nt.get(B.IExtHostTerminalService)),vt=Ke.set(y.ExtHostContext.ExtHostDebugService,nt.get(he.IExtHostDebugService)),_t=Ke.set(y.ExtHostContext.ExtHostSearch,nt.get(Se.IExtHostSearch)),mt=Ke.set(y.ExtHostContext.ExtHostTask,nt.get(ne.IExtHostTask)),wt=Ke.set(y.ExtHostContext.ExtHostOutputService,nt.get(S.IExtHostOutputService)),Lt=Ke.set(y.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Ke)),bt=Ke.set(y.ExtHostContext.ExtHostDocuments,new w.ExtHostDocuments(Ke,Qe)),Kt=Ke.set(y.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Ke,Qe,Pe)),Qt=Ke.set(y.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(Pe,bt,Ke.getProxy(y.MainContext.MainThreadBulkEdits))),Et=Ke.set(y.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Ke,lt,Qe,bt,Rt)),$t=Ke.set(y.ExtHostContext.ExtHostNotebookDocuments,new qe.ExtHostNotebookDocuments(Et)),Yt=Ke.set(y.ExtHostContext.ExtHostNotebookEditors,new He.ExtHostNotebookEditors(Pe,Ke,Et)),Jt=Ke.set(y.ExtHostContext.ExtHostNotebookKernels,new se.ExtHostNotebookKernels(Ke,ut,Et,lt,Pe)),ci=Ke.set(y.ExtHostContext.ExtHostNotebookProxyKernels,new tt.ExtHostNotebookProxyKernels(Ke,Jt,Pe)),ui=Ke.set(y.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers(Ke,Et)),kt=Ke.set(y.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Ke,Qe)),Zt=Ke.set(y.ExtHostContext.ExtHostTreeViews,new re.ExtHostTreeViews(Ke.getProxy(y.MainContext.MainThreadTreeViews),lt,Pe)),di=Ke.set(y.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Ke.getProxy(y.MainContext.MainThreadEditorInsets),kt,ut.remote)),Xt=Ke.set(y.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(Ke,Pe,Pt)),ei=Ke.set(y.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,bt,lt.converter,Ft)),ht=Ke.set(y.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ke,Ft,bt,lt,Xt,Pe,we)),hi=Ke.set(y.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ke,ht)),Bt=Ke.set(y.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ke,Pe,Qe)),xt=Ke.set(y.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,ft,lt)),ti=Ke.set(y.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(Ke,lt,Pe)),Ti=Ke.set(y.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Ke,lt,bt)),ii=Ke.set(y.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ke.getProxy(y.MainContext.MainThreadProgress))),fi=Ke.set(y.ExtHostContext.ExtHosLabelService,new ce.ExtHostLabelService(Ke)),Si=Ke.set(y.ExtHostContext.ExtHostTheming,new pe.ExtHostTheming(Ke)),ni=Ke.set(y.ExtHostContext.ExtHostAuthentication,new F.ExtHostAuthentication(Ke)),Pi=Ke.set(y.ExtHostContext.ExtHostTimeline,new $.ExtHostTimeline(Ke,lt)),mi=Ke.set(y.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,ut.remote,ft,Pe,we)),gi=Ke.set(y.ExtHostContext.ExtHostWebviewPanels,new oe.ExtHostWebviewPanels(Ke,mi,ft)),Ai=Ke.set(y.ExtHostContext.ExtHostCustomEditors,new Ee.ExtHostCustomEditors(Ke,bt,Rt,mi,gi)),pi=Ke.set(y.ExtHostContext.ExtHostWebviewViews,new me.ExtHostWebviewViews(Ke,mi)),Vt=Ke.set(y.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ke,lt)),Ri=Ke.set(y.ExtHostContext.ExtHostUriOpeners,new je.ExtHostUriOpeners(Ke));Ke.set(y.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(Ke,Et,Qe,lt));const Li=(0,Q.values)(y.ExtHostContext);Ke.assertRegistered(Li);const Oi=new De.ExtHostBulkEdits(Ke,Qe),ri=new m.ExtHostClipboard(Ke),vi=new c.ExtHostMessageService(Ke,Pe),_i=new l.ExtHostDialogs(Ke),Ci=new p.ExtHostStatusBar(Ke,lt.converter);return _.ExtHostApiCommands.register(lt),function(ze,Ut,yi){const gt=function(){let fe=!ze.isUnderDevelopment;function be(){fe||(Pe.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ot){if(Array.isArray(ot))ot.forEach(Be);else if(typeof ot=="string")be();else{const St=ot;typeof St.scheme=="undefined"&&be(),typeof St.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),jt={getSession(fe,be,Be){return ni.getSession(ze,fe,be,Be)},async hasSession(fe,be){return(0,Xe.checkProposedApiEnabled)(ze,"authSession"),!!await ni.getSession(ze,fe,be,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(fe,be,Be,ot){return ni.registerAuthenticationProvider(fe,be,Be,ot)}},Ni={registerCommand(fe,be,Be){return lt.registerCommand(!0,fe,be,Be,void 0,ze)},registerTextEditorCommand(fe,be,Be){return lt.registerCommand(!0,fe,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){Pe.warn("Cannot execute "+fe+" because there is no active text editor.");return}return St.edit(It=>{be.apply(Be,[St,It,...ot])}).then(It=>{It||Pe.warn("Edits from command "+fe+" were not applied.")},It=>{Pe.warn("An error occurred while running command "+fe,It)})},void 0,void 0,ze)},registerDiffInformationCommand:(fe,be,Be)=>((0,Xe.checkProposedApiEnabled)(ze,"diffCommand"),lt.registerCommand(!0,fe,async(...ot)=>{const St=Qe.activeEditor(!0);if(!St){Pe.warn("Cannot execute "+fe+" because there is no active text editor.");return}const It=await kt.getDiffInformation(St.id);be.apply(Be,[It,...ot])},void 0,void 0,ze)),executeCommand(fe,...be){return lt.executeCommand(fe,...be)},getCommands(fe=!1){return lt.getCommands(fe)}},Ot={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const fe=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(fe)?!1:fe<1e3*60*60*24},openExternal(fe,be){return Z.openUri(fe,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:be?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===ut.environment.appUriScheme)return Lt.createAppUri(fe);try{return await Z.asExternalUri(fe,{allowTunneling:!!ut.remote.authority})}catch(be){if((0,Ne.matchesScheme)(fe,ye.Schemas.http)||(0,Ne.matchesScheme)(fe,ye.Schemas.https))return fe;throw be}},get remoteName(){return(0,G.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(ze,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(Ot);const si={createTestController(fe,be,Be){return Vt.createTestController(fe,be,Be)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Vt.createTestObserver()},runTests(fe){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Vt.runTests(fe)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Vt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Vt.results}},oi=ut.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Fi={getExtension(fe,be){(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")||(be=!1);const Be=Ut.mine.getExtensionDescription(fe);if(Be)return new s.Extension(yt,ze.identifier,Be,oi,!1);if(be){const ot=Ut.all.getExtensionDescription(fe);if(ot)return new s.Extension(yt,ze.identifier,ot,oi,!0)}},get all(){const fe=[];for(const be of Ut.mine.getAllExtensionDescriptions())fe.push(new s.Extension(yt,ze.identifier,be,oi,!1));return fe},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(ze,"extensionsAny");const fe=new Xe.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),be=[];for(const Be of Ut.all.getAllExtensionDescriptions()){const ot=!fe.has(Be.identifier);be.push(new s.Extension(yt,ze.identifier,Be,oi,ot))}return be},get onDidChange(){return(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")?C.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},Mi={createDiagnosticCollection(fe){return Xt.createDiagnosticCollection(ze.identifier,fe)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:fe=>Xt.getDiagnostics(fe),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(fe,be){return ei.changeLanguage(fe.uri,be)},match(fe,be){const Be=bt.getDocumentData(be.uri)?.notebook;return(0,L.score)(H.LanguageSelector.from(fe),be.uri,be.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(fe,be,Be){return ht.registerCodeActionProvider(ze,gt(fe),be,Be)},registerCodeLensProvider(fe,be){return ht.registerCodeLensProvider(ze,gt(fe),be)},registerDefinitionProvider(fe,be){return ht.registerDefinitionProvider(ze,gt(fe),be)},registerDeclarationProvider(fe,be){return ht.registerDeclarationProvider(ze,gt(fe),be)},registerImplementationProvider(fe,be){return ht.registerImplementationProvider(ze,gt(fe),be)},registerTypeDefinitionProvider(fe,be){return ht.registerTypeDefinitionProvider(ze,gt(fe),be)},registerHoverProvider(fe,be){return ht.registerHoverProvider(ze,gt(fe),be,ze.identifier)},registerEvaluatableExpressionProvider(fe,be){return ht.registerEvaluatableExpressionProvider(ze,gt(fe),be,ze.identifier)},registerInlineValuesProvider(fe,be){return ht.registerInlineValuesProvider(ze,gt(fe),be,ze.identifier)},registerDocumentHighlightProvider(fe,be){return ht.registerDocumentHighlightProvider(ze,gt(fe),be)},registerLinkedEditingRangeProvider(fe,be){return ht.registerLinkedEditingRangeProvider(ze,gt(fe),be)},registerReferenceProvider(fe,be){return ht.registerReferenceProvider(ze,gt(fe),be)},registerRenameProvider(fe,be){return ht.registerRenameProvider(ze,gt(fe),be)},registerDocumentSymbolProvider(fe,be,Be){return ht.registerDocumentSymbolProvider(ze,gt(fe),be,Be)},registerWorkspaceSymbolProvider(fe){return ht.registerWorkspaceSymbolProvider(ze,fe)},registerDocumentFormattingEditProvider(fe,be){return ht.registerDocumentFormattingEditProvider(ze,gt(fe),be)},registerDocumentRangeFormattingEditProvider(fe,be){return ht.registerDocumentRangeFormattingEditProvider(ze,gt(fe),be)},registerOnTypeFormattingEditProvider(fe,be,Be,...ot){return ht.registerOnTypeFormattingEditProvider(ze,gt(fe),be,[Be].concat(ot))},registerDocumentSemanticTokensProvider(fe,be,Be){return ht.registerDocumentSemanticTokensProvider(ze,gt(fe),be,Be)},registerDocumentRangeSemanticTokensProvider(fe,be,Be){return ht.registerDocumentRangeSemanticTokensProvider(ze,gt(fe),be,Be)},registerSignatureHelpProvider(fe,be,Be,...ot){return typeof Be=="object"?ht.registerSignatureHelpProvider(ze,gt(fe),be,Be):ht.registerSignatureHelpProvider(ze,gt(fe),be,typeof Be=="undefined"?[]:[Be,...ot])},registerCompletionItemProvider(fe,be,...Be){return ht.registerCompletionItemProvider(ze,gt(fe),be,Be)},registerInlineCompletionItemProvider(fe,be){return(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletions"),be.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,gt(fe),be)},registerInlineCompletionItemProviderNew(fe,be){if((0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsNew"),be.handleDidShowCompletionItem&&!(0,Xe.isProposedApiEnabled)(ze,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ht.registerInlineCompletionsProviderNew(ze,gt(fe),be)},registerDocumentLinkProvider(fe,be){return ht.registerDocumentLinkProvider(ze,gt(fe),be)},registerColorProvider(fe,be){return ht.registerColorProvider(ze,gt(fe),be)},registerFoldingRangeProvider(fe,be){return ht.registerFoldingRangeProvider(ze,gt(fe),be)},registerSelectionRangeProvider(fe,be){return ht.registerSelectionRangeProvider(ze,fe,be)},registerCallHierarchyProvider(fe,be){return ht.registerCallHierarchyProvider(ze,fe,be)},registerTypeHierarchyProvider(fe,be){return ht.registerTypeHierarchyProvider(ze,fe,be)},setLanguageConfiguration:(fe,be)=>ht.setLanguageConfiguration(ze,fe,be),getTokenInformationAtPosition(fe,be){return(0,Xe.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(fe,be)},registerInlayHintsProvider(fe,be){return ht.registerInlayHintsProvider(ze,fe,be)},createLanguageStatusItem(fe,be){return ei.createLanguageStatusItem(ze,fe,be)},registerDocumentOnDropProvider(fe,be){return(0,Xe.checkProposedApiEnabled)(ze,"textEditorDrop"),ht.registerDocumentOnDropProvider(ze,fe,be)}},Ui={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(fe,be,Be){const ot=await(I.URI.isUri(fe)?Promise.resolve(Di.openTextDocument(fe)):Promise.resolve(fe));return kt.showTextDocument(ot,be,Be)},createTextEditorDecorationType(fe){return kt.createTextEditorDecorationType(ze,fe)},onDidChangeActiveTextEditor(fe,be,Be){return kt.onDidChangeActiveTextEditor(fe,be,Be)},onDidChangeVisibleTextEditors(fe,be,Be){return kt.onDidChangeVisibleTextEditors(fe,be,Be)},onDidChangeTextEditorSelection(fe,be,Be){return kt.onDidChangeTextEditorSelection(fe,be,Be)},onDidChangeTextEditorOptions(fe,be,Be){return kt.onDidChangeTextEditorOptions(fe,be,Be)},onDidChangeTextEditorVisibleRanges(fe,be,Be){return kt.onDidChangeTextEditorVisibleRanges(fe,be,Be)},onDidChangeTextEditorViewColumn(fe,be,Be){return kt.onDidChangeTextEditorViewColumn(fe,be,Be)},onDidCloseTerminal(fe,be,Be){return dt.onDidCloseTerminal(fe,be,Be)},onDidOpenTerminal(fe,be,Be){return dt.onDidOpenTerminal(fe,be,Be)},onDidChangeActiveTerminal(fe,be,Be){return dt.onDidChangeActiveTerminal(fe,be,Be)},onDidChangeTerminalDimensions(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(fe,be,Be)},onDidChangeTerminalState(fe,be,Be){return dt.onDidChangeTerminalState(fe,be,Be)},onDidWriteTerminalData(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(fe,be,Be)},get state(){return Z.state},onDidChangeWindowState(fe,be,Be){return Z.onDidChangeWindowState(fe,be,Be)},showInformationMessage(fe,...be){return vi.showMessage(ze,P.default.Info,fe,be[0],be.slice(1))},showWarningMessage(fe,...be){return vi.showMessage(ze,P.default.Warning,fe,be[0],be.slice(1))},showErrorMessage(fe,...be){return vi.showMessage(ze,P.default.Error,fe,be[0],be.slice(1))},showQuickPick(fe,be,Be){return xt.showQuickPick(fe,be,Be)},showWorkspaceFolderPick(fe){return xt.showWorkspaceFolderPick(fe)},showInputBox(fe,be){return xt.showInput(fe,be)},showOpenDialog(fe){return _i.showOpenDialog(fe)},showSaveDialog(fe){return _i.showSaveDialog(fe)},createStatusBarItem(fe,be,Be){let ot,St,It;return typeof fe=="string"?(ot=fe,St=be,It=Be):(St=fe,It=be),Ci.createStatusBarEntry(ze,ot,St,It)},setStatusBarMessage(fe,be){return Ci.setStatusBarMessage(fe,be)},withScmProgress(fe){return we.report("window.withScmProgress",ze,"Use 'withProgress' instead."),ii.withProgress(ze,{location:M.ProgressLocation.SourceControl},(be,Be)=>fe({report(ot){}}))},withProgress(fe,be){return ii.withProgress(ze,fe,be)},createOutputChannel(fe,be){return wt.createOutputChannel(fe,be,ze)},createWebviewPanel(fe,be,Be,ot){return gi.createWebviewPanel(ze,fe,be,Be,ot)},createWebviewTextEditorInset(fe,be,Be,ot){return(0,Xe.checkProposedApiEnabled)(ze,"editorInsets"),di.createWebviewEditorInset(fe,be,Be,ot,ze)},createTerminal(fe,be,Be){return typeof fe=="object"?"pty"in fe?dt.createExtensionTerminal(fe):dt.createTerminalFromOptions(fe):dt.createTerminal(fe,be,Be)},registerTerminalLinkProvider(fe){return dt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,be){return dt.registerProfileProvider(ze,fe,be)},registerTreeDataProvider(fe,be){return Zt.registerTreeDataProvider(fe,be,ze)},createTreeView(fe,be){return Zt.createTreeView(fe,be,ze)},registerWebviewPanelSerializer:(fe,be)=>gi.registerWebviewPanelSerializer(ze,fe,be),registerCustomEditorProvider:(fe,be,Be={})=>Ai.registerCustomEditorProvider(ze,fe,be,Be),registerFileDecorationProvider(fe){return st.registerFileDecorationProvider(fe,ze.identifier)},registerUriHandler(fe){return Lt.registerUriHandler(ze.identifier,fe)},createQuickPick(){return xt.createQuickPick(ze)},createInputBox(){return xt.createInputBox(ze)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(fe,be,Be){return Si.onDidChangeActiveColorTheme(fe,be,Be)},registerWebviewViewProvider(fe,be,Be){return pi.registerWebviewViewProvider(ze,fe,be,Be?.webviewOptions)},get activeNotebookEditor(){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(fe,be,Be)},get visibleNotebookEditors(){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(fe,be,Be)},onDidChangeNotebookEditorVisibleRanges(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(fe,be,Be)},showNotebookDocument(fe,be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditor"),Et.showNotebookDocument(fe,be)},registerExternalUriOpener(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"externalUriOpener"),Ri.registerExternalUriOpener(ze.identifier,fe,be,Be)},get tabGroups(){return xe.tabGroups}},Di={get rootPath(){return we.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(fe){throw i.readonly()},getWorkspaceFolder(fe){return ft.getWorkspaceFolder(fe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(fe){throw i.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(fe){throw i.readonly()},updateWorkspaceFolders:(fe,be,...Be)=>ft.updateWorkspaceFolders(ze,fe,be||0,...Be),onDidChangeWorkspaceFolders:function(fe,be,Be){return ft.onDidChangeWorkspace(fe,be,Be)},asRelativePath:(fe,be)=>ft.getRelativePath(fe,be),findFiles:(fe,be,Be,ot)=>ft.findFiles(fe,be,Be,ze.identifier,ot),findTextInFiles:(fe,be,Be,ot)=>{(0,Xe.checkProposedApiEnabled)(ze,"findTextInFiles");let St,It;return typeof be=="object"?(St=be,It=Be):(St={},It=be,ot=Be),ft.findTextInFiles(fe,St||{},It,ze.identifier,ot)},saveAll:fe=>ft.saveAll(fe),applyEdit(fe){return Oi.applyWorkspaceEdit(fe)},createFileSystemWatcher:(fe,be,Be,ot)=>Bt.createFileSystemWatcher(ft,ze,fe,be,Be,ot),get textDocuments(){return bt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw i.readonly()},openTextDocument(fe){let be;const Be=fe;if(typeof fe=="string")be=Promise.resolve(I.URI.file(fe));else if(I.URI.isUri(fe))be=Promise.resolve(fe);else if(!Be||typeof Be=="object")be=bt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return be.then(ot=>bt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(fe,be,Be)=>bt.onDidAddDocument(fe,be,Be),onDidCloseTextDocument:(fe,be,Be)=>bt.onDidRemoveDocument(fe,be,Be),onDidChangeTextDocument:(fe,be,Be)=>bt.onDidChangeDocument(fe,be,Be),onDidSaveTextDocument:(fe,be,Be)=>bt.onDidSaveDocument(fe,be,Be),onWillSaveTextDocument:(fe,be,Be)=>Qt.getOnWillSaveTextDocumentEvent(ze)(fe,be,Be),get notebookDocuments(){return Et.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,be){let Be;if(I.URI.isUri(fe))Be=fe,await Et.openNotebookDocument(fe);else if(typeof fe=="string")Be=I.URI.revive(await Et.createNotebookDocument({viewType:fe,content:be}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,be,Be){return $t.onDidSaveNotebookDocument(fe,be,Be)},onDidChangeNotebookDocument(fe,be,Be){return $t.onDidChangeNotebookDocument(fe,be,Be)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(fe,be,Be,ot){return Et.registerNotebookSerializer(ze,fe,be,Be,(0,Xe.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(fe,be,Be,ot)=>((0,Xe.checkProposedApiEnabled)(ze,"notebookContentProvider"),Et.registerNotebookContentProvider(ze,fe,be,Be,(0,Xe.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(fe,be,Be)=>yi.onDidChangeConfiguration(fe,be,Be),getConfiguration(fe,be){return be=arguments.length===1?void 0:be,yi.getConfiguration(fe,be,ze)},registerTextDocumentContentProvider(fe,be){return Kt.registerTextDocumentContentProvider(fe,be)},registerTaskProvider:(fe,be)=>(we.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(ze,fe,be)),registerFileSystemProvider(fe,be,Be){return(0,Ze.combinedDisposable)(hi.registerFileSystemProvider(ze,fe,be,Be),Nt.addFileSystemProvider(fe,be))},get fs(){return Nt.value},registerFileSearchProvider:(fe,be)=>((0,Xe.checkProposedApiEnabled)(ze,"fileSearchProvider"),_t.registerFileSearchProvider(fe,be)),registerTextSearchProvider:(fe,be)=>((0,Xe.checkProposedApiEnabled)(ze,"textSearchProvider"),_t.registerTextSearchProvider(fe,be)),registerRemoteAuthorityResolver:(fe,be)=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),yt.registerRemoteAuthorityResolver(fe,be)),registerResourceLabelFormatter:fe=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),fi.$registerResourceLabelFormatter(fe)),onDidCreateFiles:(fe,be,Be)=>Bt.onDidCreateFile(fe,be,Be),onDidDeleteFiles:(fe,be,Be)=>Bt.onDidDeleteFile(fe,be,Be),onDidRenameFiles:(fe,be,Be)=>Bt.onDidRenameFile(fe,be,Be),onWillCreateFiles:(fe,be,Be)=>Bt.getOnWillCreateFileEvent(ze)(fe,be,Be),onWillDeleteFiles:(fe,be,Be)=>Bt.getOnWillDeleteFileEvent(ze)(fe,be,Be),onWillRenameFiles:(fe,be,Be)=>Bt.getOnWillRenameFileEvent(ze)(fe,be,Be),openTunnel:fe=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Le.openTunnel(ze,fe).then(be=>{if(!be)throw new Error("cannot open tunnel");return be})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(fe,be,Be)=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Le.onDidChangeTunnels(fe,be,Be)),registerPortAttributesProvider:(fe,be)=>((0,Xe.checkProposedApiEnabled)(ze,"portsAttributes"),Le.registerPortsAttributesProvider(fe,be)),registerTimelineProvider:(fe,be)=>((0,Xe.checkProposedApiEnabled)(ze,"timeline"),Pi.registerTimelineProvider(fe,be,ze.identifier,lt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:fe=>((0,Xe.checkProposedApiEnabled)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,be,Be)=>ft.onDidGrantWorkspaceTrust(fe,be,Be)},Bi={get inputBox(){return we.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ti.getLastInputBox(ze)},createSourceControl(fe,be,Be){return ti.createSourceControl(ze,fe,be,Be)}},Wi={createCommentController(fe,be){return Ti.createCommentController(ze,fe,be)}},wi={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(fe,be,Be){return vt.onDidStartDebugSession(fe,be,Be)},onDidTerminateDebugSession(fe,be,Be){return vt.onDidTerminateDebugSession(fe,be,Be)},onDidChangeActiveDebugSession(fe,be,Be){return vt.onDidChangeActiveDebugSession(fe,be,Be)},onDidReceiveDebugSessionCustomEvent(fe,be,Be){return vt.onDidReceiveDebugSessionCustomEvent(fe,be,Be)},onDidChangeBreakpoints(fe,be,Be){return vt.onDidChangeBreakpoints(fe,be,Be)},registerDebugConfigurationProvider(fe,be,Be){return vt.registerDebugConfigurationProvider(fe,be,Be||rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,be){return vt.registerDebugAdapterDescriptorFactory(ze,fe,be)},registerDebugAdapterTrackerFactory(fe,be){return vt.registerDebugAdapterTrackerFactory(fe,be)},startDebugging(fe,be,Be){return!Be||typeof Be=="object"&&"configuration"in Be?vt.startDebugging(fe,be,{parentSession:Be}):vt.startDebugging(fe,be,Be||{})},stopDebugging(fe){return vt.stopDebugging(fe)},addBreakpoints(fe){return vt.addBreakpoints(fe)},removeBreakpoints(fe){return vt.removeBreakpoints(fe)},asDebugSourceUri(fe,be){return vt.asDebugSourceUri(fe,be)}},zi={registerTaskProvider:(fe,be)=>mt.registerTaskProvider(ze,fe,be),fetchTasks:fe=>mt.fetchTasks(fe),executeTask:fe=>mt.executeTask(ze,fe),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(fe,be,Be)=>mt.onDidStartTask(fe,be,Be),onDidEndTask:(fe,be,Be)=>mt.onDidEndTask(fe,be,Be),onDidStartTaskProcess:(fe,be,Be)=>mt.onDidStartTaskProcess(fe,be,Be),onDidEndTaskProcess:(fe,be,Be)=>mt.onDidEndTaskProcess(fe,be,Be)},Hi={createNotebookController(fe,be,Be,ot,St){return Jt.createNotebookController(ze,fe,be,Be,ot,(0,Xe.isProposedApiEnabled)(ze,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(fe,be)=>Et.registerNotebookCellStatusBarItemProvider(ze,fe,be),createNotebookEditorDecorationType(fe){return(0,Xe.checkProposedApiEnabled)(ze,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(fe)},createRendererMessaging(fe){return ui.createRendererMessaging(ze,fe)},onDidChangeNotebookCellExecutionState(fe,be,Be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(fe,be,Be)},createNotebookProxyController(fe,be,Be,ot){return(0,Xe.checkProposedApiEnabled)(ze,"notebookProxyController"),ci.createNotebookProxyController(ze,fe,be,Be,ot)}};return{version:ut.version,authentication:jt,commands:Ni,comments:Wi,debug:wi,env:Ot,extensions:Fi,languages:Mi,notebooks:Hi,scm:Bi,tasks:zi,tests:si,window:Ui,workspace:Di,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:y.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CommentThreadState:M.CommentThreadState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:M.InlineCompletionTriggerKindNew,EventEmitter:C.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionItemNew:M.InlineSuggestionNew,InlineCompletionList:M.InlineSuggestionList,InlineCompletionListNew:M.InlineSuggestionsNew,Hover:M.Hover,IndentAction:A.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SnippetTextEdit:M.SnippetTextEdit,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:T.UIKind,Uri:I.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintLabelPart:M.InlayHintLabelPart,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:_e.TextSearchCompleteMessageType,DataTransfer:M.DataTransfer,DataTransferItem:M.DataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind,InputBoxValidationSeverity:M.InputBoxValidationSeverity,TabInputText:M.TextTabInput,TabInputTextDiff:M.TextDiffTabInput,TabInputCustom:M.CustomEditorTabInput,TabInputNotebook:M.NotebookEditorTabInput,TabInputNotebookDiff:M.NotebookDiffEditorTabInput,TabInputWebview:M.WebviewEditorTabInput,TabInputTerminal:M.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=pt}),define(Ie[285],ke([1,0,286,296,297,2,298]),function(Y,e,d,i,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(k,y,T,_,m,v){const g=v.environment.useHostProxy,E=typeof g=="boolean"?g:!v.remote.isRemote,h=(0,I.createProxyResolver)({resolveProxy:f=>k.resolveProxy(f),getHttpProxySetting:()=>y.getConfiguration("http").get("proxy"),log:(f,o,...w)=>{switch(f){case I.LogLevel.Trace:_.trace(o,...w);break;case I.LogLevel.Debug:_.debug(o,...w);break;case I.LogLevel.Info:_.info(o,...w);break;case I.LogLevel.Warning:_.warn(o,...w);break;case I.LogLevel.Error:_.error(o,...w);break;case I.LogLevel.Critical:_.critical(o,...w);break;case I.LogLevel.Off:break;default:r(f,o,w);break}function r(s,n,...t){_.error("Unknown log level",s),_.error(n,...t)}},getLogLevel:()=>_.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:E,env:process.env}),l=b(y,h);return L(T,l)}e.connectProxyResolver=D;function b(k,y){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(m=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const _={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(m=>{_.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},d,(0,I.createHttpPatch)(d,y,{config:"off"},_,!0)),on:Object.assign({},d,(0,I.createHttpPatch)(d,y,{config:"on"},_,!0)),override:Object.assign({},d,(0,I.createHttpPatch)(d,y,{config:"override"},_,!0)),onRequest:Object.assign({},d,(0,I.createHttpPatch)(d,y,T,_,!0)),default:Object.assign(d,(0,I.createHttpPatch)(d,y,T,_,!1))},https:{off:Object.assign({},i,(0,I.createHttpPatch)(i,y,{config:"off"},_,!0)),on:Object.assign({},i,(0,I.createHttpPatch)(i,y,{config:"on"},_,!0)),override:Object.assign({},i,(0,I.createHttpPatch)(i,y,{config:"override"},_,!0)),onRequest:Object.assign({},i,(0,I.createHttpPatch)(i,y,T,_,!0)),default:Object.assign(i,(0,I.createHttpPatch)(i,y,T,_,!1))},tls:Object.assign(C,(0,I.createTlsPatch)(C))}}const A=new Map;function L(k,y){return k.getExtensionPathIndex().then(T=>{const _=Y.__$__nodeRequire("module"),m=_._load;_._load=function(g,E,h){if(g==="tls")return y.tls;if(g!=="http"&&g!=="https")return m.apply(this,arguments);const l=y[g],f=T.findSubstr(P.URI.file(E.filename));let o=A.get(f);if(o||A.set(f,o={}),!o[g]){let w=l.default;o[g]={...w}}return o[g]}})}}),define(Ie[142],ke([1,0,41,299,104,16,56,34,9,8,2,31,72,300,279,91]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=_.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(c){this.outputChannel=c}provideTextSearchResults(c,S,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((N,p)=>{O.onCancellationRequested(()=>V());const U=w(c,S),B=S.folder.fsPath,z=U.map(ce=>ce.match(/^-/)?ce:`'${ce}'`).join(" ");this.outputChannel.appendLine(`${v} ${z}
 - cwd: ${B}`);let re=d.spawn(v,U,{cwd:B});re.on("error",ce=>{console.error(ce),this.outputChannel.appendLine("Error: "+(ce&&ce.message)),p((0,k.serializeSearchError)(new k.SearchError(ce&&ce.message,k.SearchErrorCode.rgProcessError)))});let H=!1;const M=new l(S.maxResults,B,S.previewOptions);M.on("result",ce=>{H=!0,ie="",R.report(ce)});let j=!1;const V=()=>{j=!0,re&&re.kill(),M&&M.cancel()};let q=!1;M.on("hitLimit",()=>{q=!0,V()});let ie="";re.stdout.on("data",ce=>{M.handleData(ce),H||(ie+=ce)});let Q=!1;re.stdout.once("data",()=>Q=!0);let ue="";re.stderr.on("data",ce=>{const G=ce.toString();this.outputChannel.appendLine(G),ue+=G}),re.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(H?"Got result from parser":"No result from parser"),ie&&this.outputChannel.appendLine(`Got data without result: ${ie}`),this.outputChannel.appendLine(""),j)N({limitHit:q});else{M.flush(),re=null;let ce;ue&&!Q&&(ce=E(ue))?p((0,k.serializeSearchError)(new k.SearchError(ce.message,ce.code))):N({limitHit:q})}})})}}e.RipgrepTextSearchEngine=g;function E(u){const c=u.split(`
`),S=c[0].trim();if(c.some(O=>O.startsWith("regex parse error")))return new k.SearchError(h(c),k.SearchErrorCode.regexParseError);const R=S.match(/grep config error: unknown encoding: (.*)/);if(R)return new k.SearchError(`Unknown encoding: ${R[1]}`,k.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(S,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function h(u){const c=["Regex parse error"],S=u.filter(R=>R.startsWith("PCRE2:"));if(S.length>=1){const R=S[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];c.push(":"+O)}}return c.join("")}e.buildRegexParseError=h;class l extends i.EventEmitter{constructor(c,S,R){super();this.maxResults=c,this.rootFolder=S,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(c,S){return super.on(c,S),this}handleData(c){if(this.isDone)return;const S=typeof c=="string"?c:this.stringDecoder.write(c);this.handleDecodedData(S)}handleDecodedData(c){let S=c.indexOf(`
`);const R=this.remainder+c;if(S>=0)S+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;S>=0;)this.handleLine(R.substring(O,S).trim()),O=S+1,S=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(c){if(this.isDone||!c)return;let S;try{S=JSON.parse(c)}catch{throw new Error(`malformed line from rg: ${c}`)}if(S.type==="match"){const R=f(S.data.path),O=L.URI.file(b.join(this.rootFolder,R)),N=this.createTextSearchMatch(S.data,O);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const R=f(S.data.path),O=L.URI.file(b.join(this.rootFolder,R));this.createTextSearchContext(S.data,O).forEach(p=>this.onResult(p))}}createTextSearchMatch(c,S){const R=c.line_number-1,O=f(c.lines),N=Buffer.from(O);let p=0,U=0,B=R;c.submatches.length===0&&c.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const z=(0,P.coalesce)(c.submatches.map((re,H)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const M=f(re.match),j=N.slice(p,re.start).toString().length,V=U+j,q=o(M),ie=B,Q=q.numLines+ie,ue=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return p=re.end,U=ue,B=Q,new y.Range(ie,V,Q,ue)}));return(0,m.createTextSearchResult)(S,O,z,this.previewOptions)}createTextSearchContext(c,S){const R=f(c.lines),O=c.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((N,p)=>({text:N,uri:S,lineNumber:O+p}))}onResult(c){this.emit("result",c)}}e.RipgrepParser=l;function f(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function o(u){const c=/\n/g;let S=0,R=-1,O;for(;O=c.exec(u);)S++,R=O.index;const N=R>=0?u.length-R-1:u.length;return{numLines:S,lastLineLength:N}}function w(u,c){const S=["--hidden"];S.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,I.groupBy)(c.includes,p=>p.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const p=new Set;O.forEach(U=>{p.add(U)}),S.push("-g","!*"),p.forEach(U=>{r(U).map(m.anchorGlob).forEach(B=>{S.push("-g",B)})})}R&&R.length&&R.forEach(p=>{S.push("-g",p)}),c.excludes.map(m.anchorGlob).forEach(p=>S.push("-g",`!${p}`)),c.maxFileSize&&S.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?c.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),c.followSymlinks&&S.push("--follow"),c.encoding&&c.encoding!=="utf8"&&S.push("--encoding",c.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,A.escapeRegExpCharacters)(u.pattern),u.isRegExp=!0),c.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),u.isRegExp&&(u.pattern=s(u.pattern),S.push("--engine","auto"));let N;if(u.isWordMatch){const U=(0,A.createRegExp)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",U)}else if(u.isRegExp){let p=t(u.pattern);p=a(p),S.push("--regexp",p)}else N=u.pattern,S.push("--fixed-strings");return S.push("--no-config"),c.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),u.isMultiline&&S.push("--multiline"),c.beforeContext&&S.push("--before-context",c.beforeContext+""),c.afterContext&&S.push("--after-context",c.afterContext+""),S.push("--"),N&&S.push(N),S.push("."),S}function r(u){const c=(0,D.splitGlobAware)(u,"/");return c.map((S,R)=>c.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function s(u){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(c);)u=u.replace(c,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(S);)u=u.replace(S,"$1\\x{$2}");return u}e.unicodeEscapesToPCRE2=s;const n=u=>u.type==="Assertion"&&u.kind==="lookbehind";function t(u){let c;try{c=new T.RegExpParser().parsePattern(u)}catch{return u}let S="",R=0;const O=(U,B,z)=>{S+=u.slice(R,U)+z,R=B},N=[];return new T.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const B=N[0];if(!B)O(U.start,U.end,"\\r?\\n");else if(!N.some(n))if(B.type==="CharacterClass")if(B.negate){const z=u.slice(B.start+2,U.start)+u.slice(U.end,B.end-1);B.parent?.type==="Quantifier"?O(B.start,B.end,z?`[^${z}]`:"."):O(B.start,B.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=u.slice(B.start+1,U.start)+u.slice(U.end,B.end-1);O(B.start,B.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else B.type==="Quantifier"&&O(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){N.unshift(U)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(U){N.unshift(U)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(U){N.unshift(U)},onCharacterClassLeave(){N.shift()},onAssertionEnter(U){n(U)&&N.push(U)},onAssertionLeave(U){N[0]===U&&N.shift()}}).visit(c),S+=u.slice(R),S}e.fixRegexNewline=t;function a(u){return u.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(Ie[287],ke([1,0,21,142,118,10]),function(Y,e,d,i,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,L,k,y){const T=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===P.Schemas.vscodeUserData){const _={...L,folder:L.folder.with({scheme:P.Schemas.file})},m=new C.Progress(v=>k.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(y,v=>T.provideTextSearchResults(A,_,m,v))}else return this.withToken(y,_=>T.provideTextSearchResults(A,L,k,_))}async withToken(A,L){const k=D(A);this.inProgress.add(k);const y=await L(k.token);return this.inProgress.delete(k),y}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=I;function D(b){const A=new d.CancellationTokenSource;return b.onCancellationRequested(()=>A.cancel()),A}}),define(Ie[288],ke([1,0,29,142,141]),function(Y,e,d,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(b){this.query=b}search(b,A,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){L({message:T})}},y=new C.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(k),d);return new Promise((T,_)=>y.search(m=>{A(m.map(I))},b).then(m=>T({limitHit:m.limitHit,type:"success",stats:m.stats}),_))}}e.TextSearchEngineAdapter=P;function I(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((b,A)=>{if(A.ranges){const L=A;return b+(Array.isArray(L.ranges)?L.ranges.length:1)}else return b+1},0)}}}),define(Ie[289],ke([1,0,16,17,11,3,100,9,48,2,42,31,280,288]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{constructor(l="searchProcess"){this.processType=l,this.caches=Object.create(null)}fileSearch(l){let f;const o=g(l),w=new P.Emitter({onFirstListenerDidAdd:()=>{f=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(y.Engine,o,s=>w.fire(s),r)),f.then(r=>w.fire(r),r=>w.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return w.event}textSearch(l){let f;const o=g(l),w=new P.Emitter({onFirstListenerDidAdd:()=>{f=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(o,s=>w.fire(s),r)),f.then(r=>w.fire(r),r=>w.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return w.event}ripgrepTextSearch(l,f,o){return l.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(l).search(o,f,f)}doFileSearch(l,f,o){return this.doFileSearchWithEngine(y.Engine,l,f,o)}doFileSearchWithEngine(l,f,o,w,r=_.BATCH_SIZE){let s=0;const n=a=>{Array.isArray(a)?(s+=a.length,o(a.map(u=>this.rawMatchToSearchItem(u)))):a.relativePath?(s++,o(this.rawMatchToSearchItem(a))):o(a)};if(f.sortByScore){let a=this.trySortedSearchFromCache(f,n,w);if(!a){const u=f.maxResults?Object.assign({},f,{maxResults:null}):f,c=new l(u);a=this.doSortedSearch(c,f,o,n,w)}return new Promise((u,c)=>{a.then(([S,R])=>{const O=R.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(O,o,r),u(S)},c)})}const t=new l(f);return this.doSearch(t,n,r,w).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(l){return{path:l.base?(0,D.join)(l.base,l.relativePath):l.relativePath}}doSortedSearch(l,f,o,w,r){const s=new P.Emitter;let n=(0,i.createCancelablePromise)(a=>{let u=[];const c=S=>{Array.isArray(S)?u=S:(w(S),s.fire(S))};return this.doSearch(l,c,-1,a).then(S=>[S,u])}),t;if(f.cacheKey){t=this.getOrCreateCache(f.cacheKey);const a={promise:n,event:s.event,resolved:!1};t.resultsToSearchCache[f.filePattern||""]=a,n.then(()=>{a.resolved=!0},u=>{delete t.resultsToSearchCache[f.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([a,u])=>{const c=t?t.scorerCache:Object.create(null),S=(typeof f.maxResults!="number"||f.maxResults>0)&&b.StopWatch.create(!1);return this.sortResults(f,u,c,r).then(R=>{const O=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:R.length},messages:a.messages,limitHit:a.limitHit||typeof f.maxResults=="number"&&u.length>f.maxResults},R]})})}getOrCreateCache(l){const f=this.caches[l];return f||(this.caches[l]=new m)}trySortedSearchFromCache(l,f,o){const w=l.cacheKey&&this.caches[l.cacheKey];if(!w)return;const r=this.getResultsFromCache(w,l.filePattern||"",f,o);if(r)return r.then(([s,n,t])=>{const a=b.StopWatch.create(!1);return this.sortResults(l,n,w.scorerCache,o).then(u=>{const c=a.elapsed(),S={fromCache:!0,detailStats:t,type:this.processType,resultCount:n.length,sortingTime:c};return[{type:"success",limitHit:s.limitHit||typeof l.maxResults=="number"&&n.length>l.maxResults,stats:S},u]})})}sortResults(l,f,o,w){const r=(0,I.prepareQuery)(l.filePattern||""),s=(t,a)=>(0,I.compareItemsByFuzzyScore)(t,a,r,!0,v,o),n=typeof l.maxResults=="number"?l.maxResults:Number.MAX_VALUE;return d.topAsync(f,s,n,1e4,w)}sendProgress(l,f,o){if(o&&o>0)for(let w=0;w<l.length;w+=o)f(l.slice(w,w+o));else f(l)}getResultsFromCache(l,f,o,w){const r=b.StopWatch.create(!1),s=f.indexOf(D.sep)>=0;let n;for(const c in l.resultsToSearchCache)if(f.startsWith(c)){if(s&&c.indexOf(D.sep)<0&&c!=="")continue;const S=l.resultsToSearchCache[c];n={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!n)return null;const t=r.elapsed(),a=b.StopWatch.create(!1),u=n.event(o);return w&&w.onCancellationRequested(()=>{u.dispose()}),n.promise.then(([c,S])=>{if(w&&w.isCancellationRequested)throw(0,C.canceled)();const R=[],O=(0,I.prepareQuery)(f).normalizedLowercase;for(const N of S)!(0,k.isFilePatternMatch)(N,O)||R.push(N);return[c,R,{cacheWasResolved:n.resolved,cacheLookupTime:t,cacheFilterTime:a.elapsed(),cacheEntryCount:S.length}]})}doSearch(l,f,o,w){return new Promise((r,s)=>{let n=[];w&&w.onCancellationRequested(()=>l.cancel()),l.search(t=>{t&&(o?(n.push(t),o>0&&n.length>=o&&(f(n),n=[])):f(t))},t=>{f(t)},(t,a)=>{n.length&&f(n),t?s(t):r(a)})})}clearCache(l){return delete this.caches[l],Promise.resolve(void 0)}preventCancellation(l){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,o){return l.then(f,o)}catch(f){return this.then(void 0,f)}finally(f){return l.finally(f)}}}}e.SearchService=_,_.BATCH_SIZE=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(h){return(0,D.basename)(h.relativePath)}getItemDescription(h){return(0,D.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function g(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(l=>A.URI.revive(l))}}function E(h){return{...h,folder:A.URI.revive(h.folder)}}}),define(Ie[290],ke([1,0,6,10,2,29,13,27,18,76,65,31,289,287,91,141]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends A.ExtHostSearch{constructor(E,h,l,f){super(E,l,f);this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new _.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.vscodeUserData,new T.RipgrepSearchProvider(o)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new _.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new T.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(i.Schemas.file,new y.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,h){const l=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,d.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,h,l,f){const o=(0,A.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,h,o,f):super.$provideFileSearchResults(E,h,l,f)}doInternalFileSearch(E,h,l,f){const o=w=>{if((0,k.isSerializedFileMatch)(w)&&(w=[w]),Array.isArray(w)){this._proxy.$handleFileMatch(E,h,w.map(r=>C.URI.file(r.path)));return}w.message&&this._logService.debug("ExtHostSearch",w.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,o,f)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,h){return new m.NativeTextSearchManager(E,h,void 0,"textSearchProvider")}};v=Ve([$e(0,b.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,L.IURITransformerService),$e(3,I.ILogService)],v),e.NativeExtHostSearch=v}),define(Ie[143],ke([1,0,301,127,62,23,11,3,6,9,12,35,106,107,302]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(S,R=""){this.debugLabel=R,this.socket=S,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,I.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(S,R){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const R=O=>{this.traceSocketEvent("read",O),S(P.VSBuffer.wrap(O))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(S){const R=O=>{this.traceSocketEvent("close",{hadError:O}),S({type:0,hadError:O,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(S){const R=()=>{this.traceSocketEvent("nodeEndReceived"),S()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(S){if(!this.socket.destroyed)try{this.traceSocketEvent("write",S),this.socket.write(S.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,I.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,I.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((S,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),S();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),S()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=m;var v;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var g;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(g||(g={}));class E extends b.Disposable{constructor(S,R,O,N){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new h(this,R,O,N,this._onData,(p,U)=>this._write(p,U))),this._register(this._flowManager.onError(p=>{console.error(p),(0,I.onUnexpectedError)(p),this._onClose.fire({type:0,hadError:!0,error:p})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(p=>this._acceptChunk(p))),this._register(this.socket.onClose(p=>this._onClose.fire(p)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(S,R){this.socket.traceSocketEvent(S,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._flowManager.writeMessage(S)}_write(S,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",S);let O=2;S.byteLength<126?O+=0:S.byteLength<2**16?O+=2:O+=8;const N=P.VSBuffer.alloc(O);if(R?N.writeUInt8(194,0):N.writeUInt8(130,0),S.byteLength<126)N.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){N.writeUInt8(126,1);let p=1;N.writeUInt8(S.byteLength>>>8&255,++p),N.writeUInt8(S.byteLength>>>0&255,++p)}else{N.writeUInt8(127,1);let p=1;N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(0,++p),N.writeUInt8(S.byteLength>>>24&255,++p),N.writeUInt8(S.byteLength>>>16&255,++p),N.writeUInt8(S.byteLength>>>8&255,++p),N.writeUInt8(S.byteLength>>>0&255,++p)}this.socket.write(P.VSBuffer.concat([N,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),O=R.readUInt8(0),N=(O&128)>>>7,p=(O&64)>>>6,U=R.readUInt8(1),B=(U&128)>>>7,z=U&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(p)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),O=R.readUInt8(1),N=(O&128)>>>7;let p=O&127,U=1;p===126?p=R.readUInt8(++U)*2**8+R.readUInt8(++U):p===127&&(p=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let B=0;N&&(B=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=p,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),o(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class h extends b.Disposable{constructor(S,R,O,N,p,U){super();this._tracer=S,this._onData=p,this._writeFn=U,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new l(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:P.VSBuffer.alloc(0)}writeMessage(S){this._writeQueue.push(S),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const S=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,S);this._writeFn(R,!0)}else this._writeFn(S,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(S,R){return new Promise((O,N)=>{S.write(R),S.flush(p=>O(p))})}acceptFrame(S,R,O){this._readQueue.push({data:S,isCompressed:R,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const S=this._readQueue.shift();if(this._zlibInflateStream&&S.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,S.data,S.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(S.data)}this._isProcessingReadQueue=!1}}_inflateFrame(S,R,O){return new Promise((N,p)=>{S.write(R),O&&S.write(P.VSBuffer.fromByteArray([0,0,255,255])),S.flush(U=>N(U))})}}class l extends b.Disposable{constructor(S,R,O,N){super();this._tracer=S,this._recordInflateBytes=R,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=_.createInflateRaw(N),this._zlibInflate.on("error",p=>{this._tracer.traceSocketEvent("zlibInflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibInflate.on("data",p=>{this._tracer.traceSocketEvent("zlibInflateData",p),this._pendingInflateData.push(P.VSBuffer.wrap(p))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.concat(this._recordedInflateBytes):P.VSBuffer.alloc(0)}write(S){this._recordInflateBytes&&this._recordedInflateBytes.push(S.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",S),this._zlibInflate.write(S.buffer)}flush(S){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=P.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,S(R)})}}class f extends b.Disposable{constructor(S,R){super();this._tracer=S,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=_.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(P.VSBuffer.wrap(O))})}write(S){this._tracer.traceSocketEvent("zlibDeflateWrite",S.buffer),this._zlibDeflate.write(S.buffer)}flush(S){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=P.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),S(R)})}}function o(c,S){if(S===0)return;let R=c.byteLength>>>2;for(let z=0;z<R;z++){const re=c.readUInt32BE(z*4);c.writeUInt32BE(re^S,z*4)}let O=R*4,N=c.byteLength-O;const p=S>>>24&255,U=S>>>16&255,B=S>>>8&255;N>=1&&c.writeUInt8(c.readUInt8(O)^p,O),N>=2&&c.writeUInt8(c.readUInt8(O+1)^U,O+1),N>=3&&c.writeUInt8(c.readUInt8(O+2)^B,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const w={[2]:107,[1]:103};function r(){const c=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):S=(0,A.join)((0,C.tmpdir)(),`vscode-ipc-${c}.sock`),n(S),S}e.createRandomIPCHandle=r;function s(c,S,R){const O=(0,d.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${R}-${S}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${R}-${S}.sock`):N=(0,A.join)(c,`${R}-${S}.sock`),n(N),N}e.createStaticIPCHandle=s;function n(c){const S=w[L.platform];typeof S=="number"&&c.length>=S&&console.warn(`WARNING: IPC handle "${c}" is longer than ${S} chars, try a shorter --user-data-dir`)}class t extends y.IPCServer{constructor(S){super(t.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const R=D.Event.fromNodeEventEmitter(S,"connection");return D.Event.map(R,O=>({protocol:new T.Protocol(new m(O,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function a(c){return new Promise((S,R)=>{const O=(0,i.createServer)();O.on("error",R),O.listen(c,()=>{O.removeListener("error",R),S(new t(O))})})}e.serve=a;function u(c,S){return new Promise((R,O)=>{const N=(0,i.createConnection)(c,()=>{N.removeListener("error",O),R(T.Client.fromSocket(new m(N,`ipc-client${S}`),S))});N.once("error",O)})}e.connect=u}),define(Ie[291],ke([1,0,143,286,61,37,2,13,45]),function(Y,e,d,i,C,P,I,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(y,T,_){this._commands=y,this.logService=T,this._ipcHandlePath=_,this._server=i.createServer((m,v)=>this.onRequest(m,v)),this.setup().catch(m=>(T.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",y=>this.logService.error(y))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(y,T){const _=(v,g)=>{T.writeHead(v,{"content-type":"application/json"}),T.end(JSON.stringify(g||null),E=>E&&this.logService.error(E))},m=[];y.setEncoding("utf8"),y.on("data",v=>m.push(v)),y.on("end",async()=>{try{const v=JSON.parse(m.join(""));let g;switch(v.type){case"open":g=await this.open(v);break;case"openExternal":g=await this.openExternal(v);break;case"status":g=await this.getStatus(v);break;case"extensionManagement":g=await this.manageExtensions(v);break;default:_(404,`Unknown message type: ${v.type}`);break}_(200,g)}catch(v){const g=v instanceof Error?v.message:JSON.stringify(v);_(500,g),this.logService.error("Error while processing pipe request",v)}})}async open(y){const{fileURIs:T,folderURIs:_,forceNewWindow:m,diffMode:v,addMode:g,forceReuseWindow:E,gotoLineMode:h,waitMarkerFilePath:l,remoteAuthority:f}=y,o=[];if(Array.isArray(_))for(const n of _)try{o.push({folderUri:I.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,b.hasWorkspaceFileExtension)(n)?o.push({workspaceUri:I.URI.parse(n)}):o.push({fileUri:I.URI.parse(n)})}catch{}const w=l?I.URI.file(l):void 0,s={forceNewWindow:m,diffMode:v,addMode:g,gotoLineMode:h,forceReuseWindow:E,preferNewWindow:!E&&!w&&!g,waitMarkerFileURI:w,remoteAuthority:f};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(y){for(const T of y.uris){const _=I.URI.parse(T),m=_.scheme==="file"?_:T;await this._commands.executeCommand("_remoteCLI.openExternal",m)}}async manageExtensions(y){const T=m=>m?.map(v=>/\.vsix$/i.test(v)?I.URI.parse(v):v),_={list:y.list,install:T(y.install),uninstall:T(y.uninstall),force:y.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(y){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let L=class extends A{constructor(y,T){super(y,T,(0,d.createRandomIPCHandle)())}};L=Ve([$e(0,P.IExtHostCommands),$e(1,D.ILogService)],L),e.CLIServer=L}),define(Ie[292],ke([1,0,74,284,272,5,285,39,260,2,10,7,291,105]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class _ extends C.RequireInterceptor{_installInterceptor(){const g=this,E=Y.__$__nodeRequire("module"),h=E._load;E._load=function(w,r,s){return w=f(w),g._factories.has(w)?g._factories.get(w).load(w,A.URI.file((0,T.realpathSync)(r.filename)),n=>h.apply(this,[n,r,s])):h.apply(this,arguments)};const l=E._resolveLookupPaths;E._resolveLookupPaths=(o,w)=>l.call(this,f(o),w);const f=o=>{for(let w of g._alternatives){let r=w(o);if(r){o=r;break}}return o}}}class m extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const g=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(b.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(y.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(_,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),d.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,I.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),d.mark("code/extHost/didInitProxyResolver");const l=process.send,f=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?l.apply(process,o):(f.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,E,h){if(E.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{g&&d.mark(`code/extHost/willLoadExtensionCode/${g.value}`),l=Y.__$__nodeRequire(E.fsPath)}catch(f){return Promise.reject(f)}finally{g&&d.mark(`code/extHost/didLoadExtensionCode/${g.value}`),h.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const E in g){const h=g[E];h===null?delete process.env[E]:process.env[E]=h}}}e.ExtHostExtensionService=m}),define(Ie[293],ke([1,0,82,263,275,274,290,292,264,75,39,76,73,38,51,70,262,261,13,276,47]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v,g,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService),(0,d.registerSingleton)(E.ILoggerService,g.ExtHostLoggerService),(0,d.registerSingleton)(m.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,d.registerSingleton)(A.IExtHostDebugService,P.ExtHostDebugService),(0,d.registerSingleton)(k.IExtHostSearch,I.NativeExtHostSearch),(0,d.registerSingleton)(y.IExtHostTask,C.ExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,i.ExtHostTerminalService),(0,d.registerSingleton)(_.IExtHostTunnelService,b.ExtHostTunnelService),(0,d.registerSingleton)(l.IExtHostVariableResolverProvider,h.NodeExtHostVariableResolverProviderService)}),define(Ie[303],ke([1,0,127,304,74,11,107,143,196,134,273,23,29,105,17,113,209,277,293]),function(Y,e,d,i,C,P,I,D,b,A,L,k,y,T,_,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const g=i(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=Y.__$__nodeRequire("module"),n=s._load;s._load=function(t){if(t==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const E=process.exit.bind(process);function h(s){process.exit=function(n){if(s)E(n);else{const t=new Error("An extension called process.exit() and this was prevented.");console.warn(t.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let l=function(s){E()};function f(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let t=null,a=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const u=108e5,c=3e5,S=new _.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (1)"),u),R=new _.ProcessTimeRunOnceScheduler(()=>l("renderer disconnected for too long (2)"),c);process.on("message",(N,p)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){p.setNoDelay(!0);const U=k.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let B;if(N.skipWebSocketFrames)B=new D.NodeSocket(p,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));B=new D.WebSocketNodeSocket(new D.NodeSocket(p,"extHost-socket"),N.permessageDeflate,z,!1)}t?(S.cancel(),R.cancel(),t.beginAcceptReconnection(B,U),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(a),t=new I.PersistentProtocol(B,U),t.sendResume(),t.onDidDispose(()=>l("renderer disconnected")),s(t),t.onSocketClose(()=>{S.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;S.isScheduled()&&R.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,t)=>{const a=d.createConnection(s,()=>{a.removeListener("error",t),n(new I.PersistentProtocol(new D.NodeSocket(a,"extHost-renderer")))});a.once("error",t),a.on("close",()=>{l("renderer closed the socket")})})}}async function o(){const s=await f();return new class{constructor(){this._onMessage=new I.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{(0,A.isMessageOfType)(n,2)?(this._terminating=!0,l("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function w(s){return new Promise(n=>{const t=s.onMessage(a=>{t.dispose();const u=JSON.parse(a.toString()),c=u.commit,S=b.default.commit;c&&S&&c!==S&&E(55);let R=0;setInterval(function(){try{process.kill(u.parentPid,0),R=0}catch(N){N&&N.code==="EPERM"?(R++,R>=3&&l(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):l(`parent process ${u.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=Y.__$__nodeRequire("native-watchdog"),O.start(u.parentPid)}catch(N){(0,P.onUnexpectedError)(N)}s.send((0,A.createMessageOfType)(0)),n({protocol:s,initData:u})});s.send((0,A.createMessageOfType)(1))})}async function r(){const s=[];process.on("unhandledRejection",(R,O)=>{s.push(O),setTimeout(()=>{const N=s.indexOf(O);N>=0&&O.catch(p=>{s.splice(N,1),(0,P.isCancellationError)(p)||(console.warn(`rejected promise not handled within 1 second: ${p}`),p&&p.stack&&console.warn(`stack trace: ${p.stack}`),R&&(0,P.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const O=s.indexOf(R);O>=0&&s.splice(O,1)}),process.on("uncaughtException",function(R){(0,P.onUnexpectedError)(R)}),C.mark("code/extHost/willConnectToRenderer");const n=await o();C.mark("code/extHost/didConnectToRenderer");const t=await w(n);C.mark("code/extHost/didWaitForInitData");const{initData:a}=t;h(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,m.boolean)(g.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(O){E(O)}exists(O){return y.Promises.exists(O)}realpath(O){return(0,T.realpath)(O)}};let c=null;a.remote.authority&&g.transformURIs&&(c=(0,v.createURITransformer)(a.remote.authority));const S=new L.ExtensionHostMain(t.protocol,a,u,c);l=R=>S.terminate(R)}e.startExtensionHostProcess=r,r().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c29becfad5f68270b9b23efeafb147722c5feba/core/vs/workbench/api/node/extensionHostProcess.js.map
