/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/base/common/functional","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookProxyKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],De=function(Z){for(var e=[],a=0,D=Z.length;a<D;a++)e[a]=Se[Z[a]];return e};define(Se[41],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(D,g){if(!D)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=a}),define(Se[54],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function D(O){const v=[];for(let p in O)a.call(O,p)&&v.push(O[p]);return v}e.values=D;function g(O,v){for(let p in O)if(a.call(O,p)&&v({key:p,value:O[p]},function(){delete O[p]})===!1)return}e.forEach=g;function N(O,v){const p=Object.create(null);for(const b of O){const f=v(b);let u=p[f];u||(u=p[f]=[]),u.push(b)}return p}e.groupBy=N;function I(O){const v=Object.create(null);return O&&O.forEach((p,b)=>{v[b]=p}),v}e.fromMap=I;function P(O,v){const p=[],b=[];for(let f of O)v.has(f)||p.push(f);for(let f of v)O.has(f)||b.push(f);return{removed:p,added:b}}e.diffSets=P;function w(O,v){const p=[],b=[];for(let[f,u]of O)v.has(f)||p.push(u);for(let[f,u]of v)O.has(f)||b.push(u);return{removed:p,added:b}}e.diffMaps=w;class A{constructor(){this.map=new Map}add(v,p){let b=this.map.get(v);b||(b=new Set,this.map.set(v,b)),b.add(p)}delete(v,p){const b=this.map.get(v);!b||(b.delete(p),b.size===0&&this.map.delete(v))}forEach(v,p){const b=this.map.get(v);!b||b.forEach(p)}}e.SetMap=A}),define(Se[55],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(I){return(P,w,A)=>{let O=null,v=null;if(typeof A.value=="function"?(O="value",v=A.value):typeof A.get=="function"&&(O="get",v=A.get),!v)throw new Error("not supported");A[O]=I(v,w)}}e.createDecorator=a;function D(I,P,w){let A=null,O=null;if(typeof w.value=="function"?(A="value",O=w.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(A="get",O=w.get),!O)throw new Error("not supported");const v=`$memoize$${P}`;w[A]=function(...p){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,p)}),this[v]}}e.memoize=D;function g(I,P,w){return a((A,O)=>{const v=`$debounce$${O}`,p=`$debounce$result$${O}`;return function(...b){this[p]||(this[p]=w?w():void 0),clearTimeout(this[v]),P&&(this[p]=P(this[p],...b),b=[this[p]]),this[v]=setTimeout(()=>{A.apply(this,b),this[p]=w?w():void 0},I)}})}e.debounce=g;function N(I,P,w){return a((A,O)=>{const v=`$throttle$timer$${O}`,p=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...u){if(this[p]||(this[p]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...u)),this[f])return;const d=this[b]+I;d<=Date.now()?(this[b]=Date.now(),A.apply(this,[this[p]]),this[p]=w?w():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),A.apply(this,[this[p]]),this[p]=w?w():void 0},d-Date.now()))}})}e.throttle=N}),define(Se[56],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(g){this._prefix=g,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[104],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var D;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var g;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(g=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(r){r.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function I(r,k=!1){let i=0,s=r.length,n="",t=0,o=16,m=0;function h(z){let V=0,se=0;for(;V<z;){const K=r.charCodeAt(i);if(K>=48&&K<=57)se=se*16+K-48;else if(K>=65&&K<=70)se=se*16+K-65+10;else if(K>=97&&K<=102)se=se*16+K-97+10;else break;i++,V++}return V<z&&(se=-1),se}function C(z){i=z,n="",t=0,o=16,m=0}function F(){const z=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&A(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&A(r.charCodeAt(i)))for(i++;i<r.length&&A(r.charCodeAt(i));)i++;else return m=3,r.substring(z,i);let V=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&A(r.charCodeAt(i))){for(i++;i<r.length&&A(r.charCodeAt(i));)i++;V=i}else m=3;return r.substring(z,V)}function U(){let z="",V=i;for(;;){if(i>=s){z+=r.substring(V,i),m=2;break}const se=r.charCodeAt(i);if(se===34){z+=r.substring(V,i),i++;break}if(se===92){if(z+=r.substring(V,i),i++,i>=s){m=2;break}switch(r.charCodeAt(i++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const L=h(4);L>=0?z+=String.fromCharCode(L):m=4;break}default:m=5}V=i;continue}if(se>=0&&se<=31)if(w(se)){z+=r.substring(V,i),m=2;break}else m=6;i++}return z}function R(){if(n="",m=0,t=i,i>=s)return t=s,o=17;let z=r.charCodeAt(i);if(P(z)){do i++,n+=String.fromCharCode(z),z=r.charCodeAt(i);while(P(z));return o=15}if(w(z))return i++,n+=String.fromCharCode(z),z===13&&r.charCodeAt(i)===10&&(i++,n+=`
`),o=14;switch(z){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,n=U(),o=10;case 47:{const V=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<s&&!w(r.charCodeAt(i));)i++;return n=r.substring(V,i),o=12}if(r.charCodeAt(i+1)===42){i+=2;const se=s-1;let K=!1;for(;i<se;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,m=1),n=r.substring(V,i),o=13}return n+=String.fromCharCode(z),i++,o=16}case 45:if(n+=String.fromCharCode(z),i++,i===s||!A(r.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=F(),o=11;default:for(;i<s&&E(z);)i++,z=r.charCodeAt(i);if(t!==i){switch(n=r.substring(t,i),n){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return n+=String.fromCharCode(z),i++,o=16}}function E(z){if(P(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let z;do z=R();while(z>=12&&z<=15);return z}return{setPosition:C,getPosition:()=>i,scan:k?x:R,getToken:()=>o,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>m}}e.createScanner=I;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function w(r){return r===10||r===13||r===8232||r===8233}function A(r){return r>=48&&r<=57}var O;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(O||(O={}));function v(r,k){const i=[],s=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function m(h,C,F,U){t.value=h,t.offset=C,t.length=F,t.type=U,t.colonOffset=void 0,n=t}try{S(r,{onObjectBegin:(h,C)=>{if(k<=h)throw s;n=void 0,o=k>h,i.push("")},onObjectProperty:(h,C,F)=>{if(k<C||(m(h,C,F,"property"),i[i.length-1]=h,k<=C+F))throw s},onObjectEnd:(h,C)=>{if(k<=h)throw s;n=void 0,i.pop()},onArrayBegin:(h,C)=>{if(k<=h)throw s;n=void 0,i.push(0)},onArrayEnd:(h,C)=>{if(k<=h)throw s;n=void 0,i.pop()},onLiteralValue:(h,C,F)=>{if(k<C||(m(h,C,F,_(h)),k<=C+F))throw s},onSeparator:(h,C,F)=>{if(k<=C)throw s;if(h===":"&&n&&n.type==="property")n.colonOffset=C,o=!1,n=void 0;else if(h===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(o=!0,i[i.length-1]=""),n=void 0}}})}catch(h){if(h!==s)throw h}return{path:i,previousNode:n,isAtPropertyKey:o,matches:h=>{let C=0;for(let F=0;C<h.length&&F<i.length;F++)if(h[C]===i[F]||h[C]==="*")C++;else if(h[C]!=="**")return!1;return C===h.length}}}e.getLocation=v;function p(r,k=[],i=N.DEFAULT){let s=null,n=[];const t=[];function o(h){Array.isArray(n)?n.push(h):s!==null&&(n[s]=h)}return S(r,{onObjectBegin:()=>{const h={};o(h),t.push(n),n=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const h=[];o(h),t.push(n),n=h,s=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:o,onError:(h,C,F)=>{k.push({error:h,offset:C,length:F})}},i),n[0]}e.parse=p;function b(r,k=[],i=N.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){s.type==="property"&&(s.length=h-s.offset,s=s.parent)}function t(h){return s.children.push(h),h}S(r,{onObjectBegin:h=>{s=t({type:"object",offset:h,length:-1,parent:s,children:[]})},onObjectProperty:(h,C,F)=>{s=t({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:h,offset:C,length:F,parent:s})},onObjectEnd:(h,C)=>{s.length=h+C-s.offset,s=s.parent,n(h+C)},onArrayBegin:(h,C)=>{s=t({type:"array",offset:h,length:-1,parent:s,children:[]})},onArrayEnd:(h,C)=>{s.length=h+C-s.offset,s=s.parent,n(h+C)},onLiteralValue:(h,C,F)=>{t({type:_(h),offset:C,length:F,parent:s,value:h}),n(C+F)},onSeparator:(h,C,F)=>{s.type==="property"&&(h===":"?s.colonOffset=C:h===","&&n(C))},onError:(h,C,F)=>{k.push({error:h,offset:C,length:F})}},i);const m=s.children[0];return m&&delete m.parent,m}e.parseTree=b;function f(r,k){if(!r)return;let i=r;for(let s of k)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===s){i=t.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=f;function u(r){if(!r.parent||!r.parent.children)return[];const k=u(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;k.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&k.push(i)}return k}e.getNodePath=u;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const k=Object.create(null);for(let i of r.children){const s=i.children[1];s&&(k[i.children[0].value]=d(s))}return k}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function c(r,k,i=!1){return k>=r.offset&&k<r.offset+r.length||i&&k===r.offset+r.length}e.contains=c;function y(r,k,i=!1){if(c(r,k,i)){const s=r.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=k;n++){const t=y(s[n],k,i);if(t)return t}return r}}e.findNodeAtOffset=y;function S(r,k,i=N.DEFAULT){const s=I(r,!1);function n(Ee){return Ee?()=>Ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(Ee){return Ee?we=>Ee(we,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=n(k.onObjectBegin),m=t(k.onObjectProperty),h=n(k.onObjectEnd),C=n(k.onArrayBegin),F=n(k.onArrayEnd),U=t(k.onLiteralValue),R=t(k.onSeparator),E=n(k.onComment),x=t(k.onError),z=i&&i.disallowComments,V=i&&i.allowTrailingComma;function se(){for(;;){const Ee=s.scan();switch(s.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:z||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ee){case 12:case 13:z?K(10):E();break;case 16:K(1);break;case 15:case 14:break;default:return Ee}}}function K(Ee,we=[],J=[]){if(x(Ee),we.length+J.length>0){let ve=s.getToken();for(;ve!==17;){if(we.indexOf(ve)!==-1){se();break}else if(J.indexOf(ve)!==-1)break;ve=se()}}}function L(Ee){const we=s.getTokenValue();return Ee?U(we):m(we),se(),!0}function oe(){switch(s.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(s.getTokenValue()),typeof Ee!="number"&&(K(2),Ee=0)}catch{K(2)}U(Ee);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return se(),!0}function de(){return s.getToken()!==10?(K(3,[],[2,5]),!1):(L(!1),s.getToken()===6?(R(":"),se(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ae(){o(),se();let Ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Ee||K(4,[],[]),R(","),se(),s.getToken()===2&&V)break}else Ee&&K(6,[],[]);de()||K(4,[],[2,5]),Ee=!0}return h(),s.getToken()!==2?K(7,[2],[]):se(),!0}function fe(){C(),se();let Ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Ee||K(4,[],[]),R(","),se(),s.getToken()===4&&V)break}else Ee&&K(6,[],[]);ee()||K(4,[],[4,5]),Ee=!0}return F(),s.getToken()!==4?K(8,[4],[]):se(),!0}function ee(){switch(s.getToken()){case 3:return fe();case 1:return ae();case 10:return L(!0);default:return oe()}}return se(),s.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(s.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=S;function l(r,k){let i=I(r),s=[],n,t=0,o;do switch(o=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:t!==o&&s.push(r.substring(t,o)),k!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,k)),t=i.getPosition();break}while(n!==17);return s.join("")}e.stripComments=l;function _(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Se[105],De([0]),e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(Ie,_e){for(var Ce=0;Ce<_e.length;Ce++){var re=_e[Ce];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Ie,re.key,re)}}function a(Ie,_e,Ce){return _e&&e(Ie.prototype,_e),Ce&&e(Ie,Ce),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function D(Ie,_e){if(!!Ie){if(typeof Ie=="string")return g(Ie,_e);var Ce=Object.prototype.toString.call(Ie).slice(8,-1);if(Ce==="Object"&&Ie.constructor&&(Ce=Ie.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ie);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return g(Ie,_e)}}function g(Ie,_e){(_e==null||_e>Ie.length)&&(_e=Ie.length);for(var Ce=0,re=new Array(_e);Ce<_e;Ce++)re[Ce]=Ie[Ce];return re}function N(Ie,_e){var Ce=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Ce)return(Ce=Ce.call(Ie)).next.bind(Ce);if(Array.isArray(Ie)||(Ce=D(Ie))||_e&&Ie&&typeof Ie.length=="number"){Ce&&(Ie=Ce);var re=0;return function(){return re>=Ie.length?{done:!0}:{done:!1,value:Ie[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=I();function P(Ie){Z.defaults=Ie}var w=/[&<>"']/,A=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(_e){return p[_e]};function f(Ie,_e){if(_e){if(w.test(Ie))return Ie.replace(A,b)}else if(O.test(Ie))return Ie.replace(v,b);return Ie}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ie){return Ie.replace(u,function(_e,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var c=/(^|[^\[])\^/g;function y(Ie,_e){Ie=Ie.source||Ie,_e=_e||"";var Ce={replace:function(le,X){return X=X.source||X,X=X.replace(c,"$1"),Ie=Ie.replace(le,X),Ce},getRegex:function(){return new RegExp(Ie,_e)}};return Ce}var S=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Ie,_e,Ce){if(Ie){var re;try{re=decodeURIComponent(d(Ce)).replace(S,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}_e&&!l.test(Ce)&&(Ce=n(_e,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var r={},k=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ie,_e){r[" "+Ie]||(k.test(Ie)?r[" "+Ie]=Ie+"/":r[" "+Ie]=h(Ie,"/",!0)),Ie=r[" "+Ie];var Ce=Ie.indexOf(":")===-1;return _e.substring(0,2)==="//"?Ce?_e:Ie.replace(i,"$1")+_e:_e.charAt(0)==="/"?Ce?_e:Ie.replace(s,"$1")+_e:Ie+_e}var t={exec:function(){}};function o(Ie){for(var _e=1,Ce,re;_e<arguments.length;_e++){Ce=arguments[_e];for(re in Ce)Object.prototype.hasOwnProperty.call(Ce,re)&&(Ie[re]=Ce[re])}return Ie}function m(Ie,_e){var Ce=Ie.replace(/\|/g,function(X,G,T){for(var B=!1,W=G;--W>=0&&T[W]==="\\";)B=!B;return B?"|":" |"}),re=Ce.split(/ \|/),le=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>_e)re.splice(_e);else for(;re.length<_e;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function h(Ie,_e,Ce){var re=Ie.length;if(re===0)return"";for(var le=0;le<re;){var X=Ie.charAt(re-le-1);if(X===_e&&!Ce)le++;else if(X!==_e&&Ce)le++;else break}return Ie.substr(0,re-le)}function C(Ie,_e){if(Ie.indexOf(_e[1])===-1)return-1;for(var Ce=Ie.length,re=0,le=0;le<Ce;le++)if(Ie[le]==="\\")le++;else if(Ie[le]===_e[0])re++;else if(Ie[le]===_e[1]&&(re--,re<0))return le;return-1}function F(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(Ie,_e){if(_e<1)return"";for(var Ce="";_e>1;)_e&1&&(Ce+=Ie),_e>>=1,Ie+=Ie;return Ce+Ie}function R(Ie,_e,Ce,re){var le=_e.href,X=_e.title?f(_e.title):null,G=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){re.state.inLink=!0;var T={type:"link",raw:Ce,href:le,title:X,text:G,tokens:re.inlineTokens(G,[])};return re.state.inLink=!1,T}else return{type:"image",raw:Ce,href:le,title:X,text:f(G)}}function E(Ie,_e){var Ce=Ie.match(/^(\s+)(?:```)/);if(Ce===null)return _e;var re=Ce[1];return _e.split(`
`).map(function(le){var X=le.match(/^\s+/);if(X===null)return le;var G=X[0];return G.length>=re.length?le.slice(re.length):le}).join(`
`)}var x=function(){function Ie(Ce){this.options=Ce||Z.defaults}var _e=Ie.prototype;return _e.space=function(re){var le=this.rules.block.newline.exec(re);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},_e.code=function(re){var le=this.rules.block.code.exec(re);if(le){var X=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?X:h(X,`
`)}}},_e.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var X=le[0],G=E(X,le[3]||"");return{type:"code",raw:X,lang:le[2]?le[2].trim():le[2],text:G}}},_e.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var X=le[2].trim();if(/#$/.test(X)){var G=h(X,"#");(this.options.pedantic||!G||/ $/.test(G))&&(X=G.trim())}var T={type:"heading",raw:le[0],depth:le[1].length,text:X,tokens:[]};return this.lexer.inline(T.text,T.tokens),T}},_e.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},_e.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var X=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(X,[]),text:X}}},_e.list=function(re){var le=this.rules.block.list.exec(re);if(le){var X,G,T,B,W,H,ne,he,Y,ge,pe,Ne,xe=le[1].trim(),ke=xe.length>1,qe={type:"list",raw:"",ordered:ke,start:ke?+xe.slice(0,-1):"",loose:!1,items:[]};xe=ke?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=ke?xe:"[*+-]");for(var j=new RegExp("^( {0,3}"+xe+")((?: [^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(le=j.exec(re))||this.rules.block.hr.test(re)));){if(X=le[0],re=re.substring(X.length),he=le[2].split(`
`,1)[0],Y=re.split(`
`,1)[0],this.options.pedantic?(B=2,pe=he.trimLeft()):(B=le[2].search(/[^ ]/),B=B>4?1:B,pe=he.slice(B),B+=le[1].length),H=!1,!he&&/^ *$/.test(Y)&&(X+=Y+`
`,re=re.substring(Y.length+1),Ne=!0),!Ne)for(var Q=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])");re&&(ge=re.split(`
`,1)[0],he=ge,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Q.test(he));){if(he.search(/[^ ]/)>=B||!he.trim())pe+=`
`+he.slice(B);else if(!H)pe+=`
`+he;else break;!H&&!he.trim()&&(H=!0),X+=ge+`
`,re=re.substring(ge.length+1)}qe.loose||(ne?qe.loose=!0:/\n *\n *$/.test(X)&&(ne=!0)),this.options.gfm&&(G=/^\[[ xX]\] /.exec(pe),G&&(T=G[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:X,task:!!G,checked:T,loose:!1,text:pe}),qe.raw+=X}qe.items[qe.items.length-1].raw=X.trimRight(),qe.items[qe.items.length-1].text=pe.trimRight(),qe.raw=qe.raw.trimRight();var me=qe.items.length;for(W=0;W<me;W++){this.lexer.state.top=!1,qe.items[W].tokens=this.lexer.blockTokens(qe.items[W].text,[]);var Le=qe.items[W].tokens.filter(function(Xe){return Xe.type==="space"}),Be=Le.every(function(Xe){for(var Ze=Xe.raw.split(""),rt=0,Ye=N(Ze),Je;!(Je=Ye()).done;){var je=Je.value;if(je===`
`&&(rt+=1),rt>1)return!0}return!1});!qe.loose&&Le.length&&Be&&(qe.loose=!0,qe.items[W].loose=!0)}return qe}},_e.html=function(re){var le=this.rules.block.html.exec(re);if(le){var X={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(X.type="paragraph",X.text=this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]),X.tokens=[],this.lexer.inline(X.text,X.tokens)),X}},_e.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var X=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:X,raw:le[0],href:le[2],title:le[3]}}},_e.table=function(re){var le=this.rules.block.table.exec(re);if(le){var X={type:"table",header:m(le[1]).map(function(ne){return{text:ne}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=le[0];var G=X.align.length,T,B,W,H;for(T=0;T<G;T++)/^ *-+: *$/.test(X.align[T])?X.align[T]="right":/^ *:-+: *$/.test(X.align[T])?X.align[T]="center":/^ *:-+ *$/.test(X.align[T])?X.align[T]="left":X.align[T]=null;for(G=X.rows.length,T=0;T<G;T++)X.rows[T]=m(X.rows[T],X.header.length).map(function(ne){return{text:ne}});for(G=X.header.length,B=0;B<G;B++)X.header[B].tokens=[],this.lexer.inlineTokens(X.header[B].text,X.header[B].tokens);for(G=X.rows.length,B=0;B<G;B++)for(H=X.rows[B],W=0;W<H.length;W++)H[W].tokens=[],this.lexer.inlineTokens(H[W].text,H[W].tokens);return X}}},_e.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le){var X={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},_e.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le){var X={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},_e.text=function(re){var le=this.rules.block.text.exec(re);if(le){var X={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},_e.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:f(le[1])}},_e.tag=function(re){var le=this.rules.inline.tag.exec(re);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]}},_e.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var X=le[2].trim();if(!this.options.pedantic&&/^</.test(X)){if(!/>$/.test(X))return;var G=h(X.slice(0,-1),"\\");if((X.length-G.length)%2==0)return}else{var T=C(le[2],"()");if(T>-1){var B=le[0].indexOf("!")===0?5:4,W=B+le[1].length+T;le[2]=le[2].substring(0,T),le[0]=le[0].substring(0,W).trim(),le[3]=""}}var H=le[2],ne="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(H);he&&(H=he[1],ne=he[3])}else ne=le[3]?le[3].slice(1,-1):"";return H=H.trim(),/^</.test(H)&&(this.options.pedantic&&!/>$/.test(X)?H=H.slice(1):H=H.slice(1,-1)),R(le,{href:H&&H.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},_e.reflink=function(re,le){var X;if((X=this.rules.inline.reflink.exec(re))||(X=this.rules.inline.nolink.exec(re))){var G=(X[2]||X[1]).replace(/\s+/g," ");if(G=le[G.toLowerCase()],!G||!G.href){var T=X[0].charAt(0);return{type:"text",raw:T,text:T}}return R(X,G,X[0],this.lexer)}},_e.emStrong=function(re,le,X){X===void 0&&(X="");var G=this.rules.inline.emStrong.lDelim.exec(re);if(!!G&&!(G[3]&&X.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=G[1]||G[2]||"";if(!T||T&&(X===""||this.rules.inline.punctuation.exec(X))){var B=G[0].length-1,W,H,ne=B,he=0,Y=G[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,le=le.slice(-1*re.length+B);(G=Y.exec(le))!=null;)if(W=G[1]||G[2]||G[3]||G[4]||G[5]||G[6],!!W){if(H=W.length,G[3]||G[4]){ne+=H;continue}else if((G[5]||G[6])&&B%3&&!((B+H)%3)){he+=H;continue}if(ne-=H,!(ne>0)){if(H=Math.min(H,H+ne+he),Math.min(B,H)%2){var ge=re.slice(1,B+G.index+H);return{type:"em",raw:re.slice(0,B+G.index+H+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var pe=re.slice(2,B+G.index+H-1);return{type:"strong",raw:re.slice(0,B+G.index+H+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}}}}},_e.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var X=le[2].replace(/\n/g," "),G=/[^ ]/.test(X),T=/^ /.test(X)&&/ $/.test(X);return G&&T&&(X=X.substring(1,X.length-1)),X=f(X,!0),{type:"codespan",raw:le[0],text:X}}},_e.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},_e.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},_e.autolink=function(re,le){var X=this.rules.inline.autolink.exec(re);if(X){var G,T;return X[2]==="@"?(G=f(this.options.mangle?le(X[1]):X[1]),T="mailto:"+G):(G=f(X[1]),T=G),{type:"link",raw:X[0],text:G,href:T,tokens:[{type:"text",raw:G,text:G}]}}},_e.url=function(re,le){var X;if(X=this.rules.inline.url.exec(re)){var G,T;if(X[2]==="@")G=f(this.options.mangle?le(X[0]):X[0]),T="mailto:"+G;else{var B;do B=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(B!==X[0]);G=f(X[0]),X[1]==="www."?T="http://"+G:T=G}return{type:"link",raw:X[0],text:G,href:T,tokens:[{type:"text",raw:G,text:G}]}}},_e.inlineText=function(re,le){var X=this.rules.inline.text.exec(re);if(X){var G;return this.lexer.state.inRawBlock?G=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):f(X[0]):X[0]:G=f(this.options.smartypants?le(X[0]):X[0]),{type:"text",raw:X[0],text:G}}},Ie}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=y(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=y(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=y(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=y(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=y(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=y(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=o({},z),z.gfm=o({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=y(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=y(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=o({},z.normal,{html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:y(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=y(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=y(z._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=y(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=y(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=y(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=y(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=y(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=y(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=y(V.reflink).replace("label",V._label).replace("ref",z._label).getRegex(),V.nolink=y(V.nolink).replace("ref",z._label).getRegex(),V.reflinkSearch=y(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=o({},V),V.pedantic=o({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=o({},V.normal,{escape:y(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=y(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=o({},V.gfm,{br:y(V.br).replace("{2,}","*").getRegex(),text:y(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function se(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ie){var _e="",Ce,re,le=Ie.length;for(Ce=0;Ce<le;Ce++)re=Ie.charCodeAt(Ce),Math.random()>.5&&(re="x"+re.toString(16)),_e+="&#"+re+";";return _e}var L=function(){function Ie(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Z.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:z.normal,inline:V.normal};this.options.pedantic?(re.block=z.pedantic,re.inline=V.pedantic):this.options.gfm&&(re.block=z.gfm,this.options.breaks?re.inline=V.breaks:re.inline=V.gfm),this.tokenizer.rules=re}Ie.lex=function(re,le){var X=new Ie(le);return X.lex(re)},Ie.lexInline=function(re,le){var X=new Ie(le);return X.inlineTokens(re)};var _e=Ie.prototype;return _e.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},_e.blockTokens=function(re,le){var X=this;le===void 0&&(le=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var G,T,B,W;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ne){return(G=ne.call({lexer:X},re,le))?(re=re.substring(G.raw.length),le.push(G),!0):!1}))){if(G=this.tokenizer.space(re)){re=re.substring(G.raw.length),G.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(G);continue}if(G=this.tokenizer.code(re)){re=re.substring(G.raw.length),T=le[le.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):le.push(G);continue}if(G=this.tokenizer.fences(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.heading(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.hr(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.blockquote(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.list(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.html(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.def(re)){re=re.substring(G.raw.length),T=le[le.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+G.raw,T.text+=`
`+G.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[G.tag]||(this.tokens.links[G.tag]={href:G.href,title:G.title});continue}if(G=this.tokenizer.table(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.lheading(re)){re=re.substring(G.raw.length),le.push(G);continue}if(B=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var ne=1/0,he=re.slice(1),Y=void 0;X.options.extensions.startBlock.forEach(function(ge){Y=ge.call({lexer:this},he),typeof Y=="number"&&Y>=0&&(ne=Math.min(ne,Y))}),ne<1/0&&ne>=0&&(B=re.substring(0,ne+1))}(),this.state.top&&(G=this.tokenizer.paragraph(B))){T=le[le.length-1],W&&T.type==="paragraph"?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):le.push(G),W=B.length!==re.length,re=re.substring(G.raw.length);continue}if(G=this.tokenizer.text(re)){re=re.substring(G.raw.length),T=le[le.length-1],T&&T.type==="text"?(T.raw+=`
`+G.raw,T.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):le.push(G);continue}if(re){var H="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return this.state.top=!0,le},_e.inline=function(re,le){this.inlineQueue.push({src:re,tokens:le})},_e.inlineTokens=function(re,le){var X=this;le===void 0&&(le=[]);var G,T,B,W=re,H,ne,he;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(H=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)Y.includes(H[0].slice(H[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,H.index)+"["+U("a",H[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(H=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,H.index)+"["+U("a",H[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(H=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,H.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(ne||(he=""),ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(G=pe.call({lexer:X},re,le))?(re=re.substring(G.raw.length),le.push(G),!0):!1}))){if(G=this.tokenizer.escape(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.tag(re)){re=re.substring(G.raw.length),T=le[le.length-1],T&&G.type==="text"&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):le.push(G);continue}if(G=this.tokenizer.link(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(G.raw.length),T=le[le.length-1],T&&G.type==="text"&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):le.push(G);continue}if(G=this.tokenizer.emStrong(re,W,he)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.codespan(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.br(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.del(re)){re=re.substring(G.raw.length),le.push(G);continue}if(G=this.tokenizer.autolink(re,K)){re=re.substring(G.raw.length),le.push(G);continue}if(!this.state.inLink&&(G=this.tokenizer.url(re,K))){re=re.substring(G.raw.length),le.push(G);continue}if(B=re,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Ne=re.slice(1),xe=void 0;X.options.extensions.startInline.forEach(function(ke){xe=ke.call({lexer:this},Ne),typeof xe=="number"&&xe>=0&&(pe=Math.min(pe,xe))}),pe<1/0&&pe>=0&&(B=re.substring(0,pe+1))}(),G=this.tokenizer.inlineText(B,se)){re=re.substring(G.raw.length),G.raw.slice(-1)!=="_"&&(he=G.raw.slice(-1)),ne=!0,T=le[le.length-1],T&&T.type==="text"?(T.raw+=G.raw,T.text+=G.text):le.push(G);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return le},a(Ie,null,[{key:"rules",get:function(){return{block:z,inline:V}}}]),Ie}(),oe=function(){function Ie(Ce){this.options=Ce||Z.defaults}var _e=Ie.prototype;return _e.code=function(re,le,X){var G=(le||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(re,G);T!=null&&T!==re&&(X=!0,re=T)}return re=re.replace(/\n$/,"")+`
`,G?'<pre><code class="'+this.options.langPrefix+f(G,!0)+'">'+(X?re:f(re,!0))+`</code></pre>
`:"<pre><code>"+(X?re:f(re,!0))+`</code></pre>
`},_e.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},_e.html=function(re){return re},_e.heading=function(re,le,X,G){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+G.slug(X)+'">'+re+"</h"+le+`>
`:"<h"+le+">"+re+"</h"+le+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(re,le,X){var G=le?"ol":"ul",T=le&&X!==1?' start="'+X+'"':"";return"<"+G+T+`>
`+re+"</"+G+`>
`},_e.listitem=function(re){return"<li>"+re+`</li>
`},_e.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(re){return"<p>"+re+`</p>
`},_e.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},_e.tablerow=function(re){return`<tr>
`+re+`</tr>
`},_e.tablecell=function(re,le){var X=le.header?"th":"td",G=le.align?"<"+X+' align="'+le.align+'">':"<"+X+">";return G+re+"</"+X+`>
`},_e.strong=function(re){return"<strong>"+re+"</strong>"},_e.em=function(re){return"<em>"+re+"</em>"},_e.codespan=function(re){return"<code>"+re+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(re){return"<del>"+re+"</del>"},_e.link=function(re,le,X){if(re=_(this.options.sanitize,this.options.baseUrl,re),re===null)return X;var G='<a href="'+f(re)+'"';return le&&(G+=' title="'+le+'"'),G+=">"+X+"</a>",G},_e.image=function(re,le,X){if(re=_(this.options.sanitize,this.options.baseUrl,re),re===null)return X;var G='<img src="'+re+'" alt="'+X+'"';return le&&(G+=' title="'+le+'"'),G+=this.options.xhtml?"/>":">",G},_e.text=function(re){return re},Ie}(),de=function(){function Ie(){}var _e=Ie.prototype;return _e.strong=function(re){return re},_e.em=function(re){return re},_e.codespan=function(re){return re},_e.del=function(re){return re},_e.html=function(re){return re},_e.text=function(re){return re},_e.link=function(re,le,X){return""+X},_e.image=function(re,le,X){return""+X},_e.br=function(){return""},Ie}(),ae=function(){function Ie(){this.seen={}}var _e=Ie.prototype;return _e.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(re,le){var X=re,G=0;if(this.seen.hasOwnProperty(X)){G=this.seen[re];do G++,X=re+"-"+G;while(this.seen.hasOwnProperty(X))}return le||(this.seen[re]=G,this.seen[X]=0),X},_e.slug=function(re,le){le===void 0&&(le={});var X=this.serialize(re);return this.getNextSafeSlug(X,le.dryrun)},Ie}(),fe=function(){function Ie(Ce){this.options=Ce||Z.defaults,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ae}Ie.parse=function(re,le){var X=new Ie(le);return X.parse(re)},Ie.parseInline=function(re,le){var X=new Ie(le);return X.parseInline(re)};var _e=Ie.prototype;return _e.parse=function(re,le){le===void 0&&(le=!0);var X="",G,T,B,W,H,ne,he,Y,ge,pe,Ne,xe,ke,qe,j,Q,me,Le,Be,Xe=re.length;for(G=0;G<Xe;G++){if(pe=re[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Be=this.options.extensions.renderers[pe.type].call({parser:this},pe),Be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){X+=Be||"";continue}switch(pe.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,d(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Y="",he="",W=pe.header.length,T=0;T<W;T++)he+=this.renderer.tablecell(this.parseInline(pe.header[T].tokens),{header:!0,align:pe.align[T]});for(Y+=this.renderer.tablerow(he),ge="",W=pe.rows.length,T=0;T<W;T++){for(ne=pe.rows[T],he="",H=ne.length,B=0;B<H;B++)he+=this.renderer.tablecell(this.parseInline(ne[B].tokens),{header:!1,align:pe.align[B]});ge+=this.renderer.tablerow(he)}X+=this.renderer.table(Y,ge);continue}case"blockquote":{ge=this.parse(pe.tokens),X+=this.renderer.blockquote(ge);continue}case"list":{for(Ne=pe.ordered,xe=pe.start,ke=pe.loose,W=pe.items.length,ge="",T=0;T<W;T++)j=pe.items[T],Q=j.checked,me=j.task,qe="",j.task&&(Le=this.renderer.checkbox(Q),ke?j.tokens.length>0&&j.tokens[0].type==="paragraph"?(j.tokens[0].text=Le+" "+j.tokens[0].text,j.tokens[0].tokens&&j.tokens[0].tokens.length>0&&j.tokens[0].tokens[0].type==="text"&&(j.tokens[0].tokens[0].text=Le+" "+j.tokens[0].tokens[0].text)):j.tokens.unshift({type:"text",text:Le}):qe+=Le),qe+=this.parse(j.tokens,ke),ge+=this.renderer.listitem(qe,me,Q);X+=this.renderer.list(ge,Ne,xe);continue}case"html":{X+=this.renderer.html(pe.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ge=pe.tokens?this.parseInline(pe.tokens):pe.text;G+1<Xe&&re[G+1].type==="text";)pe=re[++G],ge+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);X+=le?this.renderer.paragraph(ge):ge;continue}default:{var Ze='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return X},_e.parseInline=function(re,le){le=le||this.renderer;var X="",G,T,B,W=re.length;for(G=0;G<W;G++){if(T=re[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(B=this.options.extensions.renderers[T.type].call({parser:this},T),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){X+=B||"";continue}switch(T.type){case"escape":{X+=le.text(T.text);break}case"html":{X+=le.html(T.text);break}case"link":{X+=le.link(T.href,T.title,this.parseInline(T.tokens,le));break}case"image":{X+=le.image(T.href,T.title,T.text);break}case"strong":{X+=le.strong(this.parseInline(T.tokens,le));break}case"em":{X+=le.em(this.parseInline(T.tokens,le));break}case"codespan":{X+=le.codespan(T.text);break}case"br":{X+=le.br();break}case"del":{X+=le.del(this.parseInline(T.tokens,le));break}case"text":{X+=le.text(T.text);break}default:{var H='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(H);return}else throw new Error(H)}}}return X},Ie}();function ee(Ie,_e,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof _e=="function"&&(Ce=_e,_e=null),_e=o({},ee.defaults,_e||{}),F(_e),Ce){var re=_e.highlight,le;try{le=L.lex(Ie,_e)}catch(B){return Ce(B)}var X=function(W){var H;if(!W)try{_e.walkTokens&&ee.walkTokens(le,_e.walkTokens),H=fe.parse(le,_e)}catch(ne){W=ne}return _e.highlight=re,W?Ce(W):Ce(null,H)};if(!re||re.length<3||(delete _e.highlight,!le.length))return X();var G=0;ee.walkTokens(le,function(B){B.type==="code"&&(G++,setTimeout(function(){re(B.text,B.lang,function(W,H){if(W)return X(W);H!=null&&H!==B.text&&(B.text=H,B.escaped=!0),G--,G===0&&X()})},0))}),G===0&&X();return}try{var T=L.lex(Ie,_e);return _e.walkTokens&&ee.walkTokens(T,_e.walkTokens),fe.parse(T,_e)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(B.message+"",!0)+"</pre>";throw B}}ee.options=ee.setOptions=function(Ie){return o(ee.defaults,Ie),P(ee.defaults),ee},ee.getDefaults=I,ee.defaults=Z.defaults,ee.use=function(){for(var Ie=arguments.length,_e=new Array(Ie),Ce=0;Ce<Ie;Ce++)_e[Ce]=arguments[Ce];var re=o.apply(void 0,[{}].concat(_e)),le=ee.defaults.extensions||{renderers:{},childTokens:{}},X;_e.forEach(function(G){if(G.extensions&&(X=!0,G.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var W=le.renderers?le.renderers[B.name]:null;W?le.renderers[B.name]=function(){for(var H=arguments.length,ne=new Array(H),he=0;he<H;he++)ne[he]=arguments[he];var Y=B.renderer.apply(this,ne);return Y===!1&&(Y=W.apply(this,ne)),Y}:le.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[B.level]?le[B.level].unshift(B.tokenizer):le[B.level]=[B.tokenizer],B.start&&(B.level==="block"?le.startBlock?le.startBlock.push(B.start):le.startBlock=[B.start]:B.level==="inline"&&(le.startInline?le.startInline.push(B.start):le.startInline=[B.start]))}B.childTokens&&(le.childTokens[B.name]=B.childTokens)})),G.renderer&&function(){var B=ee.defaults.renderer||new oe,W=function(he){var Y=B[he];B[he]=function(){for(var ge=arguments.length,pe=new Array(ge),Ne=0;Ne<ge;Ne++)pe[Ne]=arguments[Ne];var xe=G.renderer[he].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var H in G.renderer)W(H);re.renderer=B}(),G.tokenizer&&function(){var B=ee.defaults.tokenizer||new x,W=function(he){var Y=B[he];B[he]=function(){for(var ge=arguments.length,pe=new Array(ge),Ne=0;Ne<ge;Ne++)pe[Ne]=arguments[Ne];var xe=G.tokenizer[he].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var H in G.tokenizer)W(H);re.tokenizer=B}(),G.walkTokens){var T=ee.defaults.walkTokens;re.walkTokens=function(B){G.walkTokens.call(this,B),T&&T.call(this,B)}}X&&(re.extensions=le),ee.setOptions(re)})},ee.walkTokens=function(Ie,_e){for(var Ce=function(){var G=le.value;switch(_e.call(ee,G),G.type){case"table":{for(var T=N(G.header),B;!(B=T()).done;){var W=B.value;ee.walkTokens(W.tokens,_e)}for(var H=N(G.rows),ne;!(ne=H()).done;)for(var he=ne.value,Y=N(he),ge;!(ge=Y()).done;){var pe=ge.value;ee.walkTokens(pe.tokens,_e)}break}case"list":{ee.walkTokens(G.items,_e);break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[G.type]?ee.defaults.extensions.childTokens[G.type].forEach(function(Ne){ee.walkTokens(G[Ne],_e)}):G.tokens&&ee.walkTokens(G.tokens,_e)}},re=N(Ie),le;!(le=re()).done;)Ce()},ee.parseInline=function(Ie,_e){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");_e=o({},ee.defaults,_e||{}),F(_e);try{var Ce=L.lexInline(Ie,_e);return _e.walkTokens&&ee.walkTokens(Ce,_e.walkTokens),fe.parseInline(Ce,_e)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(re.message+"",!0)+"</pre>";throw re}},ee.Parser=fe,ee.parser=fe.parse,ee.Renderer=oe,ee.TextRenderer=de,ee.Lexer=L,ee.lexer=L.lex,ee.Tokenizer=x,ee.Slugger=ae,ee.parse=ee;var Ee=ee.options,we=ee.setOptions,J=ee.use,ve=ee.walkTokens,Pe=ee.parseInline,Fe=ee,We=fe.parse,Ge=L.lex;Z.Lexer=L,Z.Parser=fe,Z.Renderer=oe,Z.Slugger=ae,Z.TextRenderer=de,Z.Tokenizer=x,Z.getDefaults=I,Z.lexer=Ge,Z.marked=ee,Z.options=Ee,Z.parse=Fe,Z.parseInline=Pe,Z.parser=We,Z.setOptions=we,Z.use=J,Z.walkTokens=ve,Object.defineProperty(Z,"__esModule",{value:!0})}),define(Se[106],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(P,w,A){return Math.min(Math.max(P,w),A)}e.clamp=a;function D(P,w){return(w+P%w)%w}e.rot=D;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class N{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class I{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const A=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function Z(g){const N=[];typeof g=="number"&&N.push("code/timeOrigin",g);function I(w){N.push(w,Date.now())}function P(){const w=[];for(let A=0;A<N.length;A+=2)w.push({name:N[A],startTime:N[A+1]});return w}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const I of performance.getEntriesByType("mark"))N.push({name:I.name,startTime:Math.round(g+I.startTime)});return N}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function a(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=a(D))}(),define(Se[74],De([1,0,17]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var D;(function(v){v.text="text/plain",v.binary="application/octet-stream",v.unknown="application/unknown",v.markdown="text/markdown",v.latex="text/latex",v.uriList="text/uri-list"})(D=e.Mimes||(e.Mimes={}));const g={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(v){const p=(0,a.extname)(v),b=g[p.toLowerCase()];return b!==void 0?b:P(v)}e.getMediaOrTextMime=I;function P(v){const p=(0,a.extname)(v);return N[p.toLowerCase()]}e.getMediaMime=P;function w(v){for(const p in N)if(N[p]===v)return p}e.getExtensionForMimeType=w;const A=/^(.+)\/(.+?)(;.+)?$/;function O(v,p){const b=A.exec(v);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:p?void 0:v}e.normalizeMimeType=O}),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var D in a)(typeof exports=="object"?exports:Z)[D]=a[D]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function a(D){if(e[D])return e[D].exports;var g=e[D]={i:D,l:!1,exports:{}};return Z[D].call(g.exports,g,g.exports,a),g.l=!0,g.exports}return a.m=Z,a.c=e,a.d=function(D,g,N){a.o(D,g)||Object.defineProperty(D,g,{enumerable:!0,get:N})},a.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},a.t=function(D,g){if(1&g&&(D=a(D)),8&g||4&g&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(a.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&g&&typeof D!="string")for(var I in D)a.d(N,I,function(P){return D[P]}.bind(null,I));return N},a.n=function(D){var g=D&&D.__esModule?function(){return D.default}:function(){return D};return a.d(g,"a",g),g},a.o=function(D,g){return Object.prototype.hasOwnProperty.call(D,g)},a.p="",a(a.s=0)}([function(Z,e,a){(function(D){var g;e=Z.exports=J,g=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],A=0,O=A++;w[O]="0|[1-9]\\d*";var v=A++;w[v]="[0-9]+";var p=A++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=A++;w[b]="("+w[O]+")\\.("+w[O]+")\\.("+w[O]+")";var f=A++;w[f]="("+w[v]+")\\.("+w[v]+")\\.("+w[v]+")";var u=A++;w[u]="(?:"+w[O]+"|"+w[p]+")";var d=A++;w[d]="(?:"+w[v]+"|"+w[p]+")";var c=A++;w[c]="(?:-("+w[u]+"(?:\\."+w[u]+")*))";var y=A++;w[y]="(?:-?("+w[d]+"(?:\\."+w[d]+")*))";var S=A++;w[S]="[0-9A-Za-z-]+";var l=A++;w[l]="(?:\\+("+w[S]+"(?:\\."+w[S]+")*))";var _=A++,r="v?"+w[b]+w[c]+"?"+w[l]+"?";w[_]="^"+r+"$";var k="[v=\\s]*"+w[f]+w[y]+"?"+w[l]+"?",i=A++;w[i]="^"+k+"$";var s=A++;w[s]="((?:<|>)?=?)";var n=A++;w[n]=w[v]+"|x|X|\\*";var t=A++;w[t]=w[O]+"|x|X|\\*";var o=A++;w[o]="[v=\\s]*("+w[t]+")(?:\\.("+w[t]+")(?:\\.("+w[t]+")(?:"+w[c]+")?"+w[l]+"?)?)?";var m=A++;w[m]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[y]+")?"+w[l]+"?)?)?";var h=A++;w[h]="^"+w[s]+"\\s*"+w[o]+"$";var C=A++;w[C]="^"+w[s]+"\\s*"+w[m]+"$";var F=A++;w[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=A++;w[U]="(?:~>?)";var R=A++;w[R]="(\\s*)"+w[U]+"\\s+",P[R]=new RegExp(w[R],"g");var E=A++;w[E]="^"+w[U]+w[o]+"$";var x=A++;w[x]="^"+w[U]+w[m]+"$";var z=A++;w[z]="(?:\\^)";var V=A++;w[V]="(\\s*)"+w[z]+"\\s+",P[V]=new RegExp(w[V],"g");var se=A++;w[se]="^"+w[z]+w[o]+"$";var K=A++;w[K]="^"+w[z]+w[m]+"$";var L=A++;w[L]="^"+w[s]+"\\s*("+k+")$|^$";var oe=A++;w[oe]="^"+w[s]+"\\s*("+r+")$|^$";var de=A++;w[de]="(\\s*)"+w[s]+"\\s*("+k+"|"+w[o]+")",P[de]=new RegExp(w[de],"g");var ae=A++;w[ae]="^\\s*("+w[o]+")\\s+-\\s+("+w[o]+")\\s*$";var fe=A++;w[fe]="^\\s*("+w[m]+")\\s+-\\s+("+w[m]+")\\s*$";var ee=A++;w[ee]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)g(Ee,w[Ee]),P[Ee]||(P[Ee]=new RegExp(w[Ee]));function we(Y,ge){if(Y instanceof J)return Y;if(typeof Y!="string"||Y.length>N||!(ge?P[i]:P[_]).test(Y))return null;try{return new J(Y,ge)}catch{return null}}function J(Y,ge){if(Y instanceof J){if(Y.loose===ge)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof J))return new J(Y,ge);g("SemVer",Y,ge),this.loose=ge;var pe=Y.trim().match(ge?P[i]:P[_]);if(!pe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var xe=+Ne;if(xe>=0&&xe<I)return xe}return Ne}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=we,e.valid=function(Y,ge){var pe=we(Y,ge);return pe?pe.version:null},e.clean=function(Y,ge){var pe=we(Y.trim().replace(/^[=v]+/,""),ge);return pe?pe.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(Y){return g("SemVer.compare",this.version,this.loose,Y),Y instanceof J||(Y=new J(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},J.prototype.compareMain=function(Y){return Y instanceof J||(Y=new J(Y,this.loose)),Pe(this.major,Y.major)||Pe(this.minor,Y.minor)||Pe(this.patch,Y.patch)},J.prototype.comparePre=function(Y){if(Y instanceof J||(Y=new J(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ge=0;do{var pe=this.prerelease[ge],Ne=Y.prerelease[ge];if(g("prerelease compare",ge,pe,Ne),pe===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(pe===void 0)return-1;if(pe!==Ne)return Pe(pe,Ne)}while(++ge)},J.prototype.inc=function(Y,ge){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ge,pe,Ne){typeof pe=="string"&&(Ne=pe,pe=void 0);try{return new J(Y,pe).inc(ge,Ne).version}catch{return null}},e.diff=function(Y,ge){if(Ie(Y,ge))return null;var pe=we(Y),Ne=we(ge);if(pe.prerelease.length||Ne.prerelease.length){for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Ne[xe])return"pre"+xe;return"prerelease"}for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Ne[xe])return xe},e.compareIdentifiers=Pe;var ve=/^[0-9]+$/;function Pe(Y,ge){var pe=ve.test(Y),Ne=ve.test(ge);return pe&&Ne&&(Y=+Y,ge=+ge),pe&&!Ne?-1:Ne&&!pe?1:Y<ge?-1:Y>ge?1:0}function Fe(Y,ge,pe){return new J(Y,pe).compare(new J(ge,pe))}function We(Y,ge,pe){return Fe(Y,ge,pe)>0}function Ge(Y,ge,pe){return Fe(Y,ge,pe)<0}function Ie(Y,ge,pe){return Fe(Y,ge,pe)===0}function _e(Y,ge,pe){return Fe(Y,ge,pe)!==0}function Ce(Y,ge,pe){return Fe(Y,ge,pe)>=0}function re(Y,ge,pe){return Fe(Y,ge,pe)<=0}function le(Y,ge,pe,Ne){var xe;switch(ge){case"===":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y===pe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y!==pe;break;case"":case"=":case"==":xe=Ie(Y,pe,Ne);break;case"!=":xe=_e(Y,pe,Ne);break;case">":xe=We(Y,pe,Ne);break;case">=":xe=Ce(Y,pe,Ne);break;case"<":xe=Ge(Y,pe,Ne);break;case"<=":xe=re(Y,pe,Ne);break;default:throw new TypeError("Invalid operator: "+ge)}return xe}function X(Y,ge){if(Y instanceof X){if(Y.loose===ge)return Y;Y=Y.value}if(!(this instanceof X))return new X(Y,ge);g("comparator",Y,ge),this.loose=ge,this.parse(Y),this.semver===G?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(Y,ge){return Pe(ge,Y)},e.major=function(Y,ge){return new J(Y,ge).major},e.minor=function(Y,ge){return new J(Y,ge).minor},e.patch=function(Y,ge){return new J(Y,ge).patch},e.compare=Fe,e.compareLoose=function(Y,ge){return Fe(Y,ge,!0)},e.rcompare=function(Y,ge,pe){return Fe(ge,Y,pe)},e.sort=function(Y,ge){return Y.sort(function(pe,Ne){return e.compare(pe,Ne,ge)})},e.rsort=function(Y,ge){return Y.sort(function(pe,Ne){return e.rcompare(pe,Ne,ge)})},e.gt=We,e.lt=Ge,e.eq=Ie,e.neq=_e,e.gte=Ce,e.lte=re,e.cmp=le,e.Comparator=X;var G={};function T(Y,ge){if(Y instanceof T)return Y.loose===ge?Y:new T(Y.raw,ge);if(Y instanceof X)return new T(Y.value,ge);if(!(this instanceof T))return new T(Y,ge);if(this.loose=ge,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function B(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function W(Y,ge,pe,Ne,xe,ke,qe,j,Q,me,Le,Be,Xe){return((ge=B(pe)?"":B(Ne)?">="+pe+".0.0":B(xe)?">="+pe+"."+Ne+".0":">="+ge)+" "+(j=B(Q)?"":B(me)?"<"+(+Q+1)+".0.0":B(Le)?"<"+Q+"."+(+me+1)+".0":Be?"<="+Q+"."+me+"."+Le+"-"+Be:"<="+j)).trim()}function H(Y,ge){for(var pe=0;pe<Y.length;pe++)if(!Y[pe].test(ge))return!1;if(ge.prerelease.length){for(pe=0;pe<Y.length;pe++)if(g(Y[pe].semver),Y[pe].semver!==G&&Y[pe].semver.prerelease.length>0){var Ne=Y[pe].semver;if(Ne.major===ge.major&&Ne.minor===ge.minor&&Ne.patch===ge.patch)return!0}return!1}return!0}function ne(Y,ge,pe){try{ge=new T(ge,pe)}catch{return!1}return ge.test(Y)}function he(Y,ge,pe,Ne){var xe,ke,qe,j,Q;switch(Y=new J(Y,Ne),ge=new T(ge,Ne),pe){case">":xe=We,ke=re,qe=Ge,j=">",Q=">=";break;case"<":xe=Ge,ke=Ce,qe=We,j="<",Q="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ne(Y,ge,Ne))return!1;for(var me=0;me<ge.set.length;++me){var Le=ge.set[me],Be=null,Xe=null;if(Le.forEach(function(Ze){Ze.semver===G&&(Ze=new X(">=0.0.0")),Be=Be||Ze,Xe=Xe||Ze,xe(Ze.semver,Be.semver,Ne)?Be=Ze:qe(Ze.semver,Xe.semver,Ne)&&(Xe=Ze)}),Be.operator===j||Be.operator===Q||(!Xe.operator||Xe.operator===j)&&ke(Y,Xe.semver)||Xe.operator===Q&&qe(Y,Xe.semver))return!1}return!0}X.prototype.parse=function(Y){var ge=this.loose?P[L]:P[oe],pe=Y.match(ge);if(!pe)throw new TypeError("Invalid comparator: "+Y);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new J(pe[2],this.loose):this.semver=G},X.prototype.toString=function(){return this.value},X.prototype.test=function(Y){return g("Comparator.test",Y,this.loose),this.semver===G||(typeof Y=="string"&&(Y=new J(Y,this.loose)),le(Y,this.operator,this.semver,this.loose))},X.prototype.intersects=function(Y,ge){if(!(Y instanceof X))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new T(Y.value,ge),ne(this.value,pe,ge);if(Y.operator==="")return pe=new T(this.value,ge),ne(Y.semver,pe,ge);var Ne=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),ke=this.semver.version===Y.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),j=le(this.semver,"<",Y.semver,ge)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Q=le(this.semver,">",Y.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ne||xe||ke&&qe||j||Q},e.Range=T,T.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},T.prototype.toString=function(){return this.range},T.prototype.parseRange=function(Y){var ge=this.loose;Y=Y.trim(),g("range",Y,ge);var pe=ge?P[fe]:P[ae];Y=Y.replace(pe,W),g("hyphen replace",Y),Y=Y.replace(P[de],"$1$2$3"),g("comparator trim",Y,P[de]),Y=(Y=(Y=Y.replace(P[R],"$1~")).replace(P[V],"$1^")).split(/\s+/).join(" ");var Ne=ge?P[L]:P[oe],xe=Y.split(" ").map(function(ke){return function(qe,j){return g("comp",qe),qe=function(Q,me){return Q.trim().split(/\s+/).map(function(Le){return function(Be,Xe){g("caret",Be,Xe);var Ze=Xe?P[K]:P[se];return Be.replace(Ze,function(rt,Ye,Je,je,lt){var st;return g("caret",Be,rt,Ye,Je,je,lt),B(Ye)?st="":B(Je)?st=">="+Ye+".0.0 <"+(+Ye+1)+".0.0":B(je)?st=Ye==="0"?">="+Ye+"."+Je+".0 <"+Ye+"."+(+Je+1)+".0":">="+Ye+"."+Je+".0 <"+(+Ye+1)+".0.0":lt?(g("replaceCaret pr",lt),lt.charAt(0)!=="-"&&(lt="-"+lt),st=Ye==="0"?Je==="0"?">="+Ye+"."+Je+"."+je+lt+" <"+Ye+"."+Je+"."+(+je+1):">="+Ye+"."+Je+"."+je+lt+" <"+Ye+"."+(+Je+1)+".0":">="+Ye+"."+Je+"."+je+lt+" <"+(+Ye+1)+".0.0"):(g("no pr"),st=Ye==="0"?Je==="0"?">="+Ye+"."+Je+"."+je+" <"+Ye+"."+Je+"."+(+je+1):">="+Ye+"."+Je+"."+je+" <"+Ye+"."+(+Je+1)+".0":">="+Ye+"."+Je+"."+je+" <"+(+Ye+1)+".0.0"),g("caret return",st),st})}(Le,me)}).join(" ")}(qe,j),g("caret",qe),qe=function(Q,me){return Q.trim().split(/\s+/).map(function(Le){return function(Be,Xe){var Ze=Xe?P[x]:P[E];return Be.replace(Ze,function(rt,Ye,Je,je,lt){var st;return g("tilde",Be,rt,Ye,Je,je,lt),B(Ye)?st="":B(Je)?st=">="+Ye+".0.0 <"+(+Ye+1)+".0.0":B(je)?st=">="+Ye+"."+Je+".0 <"+Ye+"."+(+Je+1)+".0":lt?(g("replaceTilde pr",lt),lt.charAt(0)!=="-"&&(lt="-"+lt),st=">="+Ye+"."+Je+"."+je+lt+" <"+Ye+"."+(+Je+1)+".0"):st=">="+Ye+"."+Je+"."+je+" <"+Ye+"."+(+Je+1)+".0",g("tilde return",st),st})}(Le,me)}).join(" ")}(qe,j),g("tildes",qe),qe=function(Q,me){return g("replaceXRanges",Q,me),Q.split(/\s+/).map(function(Le){return function(Be,Xe){Be=Be.trim();var Ze=Xe?P[C]:P[h];return Be.replace(Ze,function(rt,Ye,Je,je,lt,st){g("xRange",Be,rt,Ye,Je,je,lt,st);var It=B(Je),at=It||B(je),ht=at||B(lt);return Ye==="="&&ht&&(Ye=""),It?rt=Ye===">"||Ye==="<"?"<0.0.0":"*":Ye&&ht?(at&&(je=0),ht&&(lt=0),Ye===">"?(Ye=">=",at?(Je=+Je+1,je=0,lt=0):ht&&(je=+je+1,lt=0)):Ye==="<="&&(Ye="<",at?Je=+Je+1:je=+je+1),rt=Ye+Je+"."+je+"."+lt):at?rt=">="+Je+".0.0 <"+(+Je+1)+".0.0":ht&&(rt=">="+Je+"."+je+".0 <"+Je+"."+(+je+1)+".0"),g("xRange return",rt),rt})}(Le,me)}).join(" ")}(qe,j),g("xrange",qe),qe=function(Q,me){return g("replaceStars",Q,me),Q.trim().replace(P[ee],"")}(qe,j),g("stars",qe),qe}(ke,ge)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(ke){return!!ke.match(Ne)})),xe=xe.map(function(ke){return new X(ke,ge)})},T.prototype.intersects=function(Y,ge){if(!(Y instanceof T))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Ne){return Y.set.some(function(xe){return xe.every(function(ke){return Ne.intersects(ke,ge)})})})})},e.toComparators=function(Y,ge){return new T(Y,ge).set.map(function(pe){return pe.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},T.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new J(Y,this.loose));for(var ge=0;ge<this.set.length;ge++)if(H(this.set[ge],Y))return!0;return!1},e.satisfies=ne,e.maxSatisfying=function(Y,ge,pe){var Ne=null,xe=null;try{var ke=new T(ge,pe)}catch{return null}return Y.forEach(function(qe){ke.test(qe)&&(Ne&&xe.compare(qe)!==-1||(xe=new J(Ne=qe,pe)))}),Ne},e.minSatisfying=function(Y,ge,pe){var Ne=null,xe=null;try{var ke=new T(ge,pe)}catch{return null}return Y.forEach(function(qe){ke.test(qe)&&(Ne&&xe.compare(qe)!==1||(xe=new J(Ne=qe,pe)))}),Ne},e.validRange=function(Y,ge){try{return new T(Y,ge).range||"*"}catch{return null}},e.ltr=function(Y,ge,pe){return he(Y,ge,"<",pe)},e.gtr=function(Y,ge,pe){return he(Y,ge,">",pe)},e.outside=he,e.prerelease=function(Y,ge){var pe=we(Y,ge);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(Y,ge,pe){return Y=new T(Y,pe),ge=new T(ge,pe),Y.intersects(ge)},e.coerce=function(Y){if(Y instanceof J)return Y;if(typeof Y!="string")return null;var ge=Y.match(P[F]);return ge==null?null:we((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,a(1))},function(Z,e){var a,D,g=Z.exports={};function N(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(d){if(a===setTimeout)return setTimeout(d,0);if((a===N||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:N}catch{a=N}try{D=typeof clearTimeout=="function"?clearTimeout:I}catch{D=I}})();var w,A=[],O=!1,v=-1;function p(){O&&w&&(O=!1,w.length?A=w.concat(A):v=-1,A.length&&b())}function b(){if(!O){var d=P(p);O=!0;for(var c=A.length;c;){for(w=A,A=[];++v<c;)w&&w[v].run();v=-1,c=A.length}w=null,O=!1,function(y){if(D===clearTimeout)return clearTimeout(y);if((D===I||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(y);try{D(y)}catch{try{return D.call(null,y)}catch{return D.call(this,y)}}}(d)}}function f(d,c){this.fun=d,this.array=c}function u(){}g.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)c[y-1]=arguments[y];A.push(new f(d,c)),A.length!==1||O||P(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=u,g.addListener=u,g.once=u,g.off=u,g.removeListener=u,g.removeAllListeners=u,g.emit=u,g.prependListener=u,g.prependOnceListener=u,g.listeners=function(d){return[]},g.binding=function(d){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(d){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[107],De([1,0,12,7]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function g(l){const _=l;return _?typeof _.read=="function":!1}e.isReadable=g;function N(l){const _=l;return _?[_.on,_.pause,_.resume,_.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=N;function I(l){const _=l;return _?N(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=I;function P(l,_){return new w(l,_)}e.newWriteableStream=P;class w{constructor(_,r){this.reducer=_,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _!="undefined"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(r=>r(_))}emitError(_){this.listeners.error.length===0?(0,a.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(r=>r(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,r){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(_,r){if(this.state.destroyed)return;let k;switch(_){case"data":k=this.listeners.data;break;case"end":k=this.listeners.end;break;case"error":k=this.listeners.error;break}if(k){const i=k.indexOf(r);i>=0&&k.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(k=>k())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(l,_){const r=[];let k;for(;(k=l.read())!==null;)r.push(k);return _(r)}e.consumeReadable=A;function O(l,_,r){const k=[];let i;for(;(i=l.read())!==null&&k.length<r;)k.push(i);return i===null&&k.length>0?_(k):{read:()=>{if(k.length>0)return k.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return l.read()}}}e.peekReadable=O;function v(l,_){return new Promise((r,k)=>{const i=[];p(l,{onData:s=>{_&&i.push(s)},onError:s=>{_?k(s):r(void 0)},onEnd:()=>{r(_?_(i):void 0)}})})}e.consumeStream=v;function p(l,_){let r=!1;return l.on("error",k=>{r||_.onError(k)}),l.on("end",()=>{r||_.onEnd()}),l.on("data",k=>{r||_.onData(k)}),(0,D.toDisposable)(()=>r=!0)}e.listenStream=p;function b(l,_){return new Promise((r,k)=>{const i=new D.DisposableStore,s=[],n=m=>{if(s.push(m),s.length>_)return i.dispose(),l.pause(),r({stream:l,buffer:s,ended:!1})},t=m=>k(m),o=()=>r({stream:l,buffer:s,ended:!0});i.add((0,D.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),i.add((0,D.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),i.add((0,D.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=b;function f(l,_){const r=P(_);return r.end(l),r}e.toStream=f;function u(){const l=P(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=u;function d(l){let _=!1;return{read:()=>_?null:(_=!0,l)}}e.toReadable=d;function c(l,_,r){const k=P(r);return p(l,{onData:i=>k.write(_.data(i)),onError:i=>k.error(_.error?_.error(i):i),onEnd:()=>k.end()}),k}e.transform=c;function y(l,_,r){let k=!1;return{read:()=>{const i=_.read();return k?i:(k=!0,i!==null?r([l,i]):l)}}}e.prefixedReadable=y;function S(l,_,r){let k=!1;const i=P(r);return p(_,{onData:s=>k?i.write(s):(k=!0,i.write(r([l,s]))),onError:s=>i.error(s),onEnd:()=>{k||(k=!0,i.write(l)),i.end()}}),i}e.prefixedStream=S}),define(Se[25],De([1,0,107]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let g,N;class I{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return D?new I(Buffer.allocUnsafe(m)):new I(new Uint8Array(m))}static wrap(m){return D&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new I(m)}static fromString(m,h){return!(h?.dontUseNodeBuffer||!1)&&D?new I(Buffer.from(m)):(g||(g=new TextEncoder),new I(g.encode(m)))}static fromByteArray(m){const h=I.alloc(m.length);for(let C=0,F=m.length;C<F;C++)h.buffer[C]=m[C];return h}static concat(m,h){if(typeof h=="undefined"){h=0;for(let U=0,R=m.length;U<R;U++)h+=m[U].byteLength}const C=I.alloc(h);let F=0;for(let U=0,R=m.length;U<R;U++){const E=m[U];C.set(E,F),F+=E.byteLength}return C}clone(){const m=I.alloc(this.byteLength);return m.set(this),m}toString(){return D?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(m,h){return new I(this.buffer.subarray(m,h))}set(m,h){if(m instanceof I)this.buffer.set(m.buffer,h);else if(m instanceof Uint8Array)this.buffer.set(m,h);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),h);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return A(this.buffer,m)}writeUInt32BE(m,h){O(this.buffer,m,h)}readUInt32LE(m){return v(this.buffer,m)}writeUInt32LE(m,h){p(this.buffer,m,h)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,h){f(this.buffer,m,h)}}e.VSBuffer=I;function P(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0}e.readUInt16LE=P;function w(o,m,h){o[h+0]=m&255,m=m>>>8,o[h+1]=m&255}e.writeUInt16LE=w;function A(o,m){return o[m]*2**24+o[m+1]*2**16+o[m+2]*2**8+o[m+3]}e.readUInt32BE=A;function O(o,m,h){o[h+3]=m,m=m>>>8,o[h+2]=m,m=m>>>8,o[h+1]=m,m=m>>>8,o[h]=m}e.writeUInt32BE=O;function v(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0|o[m+2]<<16>>>0|o[m+3]<<24>>>0}e.readUInt32LE=v;function p(o,m,h){o[h+0]=m&255,m=m>>>8,o[h+1]=m&255,m=m>>>8,o[h+2]=m&255,m=m>>>8,o[h+3]=m&255}e.writeUInt32LE=p;function b(o,m){return o[m]}e.readUInt8=b;function f(o,m,h){o[h]=m}e.writeUInt8=f;function u(o){return a.consumeReadable(o,m=>I.concat(m))}e.readableToBuffer=u;function d(o){return a.toReadable(o)}e.bufferToReadable=d;function c(o){return a.consumeStream(o,m=>I.concat(m))}e.streamToBuffer=c;async function y(o){return o.ended?I.concat(o.buffer):I.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=y;function S(o){return a.toStream(o,m=>I.concat(m))}e.bufferToStream=S;function l(o){return a.transform(o,{data:m=>typeof m=="string"?I.fromString(m):I.wrap(m)},m=>I.concat(m))}e.streamToBufferReadableStream=l;function _(o){return a.newWriteableStream(m=>I.concat(m),o)}e.newWriteableBufferStream=_;function r(o,m){return a.prefixedReadable(o,m,h=>I.concat(h))}e.prefixedBufferReadable=r;function k(o,m){return a.prefixedStream(o,m,h=>I.concat(h))}e.prefixedBufferStream=k;function i(o){let m=0,h=0,C=0;const F=new Uint8Array(Math.floor(o.length/4*3)),U=E=>{switch(h){case 3:F[C++]=m|E,h=0;break;case 2:F[C++]=m|E>>>2,m=E<<6,h=3;break;case 1:F[C++]=m|E>>>4,m=E<<4,h=2;break;default:m=E<<2,h=1}};for(let E=0;E<o.length;E++){const x=o.charCodeAt(E);if(x>=65&&x<=90)U(x-65);else if(x>=97&&x<=122)U(x-97+26);else if(x>=48&&x<=57)U(x-48+52);else if(x===43||x===45)U(62);else if(x===47||x===95)U(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${o[E]}`)}}const R=C;for(;h>0;)U(0);return I.wrap(F).slice(0,R)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:o},m=!0,h=!1){const C=h?n:s;let F="";const U=o.byteLength%3;let R=0;for(;R<o.byteLength-U;R+=3){const E=o[R+0],x=o[R+1],z=o[R+2];F+=C[E>>>2],F+=C[(E<<4|x>>>4)&63],F+=C[(x<<2|z>>>6)&63],F+=C[z&63]}if(U===1){const E=o[R+0];F+=C[E>>>2],F+=C[E<<4&63],m&&(F+="==")}else if(U===2){const E=o[R+0],x=o[R+1];F+=C[E>>>2],F+=C[(E<<4|x>>>4)&63],F+=C[x<<2&63],m&&(F+="=")}return F}e.encodeBase64=t});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[21],De([1,0,15,9]),function(Z,e,a,D){"use strict";var g,N,I,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function w(n,t,o){let m=n.get(t);return m===void 0&&(m=o,n.set(t,m)),m}e.getOrSet=w;function A(n){const t=[];return n.forEach((o,m)=>{t.push(`${m} => ${o}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=A;function O(n){const t=[];return n.forEach(o=>{t.push(o)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=O;class v{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),m=this._value.charCodeAt(this._pos);return o-m}value(){return this._value[this._pos]}}e.StringIterator=v;class p{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,D.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class b{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const m=this._value.charCodeAt(o);if(!(m===47||this._splitOnBackslash&&m===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,D.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var f;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(t,o){this._ignorePathCasing=t,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,D.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(c||(c={}));class y{constructor(t){this._iter=t}static forUris(t=()=>!1,o=()=>!1){return new y(new u(t,o))}static forPaths(t=!1){return new y(new b(void 0,!t))}static forStrings(){return new y(new v)}static forConfigKeys(){return new y(new p)}clear(){this._root=void 0}fill(t,o){if(o){const m=o.slice(0);(0,a.shuffle)(m);for(let h of m)this.set(h,t)}else{const m=t.slice(0);(0,a.shuffle)(m);for(let h of m)this.set(h[0],h[1])}}set(t,o){const m=this._iter.reset(t);let h;this._root||(this._root=new d,this._root.segment=m.value());const C=[];for(h=this._root;;){const U=m.cmp(h.segment);if(U>0)h.left||(h.left=new d,h.left.segment=m.value()),C.push([-1,h]),h=h.left;else if(U<0)h.right||(h.right=new d,h.right.segment=m.value()),C.push([1,h]),h=h.right;else if(m.hasNext())m.next(),h.mid||(h.mid=new d,h.mid.segment=m.value()),C.push([0,h]),h=h.mid;else break}const F=h.value;h.value=o,h.key=t;for(let U=C.length-1;U>=0;U--){const R=C[U][1];R.updateHeight();const E=R.balanceFactor();if(E<-1||E>1){const x=C[U][0],z=C[U+1][0];if(x===1&&z===1)C[U][1]=R.rotateLeft();else if(x===-1&&z===-1)C[U][1]=R.rotateRight();else if(x===1&&z===-1)R.right=C[U+1][1]=C[U+1][1].rotateRight(),C[U][1]=R.rotateLeft();else if(x===-1&&z===1)R.left=C[U+1][1]=C[U+1][1].rotateLeft(),C[U][1]=R.rotateRight();else throw new Error;if(U>0)switch(C[U-1][0]){case-1:C[U-1][1].left=C[U][1];break;case 1:C[U-1][1].right=C[U][1];break;case 0:C[U-1][1].mid=C[U][1];break}else this._root=C[0][1]}}return F}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let m=this._root;for(;m;){const h=o.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(o.hasNext())o.next(),m=m.mid;else break}return m}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const m=this._iter.reset(t),h=[];let C=this._root;for(;C;){const F=m.cmp(C.segment);if(F>0)h.push([-1,C]),C=C.left;else if(F<0)h.push([1,C]),C=C.right;else if(m.hasNext())m.next(),h.push([0,C]),C=C.mid;else break}if(!!C){if(o?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const F=this._min(C.right),{key:U,value:R,segment:E}=F;this._delete(F.key,!1),C.key=U,C.value=R,C.segment=E}else{const F=C.left??C.right;if(h.length>0){const[U,R]=h[h.length-1];switch(U){case-1:R.left=F;break;case 0:R.mid=F;break;case 1:R.right=F;break}}else this._root=F}for(let F=h.length-1;F>=0;F--){const U=h[F][1];U.updateHeight();const R=U.balanceFactor();if(R>1?(U.right.balanceFactor()>=0||(U.right=U.right.rotateRight()),h[F][1]=U.rotateLeft()):R<-1&&(U.left.balanceFactor()<=0||(U.left=U.left.rotateLeft()),h[F][1]=U.rotateRight()),F>0)switch(h[F-1][0]){case-1:h[F-1][1].left=h[F][1];break;case 1:h[F-1][1].right=h[F][1];break;case 0:h[F-1][1].mid=h[F][1];break}else this._root=h[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let m=this._root,h;for(;m;){const C=o.cmp(m.segment);if(C>0)m=m.left;else if(C<0)m=m.right;else if(o.hasNext())o.next(),h=m.value||h,m=m.mid;else break}return m&&m.value||h}findSuperstr(t){const o=this._iter.reset(t);let m=this._root;for(;m;){const h=o.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(o.hasNext())o.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(t){for(const[o,m]of this)t(m,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const m=o.balanceFactor();return m<-1||m>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=y;class S{constructor(t,o){this.uri=t,this.value=o}}class l{constructor(t,o){this[g]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=o??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new S(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[m,h]of this.map)t(h.value,h.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=n=>n.toString();class _{constructor(t,o){this[N]="ResourceSet",!t||typeof t=="function"?this._map=new l(t):(this._map=new l(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((m,h)=>t.call(o,h,h,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=_;var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class k{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const m=this._map.get(t);if(!!m)return o!==0&&this.touch(m,o),m.value}set(t,o,m=0){let h=this._map.get(t);if(h)h.value=o,m!==0&&this.touch(h,m);else{switch(h={key:t,value:o,next:void 0,previous:void 0},m){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(t,h),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const m=this._state;let h=this._head;for(;h;){if(o?t.bind(o)(h.value,h.key,this):t(h.value,h.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const t=this,o=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.key,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return h}values(){const t=this,o=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.value,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return h}entries(){const t=this,o=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:[m.key,m.value],done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return h}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,m=this.size;for(;o&&m>t;)this._map.delete(o.key),o=o.next,m--;this._head=o,this._size=m,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,m=t.previous;if(!o||!m)throw new Error("Invalid list");o.previous=m,m.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const m=t.next,h=t.previous;t===this._tail?(h.next=void 0,this._tail=h):(m.previous=h,h.next=m),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const m=t.next,h=t.previous;t===this._head?(m.previous=void 0,this._head=m):(m.previous=h,h.next=m),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,m)=>{t.push([m,o])}),t}fromJSON(t){this.clear();for(const[o,m]of t)this.set(o,m)}}e.LinkedMap=k;class i extends k{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(t){P.set(this,void 0),Qe(this,P,t,"f")}get size(){return Re(this,P,"f").size}forEach(t,o){Re(this,P,"f").forEach(t,o)}get(t){return Re(this,P,"f").get(t)}has(t){return Re(this,P,"f").has(t)}entries(){return Re(this,P,"f").entries()}keys(){return Re(this,P,"f").keys()}values(){return Re(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Re(this,P,"f").entries()}}e.ReadonlyMapView=s}),define(Se[108],De([1,0,21,9]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...X){return function(G,T){for(let B=0,W=X.length;B<W;B++){const H=X[B](G,T);if(H)return H}return null}}e.or=g,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(X,G,T){if(!T||T.length<G.length)return null;let B;return X?B=D.startsWithIgnoreCase(T,G):B=T.indexOf(G)===0,B?G.length>0?[{start:0,end:G.length}]:[]:null}function I(X,G){const T=G.toLowerCase().indexOf(X.toLowerCase());return T===-1?null:[{start:T,end:T+X.length}]}e.matchesContiguousSubString=I;function P(X,G){return w(X.toLowerCase(),G.toLowerCase(),0,0)}e.matchesSubString=P;function w(X,G,T,B){if(T===X.length)return[];if(B===G.length)return null;if(X[T]===G[B]){let W=null;return(W=w(X,G,T+1,B+1))?c({start:B,end:B+1},W):null}return w(X,G,T,B+1)}function A(X){return 97<=X&&X<=122}function O(X){return 65<=X&&X<=90}e.isUpper=O;function v(X){return 48<=X&&X<=57}function p(X){return X===32||X===9||X===10||X===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(X=>b.add(X.charCodeAt(0)));function f(X){return p(X)||b.has(X)}function u(X,G){return X===G||f(X)&&f(G)}function d(X){return A(X)||O(X)||v(X)}function c(X,G){return G.length===0?G=[X]:X.end===G[0].start?G[0].start=X.start:G.unshift(X),G}function y(X,G){for(let T=G;T<X.length;T++){const B=X.charCodeAt(T);if(O(B)||v(B)||T>0&&!d(X.charCodeAt(T-1)))return T}return X.length}function S(X,G,T,B){if(T===X.length)return[];if(B===G.length)return null;if(X[T]!==G[B].toLowerCase())return null;{let W=null,H=B+1;for(W=S(X,G,T+1,B+1);!W&&(H=y(G,H))<G.length;)W=S(X,G,T+1,H),H++;return W===null?null:c({start:B,end:B+1},W)}}function l(X){let G=0,T=0,B=0,W=0,H=0;for(let pe=0;pe<X.length;pe++)H=X.charCodeAt(pe),O(H)&&G++,A(H)&&T++,d(H)&&B++,v(H)&&W++;const ne=G/X.length,he=T/X.length,Y=B/X.length,ge=W/X.length;return{upperPercent:ne,lowerPercent:he,alphaPercent:Y,numericPercent:ge}}function _(X){const{upperPercent:G,lowerPercent:T}=X;return T===0&&G>.6}function r(X){const{upperPercent:G,lowerPercent:T,alphaPercent:B,numericPercent:W}=X;return T>.2&&G<.8&&B>.6&&W<.2}function k(X){let G=0,T=0,B=0,W=0;for(let H=0;H<X.length;H++)B=X.charCodeAt(H),O(B)&&G++,A(B)&&T++,p(B)&&W++;return(G===0||T===0)&&W===0?X.length<=30:G<=5}function i(X,G){if(!G||(G=G.trim(),G.length===0)||!k(X)||G.length>60)return null;const T=l(G);if(!r(T)){if(!_(T))return null;G=G.toLowerCase()}let B=null,W=0;for(X=X.toLowerCase();W<G.length&&(B=S(X,G,0,W))===null;)W=y(G,W+1);return B}e.matchesCamelCase=i;function s(X,G,T=!1){if(!G||G.length===0)return null;let B=null,W=0;for(X=X.toLowerCase(),G=G.toLowerCase();W<G.length&&(B=n(X,G,0,W,T))===null;)W=t(G,W+1);return B}e.matchesWords=s;function n(X,G,T,B,W){if(T===X.length)return[];if(B===G.length)return null;if(u(X.charCodeAt(T),G.charCodeAt(B))){let H=null,ne=B+1;if(H=n(X,G,T+1,B+1,W),!W)for(;!H&&(ne=t(G,ne))<G.length;)H=n(X,G,T+1,ne,W),ne++;return H===null?null:c({start:B,end:B+1},H)}else return null}function t(X,G){for(let T=G;T<X.length;T++)if(f(X.charCodeAt(T))||T>0&&f(X.charCodeAt(T-1)))return T;return X.length}const o=g(e.matchesPrefix,i,I),m=g(e.matchesPrefix,i,P),h=new a.LRUCache(1e4);function C(X,G,T=!1){if(typeof X!="string"||typeof G!="string")return null;let B=h.get(X);B||(B=new RegExp(D.convertSimple2RegExpPattern(X),"i"),h.set(X,B));const W=B.exec(G);return W?[{start:W.index,end:W.index+W[0].length}]:T?m(X,G):o(X,G)}e.matchesFuzzy=C;function F(X,G){const T=We(X,X.toLowerCase(),0,G,G.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?R(T):null}e.matchesFuzzy2=F;function U(X,G,T,B,W,H){const ne=Math.min(13,X.length);for(;T<ne;T++){const he=We(X,G,T,B,W,H,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(he)return he}return[0,H]}e.anyScore=U;function R(X){if(typeof X=="undefined")return[];const G=[],T=X[1];for(let B=X.length-1;B>1;B--){const W=X[B]+T,H=G[G.length-1];H&&H.end===W?H.end=W+1:G.push({start:W,end:W+1})}return G}e.createMatches=R;const E=128;function x(){const X=[],G=[];for(let T=0;T<=E;T++)G[T]=0;for(let T=0;T<=E;T++)X.push(G.slice(0));return X}function z(X){const G=[];for(let T=0;T<=X;T++)G[T]=0;return G}const V=z(2*E),se=z(2*E),K=x(),L=x(),oe=x(),de=!1;function ae(X,G,T,B,W){function H(he,Y,ge=" "){for(;he.length<Y;)he=ge+he;return he}let ne=` |   |${B.split("").map(he=>H(he,3)).join("|")}
`;for(let he=0;he<=T;he++)he===0?ne+=" |":ne+=`${G[he-1]}|`,ne+=X[he].slice(0,W+1).map(Y=>H(Y.toString(),3)).join("|")+`
`;return ne}function fe(X,G,T,B){X=X.substr(G),T=T.substr(B),console.log(ae(L,X,X.length,T,T.length)),console.log(ae(oe,X,X.length,T,T.length)),console.log(ae(K,X,X.length,T,T.length))}function ee(X,G){if(G<0||G>=X.length)return!1;const T=X.codePointAt(G);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(T)}}function Ee(X,G){if(G<0||G>=X.length)return!1;switch(X.charCodeAt(G)){case 32:case 9:return!0;default:return!1}}function we(X,G,T){return G[X]!==T[X]}function J(X,G,T,B,W,H,ne=!1){for(;G<T&&W<H;)X[G]===B[W]&&(ne&&(V[G]=W),G+=1),W+=1;return G===T}e.isPatternInWord=J;var ve;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(X){X.Default=[-100,0];function G(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}X.isDefault=G})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(G,T){this.firstMatchCanBeWeak=G,this.boostFullMatch=T}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(X,G,T,B,W,H,ne=Fe.default){const he=X.length>E?E:X.length,Y=B.length>E?E:B.length;if(T>=he||H>=Y||he-T>Y-H||!J(G,T,he,W,H,Y,!0))return;Ge(he,Y,T,H,G,W);let ge=1,pe=1,Ne=T,xe=H;const ke=[!1];for(ge=1,Ne=T;Ne<he;ge++,Ne++){const Le=V[Ne],Be=se[Ne],Xe=Ne+1<he?se[Ne+1]:Y;for(pe=Le-H+1,xe=Le;xe<Xe;pe++,xe++){let Ze=Number.MIN_SAFE_INTEGER,rt=!1;xe<=Be&&(Ze=Ie(X,G,Ne,T,B,W,xe,Y,H,K[ge-1][pe-1]===0,ke));let Ye=0;Ze!==Number.MAX_SAFE_INTEGER&&(rt=!0,Ye=Ze+L[ge-1][pe-1]);const Je=xe>Le,je=Je?L[ge][pe-1]+(K[ge][pe-1]>0?-5:0):0,lt=xe>Le+1&&K[ge][pe-1]>0,st=lt?L[ge][pe-2]+(K[ge][pe-2]>0?-5:0):0;if(lt&&(!Je||st>=je)&&(!rt||st>=Ye))L[ge][pe]=st,oe[ge][pe]=3,K[ge][pe]=0;else if(Je&&(!rt||je>=Ye))L[ge][pe]=je,oe[ge][pe]=2,K[ge][pe]=0;else if(rt)L[ge][pe]=Ye,oe[ge][pe]=1,K[ge][pe]=K[ge-1][pe-1]+1;else throw new Error("not possible")}}if(de&&fe(X,T,B,H),!ke[0]&&!ne.firstMatchCanBeWeak)return;ge--,pe--;const qe=[L[ge][pe],H];let j=0,Q=0;for(;ge>=1;){let Le=pe;do{const Be=oe[ge][Le];if(Be===3)Le=Le-2;else if(Be===2)Le=Le-1;else break}while(Le>=1);j>1&&G[T+ge-1]===W[H+pe-1]&&!we(Le+H-1,B,W)&&j+1>K[ge][Le]&&(Le=pe),Le===pe?j++:j=1,Q||(Q=Le),ge--,pe=Le-1,qe.push(pe)}Y===he&&ne.boostFullMatch&&(qe[0]+=2);const me=Q-he;return qe[0]-=me,qe}e.fuzzyScore=We;function Ge(X,G,T,B,W,H){let ne=X-1,he=G-1;for(;ne>=T&&he>=B;)W[ne]===H[he]&&(se[ne]=he,ne--),he--}function Ie(X,G,T,B,W,H,ne,he,Y,ge,pe){if(G[T]!==H[ne])return Number.MIN_SAFE_INTEGER;let Ne=1,xe=!1;return ne===T-B?Ne=X[T]===W[ne]?7:5:we(ne,W,H)&&(ne===0||!we(ne-1,W,H))?(Ne=X[T]===W[ne]?7:5,xe=!0):ee(H,ne)&&(ne===0||!ee(H,ne-1))?Ne=5:(ee(H,ne-1)||Ee(H,ne-1))&&(Ne=5,xe=!0),Ne>1&&T===B&&(pe[0]=!0),xe||(xe=we(ne,W,H)||ee(H,ne-1)||Ee(H,ne-1)),T===B?ne>Y&&(Ne-=xe?3:5):ge?Ne+=xe?2:0:Ne+=xe?0:1,ne+1===he&&(Ne-=xe?3:5),Ne}function _e(X,G,T,B,W,H,ne){return re(X,G,T,B,W,H,!0,ne)}e.fuzzyScoreGracefulAggressive=_e;function Ce(X,G,T,B,W,H,ne){return re(X,G,T,B,W,H,!1,ne)}e.fuzzyScoreGraceful=Ce;function re(X,G,T,B,W,H,ne,he){let Y=We(X,G,T,B,W,H,he);if(Y&&!ne)return Y;if(X.length>=3){const ge=Math.min(7,X.length-1);for(let pe=T+1;pe<ge;pe++){const Ne=le(X,pe);if(Ne){const xe=We(Ne,Ne.toLowerCase(),T,B,W,H,he);xe&&(xe[0]-=3,(!Y||xe[0]>Y[0])&&(Y=xe))}}}return Y}function le(X,G){if(G+1>=X.length)return;const T=X[G],B=X[G+1];if(T!==B)return X.slice(0,G)+B+T+X.slice(G+2)}}),define(Se[109],De([1,0,110,108,9]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const N=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(a.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${N.source}`,"g");function w(d){return d.replace(P,(c,y)=>y?c:`\\${c}`)}e.escapeIcons=w;const A=new RegExp(`\\\\${N.source}`,"g");function O(d){return d.replace(A,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=O;const v=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function p(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(v,(c,y,S,l)=>S?c:y||l||"")}e.stripIcons=p;function b(d){const c=d.indexOf(e.iconStartMarker);return c===-1?{text:d}:f(d,c)}e.parseLabelWithIcons=b;function f(d,c){const y=[];let S="";function l(o){if(o){S+=o;for(const m of o)y.push(k)}}let _=-1,r="",k=0,i,s,n=c;const t=d.length;for(l(d.substr(0,c));n<t;)i=d[n],s=d[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(_=n,l(r),r=e.iconStartMarker,n++):i===")"&&_!==-1?(k+=n-_+1,_=-1,r=""):_!==-1?I.test(i)?r+=i:(l(r),_=-1,r=""):l(i),n++;return l(r),{text:S,iconOffsets:y}}function u(d,c,y=!1){const{text:S,iconOffsets:l}=c;if(!l||l.length===0)return(0,D.matchesFuzzy)(d,S,y);const _=(0,g.ltrim)(S," "),r=S.length-_.length,k=(0,D.matchesFuzzy)(d,_,y);if(k)for(const i of k){const s=l[i.start+r]+r;i.start+=s,i.end+=s}return k}e.matchesFuzzyIconAware=u}),define(Se[32],De([1,0,9]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(D||(D={})),function(g){const N="error",I="warning",P="warn",w="info",A="ignore";function O(p){return p?a.equalsIgnoreCase(N,p)?g.Error:a.equalsIgnoreCase(I,p)||a.equalsIgnoreCase(P,p)?g.Warning:a.equalsIgnoreCase(w,p)?g.Info:g.Ignore:g.Ignore}g.fromValue=O;function v(p){switch(p){case g.Error:return N;case g.Warning:return I;case g.Info:return w;default:return A}}g.toString=v}(D||(D={})),e.default=D}),define(Se[37],De([1,0,17,22,9,10]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(n){return n===47||n===92}e.isPathSeparator=I;function P(n){return n.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function w(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=w;function A(n,t=a.posix.sep){if(!n)return"";const o=n.length,m=n.charCodeAt(0);if(I(m)){if(I(n.charCodeAt(1))&&!I(n.charCodeAt(2))){let C=3;const F=C;for(;C<o&&!I(n.charCodeAt(C));C++);if(F!==C&&!I(n.charCodeAt(C+1))){for(C+=1;C<o;C++)if(I(n.charCodeAt(C)))return n.slice(0,C+1).replace(/[\\/]/g,t)}}return t}else if(c(m)&&n.charCodeAt(1)===58)return I(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(I(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=A;function O(n){if(!D.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let o=2;const m=o;for(;o<n.length&&(t=n.charCodeAt(o),t!==92);o++);return!(m===o||(t=n.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=O;const v=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=D.isWindows){const o=t?v:p;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||t&&b.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function u(n,t,o){const m=n===t;return!o||m?m:!n||!t?!1:(0,g.equalsIgnoreCase)(n,t)}e.isEqual=u;function d(n,t,o,m=a.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(o){if(!(0,g.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let C=t.length;return t.charAt(t.length-1)===m&&C--,n.charAt(C)===m}return t.charAt(t.length-1)!==m&&(t+=m),n.indexOf(t)===0}e.isEqualOrParent=d;function c(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=c;function y(n,t){return D.isWindows&&n.endsWith(":")&&(n+=a.sep),(0,a.isAbsolute)(n)||(n=(0,a.join)(t,n)),n=(0,a.normalize)(n),D.isWindows?(n=(0,g.rtrim)(n,a.sep),n.endsWith(":")&&(n+=a.sep)):(n=(0,g.rtrim)(n,a.sep),n||(n=a.sep)),n}e.sanitizeFilePath=y;function S(n){const t=(0,a.normalize)(n);return D.isWindows?n.length>3?!1:l(t)&&(n.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=S;function l(n,t=D.isWindows){return t?c(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function _(n){return l(n)?n[0]:void 0}e.getDriveLetter=_;function r(n,t,o){return t.length>n.length?-1:n===t?0:(o&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function k(n){const t=n.split(":");let o,m,h;for(const C of t){const F=Number(C);(0,N.isNumber)(F)?m===void 0?m=F:h===void 0&&(h=F):o=o?[o,C].join(":"):C}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:h!==void 0?h:m!==void 0?1:void 0}}e.parseLineAndColumnAware=k;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,t,o=8){let m="";for(let C=0;C<o;C++)m+=i.charAt(Math.floor(Math.random()*i.length));let h;return t?h=`${t}-${m}`:h=m,n?(0,a.join)(n,h):h}e.randomPath=s}),define(Se[57],De([1,0,25,9,2]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(A){return JSON.stringify(A,P)}e.stringify=N;function I(A){let O=JSON.parse(A);return O=w(O),O}e.parse=I;function P(A,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function w(A,O=0){if(!A||O>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return g.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof a.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let v=0;v<A.length;++v)A[v]=w(A[v],O+1);else for(const v in A)Object.hasOwnProperty.call(A,v)&&(A[v]=w(A[v],O+1))}return A}e.revive=w}),define(Se[11],De([1,0,22,2]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var g;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(g=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${g.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${g.vscodeRemoteResource}`}set(w,A,O){this._hosts[w]=A,this._ports[w]=O}setConnectionToken(w,A){this._connectionTokens[w]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const A=w.authority;let O=this._hosts[A];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const v=this._ports[A],p=this._connectionTokens[A];let b=`path=${encodeURIComponent(w.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),D.URI.from({scheme:a.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${O}:${v}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new N;class I{asBrowserUri(w,A){const O=this.toUri(w,A);return O.scheme===g.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===g.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${g.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?O.with({scheme:g.vscodeFileResource,authority:O.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(w,A){const O=this.toUri(w,A);return O.scheme===g.vscodeFileResource?O.with({scheme:g.file,authority:O.authority!==I.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(w,A){return D.URI.isUri(w)?w:D.URI.parse(A.toUrl(w))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Se[23],De([1,0,37,11,17,22,9,2]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=w;class A{constructor(f){this._ignorePathCasing=f}compare(f,u,d=!1){return f===u?0:(0,I.compare)(this.getComparisonKey(f,d),this.getComparisonKey(u,d))}isEqual(f,u,d=!1){return f===u?!0:!f||!u?!1:this.getComparisonKey(f,d)===this.getComparisonKey(u,d)}getComparisonKey(f,u=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,u,d=!1){if(f.scheme===u.scheme){if(f.scheme===D.Schemas.file)return a.isEqualOrParent(w(f),w(u),this._ignorePathCasing(f))&&f.query===u.query&&(d||f.fragment===u.fragment);if((0,e.isEqualAuthority)(f.authority,u.authority))return a.isEqualOrParent(f.path,u.path,this._ignorePathCasing(f),"/")&&f.query===u.query&&(d||f.fragment===u.fragment)}return!1}joinPath(f,...u){return P.URI.joinPath(f,...u)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return g.posix.basename(f.path)}extname(f){return g.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let u;return f.scheme===D.Schemas.file?u=P.URI.file(g.dirname(w(f))).path:(u=g.posix.dirname(f.path),f.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),u="/")),f.with({path:u})}normalizePath(f){if(!f.path.length)return f;let u;return f.scheme===D.Schemas.file?u=P.URI.file(g.normalize(w(f))).path:u=g.posix.normalize(f.path),f.with({path:u})}relativePath(f,u){if(f.scheme!==u.scheme||!(0,e.isEqualAuthority)(f.authority,u.authority))return;if(f.scheme===D.Schemas.file){const y=g.relative(w(f),w(u));return N.isWindows?a.toSlashes(y):y}let d=f.path||"/",c=u.path||"/";if(this._ignorePathCasing(f)){let y=0;for(const S=Math.min(d.length,c.length);y<S&&!(d.charCodeAt(y)!==c.charCodeAt(y)&&d.charAt(y).toLowerCase()!==c.charAt(y).toLowerCase());y++);d=c.substr(0,y)+d.substr(y)}return g.posix.relative(d,c)}resolvePath(f,u){if(f.scheme===D.Schemas.file){const d=P.URI.file(g.resolve(w(f),u));return f.with({authority:d.authority,path:d.path})}return u=a.toPosixPath(u),f.with({path:g.posix.resolve(f.path,u)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,u){return f===u||f!==void 0&&u!==void 0&&(0,I.equalsIgnoreCase)(f,u)}hasTrailingPathSeparator(f,u=g.sep){if(f.scheme===D.Schemas.file){const d=w(f);return d.length>a.getRoot(d).length&&d[d.length-1]===u}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,u=g.sep){return(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,u=g.sep){let d=!1;if(f.scheme===D.Schemas.file){const c=w(f);d=c!==void 0&&c.length===a.getRoot(c).length&&c[c.length-1]===u}else{u="/";const c=f.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path+"/"}):f}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(b=>b.scheme===D.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new A(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,f){const u=[];for(let d=0;d<b.length;d++){const c=f(b[d]);b.some((y,S)=>S===d?!1:(0,e.isEqualOrParent)(c,f(y)))||u.push(b[d])}return u}e.distinctParents=O;var v;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(u){const d=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(S=>{const[l,_]=S.split(":");l&&_&&d.set(l,_)});const y=u.path.substring(0,u.path.indexOf(";"));return y&&d.set(b.META_DATA_MIME,y),d}b.parseMetaData=f})(v=e.DataUri||(e.DataUri={}));function p(b,f,u){if(f){let d=b.path;return d&&d[0]!==g.posix.sep&&(d=g.posix.sep+d),b.with({scheme:u,authority:f,path:d})}return b.with({scheme:u})}e.toLocalResource=p}),define(Se[14],De([1,0,20,12,5,7,23,22]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(we){return!!we&&typeof we.then=="function"}e.isThenable=w;function A(we){const J=new a.CancellationTokenSource,ve=we(J.token),Pe=new Promise((Fe,We)=>{const Ge=J.token.onCancellationRequested(()=>{Ge.dispose(),J.dispose(),We(new D.CancellationError)});Promise.resolve(ve).then(Ie=>{Ge.dispose(),J.dispose(),Fe(Ie)},Ie=>{Ge.dispose(),J.dispose(),We(Ie)})});return new class{cancel(){J.cancel()}then(Fe,We){return Pe.then(Fe,We)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=A;function O(we,J,ve){return new Promise((Pe,Fe)=>{const We=J.onCancellationRequested(()=>{We.dispose(),Pe(ve)});we.then(Pe,Fe).finally(()=>We.dispose())})}e.raceCancellation=O;function v(we,J){return new Promise((ve,Pe)=>{const Fe=J.onCancellationRequested(()=>{Fe.dispose(),Pe(new D.CancellationError)});we.then(ve,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=v;async function p(we){let J=-1;const ve=we.map((Fe,We)=>Fe.then(Ge=>(J=We,Ge))),Pe=await Promise.race(ve);return we.forEach((Fe,We)=>{We!==J&&Fe.cancel()}),Pe}e.raceCancellablePromises=p;function b(we,J,ve){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),ve?.()},J);return Promise.race([we.finally(()=>clearTimeout(Fe)),new Promise(We=>Pe=We)])}e.raceTimeout=b;function f(we){return new Promise((J,ve)=>{const Pe=we();w(Pe)?Pe.then(J,ve):J(Pe)})}e.asPromise=f;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(J){if(this.activePromise){if(this.queuedPromiseFactory=J,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(ve,ve).then(Pe)})}return new Promise((ve,Pe)=>{this.queuedPromise.then(ve,Pe)})}return this.activePromise=J(),new Promise((ve,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=u;class d{constructor(){this.current=Promise.resolve(null)}queue(J){return this.current=this.current.then(()=>J(),()=>J())}}e.Sequencer=d;class c{constructor(){this.promiseMap=new Map}queue(J,ve){const Fe=(this.promiseMap.get(J)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(J)===Fe&&this.promiseMap.delete(J)});return this.promiseMap.set(J,Fe),Fe}}e.SequencerByKey=c;const y=(we,J)=>{let ve=!0;const Pe=setTimeout(()=>{ve=!1,J()},we);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Pe),ve=!1}}},S=we=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,we())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(J){this.defaultDelay=J,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(J,ve=this.defaultDelay){this.task=J,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,We)=>{this.doResolve=Fe,this.doReject=We}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?S(Pe):y(ve,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class _{constructor(J){this.delayer=new l(J),this.throttler=new u}trigger(J,ve){return this.delayer.trigger(()=>this.throttler.queue(J),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class r{constructor(){this._isOpen=!1,this._promise=new Promise((J,ve)=>{this._completePromise=J})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class k extends r{constructor(J){super();this._timeout=setTimeout(()=>this.open(),J)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=k;function i(we,J){return J?new Promise((ve,Pe)=>{const Fe=setTimeout(()=>{We.dispose(),ve()},we),We=J.onCancellationRequested(()=>{clearTimeout(Fe),We.dispose(),Pe(new D.CancellationError)})}):A(ve=>i(we,ve))}e.timeout=i;function s(we,J=0){const ve=setTimeout(we,J);return(0,N.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=s;function n(we){const J=[];let ve=0;const Pe=we.length;function Fe(){return ve<Pe?we[ve++]():null}function We(Ge){Ge!=null&&J.push(Ge);const Ie=Fe();return Ie?Ie.then(We):Promise.resolve(J)}return Promise.resolve(null).then(We)}e.sequence=n;function t(we,J=Pe=>!!Pe,ve=null){let Pe=0;const Fe=we.length,We=()=>{if(Pe>=Fe)return Promise.resolve(ve);const Ge=we[Pe++];return Promise.resolve(Ge()).then(_e=>J(_e)?Promise.resolve(_e):We())};return We()}e.first=t;function o(we,J=Pe=>!!Pe,ve=null){if(we.length===0)return Promise.resolve(ve);let Pe=we.length;const Fe=()=>{Pe=-1;for(const We of we)We.cancel?.()};return new Promise((We,Ge)=>{for(const Ie of we)Ie.then(_e=>{--Pe>=0&&J(_e)?(Fe(),We(_e)):Pe===0&&We(ve)}).catch(_e=>{--Pe>=0&&(Fe(),Ge(_e))})})}e.firstParallel=o;class m{constructor(J){this._size=0,this.maxDegreeOfParalellism=J,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new g.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(J){return this._size++,new Promise((ve,Pe)=>{this.outstandingPromises.push({factory:J,c:ve,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const J=this.outstandingPromises.shift();this.runningPromises++;const ve=J.factory();ve.then(J.c,J.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class h extends m{constructor(){super(1)}}e.Queue=h;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const J=new oe;return this.drainers.add(J),J.p}isDrained(){for(const[,J]of this.queues)if(J.size>0)return!1;return!0}queueFor(J,ve=I.extUri){const Pe=ve.getComparisonKey(J);let Fe=this.queues.get(Pe);return Fe||(Fe=new h,g.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const J of this.drainers)J.complete();this.drainers.clear()}dispose(){for(const[,J]of this.queues)J.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class F{constructor(J,ve){this._token=-1,typeof J=="function"&&typeof ve=="number"&&this.setIfNotSet(J,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(J,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,J()},ve)}setIfNotSet(J,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,J()},ve))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(J,ve){this.cancel(),this._token=setInterval(()=>{J()},ve)}}e.IntervalTimer=U;class R{constructor(J,ve){this.timeoutToken=-1,this.runner=J,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(J=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,J)}get delay(){return this.timeout}set delay(J){this.timeout=J}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class E{constructor(J,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=J,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(J=this.timeout){J%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(J/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class x extends R{constructor(J,ve){super(J,ve);this.units=[]}work(J){this.units.push(J),this.isScheduled()||this.schedule()}doRun(){const J=this.units;this.units=[],this.runner&&this.runner(J)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class z extends N.Disposable{constructor(J,ve){super();this.options=J,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(J){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+J.length>this.options.maxBufferedWork)return!1}else if(this.pending+J.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...J),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=we=>{(0,P.setTimeout0)(()=>{if(J)return;const ve=Date.now()+15;we(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(we,J)=>{const ve=requestIdleCallback(we,typeof J=="number"?{timeout:J}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(ve))}}}}();class V{constructor(J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function se(we,J,ve){let Pe;for(let Fe=0;Fe<ve;Fe++)try{return await we()}catch(We){Pe=We,await i(J)}throw Pe}e.retry=se;class K{hasPending(J){return this._pending?typeof J=="number"?this._pending.taskId===J:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(J,ve,Pe){return this._pending={taskId:J,cancel:()=>Pe?.(),promise:ve},ve.then(()=>this.donePending(J),()=>this.donePending(J)),ve}donePending(J){this._pending&&J===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const J=this._next;this._next=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this._next)this._next.run=J;else{let ve,Pe;const Fe=new Promise((We,Ge)=>{ve=We,Pe=Ge});this._next={run:J,promise:Fe,promiseResolve:ve,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=K;class L{constructor(J,ve=()=>Date.now()){this.interval=J,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const J=this.nowFn();return J-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=J,this.value=0),this.value++,this.value}}e.IntervalCounter=L;class oe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((J,ve)=>{this.completeCallback=J,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(J){return new Promise(ve=>{this.completeCallback(J),this.resolved=!0,ve()})}error(J){return new Promise(ve=>{this.errorCallback(J),this.rejected=!0,ve()})}cancel(){new Promise(J=>{this.errorCallback(new D.CancellationError),this.rejected=!0,J()})}}e.DeferredPromise=oe;var de;(function(we){async function J(Pe){let Fe;const We=await Promise.all(Pe.map(Ge=>Ge.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe!="undefined")throw Fe;return We}we.settled=J;function ve(Pe){return new Promise(async(Fe,We)=>{try{await Pe(Fe,We)}catch(Ge){We(Ge)}})}we.withAsyncBody=ve})(de=e.Promises||(e.Promises={}));var ae;(function(we){we[we.Initial=0]="Initial",we[we.DoneOK=1]="DoneOK",we[we.DoneError=2]="DoneError"})(ae||(ae={}));class fe{constructor(J){this._state=0,this._results=[],this._error=null,this._onStateChanged=new g.Emitter,queueMicrotask(async()=>{const ve={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(J(ve)),this.resolve()}catch(Pe){this.reject(Pe)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(J){return new fe(ve=>{ve.emitMany(J)})}static fromPromise(J){return new fe(async ve=>{ve.emitMany(await J)})}static fromPromises(J){return new fe(async ve=>{await Promise.all(J.map(async Pe=>ve.emitOne(await Pe)))})}static merge(J){return new fe(async ve=>{await Promise.all(J.map(async Pe=>{for await(const Fe of Pe)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(J<this._results.length)return{done:!1,value:this._results[J++]};if(this._state===1)return{done:!0,value:void 0};await g.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(J,ve){return new fe(async Pe=>{for await(const Fe of J)Pe.emitOne(ve(Fe))})}map(J){return fe.map(this,J)}static filter(J,ve){return new fe(async Pe=>{for await(const Fe of J)ve(Fe)&&Pe.emitOne(Fe)})}filter(J){return fe.filter(this,J)}static coalesce(J){return fe.filter(J,ve=>!!ve)}coalesce(){return fe.coalesce(this)}static async toPromise(J){const ve=[];for await(const Pe of J)ve.push(Pe);return ve}toPromise(){return fe.toPromise(this)}emitOne(J){this._state===0&&(this._results.push(J),this._onStateChanged.fire())}emitMany(J){this._state===0&&(this._results=this._results.concat(J),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(J){this._state===0&&(this._state=2,this._error=J,this._onStateChanged.fire())}}e.AsyncIterableObject=fe,fe.EMPTY=fe.fromArray([]);class ee extends fe{constructor(J,ve){super(ve);this._source=J}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function Ee(we){const J=new a.CancellationTokenSource,ve=we(J.token);return new ee(J,async Pe=>{const Fe=J.token.onCancellationRequested(()=>{Fe.dispose(),J.dispose(),Pe.reject(new D.CancellationError)});try{for await(const We of ve){if(J.token.isCancellationRequested)return;Pe.emitOne(We)}Fe.dispose(),J.dispose()}catch(We){Fe.dispose(),J.dispose(),Pe.reject(We)}})}e.createCancelableAsyncIterable=Ee}),define(Se[111],De([1,0,14,17]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const g=new a.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),N=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(h,C,F=!1){const U=h||"",R=C||"",E=g.value.collator.compare(U,R);return g.value.collatorIsNumeric&&E===0&&U!==R?U<R?-1:1:E}e.compareFileNames=P;function w(h,C){const F=N.value.collator;return h=h||"",C=C||"",_(F,h,C)}e.compareFileNamesDefault=w;function A(h,C){const F=N.value.collator;return h=h||"",C=C||"",s(h,C)||_(F,h,C)}e.compareFileNamesUpper=A;function O(h,C){const F=N.value.collator;return h=h||"",C=C||"",i(h,C)||_(F,h,C)}e.compareFileNamesLower=O;function v(h,C){return h=h||"",C=C||"",h===C?0:h<C?-1:1}e.compareFileNamesUnicode=v;function p(h,C,F=!1){F||(h=h&&h.toLowerCase(),C=C&&C.toLowerCase());const[U,R]=S(h),[E,x]=S(C);return U!==E?U<E?-1:1:R===x?0:R<x?-1:1}e.noIntlCompareFileNames=p;function b(h,C){const[F,U]=S(h),[R,E]=S(C);let x=g.value.collator.compare(U,E);if(x===0){if(g.value.collatorIsNumeric&&U!==E)return U<E?-1:1;if(x=g.value.collator.compare(F,R),g.value.collatorIsNumeric&&x===0&&F!==R)return F<R?-1:1}return x}e.compareFileExtensions=b;function f(h,C){h=h||"",C=C||"";const F=l(h),U=l(C),R=N.value.collator,E=I.value.collator;return _(E,F,U)||_(R,h,C)}e.compareFileExtensionsDefault=f;function u(h,C){h=h||"",C=C||"";const F=l(h),U=l(C),R=N.value.collator,E=I.value.collator;return _(E,F,U)||s(h,C)||_(R,h,C)}e.compareFileExtensionsUpper=u;function d(h,C){h=h||"",C=C||"";const F=l(h),U=l(C),R=N.value.collator,E=I.value.collator;return _(E,F,U)||i(h,C)||_(R,h,C)}e.compareFileExtensionsLower=d;function c(h,C){h=h||"",C=C||"";const F=l(h).toLowerCase(),U=l(C).toLowerCase();return F!==U?F<U?-1:1:h!==C?h<C?-1:1:0}e.compareFileExtensionsUnicode=c;const y=/^(.*?)(\.([^.]*))?$/;function S(h,C=!1){const F=h?y.exec(h):[];let U=[F&&F[1]||"",F&&F[3]||""];return C&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function l(h){const C=h?y.exec(h):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function _(h,C,F){let U=h.compare(C,F);return U!==0?U:C.length!==F.length?C.length<F.length?-1:1:0}function r(h){const C=h.charAt(0);return C.toLocaleUpperCase()!==C}function k(h){const C=h.charAt(0);return C.toLocaleLowerCase()!==C}function i(h,C){return r(h)&&k(C)?-1:k(h)&&r(C)?1:0}function s(h,C){return k(h)&&r(C)?-1:r(h)&&k(C)?1:0}function n(h,C,F=!1){return F||(h=h&&h.toLowerCase(),C=C&&C.toLowerCase()),h===C?0:h<C?-1:1}function t(h,C,F=!1){const U=h.split(D.sep),R=C.split(D.sep),E=U.length-1,x=R.length-1;let z,V;for(let se=0;;se++){if(z=E===se,V=x===se,z&&V)return P(U[se],R[se],F);if(z)return-1;if(V)return 1;const K=n(U[se],R[se],F);if(K!==0)return K}}e.comparePaths=t;function o(h,C,F){const U=h.toLowerCase(),R=C.toLowerCase(),E=m(h,C,F);if(E)return E;const x=U.endsWith(F),z=R.endsWith(F);if(x!==z)return x?-1:1;const V=P(U,R);return V!==0?V:U.localeCompare(R)}e.compareAnything=o;function m(h,C,F){const U=h.toLowerCase(),R=C.toLowerCase(),E=U.startsWith(F),x=R.startsWith(F);if(E!==x)return E?-1:1;if(E&&x){if(U.length<R.length)return-1;if(U.length>R.length)return 1}return 0}e.compareByPrefix=m}),define(Se[33],De([1,0,15,14,37,21,17,22,9]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",v="[^/\\\\]",p=/\//g;function b(oe,de){switch(oe){case 0:return"";case 1:return`${v}*?`;default:return`(?:${O}|${v}+${O}${de?`|${O}${v}+`:""})*?`}}function f(oe,de){if(!oe)return[];const ae=[];let fe=!1,ee=!1,Ee="";for(const we of oe){switch(we){case de:if(!fe&&!ee){ae.push(Ee),Ee="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}Ee+=we}return Ee&&ae.push(Ee),ae}e.splitGlobAware=f;function u(oe){if(!oe)return"";let de="";const ae=f(oe,e.GLOB_SPLIT);if(ae.every(fe=>fe===e.GLOBSTAR))de=".*";else{let fe=!1;ae.forEach((ee,Ee)=>{if(ee===e.GLOBSTAR){if(fe)return;de+=b(2,Ee===ae.length-1)}else{let we=!1,J="",ve=!1,Pe="";for(const Fe of ee){if(Fe!=="}"&&we){J+=Fe;continue}if(ve&&(Fe!=="]"||!Pe)){let We;Fe==="-"?We=Fe:(Fe==="^"||Fe==="!")&&!Pe?We="^":Fe===e.GLOB_SPLIT?We="":We=(0,w.escapeRegExpCharacters)(Fe),Pe+=We;continue}switch(Fe){case"{":we=!0;continue;case"[":ve=!0;continue;case"}":{de+=`(?:${f(J,",").map(Ie=>u(Ie)).join("|")})`,we=!1,J="";break}case"]":{de+="["+Pe+"]",ve=!1,Pe="";break}case"?":de+=v;continue;case"*":de+=b(1);continue;default:de+=(0,w.escapeRegExpCharacters)(Fe)}}Ee<ae.length-1&&(ae[Ee+1]!==e.GLOBSTAR||Ee+2<ae.length)&&(de+=O)}fe=ee===e.GLOBSTAR})}return de}const d=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new N.LRUCache(1e4),k=function(){return!1},i=function(){return null};function s(oe,de){if(!oe)return i;let ae;typeof oe!="string"?ae=oe.pattern:ae=oe,ae=ae.trim();const fe=`${ae}_${!!de.trimForExclusions}`;let ee=r.get(fe);if(ee)return n(ee,oe);let Ee;return d.test(ae)?ee=o(ae.substr(4),ae):(Ee=c.exec(t(ae,de)))?ee=m(Ee[1],ae):(de.trimForExclusions?S:y).test(ae)?ee=h(ae,de):(Ee=l.exec(t(ae,de)))?ee=C(Ee[1].substr(1),ae,!0):(Ee=_.exec(t(ae,de)))?ee=C(Ee[1],ae,!1):ee=F(ae),r.set(fe,ee),n(ee,oe)}function n(oe,de){if(typeof de=="string")return oe;const ae=function(fe,ee){return(0,g.isEqualOrParent)(fe,de.base,!P.isLinux)?oe(fe.substr(de.base.length+1),ee):null};return ae.allBasenames=oe.allBasenames,ae.allPaths=oe.allPaths,ae.basenames=oe.basenames,ae.patterns=oe.patterns,ae}function t(oe,de){return de.trimForExclusions&&oe.endsWith("/**")?oe.substr(0,oe.length-2):oe}function o(oe,de){return function(ae,fe){return typeof ae=="string"&&ae.endsWith(oe)?de:null}}function m(oe,de){const ae=`/${oe}`,fe=`\\${oe}`,ee=function(we,J){return typeof we!="string"?null:J?J===oe?de:null:we===oe||we.endsWith(ae)||we.endsWith(fe)?de:null},Ee=[oe];return ee.basenames=Ee,ee.patterns=[de],ee.allBasenames=Ee,ee}function h(oe,de){const ae=K(oe.slice(1,-1).split(",").map(J=>s(J,de)).filter(J=>J!==i),oe),fe=ae.length;if(!fe)return i;if(fe===1)return ae[0];const ee=function(J,ve){for(let Pe=0,Fe=ae.length;Pe<Fe;Pe++)if(ae[Pe](J,ve))return oe;return null},Ee=ae.find(J=>!!J.allBasenames);Ee&&(ee.allBasenames=Ee.allBasenames);const we=ae.reduce((J,ve)=>ve.allPaths?J.concat(ve.allPaths):J,[]);return we.length&&(ee.allPaths=we),ee}function C(oe,de,ae){const fe=I.sep===I.posix.sep,ee=fe?oe:oe.replace(p,I.sep),Ee=I.sep+ee,we=I.posix.sep+oe;let J;return ae?J=function(ve,Pe){return typeof ve=="string"&&(ve===ee||ve.endsWith(Ee)||!fe&&(ve===oe||ve.endsWith(we)))?de:null}:J=function(ve,Pe){return typeof ve=="string"&&(ve===ee||!fe&&ve===oe)?de:null},J.allPaths=[(ae?"*/":"./")+oe],J}function F(oe){try{const de=new RegExp(`^${u(oe)}$`);return function(ae){return de.lastIndex=0,typeof ae=="string"&&de.test(ae)?oe:null}}catch{return i}}function U(oe,de,ae){return!oe||typeof de!="string"?!1:R(oe)(de,void 0,ae)}e.match=U;function R(oe,de={}){if(!oe)return k;if(typeof oe=="string"||E(oe)){const ae=s(oe,de);if(ae===i)return k;const fe=function(ee,Ee){return!!ae(ee,Ee)};return ae.allBasenames&&(fe.allBasenames=ae.allBasenames),ae.allPaths&&(fe.allPaths=ae.allPaths),fe}return V(oe,de)}e.parse=R;function E(oe){const de=oe;return de?typeof de.base=="string"&&typeof de.pattern=="string":!1}e.isRelativePattern=E;function x(oe){return oe.allBasenames||[]}e.getBasenameTerms=x;function z(oe){return oe.allPaths||[]}e.getPathTerms=z;function V(oe,de){const ae=K(Object.getOwnPropertyNames(oe).map(J=>se(J,oe[J],de)).filter(J=>J!==i)),fe=ae.length;if(!fe)return i;if(!ae.some(J=>!!J.requiresSiblings)){if(fe===1)return ae[0];const J=function(Fe,We){let Ge;for(let Ie=0,_e=ae.length;Ie<_e;Ie++){const Ce=ae[Ie](Fe,We);if(typeof Ce=="string")return Ce;(0,D.isThenable)(Ce)&&(Ge||(Ge=[]),Ge.push(Ce))}return Ge?(async()=>{for(const Ie of Ge){const _e=await Ie;if(typeof _e=="string")return _e}return null})():null},ve=ae.find(Fe=>!!Fe.allBasenames);ve&&(J.allBasenames=ve.allBasenames);const Pe=ae.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Pe.length&&(J.allPaths=Pe),J}const ee=function(J,ve,Pe){let Fe,We;for(let Ge=0,Ie=ae.length;Ge<Ie;Ge++){const _e=ae[Ge];_e.requiresSiblings&&Pe&&(ve||(ve=(0,I.basename)(J)),Fe||(Fe=ve.substr(0,ve.length-(0,I.extname)(J).length)));const Ce=_e(J,ve,Fe,Pe);if(typeof Ce=="string")return Ce;(0,D.isThenable)(Ce)&&(We||(We=[]),We.push(Ce))}return We?(async()=>{for(const Ge of We){const Ie=await Ge;if(typeof Ie=="string")return Ie}return null})():null},Ee=ae.find(J=>!!J.allBasenames);Ee&&(ee.allBasenames=Ee.allBasenames);const we=ae.reduce((J,ve)=>ve.allPaths?J.concat(ve.allPaths):J,[]);return we.length&&(ee.allPaths=we),ee}function se(oe,de,ae){if(de===!1)return i;const fe=s(oe,ae);if(fe===i)return i;if(typeof de=="boolean")return fe;if(de){const ee=de.when;if(typeof ee=="string"){const Ee=(we,J,ve,Pe)=>{if(!Pe||!fe(we,J))return null;const Fe=ee.replace("$(basename)",ve),We=Pe(Fe);return(0,D.isThenable)(We)?We.then(Ge=>Ge?oe:null):We?oe:null};return Ee.requiresSiblings=!0,Ee}}return fe}function K(oe,de){const ae=oe.filter(J=>!!J.basenames);if(ae.length<2)return oe;const fe=ae.reduce((J,ve)=>{const Pe=ve.basenames;return Pe?J.concat(Pe):J},[]);let ee;if(de){ee=[];for(let J=0,ve=fe.length;J<ve;J++)ee.push(de)}else ee=ae.reduce((J,ve)=>{const Pe=ve.patterns;return Pe?J.concat(Pe):J},[]);const Ee=function(J,ve){if(typeof J!="string")return null;if(!ve){let Fe;for(Fe=J.length;Fe>0;Fe--){const We=J.charCodeAt(Fe-1);if(We===47||We===92)break}ve=J.substr(Fe)}const Pe=fe.indexOf(ve);return Pe!==-1?ee[Pe]:null};Ee.basenames=fe,Ee.patterns=ee,Ee.allBasenames=fe;const we=oe.filter(J=>!J.basenames);return we.push(Ee),we}function L(oe,de){return(0,a.equals)(oe,de,(ae,fe)=>typeof ae=="string"&&typeof fe=="string"?ae===fe:typeof ae!="string"&&typeof fe!="string"?ae.base===fe.base&&ae.pattern===fe.pattern:!1)}e.patternsEquals=L}),define(Se[75],De([1,0,12,109,23,9,2]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(d="",c=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(d,c=0){return this.value+=p(this.supportThemeIcons?(0,D.escapeIcons)(d):d).replace(/([ \t]+)/g,(y,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,c){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(d,c,y){return this.value+="[",this.value+=this._escape(c,"]"),this.value+="](",this.value+=this._escape(String(d),")"),y&&(this.value+=` "${this._escape(this._escape(y,'"'),")")}"`),this.value+=")",this}_escape(d,c){const y=new RegExp((0,N.escapeRegExpCharacters)(c),"g");return d.replace(y,(S,l)=>d.charAt(l-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=w;function A(u){return O(u)?!u.value:Array.isArray(u)?u.every(A):!0}e.isEmptyMarkdownString=A;function O(u){return u instanceof w?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function v(u,d){return u===d?!0:!u||!d?!1:u.value===d.value&&u.isTrusted===d.isTrusted&&u.supportThemeIcons===d.supportThemeIcons&&u.supportHtml===d.supportHtml&&(u.baseUri===d.baseUri||!!u.baseUri&&!!d.baseUri&&(0,g.isEqual)(I.URI.from(u.baseUri),I.URI.from(d.baseUri)))}e.markdownStringEqual=v;function p(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=p;function b(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function f(u){const d=[],c=u.split("|").map(S=>S.trim());u=c[0];const y=c[1];if(y){const S=/height=(\d+)/.exec(y),l=/width=(\d+)/.exec(y),_=S?S[1]:"",r=l?l[1]:"",k=isFinite(parseInt(r)),i=isFinite(parseInt(_));k&&d.push(`width="${r}"`),i&&d.push(`height="${_}"`)}return{href:u,dimensions:d}}e.parseHrefAndDimensions=f}),define(Se[76],De([1,0,15,37,11,17,22,23,9,2]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function O(t,o){const{os:m,tildify:h,relative:C}=o;if(C){const R=v(t,C,m);if(typeof R=="string")return R}let F=t.fsPath;if(m===1&&!I.isWindows?F=F.replace(/\//g,"\\"):m!==1&&I.isWindows&&(F=F.replace(/\\/g,"/")),m!==1&&h?.userHome){let R=h.userHome.fsPath,E;t.scheme!==h.userHome.scheme&&t.path.startsWith(N.posix.sep)?E=h.userHome.with({path:t.path}).fsPath:E=t.fsPath,F=u(E,R,m)}return(m===1?N.win32:N.posix).normalize(b(F,m===1))}e.getPathLabel=O;function v(t,o,m){const h=m===1?N.win32:N.posix,C=m===3?P.extUri:P.extUriIgnorePathCase,F=o.getWorkspace(),U=(0,a.firstOrDefault)(F.folders);if(!U)return;t.scheme!==U.uri.scheme&&t.path.startsWith(N.posix.sep)&&(t=U.uri.with({path:t.path}));const R=o.getWorkspaceFolder(t);if(!R)return;let E;if(C.isEqual(R.uri,t)?E="":E=C.relativePath(R.uri,t)??"",E&&(E=h.normalize(E)),F.folders.length>1&&!o.noPrefix){const x=R.name?R.name:C.basenameOrAuthority(R.uri);E=E?`${x} \u2022 ${E}`:x}return E}function p(t){if(!t)return;typeof t=="string"&&(t=A.URI.file(t));const o=(0,P.basename)(t)||(t.scheme===g.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(o)?b(o):o}e.getBaseLabel=p;function b(t,o=I.isWindows){return(0,D.hasDriveLetter)(t,o)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=b;let f=Object.create(null);function u(t,o,m=I.OS){if(m===1||!t||!o)return t;let h=f.original===o?f.normalized:void 0;h||(h=o,I.isWindows&&(h=(0,D.toSlashes)(h)),h=`${(0,w.rtrim)(h,N.posix.sep)}${N.posix.sep}`,f={original:o,normalized:h});let C=t;return I.isWindows&&(C=(0,D.toSlashes)(C)),(m===3?C.startsWith(h):(0,w.startsWithIgnoreCase)(C,h))?`~/${C.substr(h.length)}`:t}e.tildify=u;function d(t,o){return t.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=d;const c="\u2026",y="\\\\",S="~";function l(t,o=N.sep){const m=new Array(t.length);let h=!1;for(let C=0;C<t.length;C++){let F=t[C];if(F===""){m[C]=`.${o}`;continue}if(!F){m[C]=F;continue}h=!0;let U="",R=F;R.indexOf(y)===0?(U=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length)):R.indexOf(o)===0?(U=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length)):R.indexOf(S)===0&&(U=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length));const E=R.split(o);for(let x=1;h&&x<=E.length;x++)for(let z=E.length-x;h&&z>=0;z--){h=!1;let V=E.slice(z,z+x).join(o);for(let se=0;!h&&se<t.length;se++)if(se!==C&&t[se]&&t[se].indexOf(V)>-1){const K=z+x===E.length,L=z>0&&t[se].indexOf(o)>-1?o+V:V,oe=t[se].endsWith(L);h=!K||oe}if(!h){let se="";(E[0].endsWith(":")||U!=="")&&(z===1&&(z=0,x++,V=E[0]+o+V),z>0&&(se=E[0]+o),se=U+se),z>0&&(se=se+c+o),se=se+V,z+x<E.length&&(se=se+o+c),m[C]=se}}h&&(m[C]=F)}return m}e.shorten=l;var _;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(_||(_={}));function r(t,o=Object.create(null)){const m=[];let h=!1,C="";for(const F of t)if(F==="$"||h&&F==="{")C&&m.push({value:C,type:_.TEXT}),C="",h=!0;else if(F==="}"&&h){const U=o[C];if(typeof U=="string")U.length&&m.push({value:U,type:_.VARIABLE});else if(U){const R=m[m.length-1];(!R||R.type!==_.SEPARATOR)&&m.push({value:U.label,type:_.SEPARATOR})}C="",h=!1}else C+=F;return C&&!h&&m.push({value:C,type:_.TEXT}),m.filter((F,U)=>{if(F.type===_.SEPARATOR){const R=m[U-1],E=m[U+1];return[R,E].every(x=>x&&(x.type===_.VARIABLE||x.type===_.TEXT)&&x.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=r;function k(t,o){return I.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function i(t,o){return I.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,m=>m==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(t){const o=t.indexOf("/")!==-1?N.posix:N.win32,m=o.basename(t),h=o.dirname(t);return m.length?{name:m,parentPath:h}:{name:h,parentPath:""}}e.splitName=n}),define(Se[112],De([1,0,2]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(O){return O.toJSON()}class g{constructor(v){this._uriTransformer=v}transformIncoming(v){const p=this._uriTransformer.transformIncoming(v);return p===v?v:D(a.URI.from(p))}transformOutgoing(v){const p=this._uriTransformer.transformOutgoing(v);return p===v?v:D(a.URI.from(p))}transformOutgoingURI(v){const p=this._uriTransformer.transformOutgoing(v);return p===v?v:a.URI.from(p)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function N(O,v,p){if(!O||p>200)return null;if(typeof O=="object"){if(O instanceof a.URI)return v.transformOutgoing(O);for(let b in O)if(Object.hasOwnProperty.call(O,b)){const f=N(O[b],v,p+1);f!==null&&(O[b]=f)}}return null}function I(O,v){const p=N(O,v,0);return p===null?O:p}e.transformOutgoingURIs=I;function P(O,v,p,b){if(!O||b>200)return null;if(typeof O=="object"){if(O.$mid===1)return p?a.URI.revive(v.transformIncoming(O)):v.transformIncoming(O);for(let f in O)if(Object.hasOwnProperty.call(O,f)){const u=P(O[f],v,p,b+1);u!==null&&(O[f]=u)}}return null}function w(O,v){const p=P(O,v,!1,0);return p===null?O:p}e.transformIncomingURIs=w;function A(O,v){const p=P(O,v,!0,0);return p===null?O:p}e.transformAndReviveIncomingURIs=A}),define(Se[42],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(g){return a.test(g)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const N=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){g(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let w=0,A="";return A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A+="-",A+=I[N[w++]],A+=I[N[w++]],A+="-",A+=I[N[w++]],A+=I[N[w++]],A+="-",A+=I[N[w++]],A+=I[N[w++]],A+="-",A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A+=I[N[w++]],A}}()}),define(Se[113],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[114],De([1,0,33,17]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(N,I,P,w,A,O){if(Array.isArray(N)){let v=0;for(const p of N){const b=g(p,I,P,w,A,O);if(b===10)return b;b>v&&(v=b)}return v}else{if(typeof N=="string")return w?N==="*"?5:N===P?10:0:0;if(N){const{language:v,pattern:p,scheme:b,hasAccessToAllModels:f,notebookType:u}=N;if(!w&&!f)return 0;u&&A&&(I=A);let d=0;if(b)if(b===I.scheme)d=10;else if(b==="*")d=5;else return 0;if(v)if(v===P)d=10;else if(v==="*")d=Math.max(d,5);else return 0;if(u)if(u===O)d=10;else if(u==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(p){let c;if(typeof p=="string"?c=p:c={...p,base:(0,D.normalize)(p.base)},c===I.fsPath||(0,a.match)(c,I.fsPath))d=10;else return 0}return d}else return 0}}e.score=g}),define(Se[115],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class D{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let w=0,A=P.notIn.length;w<A;w++)switch(P.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,w){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(w-2),O=P.getStandardTokenType(A);return this.isOK(O)}_findNeutralCharacterInRange(P,w){for(let A=P;A<=w;A++){const O=String.fromCharCode(A);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=D;class g{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of P)N(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),N(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),N(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),N(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&N(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=g;function N(I,P,w){I.has(P)?I.get(P).push(w):I.set(P,[w])}}),define(Se[77],De([1,0,25,22]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var g;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(g||(g={}));function N(v){for(let p=0,b=v.length;p<b;p+=4){const f=v[p+0],u=v[p+1],d=v[p+2],c=v[p+3];v[p+0]=c,v[p+1]=d,v[p+2]=u,v[p+3]=f}}function I(v){const p=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return D.isLittleEndian()||N(p),a.VSBuffer.wrap(p)}function P(v){const p=v.buffer;if(D.isLittleEndian()||N(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const b=new Uint8Array(p.byteLength);return b.set(p),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function w(v){const p=new Uint32Array(A(v));let b=0;if(p[b++]=v.id,v.type==="full")p[b++]=1,p[b++]=v.data.length,p.set(v.data,b),b+=v.data.length;else{p[b++]=2,p[b++]=v.deltas.length;for(const f of v.deltas)p[b++]=f.start,p[b++]=f.deleteCount,f.data?(p[b++]=f.data.length,p.set(f.data,b),b+=f.data.length):p[b++]=0}return I(p)}e.encodeSemanticTokensDto=w;function A(v){let p=0;if(p+=1+1,v.type==="full")p+=1+v.data.length;else{p+=1,p+=(1+1+1)*v.deltas.length;for(const b of v.deltas)b.data&&(p+=b.data.length)}return p}function O(v){const p=P(v);let b=0;const f=p[b++];if(p[b++]===1){const y=p[b++],S=p.subarray(b,b+y);return b+=y,{id:f,type:"full",data:S}}const d=p[b++],c=[];for(let y=0;y<d;y++){const S=p[b++],l=p[b++],_=p[b++];let r;_>0&&(r=p.subarray(b,b+_),b+=_),c[y]={start:S,deleteCount:l,data:r}}return{id:f,type:"delta",deltas:c}}e.decodeSemanticTokensDto=O}),define(Se[116],De([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(Se[117],De([1,0,116]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,g=D*60,N=g*24,I=N*7,P=N*30,w=N*365;function A(v,p,b){typeof v!="number"&&(v=v.getTime());const f=Math.round((new Date().getTime()-v)/1e3);if(f<-30)return(0,a.localize)(0,null,A(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let u;return f<D?(u=f,p?u===1?b?(0,a.localize)(2,null,u):(0,a.localize)(3,null,u):b?(0,a.localize)(4,null,u):(0,a.localize)(5,null,u):u===1?b?(0,a.localize)(6,null,u):(0,a.localize)(7,null,u):b?(0,a.localize)(8,null,u):(0,a.localize)(9,null,u)):f<g?(u=Math.floor(f/D),p?u===1?b?(0,a.localize)(10,null,u):(0,a.localize)(11,null,u):b?(0,a.localize)(12,null,u):(0,a.localize)(13,null,u):u===1?b?(0,a.localize)(14,null,u):(0,a.localize)(15,null,u):b?(0,a.localize)(16,null,u):(0,a.localize)(17,null,u)):f<N?(u=Math.floor(f/g),p?u===1?b?(0,a.localize)(18,null,u):(0,a.localize)(19,null,u):b?(0,a.localize)(20,null,u):(0,a.localize)(21,null,u):u===1?b?(0,a.localize)(22,null,u):(0,a.localize)(23,null,u):b?(0,a.localize)(24,null,u):(0,a.localize)(25,null,u)):f<I?(u=Math.floor(f/N),p?u===1?(0,a.localize)(26,null,u):(0,a.localize)(27,null,u):u===1?(0,a.localize)(28,null,u):(0,a.localize)(29,null,u)):f<P?(u=Math.floor(f/I),p?u===1?b?(0,a.localize)(30,null,u):(0,a.localize)(31,null,u):b?(0,a.localize)(32,null,u):(0,a.localize)(33,null,u):u===1?b?(0,a.localize)(34,null,u):(0,a.localize)(35,null,u):b?(0,a.localize)(36,null,u):(0,a.localize)(37,null,u)):f<w?(u=Math.floor(f/P),p?u===1?b?(0,a.localize)(38,null,u):(0,a.localize)(39,null,u):b?(0,a.localize)(40,null,u):(0,a.localize)(41,null,u):u===1?b?(0,a.localize)(42,null,u):(0,a.localize)(43,null,u):b?(0,a.localize)(44,null,u):(0,a.localize)(45,null,u)):(u=Math.floor(f/w),p?u===1?b?(0,a.localize)(46,null,u):(0,a.localize)(47,null,u):b?(0,a.localize)(48,null,u):(0,a.localize)(49,null,u):u===1?b?(0,a.localize)(50,null,u):(0,a.localize)(51,null,u):b?(0,a.localize)(52,null,u):(0,a.localize)(53,null,u))}e.fromNow=A;function O(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Se[118],De([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(Se[43],De([1,0,15,10,118]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(v,p){return p&&(v.stack||v.stacktrace)?g.localize(0,null,P(v),I(v.stack)||I(v.stacktrace)):P(v)}function I(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?g.localize(1,null,v.message):v.message||g.localize(2,null)}function w(v=null,p=!1){if(!v)return g.localize(3,null);if(Array.isArray(v)){const b=a.coalesce(v),f=w(b[0],p);return b.length>1?g.localize(4,null,f,b.length):f}if(D.isString(v))return v;if(v.detail){const b=v.detail;if(b.error)return N(b.error,p);if(b.exception)return N(b.exception,p)}return v.stack?N(v,p):v.message?v.message:g.localize(5,null)}e.toErrorMessage=w;function A(v){const p=v;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=A;function O(v,p){let b;return typeof v=="string"?b=new Error(v):b=v,b.actions=p,b}e.createErrorWithActions=O}),define(Se[119],De([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(Se[120],De([1,0,119,22,121,15,27,113]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=A;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class v{constructor(Q,me,Le,Be){this.id=Q,this.name=me,this.defaultValue=Le,this.schema=Be}applyUpdate(Q,me){return b(Q,me)}compute(Q,me,Le){return Le}}class p{constructor(Q,me){this.newValue=Q,this.didChange=me}}e.ApplyUpdateResult=p;function b(j,Q){if(typeof j!="object"||typeof Q!="object"||!j||!Q)return new p(Q,j!==Q);if(Array.isArray(j)||Array.isArray(Q)){const Le=Array.isArray(j)&&Array.isArray(Q)&&N.equals(j,Q);return new p(Q,Le)}let me=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const Be=b(j[Le],Q[Le]);Be.didChange&&(j[Le]=Be.newValue,me=!0)}return new p(j,me)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,me){return b(Q,me)}validate(Q){return this.defaultValue}}class u{constructor(Q,me,Le,Be){this.id=Q,this.name=me,this.defaultValue=Le,this.schema=Be}applyUpdate(Q,me){return b(Q,me)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,me,Le){return Le}}function d(j,Q){return typeof j=="undefined"?Q:j==="false"?!1:Boolean(j)}e.boolean=d;class c extends u{constructor(Q,me,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=Le);super(Q,me,Le,Be)}validate(Q){return d(Q,this.defaultValue)}}function y(j,Q,me,Le){if(typeof j=="undefined")return Q;let Be=parseInt(j,10);return isNaN(Be)?Q:(Be=Math.max(me,Be),Be=Math.min(Le,Be),Be|0)}e.clampedInt=y;class S extends u{constructor(Q,me,Le,Be,Xe,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Le,Ze.minimum=Be,Ze.maximum=Xe);super(Q,me,Le,Ze);this.minimum=Be,this.maximum=Xe}static clampedInt(Q,me,Le,Be){return y(Q,me,Le,Be)}validate(Q){return S.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class l extends u{constructor(Q,me,Le,Be,Xe){typeof Xe!="undefined"&&(Xe.type="number",Xe.default=Le);super(Q,me,Le,Xe);this.validationFn=Be}static clamp(Q,me,Le){return Q<me?me:Q>Le?Le:Q}static float(Q,me){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return me;const Le=parseFloat(Q);return isNaN(Le)?me:Le}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class _ extends u{static string(Q,me){return typeof Q!="string"?me:Q}constructor(Q,me,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=Le);super(Q,me,Le,Be)}validate(Q){return _.string(Q,this.defaultValue)}}function r(j,Q,me){return typeof j!="string"||me.indexOf(j)===-1?Q:j}e.stringSet=r;class k extends u{constructor(Q,me,Le,Be,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Be,Xe.default=Le);super(Q,me,Le,Xe);this._allowedValues=Be}validate(Q){return r(Q,this.defaultValue,this._allowedValues)}}class i extends v{constructor(Q,me,Le,Be,Xe,Ze,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Xe,rt.default=Be);super(Q,me,Le,rt);this._allowedValues=Xe,this._convert=Ze}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function s(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends v{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,me,Le){return Le===0?Q.accessibilitySupport:Le}}class t extends v{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(j){switch(j){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function F(j){switch(j){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class U extends f{constructor(){super(128)}compute(Q,me,Le){const Be=["monaco-editor"];return me.get(33)&&Be.push(me.get(33)),Q.extraEditorClassName&&Be.push(Q.extraEditorClassName),me.get(66)==="default"?Be.push("mouse-default"):me.get(66)==="copy"&&Be.push("mouse-copy"),me.get(100)&&Be.push("showUnused"),me.get(126)&&Be.push("showDeprecated"),Be.join(" ")}}class R extends c{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,me,Le){return Le&&Q.emptySelectionClipboard}}class E extends v{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class x extends v{constructor(){super(45,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?x.OFF:Q==="true"?x.ON:Q:Boolean(Q)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class z extends f{constructor(){super(44)}compute(Q,me,Le){return Q.fontInfo}}class V extends u{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(Q){const me=l.float(Q,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(me,6,100)}compute(Q,me,Le){return Q.fontInfo.fontSize}}class se extends v{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.MINIMUM_VALUE,maximum:se.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(S.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,se.MINIMUM_VALUE,se.MAXIMUM_VALUE))}}se.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],se.MINIMUM_VALUE=1,se.MAXIMUM_VALUE=1e3;class K extends v{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:a.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{multiple:r(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??r(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??r(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??r(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??r(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??r(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class L extends v{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:S.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky),above:d(me.above,this.defaultValue.above)}}}var oe;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(oe=e.RenderMinimap||(e.RenderMinimap={}));class de extends f{constructor(){super(131)}compute(Q,me,Le){return de.computeLayout(me,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const me=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?me-1:0,Be=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),Xe=Math.floor(Q.viewLineCount/Be);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:Xe}}static _computeMinimapLayout(Q,me){const Le=Q.outerWidth,Be=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ze=me.stableMinimapLayoutInput,rt=Ze&&Q.outerHeight===Ze.outerHeight&&Q.lineHeight===Ze.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ze.pixelRatio&&Q.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Q.minimap.enabled===Ze.minimap.enabled&&Q.minimap.side===Ze.minimap.side&&Q.minimap.size===Ze.minimap.size&&Q.minimap.showSlider===Ze.minimap.showSlider&&Q.minimap.renderCharacters===Ze.minimap.renderCharacters&&Q.minimap.maxColumn===Ze.minimap.maxColumn&&Q.minimap.scale===Ze.minimap.scale&&Q.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Q.isViewportWrapping===Ze.isViewportWrapping,Ye=Q.lineHeight,Je=Q.typicalHalfwidthCharacterWidth,je=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let st=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const It=Q.minimap.maxColumn,at=Q.minimap.size,ht=Q.minimap.side,Ut=Q.verticalScrollbarWidth,Ft=Q.viewLineCount,yt=Q.remainingWidth,ft=Q.isViewportWrapping,Dt=lt?2:3;let Pt=Math.floor(Xe*Be);const Nt=Pt/Xe;let He=!1,$t=!1,At=Dt*st,Mt=st/Xe,be=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:Ve,extraLinesBeyondLastLine:ot,desiredRatio:ct,minimapLineCount:pt}=de.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:je,height:Be,lineHeight:Ye,pixelRatio:Xe});if(Ft/pt>1)He=!0,$t=!0,st=1,At=1,Mt=st/Xe;else{let mt=!1,vt=st+1;if(at==="fit"){const Rt=Math.ceil((Ft+ot)*At);ft&&rt&&yt<=me.stableFitRemainingWidth?(mt=!0,vt=me.stableFitMaxMinimapScale):mt=Rt>Pt}if(at==="fill"||mt){He=!0;const Rt=st;At=Math.min(Ye*Xe,Math.max(1,Math.floor(1/ct))),ft&&rt&&yt<=me.stableFitRemainingWidth&&(vt=me.stableFitMaxMinimapScale),st=Math.min(vt,Math.max(1,Math.floor(At/Dt))),st>Rt&&(be=Math.min(2,st/Rt)),Mt=st/Xe/be,Pt=Math.ceil(Math.max(Ve,Ft+ot)*At),ft?(me.stableMinimapLayoutInput=Q,me.stableFitRemainingWidth=yt,me.stableFitMaxMinimapScale=st):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ye=Math.floor(It*Mt),ue=Math.min(ye,Math.max(0,Math.floor((yt-Ut-2)*Mt/(Je+Mt)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(Xe*ue);const Ae=q/Xe;q=Math.floor(q*be);const Ue=lt?1:2,tt=ht==="left"?0:Le-ue-Ut;return{renderMinimap:Ue,minimapLeft:tt,minimapWidth:ue,minimapHeightIsEditorHeight:He,minimapIsSampling:$t,minimapScale:st,minimapLineHeight:At,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Ae,minimapCanvasOuterHeight:Nt}}static computeLayout(Q,me){const Le=me.outerWidth|0,Be=me.outerHeight|0,Xe=me.lineHeight|0,Ze=me.lineNumbersDigitCount|0,rt=me.typicalHalfwidthCharacterWidth,Ye=me.maxDigitWidth,Je=me.pixelRatio,je=me.viewLineCount,lt=Q.get(123),st=lt==="inherit"?Q.get(122):lt,It=st==="inherit"?Q.get(118):st,at=Q.get(121),ht=Q.get(2),Ut=me.isDominatedByLongLines,Ft=Q.get(50),yt=Q.get(60).renderType!==0,ft=Q.get(61),Dt=Q.get(94),Pt=Q.get(65),Nt=Q.get(92),He=Nt.verticalScrollbarSize,$t=Nt.verticalHasArrows,At=Nt.arrowSize,Mt=Nt.horizontalScrollbarSize,be=Q.get(58),ye=Q.get(37);let ue;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Qt=parseFloat(be.substr(0,be.length-2));ue=S.clampedInt(Qt*rt,0,0,1e3)}else ue=S.clampedInt(be,0,0,1e3);ye&&(ue+=16);let q=0;if(yt){const Qt=Math.max(Ze,ft);q=Math.round(Qt*Ye)}let Ae=0;Ft&&(Ae=Xe);let Ue=0,tt=Ue+Ae,Ve=tt+q,ot=Ve+ue;const ct=Le-Ae-q-ue;let pt=!1,_t=!1,mt=-1;ht!==2&&(st==="inherit"&&Ut?(pt=!0,_t=!0):It==="on"||It==="bounded"?_t=!0:It==="wordWrapColumn"&&(mt=at));const vt=de._computeMinimapLayout({outerWidth:Le,outerHeight:Be,lineHeight:Xe,typicalHalfwidthCharacterWidth:rt,pixelRatio:Je,scrollBeyondLastLine:Dt,minimap:Pt,verticalScrollbarWidth:He,viewLineCount:je,remainingWidth:ct,isViewportWrapping:_t},me.memory||new O);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ue+=vt.minimapWidth,tt+=vt.minimapWidth,Ve+=vt.minimapWidth,ot+=vt.minimapWidth);const Rt=ct-vt.minimapWidth,Et=Math.max(1,Math.floor((Rt-He-2)/rt)),Gt=$t?At:0;return _t&&(mt=Math.max(1,Et),It==="bounded"&&(mt=Math.min(mt,at))),{width:Le,height:Be,glyphMarginLeft:Ue,glyphMarginWidth:Ae,lineNumbersLeft:tt,lineNumbersWidth:q,decorationsLeft:Ve,decorationsWidth:ue,contentLeft:ot,contentWidth:Rt,minimap:vt,viewportColumn:Et,isWordWrapMinified:pt,isViewportWrapping:_t,wrappingColumn:mt,verticalScrollbarWidth:He,horizontalScrollbarHeight:Mt,overviewRuler:{top:Gt,width:He,height:Be-2*Gt,right:0}}}}e.EditorLayoutInfoComputer=de;class ae extends v{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class fe extends v{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",displayStyle:"compact"};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:a.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(45,null),a.localize(46,null),a.localize(47,null),a.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(50,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:r(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(me.fontFamily,this.defaultValue.fontFamily),displayStyle:r(me.displayStyle,this.defaultValue.displayStyle,["standard","compact"])}}}class ee extends l{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:a.localize(51,null)})}compute(Q,me,Le){return Q.fontInfo.lineHeight}}class Ee extends v{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(52,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(53,null),a.localize(54,null),a.localize(55,null)],default:Q.size,description:a.localize(56,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(57,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(58,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(59,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(60,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:d(me.enabled,this.defaultValue.enabled),size:r(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(me.side,this.defaultValue.side,["right","left"]),showSlider:r(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(me.scale,1,1,3),maxColumn:S.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(j){return j==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends v{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(62,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(63,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{top:S.clampedInt(me.top,0,0,1e3),bottom:S.clampedInt(me.bottom,0,0,1e3)}}}class ve extends v{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(64,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class Pe extends f{constructor(){super(129)}compute(Q,me,Le){return Q.pixelRatio}}class Fe extends v{constructor(){const Q={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]}];super(79,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Q.strings,description:a.localize(69,null)},comments:{anyOf:me,default:Q.comments,description:a.localize(70,null)},other:{anyOf:me,default:Q.other,description:a.localize(71,null)}},default:Q,markdownDescription:a.localize(72,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Je=Q?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:me,comments:Le,strings:Be}=Q,Xe=["on","inline","off"];let Ze,rt,Ye;return typeof me=="boolean"?Ze=me?"on":"off":Ze=r(me,this.defaultValue.other,Xe),typeof Le=="boolean"?rt=Le?"on":"off":rt=r(Le,this.defaultValue.comments,Xe),typeof Be=="boolean"?Ye=Be?"on":"off":Ye=r(Be,this.defaultValue.strings,Xe),{other:Ze,comments:rt,strings:Ye}}}var We;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ge extends v{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(73,null),a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"on",description:a.localize(77,null)})}validate(Q){let me=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(me=4,Le=Q):Q==="interval"?me=3:Q==="relative"?me=2:Q==="on"?me=1:me=0),{renderType:me,renderFn:Le}}}function Ie(j){const Q=j.get(87);return Q==="editable"?j.get(81):Q!=="on"}e.filterValidationDecorations=Ie;class _e extends v{constructor(){const Q=[],me={type:"number",description:a.localize(78,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:a.localize(79,null),format:"color-hex"}}}]},default:Q,description:a.localize(80,null)})}validate(Q){if(Array.isArray(Q)){const me=[];for(let Le of Q)if(typeof Le=="number")me.push({column:S.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Be=Le;me.push({column:S.clampedInt(Be.column,0,0,1e4),color:Be.color})}return me.sort((Le,Be)=>Le.column-Be.column),me}return this.defaultValue}}function Ce(j,Q){if(typeof j!="string")return Q;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class re extends v{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(81,null),a.localize(82,null),a.localize(83,null)],default:"auto",description:a.localize(84,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"auto",description:a.localize(88,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(89,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(90,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(91,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q,Le=S.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=S.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:S.clampedInt(me.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:S.clampedInt(me.verticalSliderSize,Be,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class le extends v{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(92,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(93,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(94,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(95,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(97,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:a.localize(98,null)}})}applyUpdate(Q,me){let Le=!1;me.allowedCharacters&&(I.equals(Q.allowedCharacters,me.allowedCharacters)||(Q={...Q,allowedCharacters:me.allowedCharacters},Le=!0)),me.allowedLocales&&(I.equals(Q.allowedLocales,me.allowedLocales)||(Q={...Q,allowedLocales:me.allowedLocales},Le=!0));const Be=super.applyUpdate(Q,me);return Le?new p(Be.newValue,!0):Be}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{nonBasicASCII:B(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:B(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:B(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,me){if(typeof Q!="object"||!Q)return me;const Le={};for(const[Be,Xe]of Object.entries(Q))Xe===!0&&(Le[Be]=!0);return Le}}class X extends v{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(99,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:d(me.enabled,this.defaultValue.enabled),mode:r(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class G extends v{constructor(){const Q={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:a.localize(100,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:a.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{enabled:d(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class T extends v{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(102,null),a.localize(103,null),a.localize(104,null)],default:Q.bracketPairs,description:a.localize(105,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(106,null),a.localize(107,null),a.localize(108,null)],default:Q.bracketPairsHorizontal,description:a.localize(109,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(110,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(111,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:Q.highlightActiveIndentation,description:a.localize(115,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{bracketPairs:B(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:B(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:B(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function B(j,Q,me){const Le=me.indexOf(j);return Le===-1?Q:me[Le]}class W extends v{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(116,null),a.localize(117,null)],default:Q.insertMode,description:a.localize(118,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(119,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(120,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(121,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(122,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(123,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(124,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(125,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(126,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(127,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(128,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const me=Q;return{insertMode:r(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),preview:d(me.preview,this.defaultValue.preview),previewMode:r(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class H extends v{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(158,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends f{constructor(){super(130)}compute(Q,me,Le){return me.get(81)?!0:Q.tabFocusMode}}var he;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(he=e.WrappingIndent||(e.WrappingIndent={}));function Y(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(132)}compute(Q,me,Le){const Be=me.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const pe="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Ne:D.isLinux?xe:pe,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(j){return e.editorOptionsRegistry[j.id]=j,j}var qe;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.foldingMaximumRegions=41]="foldingMaximumRegions",j[j.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=43]="fontFamily",j[j.fontInfo=44]="fontInfo",j[j.fontLigatures=45]="fontLigatures",j[j.fontSize=46]="fontSize",j[j.fontWeight=47]="fontWeight",j[j.formatOnPaste=48]="formatOnPaste",j[j.formatOnType=49]="formatOnType",j[j.glyphMargin=50]="glyphMargin",j[j.gotoLocation=51]="gotoLocation",j[j.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",j[j.hover=53]="hover",j[j.inDiffEditor=54]="inDiffEditor",j[j.inlineSuggest=55]="inlineSuggest",j[j.letterSpacing=56]="letterSpacing",j[j.lightbulb=57]="lightbulb",j[j.lineDecorationsWidth=58]="lineDecorationsWidth",j[j.lineHeight=59]="lineHeight",j[j.lineNumbers=60]="lineNumbers",j[j.lineNumbersMinChars=61]="lineNumbersMinChars",j[j.linkedEditing=62]="linkedEditing",j[j.links=63]="links",j[j.matchBrackets=64]="matchBrackets",j[j.minimap=65]="minimap",j[j.mouseStyle=66]="mouseStyle",j[j.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=68]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",j[j.multiCursorModifier=70]="multiCursorModifier",j[j.multiCursorPaste=71]="multiCursorPaste",j[j.occurrencesHighlight=72]="occurrencesHighlight",j[j.overviewRulerBorder=73]="overviewRulerBorder",j[j.overviewRulerLanes=74]="overviewRulerLanes",j[j.padding=75]="padding",j[j.parameterHints=76]="parameterHints",j[j.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",j[j.quickSuggestions=79]="quickSuggestions",j[j.quickSuggestionsDelay=80]="quickSuggestionsDelay",j[j.readOnly=81]="readOnly",j[j.renameOnType=82]="renameOnType",j[j.renderControlCharacters=83]="renderControlCharacters",j[j.renderFinalNewline=84]="renderFinalNewline",j[j.renderLineHighlight=85]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=87]="renderValidationDecorations",j[j.renderWhitespace=88]="renderWhitespace",j[j.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",j[j.roundedSelection=90]="roundedSelection",j[j.rulers=91]="rulers",j[j.scrollbar=92]="scrollbar",j[j.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=94]="scrollBeyondLastLine",j[j.scrollPredominantAxis=95]="scrollPredominantAxis",j[j.selectionClipboard=96]="selectionClipboard",j[j.selectionHighlight=97]="selectionHighlight",j[j.selectOnLineNumbers=98]="selectOnLineNumbers",j[j.showFoldingControls=99]="showFoldingControls",j[j.showUnused=100]="showUnused",j[j.snippetSuggestions=101]="snippetSuggestions",j[j.smartSelect=102]="smartSelect",j[j.smoothScrolling=103]="smoothScrolling",j[j.stickyTabStops=104]="stickyTabStops",j[j.stopRenderingLineAfter=105]="stopRenderingLineAfter",j[j.suggest=106]="suggest",j[j.suggestFontSize=107]="suggestFontSize",j[j.suggestLineHeight=108]="suggestLineHeight",j[j.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",j[j.suggestSelection=110]="suggestSelection",j[j.tabCompletion=111]="tabCompletion",j[j.tabIndex=112]="tabIndex",j[j.unicodeHighlighting=113]="unicodeHighlighting",j[j.unusualLineTerminators=114]="unusualLineTerminators",j[j.useShadowDOM=115]="useShadowDOM",j[j.useTabStops=116]="useTabStops",j[j.wordSeparators=117]="wordSeparators",j[j.wordWrap=118]="wordWrap",j[j.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=121]="wordWrapColumn",j[j.wordWrapOverride1=122]="wordWrapOverride1",j[j.wordWrapOverride2=123]="wordWrapOverride2",j[j.wrappingIndent=124]="wrappingIndent",j[j.wrappingStrategy=125]="wrappingStrategy",j[j.showDeprecated=126]="showDeprecated",j[j.inlayHints=127]="inlayHints",j[j.editorClassName=128]="editorClassName",j[j.pixelRatio=129]="pixelRatio",j[j.tabFocusMode=130]="tabFocusMode",j[j.layoutInfo=131]="layoutInfo",j[j.wrappingInfo=132]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(159,null)})),acceptSuggestionOnEnter:ke(new k(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(160,null),""],markdownDescription:a.localize(161,null)})),accessibilitySupport:ke(new n),accessibilityPageSize:ke(new S(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(162,null)})),ariaLabel:ke(new _(4,"ariaLabel",a.localize(163,null))),autoClosingBrackets:ke(new k(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(164,null),a.localize(165,null),""],description:a.localize(166,null)})),autoClosingDelete:ke(new k(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(167,null),""],description:a.localize(168,null)})),autoClosingOvertype:ke(new k(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(169,null),""],description:a.localize(170,null)})),autoClosingQuotes:ke(new k(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(171,null),a.localize(172,null),""],description:a.localize(173,null)})),autoIndent:ke(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[a.localize(174,null),a.localize(175,null),a.localize(176,null),a.localize(177,null),a.localize(178,null)],description:a.localize(179,null)})),automaticLayout:ke(new c(10,"automaticLayout",!1)),autoSurround:ke(new k(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),""],description:a.localize(183,null)})),bracketPairColorization:ke(new G),bracketPairGuides:ke(new T),stickyTabStops:ke(new c(104,"stickyTabStops",!1,{description:a.localize(184,null)})),codeLens:ke(new c(14,"codeLens",!0,{description:a.localize(185,null)})),codeLensFontFamily:ke(new _(15,"codeLensFontFamily","",{description:a.localize(186,null)})),codeLensFontSize:ke(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(187,null)})),colorDecorators:ke(new c(17,"colorDecorators",!0,{description:a.localize(188,null)})),columnSelection:ke(new c(18,"columnSelection",!1,{description:a.localize(189,null)})),comments:ke(new t),contextmenu:ke(new c(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new c(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(190,null)})),cursorBlinking:ke(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:a.localize(191,null)})),cursorSmoothCaretAnimation:ke(new c(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(192,null)})),cursorStyle:ke(new i(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:a.localize(193,null)})),cursorSurroundingLines:ke(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(194,null)})),cursorSurroundingLinesStyle:ke(new k(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(195,null),a.localize(196,null)],description:a.localize(197,null)})),cursorWidth:ke(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(198,null)})),disableLayerHinting:ke(new c(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new c(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new c(30,"domReadOnly",!1)),dragAndDrop:ke(new c(31,"dragAndDrop",!0,{description:a.localize(199,null)})),emptySelectionClipboard:ke(new R),extraEditorClassName:ke(new _(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:a.localize(200,null)})),find:ke(new E),fixedOverflowWidgets:ke(new c(36,"fixedOverflowWidgets",!1)),folding:ke(new c(37,"folding",!0,{description:a.localize(201,null)})),foldingStrategy:ke(new k(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),foldingHighlight:ke(new c(39,"foldingHighlight",!0,{description:a.localize(205,null)})),foldingImportsByDefault:ke(new c(40,"foldingImportsByDefault",!1,{description:a.localize(206,null)})),foldingMaximumRegions:ke(new S(41,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(207,null)})),unfoldOnClickAfterEndOfLine:ke(new c(42,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(208,null)})),fontFamily:ke(new _(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(209,null)})),fontInfo:ke(new z),fontLigatures2:ke(new x),fontSize:ke(new V),fontWeight:ke(new se),formatOnPaste:ke(new c(48,"formatOnPaste",!1,{description:a.localize(210,null)})),formatOnType:ke(new c(49,"formatOnType",!1,{description:a.localize(211,null)})),glyphMargin:ke(new c(50,"glyphMargin",!0,{description:a.localize(212,null)})),gotoLocation:ke(new K),hideCursorInOverviewRuler:ke(new c(52,"hideCursorInOverviewRuler",!1,{description:a.localize(213,null)})),hover:ke(new L),inDiffEditor:ke(new c(54,"inDiffEditor",!1)),letterSpacing:ke(new l(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>l.clamp(j,-5,20),{description:a.localize(214,null)})),lightbulb:ke(new ae),lineDecorationsWidth:ke(new u(58,"lineDecorationsWidth",10)),lineHeight:ke(new ee),lineNumbers:ke(new Ge),lineNumbersMinChars:ke(new S(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new c(62,"linkedEditing",!1,{description:a.localize(215,null)})),links:ke(new c(63,"links",!0,{description:a.localize(216,null)})),matchBrackets:ke(new k(64,"matchBrackets","always",["always","near","never"],{description:a.localize(217,null)})),minimap:ke(new Ee),mouseStyle:ke(new k(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(67,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:a.localize(218,null)})),mouseWheelZoom:ke(new c(68,"mouseWheelZoom",!1,{markdownDescription:a.localize(219,null)})),multiCursorMergeOverlapping:ke(new c(69,"multiCursorMergeOverlapping",!0,{description:a.localize(220,null)})),multiCursorModifier:ke(new i(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[a.localize(221,null),a.localize(222,null)],markdownDescription:a.localize(223,null)})),multiCursorPaste:ke(new k(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(224,null),a.localize(225,null)],markdownDescription:a.localize(226,null)})),occurrencesHighlight:ke(new c(72,"occurrencesHighlight",!0,{description:a.localize(227,null)})),overviewRulerBorder:ke(new c(73,"overviewRulerBorder",!0,{description:a.localize(228,null)})),overviewRulerLanes:ke(new S(74,"overviewRulerLanes",3,0,3)),padding:ke(new J),parameterHints:ke(new ve),peekWidgetDefaultFocus:ke(new k(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(229,null),a.localize(230,null)],description:a.localize(231,null)})),definitionLinkOpensInPeek:ke(new c(78,"definitionLinkOpensInPeek",!1,{description:a.localize(232,null)})),quickSuggestions:ke(new Fe),quickSuggestionsDelay:ke(new S(80,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(233,null)})),readOnly:ke(new c(81,"readOnly",!1)),renameOnType:ke(new c(82,"renameOnType",!1,{description:a.localize(234,null),markdownDeprecationMessage:a.localize(235,null)})),renderControlCharacters:ke(new c(83,"renderControlCharacters",!0,{description:a.localize(236,null),restricted:!0})),renderFinalNewline:ke(new c(84,"renderFinalNewline",!0,{description:a.localize(237,null)})),renderLineHighlight:ke(new k(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(238,null)],description:a.localize(239,null)})),renderLineHighlightOnlyWhenFocus:ke(new c(86,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(240,null)})),renderValidationDecorations:ke(new k(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new k(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(241,null),a.localize(242,null),a.localize(243,null),""],description:a.localize(244,null)})),revealHorizontalRightPadding:ke(new S(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new c(90,"roundedSelection",!0,{description:a.localize(245,null)})),rulers:ke(new _e),scrollbar:ke(new re),scrollBeyondLastColumn:ke(new S(93,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(246,null)})),scrollBeyondLastLine:ke(new c(94,"scrollBeyondLastLine",!0,{description:a.localize(247,null)})),scrollPredominantAxis:ke(new c(95,"scrollPredominantAxis",!0,{description:a.localize(248,null)})),selectionClipboard:ke(new c(96,"selectionClipboard",!0,{description:a.localize(249,null),included:D.isLinux})),selectionHighlight:ke(new c(97,"selectionHighlight",!0,{description:a.localize(250,null)})),selectOnLineNumbers:ke(new c(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new k(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(251,null),a.localize(252,null)],description:a.localize(253,null)})),showUnused:ke(new c(100,"showUnused",!0,{description:a.localize(254,null)})),showDeprecated:ke(new c(126,"showDeprecated",!0,{description:a.localize(255,null)})),inlayHints:ke(new fe),snippetSuggestions:ke(new k(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(256,null),a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),smartSelect:ke(new H),smoothScrolling:ke(new c(103,"smoothScrolling",!1,{description:a.localize(261,null)})),stopRenderingLineAfter:ke(new S(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new W),inlineSuggest:ke(new X),suggestFontSize:ke(new S(107,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(262,null)})),suggestLineHeight:ke(new S(108,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(263,null)})),suggestOnTriggerCharacters:ke(new c(109,"suggestOnTriggerCharacters",!0,{description:a.localize(264,null)})),suggestSelection:ke(new k(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(265,null),a.localize(266,null),a.localize(267,null)],description:a.localize(268,null)})),tabCompletion:ke(new k(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(269,null),a.localize(270,null),a.localize(271,null)],description:a.localize(272,null)})),tabIndex:ke(new S(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new le),unusualLineTerminators:ke(new k(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(273,null),a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),useShadowDOM:ke(new c(115,"useShadowDOM",!0)),useTabStops:ke(new c(116,"useTabStops",!0,{description:a.localize(277,null)})),wordSeparators:ke(new _(117,"wordSeparators",g.USUAL_WORD_SEPARATORS,{description:a.localize(278,null)})),wordWrap:ke(new k(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(279,null),a.localize(280,null),a.localize(281,null),a.localize(282,null)],description:a.localize(283,null)})),wordWrapBreakAfterCharacters:ke(new _(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new _(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new S(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(284,null)})),wordWrapOverride1:ke(new k(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new k(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new i(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null),a.localize(288,null)],description:a.localize(289,null)})),wrappingStrategy:ke(new k(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(290,null),a.localize(291,null)],description:a.localize(292,null)})),editorClassName:ke(new U),pixelRatio:ke(new Pe),tabFocusMode:ke(new ne),layoutInfo:ke(new de),wrappingInfo:ke(new ge)}}),define(Se[122],De([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[123],De([18,19]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[124],De([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[125],De([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(Se[126],De([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(Se[127],De([18,19]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(Se[128],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[129],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[130],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[131],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[132],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[133],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[134],De([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[135],De([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(Se[136],De([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[137],De([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[138],De([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Se[139],De([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[140],De([18,19]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[141],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var a;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var D;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(D=e.EditorResolution||(e.EditorResolution={}));var g;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(g=e.EditorOpenSource||(e.EditorOpenSource={}));var N;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(N=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var I;(function(P){P.PROGRAMMATIC="api",P.NAVIGATION="code.navigation",P.JUMP="code.jump"})(I=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Se[142],De([1,0,23,32,124,232]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(c){return c=c.trim(),c==="*"||I.test(c)}e.isValidVersionStr=w;function A(c){if(!w(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=c.match(I);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=A;function O(c){if(!c)return null;let y=c.majorBase,S=c.majorMustEqual,l=c.minorBase,_=c.minorMustEqual,r=c.patchBase,k=c.patchMustEqual;c.hasCaret&&(y===0||(_=!1),k=!1);let i=0;if(c.preRelease){const s=P.exec(c.preRelease);if(s){const[,n,t,o]=s;i=Date.UTC(Number(n),Number(t)-1,Number(o))}}return{majorBase:y,majorMustEqual:S,minorBase:l,minorMustEqual:_,patchBase:r,patchMustEqual:k,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function v(c,y,S){let l;typeof c=="string"?l=O(A(c)):l=c;let _;y instanceof Date?_=y.getTime():typeof y=="string"&&(_=new Date(y).getTime());let r;if(typeof S=="string"?r=O(A(S)):r=S,!l||!r)return!1;let k=l.majorBase,i=l.minorBase,s=l.patchBase,n=r.majorBase,t=r.minorBase,o=r.patchBase,m=r.notBefore,h=r.majorMustEqual,C=r.minorMustEqual,F=r.patchMustEqual;return r.isMinimum?k>n?!0:k<n?!1:i>t?!0:i<t||_&&_<m?!1:s>=o:(k===1&&n===0&&(!h||!C||!F)&&(n=1,t=0,o=0,h=!0,C=!1,F=!1),k<n?!1:k>n?!h:i<t?!1:i>t?!C:s<o?!1:s>o?!F:!(_&&_<m))}e.isValidVersion=v;function p(c,y,S,l,_){const r=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return r.push([D.default.Error,g.localize(0,null)]),r;if(typeof l.name!="string")return r.push([D.default.Error,g.localize(1,null,"name")]),r;if(typeof l.version!="string")return r.push([D.default.Error,g.localize(2,null,"version")]),r;if(!l.engines)return r.push([D.default.Error,g.localize(3,null,"engines")]),r;if(typeof l.engines.vscode!="string")return r.push([D.default.Error,g.localize(4,null,"engines.vscode")]),r;if(typeof l.extensionDependencies!="undefined"&&!d(l.extensionDependencies))return r.push([D.default.Error,g.localize(5,null,"extensionDependencies")]),r;if(typeof l.activationEvents!="undefined"){if(!d(l.activationEvents))return r.push([D.default.Error,g.localize(6,null,"activationEvents")]),r;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return r.push([D.default.Error,g.localize(7,null,"activationEvents","main")]),r}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&r.push([D.default.Warning,g.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return r.push([D.default.Error,g.localize(9,null,"main")]),r;{const s=(0,a.joinPath)(S,l.main);(0,a.isEqualOrParent)(s,S)||r.push([D.default.Warning,g.localize(10,null,s.path,S.path)])}if(typeof l.activationEvents=="undefined")return r.push([D.default.Error,g.localize(11,null,"activationEvents","main")]),r}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return r.push([D.default.Error,g.localize(12,null,"browser")]),r;{const s=(0,a.joinPath)(S,l.browser);(0,a.isEqualOrParent)(s,S)||r.push([D.default.Warning,g.localize(13,null,s.path,S.path)])}if(typeof l.activationEvents=="undefined")return r.push([D.default.Error,g.localize(14,null,"activationEvents","browser")]),r}if(!N.valid(l.version))return r.push([D.default.Error,g.localize(15,null)]),r;const k=[];if(!b(c,y,l,_,k))for(const s of k)r.push([D.default.Error,s]);return r}e.validateExtensionManifest=p;function b(c,y,S,l,_){return l||typeof S.main=="undefined"&&typeof S.browser=="undefined"?!0:u(c,y,S.engines.vscode,_)}e.isValidExtensionVersion=b;function f(c,y,S){return c==="*"||u(y,S,c)}e.isEngineValid=f;function u(c,y,S,l=[]){let _=O(A(S));if(!_)return l.push(g.localize(16,null,S)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return l.push(g.localize(17,null,S)),!1}else if(!_.majorMustEqual)return l.push(g.localize(18,null,S)),!1;return v(c,y,_)?!0:(l.push(g.localize(19,null,c,S)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let y=0,S=c.length;y<S;y++)if(typeof c[y]!="string")return!1;return!0}}),define(Se[78],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(g,N=[],I=!1){this.ctor=g,this.staticArguments=N,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=a}),define(Se[58],De([1,0,78]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const D=[];function g(I,P,w){P instanceof a.SyncDescriptor||(P=new a.SyncDescriptor(P,[],w)),D.push([I,P])}e.registerSingleton=g;function N(){return D}e.getSingletonServiceDescriptors=N}),define(Se[143],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(N){this.incoming=new Map,this.outgoing=new Map,this.data=N}}e.Node=a;class D{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(let I of this._nodes.values())I.outgoing.size===0&&N.push(I);return N}insertEdge(N,I){const P=this.lookupOrInsertNode(N),w=this.lookupOrInsertNode(I);P.outgoing.set(this._hashFn(I),w),w.incoming.set(this._hashFn(N),P)}removeNode(N){const I=this._hashFn(N);this._nodes.delete(I);for(let P of this._nodes.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(N){const I=this._hashFn(N);let P=this._nodes.get(I);return P||(P=new a(N),this._nodes.set(I,P)),P}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){let N=[];for(let[I,P]of this._nodes)N.push(`${I}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return N.join(`
`)}findCycleSlow(){for(let[N,I]of this._nodes){const P=new Set([N]),w=this._findCycle(I,P);if(w)return w}}_findCycle(N,I){for(let[P,w]of N.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const A=this._findCycle(w,I);if(A)return A;I.delete(P)}}}e.Graph=D}),define(Se[3],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=g("instantiationService");function D(I,P,w){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:I,index:w}):(P[a.DI_DEPENDENCIES]=[{id:I,index:w}],P[a.DI_TARGET]=P)}function g(I){if(a.serviceIds.has(I))return a.serviceIds.get(I);const P=function(w,A,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,w,O)};return P.toString=()=>I,a.serviceIds.set(I,P),P}e.createDecorator=g;function N(I){return I}e.refineServiceDecorator=N}),define(Se[59],De([1,0,10,2,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,g.createDecorator)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationOverrides=N;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||a.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function A(c,y){const S=Object.create(null);for(let l in c)O(S,l,c[l],y);return S}e.toValuesTree=A;function O(c,y,S,l){const _=y.split("."),r=_.pop();let k=c;for(let i=0;i<_.length;i++){let s=_[i],n=k[s];switch(typeof n){case"undefined":n=k[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${y} as ${_.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}k=n}if(typeof k=="object"&&k!==null)try{k[r]=S}catch{l(`Ignoring ${y} as ${_.join(".")} is ${JSON.stringify(k)}`)}else l(`Ignoring ${y} as ${_.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=O;function v(c,y){const S=y.split(".");p(c,S)}e.removeFromValueTree=v;function p(c,y){const S=y.shift();if(y.length===0){delete c[S];return}if(Object.keys(c).indexOf(S)!==-1){const l=c[S];typeof l=="object"&&!Array.isArray(l)&&(p(l,y),Object.keys(l).length===0&&delete c[S])}}function b(c,y,S){function l(k,i){let s=k;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const _=y.split("."),r=l(c,_);return typeof r=="undefined"?S:r}e.getConfigurationValue=b;function f(c,y,S){Object.keys(y).forEach(l=>{l!=="__proto__"&&(l in c?a.isObject(c[l])&&a.isObject(y[l])?f(c[l],y[l],S):S&&(c[l]=y[l]):c[l]=y[l])})}e.merge=f;function u(c,y,S){const l=c.inspect(y),_=c.inspect(S);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:l.defaultValue}e.getMigratedSettingValue=u;function d(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Se[44],De([1,0,22,9,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",a.isMacintosh),N.set("isLinux",a.isLinux),N.set("isWindows",a.isWindows),N.set("isWeb",a.isWeb),N.set("isMacNative",a.isMacintosh&&!a.isWeb),N.set("isEdge",a.isEdge),N.set("isFirefox",a.isFirefox),N.set("isChrome",a.isChrome),N.set("isSafari",a.isSafari);const I=Object.prototype.hasOwnProperty;var P;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return v.INSTANCE}static true(){return p.INSTANCE}static has(E){return b.create(E)}static equals(E,x){return f.create(E,x)}static notEquals(E,x){return c.create(E,x)}static regex(E,x){return i.create(E,x)}static in(E,x){return u.create(E,x)}static not(E){return y.create(E)}static and(...E){return t.create(E,null)}static or(...E){return o.create(E,null,!0)}static greater(E,x){return l.create(E,x)}static greaterEquals(E,x){return _.create(E,x)}static smaller(E,x){return r.create(E,x)}static smallerEquals(E,x){return k.create(E,x)}static deserialize(E,x=!1){if(!!E)return this._deserializeOrExpression(E,x)}static _deserializeOrExpression(E,x){let z=E.split("||");return o.create(z.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(E,x){let z=E.split("&&");return t.create(z.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(E,x){if(E=E.trim(),E.indexOf("!=")>=0){let z=E.split("!=");return c.create(z[0].trim(),this._deserializeValue(z[1],x))}if(E.indexOf("==")>=0){let z=E.split("==");return f.create(z[0].trim(),this._deserializeValue(z[1],x))}if(E.indexOf("=~")>=0){let z=E.split("=~");return i.create(z[0].trim(),this._deserializeRegexValue(z[1],x))}if(E.indexOf(" in ")>=0){let z=E.split(" in ");return u.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const z=E.split(">=");return _.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const z=E.split(">");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const z=E.split("<=");return k.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const z=E.split("<");return r.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(E)?y.create(E.substr(1).trim()):b.create(E)}static _deserializeValue(E,x){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let z=/^'([^']*)'$/.exec(E);return z?z[1].trim():E}static _deserializeRegexValue(E,x){if((0,D.isFalsyOrWhitespace)(E)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=E.indexOf("/"),V=E.lastIndexOf("/");if(z===V||z<0){if(x)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let se=E.slice(z+1,V),K=E[V+1]==="i"?"i":"";try{return new RegExp(se,K)}catch(L){if(x)throw new Error(`bad regexp-value '${E}', parse error: ${L}`);return console.warn(`bad regexp-value '${E}', parse error: ${L}`),null}}}e.ContextKeyExpr=w;function A(R,E){const x=R?R.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!x&&!z?!0:!x||!z?!1:x.equals(z)}e.expressionsAreEqualWithConstantSubstitution=A;function O(R,E){return R.cmp(E)}class v{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class p{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class b{constructor(E,x){this.key=E,this.negated=x,this.type=2}static create(E,x=null){const z=N.get(E);return typeof z=="boolean"?z?p.INSTANCE:v.INSTANCE:new b(E,x)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=N.get(this.key);return typeof E=="boolean"?E?p.INSTANCE:v.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class f{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=4}static create(E,x,z=null){if(typeof x=="boolean")return x?b.create(E,z):y.create(E,z);const V=N.get(E);return typeof V=="boolean"?x===(V?"true":"false")?p.INSTANCE:v.INSTANCE:new f(E,x,z)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=N.get(this.key);if(typeof E=="boolean"){const x=E?"true":"false";return this.value===x?p.INSTANCE:v.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class u{constructor(E,x){this.key=E,this.valueKey=x,this.type=10,this.negated=null}static create(E,x){return new u(E,x)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const x=E.getValue(this.valueKey),z=E.getValue(this.key);return Array.isArray(x)?x.includes(z):typeof z=="string"&&typeof x=="object"&&x!==null?I.call(x,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=u;class d{constructor(E){this._actual=E,this.type=11}static create(E){return new d(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new d(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class c{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=5}static create(E,x,z=null){if(typeof x=="boolean")return x?y.create(E,z):b.create(E,z);const V=N.get(E);return typeof V=="boolean"?x===(V?"true":"false")?v.INSTANCE:p.INSTANCE:new c(E,x,z)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=N.get(this.key);if(typeof E=="boolean"){const x=E?"true":"false";return this.value===x?v.INSTANCE:p.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=c;class y{constructor(E,x){this.key=E,this.negated=x,this.type=3}static create(E,x=null){const z=N.get(E);return typeof z=="boolean"?z?v.INSTANCE:p.INSTANCE:new y(E,x)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=N.get(this.key);return typeof E=="boolean"?E?v.INSTANCE:p.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function S(R,E){if(typeof R=="string"){const x=parseFloat(R);isNaN(x)||(R=x)}return typeof R=="string"||typeof R=="number"?E(R):v.INSTANCE}class l{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=12}static create(E,x,z=null){return S(x,V=>new l(E,V,z))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class _{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=13}static create(E,x,z=null){return S(x,V=>new _(E,V,z))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class r{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=14}static create(E,x,z=null){return S(x,V=>new r(E,V,z))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class k{constructor(E,x,z){this.key=E,this.value=x,this.negated=z,this.type=15}static create(E,x,z=null){return S(x,V=>new k(E,V,z))}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class i{constructor(E,x){this.key=E,this.regexp=x,this.type=7,this.negated=null}static create(E,x){return new i(E,x)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const x=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return x<z?-1:x>z?1:0}equals(E){if(E.type===this.type){const x=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return this.key===E.key&&x===z}return!1}substituteConstants(){return this}evaluate(E){let x=E.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class s{constructor(E){this._actual=E,this.type=8}static create(E){return new s(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new s(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function n(R){let E=null;for(let x=0,z=R.length;x<z;x++){const V=R[x].substituteConstants();if(R[x]!==V&&E===null){E=[];for(let se=0;se<x;se++)E[se]=R[se]}E!==null&&(E[x]=V)}return E===null?R:E}class t{constructor(E,x){this.expr=E,this.negated=x,this.type=6}static create(E,x){return t._normalizeArr(E,x)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let x=0,z=this.expr.length;x<z;x++){const V=O(this.expr[x],E.expr[x]);if(V!==0)return V}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let x=0,z=this.expr.length;x<z;x++)if(!this.expr[x].equals(E.expr[x]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:t.create(E,this.negated)}evaluate(E){for(let x=0,z=this.expr.length;x<z;x++)if(!this.expr[x].evaluate(E))return!1;return!0}static _normalizeArr(E,x){const z=[];let V=!1;for(const se of E)if(!!se){if(se.type===1){V=!0;continue}if(se.type===0)return v.INSTANCE;if(se.type===6){z.push(...se.expr);continue}z.push(se)}if(z.length===0&&V)return p.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(O);for(let se=1;se<z.length;se++)z[se-1].equals(z[se])&&(z.splice(se,1),se--);if(z.length===1)return z[0];for(;z.length>1;){const se=z[z.length-1];if(se.type!==9)break;z.pop();const K=z.pop(),L=z.length===0,oe=o.create(se.expr.map(de=>t.create([de,K],null)),null,L);oe&&(z.push(oe),z.sort(O))}return z.length===1?z[0]:new t(z,x)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let x of this.expr)E.push(...x.keys());return E}map(E){return new t(this.expr.map(x=>x.map(E)),null)}negate(){if(!this.negated){const E=[];for(let x of this.expr)E.push(x.negate());this.negated=o.create(E,this,!0)}return this.negated}}class o{constructor(E,x){this.expr=E,this.negated=x,this.type=9}static create(E,x,z){return o._normalizeArr(E,x,z)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let x=0,z=this.expr.length;x<z;x++){const V=O(this.expr[x],E.expr[x]);if(V!==0)return V}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let x=0,z=this.expr.length;x<z;x++)if(!this.expr[x].equals(E.expr[x]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:o.create(E,this.negated,!1)}evaluate(E){for(let x=0,z=this.expr.length;x<z;x++)if(this.expr[x].evaluate(E))return!0;return!1}static _normalizeArr(E,x,z){let V=[],se=!1;if(E){for(let K=0,L=E.length;K<L;K++){const oe=E[K];if(!!oe){if(oe.type===0){se=!0;continue}if(oe.type===1)return p.INSTANCE;if(oe.type===9){V=V.concat(oe.expr);continue}V.push(oe)}}if(V.length===0&&se)return v.INSTANCE;V.sort(O)}if(V.length!==0){if(V.length===1)return V[0];for(let K=1;K<V.length;K++)V[K-1].equals(V[K])&&(V.splice(K,1),K--);if(V.length===1)return V[0];if(z){for(let K=0;K<V.length;K++)for(let L=K+1;L<V.length;L++)F(V[K],V[L])&&(V.splice(L,1),L--);if(V.length===1)return V[0]}return new o(V,x)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let x of this.expr)E.push(...x.keys());return E}map(E){return new o(this.expr.map(x=>x.map(E)),null)}negate(){if(!this.negated){let E=[];for(let x of this.expr)E.push(x.negate());for(;E.length>1;){const x=E.shift(),z=E.shift(),V=[];for(const K of U(x))for(const L of U(z))V.push(t.create([K,L],null));const se=E.length===0;E.unshift(o.create(V,null,se))}this.negated=E[0]}return this.negated}}class m extends b{constructor(E,x,z){super(E,null);this._defaultValue=x,typeof z=="object"?m._info.push({...z,key:E}):z!==!0&&m._info.push({key:E,description:z,type:x!=null?typeof x:void 0})}static all(){return m._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return f.create(this.key,E)}notEqualsTo(E){return c.create(this.key,E)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,g.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(R,E){return R<E?-1:R>E?1:0}function C(R,E,x,z){return R<x?-1:R>x?1:E<z?-1:E>z?1:0}function F(R,E){if(E.type===6&&R.type!==9&&R.type!==6){for(const V of E.expr)if(R.equals(V))return!0}const x=R.negate(),z=U(x).concat(U(E));z.sort(O);for(let V=0;V<z.length;V++){const K=z[V].negate();for(let L=V+1;L<z.length;L++){const oe=z[L];if(K.equals(oe))return!0}}return!1}e.implies=F;function U(R){return R.type===9?R.expr:[R]}}),define(Se[144],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[145],De([1,0,123,3]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function g(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=g;function N(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function I(c,y){switch(c){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function P(c,y){return y==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(c,y,S){return P(y,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:A(S).includes(c)}e.isTargetPlatformCompatible=w;function A(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function O(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=O;var v;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var u;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(u=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(y,S){super(y);this.code=S,this.name=S}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Se[38],De([1,0,12,21,17,9,10,2,125,3]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function O(L){return L.create===!0}e.isFileOpenForWriteOptions=O;var v;(function(L){L[L.Unknown=0]="Unknown",L[L.File=1]="File",L[L.Directory=2]="Directory",L[L.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var p;(function(L){L[L.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var b;(function(L){L[L.FileReadWrite=2]="FileReadWrite",L[L.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",L[L.FileReadStream=16]="FileReadStream",L[L.FileFolderCopy=8]="FileFolderCopy",L[L.PathCaseSensitive=1024]="PathCaseSensitive",L[L.Readonly=2048]="Readonly",L[L.Trash=4096]="Trash",L[L.FileWriteUnlock=8192]="FileWriteUnlock",L[L.FileAtomicRead=16384]="FileAtomicRead",L[L.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(L){return!!(L.capabilities&2)}e.hasReadWriteCapability=f;function u(L){return!!(L.capabilities&8)}e.hasFileFolderCopyCapability=u;function d(L){return!!(L.capabilities&32768)}e.hasFileCloneCapability=d;function c(L){return!!(L.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function y(L){return!!(L.capabilities&16)}e.hasFileReadStreamCapability=y;function S(L){return f(L)?!!(L.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var l;(function(L){L.FileExists="EntryExists",L.FileNotFound="EntryNotFound",L.FileNotADirectory="EntryNotADirectory",L.FileIsADirectory="EntryIsADirectory",L.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",L.FileTooLarge="EntryTooLarge",L.FileWriteLocked="EntryWriteLocked",L.NoPermissions="NoPermissions",L.Unavailable="Unavailable",L.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(oe,de){super(oe);this.code=de}}e.FileSystemProviderError=_;function r(L,oe){const de=new _(L.toString(),oe);return i(de,oe),de}e.createFileSystemProviderError=r;function k(L){return L||r((0,w.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=k;function i(L,oe){return L.name=oe?`${oe} (FileSystemError)`:"FileSystemError",L}e.markAsFileSystemProviderError=i;function s(L){if(!L)return l.Unknown;if(L instanceof _)return L.code;const oe=/^(.+) \(FileSystemError\)$/.exec(L.name);if(!oe)return l.Unknown;switch(oe[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=s;function n(L){if(L instanceof F)return L.fileOperationResult;switch(s(L)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(L){L[L.CREATE=0]="CREATE",L[L.DELETE=1]="DELETE",L[L.MOVE=2]="MOVE",L[L.COPY=3]="COPY",L[L.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(oe,de,ae){this.resource=oe,this.operation=de,this.target=ae}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=o;var m;(function(L){L[L.UPDATED=0]="UPDATED",L[L.ADDED=1]="ADDED",L[L.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class h{constructor(oe,de){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=oe;const ae=new Map;for(const fe of oe){const ee=ae.get(fe.type);switch(ee?ee.push([fe.resource,fe]):ae.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,ee]of ae)switch(fe){case 1:this.added=D.TernarySearchTree.forUris(()=>de),this.added.fill(ee);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>de),this.updated.fill(ee);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>de),this.deleted.fill(ee);break}}contains(oe,...de){return this.doContains(oe,{includeChildren:!1},...de)}affects(oe,...de){return this.doContains(oe,{includeChildren:!0},...de)}doContains(oe,de,...ae){if(!oe)return!1;const fe=ae.length>0;return!!((!fe||ae.includes(1))&&(this.added?.get(oe)||de.includeChildren&&this.added?.findSuperstr(oe))||(!fe||ae.includes(0))&&(this.updated?.get(oe)||de.includeChildren&&this.updated?.findSuperstr(oe))||(!fe||ae.includes(2))&&(this.deleted?.findSubstr(oe)||de.includeChildren&&this.deleted?.findSuperstr(oe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function C(L,oe,de){return!L||!oe||L===oe||oe.length>L.length?!1:(oe.charAt(oe.length-1)!==g.sep&&(oe+=g.sep),de?(0,N.startsWithIgnoreCase)(L,oe):L.indexOf(oe)===0)}e.isParent=C;class F extends a.ErrorNoTelemetry{constructor(oe,de,ae){super(oe);this.fileOperationResult=de,this.options=ae}}e.FileOperationError=F;class U extends F{constructor(oe,de,ae){super(oe,2,ae);this.stat=de}}e.NotModifiedSinceFileOperationError=U;var R;(function(L){L[L.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",L[L.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",L[L.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",L[L.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",L[L.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",L[L.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",L[L.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",L[L.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",L[L.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",L[L.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",L[L.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",L[L.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(L){L[L.FILE=0]="FILE",L[L.FOLDER=1]="FOLDER",L[L.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(L){if(!(typeof L.size!="number"||typeof L.mtime!="number"))return L.mtime.toString(29)+L.size.toString(31)}e.etag=x;async function z(L,oe){if(!oe.hasProvider(P.URI.from({scheme:L.scheme})))return new Promise(de=>{const ae=oe.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===L.scheme&&fe.added&&(ae.dispose(),de())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(oe){return(0,I.isNumber)(oe)||(oe=0),oe<V.KB?(0,w.localize)(1,null,oe.toFixed(0)):oe<V.MB?(0,w.localize)(2,null,(oe/V.KB).toFixed(2)):oe<V.GB?(0,w.localize)(3,null,(oe/V.MB).toFixed(2)):oe<V.TB?(0,w.localize)(4,null,(oe/V.GB).toFixed(2)):(0,w.localize)(5,null,(oe/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var se;(function(L){L[L.IA32=0]="IA32",L[L.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function K(L){return{maxFileSize:L===0?300*V.MB:16*V.GB,maxHeapSize:L===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=K}),define(Se[60],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...g){this._entries=new Map;for(let[N,I]of g)this.set(N,I)}set(g,N){const I=this._entries.get(g);return this._entries.set(g,N),I}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=a}),define(Se[146],De([1,0,14,12,78,143,3,60]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class A extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new P.ServiceCollection,u=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=u,this._parent=d,this._services.set(I.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...u){let d=p.traceInvocation(f),c=!1;try{return f({get:S=>{if(c)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(S,d);if(!l)throw new Error(`[invokeFunction] unknown service '${S}'`);return l}},...u)}finally{c=!0,d.stop()}}createInstance(f,...u){let d,c;return f instanceof g.SyncDescriptor?(d=p.traceCreation(f.ctor),c=this._createInstance(f.ctor,f.staticArguments.concat(u),d)):(d=p.traceCreation(f),c=this._createInstance(f,u,d)),d.stop(),c}_createInstance(f,u=[],d){let c=I._util.getServiceDependencies(f).sort((l,_)=>l.index-_.index),y=[];for(const l of c){let _=this._getOrCreateServiceInstance(l.id,d);_||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(_)}let S=c.length>0?c[0].index:u.length;if(u.length!==S){console.trace(`[createInstance] First service dependency of ${f.name} at position ${S+1} conflicts with ${u.length} static arguments`);let l=S-u.length;l>0?u=u.concat(new Array(l)):u=u.slice(0,S)}return new f(...[...u,...y])}_setServiceInstance(f,u){if(this._services.get(f)instanceof g.SyncDescriptor)this._services.set(f,u);else if(this._parent)this._parent._setServiceInstance(f,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let u=this._services.get(f);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):u}_getOrCreateServiceInstance(f,u){let d=this._getServiceInstanceOrDescriptor(f);return d instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,u.branch(f,!0)):(u.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,u,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,u,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,u,d){const c=new N.Graph(l=>l.id.toString());let y=0;const S=[{id:f,desc:u,_trace:d}];for(;S.length;){const l=S.pop();if(c.lookupOrInsertNode(l),y++>1e3)throw new A(c);for(let _ of I._util.getServiceDependencies(l.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(_.id);if(r||this._throwIfStrict(`[createInstance] ${f} depends on ${_.id} which is NOT registered.`,!0),r instanceof g.SyncDescriptor){const k={id:_.id,desc:r,_trace:l._trace.branch(_.id,!0)};c.insertEdge(l,k),S.push(k)}}}for(;;){const l=c.roots();if(l.length===0){if(!c.isEmpty())throw new A(c);break}for(const{data:_}of l){if(this._getServiceInstanceOrDescriptor(_.id)instanceof g.SyncDescriptor){const k=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,k)}c.removeNode(_)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,u,d=[],c,y){if(this._services.get(f)instanceof g.SyncDescriptor)return this._createServiceInstance(u,d,c,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,u,d,c,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(f,u=[],d,c){if(d){const y=new a.IdleValue(()=>this._createInstance(f,u,c));return new Proxy(Object.create(null),{get(S,l){if(l in S)return S[l];let _=y.value,r=_[l];return typeof r!="function"||(r=r.bind(_),S[l]=r),r},set(S,l,_){return y.value[l]=_,!0}})}else return this._createInstance(f,u,c)}_throwIfStrict(f,u){if(u&&console.warn(u),this._strict)throw new Error(f)}}e.InstantiationService=O;var v;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(v||(v={}));class p{constructor(f,u){this.type=f,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return w?new p(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(f){return w?new p(0,f.name):p._None}branch(f,u){let d=new p(2,f.toString());return this._dep.push([f,u,d]),d}stop(){let f=Date.now()-this._start;p._totals+=f;let u=!1;function d(y,S){let l=[],_=new Array(y+1).join("	");for(const[r,k,i]of S._dep)if(k&&i){u=!0,l.push(`${_}CREATES -> ${r}`);let s=d(y+1,i);s&&l.push(s)}else l.push(`${_}uses -> ${r}`);return l.join(`
`)}let c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(f>2||u)&&console.log(c.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Se[13],De([1,0,43,5,7,22,3]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function A(k,i,s){switch(i){case w.Trace:k.trace(s);break;case w.Debug:k.debug(s);break;case w.Info:k.info(s);break;case w.Warning:k.warn(s);break;case w.Error:k.error(s);break;case w.Critical:k.critical(s);break;default:throw new Error("Invalid log level")}}e.log=A;function O(k){let i="";for(let s=0;s<k.length;s++){let n=k[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}i+=(s>0?" ":"")+n}return i}e.format=O;class v extends g.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class p extends v{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,O([i,...s]))}debug(i,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,O([i,...s]))}info(i,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,O([i,...s]))}warn(i,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,O([i,...s]))}error(i,...s){if(this.checkLogLevel(w.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(w.Error,O(n))}else this.log(w.Error,O([i,...s]))}critical(i,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,O([i,...s]))}flush(){}}e.AbstractMessageLogger=p;class b extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!N.isWindows}trace(i,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}debug(i,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}info(i,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}warn(i,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...s):console.warn(`[main ${P()}]`,i,...s))}error(i,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}critical(i,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class f extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=f;class u extends v{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,a.toErrorMessage)(i,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class d extends v{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const n of this.logServices)n.trace(i,...s)}debug(i,...s){for(const n of this.logServices)n.debug(i,...s)}info(i,...s){for(const n of this.logServices)n.info(i,...s)}warn(i,...s){for(const n of this.logServices)n.warn(i,...s)}error(i,...s){for(const n of this.logServices)n.error(i,...s)}critical(i,...s){for(const n of this.logServices)n.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class c extends g.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=c;class y extends g.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,s?.always?w.Trace:this.logLevel,s),this.loggers.set(i.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class S{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(i){}getLevel(){return w.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=S;function l(k){if(k.verbose)return w.Trace;if(typeof k.logLevel=="string"){const i=_(k.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function _(k){switch(k){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=_;function r(k){switch(k){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=r}),define(Se[79],De([1,0,32,126,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var I;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function A(f,u){return u-f}w.compare=A;const O=Object.create(null);O[w.Error]=(0,D.localize)(0,null),O[w.Warning]=(0,D.localize)(1,null),O[w.Info]=(0,D.localize)(2,null);function v(f){return O[f]||""}w.toString=v;function p(f){switch(f){case a.default.Error:return w.Error;case a.default.Warning:return w.Warning;case a.default.Info:return w.Info;case a.default.Ignore:return w.Hint}}w.fromSeverity=p;function b(f){switch(f){case w.Error:return a.default.Error;case w.Warning:return a.default.Warning;case w.Info:return a.default.Info;case w.Hint:return a.default.Ignore}}w.toSeverity=b}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(w){const A="";function O(p){return v(p,!0)}w.makeKey=O;function v(p,b){let f=[A];return p.source?f.push(p.source.replace("\xA6","\\\xA6")):f.push(A),p.code?typeof p.code=="string"?f.push(p.code.replace("\xA6","\\\xA6")):f.push(p.code.value.replace("\xA6","\\\xA6")):f.push(A),p.severity!==void 0&&p.severity!==null?f.push(I.toString(p.severity)):f.push(A),p.message&&b?f.push(p.message.replace("\xA6","\\\xA6")):f.push(A),p.startLineNumber!==void 0&&p.startLineNumber!==null?f.push(p.startLineNumber.toString()):f.push(A),p.startColumn!==void 0&&p.startColumn!==null?f.push(p.startColumn.toString()):f.push(A),p.endLineNumber!==void 0&&p.endLineNumber!==null?f.push(p.endLineNumber.toString()):f.push(A),p.endColumn!==void 0&&p.endColumn!==null?f.push(p.endColumn.toString()):f.push(A),f.push(A),f.join("\xA6")}w.makeKeyOptionalMessage=v})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(Se[147],De([1,0,5,32,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=D.default,e.INotificationService=(0,g.createDecorator)("notificationService");var N;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new w,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class w{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=w}),define(Se[80],De([1,0,7,9,2,3]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,N.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function I(O,v){return g.URI.isUri(O)?(0,D.equalsIgnoreCase)(O.scheme,v):(0,D.startsWithIgnoreCase)(O,v+":")}e.matchesScheme=I;function P(O,...v){return v.some(p=>I(O,p))}e.matchesSomeScheme=P;function w(O,v){return O.with({fragment:`${v.startLineNumber},${v.startColumn}${v.endLineNumber?`-${v.endLineNumber}${v.endColumn?`,${v.endColumn}`:""}`:""}`})}e.withSelection=w;function A(O){let v;const p=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return p&&(v={startLineNumber:parseInt(p[1]),startColumn:p[2]?parseInt(p[2]):1,endLineNumber:p[4]?parseInt(p[4]):void 0,endColumn:p[4]?p[5]?parseInt(p[5]):1:void 0},O=O.with({fragment:""})),{selection:v,uri:O}}e.extractSelection=A});var $e=this&&this.__decorate||function(Z,e,a,D){var g=arguments.length,N=g<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,a):D,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(Z,e,a,D);else for(var P=Z.length-1;P>=0;P--)(I=Z[P])&&(N=(g<3?I(N):g>3?I(e,a,N):I(e,a))||N);return g>3&&N&&Object.defineProperty(e,a,N),N},ze=this&&this.__param||function(Z,e){return function(a,D){e(a,D,Z)}};define(Se[148],De([1,0,14,20,7,3]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(v){this.callback=v}get value(){return this._value}report(v){this._value=v,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let w=class extends g.Disposable{constructor(v,p){super();this.deferred=new a.DeferredPromise,p.withProgress(v,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,g.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};w=$e([ze(1,e.IProgressService)],w),e.UnmanagedProgress=w;class A extends g.Disposable{constructor(v){super();this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new g.DisposableStore)}start(v){this.stop();const p=++this.currentOperationId,b=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,g.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,g.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,g.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:b.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Se[34],De([1,0,41,10]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(I,P){a.ok(D.isString(I)),a.ok(D.isObject(P)),a.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,P)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new g}),define(Se[149],De([1,0,5,34]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class N{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,A){this.schemasById[g(w)]=A,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new N;D.Registry.add(e.Extensions.JSONContribution,I)}),define(Se[81],De([1,0,15,5,10,122,59,149,34]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(A=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=w.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,k=!0){this.registerConfigurations([r],k)}registerConfigurations(r,k=!0){const i=this.doRegisterConfigurations(r,k);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const k=this.doDeregisterConfigurations(r);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k})}updateConfigurations({add:r,remove:k}){const i=[];i.push(...this.doDeregisterConfigurations(k)),i.push(...this.doRegisterConfigurations(r,!1)),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(i)})}registerDefaultConfigurations(r){const k=[],i=[];for(const{overrides:s,source:n}of r)for(const t in s)if(k.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const o=this.configurationDefaultsOverrides.get(t),m=o?.valuesSources??new Map;if(n)for(const U of Object.keys(s[t]))m.set(U,n);const h={...o?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:h,valuesSources:m});const C=(0,I.getLanguageTagSettingPlainKey)(t),F={type:"object",default:h,description:N.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:g.isString(n)?void 0:n,defaultValueSource:n};i.push(...u(t)),this.configurationProperties[t]=F,this.defaultLanguageConfigurationOverridesNode.properties[t]=F}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:n});const o=this.configurationProperties[t];o&&(this.updatePropertyDefaultValue(t,o),this.updateSchema(t,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const k=[];for(const{overrides:i,source:s}of r)for(const n in i){const t=this.configurationDefaultsOverrides.get(n),o=g.isString(s)?s:s?.id,m=g.isString(t?.source)?t?.source:t?.source?.id;if(o===m)if(k.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const k of r)this.overrideIdentifiers.add(k);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,k){const i=[];return r.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,k,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(r){const k=[],i=s=>{if(s.properties)for(const n in s.properties)k.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n]);s.allOf&&s.allOf.forEach(n=>i(n))};for(const s of r){i(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return k}validateAndRegisterProperties(r,k=!0,i,s,n=3){n=g.isUndefinedOrNull(r.scope)?n:r.scope;let t=[],o=r.properties;if(o)for(let h in o){if(k&&S(h)){delete o[h];continue}const C=o[h];if(C.source=i,C.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,C),e.OVERRIDE_PROPERTY_REGEX.test(h)?C.scope=void 0:(C.scope=g.isUndefinedOrNull(C.scope)?n:C.scope,C.restricted=g.isUndefinedOrNull(C.restricted)?!!s?.includes(h):C.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h];!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),t.push(h)}let m=r.allOf;if(m)for(let h of m)t.push(...this.validateAndRegisterProperties(h,k,i,s,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const k=i=>{let s=i.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let n=i.allOf;n&&n.forEach(k)};k(r)}updateSchema(r,k){switch(e.allSettings.properties[r]=k,k.scope){case 1:e.applicationSettings.properties[r]=k;break;case 2:e.machineSettings.properties[r]=k;break;case 6:e.machineOverridableSettings.properties[r]=k;break;case 3:e.windowSettings.properties[r]=k;break;case 4:e.resourceSettings.properties[r]=k;break;case 5:e.resourceSettings.properties[r]=k,this.resourceLanguageSettingsSchema.properties[r]=k;break}}removeFromSchema(r,k){switch(delete e.allSettings.properties[r],k.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const k=`[${r}]`,i={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(k,i),e.allSettings.properties[k]=i,e.applicationSettings.properties[k]=i,e.machineSettings.properties[k]=i,e.machineOverridableSettings.properties[k]=i,e.windowSettings.properties[k]=i,e.resourceSettings.properties[k]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,k){const i=this.configurationDefaultsOverrides.get(r);let s=i?.value,n=i?.source;g.isUndefined(s)&&(s=k.defaultDefaultValue,n=void 0),g.isUndefined(s)&&(s=c(k.type)),k.default=s,k.defaultValueSource=n}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(_){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let k=f.exec(_);for(;k?.length;){const i=k[1].trim();i&&r.push(i),k=f.exec(_)}}return(0,a.distinct)(r)}e.overrideIdentifiersFromKey=u;function d(_){return _.reduce((r,k)=>`${r}[${k}]`,"")}e.keyFromOverrideIdentifiers=d;function c(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const y=new p;w.Registry.add(e.Extensions.Configuration,y);function S(_){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?N.localize(7,null,_):y.getConfigurationProperties()[_]!==void 0?N.localize(8,null,_):null:N.localize(6,null)}e.validateProperty=S;function l(){const _=[],r=y.getConfigurationProperties();for(const k of Object.keys(r))_.push([k,r[k].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=l}),define(Se[150],De([1,0,15,5,104,7,21,27,10,2,59,81,34]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(i={},s=[],n=[]){this._contents=i,this._keys=s,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,O.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const n=this.getContentsForOverrideIdentifer(s);return n?i?(0,O.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return a.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return a.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=P.deepClone(this.contents),n=P.deepClone(this.overrides),t=[...this.keys];for(const o of i){this.mergeContents(s,o.contents);for(const m of o.overrides){const[h]=n.filter(C=>a.equals(C.identifiers,m.identifiers));h?(this.mergeContents(h.contents,m.contents),h.keys.push(...m.keys),h.keys=a.distinct(h.keys)):n.push(P.deepClone(m))}for(const m of o.keys)t.indexOf(m)===-1&&t.push(m)}return new b(s,t,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const t of a.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[t],m=s[t];m&&(typeof o=="object"&&typeof m=="object"?(o=P.deepClone(o),this.mergeContents(o,m)):o=m),n[t]=o}return new b(n,this.keys,this.overrides)}mergeContents(i,s){for(const n of Object.keys(s)){if(n in i&&w.isObject(i[n])&&w.isObject(s[n])){this.mergeContents(i[n],s[n]);continue}i[n]=P.deepClone(s[n])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,n=null;const t=o=>{o&&(n?this.mergeContents(n,o):n=P.deepClone(o))};for(const o of this.overrides)a.equals(o.identifiers,[i])?s=o.contents:o.identifiers.includes(i)&&t(o.contents);return t(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,O.addToValueTree)(this.contents,i,s,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,O.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let n=0;n<s;n++)i.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(i={}){const s=p.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(s),t=Object.create(null),o=[];for(const m in s){const h=i[m],C=h!==void 0?h:s[m].default;(0,O.addToValueTree)(t,m,C,F=>console.error(`Conflict in default settings: ${F}`))}for(const m of Object.keys(t))v.OVERRIDE_PROPERTY_REGEX.test(m)&&o.push({identifiers:(0,v.overrideIdentifiersFromKey)(m),keys:Object.keys(t[m]),contents:(0,O.toValuesTree)(t[m],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,n,o)}}e.DefaultConfigurationModel=f;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!w.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:n,keys:t,overrides:o,restricted:m}=this.doParseRaw(i,s);this._configurationModel=new b(n,t,o),this._restrictedConfigurations=m||[]}doParseContent(i){let s={},n=null,t=[],o=[],m=[];function h(F){Array.isArray(t)?t.push(F):n!==null&&(t[n]=F)}let C={onObjectBegin:()=>{let F={};h(F),o.push(t),t=F,n=null},onObjectProperty:F=>{n=F},onObjectEnd:()=>{t=o.pop()},onArrayBegin:()=>{let F=[];h(F),o.push(t),t=F,n=null},onArrayEnd:()=>{t=o.pop()},onLiteralValue:h,onError:(F,U,R)=>{m.push({error:F,offset:U,length:R})}};if(i)try{g.visit(i,C),s=t[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return s}doParseRaw(i,s){const n=p.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),t=this.filter(i,n,!0,s);i=t.raw;const o=(0,O.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),m=Object.keys(i),h=this.toOverrides(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:o,keys:m,overrides:h,restricted:t.restricted}}filter(i,s,n,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:i,restricted:[]};const o={},m=[];for(let h in i)if(v.OVERRIDE_PROPERTY_REGEX.test(h)&&n){const C=this.filter(i[h],s,!1,t);o[h]=C.raw,m.push(...C.restricted)}else{const C=s[h],F=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&m.push(h),(F===void 0||t.scopes===void 0||t.scopes.includes(F))&&(t.skipRestricted&&C?.restricted||(o[h]=i[h]))}return{raw:o,restricted:m}}toOverrides(i,s){const n=[];for(const t of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(t)){const o={};for(const m in i[t])o[m]=i[t][m];n.push({identifiers:(0,v.overrideIdentifiersFromKey)(t),keys:Object.keys(o),contents:(0,O.toValuesTree)(o,s)})}return n}}e.ConfigurationModelParser=u;class d extends N.Disposable{constructor(i,s,n,t){super();this.userSettingsResource=i,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&n.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class c{constructor(i,s,n=new b,t=new b,o=new I.ResourceMap,m=new b,h=new I.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=h,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(i,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(i)}updateValue(i,s,n={}){let t;n.resource?(t=this._memoryConfigurationByResource.get(n.resource),t||(t=new b,this._memoryConfigurationByResource.set(n.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(i):t.setValue(i,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,n){const t=this.getConsolidateConfigurationModel(s,n),o=this.getFolderConfigurationModelForResource(s.resource,n),m=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,h=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),R=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,E=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,x=s.overrideIdentifier?m.override(s.overrideIdentifier).getValue(i):m.getValue(i),z=t.getValue(i),V=a.distinct(a.flatten(t.overrides.map(se=>se.identifiers))).filter(se=>t.getOverrideValue(i,se)!==void 0);return{defaultValue:h,userValue:C,userLocalValue:F,userRemoteValue:U,workspaceValue:R,workspaceFolderValue:E,memoryValue:x,value:z,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:o?.freeze().getValue(i),override:s.overrideIdentifier?o?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:m.getValue(i),override:s.overrideIdentifier?m.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:t,updated:o,removed:m}=_(this._defaultConfiguration,i);s=[...t,...o,...m]}for(const t of s)for(const o of(0,v.overrideIdentifiersFromKey)(t)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),h=i.getKeysForOverrideIdentifier(o),C=[...h.filter(F=>m.indexOf(F)===-1),...m.filter(F=>h.indexOf(F)===-1),...m.filter(F=>!P.equals(this._defaultConfiguration.override(o).getValue(F),i.override(o).getValue(F)))];n.push([o,C])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:t,overrides:o}=_(this.localUserConfiguration,i),m=[...s,...n,...t];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:t,overrides:o}=_(this.remoteUserConfiguration,i);let m=[...s,...n,...t];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:t,overrides:o}=_(this.workspaceConfiguration,i);let m=[...s,...n,...t];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(i,s){const n=this.folderConfigurations.get(i),{added:t,updated:o,removed:m,overrides:h}=_(n,s);let C=[...t,...o,...m];return(C.length||!n)&&this.updateFolderConfiguration(i,s),{keys:C,overrides:h}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:t,removed:o,overrides:m}=_(s,void 0);return{keys:[...n,...t,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let n=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?n.override(i.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:i},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const t=s.getFolder(i);t&&(n=this.getFolderConsolidatedConfiguration(t.uri)||n);const o=this._memoryConfigurationByResource.get(i);o&&(n=n.merge(o))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(i);t?(s=n.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=n}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:n,overrides:t,keys:o}=this._folderConfigurations.get(s);return i.push([s,{contents:n,overrides:t,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.user),t=this.parseConfigurationModel(i.workspace),o=i.folders.reduce((m,h)=>(m.set(A.URI.revive(h[0]),this.parseConfigurationModel(h[1])),m),new I.ResourceMap);return new c(s,n,new b,t,o,new b,new I.ResourceMap,!1)}static parseConfigurationModel(i){return new b(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=c;function y(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const i=new Set,s=new Map;for(const t of k)t.keys.forEach(o=>i.add(o)),t.overrides.forEach(([o,m])=>{const h=(0,I.getOrSet)(s,o,new Set);m.forEach(C=>h.add(C))});const n=[];return s.forEach((t,o)=>n.push([o,[...t.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=y;class S{constructor(i,s,n,t){this.change=i,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=t,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(h=>o.add(h)),i.overrides.forEach(([,h])=>h.forEach(C=>o.add(C))),this.affectedKeys=[...o.values()];const m=new b;this.affectedKeys.forEach(h=>m.setValue(h,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!P.equals(n,t)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let n=(0,O.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof n=="object"&&(t=Object.keys(n)[0]);){if(i=i[t],!i)return!1;n=n[t]}return!0}}e.ConfigurationChangeEvent=S;class l extends S{constructor(i,s,n,t){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=n,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=l;function _(k,i){const{added:s,removed:n,updated:t}=r(i,k),o=[],m=k?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const C=h.filter(F=>!m.includes(F));for(const F of C)o.push([F,i.getKeysForOverrideIdentifier(F)])}if(k){const C=m.filter(F=>!h.includes(F));for(const F of C)o.push([F,k.getKeysForOverrideIdentifier(F)])}if(i&&k){for(const C of m)if(h.includes(C)){const F=r({contents:k.getOverrideValue(void 0,C)||{},keys:k.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});o.push([C,[...F.added,...F.removed,...F.updated]])}}return{added:s,removed:n,updated:t,overrides:o}}function r(k,i){const s=k?i?k.keys.filter(o=>i.keys.indexOf(o)===-1):[...k.keys]:[],n=i?k?i.keys.filter(o=>k.keys.indexOf(o)===-1):[...i.keys]:[],t=[];if(k&&i){for(const o of i.keys)if(k.keys.indexOf(o)!==-1){const m=(0,O.getConfigurationValue)(i.contents,o),h=(0,O.getConfigurationValue)(k.contents,o);P.equals(m,h)||t.push(o)}}return{added:s,removed:n,updated:t}}}),define(Se[82],De([1,0,12,3]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var g;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(g=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends a.ErrorNoTelemetry{constructor(P,w=g.Unknown,A){super(P);this._message=P,this._code=w,this._detail=A,this.isHandled=w===g.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static isTemporarilyNotAvailable(P){return P instanceof N&&P._code===g.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof N&&P._code===g.NoResolverFound}static isHandled(P){return P instanceof N&&P.isHandled}}e.RemoteAuthorityResolverError=N}),define(Se[83],De([1,0,11]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(I){return I.scheme===a.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=D;function g(I){if(!I)return;const P=I.indexOf("+");return P<0?I:I.substr(0,P)}e.getRemoteName=g;function N(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=N}),define(Se[26],De([1,0,9,3,83]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=N;function I(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class A{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,u){if(typeof f=="undefined"||f===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof f=="string"||typeof u=="string"){let d=typeof f=="string"?f:f.value,c=typeof u=="string"?u:u.value;return a.equalsIgnoreCase(d,c)}return f._lower===u._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=A;function O(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function v(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function p(b,f){if(f){const u=`onResolveRemoteAuthority:${(0,g.getRemoteName)(f)}`;return b.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[151],De([1,0,9,145,26,22,2,12,61]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,a.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=A;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{constructor(s,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=s.id}static create(s){const n=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new v(s.identifier,n,t)}static parse(s){const n=O.exec(s);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof v?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=v;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(i){const s=p.exec(i);return s&&s[1]?[u(s[1]),s[2]]:[u(i),void 0]}e.getIdAndVersion=b;function f(i,s){return`${i}.${s}`}e.getExtensionId=f;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function d(i,s){return u(f(i,s))}e.getGalleryExtensionId=d;function c(i,s){const n=[],t=o=>{for(const m of n)if(m.some(h=>A(s(h),s(o))))return m;return null};for(const o of i){const m=t(o);m?m.push(o):n.push([o])}return n}e.groupByExtension=c;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function S(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new g.ExtensionIdentifier("pprice.better-merge");function l(i){const s=new Set;if(i.malicious)for(const n of i.malicious)s.add(n.id);return s}e.getMaliciousExtensionsSet=l;function _(i,s){const n=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const o=t.shift();if(o&&n.every(m=>!A(m.identifier,{id:o}))){const m=i.filter(h=>A(h.identifier,{id:o}));m.length===1&&(n.push(m[0]),t.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=_;async function r(i,s){if(!N.isLinux)return!1;let n;try{n=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function k(i,s){const n=await r(i,s),t=(0,D.getTargetPlatform)(n?"alpine":N.platform,w.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=k}),define(Se[152],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(g){this._callback=g,this._terminalBufferMap=new Map}dispose(){for(const g of this._terminalBufferMap.values())g.dispose()}startBuffering(g,N,I=5){let P;return P=N(w=>{const A=typeof w=="string"?w:w.data;let O=this._terminalBufferMap.get(g);if(O){O.data.push(A);return}const v=setTimeout(()=>this.flushBuffer(g),I);O={data:[A],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(g),P.dispose()}},this._terminalBufferMap.set(g,O)}),P}stopBuffering(g){const N=this._terminalBufferMap.get(g);N&&N.dispose()}flushBuffer(g){const N=this._terminalBufferMap.get(g);N&&(this._terminalBufferMap.delete(g),this._callback(g,N.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[153],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function D(N){return N===a.HIGH_CONTRAST_DARK||N===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=D;function g(N){return N===a.DARK||N===a.HIGH_CONTRAST_DARK}e.isDark=g}),define(Se[62],De([1,0,110,5,7,3,34,153]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var w;(function(d){function c(y){return y&&typeof y=="object"&&typeof y.id=="string"}d.isThemeColor=c})(w=e.ThemeColor||(e.ThemeColor={}));function A(d){return{id:d}}e.themeColorFromId=A;var O;(function(d){function c(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}d.isThemeIcon=c;const y=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function S(s){const n=y.exec(s);if(!n)return;let[,t]=n;return{id:t}}d.fromString=S;function l(s){return{id:s}}d.fromId=l;function _(s,n){let t=s.id;const o=t.lastIndexOf("~");return o!==-1&&(t=t.substring(0,o)),n&&(t=`${t}~${n}`),{id:t}}d.modify=_;function r(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}d.getModifier=r;function k(s,n){return s.id===n.id&&s.color?.id===n.color?.id}d.isEqual=k;function i(s,n){return{id:s.id,color:n?A(n):void 0}}d.asThemeIcon=i,d.asClassNameArray=a.CSSIcon.asClassNameArray,d.asClassName=a.CSSIcon.asClassName,d.asCSSSelector=a.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function v(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(c){return this.themingParticipants.push(c),this.onThemingParticipantAddedEmitter.fire(c),(0,g.toDisposable)(()=>{const y=this.themingParticipants.indexOf(c);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new p;I.Registry.add(e.Extensions.ThemingContribution,b);function f(d){return b.onColorThemeChange(d)}e.registerThemingParticipant=f;class u extends g.Disposable{constructor(c){super();this.themeService=c,this.theme=c.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(c){this.theme=c,this.updateStyles()}updateStyles(){}getColor(c,y){let S=this.theme.getColor(c);return S&&y&&(S=y(S,this.theme)),S?S.toString():null}}e.Themable=u}),define(Se[154],De([1,0,5,22,3,13]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,g.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,g.createDecorator)("sharedTunnelsService");var I;(function(f){f.Http="http",f.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=v;function p(f,u){return u?u!==1&&f<1024:!D.isWindows&&f<1024}e.isPortPrivileged=p;let b=class{constructor(u){this.logService=u,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(let c of d){const y=Array.from(c.values());for(let S of y){const l=await S.value;l&&u.push(l)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(c=>c?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,d,c,y,S=!1,l,_){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${y}.`),!u)return;d||(d="localhost");const r=this.retainOrCreateTunnel(u,d,c,y,S,l,_);return r?r.then(k=>{if(!k){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,c);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(k);return(k.tunnelRemoteHost!==d||k.tunnelRemotePort!==c)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const c=d.get(u.tunnelRemotePort);c&&(c.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async tryDisposeTunnel(u,d,c){if(c.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const y=c.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),y}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const c=this._tunnels.get(u);if(c&&c.has(d)){const y=c.get(d);y.refcount=0,await this.tryDisposeTunnel(u,d,y)}}addTunnelToMap(u,d,c){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:c})}async removeEmptyTunnelFromMap(u,d){const c=this._tunnels.get(u);c&&(await c.get(d)||c.delete(d),c.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){let c=[u];O(u)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):v(u)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const y=c.map(S=>this._tunnels.get(S));for(const S of y){const l=S?.get(d);if(l)return l}}canTunnel(u){return!!A(u)}createWithProvider(u,d,c,y,S,l,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${y}.`);const k={elevationRequired:S?p(y===void 0?c:y):!1},i={remoteAddress:{host:d,port:c},localAddressPort:y,privacy:l,public:l?l!==P.Private:void 0,protocol:_},s=u.forwardPort(i,k);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(d,c,s),s}};b=$e([ze(0,N.ILogService)],b),e.AbstractTunnelService=b}),define(Se[155],De([1,0,11]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function D(w){return w.scheme!==a.Schemas.file&&w.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=D;function g(w){if(w.folders.length)return w.folders.every(A=>D(A.uri))?w.folders[0].uri:void 0;if(w.configuration&&D(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=g;function N(w){return g(w)?.scheme}e.getVirtualWorkspaceScheme=N;function I(w){return g(w)?.authority}e.getVirtualWorkspaceAuthority=I;function P(w){return g(w)!==void 0}e.isVirtualWorkspace=P}),define(Se[45],De([1,0,127,17,21,23,2,3,11]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function A(i){const s=i;return typeof s?.id=="string"&&I.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=A;function O(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=O;function v(i){const s=i;return typeof s?.id=="string"&&I.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=v;function p(i){const s=i;if(s?.uri)return{id:s.id,uri:I.URI.revive(s.uri)};const n=i;if(n?.configPath)return{id:n.id,configPath:I.URI.revive(n.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=p;var b;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function f(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=f;function u(i){const s=i;return!!(s&&typeof s=="object"&&I.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=u;class d{constructor(s,n,t,o,m){this._id=s,this._transient=t,this._configuration=o,this._ignorePathCasing=m,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class c{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function y(i){return new c({uri:i,index:0,name:(0,N.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace";const S=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(i,s){return N.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function _(i){let s;return I.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=_;function r(i,s){return!l(i,s)&&!_(i)}e.isSavedWorkspace=r;function k(i){return(typeof i=="string"?(0,D.extname)(i):(0,N.extname)(i))===S}e.hasWorkspaceFileExtension=k}),define(Se[63],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(g){this.id=g,this._data=new Map,this._idPool=1}add(g){const N=this._idPool++;return this._data.set(N,g),this.logDebugInfo(),N}get(g,N){return this._data.has(g)?this._data.get(g)[N]:void 0}delete(g){this._data.delete(g),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Se[35],De([1,0,11,23,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new D.ExtUri(P=>{const w=this._providerInfo.get(P.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(P,w){w===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,w)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,g.createDecorator)("IExtHostFileSystemInfo")}),define(Se[28],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[156],De([1,0,14]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class D{constructor(I,P,w){this._deferredPromises=new Map,this._id=I,this._shared=P,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of A.values())O.complete()}catch(O){for(const v of A.values())v.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,P){let w=this._value[I];return typeof w=="undefined"&&(w=P),w}update(I,P){this._value[I]=P;let w=this._deferredPromises.get(I);if(w!==void 0)return w.p;const A=new a.DeferredPromise;return this._deferredPromises.set(I,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=D;class g extends D{constructor(I,P){super(I.identifier.value,!0,P);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=g}),define(Se[157],De([1,0,5,2]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class g{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,P,w,A){const v=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I)).acceptModelChanged(P.value,w,A);this._onDidChangeNotebookDocument.fire(v)}$acceptDirtyStateChanged(I,P){this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I)).acceptDirty(P)}$acceptModelSaved(I){const P=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(I));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=g}),define(Se[16],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class D{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=D});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[158],De([1,0,26,5]),function(Z,e,a,D){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(P,w){g.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(P.identifier),Qe(this,g,w,"f"),Re(this,g,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Re(this,g,"f").get(this._id,P)}store(P,w){return Re(this,g,"f").store(this._id,P,w)}delete(P){return Re(this,g,"f").delete(this._id,P)}}e.ExtensionSecrets=N,g=new WeakMap}),define(Se[84],De([1,0,3,5]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class g{constructor(){this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new D.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,P){this._level=I,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=g,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[64],De([1,0,3,154,5,16]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(w){function A(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:v.protocol}}w.fromApiTunnel=A;function O(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==D.TunnelPrivacyId.ConstantPrivate&&v.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}w.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new g.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,O){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,O){return{dispose:()=>{}}}async $providePortAttributes(A,O,v,p,b){return[]}async $forwardPort(A,O){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=$e([ze(0,N.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[6],De([1,0,15,12,75,21,74,9,10,2,42,38,82]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p){"use strict";var b,f,u,d,c,y,S,l,_,r,k,i,s,n,t,o,m,h,C,F;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function U($){function M(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(M,$),Object.setPrototypeOf(M.prototype,$.prototype),M}let R=c=class{constructor(M){b.set(this,void 0),Qe(this,b,M,"f")}static from(...M){let te=M;return new c(function(){if(te){for(const Te of te)Te&&typeof Te.dispose=="function"&&Te.dispose();te=void 0}})}dispose(){typeof Re(this,b,"f")=="function"&&(Re(this,b,"f").call(this),Qe(this,b,void 0,"f"))}};b=new WeakMap,R=c=$e([U],R),e.Disposable=R;let E=y=class{constructor(M,te){if(M<0)throw(0,D.illegalArgument)("line must be non-negative");if(te<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Te=1;Te<M.length;Te++){const Ke=M[Te];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Te=1;Te<M.length;Te++){const Ke=M[Te];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(M){if(!M)return!1;if(M instanceof y)return!0;let{line:te,character:Te}=M;return typeof te=="number"&&typeof Te=="number"}static of(M){if(M instanceof y)return M;if(this.isPosition(M))return new y(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,D.illegalArgument)();let Te;return typeof M=="undefined"?Te=0:typeof M=="number"?Te=M:(Te=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Te===0&&te===0?this:new y(this.line+Te,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,D.illegalArgument)();let Te;return typeof M=="undefined"?Te=this.line:typeof M=="number"?Te=M:(Te=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Te===this.line&&te===this.character?this:new y(Te,te)}toJSON(){return{line:this.line,character:this.character}}};E=y=$e([U],E),e.Position=E;let x=S=class{constructor(M,te,Te,Ke){let et,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Te=="number"&&typeof Ke=="number"?(et=new E(M,te),nt=new E(Te,Ke)):E.isPosition(M)&&E.isPosition(te)&&(et=E.of(M),nt=E.of(te)),!et||!nt)throw new Error("Invalid arguments");et.isBefore(nt)?(this._start=et,this._end=nt):(this._start=nt,this._end=et)}static isRange(M){return M instanceof S?!0:M?E.isPosition(M.start)&&E.isPosition(M.end):!1}static of(M){if(M instanceof S)return M;if(this.isRange(M))return new S(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(M){return S.isRange(M)?this.contains(M.start)&&this.contains(M.end):E.isPosition(M)?!(E.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=E.Max(M.start,this._start),Te=E.Min(M.end,this._end);if(!te.isAfter(Te))return new S(te,Te)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=E.Min(M.start,this._start),Te=E.Max(M.end,this.end);return new S(te,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,D.illegalArgument)();let Te;return M?E.isPosition(M)?Te=M:(Te=M.start||this.start,te=M.end||this.end):Te=this.start,Te.isEqual(this._start)&&te.isEqual(this.end)?this:new S(Te,te)}toJSON(){return[this.start,this.end]}};x=S=$e([U],x),e.Range=x;let z=l=class extends x{constructor(M,te,Te,Ke){let et,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Te=="number"&&typeof Ke=="number"?(et=new E(M,te),nt=new E(Te,Ke)):E.isPosition(M)&&E.isPosition(te)&&(et=E.of(M),nt=E.of(te)),!et||!nt)throw new Error("Invalid arguments");super(et,nt);this._anchor=et,this._active=nt}static isSelection(M){return M instanceof l?!0:M?x.isRange(M)&&E.isPosition(M.anchor)&&E.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=l=$e([U],z),e.Selection=z;class V{constructor(M,te,Te){if(typeof M!="string"||M.length===0)throw(0,D.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,D.illegalArgument)("port");if(typeof Te!="undefined"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,D.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Te}}e.ResolvedAuthority=V;class se extends Error{constructor(M,te=p.RemoteAuthorityResolverErrorCode.Unknown,Te){super(M);this._message=M,this._code=te,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,se.prototype)}static NotAvailable(M,te){return new se(M,p.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new se(M,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=se;var K;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var L;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let oe=_=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof _?!0:M?x.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new _(M,te)}static insert(M,te){return _.replace(new x(M,M),te)}static delete(M){return _.replace(M,"")}static setEndOfLine(M){const te=new _(new x(new E(0,0),new E(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!x.isRange(M))throw(0,D.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,D.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,D.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};oe=_=$e([U],oe),e.TextEdit=oe;class de{constructor(M,te){this.range=M,this.snippet=te}}e.SnippetTextEdit=de;var ae;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace"})(ae=e.FileEditType||(e.FileEditType={}));let fe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Te,Ke){this._edits.push({_type:1,from:M,to:te,options:Te,metadata:Ke})}createFile(M,te,Te){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Te})}deleteFile(M,te,Te){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Te})}replaceNotebookMetadata(M,te,Te){this._edits.push({_type:3,metadata:Te,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Te,Ke,et){let nt,ut,St=[],kt;if(gt.isNotebookRange(te)&&jt.isNotebookCellDataArray(Te)&&!jt.isNotebookCellDataArray(Ke)?(nt=te.start,ut=te.end,St=Te,kt=Ke):typeof te=="number"&&typeof Te=="number"&&jt.isNotebookCellDataArray(Ke)&&(nt=te,ut=Te,St=Ke,kt=et),nt===void 0||ut===void 0)throw new Error("Invalid arguments");(nt!==ut||St.length>0)&&this._edits.push({_type:5,uri:M,index:nt,count:ut-nt,cells:St,metadata:kt})}replaceNotebookCellMetadata(M,te,Te,Ke){this._edits.push({_type:3,metadata:Ke,uri:M,edit:{editType:8,index:te,metadata:Te}})}replace(M,te,Te,Ke){this._edits.push({_type:2,uri:M,edit:new oe(te,Te),metadata:Ke})}insert(M,te,Te,Ke){this.replace(M,new x(te,te),Te,Ke)}delete(M,te,Te){this.replace(M,te,"",Te)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Te of te)Te&&this._edits.push({_type:2,uri:M,edit:Te});else{for(let Te=0;Te<this._edits.length;Te++){const Ke=this._edits[Te];Ke._type===2&&Ke.uri.toString()===M.toString()&&(this._edits[Te]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Te of this._edits)Te._type===2&&Te.uri.toString()===M.toString()&&te.push(Te.edit);return te}entries(){const M=new N.ResourceMap;for(let te of this._edits)if(te._type===2){let Te=M.get(te.uri);Te||(Te=[te.uri,[]],M.set(te.uri,Te)),Te[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};fe=$e([U],fe),e.WorkspaceEdit=fe;let ee=r=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof r?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=r._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Te=new r;Te._tabstop=this._tabstop,M(Te),this._tabstop=Te._tabstop,M=Te.value}else M=r._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Te=M.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Te=new r;Te._tabstop=this._tabstop,te(Te),this._tabstop=Te._tabstop,te=Te.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ee=r=$e([U],ee),e.SnippetString=ee;var Ee;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(Ee=e.DiagnosticTag||(e.DiagnosticTag={}));var we;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(we=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=k=class{constructor(M,te){if(this.uri=M,te)if(x.isRange(te))this.range=x.of(te);else if(E.isPosition(te))this.range=new x(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof k?!0:M?x.isRange(M.range)&&A.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=k=$e([U],J),e.Location=J;let ve=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&x.isRange(M.location.range)&&A.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};ve=$e([U],ve),e.DiagnosticRelatedInformation=ve;let Pe=class{constructor(M,te,Te=we.Error){if(!x.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Te}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,a.equals)(M.tags,te.tags)&&(0,a.equals)(M.relatedInformation,te.relatedInformation,ve.isEqual)}};Pe=$e([U],Pe),e.Diagnostic=Pe;let Fe=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=te}};Fe=$e([U],Fe),e.Hover=Fe;var We;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(We=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ge=class{constructor(M,te=We.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:We[this.kind]}}};Ge=$e([U],Ge),e.DocumentHighlight=Ge;var Ie;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var _e;(function($){$[$.Deprecated=1]="Deprecated"})(_e=e.SymbolTag||(e.SymbolTag={}));let Ce=i=class{constructor(M,te,Te,Ke,et){this.name=M,this.kind=te,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Ke instanceof J?this.location=Ke:Te instanceof x&&(this.location=new J(Ke,Te)),i.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};Ce=i=$e([U],Ce),e.SymbolInformation=Ce;let re=s=class{constructor(M,te,Te,Ke,et){this.name=M,this.detail=te,this.kind=Te,this.range=Ke,this.selectionRange=et,this.children=[],s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(s.validate)}};re=s=$e([U],re),e.DocumentSymbol=re;var le;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let X=class{constructor(M,te){this.title=M,this.kind=te}};X=$e([U],X),e.CodeAction=X;let G=n=class{constructor(M){this.value=M}append(M){return new n(this.value?this.value+n.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+n.sep)}};G.sep=".",G=n=$e([U],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let T=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};T=$e([U],T),e.SelectionRange=T;class B{constructor(M,te,Te,Ke,et,nt){this.kind=M,this.name=te,this.detail=Te,this.uri=Ke,this.range=et,this.selectionRange=nt}}e.CallHierarchyItem=B;class W{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=W;class H{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=H;var ne;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(ne=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let he=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};he=$e([U],he),e.CodeLens=he;let Y=t=class{constructor(M,te=!1){f.set(this,void 0),Qe(this,f,new g.MarkdownString(M,{supportThemeIcons:te}),"f")}static isMarkdownString(M){return M instanceof t?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Re(this,f,"f").value}set value(M){Re(this,f,"f").value=M}get isTrusted(){return Re(this,f,"f").isTrusted}set isTrusted(M){Re(this,f,"f").isTrusted=M}get supportThemeIcons(){return Re(this,f,"f").supportThemeIcons}set supportThemeIcons(M){Re(this,f,"f").supportThemeIcons=M}get supportHtml(){return Re(this,f,"f").supportHtml}set supportHtml(M){Re(this,f,"f").supportHtml=M}get baseUri(){return Re(this,f,"f").baseUri}set baseUri(M){Re(this,f,"f").baseUri=M}appendText(M){return Re(this,f,"f").appendText(M),this}appendMarkdown(M){return Re(this,f,"f").appendMarkdown(M),this}appendCodeblock(M,te){return Re(this,f,"f").appendCodeblock(te??"",M),this}};f=new WeakMap,Y=t=$e([U],Y),e.MarkdownString=Y;let ge=class{constructor(M,te){this.label=M,this.documentation=te}};ge=$e([U],ge),e.ParameterInformation=ge;let pe=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};pe=$e([U],pe),e.SignatureInformation=pe;let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ne=$e([U],Ne),e.SignatureHelp=Ne;var xe;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ke;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(ke=e.InlayHintKind||(e.InlayHintKind={}));let qe=class{constructor(M){this.value=M}};qe=$e([U],qe),e.InlayHintLabelPart=qe;let j=class{constructor(M,te,Te){this.position=M,this.label=te,this.kind=Te}};j=$e([U],j),e.InlayHint=j;var Q;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var me;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(me=e.CompletionItemKind||(e.CompletionItemKind={}));var Le;(function($){$[$.Deprecated=1]="Deprecated"})(Le=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=$e([U],Be),e.CompletionItem=Be;let Xe=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};Xe=$e([U],Xe),e.CompletionList=Xe;let Ze=class{constructor(M,te,Te){this.insertText=M,this.range=te,this.command=Te}};Ze=$e([U],Ze),e.InlineSuggestion=Ze;let rt=class{constructor(M){this.commands=void 0,this.items=M}};rt=$e([U],rt),e.InlineSuggestionList=rt;let Ye=class{constructor(M,te,Te){this.insertText=M,this.range=te,this.command=Te}};Ye=$e([U],Ye),e.InlineSuggestionNew=Ye;let Je=class{constructor(M,te){this.items=M,this.commands=te}};Je=$e([U],Je),e.InlineSuggestionsNew=Je;var je;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(je=e.ViewColumn||(e.ViewColumn={}));var lt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var st;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var It;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(It=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(at=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ht;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ft;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ft=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function M(te){switch(te){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=M}(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let yt=class{constructor(M,te){if(te&&!A.URI.isUri(te))throw(0,D.illegalArgument)("target");if(!x.isRange(M)||M.isEmpty)throw(0,D.illegalArgument)("range");this.range=M,this.target=te}};yt=$e([U],yt),e.DocumentLink=yt;let ft=class{constructor(M,te,Te,Ke){this.red=M,this.green=te,this.blue=Te,this.alpha=Ke}};ft=$e([U],ft),e.Color=ft;let Dt=class{constructor(M,te){if(te&&!(te instanceof ft))throw(0,D.illegalArgument)("color");if(!x.isRange(M)||M.isEmpty)throw(0,D.illegalArgument)("range");this.range=M,this.color=te}};Dt=$e([U],Dt),e.ColorInformation=Dt;let Pt=class{constructor(M){if(!M||typeof M!="string")throw(0,D.illegalArgument)("label");this.label=M}};Pt=$e([U],Pt),e.ColorPresentation=Pt;var Nt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var He;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(He=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class $t{constructor(M,te,Te){if(this.startIndex=M,this.length=te,this.tooltip=Te,typeof M!="number"||M<0)throw(0,D.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,D.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,D.illegalArgument)("tooltip")}}e.TerminalLink=$t;var At;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(At=e.TerminalLocation||(e.TerminalLocation={}));class Mt{constructor(M){if(this.options=M,typeof M!="object")throw(0,D.illegalArgument)("options")}}e.TerminalProfile=Mt;var be;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(be=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let ue=o=class{constructor(M,te){if(this.label=te,typeof M!="string"||typeof te!="string")throw(0,D.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};ue.Clean=new o("clean","Clean"),ue.Build=new o("build","Build"),ue.Rebuild=new o("rebuild","Rebuild"),ue.Test=new o("test","Test"),ue=o=$e([U],ue),e.TaskGroup=ue;function q($){let M="";for(let te=0;te<$.length;te++)M+=$[te].replace(/,/g,",,")+",";return M}let Ae=class{constructor(M,te,Te){if(typeof M!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Te):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,D.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return q(M)}};Ae=$e([U],Ae),e.ProcessExecution=Ae;let Ue=class{constructor(M,te,Te){if(this._args=[],Array.isArray(te)){if(!M)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,D.illegalArgument)("command");this._command=M,this._args=te,this._options=Te}else{if(typeof M!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,D.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return q(M)}};Ue=$e([U],Ue),e.ShellExecution=Ue;var tt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(tt=e.ShellQuoting||(e.ShellQuoting={}));var Ve;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Ve=e.TaskScope||(e.TaskScope={}));class ot{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=ot;let ct=m=class{constructor(M,te,Te,Ke,et,nt){this.__deprecated=!1,this._definition=this.definition=M;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Te,this.execution=Ke,ut=et,this.__deprecated=!0):te===Ve.Global||te===Ve.Workspace?(this.target=te,this._name=this.name=Te,this._source=this.source=Ke,this.execution=et,ut=nt):(this.target=te,this._name=this.name=Te,this._source=this.source=Ke,this.execution=et,ut=nt),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ae?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ue?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof ot?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=m=$e([U],ct),e.Task=ct;var pt;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(M,te=mt.None){this.collapsibleState=te,A.URI.isUri(M)?this.resourceUri=M:this.label=M}};_t=$e([U],_t),e.TreeItem=_t;var mt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let vt=class{constructor(M){this.value=M}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};vt=$e([U],vt),e.DataTransferItem=vt;let Rt=class{constructor(){this._items=new Map}get(M){return this._items.get(M)}set(M,te){this._items.set(M,te)}forEach(M){this._items.forEach(M)}};Rt=$e([U],Rt),e.DataTransfer=Rt;let Et=class{constructor(M,te){this.id=M,this.color=te}};Et=$e([U],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let Gt=class{constructor(M){this.id=M}};Gt=$e([U],Gt),e.ThemeColor=Gt;var Qt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(M,te){if(typeof M!="string"&&(!M||!A.URI.isUri(M)&&!A.URI.isUri(M.uri)))throw(0,D.illegalArgument)("base");if(typeof te!="string")throw(0,D.illegalArgument)("pattern");typeof M=="string"?this.baseUri=A.URI.file(M):A.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=te}get base(){return this._base}set base(M){this._base=M,this._baseUri=A.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=$e([U],bt),e.RelativePattern=bt;let Wt=class{constructor(M,te,Te,Ke){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};Wt=$e([U],Wt),e.Breakpoint=Wt;let Yt=class extends Wt{constructor(M,te,Te,Ke,et){super(te,Te,Ke,et);if(M===null)throw(0,D.illegalArgument)("location");this.location=M}};Yt=$e([U],Yt),e.SourceBreakpoint=Yt;let Jt=class extends Wt{constructor(M,te,Te,Ke,et){super(te,Te,Ke,et);this.functionName=M}};Jt=$e([U],Jt),e.FunctionBreakpoint=Jt;let ui=class extends Wt{constructor(M,te,Te,Ke,et,nt,ut){super(Ke,et,nt,ut);if(!te)throw(0,D.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Te}};ui=$e([U],ui),e.DataBreakpoint=ui;let ci=class{constructor(M,te,Te){this.command=M,this.args=te||[],this.options=Te}};ci=$e([U],ci),e.DebugAdapterExecutable=ci;let Tt=class{constructor(M,te){this.port=M,this.host=te}};Tt=$e([U],Tt),e.DebugAdapterServer=Tt;let Zt=class{constructor(M){this.path=M}};Zt=$e([U],Zt),e.DebugAdapterNamedPipeServer=Zt;let di=class{constructor(M){this.implementation=M}};di=$e([U],di),e.DebugAdapterInlineImplementation=di;let Xt=class{constructor(M,te){this.range=M,this.expression=te}};Xt=$e([U],Xt),e.EvaluatableExpression=Xt;var ei;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(ei=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var dt;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(dt=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let hi=class{constructor(M,te){this.range=M,this.text=te}};hi=$e([U],hi),e.InlineValueText=hi;let Bt=class{constructor(M,te,Te=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Te}};Bt=$e([U],Bt),e.InlineValueVariableLookup=Bt;let Ht=class{constructor(M,te){this.range=M,this.expression=te}};Ht=$e([U],Ht),e.InlineValueEvaluatableExpression=Ht;let ti=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};ti=$e([U],ti),e.InlineValueContext=ti;var ki;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(ki=e.FileChangeType||(e.FileChangeType={}));let ii=h=class extends Error{constructor(M,te=v.FileSystemProviderErrorCode.Unknown,Te){super(A.URI.isUri(M)?M.toString(!0):M);this.code=Te?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}static FileExists(M){return new h(M,v.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(M){return new h(M,v.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(M){return new h(M,v.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(M){return new h(M,v.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(M){return new h(M,v.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(M){return new h(M,v.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};ii=h=$e([U],ii),e.FileSystemError=ii;let fi=class{constructor(M,te,Te){this.start=M,this.end=te,this.kind=Te}};fi=$e([U],fi),e.FoldingRange=fi;var _i;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ni;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pi;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Pi=e.CommentMode||(e.CommentMode={}));var mi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class gi{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=gi;function Ai($){return typeof $=="undefined"||(0,w.isStringArray)($)}class pi{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Te=M.tokenTypes.length;te<Te;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Te=M.tokenModifiers.length;te<Te;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Te,Ke,et){if(typeof M=="number"&&typeof te=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(M,te,Te,Ke,et);if(x.isRange(M)&&typeof te=="string"&&Ai(Te))return this._push(M,te,Te);throw(0,D.illegalArgument)()}_push(M,te,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=M.start.line,et=M.start.character,nt=M.end.character-M.start.character,ut=this._tokenTypeStrToInt.get(te);let St=0;if(Te)for(const kt of Te){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(kt);St|=1<<xt>>>0}this._pushEncoded(Ke,et,nt,ut,St)}_pushEncoded(M,te,Te,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,xt=0;for(let zt=0;zt<St;zt++){let qt=this._data[5*zt],bi=this._data[5*zt+1];qt===0?(qt=kt,bi+=xt):qt+=kt,this._data[5*zt]=qt,this._data[5*zt+1]=bi,kt=qt,xt=bi}}let nt=M,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Te=M.length/5|0;for(let ut=0;ut<Te;ut++)te[ut]=ut;te.sort((ut,St)=>{const kt=M[5*ut],xt=M[5*St];if(kt===xt){const zt=M[5*ut+1],qt=M[5*St+1];return zt-qt}return kt-xt});const Ke=new Uint32Array(M.length);let et=0,nt=0;for(let ut=0;ut<Te;ut++){const St=5*te[ut],kt=M[St+0],xt=M[St+1],zt=M[St+2],qt=M[St+3],bi=M[St+4],Xi=kt-et,dn=Xi===0?xt-nt:xt,wi=5*ut;Ke[wi+0]=Xi,Ke[wi+1]=dn,Ke[wi+2]=zt,Ke[wi+3]=qt,Ke[wi+4]=bi,et=kt,nt=xt}return Ke}build(M){return this._dataIsSortedAndDeltaEncoded?new Vt(new Uint32Array(this._data),M):new Vt(pi._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=pi;class Vt{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Vt;class Ri{constructor(M,te,Te){this.start=M,this.deleteCount=te,this.data=Te}}e.SemanticTokensEdit=Ri;class Oi{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=Oi;var Fi;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Fi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ri=class{constructor(){}};ri.Back={iconPath:new Et("arrow-left")},ri=$e([U],ri),e.QuickInputButtons=ri;var vi;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(vi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Si;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Si=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var yi;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(yi=e.ExtensionKind||(e.ExtensionKind={}));class Me{constructor(M,te,Te){this.badge=M,this.tooltip=te,this.color=Te}static validate(M){if(M.badge){let te=(0,P.nextCharLength)(M.badge,0);if(te<M.badge.length&&(te+=(0,P.nextCharLength)(M.badge,te)),M.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Me;let Lt=class{constructor(M){this.kind=M}};Lt=$e([U],Lt),e.ColorTheme=Lt;var Di;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Di=e.ColorThemeKind||(e.ColorThemeKind={}));class gt{constructor(M,te){if(M<0)throw(0,D.illegalArgument)("start must be positive");if(te<0)throw(0,D.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}static isNotebookRange(M){return M instanceof gt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let te=this._start,Te=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(Te=M.end),te===this._start&&Te===this._end?this:new gt(te,Te)}}e.NotebookRange=gt;class jt{constructor(M,te,Te,Ke,et,nt,ut){this.kind=M,this.value=te,this.languageId=Te,this.mime=Ke,this.outputs=et??[],this.metadata=nt,this.executionSummary=ut,jt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>jt.isNotebookCellData(te))}static isNotebookCellData(M){return!0}}e.NotebookCellData=jt;class Ni{constructor(M){this.cells=M}}e.NotebookData=Ni;class Ot{constructor(M,te){this.data=M,this.mime=te;const Te=(0,I.normalizeMimeType)(te,!0);if(!Te)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}static isNotebookCellOutputItem(M){return M instanceof Ot?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const te={name:M.name,message:M.message,stack:M.stack};return Ot.json(te,"application/vnd.code.notebook.error")}static stdout(M){return Ot.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Ot.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,te="application/octet-stream"){return new Ot(M,te)}static text(M,te=I.Mimes.text){const Te=Re(Ot,u,"f",d).encode(String(M));return new Ot(Te,te)}static json(M,te="text/x-json"){const Te=JSON.stringify(M,void 0,"	");return Ot.text(Te,te)}}e.NotebookCellOutputItem=Ot,u=Ot,d={value:new TextEncoder};class si{constructor(M,te,Te){this.items=si.ensureUniqueMimeTypes(M,!0),typeof te=="string"?(this.id=te,this.metadata=Te):(this.id=(0,O.generateUuid)(),this.metadata=te??Te)}static isNotebookCellOutput(M){return M instanceof si?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,w.isArray)(M.items)}static ensureUniqueMimeTypes(M,te=!1){const Te=new Set,Ke=new Set;for(let et=0;et<M.length;et++){const nt=M[et],ut=(0,I.normalizeMimeType)(nt.mime);if(!Te.has(ut)){Te.add(ut);continue}Ke.add(et),te&&console.warn(`DUPLICATED mime type '${nt.mime}' will be dropped`)}return Ke.size===0?M:M.filter((et,nt)=>!Ke.has(nt))}}e.NotebookCellOutput=si;var oi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(oi=e.NotebookCellKind||(e.NotebookCellKind={}));var Mi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Mi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Li;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Li=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ui;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Ui=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ci{constructor(M,te){this.text=M,this.alignment=te}}e.NotebookCellStatusBarItem=Ci;var Bi;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Bi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class xi{constructor(M,te=[]){this.uri=M,this.provides=(0,a.asArray)(te)}}e.NotebookRendererScript=xi;let Ei=class{constructor(M,te){this.label=M,this.timestamp=te}};Ei=$e([U],Ei),e.TimelineItem=Ei;var $i;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})($i=e.ExtensionMode||(e.ExtensionMode={}));var zi;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(zi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ie;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(ie=e.StandardTokenType||(e.StandardTokenType={}));class ce{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=ce;class Oe{constructor(M,te){this._port=M,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Oe;var it;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(it=e.TestResultState||(e.TestResultState={}));var wt;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(wt=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ct=class{constructor(M=void 0,te=void 0,Te=void 0){this.include=M,this.exclude=te,this.profile=Te}};Ct=$e([U],Ct),e.TestRunRequest=Ct;let Wi=C=class{constructor(M){this.message=M}static diff(M,te,Te){const Ke=new C(M);return Ke.expectedOutput=te,Ke.actualOutput=Te,Ke}};Wi=C=$e([U],Wi),e.TestMessage=Wi;let Hi=class{constructor(M){this.id=M}};Hi=$e([U],Hi),e.TestTag=Hi;let ai=class{constructor(M,te){this.covered=M,this.total=te}};ai=$e([U],ai),e.CoveredCount=ai;let Vi=F=class{constructor(M,te,Te,Ke){this.uri=M,this.statementCoverage=te,this.branchCoverage=Te,this.functionCoverage=Ke}static fromDetails(M,te){const Te=new ai(0,0),Ke=new ai(0,0),et=new ai(0,0);for(const ut of te)if("branches"in ut){Te.total+=1,Te.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ke.total+=1,Ke.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=ut.executionCount>0?1:0;const nt=new F(M,Te,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return nt.detailedCoverage=te,nt}};Vi=F=$e([U],Vi),e.FileCoverage=Vi;let ji=class{constructor(M,te,Te=[]){this.executionCount=M,this.location=te,this.branches=Te}};ji=$e([U],ji),e.StatementCoverage=ji;let qi=class{constructor(M,te){this.executionCount=M,this.location=te}};qi=$e([U],qi),e.BranchCoverage=qi;let Ki=class{constructor(M,te){this.executionCount=M,this.location=te}};Ki=$e([U],Ki),e.FunctionCoverage=Ki;var Zi;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(Zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var en;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(en=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var tn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(tn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class nn{constructor(M,te,Te,Ke,et,nt){this.kind=M,this.name=te,this.detail=Te,this.uri=Ke,this.range=et,this.selectionRange=nt}}e.TypeHierarchyItem=nn;class rn{constructor(M){this.uri=M}}e.TextTabInput=rn;class sn{constructor(M,te){this.original=M,this.modified=te}}e.TextDiffTabInput=sn;class on{constructor(M,te){this.uri=M,this.viewType=te}}e.CustomEditorTabInput=on;class an{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=an;class ln{constructor(M,te){this.uri=M,this.notebookType=te}}e.NotebookEditorTabInput=ln;class un{constructor(M,te,Te){this.original=M,this.modified=te,this.notebookType=Te}}e.NotebookDiffEditorTabInput=un;class cn{constructor(){}}e.TerminalEditorTabInput=cn}),define(Se[85],De([1,0,41,11,9,233,121,6,15]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function O(f,u){u?A.set(f,u):A.delete(f)}e.setWordDefinitionFor=O;function v(f){return A.get(f)}e.getWordDefinitionFor=v;class p extends N.MirrorTextModel{constructor(u,d,c,y,S,l,_,r){super(d,c,y,S);this._proxy=u,this._languageId=l,this._isDirty=_,this.notebook=r,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,w.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===D.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},save(){return u._save()},getText(d){return d?u._getTextInRange(d):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(d){return u._lineAt(d)},offsetAt(d){return u._offsetAt(d)},positionAt(d){return u._positionAt(d)},validateRange(d){return u._validateRange(d)},validatePosition(d){return u._validatePosition(d)},getWordRangeAtPosition(d,c){return u._getWordRangeAtPosition(d,c)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,a.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,a.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const d=this._validateRange(u);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const c=this._eol,y=d.start.line,S=d.end.line,l=[];l.push(this._lines[y].substring(d.start.character));for(let _=y+1;_<S;_++)l.push(this._lines[_]);return l.push(this._lines[S].substring(0,d.end.character)),l.join(c)}_lineAt(u){let d;if(u instanceof P.Position?d=u.line:typeof u=="number"&&(d=u),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new b(d,this._lines[d],d===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(u),c=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,c))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(u.start),c=this._validatePosition(u.end);return d===u.start&&c===u.end?u:new P.Range(d.line,d.character,c.line,c.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:d,character:c}=u,y=!1;if(d<0)d=0,c=0,y=!0;else if(d>=this._lines.length)d=this._lines.length-1,c=this._lines[d].length,y=!0;else{const S=this._lines[d].length;c<0?(c=0,y=!0):c>S&&(c=S,y=!0)}return y?new P.Position(d,c):u}_getWordRangeAtPosition(u,d){const c=this._validatePosition(u);if(!d)d=v(this._languageId);else if((0,g.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const y=(0,I.getWordAtText)(c.character+1,(0,I.ensureValidWordDefinition)(d),this._lines[c.line],0);if(y)return new P.Range(c.line,y.startColumn-1,c.line,y.endColumn-1)}}e.ExtHostDocumentData=p;class b{constructor(u,d,c){this._line=u,this._text=d,this._isLastLine=c}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(Se[159],De([1,0,6,16,5]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(P){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new g.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let w;switch(P){case"light":w=a.ColorThemeKind.Light;break;case"hcDark":w=a.ColorThemeKind.HighContrast;break;case"hcLight":w=a.ColorThemeKind.HighContrastLight;break;default:w=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};N=$e([ze(0,D.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Se[65],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class D{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=D}),define(Se[160],De([1,0,25]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class D{constructor(){this.buffers=[]}add(w){let A=this.buffers.indexOf(w);return A<0&&(A=this.buffers.length,this.buffers.push(w)),A}}function g(P,w){if(w.serializeBuffersForPostMessage){const A=new D,O=(b,f)=>{if(f instanceof ArrayBuffer){const u=A.add(f);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(f)){const u=N(f);if(u){const d=A.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:u,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},v=JSON.stringify(P,O),p=A.buffers.map(b=>{const f=new Uint8Array(b);return a.VSBuffer.wrap(f)});return{message:v,buffers:p}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=g;function N(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(P,w){const A=w.map(p=>{const b=new ArrayBuffer(p.byteLength);return new Uint8Array(b).set(p.buffer),b}),O=w.length?(p,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:u}=f,d=A[u];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return b}:void 0;return{message:JSON.parse(P,O),arrayBuffers:A}}e.deserializeWebviewMessage=I}),define(Se[86],De([1,0,161,2]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var g;(function(N){function I(w,A){const O=new Map;return w.types.forEach((v,p)=>{O.set(v,{asString:async()=>w.items[p].asString,asFile:()=>{const b=w.items[p].fileData;if(!!b)return{name:b.name,uri:D.URI.revive(b.uri),data:(0,a.once)(()=>A(p))}},value:void 0})}),O}N.toDataTransfer=I;async function P(w){const A={types:[],items:[]},O=Array.from(w.entries());for(const v of O){A.types.push(v[0]);const p=await v[1].asString(),b=v[1].asFile();A.items.push({asString:p,fileData:b?{name:b.name,uri:b.uri}:void 0})}return A}N.toDataTransferDTO=P})(g=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(Se[162],De([1,0,135,10,2,7,3,34,38,15,11]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(v=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(K){const L=K;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}e.isEditorPaneWithSelection=b;function f(K,L,oe){for(const de of oe.visibleEditorPanes)if(de.group.id===L&&K.matches(de.input))return de.getViewState()}e.findViewStateForEditor=f;function u(K){if(i(K))return!1;const L=K;return g.URI.isUri(L?.resource)}e.isResourceEditorInput=u;function d(K){if(i(K))return!1;const L=K;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=d;function c(K){if(i(K)||d(K))return!1;const L=K;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function y(K){if(i(K))return!1;const L=K;return L?L.resource===void 0||L.resource.scheme===O.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;var S;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var l;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class _{constructor(){this.mapIdToSaveSource=new Map}registerSource(L,oe){let de=this.mapIdToSaveSource.get(L);return de||(de={source:L,label:oe},this.mapIdToSaveSource.set(L,de)),de.source}getSourceLabel(L){return this.mapIdToSaveSource.get(L)?.label??L}}e.SaveSourceRegistry=new _;var r;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class k extends N.Disposable{}e.AbstractEditorInput=k;function i(K){return K instanceof k}e.isEditorInput=i;function s(K){const L=K;return g.URI.isUri(L?.preferredResource)}function n(K){const L=K;return i(L?.primary)&&i(L?.secondary)}e.isSideBySideEditorInput=n;function t(K){const L=K;return i(L?.modified)&&i(L?.original)}e.isDiffEditorInput=t;function o(K){return i(K?.editor)}e.isEditorInputWithOptions=o;function m(K){const L=K;return o(K)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function h(K){const L=K;return typeof L?.groupId=="number"&&i(L.editor)}e.isEditorIdentifier=h;var C;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(C=e.EditorCloseContext||(e.EditorCloseContext={}));var F;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(L,oe){if(!L)return;if(oe?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(L);if(ae&&fe){if(oe?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===U.ANY)return this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:oe.filterByScheme});L=oe.supportSideBySide===U.PRIMARY?ae:fe}}if(d(L)||c(L))return;const de=s(L)?L.preferredResource:L.resource;return!de||!oe||!oe.filterByScheme?de:this.filterUri(de,oe.filterByScheme)}getSideEditors(L){return n(L)||c(L)?{primary:L.primary,secondary:L.secondary}:t(L)||d(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,oe){if(!L)return;if(oe?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(L);if(ae&&fe){if(oe?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===U.ANY)return this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:oe.filterByScheme});L=oe.supportSideBySide===U.PRIMARY?ae:fe}}if(d(L)||c(L))return;const de=L.resource;return!de||!oe||!oe.filterByScheme?de:this.filterUri(de,oe.filterByScheme)}filterUri(L,oe){if(Array.isArray(oe)){if(oe.some(de=>L.scheme===de))return L}else if(oe===L.scheme)return L}}e.EditorResourceAccessor=new R;var E;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const oe=this.instantiationService=L.get(I.IInstantiationService);for(const[de,ae]of this.editorSerializerConstructors)this.createEditorSerializer(de,ae,oe);this.editorSerializerConstructors.clear()}createEditorSerializer(L,oe,de){const ae=de.createInstance(oe);this.editorSerializerInstances.set(L,ae)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,D.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,oe){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,oe,this.instantiationService):this.editorSerializerConstructors.set(L,oe),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new x);async function z(K,L){if(!K||!K.length)return[];const oe=await Promise.all(K.map(async de=>{const ae=g.URI.revive(de.fileUri);if(!ae||!await L.canHandleResource(ae))return;let ee=de.exists,Ee=de.type;if(typeof ee!="boolean"||typeof Ee!="number")try{Ee=(await L.stat(ae)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&de.openOnlyIfExists||Ee===w.FileType.Directory)return;const we={...de.options,pinned:!0};let J;return ee?J={resource:ae,options:we}:J={resource:ae,options:we,forceUntitled:!0},J}));return(0,A.coalesce)(oe)}e.pathsToEditors=z;var V;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function se(K){const L=K;if(!L)return!1;const oe=L;if(oe.modified)return se(oe.modified);const de=L;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=se}),define(Se[66],De([1,0,11,2]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function g(P,w){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(w&&w.authority&&w.isRemote&&P.scheme===a.Schemas.file&&(P=D.URI.from({scheme:a.Schemas.vscodeRemote,authority:w.authority,path:P.path})),D.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${N(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=g;function N(P){return P.replace(/./g,w=>{const A=w.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?w:"-"+A.toString(16).padStart(4,"0")})}function I(P){return P.replace(/-([0-9a-f]{4})/g,(w,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=I}),define(Se[163],De([1,0,5,7,66]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(P,w,A){this._proxy=P,this._editors=w,this._remoteInfo=A,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const O=w.getVisibleTextEditors();for(const v of this._insets.values())O.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,w,A,O,v){let p;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===P){p=S;break}if(!p)throw new Error("not a visible editor");const b=this,f=this._handlePool++,u=new a.Emitter,d=new a.Emitter,c=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,g.asWebviewUri)(S,b._remoteInfo)}get cspSource(){return g.webviewGenericCspSource}set options(S){this._options=S,b._proxy.$setOptions(f,S)}get options(){return this._options}set html(S){this._html=S,b._proxy.$setHtml(f,S)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(S){return b._proxy.$postMessage(f,S)}},y=new class{constructor(){this.editor=P,this.line=w,this.height=A,this.webview=c,this.onDidDispose=d.event}dispose(){b._insets.has(f)&&(b._insets.delete(f),b._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),u.dispose())}};return this._proxy.$createEditorInset(f,p.id,p.value.document.uri,w+1,A,O||{},v.identifier,v.extensionLocation),this._insets.set(f,{editor:P,inset:y,onDidReceiveMessage:u}),y}$onDidDispose(P){const w=this._insets.get(P);w&&w.inset.dispose()}$onDidReceiveMessage(P,w){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=N}),define(Se[164],De([1,0,5,14,136]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,w,A,O){const v={command:P};if(w&&Object.keys(w).length>0&&(v.arguments=w),this.internalSend("request",v),typeof O=="number"){const p=setTimeout(()=>{clearTimeout(p);const b=this.pendingRequests.get(v.seq);if(b){this.pendingRequests.delete(v.seq);const f={type:"response",seq:0,request_seq:v.seq,success:!1,command:P,message:(0,g.localize)(0,null,O,P)};b(f)}},O)}return A&&this.pendingRequests.set(v.seq,A),v.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,w){return P.type!=="event"||w.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,D.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const w=P,A=this.pendingRequests.get(w.request_seq);A&&(this.pendingRequests.delete(w.request_seq),A(w));break}}}}internalSend(P,w){w.type=P,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((w,A)=>P.set(A,w)),await(0,D.timeout)(500),P.forEach((w,A)=>{w({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Se[165],De([1,0,137,44,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new D.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const N=v=>a.localize(51,null,v);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var I;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(I=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var w;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(A=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,g.createDecorator)(e.DEBUG_SERVICE_ID);var O;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(O=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[166],De([1,0,9,2,17,27,11]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function w(i,s,n){return i.replace(P,function(t,o){return s&&o.length>0&&o[0]!=="_"?t:n&&n.hasOwnProperty(o)?n[o]:t})}e.formatPII=w;function A(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=A;function O(i){return i.configuration.request==="attach"&&!v(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function v(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(s,"extensionhost")||(0,a.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?v(i.parentSession):void 0}e.getExtensionHostDebugSession=v;function p(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=p;function b(i,s,n){let t,o=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=m.exec(i);){const C=h.index+1,F=C+h[0].length;if(C<=s&&F>=n){t=h[0],o=C;break}}if(t){const C=/\w+/g;let F=null;for(;(F=C.exec(t))&&!(F.index+1+o+F[0].length>=n););F&&(t=t.substring(0,C.lastIndex))}return t?{start:o,end:o+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(i){return!!(i&&i.match(f))}e.isUri=u;function d(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(u(i.path))return D.URI.parse(i.path);if((0,g.isAbsolute)(i.path))return D.URI.file(i.path)}return i.path}function c(i){if(typeof i.path=="object"){const s=D.URI.revive(i.path);if(s)return s.scheme===I.Schemas.file?s.fsPath:s.toString()}return i.path}function y(i,s){const n=s?d:c,t=(0,N.deepClone)(i);return l(t,(o,m)=>{o&&m&&(m.path=n(m))}),t}e.convertToDAPaths=y;function S(i,s){const n=s?d:c,t=(0,N.deepClone)(i);return l(t,(o,m)=>{!o&&m&&(m.path=n(m))}),t}e.convertToVSCPaths=S;function l(i,s){switch(i.type){case"event":{const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=i;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const n=i;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>s(!1,t));break;case"scopes":n.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(o=>s(!1,o.location))}break;default:break}break}}}function _(i){return i.filter(s=>!s.presentation?.hidden).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):r(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=_;function r(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}async function k(i,s){const n=i.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(n!=="none"&&(await s.saveAll(),n==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=k}),define(Se[87],De([1,0,33,167,74,11,17,22,44]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",g.Mimes.latex,g.Mimes.markdown,"image/png","image/jpeg",g.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[g.Mimes.latex,g.Mimes.markdown,"application/json",g.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var O;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(O=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var c;(function(n){n.scheme=N.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function o(R,E){return R.with({scheme:n.scheme,fragment:`ch${E.toString().padStart(7,"0")}${R.scheme!==N.Schemas.file?R.scheme:""}`})}n.generate=o;function m(R){if(R.scheme!==n.scheme)return;const E=t.exec(R.fragment);return E?{handle:Number(E[1]),notebook:R.with({scheme:R.fragment.substring(E[0].length)||N.Schemas.file,fragment:null})}:void 0}n.parse=m;function h(R,E){return R.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${E??""},${R.scheme!==N.Schemas.file?R.scheme:""}`})}n.generateCellOutputUri=h;function C(R){if(R.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const E=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!E)return;const x=E[1]&&E[1]!==""?E[1]:void 0,z=E[2];return{outputId:x,notebook:R.with({scheme:z||N.Schemas.file,fragment:null})}}n.parseCellOutputUri=C;function F(R,E,x){return R.with({scheme:x,fragment:`ch${E.toString().padStart(7,"0")}${R.scheme!==N.Schemas.file?R.scheme:""}`})}n.generateCellUri=F;function U(R,E){if(R.scheme!==E)return;const x=t.exec(R.fragment);return x?{handle:Number(x[1]),notebook:R.with({scheme:R.fragment.substring(x[0].length)||N.Schemas.file,fragment:null})}:void 0}n.parseCellUri=U})(c=e.CellUri||(e.CellUri={}));const y=n=>P.isWindows?n.replace(/\//g,"\\"):n;class S{constructor(t=[],o=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=o,this.order=[...new Set(t)].map(m=>({pattern:m,matches:a.parse(y(m))}))}sort(t){const o=new Map(D.Iterable.map(t,h=>[h,y(h)]));let m=[];for(const{matches:h}of this.order)for(const[C,F]of o)if(h(F)){m.push(C),o.delete(C);break}return o.size&&(m=m.concat([...o.keys()].sort((h,C)=>this.defaultOrder.indexOf(h)-this.defaultOrder.indexOf(C)))),m}prioritize(t,o){const m=this.findIndex(t);if(m===-1){this.order.unshift({pattern:t,matches:a.parse(y(t))});return}const h=new Set(o.map(F=>this.findIndex(F,m)));h.delete(-1);const C=Array.from(h).sort();this.order.splice(m+1,0,...C.map(F=>this.order[F]));for(let F=C.length-1;F>=0;F--)this.order.splice(C[F],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,o=this.order.length){const m=y(t);for(let h=0;h<o;h++)if(this.order[h].matches(m))return h;return-1}}e.MimeTypeDisplayOrder=S;function l(n,t,o,m=(h,C)=>h===C){const h=[];function C(R,E,x){if(E===0&&x.length===0)return;const z=h[h.length-1];z&&z.start+z.deleteCount===R?(z.deleteCount+=E,z.toInsert.push(...x)):h.push({start:R,deleteCount:E,toInsert:x})}let F=0,U=0;for(;;){if(F===n.length){C(F,0,t.slice(U));break}if(U===t.length){C(F,n.length-F,[]);break}const R=n[F],E=t[U];if(m(R,E)){F+=1,U+=1;continue}o(E)?(C(F,1,[]),F+=1):(C(F,0,[E]),U+=1)}return h}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtBoundary","none");var _;(function(n){n.default="default",n.option="option"})(_=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(n){const t=n;return!!((typeof t.include=="string"||a.isRelativePattern(t.include))&&(typeof t.exclude=="string"||a.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=r;function k(n,t,o){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const m=r(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,h=r(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(a.match(m,(0,I.basename)(o.fsPath).toLowerCase()))return!(h&&a.match(h,(0,I.basename)(o.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=k,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Se[168],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var D;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(D=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[169],De([1,0,138,3,44]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new g.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new g.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new g.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,D.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Se[170],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=a;function D(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=D}),define(Se[46],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(N){N.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var D;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(D=e.TestPosition||(e.TestPosition={}));class g{constructor(I,P=I.length){if(this.path=I,this.viewEnd=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,P,w=I.parent){if(I.id===P)return new g([P]);let A=[I.id];for(let O=w;O&&O.id!==P;O=O.parent)A.push(O.id);return A.push(P),new g(A.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new g(I.split("\0"))}static join(I,P){return new g([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static compare(I,P){return I===P?0:P.startsWith(I+"\0")?2:I.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new g(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new g(this.path,I)}compare(I){if(typeof I=="string")return g.compare(this.toString(),I);for(let P=0;P<I.viewEnd&&P<this.viewEnd;P++)if(I.path[P]!==this.path[P])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=g}),define(Se[47],De([1,0,2,48]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var N;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(N=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:D.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var P;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var w;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(w=e.ITestErrorMessage||(e.ITestErrorMessage={}));var A;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(A=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(n){n.serialize=t=>t.type===0?w.serialize(t):A.serialize(t),n.deserialize=t=>t.type===0?w.deserialize(t):A.deserialize(t)})(O=e.ITestMessage||(e.ITestMessage={}));var v;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",b=(n,t)=>n+p+t;e.namespaceTestTag=b;const f=n=>{const t=n.indexOf(p);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=f;var u;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?D.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(u=e.ITestItem||(e.ITestItem={}));var d;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var c;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:u.deserialize(t.item)})})(c=e.InternalTestItem||(e.InternalTestItem={}));var y;(function(n){n.serialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.uri!==void 0&&(o.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(o.range=t.item.range?.toJSON()),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}},n.deserialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.range!==void 0&&(o.range=t.item.range?D.Range.lift(t.item.range):null),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}}})(y=e.ITestItemUpdate||(e.ITestItemUpdate={}));const S=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=S;var l;(function(n){n.serialize=(t,o)=>({...c.serialize(t),children:o,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var _;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var r;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var k;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:c.deserialize(t.item)}:t.op===1?{op:t.op,item:y.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:c.serialize(t.item)}:t.op===1?{op:t.op,item:y.serialize(t.item)}:t})(k=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(t){}update(t){}remove(t,o){}complete(){}}e.IncrementalChangeCollector=i;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const o=this.createChangeCollector();for(const m of t)switch(m.op){case 0:{const h=c.deserialize(m.item);if(h.parent){if(this.items.has(h.parent)){const C=this.items.get(h.parent);C.children.add(h.item.extId);const F=this.createItem(h,C);this.items.set(h.item.extId,F),o.add(F)}}else{const C=this.createItem(h);this.roots.add(C),this.items.set(h.item.extId,C),o.add(C)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=y.deserialize(m.item),C=this.items.get(h.extId);if(!C)break;h.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,h),o.update(C);break}case 2:{const h=this.items.get(m.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const C=[[m.itemId]];for(;C.length;)for(const F of C.pop()){const U=this.items.get(F);U&&(C.push(U.children),this.items.delete(F),o.remove(U,U!==h),U.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}o.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=s}),define(Se[67],De([1,0,14,5,7,10,47,46]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const A=(c,y)=>c===y,O={range:(c,y)=>c===y?!0:!c||!y?!1:c.equalsRange(y),busy:A,label:A,description:A,error:A,tags:(c,y)=>!(c.length!==y.length||c.some(S=>!y.includes(S)))},v=(c,y)=>{let S;for(const[l,_]of Object.entries(O))_(c[l],y[l])||(S?S[l]=y[l]:S={[l]:y[l]});return S};class p extends g.Disposable{constructor(y){super();this.options=y,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new D.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(y){this._resolveHandler=y;for(const S of this.tree.values())this.updateExpandability(S)}collectDiff(){const y=this.diff;return this.diff=[],y}pushDiff(y){const S=this.diff[this.diff.length-1];if(S&&y.op===1){if(S.op===1&&S.item.extId===y.item.extId){(0,I.applyTestItemUpdate)(S.item,y.item);return}if(S.op===0&&S.item.item.extId===y.item.extId){(0,I.applyTestItemUpdate)(S.item,y.item);return}}this.diff.push(y),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(y,S){const l=this.tree.get(y);if(!!l){if((l.expandLevels===void 0||S>l.expandLevels)&&(l.expandLevels=S),l.expand===1){const _=this.resolveChildren(l);return _.isOpen()?this.expandChildren(l,S-1):_.wait().then(()=>this.expandChildren(l,S-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,S-1)):this.expandChildren(l,S-1)}}dispose(){for(const y of this.tree.values())this.options.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(y,S){switch(S.op){case 3:this.removeItem(P.TestId.joinToString(y.fullId,S.id));break;case 0:this.upsertItem(S.item,y);break;case 5:for(const l of S.ops)this.onTestItemEvent(y,l);break;case 1:this.diffTagRefs(S.new,S.old,y.fullId.toString());break;case 2:this.updateExpandability(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:S.update}});break;default:(0,N.assertNever)(S)}}upsertItem(y,S){const l=P.TestId.fromExtHostTestItem(y,this.root.id,S?.actual),_=this.options.getApiFor(y);_.parent&&_.parent!==S?.actual&&this.options.getChildren(_.parent).delete(y.id);let r=this.tree.get(l.toString());if(!r){r={fullId:l,actual:y,parent:S?l.parentId:null,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},y.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(y,S),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(y)}}),this.connectItemAndChildren(y,r,S);return}if(r.actual===y){this.connectItem(y,r,S);return}const k=this.options.getChildren(r.actual),i=r.actual,s=v(this.options.toITestItem(i),this.options.toITestItem(y));this.options.getApiFor(i).listener=void 0,r.actual=y,r.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(y.tags,i.tags,l.toString()),delete s.tags),this.onTestItemEvent(r,{op:4,update:s})),this.connectItemAndChildren(y,r,S);for(const n of k)this.options.getChildren(y).get(n.id)||this.removeItem(P.TestId.joinToString(l,n.id))}diffTagRefs(y,S,l){const _=new Set(S.map(r=>r.id));for(const r of y)_.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:l,item:{tags:y.map(r=>(0,I.namespaceTestTag)(this.options.controllerId,r.id))}}}),_.forEach(this.decrementTagRefs,this)}incrementTagRefs(y){const S=this.tags.get(y.id);S?S.refCount++:(this.tags.set(y.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,y.id)}}))}decrementTagRefs(y){const S=this.tags.get(y);S&&!--S.refCount&&(this.tags.delete(y),this.pushDiff({op:6,id:(0,I.namespaceTestTag)(this.options.controllerId,y)}))}setItemParent(y,S){this.options.getApiFor(y).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(y,S,l){this.setItemParent(y,l);const _=this.options.getApiFor(y);_.parent=l?.actual,_.listener=r=>this.onTestItemEvent(S,r),this.updateExpandability(S)}connectItemAndChildren(y,S,l){this.connectItem(y,S,l);for(const _ of this.options.getChildren(y))this.upsertItem(_,S)}updateExpandability(y){let S;this._resolveHandler?y.resolveBarrier?S=y.resolveBarrier.isOpen()?3:2:S=y.actual.canResolveChildren?1:0:S=0,S!==y.expand&&(y.expand=S,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:S}}),S===1&&y.expandLevels!==void 0&&this.resolveChildren(y))}expandChildren(y,S){if(S<0)return;const l=[];for(const _ of this.options.getChildren(y.actual)){const r=this.expand(P.TestId.joinToString(y.fullId,_.id),S);(0,a.isThenable)(r)&&l.push(r)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this._resolveHandler){const r=new a.Barrier;return r.open(),r}y.expand=2,this.pushExpandStateUpdate(y);const S=y.resolveBarrier=new a.Barrier,l=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let _;try{_=this._resolveHandler(y.actual===this.root?void 0:y.actual)}catch(r){l(r)}return(0,a.isThenable)(_)?_.catch(l).then(()=>{S.open(),this.updateExpandability(y)}):(S.open(),this.updateExpandability(y)),y.resolveBarrier}pushExpandStateUpdate(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}removeItem(y){const S=this.tree.get(y);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:y});const l=[S];for(;l.length;){const _=l.pop();if(!!_){this.options.getApiFor(_.actual).listener=void 0;for(const r of _.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(_.fullId.toString());for(const r of this.options.getChildren(_.actual))l.push(this.tree.get(P.TestId.joinToString(_.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.diffOpEmitter.fire(y)}}e.TestItemCollection=p;class b extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=b;class f extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(y,S,l){super(`TestItem with ID "${y}" is from controller "${S}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=u;const d=(c,y,S)=>{let l=new Map;return{get size(){return l.size},forEach(_,r){for(const k of l.values())_.call(r,k,this)},replace(_){const r=new Map,k=new Set(l.keys()),i={op:5,ops:[]};for(const s of _){if(!(s instanceof S))throw new f(s.id);const n=y(s).controllerId;if(n!==c.controllerId)throw new u(s.id,n,c.controllerId);if(r.has(s.id))throw new b(s.id);r.set(s.id,s),k.delete(s.id),i.ops.push({op:0,item:s})}for(const s of k.keys())i.ops.push({op:3,id:s});c.listener?.(i),l=r},add(_){if(!(_ instanceof S))throw new f(_.id);l.set(_.id,_),c.listener?.({op:0,item:_})},delete(_){l.delete(_)&&c.listener?.({op:3,id:_})},get(_){return l.get(_)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=d}),define(Se[88],De([1,0,67]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const D=new WeakMap,g=(I,P)=>{const w={controllerId:P};return D.set(I,w),w};e.createPrivateApiFor=g;const N=I=>{const P=D.get(I);if(!P)throw new a.InvalidTestItemError(I?.id||"<unknown>");return P};e.getPrivateApiFor=N}),define(Se[171],De([1,0,17,61,10,27,22,76,139,9]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class O{constructor(p,b,f,u){this._contributedVariables=new Map,this._context=p,this._labelService=b,this._userHomePromise=f,u&&(this._envVariablesPromise=u.then(d=>this.prepareEnv(d)))}prepareEnv(p){if(I.isWindows){const b=Object.create(null);return Object.keys(p).forEach(f=>{b[f.toLowerCase()]=p[f]}),b}return p}resolveWithEnvironment(p,b,f){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},b?b.uri:void 0,f)}async resolveAsync(p,b){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,p?p.uri:void 0,b)}async resolveAnyBase(p,b,f,u){const d=N.deepClone(b);I.isWindows&&d.windows?Object.keys(d.windows).forEach(y=>d[y]=d.windows[y]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(y=>d[y]=d.osx[y]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(y=>d[y]=d.linux[y]),delete d.windows,delete d.osx,delete d.linux;const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,p?p.uri:void 0,d,f,u)}async resolveAnyAsync(p,b,f){return this.resolveAnyBase(p,b,f)}async resolveAnyMap(p,b,f){const u=new Map;return{newConfig:await this.resolveAnyBase(p,b,f,u),resolvedVariables:u}}resolveWithInteractionReplace(p,b,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,b)}async recursiveResolve(p,b,f,u,d){if(g.isString(f))return this.resolveString(p,b,f,u,d);if(g.isArray(f))return Promise.all(f.map(c=>this.recursiveResolve(p,b,c,u,d)));if(g.isObject(f)){let c=Object.create(null);const y=await Promise.all(Object.keys(f).map(async S=>[await this.resolveString(p,b,S,u,d),await this.recursiveResolve(p,b,f[S],u,d)]));for(const[S,l]of y)c[S]=l;return c}return f}resolveString(p,b,f,u,d){return(0,A.replaceAsync)(f,O.VARIABLE_REGEXP,async(c,y)=>{if(y.includes(O.VARIABLE_LHS))return c;let S=await this.evaluateSingleVariable(p,c,y,b,u);return d&&d.set(y,S),S!==c&&g.isString(S)&&S.match(O.VARIABLE_REGEXP)&&(S=await this.resolveString(p,b,S,u,d)),S})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}async evaluateSingleVariable(p,b,f,u,d){let c;const y=f.split(":");y.length>1&&(f=y[0],c=y[1]);const S=()=>{const r=this._context.getFilePath();if(r)return r;throw new Error((0,w.localize)(0,null,b))},l=()=>{const r=S();if(this._context.getWorkspaceFolderPathForFile){const k=this._context.getWorkspaceFolderPathForFile();if(k)return k}throw new Error((0,w.localize)(1,null,b,a.basename(r)))},_=()=>{if(c){const r=this._context.getFolderUri(c);if(r)return r;throw new Error((0,w.localize)(2,null,b,c))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,w.localize)(3,null,b)):new Error((0,w.localize)(4,null,b))};switch(f){case"env":if(c){if(p.env){const r=p.env[I.isWindows?c.toLowerCase():c];if(g.isString(r))return r}return""}throw new Error((0,w.localize)(5,null,b));case"config":if(c){const r=this._context.getConfigurationValue(u,c);if(g.isUndefinedOrNull(r))throw new Error((0,w.localize)(6,null,b,c));if(g.isObject(r))throw new Error((0,w.localize)(7,null,b,c));return r}throw new Error((0,w.localize)(8,null,b));case"command":return this.resolveFromMap(b,c,d,"command");case"input":return this.resolveFromMap(b,c,d,"input");case"extensionInstallFolder":if(c){const r=await this._context.getExtension(c);if(!r)throw new Error((0,w.localize)(9,null,b,c));return this.fsPath(r.extensionLocation)}throw new Error((0,w.localize)(10,null,b));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(_()));case"cwd":return u||c?(0,P.normalizeDriveLetter)(this.fsPath(_())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(_()));case"userHome":{if(p.userHome)return p.userHome;throw new Error((0,w.localize)(11,null,b))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new Error((0,w.localize)(12,null,b))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new Error((0,w.localize)(13,null,b))}case"file":return S();case"fileWorkspaceFolder":return l();case"relativeFile":return u||c?a.relative(this.fsPath(_()),S()):S();case"relativeFileDirname":{const r=a.dirname(S());if(u||c){const k=a.relative(this.fsPath(_()),r);return k.length===0?".":k}return r}case"fileDirname":return a.dirname(S());case"fileExtname":return a.extname(S());case"fileBasename":return a.basename(S());case"fileBasenameNoExtension":{const r=a.basename(S());return r.slice(0,r.length-a.extname(r).length)}case"fileDirnameBasename":return a.basename(a.dirname(S()));case"execPath":{const r=this._context.getExecPath();return r||b}case"execInstallFolder":{const r=this._context.getAppRoot();return r||b}case"pathSeparator":return a.sep;default:try{const r=c?`${f}:${c}`:f;return this.resolveFromMap(b,r,d,void 0)}catch{return b}}}}resolveFromMap(p,b,f,u){if(b&&f){const d=u===void 0?f[b]:f[u+":"+b];if(typeof d=="string")return d;throw new Error((0,w.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=O,O.VARIABLE_LHS="${",O.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[89],De([1,0,3,162]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var g;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(g=e.GroupDirection||(e.GroupDirection={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function A(f){const u=f;return(0,D.isEditorInput)(u?.editor)&&(0,D.isEditorInput)(u?.replacement)}e.isEditorReplacement=A;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var v;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(v=e.OpenEditorContext||(e.OpenEditorContext={}));function p(f){const u=f;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=p;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Se[172],De([1,0,3,89]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function g(N){const I=N;return typeof N=="number"||(0,D.isEditorGroup)(I)}e.isPreferredGroup=g}),define(Se[8],De([1,0,15,25,75,21,105,57,27,10,2,48,68,141,79,88,87,46,47,172,6]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(be){function ye(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Ue,positionLineNumber:tt,positionColumn:Ve}=q,ot=new l.Position(Ae-1,Ue-1),ct=new l.Position(tt-1,Ve-1);return new l.Selection(ot,ct)}be.to=ye;function ue(q){const{anchor:Ae,active:Ue}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}be.from=ue})(_=e.Selection||(e.Selection={}));var r;(function(be){function ye(q){if(!q)return;const{start:Ae,end:Ue}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}be.from=ye;function ue(q){if(!q)return;const{startLineNumber:Ae,startColumn:Ue,endLineNumber:tt,endColumn:Ve}=q;return new l.Range(Ae-1,Ue-1,tt-1,Ve-1)}be.to=ue})(r=e.Range||(e.Range={}));var k;(function(be){function ye(ue){switch(ue){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}be.to=ye})(k=e.TokenType||(e.TokenType={}));var i;(function(be){function ye(q){return new l.Position(q.lineNumber-1,q.column-1)}be.to=ye;function ue(q){return{lineNumber:q.line+1,column:q.character+1}}be.from=ue})(i=e.Position||(e.Position={}));var s;(function(be){function ye(Ae,Ue){return(0,a.coalesce)((0,a.asArray)(Ae).map(tt=>ue(tt,Ue)))}be.from=ye;function ue(Ae,Ue){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Ue),pattern:Be.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Ue){return Ue&&typeof Ae=="string"?Ue.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(be){function ye(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}be.from=ye;function ue(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}be.to=ue})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(be){function ye(q){let Ae;return q.code&&((0,A.isString)(q.code)||(0,A.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...r.from(q.range),message:q.message,source:q.source,code:Ae,severity:m.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(o.from),tags:Array.isArray(q.tags)?(0,a.coalesce)(q.tags.map(n.from)):void 0}}be.from=ye;function ue(q){const Ae=new l.Diagnostic(r.to(q),q.message,m.to(q.severity));return Ae.source=q.source,Ae.code=(0,A.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(o.to),Ae.tags=q.tags&&(0,a.coalesce)(q.tags.map(n.to)),Ae}be.to=ue})(t=e.Diagnostic||(e.Diagnostic={}));var o;(function(be){function ye(q){return{...r.from(q.location.range),message:q.message,resource:q.location.uri}}be.from=ye;function ue(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,r.to(q)),q.message)}be.to=ue})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(be){function ye(q){switch(q){case l.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}be.from=ye;function ue(q){switch(q){case f.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}be.to=ue})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(be){function ye(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}be.from=ye;function ue(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ue})(h=e.ViewColumn||(e.ViewColumn={}));function C(be){return typeof be.range!="undefined"}function F(be){return be.length===0?!0:!!C(be[0])}e.isDecorationOptionsArr=F;var U;(function(be){function ye(Ve){return Ve.map(be.from)}be.fromMany=ye;function ue(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function q(Ve){let ot;if(ue(Ve)){const{language:mt,value:vt}=Ve;ot={value:"```"+mt+`
`+vt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ve)?ot={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ot={value:Ve}:ot={value:""};const ct=Object.create(null);ot.uris=ct;const pt=mt=>{try{let vt=O.URI.parse(mt,!0);vt=vt.with({query:Ae(vt.query,ct)}),ct[mt]=vt}catch{}return""},_t=new I.marked.Renderer;return _t.link=pt,_t.image=mt=>typeof mt=="string"?pt(g.parseHrefAndDimensions(mt).href):"",(0,I.marked)(ot.value,{renderer:_t}),ot}be.from=q;function Ae(Ve,ot){if(!Ve)return Ve;let ct;try{ct=(0,P.parse)(Ve)}catch{}if(!ct)return Ve;let pt=!1;return ct=(0,w.cloneAndChange)(ct,_t=>{if(O.URI.isUri(_t)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[mt]=_t,pt=!0,mt}else return}),pt?JSON.stringify(ct):Ve}function Ue(Ve){const ot=new l.MarkdownString(Ve.value,Ve.supportThemeIcons);return ot.isTrusted=Ve.isTrusted,ot.supportHtml=Ve.supportHtml,ot.baseUri=Ve.baseUri?O.URI.from(Ve.baseUri):void 0,ot}be.to=Ue;function tt(Ve){if(!!Ve)return typeof Ve=="string"?Ve:be.from(Ve)}be.fromStrict=tt})(U=e.MarkdownString||(e.MarkdownString={}));function R(be){return F(be)?be.map(ye=>({range:r.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?U.fromMany(ye.hoverMessage):ye.hoverMessage?U.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):be.map(ye=>({range:r.from(ye)}))}e.fromRangeOrRangeWithMessage=R;function E(be){return typeof be=="undefined"?be:typeof be=="string"?O.URI.file(be):be}e.pathOrURIToURI=E;var x;(function(be){function ye(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?E(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}be.from=ye})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(be){function ye(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?x.from(ue.before):void 0,after:ue.after?x.from(ue.after):void 0}}be.from=ye})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(be){function ye(ue){if(typeof ue=="undefined")return ue;switch(ue){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=ye})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var se;(function(be){function ye(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?V.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?z.from(ue.light):void 0,dark:ue.dark?z.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?x.from(ue.before):void 0,after:ue.after?x.from(ue.after):void 0}}be.from=ye})(se=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(be){function ye(q){return{text:q.newText,eol:q.newEol&&qe.from(q.newEol),range:r.from(q.range)}}be.from=ye;function ue(q){const Ae=new l.TextEdit(r.to(q.range),q.text);return Ae.newEol=typeof q.eol=="undefined"?void 0:qe.to(q.eol),Ae}be.to=ue})(K=e.TextEdit||(e.TextEdit={}));var L;(function(be){function ye(ue){return{range:r.from(ue.range),snippet:ue.snippet.value}}be.from=ye})(L=e.SnippetTextEdit||(e.SnippetTextEdit={}));var oe;(function(be){function ye(q,Ae){const Ue={edits:[]};if(q instanceof l.WorkspaceEdit){const tt=new N.ResourceSet;for(const Ve of q._allEntries())Ve._type===1&&O.URI.isUri(Ve.to)&&Ve.from===void 0&&tt.add(Ve.to);for(const Ve of q._allEntries())Ve._type===1?Ue.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Ue.edits.push({_type:2,resource:Ve.uri,edit:K.from(Ve.edit),modelVersionId:tt.has(Ve.uri)?void 0:Ae?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ue.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ue.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(lt.from)}})}return Ue}be.from=ye;function ue(q){const Ae=new l.WorkspaceEdit;for(const Ue of q.edits)Ue.edit?Ae.replace(O.URI.revive(Ue.resource),r.to(Ue.edit.range),Ue.edit.text):Ae.renameFile(O.URI.revive(Ue.oldUri),O.URI.revive(Ue.newUri),Ue.options);return Ae}be.to=ue})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(be){const ye=Object.create(null);ye[l.SymbolKind.File]=0,ye[l.SymbolKind.Module]=1,ye[l.SymbolKind.Namespace]=2,ye[l.SymbolKind.Package]=3,ye[l.SymbolKind.Class]=4,ye[l.SymbolKind.Method]=5,ye[l.SymbolKind.Property]=6,ye[l.SymbolKind.Field]=7,ye[l.SymbolKind.Constructor]=8,ye[l.SymbolKind.Enum]=9,ye[l.SymbolKind.Interface]=10,ye[l.SymbolKind.Function]=11,ye[l.SymbolKind.Variable]=12,ye[l.SymbolKind.Constant]=13,ye[l.SymbolKind.String]=14,ye[l.SymbolKind.Number]=15,ye[l.SymbolKind.Boolean]=16,ye[l.SymbolKind.Array]=17,ye[l.SymbolKind.Object]=18,ye[l.SymbolKind.Key]=19,ye[l.SymbolKind.Null]=20,ye[l.SymbolKind.EnumMember]=21,ye[l.SymbolKind.Struct]=22,ye[l.SymbolKind.Event]=23,ye[l.SymbolKind.Operator]=24,ye[l.SymbolKind.TypeParameter]=25;function ue(Ae){return typeof ye[Ae]=="number"?ye[Ae]:6}be.from=ue;function q(Ae){for(const Ue in ye)if(ye[Ue]===Ae)return Number(Ue);return l.SymbolKind.Property}be.to=q})(de=e.SymbolKind||(e.SymbolKind={}));var ae;(function(be){function ye(q){switch(q){case l.SymbolTag.Deprecated:return 1}}be.from=ye;function ue(q){switch(q){case 1:return l.SymbolTag.Deprecated}}be.to=ue})(ae=e.SymbolTag||(e.SymbolTag={}));var fe;(function(be){function ye(q){return{name:q.name,kind:de.from(q.kind),tags:q.tags&&q.tags.map(ae.from),containerName:q.containerName,location:ve.from(q.location)}}be.from=ye;function ue(q){const Ae=new l.SymbolInformation(q.name,de.to(q.kind),q.containerName,ve.to(q.location));return Ae.tags=q.tags&&q.tags.map(ae.to),Ae}be.to=ue})(fe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ee;(function(be){function ye(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:r.from(q.range),selectionRange:r.from(q.selectionRange),kind:de.from(q.kind),tags:q.tags?.map(ae.from)??[]};return q.children&&(Ae.children=q.children.map(ye)),Ae}be.from=ye;function ue(q){const Ae=new l.DocumentSymbol(q.name,q.detail,de.to(q.kind),r.to(q.range),r.to(q.selectionRange));return(0,a.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(ae.to)),q.children&&(Ae.children=q.children.map(ue)),Ae}be.to=ue})(ee=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(be){function ye(q){const Ae=new l.CallHierarchyItem(de.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),r.to(q.range),r.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}be.to=ye;function ue(q,Ae,Ue){if(Ae=Ae??q._sessionId,Ue=Ue??q._itemId,Ae===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ue,name:q.name,detail:q.detail,kind:de.from(q.kind),uri:q.uri,range:r.from(q.range),selectionRange:r.from(q.selectionRange),tags:q.tags?.map(ae.from)}}be.from=ue})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var we;(function(be){function ye(ue){return new l.CallHierarchyIncomingCall(Ee.to(ue.from),ue.fromRanges.map(q=>r.to(q)))}be.to=ye})(we=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var J;(function(be){function ye(ue){return new l.CallHierarchyOutgoingCall(Ee.to(ue.to),ue.fromRanges.map(q=>r.to(q)))}be.to=ye})(J=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(be){function ye(q){return{range:q.range&&r.from(q.range),uri:q.uri}}be.from=ye;function ue(q){return new l.Location(O.URI.revive(q.uri),r.to(q.range))}be.to=ue})(ve=e.location||(e.location={}));var Pe;(function(be){function ye(q){const Ae=q,Ue=q;return{originSelectionRange:Ae.originSelectionRange?r.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ue.uri,range:r.from(Ae.targetRange?Ae.targetRange:Ue.range),targetSelectionRange:Ae.targetSelectionRange?r.from(Ae.targetSelectionRange):void 0}}be.from=ye;function ue(q){return{targetUri:O.URI.revive(q.uri),targetRange:r.to(q.range),targetSelectionRange:q.targetSelectionRange?r.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?r.to(q.originSelectionRange):void 0}}be.to=ue})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(be){function ye(q){return{range:r.from(q.range),contents:U.fromMany(q.contents)}}be.from=ye;function ue(q){return new l.Hover(q.contents.map(U.to),r.to(q.range))}be.to=ue})(Fe=e.Hover||(e.Hover={}));var We;(function(be){function ye(q){return{range:r.from(q.range),expression:q.expression}}be.from=ye;function ue(q){return new l.EvaluatableExpression(r.to(q.range),q.expression)}be.to=ue})(We=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ge;(function(be){function ye(q){if(q instanceof l.InlineValueText)return{type:"text",range:r.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:r.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}be.from=ye;function ue(q){switch(q.type){case"text":return{range:r.to(q.range),text:q.text};case"variable":return{range:r.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:r.to(q.range),expression:q.expression}}}be.to=ue})(Ge=e.InlineValue||(e.InlineValue={}));var Ie;(function(be){function ye(q){return{frameId:q.frameId,stoppedLocation:r.from(q.stoppedLocation)}}be.from=ye;function ue(q){return new l.InlineValueContext(q.frameId,r.to(q.stoppedLocation))}be.to=ue})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var _e;(function(be){function ye(q){return{range:r.from(q.range),kind:q.kind}}be.from=ye;function ue(q){return new l.DocumentHighlight(r.to(q.range),q.kind)}be.to=ue})(_e=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(be){function ye(ue){switch(ue){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}be.to=ye})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(be){function ye(ue){return{triggerKind:Ce.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}be.to=ye})(re=e.CompletionContext||(e.CompletionContext={}));var le;(function(be){function ye(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}be.from=ye;function ue(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}be.to=ue})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(be){const ye=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ue(Ue){return ye.get(Ue)??9}be.from=ue;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Ue){return q.get(Ue)??l.CompletionItemKind.Property}be.to=Ae})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(be){function ye(ue,q){const Ae=new l.CompletionItem(ue.label);return Ae.insertText=ue.insertText,Ae.kind=X.to(ue.kind),Ae.tags=ue.tags?.map(le.to),Ae.detail=ue.detail,Ae.documentation=g.isMarkdownString(ue.documentation)?U.to(ue.documentation):ue.documentation,Ae.sortText=ue.sortText,Ae.filterText=ue.filterText,Ae.preselect=ue.preselect,Ae.commitCharacters=ue.commitCharacters,v.Range.isIRange(ue.range)?Ae.range=r.to(ue.range):typeof ue.range=="object"&&(Ae.range={inserting:r.to(ue.range.insert),replacing:r.to(ue.range.replace)}),Ae.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Ae.insertText=new l.SnippetString(ue.insertText):(Ae.insertText=ue.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ue.additionalTextEdits.map(Ue=>K.to(Ue))),Ae.command=q&&ue.command?q.fromInternal(ue.command):void 0,Ae}be.to=ye})(G=e.CompletionItem||(e.CompletionItem={}));var T;(function(be){function ye(q){return{label:q.label,documentation:U.fromStrict(q.documentation)}}be.from=ye;function ue(q){return{label:q.label,documentation:g.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation}}be.to=ue})(T=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(be){function ye(q){return{label:q.label,documentation:U.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(T.from):[],activeParameter:q.activeParameter}}be.from=ye;function ue(q){return{label:q.label,documentation:g.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(T.to):[],activeParameter:q.activeParameter}}be.to=ue})(B=e.SignatureInformation||(e.SignatureInformation={}));var W;(function(be){function ye(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}be.from=ye;function ue(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}be.to=ue})(W=e.SignatureHelp||(e.SignatureHelp={}));var H;(function(be){function ye(ue,q){const Ae=new l.InlayHint(i.to(q.position),typeof q.label=="string"?q.label:q.label.map(ne.to.bind(void 0,ue)),q.kind&&he.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map(K.to),Ae.tooltip=g.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}be.to=ye})(H=e.InlayHint||(e.InlayHint={}));var ne;(function(be){function ye(ue,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=g.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,p.Command.is(q.command)&&(Ae.command=ue.fromInternal(q.command)),q.location&&(Ae.location=ve.to(q.location)),Ae}be.to=ye})(ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var he;(function(be){function ye(q){return q}be.from=ye;function ue(q){return q}be.to=ue})(he=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(be){function ye(q){return{range:r.from(q.range),url:q.target,tooltip:q.tooltip}}be.from=ye;function ue(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?O.URI.parse(q.url,!0):O.URI.revive(q.url)}catch{}return new l.DocumentLink(r.to(q.range),Ae)}be.to=ue})(Y=e.DocumentLink||(e.DocumentLink={}));var ge;(function(be){function ye(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Ue=>K.to(Ue))),Ae}be.to=ye;function ue(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>K.from(Ae)):void 0}}be.from=ue})(ge=e.ColorPresentation||(e.ColorPresentation={}));var pe;(function(be){function ye(q){return new l.Color(q[0],q[1],q[2],q[3])}be.to=ye;function ue(q){return[q.red,q.green,q.blue,q.alpha]}be.from=ue})(pe=e.Color||(e.Color={}));var Ne;(function(be){function ye(q){return{range:r.from(q.range)}}be.from=ye;function ue(q){return new l.SelectionRange(r.to(q.range))}be.to=ue})(Ne=e.SelectionRange||(e.SelectionRange={}));var xe;(function(be){function ye(ue){switch(ue){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}be.to=ye})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ke;(function(be){function ye(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}be.from=ye;function ue(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}be.to=ue})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var qe;(function(be){function ye(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}be.from=ye;function ue(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}be.to=ue})(qe=e.EndOfLine||(e.EndOfLine={}));var j;(function(be){function ye(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=ye})(j=e.ProgressLocation||(e.ProgressLocation={}));var Q;(function(be){function ye(ue){const q={start:ue.start+1,end:ue.end+1};return ue.kind&&(q.kind=me.from(ue.kind)),q}be.from=ye})(Q=e.FoldingRange||(e.FoldingRange={}));var me;(function(be){function ye(ue){if(ue)switch(ue){case l.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}be.from=ye})(me=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(be){function ye(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?r.from(ue.selection):void 0,override:typeof ue.override=="boolean"?b.EditorResolution.DISABLED:void 0}}be.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Be;(function(be){function ye(Ue){return Ue instanceof l.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:ue(Ue)||q(Ue)?new l.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}be.from=ye;function ue(Ue){const tt=Ue;return tt?O.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function q(Ue){const tt=Ue;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ae(Ue){return typeof Ue=="string"?Ue:new l.RelativePattern(O.URI.revive(Ue.baseUri),Ue.pattern)}be.to=Ae})(Be=e.GlobPattern||(e.GlobPattern={}));var Xe;(function(be){function ye(ue){if(ue){if(Array.isArray(ue))return ue.map(ye);if(typeof ue=="string")return ue;{const q=ue;return{language:q.language,scheme:q.scheme,pattern:Be.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}be.from=ye})(Xe=e.LanguageSelector||(e.LanguageSelector={}));var Ze;(function(be){function ye(q){return{start:q.start,end:q.end}}be.from=ye;function ue(q){return new l.NotebookRange(q.start,q.end)}be.to=ue})(Ze=e.NotebookRange||(e.NotebookRange={}));var rt;(function(be){function ye(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}be.to=ye;function ue(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}be.from=ue})(rt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(be){function ye(ue){if(ue===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(ue===d.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(ue===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ue}`)}be.to=ye})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(be){function ye(q){switch(q){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}be.from=ye;function ue(q){switch(q){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}be.to=ue})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var je;(function(be){function ye(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(let Ue of q.cells)l.NotebookCellData.validate(Ue),Ae.cells.push(lt.from(Ue));return Ae}be.from=ye;function ue(q){const Ae=new l.NotebookData(q.cells.map(lt.to));return(0,A.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}be.to=ue})(je=e.NotebookData||(e.NotebookData={}));var lt;(function(be){function ye(q){return{cellKind:Je.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:rt.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(It.from):[]}}be.from=ye;function ue(q){return new l.NotebookCellData(Je.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(It.to):void 0,q.metadata,q.internalMetadata?rt.to(q.internalMetadata):void 0)}be.to=ue})(lt=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(be){function ye(q){return{mime:q.mime,valueBytes:D.VSBuffer.wrap(q.data)}}be.from=ye;function ue(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}be.to=ue})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(be){function ye(q){return{outputId:q.id,items:q.items.map(st.from),metadata:q.metadata}}be.from=ye;function ue(q){const Ae=q.items.map(st.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}be.to=ue})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(be){function ye(Ae){return q(Ae)?{include:(0,A.withNullAsUndefined)(Be.from(Ae.include)),exclude:(0,A.withNullAsUndefined)(Be.from(Ae.exclude))}:(0,A.withNullAsUndefined)(Be.from(Ae))}be.from=ye;function ue(Ae){return q(Ae)?{include:Be.to(Ae.include),exclude:Be.to(Ae.exclude)}:Be.to(Ae)}be.to=ue;function q(Ae){const Ue=Ae;return Ue?!(0,A.isUndefinedOrNull)(Ue.include)&&!(0,A.isUndefinedOrNull)(Ue.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ht;(function(be){function ye(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?x.from(ue.top):void 0}}be.from=ye})(ht=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ut;(function(be){function ye(ue,q,Ae){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ue,Ae),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}be.from=ye})(Ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ft;(function(be){function ye(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}be.from=ye})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(be){function ye(q){return{uri:q.uri,provides:q.provides}}be.from=ye;function ue(q){return new l.NotebookRendererScript(O.URI.revive(q.uri),q.provides)}be.to=ue})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(be){function ye(q){return{message:U.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:r.from(q.location.range),uri:q.location.uri}}}be.from=ye;function ue(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:U.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?ve.to(q.location):void 0,Ae}be.to=ue})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(be){be.namespace=y.namespaceTestTag,be.denamespace=y.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Pt;(function(be){function ye(q){const Ae=(0,u.getPrivateApiFor)(q).controllerId;return{extId:c.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:O.URI.revive(q.uri),busy:!1,tags:q.tags.map(Ue=>Dt.namespace(Ae,Ue.id)),range:v.Range.lift(r.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&U.fromStrict(q.error)||null}}be.from=ye;function ue(q){return{parent:void 0,error:void 0,id:c.TestId.fromString(q.extId).localId,label:q.label,uri:O.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Ue}=Dt.denamespace(Ae);return new l.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:r.to(q.range||void 0),canResolveChildren:!1,busy:!1,description:q.description||void 0,sortText:q.sortText||void 0}}be.toPlain=ue})(Pt=e.TestItem||(e.TestItem={})),function(be){function ye(q){return{id:q.id}}be.from=ye;function ue(q){return new l.TestTag(q.id)}be.to=ue}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(be){const ye=(q,Ae)=>{const Ue={...Pt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.filter(Ve=>Ve.type===0).map(ft.to)})),children:q.children.map(tt=>Ae.get(tt)).filter(A.isDefined).map(tt=>ye(tt,Ae))};for(const tt of Ue.children)tt.parent=Ue;return Ue};function ue(q){const Ae=[],Ue=new Map;for(const tt of q.items)Ue.set(tt.item.extId,tt),q.request.targets.some(Ve=>Ve.controllerId===tt.controllerId&&Ve.testIds.includes(tt.item.extId))&&Ae.push(tt);return{completedAt:q.completedAt,results:Ae.map(tt=>ye(tt,Ue))}}be.to=ue})(Nt=e.TestResults||(e.TestResults={}));var He;(function(be){function ye(Ue){return{covered:Ue.covered,total:Ue.covered}}function ue(Ue){return"line"in Ue?i.from(Ue):r.from(Ue)}function q(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ue(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(tt=>({count:tt.executionCount,location:tt.location&&ue(tt.location)})):void 0}:{type:0,count:Ue.executionCount,location:ue(Ue.location)}}be.fromDetailed=q;function Ae(Ue){return{uri:Ue.uri,statement:ye(Ue.statementCoverage),branch:Ue.branchCoverage&&ye(Ue.branchCoverage),function:Ue.functionCoverage&&ye(Ue.functionCoverage),details:Ue.detailedCoverage?.map(q)}}be.fromFile=Ae})(He=e.TestCoverage||(e.TestCoverage={}));var $t;(function(be){function ye(ue){switch(ue){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}be.to=ye})($t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(be){function ye(q){const Ae=new l.TypeHierarchyItem(de.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),r.to(q.range),r.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}be.to=ye;function ue(q,Ae,Ue){if(Ae=Ae??q._sessionId,Ue=Ue??q._itemId,Ae===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ue,kind:de.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:r.from(q.range),selectionRange:r.from(q.selectionRange),tags:q.tags?.map(ae.from)}}be.from=ue})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(be){function ye(ue){if(!!ue)return{value:ue.value,tooltip:ue.tooltip}}be.from=ye})(Mt=e.ViewBadge||(e.ViewBadge={}))}),define(Se[173],De([1,0,2,12,6,8,234]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,O,v,p={timeout:1500,errors:3}){this._logService=A,this._documents=O,this._mainThreadBulkEdits=v,this._thresholds=p,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(O,v,p)=>{const f={dispose:this._callbacks.push([O,v,A])};return Array.isArray(p)&&p.push(f),f}}async $participateInSave(A,O){const v=a.URI.revive(A);let p=!1;const b=setTimeout(()=>p=!0,this._thresholds.timeout),f=[];try{for(let u of[...this._callbacks]){if(p)break;const d=this._documents.getDocument(v),c=await this._deliverEventAsyncAndBlameBadListeners(u,{document:d,reason:N.TextDocumentSaveReason.to(O)});f.push(c)}}finally{clearTimeout(b)}return f}_deliverEventAsyncAndBlameBadListeners([A,O,v],p){const b=this._badListeners.get(A);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(v,A,O,p).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const u=this._badListeners.get(A);this._badListeners.set(A,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,O,v,p){const b=[],f=Date.now(),{document:u,reason:d}=p,{version:c}=u,y=Object.freeze({document:u,reason:d,waitUntil(S){if(Object.isFrozen(b))throw(0,D.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(S))}});try{O.apply(v,[y])}catch(S){return Promise.reject(S)}return Object.freeze(b),new Promise((S,l)=>{const _=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(_),S(r)}).catch(r=>{clearTimeout(_),l(r)})}).then(S=>{const l={edits:[]};for(const _ of S)if(Array.isArray(_)&&_.every(r=>r instanceof g.TextEdit))for(const{newText:r,newEol:k,range:i}of _)l.edits.push({_type:2,resource:u.uri,edit:{range:i&&N.Range.from(i),text:r,eol:k&&N.EndOfLine.from(k)}});if(l.edits.length!==0)return c===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Se[174],De([1,0,11,2,8,6,87]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(v,p,b,f){this.start=v,this.deletedCount=p,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class w{constructor(v,p,b){this.notebook=v,this._extHostDocument=p,this._cellData=b,this.handle=b.handle,this.uri=D.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(g.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(v,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:v}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const v=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:g.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return v._mime},set mime(f){v._mime=f},get outputs(){return v._outputs.slice(0)},get metadata(){return v._metadata},get executionSummary(){return v._previousResult}};this._apiCell=Object.freeze(b)}return this._apiCell}setOutputs(v){this._outputs=v.map(g.NotebookCellOutput.to)}setOutputItems(v,p,b){const f=b.map(g.NotebookCellOutputItem.to),u=this._outputs.find(d=>d.id===v);u&&(p||(u.items.length=0),u.items.push(...f))}setMetadata(v){this._metadata=Object.freeze(v)}setInternalMetadata(v){this._internalMetadata=v,this._previousResult=Object.freeze(g.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.ExtHostCell=w;class A{constructor(v,p,b,f,u){this._proxy=v,this._textDocumentsAndEditors=p,this._textDocuments=b,this.uri=f,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0,void 0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const v=this,p={get uri(){return v.uri},get version(){return v._versionId},get notebookType(){return v._notebookType},get isDirty(){return v._isDirty},get isUntitled(){return v.uri.scheme===a.Schemas.untitled},get isClosed(){return v._disposed},get metadata(){return v._metadata},get cellCount(){return v._cells.length},cellAt(b){return b=v._validateIndex(b),v._cells[b].apiCell},getCells(b){return(b?v._getCells(b):v._cells).map(u=>u.apiCell)},save(){return v._save()}};this._notebook=Object.freeze(p)}return this._notebook}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(v){v.metadata&&(this._metadata=Object.freeze({...this._metadata,...v.metadata}))}acceptDirty(v){this._isDirty=v}acceptModelChanged(v,p,b){this._versionId=v.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},u=[];for(const c of v.rawEvents)c.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1,f.contentChanges):c.kind===I.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx,f.contentChanges):c.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(c.index,c.outputs),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems),u.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(c.index,c.language),u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document})):c.kind===I.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document}):c.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(c.index,c.metadata),u.push({cell:this._cells[c.index].apiCell,metadata:this._cells[c.index].apiCell.metadata})):c.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(c.index,c.internalMetadata),u.push({cell:this._cells[c.index].apiCell,executionSummary:this._cells[c.index].apiCell.executionSummary}));const d=new Map;for(let c=0;c<u.length;c++){const y=u[c],S=d.get(y.cell);if(S===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...y});d.set(y.cell,l-1)}else f.cellChanges[S]={...f.cellChanges[S],...y}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(v){return v=v|0,v<0?0:v>=this._cells.length?this._cells.length-1:v}_validateRange(v){let p=v.start|0,b=v.end|0;return p<0&&(p=0),b>this._cells.length&&(b=this._cells.length),v.with({start:p,end:b})}_getCells(v){v=this._validateRange(v);const p=[];for(let b=v.start;b<v.end;b++)p.push(this._cells[b]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(v,p,b){if(this._disposed)return;const f=[],u=[],d=[];if(v.reverse().forEach(c=>{const S=c[2].map(r=>{const k=new w(this,this._textDocumentsAndEditors,r);return p||u.push(w.asModelAddData(this.apiNotebook,r)),k}),l=new P(c[0],c[1],[],S),_=this._cells.splice(c[0],c[1],...S);for(const r of _)d.push(r.uri),l.deletedItems.push(r.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:d}),b)for(let c of f)b.push(c.asApiEvent())}_moveCell(v,p,b){const f=this._cells.splice(v,1);this._cells.splice(p,0,...f);const u=[new P(v,1,f.map(d=>d.apiCell),[]),new P(p,0,[],f)];for(const d of u)b.push(d.asApiEvent())}_setCellOutputs(v,p){this._cells[v].setOutputs(p)}_setCellOutputItems(v,p,b,f){this._cells[v].setOutputItems(p,b,f)}_changeCellLanguage(v,p){const b=this._cells[v];b.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(b.uri,p)}_changeCellMime(v,p){const b=this._cells[v];b.apiCell.mime=p}_changeCellMetadata(v,p){this._cells[v].setMetadata(p)}_changeCellInternalMetadata(v,p){this._cells[v].setInternalMetadata(p)}getCellFromApiCell(v){return this._cells.find(p=>p.apiCell===v)}getCellFromIndex(v){return this._cells[v]}getCell(v){return this._cells.find(p=>p.handle===v)}getCellIndex(v){return this._cells.indexOf(v)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Se[90],De([1,0,6,8,12]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(w){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=w}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(w){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:w})}replaceCellMetadata(w,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:w,metadata:A})}replaceCells(w,A,O){this._throwIfFinalized(),!(w===A&&O.length===0)&&this._collectedEdits.push({editType:1,index:w,count:A-w,cells:O.map(D.NotebookCellData.from)})}}class I{constructor(w,A,O,v,p,b){this.id=w,this._proxy=A,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._visibleRanges=v,this._viewColumn=b}get apiEditor(){if(!this._editor){const w=this;this._editor={get document(){return w.notebookData.apiNotebook},get selections(){return w._selections},set selections(A){if(!Array.isArray(A)||!A.every(a.NotebookRange.isNotebookRange))throw(0,g.illegalArgument)("selections");w._selections=A,w._trySetSelections(A)},get visibleRanges(){return w._visibleRanges},revealRange(A,O){w._proxy.$tryRevealRange(w.id,D.NotebookRange.from(A),O??a.NotebookEditorRevealType.Default)},get viewColumn(){return w._viewColumn},edit(A){const O=new N(this.document.version);return A(O),w._applyEdit(O.finalize())},setDecorations(A,O){return w.setDecorations(A,O)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(w){this._visible=w}_acceptVisibleRanges(w){this._visibleRanges=w}_acceptSelections(w){this._selections=w}_trySetSelections(w){this._proxy.$trySetSelections(this.id,w.map(D.NotebookRange.from))}_acceptViewColumn(w){this._viewColumn=w}_applyEdit(w){if(w.cellEdits.length===0)return Promise.resolve(!0);const A=[];let O=-1;for(let v=0;v<w.cellEdits.length;v++){if(O<0){A.push(w.cellEdits[v]),O++;continue}const b=A[O],f=w.cellEdits[v];if(b.editType===1&&f.editType===1&&b.index===f.index){b.cells.push(...w.cellEdits[v].cells),b.count+=w.cellEdits[v].count;continue}A.push(w.cellEdits[v]),O++}return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,A)}setDecorations(w,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(w.key)))return A.isEmpty?this._hasDecorationsForKey.delete(w.key):this._hasDecorationsForKey.add(w.key),this._proxy.$trySetDecorations(this.id,D.NotebookRange.from(A),w.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(Se[175],De([1,0,8,148,130,20,55,12]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,b,f){const u=this._handles++,{title:d,location:c,cancellable:y}=b,S={label:(0,g.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(u,{location:a.ProgressLocation.from(c),title:d,source:S,cancellable:y},p.isUnderDevelopment?void 0:p.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(u,f,!!y)}_withProgress(p,b,f){let u;f&&(u=new N.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,u));const d=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),u&&u.dispose()};let c;try{c=b(new O(this._proxy,p),f&&u?u.token:N.CancellationToken.None)}catch(y){throw d(p),y}return c.then(y=>d(p),y=>d(p)),c}$acceptProgressCanceled(p){const b=this._mapHandleToCancellationSource.get(p);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=w;function A(v,p){return v.message=p.message,typeof p.increment=="number"&&(typeof v.increment=="number"?v.increment+=p.increment:v.increment=p.increment),v}class O extends D.Progress{constructor(p,b){super(f=>this.throttledReport(f));this._proxy=p,this._handle=b}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}$e([(0,I.throttle)(100,(v,p)=>A(v,p),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Se[91],De([1,0,48,88,46,67,47,8,2]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const A=(S,l,_,r)=>{let k=l;return{enumerable:!0,configurable:!1,get(){return k},set(i){if(!_(k,i)){const s=k;k=i,S.listener?.(r(i,s))}}}},O=(S,l)=>S===l,v={range:(S,l)=>S===l?!0:!S||!l?!1:S.isEqual(l),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(S,l)=>!(S.length!==l.length||S.some(_=>!l.find(r=>_.id===r.id)))},p=S=>l=>({op:4,update:S(l)}),b=(S,l)=>({range:A(S,void 0,v.range,p(_=>({range:a.Range.lift(P.Range.from(_))}))),label:A(S,l,v.label,p(_=>({label:_}))),description:A(S,void 0,v.description,p(_=>({description:_}))),sortText:A(S,void 0,v.sortText,p(_=>({sortText:_}))),canResolveChildren:A(S,!1,v.canResolveChildren,_=>({op:2,state:_})),busy:A(S,!1,v.busy,p(_=>({busy:_}))),error:A(S,void 0,v.error,p(_=>({error:P.MarkdownString.fromStrict(_)||null}))),tags:A(S,[],v.tags,(_,r)=>({op:1,new:_.map(P.TestTag.from),old:r.map(P.TestTag.from)}))}),f=S=>{const l=g.TestId.fromString(S.extId),_=new d(l.controllerId,l.localId,S.label,w.URI.revive(S.uri)||void 0);return _.range=P.Range.to(S.range||void 0),_.description=S.description||void 0,_.sortText=S.sortText||void 0,_.tags=S.tags.map(r=>P.TestTag.to({id:(0,I.denamespaceTestTag)(r).tagId})),_},u=S=>{let l;for(const _ of S.tests){const r=f(_.item);(0,D.getPrivateApiFor)(r).parent=l,l=r}return l};e.toItemFromContext=u;class d{constructor(l,_,r,k){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const i=(0,D.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:k,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof c?void 0:i.parent}},children:{value:(0,N.createTestItemChildren)(i,D.getPrivateApiFor,d),enumerable:!0,writable:!1},...b(i,r)})}}e.TestItemImpl=d;class c extends d{constructor(l,_){super(l,l,_,void 0)}}e.TestItemRootImpl=c;class y extends N.TestItemCollection{constructor(l,_){super({controllerId:l,getApiFor:D.getPrivateApiFor,getChildren:r=>r.children,root:new c(l,_),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=y}),define(Se[92],De([1,0,41,12,56,8,6]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(p,b,f){const u=P._Keys.nextId();p.$registerTextEditorDecorationType(b.identifier,u,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:u,dispose(){p.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new g.IdGenerator("TextEditorDecorationType");class w{constructor(p,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,b){this._throwIfFinalized();let f=null;if(p instanceof I.Position)f=new I.Range(p,p);else if(p instanceof I.Range)f=p;else throw new Error("Unrecognized location");this._pushEdit(f,b,!1)}insert(p,b){this._throwIfFinalized(),this._pushEdit(new I.Range(p,p),b,!0)}delete(p){this._throwIfFinalized();let b=null;if(p instanceof I.Range)b=p;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(p,b,f){const u=this._document.validateRange(p);this._collectedEdits.push({range:u,text:b,forceMoveMarkers:f})}setEndOfLine(p){if(this._throwIfFinalized(),p!==I.EndOfLine.LF&&p!==I.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=w;class A{constructor(p,b,f,u){this._proxy=p,this._id=b,this._accept(f),this._logService=u;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(c){d._setTabSize(c)},get insertSpaces(){return d._insertSpaces},set insertSpaces(c){d._setInsertSpaces(c)},get cursorStyle(){return d._cursorStyle},set cursorStyle(c){d._setCursorStyle(c)},get lineNumbers(){return d._lineNumbers},set lineNumbers(c){d._setLineNumbers(c)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const b=Math.floor(p);return b>0?b:null}if(typeof p=="string"){const b=parseInt(p,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(p){const b=this._validateTabSize(p);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const b=this._validateInsertSpaces(p);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(p)})))}assign(p){const b={};let f=!1;if(typeof p.tabSize!="undefined"){const u=this._validateTabSize(p.tabSize);u==="auto"?(f=!0,b.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,f=!0,b.tabSize=u)}if(typeof p.insertSpaces!="undefined"){const u=this._validateInsertSpaces(p.insertSpaces);u==="auto"?(f=!0,b.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,f=!0,b.insertSpaces=u)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,f=!0,b.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(p.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(p,b){b.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=A;class O{constructor(p,b,f,u,d,c,y,S){this.id=p,this._proxy=b,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new A(this._proxy,this.id,c,f),this._visibleRanges=y,this._viewColumn=S;const l=this;this.value=Object.freeze({get document(){return u.getValue()},set document(_){throw(0,D.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(_){if(!(_ instanceof I.Selection))throw(0,D.illegalArgument)("selection");l._selections=[_],l._trySetSelection()},get selections(){return l._selections},set selections(_){if(!Array.isArray(_)||_.some(r=>!(r instanceof I.Selection)))throw(0,D.illegalArgument)("selections");l._selections=_,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(_){throw(0,D.readonly)("visibleRanges")},get options(){return l._options.value},set options(_){l._disposed||l._options.assign(_)},get viewColumn(){return l._viewColumn},set viewColumn(_){throw(0,D.readonly)("viewColumn")},edit(_,r={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const k=new w(u.getValue(),r);return _(k),l._applyEdit(k)},insertSnippet(_,r,k={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=l._selections.map(s=>N.Range.from(s));else if(r instanceof I.Position){const{lineNumber:s,column:n}=N.Position.from(r);i=[{startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n}]}else if(r instanceof I.Range)i=[N.Range.from(r)];else{i=[];for(const s of r)if(s instanceof I.Range)i.push(N.Range.from(s));else{const{lineNumber:n,column:t}=N.Position.from(s);i.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return b.$tryInsertSnippet(p,u.getValue().version,_.value,i,k)},setDecorations(_,r){const k=r.length===0;k&&!l._hasDecorationsForKey.has(_.key)||(k?l._hasDecorationsForKey.delete(_.key):l._hasDecorationsForKey.add(_.key),l._runOnProxy(()=>{if(N.isDecorationOptionsArr(r))return b.$trySetDecorations(p,_.key,N.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let s=0,n=r.length;s<n;s++){const t=r[s];i[4*s]=t.start.line+1,i[4*s+1]=t.start.character+1,i[4*s+2]=t.end.line+1,i[4*s+3]=t.end.character+1}return b.$trySetDecorationsFast(p,_.key,i)}}))},revealRange(_,r){l._runOnProxy(()=>b.$tryRevealRange(p,N.Range.from(_),r||I.TextEditorRevealType.Default))},show(_){b.$tryShowEditor(p,N.ViewColumn.from(_))},hide(){b.$tryHideEditor(p)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,a.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,a.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,a.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,a.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const b=p.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(d=>d.range);f.sort((d,c)=>d.end.line===c.end.line?d.end.character===c.end.character?d.start.line===c.start.line?d.start.character-c.start.character:d.start.line-c.start.line:d.end.character-c.end.character:d.end.line-c.end.line);for(let d=0,c=f.length-1;d<c;d++){const y=f[d].end;if(f[d+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=b.edits.map(d=>({range:N.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,u,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=O}),define(Se[176],De([1,0,3,144]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(D.IEnvironmentService)}),define(Se[177],De([1,0,26,5,17]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(O){this.removedDueToLooping=O}}e.DeltaExtensionsResult=N;class I{constructor(O){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=O,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const O of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(O.identifier))){console.error("Extension `"+O.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(O.identifier),O),this._extensionsArr.push(O),Array.isArray(O.activationEvents))for(let v of O.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(O.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(O)}}set(O){this._extensionDescriptions=O,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(O,v){O.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(O));const p=I._findLoopingExtensions(this._extensionDescriptions);if(v=v.concat(p.map(b=>b.identifier)),v.length>0){const b=new Set;v.forEach(f=>b.add(a.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!b.has(a.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new N(p)}static _findLoopingExtensions(O){const v=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,c){this.addNode(d),this.addNode(c),this._arcs.has(d)?this._arcs.get(d).push(c):this._arcs.set(d,[c])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,c){const y=v.getArcs(d);for(let S=0;S<y.length;S++)if(!c.has(y[S]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let d of O){const c=a.ExtensionIdentifier.toKey(d.identifier);if(p.set(c,d),d.extensionDependencies)for(let y of d.extensionDependencies){const S=a.ExtensionIdentifier.toKey(y);v.addArc(c,S)}}let b=new Set;v.getNodes().filter(d=>v.getArcs(d).length===0).forEach(d=>b.add(d));let f=v.getNodes().filter(d=>!b.has(d)),u;do{u=!1;for(let d=0;d<f.length;d++){const c=f[d];v.hasOnlyGoodArcs(c,b)&&(f.splice(d,1),d--,b.add(c),u=!0)}}while(u);return f.map(d=>p.get(d))}containsActivationEvent(O){return this._activationMap.has(O)}containsExtension(O){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(O))}getExtensionDescriptionsForActivationEvent(O){const v=this._activationMap.get(O);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(O){const v=this._extensionsMap.get(a.ExtensionIdentifier.toKey(O));return v||void 0}}e.ExtensionDescriptionRegistry=I;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function w(A,O){const v=A.isBuiltin?0:A.isUnderDevelopment?2:1,p=O.isBuiltin?0:O.isUnderDevelopment?2:1;if(v!==p)return v-p;const b=g.posix.basename(A.extensionLocation.path),f=g.posix.basename(O.extensionLocation.path);return b<f?-1:b>f?1:0}}),define(Se[93],De([1,0,25]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var D;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var g;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(g=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function I(w){const A=a.VSBuffer.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=I;function P(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=P}),define(Se[24],De([1,0,5,2,3,26,151]),function(Z,e,a,D,g,N,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class w{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class A{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=A;class O{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class v{constructor(t){this.dependency=t}}e.MissingExtensionDependency=v;var p;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(p=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,o){const m=[],h=[],C=[],F=[],U=c(this._allExtensions),R=c(t),E=(se,K)=>se.extensionLocation.toString()===K.extensionLocation.toString()||se.isBuiltin===K.isBuiltin||se.isUserBuiltin===K.isUserBuiltin||se.isUnderDevelopment===K.isUnderDevelopment;for(const se of this._allExtensions){const K=R.get(N.ExtensionIdentifier.toKey(se.identifier));if(!K){m.push(se.identifier),U.delete(N.ExtensionIdentifier.toKey(se.identifier));continue}if(!E(se,K)){m.push(se.identifier),U.delete(N.ExtensionIdentifier.toKey(se.identifier));continue}}for(const se of t){const K=U.get(N.ExtensionIdentifier.toKey(se.identifier));if(!K){h.push(se);continue}if(!E(K,se)){m.push(K.identifier),U.delete(N.ExtensionIdentifier.toKey(K.identifier));continue}}const x=d(this._myExtensions),z=d(o);for(const se of this._myExtensions)z.has(N.ExtensionIdentifier.toKey(se))||C.push(se);for(const se of o)x.has(N.ExtensionIdentifier.toKey(se))||F.push(se);const V={toRemove:m,toAdd:h,myToRemove:C,myToAdd:F};return this.delta(V),V}delta(t){const{toRemove:o,toAdd:m,myToRemove:h,myToAdd:C}=t,F=d(o),U=d(h);for(let R=0;R<this._allExtensions.length;R++)F.has(N.ExtensionIdentifier.toKey(this._allExtensions[R].identifier))&&(this._allExtensions.splice(R,1),R--);for(let R=0;R<this._myExtensions.length;R++)U.has(N.ExtensionIdentifier.toKey(this._myExtensions[R]))&&(this._myExtensions.splice(R,1),R--);for(const R of m)this._allExtensions.push(R);for(const R of C)this._myExtensions.push(R)}containsExtension(t){for(const o of this._myExtensions)if(N.ExtensionIdentifier.equals(o,t))return!0;return!1}}e.ExtensionHostExtensions=f;class u{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=N.ExtensionIdentifier.toKey,t)for(const o of t)this.add(o)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,o){this._map.forEach(m=>t.call(o,m,m,this))}*entries(){for(let[t,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=u;function d(n){const t=new Set;for(const o of n)t.add(N.ExtensionIdentifier.toKey(o));return t}e.extensionIdentifiersArrayToSet=d;function c(n){const t=new Map;for(const o of n)t.set(N.ExtensionIdentifier.toKey(o.identifier),o);return t}function y(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=y;function S(n,t){if(!y(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=S;class l{constructor(t,o,m,h){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=m,this.activationReason=h}}e.ActivationTimes=l;class _{constructor(t,o){this.description=t,this.value=o}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var r;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function k(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=k;function i(n,t){return{identifier:new N.ExtensionIdentifier((0,I.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=i;class s{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,o){return Promise.resolve(0)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,o){return Promise.resolve()}}e.NullExtensionService=s}),define(Se[178],De([1,0,12,26,24,13,14]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(d,c,y,S){this.startup=d,this.codeLoadingTime=c,this.activateCallTime=y,this.activateResolvedTime=S}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class w{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,c){return d===-1||c===-1?-1:c-d}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class A{constructor(d,c,y,S,l,_){this.activationFailed=d,this.activationFailedError=c,this.activationTimes=y,this.module=S,this.exports=l,this.subscriptions=_}}e.ActivatedExtension=A;class O extends A{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class v extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class p extends A{constructor(d){super(!0,d,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let b=class{constructor(d,c,y,S,l){this._logService=l,this._registry=d,this._resolvedExtensionsSet=new Set,c.forEach(_=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(_))),this._externalExtensionsMap=new Map,y.forEach(_=>this._externalExtensionsMap.set(D.ExtensionIdentifier.toKey(_),_)),this._host=S,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,c]of this._operations)c.dispose()}isActivated(d){const c=this._operations.get(D.ExtensionIdentifier.toKey(d));return Boolean(c&&c.value)}getActivatedExtension(d){const c=this._operations.get(D.ExtensionIdentifier.toKey(d));if(!c||!c.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return c.value}async activateByEvent(d,c){if(this._alreadyActivatedEvents[d])return;const y=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(y.map(S=>({id:S.identifier,reason:{startup:c,extensionId:S.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,c){const y=this._registry.getExtensionDescription(d);if(!y)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:y.identifier,reason:c}])}async _activateExtensions(d){const c=d.filter(y=>!this.isActivated(y.id)).map(y=>this._handleActivationRequest(y));await Promise.all(c.map(y=>y.wait()))}_handleActivationRequest(d){if(this._operations.has(D.ExtensionIdentifier.toKey(d.id)))return this._operations.get(D.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const c=this._registry.getExtensionDescription(d.id);if(!c){const l=new Error(`Cannot activate unknown extension '${d.id.value}'`),_=this._createAndSaveOperation(d,null,[],new p(l));return this._host.onExtensionActivationError(d.id,l,new g.MissingExtensionDependency(d.id.value)),_}const y=[],S=typeof c.extensionDependencies=="undefined"?[]:c.extensionDependencies;for(const l of S){if(this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(l)))continue;const _=this._operations.get(D.ExtensionIdentifier.toKey(l));if(_){y.push(_);continue}if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(l))){y.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(D.ExtensionIdentifier.toKey(l)),reason:d.reason}));continue}const r=this._registry.getExtensionDescription(l);if(r){if(!r.main&&!r.browser)continue;y.push(this._handleActivationRequest({id:r.identifier,reason:d.reason}));continue}const k=c.displayName||c.identifier.value,i=new Error(`Cannot activate the '${k}' extension because it depends on unknown extension '${l}'`),s=this._createAndSaveOperation(d,c.displayName,[],new p(i));return this._host.onExtensionActivationError(c.identifier,i,new g.MissingExtensionDependency(l)),s}return this._createAndSaveOperation(d,c.displayName,y,null)}_createAndSaveOperation(d,c,y,S){const l=new f(d.id,c,d.reason,y,S,this._host,this._logService);return this._operations.set(D.ExtensionIdentifier.toKey(d.id),l),l}};b=$e([ze(4,N.ILogService)],b),e.ExtensionsActivator=b;let f=class{constructor(d,c,y,S,l,_,r){this._id=d,this._displayName=c,this._reason=y,this._deps=S,this._value=l,this._host=_,this._logService=r,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const c=this._deps[d];if(c.value&&!c.value.activationFailed){this._deps.splice(d,1),d--;continue}if(c.value&&c.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);y.detail=c.value.activationFailedError,this._value=new p(y),this._host.onExtensionActivationError(this._id,y,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const c=new Error;if(d&&d.name&&(c.name=d.name),d&&d.message?c.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(c.stack=d.stack),this._value=new p(c),this._isDisposed&&a.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=$e([ze(6,N.ILogService)],f)}),define(Se[179],De([1,0,13,28,24]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends a.LogService{constructor(P,w){super(P.createLogger(w.logFile,{name:g.ExtensionHostLogFileName}))}};N=$e([ze(0,a.ILoggerService),ze(1,D.IExtHostInitDataService)],N),e.ExtHostLogService=N}),define(Se[180],De([1,0,12]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((N,I)=>{this._actualOk=N,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(N){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=N,this._actual&&this._actualOk(N))}resolveErr(N){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=N,this._actual?this._actualErr(N):(0,a.onUnexpectedError)(N))}then(N,I){return this._ensureActual().then(N,I)}catch(N){return this._ensureActual().then(void 0,N)}finally(N){return this._ensureActual().finally(N)}}e.LazyPromise=D}),define(Se[39],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const D=[];function g(P){const w=new a(P);return D[w.nid]=w,w}e.createProxyIdentifier=g;function N(P){return D[P].sid}e.getStringIdentifierForProxy=N;class I{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=I}),define(Se[4],De([1,0,57,2,39]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(N=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(S){S[S.UnknownInput=0]="UnknownInput",S[S.TextInput=1]="TextInput",S[S.TextDiffInput=2]="TextDiffInput",S[S.NotebookInput=3]="NotebookInput",S[S.NotebookDiffInput=4]="NotebookDiffInput",S[S.CustomEditorInput=5]="CustomEditorInput",S[S.WebviewEditorInput=6]="WebviewEditorInput",S[S.TerminalEditorInput=7]="TerminalEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(S){S[S.TAB_OPEN=0]="TAB_OPEN",S[S.TAB_CLOSE=1]="TAB_CLOSE",S[S.TAB_UPDATE=2]="TAB_UPDATE",S[S.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var w;(function(S){S[S.Editable=0]="Editable",S[S.SupportsHotExit=1]="SupportsHotExit"})(w=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(S){S[S.Int8Array=1]="Int8Array",S[S.Uint8Array=2]="Uint8Array",S[S.Uint8ClampedArray=3]="Uint8ClampedArray",S[S.Int16Array=4]="Int16Array",S[S.Uint16Array=5]="Uint16Array",S[S.Int32Array=6]="Int32Array",S[S.Uint32Array=7]="Uint32Array",S[S.Float32Array=8]="Float32Array",S[S.Float64Array=9]="Float64Array",S[S.BigInt64Array=10]="BigInt64Array",S[S.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var O;(function(S){S[S.Text=1]="Text",S[S.Error=2]="Error",S[S.Rich=3]="Rich"})(O=e.CellOutputKind||(e.CellOutputKind={}));var v;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(v=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var p;(function(S){S[S.None=0]="None",S[S.Process=1]="Process",S[S.Output=2]="Output"})(p=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(l){return l._id=b._n++,l}}e.IdObject=b,b._n=0;var f;(function(S){S.label="a",S.kind="b",S.detail="c",S.documentation="d",S.sortText="e",S.filterText="f",S.preselect="g",S.insertText="h",S.insertTextRules="i",S.range="j",S.commitCharacters="k",S.additionalTextEdits="l",S.command="m",S.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(S){S.defaultRanges="a",S.completions="b",S.isIncomplete="c",S.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(S){S[S.File=1]="File",S[S.Text=2]="Text",S[S.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function c(S){if(S&&S.edits)for(const l of S.edits)typeof l.resource=="object"?l.resource=D.URI.revive(l.resource):(l.newUri=D.URI.revive(l.newUri),l.oldUri=D.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,a.revive)(l.metadata));return S}e.reviveWorkspaceEditDto=c;var y;(function(S){S[S.Workspace=0]="Workspace",S[S.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,g.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,g.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,g.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,g.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,g.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,g.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,g.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,g.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,g.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,g.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,g.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,g.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,g.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,g.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,g.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,g.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,g.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,g.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,g.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,g.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,g.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,g.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,g.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,g.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,g.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,g.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,g.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,g.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookProxyKernels:(0,g.createProxyIdentifier)("MainThreadNotebookProxyKernels"),MainThreadNotebookRenderers:(0,g.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,g.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,g.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,g.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,g.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,g.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,g.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,g.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,g.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,g.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,g.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,g.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,g.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,g.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,g.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,g.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,g.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,g.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,g.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,g.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,g.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,g.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,g.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,g.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,g.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,g.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,g.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,g.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,g.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookProxyKernels:(0,g.createProxyIdentifier)("ExtHostNotebookProxyKernels"),ExtHostNotebookRenderers:(0,g.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,g.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,g.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,g.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,g.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,g.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,g.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,g.createProxyIdentifier)("ExtHostTelemetry")}}),define(Se[69],De([1,0,4,5,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(P){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,w){return this._proxy.$getPassword(P,w)}store(P,w,A){return this._proxy.$setPassword(P,w,A)}delete(P,w){return this._proxy.$deletePassword(P,w)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,g.createDecorator)("IExtHostSecretState")}),define(Se[70],De([1,0,3,13,4,16]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(w,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(g.MainContext.MainThreadTelemetry)}report(w,A,O){const v=this.getUsageKey(w,A);this._reportedUsages.has(v)||(this._reportedUsages.add(v),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:w}))}getUsageKey(w,A){return`${w}-${A.identifier.value}`}};I=$e([ze(0,N.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(P,w,A){}})}),define(Se[181],De([1,0,5,4,6,26]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,A,O,v={}){const p=N.ExtensionIdentifier.toKey(w.identifier),b=this._inFlightRequests.get(p)||[],f=[...O].sort().join(" ");let u=b.find(d=>d.scopes===f);if(u)return u.result;{const d=this._getSession(w,p,A,O,v);u={scopes:f,result:d},b.push(u),this._inFlightRequests.set(p,b);try{await d}finally{const c=b.findIndex(y=>y.scopes===f);c>-1&&(b.splice(c),this._inFlightRequests.set(p,b))}return d}}async _getSession(w,A,O,v,p={}){await this._proxy.$ensureProvider(O);const b=w.displayName||w.name;return this._proxy.$getSession(O,v,A,b,p)}async removeSession(w,A){const O=this._authenticationProviders.get(w);return O?O.provider.removeSession(A):this._proxy.$removeSession(w,A)}registerAuthenticationProvider(w,A,O,v){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:A,provider:O,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===w)||this._providers.push({id:w,label:A});const p=O.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,A,v?.supportsMultipleAccounts??!1),new g.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(w);const b=this._providers.findIndex(f=>f.id===w);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const O=this._authenticationProviders.get(w);if(O)return Promise.resolve(O.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this._onDidChangeSessions.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Se[182],De([1,0,4,16,8]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(P,w){this._proxy=P.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:A=>w.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P){const w=g.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(w)}};N=$e([ze(0,D.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Se[183],De([1,0,4]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(N){const I=N.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(P){return I.$writeText(P)}})}}e.ExtHostClipboard=D});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[36],De([1,0,10,6,8,27,4,15,13,57,48,235,2,7,3,16,91,25,39,43]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S){"use strict";var l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(o,m){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,_.set(this,void 0),Qe(this,l,o.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=m,Qe(this,_,o.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new k(this,h=>{const C=this._apiCommands.get(h);return C?.result===s.Void?C:void 0},m),this._argumentProcessors=[{processArgument(h){return(0,A.revive)(h)}},{processArgument(h){return(0,N.cloneAndChange)(h,function(C){if(O.Range.isIRange(C))return g.Range.to(C);if(v.Position.isIPosition(C))return g.Position.to(C);if(O.Range.isIRange(C.range)&&p.URI.isUri(C.uri))return g.location.to(C);if(C instanceof c.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const m=this.registerCommand(!1,o.id,async(...h)=>{const C=o.args.map((U,R)=>{if(!U.validate(h[R]))throw new Error(`Invalid argument '${U.name}' when running '${o.id}', received: ${h[R]}`);return U.convert(h[R])}),F=await this.executeCommand(o.internalId,...C);return o.result.convert(F,h,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new D.Disposable(()=>{m.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,m,h,C,F,U){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:h,thisArg:C,description:F,extension:U}),o&&Re(this,l,"f").$registerCommand(m),new D.Disposable(()=>{this._commands.delete(m)&&o&&Re(this,l,"f").$unregisterCommand(m)})}executeCommand(o,...m){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,m,!0)}async _doExecuteCommand(o,m,h){if(this._commands.has(o))return this._executeContributedCommand(o,m,!1);{let C=!1;const F=(0,N.cloneAndChange)(m,function(U){if(U instanceof D.Position)return g.Position.from(U);if(U instanceof D.Range)return g.Range.from(U);if(U instanceof D.Location)return g.location.from(U);if(D.NotebookRange.isNotebookRange(U))return g.NotebookRange.from(U);if(U instanceof ArrayBuffer)return C=!0,c.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return C=!0,c.VSBuffer.wrap(U);if(U instanceof c.VSBuffer)return C=!0,U;if(!Array.isArray(U))return U});try{const U=await Re(this,l,"f").$executeCommand(o,C?new y.SerializableObjectWithBuffers(F):F,h);return(0,A.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this._doExecuteCommand(o,m,!1);throw U}}}async _executeContributedCommand(o,m,h){const C=this._commands.get(o);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,o);let{callback:F,thisArg:U,description:R}=C;if(R)for(let E=0;E<R.args.length;E++)try{(0,a.validateConstraint)(m[E],R.args[E].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${R.args[E].name}' - ${R.args[E].description}`)}try{return await F.apply(U,m)}catch(E){if(o===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...m);x&&(o=x.command)}throw this._logService.error(E,o,C.extension?.identifier),h?new class extends Error{constructor(){super((0,S.toErrorMessage)(E));this.id=o,this.source=C.extension?.displayName??C.extension?.name}}:E}}_reportTelemetry(o,m){!o.extension||o.extension.isBuiltin||Re(this,_,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:m})}$executeContributedCommand(o,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(m=m.map(h=>this._argumentProcessors.reduce((C,F)=>F.processArgument(C),h)),this._executeContributedCommand(o,m,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Re(this,l,"f").$getCommands().then(m=>(o&&(m=m.filter(h=>h[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[m,h]of this._commands){let{description:C}=h;C&&(o[m]=C)}return Promise.resolve(o)}};l=new WeakMap,_=new WeakMap,r=$e([ze(0,u.IExtHostRpcService),ze(1,w.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class k{constructor(o,m,h){this._commands=o,this._lookupApiCommand=m,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,m){if(!o)return;const h={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return h;const C=this._lookupApiCommand(o.command);if(C)h.id=C.internalId,h.arguments=C.args.map((F,U)=>F.convert(o.arguments&&o.arguments[U]));else if((0,P.isNonEmptyArray)(o.arguments)){const F=++this._cachIdPool;this._cache.set(F,o),m.add((0,b.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),h.$ident=F,h.id=this.delegatingCommandId,h.arguments=[F],this._logService.trace("CommandsConverter#CREATE",o.command,F)}return h}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const m=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=k;class i{constructor(o,m,h,C){this.name=o,this.description=m,this.validate=h,this.convert=C}optional(){return new i(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,m){return new i(o??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>p.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>D.Position.isPosition(t),g.Position.from),i.Range=new i("range","A range in a text document",t=>D.Range.isRange(t),g.Range.from),i.Selection=new i("selection","A selection in a text document",t=>D.Selection.isSelection(t),g.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof D.CallHierarchyItem,g.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof D.TypeHierarchyItem,g.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,g.TestItem.from);class s{constructor(o,m){this.description=o,this.convert=m}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class n{constructor(o,m,h,C,F){this.id=o,this.internalId=m,this.description=h,this.args=C,this.result=F}}e.ApiCommand=n}),define(Se[184],De([1,0,2,8,6,68,36,15,77,80,11]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(D.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,d)=>{if((0,P.isFalsyOrEmpty)(u))return;class c extends g.SymbolInformation{static to(S){const l=new c(S.name,D.SymbolKind.to(S.kind),S.containerName||"",new g.Location(d[0],D.Range.to(S.range)));return l.detail=S.detail,l.range=l.location.range,l.selectionRange=D.Range.to(S.selectionRange),l.children=S.children?S.children.map(c.to):[],l}}return u.map(c.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(D.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(D.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new I.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(D.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(D.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(D.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(d=>g.Position.isPosition(d)),u=>u.map(D.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(d=>{let c;for(const y of d.reverse())c=new g.SelectionRange(D.Range.to(y),c);return c}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(D.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(D.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:D.Range.to(u.range),placeholder:u.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return D.WorkspaceEdit.to(u)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(D.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const d=(0,w.decodeSemanticTokensDto)(u);if(d.type==="full")return new g.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new g.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const d=(0,w.decodeSemanticTokensDto)(u);if(d.type==="full")return new g.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,d,c)=>{if(!u)return new g.CompletionList([]);const y=u.suggestions.map(S=>D.CompletionItem.to(S,c));return new g.CompletionList(y,u.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return D.SignatureHelp.to(u)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,d,c)=>b(y=>new g.CodeLens(D.Range.to(y.range),y.command&&c.fromInternal(y.command)))(u))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>g.Range.isRange(u),u=>g.Selection.isSelection(u)?D.Selection.from(u):D.Range.from(u)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,d,c)=>b(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(y.command)}else{const S=new g.CodeAction(y.title,y.kind?new g.CodeActionKind(y.kind):void 0);return y.edit&&(S.edit=D.WorkspaceEdit.to(y.edit)),y.command&&(S.command=c.fromInternal(y.command)),S.isPreferred=y.isPreferred,S}})(u))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(d=>new g.ColorInformation(D.Range.to(d.range),D.Color.to(d.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",u=>u instanceof g.Color,D.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:D.Range.from(u.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(D.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,d,c)=>u.map(D.InlayHint.to.bind(void 0,c)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(d=>D.NotebookExclusiveDocumentPattern.to(d))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(D.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>a.URI.isUri(u)||typeof u=="string"&&(0,A.matchesSomeScheme)(u,O.Schemas.http,O.Schemas.https),u=>u),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[D.ViewColumn.from(u),void 0]:[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[D.ViewColumn.from(u),void 0]:[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[D.ViewColumn.from(u.viewColumn),D.TextEditorOpenOptions.from(u)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(D.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class p{static register(d){v.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=p;function b(u){return d=>{if(Array.isArray(d))return d.map(u)}}function f(u){if(!Array.isArray(u))return;const d=[];for(const c of u)N.isLocationLink(c)?d.push(D.DefinitionLink.to(c)):d.push(D.location.to(c));return d}}),define(Se[185],De([1,0,14,55,5,7,2,68,26,8,6,24,4]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(f,u,d){const c=f.getProxy(p.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const o=this._commentControllers.get(t.handle);return o?o.value:t}else if(t&&t.$mid===7){const o=this._commentControllers.get(t.commentControlHandle);if(!o)return t;const m=o.getCommentThread(t.commentThreadHandle);return m?m.value:t}else if(t&&t.$mid===8){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const m=o.getCommentThread(t.thread.commentThreadHandle);return m?{thread:m.value,text:t.text}:t}else if(t&&t.$mid===9){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const m=o.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let h=t.commentUniqueId,C=m.getCommentByUniqueId(h);return C||t}else if(t&&t.$mid===10){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const m=o.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let h=t.text,C=t.commentUniqueId,F=m.getCommentByUniqueId(C);return F?(F.body=h,F):t}return t}})}createCommentController(t,o,m){const h=y.handlePool++,C=new l(t,h,o,m);this._commentControllers.set(C.handle,C);const F=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(t.identifier))||[];return F.push(C),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(t.identifier),F),C.value}$createCommentThreadTemplate(t,o,m){const h=this._commentControllers.get(t);!h||h.$createCommentThreadTemplate(o,m)}async $updateCommentThreadTemplate(t,o,m){const h=this._commentControllers.get(t);!h||h.$updateCommentThreadTemplate(o,m)}$deleteCommentThread(t,o){const m=this._commentControllers.get(t);m&&m.$deleteCommentThread(o)}$provideCommentingRanges(t,o,m){const h=this._commentControllers.get(t);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const C=d.getDocument(I.URI.revive(o));return(0,a.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(C,m)).then(F=>F?F.map(U=>A.Range.from(U)):void 0)}$toggleReaction(t,o,m,h,C){const F=this._commentControllers.get(t);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const U=F.getCommentThread(o);if(U){const R=U.getCommentByUniqueId(h.uniqueIdInThread);if(F!==void 0&&R&&F.reactionHandler)return F.reactionHandler(R,k(C))}return Promise.resolve(void 0)})}dispose(){}}y.handlePool=0;class S{constructor(t,o,m,h,C,F,U,R){this._commentControllerHandle=o,this._id=m,this._uri=h,this._range=C,this._comments=F,this.extensionDescription=U,this._isTemplate=R,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new g.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),c.$createCommentThread(o,this.handle,this._id,this._uri,A.Range.from(this._range),U.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(o,this.handle)}});const E=this;this.value={get uri(){return E.uri},get range(){return E.range},set range(x){E.range=x},get comments(){return E.comments},set comments(x){E.comments=x},get collapsibleState(){return E.collapsibleState},set collapsibleState(x){E.collapsibleState=x},get canReply(){return E.canReply},set canReply(x){E.canReply=x},get contextValue(){return E.contextValue},set contextValue(x){E.contextValue=x},get label(){return E.label},set label(x){E.label=x},get state(){return E.state},set state(x){E.state=x},dispose:()=>{E.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,v.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,v.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const t=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),o={};t("range")&&(o.range=A.Range.from(this._range)),t("label")&&(o.label=this.label),t("contextValue")&&(o.contextValue=this.contextValue??null),t("comments")&&(o.comments=this._comments.map(m=>_(this,m,this._commentsMap))),t("collapsibleState")&&(o.collapseState=i(this._collapseState)),t("canReply")&&(o.canReply=this.canReply),t("state")&&(o.state=s(this._state)),t("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(t){for(let o of this._commentsMap){let m=o[0],h=o[1];if(t===h)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}S._handlePool=0,$e([(0,D.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,o,m,h){this._extension=t,this._handle=o,this._id=m,this._label=h,this._threads=new Map,c.$registerCommentController(this.handle,m,h);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(F){C.options=F},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(F){C.commentingRangeProvider=F},get reactionHandler(){return C.reactionHandler},set reactionHandler(F){C.reactionHandler=F},createCommentThread(F,U,R){return C.createCommentThread(F,U,R).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,o,m,h){if(typeof t=="string"){const C=new S(this.id,this.handle,t,o,m,h,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new S(this.id,this.handle,void 0,t,o,m,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(t,o){const m=new S(this.id,this.handle,void 0,I.URI.revive(t),A.Range.to(o),[],this._extension,!0);return m.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(t,o){let m=this._threads.get(t);m&&(m.range=A.Range.to(o))}$deleteCommentThread(t){let o=this._threads.get(t);o&&o.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function _(n,t,o){let m=o.get(t);m||(m=++n.commentHandle,o.set(t,m));const h=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:m,body:typeof t.body=="string"?t.body:A.MarkdownString.from(t.body),userName:t.author.name,userIconPath:h,label:t.label,commentReactions:t.reactions?t.reactions.map(C=>r(C)):void 0,timestamp:t.timestamp?.toJSON()}}function r(n){return{label:n.label,iconPath:n.iconPath?A.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function k(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?I.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function i(n){if(n!==void 0)switch(n){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function s(n){if(n!==void 0)switch(n){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new y}e.createExtHostComments=b}),define(Se[94],De([1,0,2,4,6,3,16,13,15,9,17]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Ii{constructor(b,f){this._logService=f,this._provider=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,f){const u=Ii._handlePool++;this._provider.set(u,{provider:b,extensionId:f}),this._proxy.$registerDecorationProvider(u,f.value);const d=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(u,null);return}let y=(0,w.asArray)(c);if(y.length<=Ii._maxEventSize){this._proxy.$onDidChange(u,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,y.length);const S=y.map(r=>({uri:r,rank:(0,A.count)(r.path,"/")})),l=(0,w.groupBy)(S,(r,k)=>r.rank-k.rank||(0,A.compare)(r.uri.path,k.uri.path));let _=[];e:for(let r of l){let k;for(let i of r){let s=(0,O.dirname)(i.uri.path);if(k!==s&&(k=s,_.push(i.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(u,_)});return new g.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(b,f,u){if(!this._provider.has(b))return Object.create(null);const d=Object.create(null),{provider:c,extensionId:y}=this._provider.get(b);return await Promise.all(f.map(async S=>{try{const{uri:l,id:_}=S,r=await Promise.resolve(c.provideFileDecoration(a.URI.revive(l),u));if(!r)return;try{g.FileDecoration.validate(r),d[_]=[r.propagate,r.tooltip,r.badge,r.color]}catch(k){this._logService.warn(`INVALID decoration from extension '${y.value}': ${k}`)}}catch(l){this._logService.error(l)}})),d}};v._handlePool=0,v._maxEventSize=250,v=$e([ze(0,I.IExtHostRpcService),ze(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[186],De([1,0,128,79,2,4,6,8,5,13,21,35]),function(Z,e,a,D,g,N,I,P,w,A,O,v){"use strict";var p,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(y,S,l,_,r,k){this._name=y,this._owner=S,this._maxDiagnosticsPerFile=l,p.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Qe(this,f,new O.ResourceMap(i=>_.getComparisonKey(i)),"f"),Qe(this,p,r,"f"),Qe(this,b,k,"f")}dispose(){this._isDisposed||(Re(this,b,"f").fire([...Re(this,f,"f").keys()]),Re(this,p,"f")&&Re(this,p,"f").$clear(this._owner),Re(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,S){if(!y){this.clear();return}this._checkDisposed();let l=[];if(g.URI.isUri(y)){if(!S){this.delete(y);return}Re(this,f,"f").set(y,S.slice()),l=[y]}else if(Array.isArray(y)){l=[];let r;y=[...y].sort(u._compareIndexedTuplesByUri);for(const k of y){const[i,s]=k;if((!r||i.toString()!==r.toString())&&(r&&Re(this,f,"f").get(r).length===0&&Re(this,f,"f").delete(r),r=i,l.push(i),Re(this,f,"f").set(i,[])),s){const n=Re(this,f,"f").get(i);n&&n.push(...s)}else{const n=Re(this,f,"f").get(i);n&&(n.length=0)}}}if(Re(this,b,"f").fire(l),!Re(this,p,"f"))return;const _=[];for(let r of l){let k=[];const i=Re(this,f,"f").get(r);if(i)if(i.length>this._maxDiagnosticsPerFile){k=[];const s=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of i)if(t.severity===s[n]&&k.push(P.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;k.push({severity:D.MarkerSeverity.Info,message:(0,a.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:k[k.length-1].startLineNumber,startColumn:k[k.length-1].startColumn,endLineNumber:k[k.length-1].endLineNumber,endColumn:k[k.length-1].endColumn})}else k=i.map(s=>P.Diagnostic.from(s));_.push([r,k])}Re(this,p,"f").$changeMany(this._owner,_)}delete(y){this._checkDisposed(),Re(this,b,"f").fire([y]),Re(this,f,"f").delete(y),Re(this,p,"f")&&Re(this,p,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Re(this,b,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,p,"f")&&Re(this,p,"f").$clear(this._owner)}forEach(y,S){this._checkDisposed();for(let l of Re(this,f,"f").keys())y.apply(S,[l,this.get(l),this])}get(y){this._checkDisposed();const S=Re(this,f,"f").get(y);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Re(this,f,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,S){return y[0].toString()<S[0].toString()?-1:y[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=u,p=new WeakMap,b=new WeakMap,f=new WeakMap;let d=class li{constructor(y,S,l){this._logService=S,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=y.getProxy(N.MainContext.MainThreadDiagnostics)}static _mapper(y){const S=new O.ResourceMap;for(const l of y)S.set(l,l);return{uris:Object.freeze(Array.from(S.values()))}}createDiagnosticCollection(y,S){const{_collections:l,_proxy:_,_onDidChangeDiagnostics:r,_logService:k,_fileSystemInfoService:i}=this,s=new class{$changeMany(o,m){_.$changeMany(o,m),k.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,o,m.length===0?"CLEARING":m)}$clear(o){_.$clear(o),k.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,o)}dispose(){_.dispose()}};let n;if(!S)S="_generated_diagnostic_collection_name_#"+li._idPool++,n=S;else if(!l.has(S))n=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do n=S+li._idPool++;while(l.has(n))}return new class extends u{constructor(){super(S,n,li._maxDiagnosticsPerFile,i.extUri,s,r);l.set(n,this)}dispose(){super.dispose(),l.delete(n)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const S=new Map,l=[];for(const _ of this._collections.values())_.forEach((r,k)=>{let i=S.get(r.toString());typeof i=="undefined"&&(i=l.length,S.set(r.toString(),i),l.push([r,[]])),l[i][1]=l[i][1].concat(...k)});return l}}_getDiagnostics(y){let S=[];for(let l of this._collections.values())l.has(y)&&(S=S.concat(l.get(y)));return S}$acceptMarkersChange(y){if(!this._mirrorCollection){const S="_generated_mirror",l=new u(S,S,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,l),this._mirrorCollection=l}for(const[S,l]of y)this._mirrorCollection.set(g.URI.revive(S),l.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=$e([ze(1,A.ILogService),ze(2,v.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Se[187],De([1,0,2,4]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class g{constructor(I){this._proxy=I.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(P=>P?P.map(w=>a.URI.revive(w)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=g}),define(Se[188],De([1,0,12,2,6,4,11,20,9]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(v,p,b){this._documentsAndEditors=p,this._logService=b,this._documentContentProviders=new Map,this._proxy=v.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,p){if(Object.keys(I.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const b=A._handlePool++;this._documentContentProviders.set(b,p),this._proxy.$registerTextContentProvider(b,v);let f;return typeof p.onDidChange=="function"&&(f=p.onDidChange(u=>{if(u.scheme!==v){this._logService.warn(`Provider for scheme '${v}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(b,u).then(d=>{if(!d&&typeof d!="string")return;const c=this._documentsAndEditors.getDocument(u);if(!c)return;const y=(0,w.splitLines)(d);if(!c.equalLines(y))return this._proxy.$onVirtualDocumentChange(u,d)},a.onUnexpectedError)})),new g.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(v,p){const b=this._documentContentProviders.get(v);return b?Promise.resolve(b.provideTextDocumentContent(D.URI.revive(p),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(Se[189],De([1,0,5,7,2,4,85,8,10,27,6]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(b,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const d of u)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const d of u)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const f=this._documentsAndEditors.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this._documentsAndEditors.getDocument(b);if(f)return Promise.resolve(f);let u=this._documentLoader.get(b.toString());return u||(u=this._proxy.$tryOpenDocument(b).then(d=>{this._documentLoader.delete(b.toString());const c=g.URI.revive(d);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(c))},d=>(this._documentLoader.delete(b.toString()),Promise.reject(d))),this._documentLoader.set(b.toString(),u)),u}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(f=>g.URI.revive(f))}$acceptModelLanguageChanged(b,f){const u=g.URI.revive(b),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(b){const f=g.URI.revive(b),u=this._documentsAndEditors.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(b,f){const u=g.URI.revive(b),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,u){const d=g.URI.revive(b),c=this._documentsAndEditors.getDocument(d);if(!c)throw new Error("unknown document");c._acceptIsDirty(u),c.onEvents(f);let y;f.isUndoing?y=O.TextDocumentChangeReason.Undo:f.isRedoing&&(y=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:c.document,contentChanges:f.changes.map(S=>({range:P.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:y}))}setWordDefinitionFor(b,f){(0,I.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=v}),define(Se[49],De([1,0,41,5,7,2,3,4,85,16,92,8,13,21,11,167,190]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class c{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(l,_){this._extHostRpc=l,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const _=[],r=[],k=[];if(l.removedDocuments)for(const i of l.removedDocuments){const s=N.URI.revive(i),n=this._documents.get(s);n?.unref()&&(this._documents.delete(s),_.push(n.value))}if(l.addedDocuments)for(const i of l.addedDocuments){const s=N.URI.revive(i.uri);let n=this._documents.get(s);if(n&&s.scheme!==f.Schemas.vscodeNotebookCell&&s.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);n||(n=new c(new w.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),s,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(s,n),r.push(n.value)),n.ref()}if(l.removedEditors)for(const i of l.removedEditors){const s=this._editors.get(i);this._editors.delete(i),s&&k.push(s)}if(l.addedEditors)for(const i of l.addedEditors){const s=N.URI.revive(i.documentUri);a.ok(this._documents.has(s),`document '${s}' does not exist`),a.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const n=this._documents.get(s).value,t=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>n.document),i.selections.map(v.Selection.to),i.options,i.visibleRanges.map(o=>v.Range.to(o)),typeof i.editorPosition=="number"?v.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}l.newActiveEditor!==void 0&&(a.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,g.dispose)(_),(0,g.dispose)(k),l.removedDocuments&&this._onDidRemoveDocuments.fire(_),l.addedDocuments&&this._onDidAddDocuments.fire(r),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return l?_:_?.value}allEditors(){return[...this._editors.values()]}};y=$e([ze(0,A.IExtHostRpcService),ze(1,p.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[50],De([1,0,8,4,2,5,3,6,16,10,54]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class v{constructor(d,c,y){this._activeTabIdGetter=y,this._parentGroup=c,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,c={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(c)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(g.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified));case 5:return new P.CustomEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new P.NotebookEditorTabInput(g.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new P.NotebookDiffEditorTabInput(g.URI.revive(this._dto.input.original),g.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new P.TerminalEditorTabInput;default:return}}}class p{constructor(d,c,y){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=y;for(const S of d.tabs)S.isActive&&(this._activeTabId=S.id),this._tabs.push(new v(S,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,c={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(y=>y.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(y=>y.apiObject))}};this._apiObject=Object.freeze(c)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const y=new v(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,y),d.tabDto.isActive&&(this._activeTabId=y.tabId),y}else if(d.kind===1){const y=this._tabs.splice(d.index,1)[0];if(!y)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return y.tabId===this._activeTabId&&(this._activeTabId=""),y}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const y=this._tabs.splice(d.oldIndex,1)[0];if(!y)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,y),y}const c=this._tabs.find(y=>y.tabId===d.tabDto.id);if(!c)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),c.acceptDtoUpdate(d.tabDto),c}activeTabId(){return this._activeTabId}}let b=class{constructor(d){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(D.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,c={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(y=>y.apiObject))},get activeTabGroup(){const y=d._activeGroupId;return(0,A.assertIsDefined)(d._extHostTabGroups.find(l=>l.groupId===y)?.apiObject)},close:async(y,S)=>{const l=Array.isArray(y)?y:[y];return l.length?f(l[0])?this._closeGroups(l,S):this._closeTabs(l,S):!0}};this._apiObject=Object.freeze(c)}return this._apiObject}$acceptEditorTabModel(d){const c=new Set(this._extHostTabGroups.map(i=>i.groupId)),y=new Set(d.map(i=>i.groupId)),S=(0,O.diffSets)(c,y),l=this._extHostTabGroups.filter(i=>S.removed.includes(i.groupId)).map(i=>i.apiObject),_=[],r=[];this._extHostTabGroups=d.map(i=>{const s=new p(i,this._proxy,()=>this._activeGroupId);return S.added.includes(s.groupId)?_.push(s.apiObject):r.push(s.apiObject),s});const k=(0,A.assertIsDefined)(d.find(i=>i.isActive===!0)?.groupId);k!==void 0&&this._activeGroupId!==k&&(this._activeGroupId=k),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:l,changed:r}))}$acceptTabGroupUpdate(d){const c=this._extHostTabGroups.find(y=>y.groupId===d.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const c=this._extHostTabGroups.find(S=>S.groupId===d.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const y=c.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[y.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[y.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[y.apiObject]}));return}}_findExtHostTabFromApi(d){for(const c of this._extHostTabGroups)for(const y of c.tabs)if(y.apiObject===d)return y}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(c=>c.apiObject===d)}async _closeTabs(d,c){const y=[];for(const S of d){const l=this._findExtHostTabFromApi(S);if(!l)throw new Error("Tab close: Invalid tab not found!");y.push(l.tabId)}return this._proxy.$closeTab(y,c)}async _closeGroups(d,c){const y=[];for(const S of d){const l=this._findExtHostTabGroupFromApi(S);if(!l)throw new Error("Group close: Invalid group not found!");y.push(l.groupId)}return this._proxy.$closeGroup(y,c)}};b=$e([ze(0,w.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function f(u){return u.tabs!==void 0}}),define(Se[191],De([1,0,2,4,7,6,8,236,9,25,24]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let d,c,y=14,S=14;for(const l of f){let _=d?(0,w.commonPrefixLength)(d,l):0;for(_===0?c=1:c=S;_<l.length;_++)_+1===l.length?(y=S,S=9):S+=1,u.push([c,l.toUpperCase().charCodeAt(_),S]),u.push([c,l.toLowerCase().charCodeAt(_),S]),c=S;d=l,S=y}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],d=P.LinkComputer.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const c of d){const y=I.DocumentLink.to(c);y.target&&u.push(y)}return u}}class p{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,u,d,c={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const y=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(y,d);let S=2;c.isCaseSensitive&&(S+=1024),c.isReadonly&&(S+=2048),typeof d.copy=="function"&&(S+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(y,u,S).catch(_=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${u}`),console.error(_)});const l=d.onDidChangeFile(_=>{const r=[];for(const k of _){let{uri:i,type:s}=k;if(i.scheme!==u)continue;let n;switch(s){case N.FileChangeType.Changed:n=0;break;case N.FileChangeType.Created:n=1;break;case N.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:n})}this._proxy.$onFileSystemChange(y,r)});return(0,g.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(f){const{type:u,ctime:d,mtime:c,size:y,permissions:S}=f;return{type:u,ctime:d,mtime:c,size:y,permissions:S}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(u))).then(d=>p._asIStat(d))}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(u))).then(d=>A.VSBuffer.wrap(d))}$writeFile(f,u,d,c){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(u),d.buffer,c))}$delete(f,u,d){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(u),d))}$rename(f,u,d,c){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(u),a.URI.revive(d),c))}$copy(f,u,d,c){const y=this._getFsProvider(f);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(a.URI.revive(u),a.URI.revive(d),c))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(u)))}$watch(f,u,d,c){const y=this._getFsProvider(f).watch(a.URI.revive(d),c);this._watches.set(u,y)}$unwatch(f,u){const d=this._watches.get(u);d&&(d.dispose(),this._watches.delete(u))}$open(f,u,d){const c=this._getFsProvider(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(a.URI.revive(u),d))}$close(f,u){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(u))}$read(f,u,d,c){const y=this._getFsProvider(f);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const S=A.VSBuffer.alloc(c);return Promise.resolve(y.read(u,d,S.buffer,0,c)).then(l=>S.slice(0,l))}$write(f,u,d,c){const y=this._getFsProvider(f);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(u,d,c.buffer,0,c.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return u}}e.ExtHostFileSystem=p}),define(Se[51],De([1,0,4,38,6,25,3,16,35,7]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Kt{constructor(p,b){this._fileSystemProvider=new Map,this._proxy=p.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(u){try{const d=f._fileSystemProvider.get(u.scheme);if(!d)return await f._proxy.$stat(u);await f._proxy.$ensureActivation(u.scheme);const c=await d.stat(u);return{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions}}catch(d){Kt._handleError(d)}},async readDirectory(u){try{const d=f._fileSystemProvider.get(u.scheme);return d?(await f._proxy.$ensureActivation(u.scheme),(await d.readDirectory(u)).slice()):await f._proxy.$readdir(u)}catch(d){return Kt._handleError(d)}},async createDirectory(u){try{return await f._proxy.$mkdir(u)}catch(d){return Kt._handleError(d)}},async readFile(u){try{const d=f._fileSystemProvider.get(u.scheme);return d?(await f._proxy.$ensureActivation(u.scheme),(await d.readFile(u)).slice()):(await f._proxy.$readFile(u)).buffer}catch(d){return Kt._handleError(d)}},async writeFile(u,d){try{return await f._proxy.$writeFile(u,N.VSBuffer.wrap(d))}catch(c){return Kt._handleError(c)}},async delete(u,d){try{const c=f._fileSystemProvider.get(u.scheme);return c?(await f._proxy.$ensureActivation(u.scheme),await c.delete(u,{recursive:!1,...d})):await f._proxy.$delete(u,{recursive:!1,useTrash:!1,...d})}catch(c){return Kt._handleError(c)}},async rename(u,d,c){try{return await f._proxy.$rename(u,d,{overwrite:!1,...c})}catch(y){return Kt._handleError(y)}},async copy(u,d,c){try{return await f._proxy.$copy(u,d,{overwrite:!1,...c})}catch(y){return Kt._handleError(y)}},isWritableFileSystem(u){const d=b.getCapabilities(u);if(typeof d=="number")return!(d&2048)}})}static _handleError(p){if(p instanceof g.FileSystemError)throw p;if(!(p instanceof Error))throw new g.FileSystemError(String(p));if(p.name==="ENOPRO")throw g.FileSystemError.Unavailable(p.message);switch(p.name){case D.FileSystemProviderErrorCode.FileExists:throw g.FileSystemError.FileExists(p.message);case D.FileSystemProviderErrorCode.FileNotFound:throw g.FileSystemError.FileNotFound(p.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw g.FileSystemError.FileNotADirectory(p.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw g.FileSystemError.FileIsADirectory(p.message);case D.FileSystemProviderErrorCode.NoPermissions:throw g.FileSystemError.NoPermissions(p.message);case D.FileSystemProviderErrorCode.Unavailable:throw g.FileSystemError.Unavailable(p.message);default:throw new g.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,b){return this._fileSystemProvider.set(p,b),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(p))}};O=$e([ze(0,P.IExtHostRpcService),ze(1,w.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[192],De([1,0,5,33,2,4,8,6]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{constructor(v,p,b,f,u,d,c,y){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const S=this.ensureWatching(v,b,u);this._config=0,d&&(this._config+=1),c&&(this._config+=2),y&&(this._config+=4);const l=(0,D.parse)(u),_=typeof u=="string",r=f(k=>{if(!d)for(let i of k.created){const s=g.URI.revive(i);l(s.fsPath)&&(!_||p.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!c)for(let i of k.changed){const s=g.URI.revive(i);l(s.fsPath)&&(!_||p.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!y)for(let i of k.deleted){const s=g.URI.revive(i);l(s.fsPath)&&(!_||p.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(v,p,b){let f=P.Disposable.from();if(typeof b=="string")return f;const u=v.getProxy(N.MainContext.MainThreadFileSystem);let d=!1;(b.pattern.includes(D.GLOBSTAR)||b.pattern.includes(D.GLOB_SPLIT))&&(d=!0);const c=Math.random();return u.$watch(p.identifier.value,c,b.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>u.$unwatch(c)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(v,p,b){this._mainContext=v,this._logService=p,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,p,b,f,u,d){return new w(this._mainContext,v,p,this._onFileSystemEvent.event,I.GlobPattern.from(b),f,u,d)}$onFileEvent(v){this._onFileSystemEvent.fire(v)}$onDidRunFileOperation(v,p){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(b=>({oldUri:g.URI.revive(b.source),newUri:g.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(b=>g.URI.revive(b.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(b=>g.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,p){return(b,f,u)=>{const d=function(y){b.call(f,y)};return d.extension=v,p.event(d,void 0,u)}}async $onWillRunFileOperation(v,p,b,f){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(u=>({oldUri:g.URI.revive(u.source),newUri:g.URI.revive(u.target)}))},b,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(u=>g.URI.revive(u.target))},b,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(u=>g.URI.revive(u.target))},b,f)}}async _fireWillEvent(v,p,b,f){const u=new Set,d=[];if(await v.fireAsync(p,f,async(y,S)=>{const l=Date.now(),_=await Promise.resolve(y);_ instanceof P.WorkspaceEdit&&(d.push(_),u.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-l>b&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),f.isCancellationRequested||d.length===0)return;const c={edits:[]};for(let y of d){let{edits:S}=I.WorkspaceEdit.from(y,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(S)}return{edit:c,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=A}),define(Se[193],De([1,0,2,36]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class g{constructor(I,P,w,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=w,this._commands=A;const O=new D.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new D.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new D.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new D.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new D.ApiCommandResult("Notebook and input URI",v=>{if(v.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(v.notebookEditorId);return{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:p.apiEditor}}return{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(O)}$willAddInteractiveDocument(I,P,w,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:w,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=g}),define(Se[194],De([1,0,7,4]),function(Z,e,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class g{constructor(I){this._handlePool=0,this._proxy=I.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,I),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=g}),define(Se[195],De([1,0,2,27,8,6,68,4,9,48,15,10,237,20,7,77,56,63,196,12,14,24,86]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class k{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentSymbols(T,B){const W=this._documents.getDocument(T),H=await this._provider.provideDocumentSymbols(W,B);if(!(0,O.isFalsyOrEmpty)(H))return H[0]instanceof N.DocumentSymbol?H.map(g.DocumentSymbol.from):k._asDocumentSymbolTree(H)}static _asDocumentSymbolTree(T){T=T.slice(0).sort((H,ne)=>{let he=H.location.range.start.compareTo(ne.location.range.start);return he===0&&(he=ne.location.range.end.compareTo(H.location.range.end)),he});const B=[],W=[];for(const H of T){const ne={name:H.name||"!!MISSING: name!!",kind:g.SymbolKind.from(H.kind),tags:H.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:g.Range.from(H.location.range),selectionRange:g.Range.from(H.location.range),children:[]};for(;;){if(W.length===0){W.push(ne),B.push(ne);break}const he=W[W.length-1];if(A.Range.containsRange(he.range,ne.range)&&!A.Range.equalsRange(he.range,ne.range)){he.children&&he.children.push(ne),W.push(ne);break}W.pop()}}return B}}class i{constructor(T,B,W){this._documents=T,this._commands=B,this._provider=W,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(T,B){const W=this._documents.getDocument(T),H=await this._provider.provideCodeLenses(W,B);if(!H||B.isCancellationRequested)return;const ne=this._cache.add(H),he=new f.DisposableStore;this._disposables.set(ne,he);const Y={cacheId:ne,lenses:[]};for(let ge=0;ge<H.length;ge++)Y.lenses.push({cacheId:[ne,ge],range:g.Range.from(H[ge].range),command:this._commands.toInternal(H[ge].command,he)});return Y}async resolveCodeLens(T,B){const W=T.cacheId&&this._cache.get(...T.cacheId);if(!W)return;let H;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?H=W:H=await this._provider.resolveCodeLens(W,B),H||(H=W),B.isCancellationRequested)return;const ne=T.cacheId&&this._disposables.get(T.cacheId[0]);if(!!ne)return T.command=this._commands.toInternal(H.command??i._badCmd,ne),T}releaseCodeLenses(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}}i._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(G){return Array.isArray(G)?G.map(g.DefinitionLink.from):G?[g.DefinitionLink.from(G)]:[]}class n{constructor(T,B){this._documents=T,this._provider=B}async provideDefinition(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideDefinition(H,ne,W);return s(he)}}class t{constructor(T,B){this._documents=T,this._provider=B}async provideDeclaration(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideDeclaration(H,ne,W);return s(he)}}class o{constructor(T,B){this._documents=T,this._provider=B}async provideImplementation(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideImplementation(H,ne,W);return s(he)}}class m{constructor(T,B){this._documents=T,this._provider=B}async provideTypeDefinition(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideTypeDefinition(H,ne,W);return s(he)}}class h{constructor(T,B){this._documents=T,this._provider=B}async provideHover(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideHover(H,ne,W);if(!(!he||(0,O.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=H.getWordRangeAtPosition(ne)),he.range||(he.range=new N.Range(ne,ne)),g.Hover.from(he)}}class C{constructor(T,B){this._documents=T,this._provider=B}async provideEvaluatableExpression(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideEvaluatableExpression(H,ne,W);if(he)return g.EvaluatableExpression.from(he)}}class F{constructor(T,B){this._documents=T,this._provider=B}async provideInlineValues(T,B,W,H){const ne=this._documents.getDocument(T),he=await this._provider.provideInlineValues(ne,g.Range.to(B),g.InlineValueContext.to(W),H);if(Array.isArray(he))return he.map(Y=>g.InlineValue.from(Y))}}class U{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentHighlights(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideDocumentHighlights(H,ne,W);if(Array.isArray(he))return he.map(g.DocumentHighlight.from)}}class R{constructor(T,B){this._documents=T,this._provider=B}async provideLinkedEditingRanges(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.provideLinkedEditingRanges(H,ne,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,O.coalesce)(he.ranges.map(g.Range.from)),wordPattern:he.wordPattern}}}class E{constructor(T,B){this._documents=T,this._provider=B}async provideReferences(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B),Y=await this._provider.provideReferences(ne,he,W,H);if(Array.isArray(Y))return Y.map(g.location.from)}}class x{constructor(T,B,W,H,ne,he,Y){this._documents=T,this._commands=B,this._diagnostics=W,this._provider=H,this._logService=ne,this._extension=he,this._apiDeprecation=Y,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(T,B,W,H){const ne=this._documents.getDocument(T),he=p.Selection.isISelection(B)?g.Selection.to(B):g.Range.to(B),Y=[];for(const qe of this._diagnostics.getDiagnostics(T))if(he.intersection(qe.range)&&Y.push(qe)>x._maxCodeActionsPerFile)break;const ge={diagnostics:Y,only:W.only?new N.CodeActionKind(W.only):void 0,triggerKind:g.CodeActionTriggerKind.to(W.trigger)},pe=await this._provider.provideCodeActions(ne,he,ge,H);if(!(0,O.isNonEmptyArray)(pe)||H.isCancellationRequested)return;const Ne=this._cache.add(pe),xe=new f.DisposableStore;this._disposables.set(Ne,xe);const ke=[];for(let qe=0;qe<pe.length;qe++){const j=pe[qe];!j||(x._isCommand(j)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:j.title,command:this._commands.toInternal(j,xe)})):(ge.only&&(j.kind?ge.only.contains(j.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${j.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Ne,qe],title:j.title,command:j.command&&this._commands.toInternal(j.command,xe),diagnostics:j.diagnostics&&j.diagnostics.map(g.Diagnostic.from),edit:j.edit&&g.WorkspaceEdit.from(j.edit),kind:j.kind&&j.kind.value,isPreferred:j.isPreferred,disabled:j.disabled?.reason})))}return{cacheId:Ne,actions:ke}}async resolveCodeAction(T,B){const[W,H]=T,ne=this._cache.get(W,H);if(!ne||x._isCommand(ne)||!this._provider.resolveCodeAction)return;const he=await this._provider.resolveCodeAction(ne,B)??ne;return he?.edit?g.WorkspaceEdit.from(he.edit):void 0}releaseCodeActions(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}static _isCommand(T){return typeof T.command=="string"&&typeof T.title=="string"}}x._maxCodeActionsPerFile=1e3;class z{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentFormattingEdits(T,B,W){const H=this._documents.getDocument(T),ne=await this._provider.provideDocumentFormattingEdits(H,B,W);if(Array.isArray(ne))return ne.map(g.TextEdit.from)}}class V{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentRangeFormattingEdits(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Range.to(B),Y=await this._provider.provideDocumentRangeFormattingEdits(ne,he,W,H);if(Array.isArray(Y))return Y.map(g.TextEdit.from)}}class se{constructor(T,B){this._documents=T,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,B,W,H,ne){const he=this._documents.getDocument(T),Y=g.Position.to(B),ge=await this._provider.provideOnTypeFormattingEdits(he,Y,W,H,ne);if(Array.isArray(ge))return ge.map(g.TextEdit.from)}}class K{constructor(T,B){this._provider=T,this._logService=B,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(T,B){const W=await this._provider.provideWorkspaceSymbols(T,B);if(!(0,O.isNonEmptyArray)(W))return{symbols:[]};const H=this._cache.add(W),ne={cacheId:H,symbols:[]};for(let he=0;he<W.length;he++){const Y=W[he];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}ne.symbols.push({...g.WorkspaceSymbol.from(Y),cacheId:[H,he]})}return ne}async resolveWorkspaceSymbol(T,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const W=this._cache.get(...T.cacheId);if(W){const H=await this._provider.resolveWorkspaceSymbol(W,B);return H&&(0,D.mixin)(T,g.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(T){this._cache.delete(T)}}class L{constructor(T,B,W){this._documents=T,this._provider=B,this._logService=W}static supportsResolving(T){return typeof T.prepareRename=="function"}async provideRenameEdits(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B);try{const Y=await this._provider.provideRenameEdits(ne,he,W,H);return Y?g.WorkspaceEdit.from(Y):void 0}catch(Y){const ge=L._asMessage(Y);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(T,B,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const H=this._documents.getDocument(T),ne=g.Position.to(B);try{const he=await this._provider.prepareRename(H,ne,W);let Y,ge;if(N.Range.isRange(he)?(Y=he,ge=H.getText(he)):(0,v.isObject)(he)&&(Y=he.range,ge=he.placeholder),!Y||!ge)return;if(Y.start.line>ne.line||Y.end.line<ne.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Y),text:ge}}catch(he){const Y=L._asMessage(he);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(he)}}static _asMessage(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class oe{constructor(T,B){this.resultId=T,this.tokens=B}}class de{constructor(T,B){this._documents=T,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(T,B,W){const H=this._documents.getDocument(T),ne=B!==0?this._previousResults.get(B):null;let he=typeof ne?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(H,ne.resultId,W):await this._provider.provideDocumentSemanticTokens(H,W);return ne&&this._previousResults.delete(B),he?(he=de._fixProvidedSemanticTokens(he),this._send(de._convertToEdits(ne,he),he)):null}async releaseDocumentSemanticColoring(T){this._previousResults.delete(T)}static _fixProvidedSemanticTokens(T){return de._isSemanticTokens(T)?de._isCorrectSemanticTokens(T)?T:new N.SemanticTokens(new Uint32Array(T.data),T.resultId):de._isSemanticTokensEdits(T)?de._isCorrectSemanticTokensEdits(T)?T:new N.SemanticTokensEdits(T.edits.map(B=>new N.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),T.resultId):T}static _isSemanticTokens(T){return T&&!!T.data}static _isCorrectSemanticTokens(T){return T.data instanceof Uint32Array}static _isSemanticTokensEdits(T){return T&&Array.isArray(T.edits)}static _isCorrectSemanticTokensEdits(T){for(const B of T.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(T,B){if(!de._isSemanticTokens(B)||!T||!T.tokens)return B;const W=T.tokens,H=W.length,ne=B.data,he=ne.length;let Y=0;const ge=Math.min(H,he);for(;Y<ge&&W[Y]===ne[Y];)Y++;if(Y===H&&Y===he)return new N.SemanticTokensEdits([],B.resultId);let pe=0;const Ne=ge-Y;for(;pe<Ne&&W[H-pe-1]===ne[he-pe-1];)pe++;return new N.SemanticTokensEdits([{start:Y,deleteCount:H-Y-pe,data:ne.subarray(Y,he-pe)}],B.resultId)}_send(T,B){if(de._isSemanticTokens(T)){const W=this._nextResultId++;return this._previousResults.set(W,new oe(T.resultId,T.data)),(0,u.encodeSemanticTokensDto)({id:W,type:"full",data:T.data})}if(de._isSemanticTokensEdits(T)){const W=this._nextResultId++;return de._isSemanticTokens(B)?this._previousResults.set(W,new oe(B.resultId,B.data)):this._previousResults.set(W,new oe(T.resultId)),(0,u.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(T.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}e.DocumentSemanticTokensAdapter=de;class ae{constructor(T,B){this._documents=T,this._provider=B}async provideDocumentRangeSemanticTokens(T,B,W){const H=this._documents.getDocument(T),ne=await this._provider.provideDocumentRangeSemanticTokens(H,g.Range.to(B),W);return ne?this._send(ne):null}_send(T){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:T.data})}}e.DocumentRangeSemanticTokensAdapter=ae;class fe{constructor(T,B,W,H,ne){this._documents=T,this._commands=B,this._provider=W,this._apiDeprecation=H,this._extension=ne,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}async provideCompletionItems(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B),Y=ne.getWordRangeAtPosition(he)||new N.Range(he,he),ge=Y.with({end:he}),pe=new y.StopWatch(!0),Ne=await this._provider.provideCompletionItems(ne,he,H,g.CompletionContext.to(W));if(!Ne||H.isCancellationRequested)return;const xe=Array.isArray(Ne)?new N.CompletionList(Ne):Ne,ke=fe.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(ke,qe);const j=[],Q={x:ke,b:j,a:{replace:g.Range.from(Y),insert:g.Range.from(ge)},c:xe.isIncomplete||void 0,d:pe.elapsed()};for(let me=0;me<xe.items.length;me++){const Le=xe.items[me],Be=this._convertCompletionItem(Le,[ke,me],ge,Y);j.push(Be)}return Q}async resolveCompletionItem(T,B){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(...T);if(!W)return;const H=await this._provider.resolveCompletionItem(W,B);if(!!H)return this._convertCompletionItem(H,T)}releaseCompletionItems(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_convertCompletionItem(T,B,W,H){const ne=this._disposables.get(B[0]);if(!ne)throw Error("DisposableStore is missing...");const he={x:B,a:T.label,b:T.kind!==void 0?g.CompletionItemKind.from(T.kind):void 0,n:T.tags&&T.tags.map(g.CompletionItemTag.from),c:T.detail,d:typeof T.documentation=="undefined"?void 0:g.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters,l:T.additionalTextEdits&&T.additionalTextEdits.map(g.TextEdit.from),m:this._commands.toInternal(T.command,ne)};T.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=T.textEdit.newText):typeof T.insertText=="string"?he.h=T.insertText:T.insertText instanceof N.SnippetString&&(he.h=T.insertText.value,he.i|=4);let Y;return T.textEdit?Y=T.textEdit.range:T.range&&(Y=T.range),N.Range.isRange(Y)?he.j=g.Range.from(Y):Y&&(!W?.isEqual(Y.inserting)||!H?.isEqual(Y.replacing))&&(he.j={insert:g.Range.from(Y.inserting),replace:g.Range.from(Y.replacing)}),he}}class ee{async provideInlineCompletions(T,B,W,H){}disposeCompletions(T){}handleDidShowCompletionItem(T,B){}}class Ee extends ee{constructor(T,B,W,H){super();this._extension=T,this._documents=B,this._provider=W,this._commands=H,this._references=new J,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B),Y=await this._provider.provideInlineCompletionItems(ne,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:g.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},H);if(!Y||H.isCancellationRequested)return;const ge=(0,v.isArray)(Y)?Y:Y.items,pe=this._isAdditionsProposedApiEnabled?(0,v.isArray)(Y)?[]:Y.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((ke,qe)=>{let j;ke.command&&(Ne||(Ne=new f.DisposableStore),j=this._commands.toInternal(ke.command,Ne));const Q=ke.insertText;return{insertText:typeof Q=="string"?Q:{snippet:Q.value},filterText:ke.filterText,range:ke.range?g.Range.from(ke.range):void 0,command:j,idx:qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?ke.completeBracketPairs:!1}}),commands:pe.map(ke=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(ke,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,B){const W=this._references.get(T)?.items[B];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class we extends ee{constructor(T,B,W,H){super();this.extension=T,this._documents=B,this._provider=W,this._commands=H,this._references=new J,this.isAdditionProposedApiEnabled=(0,_.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B),Y=await this._provider.provideInlineCompletionItems(ne,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:g.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},H);if(!Y||H.isCancellationRequested)return;const ge=(0,v.isArray)(Y)?Y:Y.items,pe=(0,v.isArray)(Y)?[]:Y.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:ge}),items:ge.map((ke,qe)=>{let j;ke.command&&(Ne||(Ne=new f.DisposableStore),j=this._commands.toInternal(ke.command,Ne));const Q=ke.insertText;return{insertText:typeof Q=="string"?Q:{snippet:Q.value},filterText:ke.filterText,range:ke.range?g.Range.from(ke.range):void 0,command:j,idx:qe,completeBracketPairs:this.isAdditionProposedApiEnabled?ke.completeBracketPairs:!1}}),commands:pe.map(ke=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(ke,Ne)))}}disposeCompletions(T){this._references.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,B){const W=this._references.get(T)?.items[B];W&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class J{constructor(){this._references=new Map,this._idPool=1}createReferenceId(T){const B=this._idPool++;return this._references.set(B,T),B}disposeReferenceId(T){const B=this._references.get(T);return this._references.delete(T),B}get(T){return this._references.get(T)}}class ve{constructor(T,B){this._documents=T,this._provider=B,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(T,B,W,H){const ne=this._documents.getDocument(T),he=g.Position.to(B),Y=this.reviveContext(W),ge=await this._provider.provideSignatureHelp(ne,he,H,Y);if(ge){const pe=this._cache.add([ge]);return{...g.SignatureHelp.from(ge),id:pe}}}reviveContext(T){let B;if(T.activeSignatureHelp){const W=g.SignatureHelp.to(T.activeSignatureHelp),H=this._cache.get(T.activeSignatureHelp.id,0);H?(B=H,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...T,activeSignatureHelp:B}}releaseSignatureHelp(T){this._cache.delete(T)}}class Pe{constructor(T,B,W,H,ne){this._documents=T,this._commands=B,this._provider=W,this._logService=H,this._extension=ne,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(T,B,W){const H=this._documents.getDocument(T),ne=g.Range.to(B),he=await this._provider.provideInlayHints(H,ne,W);if(!Array.isArray(he)||he.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const Y=this._cache.add(he);this._disposables.set(Y,new f.DisposableStore);const ge={hints:[],cacheId:Y};for(let pe=0;pe<he.length;pe++)this._isValidInlayHint(he[pe],ne)&&ge.hints.push(this._convertInlayHint(he[pe],[Y,pe]));return this._logService.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ge}async resolveInlayHint(T,B){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(...T);if(!W)return;const H=await this._provider.resolveInlayHint(W,B);if(!!H&&!!this._isValidInlayHint(H))return this._convertInlayHint(H,T)}releaseHints(T){this._disposables.get(T)?.dispose(),this._disposables.delete(T),this._cache.delete(T)}_isValidInlayHint(T,B){return T.label.length===0||Array.isArray(T.label)&&T.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(B&&!B.contains(T.position))}_convertInlayHint(T,B){const W=this._disposables.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const H={label:"",cacheId:B,tooltip:g.MarkdownString.fromStrict(T.tooltip),position:g.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(g.TextEdit.from),kind:T.kind&&g.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?H.label=T.label:H.label=T.label.map(ne=>{let he={label:ne.value};return he.tooltip=g.MarkdownString.fromStrict(ne.tooltip),N.Location.isLocation(ne.location)&&(he.location=g.location.from(ne.location)),ne.command&&(he.command=this._commands.toInternal(ne.command,W)),he}),H}}class Fe{constructor(T,B){this._documents=T,this._provider=B,this._cache=new c.Cache("DocumentLink")}async provideLinks(T,B){const W=this._documents.getDocument(T),H=await this._provider.provideDocumentLinks(W,B);if(!(!Array.isArray(H)||H.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:H.filter(Fe._validateLink).map(g.DocumentLink.from)};{const ne=this._cache.add(H),he={links:[],cacheId:ne};for(let Y=0;Y<H.length;Y++){if(!Fe._validateLink(H[Y]))continue;const ge=g.DocumentLink.from(H[Y]);ge.cacheId=[ne,Y],he.links.push(ge)}return he}}}static _validateLink(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,B){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(...T);if(!W)return;const H=await this._provider.resolveDocumentLink(W,B);if(!(!H||!Fe._validateLink(H)))return g.DocumentLink.from(H)}releaseLinks(T){this._cache.delete(T)}}class We{constructor(T,B){this._documents=T,this._provider=B}async provideColors(T,B){const W=this._documents.getDocument(T),H=await this._provider.provideDocumentColors(W,B);return Array.isArray(H)?H.map(he=>({color:g.Color.from(he.color),range:g.Range.from(he.range)})):[]}async provideColorPresentations(T,B,W){const H=this._documents.getDocument(T),ne=g.Range.to(B.range),he=g.Color.to(B.color),Y=await this._provider.provideColorPresentations(he,{document:H,range:ne},W);if(!!Array.isArray(Y))return Y.map(g.ColorPresentation.from)}}class Ge{constructor(T,B){this._documents=T,this._provider=B}async provideFoldingRanges(T,B,W){const H=this._documents.getDocument(T),ne=await this._provider.provideFoldingRanges(H,B,W);if(!!Array.isArray(ne))return ne.map(g.FoldingRange.from)}}class Ie{constructor(T,B,W){this._documents=T,this._provider=B,this._logService=W}async provideSelectionRanges(T,B,W){const H=this._documents.getDocument(T),ne=B.map(g.Position.to),he=await this._provider.provideSelectionRanges(H,ne,W);if(!(0,O.isNonEmptyArray)(he))return[];if(he.length!==ne.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let ge=0;ge<ne.length;ge++){const pe=[];Y.push(pe);let Ne=ne[ge],xe=he[ge];for(;;){if(!xe.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(g.SelectionRange.from(xe)),!xe.parent)break;Ne=xe.range,xe=xe.parent}}return Y}}class _e{constructor(T,B){this._documents=T,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.prepareCallHierarchy(H,ne,W);if(!he)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(he)?he.map(ge=>this._cacheAndConvertItem(Y,ge)):[this._cacheAndConvertItem(Y,he)]}async provideCallsTo(T,B,W){const H=this._itemFromCache(T,B);if(!H)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyIncomingCalls(H,W);if(!!ne)return ne.map(he=>({from:this._cacheAndConvertItem(T,he.from),fromRanges:he.fromRanges.map(Y=>g.Range.from(Y))}))}async provideCallsFrom(T,B,W){const H=this._itemFromCache(T,B);if(!H)throw new Error("missing call hierarchy item");const ne=await this._provider.provideCallHierarchyOutgoingCalls(H,W);if(!!ne)return ne.map(he=>({to:this._cacheAndConvertItem(T,he.to),fromRanges:he.fromRanges.map(Y=>g.Range.from(Y))}))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,B){const W=this._cache.get(T),H=g.CallHierarchyItem.from(B,T,W.size.toString(36));return W.set(H._itemId,B),H}_itemFromCache(T,B){return this._cache.get(T)?.get(B)}}class Ce{constructor(T,B){this._documents=T,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(T,B,W){const H=this._documents.getDocument(T),ne=g.Position.to(B),he=await this._provider.prepareTypeHierarchy(H,ne,W);if(!he)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(he)?he.map(ge=>this._cacheAndConvertItem(Y,ge)):[this._cacheAndConvertItem(Y,he)]}async provideSupertypes(T,B,W){const H=this._itemFromCache(T,B);if(!H)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySupertypes(H,W);if(!!ne)return ne.map(he=>this._cacheAndConvertItem(T,he))}async provideSubtypes(T,B,W){const H=this._itemFromCache(T,B);if(!H)throw new Error("missing type hierarchy item");const ne=await this._provider.provideTypeHierarchySubtypes(H,W);if(!!ne)return ne.map(he=>this._cacheAndConvertItem(T,he))}releaseSession(T){this._cache.delete(T)}_cacheAndConvertItem(T,B){const W=this._cache.get(T),H=g.TypeHierarchyItem.from(B,T,W.size.toString(36));return W.set(H._itemId,B),H}_itemFromCache(T,B){return this._cache.get(T)?.get(B)}}class re{constructor(T,B,W,H){this._proxy=T,this._documents=B,this._provider=W,this._handle=H}async provideDocumentOnDropEdits(T,B,W,H,ne){const he=this._documents.getDocument(B),Y=g.Position.to(W),ge=r.DataTransferConverter.toDataTransfer(H,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,T,Ne)).buffer),pe=await this._provider.provideDocumentOnDropEdits(he,Y,ge,ne);if(!!pe)return g.SnippetTextEdit.from(pe)}}class le{constructor(T,B){this.adapter=T,this.extension=B}}class X{constructor(T,B,W,H,ne,he,Y){this._adapter=new Map,this._uriTransformer=B,this._proxy=T.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=W,this._commands=H,this._diagnostics=ne,this._logService=he,this._apiDeprecation=Y}_transformDocumentSelector(T){return g.DocumentSelector.from(T,this._uriTransformer)}_createDisposable(T){return new N.Disposable(()=>{this._adapter.delete(T),this._proxy.$unregister(T)})}_nextHandle(){return X._handlePool++}async _withAdapter(T,B,W,H,ne,he=!1){const Y=this._adapter.get(T);if(!Y||!(Y.adapter instanceof B))return H;const ge=Date.now();he||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const pe=W(Y.adapter,Y.extension);return Promise.resolve(pe).catch(Ne=>{(0,S.isCancellationError)(Ne)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{he||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),b.CancellationToken.isCancellationToken(ne)?(0,l.raceCancellationError)(pe,ne):pe}_addNewAdapter(T,B){const W=this._nextHandle();return this._adapter.set(W,new le(T,B)),W}static _extLabel(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,B,W,H){const ne=this._addNewAdapter(new k(this._documents,W),T),he=H&&H.label||X._extLabel(T);return this._proxy.$registerDocumentSymbolProvider(ne,this._transformDocumentSelector(B),he),this._createDisposable(ne)}$provideDocumentSymbols(T,B,W){return this._withAdapter(T,k,H=>H.provideDocumentSymbols(a.URI.revive(B),W),void 0,W)}registerCodeLensProvider(T,B,W){const H=this._nextHandle(),ne=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(H,new le(new i(this._documents,this._commands.converter,W),T)),this._proxy.$registerCodeLensSupport(H,this._transformDocumentSelector(B),ne);let he=this._createDisposable(H);if(ne!==void 0){const Y=W.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(ne));he=N.Disposable.from(he,Y)}return he}$provideCodeLenses(T,B,W){return this._withAdapter(T,i,H=>H.provideCodeLenses(a.URI.revive(B),W),void 0,W)}$resolveCodeLens(T,B,W){return this._withAdapter(T,i,H=>H.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(T,B){this._withAdapter(T,i,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(T,B,W){const H=this._addNewAdapter(new n(this._documents,W),T);return this._proxy.$registerDefinitionSupport(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideDefinition(T,B,W,H){return this._withAdapter(T,n,ne=>ne.provideDefinition(a.URI.revive(B),W,H),[],H)}registerDeclarationProvider(T,B,W){const H=this._addNewAdapter(new t(this._documents,W),T);return this._proxy.$registerDeclarationSupport(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideDeclaration(T,B,W,H){return this._withAdapter(T,t,ne=>ne.provideDeclaration(a.URI.revive(B),W,H),[],H)}registerImplementationProvider(T,B,W){const H=this._addNewAdapter(new o(this._documents,W),T);return this._proxy.$registerImplementationSupport(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideImplementation(T,B,W,H){return this._withAdapter(T,o,ne=>ne.provideImplementation(a.URI.revive(B),W,H),[],H)}registerTypeDefinitionProvider(T,B,W){const H=this._addNewAdapter(new m(this._documents,W),T);return this._proxy.$registerTypeDefinitionSupport(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideTypeDefinition(T,B,W,H){return this._withAdapter(T,m,ne=>ne.provideTypeDefinition(a.URI.revive(B),W,H),[],H)}registerHoverProvider(T,B,W,H){const ne=this._addNewAdapter(new h(this._documents,W),T);return this._proxy.$registerHoverProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideHover(T,B,W,H){return this._withAdapter(T,h,ne=>ne.provideHover(a.URI.revive(B),W,H),void 0,H)}registerEvaluatableExpressionProvider(T,B,W,H){const ne=this._addNewAdapter(new C(this._documents,W),T);return this._proxy.$registerEvaluatableExpressionProvider(ne,this._transformDocumentSelector(B)),this._createDisposable(ne)}$provideEvaluatableExpression(T,B,W,H){return this._withAdapter(T,C,ne=>ne.provideEvaluatableExpression(a.URI.revive(B),W,H),void 0,H)}registerInlineValuesProvider(T,B,W,H){const ne=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new F(this._documents,W),T);this._proxy.$registerInlineValuesProvider(he,this._transformDocumentSelector(B),ne);let Y=this._createDisposable(he);if(ne!==void 0){const ge=W.onDidChangeInlineValues(pe=>this._proxy.$emitInlineValuesEvent(ne));Y=N.Disposable.from(Y,ge)}return Y}$provideInlineValues(T,B,W,H,ne){return this._withAdapter(T,F,he=>he.provideInlineValues(a.URI.revive(B),W,H,ne),void 0,ne)}registerDocumentHighlightProvider(T,B,W){const H=this._addNewAdapter(new U(this._documents,W),T);return this._proxy.$registerDocumentHighlightProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideDocumentHighlights(T,B,W,H){return this._withAdapter(T,U,ne=>ne.provideDocumentHighlights(a.URI.revive(B),W,H),void 0,H)}registerLinkedEditingRangeProvider(T,B,W){const H=this._addNewAdapter(new R(this._documents,W),T);return this._proxy.$registerLinkedEditingRangeProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideLinkedEditingRanges(T,B,W,H){return this._withAdapter(T,R,async ne=>{const he=await ne.provideLinkedEditingRanges(a.URI.revive(B),W,H);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?X._serializeRegExp(he.wordPattern):void 0}},void 0,H)}registerReferenceProvider(T,B,W){const H=this._addNewAdapter(new E(this._documents,W),T);return this._proxy.$registerReferenceSupport(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideReferences(T,B,W,H,ne){return this._withAdapter(T,E,he=>he.provideReferences(a.URI.revive(B),W,H,ne),void 0,ne)}registerCodeActionProvider(T,B,W,H){const ne=new f.DisposableStore,he=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,W,this._logService,T,this._apiDeprecation),T);return this._proxy.$registerQuickFixSupport(he,this._transformDocumentSelector(B),{providedKinds:H?.providedCodeActionKinds?.map(Y=>Y.value),documentation:H?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,ne)}))},X._extLabel(T),Boolean(W.resolveCodeAction)),ne.add(this._createDisposable(he)),ne}$provideCodeActions(T,B,W,H,ne){return this._withAdapter(T,x,he=>he.provideCodeActions(a.URI.revive(B),W,H,ne),void 0,ne)}$resolveCodeAction(T,B,W){return this._withAdapter(T,x,H=>H.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(T,B){this._withAdapter(T,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(T,B,W){const H=this._addNewAdapter(new z(this._documents,W),T);return this._proxy.$registerDocumentFormattingSupport(H,this._transformDocumentSelector(B),T.identifier,T.displayName||T.name),this._createDisposable(H)}$provideDocumentFormattingEdits(T,B,W,H){return this._withAdapter(T,z,ne=>ne.provideDocumentFormattingEdits(a.URI.revive(B),W,H),void 0,H)}registerDocumentRangeFormattingEditProvider(T,B,W){const H=this._addNewAdapter(new V(this._documents,W),T);return this._proxy.$registerRangeFormattingSupport(H,this._transformDocumentSelector(B),T.identifier,T.displayName||T.name),this._createDisposable(H)}$provideDocumentRangeFormattingEdits(T,B,W,H,ne){return this._withAdapter(T,V,he=>he.provideDocumentRangeFormattingEdits(a.URI.revive(B),W,H,ne),void 0,ne)}registerOnTypeFormattingEditProvider(T,B,W,H){const ne=this._addNewAdapter(new se(this._documents,W),T);return this._proxy.$registerOnTypeFormattingSupport(ne,this._transformDocumentSelector(B),H,T.identifier),this._createDisposable(ne)}$provideOnTypeFormattingEdits(T,B,W,H,ne,he){return this._withAdapter(T,se,Y=>Y.provideOnTypeFormattingEdits(a.URI.revive(B),W,H,ne,he),void 0,he)}registerWorkspaceSymbolProvider(T,B){const W=this._addNewAdapter(new K(B,this._logService),T);return this._proxy.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(T,B,W){return this._withAdapter(T,K,H=>H.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(T,B,W){return this._withAdapter(T,K,H=>H.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(T,B){this._withAdapter(T,K,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(T,B,W){const H=this._addNewAdapter(new L(this._documents,W,this._logService),T);return this._proxy.$registerRenameSupport(H,this._transformDocumentSelector(B),L.supportsResolving(W)),this._createDisposable(H)}$provideRenameEdits(T,B,W,H,ne){return this._withAdapter(T,L,he=>he.provideRenameEdits(a.URI.revive(B),W,H,ne),void 0,ne)}$resolveRenameLocation(T,B,W,H){return this._withAdapter(T,L,ne=>ne.resolveRenameLocation(a.URI.revive(B),W,H),void 0,H)}registerDocumentSemanticTokensProvider(T,B,W,H){const ne=this._addNewAdapter(new de(this._documents,W),T),he=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ne,this._transformDocumentSelector(B),H,he);let Y=this._createDisposable(ne);if(he){const ge=W.onDidChangeSemanticTokens(pe=>this._proxy.$emitDocumentSemanticTokensEvent(he));Y=N.Disposable.from(Y,ge)}return Y}$provideDocumentSemanticTokens(T,B,W,H){return this._withAdapter(T,de,ne=>ne.provideDocumentSemanticTokens(a.URI.revive(B),W,H),null,H)}$releaseDocumentSemanticTokens(T,B){this._withAdapter(T,de,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,B,W,H){const ne=this._addNewAdapter(new ae(this._documents,W),T);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ne,this._transformDocumentSelector(B),H),this._createDisposable(ne)}$provideDocumentRangeSemanticTokens(T,B,W,H){return this._withAdapter(T,ae,ne=>ne.provideDocumentRangeSemanticTokens(a.URI.revive(B),W,H),null,H)}registerCompletionItemProvider(T,B,W,H){const ne=this._addNewAdapter(new fe(this._documents,this._commands.converter,W,this._apiDeprecation,T),T);return this._proxy.$registerCompletionsProvider(ne,this._transformDocumentSelector(B),H,fe.supportsResolving(W),`${T.identifier.value}(${H.join("")})`),this._createDisposable(ne)}$provideCompletionItems(T,B,W,H,ne){return this._withAdapter(T,fe,he=>he.provideCompletionItems(a.URI.revive(B),W,H,ne),void 0,ne)}$resolveCompletionItem(T,B,W){return this._withAdapter(T,fe,H=>H.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(T,B){this._withAdapter(T,fe,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(T,B,W){const H=new Ee(T,this._documents,W,this._commands.converter),ne=this._addNewAdapter(H,T);return this._proxy.$registerInlineCompletionsSupport(ne,this._transformDocumentSelector(B),H.supportsHandleDidShowCompletionItem),this._createDisposable(ne)}registerInlineCompletionsProviderNew(T,B,W){const H=this._addNewAdapter(new we(T,this._documents,W,this._commands.converter),T);return this._proxy.$registerInlineCompletionsSupport(H,this._transformDocumentSelector(B),!0),this._createDisposable(H)}$provideInlineCompletions(T,B,W,H,ne){return this._withAdapter(T,ee,he=>he.provideInlineCompletions(a.URI.revive(B),W,H,ne),void 0,ne)}$handleInlineCompletionDidShow(T,B,W){this._withAdapter(T,ee,async H=>{H.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(T,B){this._withAdapter(T,ee,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(T,B,W,H){const ne=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,he=this._addNewAdapter(new ve(this._documents,W),T);return this._proxy.$registerSignatureHelpProvider(he,this._transformDocumentSelector(B),ne),this._createDisposable(he)}$provideSignatureHelp(T,B,W,H,ne){return this._withAdapter(T,ve,he=>he.provideSignatureHelp(a.URI.revive(B),W,H,ne),void 0,ne)}$releaseSignatureHelp(T,B){this._withAdapter(T,ve,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(T,B,W){const H=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new Pe(this._documents,this._commands.converter,W,this._logService,T),T);this._proxy.$registerInlayHintsProvider(ne,this._transformDocumentSelector(B),typeof W.resolveInlayHint=="function",H,X._extLabel(T));let he=this._createDisposable(ne);if(H!==void 0){const Y=W.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(H));he=N.Disposable.from(he,Y)}return he}$provideInlayHints(T,B,W,H){return this._withAdapter(T,Pe,ne=>ne.provideInlayHints(a.URI.revive(B),W,H),void 0,H)}$resolveInlayHint(T,B,W){return this._withAdapter(T,Pe,H=>H.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(T,B){this._withAdapter(T,Pe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(T,B,W){const H=this._addNewAdapter(new Fe(this._documents,W),T);return this._proxy.$registerDocumentLinkProvider(H,this._transformDocumentSelector(B),typeof W.resolveDocumentLink=="function"),this._createDisposable(H)}$provideDocumentLinks(T,B,W){return this._withAdapter(T,Fe,H=>H.provideLinks(a.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(T,B,W){return this._withAdapter(T,Fe,H=>H.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(T,B){this._withAdapter(T,Fe,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(T,B,W){const H=this._addNewAdapter(new We(this._documents,W),T);return this._proxy.$registerDocumentColorProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideDocumentColors(T,B,W){return this._withAdapter(T,We,H=>H.provideColors(a.URI.revive(B),W),[],W)}$provideColorPresentations(T,B,W,H){return this._withAdapter(T,We,ne=>ne.provideColorPresentations(a.URI.revive(B),W,H),void 0,H)}registerFoldingRangeProvider(T,B,W){const H=this._nextHandle(),ne=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(H,new le(new Ge(this._documents,W),T)),this._proxy.$registerFoldingRangeProvider(H,this._transformDocumentSelector(B),ne);let he=this._createDisposable(H);if(ne!==void 0){const Y=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ne));he=N.Disposable.from(he,Y)}return he}$provideFoldingRanges(T,B,W,H){return this._withAdapter(T,Ge,ne=>ne.provideFoldingRanges(a.URI.revive(B),W,H),void 0,H)}registerSelectionRangeProvider(T,B,W){const H=this._addNewAdapter(new Ie(this._documents,W,this._logService),T);return this._proxy.$registerSelectionRangeProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideSelectionRanges(T,B,W,H){return this._withAdapter(T,Ie,ne=>ne.provideSelectionRanges(a.URI.revive(B),W,H),[],H)}registerCallHierarchyProvider(T,B,W){const H=this._addNewAdapter(new _e(this._documents,W),T);return this._proxy.$registerCallHierarchyProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$prepareCallHierarchy(T,B,W,H){return this._withAdapter(T,_e,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),W,H)),void 0,H)}$provideCallHierarchyIncomingCalls(T,B,W,H){return this._withAdapter(T,_e,ne=>ne.provideCallsTo(B,W,H),void 0,H)}$provideCallHierarchyOutgoingCalls(T,B,W,H){return this._withAdapter(T,_e,ne=>ne.provideCallsFrom(B,W,H),void 0,H)}$releaseCallHierarchy(T,B){this._withAdapter(T,_e,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(T,B,W){const H=this._addNewAdapter(new Ce(this._documents,W),T);return this._proxy.$registerTypeHierarchyProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$prepareTypeHierarchy(T,B,W,H){return this._withAdapter(T,Ce,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),W,H)),void 0,H)}$provideTypeHierarchySupertypes(T,B,W,H){return this._withAdapter(T,Ce,ne=>ne.provideSupertypes(B,W,H),void 0,H)}$provideTypeHierarchySubtypes(T,B,W,H){return this._withAdapter(T,Ce,ne=>ne.provideSubtypes(B,W,H),void 0,H)}$releaseTypeHierarchy(T,B){this._withAdapter(T,Ce,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropProvider(T,B,W){const H=this._nextHandle();return this._adapter.set(H,new le(new re(this._proxy,this._documents,W,H),T)),this._proxy.$registerDocumentOnDropProvider(H,this._transformDocumentSelector(B)),this._createDisposable(H)}$provideDocumentOnDropEdits(T,B,W,H,ne,he){return this._withAdapter(T,re,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(B,a.URI.revive(W),H,ne,he)),void 0,void 0)}static _serializeRegExp(T){return{pattern:T.source,flags:(0,w.regExpFlags)(T)}}static _serializeIndentationRule(T){return{decreaseIndentPattern:X._serializeRegExp(T.decreaseIndentPattern),increaseIndentPattern:X._serializeRegExp(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?X._serializeRegExp(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?X._serializeRegExp(T.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(T){return{beforeText:X._serializeRegExp(T.beforeText),afterText:T.afterText?X._serializeRegExp(T.afterText):void 0,previousLineText:T.previousLineText?X._serializeRegExp(T.previousLineText):void 0,action:T.action}}static _serializeOnEnterRules(T){return T.map(X._serializeOnEnterRule)}setLanguageConfiguration(T,B,W){let{wordPattern:H}=W;if(H&&(0,w.regExpLeadsToEndlessLoop)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this._documents.setWordDefinitionFor(B,H):this._documents.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const ne=this._nextHandle(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?X._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?X._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?X._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ne,B,he),this._createDisposable(ne)}$setWordDefinitions(T){for(const B of T)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=X,X._handlePool=0}),define(Se[197],De([1,0,4,8,6,32,14,7]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(O,v,p,b){this._documents=v,this._commands=p,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,v){await this._proxy.$changeLanguage(O,v);const p=this._documents.getDocumentData(O);if(!p)throw new Error(`document '${O.toString()}' NOT found`);return p.document}async tokenAtPosition(O,v){const p=O.version,b=D.Position.from(v),f=await this._proxy.$tokensAtPosition(O.uri,b),u={type:g.StandardTokenType.Other,range:O.getWordRangeAtPosition(v)??new g.Range(v.line,v.character,v.line,v.character)};if(!f)return u;const d={range:D.Range.to(f.range),type:D.TokenType.to(f.type)};return!d.range.contains(v)||p!==O.version?u:d}createLanguageStatusItem(O,v,p){const b=this._handlePool++,f=this._proxy,u=this._ids,d=`${O.identifier.value}/${v}`;if(u.has(d))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);u.add(d);const c={selector:p,id:v,name:O.displayName??O.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,S=new P.DisposableStore;const l=()=>{y?.dispose(),y=(0,I.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(b,{id:d,name:c.name??O.displayName??O.name,source:O.displayName??O.name,selector:D.DocumentSelector.from(c.selector,this._uriTransformer),label:c.text,detail:c.detail??"",severity:c.severity===g.LanguageStatusSeverity.Error?N.default.Error:c.severity===g.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:c.command&&this._commands.toInternal(c.command,S),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},_={dispose(){S.dispose(),y?.dispose(),f.$removeLanguageStatus(b),u.delete(d)},get id(){return c.id},get name(){return c.name},set name(r){c.name=r,l()},get selector(){return c.selector},set selector(r){c.selector=r,l()},get text(){return c.text},set text(r){c.text=r,l()},get detail(){return c.detail},set detail(r){c.detail=r,l()},get severity(){return c.severity},set severity(r){c.severity=r,l()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(r){c.accessibilityInformation=r,l()},get command(){return c.command},set command(r){c.command=r,l()},get busy(){return c.busy},set busy(r){c.busy=r,l()}};return l(),_}}e.ExtHostLanguages=w}),define(Se[198],De([1,0,13,4,28,16,5]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends a.AbstractLoggerService{constructor(O,v){const p=new I.Emitter;super(v.logLevel,p.event);this._proxy=O.getProxy(D.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(p)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,v,p){return new w(this._proxy,O,v,p)}};P=$e([ze(0,N.IExtHostRpcService),ze(1,g.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class w extends a.AbstractMessageLogger{constructor(O,v,p,b){super(b?.always);this.proxy=O,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(v,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,v){const p=[[O,v]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Se[199],De([1,0,4,13,24]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(P){return P&&P.title}let I=class{constructor(w,A){this._logService=A,this._proxy=w.getProxy(a.MainContext.MainThreadMessageService)}showMessage(w,A,O,v,p){const b={source:{identifier:w.identifier,label:w.displayName||w.name}};let f;typeof v=="string"||N(v)?f=[v,...p]:(b.modal=v?.modal,b.useCustom=v?.useCustom,b.detail=v?.detail,f=p),b.useCustom&&(0,g.checkProposedApiEnabled)(w,"resolvers");const u=[];for(let d=0;d<f.length;d++){const c=f[d];if(typeof c=="string")u.push({title:c,handle:d,isCloseAffordance:!1});else if(typeof c=="object"){let{title:y,isCloseAffordance:S}=c;u.push({title:y,isCloseAffordance:!!S,handle:d})}else this._logService.warn("Invalid message item:",c)}return this._proxy.$showMessage(A,O,b,u).then(d=>{if(typeof d=="number")return f[d]})}};I=$e([ze(1,D.ILogService)],I),e.ExtHostMessageService=I}),define(Se[200],De([1,0,25,5,95,7,21,9,10,2,63,4,36,8,6,39,174,90]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(l,_,r,k,i){this._textDocumentsAndEditors=r,this._textDocuments=k,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=_.converter,_.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,t=s.cell.handle,m=this._documents.get(n)?.getCell(t);if(m)return m.apiCell}return s}}),y._registerApiCommands(_)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const _=this._editors.get(l);if(!_)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return _}getIdByEditor(l){for(const[_,r]of this._editors)if(r.apiEditor===l)return _}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,_){const r=this._documents.get(l);if(!r&&!_)throw new Error(`NO notebook document for '${l}'`);return r}_getProviderData(l){const _=this._notebookContentProviders.get(l);if(!_)throw new Error(`NO provider for '${l}'`);return _}registerNotebookContentProvider(l,_,r,k,i){if((0,P.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(_))throw new Error(`Notebook provider for '${_}' already registered`);this._notebookContentProviders.set(_,{extension:l,provider:r});let s;return r.onDidChangeNotebookContentOptions&&(s=r.onDidChangeNotebookContentOptions(()=>{const n=b.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(_,n)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},_,b.NotebookDocumentContentOptions.from(k),y._convertNotebookRegistrationData(l,i)),new f.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(_),this._notebookProxy.$unregisterNotebookProvider(_)})}static _convertNotebookRegistrationData(l,_){if(!_)return;const r=_.filenamePattern.map(k=>b.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(_.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${_.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:_.displayName,filenamePattern:r,exclusive:_.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,_,r){const k=y._notebookStatusBarItemProviderHandlePool++,i=typeof r.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(k,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(k,i,_);let s;return i!==void 0&&(s=r.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(i))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(k),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(k,i),s&&s.dispose()})}async createNotebookDocument(l){const _=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&b.NotebookData.from(l.content)});return A.URI.revive(_)}async openNotebookDocument(l){const _=this._documents.get(l);if(_)return _.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(l),k=this._documents.get(A.URI.revive(r));return(0,w.assertIsDefined)(k?.apiNotebook)}async showNotebookDocument(l,_){A.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let r;typeof _=="object"?r={position:b.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selections:_.selections&&_.selections.map(b.NotebookRange.from),pinned:typeof _.preview=="boolean"?!_.preview:void 0}:r={preserveFocus:!1};const k=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,r),i=k&&this._editors.get(k)?.apiEditor;if(i)return i;throw k?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,_,r,k){const i=this._notebookStatusBarItemProviders.get(l),s=A.URI.revive(_),n=this._documents.get(s);if(!n||!i)return;const t=n.getCellFromIndex(r);if(!t)return;const o=await i.provideCellStatusBarItems(t.apiCell,k);if(!o)return;const m=new N.DisposableStore,h=this._statusBarCache.add([m]),F=(Array.isArray(o)?o:[o]).map(U=>b.NotebookStatusBarItem.from(U,this._commandsConverter,m));return{cacheId:h,items:F}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,_,r,k,i){if((0,P.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,r),this._notebookProxy.$registerNotebookSerializer(s,{id:l.identifier,location:l.extensionLocation},_,b.NotebookDocumentContentOptions.from(k),y._convertNotebookRegistrationData(l,i)),(0,N.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(l,_,r){const k=this._notebookSerializer.get(l);if(!k)throw new Error("NO serializer found");const i=await k.deserializeNotebook(_.buffer,r);return new u.SerializableObjectWithBuffers(b.NotebookData.from(i))}async $notebookToData(l,_,r){const k=this._notebookSerializer.get(l);if(!k)throw new Error("NO serializer found");const i=await k.serializeNotebook(b.NotebookData.to(_.value),r);return a.VSBuffer.wrap(i)}async $openNotebook(l,_,r,k,i){const{provider:s}=this._getProviderData(l),n=await s.openNotebook(A.URI.revive(_),{backupId:r,untitledDocumentData:k?.buffer},i);return new u.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(b.NotebookCellData.from)})}async $saveNotebook(l,_,r){const k=this.getNotebookDocument(A.URI.revive(_)),{provider:i}=this._getProviderData(l);return await i.saveNotebook(k.apiNotebook,r),!0}async $saveNotebookAs(l,_,r,k){const i=this.getNotebookDocument(A.URI.revive(_)),{provider:s}=this._getProviderData(l);return await s.saveNotebookAs(A.URI.revive(r),i.apiNotebook,k),!0}async $backupNotebook(l,_,r){const k=this.getNotebookDocument(A.URI.revive(_)),i=this._getProviderData(l),s=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),n=String((0,g.hash)([k.uri.toString(),this._backupIdPool++])),t=A.URI.joinPath(s,n),o=await i.provider.backupNotebook(k.apiNotebook,{destination:t},r);return k.updateBackup(o),o.id}_createExtHostEditor(l,_,r){if(this._editors.has(_))throw new Error(`editor with id ALREADY EXSIST: ${_}`);const k=new c.ExtHostNotebookEditor(_,this._notebookEditorsProxy,l,r.visibleRanges.map(b.NotebookRange.to),r.selections.map(b.NotebookRange.to),typeof r.viewColumn=="number"?b.ViewColumn.to(r.viewColumn):void 0);this._editors.set(_,k)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const r of l.value.removedDocuments){const k=A.URI.revive(r),i=this._documents.get(k);i&&(i.dispose(),this._documents.delete(k),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===k.toString()&&this._editors.delete(s.id)}if(l.value.addedDocuments){const r=[];for(const k of l.value.addedDocuments){const i=A.URI.revive(k.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const s=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,k);r.push(...k.cells.map(n=>d.ExtHostCell.asModelAddData(s.apiNotebook,n))),this._documents.get(i)?.dispose(),this._documents.set(i,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(l.value.addedEditors)for(const r of l.value.addedEditors){if(this._editors.has(r.id))return;const k=A.URI.revive(r.documentUri),i=this._documents.get(k);i&&this._createExtHostEditor(i,r.id,r)}const _=[];if(l.value.removedEditors)for(const r of l.value.removedEditors){const k=this._editors.get(r);k&&(this._editors.delete(r),this._activeNotebookEditor?.id===k.id&&(this._activeNotebookEditor=void 0),_.push(k))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(k=>this._editors.get(k)).filter(k=>!!k);const r=new Set;this._visibleNotebookEditors.forEach(k=>r.add(k.id));for(const k of this._editors.values()){const i=r.has(k.id);k._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(k=>k).filter(k=>k.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const _=p.ApiCommandArgument.String.with("notebookType","A notebook type"),r=new p.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[_,new p.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>a.VSBuffer.wrap(i))],new p.ApiCommandResult("Notebook Data",i=>b.NotebookData.to(i.value))),k=new p.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[_,new p.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new u.SerializableObjectWithBuffers(b.NotebookData.from(i)))],new p.ApiCommandResult("Bytes",i=>i.buffer));l.registerApiCommand(r),l.registerApiCommand(k)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(Se[201],De([1,0,5,56,13,4,16,8]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class w{constructor(v,p){const b=w._Keys.nextId();v.$registerNotebookEditorDecorationType(b,P.NotebookDecorationRenderOptions.from(p)),this.value={key:b,dispose(){v.$removeNotebookEditorDecorationType(b)}}}}w._Keys=new D.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(v,p,b){this._logService=v,this._extHostRpc=p,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(v){return new w(this._extHostRpc.getProxy(N.MainContext.MainThreadNotebookEditors),v).value}$acceptEditorPropertiesChanged(v,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,p);const b=this._notebooksAndEditors.getEditorById(v);p.visibleRanges&&b._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&b._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const p in v)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(v[p]))}};A=$e([ze(0,g.ILogService),ze(1,I.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(Se[96],De([1,0,15,14,20,5,7,21,2,26,13,4,36,8,6,66,168,24,39]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(s,n,t,o,m){this._initData=n,this._extHostNotebook=t,this._commands=o,this._logService=m,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(v.MainContext.MainThreadNotebookKernels);const h=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const F=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:F}}else if(C&&"notebookEditor"in C){const F=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:F}}return C})],p.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(s,n,t,o,m,h){for(const fe of this._kernelData.values())if(fe.controller.id===n&&A.ExtensionIdentifier.equals(s.identifier,fe.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const C=this._handlePool++,F=this;this._logService.trace(`NotebookController[${C}], CREATED by ${s.identifier.value}, ${n}`);const U=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${s.identifier}'`);let R=!1;const E=new I.DisposableStore,x=new N.Emitter,z=new N.Emitter,V={id:k(s.identifier,n),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:o||s.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let se=m??U,K;this._proxy.$addKernel(C,V).catch(fe=>{console.log(fe),R=!0});let L=0;const oe=()=>{if(R)return;const fe=++L;Promise.resolve().then(()=>{fe===L&&this._proxy.$updateKernel(C,V)})},de=new P.ResourceMap,ae={get id(){return n},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return V.label},set label(fe){V.label=fe??s.displayName??s.name,oe()},get detail(){return V.detail??""},set detail(fe){V.detail=fe,oe()},get description(){return V.description??""},set description(fe){V.description=fe,oe()},get kind(){return(0,c.checkProposedApiEnabled)(s,"notebookControllerKind"),V.kind??""},set kind(fe){(0,c.checkProposedApiEnabled)(s,"notebookControllerKind"),V.kind=fe,oe()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(fe){V.supportedLanguages=fe,oe()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){V.supportsExecutionOrder=fe,oe()},get rendererScripts(){return V.preloads?V.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(fe){se=fe??U},get interruptHandler(){return K},set interruptHandler(fe){K=fe,V.supportsInterrupt=Boolean(fe),oe()},createNotebookCellExecution(fe){if(R)throw new Error("notebook controller is DISPOSED");if(!de.has(fe.notebook.uri))throw F._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return F._createNotebookCellExecution(fe,k(s.identifier,this.id))},dispose:()=>{R||(this._logService.trace(`NotebookController[${C}], DISPOSED`),R=!0,this._kernelData.delete(C),E.dispose(),x.dispose(),z.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(fe,ee){F._proxy.$updateNotebookPriority(C,fe.uri,ee)},onDidReceiveMessage:z.event,postMessage(fe,ee){return(0,c.checkProposedApiEnabled)(s,"notebookMessaging"),F._proxy.$postMessage(C,ee&&F._extHostNotebook.getIdByEditor(ee),fe)},asWebviewUri(fe){return(0,c.checkProposedApiEnabled)(s,"notebookMessaging"),(0,u.asWebviewUri)(fe,F._initData.remote)}};return this._kernelData.set(C,{extensionId:s.identifier,controller:ae,onDidReceiveMessage:z,onDidChangeSelection:x,associatedNotebooks:de}),ae}getIdByController(s){for(const[n,t]of this._kernelData)if(t.controller===s)return k(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,n,t){const o=this._kernelData.get(s);if(o){const m=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));t?o.associatedNotebooks.set(m.uri,!0):o.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,m.uri.toString(),t),o.onDidChangeSelection.fire({selected:t,notebook:m.apiNotebook})}}async $executeCells(s,n,t){const o=this._kernelData.get(s);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(w.URI.revive(n)),h=[];for(const C of t){const F=m.getCell(C);F&&h.push(F.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,m.uri.toString(),h.length),await o.controller.executeHandler.call(o.controller,h,m.apiNotebook,o.controller)}catch(C){this._logService.error(`NotebookController[${s}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(s,n,t){const o=this._kernelData.get(s);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(w.URI.revive(n));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,m.apiNotebook);else for(const h of t){const C=m.getCell(h);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,t){const o=this._kernelData.get(s);if(!o)return;const m=this._extHostNotebook.getEditorById(n);o.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:t}))}$cellExecutionChanged(s,n,t){const m=this._extHostNotebook.getNotebookDocument(w.URI.revive(s)).getCell(n);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:t?b.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,n){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const m=new _(n,o,this._proxy);this._activeExecutions.set(o.uri,m);const h=m.onDidChangeState(()=>{m.state===l.Resolved&&(m.dispose(),h.dispose(),this._activeExecutions.delete(o.uri))});return m.asApiObject()}};S=$e([ze(4,O.ILogService)],S),e.ExtHostNotebookKernels=S;var l;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(l||(l={}));class _ extends I.Disposable{constructor(s,n,t){super();this._cell=n,this._proxy=t,this._handle=_.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new g.CancellationTokenSource),this._collector=new r(10,o=>this.update(o)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new y.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(s){return s.map(n=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?b.NotebookCellOutput.from(n):b.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,t){const o=this.validateAndConvertOutputs((0,a.asArray)(s));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,append:t,outputs:o})}async updateOutputItems(s,n,t){return s=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(s),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:s.map(b.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===l.Resolved||s._state===l.Started)throw new Error("Cannot call start again");s._state=l.Started,s._onDidChangeState.fire(),s.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,o){if(s._state===l.Resolved)throw new Error("Cannot call resolve twice");s._state=l.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new y.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,o){return s.verifyStateForOutput(),s.updateOutputs(t,o,!0)},replaceOutput(t,o){return s.verifyStateForOutput(),s.updateOutputs(t,o,!1)},appendOutputItems(t,o){return s.verifyStateForOutput(),s.updateOutputItems(t,o,!0)},replaceOutputItems(t,o){return s.verifyStateForOutput(),s.updateOutputItems(t,o,!1)}})}}_.HANDLE=0;class r{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new D.DeferredPromise,this.startedTimer=Date.now(),(0,D.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}function k(i,s){return`${i.value}/${s}`}e.createKernelId=k}),define(Se[202],De([1,0,5,7,21,13,4,96,24]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookProxyKernels=void 0;let A=class{constructor(v,p,b){this.extHostNotebook=p,this._logService=b,this._proxyKernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new a.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=v.getProxy(I.MainContext.MainThreadNotebookProxyKernels)}createNotebookProxyController(v,p,b,f,u){const d=this._handlePool++;let c=!1;const y=new D.DisposableStore,S=new a.Emitter,l={id:(0,P.createKernelId)(v.identifier,p),notebookType:b,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:f||v.identifier.value};let _=u;this._proxy.$addProxyKernel(d,l).catch(n=>{console.log(n),c=!0});let r=0;const k=()=>{if(c)return;const n=++r;Promise.resolve().then(()=>{n===r&&this._proxy.$updateProxyKernel(d,l)})},i=new g.ResourceMap,s={get id(){return p},get notebookType(){return l.notebookType},onDidChangeSelectedNotebooks:S.event,get label(){return l.label},set label(n){l.label=n??v.displayName??v.name,k()},get detail(){return l.detail??""},set detail(n){l.detail=n,k()},get description(){return l.description??""},set description(n){l.description=n,k()},get kind(){return(0,w.checkProposedApiEnabled)(v,"notebookControllerKind"),l.kind??""},set kind(n){(0,w.checkProposedApiEnabled)(v,"notebookControllerKind"),l.kind=n,k()},get resolveHandler(){return _},dispose:()=>{c||(this._logService.trace(`NotebookProxyController[${d}], DISPOSED`),c=!0,this._proxyKernelData.delete(d),y.dispose(),S.dispose(),this._proxy.$removeProxyKernel(d))}};return this._proxyKernelData.set(d,{extensionId:v.identifier,controller:s,onDidChangeSelection:S,associatedNotebooks:i}),s}async $resolveKernel(v){const p=this._proxyKernelData.get(v);if(!p)return null;const b=await p.controller.resolveHandler();return typeof b=="string"?b:this.extHostNotebook.getIdByController(b)}};A=$e([ze(2,N.ILogService)],A),e.ExtHostNotebookProxyKernels=A}),define(Se[203],De([1,0,5,4,90,24]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class I{constructor(w,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=w.getProxy(D.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(w,A,O){const v=this._extHostNotebook.getEditorById(w);this._rendererMessageEmitters.get(A)?.fire({editor:v.apiEditor,message:O})}createRendererMessaging(w,A){if(!w.contributes?.notebookRenderer?.some(b=>b.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const O=(0,N.isProposedApiEnabled)(w,"notebookEditor"),v=new WeakMap;return{onDidReceiveMessage:(b,f,u)=>{const d=O?b:c=>{const y={};v.set(y,c.editor),b({editor:y,message:c.message})};return this.getOrCreateEmitterFor(A).event(d,f,u)},postMessage:(b,f)=>{g.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,f]=[f,b]);const u=O?f:v.get(f),d=u&&g.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(d?.id,A,b)}}}getOrCreateEmitterFor(w){let A=this._rendererMessageEmitters.get(w);return A||(A=new a.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(w)}}),this._rendererMessageEmitters.set(w,A),A)}}e.ExtHostNotebookRenderers=I}),define(Se[204],De([1,0,20,5,7,4,2,6,12,15,32,62]),function(Z,e,a,D,g,N,I,P,w,A,O,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(b,f,u){const d=b.getProxy(N.MainContext.MainThreadQuickOpen);class c{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,o=a.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(n),h=++this._instances,C=d.$show(h,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},o),F={},U=C.then(()=>F);return Promise.race([U,m]).then(R=>{if(R!==F)return m.then(E=>{const x=[];for(let z=0;z<E.length;z++){const V=E[z];typeof V=="string"?x.push({label:V,handle:z}):V.kind===P.QuickPickItemKind.Separator?x.push({type:"separator",label:V.label}):x.push({label:V.label,description:V.description,detail:V.detail,picked:V.picked,alwaysShow:V.alwaysShow,handle:z})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{t.onDidSelectItem(E[z])}),d.$setItems(h,x),C.then(z=>{if(typeof z=="number")return E[z];if(Array.isArray(z))return z.map(V=>E[V])})})}).then(void 0,R=>{if(!(0,w.isCancellationError)(R))return d.$setError(h,R),Promise.reject(R)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=a.CancellationToken.None){return this._validateInput=n?.validateInput,d.$input(n,typeof this._validateInput=="function",t).then(void 0,o=>{if(!(0,w.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let o;switch(t.severity){case P.InputBoxValidationSeverity.Info:o=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:o=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:o=O.default.Error;break;default:o=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:o}}async showWorkspaceFolderPick(n,t=a.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!o)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(h=>h.uri.toString()===o.uri.toString())}createQuickPick(n){const t=new k(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new i(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const o=this._sessions.get(n);o&&o._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const o=this._sessions.get(n);o instanceof k&&o._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const o=this._sessions.get(n);o instanceof k&&o._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const o=this._sessions.get(n);o&&o._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,o){const m=this._sessions.get(n);m instanceof k&&m._fireDidTriggerItemButton(t,o)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class y{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=k._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,o)=>{const m=t===P.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(m,t)}),this.update({buttons:n.map((t,o)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,g.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const o=n[t];this._pendingUpdate[t]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}y._nextId=1;function S(s){if(s instanceof P.ThemeIcon)return{id:s.id};const n=_(s),t=l(s);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof t=="string"?I.URI.file(t):t}}function l(s){return typeof s=="object"&&"light"in s?s.light:s}function _(s){return typeof s=="object"&&"dark"in s?s.dark:s}function r(s){const n=S(s.iconPath);let t,o;return"id"in n?o=v.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:o}}class k extends y{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,m)=>{this._handlesToItems.set(m,o),this._itemsToHandles.set(o,m)});const t=[];for(let o=0;o<n.length;o++){const m=n[o];m.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:m.label}):t.push({handle:o,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((h,C)=>({...r(h),tooltip:h.tooltip,handle:C}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,A.coalesce)(n.map(o=>this._handlesToItems.get(o)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,A.coalesce)(n.map(o=>this._handlesToItems.get(o)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const o=this._handlesToItems.get(n);if(!o||!o.buttons||!o.buttons.length)return;const m=o.buttons[t];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:o})}}class i extends y{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:O.default.Error}):this.update({validationMessage:n.message,severity:n.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new c(f,u)}e.createExtHostQuickOpen=p});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[205],De([1,0,2,5,55,7,14,4,15,111,13,26,62,8,24]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f){"use strict";var u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(m){if(m)return typeof m.iconPath=="string"?a.URI.file(m.iconPath):a.URI.isUri(m.iconPath)||p.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function y(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const C=typeof m.iconPath=="string"?m.iconPath:a.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,F=typeof h.iconPath=="string"?h.iconPath:a.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,A.comparePaths)(C,F)}function S(m,h){let C=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(C=y(m,h),C!==0)return C;if(m.light&&h.light)C=y(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(C!==0)return C;if(m.dark&&h.dark)C=y(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return C}function l(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let C=0;C<m.arguments.length;C++){const F=m.arguments[C],U=h.arguments[C];if(F!==U)return F<U?-1:1}return 0}function _(m,h){let C=(0,A.comparePaths)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(C!==0)return C;if(m.command&&h.command)C=l(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(C!==0)return C;if(m.decorations&&h.decorations)C=S(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return C}function r(m,h){for(let C=0;C<m.length;C++)if(m[C]!==h[C])return!1;return!0}function k(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?r(m.arguments,h.arguments):m.arguments===h.arguments)}function i(m,h){return(0,w.equals)(m,h,k)}class s{constructor(h,C,F){this._extension=h,this._sourceControlHandle=F,u.set(this,void 0),this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._visible=!0,Qe(this,u,C,"f")}get value(){return this._value}set value(h){h=h??"",Re(this,u,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Re(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Re(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Re(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,C){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Re(this,u,"f").$showValidationMessage(this._sourceControlHandle,h,C)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=s,u=new WeakMap;class n{constructor(h,C,F,U,R){this._proxy=h,this._commands=C,this._sourceControlHandle=F,this._id=U,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,C){const F=this._resourceStatesCommandsMap.get(h);return F?(0,I.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(_),F=(0,w.sortedDiff)(this._resourceSnapshot,h,_).map(E=>{const x=E.toInsert.map(z=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,z);const se=z.resourceUri;let K;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ve=new N.DisposableStore;K=this._commands.converter.toInternal(z.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,z.command);const L=c(z.decorations),oe=z.decorations&&c(z.decorations.light)||L,de=z.decorations&&c(z.decorations.dark)||L,ae=[oe,de],fe=z.decorations&&z.decorations.tooltip||"",ee=z.decorations&&!!z.decorations.strikeThrough,Ee=z.decorations&&!!z.decorations.faded,we=z.contextValue||"";return{rawResource:[V,se,ae,fe,ee,Ee,we,K],handle:V}});return{start:E.start,deleteCount:E.deleteCount,toInsert:x}}),U=F.map(({start:E,deleteCount:x,toInsert:z})=>[E,x,z.map(V=>V.rawResource)]),R=F.reverse();for(const{start:E,deleteCount:x,toInsert:z}of R){const V=z.map(K=>K.handle),se=this._handlesSnapshot.splice(E,x,...V);for(const K of se)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=h,U}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(h,C,F,U,R,E){this._extension=h,this._commands=F,this._id=U,this._label=R,this._rootUri=E,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Qe(this,d,C,"f"),this._inputBox=new s(h,Re(this,d,"f"),this.handle),Re(this,d,"f").$registerSourceControl(this.handle,U,R,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Re(this,d,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Re(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Re(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=h;const C=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Re(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=h;const C=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;Re(this,d,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&i(this._statusBarCommands,h))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=h;const C=(h||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Re(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(h,C){const F=new n(Re(this,d,"f"),this._commands,this.handle,h,C),U=D.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,U),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const h=[],C=[];for(const[F,U]of this.createdResourceGroups){U.dispose();const R=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});D.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),R.dispose(),this._groups.delete(F.handle),Re(this,d,"f").$unregisterGroup(this.handle,F.handle)}),h.push([F.handle,F.id,F.label,F.features]);const E=F._takeResourceStateSnapshot();E.length>0&&C.push([F.handle,E]),this._groups.set(F.handle,F)}Re(this,d,"f").$registerGroups(this.handle,h,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(C=>{const F=C._takeResourceStateSnapshot();F.length!==0&&h.push([C.handle,F])}),h.length>0&&Re(this,d,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Re(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,$e([(0,g.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),$e([(0,g.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let o=class Qi{constructor(h,C,F){this._commands=C,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=h.getProxy(P.MainContext.MainThreadSCM),this._telemetry=h.getProxy(P.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const R=this._sourceControls.get(U.sourceControlHandle);if(!R)return U;const E=R.getResourceGroup(U.groupHandle);return E?E.getResourceState(U.handle):U}else if(U&&U.$mid===4){const R=this._sourceControls.get(U.sourceControlHandle);return R?R.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const R=this._sourceControls.get(U.handle);return R||U}return U}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,C,F,U){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,C,F,U),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const R=Qi._handlePool++,E=new t(h,this._proxy,this._commands,C,F,U);this._sourceControls.set(R,E);const x=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier))||[];return x.push(E),this._sourceControlsByExtension.set(v.ExtensionIdentifier.toKey(h.identifier),x),E}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const C=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier)),F=C&&C[C.length-1];return F&&F.inputBox}$provideOriginalResource(h,C,F){const U=a.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,U.toString());const R=this._sourceControls.get(h);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(U,F)).then(E=>E||null)}$onInputBoxValueChange(h,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const F=this._sourceControls.get(h);return F&&F.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(h,C,F,U){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,C,F);const R=this._sourceControls.get(h);if(!R)return Promise.resolve(void 0);const E=R.getResourceGroup(C);return E?E.$executeResourceCommand(F,U):Promise.resolve(void 0)}$validateInput(h,C,F){this.logService.trace("ExtHostSCM#$validateInput",h);const U=this._sourceControls.get(h);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>U.inputBox.validateInput(C,F)).then(R=>{if(!R)return Promise.resolve(void 0);const E=b.MarkdownString.fromStrict(R.message);return E?Promise.resolve([E,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};o._handlePool=0,o=$e([ze(2,O.ILogService)],o),e.ExtHostSCM=o});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[206],De([1,0,6,4,131,7,8,10]),function(Z,e,a,D,g,N,I,P){"use strict";var w,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,u,d,c,y=a.StatusBarAlignment.Left,S){w.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new N.DisposableStore,Qe(this,w,f,"f"),Qe(this,A,u,"f"),this._entryId=O.ID_GEN++,this._extension=d,this._id=c,this._alignment=y,this._priority=this.validatePriority(S)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Re(this,A,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Re(this,A,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let u;this._name?u=this._name:u=(0,g.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const c=I.MarkdownString.fromStrict(this._tooltip);Re(this,w,"f").$setEntry(this._entryId,f,u,this._text,c,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,w=new WeakMap,A=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class v{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,g.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const u={message:f};return this._messages.unshift(u),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(u);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(f,u){this._proxy=f.getProxy(D.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new v(this)}createStatusBarEntry(f,u,d,c){return new O(this._proxy,this._commands,f,u,d,c)}setStatusBarMessage(f,u){const d=this._statusMessage.setMessage(f);let c;return typeof u=="number"?c=setTimeout(()=>d.dispose(),u):typeof u!="undefined"&&u.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=p}),define(Se[71],De([1,0,4,5,3]),function(Z,e,a,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(P){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,w){this._proxy.$registerExtensionStorageKeysToSync(P,w)}initializeExtensionStorage(P,w,A){return this._proxy.$initializeExtensionStorage(P,w).then(O=>O||A)}setValue(P,w,A){return this._proxy.$setValue(P,w,A)}$acceptValue(P,w,A){this._onDidChangeStorage.fire({shared:P,key:w,value:A})}}e.ExtHostStorage=N,e.IExtHostStorage=(0,g.createDecorator)("IExtHostStorage")}),define(Se[72],De([1,0,3,28,13,51,2]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,O,v){this._logService=O,this._extHostFileSystem=v,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(A){return I.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,O=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(A){if(this._value)return I.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return I.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=$e([ze(0,D.IExtHostInitDataService),ze(1,g.ILogService),ze(2,N.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Se[52],De([1,0,5,4,3,2,16,7,6,132,12,170,20,42,152,62,10,14]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,g.createDecorator)("IExtHostTerminalService");class y{constructor(t,o,m,h){this._proxy=t,this._id=o,this._creationOptions=m,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(F=>this._pidPromiseComplete=F);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(F,U=!0){C._checkDisposed(),C._proxy.$sendText(C._id,F,U)},show(F){C._checkDisposed(),C._proxy.$show(C._id,F)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(t,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(i(t.iconPath)),color:u.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(t.location,o?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,o,m,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:u.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,o){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,o){return t===this._cols&&o===this._rows||t===0||o===0?!1:(this._cols=t,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=y;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,o){this._pty.setDimensions?.({columns:t,rows:o})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let l=1,_=class extends P.Disposable{constructor(t,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[m,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,o){const m=new y(this._proxy,(0,b.generateUuid)(),t,t.name),h=new S(t.pty);return m.createExtensionTerminal(t.location,this._serializeParentTerminal(t,o).resolvedExtHostIdentifier,i(t.iconPath),s(t.color)).then(C=>{const F=this._setupExtHostProcessListeners(C,h);this._terminalProcessDisposables[C]=F}),this._terminals.push(m),m.value}_serializeParentTerminal(t,o){if(o=o||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const m=t.location.parentTerminal;if(m){const h=this._terminals.find(C=>C.value===m);h&&(o.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?o.location=t.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(t,o){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new S(o),C=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=C}async $acceptActiveTerminalChanged(t){const o=this._activeTerminal;if(t===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(t);m&&(this._activeTerminal=m,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,o){const m=this._getTerminalById(t);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:o})}async $acceptTerminalDimensions(t,o,m){const h=this._getTerminalById(t);h&&h.setDimensions(o,m)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,o,m){this._terminalProcesses.get(t)?.resize(o,m)}async $acceptTerminalTitleChange(t,o){const m=this._getTerminalById(t);m&&(m.name=o)}async $acceptTerminalClosed(t,o){const m=this._getTerminalObjectIndexById(this._terminals,t);if(m!==null){const h=this._terminals.splice(m,1)[0];h.setExitCode(o),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,o,m,h){if(o){const U=this._getTerminalObjectIndexById(this._terminals,o);if(U!==null){this._terminals[U]._id=t,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const C={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:N.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},F=new y(this._proxy,t,C,m);this._terminals.push(F),this._onDidOpenTerminal.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(t,o){const m=this._getTerminalById(t);m&&m._setProcessId(o)}async $startExtensionTerminal(t,o){const m=this._getTerminalById(t);if(!m)return{message:(0,A.localize)(0,null,t)};m.isOpen||await new Promise(C=>{const F=this.onDidOpenTerminal(async U=>{U===m.value&&(F.dispose(),C())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(o):this._extensionTerminalAwaitingStart[t]={initialDimensions:o}}_setupExtHostProcessListeners(t,o){const m=new P.DisposableStore;m.add(o.onProcessReady(C=>this._proxy.$sendProcessReady(t,C.pid,C.cwd))),m.add(o.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(t,C))),this._bufferer.startBuffering(t,o.onProcessData),m.add(o.onProcessExit(C=>this._onProcessExit(t,C))),this._terminalProcesses.set(t,o);const h=this._extensionTerminalAwaitingStart[t];return h&&o instanceof S&&(o.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),m}$acceptProcessAckDataEvent(t,o){this._terminalProcesses.get(t)?.acknowledgeDataEvent(o)}$acceptProcessInput(t,o){this._terminalProcesses.get(t)?.input(o)}$acceptTerminalInteraction(t){const o=this._getTerminalById(t);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(t,o,m){try{this._terminalProcesses.get(t)?.resize(o,m)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,o){this._terminalProcesses.get(t)?.shutdown(o)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:o}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,o,m){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,m),this._proxy.$registerProfileProvider(o,t.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(t,o){const m=new p.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,o);return}this.createTerminalFromOptions(h.options,o)}}async $provideLinks(t,o){const m=this._getTerminalById(t);if(!m)return[];this._terminalLinkCache.delete(t);const h=this._terminalLinkCancellationSource.get(t);h&&h.dispose(!0);const C=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,C);const F=[],U={terminal:m.value,line:o},R=[];for(const z of this._linkProviders)R.push(c.Promises.withAsyncBody(async V=>{C.token.onCancellationRequested(()=>V({provider:z,links:[]}));const se=await z.provideTerminalLinks(U,C.token)||[];C.token.isCancellationRequested||V({provider:z,links:se})}));const E=await Promise.all(R);if(C.token.isCancellationRequested)return[];const x=new Map;for(const z of E)z&&z.links.length>0&&F.push(...z.links.map(V=>{const se={id:l++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return x.set(se.id,{provider:z.provider,link:V}),se}));return this._terminalLinkCache.set(t,x),F}$activateLink(t,o){const m=this._terminalLinkCache.get(t)?.get(o);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(t,o){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const m=this._terminalProcessDisposables[t];m&&(m.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,o)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,o){const m=this._getTerminalObjectIndexById(t,o);return m!==null?t[m]:null}_getTerminalObjectIndexById(t,o){let m=null;return t.some((h,C)=>h._id===o?(m=C,!0):!1),m}getEnvironmentVariableCollection(t){let o=this._environmentVariableCollections.get(t.identifier.value);return o||(o=new r,this._setEnvironmentVariableCollection(t.identifier.value,o)),o}_syncEnvironmentVariableCollection(t,o){const m=(0,v.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(t,o.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(t){t.forEach(o=>{const m=o[0],h=new r(o[1]);this._setEnvironmentVariableCollection(m,h)})}$acceptDefaultProfile(t,o){this._defaultProfile=t,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(t,o){this._environmentVariableCollections.set(t,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,o)})}};_=$e([ze(1,I.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class r{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,o){this._setIfDiffers(t,{value:o,type:w.EnvironmentVariableMutatorType.Replace})}append(t,o){this._setIfDiffers(t,{value:o,type:w.EnvironmentVariableMutatorType.Append})}prepend(t,o){this._setIfDiffers(t,{value:o,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,o){const m=this.map.get(t);(!m||m.value!==o.value||m.type!==o.type)&&(this.map.set(t,o),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,o){this.map.forEach((m,h)=>t.call(o,h,m,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let k=class extends _{constructor(t){super(!1,t)}createTerminal(t,o,m){throw new O.NotSupportedError}createTerminalFromOptions(t,o){throw new O.NotSupportedError}};k=$e([ze(0,I.IExtHostRpcService)],k),e.WorkerExtHostTerminalService=k;function i(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function s(n){return u.ThemeColor.isThemeColor(n)?n:void 0}});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[207],De([1,0,15,25,20,5,161,95,7,27,10,42,4,16,91,8,6,46,67,47]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S){"use strict";var l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(R,E){this.resultsChangedEmitter=new N.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(p.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new i(this.proxy),E.registerArgumentProcessor({processArgument:x=>x?.$mid===13?(0,f.toItemFromContext)(x):x})}createTestController(R,E,x){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const z=new w.DisposableStore,V=z.add(new f.ExtHostTestItemCollection(R,E));V.root.label=E;const se=new Map,K=this.proxy,L={items:V.root.children,get label(){return E},set label(de){E=de,V.root.label=de,K.$updateController(R,{label:E})},get refreshHandler(){return x},set refreshHandler(de){x=de,K.$updateController(R,{canRefresh:!!de})},get id(){return R},createRunProfile:(de,ae,fe,ee,Ee)=>{let we=(0,P.hash)(de);for(;se.has(we);)we++;return new C(this.proxy,se,R,we,de,ae,fe,ee,Ee)},createTestItem(de,ae,fe){return new f.TestItemImpl(R,de,ae,fe)},createTestRun:(de,ae,fe=!0)=>this.runTracker.createTestRun(R,V,de,ae,fe),set resolveHandler(de){V.resolveHandler=de},get resolveHandler(){return V.resolveHandler},dispose:()=>{z.dispose()}};K.$registerTestController(R,E,!!x),z.add((0,w.toDisposable)(()=>K.$unregisterTestController(R)));const oe={controller:L,collection:V,profiles:se};return this.controllers.set(R,oe),z.add((0,w.toDisposable)(()=>this.controllers.delete(R))),z.add(V.onDidGenerateDiff(de=>K.$publishDiff(R,de.map(S.TestsDiffOp.serialize)))),L}createTestObserver(){return this.observer.checkout()}async runTests(R,E=g.CancellationToken.None){const x=s(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(x.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(V=>c.TestId.fromExtHostTestItem(V,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:F[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map(V=>V.id)},E)}$provideFileCoverage(R,E,x){return(0,a.mapFind)(this.runTracker.trackers,V=>V.id===R?V.getCoverage(E):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,E,x,z){return(0,a.mapFind)(this.runTracker.trackers,se=>se.id===R?se.getCoverage(E):void 0)?.resolveFileCoverage(x,z)??Promise.resolve([])}$configureRunProfile(R,E){this.controllers.get(R)?.profiles.get(E)?.configureHandler?.()}async $refreshTests(R,E){await this.controllers.get(R)?.controller.refreshHandler?.(E)}$publishTestResults(R){this.results=Object.freeze(R.map(E=>(0,A.deepFreeze)(u.TestResults.to(E))).concat(this.results).sort((E,x)=>x.completedAt-E.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,E){const x=this.controllers.get(c.TestId.fromString(R).controllerId)?.collection;x&&(await x.expand(R,E<0?1/0:E),x.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(S.TestsDiffOp.deserialize))}async $runControllerTests(R,E){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:z,profiles:V}=x,se=V.get(R.profileId);if(!se)return;const K=R.testIds.map(ae=>z.tree.get(ae)).filter(O.isDefined),L=R.excludeExtIds.map(ae=>x.collection.tree.get(ae)).filter(O.isDefined).filter(ae=>K.some(fe=>fe.fullId.compare(ae.fullId)===2));if(!K.length)return;const oe=new d.TestRunRequest(K.some(ae=>ae.actual instanceof f.TestItemRootImpl)?void 0:K.map(ae=>ae.actual),L.map(ae=>ae.actual),se),de=this.runTracker.prepareForMainThreadTestRun(oe,n.fromInternal(R,x.collection),E);try{await se.runHandler(oe,E)}finally{de.isRunning&&!E.isCancellationRequested&&await N.Event.toPromise(de.onEnd),de.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};r=$e([ze(0,b.IExtHostRpcService)],r),e.ExtHostTesting=r;class k extends w.Disposable{constructor(R,E,x){super();this.dto=R,this.proxy=E,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new N.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new g.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:z}of this.tasks.values())z.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const E=this.dto.id,x=this.dto.controllerId,z=(0,v.generateUuid)(),V=new t(this.proxy,E,z),se=de=>(ae,...fe)=>{if(L){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),de(ae,...fe))},K=(de,ae)=>{const fe=ae instanceof Array?ae.map(u.TestMessage.from):[u.TestMessage.from(ae)];if(de.uri&&de.range){const ee={range:u.Range.from(de.range),uri:de.uri};for(const Ee of fe)Ee.location=Ee.location||ee}this.proxy.$appendTestMessagesInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),fe)};let L=!1;const oe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return V.coverageProvider},set coverageProvider(de){V.coverageProvider=de},enqueued:se(de=>{this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),1)}),skipped:se(de=>{this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),5)}),started:se(de=>{this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),2)}),errored:se((de,ae,fe)=>{K(de,ae),this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),6,fe)}),failed:se((de,ae,fe)=>{K(de,ae),this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,x).toString(),4,fe)}),passed:se((de,ae)=>{this.proxy.$updateTestStateInRun(E,z,c.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,ae)}),appendOutput:(de,ae,fe)=>{L||(fe&&(this.dto.isIncluded(fe)?this.ensureTestIsKnown(fe):fe=void 0),this.proxy.$appendOutputToRun(E,z,D.VSBuffer.fromString(de),ae&&u.location.from(ae),fe&&c.TestId.fromExtHostTestItem(fe,x).toString()))},end:()=>{L||(L=!0,this.proxy.$finishedTestRunTask(E,z),this.tasks.delete(z),this.isRunning||this.dispose())}};return this.tasks.set(z,{run:oe,coverage:V}),this.proxy.$startedTestRunTask(E,{id:z,name:R,running:!0}),oe}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new y.InvalidTestItemError(R.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const E=[],x=this.dto.colllection.root;for(;;){const z=u.TestItem.from(R);if(E.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),R===x))break;R=R.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,E)}}class i{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,E,x){return this.getTracker(R,E,x)}cancelRunById(R){for(const E of this.tracked.values())if(E.id===R){E.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,E,x,z,V){const se=this.tracked.get(x);if(se)return se.createRun(z);const K=n.fromPublic(R,E,x,V),L=s(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:L&&{group:F[L.kind],id:L.profileId},exclude:x.exclude?.map(de=>c.TestId.fromExtHostTestItem(de,E.root.id).toString())??[],id:K.id,include:x.include?.map(de=>c.TestId.fromExtHostTestItem(de,E.root.id).toString())??[E.root.id],persist:V});const oe=this.getTracker(x,K);return oe.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),oe.createRun(z)}getTracker(R,E,x){const z=new k(E,this.proxy,x);return this.tracked.set(R,z),z.onEnd(()=>this.tracked.delete(R)),z}}e.TestRunCoordinator=i;const s=U=>{if(!!U.profile){if(!(U.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class n{constructor(R,E,x,z,V,se){this.controllerId=R,this.id=E,this.isPersisted=V,this.colllection=se,this.includePrefix=x.map(K=>K+"\0"),this.excludePrefix=z.map(K=>K+"\0")}static fromPublic(R,E,x,z){return new n(R,(0,v.generateUuid)(),x.include?.map(V=>c.TestId.fromExtHostTestItem(V,R).toString())??[R],x.exclude?.map(V=>c.TestId.fromExtHostTestItem(V,R).toString())??[],z,E)}static fromInternal(R,E){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,E)}isIncluded(R){const E=c.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(E===x||E.startsWith(x))return!1;for(const x of this.includePrefix)if(E===x||E.startsWith(x))return!0;return!1}}e.TestRunDto=n;class t{constructor(R,E,x){this.proxy=R,this.runId=E,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(E){throw this.fileCoverage=void 0,E}}async resolveFileCoverage(R,E){const x=await this.fileCoverage;let z=x?.[R];return!this._coverageProvider||!x||!z?[]:(z.detailedCoverage||(z=x[R]=await this._coverageProvider.resolveFileCoverage?.(z,E)??z),z.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class o extends S.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,u.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:E,removed:x}=this;return{get added(){return[...R].map(z=>z.revived)},get updated(){return[...E].map(z=>z.revived)},get removed(){return[...x].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new N.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,E){return{...R,revived:u.TestItem.toPlain(R.item),depth:E?E.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=m;class h{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(E=>E.revived)},dispose:(0,I.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class C{constructor(R,E,x,z,V,se,K,L=!1,oe=void 0){this.controllerId=x,this.profileId=z,this._label=V,this.kind=se,this.runHandler=K,this._isDefault=L,this._tag=oe,l.set(this,void 0),_.set(this,void 0),Qe(this,l,R,"f"),Qe(this,_,E,"f"),E.set(z,this);const de=F[se];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);Re(this,l,"f").$publishTestRunProfile({profileId:z,controllerId:x,tag:oe?u.TestTag.namespace(this.controllerId,oe.id):null,label:V,group:de,isDefault:L,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?u.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Re(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Re(this,_,"f")?.delete(this.profileId)&&(Qe(this,_,void 0,"f"),Re(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,l=new WeakMap,_=new WeakMap;const F={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Se[208],De([1,0,15,5,4,92,8,6]),function(Z,e,a,D,g,N,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(O,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new D.Emitter,this._onDidChangeTextEditorOptions=new D.Emitter,this._onDidChangeTextEditorVisibleRanges=new D.Emitter,this._onDidChangeTextEditorViewColumn=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(g.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const v=this._extHostDocumentsAndEditors.allEditors();return O?v:v.map(p=>p.value)}async showTextDocument(O,v,p){let b;typeof v=="number"?b={position:I.ViewColumn.from(v),preserveFocus:p}:typeof v=="object"?b={position:I.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?I.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:b={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,b),u=f&&this._extHostDocumentsAndEditors.getEditor(f);if(u)return u.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,v){return new N.TextEditorDecorationType(this._proxy,O,v).value}$acceptEditorPropertiesChanged(O,v){const p=this._extHostDocumentsAndEditors.getEditor(O);if(!p)throw new Error("unknown text editor");if(v.options&&p._acceptOptions(v.options),v.selections){const b=v.selections.selections.map(I.Selection.to);p._acceptSelections(b)}if(v.visibleRanges){const b=a.coalesce(v.visibleRanges.map(I.Range.to));p._acceptVisibleRanges(b)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...v.options,lineNumbers:I.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const b=P.TextEditorSelectionChangeKind.fromValue(v.selections.source),f=v.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:f,kind:b})}if(v.visibleRanges){const b=a.coalesce(v.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const v in O){const p=this._extHostDocumentsAndEditors.getEditor(v);if(!p)throw new Error("Unknown text editor");const b=I.ViewColumn.to(O[v]);p.value.viewColumn!==b&&(p._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=w}),define(Se[209],De([1,0,2,3,4,7,6,8,10]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class A{constructor(p,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(g.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const u=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(u))?.get(f.handle)}return f}})}async $getTimeline(p,b,f,u){return this._providers.get(p)?.provideTimeline(a.URI.revive(b),f,u)}registerTimelineProvider(p,b,f,u){const d=new N.DisposableStore,c=this.convertTimelineItem(b.id,u,d).bind(this);let y;b.onDidChange&&(y=b.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:b.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:p,onDidChange:void 0,async provideTimeline(l,_,r){_?.resetCache&&(d.clear(),S.get(b.id)?.clear());const k=await b.provideTimeline(l,_,r);if(k==null)return;const i=c(l,_);return{...k,source:b.id,items:k.items.map(i)}},dispose(){for(const l of S.values())l.get(b.id)?.clear();y?.dispose(),d.dispose()}})}convertTimelineItem(p,b,f){return(u,d)=>{let c;if(d?.cacheResults){let y=this._itemsBySourceAndUriMap.get(p);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(p,y));const S=O(u);c=y.get(S),c===void 0&&(c=new Map,y.set(S,c))}return y=>{const{iconPath:S,...l}=y,_=`${p}|${y.id??y.timestamp}`;c?.set(_,y);let r,k,i;y.iconPath&&(S instanceof I.ThemeIcon?i={id:S.id,color:S.color}:a.URI.isUri(S)?(r=S,k=S):{light:r,dark:k}=S);let s;return I.MarkdownString.isMarkdownString(l.tooltip)?s=P.MarkdownString.from(l.tooltip):(0,w.isString)(l.tooltip)?s=l.tooltip:I.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=P.MarkdownString.from(l.detail)):(0,w.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=l.detail),{...l,id:l.id??void 0,handle:_,source:p,command:y.command?b.toInternal(y.command,f):void 0,icon:r,iconDark:k,themeIcon:i,tooltip:s,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(p){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,p),(0,N.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=A;function O(v){return v?.toString()}}),define(Se[210],De([1,0,7,11,2,4]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(w){this._openers=new Map,this._proxy=w.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,A,O,v){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const p=v.schemes.find(b=>!I.supportedSchemes.has(b));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,O),this._proxy.$registerUriOpener(A,v.schemes,w,v.label),(0,a.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(w,A,O){const v=this._openers.get(w);if(!v)throw new Error(`Unknown opener with id: ${w}`);const p=g.URI.revive(A);return v.canOpenExternalUri(p,O)}async $openUri(w,A,O){const v=this._openers.get(w);if(!v)throw new Error(`Unknown opener id: '${w}'`);return v.openExternalUri(g.URI.revive(A.resolvedUri),{sourceUri:g.URI.revive(A.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(Se[211],De([1,0,4,2,7,12,26]),function(Z,e,a,D,g,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(A,O){if(this.handles.has(I.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const v=P.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(A)),this.handlers.set(v,O),this._proxy.$registerUriHandler(v,A),(0,g.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(A)),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(A,O){const v=this.handlers.get(A);if(!v)return Promise.resolve(void 0);try{v.handleUri(D.URI.revive(O))}catch(p){(0,N.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(A){return D.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[53],De([1,0,5,11,2,142,160,66,4]),function(Z,e,a,D,g,N,I,P,w){"use strict";var A,O,v,p,b,f,u,d,c,y,S,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(m,h,C,F,U,R,E){A.set(this,void 0),O.set(this,void 0),v.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,void 0),u.set(this,""),d.set(this,void 0),c.set(this,!1),y.set(this,!1),S.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.Emitter),this._onDidDispose=Re(this,l,"f").event,Qe(this,A,m,"f"),Qe(this,O,h,"f"),Qe(this,d,C,"f"),Qe(this,p,F,"f"),Qe(this,b,U,"f"),Qe(this,f,R,"f"),Qe(this,S,r(R),"f"),Qe(this,v,E,"f")}dispose(){Qe(this,c,!0,"f"),Re(this,l,"f").fire(),Re(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Qe(this,y,!0,"f"),(0,P.asWebviewUri)(m,Re(this,p,"f"))}get cspSource(){const m=Re(this,f,"f").extensionLocation;if(m.scheme===D.Schemas.https||m.scheme===D.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(m){this.assertNotDisposed(),Re(this,u,"f")!==m&&(Qe(this,u,m,"f"),!Re(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Qe(this,y,!0,"f"),Re(this,v,"f").report("Webview vscode-resource: uris",Re(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,O,"f").$setHtml(Re(this,A,"f"),m))}get options(){return this.assertNotDisposed(),Re(this,d,"f")}set options(m){this.assertNotDisposed(),Re(this,O,"f").$setOptions(Re(this,A,"f"),s(Re(this,f,"f"),Re(this,b,"f"),m)),Qe(this,d,m,"f")}async postMessage(m){if(Re(this,c,"f"))return!1;const h=(0,I.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Re(this,S,"f")});return Re(this,O,"f").$postMessage(Re(this,A,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Re(this,c,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,A=new WeakMap,O=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,y=new WeakMap,S=new WeakMap,l=new WeakMap;function r(o){try{const m=(0,N.normalizeVersion)((0,N.parseVersion)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class k{constructor(m,h,C,F,U){this.remoteInfo=h,this.workspace=C,this._logService=F,this._deprecationService=U,this._webviews=new Map,this._webviewProxy=m.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(m,h,C){const F=this.getWebview(m);if(F){const{message:U}=(0,I.deserializeWebviewMessage)(h,C.value);F._onMessageEmitter.fire(U)}}$onMissingCsp(m,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,C){const F=new _(m,this._webviewProxy,n(h),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(m,F),F._onDidDispose(()=>{this._webviews.delete(m)}),F}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=k;function i(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=i;function s(o,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(o,m)}}e.serializeWebviewOptions=s;function n(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>g.URI.from(m))}}e.reviveOptions=n;function t(o,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Se[212],De([1,0,20,95,7,11,23,2,8,53,63,4,6]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(r,k){this.document=r,this._storagePath=k,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,k){await this.getEdit(r).undo(),k||this.disposeBackup()}async redo(r,k){await this.getEdit(r).redo(),k||this.disposeBackup()}disposeEdits(r){for(const k of r)this._edits.delete(k)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=l(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const k=this._edits.get(r,0);if(!k)throw new Error("No edit found");return k}}class f{constructor(){this._documents=new Map}get(r,k){return this._documents.get(this.key(r,k))}add(r,k,i){const s=this.key(r,k.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${r} resource:${k.uri}`);const n=new b(k,i);return this._documents.set(s,n),n}delete(r,k){const i=this.key(r,k.uri);this._documents.delete(i)}key(r,k){return`${r}@@@${k}`}}var u;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(u||(u={}));class d{constructor(){this._providers=new Map}addTextProvider(r,k,i){return this.add(0,r,k,i)}addCustomProvider(r,k,i){return this.add(1,r,k,i)}get(r){return this._providers.get(r)}add(r,k,i,s){if(this._providers.has(k))throw new Error(`Provider for viewType:${k} already registered`);return this._providers.set(k,{type:r,extension:i,provider:s}),new p.Disposable(()=>this._providers.delete(k))}}class c{constructor(r,k,i,s,n){this._extHostDocuments=k,this._extensionStoragePaths=i,this._extHostWebview=s,this._extHostWebviewPanels=n,this._editorProviders=new d,this._documents=new f,this._proxy=r.getProxy(v.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,k,i,s){const n=new g.DisposableStore;return y(i)?(n.add(this._editorProviders.addTextProvider(k,r,i)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(r),k,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(k,r,i)),this.supportEditing(i)&&n.add(i.onDidChangeCustomDocument(t=>{const o=this.getCustomDocumentEntry(k,t.document.uri);if(S(t)){const m=o.addEdit(t);this._proxy.$onDidEdit(t.document.uri,k,m,t.label)}else this._proxy.$onContentChange(t.document.uri,k)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(r),k,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(r))),p.Disposable.from(n,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(k)}))}async $createCustomDocument(r,k,i,s,n){const t=this._editorProviders.get(k);if(!t)throw new Error(`No provider found for '${k}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${k}'`);const o=P.URI.revive(r),m=await t.provider.openCustomDocument(o,{backupId:i,untitledDocumentData:s?.buffer},n);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(k,m,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(r,k){const i=this._editorProviders.get(k);if(!i)throw new Error(`No provider found for '${k}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${k}'`);const s=P.URI.revive(r),{document:n}=this.getCustomDocumentEntry(k,s);this._documents.delete(k,n),n.dispose()}async $resolveWebviewEditor(r,k,i,s,n,t){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);const m=w.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(k,s.webviewOptions,o.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(k,i,s.title,m,s.panelOptions,h,!0),F=P.URI.revive(r);switch(o.type){case 1:{const{document:U}=this.getCustomDocumentEntry(i,F);return o.provider.resolveCustomEditor(U,C,t)}case 0:{const U=this._extHostDocuments.getDocument(F);return o.provider.resolveCustomTextEditor(U,C,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,k,i){this.getCustomDocumentEntry(k,r).disposeEdits(i)}async $onMoveCustomEditor(r,k,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const t=P.URI.revive(k),o=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(o,n,a.CancellationToken.None)}async $undo(r,k,i,s){return this.getCustomDocumentEntry(k,r).undo(i,s)}async $redo(r,k,i,s){return this.getCustomDocumentEntry(k,r).redo(i,s)}async $revert(r,k,i){const s=this.getCustomDocumentEntry(k,r);await this.getCustomEditorProvider(k).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(r,k,i){const s=this.getCustomDocumentEntry(k,r);await this.getCustomEditorProvider(k).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(r,k,i,s){const n=this.getCustomDocumentEntry(k,r);return this.getCustomEditorProvider(k).saveCustomDocumentAs(n.document,P.URI.revive(i),s)}async $backup(r,k,i){const s=this.getCustomDocumentEntry(k,r),t=await this.getCustomEditorProvider(k).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(t),t.id}getCustomDocumentEntry(r,k){const i=this._documents.get(r,P.URI.revive(k));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=c;function y(_){return typeof _.resolveCustomTextEditor=="function"}function S(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function l(_){const r=_.scheme===N.Schemas.file||_.scheme===N.Schemas.untitled?_.fsPath:_.toString();return(0,D.hash)(r)+""}});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[213],De([1,0,5,7,2,42,8,53,4,6]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";var O,v,p,b,f,u,d,c,y,S,l,_,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class k extends D.Disposable{constructor(t,o,m,h){super();O.set(this,void 0),v.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,void 0),u.set(this,void 0),d.set(this,void 0),c.set(this,void 0),y.set(this,!0),S.set(this,void 0),l.set(this,!1),_.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,_,"f").event,r.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Re(this,r,"f").event,Qe(this,O,t,"f"),Qe(this,v,o,"f"),Qe(this,b,m,"f"),Qe(this,p,h.viewType,"f"),Qe(this,f,h.panelOptions,"f"),Qe(this,c,h.viewColumn,"f"),Qe(this,u,h.title,"f"),Qe(this,S,h.active,"f")}dispose(){Re(this,l,"f")||(Qe(this,l,!0,"f"),Re(this,_,"f").fire(),Re(this,v,"f").$disposeWebview(Re(this,O,"f")),Re(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,b,"f")}get viewType(){return this.assertNotDisposed(),Re(this,p,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(t){this.assertNotDisposed(),Re(this,u,"f")!==t&&(Qe(this,u,t,"f"),Re(this,v,"f").$setTitle(Re(this,O,"f"),t))}get iconPath(){return this.assertNotDisposed(),Re(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Re(this,d,"f")!==t&&(Qe(this,d,t,"f"),Re(this,v,"f").$setIconPath(Re(this,O,"f"),g.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,c,"f")=="number"&&Re(this,c,"f")<0))return Re(this,c,"f")}get active(){return this.assertNotDisposed(),Re(this,S,"f")}get visible(){return this.assertNotDisposed(),Re(this,y,"f")}_updateViewState(t){Re(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Qe(this,S,t.active,"f"),Qe(this,y,t.visible,"f"),Qe(this,c,t.viewColumn,"f"),Re(this,r,"f").fire({webviewPanel:this}))}reveal(t,o){this.assertNotDisposed(),Re(this,v,"f").$reveal(Re(this,O,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!o})}assertNotDisposed(){if(Re(this,l,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,y=new WeakMap,S=new WeakMap,l=new WeakMap,_=new WeakMap,r=new WeakMap;class i{constructor(t,o,m){this.webviews=o,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,N.generateUuid)()}createWebviewPanel(t,o,m,h,C={}){const F=typeof h=="object"?h.viewColumn:h,U={viewColumn:I.ViewColumn.from(F),preserveFocus:typeof h=="object"&&!!h.preserveFocus},R=(0,P.shouldSerializeBuffersForPostMessage)(t),E=i.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),E,o,{title:m,panelOptions:s(C),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,C),serializeBuffersForPostMessage:R},U);const x=this.webviews.createNewWebview(E,C,t);return this.createNewWebviewPanel(E,o,m,F,C,x,!0)}$onDidChangeWebviewPanelViewStates(t){const o=Object.keys(t);o.sort((m,h)=>{const C=t[m],F=t[h];return C.active?1:F.active?-1:+C.visible-+F.visible});for(const m of o){const h=this.getWebviewPanel(m);if(!h)continue;const C=t[m];h._updateViewState({active:C.active,visible:C.visible,viewColumn:I.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,o,m){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:m,extension:t}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(t,o,m,h){const C=this._serializers.get(o);if(!C)throw new Error(`No serializer found for '${o}'`);const{serializer:F,extension:U}=C,R=this.webviews.createNewWebview(t,m.webviewOptions,U),E=this.createNewWebviewPanel(t,o,m.title,h,m.panelOptions,R,m.active);await F.deserializeWebviewPanel(E,m.state)}createNewWebviewPanel(t,o,m,h,C,F,U){const R=new k(t,this._proxy,F,{viewType:o,title:m,viewColumn:h,panelOptions:C,active:U});return this._webviewPanels.set(t,R),R}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function s(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[214],De([1,0,5,7,53,24,8,4,6]),function(Z,e,a,D,g,N,I,P,w){"use strict";var A,O,v,p,b,f,u,d,c,y,S,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends D.Disposable{constructor(i,s,n,t,o,m,h){super();A.set(this,void 0),O.set(this,void 0),v.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,!1),u.set(this,void 0),d.set(this,void 0),c.set(this,void 0),y.set(this,void 0),S.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Re(this,S,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidDispose=Re(this,l,"f").event,Qe(this,v,n,"f"),Qe(this,d,t,"f"),Qe(this,A,i,"f"),Qe(this,O,s,"f"),Qe(this,p,o,"f"),Qe(this,b,m,"f"),Qe(this,u,h,"f")}dispose(){Re(this,f,"f")||(Qe(this,f,!0,"f"),Re(this,l,"f").fire(),Re(this,p,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,d,"f")}set title(i){this.assertNotDisposed(),Re(this,d,"f")!==i&&(Qe(this,d,i,"f"),Re(this,O,"f").$setWebviewViewTitle(Re(this,A,"f"),i))}get description(){return this.assertNotDisposed(),Re(this,c,"f")}set description(i){this.assertNotDisposed(),Re(this,c,"f")!==i&&(Qe(this,c,i,"f"),Re(this,O,"f").$setWebviewViewDescription(Re(this,A,"f"),i))}get visible(){return Re(this,u,"f")}get webview(){return Re(this,p,"f")}get viewType(){return Re(this,v,"f")}_setVisible(i){i===Re(this,u,"f")||Re(this,f,"f")||(Qe(this,u,i,"f"),Re(this,S,"f").fire())}get badge(){return this.assertNotDisposed(),(0,N.checkProposedApiEnabled)(Re(this,b,"f"),"badges"),Re(this,y,"f")}set badge(i){this.assertNotDisposed(),(0,N.checkProposedApiEnabled)(Re(this,b,"f"),"badges"),!(i?.value===Re(this,y,"f")?.value&&i?.tooltip===Re(this,y,"f")?.tooltip)&&(Qe(this,y,I.ViewBadge.from(i),"f"),Re(this,O,"f").$setWebviewViewBadge(Re(this,A,"f"),i))}show(i){this.assertNotDisposed(),Re(this,O,"f").$show(Re(this,A,"f"),!!i)}assertNotDisposed(){if(Re(this,f,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,O=new WeakMap,v=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,y=new WeakMap,S=new WeakMap,l=new WeakMap;class r{constructor(i,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,n,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,g.toExtensionData)(i),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(i)}),new w.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,n,t,o){const m=this._viewProviders.get(s);if(!m)throw new Error(`No view provider found for '${s}'`);const{provider:h,extension:C}=m,F=this._extHostWebview.createNewWebview(i,{},C),U=new _(i,this._proxy,s,n,F,C,!0);this._webviewViews.set(i,U),await h.resolveWebviewView(U,{state:t},o)}async $onDidChangeWebviewViewVisibility(i,s){this.getWebviewView(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.getWebviewView(i);this._webviewViews.delete(i),s.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const s=this._webviewViews.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=r}),define(Se[97],De([1,0,5,4,2,11,9,3,16]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Yi{constructor(v){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yi.InitialState,this._proxy=v.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(v){v!==this._state.focused&&(this._state={...this._state,focused:v},this._onDidChangeWindowState.fire(this._state))}openUri(v,p){let b;if(typeof v=="string"){b=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,I.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,b,p)}async asExternalUri(v,p){if((0,I.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(v,p);return g.URI.from(b)}};A.InitialState={focused:!0},A=$e([ze(0,w.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Se[215],De([1,0,14,25,20,12,5,7,112,180,39]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(C,F){try{return JSON.stringify(C,F)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class u{constructor(F,U){this.jsonString=F,this.referencedBuffers=U}}function d(C,F=null,U=!1){const R=[];return{jsonString:(U?p:JSON.stringify)(C,(x,z)=>{if(typeof z=="undefined")return f;if(typeof z=="object"){if(z instanceof D.VSBuffer){const V=R.push(z)-1;return{[b]:V}}if(F)return F(x,z)}return z}),referencedBuffers:R}}e.stringifyJsonWithBufferRefs=d;function c(C,F,U){return JSON.parse(C,(R,E)=>{if(E){const x=E[b];if(typeof x=="number")return F[x];if(U&&E.$mid===1)return U.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=c;function y(C,F){return JSON.stringify(C,F)}function S(C){return C?(F,U)=>U&&U.$mid===1?C.transformOutgoing(U):U:null}var l;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},k=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class s extends P.Disposable{constructor(F,U=null,R=null){super();this[v]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=F,this._logger=U,this._uriTransformer=R,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,x=O.ProxyIdentifier.count;E<x;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(F=>{this._pendingRPCReplies[F].resolveErr(N.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(F){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(F){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(F){this._responsiveState!==F&&(this._responsiveState=F,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(F){return this._uriTransformer?(0,w.transformIncomingURIs)(F,this._uriTransformer):F}getProxy(F){const{nid:U,sid:R}=F;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,R)),this._proxies[U]}_createProxy(F,U){let R={get:(E,x)=>(typeof x=="string"&&!E[x]&&x.charCodeAt(0)===36&&(E[x]=(...z)=>this._remoteCall(F,x,z)),x===i?U:E[x])};return new Proxy(Object.create(null),R)}set(F,U){return this._locals[F.nid]=U,U}assertRegistered(F){for(let U=0,R=F.length;U<R;U++){const E=F[U];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(F){if(this._isDisposed)return;const U=F.byteLength,R=n.read(F,0),E=R.readUInt8(),x=R.readUInt32();switch(E){case 1:case 2:{let{rpcId:z,method:V,args:se}=o.deserializeRequestJSONArgs(R);this._uriTransformer&&(se=(0,w.transformIncomingURIs)(se,this._uriTransformer)),this._receiveRequest(U,x,z,V,se,E===2);break}case 3:case 4:{let{rpcId:z,method:V,args:se}=o.deserializeRequestMixedArgs(R);this._uriTransformer&&(se=(0,w.transformIncomingURIs)(se,this._uriTransformer)),this._receiveRequest(U,x,z,V,se,E===4);break}case 5:{this._logger&&this._logger.logIncoming(U,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(U,x);break}case 7:{this._receiveReply(U,x,void 0);break}case 9:{let z=o.deserializeReplyOKJSON(R);this._uriTransformer&&(z=(0,w.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(U,x,z);break}case 10:{const z=o.deserializeReplyOKJSONWithBuffers(R,this._uriTransformer);this._receiveReply(U,x,z);break}case 8:{let z=o.deserializeReplyOKVSBuffer(R);this._receiveReply(U,x,z);break}case 11:{let z=o.deserializeReplyErrError(R);this._uriTransformer&&(z=(0,w.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(U,x,z);break}case 12:{this._receiveReplyErr(U,x,void 0);break}default:console.error("received unexpected message"),console.error(F)}}_receiveRequest(F,U,R,E,x,z){this._logger&&this._logger.logIncoming(F,U,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(R)}.${E}(`,x);const V=String(U);let se,K;if(z){const oe=new g.CancellationTokenSource;x.push(oe.token),se=this._invokeHandler(R,E,x),K=()=>oe.cancel()}else se=this._invokeHandler(R,E,x),K=r;this._cancelInvokedHandlers[V]=K;const L=o.serializeAcknowledged(U);this._logger&&this._logger.logOutgoing(L.byteLength,U,1,"ack"),this._protocol.send(L),se.then(oe=>{delete this._cancelInvokedHandlers[V];const de=o.serializeReplyOK(U,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(de.byteLength,U,1,"reply:",oe),this._protocol.send(de)},oe=>{delete this._cancelInvokedHandlers[V];const de=o.serializeReplyErr(U,oe);this._logger&&this._logger.logOutgoing(de.byteLength,U,1,"replyErr:",oe),this._protocol.send(de)})}_receiveCancel(F,U){this._logger&&this._logger.logIncoming(F,U,1,"receiveCancel");const R=String(U);this._cancelInvokedHandlers[R]&&this._cancelInvokedHandlers[R]()}_receiveReply(F,U,R){this._logger&&this._logger.logIncoming(F,U,0,"receiveReply:",R);const E=String(U);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const x=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],x.resolveOk(R)}_receiveReplyErr(F,U,R){this._logger&&this._logger.logIncoming(F,U,0,"receiveReplyErr:",R);const E=String(U);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const x=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let z;R&&(R.$isError?(z=new Error,z.name=R.name,z.message=R.message,z.stack=R.stack):z=R),x.resolveErr(z)}_invokeHandler(F,U,R){try{return Promise.resolve(this._doInvokeHandler(F,U,R))}catch(E){return Promise.reject(E)}}_doInvokeHandler(F,U,R){const E=this._locals[F];if(!E)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(F));let x=E[U];if(typeof x!="function")throw new Error("Unknown method "+U+" on actor "+(0,O.getStringIdentifierForProxy)(F));return x.apply(E,R)}_remoteCall(F,U,R){if(this._isDisposed)return Promise.reject(N.canceled());let E=null;if(R.length>0&&g.CancellationToken.isCancellationToken(R[R.length-1])&&(E=R.pop()),E&&E.isCancellationRequested)return Promise.reject(N.canceled());const x=o.serializeRequestArguments(R,this._uriReplacer),z=++this._lastMessageId,V=String(z),se=new A.LazyPromise;E&&E.onCancellationRequested(()=>{const L=o.serializeCancel(z);this._logger&&this._logger.logOutgoing(L.byteLength,z,0,"cancel"),this._protocol.send(o.serializeCancel(z))}),this._pendingRPCReplies[V]=se,this._onWillSendRequest(z);const K=o.serializeRequest(z,F,U,x,!!E);return this._logger&&this._logger.logOutgoing(K.byteLength,z,0,`request: ${(0,O.getStringIdentifierForProxy)(F)}.${U}(`,R),this._protocol.send(K),se}}e.RPCProtocol=s,v=k,s.UNRESPONSIVE_TIME=3*1e3;class n{constructor(F,U){this._buff=F,this._offset=U}static alloc(F,U,R){let E=new n(D.VSBuffer.alloc(R+1+4),0);return E.writeUInt8(F),E.writeUInt32(U),E}static read(F,U){return new n(F,U)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(F){this._buff.writeUInt8(F,this._offset),this._offset+=1}readUInt8(){const F=this._buff.readUInt8(this._offset);return this._offset+=1,F}writeUInt32(F){this._buff.writeUInt32BE(F,this._offset),this._offset+=4}readUInt32(){const F=this._buff.readUInt32BE(this._offset);return this._offset+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this._buff.writeUInt8(F.byteLength,this._offset),this._offset+=1,this._buff.set(F,this._offset),this._offset+=F.byteLength}readShortString(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const R=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,R}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readLongString(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,R}writeBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readVSBuffer(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+F);return this._offset+=F,U}static sizeMixedArray(F){let U=0;U+=1;for(let R=0,E=F.length;R<E;R++){const x=F[R];switch(U+=1,x.type){case 1:U+=this.sizeLongString(x.value);break;case 2:U+=this.sizeVSBuffer(x.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(x.value);for(let z=0;z<x.buffers.length;++z)U+=this.sizeVSBuffer(x.buffers[z]);break;case 4:break}}return U}writeMixedArray(F){this._buff.writeUInt8(F.length,this._offset),this._offset+=1;for(let U=0,R=F.length;U<R;U++){const E=F[U];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let x=0;x<E.buffers.length;++x)this.writeBuffer(E.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this._buff.readUInt8(this._offset);this._offset+=1;let U=new Array(F);for(let R=0;R<F;R++)switch(this.readUInt8()){case 1:U[R]=this.readLongString();break;case 2:U[R]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),z=this.readLongString(),V=[];for(let se=0;se<x;++se)V.push(this.readVSBuffer());U[R]=new O.SerializableObjectWithBuffers(c(z,V,null));break}case 4:U[R]=void 0;break}return U}}n.sizeUInt32=4;var t;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(t||(t={}));class o{static _useMixedArgSerialization(F){for(let U=0,R=F.length;U<R;U++)if(F[U]instanceof D.VSBuffer||F[U]instanceof O.SerializableObjectWithBuffers||typeof F[U]=="undefined")return!0;return!1}static serializeRequestArguments(F,U){if(this._useMixedArgSerialization(F)){const R=[];for(let E=0,x=F.length;E<x;E++){const z=F[E];if(z instanceof D.VSBuffer)R[E]={type:2,value:z};else if(typeof z=="undefined")R[E]={type:4};else if(z instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:se}=d(z.value,U);R[E]={type:3,value:D.VSBuffer.fromString(V),buffers:se}}else R[E]={type:1,value:D.VSBuffer.fromString(y(z,U))}}return{type:1,args:R}}return{type:0,args:y(F,U)}}static serializeRequest(F,U,R,E,x){switch(E.type){case 0:return this._requestJSONArgs(F,U,R,E.args,x);case 1:return this._requestMixedArgs(F,U,R,E.args,x)}}static _requestJSONArgs(F,U,R,E,x){const z=D.VSBuffer.fromString(R),V=D.VSBuffer.fromString(E);let se=0;se+=n.sizeUInt8(),se+=n.sizeShortString(z),se+=n.sizeLongString(V);let K=n.alloc(x?2:1,F,se);return K.writeUInt8(U),K.writeShortString(z),K.writeLongString(V),K.buffer}static deserializeRequestJSONArgs(F){const U=F.readUInt8(),R=F.readShortString(),E=F.readLongString();return{rpcId:U,method:R,args:JSON.parse(E)}}static _requestMixedArgs(F,U,R,E,x){const z=D.VSBuffer.fromString(R);let V=0;V+=n.sizeUInt8(),V+=n.sizeShortString(z),V+=n.sizeMixedArray(E);let se=n.alloc(x?4:3,F,V);return se.writeUInt8(U),se.writeShortString(z),se.writeMixedArray(E),se.buffer}static deserializeRequestMixedArgs(F){const U=F.readUInt8(),R=F.readShortString(),E=F.readMixedArray(),x=new Array(E.length);for(let z=0,V=E.length;z<V;z++){const se=E[z];typeof se=="string"?x[z]=JSON.parse(se):x[z]=se}return{rpcId:U,method:R,args:x}}static serializeAcknowledged(F){return n.alloc(5,F,0).buffer}static serializeCancel(F){return n.alloc(6,F,0).buffer}static serializeReplyOK(F,U,R){if(typeof U=="undefined")return this._serializeReplyOKEmpty(F);if(U instanceof D.VSBuffer)return this._serializeReplyOKVSBuffer(F,U);if(U instanceof O.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:x}=d(U.value,R,!0);return this._serializeReplyOKJSONWithBuffers(F,E,x)}else return this._serializeReplyOKJSON(F,p(U,R))}static _serializeReplyOKEmpty(F){return n.alloc(7,F,0).buffer}static _serializeReplyOKVSBuffer(F,U){let R=0;R+=n.sizeVSBuffer(U);let E=n.alloc(8,F,R);return E.writeVSBuffer(U),E.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static _serializeReplyOKJSON(F,U){const R=D.VSBuffer.fromString(U);let E=0;E+=n.sizeLongString(R);let x=n.alloc(9,F,E);return x.writeLongString(R),x.buffer}static _serializeReplyOKJSONWithBuffers(F,U,R){const E=D.VSBuffer.fromString(U);let x=0;x+=n.sizeUInt32,x+=n.sizeLongString(E);for(const V of R)x+=n.sizeVSBuffer(V);let z=n.alloc(10,F,x);z.writeUInt32(R.length),z.writeLongString(E);for(const V of R)z.writeBuffer(V);return z.buffer}static deserializeReplyOKJSON(F){const U=F.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(F,U){const R=F.readUInt32(),E=F.readLongString(),x=[];for(let z=0;z<R;++z)x.push(F.readVSBuffer());return new O.SerializableObjectWithBuffers(c(E,x,U))}static serializeReplyErr(F,U){const R=U?p(N.transformErrorForSerialization(U),null):void 0;if(typeof R!="string")return this._serializeReplyErrEmpty(F);const E=D.VSBuffer.fromString(R);let x=0;x+=n.sizeLongString(E);let z=n.alloc(11,F,x);return z.writeLongString(E),z.buffer}static deserializeReplyErrError(F){const U=F.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(F){return n.alloc(12,F,0).buffer}}var m;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var h;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(h||(h={}))}),define(Se[216],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(N){const I=P=>{self.removeEventListener("message",I);const w=P.data;Object.defineProperties(self,{postMessage:{value(A,O){w.postMessage(A,O)}},onmessage:{get(){return w.onmessage},set(A){w.onmessage=A}}}),w.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),w.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",I)}.toString();class D extends EventTarget{constructor(N,I,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${a})('${I}'))`,A=new Blob([w],{type:"application/javascript"}),O=URL.createObjectURL(A),v=new MessageChannel,p=O,b={type:"_newWorker",id:p,port:v.port2,url:O,options:P};N(b,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{N({type:"_terminateWorker",id:p}),URL.revokeObjectURL(O),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(f){v.port1.onmessage=f}},onmessageerror:{get(){return v.port1.onmessageerror},set(f){v.port1.onmessageerror=f}}}),v.port1.addEventListener("messageerror",f=>{const u=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(u)}),v.port1.addEventListener("message",f=>{const u=new MessageEvent("message",{data:f.data});this.dispatchEvent(u)}),v.port1.start()}}e.NestedWorker=D}),define(Se[217],De([1,0,5,34,44,3,38,12,14]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new g.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new g.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new g.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var A;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(A=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(u=>f.push(u)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}D.Registry.add(e.Extensions.OutputChannels,new O);function v(b,f,u,d,c){return(0,w.createCancelablePromise)(async y=>{await(0,I.whenProviderRegistered)(u,d);const S=D.Registry.as(e.Extensions.OutputChannels);try{await p(u,1,d,c,y),S.registerChannel({id:b,label:f,file:u,log:!0})}catch(l){(0,P.isCancellationError)(l)||c.error("Error while registering log channel",u.toString(),(0,P.getErrorMessage)(l))}})}e.registerLogChannel=v;async function p(b,f,u,d,c){if(!await u.exists(b)){if(c.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",b.toString()),await(0,w.timeout)(1e3,c),await p(b,f+1,u,d,c)}}}),define(Se[98],De([1,0,4,7,3,16,13,217,51,28,35,117,25,10]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends D.Disposable{constructor(c,y,S,l){super();this.id=c,this.name=y,this.logger=S,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(c){this.append(c+`
`)}append(c){this.write(c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const c=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,c)}replace(c){const y=this.offset;this.write(c),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,y),this.visible&&this.logger.flush()}show(c,y){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof c=="boolean"?c:y))}hide(){this.proxy.$close(this.id)}write(c){this.offset+=p.VSBuffer.fromString(c).byteLength,this.logger.info(c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let u=class{constructor(c,y,S,l,_){this.extHostFileSystem=S,this.extHostFileSystemInfo=l,this.loggerService=_,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=c.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(y.logsLocation,`output_logging_${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.visibleChannelId=c;for(const[y,S]of this.channels)S.visible=y===this.visibleChannelId}createOutputChannel(c,y,S){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if((0,b.isString)(y)&&!y.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(c,y,S);return l.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),this.createExtHostOutputChannel(c,l)}async doCreateOutputChannel(c,y,S){const l=await this.createOutputDirectory(),_=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(_,{always:!0,donotRotate:!0,donotUseFormatters:!0}),k=await this.proxy.$register(c,!1,_,y,S.identifier.value);return new f(k,c,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(c,y){let S=!1;const l=()=>{if(S)throw new Error("Channel has been closed")};return{get name(){return c},append(_){l(),y.then(r=>r.append(_))},appendLine(_){l(),y.then(r=>r.appendLine(_))},clear(){l(),y.then(_=>_.clear())},replace(_){l(),y.then(r=>r.replace(_))},show(_,r){l(),y.then(k=>k.show(_,r))},hide(){l(),y.then(_=>_.hide())},dispose(){S=!0,y.then(_=>_.dispose())}}}};u=$e([ze(0,N.IExtHostRpcService),ze(1,A.IExtHostInitDataService),ze(2,w.IExtHostConsumerFileSystem),ze(3,O.IExtHostFileSystemInfo),ze(4,I.ILoggerService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,g.createDecorator)("IExtHostOutputService")}),define(Se[218],De([1,0,3]),function(Z,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[219],De([1,0,37,11,17,22,23,2,3,155,45,176,218]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let b=class Ji{constructor(u,d,c,y){this.localUserHome=u,this.remoteAgentService=d,this.environmentService=c,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??u})()}hasValidBasename(u,d,c){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(u,y,d)):this.doHasValidBasename(u,d,c)}doHasValidBasename(u,d,c){return u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote?(0,a.isValidBasename)(c??(0,I.basename)(u),d===1):!0}get defaultUriScheme(){return Ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,d){if(u.remoteAuthority)return D.Schemas.vscodeRemote;const c=(0,A.getVirtualWorkspaceScheme)(d.getWorkspace());if(c)return c;const y=d.getWorkspace().folders[0];if(y)return y.uri.scheme;const S=d.getWorkspace().configuration;return S?S.scheme:D.Schemas.file}userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?g.win32:g.posix)}async fileURI(u){let d="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const y=u.indexOf("/",2);y===-1?(d=u.substring(2),u="/"):(d=u.substring(2,y),u=u.substring(y)||"/")}return P.URI.from({scheme:D.Schemas.file,authority:d,path:u,query:"",fragment:""})}};b=$e([ze(1,p.IRemoteAgentService),ze(2,v.IWorkbenchEnvironmentService),ze(3,O.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Se[99],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(I,P){this.line=I,this.character=P}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,P){return new a(0,0)}with(I){return new a(0,0)}}e.Position=a;class D{constructor(I,P,w,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(I,P),this.end=new a(w,A)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new D(0,0,0,0)}with(I){return new D(0,0,0,0)}}e.Range=D;var g;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(g=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[40],De([1,0,15,33,27,37,9,3,17,12,99,14]),function(Z,e,a,D,g,N,I,P,w,A,O,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",b=" characters skipped \u27EB",f=(p.length+b.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function c(ae){return!!ae.preview}e.resultIsMatch=c;function y(ae){return!!ae.resource}e.isFileMatch=y;function S(ae){return!!ae.message}e.isProgressMessage=S;var l;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(fe){this.resource=fe,this.results=[]}}e.FileMatch=_;class r{constructor(fe,ee,Ee){this.ranges=ee;const we=Array.isArray(ee)?ee:[ee];if(Ee&&Ee.matchLines===1&&k(we)){fe=(0,I.getNLines)(fe,Ee.matchLines);let J="",ve=0,Pe=0;const Fe=Math.floor(Ee.charsPerLine/5),We=[];for(const Ge of we){const Ie=Math.max(Ge.startColumn-Fe,0),_e=Ge.startColumn+Ee.charsPerLine;if(Ie>Pe+Fe+f){const Ce=p+(Ie-Pe)+b;J+=Ce+fe.slice(Ie,_e),ve+=Ie-(Pe+Ce.length)}else J+=fe.slice(Pe,_e);We.push(new s(0,Ge.startColumn-ve,Ge.endColumn-ve)),Pe=_e}this.preview={text:J,matches:Array.isArray(this.ranges)?We:We[0]}}else{const J=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:fe,matches:(0,a.mapArrayOrNot)(ee,ve=>new i(ve.startLineNumber-J,ve.startColumn,ve.endLineNumber-J,ve.endColumn))}}}}e.TextSearchMatch=r;function k(ae){const fe=ae[0].startLineNumber;for(const ee of ae)if(ee.startLineNumber!==fe||ee.endLineNumber!==fe)return!1;return!0}class i{constructor(fe,ee,Ee,we){this.startLineNumber=fe,this.startColumn=ee,this.endLineNumber=Ee,this.endColumn=we}}e.SearchRange=i;class s extends i{constructor(fe,ee,Ee){super(fe,ee,fe,Ee)}}e.OneLineRange=s;var n;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(ae,fe=!0){const ee=ae&&ae.files&&ae.files.exclude,Ee=fe&&ae&&ae.search&&ae.search.exclude;if(!ee&&!Ee)return;if(!ee||!Ee)return ee||Ee;let we=Object.create(null);return we=g.mixin(we,g.deepClone(ee)),we=g.mixin(we,g.deepClone(Ee),!0),we}e.getExcludes=t;function o(ae,fe){return ae.excludePattern&&D.match(ae.excludePattern,fe)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&D.match(ae.includePattern,fe)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(ee=>{const Ee=ee.folder.fsPath;if(N.isEqualOrParent(fe,Ee)){const we=w.relative(Ee,fe);return!ee.includePattern||!!D.match(ee.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var m;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(fe,ee){super(fe);this.code=ee}}e.SearchError=h;function C(ae){const fe=ae.message;if((0,A.isCancellationError)(ae))return new h(fe,m.canceled);try{const ee=JSON.parse(fe);return new h(ee.message,ee.code)}catch{return new h(fe,m.other)}}e.deserializeSearchError=C;function F(ae){const fe={message:ae.message,code:ae.code};return new Error(JSON.stringify(fe))}e.serializeSearchError=F;function U(ae){return ae.type==="error"?!0:ae.type==="success"}e.isSerializedSearchComplete=U;function R(ae){return ae.type==="success"}e.isSerializedSearchSuccess=R;function E(ae){return!!ae.path}e.isSerializedFileMatch=E;function x(ae,fe){const ee=ae.searchPath?ae.searchPath:ae.relativePath;return(0,I.fuzzyContains)(ee,fe)}e.isFilePatternMatch=x;class z{constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function V(ae,fe){const ee={...ae||{},...fe||{}};return Object.keys(ee).filter(Ee=>{const we=ee[Ee];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=V;class se{constructor(fe,ee){this._parsedIncludeExpression=null,this._excludeExpression={...fe.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=D.parse(this._excludeExpression);let Ee=fe.includePattern;ee.includePattern&&(Ee?Ee={...Ee,...ee.includePattern}:Ee=ee.includePattern),Ee&&(this._parsedIncludeExpression=D.parse(Ee))}matchesExcludesSync(fe,ee,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ee,Ee))}includedInQuerySync(fe,ee,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ee,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(fe,ee,Ee))}includedInQuery(fe,ee,Ee){const we=this._parsedExcludeExpression(fe,ee,Ee),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(fe,ee,Ee):!0;return(0,v.isThenable)(we)?we.then(ve=>ve?!1:J()):J()}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=se;function K(ae){for(const fe in ae)if(typeof ae[fe]!="boolean")return!0;return!1}function L(ae){if(!ae)return;let fe;return ee=>(fe||(fe=(ae()||Promise.resolve([])).then(Ee=>Ee?de(Ee):{})),fe.then(Ee=>!!Ee[ee]))}e.hasSiblingPromiseFn=L;function oe(ae){if(!ae)return;let fe;return ee=>{if(!fe){const Ee=ae();fe=Ee?de(Ee):{}}return!!fe[ee]}}e.hasSiblingFn=oe;function de(ae){const fe={};for(const ee of ae)fe[ee]=!0;return fe}}),define(Se[29],De([1,0,15,14,20,5,21,11,106,23,9,10,2,134,3,13,147,45,35,28,16,8,6,40,4]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l,_,r,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(U,R,E){return new A.ExtUri(x=>m(x,E)).isEqual(U,R)}function n(U,R,E){return s(U.uri,R.uri,E)?0:(0,O.compare)(U.uri.toString(),R.uri.toString())}function t(U,R,E){return U.index!==R.index?U.index<R.index?-1:1:s(U.uri,R.uri,E)?(0,O.compare)(U.name,R.name):(0,O.compare)(U.uri.toString(),R.uri.toString())}function o(U,R,E,x){const z=U.slice(0).sort((se,K)=>E(se,K,x)),V=R.slice(0).sort((se,K)=>E(se,K,x));return(0,a.delta)(z,V,(se,K)=>E(se,K,x))}function m(U,R){const E=R.getCapabilities(U.scheme);return!(E&&E&1024)}class h extends c.Workspace{constructor(R,E,x,z,V,se,K){super(R,x.map(L=>new c.WorkspaceFolder(L)),z,V,K);this._name=E,this._isUntitled=se,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(K),x.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(R,E,x,z){if(!R)return{workspace:null,added:[],removed:[]};const{id:V,name:se,folders:K,configuration:L,transient:oe,isUntitled:de}=R,ae=[],fe=E;E?K.forEach((J,ve)=>{const Pe=p.URI.revive(J.uri),Fe=h._findFolder(x||E,Pe,z);Fe?(Fe.name=J.name,Fe.index=J.index,ae.push(Fe)):ae.push({uri:Pe,name:J.name,index:ve})}):ae.push(...K.map(({uri:J,name:ve,index:Pe})=>({uri:p.URI.revive(J),name:ve,index:Pe}))),ae.sort((J,ve)=>J.index<ve.index?-1:1);const ee=new h(V,se,ae,!!oe,L?p.URI.revive(L):null,!!de,J=>m(J,z)),{added:Ee,removed:we}=o(fe?fe.workspaceFolders:[],ee.workspaceFolders,n,z);return{workspace:ee,added:Ee,removed:we}}static _findFolder(R,E,x){for(let z=0;z<R.folders.length;z++){const V=R.workspaceFolders[z];if(s(V.uri,E,x))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,E){return E&&this._structure.get(R)&&(R=(0,A.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let C=class{constructor(R,E,x,z){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=x,this._requestIdProvider=new w.Counter,this._barrier=new D.Barrier,this._proxy=R.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(i.MainContext.MainThreadMessageService);const V=E.workspace;this._confirmedWorkspace=V?new h(V.id,V.name,[],!!V.transient,V.configuration?p.URI.revive(V.configuration):null,!!V.isUntitled,se=>m(se,x)):void 0}$initializeWorkspace(R,E){this._trusted=E,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,E,x,...z){const V=[];if(Array.isArray(z)&&z.forEach(de=>{p.URI.isUri(de.uri)&&!V.some(ae=>s(ae.uri,de.uri,this._extHostFileSystemInfo))&&V.push({uri:de.uri,name:de.name||(0,A.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[E,x].some(de=>typeof de!="number"||de<0)||x===0&&V.length===0)return!1;const se=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+x>se.length)return!1;const K=se.slice(0);K.splice(E,x,...V.map(de=>({uri:de.uri,name:de.name||(0,A.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<K.length;de++){const ae=K[de];if(K.some((fe,ee)=>ee!==de&&s(ae.uri,fe.uri,this._extHostFileSystemInfo)))return!1}K.forEach((de,ae)=>de.index=ae);const{added:L,removed:oe}=o(se,K,t,this._extHostFileSystemInfo);if(L.length===0&&oe.length===0)return!1;if(this._proxy){const de=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(de,E,x,V).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const fe={source:{identifier:R.identifier,label:R.displayName||R.name}};this._messageService.$showMessage(d.Severity.Error,(0,b.localize)(0,null,de,ae.toString()),fe,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(R,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,E)}async getWorkspaceFolder2(R,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,E)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,E){let x,z="";if(typeof R=="string"?(x=p.URI.file(R),z=R):typeof R!="undefined"&&(x=R,z=R.fsPath),!x)return z;const V=this.getWorkspaceFolder(x,!0);if(!V)return z;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let se=(0,A.relativePath)(V.uri,x);return E&&V.name&&(se=`${V.name}/${se}`),se}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:E,added:x,removed:z}=h.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:z}))}findFiles(R,E,x,z,V=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let se;if(E===null?se=!1:E&&(typeof E=="string"?se=E:se=E.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:L}=F(_.GlobPattern.from(R));return this._proxy.$startFileSearch((0,v.withUndefinedAsNull)(K),(0,v.withUndefinedAsNull)(L),(0,v.withUndefinedAsNull)(se),(0,v.withUndefinedAsNull)(x),V).then(oe=>Array.isArray(oe)?oe.map(de=>p.URI.revive(de)):[])}async findTextInFiles(R,E,x,z,V=g.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const se=this._requestIdProvider.getNext(),K=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:L,folder:oe}=F(_.GlobPattern.from(E.include)),de=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,ae={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:K,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:L,excludePattern:de},fe=!1;if(this._activeSearchCallbacks[se]=ee=>{if(fe)return;const Ee=p.URI.revive(ee.resource);ee.results.forEach(we=>{(0,k.resultIsMatch)(we)?x({uri:Ee,preview:{text:we.preview.text,matches:(0,a.mapArrayOrNot)(we.preview.matches,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,a.mapArrayOrNot)(we.ranges,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):x({uri:Ee,text:we.text,lineNumber:we.lineNumber})})},V.isCancellationRequested)return{};try{const ee=await this._proxy.$startTextSearch(R,(0,v.withUndefinedAsNull)(oe),ae,se,V);return delete this._activeSearchCallbacks[se],ee||{}}catch(ee){throw delete this._activeSearchCallbacks[se],ee}}$handleTextSearchResult(R,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=$e([ze(0,l.IExtHostRpcService),ze(1,S.IExtHostInitDataService),ze(2,y.IExtHostFileSystemInfo),ze(3,u.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function F(U){let R,E;return U&&(typeof U=="string"?R=U:(R=U.pattern,E=p.URI.revive(U.baseUri))),{includePattern:R,folder:E}}}),define(Se[30],De([1,0,27,5,29,4,6,150,81,10,14,3,16,13,2]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(k,i){if(i){const s=i.split(".");let n=k;for(let t=0;n&&t<s.length;t++)n=n[s[t]];return n}}function d(k){return k instanceof f.URI}function c(k){return k&&k.uri instanceof f.URI&&k.languageId&&typeof k.languageId=="string"}function y(k){return k&&!k.uri&&k.languageId&&typeof k.languageId=="string"}function S(k){return k&&k.uri instanceof f.URI&&(!k.name||typeof k.name=="string")&&(!k.index||typeof k.index=="number")}function l(k){if(d(k))return{resource:k};if(c(k))return{resource:k.uri,overrideIdentifier:k.languageId};if(y(k))return{overrideIdentifier:k.languageId};if(S(k))return{resource:k.uri};if(k===null)return{resource:null}}let _=class{constructor(i,s,n){this._proxy=i.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=n,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,s){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(i,s))}};_=$e([ze(0,p.IExtHostRpcService),ze(1,g.IExtHostWorkspace),ze(2,b.ILogService)],_),e.ExtHostConfiguration=_;class r{constructor(i,s,n,t){this._onDidChangeConfiguration=new D.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=s,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,s){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,n))}getConfiguration(i,s,n){const t=l(s)||{},o=this._toReadonlyValue(i?u(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,n?.identifier);function m(C){if(C==null)return null;if(typeof C=="boolean")return C?1:4;switch(C){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(C){return typeof u(o,C)!="undefined"},get:(C,F)=>{this._validateConfigurationAccess(i?`${i}.${C}`:C,t,n?.identifier);let U=u(o,C);if(typeof U=="undefined")U=F;else{let R;const E=(x,z)=>{let V;const se=()=>{R=R||(0,a.deepClone)(o),V=V||u(R,z)};return(0,A.isObject)(x)?new Proxy(x,{get:(K,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return se(),()=>V;if(R)return V=V||u(R,z),V[L];const oe=K[L];return typeof L=="string"?E(oe,`${z}.${L}`):oe},set:(K,L,oe)=>(se(),V&&(V[L]=oe),!0),deleteProperty:(K,L)=>(se(),V&&delete V[L],!0),defineProperty:(K,L,oe)=>(se(),V&&Object.defineProperty(V,L,oe),!0)}):x};U=E(U,C)}return U},update:(C,F,U,R)=>{C=i?`${i}.${C}`:C;const E=m(U);return F!==void 0?this._proxy.$updateConfigurationOption(E,C,F,t,R):this._proxy.$removeConfigurationOption(E,C,t,R)},inspect:C=>{C=i?`${i}.${C}`:C;const F=(0,a.deepClone)(this._configuration.inspect(C,t,this._extHostWorkspace.workspace));if(F)return{key:C,defaultValue:F.default?.value,globalValue:F.user?.value,workspaceValue:F.workspace?.value,workspaceFolderValue:F.workspaceFolder?.value,defaultLanguageValue:F.default?.override,globalLanguageValue:F.user?.override,workspaceLanguageValue:F.workspace?.override,workspaceFolderLanguageValue:F.workspaceFolder?.override,languageIds:F.overrideIdentifiers}}};return typeof o=="object"&&(0,a.mixin)(h,o,!1),Object.freeze(h)}_toReadonlyValue(i){const s=n=>(0,A.isObject)(n)?new Proxy(n,{get:(t,o)=>s(t[o]),set:(t,o,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(t,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(t,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return s(i)}_validateConfigurationAccess(i,s,n){const t=w.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),o=n?`[${n.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,s){const n=new P.ConfigurationChangeEvent(i,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,o)=>n.affectsConfiguration(t,l(o))})}_toMap(i){return i.reduce((s,n)=>(s.set(n[0],n[1]),s),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,v.createDecorator)("IExtHostConfiguration")});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[100],De([1,0,2,14,5,4,6,29,49,30,20,52,16,28,3,11,22,13,70,169,12]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(z){function V(K){if(K!=null)return K}z.from=V;function se(K){if(K!=null)return K}z.to=se})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var k;(function(z){function V(K){if(K!=null)return K}z.from=V;function se(K){if(K!=null)return K}z.to=se})(k=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(z){function V(K){if(K!=null)return K}z.from=V;function se(K){if(K!=null)return K}z.to=se})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(z){function V(L){if(L){const oe=L;return oe&&!!oe.process}else return!1}z.is=V;function se(L){if(L==null)return;const oe={process:L.process,args:L.args};return L.options&&(oe.options=i.from(L.options)),oe}z.from=se;function K(L){if(L!=null)return new I.ProcessExecution(L.process,L.args,L.options)}z.to=K})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(z){function V(K){if(K!=null)return K}z.from=V;function se(K){if(K!=null)return K}z.to=se})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(z){function V(L){if(L){const oe=L;return oe&&(!!oe.commandLine||!!oe.command)}else return!1}z.is=V;function se(L){if(L==null)return;const oe={};return L.commandLine!==void 0?oe.commandLine=L.commandLine:(oe.command=L.command,oe.args=L.args),L.options&&(oe.options=n.from(L.options)),oe}z.from=se;function K(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new I.ShellExecution(L.commandLine,L.options):new I.ShellExecution(L.command,L.args?L.args:[],L.options)}z.to=K})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(z){function V(L){if(L){let oe=L;return oe&&oe.customExecution==="customExecution"}else return!1}z.is=V;function se(L){return{customExecution:"customExecution"}}z.from=se;function K(L,oe){return oe.get(L)}z.to=K})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(z){function V(se,K){let L;return se.scope!==void 0&&typeof se.scope!="number"?L=se.scope.uri:se.scope!==void 0&&typeof se.scope=="number"&&(se.scope===I.TaskScope.Workspace&&K&&K.workspaceFile?L=K.workspaceFile:L=S.USER_TASKS_GROUP_KEY),{id:se._id,workspaceFolder:L}}z.from=V})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(z){function V(se){if(se!=null)return{_id:se.id,isDefault:se.isDefault}}z.from=V})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function(z){function V(L,oe){if(L==null)return[];const de=[];for(let ae of L){const fe=se(ae,oe);fe&&de.push(fe)}return de}z.fromMany=V;function se(L,oe){if(L==null)return;let de;L.execution instanceof I.ProcessExecution?de=s.from(L.execution):L.execution instanceof I.ShellExecution?de=t.from(L.execution):L.execution&&L.execution instanceof I.CustomExecution&&(de=o.from(L.execution));const ae=r.from(L.definition);let fe;return L.scope?typeof L.scope=="number"?fe=L.scope:fe=L.scope.uri:fe=I.TaskScope.Workspace,!ae||!fe?void 0:{_id:L._id,definition:ae,name:L.name,source:{extensionId:oe.identifier.value,label:L.source,scope:fe},execution:de,isBackground:L.isBackground,group:h.from(L.group),presentationOptions:k.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}z.from=se;async function K(L,oe,de){if(L==null)return;let ae;s.is(L.execution)?ae=s.to(L.execution):t.is(L.execution)?ae=t.to(L.execution):o.is(L.execution)&&(ae=o.to(L._id,de));const fe=r.to(L.definition);let ee;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?ee=L.source.scope:ee=await oe.resolveWorkspaceFolder(a.URI.revive(L.source.scope)):ee=I.TaskScope.Workspace),!fe||!ee)return;const Ee=new I.Task(fe,ee,L.name,L.source.label,ae,L.problemMatchers);return L.isBackground!==void 0&&(Ee.isBackground=L.isBackground),L.group!==void 0&&(Ee.group=I.TaskGroup.from(L.group._id),Ee.group&&L.group.isDefault&&(Ee.group=new I.TaskGroup(Ee.group.id,Ee.group.label),L.group.isDefault===!0&&(Ee.group.isDefault=L.group.isDefault))),L.presentationOptions&&(Ee.presentationOptions=k.to(L.presentationOptions)),L._id&&(Ee._id=L._id),L.detail&&(Ee.detail=L.detail),Ee}z.to=K})(C=e.TaskDTO||(e.TaskDTO={}));var F;(function(z){function V(K){return K}z.from=V;function se(K){if(!!K)return Object.assign(Object.create(null),K)}z.to=se})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(V,se,K){this._id=se,this._task=K,_.set(this,void 0),Qe(this,_,V,"f")}get task(){return this._task}terminate(){Re(this,_,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}_=new WeakMap;var R;(function(z){function V(se){return{id:se._id,task:void 0}}z.from=V})(R=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(V,se,K,L,oe,de,ae,fe){this._onDidExecuteTask=new g.Emitter,this._onDidTerminateTask=new g.Emitter,this._onDidTaskProcessStarted=new g.Emitter,this._onDidTaskProcessEnded=new g.Emitter,this._proxy=V.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=L,this._configurationService=oe,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=fe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,se,K){if(!K)return new I.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:se,provider:K,extension:V}),this._proxy.$registerTaskProvider(L,se),new I.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(V,se){this._proxy.$registerTaskSystem(V,se)}fetchTasks(V){return this._proxy.$fetchTasks(F.from(V)).then(async se=>{const K=[];for(let L of se){const oe=await C.to(L,this._workspaceProvider,this._providedCustomExecutions2);oe&&K.push(oe)}return K})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(se=>V.push(se)),V}terminateTask(V){if(!(V instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,se,K){const L=this._providedCustomExecutions2.get(V.id);L&&(this._activeCustomExecutions2.set(V.id,L),this._terminalService.attachPtyToTerminal(se,await L.callback(K))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const se=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:se})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const se=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:se,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const se=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:se,exitCode:V.exitCode})}$provideTasks(V,se){const K=this._handlers.get(V);if(!K)return Promise.reject(new Error("no handler found"));const L=[],oe=(0,D.asPromise)(()=>K.provider.provideTasks(O.CancellationToken.None)).then(de=>this.provideTasksInternal(se,L,K,de));return new Promise(de=>{oe.then(ae=>{Promise.all(L).then(()=>{de(ae)})})})}async $resolveTask(V,se){const K=this._handlers.get(V);if(!K)return Promise.reject(new Error("no handler found"));if(se.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${se.definition.type}] cannot be resolved by provider of type [${K.type}].`);const L=await C.to(se,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const oe=await K.provider.resolveTask(L,O.CancellationToken.None);if(!oe)return;this.checkDeprecation(oe,K);const de=C.from(oe,K.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(oe.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(de.execution)&&await this.addCustomExecution(de,oe,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,se,K){const L=await this._proxy.$createTaskId(V);!K&&!this._providedCustomExecutions2.has(L)&&(this._notProvidedCustomExecutions.add(L),this._activeCustomExecutions2.set(L,se.execution)),this._providedCustomExecutions2.set(L,se.execution)}async getTaskExecution(V,se){if(typeof V=="string"){const oe=this._taskExecutionPromises.get(V);if(!oe)throw new Error("Unexpected: The specified task is missing an execution");return oe}let K=this._taskExecutionPromises.get(V.id);if(K)return K;const L=new Promise((oe,de)=>{function ae(fe,ee,Ee){Ee?oe(new U(fe,ee.id,Ee)):de("Unexpected: Task does not exist.")}se?ae(this,V,se):C.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(fe=>ae(this,V,fe))});return this._taskExecutionPromises.set(V.id,L),L.then(oe=>(this._taskExecutions.set(V.id,oe),oe),oe=>Promise.reject(oe))}checkDeprecation(V,se){V._deprecated&&this._deprecationService.report("Task.constructor",se.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let K=this._notProvidedCustomExecutions.values(),L=K.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=K.next()}};E=$e([ze(0,p.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,w.IExtHostDocumentsAndEditors),ze(4,A.IExtHostConfiguration),ze(5,v.IExtHostTerminalService),ze(6,c.ILogService),ze(7,y.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let x=class extends E{constructor(V,se,K,L,oe,de,ae,fe){super(V,se,K,L,oe,de,ae,fe);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(V,se){if(!se.execution)throw new Error("Tasks to execute must include an execution");const K=C.from(se,V);if(K===void 0)throw new Error("Task is not valid");if(o.is(K.execution))await this.addCustomExecution(K,se,!1);else throw new l.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),se);return this._proxy.$executeTask(K).catch(oe=>{throw new Error(oe)}),L}provideTasksInternal(V,se,K,L){const oe=[];if(L)for(let de of L){this.checkDeprecation(de,K),(!de.definition||!V[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const ae=C.from(de,K.extension);ae&&o.is(ae.execution)?(oe.push(ae),se.push(this.addCustomExecution(ae,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:oe,extension:K.extension}}async resolveTaskInternal(V){if(o.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,se){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,se,K){}};x=$e([ze(0,p.IExtHostRpcService),ze(1,b.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,w.IExtHostDocumentsAndEditors),ze(4,A.IExtHostConfiguration),ze(5,v.IExtHostTerminalService),ze(6,c.ILogService),ze(7,y.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Se[220],De([1,0,17,20,43,33,23,196,40]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(p,b,f){this.config=p,this.provider=b,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&N.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&N.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const b=this.config.folderQueries||[];return new Promise((f,u)=>{const d=c=>{this.resultCount++,p(c)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(c=>{const y=c.toString(),S=a.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,S)||this.matchFile(d,{base:c,basename:S})}),Promise.all(b.map(c=>this.searchInFolder(c,d))).then(c=>{f({limitHit:this.isLimitHit,stats:c[0]||void 0})},c=>{u(new Error((0,g.toErrorMessage)(c)))})})}async searchInFolder(p,b){const f=new D.CancellationTokenSource,u=this.getSearchOptionsForFolder(p),d=this.initDirectoryTree(),c=new w.QueryGlobTester(this.config,p),y=!c.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(f),S=P.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,f.token),_=S.elapsed(),r=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(k=>{const i=a.posix.relative(p.folder.path,k.path);if(y){const s=a.basename(k.path);this.matchFile(b,{base:p.folder,relativePath:i,basename:s});return}this.addDirectoryEntries(d,p.folder,i,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,c,b),{providerTime:_,postProcessTime:r.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(p){const b=(0,w.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),f=(0,w.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:f,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},b,f,u){if(f===this.filePattern){const c=a.basename(this.filePattern);this.matchFile(u,{base:b,relativePath:this.filePattern,basename:c})}function d(c){const y=a.basename(c),S=a.dirname(c);let l=p[S];l||(l=p[S]=[],d(S)),l.push({base:b,relativePath:c,basename:y})}d(f)}matchDirectoryTree({rootEntries:p,pathToEntries:b},f,u){const d=this,c=this.filePattern;function y(S){const l=(0,w.hasSiblingFn)(()=>S.map(_=>_.basename));for(let _=0,r=S.length;_<r;_++){const k=S[_],{relativePath:i,basename:s}=k;if(f.matchesExcludesSync(i,s,c!==s?l:void 0))continue;const n=b[i];if(n)y(n);else{if(i===c)continue;d.matchFile(u,k)}if(d.isLimitHit)break}}y(p)}matchFile(p,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(b))}}class O{constructor(){this.sessions=new Map}fileSearch(p,b,f,u){const d=this.getSessionTokenSource(p.cacheKey),c=new A(p,b,d&&d.token);let y=0;const S=l=>{y+=l.length,f(l.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(c,O.BATCH_SIZE,S,u).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:l.stats}}))}clearCache(p){const b=this.getSessionTokenSource(p);b&&b.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new D.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:I.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,b,f,u){u.onCancellationRequested(()=>{p.cancel()});const d=y=>{y&&(c.push(y),b>0&&c.length>=b&&(f(c),c=[]))};let c=[];return p.search(d).then(y=>(c.length&&f(c),y),y=>(c.length&&f(c),Promise.reject(y)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Se[221],De([1,0,15,54,33,76,21,11,17,23,9,10,2,238,140,59,13,45,89,219,40]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=class{constructor(h,C,F,U,R){this.configurationService=h,this.workspaceContextService=C,this.editorGroupsService=F,this.logService=U,this.pathService=R}text(h,C,F={}){h=this.getContentPattern(h,F);const U=this.configurationService.getValue(),R=C&&C.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(C?.map(c.toWorkspaceFolder),F),type:2,contentPattern:h,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:U.search.usePCRE2||R||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(h,C){const F=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const U={...h,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(h,C)&&(U.isCaseSensitive=!0),this.isMultiline(h)&&(U.isMultiline=!0),U}file(h,C={}){return{...this.commonQuery(h,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(h,C){return h?(h=Array.isArray(h)?h.map(n):n(h),C?this.parseSearchPaths(h):{pattern:k(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],C={}){const F=this.handleIncludeExclude(C.includePattern,C.expandPatterns),U=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),R=h.length>1,E=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,C,U)):h.map(V=>this.getFolderQueryForRoot(V,C,U,R))).filter(V=>!!V),x={_reason:C._reason,folderQueries:E,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:U.pattern,includePattern:F.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const V=a.coalesce(a.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(oe=>oe.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(V));const se=V.filter(L=>(0,l.pathIncludedInQuery)(x,L.fsPath)),K=this.commonQueryFromFileList(se);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...x,...K}}const z=C.extraFileResources&&C.extraFileResources.filter(V=>(0,l.pathIncludedInQuery)(x,V.fsPath));return x.extraFileResources=z&&z.length?z:void 0,x}commonQueryFromFileList(h){const C=[],F=new I.ResourceMap,U={};let R=!1;return h.forEach(E=>{if(E.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(E)){const z=this.workspaceContextService.getWorkspaceFolder(E)?.uri??E.with({path:w.dirname(E.fsPath)});let V=F.get(z);V||(R=!0,V={folder:z,includePattern:{}},C.push(V),F.set(z,V));const se=w.relative(z.fsPath,E.fsPath);(0,v.assertIsDefined)(V.includePattern)[se.replace(/\\/g,"/")]=!0}else E.fsPath&&(R=!0,U[E.fsPath]=!0)}),{folderQueries:C,includePattern:U,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(h,C){if(C.isSmartCase){if(h.isRegExp){if(O.containsUppercaseCharacter(h.pattern,!0))return!0}else if(O.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,b.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const C=K=>w.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),U=(Array.isArray(h)?h:i(h)).map(K=>{const L=this.pathService.resolvedUserHome;return L?(0,N.untildify)(K,L.scheme===P.Schemas.file?L.fsPath:L.path):K}),R=D.groupBy(U,K=>C(K)?"searchPaths":"exprSegments"),E=(R.exprSegments||[]).map(K=>O.rtrim(K,"/")).map(K=>O.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),s(K))),x={},z=this.expandSearchPathPatterns(R.searchPaths||[]);z&&z.length&&(x.searchPaths=z);const V=a.flatten(E),se=k(...V);return se&&(x.pattern=se),x}getExcludesForFolder(h,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(h,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const C=a.flatten(h.map(U=>{let{pathPortion:R,globPortion:E}=r(U);E&&(E=t(E));const x=this.expandOneSearchPath(R);return a.flatten(x.map(z=>this.resolveOneSearchPathPattern(z,E)))})),F=new Map;return C.forEach(U=>{const R=U.searchPath.toString(),E=F.get(R);E?U.pattern&&(E.pattern=E.pattern||{},E.pattern[U.pattern]=!0):F.set(R,{searchPath:U.searchPath,pattern:U.pattern?k(U.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(h){if(w.isAbsolute(h)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==P.Schemas.file?[{searchPath:C[0].uri.with({path:h})}]:[{searchPath:p.URI.file(w.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=n(h),h.startsWith("../")||h===".."){const U=w.posix.resolve(C.path,h);return[{searchPath:C.with({path:U})}]}const F=t(h);return[{searchPath:C,pattern:F}]}else{if(h==="./"||h===".\\")return[];{const C=h.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(R=>{const E=C.match(new RegExp(`^${O.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return E?{match:E,folder:R}:null}).filter(v.isDefined);if(U.length)return U.map(R=>{const E=R.match[1];return{searchPath:R.folder.uri,pattern:E&&t(E)}});{const R=h.match(/\.[\/\\](.+)[\/\\]?/),E=R?R[1]:h,x=f.localize(0,null,E);throw new Error(x)}}}}resolveOneSearchPathPattern(h,C){const F=h.pattern&&C?`${h.pattern}/${C}`:h.pattern||C,U=[{searchPath:h.searchPath,pattern:F}];return F&&!F.endsWith("**")&&U.push({searchPath:h.searchPath,pattern:F+"/**"}),U}getFolderQueryForSearchPath(h,C,F){const U=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(h.searchPath),C,F,!1);return U?{...U,includePattern:h.pattern}:null}getFolderQueryForRoot(h,C,F,U){let R;const E=p.URI.isUri(h)?h:h.uri;if(F.searchPaths){const K=F.searchPaths.filter(L=>(0,A.isEqual)(L.searchPath,E))[0];if(K&&!K.pattern)return null;K&&(R=K.pattern)}const x=this.configurationService.getValue({resource:E}),V={...this.getExcludesForFolder(x,C)||{},...R||{}},se=p.URI.isUri(h)?(0,A.basename)(h):h.name;return{folder:E,folderName:U?se:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!x.search.followSymlinks}}};_=$e([ze(0,u.IConfigurationService),ze(1,c.IWorkspaceContextService),ze(2,y.IEditorGroupsService),ze(3,d.ILogService),ze(4,S.IPathService)],_),e.QueryBuilder=_;function r(m){const h=m.match(/[\*\{\}\(\)\[\]\?]/);if(h){const C=h.index,F=m.substr(0,C).match(/[/|\\][^/\\]*$/);if(F){let U=m.substr(0,F.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:m.substr((F.index||0)+1)}}}return{pathPortion:m}}function k(...m){return m.length?m.reduce((h,C)=>(h[C]=!0,h),Object.create(null)):void 0}function i(m){return g.splitGlobAware(m,",").map(h=>h.trim()).filter(h=>!!h.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function t(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(m,h){m=a.distinct(m,U=>U.toString());const C=[],F=h.getWorkspace();return m&&m.forEach(U=>{let R;if(h.getWorkbenchState()===2)R=(0,A.relativePath)(F.folders[0].uri,U),R&&R!=="."&&(R="./"+R);else{const E=h.getWorkspaceFolder(U);if(E){const x=E.name;if(F.folders.filter(V=>V.name===x).length===1){const V=(0,A.relativePath)(E.uri,U);V===""?R=`./${E.name}`:R=`./${E.name}/${V}`}else R=U.fsPath}}R&&C.push(R)}),C}e.resolveResourcesForSearchIncludes=o}),define(Se[222],De([1,0,23,2,20,12,3,221,40,45]),function(Z,e,a,D,g,N,I,P,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function v(u,d){const c=d.activationEvents;if(!c)return Promise.resolve(void 0);const y=[],S=[];for(const s of c)if(/^workspaceContains:/.test(s)){const n=s.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||u.forceUsingSearch?S.push(n):y.push(n)}if(y.length===0&&S.length===0)return Promise.resolve(void 0);let l;const _=new Promise((s,n)=>{l=s}),r=s=>l({activationEvent:s}),k=Promise.all(y.map(s=>p(u,s,r))).then(()=>{}),i=b(u,d.identifier,S,r);return Promise.all([k,i]).then(()=>{l(void 0)}),_}e.checkActivateWorkspaceContainsExtension=v;async function p(u,d,c){for(const y of u.folders)if(await u.exists(a.joinPath(D.URI.revive(y),d))){c(`workspaceContains:${d}`);return}}async function b(u,d,c,y){if(c.length===0)return Promise.resolve(void 0);const S=new g.CancellationTokenSource,l=u.checkExists(u.folders,c,S.token),_=setTimeout(async()=>{S.cancel(),u.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},O);let r=!1;try{r=await l}catch(k){N.isCancellationError(k)||N.onUnexpectedError(k)}S.dispose(),clearTimeout(_),r&&y(`workspaceContains:${c.join(",")}`)}function f(u,d,c,y){const S=u.get(I.IInstantiationService),l=u.get(w.ISearchService),r=S.createInstance(P.QueryBuilder).file(d.map(k=>(0,A.toWorkspaceFolder)(D.URI.revive(k))),{_reason:"checkExists",includePattern:c,exists:!0});return l.fileSearch(r,y).then(k=>!!k.limitHit,k=>N.isCancellationError(k)?!1:Promise.reject(k))}e.checkGlobFileExists=f});var Qe=this&&this.__classPrivateFieldSet||function(Z,e,a,D,g){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!g:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?g.call(Z,a):g?g.value=a:e.set(Z,a),a},Re=this&&this.__classPrivateFieldGet||function(Z,e,a,D){if(a==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?D:a==="a"?D.call(Z):D?D.value:e.get(Z)};define(Se[31],De([1,0,129,17,73,23,14,7,21,2,13,4,30,178,71,29,24,177,12,26,25,156,6,82,3,28,72,16,60,64,52,5,222,69,158,11]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l,_,r,k,i,s,n,t,o,m,h,C,F,U,R,E){"use strict";var x,z,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let se=class Ti extends P.Disposable{constructor(ee,Ee,we,J,ve,Pe,Fe,We,Ge,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=we,this._initData=Fe,this._extHostWorkspace=J,this._extHostConfiguration=ve,this._logService=Pe,this._extHostTunnelService=Ge,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(v.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(v.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(v.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new c.ExtensionDescriptionRegistry(this._initData.allExtensions);const _e=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new c.ExtensionDescriptionRegistry(oe(this._globalRegistry,_e)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=ee.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));let Ce=[],re=[];this._initData.remote.isRemote&&(Ce=this._initData.allExtensions.filter(X=>!X.main&&!X.browser).map(X=>X.identifier),re=this._initData.allExtensions.filter(X=>!_e.has(S.ExtensionIdentifier.toKey(X.identifier.value))).filter(X=>(X.main||X.browser)&&X.api==="none").map(X=>X.identifier));const le=(0,d.extensionIdentifiersArrayToSet)(re);this._activator=this._register(new b.ExtensionsActivator(this._myRegistry,Ce,re,{onExtensionActivationError:(X,G,T)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(X,y.transformErrorForSerialization(G),T)},actualActivateExtension:async(X,G)=>{if(le.has(S.ExtensionIdentifier.toKey(X)))return await this._mainThreadExtensionsProxy.$activateExtension(X,G),new b.HostExtension;const T=this._myRegistry.getExtensionDescription(X);return this._activateExtension(T,G)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),g.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){y.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(ee)}terminate(ee,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),y.setUnexpectedErrorHandler(J=>{this._logService.error(J)}),this._extHostContext.dispose();const we=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),we]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const Ee=await this._mainThreadExtensionsProxy.$getExtension(ee);return Ee&&{...Ee,identifier:new S.ExtensionIdentifier(Ee.identifier.value),extensionLocation:A.URI.revive(Ee.extensionLocation)}}_activateByEvent(ee,Ee){return this._activator.activateByEvent(ee,Ee)}_activateById(ee,Ee){return this._activator.activateById(ee,Ee)}activateByIdWithErrors(ee,Ee){return this._activateById(ee,Ee).then(()=>{const we=this._activator.getActivatedExtension(ee);if(we.activationFailed)return Promise.reject(we.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==E.Schemas.file)return ee;const Ee=await this._hostUtils.realpath(ee.fsPath);return A.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new ae(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const Ee=w.TernarySearchTree.forUris(we=>N.extUriBiasedIgnorePathCase.ignorePathCasing(we));return await Promise.all(ee.map(async we=>{if(this._getEntryPoint(we)){const J=await this._realPathExtensionUri(we.extensionLocation);Ee.set(J,we)}})),Ee}_deactivate(ee){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return Ee;const we=this._activator.getActivatedExtension(ee);if(!we)return Ee;try{typeof we.module.deactivate=="function"&&(Ee=Promise.resolve(we.module.deactivate()).then(void 0,J=>(this._logService.error(J),Promise.resolve(void 0))))}catch(J){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(J)}try{(0,P.dispose)(we.subscriptions)}catch(J){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(J)}return Ee}async _activateExtension(ee,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,Ee).then(we=>{const J=we.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,Ee),this._logExtensionActivationTimes(ee,Ee,"success",J),we},we=>{throw this._logExtensionActivationTimes(ee,Ee,"failure"),we})}_logExtensionActivationTimes(ee,Ee,we,J){const ve=K(ee,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...J||{},outcome:we})}_doActivateExtension(ee,Ee){const we=K(ee,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",we);const J=this._getEntryPoint(ee);if(!J)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${ee.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new b.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(ee.identifier,(0,N.joinPath)(ee.extensionLocation,J),ve),this._loadExtensionContext(ee)]).then(Pe=>(g.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Ti._callActivate(this._logService,ee.identifier,Pe[0],Pe[1],ve))).then(Pe=>(g.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Pe))}_loadExtensionContext(ee){const Ee=new _.ExtensionGlobalMemento(ee,this._storage),we=new _.ExtensionMemento(ee.identifier.value,!1,this._storage),J=new R.ExtensionSecrets(ee,this._secretState),ve=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Pe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([Ee.whenReady,we.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let We,Ge;const Ie=(0,d.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:we,secrets:J,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(_e){return D.join(ee.extensionLocation.fsPath,_e)},get storagePath(){return Fe._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(ee).fsPath},get logPath(){return D.join(Fe._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return A.URI.joinPath(Fe._initData.logsLocation,ee.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(ee)},get globalStorageUri(){return Fe._storagePath.globalValue(ee)},get extensionMode(){return ve},get extension(){return We===void 0&&(We=new L(Fe,ee.identifier,ee,Pe,!1)),We},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ee,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!Ge){if(!Ie)return;const _e=C.Event.buffer(C.Event.fromDOMEventEmitter(Ie,"message",Ce=>Ce.data));Ie.start(),Ge={onDidReceiveMessage:_e,postMessage:Ie.postMessage.bind(Ie)}}return Ge}})})}static _callActivate(ee,Ee,we,J,ve){return we=we||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,Ee,we,J,ve).then(Pe=>new b.ActivatedExtension(!1,null,ve.build(),we,Pe,J.subscriptions))}static _callActivateOptional(ee,Ee,we,J,ve){if(typeof we.activate=="function")try{ve.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Pe=typeof global=="object"?global:self,Fe=we.activate.apply(Pe,[J]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then(We=>(ve.activateResolveStop(),We))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(we)}_activateOneStartupFinished(ee,Ee){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:Ee}).then(void 0,we=>{this._logService.error(we)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(g.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const Ee of ee.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(ee,Ee)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],we=this._handleWorkspaceContainsEagerExtensions(Ee),J=Promise.all([ee,we]).then(()=>{});return Promise.race([J,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(ee,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,Ee){if(this.isActivated(Ee.identifier))return;const we=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={logService:this._logService,folders:ee.map(Pe=>Pe.uri),forceUsingSearch:we,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,We)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,We)},ve=await(0,F.checkActivateWorkspaceContainsExtension)(J,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:Ee}=this._initData.environment;if(!ee||!Ee)throw new Error(a.localize(0,null));const we=await this._loadCommonJSModule(null,Ee,new b.ExtensionActivationTimesBuilder(!1));if(!we||typeof we.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((J,ve)=>{const Pe=(Ge,Ie)=>{Ge?ve(Ge):J(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,N.originalFSPath)(Ee),We=we.run(Fe,Pe);We&&We.then&&We.then(()=>{J(0)}).catch(Ge=>{ve(Ge instanceof Error&&Ge.stack?Ge.stack:String(Ge))})})}async $extensionTestsExit(ee){this.terminate(`test runner requested exit with code ${ee}`,ee)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,Ee){return this._resolvers[ee]=Ee,(0,P.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const Ee=ee.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const we=ee.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${we}`,!1),{authorityPrefix:we,resolver:this._resolvers[we]}}async $resolveAuthority(ee,Ee){this._logService.info(`$resolveAuthority invoked for authority (${de(ee)})`);const{authorityPrefix:we,resolver:J}=await this._activateAndGetResolver(ee);if(!J)return{type:"error",error:{code:k.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${we}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(J)),g.mark(`code/extHost/willResolveAuthority/${we}`);const ve=await J.resolve(ee,{resolveAttempt:Ee});g.mark(`code/extHost/didResolveAuthorityOK/${we}`);const Pe={authority:ee,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(g.mark(`code/extHost/didResolveAuthorityError/${we}`),ve instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(ee,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${de(ee)})`);const{resolver:we}=await this._activateAndGetResolver(ee);if(!we)return null;const J=A.URI.revive(Ee);if(typeof we.getCanonicalURI=="undefined")return J;const ve=await(0,I.asPromise)(()=>we.getCanonicalURI(J));return ve||J}static _applyExtensionsDelta(ee,Ee,we){const J=new c.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());J.deltaExtensions(we.toAdd,we.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of we.myToRemove)ve.delete(S.ExtensionIdentifier.toKey(Fe));for(const Fe of we.myToAdd)ve.add(S.ExtensionIdentifier.toKey(Fe));const Pe=oe(J,ve);return{globalRegistry:J,myExtensions:Pe}}$startExtensionHost(ee){ee.toAdd.forEach(J=>J.extensionLocation=A.URI.revive(J.extensionLocation));const{globalRegistry:Ee,myExtensions:we}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(we),this._startExtensionHost()}$activateByEvent(ee,Ee){return Ee===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(we=>this._activateByEvent(ee,!1))}async $activate(ee,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,Ee),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Pe=>Pe.extensionLocation=A.URI.revive(Pe.extensionLocation));const{globalRegistry:Ee,myExtensions:we}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),J=await this._createExtensionPathIndex(we);return(await this.getExtensionPathIndex()).setSearchTree(J),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(we),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){let Ee=l.VSBuffer.alloc(ee),we=Math.random()%256;for(let J=0;J<ee;J++)Ee.writeUInt8(we,J);return Ee}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};se=$e([ze(0,i.IInstantiationService),ze(1,e.IHostUtils),ze(2,t.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,p.IExtHostConfiguration),ze(5,O.ILogService),ze(6,s.IExtHostInitDataService),ze(7,n.IExtensionStoragePaths),ze(8,m.IExtHostTunnelService),ze(9,h.IExtHostTerminalService)],se),e.AbstractExtHostExtensionService=se;function K(fe,ee){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class L{constructor(ee,Ee,we,J,ve){x.set(this,void 0),z.set(this,void 0),V.set(this,void 0),Qe(this,x,ee,"f"),Qe(this,z,Ee,"f"),Qe(this,V,we.identifier,"f"),this.id=we.identifier.value,this.extensionUri=we.extensionLocation,this.extensionPath=D.normalize((0,N.originalFSPath)(we.extensionLocation)),this.packageJSON=we,this.extensionKind=J,this.isFromDifferentExtensionHost=ve}get isActive(){return Re(this,x,"f").isActivated(Re(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,x,"f").getExtensionExports(Re(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,x,"f").activateByIdWithErrors(Re(this,V,"f"),{startup:!1,extensionId:Re(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=L,x=new WeakMap,z=new WeakMap,V=new WeakMap;function oe(fe,ee){return fe.getAllExtensionDescriptions().filter(Ee=>ee.has(S.ExtensionIdentifier.toKey(Ee.identifier)))}function de(fe){const ee=fe.indexOf("+");return ee===-1?fe:fe.substring(0,ee)}class ae{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=ae}),define(Se[223],De([1,0,73,2,4,30,24,26,16,28,3,31,61,13,9]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(_,r,k,i,s,n,t){this._apiFactory=_,this._extensionRegistry=r,this._instaService=k,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,r,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(y,r)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,r,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(let r of _.nodeModuleName)this._factories.set(r,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(r=>_.alternativeModuleName(r))}};u=$e([ze(2,O.IInstantiationService),ze(3,N.IExtHostConfiguration),ze(4,v.IExtHostExtensionService),ze(5,A.IExtHostInitDataService),ze(6,b.ILogService)],u),e.RequireInterceptor=u;let d=class Gi{constructor(_){if(_.environment.appRoot&&Gi.aliased.size){const r=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),k="[a-z0-9_.-]",i=`@${k}+\\/${k}+|${k}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${s}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(_));if(!r)return;const[,k,i,s]=r,n=Gi.aliased.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),k+n+s}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=$e([ze(0,A.IExtHostInitDataService)],d);class c{constructor(_,r,k,i,s){this._apiFactory=_,this._extensionPaths=r,this._extensionRegistry=k,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,r){const k=this._extensionPaths.findSubstr(r);if(k){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(k.identifier));return i||(i=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(k.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,n)=>i+=`	${n} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(_,r,k){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(g.MainContext.MainThreadTelemetry);const{environment:i}=k,s=r.getProxy(g.MainContext.MainThreadKeytar);if(i.appRoot){let n=i.appRoot.fsPath;p.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>s.$getPassword(n,t),setPassword:(n,t,o)=>s.$setPassword(n,t,o),deletePassword:(n,t)=>s.$deletePassword(n,t),findPassword:n=>s.$findPassword(n),findCredentials(n){return s.$findCredentials(n)}}}load(_,r){const k=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:k?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const r=_.length;if(r<=7||!this.alternativeNames)return;const k=r-7;if((_.charAt(k)==="/"||_.charAt(k)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};y=$e([ze(1,w.IExtHostRpcService),ze(2,A.IExtHostInitDataService)],y);let S=class{constructor(_,r,k){this._extensionPaths=_,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(g.MainContext.MainThreadTelemetry);const i=k.getProxy(g.MainContext.MainThreadWindow);this._impl=(s,n)=>{const t=D.URI.parse(s);return n?this.callOriginal(s,n):t.scheme==="http"||t.scheme==="https"?i.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?i.$openUri(t,s,{}):this.callOriginal(s,n)}}load(_,r,k){const i=this._extensionPaths.findSubstr(r);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=k(_),this._impl}callOriginal(_,r){return this.sendNoForwardTelemetry(),this._original(_,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=$e([ze(2,w.IExtHostRpcService)],S)}),define(Se[101],De([1,0,190,7,17,61,3,49,50,31,6,29,171,30]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends p.AbstractVariableResolverService{constructor(c,y,S,l,_,r,k){function i(){if(S){const s=S.activeEditor();if(s)return s.document.uri;const n=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof O.TextDiffTabInput||n.input instanceof O.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof O.TextTabInput||n.input instanceof O.NotebookEditorTabInput||n.input instanceof O.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:s=>{const n=r.folders.filter(t=>t.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,n)=>_.getConfiguration(void 0,s).get(n),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=i();if(s)return g.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(y){const s=i();if(s){const n=y.getWorkspaceFolder(s);if(n)return g.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(S){const s=S.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(S){const s=S.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>c.getExtension(s)},void 0,k?Promise.resolve(k):void 0,Promise.resolve(N.env))}}let u=class extends D.Disposable{constructor(c,y,S,l,_){super();this.extensionService=c,this.workspaceService=y,this.editorService=S,this.configurationService=l,this.editorTabs=_,this._resolver=new a.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};u=$e([ze(0,A.IExtHostExtensionService),ze(1,v.IExtHostWorkspace),ze(2,P.IExtHostDocumentsAndEditors),ze(3,b.IExtHostConfiguration),ze(4,w.IExtHostEditorTabs)],u),e.ExtHostVariableResolverProviderService=u}),define(Se[102],De([1,0,14,5,10,2,3,4,50,31,16,6,29,164,166,30,101]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let c=class{constructor(i,s,n,t,o,m){this._workspaceService=s,this._extensionService=n,this._configurationService=t,this._editorTabs=o,this._variableResolver=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=i.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(C=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,s){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,o="?";return s&&(t+=`${o}session=${encodeURIComponent(s.id)}`,o="&"),t+=`${o}ref=${n.sourceReference}`,N.URI.parse(t)}else{if(n.path)return N.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const s=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const o of t)(0,f.isDebuggerMainContribution)(o)&&s.push(o.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(s=>i.push(s)),i}addBreakpoints(i){this.startBreakpoints();const s=i.filter(o=>{const m=o.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,o),!0)});this.fireBreakpointChanges(s,[],[]);const n=[],t=new Map;for(const o of s)if(o instanceof v.SourceBreakpoint){let m=t.get(o.location.uri.toString());m||(m={type:"sourceMulti",uri:o.location.uri,lines:[]},t.set(o.location.uri.toString(),m),n.push(m)),m.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof v.FunctionBreakpoint&&n.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(i){this.startBreakpoints();const s=i.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],s,[]);const n=s.filter(m=>m instanceof v.SourceBreakpoint).map(m=>m.id),t=s.filter(m=>m instanceof v.FunctionBreakpoint).map(m=>m.id),o=s.filter(m=>m instanceof v.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,o)}startDebugging(i,s,n){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===v.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,s,n){if(!s)return new v.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new v.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,s,n){if(!n)return new v.Disposable(()=>{});if(!this.definesDebugType(i,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new v.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,s){if(!s)return new v.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:n,factory:s}),new v.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(i,s){return Promise.resolve(void 0)}async $substituteVariables(i,s){let n;const t=await this.getFolder(i);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,s)}createDebugAdapter(i,s){if(i.type==="implementation")return new _(i.implementation)}createSignService(){}async $startDASession(i,s){const n=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const m=this.convertToDto(o),h=this.createDebugAdapter(m,t);if(!h)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const C=h;return this._debugAdapters.set(i,C),this.getDebugAdapterTrackers(t).then(F=>(F&&this._debugAdaptersTrackers.set(i,F),C.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const R=U,E={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(R.arguments.value);E.body={signature:x},C.sendResponse(E)}else throw new Error("no signer")}catch(x){E.success=!1,E.message=x.message,C.sendResponse(E)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(U),U=(0,f.convertToVSCPaths)(U,!0),n._debugServiceProxy.$acceptDAMessage(i,U)}),C.onError(U=>{F&&F.onError&&F.onError(U),this._debugServiceProxy.$acceptDAError(i,U.name,U.message,U.stack)}),C.onExit(U=>{F&&F.onExit&&F.onExit((0,g.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,g.withNullAsUndefined)(U),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),C.startSession()))})}$sendDAMessage(i,s){s=(0,f.convertToDAPaths)(s,!1);const n=this._debugAdaptersTrackers.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s);const t=this._debugAdapters.get(i);t&&t.sendMessage(s)}$stopDASession(i){const s=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),s&&s.onWillStopSession&&s.onWillStopSession();const n=this._debugAdapters.get(i);return this._debugAdapters.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const s=[],n=[],t=[];if(i.added)for(const o of i.added){const m=o.id;if(m&&!this._breakpoints.has(m)){let h;if(o.type==="function")h=new v.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")h=new v.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const C=N.URI.revive(o.uri);h=new v.SourceBreakpoint(new v.Location(C,new v.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}h._id=m,this._breakpoints.set(m,h),s.push(h)}}if(i.removed)for(const o of i.removed){const m=this._breakpoints.get(o);m&&(this._breakpoints.delete(o),n.push(m))}if(i.changed){for(const o of i.changed)if(o.id){const m=this._breakpoints.get(o.id);if(m){if(m instanceof v.FunctionBreakpoint&&o.type==="function"){const h=m;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.functionName=o.functionName}else if(m instanceof v.SourceBreakpoint&&o.type==="source"){const h=m;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.location=new v.Location(N.URI.revive(o.uri),new v.Position(o.line,o.character))}t.push(m)}}}this.fireBreakpointChanges(s,n,t)}$provideDebugConfigurations(i,s,n){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(s);return t.provideDebugConfigurations(o,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,s,n,t){return(0,a.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(s);return o.resolveDebugConfiguration(m,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,s,n,t){return(0,a.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(s);return o.resolveDebugConfigurationWithSubstitutedVariables(m,n,t)})}async $provideDebugAdapter(i,s){const n=this.getAdapterDescriptorFactoryByHandle(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(n,t).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(i){const s=await this.getSession(i);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(i){const s=await this.getSession(i);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,s){const n=await this.getSession(i);n&&n._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(i,s){const t={session:await this.getSession(i),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof v.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof v.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof v.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof v.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const s=this._adapterFactories.filter(n=>n.type===i);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(i){const s=this._adapterFactories.filter(n=>n.handle===i);if(s.length>0)return s[0].factory}getConfigProviderByHandle(i){const s=this._configProviders.filter(n=>n.handle===i);if(s.length>0)return s[0].provider}definesDebugType(i,s){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(i){const n=i.configuration.type,t=this._trackerFactories.filter(o=>o.type===n||o.type==="*").map(o=>(0,a.asPromise)(()=>o.factory.createDebugAdapterTracker(i)).then(m=>m,m=>null));return Promise.race([Promise.all(t).then(o=>{const m=o.filter(h=>!!h);if(m.length>0)return new l(m)}),new Promise((o,m)=>{const h=setTimeout(()=>{clearTimeout(h),m(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(i,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new v.DebugAdapterServer(n));if(i){const o=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>i.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,o))).then(m=>{if(m)return m})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(i,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,s,n){(i.length>0||s.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:s,changed:n}))}async getSession(i){if(i)if(typeof i=="string"){const s=this._debugSessions.get(i);if(s)return s}else{let s=this._debugSessions.get(i.id);if(!s){const n=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;s=new y(this._debugServiceProxy,i.id,i.type,i.name,n,i.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(i){if(i){const s=N.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};c=$e([ze(0,O.IExtHostRpcService),ze(1,p.IExtHostWorkspace),ze(2,A.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,w.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],c),e.ExtHostDebugServiceBase=c;class y{constructor(i,s,n,t,o,m,h){this._debugServiceProxy=i,this._id=s,this._type=n,this._name=t,this._workspaceFolder=o,this._configuration=m,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,s)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=y;class S{constructor(i){this.value=Object.freeze({append(s){i.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=S;class l{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(s=>s.onError?s.onError(i):void 0)}onExit(i,s){this.trackers.forEach(n=>n.onExit?n.onExit(i,s):void 0)}}class _ extends b.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(i,s,n,t,o,m){super(i,s,n,t,o,m)}};r=$e([ze(0,O.IExtHostRpcService),ze(1,p.IExtHostWorkspace),ze(2,A.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,w.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(Se[224],De([1,0,12,73,2,4,215,13,58,60,28,146,16,65,31]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class u{constructor(c,y,S,l,_){this._hostUtils=S,this._rpcProtocol=new I.RPCProtocol(c,null,l),y=u._transform(y,this._rpcProtocol);const r=new A.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:_}),r.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),r.set(b.IURITransformerService,new b.URITransformerService(l)),r.set(f.IHostUtils,S);const k=new v.InstantiationService(r,!0);this._logService=k.invokeFunction(t=>t.get(P.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",y),this._extensionService=k.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(o,m)=>{let h="",C,F;for(const U of m)h+=`
	at ${U.toString()}`,F=U.getFileName(),!C&&F&&(C=t.findSubstr(g.URI.file(F)));return i.set(o,C),`${o.name||"Error"}: ${o.message||""}${h}`}});const s=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(N.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const o=a.transformErrorForSerialization(t),m=i.get(t);m?s.$onExtensionRuntimeError(m.identifier,o):n.$onUnexpectedError(o)})}async asBrowserUri(c){const y=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return g.URI.revive(await y.$asBrowserUri(c))}terminate(c){this._extensionService.terminate(c)}static _transform(c,y){c.allExtensions.forEach(l=>l.extensionLocation=g.URI.revive(y.transformIncomingURIs(l.extensionLocation))),c.environment.appRoot=g.URI.revive(y.transformIncomingURIs(c.environment.appRoot));const S=c.environment.extensionDevelopmentLocationURI;return S&&(c.environment.extensionDevelopmentLocationURI=S.map(l=>g.URI.revive(y.transformIncomingURIs(l)))),c.environment.extensionTestsLocationURI=g.URI.revive(y.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=g.URI.revive(y.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=g.URI.revive(y.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=g.URI.revive(y.transformIncomingURIs(c.logsLocation)),c.logFile=g.URI.revive(y.transformIncomingURIs(c.logFile)),c.workspace=y.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=u}),define(Se[225],De([1,0,15,14,20,43,11,17,23,10,2,40]),function(Z,e,a,D,g,N,I,P,w,A,O,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class p{constructor(S,l,_,r){this.query=S,this.provider=l,this.fileUtils=_,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(S,l){const _=this.query.folderQueries||[],r=new g.CancellationTokenSource;return l.onCancellationRequested(()=>r.cancel()),new Promise((k,i)=>{this.collector=new f(S);let s=!1;const n=(t,o)=>{if(!s&&!this.isLimitHit){const m=this.resultSize(t);d(t)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,s=!0,r.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const h=this.resultSize(t);this.resultCount+=h,(h>0||!d(t))&&this.collector.add(t,o)}};Promise.all(_.map((t,o)=>this.searchInFolder(t,m=>n(m,o),r.token))).then(t=>{r.dispose(),this.collector.flush();const o=t.some(m=>!!m&&!!m.limitHit);k({limitHit:this.isLimitHit||o,messages:(0,a.flatten)(t.map(m=>m?.message?(0,A.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},t=>{r.dispose();const o=(0,N.toErrorMessage)(t);i(new Error(o))})})}resultSize(S){return d(S)?Array.isArray(S.ranges)?S.ranges.length:1:0}trimResultToSize(S,l){const _=Array.isArray(S.ranges)?S.ranges:[S.ranges],r=Array.isArray(S.preview.matches)?S.preview.matches:[S.preview.matches];return{ranges:_.slice(0,l),preview:{matches:r.slice(0,l),text:S.preview.text},uri:S.uri}}async searchInFolder(S,l,_){const r=new v.QueryGlobTester(this.query,S),k=[],i={report:t=>{if(!this.validateProviderResult(t))return;const o=S.folder.scheme===I.Schemas.file?(0,v.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(t.uri))):void 0,m=w.relativePath(S.folder,t.uri);if(m){const h=r.includedInQuery(m,P.basename(m),o);(0,D.isThenable)(h)?k.push(h.then(C=>{C&&l(t)})):h&&l(t)}}},s=this.getSearchOptionsForFolder(S),n=await this.provider.provideTextSearchResults(b(this.query.contentPattern),s,i,_);return k.length&&await Promise.all(k),n}validateProviderResult(S){if(d(S)){if(Array.isArray(S.ranges)){if(!Array.isArray(S.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(S.preview.matches.length!==S.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(S.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(S){const l=(0,v.resolvePatternsForProvider)(this.query.includePattern,S.includePattern),_=(0,v.resolvePatternsForProvider)(this.query.excludePattern,S.excludePattern),r={folder:O.URI.from(S.folder),excludes:_,includes:l,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,encoding:S.fileEncoding&&this.fileUtils.toCanonicalName(S.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=p;function b(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class f{constructor(S){this._onResult=S,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new c(512,l=>this.sendItems(l))}add(S,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!w.isEqual(this._currentUri,S.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:S.uri,results:[]}),this._currentFileMatch.results.push(u(S))}pushToCollector(){const S=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,S)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(S){this._onResult(S)}}e.TextSearchResultsCollector=f;function u(y){return d(y)?{preview:{matches:(0,a.mapArrayOrNot)(y.preview.matches,S=>({startLineNumber:S.start.line,startColumn:S.start.character,endLineNumber:S.end.line,endColumn:S.end.character})),text:y.preview.text},ranges:(0,a.mapArrayOrNot)(y.ranges,S=>({startLineNumber:S.start.line,startColumn:S.start.character,endLineNumber:S.end.line,endColumn:S.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function d(y){return!!y.preview}e.extensionResultIsMatch=d;class c{constructor(S,l){this.maxBatchSize=S,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(S,l){!S||this.addItemToBatch(S,l)}addItems(S,l){!S||this.addItemsToBatch(S,l)}addItemToBatch(S,l){this.batch.push(S),this.batchSize+=l,this.onUpdate()}addItemsToBatch(S,l){this.batch=this.batch.concat(S),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<c.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},c.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=c,c.TIMEOUT=4e3,c.START_BATCH_AFTER_COUNT=50}),define(Se[103],De([1,0,7,4,3,220,16,65,13,2,225]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,g.createDecorator)("IExtHostSearch");let v=class{constructor(u,d,c){this.extHostRpc=u,this._uriTransformer=d,this._logService=c,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,d){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const c=this._handlePool++;return this._textSearchProvider.set(c,d),this._proxy.$registerTextSearchProvider(c,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}registerFileSearchProvider(u,d){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const c=this._handlePool++;return this._fileSearchProvider.set(c,d),this._proxy.$registerFileSearchProvider(c,this._transformScheme(u)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(u,d,c,y){const S=p(c),l=this._fileSearchProvider.get(u);if(l)return this._fileSearchManager.fileSearch(S,l,_=>{this._proxy.$handleFileMatch(u,d,_.map(r=>r.resource))},y);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,d,c,y){const S=this._textSearchProvider.get(u);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const l=p(c);return this.createTextSearchManager(l,S).search(r=>this._proxy.$handleTextMatch(u,d,r),y)}$enableExtensionHostSearch(){}createTextSearchManager(u,d){return new O.TextSearchManager(u,d,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};v=$e([ze(0,I.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,w.ILogService)],v),e.ExtHostSearch=v;function p(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(u=>A.URI.revive(u))}}e.reviveQuery=p;function b(f){return{...f,folder:A.URI.revive(f.folder)}}}),define(Se[226],De([1,0,58,98,29,94,30,36,49,52,100,102,103,71,64,70,97,51,35,69,84,50,198,13,179,101]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l,_,r,k,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(k.ILoggerService,r.ExtHostLoggerService),(0,a.registerSingleton)(k.ILogService,i.ExtHostLogService),(0,a.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,a.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,a.registerSingleton)(c.IExtHostConsumerFileSystem,c.ExtHostConsumerFileSystem),(0,a.registerSingleton)(v.IExtHostDebugService,v.WorkerExtHostDebugService),(0,a.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations),(0,a.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,a.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService),(0,a.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,a.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,a.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,a.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,a.registerSingleton)(g.IExtHostWorkspace,g.ExtHostWorkspace),(0,a.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState),(0,a.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,a.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs),(0,a.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(Se[227],De([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(g){if(g&&this._dragOperations.has(g)){const N=this._dragOperations.get(g);return this._dragOperations.delete(g),N}}addDragOperationTransfer(g,N){this._dragOperations.set(g,N)}getRenderedTreeElement(g){if(this._renderedElements.has(g))return this._renderedElements.get(g)}addRenderedTreeItemElement(g,N){this._renderedElements.set(g,N)}removeRenderedTreeItemElement(g){this._renderedElements.has(g)&&this._renderedElements.delete(g)}}e.TreeviewsService=a}),define(Se[228],De([1,0,133,23,2,5,7,14,6,10,15,8,20,86,227,24]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(S,l){if((0,A.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class c{constructor(l,_,r){this._proxy=l,this.commands=_,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function k(i){return i&&i.$treeViewId&&i.$treeItemHandle}_.registerArgumentProcessor({processArgument:i=>k(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(s=>k(s)?this.convertArgument(s):s):i})}registerTreeDataProvider(l,_,r){const k=this.createTreeView(l,{treeDataProvider:_},r);return{dispose:()=>k.dispose()}}createTreeView(l,_,r){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const k=_.dragAndDropController?.dropMimeTypes??[],i=_.dragAndDropController?.dragMimeTypes??[],s=!!_.dragAndDropController?.handleDrag,n=!!_.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:k,dragMimeTypes:i,hasHandleDrag:s,hasHandleDrop:n}),o=this.createExtHostTreeView(l,_,r);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(m){o.message=m},get title(){return o.title},set title(m){o.title=m},get description(){return o.description},set description(m){o.description=m},get badge(){return(0,u.checkProposedApiEnabled)(r,"badges"),o.badge},set badge(m){(0,u.checkProposedApiEnabled)(r,"badges"),o.badge=m},reveal:(m,h)=>o.reveal(m,h),dispose:async()=>{await t,this.treeViews.delete(l),o.dispose()}}}$getChildren(l,_){const r=this.treeViews.get(l);return r?r.getChildren(_):Promise.reject(new Error((0,a.localize)(0,null,l)))}async $handleDrop(l,_,r,k,i,s,n,t){const o=this.treeViews.get(l);if(!o)return Promise.reject(new Error((0,a.localize)(1,null,l)));const m=b.DataTransferConverter.toDataTransfer(r,async h=>(await this._proxy.$resolveDropFileData(l,_,h)).buffer);return n===l&&t&&await this.addAdditionalTransferItems(m,o,t,i,s),o.onDrop(m,k,i)}async addAdditionalTransferItems(l,_,r,k,i){const s=this.treeDragAndDropService.removeDragOperationTransfer(i);if(s)(await s)?.forEach((n,t)=>{if(n){const o=n.asFile();l.set(t,{value:n.value,asString:n.asString,asFile(){if(!!o)return{name:o.name,uri:o.uri,data:async()=>await o.data()}}})}});else if(i&&_.handleDrag){const n=_.handleDrag(r,l,k);this.treeDragAndDropService.addDragOperationTransfer(i,n),await n}return l}async $handleDrag(l,_,r,k){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,a.localize)(2,null,l)));const s=await this.addAdditionalTransferItems(new Map,i,_,k,r);if(!!s)return b.DataTransferConverter.toDataTransferDTO(s)}async $hasResolve(l){const _=this.treeViews.get(l);if(!_)throw new Error((0,a.localize)(3,null,l));return _.hasResolve}$resolve(l,_,r){const k=this.treeViews.get(l);if(!k)throw new Error((0,a.localize)(4,null,l));return k.resolveTreeItem(_,r)}$setExpanded(l,_,r){const k=this.treeViews.get(l);if(!k)throw new Error((0,a.localize)(5,null,l));k.setExpanded(_,r)}$setSelection(l,_){const r=this.treeViews.get(l);if(!r)throw new Error((0,a.localize)(6,null,l));r.setSelection(_)}$setVisible(l,_){const r=this.treeViews.get(l);if(!r)throw new Error((0,a.localize)(7,null,l));r.setVisible(_)}createExtHostTreeView(l,_,r){const k=new y(l,_,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(l,k),k}convertArgument(l){const _=this.treeViews.get(l.$treeViewId);return _?_.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=c;class y extends I.Disposable{constructor(l,_,r,k,i,s){super();if(this.viewId=l,this.proxy=r,this.commands=k,this.logService=i,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new N.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new N.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new N.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new N.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new N.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,s.contributes&&s.contributes.views)for(const o in s.contributes.views)for(const m of s.contributes.views[o])m.id===l&&(this._title=m.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,t;this._register(N.Event.debounce(this._onDidChangeData.event,(o,m)=>(o||(o={message:!1,elements:[]}),m.element!==!1&&(n||(n=new Promise(h=>t=h),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(m.element)?o.elements.push(...m.element):o.elements.push(m.element)),m.message&&(o.message=!0),o),200,!0)(({message:o,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=t;return n=null,this.refresh(m).then(()=>h())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.isUndefinedOrNull)(l))}async getChildren(l){const _=l?this.getExtensionElement(l):void 0;if(l&&!_)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(l);return r||(r=await this.fetchChildrenNodes(_)),r?r.map(k=>k.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,_){_=_||{select:!0,focus:!1};const r=(0,A.isUndefinedOrNull)(_.select)?!0:_.select,k=(0,A.isUndefinedOrNull)(_.focus)?!1:_.focus,i=(0,A.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(t=>t.item)},{select:r,focus:k,expand:i})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:k,expand:i})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=v.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,_){const r=this.getExtensionElement(l);r&&(_?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(l){(0,O.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,_,r){const k=[];for(const i of l){const s=this.getExtensionElement(i);s&&k.push(s)}if(!(!this.dndController?.handleDrag||k.length===0))return await this.dndController.handleDrag(k,_,r),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,_,r){const k=_?this.getExtensionElement(_):void 0;if(!(!k&&_||!this.dndController?.handleDrop))return(0,P.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(k,l,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,_){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(l);if(r){const k=this.nodes.get(r);if(k){const i=await this.dataProvider.resolveTreeItem(k.extensionItem,r,_)??k.extensionItem;return k.item.tooltip=this.getTooltip(i.tooltip),k.item.command=this.getCommand(k.disposableStore,i.command),k.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(_=>_?this.resolveUnknownParentChain(_).then(r=>this.resolveTreeNode(_,r[r.length-1]).then(k=>(r.push(k),r))):Promise.resolve([]))}resolveParent(l){const _=this.nodes.get(l);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,_){const r=this.nodes.get(l);return r?Promise.resolve(r):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(k=>this.createHandle(l,k,_,!0)).then(k=>this.getChildren(_?_.item.handle:void 0).then(()=>{const i=this.getExtensionElement(k);if(i){const s=this.nodes.get(i);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${k}`)}))}getChildrenNodes(l){if(l){let _;if(typeof l=="string"){const r=this.getExtensionElement(l);_=r?this.nodes.get(r):void 0}else _=l;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const _=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=l?this.nodes.get(l):void 0,k=await this.dataProvider.getChildren(l);if(_.token.isCancellationRequested)return;const i=await Promise.all((0,O.coalesce)(k||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,r):null}));return _.token.isCancellationRequested?void 0:(0,O.coalesce)(i)}finally{_.dispose()}}refresh(l){if(l.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(l);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const _=new Set,r=l.map(i=>this.nodes.get(i));for(const i of r)if(i&&!_.has(i.item.handle)){let s=i;for(;s&&s.parent&&r.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&_.add(i.item.handle)}const k=[];return _.forEach(i=>{const s=this.elements.get(i);if(s){const n=this.nodes.get(s);n&&(!n.parent||!_.has(n.parent.item.handle))&&k.push(i)}}),k}refreshHandles(l){const _={};return Promise.all(l.map(r=>this.refreshNode(r).then(k=>{k&&(_[r]=k.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(l){const _=this.getExtensionElement(l);if(_){const r=this.nodes.get(_);if(r)return this.clearChildren(_),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(k=>{if(k){const i=this.createTreeNode(_,k,r.parent);return this.updateNodeCache(_,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,_,r){const k=this.createTreeNode(l,_,r);if(_.id&&this.elements.has(k.item.handle))throw new Error((0,a.localize)(8,null,_.id));return this.addNodeToCache(l,k),this.addNodeToParentCache(k,r),k}getTooltip(l){return w.MarkdownString.isMarkdownString(l)?v.MarkdownString.from(l):l}getCommand(l,_){return _?this.commands.toInternal(_,l):void 0}createTreeNode(l,_,r){const k=new I.DisposableStore,i=this.createHandle(l,_,r),s=this.getLightIconPath(_);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:d(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(k,_.command),contextValue:_.contextValue,icon:s,iconDark:this.getDarkIconPath(_)||s,themeIcon:this.getThemeIcon(_),collapsibleState:(0,A.isUndefinedOrNull)(_.collapsibleState)?w.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:r,children:void 0,disposableStore:k,dispose(){k.dispose()}}}getThemeIcon(l){return l.iconPath instanceof w.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:_,label:r,resourceUri:k},i,s){if(_)return`${y.ID_HANDLE_PREFIX}/${_}`;const n=d(r,this.extension),t=i?i.item.handle:y.LABEL_HANDLE_PREFIX;let o=n?n.label:k?(0,D.basename)(k):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const m=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,h=this.getChildrenNodes(i)||[];let C,F=0;do{if(C=`${t}/${F}:${o}`,s||!this.elements.has(C)||m===C)break;F++}while(F<=h.length);return C}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof w.ThemeIcon))return typeof l.iconPath=="string"||g.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof w.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return g.URI.isUri(l)?l:g.URI.file(l)}addNodeToCache(l,_){this.elements.set(_.item.handle,l),this.nodes.set(l,_)}updateNodeCache(l,_,r,k){this.elements.delete(_.item.handle),this.nodes.delete(l),_.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(l,_);const i=this.getChildrenNodes(k)||[],s=i.filter(n=>n.item.handle===r.item.handle)[0];s&&i.splice(i.indexOf(s),1,_)}addNodeToParentCache(l,_){_?(_.children||(_.children=[]),_.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const _=this.nodes.get(l);if(_){if(_.children)for(const r of _.children){const k=this.elements.get(r.item.handle);k&&this.clear(k)}_.children=void 0}}else this.clearAll()}clear(l){const _=this.nodes.get(l);if(_){if(_.children)for(const r of _.children){const k=this.elements.get(r.item.handle);k&&this.clear(k)}this.nodes.delete(l),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}y.LABEL_HANDLE_PREFIX="0",y.ID_HANDLE_PREFIX="1"}),define(Se[229],De([1,0,20,12,5,32,2,120,239,115,114,38,4,93,184,183,36,185,30,186,187,188,173,189,49,31,191,192,195,197,199,98,175,204,205,206,71,52,208,228,8,6,211,53,97,29,54,163,194,83,94,100,102,103,13,65,16,28,200,159,64,70,181,209,72,51,214,212,213,182,35,207,210,69,50,84,96,99,203,11,80,201,157,193,7,24,165,202]),function(Z,e,a,D,g,N,I,P,w,A,O,v,p,b,f,u,d,c,y,S,l,_,r,k,i,s,n,t,o,m,h,C,F,U,R,E,x,z,V,se,K,L,oe,de,ae,fe,ee,Ee,we,J,ve,Pe,Fe,We,Ge,Ie,_e,Ce,re,le,X,G,T,B,W,H,ne,he,Y,ge,pe,Ne,xe,ke,qe,j,Q,me,Le,Be,Xe,Ze,rt,Ye,Je,je,lt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function It(at){const ht=at.get(Ce.IExtHostInitDataService),Ut=at.get(pe.IExtHostFileSystemInfo),Ft=at.get(H.IExtHostConsumerFileSystem),yt=at.get(s.IExtHostExtensionService),ft=at.get(fe.IExtHostWorkspace),Dt=at.get(j.IExtHostTelemetry),Pt=at.get(y.IExtHostConfiguration),Nt=at.get(Ie.IURITransformerService),He=at.get(_e.IExtHostRpcService),$t=at.get(x.IExtHostStorage),At=at.get(W.IExtensionStoragePaths),Mt=at.get(Ge.ILoggerService),be=at.get(Ge.ILogService),ye=at.get(X.IExtHostTunnelService),ue=at.get(G.IExtHostApiDeprecationService),q=at.get(ae.IExtHostWindow),Ae=at.get(ke.IExtHostSecretState),Ue=at.get(qe.IExtHostEditorTabs);He.set(p.ExtHostContext.ExtHostFileSystemInfo,Ut),He.set(p.ExtHostContext.ExtHostLogLevelServiceShape,Mt),He.set(p.ExtHostContext.ExtHostWorkspace,ft),He.set(p.ExtHostContext.ExtHostConfiguration,Pt),He.set(p.ExtHostContext.ExtHostExtensionService,yt),He.set(p.ExtHostContext.ExtHostStorage,$t),He.set(p.ExtHostContext.ExtHostTunnelService,ye),He.set(p.ExtHostContext.ExtHostWindow,q),He.set(p.ExtHostContext.ExtHostSecretState,Ae),He.set(p.ExtHostContext.ExtHostTelemetry,Dt),He.set(p.ExtHostContext.ExtHostEditorTabs,Ue);const tt=He.set(p.ExtHostContext.ExtHostDecorations,at.get(ve.IExtHostDecorations)),Ve=He.set(p.ExtHostContext.ExtHostDocumentsAndEditors,at.get(i.IExtHostDocumentsAndEditors)),ot=He.set(p.ExtHostContext.ExtHostCommands,at.get(d.IExtHostCommands)),ct=He.set(p.ExtHostContext.ExtHostTerminalService,at.get(z.IExtHostTerminalService)),pt=He.set(p.ExtHostContext.ExtHostDebugService,at.get(Fe.IExtHostDebugService)),_t=He.set(p.ExtHostContext.ExtHostSearch,at.get(We.IExtHostSearch)),mt=He.set(p.ExtHostContext.ExtHostTask,at.get(Pe.IExtHostTask)),vt=He.set(p.ExtHostContext.ExtHostOutputService,at.get(C.IExtHostOutputService)),Rt=He.set(p.ExtHostContext.ExtHostUrls,new oe.ExtHostUrls(He)),Et=He.set(p.ExtHostContext.ExtHostDocuments,new k.ExtHostDocuments(He,Ve)),Gt=He.set(p.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(He,Ve,be)),Qt=He.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(be,Et,He.getProxy(p.MainContext.MainThreadBulkEdits))),bt=He.set(p.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(He,ot,Ve,Et,At)),Wt=He.set(p.ExtHostContext.ExtHostNotebookDocuments,new rt.ExtHostNotebookDocuments(bt)),Yt=He.set(p.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(be,He,bt)),Jt=He.set(p.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(He,ht,bt,ot,be)),ui=He.set(p.ExtHostContext.ExtHostNotebookProxyKernels,new st.ExtHostNotebookProxyKernels(He,Jt,be)),ci=He.set(p.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(He,bt)),Tt=He.set(p.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(He,Ve)),Zt=He.set(p.ExtHostContext.ExtHostTreeViews,new se.ExtHostTreeViews(He.getProxy(p.MainContext.MainThreadTreeViews),ot,be)),di=He.set(p.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(He.getProxy(p.MainContext.MainThreadEditorInsets),Tt,ht.remote)),Xt=He.set(p.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(He,be,Ut)),ei=He.set(p.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(He,Et,ot.converter,Nt)),dt=He.set(p.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(He,Nt,Et,ot,Xt,be,ue)),hi=He.set(p.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(He,dt)),Bt=He.set(p.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(He,be,Ve)),Ht=He.set(p.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(He,ft,ot)),ti=He.set(p.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(He,ot,be)),ki=He.set(p.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(He,ot,Et)),ii=He.set(p.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(He.getProxy(p.MainContext.MainThreadProgress))),fi=He.set(p.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(He)),_i=He.set(p.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(He)),ni=He.set(p.ExtHostContext.ExtHostAuthentication,new T.ExtHostAuthentication(He)),Pi=He.set(p.ExtHostContext.ExtHostTimeline,new B.ExtHostTimeline(He,ot)),mi=He.set(p.ExtHostContext.ExtHostWebviews,new de.ExtHostWebviews(He,ht.remote,ft,be,ue)),gi=He.set(p.ExtHostContext.ExtHostWebviewPanels,new Y.ExtHostWebviewPanels(He,mi,ft)),Ai=He.set(p.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(He,Et,At,mi,gi)),pi=He.set(p.ExtHostContext.ExtHostWebviewViews,new ne.ExtHostWebviewViews(He,mi)),Vt=He.set(p.ExtHostContext.ExtHostTesting,new Ne.ExtHostTesting(He,ot)),Ri=He.set(p.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(He));He.set(p.ExtHostContext.ExtHostInteractive,new Ye.ExtHostInteractive(He,bt,Ve,ot));const Oi=(0,ee.values)(p.ExtHostContext);He.assertRegistered(Oi);const Fi=new ge.ExtHostBulkEdits(He,Ve),ri=new u.ExtHostClipboard(He),vi=new h.ExtHostMessageService(He,be),Si=new l.ExtHostDialogs(He),yi=new E.ExtHostStatusBar(He,ot.converter);return f.ExtHostApiCommands.register(ot),function(Me,Lt,Di){const gt=function(){let ie=!Me.isUnderDevelopment;function ce(){ie||(be.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Oe(it){if(Array.isArray(it))it.forEach(Oe);else if(typeof it=="string")ce();else{const wt=it;typeof wt.scheme=="undefined"&&ce(),typeof wt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return it}}(),jt={getSession(ie,ce,Oe){return ni.getSession(Me,ie,ce,Oe)},async hasSession(ie,ce){return(0,je.checkProposedApiEnabled)(Me,"authSession"),!!await ni.getSession(Me,ie,ce,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(ie,ce,Oe,it){return ni.registerAuthenticationProvider(ie,ce,Oe,it)}},Ni={registerCommand(ie,ce,Oe){return ot.registerCommand(!0,ie,ce,Oe,void 0,Me)},registerTextEditorCommand(ie,ce,Oe){return ot.registerCommand(!0,ie,(...it)=>{const wt=Tt.getActiveTextEditor();if(!wt){be.warn("Cannot execute "+ie+" because there is no active text editor.");return}return wt.edit(Ct=>{ce.apply(Oe,[wt,Ct,...it])}).then(Ct=>{Ct||be.warn("Edits from command "+ie+" were not applied.")},Ct=>{be.warn("An error occurred while running command "+ie,Ct)})},void 0,void 0,Me)},registerDiffInformationCommand:(ie,ce,Oe)=>((0,je.checkProposedApiEnabled)(Me,"diffCommand"),ot.registerCommand(!0,ie,async(...it)=>{const wt=Ve.activeEditor(!0);if(!wt){be.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ct=await Tt.getDiffInformation(wt.id);ce.apply(Oe,[Ct,...it])},void 0,void 0,Me)),executeCommand(ie,...ce){return ot.executeCommand(ie,...ce)},getCommands(ie=!1){return ot.getCommands(ie)}},Ot={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ie=Date.now()-new Date(ht.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,ce){return q.openUri(ie,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===ht.environment.appUriScheme)return Rt.createAppUri(ie);try{return await q.asExternalUri(ie,{allowTunneling:!!ht.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(ie,Be.Schemas.http)||(0,Xe.matchesScheme)(ie,Be.Schemas.https))return ie;throw ce}},get remoteName(){return(0,J.getRemoteName)(ht.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Me,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind}};ht.environment.extensionTestsLocationURI||Object.freeze(Ot);const si={createTestController(ie,ce,Oe){return Vt.createTestController(ie,ce,Oe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Vt.createTestObserver()},runTests(ie){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Vt.runTests(ie)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Vt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Vt.results}},oi=ht.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Mi={getExtension(ie,ce){(0,je.isProposedApiEnabled)(Me,"extensionsAny")||(ce=!1);const Oe=Lt.mine.getExtensionDescription(ie);if(Oe)return new s.Extension(yt,Me.identifier,Oe,oi,!1);if(ce){const it=Lt.all.getExtensionDescription(ie);if(it)return new s.Extension(yt,Me.identifier,it,oi,!0)}},get all(){const ie=[];for(const ce of Lt.mine.getAllExtensionDescriptions())ie.push(new s.Extension(yt,Me.identifier,ce,oi,!1));return ie},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Me,"extensionsAny");const ie=new je.ExtensionIdentifierSet(Lt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ce=[];for(const Oe of Lt.all.getAllExtensionDescriptions()){const it=!ie.has(Oe.identifier);ce.push(new s.Extension(yt,Me.identifier,Oe,oi,it))}return ce},get onDidChange(){return(0,je.isProposedApiEnabled)(Me,"extensionsAny")?g.Event.any(Lt.mine.onDidChange,Lt.all.onDidChange):Lt.mine.onDidChange}},Li={createDiagnosticCollection(ie){return Xt.createDiagnosticCollection(Me.identifier,ie)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:ie=>Xt.getDiagnostics(ie),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ie,ce){return ei.changeLanguage(ie.uri,ce)},match(ie,ce){const Oe=Et.getDocumentData(ce.uri)?.notebook;return(0,O.score)(K.LanguageSelector.from(ie),ce.uri,ce.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ie,ce,Oe){return dt.registerCodeActionProvider(Me,gt(ie),ce,Oe)},registerCodeLensProvider(ie,ce){return dt.registerCodeLensProvider(Me,gt(ie),ce)},registerDefinitionProvider(ie,ce){return dt.registerDefinitionProvider(Me,gt(ie),ce)},registerDeclarationProvider(ie,ce){return dt.registerDeclarationProvider(Me,gt(ie),ce)},registerImplementationProvider(ie,ce){return dt.registerImplementationProvider(Me,gt(ie),ce)},registerTypeDefinitionProvider(ie,ce){return dt.registerTypeDefinitionProvider(Me,gt(ie),ce)},registerHoverProvider(ie,ce){return dt.registerHoverProvider(Me,gt(ie),ce,Me.identifier)},registerEvaluatableExpressionProvider(ie,ce){return dt.registerEvaluatableExpressionProvider(Me,gt(ie),ce,Me.identifier)},registerInlineValuesProvider(ie,ce){return dt.registerInlineValuesProvider(Me,gt(ie),ce,Me.identifier)},registerDocumentHighlightProvider(ie,ce){return dt.registerDocumentHighlightProvider(Me,gt(ie),ce)},registerLinkedEditingRangeProvider(ie,ce){return dt.registerLinkedEditingRangeProvider(Me,gt(ie),ce)},registerReferenceProvider(ie,ce){return dt.registerReferenceProvider(Me,gt(ie),ce)},registerRenameProvider(ie,ce){return dt.registerRenameProvider(Me,gt(ie),ce)},registerDocumentSymbolProvider(ie,ce,Oe){return dt.registerDocumentSymbolProvider(Me,gt(ie),ce,Oe)},registerWorkspaceSymbolProvider(ie){return dt.registerWorkspaceSymbolProvider(Me,ie)},registerDocumentFormattingEditProvider(ie,ce){return dt.registerDocumentFormattingEditProvider(Me,gt(ie),ce)},registerDocumentRangeFormattingEditProvider(ie,ce){return dt.registerDocumentRangeFormattingEditProvider(Me,gt(ie),ce)},registerOnTypeFormattingEditProvider(ie,ce,Oe,...it){return dt.registerOnTypeFormattingEditProvider(Me,gt(ie),ce,[Oe].concat(it))},registerDocumentSemanticTokensProvider(ie,ce,Oe){return dt.registerDocumentSemanticTokensProvider(Me,gt(ie),ce,Oe)},registerDocumentRangeSemanticTokensProvider(ie,ce,Oe){return dt.registerDocumentRangeSemanticTokensProvider(Me,gt(ie),ce,Oe)},registerSignatureHelpProvider(ie,ce,Oe,...it){return typeof Oe=="object"?dt.registerSignatureHelpProvider(Me,gt(ie),ce,Oe):dt.registerSignatureHelpProvider(Me,gt(ie),ce,typeof Oe=="undefined"?[]:[Oe,...it])},registerCompletionItemProvider(ie,ce,...Oe){return dt.registerCompletionItemProvider(Me,gt(ie),ce,Oe)},registerInlineCompletionItemProvider(ie,ce){return(0,je.checkProposedApiEnabled)(Me,"inlineCompletions"),ce.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Me,gt(ie),ce)},registerInlineCompletionItemProviderNew(ie,ce){if((0,je.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),ce.handleDidShowCompletionItem&&!(0,je.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(Me,gt(ie),ce)},registerDocumentLinkProvider(ie,ce){return dt.registerDocumentLinkProvider(Me,gt(ie),ce)},registerColorProvider(ie,ce){return dt.registerColorProvider(Me,gt(ie),ce)},registerFoldingRangeProvider(ie,ce){return dt.registerFoldingRangeProvider(Me,gt(ie),ce)},registerSelectionRangeProvider(ie,ce){return dt.registerSelectionRangeProvider(Me,ie,ce)},registerCallHierarchyProvider(ie,ce){return dt.registerCallHierarchyProvider(Me,ie,ce)},registerTypeHierarchyProvider(ie,ce){return dt.registerTypeHierarchyProvider(Me,ie,ce)},setLanguageConfiguration:(ie,ce)=>dt.setLanguageConfiguration(Me,ie,ce),getTokenInformationAtPosition(ie,ce){return(0,je.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(ie,ce)},registerInlayHintsProvider(ie,ce){return dt.registerInlayHintsProvider(Me,ie,ce)},createLanguageStatusItem(ie,ce){return ei.createLanguageStatusItem(Me,ie,ce)},registerDocumentOnDropProvider(ie,ce){return(0,je.checkProposedApiEnabled)(Me,"textEditorDrop"),dt.registerDocumentOnDropProvider(Me,ie,ce)}},Ui={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(ie,ce,Oe){const it=await(I.URI.isUri(ie)?Promise.resolve(Ci.openTextDocument(ie)):Promise.resolve(ie));return Tt.showTextDocument(it,ce,Oe)},createTextEditorDecorationType(ie){return Tt.createTextEditorDecorationType(Me,ie)},onDidChangeActiveTextEditor(ie,ce,Oe){return Tt.onDidChangeActiveTextEditor(ie,ce,Oe)},onDidChangeVisibleTextEditors(ie,ce,Oe){return Tt.onDidChangeVisibleTextEditors(ie,ce,Oe)},onDidChangeTextEditorSelection(ie,ce,Oe){return Tt.onDidChangeTextEditorSelection(ie,ce,Oe)},onDidChangeTextEditorOptions(ie,ce,Oe){return Tt.onDidChangeTextEditorOptions(ie,ce,Oe)},onDidChangeTextEditorVisibleRanges(ie,ce,Oe){return Tt.onDidChangeTextEditorVisibleRanges(ie,ce,Oe)},onDidChangeTextEditorViewColumn(ie,ce,Oe){return Tt.onDidChangeTextEditorViewColumn(ie,ce,Oe)},onDidCloseTerminal(ie,ce,Oe){return ct.onDidCloseTerminal(ie,ce,Oe)},onDidOpenTerminal(ie,ce,Oe){return ct.onDidOpenTerminal(ie,ce,Oe)},onDidChangeActiveTerminal(ie,ce,Oe){return ct.onDidChangeActiveTerminal(ie,ce,Oe)},onDidChangeTerminalDimensions(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"terminalDimensions"),ct.onDidChangeTerminalDimensions(ie,ce,Oe)},onDidChangeTerminalState(ie,ce,Oe){return ct.onDidChangeTerminalState(ie,ce,Oe)},onDidWriteTerminalData(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ct.onDidWriteTerminalData(ie,ce,Oe)},get state(){return q.state},onDidChangeWindowState(ie,ce,Oe){return q.onDidChangeWindowState(ie,ce,Oe)},showInformationMessage(ie,...ce){return vi.showMessage(Me,N.default.Info,ie,ce[0],ce.slice(1))},showWarningMessage(ie,...ce){return vi.showMessage(Me,N.default.Warning,ie,ce[0],ce.slice(1))},showErrorMessage(ie,...ce){return vi.showMessage(Me,N.default.Error,ie,ce[0],ce.slice(1))},showQuickPick(ie,ce,Oe){return Ht.showQuickPick(ie,ce,Oe)},showWorkspaceFolderPick(ie){return Ht.showWorkspaceFolderPick(ie)},showInputBox(ie,ce){return Ht.showInput(ie,ce)},showOpenDialog(ie){return Si.showOpenDialog(ie)},showSaveDialog(ie){return Si.showSaveDialog(ie)},createStatusBarItem(ie,ce,Oe){let it,wt,Ct;return typeof ie=="string"?(it=ie,wt=ce,Ct=Oe):(wt=ie,Ct=ce),yi.createStatusBarEntry(Me,it,wt,Ct)},setStatusBarMessage(ie,ce){return yi.setStatusBarMessage(ie,ce)},withScmProgress(ie){return ue.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ii.withProgress(Me,{location:L.ProgressLocation.SourceControl},(ce,Oe)=>ie({report(it){}}))},withProgress(ie,ce){return ii.withProgress(Me,ie,ce)},createOutputChannel(ie,ce){return vt.createOutputChannel(ie,ce,Me)},createWebviewPanel(ie,ce,Oe,it){return gi.createWebviewPanel(Me,ie,ce,Oe,it)},createWebviewTextEditorInset(ie,ce,Oe,it){return(0,je.checkProposedApiEnabled)(Me,"editorInsets"),di.createWebviewEditorInset(ie,ce,Oe,it,Me)},createTerminal(ie,ce,Oe){return typeof ie=="object"?"pty"in ie?ct.createExtensionTerminal(ie):ct.createTerminalFromOptions(ie):ct.createTerminal(ie,ce,Oe)},registerTerminalLinkProvider(ie){return ct.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,ce){return ct.registerProfileProvider(Me,ie,ce)},registerTreeDataProvider(ie,ce){return Zt.registerTreeDataProvider(ie,ce,Me)},createTreeView(ie,ce){return Zt.createTreeView(ie,ce,Me)},registerWebviewPanelSerializer:(ie,ce)=>gi.registerWebviewPanelSerializer(Me,ie,ce),registerCustomEditorProvider:(ie,ce,Oe={})=>Ai.registerCustomEditorProvider(Me,ie,ce,Oe),registerFileDecorationProvider(ie){return tt.registerFileDecorationProvider(ie,Me.identifier)},registerUriHandler(ie){return Rt.registerUriHandler(Me.identifier,ie)},createQuickPick(){return Ht.createQuickPick(Me)},createInputBox(){return Ht.createInputBox(Me)},get activeColorTheme(){return _i.activeColorTheme},onDidChangeActiveColorTheme(ie,ce,Oe){return _i.onDidChangeActiveColorTheme(ie,ce,Oe)},registerWebviewViewProvider(ie,ce,Oe){return pi.registerWebviewViewProvider(Me,ie,ce,Oe?.webviewOptions)},get activeNotebookEditor(){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(ie,ce,Oe)},get visibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(ie,ce,Oe)},onDidChangeNotebookEditorVisibleRanges(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(ie,ce,Oe)},showNotebookDocument(ie,ce){return(0,je.checkProposedApiEnabled)(Me,"notebookEditor"),bt.showNotebookDocument(ie,ce)},registerExternalUriOpener(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"externalUriOpener"),Ri.registerExternalUriOpener(Me.identifier,ie,ce,Oe)},get tabGroups(){return Ue.tabGroups}},Ci={get rootPath(){return ue.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ie){throw D.readonly()},getWorkspaceFolder(ie){return ft.getWorkspaceFolder(ie)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ie){throw D.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ie){throw D.readonly()},updateWorkspaceFolders:(ie,ce,...Oe)=>ft.updateWorkspaceFolders(Me,ie,ce||0,...Oe),onDidChangeWorkspaceFolders:function(ie,ce,Oe){return ft.onDidChangeWorkspace(ie,ce,Oe)},asRelativePath:(ie,ce)=>ft.getRelativePath(ie,ce),findFiles:(ie,ce,Oe,it)=>ft.findFiles(ie,ce,Oe,Me.identifier,it),findTextInFiles:(ie,ce,Oe,it)=>{(0,je.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Ct;return typeof ce=="object"?(wt=ce,Ct=Oe):(wt={},Ct=ce,it=Oe),ft.findTextInFiles(ie,wt||{},Ct,Me.identifier,it)},saveAll:ie=>ft.saveAll(ie),applyEdit(ie){return Fi.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,ce,Oe,it)=>Bt.createFileSystemWatcher(ft,Me,ie,ce,Oe,it),get textDocuments(){return Et.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw D.readonly()},openTextDocument(ie){let ce;const Oe=ie;if(typeof ie=="string")ce=Promise.resolve(I.URI.file(ie));else if(I.URI.isUri(ie))ce=Promise.resolve(ie);else if(!Oe||typeof Oe=="object")ce=Et.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(it=>Et.ensureDocumentData(it).then(wt=>wt.document))},onDidOpenTextDocument:(ie,ce,Oe)=>Et.onDidAddDocument(ie,ce,Oe),onDidCloseTextDocument:(ie,ce,Oe)=>Et.onDidRemoveDocument(ie,ce,Oe),onDidChangeTextDocument:(ie,ce,Oe)=>Et.onDidChangeDocument(ie,ce,Oe),onDidSaveTextDocument:(ie,ce,Oe)=>Et.onDidSaveDocument(ie,ce,Oe),onWillSaveTextDocument:(ie,ce,Oe)=>Qt.getOnWillSaveTextDocumentEvent(Me)(ie,ce,Oe),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,ce){let Oe;if(I.URI.isUri(ie))Oe=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Oe=I.URI.revive(await bt.createNotebookDocument({viewType:ie,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ie,ce,Oe){return Wt.onDidSaveNotebookDocument(ie,ce,Oe)},onDidChangeNotebookDocument(ie,ce,Oe){return Wt.onDidChangeNotebookDocument(ie,ce,Oe)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,ce,Oe,it){return bt.registerNotebookSerializer(Me,ie,ce,Oe,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)},registerNotebookContentProvider:(ie,ce,Oe,it)=>((0,je.checkProposedApiEnabled)(Me,"notebookContentProvider"),bt.registerNotebookContentProvider(Me,ie,ce,Oe,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?it:void 0)),onDidChangeConfiguration:(ie,ce,Oe)=>Di.onDidChangeConfiguration(ie,ce,Oe),getConfiguration(ie,ce){return ce=arguments.length===1?void 0:ce,Di.getConfiguration(ie,ce,Me)},registerTextDocumentContentProvider(ie,ce){return Gt.registerTextDocumentContentProvider(ie,ce)},registerTaskProvider:(ie,ce)=>(ue.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Me,ie,ce)),registerFileSystemProvider(ie,ce,Oe){return(0,Je.combinedDisposable)(hi.registerFileSystemProvider(Me,ie,ce,Oe),Ft.addFileSystemProvider(ie,ce))},get fs(){return Ft.value},registerFileSearchProvider:(ie,ce)=>((0,je.checkProposedApiEnabled)(Me,"fileSearchProvider"),_t.registerFileSearchProvider(ie,ce)),registerTextSearchProvider:(ie,ce)=>((0,je.checkProposedApiEnabled)(Me,"textSearchProvider"),_t.registerTextSearchProvider(ie,ce)),registerRemoteAuthorityResolver:(ie,ce)=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),yt.registerRemoteAuthorityResolver(ie,ce)),registerResourceLabelFormatter:ie=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),fi.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,ce,Oe)=>Bt.onDidCreateFile(ie,ce,Oe),onDidDeleteFiles:(ie,ce,Oe)=>Bt.onDidDeleteFile(ie,ce,Oe),onDidRenameFiles:(ie,ce,Oe)=>Bt.onDidRenameFile(ie,ce,Oe),onWillCreateFiles:(ie,ce,Oe)=>Bt.getOnWillCreateFileEvent(Me)(ie,ce,Oe),onWillDeleteFiles:(ie,ce,Oe)=>Bt.getOnWillDeleteFileEvent(Me)(ie,ce,Oe),onWillRenameFiles:(ie,ce,Oe)=>Bt.getOnWillRenameFileEvent(Me)(ie,ce,Oe),openTunnel:ie=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),ye.openTunnel(Me,ie).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,je.checkProposedApiEnabled)(Me,"resolvers"),ye.getTunnels()},onDidChangeTunnels:(ie,ce,Oe)=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),ye.onDidChangeTunnels(ie,ce,Oe)),registerPortAttributesProvider:(ie,ce)=>((0,je.checkProposedApiEnabled)(Me,"portsAttributes"),ye.registerPortsAttributesProvider(ie,ce)),registerTimelineProvider:(ie,ce)=>((0,je.checkProposedApiEnabled)(Me,"timeline"),Pi.registerTimelineProvider(ie,ce,Me.identifier,ot.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ie=>((0,je.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,ce,Oe)=>ft.onDidGrantWorkspaceTrust(ie,ce,Oe)},Bi={get inputBox(){return ue.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ti.getLastInputBox(Me)},createSourceControl(ie,ce,Oe){return ti.createSourceControl(Me,ie,ce,Oe)}},xi={createCommentController(ie,ce){return ki.createCommentController(Me,ie,ce)}},Ei={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},onDidStartDebugSession(ie,ce,Oe){return pt.onDidStartDebugSession(ie,ce,Oe)},onDidTerminateDebugSession(ie,ce,Oe){return pt.onDidTerminateDebugSession(ie,ce,Oe)},onDidChangeActiveDebugSession(ie,ce,Oe){return pt.onDidChangeActiveDebugSession(ie,ce,Oe)},onDidReceiveDebugSessionCustomEvent(ie,ce,Oe){return pt.onDidReceiveDebugSessionCustomEvent(ie,ce,Oe)},onDidChangeBreakpoints(ie,ce,Oe){return pt.onDidChangeBreakpoints(ie,ce,Oe)},registerDebugConfigurationProvider(ie,ce,Oe){return pt.registerDebugConfigurationProvider(ie,ce,Oe||lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,ce){return pt.registerDebugAdapterDescriptorFactory(Me,ie,ce)},registerDebugAdapterTrackerFactory(ie,ce){return pt.registerDebugAdapterTrackerFactory(ie,ce)},startDebugging(ie,ce,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?pt.startDebugging(ie,ce,{parentSession:Oe}):pt.startDebugging(ie,ce,Oe||{})},stopDebugging(ie){return pt.stopDebugging(ie)},addBreakpoints(ie){return pt.addBreakpoints(ie)},removeBreakpoints(ie){return pt.removeBreakpoints(ie)},asDebugSourceUri(ie,ce){return pt.asDebugSourceUri(ie,ce)}},$i={registerTaskProvider:(ie,ce)=>mt.registerTaskProvider(Me,ie,ce),fetchTasks:ie=>mt.fetchTasks(ie),executeTask:ie=>mt.executeTask(Me,ie),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(ie,ce,Oe)=>mt.onDidStartTask(ie,ce,Oe),onDidEndTask:(ie,ce,Oe)=>mt.onDidEndTask(ie,ce,Oe),onDidStartTaskProcess:(ie,ce,Oe)=>mt.onDidStartTaskProcess(ie,ce,Oe),onDidEndTaskProcess:(ie,ce,Oe)=>mt.onDidEndTaskProcess(ie,ce,Oe)},zi={createNotebookController(ie,ce,Oe,it,wt){return Jt.createNotebookController(Me,ie,ce,Oe,it,(0,je.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,ce)=>bt.registerNotebookCellStatusBarItemProvider(Me,ie,ce),createNotebookEditorDecorationType(ie){return(0,je.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return ci.createRendererMessaging(Me,ie)},onDidChangeNotebookCellExecutionState(ie,ce,Oe){return(0,je.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(ie,ce,Oe)},createNotebookProxyController(ie,ce,Oe,it){return(0,je.checkProposedApiEnabled)(Me,"notebookProxyController"),ui.createNotebookProxyController(Me,ie,ce,Oe,it)}};return{version:ht.version,authentication:jt,commands:Ni,comments:xi,debug:Ei,env:Ot,extensions:Mi,languages:Li,notebooks:zi,scm:Bi,tasks:$i,tests:si,window:Ui,workspace:Ci,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CommentThreadState:L.CommentThreadState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:L.InlineCompletionTriggerKindNew,EventEmitter:g.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionItemNew:L.InlineSuggestionNew,InlineCompletionList:L.InlineSuggestionList,InlineCompletionListNew:L.InlineSuggestionsNew,Hover:L.Hover,IndentAction:A.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SnippetTextEdit:L.SnippetTextEdit,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalLocation:L.TerminalLocation,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:b.UIKind,Uri:I.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintLabelPart:L.InlayHintLabelPart,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestTag:L.TestTag,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:me.TextSearchCompleteMessageType,DataTransfer:L.DataTransfer,DataTransferItem:L.DataTransferItem,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity,QuickPickItemKind:L.QuickPickItemKind,InputBoxValidationSeverity:L.InputBoxValidationSeverity,TabInputText:L.TextTabInput,TabInputTextDiff:L.TextDiffTabInput,TabInputCustom:L.CustomEditorTabInput,TabInputNotebook:L.NotebookEditorTabInput,TabInputNotebookDiff:L.NotebookDiffEditorTabInput,TabInputWebview:L.WebviewEditorTabInput,TabInputTerminal:L.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=It}),define(Se[230],De([1,0,229,31,2,223,6,14,4]),function(Z,e,a,D,g,N,I,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends N.RequireInterceptor{_installInterceptor(){}getModule(f,u){for(let d of this._alternatives){let c=d(f);if(c){f=c;break}}if(this._factories.has(f))return this._factories.get(f).load(f,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(w.MainContext.MainThreadConsole);p(f,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,u,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,u,d){u=u.with({path:v(u.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const c=g.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(u)),y=await fetch(c.toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),y.status!==200)throw new Error(y.statusText);const S=await y.text(),l=`${u.toString(!0)}#vscode-extension`,_=`${S}
//# sourceURL=${l}`;let r;try{r=new Function("module","exports","require",_)}catch(n){throw console.error(f?`Loading code for extension ${f.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${u.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const k={},i={exports:k},s=n=>{const t=this._fakeModules.getModule(n,u);if(t===void 0)throw new Error(`Cannot load module '${n}'`);return t};try{return d.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),r(i,k,s),i.exports!==k?i.exports:k}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+f;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=O;function v(b,f){return b.endsWith(f)?b:b+f}function p(b,f){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(y,S){const l=console[y];console[y]=function(){b.$logExtensionHostMessage({type:"__$console",severity:S,arguments:c(arguments)}),f&&l.apply(console,arguments)}}const d=1e5;function c(y){const S=[],l=[];if(y.length)for(let _=0;_<y.length;_++){if(typeof y[_]=="undefined")y[_]="undefined";else if(y[_]instanceof Error){const r=y[_];r.stack?y[_]=r.stack:y[_]=r.toString()}l.push(y[_])}try{const _=JSON.stringify(l,function(r,k){if(k&&typeof k=="object"){if(S.indexOf(k)!==-1)return"[Circular]";S.push(k)}return k});return _.length>d?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}}),define(Se[231],De([1,0,58,31,72,230]),function(Z,e,a,D,g,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(D.IExtHostExtensionService,N.ExtHostExtensionService),(0,a.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths)}),define(Se[240],De([1,0,25,5,93,224,216,17,73,11,2,226,231]),function(Z,e,a,D,g,N,I,P,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const p=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function u(r){self.fetch=async function(k,i){return k instanceof Request||b(String(k))&&(k=(await r(O.URI.parse(String(k)))).toString(!0)),f(k,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,i,s,n,t){(async()=>{b(i.toString())&&(i=(await r(O.URI.parse(i.toString()))).toString(!0)),super.open(k,i,s??!0,n,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(k,i){if(/^file:/i.test(k.toString()))k=A.FileAccess.asBrowserUri(O.URI.parse(k.toString())).toString(!0);else if(/^vscode-remote:/i.test(k.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const n=`(${function(h){function C(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const F=fetch.bind(self);self.fetch=function(R,E){return R instanceof Request?F(R,E):F(C(R),E)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,E,x,z,V){return super.open(R,C(E),x??!0,z,V)}};const U=importScripts.bind(self);self.importScripts=(...R)=>{U(...R.map(C))},U(h)}.toString()}('${k}'))`;i=i||{},i.name=i.name||P.basename(k.toString());const t=new Blob([n],{type:"application/javascript"}),o=URL.createObjectURL(t);return new r(o,i)}}else self.Worker=class extends I.NestedWorker{constructor(r,k){super(p,r,{name:P.basename(r.toString()),...k})}};const d=new class{constructor(){this.pid=void 0}exit(r){v()}async exists(r){return!0}async realpath(r){return r}};class c{constructor(){const k=new MessageChannel,i=new D.Emitter;let s=!1;p(k.port2,[k.port2]),k.port1.onmessage=n=>{const{data:t}=n;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const o=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,g.isMessageOfType)(o,2)){s=!0,S("received terminate message from renderer");return}i.fire(o)},this.protocol={onMessage:i.event,send:n=>{if(!s){const t=n.buffer.buffer.slice(n.buffer.byteOffset,n.buffer.byteOffset+n.buffer.byteLength);k.port1.postMessage(t,[t])}}}}}function y(r){return new Promise(k=>{const i=r.onMessage(s=>{i.dispose();const n=JSON.parse(s.toString());r.send((0,g.createMessageOfType)(0)),k({protocol:r,initData:n})});r.send((0,g.createMessageOfType)(1))})}let S=r=>v();function l(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function _(){w.mark("code/extHost/willConnectToRenderer");const r=new c;return{onmessage(k){!l(k)||y(r.protocol).then(i=>{w.mark("code/extHost/didWaitForInitData");const s=new N.ExtensionHostMain(i.protocol,i.initData,d,null,k.data);u(n=>s.asBrowserUri(n)),S=n=>s.terminate(n)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c29becfad5f68270b9b23efeafb147722c5feba/core/vs/workbench/api/worker/extensionHostWorker.js.map
